/*
MySQL Data Transfer
Source Host: localhost
Source Database: ffxiv_server
Target Host: localhost
Target Database: ffxiv_server
Date: 3/19/2016 7:25:31 PM
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for characters
-- ----------------------------
CREATE TABLE `characters` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `userId` int(11) unsigned NOT NULL,
  `slot` smallint(6) unsigned NOT NULL,
  `serverId` int(11) NOT NULL,
  `name` varchar(32) NOT NULL,
  `state` smallint(5) unsigned NOT NULL DEFAULT '0',
  `creationDate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `isLegacy` smallint(1) unsigned DEFAULT '0',
  `doRename` smallint(1) unsigned DEFAULT '0',
  `playTime` int(10) unsigned NOT NULL DEFAULT '0',
  `positionX` float NOT NULL DEFAULT '0',
  `positionY` float NOT NULL DEFAULT '0',
  `positionZ` float NOT NULL DEFAULT '0',
  `rotation` float NOT NULL DEFAULT '0',
  `actorState` smallint(5) unsigned DEFAULT '0',
  `currentZoneId` smallint(5) unsigned DEFAULT '0',
  `guardian` tinyint(3) unsigned NOT NULL,
  `birthDay` tinyint(3) unsigned NOT NULL,
  `birthMonth` tinyint(3) unsigned NOT NULL,
  `initialTown` tinyint(3) unsigned NOT NULL,
  `tribe` tinyint(3) unsigned NOT NULL,
  `gcCurrent` tinyint(3) unsigned DEFAULT '0',
  `gcLimsaRank` tinyint(3) unsigned DEFAULT '127',
  `gcGridaniaRank` tinyint(3) unsigned DEFAULT '127',
  `gcUldahRank` tinyint(3) unsigned DEFAULT '127',
  `currentTitle` int(10) unsigned DEFAULT '0',
  `currentParty` int(10) unsigned DEFAULT '0',
  `restBonus` int(10) DEFAULT '0',
  `achievementPoints` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=137 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_achievements
-- ----------------------------
CREATE TABLE `characters_achievements` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `achievementId` int(10) unsigned NOT NULL,
  `timeDone` int(10) unsigned DEFAULT NULL,
  `progress` int(10) unsigned DEFAULT '0',
  `progressFlags` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_appearance
-- ----------------------------
CREATE TABLE `characters_appearance` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `baseId` int(10) unsigned NOT NULL,
  `size` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `voice` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `skinColor` smallint(5) unsigned NOT NULL,
  `hairStyle` smallint(5) unsigned NOT NULL,
  `hairColor` smallint(5) unsigned NOT NULL,
  `hairHighlightColor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `hairVariation` smallint(5) unsigned NOT NULL,
  `eyeColor` smallint(5) unsigned NOT NULL,
  `faceType` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceEyebrows` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceEyeShape` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceIrisSize` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceNose` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceMouth` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `faceFeatures` tinyint(3) unsigned NOT NULL,
  `ears` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `characteristics` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `characteristicsColor` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `mainhand` int(10) unsigned NOT NULL,
  `offhand` int(10) unsigned NOT NULL,
  `head` int(10) unsigned NOT NULL,
  `body` int(10) unsigned NOT NULL,
  `hands` int(10) unsigned NOT NULL,
  `legs` int(10) unsigned NOT NULL,
  `feet` int(10) unsigned NOT NULL,
  `waist` int(10) unsigned NOT NULL,
  `leftFinger` int(10) unsigned NOT NULL,
  `rightFinger` int(10) unsigned NOT NULL,
  `leftEar` int(10) unsigned NOT NULL,
  `rightEar` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_blacklist
-- ----------------------------
CREATE TABLE `characters_blacklist` (
  `characterId` int(10) unsigned NOT NULL,
  `slot` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_chocobo
-- ----------------------------
CREATE TABLE `characters_chocobo` (
  `characterId` int(10) unsigned NOT NULL,
  `hasChocobo` tinyint(1) unsigned DEFAULT '0',
  `hasGoobbue` tinyint(1) unsigned DEFAULT '0',
  `chocoboAppearance` tinyint(3) unsigned DEFAULT NULL,
  `chocoboName` varchar(255) DEFAULT '',
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_class_exp
-- ----------------------------
CREATE TABLE `characters_class_exp` (
  `characterId` int(10) unsigned NOT NULL,
  `pug` int(10) unsigned DEFAULT '0',
  `gla` int(10) unsigned DEFAULT '0',
  `mrd` int(10) unsigned DEFAULT '0',
  `arc` int(10) unsigned DEFAULT '0',
  `lnc` int(10) unsigned DEFAULT '0',
  `thm` int(10) unsigned DEFAULT '0',
  `cnj` int(10) unsigned DEFAULT '0',
  `crp` int(10) unsigned DEFAULT '0',
  `bsm` int(10) unsigned DEFAULT '0',
  `arm` int(10) unsigned DEFAULT '0',
  `gsm` int(10) unsigned DEFAULT '0',
  `ltw` int(10) unsigned DEFAULT '0',
  `wvr` int(10) unsigned DEFAULT '0',
  `alc` int(10) unsigned DEFAULT '0',
  `cul` int(10) unsigned DEFAULT '0',
  `min` int(10) unsigned DEFAULT '0',
  `btn` int(10) unsigned DEFAULT '0',
  `fsh` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_class_levels
-- ----------------------------
CREATE TABLE `characters_class_levels` (
  `characterId` int(10) unsigned NOT NULL,
  `pug` smallint(6) DEFAULT '0',
  `gla` smallint(6) DEFAULT '0',
  `mrd` smallint(6) DEFAULT '0',
  `arc` smallint(6) DEFAULT '0',
  `lnc` smallint(6) DEFAULT '0',
  `thm` smallint(6) DEFAULT '0',
  `cnj` smallint(6) DEFAULT '0',
  `crp` smallint(6) DEFAULT '0',
  `bsm` smallint(6) DEFAULT '0',
  `arm` smallint(6) DEFAULT '0',
  `gsm` smallint(6) DEFAULT '0',
  `ltw` smallint(6) DEFAULT '0',
  `wvr` smallint(6) DEFAULT '0',
  `alc` smallint(6) DEFAULT '0',
  `cul` smallint(6) DEFAULT '0',
  `min` smallint(6) DEFAULT '0',
  `btn` smallint(6) DEFAULT '0',
  `fsh` smallint(6) DEFAULT '0',
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_customattributes
-- ----------------------------
CREATE TABLE `characters_customattributes` (
  `characterId` int(10) unsigned NOT NULL,
  `pointsRemaining` int(11) DEFAULT '0',
  `strSpent` int(11) DEFAULT '0',
  `vitSpent` int(11) DEFAULT '0',
  `dexSpent` int(11) DEFAULT '0',
  `intSpent` int(11) DEFAULT '0',
  `minSpent` int(11) DEFAULT '0',
  `pieSpent` int(11) DEFAULT '0',
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_friendlist
-- ----------------------------
CREATE TABLE `characters_friendlist` (
  `id` int(10) unsigned zerofill NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_hotbar
-- ----------------------------
CREATE TABLE `characters_hotbar` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `classId` smallint(5) unsigned NOT NULL,
  `hotbarSlot` smallint(5) unsigned NOT NULL,
  `commandId` int(10) unsigned NOT NULL,
  `recastTime` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_inventory
-- ----------------------------
CREATE TABLE `characters_inventory` (
  `id` int(10) unsigned zerofill NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` int(10) unsigned NOT NULL,
  `inventoryType` smallint(5) unsigned NOT NULL DEFAULT '0',
  `serverItemId` int(10) unsigned NOT NULL,
  `quantity` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=886 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_inventory_equipment
-- ----------------------------
CREATE TABLE `characters_inventory_equipment` (
  `characterId` int(10) unsigned NOT NULL,
  `classId` smallint(5) unsigned NOT NULL,
  `equipSlot` smallint(5) unsigned NOT NULL,
  `itemId` bigint(10) unsigned NOT NULL,
  PRIMARY KEY (`characterId`,`classId`,`equipSlot`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_linkshells
-- ----------------------------
CREATE TABLE `characters_linkshells` (
  `id` int(10) unsigned zerofill NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` int(10) unsigned NOT NULL,
  `linkshellId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for characters_npclinkshell
-- ----------------------------
CREATE TABLE `characters_npclinkshell` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(11) unsigned NOT NULL,
  `npcLinkshellId` smallint(5) unsigned NOT NULL,
  `isCalling` tinyint(1) unsigned DEFAULT '0',
  `isExtra` tinyint(1) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_parametersave
-- ----------------------------
CREATE TABLE `characters_parametersave` (
  `characterId` int(10) unsigned NOT NULL,
  `hp` smallint(6) NOT NULL,
  `hpMax` smallint(6) NOT NULL,
  `mp` smallint(6) NOT NULL,
  `mpMax` smallint(6) NOT NULL,
  `mainSkill` tinyint(3) unsigned NOT NULL,
  `mainSkillLevel` smallint(6) NOT NULL,
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_completed
-- ----------------------------
CREATE TABLE `characters_quest_completed` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `questId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_guildleve_local
-- ----------------------------
CREATE TABLE `characters_quest_guildleve_local` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` smallint(5) unsigned NOT NULL,
  `questId` int(10) unsigned NOT NULL,
  `abandoned` tinyint(1) unsigned DEFAULT '0',
  `completed` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_guildleve_regional
-- ----------------------------
CREATE TABLE `characters_quest_guildleve_regional` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` smallint(5) unsigned NOT NULL,
  `guildleveId` smallint(3) unsigned NOT NULL,
  `abandoned` tinyint(1) unsigned DEFAULT '0',
  `completed` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_guildlevehistory
-- ----------------------------
CREATE TABLE `characters_quest_guildlevehistory` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `questId` int(10) unsigned NOT NULL,
  `timeCompleted` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_progress
-- ----------------------------
CREATE TABLE `characters_quest_progress` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `questId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_quest_scenario
-- ----------------------------
CREATE TABLE `characters_quest_scenario` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `slot` smallint(5) unsigned NOT NULL,
  `questId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_statuseffect
-- ----------------------------
CREATE TABLE `characters_statuseffect` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `statusId` tinyint(3) unsigned NOT NULL,
  `expireTime` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for characters_timers
-- ----------------------------
CREATE TABLE `characters_timers` (
  `characterId` int(10) unsigned NOT NULL DEFAULT '0',
  `thousandmaws` int(10) unsigned DEFAULT '0',
  `dzemaeldarkhold` int(10) unsigned DEFAULT '0',
  `bowlofembers_hard` int(10) unsigned DEFAULT '0',
  `bowlofembers` int(10) unsigned DEFAULT '0',
  `thornmarch` int(10) unsigned DEFAULT '0',
  `aurumvale` int(10) unsigned DEFAULT '0',
  `cutterscry` int(10) unsigned DEFAULT '0',
  `battle_aleport` int(10) unsigned DEFAULT '0',
  `battle_hyrstmill` int(10) unsigned DEFAULT '0',
  `battle_goldenbazaar` int(10) unsigned DEFAULT '0',
  `howlingeye_hard` int(10) unsigned DEFAULT '0',
  `howlingeye` int(10) unsigned DEFAULT '0',
  `castrumnovum` int(10) unsigned DEFAULT '0',
  `bowlofembers_extreme` int(10) unsigned DEFAULT '0',
  `rivenroad` int(10) unsigned DEFAULT '0',
  `rivenroad_hard` int(10) unsigned DEFAULT '0',
  `behests` int(10) unsigned DEFAULT '0',
  `companybehests` int(10) unsigned DEFAULT '0',
  `returntimer` int(10) unsigned DEFAULT '0',
  `skirmish` int(10) unsigned DEFAULT '0',
  PRIMARY KEY (`characterId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for gamedata_achievements
-- ----------------------------
CREATE TABLE `gamedata_achievements` (
  `achievementId` smallint(5) unsigned NOT NULL,
  `name` varchar(255) CHARACTER SET utf8 NOT NULL,
  `packetOffsetId` smallint(5) unsigned NOT NULL,
  `rewardPoints` smallint(5) unsigned NOT NULL,
  PRIMARY KEY (`achievementId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_actor_appearance
-- ----------------------------
CREATE TABLE `gamedata_actor_appearance` (
  `id` int(10) unsigned NOT NULL,
  `base` int(10) unsigned NOT NULL,
  `size` int(10) unsigned NOT NULL DEFAULT '0',
  `hairStyle` int(10) unsigned NOT NULL,
  `hairHighlightColor` int(10) unsigned NOT NULL DEFAULT '0',
  `hairVariation` int(10) unsigned NOT NULL,
  `faceType` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `characteristics` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `characteristicsColor` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `faceEyebrows` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `faceIrisSize` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `faceEyeShape` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `faceNose` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `faceFeatures` tinyint(5) unsigned NOT NULL,
  `faceMouth` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `ears` tinyint(5) unsigned NOT NULL DEFAULT '0',
  `hairColor` int(10) unsigned NOT NULL,
  `skinColor` int(10) unsigned NOT NULL,
  `eyeColor` int(10) unsigned NOT NULL,
  `voice` int(10) unsigned NOT NULL DEFAULT '0',
  `mainHand` int(10) unsigned NOT NULL,
  `offHand` int(10) unsigned NOT NULL,
  `spMainHand` int(10) unsigned NOT NULL,
  `spOffHand` int(11) unsigned NOT NULL,
  `throwing` int(10) unsigned NOT NULL,
  `pack` int(10) unsigned NOT NULL,
  `pouch` int(10) unsigned NOT NULL,
  `head` int(10) unsigned NOT NULL,
  `body` int(10) unsigned NOT NULL,
  `legs` int(10) unsigned NOT NULL,
  `hands` int(10) unsigned NOT NULL,
  `feet` int(10) unsigned NOT NULL,
  `waist` int(10) unsigned NOT NULL,
  `neck` int(10) unsigned NOT NULL,
  `leftEar` int(10) unsigned NOT NULL,
  `rightEar` int(10) unsigned NOT NULL,
  `leftIndex` int(10) unsigned NOT NULL,
  `rightIndex` int(10) unsigned NOT NULL,
  `leftFinger` int(10) unsigned NOT NULL,
  `rightFinger` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for gamedata_actor_class
-- ----------------------------
CREATE TABLE `gamedata_actor_class` (
  `id` int(10) unsigned NOT NULL,
  `name` varchar(32) DEFAULT NULL,
  `zoneId` int(10) unsigned NOT NULL,
  `privateAreaId` int(11) DEFAULT '0',
  `positionX` float DEFAULT NULL,
  `positionY` float DEFAULT NULL,
  `positionZ` float DEFAULT NULL,
  `rotation` float DEFAULT NULL,
  `actorState` smallint(5) unsigned NOT NULL,
  `animationId` int(10) unsigned NOT NULL,
  `displayNameId` int(10) unsigned NOT NULL DEFAULT '4294967295',
  `customDisplayName` char(32) DEFAULT '',
  `actorClassName` varchar(32) NOT NULL,
  `eventConditions` longtext,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_items
-- ----------------------------
CREATE TABLE `gamedata_items` (
  `catalogID` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `category` varchar(255) NOT NULL,
  `maxStack` int(11) NOT NULL,
  `isRare` tinyint(1) unsigned NOT NULL,
  `isExclusive` tinyint(1) unsigned NOT NULL,
  `durability` int(11) NOT NULL,
  `sellPrice` int(11) NOT NULL,
  `icon` int(11) NOT NULL,
  `kind` int(11) NOT NULL,
  `rarity` int(11) NOT NULL,
  `isUseable` int(11) NOT NULL,
  `mainSkill` int(11) NOT NULL,
  `subSkill` int(11) NOT NULL,
  `levelType` int(11) NOT NULL,
  `level` int(11) NOT NULL,
  `compatibility` int(11) NOT NULL,
  `effectMagnitude` float NOT NULL,
  `effectRate` float NOT NULL,
  `shieldBlocking` float NOT NULL,
  `effectDuration` float NOT NULL,
  `recastTime` float NOT NULL,
  `recastGroup` tinyint(4) NOT NULL,
  `repairSkill` int(11) NOT NULL,
  `repairItem` int(11) NOT NULL,
  `repairItemNum` int(11) NOT NULL,
  `repairLevel` int(11) NOT NULL,
  `repairLicense` int(11) NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for gamedata_items_accessory
-- ----------------------------
CREATE TABLE `gamedata_items_accessory` (
  `catalogID` int(10) unsigned NOT NULL,
  `power` tinyint(4) NOT NULL,
  `size` tinyint(4) NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_items_armor
-- ----------------------------
CREATE TABLE `gamedata_items_armor` (
  `catalogID` int(10) unsigned NOT NULL,
  `defense` smallint(6) NOT NULL,
  `magicDefense` smallint(6) NOT NULL,
  `criticalDefense` smallint(6) NOT NULL,
  `evasion` smallint(6) NOT NULL,
  `magicResistance` smallint(6) NOT NULL,
  `damageDefenseType1` int(11) NOT NULL,
  `damageDefenseValue1` smallint(6) NOT NULL,
  `damageDefenseType2` int(11) NOT NULL,
  `damageDefenseValue2` smallint(6) NOT NULL,
  `damageDefenseType3` int(11) NOT NULL,
  `damageDefenseValue3` smallint(6) NOT NULL,
  `damageDefenseType4` int(11) NOT NULL,
  `damageDefenseValue4` smallint(6) NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_items_equipment
-- ----------------------------
CREATE TABLE `gamedata_items_equipment` (
  `catalogID` int(11) NOT NULL,
  `equipPoint` int(11) NOT NULL,
  `equipTribe` tinyint(4) NOT NULL,
  `paramBonusType1` int(11) NOT NULL,
  `paramBonusValue1` smallint(6) NOT NULL,
  `paramBonusType2` int(11) NOT NULL,
  `paramBonusValue2` smallint(6) NOT NULL,
  `paramBonusType3` int(11) NOT NULL,
  `paramBonusValue3` smallint(6) NOT NULL,
  `paramBonusType4` int(11) NOT NULL,
  `paramBonusValue4` smallint(6) NOT NULL,
  `paramBonusType5` int(11) NOT NULL,
  `paramBonusValue5` smallint(6) NOT NULL,
  `paramBonusType6` int(11) NOT NULL,
  `paramBonusValue6` smallint(6) NOT NULL,
  `paramBonusType7` int(11) NOT NULL,
  `paramBonusValue7` smallint(6) NOT NULL,
  `paramBonusType8` int(11) NOT NULL,
  `paramBonusValue8` smallint(6) NOT NULL,
  `paramBonusType9` int(11) NOT NULL,
  `paramBonusValue9` smallint(6) NOT NULL,
  `paramBonusType10` int(11) NOT NULL,
  `paramBonusValue10` smallint(6) NOT NULL,
  `additionalEffect` smallint(6) NOT NULL,
  `materiaBindPermission` tinyint(1) unsigned NOT NULL,
  `materializeTable` smallint(6) NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_items_graphics
-- ----------------------------
CREATE TABLE `gamedata_items_graphics` (
  `catalogID` int(10) unsigned NOT NULL,
  `weaponId` int(10) unsigned NOT NULL,
  `equipmentId` int(10) unsigned NOT NULL,
  `variantId` int(10) unsigned NOT NULL,
  `colorId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for gamedata_items_weapon
-- ----------------------------
CREATE TABLE `gamedata_items_weapon` (
  `catalogID` int(10) unsigned NOT NULL,
  `attack` smallint(6) NOT NULL,
  `magicAttack` smallint(6) NOT NULL,
  `craftProcessing` smallint(6) NOT NULL,
  `craftMagicProcessing` smallint(6) NOT NULL,
  `harvestPotency` smallint(6) NOT NULL,
  `harvestLimit` smallint(6) NOT NULL,
  `frequency` tinyint(4) NOT NULL,
  `rate` smallint(6) NOT NULL,
  `magicRate` smallint(6) NOT NULL,
  `craftProcessControl` smallint(6) NOT NULL,
  `harvestRate` smallint(6) NOT NULL,
  `critical` smallint(6) NOT NULL,
  `magicCritical` smallint(6) NOT NULL,
  `parry` smallint(6) NOT NULL,
  `damageAttributeType1` int(11) NOT NULL,
  `damageAttributeValue1` float NOT NULL,
  `damageAttributeType2` int(11) NOT NULL,
  `damageAttributeValue2` float NOT NULL,
  `damageAttributeType3` int(11) NOT NULL,
  `damageAttributeValue3` float NOT NULL,
  `damagePower` smallint(6) NOT NULL,
  `damageInterval` float NOT NULL,
  `ammoVirtualDamagePower` smallint(6) NOT NULL,
  PRIMARY KEY (`catalogID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for linkshells
-- ----------------------------
CREATE TABLE `linkshells` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `crestIcon` smallint(5) unsigned NOT NULL,
  `founder` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for parties
-- ----------------------------
CREATE TABLE `parties` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `leaderCharacterId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for reserved_names
-- ----------------------------
CREATE TABLE `reserved_names` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `userId` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for retainers
-- ----------------------------
CREATE TABLE `retainers` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterId` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `slot` smallint(5) unsigned NOT NULL,
  `doRename` smallint(1) unsigned NOT NULL DEFAULT '0',
  `locationId` smallint(5) unsigned NOT NULL,
  `state` tinyint(4) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for server_items
-- ----------------------------
CREATE TABLE `server_items` (
  `id` int(10) unsigned zerofill NOT NULL AUTO_INCREMENT,
  `itemId` int(10) unsigned NOT NULL,
  `quality` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `itemType` tinyint(6) unsigned NOT NULL DEFAULT '0',
  `durability` int(11) NOT NULL DEFAULT '0',
  `spiritbind` smallint(5) unsigned DEFAULT '0',
  `materia1` tinyint(3) unsigned DEFAULT '0',
  `materia2` tinyint(3) unsigned DEFAULT '0',
  `materia3` tinyint(3) unsigned DEFAULT '0',
  `materia4` tinyint(3) unsigned DEFAULT '0',
  `materia5` tinyint(3) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=903 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for server_sessions
-- ----------------------------
CREATE TABLE `server_sessions` (
  `id` char(255) NOT NULL,
  `characterId` int(11) NOT NULL,
  `actorId` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for server_zones
-- ----------------------------
CREATE TABLE `server_zones` (
  `id` int(10) unsigned NOT NULL,
  `regionId` smallint(6) unsigned NOT NULL,
  `zoneName` varchar(255) DEFAULT NULL,
  `placeName` varchar(255) NOT NULL,
  `className` varchar(30) NOT NULL,
  `dayMusic` smallint(6) unsigned DEFAULT '0',
  `nightMusic` smallint(6) unsigned DEFAULT '0',
  `battleMusic` smallint(6) unsigned DEFAULT '0',
  `isIsolated` tinyint(1) DEFAULT '0',
  `isInn` tinyint(1) DEFAULT '0',
  `canRideChocobo` tinyint(1) DEFAULT '1',
  `canStealth` tinyint(1) DEFAULT '0',
  `isInstanceRaid` tinyint(1) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for server_zones_privateareas
-- ----------------------------
CREATE TABLE `server_zones_privateareas` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parentZoneId` int(10) unsigned NOT NULL,
  `privateAreaName` varchar(20) NOT NULL,
  `className` varchar(20) NOT NULL,
  `dayMusic` smallint(6) unsigned DEFAULT '0',
  `nightMusic` smallint(6) unsigned DEFAULT '0',
  `battleMusic` smallint(6) unsigned DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for server_zones_spawnlocations
-- ----------------------------
CREATE TABLE `server_zones_spawnlocations` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `zoneId` int(10) unsigned NOT NULL,
  `spawnType` tinyint(3) unsigned DEFAULT '0',
  `spawnX` float NOT NULL,
  `spawnY` float NOT NULL,
  `spawnZ` float NOT NULL,
  `spawnRotation` float NOT NULL,
  `privateAreaName` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for servers
-- ----------------------------
CREATE TABLE `servers` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL,
  `address` varchar(255) NOT NULL,
  `port` smallint(6) unsigned NOT NULL,
  `listPosition` smallint(6) NOT NULL,
  `numchars` int(10) unsigned NOT NULL DEFAULT '0',
  `maxchars` int(10) unsigned NOT NULL DEFAULT '5000',
  `isActive` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for sessions
-- ----------------------------
CREATE TABLE `sessions` (
  `id` char(56) NOT NULL,
  `userid` int(11) NOT NULL,
  `expiration` datetime NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `userid_UNIQUE` (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for users
-- ----------------------------
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `passhash` char(56) NOT NULL,
  `salt` char(56) NOT NULL,
  `email` varchar(256) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_UNIQUE` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records 
-- ----------------------------
INSERT INTO `gamedata_achievements` VALUES ('100', 'Battle', '0', '0');
INSERT INTO `gamedata_achievements` VALUES ('101', 'To Crush Your Enemies I', '1', '5');
INSERT INTO `gamedata_achievements` VALUES ('102', 'To Crush Your Enemies II', '2', '5');
INSERT INTO `gamedata_achievements` VALUES ('103', 'To Crush Your Enemies III', '3', '10');
INSERT INTO `gamedata_achievements` VALUES ('104', 'To Crush Your Enemies IV', '4', '10');
INSERT INTO `gamedata_achievements` VALUES ('105', 'To Crush Your Enemies V', '5', '10');
INSERT INTO `gamedata_achievements` VALUES ('106', 'To Crush Your Enemies VI', '6', '10');
INSERT INTO `gamedata_achievements` VALUES ('107', 'Let the Bodies Hit the Floor', '7', '30');
INSERT INTO `gamedata_achievements` VALUES ('108', 'La Noscea Big Game Hunter', '8', '10');
INSERT INTO `gamedata_achievements` VALUES ('109', 'Black Shroud Big Game Hunter', '9', '10');
INSERT INTO `gamedata_achievements` VALUES ('110', 'Thanalan Big Game Hunter', '10', '10');
INSERT INTO `gamedata_achievements` VALUES ('111', 'Coerthas Big Game Hunter', '11', '10');
INSERT INTO `gamedata_achievements` VALUES ('112', 'Mor Dhona Big Game Hunter', '12', '10');
INSERT INTO `gamedata_achievements` VALUES ('113', 'Shposhae Big Game Hunter', '13', '10');
INSERT INTO `gamedata_achievements` VALUES ('114', 'Bane of the Tribes', '14', '10');
INSERT INTO `gamedata_achievements` VALUES ('115', 'Notorious Monster Hunting', '15', '30');
INSERT INTO `gamedata_achievements` VALUES ('116', 'Had Me Some Fun', '16', '5');
INSERT INTO `gamedata_achievements` VALUES ('117', 'Most Adorable Death Ever', '17', '5');
INSERT INTO `gamedata_achievements` VALUES ('118', 'Where the Wind Blows', '18', '5');
INSERT INTO `gamedata_achievements` VALUES ('197', 'To Crush Your Enemies IV', '19', '0');
INSERT INTO `gamedata_achievements` VALUES ('198', 'Notorious Monster Hunting', '20', '0');
INSERT INTO `gamedata_achievements` VALUES ('199', 'Let the Bodies Hit the Floor', '21', '0');
INSERT INTO `gamedata_achievements` VALUES ('200', 'Character', '50', '0');
INSERT INTO `gamedata_achievements` VALUES ('201', 'Stick Them with the Pointy End I', '51', '5');
INSERT INTO `gamedata_achievements` VALUES ('202', 'Stick Them with the Pointy End II', '52', '5');
INSERT INTO `gamedata_achievements` VALUES ('203', 'Stick Them with the Pointy End III', '53', '5');
INSERT INTO `gamedata_achievements` VALUES ('204', 'Stick Them with the Pointy End IV', '54', '5');
INSERT INTO `gamedata_achievements` VALUES ('205', 'Stick Them with the Pointy End V', '55', '5');
INSERT INTO `gamedata_achievements` VALUES ('206', 'The Sweet Science I', '56', '5');
INSERT INTO `gamedata_achievements` VALUES ('207', 'The Sweet Science II', '57', '5');
INSERT INTO `gamedata_achievements` VALUES ('208', 'The Sweet Science III', '58', '5');
INSERT INTO `gamedata_achievements` VALUES ('209', 'The Sweet Science IV', '59', '5');
INSERT INTO `gamedata_achievements` VALUES ('210', 'The Sweet Science V', '60', '5');
INSERT INTO `gamedata_achievements` VALUES ('211', 'An Axe to Grind I', '61', '5');
INSERT INTO `gamedata_achievements` VALUES ('212', 'An Axe to Grind II', '62', '5');
INSERT INTO `gamedata_achievements` VALUES ('213', 'An Axe to Grind III', '63', '5');
INSERT INTO `gamedata_achievements` VALUES ('214', 'An Axe to Grind IV', '64', '5');
INSERT INTO `gamedata_achievements` VALUES ('215', 'An Axe to Grind V', '65', '5');
INSERT INTO `gamedata_achievements` VALUES ('216', 'Strong Lance Arm I', '66', '5');
INSERT INTO `gamedata_achievements` VALUES ('217', 'Strong Lance Arm II', '67', '5');
INSERT INTO `gamedata_achievements` VALUES ('218', 'Strong Lance Arm III', '68', '5');
INSERT INTO `gamedata_achievements` VALUES ('219', 'Strong Lance Arm IV', '69', '5');
INSERT INTO `gamedata_achievements` VALUES ('220', 'Strong Lance Arm V', '70', '5');
INSERT INTO `gamedata_achievements` VALUES ('221', 'Just Talkin\' \'Bout Shafts I', '71', '5');
INSERT INTO `gamedata_achievements` VALUES ('222', 'Just Talkin\' \'Bout Shafts II', '72', '5');
INSERT INTO `gamedata_achievements` VALUES ('223', 'Just Talkin\' \'Bout Shafts III', '73', '5');
INSERT INTO `gamedata_achievements` VALUES ('224', 'Just Talkin\' \'Bout Shafts IV', '74', '5');
INSERT INTO `gamedata_achievements` VALUES ('225', 'Just Talkin\' \'Bout Shafts V', '75', '5');
INSERT INTO `gamedata_achievements` VALUES ('226', 'Mastering War', '76', '20');
INSERT INTO `gamedata_achievements` VALUES ('227', 'I Got the Magic Stick I', '77', '5');
INSERT INTO `gamedata_achievements` VALUES ('228', 'I Got the Magic Stick II', '78', '5');
INSERT INTO `gamedata_achievements` VALUES ('229', 'I Got the Magic Stick III', '79', '5');
INSERT INTO `gamedata_achievements` VALUES ('230', 'I Got the Magic Stick IV', '80', '5');
INSERT INTO `gamedata_achievements` VALUES ('231', 'I Got the Magic Stick V', '81', '5');
INSERT INTO `gamedata_achievements` VALUES ('232', 'Bring Out Your Dead I', '82', '5');
INSERT INTO `gamedata_achievements` VALUES ('233', 'Bring Out Your Dead II', '83', '5');
INSERT INTO `gamedata_achievements` VALUES ('234', 'Bring Out Your Dead III', '84', '5');
INSERT INTO `gamedata_achievements` VALUES ('235', 'Bring Out Your Dead IV', '85', '5');
INSERT INTO `gamedata_achievements` VALUES ('236', 'Bring Out Your Dead V', '86', '5');
INSERT INTO `gamedata_achievements` VALUES ('237', 'Mastering Magic', '87', '20');
INSERT INTO `gamedata_achievements` VALUES ('238', 'A Life of Adventure', '88', '30');
INSERT INTO `gamedata_achievements` VALUES ('239', 'Knock on Wood I', '89', '5');
INSERT INTO `gamedata_achievements` VALUES ('240', 'Knock on Wood II', '90', '5');
INSERT INTO `gamedata_achievements` VALUES ('241', 'Knock on Wood III', '91', '5');
INSERT INTO `gamedata_achievements` VALUES ('242', 'Knock on Wood IV', '92', '5');
INSERT INTO `gamedata_achievements` VALUES ('243', 'Knock on Wood V', '93', '5');
INSERT INTO `gamedata_achievements` VALUES ('244', '\"Temper, Temper I\"', '94', '5');
INSERT INTO `gamedata_achievements` VALUES ('245', '\"Temper, Temper II\"', '95', '5');
INSERT INTO `gamedata_achievements` VALUES ('246', '\"Temper, Temper III\"', '96', '5');
INSERT INTO `gamedata_achievements` VALUES ('247', '\"Temper, Temper IV\"', '97', '5');
INSERT INTO `gamedata_achievements` VALUES ('248', '\"Temper, Temper V\"', '98', '5');
INSERT INTO `gamedata_achievements` VALUES ('249', 'The Riddle of Steel I', '99', '5');
INSERT INTO `gamedata_achievements` VALUES ('250', 'The Riddle of Steel II', '100', '5');
INSERT INTO `gamedata_achievements` VALUES ('251', 'The Riddle of Steel III', '101', '5');
INSERT INTO `gamedata_achievements` VALUES ('252', 'The Riddle of Steel IV', '102', '5');
INSERT INTO `gamedata_achievements` VALUES ('253', 'The Riddle of Steel V', '103', '5');
INSERT INTO `gamedata_achievements` VALUES ('254', 'Heart of Gold I', '104', '0');
INSERT INTO `gamedata_achievements` VALUES ('255', 'Heart of Gold II', '105', '5');
INSERT INTO `gamedata_achievements` VALUES ('256', 'Heart of Gold III', '106', '5');
INSERT INTO `gamedata_achievements` VALUES ('257', 'Heart of Gold IV', '107', '5');
INSERT INTO `gamedata_achievements` VALUES ('258', 'Heart of Gold V', '108', '5');
INSERT INTO `gamedata_achievements` VALUES ('259', 'Tougher Than Leather I', '109', '5');
INSERT INTO `gamedata_achievements` VALUES ('260', 'Tougher Than Leather II', '110', '5');
INSERT INTO `gamedata_achievements` VALUES ('261', 'Tougher Than Leather III', '111', '5');
INSERT INTO `gamedata_achievements` VALUES ('262', 'Tougher Than Leather IV', '112', '5');
INSERT INTO `gamedata_achievements` VALUES ('263', 'Tougher Than Leather V', '113', '5');
INSERT INTO `gamedata_achievements` VALUES ('264', '\"Smiling, Styling, and Textiling I\"', '114', '5');
INSERT INTO `gamedata_achievements` VALUES ('265', '\"Smiling, Styling, and Textiling II\"', '115', '5');
INSERT INTO `gamedata_achievements` VALUES ('266', '\"Smiling, Styling, and Textiling III\"', '116', '5');
INSERT INTO `gamedata_achievements` VALUES ('267', '\"Smiling, Styling, and Textiling IV\"', '117', '5');
INSERT INTO `gamedata_achievements` VALUES ('268', '\"Smiling, Styling, and Textiling V\"', '118', '5');
INSERT INTO `gamedata_achievements` VALUES ('269', '\'Tis True Without Lying I', '119', '5');
INSERT INTO `gamedata_achievements` VALUES ('270', '\'Tis True Without Lying II', '120', '5');
INSERT INTO `gamedata_achievements` VALUES ('271', '\'Tis True Without Lying III', '121', '5');
INSERT INTO `gamedata_achievements` VALUES ('272', '\'Tis True Without Lying IV', '122', '5');
INSERT INTO `gamedata_achievements` VALUES ('273', '\'Tis True Without Lying V', '123', '5');
INSERT INTO `gamedata_achievements` VALUES ('274', 'All in Good Taste I', '124', '5');
INSERT INTO `gamedata_achievements` VALUES ('275', 'All in Good Taste II', '125', '5');
INSERT INTO `gamedata_achievements` VALUES ('276', 'All in Good Taste III', '126', '5');
INSERT INTO `gamedata_achievements` VALUES ('277', 'All in Good Taste IV', '127', '5');
INSERT INTO `gamedata_achievements` VALUES ('278', 'All in Good Taste V', '128', '5');
INSERT INTO `gamedata_achievements` VALUES ('279', 'Mastering the Hand', '129', '20');
INSERT INTO `gamedata_achievements` VALUES ('280', 'Breaking Rocks in the Hot Sun I', '130', '5');
INSERT INTO `gamedata_achievements` VALUES ('281', 'Breaking Rocks in the Hot Sun II', '131', '5');
INSERT INTO `gamedata_achievements` VALUES ('282', 'Breaking Rocks in the Hot Sun III', '132', '5');
INSERT INTO `gamedata_achievements` VALUES ('283', 'Breaking Rocks in the Hot Sun IV', '133', '5');
INSERT INTO `gamedata_achievements` VALUES ('284', 'Breaking Rocks in the Hot Sun V', '134', '5');
INSERT INTO `gamedata_achievements` VALUES ('285', 'Don\'t Fear the Reaper I', '135', '5');
INSERT INTO `gamedata_achievements` VALUES ('286', 'Don\'t Fear the Reaper II', '136', '5');
INSERT INTO `gamedata_achievements` VALUES ('287', 'Don\'t Fear the Reaper III', '137', '5');
INSERT INTO `gamedata_achievements` VALUES ('288', 'Don\'t Fear the Reaper IV', '138', '5');
INSERT INTO `gamedata_achievements` VALUES ('289', 'Don\'t Fear the Reaper V', '139', '5');
INSERT INTO `gamedata_achievements` VALUES ('290', 'Gone Fishin\' I', '140', '5');
INSERT INTO `gamedata_achievements` VALUES ('291', 'Gone Fishin\' II', '141', '5');
INSERT INTO `gamedata_achievements` VALUES ('292', 'Gone Fishin\' III', '142', '5');
INSERT INTO `gamedata_achievements` VALUES ('293', 'Gone Fishin\' IV', '143', '5');
INSERT INTO `gamedata_achievements` VALUES ('294', 'Gone Fishin\' V', '144', '5');
INSERT INTO `gamedata_achievements` VALUES ('295', 'Mastering the Land', '145', '20');
INSERT INTO `gamedata_achievements` VALUES ('390', 'Mastering War', '146', '0');
INSERT INTO `gamedata_achievements` VALUES ('391', 'Mastering Magic', '147', '0');
INSERT INTO `gamedata_achievements` VALUES ('392', 'Mastering the Hand', '148', '0');
INSERT INTO `gamedata_achievements` VALUES ('393', 'Mastering the Land', '149', '0');
INSERT INTO `gamedata_achievements` VALUES ('394', 'A Life of Adventure', '150', '0');
INSERT INTO `gamedata_achievements` VALUES ('400', 'Currency', '200', '0');
INSERT INTO `gamedata_achievements` VALUES ('401', 'On the Payroll I', '201', '5');
INSERT INTO `gamedata_achievements` VALUES ('402', 'On the Payroll II', '202', '5');
INSERT INTO `gamedata_achievements` VALUES ('403', 'On the Payroll III', '203', '5');
INSERT INTO `gamedata_achievements` VALUES ('404', 'On the Payroll IV', '204', '5');
INSERT INTO `gamedata_achievements` VALUES ('405', 'On the Payroll V', '205', '5');
INSERT INTO `gamedata_achievements` VALUES ('406', 'Who Wants to Be a Gillionaire?', '206', '10');
INSERT INTO `gamedata_achievements` VALUES ('407', 'You Can\'t Take It With You I', '207', '5');
INSERT INTO `gamedata_achievements` VALUES ('408', 'You Can\'t Take It With You II', '208', '5');
INSERT INTO `gamedata_achievements` VALUES ('409', 'You Can\'t Take It With You III', '209', '5');
INSERT INTO `gamedata_achievements` VALUES ('410', 'You Can\'t Take It With You IV', '210', '5');
INSERT INTO `gamedata_achievements` VALUES ('411', 'You Can\'t Take It With You V', '211', '5');
INSERT INTO `gamedata_achievements` VALUES ('412', 'Never Met a Corpse I Couldn\'t Rifle', '212', '10');
INSERT INTO `gamedata_achievements` VALUES ('498', 'Who Wants to Be a Gillionaire?', '213', '0');
INSERT INTO `gamedata_achievements` VALUES ('499', 'Never Met a Corpse I Couldn\'t Rifle', '214', '0');
INSERT INTO `gamedata_achievements` VALUES ('500', 'Items', '250', '0');
INSERT INTO `gamedata_achievements` VALUES ('501', 'My Body is a Temple', '251', '5');
INSERT INTO `gamedata_achievements` VALUES ('502', 'Dress Like a Pirate Day', '252', '5');
INSERT INTO `gamedata_achievements` VALUES ('503', 'A Mummer in Motley', '253', '5');
INSERT INTO `gamedata_achievements` VALUES ('504', 'Raising the Curtana', '254', '10');
INSERT INTO `gamedata_achievements` VALUES ('505', 'Enter the Coeurl', '255', '10');
INSERT INTO `gamedata_achievements` VALUES ('506', 'Cleaving to Tradition', '256', '10');
INSERT INTO `gamedata_achievements` VALUES ('507', 'Having a Gae Old Time', '257', '10');
INSERT INTO `gamedata_achievements` VALUES ('508', 'Hard to Miss', '258', '10');
INSERT INTO `gamedata_achievements` VALUES ('509', 'Dressed to Heal', '259', '10');
INSERT INTO `gamedata_achievements` VALUES ('510', 'Ohohohohoho!', '260', '10');
INSERT INTO `gamedata_achievements` VALUES ('511', 'Armed to the Teeth', '261', '30');
INSERT INTO `gamedata_achievements` VALUES ('592', 'Raising the Curtana', '262', '0');
INSERT INTO `gamedata_achievements` VALUES ('593', 'Enter the Coeurl', '263', '0');
INSERT INTO `gamedata_achievements` VALUES ('594', 'Cleaving to Tradition', '264', '0');
INSERT INTO `gamedata_achievements` VALUES ('595', 'Having a Gae Old Time', '265', '0');
INSERT INTO `gamedata_achievements` VALUES ('596', 'Hard to Miss', '266', '0');
INSERT INTO `gamedata_achievements` VALUES ('597', 'Dressed to Heal', '267', '0');
INSERT INTO `gamedata_achievements` VALUES ('598', 'Ohohohohoho!', '268', '0');
INSERT INTO `gamedata_achievements` VALUES ('599', 'Armed to the Teeth', '269', '0');
INSERT INTO `gamedata_achievements` VALUES ('600', 'Synthesis', '300', '0');
INSERT INTO `gamedata_achievements` VALUES ('601', 'Going with the Grain: Amateur', '301', '5');
INSERT INTO `gamedata_achievements` VALUES ('602', 'Going with the Grain: Initiate', '302', '5');
INSERT INTO `gamedata_achievements` VALUES ('603', 'Going with the Grain: Apprentice', '303', '5');
INSERT INTO `gamedata_achievements` VALUES ('604', 'Going with the Grain: Journeyman', '304', '5');
INSERT INTO `gamedata_achievements` VALUES ('605', 'Going with the Grain: Artisan', '305', '10');
INSERT INTO `gamedata_achievements` VALUES ('606', 'A Carpenter\'s Life for Me', '306', '30');
INSERT INTO `gamedata_achievements` VALUES ('607', 'Working the Bellows: Amateur', '307', '5');
INSERT INTO `gamedata_achievements` VALUES ('608', 'Working the Bellows: Initiate', '308', '5');
INSERT INTO `gamedata_achievements` VALUES ('609', 'Working the Bellows: Apprentice', '309', '5');
INSERT INTO `gamedata_achievements` VALUES ('610', 'Working the Bellows: Journeyman', '310', '5');
INSERT INTO `gamedata_achievements` VALUES ('611', 'Working the Bellows: Artisan', '311', '10');
INSERT INTO `gamedata_achievements` VALUES ('612', 'A Blacksmith\'s Life for Me', '312', '30');
INSERT INTO `gamedata_achievements` VALUES ('613', 'Pounding Out the Dents: Amateur', '313', '5');
INSERT INTO `gamedata_achievements` VALUES ('614', 'Pounding Out the Dents: Initiate', '314', '5');
INSERT INTO `gamedata_achievements` VALUES ('615', 'Pounding Out the Dents: Apprentice', '315', '5');
INSERT INTO `gamedata_achievements` VALUES ('616', 'Pounding Out the Dents: Journeyman', '316', '5');
INSERT INTO `gamedata_achievements` VALUES ('617', 'Pounding Out the Dents: Artisan', '317', '10');
INSERT INTO `gamedata_achievements` VALUES ('618', 'An Armorer\'s Life for Me', '318', '30');
INSERT INTO `gamedata_achievements` VALUES ('619', 'Cutting the Carats: Amateur', '319', '5');
INSERT INTO `gamedata_achievements` VALUES ('620', 'Cutting the Carats: Initiate', '320', '5');
INSERT INTO `gamedata_achievements` VALUES ('621', 'Cutting the Carats: Apprentice', '321', '5');
INSERT INTO `gamedata_achievements` VALUES ('622', 'Cutting the Carats: Journeyman', '322', '5');
INSERT INTO `gamedata_achievements` VALUES ('623', 'Cutting the Carats: Artisan', '323', '10');
INSERT INTO `gamedata_achievements` VALUES ('624', 'A Goldsmith\'s Life for Me', '324', '30');
INSERT INTO `gamedata_achievements` VALUES ('625', 'Hiding in Plain Sight: Amateur', '325', '5');
INSERT INTO `gamedata_achievements` VALUES ('626', 'Hiding in Plain Sight: Initiate', '326', '5');
INSERT INTO `gamedata_achievements` VALUES ('627', 'Hiding in Plain Sight: Apprentice', '327', '5');
INSERT INTO `gamedata_achievements` VALUES ('628', 'Hiding in Plain Sight: Journeyman', '328', '5');
INSERT INTO `gamedata_achievements` VALUES ('629', 'Hiding in Plain Sight: Artisan', '329', '10');
INSERT INTO `gamedata_achievements` VALUES ('630', 'A Leatherworker\'s Life for Me', '330', '30');
INSERT INTO `gamedata_achievements` VALUES ('631', 'Threading the Needle: Amateur', '331', '5');
INSERT INTO `gamedata_achievements` VALUES ('632', 'Threading the Needle: Initiate', '332', '5');
INSERT INTO `gamedata_achievements` VALUES ('633', 'Threading the Needle: Apprentice', '333', '5');
INSERT INTO `gamedata_achievements` VALUES ('634', 'Threading the Needle: Journeyman', '334', '5');
INSERT INTO `gamedata_achievements` VALUES ('635', 'Threading the Needle: Artisan', '335', '10');
INSERT INTO `gamedata_achievements` VALUES ('636', 'A Weaver\'s Life for Me', '336', '30');
INSERT INTO `gamedata_achievements` VALUES ('637', 'Mixing It Up: Amateur', '337', '5');
INSERT INTO `gamedata_achievements` VALUES ('638', 'Mixing It Up: Initiate', '338', '5');
INSERT INTO `gamedata_achievements` VALUES ('639', 'Mixing It Up: Apprentice', '339', '5');
INSERT INTO `gamedata_achievements` VALUES ('640', 'Mixing It Up: Journeyman', '340', '5');
INSERT INTO `gamedata_achievements` VALUES ('641', 'Mixing It Up: Artisan', '341', '10');
INSERT INTO `gamedata_achievements` VALUES ('642', 'An Alchemist\'s Life for Me', '342', '30');
INSERT INTO `gamedata_achievements` VALUES ('643', 'Savoring the Realm: Amateur', '343', '5');
INSERT INTO `gamedata_achievements` VALUES ('644', 'Savoring the Realm: Initiate', '344', '5');
INSERT INTO `gamedata_achievements` VALUES ('645', 'Savoring the Realm: Apprentice', '345', '5');
INSERT INTO `gamedata_achievements` VALUES ('646', 'Savoring the Realm: Journeyman', '346', '5');
INSERT INTO `gamedata_achievements` VALUES ('647', 'Savoring the Realm: Artisan', '347', '10');
INSERT INTO `gamedata_achievements` VALUES ('648', 'A Life of Cooking', '348', '30');
INSERT INTO `gamedata_achievements` VALUES ('683', 'Going with the Grain: Artisan', '349', '0');
INSERT INTO `gamedata_achievements` VALUES ('684', 'Working the Bellows: Artisan', '350', '0');
INSERT INTO `gamedata_achievements` VALUES ('685', 'Pounding Out the Dents: Artisan', '351', '0');
INSERT INTO `gamedata_achievements` VALUES ('686', 'Cutting the Carats: Artisan', '352', '0');
INSERT INTO `gamedata_achievements` VALUES ('687', 'Hiding in Plain Sight: Artisan', '353', '0');
INSERT INTO `gamedata_achievements` VALUES ('688', 'Threading the Needle: Artisan', '354', '0');
INSERT INTO `gamedata_achievements` VALUES ('689', 'Mixing It Up: Artisan', '355', '0');
INSERT INTO `gamedata_achievements` VALUES ('690', 'Savoring the Realm: Artisan', '356', '0');
INSERT INTO `gamedata_achievements` VALUES ('691', 'A Carpenter\'s Life for Me', '357', '0');
INSERT INTO `gamedata_achievements` VALUES ('692', 'A Blacksmith\'s Life for Me', '358', '0');
INSERT INTO `gamedata_achievements` VALUES ('693', 'An Armorer\'s Life for Me', '359', '0');
INSERT INTO `gamedata_achievements` VALUES ('694', 'A Goldsmith\'s Life for Me', '360', '0');
INSERT INTO `gamedata_achievements` VALUES ('695', 'A Leatherworker\'s Life for Me', '361', '0');
INSERT INTO `gamedata_achievements` VALUES ('696', 'A Weaver\'s Life for Me', '362', '0');
INSERT INTO `gamedata_achievements` VALUES ('697', 'An Alchemist\'s Life for Me', '363', '0');
INSERT INTO `gamedata_achievements` VALUES ('698', 'A Life of Cooking', '364', '0');
INSERT INTO `gamedata_achievements` VALUES ('700', 'Gathering', '400', '0');
INSERT INTO `gamedata_achievements` VALUES ('701', 'Mining Your Own Business: La Noscea I', '401', '5');
INSERT INTO `gamedata_achievements` VALUES ('702', 'Mining Your Own Business: La Noscea II', '402', '5');
INSERT INTO `gamedata_achievements` VALUES ('703', 'Mining Your Own Business: La Noscea III', '403', '5');
INSERT INTO `gamedata_achievements` VALUES ('704', 'Mining Your Own Business: La Noscea IV', '404', '5');
INSERT INTO `gamedata_achievements` VALUES ('705', 'Mining Your Own Business: La Noscea V', '405', '5');
INSERT INTO `gamedata_achievements` VALUES ('706', 'A Miner\'s Life for Me: La Noscea', '406', '10');
INSERT INTO `gamedata_achievements` VALUES ('707', 'Mining Your Own Business: Black Shroud I', '407', '5');
INSERT INTO `gamedata_achievements` VALUES ('708', 'Mining Your Own Business: Black Shroud II', '408', '5');
INSERT INTO `gamedata_achievements` VALUES ('709', 'Mining Your Own Business: Black Shroud III', '409', '5');
INSERT INTO `gamedata_achievements` VALUES ('710', 'Mining Your Own Business: Black Shroud IV', '410', '5');
INSERT INTO `gamedata_achievements` VALUES ('711', 'Mining Your Own Business: Black Shroud V', '411', '5');
INSERT INTO `gamedata_achievements` VALUES ('712', 'A Miner\'s Life for Me: Black Shroud', '412', '10');
INSERT INTO `gamedata_achievements` VALUES ('713', 'Mining Your Own Business: Thanalan I', '413', '5');
INSERT INTO `gamedata_achievements` VALUES ('714', 'Mining Your Own Business: Thanalan II', '414', '5');
INSERT INTO `gamedata_achievements` VALUES ('715', 'Mining Your Own Business: Thanalan III', '415', '5');
INSERT INTO `gamedata_achievements` VALUES ('716', 'Mining Your Own Business: Thanalan IV', '416', '5');
INSERT INTO `gamedata_achievements` VALUES ('717', 'Mining Your Own Business: Thanalan V', '417', '5');
INSERT INTO `gamedata_achievements` VALUES ('718', 'A Miner\'s Life for Me: Thanalan', '418', '10');
INSERT INTO `gamedata_achievements` VALUES ('719', 'A Miner\'s Life for Me: Eorzea', '419', '30');
INSERT INTO `gamedata_achievements` VALUES ('720', 'Rocking Around the Clock: La Noscea I', '420', '5');
INSERT INTO `gamedata_achievements` VALUES ('721', 'Rocking Around the Clock: La Noscea II', '421', '5');
INSERT INTO `gamedata_achievements` VALUES ('722', 'Rocking Around the Clock: La Noscea III', '422', '5');
INSERT INTO `gamedata_achievements` VALUES ('723', 'Rocking Around the Clock: La Noscea IV', '423', '5');
INSERT INTO `gamedata_achievements` VALUES ('724', 'Rocking Around the Clock: La Noscea V', '424', '5');
INSERT INTO `gamedata_achievements` VALUES ('725', 'I\'d Rather Be Quarrying: La Noscea', '425', '10');
INSERT INTO `gamedata_achievements` VALUES ('726', 'Rocking Around the Clock: Black Shroud I', '426', '5');
INSERT INTO `gamedata_achievements` VALUES ('727', 'Rocking Around the Clock: Black Shroud II', '427', '5');
INSERT INTO `gamedata_achievements` VALUES ('728', 'Rocking Around the Clock: Black Shroud III', '428', '5');
INSERT INTO `gamedata_achievements` VALUES ('729', 'Rocking Around the Clock: Black Shroud IV', '429', '5');
INSERT INTO `gamedata_achievements` VALUES ('730', 'Rocking Around the Clock: Black Shroud V', '430', '5');
INSERT INTO `gamedata_achievements` VALUES ('731', 'I\'d Rather Be Quarrying: Black Shroud', '431', '10');
INSERT INTO `gamedata_achievements` VALUES ('732', 'Rocking Around the Clock: Thanalan I', '432', '5');
INSERT INTO `gamedata_achievements` VALUES ('733', 'Rocking Around the Clock: Thanalan II', '433', '5');
INSERT INTO `gamedata_achievements` VALUES ('734', 'Rocking Around the Clock: Thanalan III', '434', '5');
INSERT INTO `gamedata_achievements` VALUES ('735', 'Rocking Around the Clock: Thanalan IV', '435', '5');
INSERT INTO `gamedata_achievements` VALUES ('736', 'Rocking Around the Clock: Thanalan V', '436', '5');
INSERT INTO `gamedata_achievements` VALUES ('737', 'I\'d Rather Be Quarrying: Thanalan', '437', '10');
INSERT INTO `gamedata_achievements` VALUES ('738', 'Logging the Hours: La Noscea I', '438', '5');
INSERT INTO `gamedata_achievements` VALUES ('739', 'Logging the Hours: La Noscea II', '439', '5');
INSERT INTO `gamedata_achievements` VALUES ('740', 'Logging the Hours: La Noscea III', '440', '5');
INSERT INTO `gamedata_achievements` VALUES ('741', 'Logging the Hours: La Noscea IV', '441', '5');
INSERT INTO `gamedata_achievements` VALUES ('742', 'Logging the Hours: La Noscea V', '442', '5');
INSERT INTO `gamedata_achievements` VALUES ('743', 'A Botanist\'s Life for Me: La Noscea', '443', '10');
INSERT INTO `gamedata_achievements` VALUES ('744', 'Logging the Hours: Black Shroud I', '444', '5');
INSERT INTO `gamedata_achievements` VALUES ('745', 'Logging the Hours: Black Shroud II', '445', '5');
INSERT INTO `gamedata_achievements` VALUES ('746', 'Logging the Hours: Black Shroud III', '446', '5');
INSERT INTO `gamedata_achievements` VALUES ('747', 'Logging the Hours: Black Shroud IV', '447', '5');
INSERT INTO `gamedata_achievements` VALUES ('748', 'Logging the Hours: Black Shroud V', '448', '5');
INSERT INTO `gamedata_achievements` VALUES ('749', 'A Botanist\'s Life for Me: Black Shroud', '449', '10');
INSERT INTO `gamedata_achievements` VALUES ('750', 'Logging the Hours: Thanalan I', '450', '5');
INSERT INTO `gamedata_achievements` VALUES ('751', 'Logging the Hours: Thanalan II', '451', '5');
INSERT INTO `gamedata_achievements` VALUES ('752', 'Logging the Hours: Thanalan III', '452', '5');
INSERT INTO `gamedata_achievements` VALUES ('753', 'Logging the Hours: Thanalan IV', '453', '5');
INSERT INTO `gamedata_achievements` VALUES ('754', 'Logging the Hours: Thanalan V', '454', '5');
INSERT INTO `gamedata_achievements` VALUES ('755', 'A Botanist\'s Life for Me: Thanalan', '455', '10');
INSERT INTO `gamedata_achievements` VALUES ('756', 'A Botanist\'s Life for Me: Eorzea', '456', '30');
INSERT INTO `gamedata_achievements` VALUES ('757', 'Reaping What You Sow: La Noscea I', '457', '5');
INSERT INTO `gamedata_achievements` VALUES ('758', 'Reaping What You Sow: La Noscea II', '458', '5');
INSERT INTO `gamedata_achievements` VALUES ('759', 'Reaping What You Sow: La Noscea III', '459', '5');
INSERT INTO `gamedata_achievements` VALUES ('760', 'Reaping What You Sow: La Noscea IV', '460', '5');
INSERT INTO `gamedata_achievements` VALUES ('761', 'Reaping What You Sow: La Noscea V', '461', '5');
INSERT INTO `gamedata_achievements` VALUES ('762', 'I\'d Rather Be Harvesting: La Noscea', '462', '10');
INSERT INTO `gamedata_achievements` VALUES ('763', 'Reaping What You Sow: Black Shroud I', '463', '5');
INSERT INTO `gamedata_achievements` VALUES ('764', 'Reaping What You Sow: Black Shroud II', '464', '5');
INSERT INTO `gamedata_achievements` VALUES ('765', 'Reaping What You Sow: Black Shroud III', '465', '5');
INSERT INTO `gamedata_achievements` VALUES ('766', 'Reaping What You Sow: Black Shroud IV', '466', '5');
INSERT INTO `gamedata_achievements` VALUES ('767', 'Reaping What You Sow: Black Shroud V', '467', '5');
INSERT INTO `gamedata_achievements` VALUES ('768', 'I\'d Rather Be Harvesting: Black Shroud', '468', '10');
INSERT INTO `gamedata_achievements` VALUES ('769', 'Reaping What You Sow: Thanalan I', '469', '5');
INSERT INTO `gamedata_achievements` VALUES ('770', 'Reaping What You Sow: Thanalan II', '470', '5');
INSERT INTO `gamedata_achievements` VALUES ('771', 'Reaping What You Sow: Thanalan III', '471', '5');
INSERT INTO `gamedata_achievements` VALUES ('772', 'Reaping What You Sow: Thanalan IV', '472', '5');
INSERT INTO `gamedata_achievements` VALUES ('773', 'Reaping What You Sow: Thanalan V', '473', '5');
INSERT INTO `gamedata_achievements` VALUES ('774', 'I\'d Rather Be Harvesting: Thanalan', '474', '10');
INSERT INTO `gamedata_achievements` VALUES ('775', 'Good Things Come to Those Who Bait: La Noscea I', '475', '5');
INSERT INTO `gamedata_achievements` VALUES ('776', 'Good Things Come to Those Who Bait: La Noscea II', '476', '5');
INSERT INTO `gamedata_achievements` VALUES ('777', 'Good Things Come to Those Who Bait: La Noscea III', '477', '5');
INSERT INTO `gamedata_achievements` VALUES ('778', 'Good Things Come to Those Who Bait: La Noscea IV', '478', '5');
INSERT INTO `gamedata_achievements` VALUES ('779', 'Good Things Come to Those Who Bait: La Noscea V', '479', '5');
INSERT INTO `gamedata_achievements` VALUES ('780', 'A Fisher\'s Life for Me: La Noscea', '480', '10');
INSERT INTO `gamedata_achievements` VALUES ('781', 'Good Things Come to Those Who Bait: Black Shroud I', '481', '5');
INSERT INTO `gamedata_achievements` VALUES ('782', 'Good Things Come to Those Who Bait: Black Shroud II', '482', '5');
INSERT INTO `gamedata_achievements` VALUES ('783', 'Good Things Come to Those Who Bait: Black Shroud III', '483', '5');
INSERT INTO `gamedata_achievements` VALUES ('784', 'Good Things Come to Those Who Bait: Black Shroud IV', '484', '5');
INSERT INTO `gamedata_achievements` VALUES ('785', 'Good Things Come to Those Who Bait: Black Shroud V', '485', '5');
INSERT INTO `gamedata_achievements` VALUES ('786', 'A Fisher\'s Life for Me: Black Shroud', '486', '10');
INSERT INTO `gamedata_achievements` VALUES ('787', 'Good Things Come to Those Who Bait: Thanalan I', '487', '5');
INSERT INTO `gamedata_achievements` VALUES ('788', 'Good Things Come to Those Who Bait: Thanalan II', '488', '5');
INSERT INTO `gamedata_achievements` VALUES ('789', 'Good Things Come to Those Who Bait: Thanalan III', '489', '5');
INSERT INTO `gamedata_achievements` VALUES ('790', 'Good Things Come to Those Who Bait: Thanalan IV', '490', '5');
INSERT INTO `gamedata_achievements` VALUES ('791', 'Good Things Come to Those Who Bait: Thanalan V', '491', '5');
INSERT INTO `gamedata_achievements` VALUES ('792', 'A Fisher\'s Life for Me: Thanalan', '492', '10');
INSERT INTO `gamedata_achievements` VALUES ('793', 'A Fisher\'s Life for Me: Eorzea', '493', '30');
INSERT INTO `gamedata_achievements` VALUES ('794', 'Getting Giggy with It: La Noscea I', '494', '5');
INSERT INTO `gamedata_achievements` VALUES ('795', 'Getting Giggy with It: La Noscea II', '495', '5');
INSERT INTO `gamedata_achievements` VALUES ('796', 'Getting Giggy with It: La Noscea III', '496', '5');
INSERT INTO `gamedata_achievements` VALUES ('797', 'Getting Giggy with It: La Noscea IV', '497', '5');
INSERT INTO `gamedata_achievements` VALUES ('798', 'Getting Giggy with It: La Noscea V', '498', '5');
INSERT INTO `gamedata_achievements` VALUES ('799', 'I\'d Rather Be Spearfishing: La Noscea', '499', '10');
INSERT INTO `gamedata_achievements` VALUES ('800', 'Getting Giggy with It: Black Shroud I', '500', '5');
INSERT INTO `gamedata_achievements` VALUES ('801', 'Getting Giggy with It: Black Shroud II', '501', '5');
INSERT INTO `gamedata_achievements` VALUES ('802', 'Getting Giggy with It: Black Shroud III', '502', '5');
INSERT INTO `gamedata_achievements` VALUES ('803', 'Getting Giggy with It: Black Shroud IV', '503', '5');
INSERT INTO `gamedata_achievements` VALUES ('804', 'Getting Giggy with It: Black Shroud V', '504', '5');
INSERT INTO `gamedata_achievements` VALUES ('805', 'I\'d Rather Be Spearfishing: Black Shroud', '505', '10');
INSERT INTO `gamedata_achievements` VALUES ('806', 'Getting Giggy with It: Thanalan I', '506', '5');
INSERT INTO `gamedata_achievements` VALUES ('807', 'Getting Giggy with It: Thanalan II', '507', '5');
INSERT INTO `gamedata_achievements` VALUES ('808', 'Getting Giggy with It: Thanalan III', '508', '5');
INSERT INTO `gamedata_achievements` VALUES ('809', 'Getting Giggy with It: Thanalan IV', '509', '5');
INSERT INTO `gamedata_achievements` VALUES ('810', 'Getting Giggy with It: Thanalan V', '510', '5');
INSERT INTO `gamedata_achievements` VALUES ('811', 'I\'d Rather Be Spearfishing: Thanalan', '511', '10');
INSERT INTO `gamedata_achievements` VALUES ('879', 'A Miner\'s Life for Me: La Noscea', '512', '0');
INSERT INTO `gamedata_achievements` VALUES ('880', 'A Miner\'s Life for Me: Black Shroud', '513', '0');
INSERT INTO `gamedata_achievements` VALUES ('881', 'A Miner\'s Life for Me: Thanalan', '514', '0');
INSERT INTO `gamedata_achievements` VALUES ('882', 'I\'d Rather Be Quarrying: La Noscea', '515', '0');
INSERT INTO `gamedata_achievements` VALUES ('883', 'I\'d Rather Be Quarrying: Black Shroud', '516', '0');
INSERT INTO `gamedata_achievements` VALUES ('884', 'I\'d Rather Be Quarrying: Thanalan', '517', '0');
INSERT INTO `gamedata_achievements` VALUES ('885', 'A Botanist\'s Life for Me: La Noscea', '518', '0');
INSERT INTO `gamedata_achievements` VALUES ('886', 'A Botanist\'s Life for Me: Black Shroud', '519', '0');
INSERT INTO `gamedata_achievements` VALUES ('887', 'A Botanist\'s Life for Me: Thanalan', '520', '0');
INSERT INTO `gamedata_achievements` VALUES ('888', 'I\'d Rather Be Harvesting: La Noscea', '521', '0');
INSERT INTO `gamedata_achievements` VALUES ('889', 'I\'d Rather Be Harvesting: Black Shroud', '522', '0');
INSERT INTO `gamedata_achievements` VALUES ('890', 'I\'d Rather Be Harvesting: Thanalan', '523', '0');
INSERT INTO `gamedata_achievements` VALUES ('891', 'A Fisher\'s Life for Me: La Noscea', '524', '0');
INSERT INTO `gamedata_achievements` VALUES ('892', 'A Fisher\'s Life for Me: Black Shroud', '525', '0');
INSERT INTO `gamedata_achievements` VALUES ('893', 'A Fisher\'s Life for Me: Thanalan', '526', '0');
INSERT INTO `gamedata_achievements` VALUES ('894', 'I\'d Rather Be Spearfishing: La Noscea', '527', '0');
INSERT INTO `gamedata_achievements` VALUES ('895', 'I\'d Rather Be Spearfishing: Black Shroud', '528', '0');
INSERT INTO `gamedata_achievements` VALUES ('896', 'I\'d Rather Be Spearfishing: Thanalan', '529', '0');
INSERT INTO `gamedata_achievements` VALUES ('897', 'A Miner\'s Life for Me: Eorzea', '530', '0');
INSERT INTO `gamedata_achievements` VALUES ('898', 'A Botanist\'s Life for Me: Eorzea', '531', '0');
INSERT INTO `gamedata_achievements` VALUES ('899', 'A Fisher\'s Life for Me: Eorzea', '532', '0');
INSERT INTO `gamedata_achievements` VALUES ('900', 'Materia', '550', '0');
INSERT INTO `gamedata_achievements` VALUES ('901', 'Getting Too Attached I', '551', '5');
INSERT INTO `gamedata_achievements` VALUES ('902', 'Getting Too Attached II', '552', '5');
INSERT INTO `gamedata_achievements` VALUES ('903', 'Getting Too Attached III', '553', '5');
INSERT INTO `gamedata_achievements` VALUES ('904', 'Getting Too Attached IV', '554', '5');
INSERT INTO `gamedata_achievements` VALUES ('905', 'Materia Hysteria', '555', '10');
INSERT INTO `gamedata_achievements` VALUES ('906', 'Beginner\'s Luck', '556', '10');
INSERT INTO `gamedata_achievements` VALUES ('907', 'I Make My Own Luck', '557', '20');
INSERT INTO `gamedata_achievements` VALUES ('908', 'Luck\'s Got Nothing to Do with It', '558', '30');
INSERT INTO `gamedata_achievements` VALUES ('909', 'I Got This!', '559', '40');
INSERT INTO `gamedata_achievements` VALUES ('910', 'Prepare to Be Assimilated I', '560', '5');
INSERT INTO `gamedata_achievements` VALUES ('911', 'Prepare to Be Assimilated II', '561', '5');
INSERT INTO `gamedata_achievements` VALUES ('912', 'Prepare to Be Assimilated III', '562', '5');
INSERT INTO `gamedata_achievements` VALUES ('913', 'Prepare to Be Assimilated IV', '563', '5');
INSERT INTO `gamedata_achievements` VALUES ('914', 'Living in a Materia World', '564', '10');
INSERT INTO `gamedata_achievements` VALUES ('997', 'Materia Hysteria', '565', '0');
INSERT INTO `gamedata_achievements` VALUES ('998', 'Living in a Materia World', '566', '0');
INSERT INTO `gamedata_achievements` VALUES ('999', 'I Got This!', '567', '0');
INSERT INTO `gamedata_achievements` VALUES ('1000', 'Quests', '600', '0');
INSERT INTO `gamedata_achievements` VALUES ('1001', 'Leaving Limsa Lominsa', '601', '5');
INSERT INTO `gamedata_achievements` VALUES ('1002', 'Gone from Gridania', '602', '5');
INSERT INTO `gamedata_achievements` VALUES ('1003', 'Out of Ul\'dah', '603', '5');
INSERT INTO `gamedata_achievements` VALUES ('1004', '\"This One Time, at Level Thirty-six...\"', '604', '5');
INSERT INTO `gamedata_achievements` VALUES ('1005', 'Tales of War', '605', '10');
INSERT INTO `gamedata_achievements` VALUES ('1006', 'Tales of Magic', '606', '10');
INSERT INTO `gamedata_achievements` VALUES ('1007', 'Tales of the Hand', '607', '10');
INSERT INTO `gamedata_achievements` VALUES ('1008', 'Tales of the Land', '608', '10');
INSERT INTO `gamedata_achievements` VALUES ('1009', 'The Greatest Tales Ever Told', '609', '20');
INSERT INTO `gamedata_achievements` VALUES ('1010', 'A Little Something on the Side: La Noscea', '610', '5');
INSERT INTO `gamedata_achievements` VALUES ('1011', 'A Little Something on the Side: Black Shroud', '611', '5');
INSERT INTO `gamedata_achievements` VALUES ('1012', 'A Little Something on the Side: Thanalan', '612', '5');
INSERT INTO `gamedata_achievements` VALUES ('1013', 'Sideways', '613', '10');
INSERT INTO `gamedata_achievements` VALUES ('1014', 'All the More Region to Leve I', '614', '5');
INSERT INTO `gamedata_achievements` VALUES ('1015', 'All the More Region to Leve II', '615', '5');
INSERT INTO `gamedata_achievements` VALUES ('1016', 'All the More Region to Leve III', '616', '5');
INSERT INTO `gamedata_achievements` VALUES ('1017', 'All the More Region to Leve IV', '617', '5');
INSERT INTO `gamedata_achievements` VALUES ('1018', 'All the More Region to Leve V', '618', '5');
INSERT INTO `gamedata_achievements` VALUES ('1019', 'All the More Region to Leve VI', '619', '10');
INSERT INTO `gamedata_achievements` VALUES ('1020', 'Region d\'Etre', '620', '20');
INSERT INTO `gamedata_achievements` VALUES ('1021', '\"Think Global, Quest Local I\"', '621', '5');
INSERT INTO `gamedata_achievements` VALUES ('1022', '\"Think Global, Quest Local II\"', '622', '5');
INSERT INTO `gamedata_achievements` VALUES ('1023', '\"Think Global, Quest Local III\"', '623', '5');
INSERT INTO `gamedata_achievements` VALUES ('1024', '\"Think Global, Quest Local IV\"', '624', '5');
INSERT INTO `gamedata_achievements` VALUES ('1025', '\"Think Global, Quest Local V\"', '625', '5');
INSERT INTO `gamedata_achievements` VALUES ('1026', '\"Think Global, Quest Local VI\"', '626', '10');
INSERT INTO `gamedata_achievements` VALUES ('1027', 'Lost in Localization', '627', '20');
INSERT INTO `gamedata_achievements` VALUES ('1028', 'A Slave to Faction I', '628', '5');
INSERT INTO `gamedata_achievements` VALUES ('1029', 'A Slave to Faction II', '629', '5');
INSERT INTO `gamedata_achievements` VALUES ('1030', 'A Slave to Faction III', '630', '10');
INSERT INTO `gamedata_achievements` VALUES ('1031', '\"Just the Factions, Ma\'am\"', '631', '20');
INSERT INTO `gamedata_achievements` VALUES ('1032', 'Serving a Greater Cause I', '632', '5');
INSERT INTO `gamedata_achievements` VALUES ('1033', 'Serving a Greater Cause II', '633', '5');
INSERT INTO `gamedata_achievements` VALUES ('1034', 'Serving a Greater Cause III', '634', '5');
INSERT INTO `gamedata_achievements` VALUES ('1035', 'Serving a Greater Cause IV', '635', '5');
INSERT INTO `gamedata_achievements` VALUES ('1036', 'Serving a Greater Cause V', '636', '5');
INSERT INTO `gamedata_achievements` VALUES ('1037', 'Serving a Greater Cause VI', '637', '10');
INSERT INTO `gamedata_achievements` VALUES ('1038', 'Enraptured Servitude', '638', '20');
INSERT INTO `gamedata_achievements` VALUES ('1039', 'Around the Realm and Back Again', '639', '5');
INSERT INTO `gamedata_achievements` VALUES ('1040', 'I Survived Camp Bearded Rock', '640', '5');
INSERT INTO `gamedata_achievements` VALUES ('1041', 'I Survived Cedarwood', '641', '5');
INSERT INTO `gamedata_achievements` VALUES ('1042', 'I Survived Camp Skull Valley', '642', '5');
INSERT INTO `gamedata_achievements` VALUES ('1043', 'I Survived Camp Bald Knoll', '643', '5');
INSERT INTO `gamedata_achievements` VALUES ('1044', 'I Survived Camp Bloodshore', '644', '5');
INSERT INTO `gamedata_achievements` VALUES ('1045', 'I Survived Cassiopeia Hollow', '645', '5');
INSERT INTO `gamedata_achievements` VALUES ('1046', 'I Survived Camp Iron Lake', '646', '5');
INSERT INTO `gamedata_achievements` VALUES ('1047', 'And All I Got Was This Lousy Achievement: La Noscea', '647', '10');
INSERT INTO `gamedata_achievements` VALUES ('1048', 'I Survived Camp Bentbranch', '648', '5');
INSERT INTO `gamedata_achievements` VALUES ('1049', 'I Survived Humblehearth', '649', '5');
INSERT INTO `gamedata_achievements` VALUES ('1050', 'I Survived Camp Nine Ivies', '650', '5');
INSERT INTO `gamedata_achievements` VALUES ('1051', 'I Survived Camp Emerald Moss', '651', '5');
INSERT INTO `gamedata_achievements` VALUES ('1052', 'I Survived Treespeak', '652', '5');
INSERT INTO `gamedata_achievements` VALUES ('1053', 'I Survived the Mun-Tuy Cellars', '653', '5');
INSERT INTO `gamedata_achievements` VALUES ('1054', 'I Survived Camp Tranquil', '654', '5');
INSERT INTO `gamedata_achievements` VALUES ('1055', 'And All I Got Was This Lousy Achievement: Black Shroud', '655', '10');
INSERT INTO `gamedata_achievements` VALUES ('1056', 'I Survived Camp Black Brush', '656', '5');
INSERT INTO `gamedata_achievements` VALUES ('1057', 'I Survived the Nanawa Mines', '657', '5');
INSERT INTO `gamedata_achievements` VALUES ('1058', 'I Survived Camp Drybone', '658', '5');
INSERT INTO `gamedata_achievements` VALUES ('1059', 'I Survived Halatali', '659', '5');
INSERT INTO `gamedata_achievements` VALUES ('1060', 'I Survived Camp Horizon', '660', '5');
INSERT INTO `gamedata_achievements` VALUES ('1061', 'I Survived Nophica\'s Wells', '661', '5');
INSERT INTO `gamedata_achievements` VALUES ('1062', 'I Survived Camp Broken Water', '662', '5');
INSERT INTO `gamedata_achievements` VALUES ('1063', 'And All I Got Was This Lousy Achievement: Thanalan', '663', '10');
INSERT INTO `gamedata_achievements` VALUES ('1064', 'Globetrotter', '664', '20');
INSERT INTO `gamedata_achievements` VALUES ('1065', 'At the Realm\'s Behest', '665', '5');
INSERT INTO `gamedata_achievements` VALUES ('1066', 'To Serve and Protect: Camp Bearded Rock', '666', '5');
INSERT INTO `gamedata_achievements` VALUES ('1067', 'To Serve and Protect: Cedarwood', '667', '5');
INSERT INTO `gamedata_achievements` VALUES ('1068', 'To Serve and Protect: Camp Skull Valley', '668', '5');
INSERT INTO `gamedata_achievements` VALUES ('1069', 'To Serve and Protect: Camp Bald Knoll', '669', '5');
INSERT INTO `gamedata_achievements` VALUES ('1070', 'To Serve and Protect: Camp Bloodshore', '670', '5');
INSERT INTO `gamedata_achievements` VALUES ('1071', 'To Serve and Protect: Cassiopeia Hollow', '671', '5');
INSERT INTO `gamedata_achievements` VALUES ('1072', 'To Serve and Protect: Camp Iron Lake', '672', '5');
INSERT INTO `gamedata_achievements` VALUES ('1073', 'La Noscea Got Served...and Protected', '673', '10');
INSERT INTO `gamedata_achievements` VALUES ('1074', 'To Serve and Protect: Camp Bentbranch', '674', '5');
INSERT INTO `gamedata_achievements` VALUES ('1075', 'To Serve and Protect: Humblehearth', '675', '5');
INSERT INTO `gamedata_achievements` VALUES ('1076', 'To Serve and Protect: Camp Nine Ivies', '676', '5');
INSERT INTO `gamedata_achievements` VALUES ('1077', 'To Serve and Protect: Camp Emerald Moss', '677', '5');
INSERT INTO `gamedata_achievements` VALUES ('1078', 'To Serve and Protect: Treespeak', '678', '5');
INSERT INTO `gamedata_achievements` VALUES ('1079', 'To Serve and Protect: Mun[@1F]Tuy Cellars', '679', '5');
INSERT INTO `gamedata_achievements` VALUES ('1080', 'To Serve and Protect: Camp Tranquil', '680', '5');
INSERT INTO `gamedata_achievements` VALUES ('1081', 'The Black Shroud Got Served...and Protected', '681', '10');
INSERT INTO `gamedata_achievements` VALUES ('1082', 'To Serve and Protect: Camp Black Brush', '682', '5');
INSERT INTO `gamedata_achievements` VALUES ('1083', 'To Serve and Protect: Nanawa Silvermines', '683', '5');
INSERT INTO `gamedata_achievements` VALUES ('1084', 'To Serve and Protect: Camp Drybone', '684', '5');
INSERT INTO `gamedata_achievements` VALUES ('1085', 'To Serve and Protect: Halatali', '685', '5');
INSERT INTO `gamedata_achievements` VALUES ('1086', 'To Serve and Protect: Camp Horizon', '686', '5');
INSERT INTO `gamedata_achievements` VALUES ('1087', 'To Serve and Protect: Nophica\'s Wells', '687', '5');
INSERT INTO `gamedata_achievements` VALUES ('1088', 'To Serve and Protect: Camp Broken Water', '688', '5');
INSERT INTO `gamedata_achievements` VALUES ('1089', 'Thanalan Got Served...and Protected', '689', '10');
INSERT INTO `gamedata_achievements` VALUES ('1090', 'Eorzea Got Served...and Protected', '690', '20');
INSERT INTO `gamedata_achievements` VALUES ('1091', 'Leaning Towards the Brotherhood', '691', '5');
INSERT INTO `gamedata_achievements` VALUES ('1092', 'Love Thy Brother', '692', '10');
INSERT INTO `gamedata_achievements` VALUES ('1093', 'Leaning Towards the Shield', '693', '5');
INSERT INTO `gamedata_achievements` VALUES ('1094', 'Another Brick in the Shield Wall', '694', '10');
INSERT INTO `gamedata_achievements` VALUES ('1095', 'Leaning Towards the Horn', '695', '5');
INSERT INTO `gamedata_achievements` VALUES ('1096', 'A Helping Horn', '696', '10');
INSERT INTO `gamedata_achievements` VALUES ('1097', 'Commitment Issues', '697', '20');
INSERT INTO `gamedata_achievements` VALUES ('1098', 'Like a Knight in Shining Armor', '698', '5');
INSERT INTO `gamedata_achievements` VALUES ('1099', 'Bulletproof', '699', '5');
INSERT INTO `gamedata_achievements` VALUES ('1100', 'I am the Warrior', '700', '5');
INSERT INTO `gamedata_achievements` VALUES ('1101', 'Dragoon Age', '701', '5');
INSERT INTO `gamedata_achievements` VALUES ('1102', 'A Bard\'s Tale', '702', '5');
INSERT INTO `gamedata_achievements` VALUES ('1103', 'Seeing White', '703', '5');
INSERT INTO `gamedata_achievements` VALUES ('1104', 'Back in Black', '704', '5');
INSERT INTO `gamedata_achievements` VALUES ('1105', 'Career Opportunities', '705', '20');
INSERT INTO `gamedata_achievements` VALUES ('1106', 'Once in a Lifetime', '706', '20');
INSERT INTO `gamedata_achievements` VALUES ('1107', 'x', '707', '1');
INSERT INTO `gamedata_achievements` VALUES ('1108', 'x', '708', '1');
INSERT INTO `gamedata_achievements` VALUES ('1109', 'x', '709', '1');
INSERT INTO `gamedata_achievements` VALUES ('1110', 'x', '710', '1');
INSERT INTO `gamedata_achievements` VALUES ('1156', 'Once in a Lifetime', '711', '20');
INSERT INTO `gamedata_achievements` VALUES ('1157', 'Patricide', '712', '0');
INSERT INTO `gamedata_achievements` VALUES ('1158', 'To Kill a Mocking Bird', '713', '0');
INSERT INTO `gamedata_achievements` VALUES ('1159', 'Pounding the Spike', '714', '0');
INSERT INTO `gamedata_achievements` VALUES ('1160', 'First Blood: Aleport', '715', '0');
INSERT INTO `gamedata_achievements` VALUES ('1161', 'First Blood: Hyrstmill', '716', '0');
INSERT INTO `gamedata_achievements` VALUES ('1162', 'First Blood: Golden Bazaar', '717', '0');
INSERT INTO `gamedata_achievements` VALUES ('1163', 'To Be or Not to Be the Guardian of Aleport', '718', '0');
INSERT INTO `gamedata_achievements` VALUES ('1164', 'To Be or Not to Be the Guardian of Hyrstmill', '719', '0');
INSERT INTO `gamedata_achievements` VALUES ('1165', 'To Be or Not to Be the Guardian of the Golden Bazaar', '720', '0');
INSERT INTO `gamedata_achievements` VALUES ('1166', 'To Be or Not to Be the Wind of Aleport', '721', '0');
INSERT INTO `gamedata_achievements` VALUES ('1167', 'To Be or Not to Be the Wind of Hyrstmill', '722', '0');
INSERT INTO `gamedata_achievements` VALUES ('1168', 'To Be or Not to Be the Wind of the Golden Bazaar', '723', '0');
INSERT INTO `gamedata_achievements` VALUES ('1169', 'To Be or Not to Be the Hand of Aleport', '724', '0');
INSERT INTO `gamedata_achievements` VALUES ('1171', 'To Be or Not to Be the Hand of Hyrstmill', '725', '0');
INSERT INTO `gamedata_achievements` VALUES ('1172', 'To Be or Not to Be the Hand of the Golden Bazaar', '726', '0');
INSERT INTO `gamedata_achievements` VALUES ('1173', 'A Slave to Faction III', '727', '0');
INSERT INTO `gamedata_achievements` VALUES ('1174', 'Serving a Greater Cause VI', '728', '0');
INSERT INTO `gamedata_achievements` VALUES ('1175', 'And All I Got Was This Lousy Achievement: La Noscea', '729', '0');
INSERT INTO `gamedata_achievements` VALUES ('1176', 'And All I Got Was This Lousy Achievement: Black Shroud', '730', '0');
INSERT INTO `gamedata_achievements` VALUES ('1177', 'And All I Got Was This Lousy Achievement: Thanalan', '731', '0');
INSERT INTO `gamedata_achievements` VALUES ('1178', 'Globetrotter', '732', '0');
INSERT INTO `gamedata_achievements` VALUES ('1179', 'La Noscea Got Served...and Protected', '733', '0');
INSERT INTO `gamedata_achievements` VALUES ('1180', 'The Black Shroud Got Served...and Protected', '734', '0');
INSERT INTO `gamedata_achievements` VALUES ('1181', 'Thanalan Got Served...and Protected', '735', '0');
INSERT INTO `gamedata_achievements` VALUES ('1182', 'Eorzea Got Served...and Protected', '736', '0');
INSERT INTO `gamedata_achievements` VALUES ('1183', 'Love Thy Brother', '737', '0');
INSERT INTO `gamedata_achievements` VALUES ('1184', 'Another Brick in the Shield Wall', '738', '0');
INSERT INTO `gamedata_achievements` VALUES ('1185', 'A Helping Horn', '739', '0');
INSERT INTO `gamedata_achievements` VALUES ('1186', 'Commitment Issues', '740', '0');
INSERT INTO `gamedata_achievements` VALUES ('1187', 'Career Opportunities', '741', '0');
INSERT INTO `gamedata_achievements` VALUES ('1188', 'Sideways', '742', '0');
INSERT INTO `gamedata_achievements` VALUES ('1189', 'All the More Region to Leve VI', '743', '0');
INSERT INTO `gamedata_achievements` VALUES ('1190', '\"Think Global, Quest Local VI\"', '744', '0');
INSERT INTO `gamedata_achievements` VALUES ('1191', 'Tales of War', '745', '0');
INSERT INTO `gamedata_achievements` VALUES ('1192', 'Tales of Magic', '746', '0');
INSERT INTO `gamedata_achievements` VALUES ('1193', 'Tales of the Hand', '747', '0');
INSERT INTO `gamedata_achievements` VALUES ('1194', 'Tales of the Land', '748', '0');
INSERT INTO `gamedata_achievements` VALUES ('1195', 'The Greatest Tales Ever Told', '749', '0');
INSERT INTO `gamedata_achievements` VALUES ('1196', 'Region d\'Etre', '750', '0');
INSERT INTO `gamedata_achievements` VALUES ('1197', 'Lost in Localization', '751', '0');
INSERT INTO `gamedata_achievements` VALUES ('1198', '\"Just the Factions, Ma\'am\"', '752', '0');
INSERT INTO `gamedata_achievements` VALUES ('1199', 'Enraptured Servitude', '753', '0');
INSERT INTO `gamedata_achievements` VALUES ('1200', 'Seasonal Events', '700', '0');
INSERT INTO `gamedata_achievements` VALUES ('1201', 'It\'s Reining Deer', '701', '20');
INSERT INTO `gamedata_achievements` VALUES ('1202', 'Beast from the East', '702', '5');
INSERT INTO `gamedata_achievements` VALUES ('1203', 'Red Beast from the East', '703', '5');
INSERT INTO `gamedata_achievements` VALUES ('1204', 'Gold Beast from the East', '704', '5');
INSERT INTO `gamedata_achievements` VALUES ('1205', 'Black Beast from the East', '705', '5');
INSERT INTO `gamedata_achievements` VALUES ('1206', 'Get All the Things!', '706', '20');
INSERT INTO `gamedata_achievements` VALUES ('1207', 'Love Me Tender', '707', '5');
INSERT INTO `gamedata_achievements` VALUES ('1208', 'B.F.F.', '708', '5');
INSERT INTO `gamedata_achievements` VALUES ('1209', 'Did It All for the Glory of Love', '709', '5');
INSERT INTO `gamedata_achievements` VALUES ('1210', 'Love Makes the World Go Round', '710', '20');
INSERT INTO `gamedata_achievements` VALUES ('1211', 'Royal Audience', '711', '20');
INSERT INTO `gamedata_achievements` VALUES ('1212', 'Eggsceptional Hunting', '712', '5');
INSERT INTO `gamedata_achievements` VALUES ('1213', 'Eggstraordinary Hunting', '713', '5');
INSERT INTO `gamedata_achievements` VALUES ('1214', 'Eggsemplary Hunting', '714', '5');
INSERT INTO `gamedata_achievements` VALUES ('1215', 'Eggstreme Hunting', '715', '5');
INSERT INTO `gamedata_achievements` VALUES ('1216', 'Eggstravagant Hunting', '716', '5');
INSERT INTO `gamedata_achievements` VALUES ('1217', 'Seven Short of a Dozen', '717', '20');
INSERT INTO `gamedata_achievements` VALUES ('1218', 'Cascadier Survivor', '718', '5');
INSERT INTO `gamedata_achievements` VALUES ('1219', 'Stylish Cascadier', '719', '5');
INSERT INTO `gamedata_achievements` VALUES ('1220', 'Dapper Cascadier', '720', '5');
INSERT INTO `gamedata_achievements` VALUES ('1221', 'Dapper Cascadier', '721', '5');
INSERT INTO `gamedata_achievements` VALUES ('1222', 'Classy Cascadier', '722', '5');
INSERT INTO `gamedata_achievements` VALUES ('1223', 'Refined Cascadier', '723', '5');
INSERT INTO `gamedata_achievements` VALUES ('1224', 'Clogging Along', '724', '5');
INSERT INTO `gamedata_achievements` VALUES ('1225', 'Cascadier for Life', '725', '20');
INSERT INTO `gamedata_achievements` VALUES ('1226', 'Chock-full of Elemental Goodness', '726', '20');
INSERT INTO `gamedata_achievements` VALUES ('1281', 'It\'s Reining Deer', '727', '0');
INSERT INTO `gamedata_achievements` VALUES ('1282', 'Get All the Things!', '728', '0');
INSERT INTO `gamedata_achievements` VALUES ('1283', 'Love Makes the World Go Round', '729', '0');
INSERT INTO `gamedata_achievements` VALUES ('1284', 'Royal Audience', '730', '0');
INSERT INTO `gamedata_achievements` VALUES ('1285', 'Seven Short of a Dozen', '731', '0');
INSERT INTO `gamedata_achievements` VALUES ('1286', 'Cascadier for Life', '732', '20');
INSERT INTO `gamedata_achievements` VALUES ('1287', 'Chock-full of Elemental Goodness', '733', '20');
INSERT INTO `gamedata_achievements` VALUES ('1300', 'Dungeons', '750', '0');
INSERT INTO `gamedata_achievements` VALUES ('1301', 'One-upping the Antares', '751', '5');
INSERT INTO `gamedata_achievements` VALUES ('1302', 'Kicking Sargas and Taking Names', '752', '5');
INSERT INTO `gamedata_achievements` VALUES ('1303', 'Shaula We Dance?', '753', '5');
INSERT INTO `gamedata_achievements` VALUES ('1304', 'Like a Batraal Out of Hell', '754', '5');
INSERT INTO `gamedata_achievements` VALUES ('1305', 'Miser Neutralizer', '755', '5');
INSERT INTO `gamedata_achievements` VALUES ('1306', 'Raiding the Vale', '756', '5');
INSERT INTO `gamedata_achievements` VALUES ('1307', 'Breathless', '757', '5');
INSERT INTO `gamedata_achievements` VALUES ('1308', 'Three Heads Are Better Than One', '758', '5');
INSERT INTO `gamedata_achievements` VALUES ('1309', 'Making the Cut', '759', '5');
INSERT INTO `gamedata_achievements` VALUES ('1310', 'Big Ants Don\'t Cry', '760', '5');
INSERT INTO `gamedata_achievements` VALUES ('1400', 'Exploration', '800', '0');
INSERT INTO `gamedata_achievements` VALUES ('1401', 'Taking in the Sights: La Noscea', '801', '5');
INSERT INTO `gamedata_achievements` VALUES ('1402', 'Taking in the Sights: Black Shroud', '802', '5');
INSERT INTO `gamedata_achievements` VALUES ('1403', 'Taking in the Sights: Thanalan', '803', '5');
INSERT INTO `gamedata_achievements` VALUES ('1404', 'Taking in the Sights: Coerthas', '804', '5');
INSERT INTO `gamedata_achievements` VALUES ('1405', 'Taking in the Sights: Mor Dhona', '805', '5');
INSERT INTO `gamedata_achievements` VALUES ('1406', '\"Been There, Done That\"', '806', '10');
INSERT INTO `gamedata_achievements` VALUES ('1499', '\"Been There, Done That\"', '807', '0');
INSERT INTO `gamedata_achievements` VALUES ('1500', 'Grand Company', '820', '5');
INSERT INTO `gamedata_achievements` VALUES ('1501', 'All Watched Over by a Maelstrom of Loving Grace', '821', '5');
INSERT INTO `gamedata_achievements` VALUES ('1502', 'Snakebitten', '822', '5');
INSERT INTO `gamedata_achievements` VALUES ('1503', '\"Come On Baby, Light My Fire\"', '823', '5');
INSERT INTO `gamedata_achievements` VALUES ('1504', 'A Storm of Seals I', '824', '5');
INSERT INTO `gamedata_achievements` VALUES ('1505', 'A Storm of Seals II', '825', '5');
INSERT INTO `gamedata_achievements` VALUES ('1506', 'A Storm of Seals III', '826', '10');
INSERT INTO `gamedata_achievements` VALUES ('1507', 'The Ruby Anchor', '827', '20');
INSERT INTO `gamedata_achievements` VALUES ('1508', 'A Snake in the Brass I', '828', '5');
INSERT INTO `gamedata_achievements` VALUES ('1509', 'A Snake in the Brass II', '829', '5');
INSERT INTO `gamedata_achievements` VALUES ('1510', 'A Snake in the Brass III', '830', '10');
INSERT INTO `gamedata_achievements` VALUES ('1511', 'The Mahogany Leaf', '831', '20');
INSERT INTO `gamedata_achievements` VALUES ('1512', 'Burning a Hole in My Pocket I', '832', '5');
INSERT INTO `gamedata_achievements` VALUES ('1513', 'Burning a Hole in My Pocket II', '833', '5');
INSERT INTO `gamedata_achievements` VALUES ('1514', 'Burning a Hole in My Pocket III', '834', '10');
INSERT INTO `gamedata_achievements` VALUES ('1515', 'The Mythril Scales', '835', '20');
INSERT INTO `gamedata_achievements` VALUES ('1516', 'In Good Company: Maelstrom I', '836', '5');
INSERT INTO `gamedata_achievements` VALUES ('1517', 'In Good Company: Maelstrom II', '837', '5');
INSERT INTO `gamedata_achievements` VALUES ('1518', 'In Good Company: Maelstrom III', '838', '10');
INSERT INTO `gamedata_achievements` VALUES ('1519', 'The Turquoise Cannon', '839', '20');
INSERT INTO `gamedata_achievements` VALUES ('1520', 'In Good Company: Twin Adder I', '840', '5');
INSERT INTO `gamedata_achievements` VALUES ('1521', 'In Good Company: Twin Adder II', '841', '5');
INSERT INTO `gamedata_achievements` VALUES ('1522', 'In Good Company: Twin Adder III', '842', '10');
INSERT INTO `gamedata_achievements` VALUES ('1523', 'The Ironwood Leaf', '843', '20');
INSERT INTO `gamedata_achievements` VALUES ('1524', 'In Good Company: Immortal Flames I', '844', '5');
INSERT INTO `gamedata_achievements` VALUES ('1525', 'In Good Company: Immortal Flames II', '845', '5');
INSERT INTO `gamedata_achievements` VALUES ('1526', 'In Good Company: Immortal Flames III', '846', '10');
INSERT INTO `gamedata_achievements` VALUES ('1527', 'The Silver Scales', '847', '20');
INSERT INTO `gamedata_achievements` VALUES ('1528', 'Fueling the Storm I', '848', '5');
INSERT INTO `gamedata_achievements` VALUES ('1529', 'Fueling the Storm II', '849', '5');
INSERT INTO `gamedata_achievements` VALUES ('1530', 'Fueling the Storm III', '850', '10');
INSERT INTO `gamedata_achievements` VALUES ('1531', 'The Onyx Oars', '851', '20');
INSERT INTO `gamedata_achievements` VALUES ('1532', 'Feeding the Serpent I', '852', '5');
INSERT INTO `gamedata_achievements` VALUES ('1533', 'Feeding the Serpent II', '853', '5');
INSERT INTO `gamedata_achievements` VALUES ('1534', 'Feeding the Serpent III', '854', '10');
INSERT INTO `gamedata_achievements` VALUES ('1535', 'The Sycamore Leaf', '855', '20');
INSERT INTO `gamedata_achievements` VALUES ('1536', 'Fanning the Flames I', '856', '5');
INSERT INTO `gamedata_achievements` VALUES ('1537', 'Fanning the Flames II', '857', '5');
INSERT INTO `gamedata_achievements` VALUES ('1538', 'Fanning the Flames III', '858', '10');
INSERT INTO `gamedata_achievements` VALUES ('1539', 'The Brass Scales', '859', '20');
INSERT INTO `gamedata_achievements` VALUES ('1540', 'To Each According to His Need: Maelstrom I', '860', '5');
INSERT INTO `gamedata_achievements` VALUES ('1541', 'To Each According to His Need: Maelstrom II', '861', '5');
INSERT INTO `gamedata_achievements` VALUES ('1542', 'To Each According to His Need: Maelstrom III', '862', '10');
INSERT INTO `gamedata_achievements` VALUES ('1543', 'The Jade Mast', '863', '20');
INSERT INTO `gamedata_achievements` VALUES ('1544', 'To Each According to His Need: Twin Adder I', '864', '5');
INSERT INTO `gamedata_achievements` VALUES ('1545', 'To Each According to His Need: Twin Adder II', '865', '5');
INSERT INTO `gamedata_achievements` VALUES ('1546', 'To Each According to His Need: Twin Adder III', '866', '10');
INSERT INTO `gamedata_achievements` VALUES ('1547', 'The Willow Leaf', '867', '20');
INSERT INTO `gamedata_achievements` VALUES ('1548', 'To Each According to His Need: Immortal Flames I', '868', '5');
INSERT INTO `gamedata_achievements` VALUES ('1549', 'To Each According to His Need: Immortal Flames II', '869', '5');
INSERT INTO `gamedata_achievements` VALUES ('1550', 'To Each According to His Need: Immortal Flames III', '870', '10');
INSERT INTO `gamedata_achievements` VALUES ('1551', 'The Bronze Scales', '871', '20');
INSERT INTO `gamedata_achievements` VALUES ('1552', 'Twelve Minutes or Less or Your Cargo\'s Free', '872', '5');
INSERT INTO `gamedata_achievements` VALUES ('1553', 'Ten Minutes or Less or Your Cargo\'s Free', '873', '5');
INSERT INTO `gamedata_achievements` VALUES ('1554', 'Eight Minutes or Less or Your Cargo\'s Free', '874', '10');
INSERT INTO `gamedata_achievements` VALUES ('1555', 'Gone in Twelve Minutes', '875', '5');
INSERT INTO `gamedata_achievements` VALUES ('1556', 'Gone in Ten Minutes', '876', '5');
INSERT INTO `gamedata_achievements` VALUES ('1557', 'Gone in Eight Minutes', '877', '10');
INSERT INTO `gamedata_achievements` VALUES ('1558', 'Handle with Care I', '878', '5');
INSERT INTO `gamedata_achievements` VALUES ('1559', 'Handle with Care II', '879', '5');
INSERT INTO `gamedata_achievements` VALUES ('1560', 'Handle with Care III', '880', '5');
INSERT INTO `gamedata_achievements` VALUES ('1561', 'Handle with Care IV', '881', '10');
INSERT INTO `gamedata_achievements` VALUES ('1562', 'Chocobo Shrugged', '882', '20');
INSERT INTO `gamedata_achievements` VALUES ('1563', 'I Make This Look Good', '883', '5');
INSERT INTO `gamedata_achievements` VALUES ('1564', 'My Little Chocobo', '884', '5');
INSERT INTO `gamedata_achievements` VALUES ('1565', 'Pimp Your Ride', '885', '5');
INSERT INTO `gamedata_achievements` VALUES ('1671', 'A Storm of Seals III', '886', '0');
INSERT INTO `gamedata_achievements` VALUES ('1672', 'The Ruby Anchor', '887', '0');
INSERT INTO `gamedata_achievements` VALUES ('1673', 'A Snake in the Brass III', '888', '0');
INSERT INTO `gamedata_achievements` VALUES ('1674', 'The Mahogany Leaf', '889', '0');
INSERT INTO `gamedata_achievements` VALUES ('1675', 'Burning a Hole in My Pocket III', '890', '0');
INSERT INTO `gamedata_achievements` VALUES ('1676', 'The Mythril Scales', '891', '0');
INSERT INTO `gamedata_achievements` VALUES ('1677', 'In Good Company: Maelstrom III', '892', '0');
INSERT INTO `gamedata_achievements` VALUES ('1678', 'The Turquoise Cannon', '893', '0');
INSERT INTO `gamedata_achievements` VALUES ('1679', 'In Good Company: Twin Adder III', '894', '0');
INSERT INTO `gamedata_achievements` VALUES ('1680', 'The Ironwood Leaf', '895', '0');
INSERT INTO `gamedata_achievements` VALUES ('1681', 'In Good Company: Immortal Flames III', '896', '0');
INSERT INTO `gamedata_achievements` VALUES ('1682', 'The Silver Scales', '897', '0');
INSERT INTO `gamedata_achievements` VALUES ('1683', 'Fueling the Storm III', '898', '0');
INSERT INTO `gamedata_achievements` VALUES ('1684', 'The Onyx Oars', '899', '0');
INSERT INTO `gamedata_achievements` VALUES ('1685', 'Feeding the Serpent III', '900', '0');
INSERT INTO `gamedata_achievements` VALUES ('1686', 'The Sycamore Leaf', '901', '0');
INSERT INTO `gamedata_achievements` VALUES ('1687', 'Fanning the Flames III', '902', '0');
INSERT INTO `gamedata_achievements` VALUES ('1688', 'The Brass Scales', '903', '0');
INSERT INTO `gamedata_achievements` VALUES ('1689', 'To Each According to His Need: Maelstrom III', '904', '0');
INSERT INTO `gamedata_achievements` VALUES ('1690', 'The Jade Mast', '905', '0');
INSERT INTO `gamedata_achievements` VALUES ('1691', 'To Each According to His Need: Twin Adder III', '906', '0');
INSERT INTO `gamedata_achievements` VALUES ('1692', 'The Willow Leaf', '907', '0');
INSERT INTO `gamedata_achievements` VALUES ('1693', 'To Each According to His Need: Immortal Flames III', '908', '0');
INSERT INTO `gamedata_achievements` VALUES ('1694', 'The Bronze Scales', '909', '0');
INSERT INTO `gamedata_achievements` VALUES ('1695', 'Eight Minutes or Less or Your Cargo\'s Free', '910', '0');
INSERT INTO `gamedata_achievements` VALUES ('1696', 'Gone in Eight Minutes', '911', '0');
INSERT INTO `gamedata_achievements` VALUES ('1697', 'Handle with Care IV', '912', '0');
INSERT INTO `gamedata_achievements` VALUES ('1698', 'Handle with Care III', '913', '0');
INSERT INTO `gamedata_achievements` VALUES ('1699', 'Pimp Your Ride', '914', '0');
INSERT INTO `gamedata_achievements` VALUES ('2001', 'Patricide', '915', '5');
INSERT INTO `gamedata_achievements` VALUES ('2006', 'To Kill a Mocking Bird', '916', '5');
INSERT INTO `gamedata_achievements` VALUES ('2011', 'Pounding the Spike', '917', '5');
INSERT INTO `gamedata_achievements` VALUES ('2016', 'An Eye on the Ale I', '918', '5');
INSERT INTO `gamedata_achievements` VALUES ('2017', 'An Eye on the Ale II', '919', '5');
INSERT INTO `gamedata_achievements` VALUES ('2018', 'An Eye on the Ale III', '920', '5');
INSERT INTO `gamedata_achievements` VALUES ('2019', 'An Eye on the Ale IV', '921', '5');
INSERT INTO `gamedata_achievements` VALUES ('2020', 'First Blood: Aleport', '922', '10');
INSERT INTO `gamedata_achievements` VALUES ('2021', 'An Eye on the Trees I', '923', '5');
INSERT INTO `gamedata_achievements` VALUES ('2022', 'An Eye on the Trees II', '924', '5');
INSERT INTO `gamedata_achievements` VALUES ('2023', 'An Eye on the Trees III', '925', '5');
INSERT INTO `gamedata_achievements` VALUES ('2024', 'An Eye on the Trees IV', '926', '5');
INSERT INTO `gamedata_achievements` VALUES ('2025', 'First Blood: Hyrstmill', '927', '10');
INSERT INTO `gamedata_achievements` VALUES ('2026', 'An Eye on the Gold I', '928', '5');
INSERT INTO `gamedata_achievements` VALUES ('2027', 'An Eye on the Gold II', '929', '5');
INSERT INTO `gamedata_achievements` VALUES ('2028', 'An Eye on the Gold III', '930', '5');
INSERT INTO `gamedata_achievements` VALUES ('2029', 'An Eye on the Gold IV', '931', '5');
INSERT INTO `gamedata_achievements` VALUES ('2030', 'First Blood: Golden Bazaar', '932', '10');
INSERT INTO `gamedata_achievements` VALUES ('2031', 'Holding the Hamlet: Aleport I', '933', '5');
INSERT INTO `gamedata_achievements` VALUES ('2032', 'Holding the Hamlet: Aleport II', '934', '5');
INSERT INTO `gamedata_achievements` VALUES ('2033', 'Holding the Hamlet: Aleport III', '935', '5');
INSERT INTO `gamedata_achievements` VALUES ('2034', 'Holding the Hamlet: Aleport IV', '936', '5');
INSERT INTO `gamedata_achievements` VALUES ('2035', 'To Be or Not to Be the Guardian of Aleport', '937', '10');
INSERT INTO `gamedata_achievements` VALUES ('2036', 'Holding the Hamlet: Hyrstmill I', '938', '5');
INSERT INTO `gamedata_achievements` VALUES ('2037', 'Holding the Hamlet: Hyrstmill II', '939', '5');
INSERT INTO `gamedata_achievements` VALUES ('2038', 'Holding the Hamlet: Hyrstmill III', '940', '5');
INSERT INTO `gamedata_achievements` VALUES ('2039', 'Holding the Hamlet: Hyrstmill IV', '941', '5');
INSERT INTO `gamedata_achievements` VALUES ('2040', 'To Be or Not to Be the Guardian of Hyrstmill', '942', '10');
INSERT INTO `gamedata_achievements` VALUES ('2041', 'Holding the Hamlet: Golden Bazaar I', '943', '5');
INSERT INTO `gamedata_achievements` VALUES ('2042', 'Holding the Hamlet: Golden Bazaar II', '944', '5');
INSERT INTO `gamedata_achievements` VALUES ('2043', 'Holding the Hamlet: Golden Bazaar III', '945', '5');
INSERT INTO `gamedata_achievements` VALUES ('2044', 'Holding the Hamlet: Golden Bazaar IV', '946', '5');
INSERT INTO `gamedata_achievements` VALUES ('2045', 'To Be or Not to Be the Guardian of the Golden Bazaar', '947', '10');
INSERT INTO `gamedata_achievements` VALUES ('2046', 'Helping the Hamlet: Aleport I', '948', '5');
INSERT INTO `gamedata_achievements` VALUES ('2047', 'Helping the Hamlet: Aleport II', '949', '5');
INSERT INTO `gamedata_achievements` VALUES ('2048', 'Helping the Hamlet: Aleport III', '950', '5');
INSERT INTO `gamedata_achievements` VALUES ('2049', 'Helping the Hamlet: Aleport IV', '951', '5');
INSERT INTO `gamedata_achievements` VALUES ('2050', 'To Be or Not to Be the Wind of Aleport', '952', '10');
INSERT INTO `gamedata_achievements` VALUES ('2051', 'Helping the Hamlet: Hyrstmill I', '953', '5');
INSERT INTO `gamedata_achievements` VALUES ('2052', 'Helping the Hamlet: Hyrstmill II', '954', '5');
INSERT INTO `gamedata_achievements` VALUES ('2053', 'Helping the Hamlet: Hyrstmill III', '955', '5');
INSERT INTO `gamedata_achievements` VALUES ('2054', 'Helping the Hamlet: Hyrstmill IV', '956', '5');
INSERT INTO `gamedata_achievements` VALUES ('2055', 'To Be or Not to Be the Wind of Hyrstmill', '957', '10');
INSERT INTO `gamedata_achievements` VALUES ('2056', 'Helping the Hamlet: Golden Bazaar I', '958', '5');
INSERT INTO `gamedata_achievements` VALUES ('2057', 'Helping the Hamlet: Golden Bazaar II', '959', '5');
INSERT INTO `gamedata_achievements` VALUES ('2058', 'Helping the Hamlet: Golden Bazaar III', '960', '5');
INSERT INTO `gamedata_achievements` VALUES ('2059', 'Helping the Hamlet: Golden Bazaar IV', '961', '5');
INSERT INTO `gamedata_achievements` VALUES ('2060', 'To Be or Not to Be the Wind of the Golden Bazaar', '962', '10');
INSERT INTO `gamedata_achievements` VALUES ('2061', 'Habiting the Hamlet: Aleport I', '963', '5');
INSERT INTO `gamedata_achievements` VALUES ('2062', 'Habiting the Hamlet: Aleport II', '964', '5');
INSERT INTO `gamedata_achievements` VALUES ('2063', 'Habiting the Hamlet: Aleport III', '965', '5');
INSERT INTO `gamedata_achievements` VALUES ('2064', 'Habiting the Hamlet: Aleport IV', '966', '5');
INSERT INTO `gamedata_achievements` VALUES ('2065', 'To Be or Not to Be the Hand of Aleport', '967', '10');
INSERT INTO `gamedata_achievements` VALUES ('2066', 'Habiting the Hamlet: Hyrstmill I', '968', '5');
INSERT INTO `gamedata_achievements` VALUES ('2067', 'Habiting the Hamlet: Hyrstmill II', '969', '5');
INSERT INTO `gamedata_achievements` VALUES ('2068', 'Habiting the Hamlet: Hyrstmill III', '970', '5');
INSERT INTO `gamedata_achievements` VALUES ('2069', 'Habiting the Hamlet: Hyrstmill IV', '971', '5');
INSERT INTO `gamedata_achievements` VALUES ('2070', 'To Be or Not to Be the Hand of Hyrstmill', '972', '10');
INSERT INTO `gamedata_achievements` VALUES ('2071', 'Habiting the Hamlet: Golden Bazaar I', '973', '5');
INSERT INTO `gamedata_achievements` VALUES ('2072', 'Habiting the Hamlet: Golden Bazaar II', '974', '5');
INSERT INTO `gamedata_achievements` VALUES ('2073', 'Habiting the Hamlet: Golden Bazaar III', '975', '5');
INSERT INTO `gamedata_achievements` VALUES ('2074', 'Habiting the Hamlet: Golden Bazaar IV', '976', '5');
INSERT INTO `gamedata_achievements` VALUES ('2075', 'To Be or Not to Be the Hand of the Golden Bazaar', '977', '10');
INSERT INTO `gamedata_achievements` VALUES ('2076', 'Leave Your Hammer at Home: Aleport', '978', '5');
INSERT INTO `gamedata_achievements` VALUES ('2077', 'Leave Your Hammer at Home: Hyrstmill', '979', '5');
INSERT INTO `gamedata_achievements` VALUES ('2078', 'Leave Your Hammer at Home: Golden Bazaar', '980', '5');
INSERT INTO `gamedata_achievements` VALUES ('2079', '\"Make Stuff, Not War: Aleport\"', '981', '5');
INSERT INTO `gamedata_achievements` VALUES ('2080', '\"Make Stuff, Not War: Hyrstmill\"', '982', '5');
INSERT INTO `gamedata_achievements` VALUES ('2081', '\"Make Stuff, Not War: Golden Bazaar\"', '983', '5');
INSERT INTO `gamedata_achievements` VALUES ('2082', 'Looking Out for the Little People', '984', '5');
INSERT INTO `gamedata_actor_appearance` VALUES ('0', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000001', '8', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '0', '331351046', '0', '0', '0', '0', '0', '0', '0', '4387', '5347', '1024', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000002', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '243270686', '0', '0', '0', '0', '0', '0', '11364', '5188', '11360', '15424', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000003', '7', '3', '1', '0', '0', '5', '31', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '12', '0', '0', '0', '0', '0', '0', '0', '0', '22624', '1057', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000004', '6', '2', '1', '0', '0', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '74', '61', '62', '0', '147850241', '0', '0', '0', '0', '0', '0', '23842', '1377', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000005', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '0', '0', '0', '0', '0', '0', '24583', '1121', '10304', '25697', '25664', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000006', '1', '1', '1', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '5344', '16579', '1024', '4321', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000007', '1', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23655', '10369', '16387', '25696', '25632', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000008', '3', '1', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '13', '7', '0', '147852300', '0', '0', '0', '0', '0', '0', '11289', '14529', '15360', '14529', '15459', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000009', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000010', '5', '3', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '9', '0', '310379590', '0', '0', '0', '0', '0', '0', '20507', '7589', '16641', '3265', '9504', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000011', '21', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '9', '10', '0', '347079691', '0', '0', '0', '0', '0', '0', '0', '1888', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000012', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '15', '7', '0', '0', '0', '0', '0', '0', '0', '0', '1760', '1760', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000013', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '3', '0', '168821810', '0', '0', '0', '0', '0', '0', '19499', '14688', '3297', '14720', '10496', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000014', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '2784', '2784', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000015', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000016', '8', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '8', '8', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '3138', '14624', '10339', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000017', '1', '3', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '1', '16', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '3143', '14624', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000018', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '10', '0', '168821790', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '10304', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000019', '7', '3', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '15', '15', '0', '168821780', '0', '0', '0', '0', '0', '0', '19496', '14624', '3074', '14624', '10339', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000020', '1', '3', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '65', '63', '0', '210767912', '236979200', '0', '0', '0', '231736353', '0', '9761', '9856', '9856', '9505', '9603', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000021', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '11', '7', '0', '210766858', '236979210', '0', '0', '0', '231736332', '0', '9507', '9443', '9472', '9444', '9412', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000022', '7', '2', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '59', '57', '60', '0', '210764810', '236979210', '0', '0', '0', '231736331', '0', '9315', '9347', '9344', '9251', '9379', '195584', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000023', '3', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '14', '4', '0', '210764840', '236979210', '0', '0', '0', '231736350', '0', '9408', '9376', '9760', '9284', '9316', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000024', '3', '3', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '4', '1', '0', '210765825', '236979210', '0', '0', '0', '231736331', '0', '9345', '9345', '9472', '9281', '9312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000025', '2', '2', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '15', '6', '0', '147850270', '0', '0', '0', '0', '0', '0', '0', '8481', '8832', '8385', '8513', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000026', '5', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '66', '63', '66', '0', '168825858', '0', '0', '0', '0', '0', '0', '13571', '12707', '2048', '14658', '13601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000027', '7', '1', '4', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '3', '0', '79698947', '32508948', '0', '0', '0', '0', '0', '14496', '15585', '15456', '8544', '15555', '219136', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000028', '2', '2', '8', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '12', '0', '168821810', '0', '0', '0', '0', '0', '0', '19499', '12800', '8384', '14656', '13665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000029', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '1', '6', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000030', '8', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '13', '2', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '3072', '14624', '10371', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000031', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '8', '12', '0', '168821761', '0', '0', '0', '0', '0', '0', '19496', '14624', '3072', '14624', '10338', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000032', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '11', '15', '0', '168821770', '0', '0', '0', '0', '0', '0', '19496', '14624', '3236', '14624', '10432', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000033', '21', '1', '2', '0', '0', '1', '0', '0', '4', '0', '0', '3', '2', '0', '0', '4', '14', '3', '0', '347081758', '0', '0', '0', '0', '0', '0', '0', '1921', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000034', '2', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '6', '12', '0', '210766898', '236979200', '0', '0', '0', '231736351', '0', '9603', '9698', '9696', '9443', '9476', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000035', '2', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '3', '0', '347079683', '0', '0', '0', '0', '0', '0', '0', '4226', '2147', '1024', '4195', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000036', '6', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '51', '54', '0', '347079684', '0', '0', '0', '0', '0', '0', '7266', '4290', '2114', '1024', '4321', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000037', '3', '1', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '2304', '5344', '1024', '10496', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000038', '8', '1', '3', '0', '0', '7', '0', '0', '0', '1', '1', '0', '0', '0', '0', '55', '55', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10368', '1664', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000039', '7', '3', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '64', '53', '57', '0', '79695902', '0', '0', '0', '0', '0', '0', '11301', '11460', '4225', '11459', '15457', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000040', '5', '4', '3', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '58', '61', '64', '0', '862980116', '0', '0', '0', '0', '0', '0', '0', '6401', '2177', '1024', '6401', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000041', '5', '4', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '61', '65', '0', '862981121', '0', '0', '0', '0', '0', '0', '0', '6403', '6304', '1024', '6402', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000042', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6848', '6848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000043', '3', '1', '8', '20', '0', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '29', '1', '6', '0', '294650930', '0', '0', '0', '0', '0', '0', '0', '7297', '5190', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000044', '3', '2', '4', '0', '0', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '29', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5380', '10403', '1024', '10531', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000045', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1057', '5153', '1024', '4129', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000046', '6', '2', '3', '0', '0', '4', '0', '0', '2', '1', '4', '5', '1', '3', '1', '74', '61', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29955', '16608', '2240', '5472', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000047', '6', '2', '1', '0', '0', '7', '0', '0', '3', '0', '1', '4', '3', '2', '2', '70', '57', '56', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000048', '7', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '15', '0', '944809984', '0', '0', '0', '0', '0', '0', '6336', '1089', '6213', '5252', '6214', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000049', '4', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '16', '0', '944770048', '0', '0', '0', '0', '0', '0', '11296', '10337', '16483', '25668', '5218', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000050', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '1', '0', '894436362', '0', '0', '0', '0', '0', '0', '6336', '4098', '6146', '1024', '6145', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000051', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '2', '0', '147850240', '0', '0', '0', '0', '0', '0', '23842', '1057', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000052', '3', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '3', '0', '147850241', '0', '0', '0', '0', '0', '0', '13506', '15362', '9408', '25732', '8353', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000053', '8', '2', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '4', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000054', '7', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '5', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000055', '7', '2', '4', '0', '0', '4', '0', '0', '3', '1', '0', '4', '1', '1', '1', '2', '16', '5', '0', '243270657', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000056', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '6', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '7232', '5198', '6209', '6209', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000057', '8', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '5', '7', '0', '944780288', '953159680', '0', '0', '0', '0', '0', '6149', '1057', '2114', '1024', '6210', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000058', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '4', '5', '0', '2', '0', '21', '12', '10', '0', '947914752', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000059', '4', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '9248', '2148', '5155', '1024', '5316', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000060', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '8', '0', '944775168', '0', '0', '0', '0', '0', '0', '21505', '1088', '2083', '2081', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000061', '8', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '9', '0', '944779264', '0', '0', '0', '0', '0', '0', '21507', '1060', '2116', '2112', '2080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000062', '3', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '10', '0', '948962304', '0', '0', '0', '0', '0', '0', '23590', '1058', '2121', '2115', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000063', '9', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '60', '66', '0', '944778240', '815793163', '955253760', '0', '0', '0', '0', '5152', '7200', '1024', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000064', '7', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '8', '11', '0', '944776192', '0', '0', '0', '0', '0', '0', '5152', '7200', '2080', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000065', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '12', '0', '826278912', '0', '0', '0', '0', '0', '0', '5152', '7200', '1152', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000066', '4', '2', '7', '0', '0', '8', '0', '0', '4', '0', '5', '2', '2', '2', '1', '10', '4', '7', '0', '768607243', '0', '0', '0', '0', '0', '0', '20483', '33924', '7238', '1024', '9314', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000067', '6', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '8', '7', '0', '785384448', '0', '0', '0', '0', '0', '0', '0', '4194', '7238', '1024', '9316', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000068', '1', '2', '1', '0', '0', '8', '0', '0', '1', '1', '4', '3', '1', '2', '1', '32', '5', '8', '0', '780141569', '0', '0', '0', '0', '0', '0', '0', '4194', '4170', '11361', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000069', '2', '2', '6', '0', '0', '1', '0', '0', '1', '0', '0', '0', '2', '1', '0', '32', '3', '8', '0', '168821760', '0', '0', '0', '0', '0', '0', '19502', '14624', '1216', '14402', '21635', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000070', '5', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '1', '2', '1', '3', '53', '61', '65', '0', '58723329', '59771905', '0', '0', '0', '0', '0', '10305', '10401', '10370', '5248', '10337', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000071', '3', '2', '3', '0', '0', '3', '0', '0', '1', '0', '5', '4', '3', '0', '2', '22', '7', '11', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000072', '4', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '5', '2', '1', '2', '21', '2', '5', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '1216', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000073', '1', '2', '4', '0', '0', '8', '0', '0', '4', '0', '5', '2', '0', '2', '3', '29', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000074', '2', '2', '7', '0', '0', '5', '0', '0', '3', '1', '3', '2', '1', '0', '0', '4', '4', '9', '0', '944790528', '0', '0', '0', '0', '0', '0', '6187', '4192', '7264', '1024', '6240', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000075', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1060', '4097', '11264', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000076', '3', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '2209', '2145', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000077', '6', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23656', '9410', '9472', '25730', '9380', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000078', '8', '3', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '14', '0', '79692870', '0', '0', '0', '0', '0', '0', '0', '10434', '10402', '10530', '21826', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000079', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '1', '0', '243270656', '0', '0', '0', '0', '0', '0', '23554', '1025', '10241', '25696', '8192', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000080', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '2', '0', '243270656', '0', '0', '0', '0', '0', '0', '23884', '10272', '10305', '25668', '21636', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000081', '7', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '3', '0', '243270656', '0', '0', '0', '0', '0', '0', '25729', '11329', '4163', '11296', '25632', '11264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000082', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '8', '4', '0', '147851276', '0', '0', '0', '0', '0', '0', '13376', '15392', '9408', '13376', '8352', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000083', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '5', '0', '147852299', '0', '0', '0', '0', '0', '0', '14337', '14432', '15360', '14400', '15424', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000084', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '6', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000085', '7', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '7', '0', '147851274', '0', '0', '0', '0', '0', '0', '14336', '12480', '10274', '10369', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000086', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '8', '0', '147852288', '0', '0', '0', '0', '0', '0', '23555', '8193', '9248', '25697', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000087', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '9', '0', '147851274', '0', '0', '0', '0', '0', '0', '22560', '10306', '10305', '25632', '8224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000088', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '10', '0', '147851275', '0', '0', '0', '0', '0', '0', '23875', '1058', '9376', '25696', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000089', '5', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '11', '0', '147850240', '0', '0', '0', '0', '0', '0', '13344', '15361', '9216', '11296', '8224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000090', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10369', '16384', '5250', '25760', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000091', '7', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '1060', '2050', '5122', '6146', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000092', '3', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '4132', '4132', '6144', '1024', '6146', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000093', '2', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '4128', '5122', '5122', '4099', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000094', '5', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1057', '6146', '6177', '6144', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000095', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '8', '0', '243270657', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000096', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000097', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '10', '0', '0', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000098', '4', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '6', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7426', '2145', '1024', '4194', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000099', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '9', '12', '0', '0', '0', '0', '0', '0', '0', '0', '7169', '7169', '5152', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000100', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '13', '0', '737150977', '0', '0', '0', '0', '0', '0', '5346', '2151', '2115', '1024', '2082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000101', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '5', '0', '79692820', '0', '0', '0', '0', '0', '0', '13410', '11299', '15392', '11328', '21632', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000102', '4', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '6', '0', '0', '0', '0', '0', '0', '0', '0', '7203', '4195', '2120', '1024', '4160', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000103', '3', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '7', '0', '60818462', '61867038', '0', '0', '0', '0', '0', '8225', '8256', '8352', '8224', '8256', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000104', '9', '3', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '53', '62', '0', '0', '0', '0', '0', '0', '0', '0', '25697', '6370', '6370', '5284', '6369', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000105', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '9', '0', '168823848', '0', '0', '0', '0', '0', '0', '13540', '13666', '3233', '13472', '10465', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000106', '3', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '10', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000107', '7', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '11', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000108', '8', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '12', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000109', '2', '3', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '13', '0', '0', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000110', '5', '3', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '14', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000111', '1', '2', '5', '0', '0', '7', '31', '0', '0', '0', '0', '0', '0', '0', '0', '12', '7', '10', '0', '147852288', '0', '0', '0', '0', '0', '0', '22624', '1057', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000112', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '52', '52', '0', '147850240', '0', '0', '0', '0', '0', '0', '23842', '1057', '9408', '5154', '4130', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000113', '4', '1', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '53', '53', '0', '147850241', '0', '0', '0', '0', '0', '0', '22629', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000114', '1', '3', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '54', '54', '0', '147850241', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000115', '2', '0', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '55', '55', '0', '147852288', '0', '0', '0', '0', '0', '0', '25795', '11491', '15872', '11363', '2082', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000116', '2', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '56', '56', '0', '147852288', '0', '0', '0', '0', '0', '0', '22624', '11491', '15872', '1024', '2082', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000117', '4', '3', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '57', '57', '0', '80741386', '0', '0', '0', '0', '0', '0', '22629', '15680', '15872', '11459', '15680', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000118', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '15', '6', '0', '147852298', '0', '0', '0', '0', '0', '0', '15680', '15680', '15872', '11363', '15680', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000119', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '13', '6', '0', '147852289', '0', '0', '0', '0', '0', '0', '15680', '15680', '15872', '11459', '15680', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000120', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '60', '60', '0', '383779840', '0', '0', '0', '0', '0', '0', '5152', '4128', '5153', '6209', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000121', '1', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '61', '61', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '4160', '5187', '6219', '10336', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000122', '8', '0', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '63', '62', '62', '0', '383779840', '0', '0', '0', '0', '0', '0', '20496', '10306', '15872', '1024', '2243', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000123', '3', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '4164', '10272', '1024', '8256', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000124', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '64', '64', '0', '0', '0', '0', '0', '0', '0', '0', '5217', '2144', '5187', '1024', '10336', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000125', '3', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '65', '65', '0', '243270659', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000126', '8', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '66', '66', '0', '243270666', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000127', '7', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '15', '0', '243270666', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000128', '6', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '55', '0', '243270666', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000129', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '4', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000130', '7', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '5', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000131', '8', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '57', '57', '58', '0', '243270659', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000132', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '9', '7', '0', '243270659', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000133', '3', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '8', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000134', '3', '1', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '9', '0', '721421313', '0', '0', '0', '0', '0', '0', '0', '1089', '2083', '2114', '2082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000135', '2', '1', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '10', '0', '721421332', '0', '0', '0', '0', '0', '0', '4160', '4160', '2115', '2116', '2084', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000136', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '11', '0', '147850241', '0', '0', '0', '0', '0', '0', '23655', '10369', '16384', '5250', '25760', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000137', '1', '3', '2', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23877', '9603', '5284', '1024', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000138', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '2146', '5190', '1024', '5186', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000139', '7', '4', '2', '0', '0', '5', '18', '0', '0', '0', '0', '0', '0', '0', '0', '14', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '23616', '7587', '2272', '1024', '25732', '146432', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000140', '1', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '12', '4', '0', '243270676', '0', '0', '0', '0', '0', '0', '16705', '16609', '10402', '1024', '9603', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000141', '1', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '12', '4', '0', '243270658', '0', '0', '0', '0', '0', '0', '16705', '16609', '10371', '1024', '9539', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000142', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '5', '0', '243270657', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000143', '7', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '66', '58', '0', '79693826', '0', '0', '0', '0', '0', '0', '21504', '4161', '2080', '5152', '2241', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000144', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '21537', '1090', '2116', '5185', '2083', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000145', '8', '0', '2', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '70', '60', '59', '0', '737150977', '0', '0', '0', '0', '0', '0', '21508', '1154', '2115', '1024', '2083', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000146', '8', '1', '2', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '70', '60', '59', '0', '737151016', '0', '0', '0', '0', '0', '0', '21508', '1154', '2208', '1024', '2210', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000147', '3', '2', '7', '0', '0', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '9', '4', '9', '0', '147850300', '0', '0', '0', '0', '0', '0', '16738', '10498', '16641', '5411', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000148', '2', '2', '7', '0', '0', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '19', '15', '12', '0', '243270676', '0', '0', '0', '0', '0', '0', '24801', '10465', '1696', '25730', '2210', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000149', '8', '3', '5', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '15', '0', '383779883', '0', '0', '0', '0', '0', '0', '20497', '4418', '5250', '6433', '10497', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000150', '8', '1', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20496', '4160', '5187', '6219', '10336', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000151', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '24579', '16418', '10272', '1024', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000152', '3', '2', '8', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20', '12', '4', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000153', '8', '1', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '9', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5186', '1089', '9312', '1024', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000154', '5', '3', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '52', '58', '66', '0', '894437416', '0', '0', '0', '0', '0', '0', '6241', '10369', '6241', '5376', '6496', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000155', '6', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '65', '52', '55', '0', '894436363', '0', '0', '0', '0', '0', '0', '6336', '1409', '9440', '5250', '6496', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000156', '6', '1', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '65', '52', '55', '0', '894436363', '0', '0', '0', '0', '0', '0', '6144', '1409', '9440', '5120', '6496', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000157', '8', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '6', '0', '0', '0', '0', '0', '0', '0', '0', '20483', '5153', '5187', '1024', '5153', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000158', '4', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '16', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '2146', '5190', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000159', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2146', '5190', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000160', '7', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '2', '9', '0', '383779841', '0', '0', '0', '0', '0', '0', '20496', '4128', '5153', '6209', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000161', '5', '2', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000162', '8', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '11', '0', '721421333', '0', '0', '0', '0', '0', '0', '0', '33954', '9856', '2115', '25633', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000163', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2210', '2146', '2113', '2081', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000164', '3', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '4132', '9760', '1024', '6212', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000165', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '2', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '8192', '6145', '1024', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000166', '4', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '9', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1444', '4290', '10499', '10435', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000167', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '2049', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000168', '2', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '14', '14', '0', '0', '826278914', '0', '0', '0', '0', '0', '0', '34880', '2080', '1024', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000169', '2', '1', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '1', '9', '0', '0', '826278913', '0', '0', '0', '0', '0', '23584', '34880', '2080', '1024', '4192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000170', '8', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '7200', '2080', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000171', '5', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '25632', '7200', '2080', '1024', '25600', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000172', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '4128', '7200', '1024', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000173', '2', '1', '4', '27', '0', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '28', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6152', '1059', '9760', '5250', '6212', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000174', '5', '3', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '52', '58', '66', '0', '894436362', '0', '0', '0', '0', '0', '0', '4193', '4193', '6241', '5376', '6496', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000175', '6', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '54', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1476', '10402', '10530', '1060', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000176', '5', '2', '4', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '66', '66', '53', '0', '721421332', '0', '0', '0', '0', '0', '0', '0', '1122', '2208', '2114', '2082', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000177', '7', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '4', '0', '737149954', '747635714', '0', '0', '0', '0', '0', '23595', '2240', '9376', '10339', '2082', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000178', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '5', '0', '383779882', '0', '0', '0', '0', '0', '0', '20608', '7424', '5191', '6339', '6304', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000179', '8', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '6', '0', '383779860', '0', '0', '0', '0', '0', '0', '20576', '7232', '5198', '6209', '6209', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000180', '4', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '7', '0', '894437377', '0', '0', '0', '0', '0', '0', '6148', '1410', '9472', '5251', '6216', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000181', '3', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '8', '8', '0', '894436363', '0', '0', '0', '0', '0', '0', '4195', '6212', '9472', '1024', '6244', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000182', '7', '3', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '9', '0', '243270659', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000183', '7', '2', '3', '0', '0', '4', '0', '0', '1', '0', '5', '0', '3', '3', '1', '12', '2', '2', '0', '243270658', '0', '0', '0', '0', '0', '0', '16610', '16672', '10403', '1024', '21859', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000184', '7', '2', '7', '0', '0', '8', '0', '0', '4', '1', '2', '4', '3', '2', '1', '28', '2', '6', '0', '243270657', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000185', '1', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '5', '0', '79693844', '0', '0', '0', '0', '0', '0', '0', '9413', '16644', '5347', '8576', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000186', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1089', '5197', '1024', '4163', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000187', '8', '2', '2', '0', '0', '1', '0', '0', '0', '1', '0', '4', '0', '2', '3', '12', '11', '13', '0', '737152000', '0', '0', '0', '0', '0', '0', '23845', '33953', '1440', '5217', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000188', '4', '2', '1', '0', '0', '1', '0', '0', '3', '0', '0', '3', '1', '0', '0', '30', '6', '3', '0', '737152000', '0', '0', '0', '0', '0', '0', '23845', '33953', '1440', '5217', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000189', '2', '2', '9', '0', '0', '3', '0', '0', '1', '1', '5', '4', '0', '0', '3', '3', '10', '5', '0', '721421333', '0', '0', '0', '0', '0', '0', '21696', '33954', '2115', '2115', '25633', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000190', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '12', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '8353', '15904', '14530', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000191', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '13', '0', '147852288', '0', '0', '0', '0', '0', '0', '25641', '10306', '15872', '1024', '2243', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000192', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '14', '0', '147852289', '0', '0', '0', '0', '0', '0', '25795', '11491', '15872', '1024', '2082', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000193', '7', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '1057', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000194', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '2', '0', '147851275', '0', '0', '0', '0', '0', '0', '22592', '8323', '15904', '14467', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000195', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '3', '0', '383779841', '0', '0', '0', '0', '0', '0', '20496', '4160', '5187', '6219', '10336', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000196', '5', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '4', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '7424', '3148', '5121', '1060', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000197', '1', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '5', '0', '383779881', '0', '0', '0', '0', '0', '0', '20495', '4384', '5345', '6308', '10496', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000198', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '6', '0', '383779840', '0', '0', '0', '0', '0', '0', '0', '7200', '5153', '6144', '6177', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000199', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '7', '0', '894436363', '0', '0', '0', '0', '0', '0', '4224', '1120', '6240', '5281', '6240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000200', '7', '2', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '63', '61', '62', '0', '894437386', '0', '0', '0', '0', '0', '0', '6336', '8417', '9728', '1024', '6338', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000201', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '9', '0', '894436362', '0', '0', '0', '0', '0', '0', '6146', '1026', '6145', '1024', '6145', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000202', '8', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '57', '53', '0', '894437406', '0', '0', '0', '0', '0', '0', '6240', '6336', '6272', '6272', '6272', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000203', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '11', '0', '894437377', '0', '0', '0', '0', '0', '0', '23593', '4164', '9376', '5188', '4160', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000204', '9', '2', '3', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '58', '59', '60', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '4160', '5187', '6219', '10336', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000205', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '3776', '3776', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000206', '4', '2', '8', '23', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '8', '4', '0', '383779842', '0', '0', '0', '0', '0', '0', '20608', '7424', '5191', '6339', '6304', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000207', '1', '1', '1', '0', '0', '7', '0', '0', '5', '1', '5', '0', '2', '3', '1', '5', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000208', '5', '2', '3', '12', '0', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '9', '7', '9', '0', '815795200', '0', '0', '0', '0', '0', '0', '0', '7587', '2272', '1024', '25732', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000209', '5', '2', '3', '12', '0', '1', '13', '0', '5', '0', '0', '3', '2', '3', '2', '9', '7', '9', '0', '815793173', '0', '0', '0', '0', '0', '0', '23616', '7232', '4130', '10272', '4130', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000210', '3', '2', '5', '0', '0', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '1', '5', '12', '0', '815795220', '0', '0', '0', '0', '0', '0', '6180', '10624', '5284', '1024', '5348', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000211', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '2', '4', '2', '1', '3', '4', '8', '15', '0', '815793167', '0', '0', '0', '0', '0', '0', '25768', '35072', '15744', '1024', '8288', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000212', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '9', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1089', '10274', '25664', '25664', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000213', '2', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '5', '6', '0', '815793163', '0', '0', '0', '0', '0', '0', '0', '5186', '10305', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000214', '4', '2', '2', '0', '0', '6', '26', '0', '4', '0', '1', '4', '0', '0', '3', '8', '8', '10', '0', '168825858', '0', '0', '0', '0', '0', '0', '23885', '15586', '3149', '11618', '8515', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000215', '7', '4', '6', '0', '0', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '25', '15', '3', '0', '147853342', '0', '0', '0', '0', '0', '0', '13664', '15808', '9408', '13696', '8545', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000216', '8', '0', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '63', '62', '62', '0', '383779841', '0', '0', '0', '0', '0', '0', '20496', '11491', '15872', '1024', '2082', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000217', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000218', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000219', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000220', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000221', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000222', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000223', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000224', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000225', '7', '3', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '22624', '15712', '15904', '25728', '15712', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000226', '8', '3', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000227', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '62', '56', '0', '0', '0', '0', '0', '0', '0', '0', '21505', '1027', '2081', '5153', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000228', '2', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '1091', '9632', '5252', '6241', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000229', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5250', '1059', '5188', '1024', '5188', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000230', '4', '2', '1', '0', '0', '5', '24', '0', '0', '0', '0', '0', '0', '0', '0', '73', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9376', '5190', '1024', '1057', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000231', '1', '2', '5', '0', '0', '8', '0', '0', '1', '1', '0', '5', '3', '1', '0', '7', '9', '4', '0', '768607243', '0', '0', '0', '0', '0', '0', '23585', '31875', '2113', '11360', '25697', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000232', '2', '3', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '6', '5', '0', '768610314', '0', '0', '0', '0', '0', '0', '4355', '4386', '7298', '1024', '9604', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000233', '2', '3', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '6', '5', '0', '768610304', '0', '0', '0', '0', '0', '0', '4355', '4355', '7298', '1024', '9604', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000234', '4', '2', '8', '0', '0', '8', '0', '0', '4', '0', '5', '2', '1', '3', '0', '16', '14', '11', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000235', '21', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1013760', '1013760', '1013760', '1013760', '1013760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000236', '7', '3', '3', '0', '0', '8', '0', '0', '2', '0', '5', '2', '0', '2', '0', '30', '13', '14', '0', '0', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000237', '6', '3', '2', '0', '0', '7', '22', '0', '0', '0', '0', '0', '0', '0', '0', '74', '52', '55', '0', '878709770', '0', '0', '0', '0', '0', '0', '6304', '6528', '6496', '6275', '6464', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000238', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '1728', '1728', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000239', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '2752', '2752', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000240', '5', '2', '4', '0', '0', '4', '1', '0', '0', '0', '0', '0', '0', '0', '0', '51', '54', '53', '0', '705692763', '0', '0', '0', '0', '0', '0', '0', '29891', '9696', '10371', '8257', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000241', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '15', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '10339', '10273', '25664', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000242', '2', '2', '5', '0', '0', '3', '0', '0', '4', '0', '0', '4', '3', '1', '3', '24', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4196', '9472', '1024', '9379', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000243', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '10', '0', '168821790', '0', '0', '0', '0', '0', '0', '19503', '14624', '3106', '14624', '10304', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000244', '1', '2', '6', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '24580', '16480', '10305', '1024', '9313', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000245', '6', '3', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '63', '62', '65', '0', '147850241', '0', '0', '0', '0', '0', '0', '23842', '4130', '9408', '5154', '4130', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000246', '7', '1', '4', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '25', '7', '2', '0', '737152010', '0', '0', '0', '0', '0', '0', '20494', '2240', '2208', '1024', '2144', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000247', '1', '2', '5', '0', '0', '7', '29', '0', '0', '0', '0', '0', '0', '0', '0', '26', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1154', '2208', '1024', '2208', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000248', '8', '3', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '61', '66', '0', '0', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000249', '4', '1', '4', '0', '0', '4', '0', '0', '5', '1', '0', '4', '1', '2', '0', '4', '10', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6153', '33827', '7232', '6224', '9248', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000250', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '9', '8', '0', '0', '0', '0', '0', '0', '0', '0', '16513', '2146', '5190', '1024', '5186', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000251', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '16513', '2146', '5190', '1024', '5186', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000252', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '2146', '5190', '1024', '5186', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000253', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1092', '6215', '1024', '5281', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000254', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '58', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '5153', '2115', '1024', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000255', '7', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '9314', '9280', '1024', '9315', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000256', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16546', '5280', '1024', '5444', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000257', '8', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5249', '4163', '10273', '1024', '5154', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000258', '7', '2', '9', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '4', '0', '944784384', '0', '0', '0', '0', '0', '0', '23875', '8322', '15904', '14466', '8259', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000259', '6', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5378', '5316', '5218', '1024', '5314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000260', '1', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '1025', '6144', '5120', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000261', '5', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23890', '1120', '10338', '25697', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000262', '4', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '16644', '5376', '5280', '1024', '5378', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000263', '21', '2', '41', '0', '0', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '24', '24', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3904', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000264', '6', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '10', '0', '60818442', '61867018', '0', '0', '0', '0', '0', '10272', '10273', '10272', '1024', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000265', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '11', '0', '721421314', '731907073', '0', '0', '0', '0', '0', '4224', '1408', '2145', '2112', '2083', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000266', '1', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '57', '57', '59', '0', '721421313', '731907072', '0', '0', '0', '0', '0', '0', '1058', '2080', '5155', '2244', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000267', '6', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '13', '0', '737149954', '747635714', '0', '0', '0', '0', '0', '0', '32833', '16577', '10338', '2082', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000268', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '14', '0', '737149954', '0', '0', '0', '0', '0', '0', '20481', '2240', '9856', '10337', '9571', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000269', '6', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '15', '0', '80741416', '0', '0', '0', '0', '0', '0', '24801', '10435', '10403', '25731', '21648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000270', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '16', '0', '0', '0', '0', '0', '0', '0', '0', '11303', '7427', '5217', '5280', '5312', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000271', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '15', '1', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '0', '8418', '8640', '8448', '8512', '187392', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000272', '3', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '2', '0', '168823811', '0', '0', '0', '0', '0', '0', '13600', '13728', '4224', '13536', '13600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000273', '2', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '9696', '9792', '9856', '9539', '9571', '198656', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000274', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '11308', '4355', '4225', '5280', '4323', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000275', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '5', '0', '784335892', '0', '0', '0', '0', '0', '0', '5409', '5316', '5249', '1024', '5345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000276', '6', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2208', '5250', '5314', '10465', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000277', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '7', '0', '800068608', '0', '0', '0', '0', '0', '0', '20498', '5380', '5284', '1024', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000278', '3', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '4256', '6560', '2115', '5316', '6339', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000279', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '9', '0', '717227011', '0', '0', '0', '0', '0', '0', '6240', '1154', '2210', '10432', '9539', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000280', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '54', '51', '0', '768610304', '0', '0', '0', '0', '0', '0', '4227', '4256', '2209', '1024', '9440', '145408', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000281', '2', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '6304', '6400', '6308', '6274', '6306', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000282', '6', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '12', '0', '168823829', '0', '0', '0', '0', '0', '0', '13410', '13600', '4228', '13442', '10400', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000283', '5', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '13', '0', '147850241', '0', '0', '0', '0', '0', '0', '23588', '11300', '9248', '5122', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000284', '7', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '14', '0', '147852288', '0', '0', '0', '0', '0', '0', '21507', '15362', '9408', '25732', '8353', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000285', '8', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '147852288', '0', '0', '0', '0', '0', '0', '13506', '15362', '9408', '25696', '8353', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000286', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '16', '0', '243270666', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000287', '7', '3', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80712704', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000288', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '274699264', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000289', '8', '2', '2', '0', '0', '4', '0', '0', '3', '1', '1', '5', '3', '2', '2', '29', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '7360', '7652', '7397', '5408', '5472', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000290', '5', '2', '2', '0', '0', '8', '0', '0', '4', '0', '2', '2', '1', '3', '3', '81', '59', '60', '0', '61867058', '60818482', '0', '0', '0', '0', '0', '10528', '30018', '10496', '11620', '10432', '219136', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000291', '2', '2', '6', '0', '0', '3', '0', '0', '3', '1', '5', '3', '1', '1', '2', '15', '9', '2', '0', '210767922', '236979210', '0', '0', '0', '0', '0', '9763', '9858', '7395', '9571', '9602', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000292', '5', '2', '1', '0', '0', '7', '0', '0', '1', '0', '1', '5', '3', '3', '2', '15', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '10273', '7171', '1024', '8194', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000293', '4', '2', '2', '0', '0', '6', '0', '0', '2', '1', '0', '0', '2', '0', '3', '12', '2', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000294', '7', '2', '6', '0', '0', '1', '0', '0', '2', '1', '2', '0', '0', '1', '3', '32', '12', '9', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000295', '5', '2', '4', '0', '0', '7', '0', '0', '2', '0', '1', '1', '0', '0', '0', '26', '15', '1', '0', '815793173', '0', '0', '0', '0', '0', '0', '23616', '7232', '4130', '10272', '4130', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000296', '8', '2', '3', '0', '0', '2', '0', '0', '5', '1', '2', '0', '1', '3', '2', '20', '7', '11', '0', '815793164', '0', '0', '0', '0', '0', '0', '23686', '7587', '4355', '10530', '4352', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000297', '4', '2', '6', '0', '0', '4', '0', '0', '0', '1', '4', '1', '3', '0', '0', '21', '6', '6', '0', '815793164', '0', '0', '0', '0', '0', '0', '23686', '7587', '4355', '10530', '4352', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000298', '7', '2', '1', '0', '0', '4', '0', '0', '3', '1', '0', '1', '2', '0', '1', '1', '3', '4', '0', '147850280', '0', '0', '0', '0', '0', '0', '12355', '8352', '4169', '5216', '8352', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000299', '1', '2', '7', '0', '0', '7', '0', '0', '5', '0', '3', '5', '0', '1', '3', '11', '3', '15', '0', '815793182', '0', '0', '0', '0', '0', '0', '23874', '35328', '5220', '10272', '8288', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000300', '8', '2', '8', '0', '0', '1', '0', '0', '5', '1', '0', '0', '2', '0', '1', '13', '3', '1', '0', '815793167', '0', '0', '0', '0', '0', '0', '25728', '35072', '15744', '1024', '8288', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000301', '9', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '66', '63', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000302', '6', '2', '3', '0', '0', '5', '0', '0', '3', '1', '2', '2', '2', '0', '1', '29', '7', '12', '0', '815793164', '0', '0', '0', '0', '0', '0', '23686', '7587', '4355', '10530', '4352', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000303', '8', '2', '7', '0', '0', '4', '0', '0', '1', '1', '3', '4', '2', '3', '0', '15', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000304', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '4', '3', '2', '0', '1', '9', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000305', '6', '0', '4', '0', '0', '2', '0', '0', '4', '0', '3', '2', '1', '3', '0', '2', '14', '15', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1376', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000306', '2', '2', '8', '0', '0', '2', '0', '0', '3', '0', '3', '0', '0', '3', '2', '13', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000307', '1', '2', '4', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '1', '19', '13', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000308', '5', '2', '1', '0', '0', '8', '0', '0', '1', '1', '2', '5', '2', '2', '3', '78', '56', '53', '0', '815793164', '0', '0', '0', '0', '0', '0', '25634', '34884', '4128', '10240', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000309', '3', '2', '5', '0', '0', '7', '0', '0', '1', '0', '3', '3', '0', '1', '2', '17', '4', '5', '0', '815793164', '0', '0', '0', '0', '0', '0', '25634', '34884', '4128', '10240', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000310', '2', '2', '9', '0', '0', '2', '0', '0', '4', '1', '5', '5', '0', '0', '2', '9', '12', '2', '0', '815793167', '0', '0', '0', '0', '0', '0', '25728', '35072', '15744', '1024', '8288', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000311', '6', '2', '2', '0', '0', '6', '0', '0', '4', '1', '0', '5', '3', '3', '2', '9', '7', '5', '0', '815793166', '0', '0', '0', '0', '0', '0', '25636', '34882', '7232', '10240', '4099', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000312', '9', '2', '1', '0', '0', '2', '0', '0', '5', '0', '0', '2', '1', '1', '2', '70', '55', '53', '0', '0', '0', '0', '0', '0', '0', '0', '21696', '32802', '10304', '25696', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000313', '7', '2', '8', '0', '0', '4', '0', '0', '2', '1', '4', '0', '0', '0', '2', '26', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '25795', '6177', '16452', '10304', '8224', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000314', '4', '2', '1', '0', '0', '4', '0', '0', '1', '0', '5', '3', '3', '2', '1', '19', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '13377', '31904', '16449', '25632', '8320', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000315', '8', '2', '4', '0', '0', '2', '0', '0', '4', '1', '2', '2', '3', '0', '0', '10', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '23586', '32804', '10274', '5120', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000316', '8', '2', '5', '0', '0', '3', '0', '0', '1', '1', '0', '4', '2', '0', '1', '27', '11', '1', '0', '894436352', '0', '0', '0', '0', '0', '0', '6146', '10275', '9280', '5121', '2244', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000317', '5', '2', '2', '0', '0', '7', '0', '0', '0', '1', '4', '0', '2', '1', '1', '17', '2', '4', '0', '894437376', '0', '0', '0', '0', '0', '0', '20481', '1057', '6147', '1024', '8225', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000318', '7', '2', '7', '0', '0', '5', '0', '0', '5', '1', '5', '4', '1', '3', '0', '20', '14', '11', '0', '894437377', '0', '0', '0', '0', '0', '0', '6145', '10273', '9280', '5121', '2240', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000319', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '54', '51', '0', '894437376', '0', '0', '0', '0', '0', '0', '23585', '8224', '6177', '5153', '1024', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000320', '2', '2', '4', '0', '0', '1', '0', '0', '5', '0', '4', '2', '3', '0', '0', '14', '14', '3', '0', '168825867', '0', '0', '0', '0', '0', '0', '13603', '14661', '3296', '14689', '10592', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000321', '6', '2', '2', '0', '0', '2', '0', '0', '4', '1', '0', '1', '0', '3', '2', '6', '8', '5', '0', '894436364', '0', '0', '0', '0', '0', '0', '21698', '6560', '16609', '6432', '25732', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000322', '7', '2', '5', '0', '0', '8', '0', '0', '4', '0', '4', '5', '3', '3', '2', '3', '6', '3', '0', '894437378', '0', '0', '0', '0', '0', '0', '21698', '6592', '6433', '25730', '25760', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000323', '8', '2', '1', '0', '0', '3', '0', '0', '0', '1', '1', '2', '2', '3', '0', '4', '14', '12', '0', '894437406', '0', '0', '0', '0', '0', '0', '6272', '2208', '15712', '5411', '9569', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000324', '4', '2', '3', '0', '0', '8', '0', '0', '2', '0', '4', '1', '1', '2', '1', '2', '1', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '35266', '4356', '1024', '6400', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000325', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '13', '0', '894437416', '0', '0', '0', '0', '0', '0', '6272', '2208', '15712', '5411', '9569', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000326', '2', '2', '7', '0', '0', '1', '0', '0', '0', '0', '3', '1', '0', '3', '3', '11', '3', '8', '0', '878708737', '0', '0', '0', '0', '0', '0', '5376', '4354', '6304', '6304', '6340', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000327', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000328', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000329', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000330', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '9', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20544', '7200', '5153', '6144', '6177', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000331', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '2', '0', '0', '0', '0', '0', '0', '0', '0', '21569', '1121', '2208', '5218', '2083', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000332', '7', '3', '3', '0', '0', '5', '22', '0', '0', '0', '0', '0', '0', '0', '0', '12', '13', '3', '0', '0', '0', '0', '0', '0', '0', '0', '24704', '16576', '10337', '1024', '9412', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000333', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '1026', '6145', '5120', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000334', '6', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '11298', '4098', '11264', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000335', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '10273', '1058', '10273', '10272', '25601', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000336', '8', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '5312', '5216', '1024', '5312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000337', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '8353', '15904', '14530', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000338', '7', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '57', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2149', '2208', '2114', '2082', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000339', '8', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '16513', '2146', '5190', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000340', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20495', '4384', '5345', '6308', '10496', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000341', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '6496', '6464', '6432', '6496', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000342', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '14336', '12480', '10274', '10369', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000343', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '1024', '2083', '1024', '1056', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000344', '3', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '16483', '5184', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000345', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '6153', '4132', '5188', '1024', '1024', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000346', '4', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16608', '10369', '1024', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000347', '7', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '16', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10305', '10401', '10370', '10400', '10400', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000348', '9', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '55', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20483', '7297', '5190', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000349', '7', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '16', '0', '147851275', '0', '0', '0', '0', '0', '0', '14336', '12480', '10274', '10369', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000350', '3', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '1', '0', '147851275', '0', '0', '0', '0', '0', '0', '14336', '12480', '10274', '10369', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000351', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '16', '2', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000352', '7', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '3', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000353', '7', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '2', '4', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000354', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '5', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000355', '3', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '6', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000356', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '7', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000357', '8', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '8', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000358', '5', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '9', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000359', '7', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '12', '0', '210766849', '236979210', '0', '0', '0', '231737384', '0', '9312', '9280', '9280', '9248', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000360', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '13', '0', '347079683', '0', '0', '0', '0', '0', '0', '7202', '7234', '2116', '5185', '4162', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000361', '7', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '14', '0', '147851265', '0', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000362', '4', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '15', '0', '80741386', '0', '0', '0', '0', '0', '0', '24577', '10274', '10272', '11296', '21536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000363', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '3', '0', '79694848', '32507924', '0', '0', '0', '0', '0', '14337', '12288', '10274', '11457', '21506', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000364', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '4', '0', '79694848', '32507924', '0', '0', '0', '0', '0', '14337', '12288', '10274', '11457', '21506', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000365', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '59', '55', '51', '0', '737149954', '0', '0', '0', '0', '0', '0', '0', '2151', '2240', '5251', '2081', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000366', '3', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '8', '10', '0', '79694848', '32507924', '0', '0', '0', '0', '0', '14337', '12288', '10274', '11457', '21506', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000367', '8', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '9', '11', '0', '147851264', '0', '0', '0', '0', '0', '0', '23842', '1057', '9280', '5154', '8193', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000368', '6', '1', '3', '0', '0', '3', '0', '0', '3', '0', '2', '3', '2', '3', '3', '58', '59', '62', '0', '768609300', '331351042', '0', '0', '0', '0', '0', '5346', '4289', '3203', '11329', '4162', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000369', '3', '3', '7', '0', '0', '4', '6', '0', '2', '1', '4', '5', '3', '0', '2', '14', '5', '3', '0', '79698947', '32515082', '0', '0', '0', '0', '0', '14497', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000370', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '4', '2', '1', '3', '0', '17', '5', '10', '0', '80741436', '32515112', '0', '0', '0', '0', '0', '3232', '3232', '3300', '3232', '3232', '140288', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000371', '7', '1', '5', '0', '0', '4', '5', '0', '2', '1', '5', '2', '0', '1', '2', '30', '13', '10', '0', '768610304', '0', '0', '0', '0', '0', '0', '20489', '33952', '10369', '5251', '4258', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000372', '1', '3', '5', '0', '0', '1', '0', '0', '2', '0', '5', '3', '1', '3', '1', '25', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000373', '7', '2', '5', '0', '0', '8', '5', '0', '4', '1', '1', '3', '0', '1', '1', '19', '12', '1', '0', '904922115', '0', '0', '0', '0', '0', '0', '6336', '10466', '2147', '5376', '10499', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000374', '5', '2', '4', '0', '0', '8', '0', '0', '2', '1', '0', '4', '0', '1', '0', '72', '51', '60', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1152', '1760', '25600', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000375', '20971', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000376', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000377', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '8', '3', '0', '944771072', '0', '0', '0', '0', '0', '0', '23554', '8320', '15904', '10336', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000378', '6', '2', '2', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '66', '52', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4129', '6145', '1024', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000379', '2', '2', '8', '0', '0', '5', '0', '0', '0', '1', '0', '1', '2', '2', '3', '4', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000380', '1', '2', '3', '0', '0', '2', '0', '0', '5', '1', '2', '4', '0', '3', '2', '30', '14', '2', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000381', '2', '2', '5', '0', '0', '2', '0', '0', '2', '0', '3', '1', '0', '2', '3', '4', '1', '14', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '1216', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000382', '3', '2', '1', '0', '0', '8', '0', '0', '3', '1', '0', '5', '1', '3', '1', '8', '13', '5', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000383', '4', '2', '8', '0', '0', '6', '0', '0', '5', '1', '2', '1', '1', '2', '1', '22', '8', '5', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '1216', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000384', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '1', '5', '0', '0', '1', '27', '14', '5', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000385', '1', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '5', '4', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '9408', '14400', '4416', '14432', '9440', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000386', '4', '2', '3', '0', '0', '8', '0', '0', '0', '0', '3', '5', '3', '2', '1', '11', '11', '6', '0', '80741388', '32515112', '0', '0', '0', '0', '0', '3232', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000387', '3', '2', '1', '0', '0', '3', '0', '0', '4', '0', '2', '1', '1', '3', '2', '6', '6', '9', '0', '147851266', '0', '0', '0', '0', '0', '0', '3232', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000388', '4', '2', '6', '0', '0', '8', '0', '0', '5', '1', '5', '2', '3', '1', '1', '4', '10', '10', '0', '79697950', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000389', '5', '2', '2', '0', '0', '3', '0', '0', '0', '1', '3', '2', '0', '2', '1', '10', '10', '9', '0', '79693844', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000390', '7', '2', '8', '0', '0', '8', '0', '0', '1', '1', '2', '0', '3', '1', '1', '11', '5', '12', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000391', '8', '2', '3', '0', '0', '2', '0', '0', '3', '0', '4', '3', '0', '0', '2', '5', '9', '1', '0', '79692820', '0', '0', '0', '0', '0', '0', '9408', '14400', '4416', '14432', '9440', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000392', '6', '2', '3', '0', '0', '5', '0', '0', '3', '0', '2', '3', '3', '3', '0', '2', '11', '13', '0', '347080706', '0', '0', '0', '0', '0', '0', '9408', '14400', '4416', '14432', '9440', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000393', '2', '2', '3', '0', '0', '5', '0', '0', '4', '1', '2', '3', '2', '3', '3', '20', '12', '14', '0', '768608256', '0', '0', '0', '0', '0', '0', '4192', '31877', '2115', '11328', '9312', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000394', '4', '2', '4', '0', '0', '2', '0', '0', '4', '1', '0', '2', '0', '2', '3', '63', '64', '56', '0', '168825866', '0', '0', '0', '0', '0', '0', '3296', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000395', '3', '2', '1', '0', '0', '7', '0', '0', '3', '0', '0', '3', '0', '1', '1', '28', '15', '5', '0', '168825866', '0', '0', '0', '0', '0', '0', '3296', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000396', '3', '2', '5', '0', '0', '3', '20', '0', '1', '0', '0', '5', '2', '0', '3', '12', '14', '16', '0', '168825866', '0', '0', '0', '0', '0', '0', '3296', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000397', '5', '2', '2', '0', '0', '5', '0', '0', '5', '1', '5', '0', '3', '3', '2', '12', '6', '7', '0', '768607232', '0', '0', '0', '0', '0', '0', '4098', '4098', '4099', '6147', '9248', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000398', '1', '2', '7', '0', '0', '7', '4', '0', '4', '0', '1', '0', '0', '1', '2', '27', '8', '10', '0', '768608256', '0', '0', '0', '0', '0', '0', '0', '4194', '4170', '11361', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000399', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '3', '4', '3', '0', '3', '11', '7', '9', '0', '768608256', '0', '0', '0', '0', '0', '0', '4192', '31877', '2115', '11328', '9312', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000400', '5', '2', '2', '0', '0', '4', '0', '0', '3', '1', '4', '2', '3', '3', '2', '57', '63', '60', '0', '768609300', '0', '0', '0', '0', '0', '0', '0', '4416', '2208', '6336', '25760', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000401', '5', '2', '2', '0', '0', '8', '0', '0', '1', '1', '4', '5', '2', '0', '3', '75', '53', '56', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000402', '9', '2', '2', '0', '0', '2', '25', '0', '4', '1', '3', '0', '1', '2', '3', '67', '51', '60', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '10282', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000403', '6', '2', '3', '0', '0', '8', '0', '0', '3', '1', '4', '4', '2', '3', '2', '53', '61', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5380', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000404', '7', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '1', '2', '3', '2', '21', '10', '11', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000405', '1', '2', '1', '0', '0', '8', '0', '0', '4', '1', '2', '3', '0', '1', '1', '2', '2', '8', '0', '210765825', '236979210', '0', '0', '0', '0', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000406', '6', '2', '1', '0', '0', '2', '0', '0', '2', '1', '1', '5', '2', '1', '2', '9', '1', '13', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000407', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000408', '21', '2', '31', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000409', '21', '2', '0', '0', '0', '41', '0', '0', '0', '1', '2', '5', '0', '3', '0', '14', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '1792', '1792', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000410', '21', '2', '51', '0', '0', '51', '0', '0', '0', '0', '3', '2', '3', '0', '0', '22', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '2816', '2816', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000411', '21', '1', '0', '0', '0', '31', '0', '0', '3', '1', '0', '1', '0', '3', '2', '28', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '2753', '2753', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000412', '21', '2', '0', '0', '0', '21', '0', '0', '5', '0', '0', '5', '1', '1', '0', '28', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '1856', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000413', '4', '2', '8', '0', '0', '8', '0', '0', '1', '1', '0', '3', '1', '2', '0', '3', '10', '1', '0', '721421333', '0', '0', '0', '0', '0', '0', '21696', '33954', '2115', '2115', '25633', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000414', '5', '2', '2', '0', '0', '1', '0', '0', '5', '0', '3', '3', '0', '2', '0', '28', '4', '1', '0', '737149954', '0', '0', '0', '0', '0', '0', '23595', '32833', '9376', '10338', '2082', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000415', '1', '2', '5', '0', '0', '8', '0', '0', '3', '1', '0', '0', '1', '1', '1', '15', '13', '5', '0', '721421325', '0', '0', '0', '0', '0', '0', '23596', '2304', '2240', '2272', '9603', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000416', '2', '2', '4', '0', '0', '1', '0', '0', '0', '0', '1', '2', '2', '2', '0', '19', '6', '8', '0', '721421314', '0', '0', '0', '0', '0', '0', '23593', '32832', '9632', '2113', '25696', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000417', '3', '2', '5', '0', '0', '8', '0', '0', '3', '0', '1', '3', '2', '0', '3', '13', '6', '15', '0', '737150979', '0', '0', '0', '0', '0', '0', '23880', '2240', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000418', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '2', '3', '0', '0', '0', '19', '13', '8', '0', '721421333', '0', '0', '0', '0', '0', '0', '21537', '32836', '2112', '2114', '2081', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000419', '8', '2', '5', '0', '0', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '22', '12', '5', '0', '737149954', '0', '0', '0', '0', '0', '0', '20481', '2148', '9856', '10337', '9571', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000420', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '3', '4', '2', '0', '2', '65', '62', '59', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000421', '8', '2', '2', '0', '0', '4', '0', '0', '4', '0', '1', '3', '0', '1', '0', '16', '4', '13', '0', '58722324', '59770900', '0', '0', '0', '0', '0', '0', '10401', '10272', '10466', '4193', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000422', '4', '2', '4', '0', '0', '4', '0', '0', '3', '0', '1', '1', '2', '3', '1', '12', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000423', '3', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '3', '2', '1', '2', '11', '4', '1', '0', '705692752', '0', '0', '0', '0', '0', '0', '23875', '10467', '16673', '11364', '9571', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000424', '21', '2', '41', '0', '0', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '12', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1824', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000425', '7', '2', '8', '0', '0', '5', '21', '0', '3', '1', '1', '1', '2', '3', '1', '12', '14', '10', '0', '147851274', '0', '0', '0', '0', '0', '0', '23883', '8352', '8416', '14528', '8353', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000426', '1', '2', '1', '0', '0', '7', '0', '0', '1', '0', '1', '1', '1', '1', '2', '10', '14', '16', '0', '147851274', '0', '0', '0', '0', '0', '0', '23883', '8352', '8416', '14528', '8353', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000427', '6', '2', '2', '0', '0', '2', '0', '0', '1', '0', '2', '3', '3', '1', '3', '1', '13', '13', '0', '58724382', '59772958', '0', '0', '0', '0', '0', '10400', '10528', '10402', '8256', '4323', '340992', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000428', '7', '2', '2', '0', '0', '5', '0', '0', '2', '1', '1', '2', '1', '2', '0', '5', '12', '9', '0', '147852300', '0', '0', '0', '0', '0', '0', '8292', '15585', '8960', '8579', '21860', '219136', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000429', '5', '2', '3', '0', '0', '3', '0', '0', '1', '1', '3', '3', '1', '0', '0', '20', '15', '12', '0', '784335902', '0', '0', '0', '0', '0', '0', '5568', '5379', '16672', '5184', '5440', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000430', '5', '2', '4', '0', '0', '1', '0', '0', '3', '0', '4', '5', '2', '0', '0', '15', '4', '8', '0', '752878622', '0', '0', '0', '0', '0', '0', '4417', '4417', '5344', '5440', '10529', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000431', '8', '2', '3', '0', '0', '4', '0', '0', '3', '0', '5', '1', '2', '0', '3', '25', '14', '8', '0', '800070656', '0', '0', '0', '0', '0', '0', '11333', '4356', '10432', '6340', '5442', '8192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000432', '6', '2', '2', '0', '0', '2', '0', '0', '5', '0', '1', '5', '1', '1', '1', '6', '6', '12', '0', '862980116', '0', '0', '0', '0', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000433', '3', '2', '7', '0', '0', '6', '0', '0', '0', '0', '4', '4', '2', '1', '0', '61', '63', '59', '0', '894437396', '0', '0', '0', '0', '0', '0', '6336', '10466', '2147', '5376', '10499', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000434', '4', '2', '5', '0', '0', '8', '0', '0', '3', '1', '2', '2', '3', '0', '1', '30', '9', '14', '0', '815793164', '0', '0', '0', '0', '0', '0', '23686', '7587', '4355', '10530', '4352', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000435', '9', '2', '1', '0', '0', '4', '0', '0', '2', '1', '5', '1', '2', '1', '0', '54', '58', '58', '0', '721421325', '0', '0', '0', '0', '0', '0', '23596', '2304', '2240', '2272', '9603', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000436', '7', '2', '4', '0', '0', '8', '0', '0', '0', '1', '1', '2', '0', '3', '1', '15', '9', '11', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '8290', '3296', '3265', '14656', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000437', '8', '2', '7', '0', '0', '1', '0', '0', '0', '1', '5', '0', '2', '3', '2', '27', '4', '15', '0', '294651964', '0', '0', '0', '0', '0', '0', '11321', '7649', '5280', '10530', '4354', '145408', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000438', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '54', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5122', '1091', '9248', '5122', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000439', '1', '2', '1', '0', '2', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '10496', '10467', '10403', '25731', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000440', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '11', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8193', '9248', '5122', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000441', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '76', '64', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '2211', '2147', '1024', '2113', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000442', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '7395', '7651', '5408', '5411', '5443', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000443', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '2', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11424', '3147', '1024', '25665', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000444', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '12', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '1124', '9472', '1024', '6211', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000445', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '8', '14', '0', '0', '0', '0', '0', '0', '0', '0', '13472', '13505', '3139', '1024', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000446', '1', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '56', '58', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '11488', '3169', '11458', '15456', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000447', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5186', '5155', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000448', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '9476', '9412', '9440', '9289', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000449', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1154', '5344', '5348', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000450', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '2081', '2050', '1024', '2241', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000451', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4195', '2116', '1024', '4163', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000452', '1', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '9', '9', '0', '383779841', '0', '0', '0', '0', '0', '0', '20576', '7232', '5198', '6209', '6209', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000453', '7', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '3', '16', '0', '383779842', '0', '0', '0', '0', '0', '0', '20608', '7424', '5191', '6339', '6304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000454', '3', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '12', '4', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000455', '8', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5197', '1024', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000456', '2', '2', '4', '0', '0', '1', '0', '0', '1', '0', '4', '1', '0', '1', '2', '6', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '33860', '7234', '1024', '1058', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000457', '3', '2', '7', '0', '0', '8', '5', '0', '1', '0', '1', '1', '1', '1', '0', '3', '16', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '33860', '2083', '1024', '25664', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000458', '8', '2', '7', '0', '0', '2', '0', '0', '1', '1', '1', '2', '2', '1', '3', '14', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000459', '2', '2', '7', '0', '0', '2', '0', '0', '3', '0', '5', '0', '2', '3', '0', '14', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20640', '2209', '15648', '6340', '9568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000460', '9', '2', '4', '0', '0', '1', '0', '0', '0', '0', '4', '4', '3', '3', '2', '69', '58', '61', '0', '0', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000461', '6', '2', '1', '0', '0', '5', '0', '0', '4', '1', '5', '2', '0', '0', '2', '9', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6368', '6404', '4416', '6340', '6464', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000462', '9', '2', '5', '0', '0', '1', '0', '0', '3', '1', '1', '1', '0', '3', '0', '79', '53', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31878', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000463', '5', '2', '1', '0', '0', '4', '0', '0', '5', '1', '2', '5', '3', '2', '0', '74', '52', '64', '0', '0', '0', '0', '0', '0', '0', '0', '14465', '9697', '9280', '14496', '13505', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000464', '2', '2', '9', '0', '0', '1', '0', '0', '0', '1', '5', '0', '0', '1', '1', '24', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5377', '9472', '9664', '1024', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000465', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '1', '0', '2', '2', '2', '29', '12', '2', '0', '705692693', '0', '0', '0', '0', '0', '0', '9378', '2147', '7265', '2083', '9313', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000466', '2', '2', '3', '0', '0', '3', '0', '0', '1', '0', '4', '2', '2', '0', '0', '17', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '6241', '9472', '5251', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000467', '6', '1', '3', '0', '0', '3', '0', '0', '3', '0', '2', '3', '2', '3', '3', '58', '59', '62', '0', '331351052', '0', '0', '0', '0', '0', '0', '11339', '7587', '3107', '5282', '4288', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000468', '8', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '12', '4', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000469', '6', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '61', '62', '0', '0', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000470', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '9', '9', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000471', '8', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '14', '15', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000472', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '8', '8', '0', '243270656', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000473', '4', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '6', '9', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000474', '8', '2', '4', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '77', '53', '55', '0', '383779861', '0', '0', '0', '0', '0', '0', '20608', '7424', '5191', '6339', '6304', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000475', '8', '2', '5', '0', '0', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '30', '5', '2', '0', '147850242', '0', '0', '0', '0', '0', '0', '13506', '15427', '9408', '25732', '8353', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000476', '8', '2', '2', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '28', '15', '8', '0', '147850241', '0', '0', '0', '0', '0', '0', '13506', '15362', '9408', '25732', '8353', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000477', '9', '2', '3', '0', '0', '1', '30', '0', '3', '0', '1', '0', '1', '0', '0', '62', '52', '56', '0', '80741426', '32509982', '0', '0', '0', '0', '0', '0', '1154', '8896', '11617', '8576', '187392', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000478', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '7', '1', '0', '168823811', '0', '0', '0', '0', '0', '0', '12544', '8387', '8640', '13504', '13538', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000479', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '5', '1', '0', '0', '32507964', '0', '0', '0', '0', '0', '8289', '8417', '8640', '11490', '8448', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000480', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '4', '1', '0', '210766850', '236979200', '0', '0', '0', '231736351', '0', '12800', '8418', '8640', '9505', '8481', '247808', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000481', '9', '2', '5', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '66', '66', '53', '0', '168825866', '0', '0', '0', '0', '0', '0', '21569', '8448', '8576', '14592', '15521', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000482', '3', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '57', '51', '60', '0', '347079685', '0', '0', '0', '0', '0', '0', '7396', '1122', '8640', '13600', '13602', '186368', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000483', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '13', '1', '0', '210764830', '236979200', '0', '0', '0', '231736351', '0', '15490', '8386', '8608', '11520', '9537', '186368', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000484', '1', '1', '4', '0', '0', '7', '0', '0', '3', '1', '4', '5', '2', '0', '1', '22', '15', '6', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000485', '3', '2', '6', '0', '0', '3', '0', '0', '5', '0', '3', '0', '1', '0', '0', '27', '10', '1', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000486', '4', '2', '5', '0', '0', '1', '0', '0', '5', '0', '1', '4', '2', '2', '1', '24', '2', '13', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000487', '7', '3', '3', '0', '0', '5', '29', '0', '1', '0', '5', '3', '1', '3', '1', '9', '16', '12', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000488', '7', '1', '5', '0', '0', '8', '2', '0', '4', '1', '5', '2', '3', '2', '3', '21', '13', '6', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000489', '7', '4', '9', '0', '0', '5', '31', '0', '3', '1', '4', '2', '2', '3', '1', '9', '6', '3', '0', '147850300', '0', '0', '0', '0', '0', '0', '0', '8576', '8896', '8576', '8545', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000490', '5', '2', '1', '0', '0', '8', '0', '0', '2', '0', '1', '2', '2', '2', '1', '63', '61', '55', '0', '147851264', '0', '0', '0', '0', '0', '0', '23842', '1057', '9408', '5154', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000491', '8', '2', '3', '0', '0', '4', '0', '0', '0', '0', '1', '3', '2', '0', '0', '20', '8', '3', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000492', '1', '2', '5', '0', '0', '7', '0', '0', '0', '0', '4', '3', '3', '0', '2', '8', '15', '7', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000493', '5', '2', '3', '0', '0', '5', '0', '0', '4', '0', '5', '4', '1', '0', '3', '25', '5', '11', '0', '768607242', '0', '0', '0', '0', '0', '0', '20481', '33827', '4128', '11296', '9216', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000494', '3', '2', '4', '0', '0', '6', '0', '0', '4', '1', '4', '5', '0', '0', '1', '71', '56', '57', '0', '878708736', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000495', '4', '2', '1', '0', '0', '5', '0', '0', '1', '0', '3', '3', '2', '1', '2', '78', '51', '57', '0', '210764820', '236979210', '0', '0', '0', '0', '0', '10284', '9411', '9504', '11426', '9379', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000496', '2', '2', '7', '0', '0', '1', '0', '0', '4', '0', '3', '4', '2', '3', '0', '16', '13', '1', '0', '210764820', '236979210', '0', '0', '0', '0', '0', '10284', '9411', '9504', '11426', '9379', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000497', '6', '2', '1', '0', '0', '6', '0', '0', '0', '1', '3', '3', '0', '2', '3', '8', '8', '11', '0', '347079681', '0', '0', '0', '0', '0', '0', '0', '4164', '2080', '5188', '5184', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000498', '2', '2', '2', '0', '0', '2', '0', '0', '5', '0', '1', '2', '1', '3', '1', '3', '12', '10', '0', '168825867', '0', '0', '0', '0', '0', '0', '13603', '14661', '3296', '14689', '10592', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000499', '3', '2', '1', '0', '0', '8', '0', '0', '2', '0', '1', '2', '0', '3', '2', '30', '8', '4', '0', '80741396', '0', '0', '0', '0', '0', '0', '3136', '12707', '16032', '8320', '3105', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000500', '9', '2', '2', '0', '0', '2', '0', '0', '1', '0', '0', '5', '0', '1', '1', '58', '63', '54', '0', '294652958', '0', '0', '0', '0', '0', '0', '0', '30019', '7168', '2274', '2210', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000501', '8', '2', '5', '0', '0', '7', '0', '0', '2', '0', '0', '2', '3', '1', '3', '79', '59', '64', '0', '210767922', '236979210', '0', '0', '0', '0', '0', '9763', '9858', '7395', '9571', '9602', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000502', '5', '2', '3', '0', '0', '1', '0', '0', '5', '1', '1', '4', '1', '0', '3', '20', '7', '8', '0', '331351050', '0', '0', '0', '0', '0', '0', '5537', '7649', '7298', '5472', '10528', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000503', '6', '2', '3', '0', '0', '1', '0', '0', '5', '0', '1', '4', '1', '2', '3', '9', '12', '11', '0', '147853342', '0', '0', '0', '0', '0', '0', '3168', '12736', '3392', '5348', '8545', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000504', '1', '2', '4', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '14', '2', '5', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000505', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '15', '16', '0', '331351046', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000506', '21', '2', '21', '0', '0', '21', '0', '0', '0', '1', '3', '0', '3', '0', '1', '16', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1952', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000507', '2', '1', '3', '0', '0', '5', '0', '0', '2', '0', '4', '4', '1', '0', '1', '7', '14', '6', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000508', '2', '3', '6', '0', '0', '2', '0', '0', '0', '1', '2', '2', '2', '3', '1', '18', '1', '10', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000509', '2', '2', '7', '0', '0', '1', '0', '0', '2', '0', '4', '0', '2', '1', '3', '15', '3', '7', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000510', '24', '2', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '924768', '924864', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000511', '2', '2', '9', '0', '0', '3', '0', '0', '5', '1', '3', '0', '0', '0', '0', '17', '14', '9', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000512', '3', '2', '8', '0', '0', '5', '0', '0', '4', '1', '2', '0', '1', '3', '3', '79', '57', '65', '0', '347079711', '0', '0', '0', '0', '0', '0', '9664', '7712', '2144', '5280', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000513', '6', '2', '1', '0', '0', '4', '0', '0', '2', '1', '1', '3', '0', '3', '3', '66', '51', '65', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000514', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000515', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000516', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000517', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000518', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000519', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000520', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000521', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000522', '10903', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000523', '10903', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '1026', '1026', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000524', '10903', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '1026', '1026', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000525', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000526', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000527', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000528', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000529', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000530', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000531', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000532', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000533', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2053', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000534', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2053', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000535', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000536', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2053', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000537', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2053', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000538', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2052', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000539', '7', '2', '9', '0', '0', '8', '18', '0', '1', '0', '5', '5', '1', '1', '1', '19', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000540', '1', '2', '5', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23852', '8259', '8384', '25696', '13345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000541', '3', '2', '2', '0', '0', '8', '0', '0', '2', '1', '0', '4', '1', '1', '1', '21', '5', '2', '0', '0', '0', '0', '0', '0', '0', '0', '23619', '1122', '8416', '10336', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000542', '6', '2', '3', '0', '0', '2', '0', '0', '5', '1', '3', '3', '0', '2', '1', '15', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '4132', '1440', '2084', '11360', '8256', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000543', '3', '2', '5', '0', '0', '4', '0', '0', '2', '1', '2', '2', '2', '1', '1', '9', '11', '6', '0', '80741396', '0', '0', '0', '0', '0', '0', '3136', '12707', '16032', '8320', '3105', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000544', '2', '2', '7', '0', '0', '5', '0', '0', '1', '1', '1', '1', '1', '2', '0', '7', '9', '16', '0', '168821810', '0', '0', '0', '0', '0', '0', '12739', '12803', '7424', '14656', '13667', '247808', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000545', '7', '2', '2', '0', '0', '5', '0', '0', '5', '1', '3', '4', '3', '3', '3', '16', '15', '10', '0', '752878632', '0', '0', '0', '0', '0', '0', '5600', '2305', '5376', '5412', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000546', '8', '2', '8', '0', '0', '1', '0', '0', '3', '1', '5', '4', '3', '2', '1', '5', '10', '13', '0', '147851286', '0', '0', '0', '0', '0', '0', '23686', '8577', '8928', '8577', '21826', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000547', '5', '2', '3', '0', '0', '7', '0', '0', '4', '0', '5', '4', '0', '3', '3', '19', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000548', '8', '2', '4', '0', '0', '1', '0', '0', '5', '1', '2', '5', '2', '0', '3', '14', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '23586', '32804', '10274', '5120', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000549', '5', '2', '1', '0', '0', '8', '0', '0', '3', '0', '4', '5', '1', '3', '1', '78', '51', '64', '0', '721421333', '0', '0', '0', '0', '0', '0', '21537', '32836', '2112', '2114', '2081', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000550', '1', '2', '1', '0', '0', '1', '0', '0', '4', '0', '5', '1', '1', '2', '3', '2', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '23619', '1122', '8416', '10336', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000551', '4', '2', '1', '0', '0', '8', '0', '0', '0', '1', '4', '4', '0', '0', '0', '10', '5', '3', '0', '0', '0', '0', '0', '0', '0', '0', '21664', '33952', '9472', '10400', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000552', '10910', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '404751360', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000553', '4', '3', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '57', '57', '0', '80741386', '0', '0', '0', '0', '0', '0', '22629', '15680', '15872', '11459', '15680', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000554', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '13', '6', '0', '147852289', '0', '0', '0', '0', '0', '0', '15680', '15680', '15872', '11459', '15680', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000555', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '12', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '8353', '15904', '14530', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000556', '2', '2', '9', '0', '0', '2', '0', '0', '5', '0', '1', '2', '0', '1', '3', '26', '5', '12', '0', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9696', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000557', '2', '1', '8', '0', '0', '1', '0', '0', '3', '1', '5', '5', '1', '1', '3', '14', '2', '4', '0', '705692752', '0', '0', '0', '0', '0', '0', '9378', '6241', '9472', '5251', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000558', '9', '2', '4', '0', '0', '1', '0', '0', '3', '1', '1', '4', '2', '2', '0', '74', '62', '60', '0', '705692712', '0', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000559', '5', '1', '2', '0', '0', '7', '0', '0', '2', '1', '4', '2', '1', '1', '2', '7', '11', '14', '0', '705692712', '0', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000560', '7', '3', '8', '0', '0', '1', '0', '0', '4', '0', '5', '2', '2', '0', '3', '17', '6', '10', '0', '705692722', '0', '0', '0', '0', '0', '0', '9378', '2147', '9536', '5217', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000561', '4', '3', '3', '0', '0', '4', '0', '0', '1', '1', '2', '5', '0', '2', '0', '30', '15', '2', '0', '705692693', '0', '0', '0', '0', '0', '0', '9378', '2147', '7265', '2083', '9313', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000562', '1', '1', '8', '0', '0', '2', '4', '0', '3', '1', '2', '1', '2', '1', '3', '16', '14', '11', '0', '705692752', '0', '0', '0', '0', '0', '0', '23875', '10467', '16673', '11364', '9571', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000563', '5', '2', '3', '0', '0', '5', '0', '0', '0', '0', '4', '2', '0', '3', '3', '29', '9', '11', '0', '705692752', '0', '0', '0', '0', '0', '0', '23875', '10467', '16673', '11364', '9571', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000564', '8', '2', '2', '0', '0', '3', '0', '0', '5', '1', '4', '2', '3', '0', '2', '5', '1', '7', '0', '705692752', '0', '0', '0', '0', '0', '0', '9378', '6241', '9472', '5251', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000565', '2', '2', '5', '0', '0', '5', '0', '0', '4', '0', '1', '4', '0', '2', '2', '14', '7', '3', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '1216', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000566', '1', '2', '3', '0', '0', '7', '7', '0', '0', '1', '0', '0', '2', '2', '3', '30', '5', '9', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000567', '7', '2', '4', '0', '0', '1', '0', '0', '4', '0', '0', '1', '1', '1', '0', '23', '12', '16', '0', '168821760', '0', '0', '0', '0', '0', '0', '19502', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000568', '9', '2', '2', '0', '0', '1', '0', '0', '2', '0', '5', '1', '1', '1', '1', '60', '64', '64', '0', '168821760', '0', '0', '0', '0', '0', '0', '19502', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000569', '3', '2', '2', '0', '0', '3', '0', '0', '2', '1', '0', '1', '1', '1', '0', '25', '14', '2', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000570', '8', '2', '8', '0', '0', '3', '0', '0', '4', '0', '1', '3', '3', '1', '2', '8', '3', '2', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '9472', '14467', '9379', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000571', '3', '2', '1', '0', '0', '1', '0', '0', '1', '1', '5', '0', '1', '1', '2', '71', '66', '62', '0', '168822794', '0', '0', '0', '0', '0', '0', '14496', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000572', '4', '2', '1', '0', '0', '6', '0', '0', '4', '0', '4', '4', '2', '1', '3', '6', '10', '16', '0', '80741406', '32515112', '0', '0', '0', '0', '0', '3232', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000573', '3', '2', '6', '0', '0', '8', '0', '0', '3', '1', '5', '5', '0', '0', '1', '9', '13', '13', '0', '80741406', '32515112', '0', '0', '0', '0', '0', '3232', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000574', '7', '2', '4', '0', '0', '8', '0', '0', '2', '0', '2', '3', '0', '2', '0', '15', '13', '10', '0', '878707712', '0', '0', '0', '0', '0', '0', '6144', '6147', '6144', '6145', '6147', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000575', '3', '2', '7', '0', '0', '8', '0', '0', '2', '1', '4', '5', '3', '0', '3', '3', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '34912', '2080', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000576', '4', '2', '2', '0', '0', '6', '0', '0', '2', '0', '0', '1', '1', '2', '0', '32', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000577', '22', '2', '7', '0', '0', '1', '0', '0', '5', '1', '4', '3', '2', '0', '0', '1', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '923041', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000578', '5', '2', '4', '0', '0', '7', '0', '0', '1', '0', '0', '4', '1', '1', '0', '28', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '6147', '6144', '6145', '6147', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000579', '9', '2', '4', '0', '0', '1', '0', '0', '5', '0', '4', '0', '1', '2', '3', '72', '65', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '6146', '6147', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000580', '2', '2', '9', '0', '0', '2', '0', '0', '5', '0', '2', '4', '1', '2', '3', '2', '14', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '6176', '15392', '6177', '6176', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000581', '9', '2', '4', '0', '0', '3', '0', '0', '0', '0', '4', '1', '3', '3', '1', '69', '65', '66', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '6146', '6147', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000582', '1', '2', '7', '0', '0', '8', '0', '0', '0', '1', '4', '2', '3', '0', '1', '23', '14', '13', '0', '147852300', '0', '0', '0', '0', '0', '0', '8292', '15585', '8960', '8579', '21860', '219136', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000583', '6', '2', '4', '0', '0', '1', '0', '0', '1', '1', '2', '1', '2', '1', '3', '1', '10', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000584', '4', '2', '4', '0', '0', '5', '0', '0', '3', '1', '3', '3', '3', '2', '1', '52', '61', '65', '0', '294650940', '0', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000585', '8', '2', '7', '0', '0', '4', '0', '0', '4', '0', '4', '3', '1', '0', '0', '12', '12', '7', '0', '168822794', '0', '0', '0', '0', '0', '0', '12739', '12803', '7424', '14656', '13667', '247808', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000586', '3', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '2', '3', '0', '1', '4', '9', '11', '0', '79698946', '32515082', '0', '0', '0', '0', '0', '3296', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000587', '2', '1', '8', '0', '0', '2', '0', '0', '5', '1', '5', '2', '2', '2', '1', '15', '9', '2', '0', '210765827', '236979210', '0', '0', '0', '0', '0', '0', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000588', '1', '3', '1', '0', '0', '8', '0', '0', '4', '0', '4', '2', '3', '0', '0', '23', '4', '5', '0', '210764850', '236979210', '0', '0', '0', '0', '0', '9440', '9472', '9472', '9312', '9345', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000589', '3', '2', '2', '0', '0', '7', '0', '0', '2', '0', '0', '4', '0', '0', '1', '9', '5', '4', '0', '80741388', '32515112', '0', '0', '0', '0', '0', '14496', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000590', '21', '2', '0', '0', '0', '41', '0', '0', '5', '1', '4', '5', '2', '2', '2', '9', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '3780', '3968', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000591', '1', '3', '1', '0', '0', '1', '0', '0', '3', '1', '0', '4', '1', '0', '0', '19', '15', '1', '0', '210764840', '236979210', '0', '0', '0', '0', '0', '9505', '9795', '9760', '9345', '13475', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000592', '1', '3', '5', '0', '0', '1', '0', '0', '5', '1', '2', '1', '2', '0', '0', '1', '8', '14', '0', '705692712', '0', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000593', '2', '2', '7', '0', '0', '5', '4', '0', '2', '1', '1', '1', '1', '1', '3', '9', '5', '12', '0', '705692693', '0', '0', '0', '0', '0', '0', '0', '2147', '7265', '2083', '9313', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000594', '8', '2', '8', '0', '0', '3', '0', '0', '5', '0', '1', '4', '1', '1', '1', '4', '15', '11', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000595', '1', '2', '6', '0', '0', '2', '0', '0', '5', '0', '5', '4', '2', '1', '1', '31', '6', '3', '0', '878708737', '0', '0', '0', '0', '0', '0', '23885', '6336', '2208', '6304', '9572', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000596', '3', '2', '7', '0', '0', '1', '9', '0', '4', '1', '2', '1', '2', '0', '0', '65', '63', '59', '0', '705692712', '0', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000597', '3', '2', '5', '0', '0', '7', '0', '0', '5', '1', '2', '3', '1', '3', '3', '18', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '25632', '4128', '4128', '10240', '4160', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000598', '9', '4', '4', '0', '0', '1', '0', '0', '0', '1', '2', '2', '3', '0', '3', '58', '62', '60', '0', '347079691', '0', '0', '0', '0', '0', '0', '0', '29956', '2146', '1024', '4388', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000599', '8', '3', '2', '0', '0', '3', '0', '0', '0', '0', '2', '2', '0', '1', '0', '12', '6', '11', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '1600', '14402', '21635', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000600', '8', '3', '2', '0', '0', '3', '0', '0', '0', '0', '2', '2', '0', '1', '0', '12', '6', '11', '0', '168821800', '0', '0', '0', '0', '0', '0', '0', '12417', '7297', '14467', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000601', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '79698946', '32508928', '0', '0', '0', '0', '0', '0', '3105', '3265', '11460', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000602', '5', '0', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31905', '4096', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000603', '9', '4', '1', '0', '0', '1', '0', '0', '5', '0', '4', '3', '1', '0', '2', '76', '63', '62', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000604', '6', '1', '4', '0', '0', '4', '0', '0', '3', '0', '3', '2', '1', '3', '1', '70', '61', '53', '0', '0', '0', '0', '0', '0', '0', '0', '5441', '5379', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000605', '6', '2', '1', '0', '0', '3', '0', '0', '1', '1', '3', '4', '2', '1', '0', '73', '62', '56', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29771', '5217', '10528', '4198', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000606', '7', '1', '4', '0', '0', '1', '4', '0', '3', '0', '3', '0', '3', '2', '0', '14', '2', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '31968', '2208', '10368', '8257', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000607', '6', '2', '1', '0', '0', '6', '0', '0', '3', '1', '2', '5', '3', '2', '1', '14', '6', '7', '0', '310379560', '0', '0', '0', '0', '0', '0', '20485', '7234', '1024', '1024', '25666', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000608', '10508', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000609', '10023', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000610', '10508', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000611', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000612', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000613', '7', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1057', '10274', '5155', '8257', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000614', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1057', '10274', '5155', '8257', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000615', '8', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1057', '10274', '5155', '8257', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000616', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1377', '10274', '5155', '8257', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000617', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '51', '58', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1057', '10274', '5155', '8257', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000618', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4132', '4132', '2116', '5120', '4195', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000619', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000620', '5', '2', '1', '0', '0', '5', '0', '0', '1', '0', '2', '5', '0', '0', '3', '22', '13', '3', '0', '383779840', '0', '0', '0', '0', '0', '0', '20544', '34880', '3108', '2048', '8224', '197632', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000621', '1', '2', '1', '0', '0', '1', '0', '0', '4', '0', '3', '4', '1', '2', '3', '28', '9', '12', '0', '717227010', '0', '0', '0', '0', '0', '0', '23597', '32838', '16480', '11360', '6213', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000622', '2', '2', '1', '0', '0', '5', '0', '0', '4', '0', '4', '0', '1', '3', '2', '4', '14', '15', '0', '717227009', '716178432', '0', '0', '0', '0', '0', '9378', '2147', '7265', '2083', '9313', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000623', '5', '2', '4', '0', '0', '5', '0', '0', '5', '0', '3', '4', '1', '1', '1', '3', '5', '13', '0', '717227010', '716178432', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000624', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '16', '0', '944811008', '0', '0', '0', '0', '0', '0', '1728', '1728', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000625', '6', '2', '4', '0', '0', '7', '0', '0', '4', '1', '5', '0', '0', '3', '0', '55', '57', '52', '0', '210765827', '236979210', '0', '0', '0', '231736330', '0', '9696', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000626', '1', '2', '7', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '2', '7', '0', '210764840', '0', '0', '0', '0', '0', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000627', '7', '2', '2', '0', '0', '1', '0', '0', '2', '1', '5', '4', '3', '2', '3', '2', '5', '10', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000628', '3', '2', '2', '0', '0', '7', '0', '0', '3', '1', '3', '0', '2', '3', '2', '25', '11', '14', '0', '0', '0', '0', '0', '0', '0', '0', '9664', '7712', '2144', '5280', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000629', '9', '2', '5', '0', '0', '3', '0', '0', '3', '0', '0', '1', '1', '0', '2', '69', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '6147', '6144', '6145', '6147', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000630', '1', '2', '7', '0', '0', '7', '9', '0', '2', '0', '3', '0', '3', '0', '1', '20', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000631', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '3', '5', '0', '2', '2', '25', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000632', '2', '2', '9', '0', '0', '3', '0', '0', '5', '1', '2', '0', '0', '3', '1', '3', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '5411', '10467', '10402', '1024', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000633', '7', '2', '8', '0', '0', '4', '0', '0', '5', '1', '4', '1', '2', '0', '2', '11', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '9792', '2240', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000634', '2', '2', '6', '0', '0', '5', '0', '0', '4', '0', '4', '1', '2', '0', '3', '3', '5', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '34880', '1024', '10240', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000635', '9', '2', '1', '0', '0', '2', '0', '0', '5', '1', '1', '4', '0', '2', '2', '76', '56', '63', '0', '0', '0', '0', '0', '0', '0', '0', '5440', '4384', '5345', '5152', '10528', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000636', '5', '2', '4', '0', '0', '3', '0', '0', '1', '0', '4', '4', '3', '2', '2', '10', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '4288', '9760', '5408', '10530', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000637', '9', '2', '5', '0', '0', '2', '0', '0', '5', '0', '5', '1', '3', '0', '1', '75', '53', '63', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000638', '5', '2', '4', '0', '0', '7', '0', '0', '3', '1', '5', '3', '3', '0', '0', '3', '7', '11', '0', '752878613', '753927168', '0', '0', '0', '0', '0', '20640', '2208', '5312', '5152', '10530', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000639', '2', '2', '2', '0', '0', '3', '0', '0', '3', '1', '1', '1', '1', '2', '0', '6', '8', '2', '0', '944781312', '0', '0', '0', '0', '0', '0', '4417', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000640', '3', '2', '2', '0', '0', '3', '0', '0', '1', '1', '5', '4', '1', '1', '2', '29', '3', '10', '0', '944803840', '0', '0', '0', '0', '0', '0', '5440', '4384', '5345', '5152', '10528', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000641', '8', '2', '5', '0', '0', '6', '0', '0', '5', '0', '0', '2', '3', '3', '3', '82', '58', '53', '0', '944805888', '944804864', '0', '0', '0', '0', '0', '23584', '34880', '1024', '10240', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000642', '7', '2', '4', '0', '0', '6', '0', '0', '2', '1', '0', '3', '0', '2', '2', '72', '52', '52', '0', '0', '0', '0', '0', '950010880', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000643', '6', '2', '2', '0', '0', '4', '0', '0', '0', '0', '4', '3', '1', '0', '3', '53', '65', '63', '0', '0', '944776192', '0', '0', '0', '0', '0', '23584', '34880', '1024', '10240', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000644', '7', '2', '8', '0', '0', '4', '0', '0', '4', '0', '2', '5', '1', '0', '0', '22', '4', '2', '0', '944797696', '0', '0', '0', '0', '0', '0', '0', '35204', '5190', '1024', '4288', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000645', '2', '2', '1', '0', '0', '2', '0', '0', '1', '0', '4', '3', '2', '2', '2', '26', '8', '1', '0', '944792576', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000646', '8', '2', '8', '0', '0', '6', '0', '0', '2', '0', '1', '4', '1', '2', '1', '68', '65', '62', '0', '954205184', '954206208', '0', '0', '0', '0', '0', '0', '4418', '7298', '1024', '9474', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000647', '7', '2', '8', '0', '0', '2', '0', '0', '3', '0', '2', '0', '2', '3', '0', '57', '56', '63', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000648', '5', '2', '4', '0', '0', '4', '0', '0', '5', '0', '5', '0', '3', '3', '3', '61', '59', '57', '0', '294650900', '0', '0', '0', '0', '0', '0', '0', '29923', '9792', '2240', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000649', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '5', '3', '2', '0', '1', '27', '15', '4', '0', '0', '945816576', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000650', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '5', '0', '294650892', '0', '0', '0', '0', '0', '0', '0', '29773', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000651', '6', '2', '1', '0', '0', '8', '0', '0', '0', '1', '3', '1', '3', '2', '2', '52', '58', '53', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '5411', '10528', '10403', '10464', '25665', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000652', '6', '2', '1', '0', '0', '4', '0', '0', '4', '1', '1', '3', '3', '0', '2', '54', '63', '62', '0', '0', '953160704', '0', '0', '953160704', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000653', '8', '2', '8', '0', '0', '6', '0', '0', '2', '1', '3', '5', '0', '1', '3', '81', '55', '59', '0', '0', '0', '0', '0', '0', '0', '0', '11328', '1153', '1728', '5347', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000654', '5', '2', '1', '0', '0', '4', '0', '0', '0', '1', '1', '0', '1', '0', '1', '81', '51', '58', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000655', '1', '2', '1', '0', '0', '2', '0', '0', '2', '1', '4', '5', '1', '3', '1', '9', '4', '6', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000656', '2', '2', '9', '0', '0', '1', '0', '0', '4', '0', '0', '1', '1', '2', '2', '5', '10', '13', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000657', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '3', '0', '3', '1', '3', '5', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000658', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '5', '5', '2', '0', '3', '80', '54', '63', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29793', '2121', '1024', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000659', '1', '2', '3', '0', '0', '1', '0', '0', '3', '0', '5', '1', '0', '1', '1', '16', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000660', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '8', '7', '0', '944788480', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000661', '4', '2', '6', '0', '0', '1', '0', '0', '5', '0', '1', '0', '2', '3', '2', '5', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16418', '5188', '1024', '5152', '339968', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000662', '7', '2', '8', '0', '0', '5', '0', '0', '1', '1', '2', '2', '1', '3', '2', '24', '15', '14', '0', '894437416', '0', '0', '0', '0', '0', '0', '21698', '6592', '6433', '25730', '25760', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000663', '1', '2', '3', '0', '0', '1', '0', '0', '1', '1', '0', '4', '1', '3', '3', '21', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31905', '2116', '5188', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000664', '7', '2', '3', '0', '0', '8', '0', '0', '3', '1', '5', '5', '0', '2', '3', '18', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '23597', '31905', '2116', '5188', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000665', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '2', '2', '0', '0', '945816576', '0', '0', '0', '0', '0', '20480', '33920', '7236', '1024', '1059', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000666', '6', '2', '2', '0', '0', '1', '0', '0', '3', '1', '4', '2', '1', '0', '2', '8', '16', '6', '0', '944787456', '79693824', '0', '0', '944769024', '0', '0', '17473', '10433', '10402', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000667', '5', '2', '2', '0', '0', '2', '0', '0', '5', '1', '1', '5', '0', '1', '2', '52', '57', '66', '0', '944771072', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000668', '8', '2', '8', '0', '0', '4', '0', '0', '5', '0', '5', '3', '0', '1', '0', '7', '13', '10', '0', '944773120', '0', '0', '0', '0', '0', '0', '5120', '33892', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000669', '5', '2', '2', '0', '0', '6', '0', '0', '0', '0', '2', '4', '1', '1', '3', '72', '55', '56', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000670', '6', '2', '3', '0', '0', '8', '0', '0', '2', '1', '3', '5', '0', '2', '3', '68', '55', '57', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000671', '3', '2', '8', '0', '0', '7', '0', '0', '1', '0', '2', '0', '0', '2', '2', '27', '3', '9', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000672', '7', '2', '1', '0', '0', '7', '0', '0', '4', '1', '4', '3', '3', '0', '3', '60', '56', '54', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000673', '5', '2', '1', '0', '0', '8', '0', '0', '0', '1', '4', '5', '1', '0', '2', '73', '56', '53', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000674', '8', '2', '7', '0', '0', '4', '0', '0', '0', '0', '4', '2', '1', '3', '2', '15', '13', '15', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000675', '4', '2', '8', '0', '0', '6', '0', '0', '5', '0', '0', '4', '2', '3', '3', '8', '1', '1', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000676', '5', '2', '1', '0', '0', '1', '0', '0', '5', '0', '5', '0', '2', '1', '2', '28', '3', '9', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000677', '1', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '3', '2', '3', '29', '1', '2', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000678', '7', '2', '4', '0', '0', '3', '0', '0', '1', '1', '4', '2', '2', '3', '0', '53', '56', '58', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000679', '21', '1', '2', '0', '0', '1', '0', '0', '4', '0', '0', '3', '2', '0', '0', '4', '14', '3', '0', '347081758', '0', '0', '0', '0', '0', '0', '0', '1921', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000680', '2', '2', '8', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '12', '0', '168821810', '0', '0', '0', '0', '0', '0', '19470', '12802', '8384', '14656', '13665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000681', '2', '3', '3', '1', '0', '1', '0', '0', '2', '0', '0', '5', '1', '2', '3', '23', '10', '6', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '1216', '14402', '21635', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000682', '1', '2', '6', '0', '0', '7', '0', '0', '5', '1', '4', '5', '0', '3', '3', '21', '15', '10', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000683', '2', '2', '5', '0', '0', '3', '0', '0', '4', '1', '0', '0', '3', '1', '3', '20', '11', '11', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '9472', '14467', '9379', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000684', '2', '2', '6', '0', '0', '3', '0', '0', '0', '1', '3', '0', '2', '3', '0', '11', '15', '7', '0', '210765837', '236979210', '0', '0', '0', '0', '0', '9696', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000685', '1', '4', '5', '0', '0', '1', '0', '0', '0', '1', '1', '3', '0', '3', '2', '21', '15', '5', '0', '168821810', '0', '0', '0', '0', '0', '0', '19499', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000686', '8', '2', '6', '0', '0', '5', '0', '0', '3', '1', '5', '0', '1', '2', '1', '77', '62', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16480', '5188', '1024', '5154', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000687', '3', '2', '2', '0', '0', '4', '0', '0', '5', '1', '0', '4', '2', '2', '1', '25', '12', '1', '0', '862980116', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000688', '5', '2', '2', '0', '0', '3', '0', '0', '0', '1', '1', '0', '0', '3', '2', '21', '9', '7', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000689', '5', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '5', '1', '2', '1', '61', '51', '56', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000690', '7', '3', '1', '0', '0', '4', '0', '0', '2', '1', '5', '0', '0', '3', '3', '21', '5', '7', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000691', '5', '1', '4', '0', '0', '5', '0', '0', '2', '0', '4', '5', '1', '1', '2', '17', '1', '11', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000692', '6', '2', '4', '0', '0', '6', '0', '0', '1', '1', '0', '1', '3', '0', '1', '31', '4', '5', '0', '862980096', '0', '0', '0', '0', '0', '0', '25728', '1376', '6147', '6147', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000693', '6', '2', '2', '0', '0', '6', '0', '0', '4', '1', '3', '2', '3', '3', '1', '17', '9', '9', '0', '862980096', '0', '0', '0', '0', '0', '0', '25728', '1376', '6147', '6147', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000694', '3', '2', '8', '0', '0', '3', '0', '0', '1', '0', '3', '0', '2', '0', '0', '12', '14', '9', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '6433', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000695', '1', '2', '6', '0', '0', '8', '0', '0', '0', '0', '4', '0', '3', '3', '3', '16', '3', '8', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '1124', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000696', '7', '2', '2', '0', '0', '1', '0', '0', '3', '1', '3', '3', '1', '3', '3', '4', '8', '7', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '6433', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000697', '4', '2', '6', '0', '0', '8', '0', '0', '0', '0', '4', '4', '3', '2', '0', '17', '10', '10', '0', '862981120', '0', '0', '0', '0', '0', '0', '23852', '6242', '1344', '6145', '6217', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000698', '4', '2', '8', '0', '0', '7', '0', '0', '5', '0', '2', '3', '3', '1', '1', '62', '57', '65', '0', '862981120', '0', '0', '0', '0', '0', '0', '23852', '6242', '1344', '6145', '6217', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000699', '8', '2', '8', '0', '0', '3', '0', '0', '4', '0', '5', '0', '2', '3', '1', '7', '7', '1', '0', '862980116', '0', '0', '0', '0', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000700', '7', '2', '4', '0', '0', '8', '0', '0', '3', '1', '3', '5', '0', '1', '0', '5', '3', '8', '0', '705692722', '0', '0', '0', '0', '0', '0', '9378', '2147', '9536', '5217', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000701', '5', '2', '3', '0', '0', '6', '0', '0', '2', '1', '0', '0', '3', '1', '2', '82', '57', '59', '0', '705692722', '0', '0', '0', '0', '0', '0', '9378', '2147', '9536', '5217', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000702', '2', '2', '6', '0', '0', '1', '0', '0', '5', '1', '0', '4', '0', '0', '2', '31', '5', '13', '0', '878707712', '0', '0', '0', '0', '0', '0', '5152', '6176', '15392', '6177', '6176', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000703', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '1', '0', '0', '1', '1', '1', '6', '5', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9602', '4164', '11329', '21537', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000704', '4', '2', '2', '0', '0', '8', '0', '0', '3', '1', '0', '5', '0', '0', '1', '26', '7', '7', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000705', '8', '0', '3', '0', '0', '1', '0', '0', '0', '1', '5', '4', '3', '1', '3', '31', '8', '13', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000706', '6', '4', '4', '0', '0', '6', '0', '0', '2', '0', '0', '0', '1', '3', '0', '30', '14', '9', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000707', '7', '2', '7', '0', '0', '5', '0', '0', '1', '0', '5', '1', '0', '1', '0', '17', '7', '15', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000708', '1', '0', '4', '0', '0', '7', '0', '0', '1', '0', '1', '2', '2', '3', '2', '24', '7', '13', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000709', '3', '2', '6', '0', '0', '6', '0', '0', '1', '0', '1', '4', '3', '2', '2', '59', '57', '62', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000710', '3', '2', '5', '0', '0', '8', '0', '0', '1', '1', '2', '4', '0', '0', '3', '22', '12', '2', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000711', '1', '2', '4', '0', '0', '1', '0', '0', '1', '1', '3', '5', '3', '0', '3', '12', '10', '6', '0', '721421333', '0', '0', '0', '0', '0', '0', '21537', '32836', '2112', '2114', '2081', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000712', '2', '2', '1', '0', '0', '1', '0', '0', '2', '1', '0', '4', '0', '2', '1', '17', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23598', '2305', '2210', '2272', '25824', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000713', '3', '2', '6', '0', '0', '7', '0', '0', '5', '1', '2', '0', '2', '0', '3', '28', '10', '9', '0', '721421325', '0', '0', '0', '0', '0', '0', '23596', '2304', '2240', '2272', '9603', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000714', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '5', '3', '0', '3', '0', '2', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11328', '1473', '1728', '5347', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000715', '6', '2', '4', '0', '0', '2', '0', '0', '3', '1', '0', '5', '2', '1', '2', '14', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000716', '5', '2', '3', '0', '0', '7', '0', '0', '1', '0', '0', '4', '3', '0', '0', '18', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '32771', '4131', '6145', '6145', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000717', '5', '2', '4', '0', '0', '6', '0', '0', '4', '1', '5', '1', '3', '1', '0', '62', '51', '55', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000718', '7', '2', '2', '0', '0', '3', '0', '0', '5', '1', '3', '1', '3', '2', '0', '65', '57', '64', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000719', '8', '2', '5', '0', '0', '2', '0', '0', '4', '0', '0', '0', '3', '0', '3', '25', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '11328', '1153', '1728', '5347', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000720', '8', '2', '5', '0', '0', '2', '0', '0', '2', '0', '3', '4', '3', '1', '1', '32', '8', '16', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1152', '1760', '25600', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000721', '1', '2', '6', '0', '0', '2', '0', '0', '5', '1', '0', '2', '1', '0', '3', '4', '9', '15', '0', '737150979', '0', '0', '0', '0', '0', '0', '23880', '1024', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000722', '2', '2', '3', '0', '0', '5', '0', '0', '1', '1', '3', '4', '3', '0', '2', '14', '16', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23554', '32800', '2050', '5122', '2272', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000723', '3', '2', '8', '0', '0', '7', '0', '0', '5', '0', '4', '3', '1', '1', '0', '21', '7', '14', '0', '737149954', '0', '0', '0', '0', '0', '0', '23595', '32833', '9376', '10338', '2082', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000724', '4', '2', '2', '0', '0', '4', '0', '0', '1', '0', '5', '2', '0', '1', '3', '32', '14', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11338', '10497', '1664', '25600', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000725', '6', '2', '4', '0', '0', '2', '0', '0', '3', '1', '0', '5', '2', '1', '2', '14', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000726', '5', '2', '3', '0', '0', '3', '0', '0', '5', '0', '4', '1', '0', '2', '3', '23', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '22658', '32866', '9696', '5440', '9538', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000727', '5', '2', '2', '0', '0', '6', '0', '0', '3', '0', '3', '5', '1', '2', '3', '79', '60', '52', '0', '0', '0', '0', '0', '0', '0', '0', '23880', '2240', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000728', '7', '2', '1', '0', '0', '1', '0', '0', '2', '0', '3', '4', '0', '2', '3', '4', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000729', '8', '2', '3', '0', '0', '3', '1', '0', '2', '1', '5', '3', '1', '2', '0', '20', '15', '9', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1152', '1760', '25600', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000730', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '3', '0', '1', '0', '3', '7', '16', '9', '0', '0', '0', '0', '0', '0', '0', '0', '11328', '1153', '1728', '5347', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000731', '1', '2', '4', '0', '0', '8', '9', '0', '4', '1', '5', '3', '1', '2', '1', '20', '15', '1', '0', '168821790', '0', '0', '0', '0', '0', '0', '19503', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000732', '1', '2', '3', '0', '0', '1', '0', '0', '4', '1', '4', '2', '1', '3', '1', '10', '13', '5', '0', '210764840', '236979210', '0', '0', '0', '0', '0', '9505', '9795', '9760', '9345', '13475', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000733', '1', '2', '5', '0', '0', '7', '0', '0', '3', '1', '5', '4', '2', '3', '3', '29', '14', '6', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000734', '3', '2', '5', '0', '0', '5', '0', '0', '5', '0', '0', '2', '2', '3', '2', '81', '65', '58', '0', '210764840', '236979210', '0', '0', '0', '0', '0', '9505', '9795', '9760', '9345', '13475', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000735', '7', '2', '5', '0', '0', '5', '0', '0', '0', '1', '3', '1', '1', '0', '0', '13', '14', '6', '0', '0', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000736', '4', '2', '4', '0', '0', '4', '0', '0', '4', '1', '5', '4', '2', '0', '0', '20', '14', '6', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000737', '2', '2', '9', '0', '0', '3', '0', '0', '1', '1', '1', '4', '1', '1', '0', '8', '11', '11', '0', '331351052', '0', '0', '0', '0', '0', '0', '11339', '7587', '3107', '5282', '4288', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000738', '3', '2', '2', '0', '0', '8', '0', '0', '0', '1', '1', '3', '3', '3', '3', '5', '15', '15', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000739', '3', '2', '2', '0', '0', '7', '0', '0', '1', '1', '0', '3', '0', '0', '0', '14', '3', '16', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000740', '3', '2', '7', '0', '0', '8', '0', '0', '0', '1', '1', '1', '2', '0', '1', '24', '13', '13', '0', '347079711', '0', '0', '0', '0', '0', '0', '9664', '7712', '2144', '5280', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000741', '5', '2', '1', '0', '0', '4', '0', '0', '4', '1', '0', '4', '2', '1', '2', '67', '62', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000742', '2', '1', '2', '0', '0', '5', '0', '0', '5', '0', '5', '0', '2', '3', '2', '29', '7', '1', '0', '331351052', '0', '0', '0', '0', '0', '0', '11339', '7587', '3107', '5282', '4288', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000743', '3', '2', '1', '0', '0', '8', '0', '0', '1', '0', '3', '2', '1', '0', '3', '15', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000744', '7', '2', '7', '0', '0', '4', '0', '0', '3', '0', '2', '3', '1', '0', '1', '4', '14', '15', '0', '168821790', '0', '0', '0', '0', '0', '0', '19503', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000745', '8', '2', '1', '0', '0', '1', '0', '0', '2', '0', '3', '0', '3', '3', '0', '25', '7', '11', '0', '210766898', '236979210', '0', '0', '0', '0', '0', '16580', '14593', '4352', '5411', '6307', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000746', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '2', '2', '0', '2', '1', '10', '14', '7', '0', '210767912', '236979210', '0', '0', '0', '0', '0', '14499', '14656', '4288', '14658', '9504', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000747', '6', '2', '2', '0', '0', '6', '0', '0', '4', '0', '4', '1', '3', '2', '1', '11', '6', '7', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000748', '8', '2', '6', '0', '0', '4', '0', '0', '5', '0', '3', '3', '2', '1', '0', '26', '12', '5', '0', '331351052', '0', '0', '0', '0', '0', '0', '11339', '7587', '3107', '5282', '4288', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000749', '3', '2', '8', '0', '0', '7', '0', '0', '4', '1', '2', '2', '1', '0', '1', '30', '1', '5', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000750', '1', '2', '2', '0', '0', '1', '0', '0', '1', '1', '0', '1', '3', '2', '1', '12', '9', '13', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000751', '3', '2', '6', '0', '0', '2', '0', '0', '3', '0', '3', '0', '0', '1', '1', '60', '54', '55', '0', '331351050', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000752', '8', '2', '3', '0', '0', '6', '0', '0', '2', '1', '5', '4', '0', '2', '2', '82', '57', '52', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000753', '3', '2', '8', '0', '0', '7', '0', '0', '5', '1', '3', '1', '0', '2', '1', '19', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000754', '1', '2', '6', '0', '0', '1', '0', '0', '3', '1', '2', '5', '0', '0', '1', '24', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000755', '7', '2', '4', '0', '0', '5', '0', '0', '0', '0', '5', '0', '3', '3', '1', '6', '5', '8', '0', '705692683', '0', '0', '0', '0', '0', '0', '0', '1058', '6145', '9251', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000756', '3', '2', '6', '0', '0', '8', '0', '0', '1', '0', '2', '0', '1', '2', '3', '15', '13', '14', '0', '768607243', '0', '0', '0', '0', '0', '0', '23585', '31875', '2113', '11360', '25697', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000757', '4', '2', '2', '0', '0', '6', '0', '0', '4', '1', '2', '5', '2', '2', '0', '20', '10', '1', '0', '168823818', '0', '0', '0', '0', '0', '0', '23585', '13472', '3074', '13344', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000758', '3', '2', '4', '0', '0', '8', '0', '0', '4', '0', '4', '2', '0', '3', '3', '7', '6', '8', '0', '210767873', '236979210', '0', '0', '0', '0', '0', '19460', '9760', '9280', '14595', '13505', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000759', '8', '2', '1', '0', '0', '1', '0', '0', '2', '0', '3', '4', '1', '1', '0', '28', '8', '16', '0', '210766898', '236979210', '0', '0', '0', '0', '0', '19461', '14593', '4352', '5411', '6307', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000760', '7', '2', '2', '0', '0', '1', '0', '0', '1', '1', '3', '0', '1', '3', '0', '13', '3', '16', '0', '168821800', '0', '0', '0', '0', '0', '0', '19499', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000761', '2', '2', '3', '0', '0', '2', '0', '0', '1', '0', '2', '5', '1', '3', '0', '14', '9', '15', '0', '243270657', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000762', '2', '2', '4', '0', '0', '3', '0', '0', '3', '0', '4', '1', '1', '2', '1', '26', '12', '15', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000763', '1', '2', '3', '0', '0', '1', '0', '0', '1', '0', '3', '0', '0', '1', '1', '15', '8', '13', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000764', '6', '2', '3', '0', '0', '1', '0', '0', '3', '1', '1', '4', '0', '0', '2', '32', '5', '15', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000765', '7', '2', '8', '0', '0', '5', '0', '0', '4', '0', '5', '3', '3', '2', '2', '19', '10', '10', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000766', '3', '2', '2', '0', '0', '4', '0', '0', '1', '1', '2', '2', '3', '0', '0', '23', '13', '12', '0', '0', '0', '0', '0', '0', '0', '0', '23619', '1122', '8416', '10336', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000767', '21', '2', '0', '0', '0', '31', '0', '0', '1', '1', '0', '4', '2', '0', '0', '13', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6976', '7136', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000768', '2', '2', '2', '0', '0', '3', '0', '0', '5', '0', '2', '2', '1', '2', '0', '13', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10434', '7651', '5312', '1024', '5443', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000769', '2', '2', '3', '0', '0', '2', '0', '0', '5', '0', '4', '2', '2', '1', '0', '10', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '9280', '9252', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000770', '1', '2', '1', '0', '0', '8', '0', '0', '2', '1', '4', '4', '3', '1', '1', '21', '9', '13', '0', '0', '0', '0', '0', '0', '0', '0', '9474', '9410', '4160', '9287', '6217', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000771', '3', '2', '5', '0', '0', '8', '0', '0', '5', '1', '2', '0', '3', '0', '2', '7', '8', '2', '0', '168822785', '0', '0', '0', '0', '0', '0', '4224', '13536', '7296', '14467', '10336', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000772', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '3', '3', '0', '0', '3', '9', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '6244', '2119', '1024', '4160', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000773', '5', '2', '4', '0', '0', '5', '0', '0', '2', '1', '4', '2', '2', '2', '1', '4', '2', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000774', '7', '2', '7', '0', '0', '1', '0', '0', '3', '1', '4', '4', '1', '0', '3', '24', '8', '7', '0', '862980096', '0', '0', '0', '0', '0', '0', '21664', '1058', '2081', '6145', '6145', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000775', '1', '2', '1', '0', '0', '8', '0', '0', '3', '0', '4', '1', '3', '1', '0', '4', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000776', '8', '2', '3', '0', '0', '2', '0', '0', '0', '0', '4', '0', '2', '1', '3', '29', '6', '5', '0', '243270657', '0', '0', '0', '0', '0', '0', '16423', '2146', '16738', '9282', '4160', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000777', '8', '2', '1', '0', '0', '4', '0', '0', '5', '0', '3', '4', '3', '1', '3', '21', '2', '13', '0', '147853312', '0', '0', '0', '0', '0', '0', '23852', '8323', '4173', '5218', '21646', '186368', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000778', '7', '2', '9', '0', '0', '1', '0', '0', '2', '0', '1', '0', '2', '3', '3', '31', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '4226', '5199', '5252', '10272', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000779', '1', '2', '1', '0', '0', '7', '0', '0', '4', '0', '0', '2', '0', '0', '3', '17', '5', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '2148', '16516', '9284', '4288', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000780', '2', '2', '7', '0', '0', '5', '0', '0', '0', '0', '4', '1', '2', '0', '3', '24', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23686', '8577', '8928', '8577', '21826', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000781', '8', '2', '5', '0', '0', '1', '0', '0', '0', '1', '4', '1', '1', '2', '3', '4', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '21698', '6560', '16609', '6432', '25732', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000782', '1', '2', '6', '0', '0', '7', '0', '0', '4', '0', '0', '4', '0', '2', '1', '10', '13', '5', '0', '815795200', '0', '0', '0', '0', '0', '0', '23845', '7424', '4224', '1024', '25792', '339968', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000783', '2', '2', '8', '0', '0', '1', '0', '0', '1', '1', '4', '3', '0', '0', '2', '29', '2', '14', '0', '721421382', '0', '0', '0', '0', '0', '0', '21577', '31937', '9856', '2240', '25792', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000784', '7', '2', '3', '0', '0', '8', '0', '0', '2', '0', '2', '4', '3', '0', '0', '1', '9', '6', '0', '168822815', '0', '0', '0', '0', '0', '0', '12740', '12705', '7394', '14658', '13664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000785', '7', '2', '6', '0', '0', '5', '0', '0', '5', '1', '5', '3', '1', '1', '3', '13', '12', '8', '0', '210765844', '236979210', '0', '0', '0', '0', '0', '14373', '14658', '9888', '14658', '13696', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000786', '8', '2', '7', '0', '0', '7', '0', '0', '4', '0', '0', '0', '3', '2', '0', '57', '59', '53', '0', '347079687', '0', '0', '0', '0', '0', '0', '5569', '7651', '7395', '5347', '10529', '146432', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000787', '4', '2', '2', '0', '0', '8', '0', '0', '0', '0', '4', '0', '3', '0', '1', '19', '2', '6', '0', '705692742', '0', '0', '0', '0', '0', '0', '21698', '10466', '6368', '11363', '6372', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000788', '2', '2', '2', '0', '0', '3', '0', '0', '1', '0', '1', '5', '0', '2', '3', '32', '2', '5', '0', '768610324', '0', '0', '0', '0', '0', '0', '0', '2304', '2210', '6340', '9571', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000789', '9', '2', '1', '0', '0', '2', '0', '0', '4', '1', '3', '4', '2', '1', '2', '75', '57', '60', '0', '878707724', '0', '0', '0', '0', '0', '0', '6275', '4356', '4224', '6340', '6434', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000790', '5', '2', '4', '0', '0', '8', '0', '0', '4', '1', '0', '0', '2', '3', '3', '60', '51', '62', '0', '79692800', '32507904', '0', '0', '0', '0', '0', '0', '8192', '4128', '11264', '15360', '133120', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000791', '3', '2', '1', '0', '0', '3', '0', '0', '4', '0', '2', '5', '3', '0', '3', '23', '7', '5', '0', '784335882', '0', '0', '0', '0', '0', '0', '5216', '33956', '3149', '5184', '10336', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000792', '3', '2', '5', '0', '0', '8', '0', '0', '5', '1', '1', '3', '1', '2', '3', '19', '4', '1', '0', '862981120', '0', '0', '0', '0', '0', '0', '25740', '32867', '2112', '1024', '4161', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000793', '1', '2', '7', '0', '0', '1', '0', '0', '0', '1', '1', '2', '0', '2', '2', '2', '5', '3', '0', '0', '0', '0', '0', '0', '0', '0', '11289', '7232', '4167', '1024', '8259', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000794', '4', '2', '3', '0', '0', '5', '0', '0', '4', '0', '2', '0', '1', '1', '2', '58', '63', '55', '0', '800064522', '0', '0', '0', '0', '0', '0', '7169', '7169', '4128', '6180', '5152', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000795', '6', '2', '2', '0', '0', '1', '0', '0', '2', '0', '4', '1', '3', '1', '2', '11', '2', '9', '0', '800064512', '0', '0', '0', '0', '0', '0', '11269', '5156', '4097', '6180', '5153', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000796', '4', '2', '8', '0', '0', '4', '0', '0', '0', '1', '1', '1', '0', '1', '3', '23', '15', '13', '0', '58722324', '59770900', '0', '0', '0', '0', '0', '10283', '29766', '10272', '10466', '4193', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000797', '8', '2', '8', '0', '0', '4', '0', '0', '3', '1', '2', '1', '3', '2', '3', '11', '13', '7', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000798', '2', '2', '8', '0', '0', '1', '0', '0', '1', '1', '5', '5', '0', '1', '1', '12', '1', '1', '0', '780141568', '0', '0', '0', '0', '0', '0', '25739', '9378', '5184', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000799', '6', '2', '4', '0', '0', '7', '0', '0', '0', '1', '0', '1', '0', '1', '3', '61', '56', '60', '0', '780141568', '0', '0', '0', '0', '0', '0', '0', '2148', '5191', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000800', '9', '2', '1', '0', '0', '3', '0', '0', '4', '1', '3', '0', '3', '0', '0', '58', '59', '60', '0', '784335882', '0', '0', '0', '0', '0', '0', '5216', '33956', '3149', '5184', '10336', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000801', '5', '2', '3', '0', '0', '6', '0', '0', '5', '1', '4', '3', '2', '3', '1', '67', '57', '52', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000802', '5', '2', '2', '0', '0', '5', '0', '0', '3', '0', '4', '0', '2', '1', '0', '3', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '7203', '9376', '10306', '10337', '5184', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000803', '9', '2', '4', '0', '0', '1', '0', '0', '1', '0', '4', '1', '1', '0', '0', '60', '53', '61', '0', '0', '0', '0', '0', '0', '0', '0', '7203', '9376', '10306', '10337', '5184', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000804', '7', '2', '6', '0', '0', '8', '0', '0', '3', '0', '1', '4', '2', '2', '2', '20', '8', '14', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000805', '8', '2', '2', '0', '0', '4', '0', '0', '3', '0', '4', '1', '3', '3', '2', '18', '12', '10', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29767', '5188', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000806', '7', '2', '8', '0', '0', '4', '0', '0', '4', '0', '2', '3', '1', '1', '2', '1', '5', '12', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000807', '4', '2', '5', '0', '0', '8', '0', '0', '4', '0', '1', '0', '0', '3', '3', '13', '7', '3', '0', '784335882', '0', '0', '0', '0', '0', '0', '5216', '33956', '3149', '5184', '10336', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000808', '1', '2', '3', '0', '0', '2', '0', '0', '1', '1', '5', '4', '1', '3', '1', '28', '2', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000809', '1', '2', '3', '0', '0', '1', '0', '0', '1', '1', '4', '0', '0', '1', '3', '15', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000810', '6', '2', '3', '0', '0', '8', '0', '0', '0', '1', '2', '5', '0', '0', '1', '78', '64', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29793', '5472', '1024', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000811', '7', '2', '5', '0', '0', '5', '0', '0', '1', '1', '1', '2', '0', '2', '1', '1', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000812', '2', '2', '3', '0', '0', '2', '0', '0', '2', '1', '5', '4', '1', '2', '3', '4', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '10274', '7202', '15360', '11264', '10240', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000813', '5', '2', '1', '0', '0', '1', '0', '0', '0', '1', '4', '4', '3', '0', '2', '11', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000814', '3', '2', '1', '0', '0', '7', '0', '0', '1', '1', '2', '3', '3', '2', '2', '29', '13', '16', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000815', '1', '2', '8', '0', '0', '8', '0', '0', '3', '1', '1', '3', '3', '0', '3', '4', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000816', '5', '2', '4', '0', '0', '1', '0', '0', '2', '0', '0', '3', '0', '1', '3', '2', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000817', '24', '2', '6', '0', '0', '1', '0', '0', '3', '1', '2', '3', '0', '3', '0', '29', '3', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '924800', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000818', '1', '2', '4', '0', '0', '2', '0', '0', '4', '1', '2', '3', '2', '2', '2', '12', '16', '16', '0', '210765825', '236979210', '0', '0', '0', '0', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000819', '4', '2', '5', '0', '0', '4', '0', '0', '5', '1', '0', '5', '0', '0', '1', '13', '3', '14', '0', '752878632', '0', '0', '0', '0', '0', '0', '20496', '2144', '5190', '5250', '10338', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000820', '8', '2', '1', '0', '0', '3', '0', '0', '2', '1', '2', '3', '2', '3', '0', '9', '6', '14', '0', '768607232', '0', '0', '0', '0', '0', '0', '4131', '4131', '4097', '6147', '9248', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000821', '4', '2', '2', '0', '0', '1', '0', '0', '4', '0', '5', '1', '2', '1', '1', '14', '12', '7', '0', '705692752', '0', '0', '0', '0', '0', '0', '9378', '6241', '9472', '5251', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000822', '1', '2', '4', '0', '0', '7', '0', '0', '3', '1', '2', '0', '3', '3', '0', '1', '5', '5', '0', '705692712', '0', '0', '0', '0', '0', '0', '9378', '6240', '3147', '11364', '9345', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000823', '7', '2', '2', '0', '0', '5', '0', '0', '2', '1', '1', '0', '3', '1', '3', '14', '4', '16', '0', '705692722', '0', '0', '0', '0', '0', '0', '9378', '2147', '9536', '5217', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000824', '21', '2', '41', '0', '0', '41', '0', '0', '2', '0', '4', '1', '2', '2', '1', '8', '11', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1761', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000825', '21', '2', '0', '0', '0', '21', '0', '0', '1', '0', '3', '3', '1', '2', '2', '7', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '1825', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000826', '21', '2', '21', '0', '0', '31', '0', '0', '5', '1', '2', '1', '3', '0', '3', '11', '15', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2944', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000827', '21', '2', '0', '0', '0', '31', '0', '0', '1', '1', '0', '0', '2', '3', '2', '31', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '2849', '2849', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000828', '21', '2', '0', '0', '0', '41', '0', '0', '5', '0', '0', '2', '2', '1', '0', '59', '58', '53', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '1825', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000829', '8', '2', '5', '0', '0', '3', '0', '0', '5', '1', '3', '2', '3', '0', '3', '26', '7', '7', '0', '210765827', '236979210', '0', '0', '0', '0', '0', '9696', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000830', '3', '2', '2', '0', '0', '4', '0', '0', '1', '0', '4', '4', '2', '0', '2', '25', '16', '3', '0', '210767912', '236979210', '0', '0', '0', '0', '0', '14499', '14656', '4288', '14658', '9504', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000831', '1', '2', '3', '0', '0', '8', '0', '0', '4', '1', '2', '5', '1', '2', '2', '7', '4', '1', '0', '210767912', '236979210', '0', '0', '0', '0', '0', '14499', '14656', '4288', '14658', '9504', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000832', '4', '2', '3', '0', '0', '4', '0', '0', '0', '1', '2', '0', '1', '3', '3', '5', '15', '1', '0', '210764830', '236979210', '0', '0', '0', '0', '0', '9665', '9761', '7392', '14562', '6243', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000833', '7', '2', '8', '0', '0', '1', '0', '0', '3', '1', '1', '5', '0', '2', '3', '28', '4', '10', '0', '878708737', '0', '0', '0', '0', '0', '0', '23885', '6336', '2208', '6304', '9572', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000834', '1', '2', '6', '0', '0', '2', '0', '0', '3', '1', '5', '4', '2', '1', '2', '23', '8', '5', '0', '878707724', '0', '0', '0', '0', '0', '0', '6275', '4356', '4224', '6340', '6434', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000835', '5', '2', '2', '0', '0', '5', '0', '0', '2', '1', '4', '2', '0', '3', '0', '25', '15', '14', '0', '878708737', '0', '0', '0', '0', '0', '0', '23885', '6336', '2208', '6304', '9572', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000836', '8', '2', '1', '0', '0', '4', '0', '0', '4', '1', '3', '0', '1', '2', '1', '26', '15', '1', '0', '878707712', '0', '0', '0', '0', '0', '0', '5152', '6176', '15392', '6177', '6176', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000837', '8', '2', '8', '0', '0', '2', '0', '0', '4', '1', '5', '5', '0', '3', '0', '27', '10', '14', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000838', '5', '2', '4', '0', '0', '1', '0', '0', '5', '1', '1', '0', '3', '3', '0', '31', '5', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '178176', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000839', '8', '2', '4', '0', '0', '6', '0', '0', '4', '1', '0', '2', '2', '1', '3', '73', '63', '58', '0', '331351052', '0', '0', '0', '0', '0', '0', '11339', '7587', '3107', '5282', '4288', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000840', '5', '2', '2', '0', '0', '1', '0', '0', '3', '0', '2', '3', '1', '1', '0', '16', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9602', '4164', '11329', '21537', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000841', '6', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '52', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16548', '5216', '1024', '5312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000842', '8', '1', '3', '0', '0', '7', '0', '0', '0', '1', '1', '0', '0', '0', '0', '55', '55', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10368', '1664', '25668', '21636', '198656', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000843', '2', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1092', '6244', '10336', '6242', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000844', '5', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '54', '54', '0', '294650960', '0', '0', '0', '0', '0', '0', '0', '29954', '7394', '13600', '10531', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000845', '5', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '54', '54', '0', '294650920', '0', '0', '0', '0', '0', '0', '0', '29954', '7394', '13504', '10435', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000846', '6', '2', '2', '0', '0', '7', '0', '0', '1', '0', '5', '5', '2', '2', '0', '57', '59', '64', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '7584', '16608', '2240', '5472', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000847', '8', '2', '6', '0', '0', '1', '0', '0', '0', '1', '5', '0', '0', '1', '2', '19', '12', '13', '0', '294650940', '0', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000848', '5', '3', '1', '0', '0', '8', '0', '0', '1', '0', '4', '5', '0', '2', '3', '61', '59', '61', '0', '294651984', '0', '0', '0', '0', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000849', '6', '2', '1', '0', '0', '2', '0', '0', '3', '0', '0', '1', '1', '2', '3', '3', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30048', '5251', '1024', '10531', '197632', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000850', '6', '0', '1', '0', '0', '2', '0', '0', '3', '0', '1', '5', '2', '0', '3', '3', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5441', '5379', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000851', '1', '1', '2', '0', '0', '7', '0', '0', '2', '0', '4', '1', '0', '3', '3', '25', '5', '9', '0', '79693845', '0', '0', '0', '0', '0', '0', '0', '29986', '3265', '1024', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000852', '3', '3', '5', '0', '0', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '5440', '5344', '1024', '5472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000853', '21', '2', '41', '0', '0', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5888', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000854', '21', '1', '41', '0', '0', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5888', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000855', '6', '2', '2', '0', '0', '8', '21', '0', '0', '0', '0', '0', '0', '0', '0', '78', '56', '56', '0', '58723368', '59771944', '0', '0', '0', '0', '0', '0', '16641', '7393', '1024', '10529', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000856', '6', '2', '2', '0', '0', '8', '21', '0', '0', '0', '0', '0', '0', '0', '0', '78', '56', '56', '0', '58723338', '59771914', '0', '0', '0', '0', '0', '0', '16609', '7393', '1024', '10433', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000857', '5', '4', '3', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '58', '61', '64', '0', '862980116', '0', '0', '0', '0', '0', '0', '0', '6432', '2177', '1024', '6401', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000858', '5', '4', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '61', '65', '0', '862981121', '0', '0', '0', '0', '0', '0', '0', '6433', '6304', '1024', '6402', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000859', '6', '3', '2', '0', '0', '1', '0', '0', '5', '1', '2', '3', '2', '0', '3', '7', '8', '14', '0', '60818472', '61867048', '0', '0', '0', '0', '0', '5411', '10528', '10403', '10464', '25665', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000860', '5', '2', '1', '0', '0', '8', '0', '0', '2', '1', '5', '4', '2', '3', '0', '54', '58', '53', '0', '294651984', '0', '0', '0', '0', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000861', '2', '2', '1', '0', '0', '5', '0', '0', '1', '0', '2', '4', '1', '0', '1', '30', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '23852', '6242', '1344', '6145', '6217', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000862', '5', '3', '4', '0', '0', '4', '0', '0', '0', '1', '3', '5', '3', '0', '1', '52', '66', '51', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000863', '6', '2', '2', '0', '0', '7', '0', '0', '5', '0', '2', '2', '1', '2', '1', '76', '64', '57', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '10402', '8448', '1024', '15456', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000864', '5', '2', '1', '0', '0', '7', '0', '0', '3', '1', '2', '3', '0', '2', '3', '29', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '16484', '5187', '1024', '5152', '339968', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000865', '4', '2', '1', '0', '0', '1', '12', '0', '0', '0', '0', '4', '3', '1', '1', '28', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16576', '5249', '1024', '5345', '339968', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000866', '5', '3', '4', '0', '0', '3', '1', '0', '5', '1', '5', '1', '0', '0', '1', '15', '16', '3', '0', '79698947', '32508948', '0', '0', '0', '0', '0', '0', '3136', '3266', '14658', '15553', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000867', '1', '2', '5', '0', '0', '2', '4', '0', '1', '0', '3', '2', '2', '2', '3', '7', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '10435', '4417', '5312', '1024', '9571', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000868', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '8', '0', '147852288', '0', '0', '0', '0', '0', '0', '25641', '10306', '15872', '1024', '2243', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000869', '4', '1', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '53', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '8192', '1024', '21505', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000870', '4', '3', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '57', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10304', '5154', '1024', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000871', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '13', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6177', '1378', '10304', '5187', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000872', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '10', '0', '147851275', '0', '0', '0', '0', '0', '0', '23554', '8320', '15904', '10336', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000873', '5', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '11', '0', '147850240', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000874', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '9', '0', '147851274', '0', '0', '0', '0', '0', '0', '22560', '8320', '15904', '10304', '8257', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000875', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '2', '0', '147850241', '0', '0', '0', '0', '0', '0', '23655', '10369', '16384', '5250', '25760', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000876', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '168821800', '0', '0', '0', '0', '0', '0', '19499', '14624', '3150', '14624', '10496', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000877', '9', '2', '5', '0', '0', '2', '0', '0', '5', '1', '4', '4', '3', '2', '2', '77', '52', '66', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000878', '7', '2', '1', '0', '0', '4', '0', '0', '3', '0', '0', '4', '1', '1', '2', '25', '7', '7', '0', '168821790', '0', '0', '0', '0', '0', '0', '19498', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000879', '4', '2', '5', '0', '0', '6', '0', '0', '3', '1', '0', '5', '2', '2', '0', '23', '9', '15', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '9472', '14467', '9379', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000880', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000881', '10903', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000882', '10903', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000883', '10903', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000884', '2', '2', '2', '0', '0', '2', '0', '0', '0', '1', '4', '5', '0', '3', '0', '22', '2', '4', '0', '210764830', '236979210', '0', '0', '0', '0', '0', '9665', '9761', '7392', '14562', '6243', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000885', '8', '2', '5', '0', '0', '3', '0', '0', '2', '1', '5', '1', '0', '0', '0', '1', '15', '3', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000886', '9', '2', '4', '0', '0', '1', '0', '0', '2', '1', '2', '5', '3', '3', '0', '69', '59', '64', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000887', '8', '2', '1', '0', '0', '2', '0', '0', '2', '1', '3', '4', '3', '2', '2', '8', '14', '4', '0', '862982144', '0', '0', '0', '0', '0', '0', '21576', '33216', '2208', '6340', '6404', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000888', '6', '1', '4', '0', '0', '4', '0', '0', '3', '0', '3', '2', '1', '3', '1', '70', '61', '53', '0', '862982144', '0', '0', '0', '0', '0', '0', '0', '29889', '5185', '1024', '6339', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000889', '6', '2', '3', '0', '0', '3', '0', '0', '1', '0', '4', '1', '3', '1', '0', '70', '61', '54', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '35265', '5346', '1024', '10531', '197632', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000890', '5', '2', '1', '0', '0', '8', '0', '0', '0', '0', '5', '1', '1', '1', '1', '51', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '4420', '4420', '5346', '5440', '10529', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000891', '8', '2', '2', '0', '0', '1', '0', '0', '5', '0', '0', '0', '1', '2', '2', '22', '9', '6', '0', '79693874', '32514128', '0', '0', '0', '0', '0', '14531', '15552', '8992', '8578', '3168', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000892', '7', '2', '6', '0', '0', '1', '0', '0', '0', '1', '5', '1', '2', '3', '3', '13', '15', '12', '0', '80741396', '0', '0', '0', '0', '0', '0', '3136', '12707', '16032', '8320', '3105', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000893', '5', '2', '2', '0', '0', '7', '0', '0', '1', '1', '2', '4', '1', '2', '0', '19', '7', '12', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000894', '4', '2', '4', '0', '0', '6', '0', '0', '0', '1', '2', '3', '0', '2', '1', '12', '8', '16', '0', '79692820', '32512000', '0', '0', '0', '0', '0', '11292', '15395', '8544', '11457', '13408', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000895', '6', '2', '2', '0', '0', '4', '0', '0', '2', '1', '1', '3', '0', '3', '0', '61', '51', '56', '0', '58724382', '59772958', '0', '0', '0', '0', '0', '10400', '10528', '10402', '8256', '4323', '340992', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000896', '1', '2', '5', '0', '0', '2', '0', '0', '4', '1', '4', '4', '2', '2', '2', '28', '6', '13', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '10434', '10498', '16674', '10464', '10496', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000897', '3', '2', '7', '0', '0', '7', '0', '0', '4', '1', '0', '3', '2', '2', '0', '12', '4', '5', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '10434', '10498', '16674', '10464', '10496', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000898', '5', '2', '4', '0', '0', '2', '0', '0', '2', '1', '0', '1', '1', '3', '0', '69', '64', '64', '0', '58723329', '59771905', '0', '0', '0', '0', '0', '10305', '10401', '10370', '5248', '10337', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000899', '7', '3', '8', '0', '0', '1', '17', '0', '1', '1', '4', '1', '0', '3', '2', '3', '2', '13', '0', '862980116', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000900', '22', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922721', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000901', '6', '2', '1', '0', '0', '3', '0', '0', '3', '1', '3', '5', '2', '1', '2', '71', '63', '57', '0', '862980116', '0', '0', '0', '0', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000902', '10033', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000903', '10033', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000904', '10033', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000905', '6', '1', '4', '0', '0', '4', '0', '0', '4', '1', '2', '2', '1', '0', '0', '72', '65', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '34816', '6176', '1024', '5155', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000906', '6', '1', '4', '0', '0', '4', '0', '0', '4', '1', '2', '2', '1', '0', '0', '72', '65', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5442', '7397', '1024', '5442', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000907', '4', '2', '1', '0', '0', '6', '0', '0', '0', '1', '4', '1', '2', '0', '1', '20', '7', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35328', '7300', '1024', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000908', '8', '2', '2', '0', '0', '6', '0', '0', '5', '0', '3', '1', '2', '2', '0', '62', '61', '66', '0', '0', '0', '0', '0', '0', '0', '0', '5441', '5379', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000909', '2', '2', '4', '0', '0', '2', '0', '0', '1', '1', '4', '4', '2', '2', '0', '17', '6', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5441', '5379', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000910', '5', '2', '3', '0', '0', '6', '0', '0', '3', '1', '1', '4', '2', '0', '1', '62', '62', '54', '0', '0', '0', '0', '0', '0', '0', '0', '10435', '4417', '5312', '1024', '9571', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000911', '3', '2', '5', '0', '0', '8', '0', '0', '5', '0', '0', '5', '3', '2', '3', '3', '10', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '16481', '5216', '1024', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000912', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000913', '7', '3', '2', '0', '0', '1', '0', '0', '3', '0', '4', '0', '3', '2', '2', '27', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000914', '6', '1', '3', '0', '0', '1', '0', '0', '2', '1', '3', '2', '0', '3', '0', '9', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10433', '7328', '1024', '1121', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000915', '3', '1', '4', '0', '0', '7', '0', '0', '2', '0', '5', '3', '0', '1', '2', '22', '3', '7', '0', '784335902', '0', '0', '0', '0', '0', '0', '0', '35204', '5190', '1024', '4288', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000916', '6', '2', '4', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '3', '2', '27', '5', '9', '0', '784335883', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000917', '2', '2', '2', '0', '0', '2', '0', '0', '5', '0', '0', '3', '2', '0', '0', '25', '12', '2', '0', '784335883', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000918', '3', '2', '2', '0', '0', '4', '0', '0', '3', '1', '5', '3', '3', '0', '2', '25', '13', '3', '0', '784335902', '0', '0', '0', '0', '0', '0', '0', '35204', '5190', '1024', '4288', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000919', '10508', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000920', '10002', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000921', '10004', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000922', '10006', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000923', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000924', '25', '2', '0', '0', '0', '1', '0', '0', '0', '1', '1', '5', '2', '3', '1', '15', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '925762', '925793', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000925', '25', '2', '6', '0', '0', '1', '0', '0', '2', '1', '4', '0', '3', '0', '3', '23', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '925794', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000926', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '243270686', '0', '0', '0', '0', '0', '0', '24769', '16672', '10403', '3104', '21859', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000927', '5', '1', '2', '0', '0', '2', '3', '0', '1', '0', '2', '3', '2', '0', '1', '70', '52', '53', '0', '79692850', '32514088', '0', '0', '0', '0', '0', '12416', '8385', '4352', '11584', '15552', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000928', '4', '1', '8', '0', '0', '1', '0', '0', '5', '0', '3', '4', '2', '3', '0', '19', '12', '2', '0', '79693874', '32510978', '0', '0', '0', '0', '0', '23879', '8354', '8448', '8352', '15456', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000929', '1', '3', '2', '0', '0', '2', '0', '0', '3', '1', '4', '4', '0', '1', '1', '1', '6', '13', '0', '294652958', '0', '0', '0', '0', '0', '0', '0', '30019', '7168', '2274', '2210', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000930', '6', '2', '2', '0', '0', '1', '3', '0', '0', '1', '4', '3', '0', '2', '2', '12', '4', '1', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '34880', '1024', '10240', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000931', '8', '1', '1', '0', '0', '2', '0', '0', '3', '1', '5', '1', '1', '0', '2', '15', '13', '8', '0', '147850260', '0', '0', '0', '0', '0', '0', '14400', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000932', '8', '2', '2', '0', '0', '4', '0', '0', '2', '0', '4', '0', '3', '0', '3', '26', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33856', '7296', '5280', '4257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000933', '2', '2', '4', '0', '0', '3', '0', '0', '5', '1', '3', '1', '1', '0', '2', '26', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1156', '4356', '10528', '5441', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000934', '5', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '3', '0', '2', '3', '59', '62', '63', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000935', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000936', '9', '3', '2', '0', '0', '3', '0', '0', '5', '1', '3', '5', '1', '1', '2', '82', '62', '53', '0', '310379520', '0', '0', '0', '0', '0', '0', '0', '29698', '7171', '1024', '10240', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000937', '6', '2', '4', '0', '0', '1', '0', '0', '5', '1', '3', '2', '2', '1', '1', '28', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000938', '7', '2', '8', '0', '0', '8', '0', '0', '2', '1', '0', '4', '3', '1', '2', '25', '3', '14', '0', '784335872', '0', '0', '0', '0', '0', '0', '5122', '5120', '5122', '5120', '5120', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000939', '1', '2', '3', '0', '0', '7', '0', '0', '4', '0', '4', '3', '2', '2', '2', '11', '14', '15', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000940', '5', '2', '4', '0', '0', '3', '0', '0', '3', '0', '3', '5', '0', '1', '3', '20', '7', '1', '0', '58723328', '59771904', '0', '0', '0', '0', '0', '0', '10276', '10274', '10272', '10240', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000941', '8', '3', '5', '0', '0', '3', '0', '0', '1', '1', '1', '0', '1', '3', '3', '5', '4', '10', '0', '780141568', '0', '0', '0', '0', '0', '0', '0', '2082', '5153', '5153', '10240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000942', '3', '2', '1', '0', '0', '8', '0', '0', '4', '0', '5', '1', '2', '2', '1', '1', '16', '15', '0', '780141568', '0', '0', '0', '0', '0', '0', '20480', '4128', '5187', '5121', '10272', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000943', '1', '2', '2', '0', '0', '8', '0', '0', '3', '1', '0', '2', '2', '3', '2', '12', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29920', '5312', '1024', '10530', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000944', '5', '3', '3', '0', '0', '1', '0', '0', '1', '0', '4', '5', '0', '3', '2', '11', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29920', '5312', '1024', '10530', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000945', '2', '1', '8', '0', '0', '1', '0', '0', '0', '0', '2', '0', '2', '2', '1', '5', '1', '10', '0', '894436363', '0', '0', '0', '0', '0', '0', '23889', '32866', '6216', '2113', '25697', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000946', '5', '2', '1', '0', '0', '5', '0', '0', '3', '0', '2', '0', '0', '0', '0', '20', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7744', '2112', '1024', '6144', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000947', '6', '2', '2', '0', '0', '1', '0', '0', '1', '1', '1', '0', '0', '0', '3', '22', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000948', '1', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '5', '0', '79693844', '0', '0', '0', '0', '0', '0', '0', '9413', '16644', '5347', '8576', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000949', '3', '1', '2', '0', '0', '3', '0', '0', '1', '0', '1', '1', '3', '3', '3', '6', '6', '10', '0', '752878622', '0', '0', '0', '0', '0', '0', '4417', '4417', '5344', '5440', '10529', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000950', '4', '1', '7', '0', '0', '1', '0', '0', '3', '1', '2', '3', '3', '1', '1', '29', '12', '1', '0', '0', '0', '0', '0', '0', '0', '0', '4417', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000951', '7', '3', '4', '0', '0', '8', '4', '0', '0', '1', '3', '4', '1', '2', '3', '12', '13', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3106', '11332', '5220', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000952', '4', '2', '7', '0', '0', '6', '16', '0', '3', '0', '4', '4', '1', '2', '0', '28', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '11314', '1476', '5280', '10530', '1060', '340992', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000953', '8', '2', '4', '0', '0', '6', '1', '0', '2', '1', '3', '3', '0', '2', '2', '67', '55', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10432', '1728', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000954', '1', '2', '7', '0', '0', '7', '4', '0', '0', '0', '3', '1', '0', '1', '1', '30', '8', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20494', '35266', '5376', '1024', '5442', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000955', '5', '2', '1', '0', '0', '3', '13', '0', '5', '0', '3', '0', '3', '0', '3', '23', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000956', '4', '1', '6', '0', '0', '1', '0', '0', '0', '0', '4', '4', '1', '3', '0', '16', '1', '16', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000957', '21', '2', '0', '0', '0', '21', '0', '0', '5', '0', '5', '0', '2', '1', '1', '24', '13', '2', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '3968', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000958', '21', '2', '21', '0', '0', '21', '0', '0', '0', '0', '1', '3', '0', '3', '2', '15', '7', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3968', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000959', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '5', '1', '0', '1', '2', '15', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '4032', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000960', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '2', '3', '3', '0', '0', '24', '11', '10', '0', '0', '0', '0', '0', '0', '0', '0', '3780', '4001', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000961', '21', '2', '0', '0', '0', '21', '0', '0', '5', '1', '2', '1', '1', '3', '0', '21', '9', '2', '0', '0', '0', '0', '0', '0', '0', '0', '3779', '3904', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000962', '6', '2', '2', '0', '0', '7', '0', '0', '4', '1', '3', '4', '3', '1', '0', '55', '51', '54', '0', '79693874', '32510978', '0', '0', '0', '0', '0', '23879', '8354', '8448', '8352', '15456', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000963', '9', '2', '2', '0', '0', '2', '0', '0', '2', '1', '5', '5', '2', '3', '2', '77', '63', '57', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000964', '7', '2', '1', '0', '0', '4', '0', '0', '3', '0', '2', '3', '0', '3', '1', '26', '6', '6', '0', '79692900', '32514088', '0', '0', '0', '0', '0', '12416', '8385', '4352', '11584', '15552', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000965', '5', '2', '1', '0', '0', '5', '0', '0', '5', '1', '1', '2', '3', '2', '3', '12', '12', '2', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000966', '5', '2', '2', '0', '0', '1', '0', '0', '1', '1', '1', '5', '3', '1', '1', '10', '7', '3', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000967', '7', '2', '6', '0', '0', '2', '0', '0', '2', '0', '0', '4', '1', '2', '3', '61', '53', '62', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000968', '2', '2', '5', '0', '0', '3', '0', '0', '5', '0', '3', '1', '2', '0', '3', '23', '16', '4', '0', '79694868', '32510983', '0', '0', '0', '0', '0', '11333', '8417', '15456', '11521', '15489', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000969', '8', '2', '4', '0', '0', '2', '0', '0', '4', '0', '1', '1', '3', '1', '0', '3', '16', '3', '0', '79693874', '32510978', '0', '0', '0', '0', '0', '23879', '8354', '8448', '8352', '15456', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000970', '1', '2', '3', '0', '0', '1', '0', '0', '5', '0', '2', '2', '0', '1', '2', '21', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '25795', '1089', '16452', '10304', '8224', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000971', '3', '2', '2', '0', '0', '8', '0', '0', '0', '0', '1', '5', '0', '0', '3', '1', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '10337', '6274', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000972', '5', '2', '1', '0', '0', '7', '0', '0', '3', '1', '1', '3', '0', '1', '1', '5', '16', '15', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '10337', '6274', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000973', '1', '2', '5', '0', '0', '8', '0', '0', '0', '1', '1', '4', '0', '0', '3', '3', '14', '6', '0', '0', '0', '0', '0', '0', '0', '0', '23619', '1122', '8416', '10336', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000974', '7', '2', '5', '0', '0', '4', '0', '0', '2', '0', '5', '0', '1', '1', '1', '1', '9', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '10337', '6274', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000975', '4', '2', '4', '0', '0', '6', '0', '0', '3', '1', '5', '1', '1', '1', '2', '10', '15', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23852', '8259', '8384', '25696', '13345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000976', '8', '2', '3', '0', '0', '1', '0', '0', '5', '0', '3', '2', '0', '2', '1', '30', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '13377', '31904', '16449', '25632', '8320', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000977', '3', '2', '6', '0', '0', '7', '0', '0', '3', '1', '1', '2', '0', '1', '0', '5', '12', '16', '0', '0', '0', '0', '0', '0', '0', '0', '25795', '1089', '16452', '10304', '8224', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000978', '1', '2', '5', '0', '0', '8', '0', '0', '4', '1', '0', '0', '0', '1', '3', '18', '1', '1', '0', '168822785', '0', '0', '0', '0', '0', '0', '4224', '13536', '7296', '14467', '10336', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000979', '3', '3', '3', '0', '0', '3', '0', '0', '5', '0', '1', '3', '1', '2', '0', '28', '1', '13', '0', '168825866', '0', '0', '0', '0', '0', '0', '3296', '15521', '3328', '3296', '3296', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000980', '22', '2', '0', '0', '0', '1', '0', '0', '4', '1', '4', '1', '1', '3', '1', '8', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '922658', '922784', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000981', '23', '2', '0', '0', '0', '1', '0', '0', '3', '0', '5', '5', '3', '3', '0', '29', '16', '10', '0', '0', '0', '0', '0', '0', '0', '0', '923713', '923747', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000982', '3', '2', '4', '0', '0', '8', '0', '0', '3', '1', '4', '3', '3', '0', '2', '17', '6', '14', '0', '780141568', '0', '0', '0', '0', '0', '0', '0', '2148', '5191', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000983', '4', '2', '8', '0', '0', '1', '0', '0', '1', '0', '4', '5', '2', '0', '3', '32', '7', '12', '0', '0', '0', '0', '0', '0', '0', '0', '4384', '4384', '7300', '1024', '4352', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000984', '6', '2', '2', '0', '0', '1', '0', '0', '4', '0', '4', '1', '0', '0', '1', '31', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '4384', '4384', '7300', '1024', '4352', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000985', '8', '2', '7', '0', '0', '1', '0', '0', '3', '1', '1', '2', '2', '2', '0', '13', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4384', '4384', '7300', '1024', '4352', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000986', '8', '2', '3', '0', '0', '6', '0', '0', '0', '0', '3', '3', '2', '2', '2', '58', '55', '59', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '35266', '4356', '1024', '6400', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000987', '2', '2', '6', '0', '0', '2', '0', '0', '0', '0', '1', '2', '1', '3', '0', '30', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30048', '5251', '1024', '10531', '197632', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000988', '2', '2', '3', '0', '0', '2', '0', '0', '2', '0', '4', '4', '2', '1', '2', '20', '13', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5568', '35203', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000989', '3', '2', '2', '0', '0', '4', '0', '0', '2', '1', '2', '5', '3', '3', '1', '26', '5', '13', '0', '780141568', '0', '0', '0', '0', '0', '0', '0', '2148', '5191', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000990', '4', '2', '6', '0', '0', '3', '0', '0', '0', '0', '1', '0', '0', '1', '3', '64', '58', '53', '0', '0', '0', '0', '0', '0', '0', '0', '10434', '7651', '5312', '1024', '5443', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000991', '6', '2', '2', '0', '0', '5', '0', '0', '2', '1', '1', '3', '2', '2', '3', '6', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '35266', '4356', '1024', '6400', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000992', '8', '2', '8', '0', '0', '1', '0', '0', '0', '0', '1', '2', '0', '3', '1', '13', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000993', '8', '2', '8', '0', '0', '3', '0', '0', '5', '0', '5', '3', '3', '1', '0', '21', '16', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000994', '2', '2', '3', '0', '0', '2', '0', '0', '2', '1', '4', '5', '0', '0', '0', '9', '16', '9', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '2148', '5284', '1024', '1056', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000995', '2', '3', '6', '0', '0', '3', '0', '0', '1', '1', '3', '0', '0', '0', '1', '30', '2', '11', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000996', '9', '3', '2', '0', '0', '4', '0', '0', '1', '1', '4', '3', '1', '2', '0', '70', '61', '65', '0', '862980116', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000997', '8', '3', '4', '0', '0', '1', '0', '0', '5', '0', '0', '3', '2', '1', '0', '6', '12', '13', '0', '79698945', '32514048', '0', '0', '0', '0', '0', '0', '31812', '4131', '11361', '13346', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000998', '5', '3', '4', '0', '0', '1', '0', '0', '3', '1', '1', '5', '1', '0', '0', '24', '4', '7', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1000999', '6', '2', '2', '0', '0', '2', '0', '0', '2', '1', '5', '1', '3', '3', '3', '17', '14', '12', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001000', '3', '2', '5', '0', '0', '3', '0', '0', '2', '1', '0', '3', '0', '2', '0', '25', '15', '4', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001001', '9', '2', '1', '0', '0', '2', '0', '0', '4', '0', '5', '1', '1', '1', '2', '81', '58', '55', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001002', '7', '2', '5', '0', '0', '4', '0', '0', '3', '1', '3', '4', '2', '3', '0', '8', '9', '16', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001003', '2', '2', '6', '0', '0', '5', '0', '0', '4', '0', '4', '1', '1', '2', '3', '24', '5', '6', '0', '147850240', '0', '0', '0', '0', '0', '0', '23849', '10369', '15840', '5188', '25633', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001004', '8', '2', '1', '0', '0', '4', '0', '0', '0', '1', '2', '4', '3', '0', '0', '29', '12', '16', '0', '147850240', '0', '0', '0', '0', '0', '0', '23849', '10369', '15840', '5188', '25633', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001005', '7', '2', '1', '0', '0', '4', '0', '0', '3', '1', '2', '5', '0', '0', '2', '6', '15', '4', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001006', '3', '2', '6', '0', '0', '7', '0', '0', '4', '0', '2', '3', '0', '2', '3', '7', '14', '13', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001007', '1', '2', '5', '0', '0', '1', '0', '0', '0', '1', '5', '4', '0', '0', '0', '21', '7', '16', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001008', '8', '2', '6', '0', '0', '2', '0', '0', '2', '0', '3', '1', '3', '3', '0', '27', '13', '7', '0', '721421325', '0', '0', '0', '0', '0', '0', '23598', '2305', '2210', '2272', '25824', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001009', '4', '2', '6', '0', '0', '6', '0', '0', '2', '1', '5', '4', '1', '2', '2', '30', '13', '11', '0', '58722344', '59770920', '0', '0', '0', '0', '0', '5411', '10499', '5283', '11361', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001010', '1', '1', '5', '0', '0', '2', '0', '0', '0', '1', '1', '0', '0', '3', '2', '29', '9', '14', '0', '58722314', '59770890', '0', '0', '0', '0', '0', '0', '29698', '10464', '10272', '10240', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001011', '9', '2', '4', '0', '0', '4', '0', '0', '5', '0', '0', '1', '0', '1', '0', '73', '54', '57', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001012', '5', '2', '1', '0', '0', '5', '0', '0', '1', '0', '2', '2', '3', '2', '2', '20', '15', '5', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001013', '6', '2', '4', '0', '0', '5', '0', '0', '3', '0', '1', '5', '2', '3', '3', '13', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16416', '5153', '1024', '5152', '339968', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001014', '1', '3', '6', '0', '0', '1', '0', '0', '3', '1', '0', '5', '1', '1', '2', '5', '2', '15', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '11267', '11328', '3104', '1024', '25632', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001015', '7', '2', '6', '0', '0', '5', '0', '0', '1', '0', '0', '1', '3', '3', '0', '17', '15', '5', '0', '780141568', '0', '0', '0', '0', '0', '0', '25601', '2337', '5152', '5122', '10240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001016', '5', '2', '2', '0', '0', '3', '0', '0', '4', '1', '4', '1', '1', '3', '2', '19', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '7203', '9376', '10306', '10337', '5184', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001017', '24', '2', '6', '0', '0', '1', '0', '0', '1', '1', '2', '3', '0', '3', '1', '21', '8', '2', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '0', '924800', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001018', '7', '3', '5', '0', '0', '4', '0', '0', '5', '0', '4', '5', '0', '2', '3', '14', '11', '8', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '10434', '10498', '16674', '10464', '10496', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001019', '3', '3', '5', '0', '0', '7', '0', '0', '5', '0', '4', '4', '2', '2', '3', '29', '16', '1', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001020', '1', '3', '3', '0', '0', '7', '0', '0', '0', '1', '1', '1', '1', '3', '0', '22', '7', '6', '0', '79692900', '32514088', '0', '0', '0', '0', '0', '12416', '8385', '4352', '11584', '15552', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001021', '1', '3', '3', '0', '0', '7', '0', '0', '3', '0', '1', '0', '0', '0', '2', '24', '7', '13', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001022', '5', '2', '2', '0', '0', '3', '0', '0', '3', '0', '0', '2', '3', '3', '0', '11', '1', '11', '0', '780141568', '0', '0', '0', '0', '0', '0', '20480', '4128', '5187', '5121', '10272', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001023', '5', '2', '3', '0', '0', '1', '0', '0', '5', '0', '5', '4', '2', '2', '2', '10', '8', '6', '0', '58723329', '59771905', '0', '0', '0', '0', '0', '10305', '10401', '10370', '5248', '10337', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001024', '7', '2', '5', '0', '0', '1', '0', '0', '1', '1', '0', '4', '2', '1', '0', '7', '14', '1', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001025', '2', '2', '4', '0', '0', '5', '0', '0', '2', '0', '3', '3', '3', '3', '3', '2', '8', '5', '0', '60818442', '61867018', '0', '0', '0', '0', '0', '10274', '1026', '10273', '10304', '25602', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001026', '8', '2', '8', '0', '0', '2', '0', '0', '4', '1', '1', '0', '3', '2', '1', '19', '15', '12', '0', '58722304', '59770880', '0', '0', '0', '0', '0', '0', '10272', '10272', '10272', '10272', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001027', '8', '2', '2', '0', '0', '3', '0', '0', '5', '1', '4', '3', '3', '1', '2', '20', '4', '5', '0', '58724382', '59772958', '0', '0', '0', '0', '0', '10400', '10528', '10402', '8256', '4323', '340992', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001028', '1', '3', '6', '0', '0', '1', '0', '0', '3', '0', '1', '4', '2', '1', '3', '15', '8', '16', '0', '58723329', '59771905', '0', '0', '0', '0', '0', '10305', '10401', '10370', '5248', '10337', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001029', '2', '2', '6', '0', '0', '5', '0', '0', '1', '1', '2', '1', '2', '0', '2', '3', '10', '4', '0', '58722344', '59770920', '0', '0', '0', '0', '0', '5411', '10499', '5283', '11361', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001030', '3', '2', '5', '0', '0', '7', '0', '0', '5', '1', '5', '3', '2', '2', '2', '28', '16', '3', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001031', '5', '2', '1', '0', '0', '3', '0', '0', '2', '1', '4', '2', '0', '2', '3', '1', '3', '14', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001032', '4', '2', '4', '0', '0', '8', '0', '0', '3', '0', '5', '3', '1', '3', '2', '4', '8', '11', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '7424', '3148', '5121', '1060', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001033', '2', '2', '6', '0', '0', '2', '0', '0', '2', '1', '4', '4', '0', '2', '3', '26', '15', '7', '0', '0', '0', '0', '0', '0', '0', '0', '11302', '10433', '16608', '5376', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001034', '24', '2', '7', '0', '0', '1', '0', '0', '0', '1', '0', '5', '1', '2', '0', '18', '10', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '924832', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001035', '6', '0', '1', '0', '0', '2', '0', '0', '4', '1', '3', '2', '3', '1', '2', '21', '12', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4098', '6144', '1024', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001036', '5', '0', '4', '0', '0', '3', '0', '0', '4', '1', '0', '1', '2', '0', '0', '17', '5', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001037', '21', '2', '51', '0', '0', '51', '0', '0', '1', '1', '4', '1', '1', '1', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7072', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001038', '21', '2', '21', '0', '0', '21', '0', '0', '5', '0', '1', '3', '0', '0', '1', '10', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4000', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001039', '6', '0', '3', '0', '0', '6', '0', '0', '5', '0', '4', '0', '1', '3', '3', '23', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001040', '1', '2', '2', '0', '0', '2', '0', '0', '3', '0', '2', '2', '0', '1', '1', '29', '13', '6', '0', '784335882', '0', '0', '0', '0', '0', '0', '5216', '33956', '3149', '5184', '10336', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001041', '3', '2', '7', '0', '0', '4', '0', '0', '2', '1', '2', '5', '1', '0', '3', '12', '8', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29955', '2146', '1024', '10465', '146432', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001042', '3', '2', '1', '0', '0', '2', '0', '0', '1', '0', '1', '1', '0', '2', '3', '53', '63', '56', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29955', '2146', '1024', '10465', '146432', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001043', '2', '2', '7', '0', '0', '2', '0', '0', '5', '1', '0', '4', '1', '1', '3', '7', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001044', '1', '2', '3', '0', '0', '1', '0', '0', '4', '0', '4', '1', '1', '1', '2', '7', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '4448', '4449', '4096', '1024', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001045', '7', '2', '5', '0', '0', '1', '0', '0', '4', '1', '2', '4', '2', '3', '2', '25', '13', '4', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '10434', '10498', '16674', '10464', '10496', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001046', '6', '1', '4', '0', '0', '3', '0', '0', '5', '0', '2', '2', '1', '0', '3', '79', '52', '60', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001047', '1', '3', '5', '0', '0', '1', '0', '0', '1', '1', '4', '5', '0', '0', '2', '22', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4194', '5216', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001048', '5', '1', '2', '0', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '12', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20489', '4356', '5219', '1024', '9472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001049', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001050', '5', '2', '1', '0', '0', '6', '1', '0', '0', '0', '1', '1', '3', '3', '0', '59', '53', '56', '0', '0', '0', '0', '0', '0', '0', '0', '7236', '34950', '2081', '5251', '4197', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001051', '5', '1', '2', '0', '0', '2', '13', '0', '2', '0', '5', '2', '0', '0', '0', '60', '56', '61', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001052', '6', '2', '4', '0', '0', '3', '10', '0', '2', '1', '0', '2', '3', '1', '0', '77', '56', '57', '0', '347081729', '0', '0', '0', '0', '0', '0', '5344', '7234', '2114', '5153', '10304', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001053', '4', '1', '3', '0', '0', '6', '14', '0', '4', '0', '4', '3', '0', '3', '0', '4', '9', '10', '0', '752879616', '0', '0', '0', '0', '0', '0', '5504', '2211', '5284', '5152', '10531', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001054', '3', '1', '8', '20', '0', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '29', '1', '6', '0', '294650930', '0', '0', '0', '0', '0', '0', '0', '4388', '5190', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001055', '1', '2', '3', '0', '0', '8', '0', '0', '0', '0', '3', '4', '1', '3', '3', '7', '16', '4', '0', '780141568', '0', '0', '0', '0', '0', '0', '0', '2148', '5191', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001056', '6', '2', '2', '0', '0', '5', '0', '0', '4', '1', '3', '1', '3', '3', '1', '22', '9', '9', '0', '752879636', '0', '0', '0', '0', '0', '0', '4417', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001057', '1', '2', '7', '0', '0', '1', '0', '0', '2', '1', '1', '5', '2', '3', '1', '18', '7', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '33827', '4128', '11296', '9216', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001058', '9', '2', '5', '0', '0', '2', '0', '0', '1', '0', '1', '5', '3', '1', '2', '82', '54', '53', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001059', '4', '2', '6', '0', '0', '6', '0', '0', '1', '1', '2', '4', '2', '2', '2', '17', '15', '9', '0', '210767882', '236979210', '0', '0', '0', '0', '0', '14372', '14657', '9888', '11617', '13601', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001060', '6', '2', '1', '0', '0', '2', '0', '0', '2', '1', '0', '1', '1', '2', '2', '32', '9', '16', '0', '705692733', '0', '0', '0', '0', '0', '0', '10435', '6433', '9856', '10467', '6372', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001061', '8', '2', '8', '0', '0', '2', '0', '0', '1', '0', '2', '1', '3', '3', '0', '26', '3', '16', '0', '347081729', '0', '0', '0', '0', '0', '0', '5344', '7234', '2114', '5153', '10304', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001062', '2', '2', '8', '0', '0', '5', '0', '0', '3', '1', '3', '2', '1', '3', '0', '3', '5', '2', '0', '878708736', '0', '0', '0', '0', '0', '0', '6187', '4192', '7264', '1024', '6240', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001063', '7', '3', '9', '0', '0', '8', '0', '0', '5', '0', '0', '3', '3', '0', '2', '16', '3', '5', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '8353', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001064', '7', '4', '9', '0', '0', '4', '0', '0', '2', '0', '3', '3', '1', '1', '0', '31', '14', '11', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001065', '8', '3', '8', '0', '0', '6', '0', '0', '3', '0', '5', '3', '0', '3', '3', '57', '61', '53', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001066', '7', '1', '8', '0', '0', '1', '0', '0', '3', '1', '1', '0', '0', '2', '2', '26', '11', '4', '0', '147851264', '0', '0', '0', '0', '0', '0', '22528', '8256', '6213', '1024', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001067', '8', '1', '8', '0', '0', '7', '0', '0', '5', '0', '1', '2', '2', '1', '1', '53', '51', '65', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001068', '3', '3', '6', '0', '0', '3', '0', '0', '3', '0', '3', '5', '3', '3', '0', '23', '13', '16', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001069', '2', '3', '8', '0', '0', '3', '0', '0', '0', '0', '0', '4', '1', '1', '0', '12', '2', '6', '0', '147851274', '0', '0', '0', '0', '0', '0', '21577', '8352', '15904', '14528', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001070', '9', '3', '5', '0', '0', '4', '0', '0', '2', '0', '4', '4', '2', '0', '3', '57', '65', '53', '0', '147851264', '0', '0', '0', '0', '0', '0', '22528', '8256', '6213', '1024', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001071', '8', '2', '3', '0', '0', '4', '0', '0', '4', '0', '2', '1', '2', '3', '1', '3', '14', '8', '0', '331351046', '0', '0', '0', '0', '0', '0', '4388', '7584', '5280', '5217', '1056', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001072', '5', '2', '1', '0', '0', '8', '0', '0', '1', '1', '3', '5', '2', '2', '1', '70', '53', '55', '0', '347079711', '0', '0', '0', '0', '0', '0', '9664', '7712', '2144', '5280', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001073', '5', '2', '4', '0', '0', '3', '0', '0', '3', '0', '1', '4', '2', '3', '3', '16', '13', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '7200', '2080', '5152', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001074', '6', '2', '4', '0', '0', '1', '0', '0', '2', '0', '2', '0', '3', '0', '1', '12', '4', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '34880', '5152', '10240', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001075', '9', '2', '1', '0', '0', '3', '0', '0', '4', '1', '1', '3', '3', '0', '2', '74', '56', '66', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '7200', '2080', '5152', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001076', '5', '1', '2', '0', '0', '2', '3', '0', '1', '0', '2', '3', '2', '0', '1', '70', '52', '53', '0', '79692900', '32514088', '0', '0', '0', '0', '0', '12288', '8225', '4352', '11328', '15424', '11264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001077', '1', '2', '3', '0', '0', '8', '0', '0', '5', '0', '2', '4', '1', '2', '2', '7', '11', '4', '0', '768607243', '0', '0', '0', '0', '0', '0', '23585', '31875', '2113', '11360', '25697', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001078', '2', '2', '1', '0', '0', '2', '0', '0', '4', '0', '3', '0', '3', '3', '3', '19', '14', '3', '0', '768609300', '0', '0', '0', '0', '0', '0', '5346', '4289', '5216', '11329', '5472', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001079', '7', '2', '7', '0', '0', '1', '0', '0', '0', '0', '4', '3', '1', '3', '1', '8', '2', '2', '0', '768610304', '0', '0', '0', '0', '0', '0', '20489', '33952', '10338', '5251', '4128', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001080', '5', '2', '3', '0', '0', '4', '0', '0', '5', '0', '4', '4', '2', '2', '2', '80', '54', '51', '0', '768610304', '0', '0', '0', '0', '0', '0', '20489', '33952', '10338', '5251', '4128', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001081', '8', '2', '1', '0', '0', '5', '0', '0', '1', '0', '4', '5', '0', '3', '2', '51', '53', '54', '0', '768609300', '0', '0', '0', '0', '0', '0', '5346', '4289', '5216', '11329', '5472', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001082', '2', '2', '5', '0', '0', '3', '0', '0', '2', '0', '1', '2', '0', '3', '2', '29', '15', '12', '0', '768609300', '0', '0', '0', '0', '0', '0', '20640', '2209', '15648', '6340', '9568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001083', '3', '2', '5', '0', '0', '4', '0', '0', '4', '0', '0', '3', '1', '0', '3', '23', '6', '3', '0', '210764830', '236979210', '0', '0', '0', '0', '0', '11425', '11364', '7264', '1024', '21568', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001084', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001085', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001086', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001087', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001088', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001089', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001090', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001091', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001092', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001093', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001094', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001095', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001096', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001097', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001098', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001099', '10034', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001100', '10033', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001101', '8', '1', '7', '0', '0', '1', '0', '0', '3', '0', '0', '5', '1', '0', '0', '26', '1', '6', '0', '878708736', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001102', '1', '3', '4', '0', '0', '7', '0', '0', '1', '0', '3', '4', '1', '1', '0', '21', '11', '3', '0', '878708736', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001103', '3', '2', '2', '0', '0', '1', '0', '0', '5', '1', '2', '2', '3', '3', '3', '65', '65', '62', '0', '878708736', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001104', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7204', '5156', '1024', '4132', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001105', '3', '3', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '5152', '1024', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001106', '6', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '55', '62', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '1377', '5154', '1024', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001107', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '11297', '4131', '11296', '25632', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001108', '9', '2', '4', '0', '0', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '71', '56', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31776', '1088', '5121', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001109', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33824', '2272', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001110', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '1027', '6144', '5121', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001111', '5', '2', '4', '0', '0', '1', '0', '0', '3', '1', '1', '2', '2', '3', '0', '16', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001112', '8', '2', '3', '0', '0', '2', '0', '0', '1', '0', '0', '4', '0', '3', '2', '7', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001113', '1', '2', '6', '0', '0', '2', '0', '0', '2', '0', '4', '5', '1', '3', '3', '17', '10', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001114', '1', '2', '1', '0', '0', '7', '0', '0', '0', '1', '3', '5', '3', '2', '3', '30', '7', '15', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001115', '2', '2', '5', '0', '0', '2', '0', '0', '0', '0', '2', '2', '3', '2', '0', '17', '9', '15', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001116', '3', '2', '1', '0', '0', '8', '0', '0', '2', '1', '3', '2', '2', '3', '3', '20', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001117', '4', '2', '2', '0', '0', '8', '0', '0', '0', '0', '2', '3', '1', '2', '1', '31', '11', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001118', '5', '2', '4', '0', '0', '6', '0', '0', '3', '0', '3', '2', '0', '3', '0', '63', '59', '51', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001119', '6', '2', '2', '0', '0', '8', '0', '0', '5', '1', '2', '4', '0', '2', '3', '63', '53', '65', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001120', '8', '2', '5', '0', '0', '1', '0', '0', '1', '0', '2', '5', '0', '1', '3', '25', '10', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001121', '7', '2', '1', '0', '0', '4', '0', '0', '0', '1', '3', '4', '2', '3', '1', '27', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001122', '9', '2', '3', '0', '0', '1', '0', '0', '4', '1', '1', '0', '0', '2', '0', '77', '65', '56', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001123', '1', '2', '1', '0', '0', '8', '0', '0', '1', '1', '0', '0', '1', '1', '2', '9', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001124', '2', '2', '5', '0', '0', '5', '0', '0', '2', '0', '2', '5', '1', '1', '3', '17', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001125', '3', '2', '5', '0', '0', '7', '0', '0', '1', '1', '3', '0', '1', '2', '1', '12', '3', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001126', '4', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '3', '0', '2', '60', '55', '59', '0', '0', '0', '0', '0', '0', '0', '0', '13376', '8259', '15456', '25696', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001127', '5', '2', '3', '0', '0', '3', '0', '0', '1', '1', '2', '5', '2', '0', '3', '20', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001128', '6', '2', '4', '0', '0', '2', '0', '0', '5', '0', '4', '0', '1', '0', '0', '28', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '13376', '8259', '15456', '25696', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001129', '8', '2', '8', '0', '0', '2', '0', '0', '3', '1', '1', '0', '1', '3', '1', '23', '7', '11', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001130', '7', '2', '6', '0', '0', '1', '0', '0', '2', '1', '5', '4', '1', '0', '2', '1', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001131', '9', '2', '5', '0', '0', '3', '0', '0', '1', '1', '2', '1', '2', '3', '0', '72', '51', '59', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001132', '1', '2', '8', '0', '0', '7', '0', '0', '1', '0', '2', '5', '1', '3', '0', '1', '3', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001133', '2', '2', '3', '0', '0', '2', '0', '0', '5', '0', '1', '3', '0', '2', '0', '29', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001134', '3', '2', '1', '0', '0', '3', '0', '0', '3', '1', '2', '3', '2', '1', '3', '23', '12', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001135', '4', '2', '5', '0', '0', '8', '0', '0', '1', '1', '5', '5', '3', '2', '2', '16', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32834', '9536', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001136', '5', '2', '3', '0', '0', '7', '0', '0', '4', '1', '1', '1', '0', '3', '1', '17', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001137', '6', '2', '4', '0', '0', '5', '0', '0', '1', '0', '4', '0', '1', '3', '0', '16', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001138', '8', '2', '2', '0', '0', '1', '0', '0', '4', '1', '4', '5', '0', '0', '3', '22', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001139', '7', '2', '8', '0', '0', '8', '0', '0', '2', '0', '5', '0', '1', '0', '3', '15', '6', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001140', '9', '2', '3', '0', '0', '3', '0', '0', '0', '1', '0', '1', '3', '2', '3', '72', '53', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001141', '5', '3', '3', '0', '0', '4', '0', '0', '0', '0', '2', '5', '2', '1', '2', '80', '56', '63', '0', '294650970', '0', '0', '0', '0', '0', '0', '0', '29923', '9792', '2240', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001142', '5', '2', '3', '0', '0', '1', '0', '0', '4', '0', '2', '4', '2', '3', '1', '19', '12', '6', '0', '294651984', '0', '0', '0', '0', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001143', '6', '1', '1', '0', '0', '8', '0', '0', '1', '1', '0', '2', '2', '1', '0', '74', '51', '63', '0', '294652948', '0', '0', '0', '0', '0', '0', '0', '29955', '16608', '2240', '5472', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001144', '7', '1', '9', '0', '0', '4', '0', '0', '2', '1', '4', '3', '1', '1', '2', '17', '13', '11', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5193', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001145', '4', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '3', '3', '3', '1', '18', '12', '11', '0', '294650940', '0', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001146', '7', '2', '3', '0', '0', '8', '0', '0', '2', '0', '3', '4', '1', '3', '1', '4', '12', '14', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001147', '8', '2', '7', '0', '0', '2', '0', '0', '2', '0', '0', '1', '0', '3', '0', '21', '6', '14', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001148', '5', '2', '4', '0', '0', '7', '0', '0', '2', '0', '2', '5', '3', '2', '1', '6', '11', '8', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001149', '1', '2', '8', '0', '0', '2', '0', '0', '1', '1', '0', '0', '2', '0', '2', '3', '9', '7', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001150', '3', '2', '3', '0', '0', '3', '0', '0', '5', '1', '3', '4', '0', '2', '3', '26', '13', '10', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001151', '2', '2', '7', '0', '0', '1', '0', '0', '1', '1', '3', '3', '0', '0', '1', '26', '12', '7', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001152', '5', '2', '3', '0', '0', '7', '0', '0', '1', '1', '1', '3', '2', '1', '1', '13', '12', '9', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001153', '6', '2', '4', '0', '0', '5', '0', '0', '2', '0', '1', '3', '1', '1', '0', '22', '3', '12', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001154', '7', '2', '2', '0', '0', '8', '0', '0', '3', '0', '2', '3', '2', '2', '3', '7', '2', '11', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '15840', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001155', '1', '2', '5', '0', '0', '1', '0', '0', '3', '0', '3', '2', '3', '3', '2', '11', '13', '6', '0', '80741386', '32515112', '0', '0', '0', '0', '0', '11314', '15808', '3169', '11427', '15808', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001156', '4', '2', '8', '0', '0', '8', '0', '0', '4', '0', '2', '3', '0', '1', '2', '20', '10', '16', '0', '79698945', '32515122', '0', '0', '0', '0', '0', '3232', '15585', '3169', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001157', '6', '2', '1', '0', '0', '2', '0', '0', '1', '1', '1', '0', '3', '1', '3', '6', '3', '10', '0', '80741386', '32515112', '0', '0', '0', '0', '0', '11314', '15808', '3169', '11427', '15808', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001158', '3', '2', '8', '0', '0', '4', '0', '0', '4', '1', '0', '5', '1', '1', '0', '15', '3', '11', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '15840', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001159', '5', '2', '1', '0', '0', '3', '0', '0', '5', '0', '1', '3', '2', '3', '2', '14', '11', '3', '0', '79698945', '32515122', '0', '0', '0', '0', '0', '3232', '15585', '3169', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001160', '7', '2', '5', '0', '0', '5', '0', '0', '2', '0', '2', '0', '2', '2', '0', '30', '6', '13', '0', '147852298', '0', '0', '0', '0', '0', '0', '25735', '32832', '16548', '25731', '25732', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001161', '8', '2', '1', '0', '0', '2', '0', '0', '4', '1', '0', '3', '3', '1', '3', '10', '11', '16', '0', '147852289', '0', '0', '0', '0', '0', '0', '22630', '11491', '15872', '25668', '15457', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001162', '3', '2', '7', '0', '0', '4', '0', '0', '4', '1', '2', '1', '3', '1', '3', '29', '16', '2', '0', '147851274', '0', '0', '0', '0', '0', '0', '23883', '8352', '8416', '14528', '8353', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001163', '9', '2', '3', '0', '0', '2', '0', '0', '0', '1', '4', '4', '0', '2', '3', '73', '58', '58', '0', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001164', '6', '2', '3', '0', '0', '2', '0', '0', '5', '0', '2', '3', '0', '1', '1', '27', '2', '2', '0', '147852298', '0', '0', '0', '0', '0', '0', '21539', '16481', '15488', '14528', '13408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001165', '5', '3', '3', '0', '0', '3', '0', '0', '1', '1', '0', '3', '1', '2', '0', '27', '12', '7', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001166', '5', '2', '4', '0', '0', '7', '0', '0', '0', '0', '2', '0', '0', '3', '0', '24', '4', '16', '0', '862980116', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001167', '6', '1', '3', '0', '0', '6', '0', '0', '5', '0', '2', '1', '3', '2', '0', '16', '4', '6', '0', '862982144', '0', '0', '0', '0', '0', '0', '21576', '33216', '2208', '6340', '6404', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001168', '6', '2', '3', '0', '0', '2', '0', '0', '4', '1', '5', '5', '2', '2', '1', '9', '7', '9', '0', '862982144', '0', '0', '0', '0', '0', '0', '21576', '33216', '2208', '6340', '6404', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001169', '3', '2', '8', '0', '0', '4', '0', '0', '5', '1', '2', '2', '3', '0', '0', '15', '15', '10', '0', '862981120', '0', '0', '0', '0', '0', '0', '25740', '32867', '2112', '1024', '4161', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001170', '7', '3', '3', '0', '0', '1', '0', '0', '2', '1', '5', '2', '2', '2', '2', '20', '10', '14', '0', '944787456', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001171', '8', '3', '7', '0', '0', '1', '0', '0', '2', '0', '5', '3', '1', '2', '0', '11', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1152', '1760', '25600', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001172', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001173', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001174', '10909', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001175', '2', '2', '6', '0', '0', '1', '0', '0', '1', '0', '2', '4', '2', '3', '1', '14', '1', '4', '0', '210766898', '236979210', '0', '0', '0', '0', '0', '16580', '14593', '4352', '5411', '6307', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001176', '1', '2', '6', '0', '0', '1', '0', '0', '5', '0', '4', '2', '3', '0', '1', '23', '7', '1', '0', '79695883', '32514078', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001177', '8', '2', '1', '0', '0', '2', '0', '0', '5', '0', '1', '5', '0', '3', '0', '5', '2', '7', '0', '79693874', '32510978', '0', '0', '0', '0', '0', '23879', '8354', '8448', '8352', '15456', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001178', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001179', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001180', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001181', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001182', '5', '2', '4', '0', '0', '1', '0', '0', '3', '0', '5', '3', '1', '0', '2', '29', '11', '5', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001183', '2', '2', '9', '0', '0', '2', '0', '0', '2', '0', '4', '2', '2', '0', '3', '32', '9', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001184', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '5', '5', '2', '1', '2', '7', '12', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001185', '1', '1', '6', '0', '0', '2', '0', '0', '3', '1', '1', '1', '1', '0', '2', '30', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '10273', '7171', '1024', '8194', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001186', '8', '3', '5', '0', '0', '3', '0', '0', '3', '1', '4', '2', '1', '2', '3', '23', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '31808', '1024', '6145', '25602', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001187', '5', '2', '4', '0', '0', '3', '0', '0', '0', '1', '2', '5', '2', '1', '2', '5', '9', '2', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001188', '2', '1', '4', '0', '0', '3', '0', '0', '2', '1', '3', '3', '3', '2', '2', '30', '15', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001189', '6', '2', '3', '0', '0', '2', '0', '0', '4', '1', '2', '1', '0', '3', '0', '30', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '9316', '2084', '15424', '5120', '4384', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001190', '3', '3', '6', '0', '0', '3', '0', '0', '2', '1', '0', '3', '1', '3', '2', '9', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '4128', '4097', '5252', '25825', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001191', '1', '2', '7', '0', '0', '1', '0', '0', '1', '0', '2', '1', '3', '1', '1', '4', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001192', '4', '1', '7', '0', '0', '1', '0', '0', '1', '0', '5', '5', '0', '1', '0', '7', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4194', '10305', '2144', '8194', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001193', '7', '3', '3', '0', '0', '8', '0', '0', '0', '0', '3', '1', '1', '3', '3', '7', '11', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001194', '5', '2', '4', '0', '0', '7', '0', '0', '2', '0', '3', '5', '3', '1', '0', '22', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001195', '7', '2', '4', '0', '0', '4', '0', '0', '1', '1', '3', '0', '1', '3', '2', '4', '2', '15', '0', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001196', '7', '2', '8', '0', '0', '4', '0', '0', '2', '0', '2', '2', '3', '1', '3', '10', '9', '7', '0', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001197', '8', '2', '2', '0', '0', '1', '0', '0', '2', '0', '2', '4', '3', '0', '1', '5', '12', '3', '0', '0', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001198', '5', '2', '2', '0', '0', '7', '0', '0', '4', '1', '0', '0', '3', '0', '1', '29', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001199', '6', '2', '3', '0', '0', '5', '0', '0', '2', '0', '1', '5', '0', '2', '1', '21', '10', '2', '0', '210765844', '236979210', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001200', '4', '2', '2', '0', '0', '1', '0', '0', '1', '0', '2', '0', '1', '1', '1', '1', '8', '6', '0', '784335883', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001201', '4', '2', '4', '0', '0', '1', '0', '0', '4', '1', '2', '2', '0', '0', '3', '28', '11', '7', '0', '784335883', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001202', '3', '2', '6', '0', '0', '8', '0', '0', '0', '1', '5', '1', '0', '2', '2', '13', '9', '7', '0', '784335882', '0', '0', '0', '0', '0', '0', '5568', '5441', '5376', '5409', '5472', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001203', '8', '3', '7', '0', '0', '2', '0', '0', '3', '1', '0', '1', '0', '3', '0', '31', '6', '16', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001204', '8', '1', '4', '0', '0', '4', '0', '0', '1', '0', '3', '0', '0', '2', '3', '26', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '11338', '10497', '1664', '25600', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001205', '2', '2', '1', '0', '0', '1', '0', '0', '5', '0', '0', '1', '0', '1', '2', '28', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001206', '8', '2', '1', '0', '0', '4', '0', '0', '1', '1', '2', '0', '3', '1', '1', '26', '4', '10', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001207', '1', '2', '2', '0', '0', '2', '0', '0', '3', '0', '5', '3', '1', '0', '3', '7', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '25632', '4128', '4128', '10240', '4160', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001208', '1', '2', '5', '0', '0', '7', '0', '0', '2', '0', '4', '0', '0', '3', '1', '15', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '15426', '15396', '4098', '8288', '13475', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001209', '1', '2', '3', '0', '0', '8', '0', '0', '4', '1', '5', '5', '3', '0', '1', '12', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '7200', '2080', '5152', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001210', '3', '2', '5', '0', '0', '8', '0', '0', '2', '1', '2', '3', '0', '0', '0', '28', '4', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '7200', '2080', '5152', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001211', '2', '2', '5', '0', '0', '3', '0', '0', '0', '0', '4', '4', '1', '2', '2', '22', '3', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '33856', '7296', '5280', '4257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001212', '3', '2', '7', '0', '0', '8', '0', '0', '0', '1', '2', '1', '2', '2', '1', '2', '11', '11', '0', '294650970', '0', '0', '0', '0', '0', '0', '0', '29923', '9792', '2240', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001213', '1', '2', '8', '0', '0', '7', '0', '0', '1', '0', '4', '1', '1', '3', '3', '11', '2', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '9792', '2240', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001214', '3', '2', '8', '0', '0', '8', '0', '0', '0', '1', '5', '4', '0', '0', '1', '22', '10', '8', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001215', '2', '2', '5', '0', '0', '2', '0', '0', '2', '0', '2', '1', '2', '2', '1', '1', '16', '15', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001216', '7', '2', '6', '0', '0', '4', '0', '0', '3', '0', '5', '2', '0', '0', '2', '9', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '4448', '4449', '4096', '1024', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001217', '8', '2', '1', '0', '0', '2', '0', '0', '2', '1', '3', '4', '3', '2', '2', '8', '14', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16448', '2115', '1024', '25633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001218', '5', '2', '1', '0', '0', '8', '0', '0', '2', '1', '5', '4', '2', '3', '0', '54', '58', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16481', '5190', '1024', '25633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001219', '7', '2', '2', '0', '0', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '63', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16545', '5217', '1024', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001220', '2', '2', '8', '0', '0', '3', '0', '0', '2', '0', '5', '5', '3', '1', '1', '32', '6', '6', '0', '210764850', '236979210', '0', '0', '0', '0', '0', '10284', '9411', '9504', '11426', '9379', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001221', '9', '2', '3', '0', '0', '1', '0', '0', '1', '0', '4', '4', '0', '2', '3', '64', '51', '51', '0', '79695882', '32506900', '0', '0', '0', '0', '0', '8385', '8577', '3297', '8288', '8545', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001222', '7', '2', '1', '0', '0', '4', '0', '0', '0', '0', '5', '4', '1', '2', '3', '32', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001223', '21', '2', '21', '0', '0', '21', '0', '0', '4', '0', '5', '1', '2', '1', '2', '25', '4', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5825', '5888', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001224', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '10', '7', '0', '79692900', '32514088', '0', '0', '0', '0', '0', '12416', '8385', '4352', '11584', '15552', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001225', '9', '2', '1', '0', '0', '2', '0', '0', '5', '1', '4', '5', '3', '3', '0', '59', '63', '63', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001226', '8', '2', '8', '0', '0', '3', '0', '0', '2', '1', '3', '5', '0', '0', '1', '31', '16', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '34976', '9504', '1024', '5122', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001227', '5', '0', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29793', '5472', '1024', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001228', '7', '2', '8', '0', '0', '1', '0', '0', '2', '1', '4', '4', '2', '3', '0', '32', '12', '13', '0', '210764850', '236979210', '0', '0', '0', '0', '0', '9762', '9794', '9824', '9570', '9604', '145408', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001229', '3', '2', '4', '0', '0', '4', '0', '0', '1', '0', '5', '2', '2', '3', '1', '4', '7', '7', '0', '61867058', '60818482', '0', '0', '0', '0', '0', '10528', '30018', '10496', '11620', '10432', '219136', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001230', '8', '2', '8', '0', '0', '2', '0', '0', '5', '0', '3', '4', '3', '2', '2', '13', '14', '2', '0', '0', '0', '0', '0', '0', '0', '0', '7360', '7652', '7397', '5408', '5472', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001231', '3', '2', '3', '0', '0', '3', '0', '0', '1', '0', '2', '4', '0', '0', '2', '31', '16', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '32800', '4128', '10240', '4099', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001232', '6', '2', '2', '0', '0', '1', '0', '0', '4', '1', '3', '3', '1', '0', '3', '12', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001233', '7', '2', '5', '0', '0', '5', '0', '0', '0', '1', '2', '2', '1', '1', '3', '12', '7', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001234', '4', '2', '7', '0', '0', '8', '0', '0', '3', '0', '0', '1', '1', '0', '1', '26', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001235', '9', '2', '1', '0', '0', '3', '0', '0', '0', '1', '0', '4', '2', '2', '0', '57', '52', '64', '0', '79695882', '32506900', '0', '0', '0', '0', '0', '15426', '15396', '4098', '8288', '13475', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001236', '5', '2', '3', '0', '0', '7', '0', '0', '2', '0', '0', '1', '2', '3', '1', '28', '9', '14', '0', '705692712', '0', '0', '0', '0', '0', '0', '23597', '32838', '16480', '11360', '6213', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001237', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001238', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001239', '8', '2', '6', '0', '0', '2', '0', '0', '4', '1', '5', '0', '2', '1', '1', '13', '15', '15', '0', '168823809', '0', '0', '0', '0', '0', '0', '21569', '8386', '8608', '11520', '9537', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001240', '7', '2', '3', '0', '0', '1', '0', '0', '2', '0', '5', '5', '2', '0', '2', '30', '12', '7', '0', '168823809', '0', '0', '0', '0', '0', '0', '8289', '8417', '8640', '11490', '8448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001241', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '13', '1', '0', '210764830', '236979200', '0', '0', '0', '231736351', '0', '15490', '8386', '8608', '11520', '9537', '186368', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001242', '1', '2', '3', '0', '0', '7', '0', '0', '3', '0', '1', '1', '3', '0', '0', '28', '5', '14', '0', '168823809', '0', '0', '0', '0', '0', '0', '15490', '8386', '8608', '11520', '9537', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001243', '3', '2', '2', '0', '0', '7', '0', '0', '1', '0', '2', '0', '2', '0', '1', '11', '11', '10', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001244', '1', '2', '8', '0', '0', '2', '0', '0', '2', '1', '2', '0', '0', '1', '0', '26', '2', '13', '0', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001245', '2', '2', '6', '0', '0', '3', '0', '0', '2', '1', '3', '5', '2', '2', '0', '18', '12', '7', '0', '210765844', '236979210', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001246', '4', '2', '2', '0', '0', '4', '0', '0', '5', '0', '4', '2', '0', '2', '1', '19', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001247', '9', '2', '4', '0', '0', '4', '0', '0', '3', '0', '1', '0', '2', '2', '0', '81', '56', '60', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001248', '7', '2', '8', '0', '0', '8', '0', '0', '5', '0', '2', '5', '2', '0', '3', '13', '8', '13', '0', '210765844', '236979210', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001249', '3', '2', '5', '0', '0', '4', '0', '0', '2', '1', '5', '4', '0', '1', '3', '16', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4130', '16417', '2048', '1024', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001250', '3', '2', '8', '0', '0', '7', '0', '0', '2', '1', '2', '2', '2', '1', '1', '17', '6', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001251', '8', '2', '5', '0', '0', '2', '0', '0', '1', '1', '4', '1', '2', '1', '1', '32', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '9316', '2084', '15424', '5120', '4384', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001252', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001253', '3', '2', '7', '0', '0', '4', '0', '0', '4', '1', '4', '0', '3', '2', '2', '16', '16', '6', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001254', '4', '2', '6', '0', '0', '6', '0', '0', '3', '0', '0', '3', '0', '0', '0', '17', '13', '15', '0', '60818472', '61867048', '0', '0', '0', '0', '0', '5411', '10528', '10403', '10464', '25665', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001255', '5', '2', '2', '0', '0', '7', '0', '0', '1', '1', '5', '2', '2', '3', '0', '2', '14', '4', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001256', '9', '2', '2', '0', '0', '3', '0', '0', '1', '0', '3', '1', '2', '2', '2', '62', '52', '57', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001257', '1', '2', '2', '0', '0', '2', '0', '0', '4', '0', '2', '1', '3', '2', '1', '18', '3', '10', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001258', '4', '2', '1', '0', '0', '4', '0', '0', '1', '0', '4', '1', '0', '1', '1', '4', '11', '10', '0', '58722344', '59770920', '0', '0', '0', '0', '0', '5411', '10499', '5283', '11361', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001259', '7', '2', '2', '0', '0', '1', '0', '0', '1', '1', '1', '5', '0', '1', '0', '11', '11', '5', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001260', '8', '2', '4', '0', '0', '1', '0', '0', '2', '1', '3', '0', '2', '1', '3', '27', '5', '1', '0', '58722344', '59770920', '0', '0', '0', '0', '0', '5411', '10499', '5283', '11361', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001261', '4', '2', '3', '0', '0', '6', '0', '0', '5', '0', '4', '2', '3', '0', '0', '32', '5', '12', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001262', '1', '2', '1', '0', '0', '7', '0', '0', '1', '0', '5', '3', '3', '3', '1', '19', '12', '9', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001263', '5', '2', '2', '0', '0', '1', '0', '0', '2', '1', '0', '2', '1', '1', '1', '24', '11', '12', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001264', '8', '2', '7', '0', '0', '4', '0', '0', '3', '0', '2', '4', '2', '3', '3', '9', '6', '3', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001265', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001266', '10511', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001267', '3', '2', '8', '0', '0', '4', '0', '0', '5', '1', '5', '5', '1', '2', '1', '7', '7', '10', '0', '168822794', '0', '0', '0', '0', '0', '0', '14496', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001268', '4', '2', '5', '0', '0', '8', '0', '0', '1', '0', '1', '4', '1', '1', '2', '25', '11', '4', '0', '168822794', '0', '0', '0', '0', '0', '0', '14496', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001269', '3', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '2', '2', '1', '1', '25', '14', '15', '0', '168822794', '0', '0', '0', '0', '0', '0', '14496', '3232', '3300', '3232', '3232', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001270', '3', '2', '6', '0', '0', '8', '0', '0', '5', '1', '4', '4', '1', '2', '1', '17', '5', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33056', '5123', '1024', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001271', '4', '2', '1', '0', '0', '8', '0', '0', '4', '0', '2', '2', '0', '1', '0', '6', '15', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001272', '5', '2', '4', '0', '0', '7', '0', '0', '3', '0', '5', '0', '0', '0', '2', '23', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '34912', '2080', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001273', '10037', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001274', '1', '2', '5', '0', '0', '8', '0', '0', '4', '0', '0', '4', '0', '1', '3', '1', '14', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001275', '6', '0', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '2144', '1024', '5378', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001276', '7', '2', '3', '0', '0', '5', '0', '0', '5', '0', '4', '4', '1', '1', '0', '18', '8', '15', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001277', '22', '2', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '922659', '922816', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001278', '8', '2', '8', '0', '0', '3', '0', '0', '5', '1', '4', '1', '2', '0', '0', '8', '6', '11', '0', '147853312', '0', '0', '0', '0', '0', '0', '23852', '8323', '4173', '5218', '21646', '186368', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001279', '24', '2', '0', '0', '0', '1', '0', '0', '1', '0', '5', '0', '3', '1', '2', '12', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '924800', '924705', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001280', '3', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '5', '10', '0', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001281', '4', '2', '5', '0', '0', '8', '0', '0', '0', '1', '0', '4', '1', '3', '1', '13', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29793', '5472', '1024', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001282', '9', '2', '5', '0', '0', '2', '0', '0', '0', '0', '4', '2', '0', '1', '3', '63', '51', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29793', '2121', '1024', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001283', '1', '2', '1', '0', '0', '7', '0', '0', '5', '1', '1', '3', '1', '3', '3', '20', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001284', '1', '2', '3', '0', '0', '2', '0', '0', '4', '1', '3', '5', '1', '3', '2', '27', '16', '2', '0', '0', '0', '0', '0', '0', '0', '0', '25740', '32867', '2112', '1024', '4161', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001285', '4', '2', '2', '0', '0', '1', '0', '0', '4', '1', '0', '5', '1', '3', '2', '12', '5', '6', '0', '0', '0', '0', '0', '0', '0', '0', '11338', '10497', '1664', '25600', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001286', '5', '2', '4', '0', '0', '5', '0', '0', '3', '0', '0', '4', '1', '3', '1', '28', '3', '11', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001287', '1', '2', '6', '0', '0', '8', '0', '0', '4', '0', '4', '3', '1', '0', '1', '30', '5', '3', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001288', '7', '2', '6', '0', '0', '8', '0', '0', '1', '1', '3', '1', '0', '2', '3', '16', '14', '8', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001289', '8', '2', '1', '0', '0', '3', '0', '0', '2', '0', '2', '4', '0', '3', '3', '20', '10', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4098', '32802', '4098', '6145', '6147', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001290', '2', '2', '2', '0', '0', '1', '0', '0', '3', '0', '4', '0', '0', '0', '2', '13', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1152', '1760', '25600', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001291', '1', '2', '7', '0', '0', '8', '0', '0', '1', '0', '1', '5', '1', '3', '1', '29', '5', '15', '0', '947914752', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001292', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '4', '5', '0', '2', '0', '21', '12', '10', '0', '947914752', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001293', '1', '2', '7', '0', '0', '8', '0', '0', '1', '0', '1', '5', '1', '3', '1', '29', '5', '15', '0', '947914752', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001294', '4', '2', '3', '0', '0', '8', '0', '0', '2', '0', '3', '2', '3', '2', '0', '27', '9', '11', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001295', '1', '2', '5', '0', '0', '7', '0', '0', '0', '1', '2', '2', '1', '0', '1', '22', '4', '2', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001296', '7', '2', '4', '0', '0', '4', '0', '0', '5', '1', '0', '0', '0', '1', '2', '10', '5', '3', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001297', '2', '2', '6', '0', '0', '1', '0', '0', '0', '1', '5', '2', '1', '0', '1', '22', '7', '10', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001298', '6', '2', '4', '0', '0', '2', '0', '0', '0', '0', '3', '1', '3', '2', '3', '25', '11', '11', '0', '0', '0', '0', '0', '0', '0', '0', '5121', '33860', '1024', '25600', '25601', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001299', '8', '3', '1', '0', '0', '4', '0', '0', '0', '0', '4', '2', '3', '1', '2', '1', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001300', '7', '2', '8', '0', '0', '5', '0', '0', '4', '0', '3', '5', '1', '0', '3', '20', '11', '14', '0', '0', '0', '0', '0', '0', '0', '0', '16386', '1026', '3075', '10240', '1056', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001301', '6', '1', '3', '0', '0', '2', '0', '0', '2', '0', '5', '0', '3', '2', '0', '27', '12', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001302', '7', '2', '2', '0', '0', '8', '0', '0', '4', '1', '5', '5', '3', '2', '0', '27', '7', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001303', '3', '3', '7', '0', '0', '3', '0', '0', '2', '0', '0', '2', '0', '0', '0', '2', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001304', '7', '2', '9', '0', '0', '8', '0', '0', '1', '1', '1', '4', '1', '2', '2', '28', '8', '8', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001305', '8', '2', '3', '0', '0', '2', '0', '0', '3', '0', '0', '0', '1', '0', '1', '20', '8', '1', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001306', '7', '3', '1', '0', '0', '4', '0', '0', '5', '1', '3', '0', '0', '1', '1', '12', '3', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001307', '8', '2', '1', '0', '0', '2', '0', '0', '3', '0', '4', '5', '3', '3', '3', '29', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5121', '33860', '1024', '25600', '25601', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001308', '7', '2', '7', '0', '0', '1', '0', '0', '0', '1', '5', '3', '3', '1', '0', '3', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16418', '5152', '1024', '5120', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001309', '8', '1', '2', '0', '0', '3', '0', '0', '2', '0', '3', '5', '3', '2', '1', '9', '11', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1056', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001310', '9', '3', '1', '0', '0', '1', '0', '0', '5', '1', '5', '1', '3', '2', '3', '59', '53', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001311', '8', '2', '3', '0', '0', '2', '0', '0', '1', '1', '1', '0', '2', '1', '1', '7', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001312', '7', '2', '7', '0', '0', '8', '0', '0', '4', '1', '0', '0', '1', '2', '0', '21', '8', '3', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001313', '7', '1', '1', '0', '0', '5', '0', '0', '0', '1', '4', '0', '2', '3', '3', '13', '10', '5', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001314', '3', '3', '6', '0', '0', '7', '0', '0', '4', '0', '4', '2', '3', '3', '3', '15', '7', '10', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001315', '6', '2', '4', '0', '0', '6', '0', '0', '3', '1', '1', '4', '2', '2', '1', '16', '9', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4194', '10305', '2144', '8194', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001316', '6', '1', '1', '0', '0', '5', '0', '0', '2', '0', '5', '1', '1', '2', '1', '19', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4194', '10305', '2144', '8194', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001317', '5', '3', '4', '0', '0', '5', '0', '0', '4', '0', '4', '1', '0', '0', '0', '22', '6', '2', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001318', '5', '2', '2', '0', '0', '1', '0', '0', '1', '0', '5', '0', '2', '3', '1', '28', '10', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001319', '9', '1', '5', '0', '0', '2', '0', '0', '3', '0', '2', '1', '1', '2', '1', '57', '54', '60', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001320', '6', '3', '4', '0', '0', '2', '0', '0', '0', '1', '1', '5', '1', '0', '1', '11', '1', '7', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001321', '6', '2', '3', '0', '0', '1', '0', '0', '3', '1', '5', '5', '3', '2', '2', '27', '3', '3', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001322', '5', '1', '3', '0', '0', '3', '0', '0', '5', '0', '5', '4', '1', '0', '2', '29', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001323', '4', '2', '6', '0', '0', '4', '0', '0', '3', '1', '4', '0', '2', '2', '1', '31', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4194', '10305', '2144', '8194', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001324', '5', '2', '2', '0', '0', '5', '0', '0', '2', '1', '5', '3', '2', '2', '2', '17', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001325', '8', '2', '2', '0', '0', '2', '0', '0', '2', '1', '0', '4', '3', '2', '2', '5', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001326', '23', '1', '0', '0', '0', '1', '0', '0', '1', '1', '0', '1', '0', '2', '2', '8', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '923744', '923873', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001327', '6', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '2', '3', '3', '3', '29', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001328', '9', '2', '2', '0', '0', '4', '0', '0', '1', '0', '5', '2', '1', '3', '2', '62', '62', '55', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001329', '5', '2', '1', '0', '0', '3', '0', '0', '4', '0', '4', '1', '0', '3', '3', '27', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001330', '2', '2', '5', '0', '0', '3', '0', '0', '5', '0', '3', '1', '1', '1', '1', '17', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5632', '4448', '2241', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001331', '7', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '1', '1', '2', '2', '17', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001332', '9', '3', '2', '0', '0', '2', '0', '0', '0', '0', '2', '1', '3', '2', '2', '70', '61', '51', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001333', '9', '2', '3', '0', '0', '2', '0', '0', '4', '1', '4', '5', '2', '2', '0', '65', '58', '51', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001334', '9', '1', '2', '0', '0', '3', '0', '0', '2', '1', '5', '3', '0', '0', '3', '58', '53', '53', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001335', '6', '2', '3', '0', '0', '2', '0', '0', '2', '1', '3', '4', '0', '0', '0', '29', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '7744', '5472', '1024', '5120', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001336', '23', '2', '0', '0', '0', '1', '0', '0', '5', '0', '2', '4', '1', '0', '2', '18', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '923680', '923680', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001337', '1', '2', '5', '0', '0', '7', '0', '0', '1', '0', '4', '1', '0', '0', '3', '3', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4448', '4449', '4096', '1024', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001338', '2', '2', '8', '0', '0', '5', '0', '0', '0', '0', '5', '4', '1', '1', '1', '11', '16', '1', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001339', '23', '2', '0', '0', '0', '1', '0', '0', '2', '0', '1', '3', '3', '2', '1', '22', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '923649', '924001', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001340', '25', '2', '0', '0', '0', '1', '0', '0', '1', '1', '4', '4', '0', '2', '3', '11', '15', '11', '0', '0', '0', '0', '0', '0', '0', '0', '925761', '925824', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001341', '22', '3', '1', '0', '0', '1', '0', '0', '2', '0', '2', '4', '3', '1', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922720', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001342', '7', '2', '9', '0', '0', '5', '0', '0', '3', '1', '1', '2', '3', '1', '3', '27', '15', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001343', '5', '2', '3', '0', '0', '3', '0', '0', '1', '1', '3', '3', '0', '2', '3', '10', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001344', '1', '2', '5', '0', '0', '2', '0', '0', '1', '1', '3', '4', '1', '0', '3', '27', '5', '5', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001345', '1', '3', '7', '0', '0', '2', '0', '0', '2', '1', '1', '2', '3', '0', '1', '6', '3', '3', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001346', '6', '2', '1', '0', '0', '6', '0', '0', '0', '0', '2', '5', '1', '0', '3', '13', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001347', '7', '3', '8', '0', '0', '4', '0', '0', '4', '1', '5', '1', '1', '2', '0', '24', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001348', '24', '2', '0', '0', '0', '1', '0', '0', '1', '1', '1', '5', '1', '2', '1', '6', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '924770', '924866', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001349', '24', '2', '0', '0', '0', '1', '0', '0', '2', '1', '1', '5', '3', '2', '1', '31', '1', '16', '0', '0', '0', '0', '0', '0', '0', '0', '924801', '924706', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001350', '3', '2', '8', '0', '0', '7', '0', '0', '4', '0', '2', '0', '0', '0', '1', '9', '15', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001351', '8', '1', '7', '0', '0', '1', '0', '0', '2', '0', '4', '2', '1', '1', '3', '25', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001352', '2', '3', '1', '0', '0', '3', '0', '0', '5', '1', '2', '2', '2', '1', '3', '1', '5', '8', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001353', '2', '2', '7', '0', '0', '2', '0', '0', '0', '0', '2', '2', '2', '3', '1', '3', '7', '3', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001354', '9', '2', '1', '0', '0', '4', '0', '0', '2', '1', '2', '1', '2', '3', '0', '67', '53', '63', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001355', '4', '3', '7', '0', '0', '6', '0', '0', '2', '0', '3', '1', '1', '3', '0', '25', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001356', '3', '1', '8', '0', '0', '3', '0', '0', '0', '1', '2', '2', '3', '0', '2', '10', '15', '7', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001357', '7', '2', '9', '0', '0', '4', '0', '0', '4', '0', '4', '1', '2', '3', '3', '10', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001358', '22', '2', '0', '0', '0', '1', '0', '0', '3', '0', '0', '0', '1', '0', '2', '15', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '922816', '923104', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001359', '4', '2', '1', '0', '0', '4', '0', '0', '3', '0', '0', '0', '1', '0', '3', '26', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001360', '4', '3', '6', '0', '0', '4', '0', '0', '1', '0', '1', '0', '0', '1', '1', '20', '3', '6', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001361', '3', '3', '5', '0', '0', '8', '0', '0', '4', '0', '1', '5', '2', '0', '2', '24', '5', '1', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001362', '6', '2', '2', '0', '0', '1', '0', '0', '0', '1', '0', '5', '3', '1', '1', '2', '16', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001363', '4', '1', '5', '0', '0', '6', '0', '0', '3', '0', '5', '4', '1', '1', '1', '25', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001364', '24', '2', '0', '0', '0', '1', '0', '0', '5', '0', '4', '3', '1', '1', '2', '4', '11', '11', '0', '0', '0', '0', '0', '0', '0', '0', '924768', '924864', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001365', '23', '2', '0', '0', '0', '1', '0', '0', '4', '0', '1', '4', '3', '0', '1', '14', '10', '9', '0', '0', '0', '0', '0', '0', '0', '0', '923744', '923873', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001366', '4', '3', '4', '0', '0', '8', '0', '0', '2', '1', '3', '5', '2', '2', '2', '20', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001367', '3', '2', '7', '0', '0', '8', '0', '0', '4', '0', '0', '5', '3', '3', '2', '23', '5', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001368', '3', '3', '3', '0', '0', '4', '0', '0', '4', '0', '0', '1', '3', '2', '0', '21', '9', '14', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001369', '4', '2', '3', '0', '0', '6', '0', '0', '4', '1', '3', '3', '1', '1', '1', '14', '3', '12', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001370', '10023', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001371', '5', '2', '4', '0', '0', '3', '0', '0', '0', '1', '0', '2', '2', '1', '0', '30', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001372', '1', '2', '4', '0', '0', '2', '0', '0', '1', '0', '1', '1', '2', '1', '2', '32', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001373', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '3', '5', '1', '2', '2', '16', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001374', '5', '2', '1', '0', '0', '1', '0', '0', '0', '1', '1', '1', '0', '1', '2', '29', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001375', '22', '2', '0', '0', '0', '1', '0', '0', '5', '0', '4', '5', '2', '1', '3', '8', '7', '7', '0', '0', '0', '0', '0', '0', '0', '0', '922656', '922656', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001376', '6', '2', '2', '0', '0', '2', '0', '0', '0', '1', '0', '5', '0', '2', '0', '3', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001377', '6', '2', '2', '0', '0', '1', '0', '0', '0', '0', '4', '1', '1', '1', '0', '18', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001378', '3', '2', '2', '0', '0', '7', '0', '0', '5', '1', '1', '2', '1', '1', '1', '11', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001379', '9', '2', '2', '0', '0', '4', '0', '0', '2', '0', '4', '4', '0', '0', '2', '60', '51', '65', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001380', '6', '2', '3', '0', '0', '2', '0', '0', '1', '0', '2', '1', '0', '1', '1', '27', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29766', '4099', '1024', '4130', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001381', '4', '2', '1', '0', '0', '6', '0', '0', '5', '1', '1', '0', '0', '0', '3', '14', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '9475', '7200', '7241', '25668', '4288', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001382', '22', '2', '6', '0', '0', '1', '0', '0', '2', '0', '2', '1', '2', '0', '3', '20', '12', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922880', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001383', '1', '2', '4', '0', '0', '2', '0', '0', '4', '0', '4', '4', '2', '0', '0', '23', '7', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001384', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '2', '0', '2', '1', '3', '30', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001385', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001386', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001387', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001388', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001389', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001390', '6', '2', '2', '0', '0', '6', '0', '0', '4', '0', '5', '2', '1', '3', '2', '6', '10', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001391', '9', '2', '2', '0', '0', '2', '0', '0', '2', '0', '3', '0', '2', '1', '0', '70', '53', '56', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001392', '6', '2', '3', '0', '0', '6', '0', '0', '0', '1', '3', '3', '1', '3', '2', '16', '9', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '16385', '7170', '1024', '5120', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001393', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001394', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001395', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001396', '22', '2', '0', '0', '0', '1', '0', '0', '0', '1', '1', '0', '0', '0', '0', '2', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '922659', '922848', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001397', '5', '2', '4', '0', '0', '5', '0', '0', '3', '1', '1', '0', '2', '2', '0', '26', '9', '15', '0', '784335873', '0', '0', '0', '0', '0', '0', '23852', '4196', '5191', '5184', '5220', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001398', '9', '2', '3', '0', '0', '1', '0', '0', '2', '1', '3', '1', '1', '1', '3', '79', '56', '58', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001399', '22', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922976', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001400', '23', '3', '5', '0', '0', '1', '0', '0', '2', '0', '4', '1', '1', '3', '0', '16', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '923872', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001401', '3', '1', '7', '0', '0', '4', '0', '0', '5', '0', '2', '0', '1', '2', '3', '10', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '23880', '2240', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001402', '4', '0', '6', '0', '0', '4', '0', '0', '1', '0', '0', '3', '1', '3', '0', '11', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '23884', '32929', '9856', '5376', '2112', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001403', '6', '4', '2', '0', '0', '2', '0', '0', '5', '0', '3', '0', '3', '2', '0', '11', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '31937', '9856', '2240', '25792', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001404', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '5', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6187', '16512', '10336', '1024', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001405', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5283', '16480', '5153', '1024', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001406', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '9', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6149', '9378', '8192', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001407', '2', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10433', '5155', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001408', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16577', '10371', '1024', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001409', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001410', '6', '2', '1', '0', '0', '1', '0', '0', '4', '1', '3', '2', '0', '3', '2', '3', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9601', '1152', '11332', '21635', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001411', '5', '2', '3', '0', '0', '5', '0', '0', '4', '1', '4', '4', '1', '2', '3', '23', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '4292', '9601', '4163', '11332', '21635', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001412', '6', '3', '1', '0', '0', '5', '0', '0', '2', '0', '2', '0', '3', '3', '3', '31', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9601', '1152', '11332', '21635', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001413', '5', '1', '3', '0', '0', '5', '0', '0', '5', '0', '4', '1', '1', '3', '0', '30', '5', '16', '0', '0', '0', '0', '0', '0', '0', '0', '4292', '9601', '4163', '11332', '21635', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001414', '2', '2', '5', '0', '0', '3', '0', '0', '2', '0', '0', '5', '1', '1', '3', '19', '13', '2', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9601', '1152', '11332', '21635', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001415', '2', '2', '7', '0', '0', '1', '0', '0', '1', '0', '5', '1', '2', '2', '0', '20', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29920', '7394', '5410', '10592', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001416', '7', '2', '6', '0', '0', '8', '0', '0', '1', '0', '3', '5', '2', '0', '0', '31', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001417', '5', '3', '2', '0', '0', '1', '0', '0', '1', '1', '0', '1', '2', '3', '2', '2', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29920', '5312', '1024', '10530', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001418', '7', '2', '9', '0', '0', '1', '0', '0', '1', '0', '3', '3', '0', '3', '0', '9', '4', '9', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001419', '6', '1', '2', '0', '0', '2', '0', '0', '5', '1', '2', '1', '0', '3', '0', '16', '14', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10434', '7651', '5312', '1024', '5443', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001420', '6', '1', '4', '0', '0', '5', '0', '0', '1', '1', '2', '1', '1', '3', '2', '28', '13', '15', '0', '294652948', '0', '0', '0', '0', '0', '0', '0', '29955', '16608', '2240', '5472', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001421', '5', '2', '3', '0', '0', '1', '0', '0', '1', '1', '5', '1', '2', '1', '0', '22', '9', '3', '0', '294651984', '0', '0', '0', '0', '0', '0', '0', '29953', '9856', '2274', '4355', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001422', '6', '2', '4', '0', '0', '6', '0', '0', '4', '0', '2', '2', '1', '2', '2', '32', '5', '7', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001423', '5', '2', '2', '0', '0', '4', '0', '0', '1', '1', '4', '1', '3', '0', '2', '60', '61', '55', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001424', '5', '2', '3', '0', '0', '4', '0', '0', '3', '1', '1', '1', '2', '0', '0', '80', '58', '61', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001425', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '1', '0', '3', '0', '3', '4', '10', '6', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001426', '6', '2', '4', '0', '0', '4', '0', '0', '0', '1', '4', '3', '2', '0', '2', '59', '63', '65', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001427', '3', '2', '2', '0', '0', '7', '0', '0', '3', '1', '4', '4', '3', '0', '0', '17', '15', '15', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001428', '5', '2', '2', '0', '0', '4', '0', '0', '3', '0', '2', '3', '3', '3', '0', '55', '63', '59', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001429', '6', '2', '3', '0', '0', '8', '0', '0', '2', '1', '4', '3', '1', '3', '2', '73', '57', '52', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001430', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '2', '3', '0', '3', '0', '21', '4', '6', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001431', '2', '2', '8', '0', '0', '4', '0', '0', '2', '0', '2', '5', '1', '2', '0', '32', '10', '10', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001432', '1', '2', '6', '0', '0', '1', '0', '0', '3', '1', '1', '2', '1', '2', '0', '9', '13', '13', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001433', '9', '2', '5', '0', '0', '4', '0', '0', '2', '1', '5', '0', '1', '2', '3', '59', '63', '54', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001434', '2', '2', '7', '0', '0', '2', '0', '0', '5', '0', '1', '5', '0', '0', '2', '29', '16', '12', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001435', '4', '2', '7', '0', '0', '1', '0', '0', '2', '1', '4', '5', '0', '1', '0', '16', '5', '9', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001436', '1', '2', '7', '0', '0', '8', '0', '0', '3', '0', '3', '1', '3', '3', '2', '21', '8', '15', '0', '0', '168821770', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001437', '2', '2', '2', '0', '0', '5', '0', '0', '2', '0', '5', '1', '2', '1', '2', '15', '13', '11', '0', '0', '168821770', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001438', '5', '1', '1', '0', '0', '7', '0', '0', '2', '1', '0', '4', '2', '2', '1', '29', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001439', '9', '2', '4', '0', '0', '1', '0', '0', '2', '1', '0', '1', '2', '0', '0', '71', '62', '56', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001440', '6', '0', '4', '0', '0', '6', '0', '0', '1', '1', '5', '0', '2', '2', '2', '31', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '7744', '5472', '1024', '5120', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001441', '9', '3', '1', '0', '0', '3', '0', '0', '0', '0', '5', '2', '0', '3', '0', '54', '65', '62', '0', '0', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001442', '25', '1', '0', '0', '0', '1', '0', '0', '5', '1', '5', '1', '0', '3', '2', '11', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '925761', '925824', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001443', '21', '2', '0', '0', '0', '21', '0', '0', '1', '0', '5', '0', '3', '3', '1', '4', '11', '4', '0', '0', '0', '0', '0', '0', '0', '0', '3810', '3809', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001444', '21', '2', '31', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '5', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4928', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001445', '1', '2', '2', '0', '0', '2', '0', '0', '0', '1', '5', '2', '3', '3', '0', '31', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '14369', '8483', '3268', '3168', '8257', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001446', '23', '2', '0', '0', '0', '1', '0', '0', '5', '1', '5', '2', '3', '2', '2', '22', '14', '12', '0', '0', '0', '0', '0', '0', '0', '0', '924000', '923840', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001447', '22', '2', '0', '0', '0', '1', '0', '0', '2', '0', '4', '3', '1', '2', '0', '25', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '922688', '922752', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001448', '9', '2', '5', '0', '0', '3', '0', '0', '2', '1', '1', '1', '1', '3', '0', '80', '63', '58', '0', '0', '0', '0', '0', '0', '0', '0', '8290', '3296', '3265', '14656', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001449', '7', '2', '3', '0', '0', '7', '0', '0', '2', '1', '2', '4', '2', '1', '1', '54', '59', '60', '0', '0', '0', '0', '0', '0', '0', '0', '5600', '2305', '5376', '5412', '10530', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001450', '5', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '68', '54', '63', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9602', '4164', '11329', '21537', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001451', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001452', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001453', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001454', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001455', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001456', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001457', '10036', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001458', '7', '2', '4', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '28', '11', '15', '0', '721421333', '0', '0', '0', '0', '0', '0', '21696', '32832', '2115', '2115', '25633', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001459', '4', '2', '3', '0', '0', '1', '0', '0', '0', '1', '2', '5', '1', '1', '0', '15', '13', '11', '0', '737150979', '0', '0', '0', '0', '0', '0', '23880', '1344', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001460', '4', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '9', '13', '0', '737150979', '0', '0', '0', '0', '0', '0', '0', '32866', '9696', '5440', '9538', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001461', '3', '2', '3', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '6', '15', '0', '737150979', '0', '0', '0', '0', '0', '0', '5249', '2152', '16577', '10337', '8258', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001462', '8', '2', '2', '0', '0', '6', '0', '0', '1', '0', '1', '3', '1', '2', '1', '53', '55', '66', '0', '0', '0', '0', '0', '0', '0', '0', '5411', '10499', '5283', '11361', '4288', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001463', '6', '2', '4', '0', '0', '7', '0', '0', '5', '1', '2', '3', '1', '0', '2', '73', '62', '54', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '33856', '7296', '5280', '4257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001464', '1', '2', '3', '0', '0', '7', '0', '0', '0', '1', '0', '2', '3', '2', '1', '10', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001465', '6', '2', '4', '0', '0', '4', '0', '0', '0', '1', '2', '5', '1', '1', '0', '64', '55', '54', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5184', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001466', '8', '2', '7', '0', '0', '2', '0', '0', '2', '1', '2', '1', '3', '0', '2', '17', '13', '3', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001467', '3', '2', '6', '0', '0', '6', '0', '0', '0', '0', '3', '3', '2', '0', '2', '51', '58', '66', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '8290', '3296', '3265', '14656', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001468', '2', '2', '3', '0', '0', '4', '0', '0', '2', '1', '4', '4', '3', '1', '0', '15', '14', '4', '0', '58722344', '59770920', '0', '0', '0', '0', '0', '4388', '10497', '16612', '10528', '10531', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001469', '2', '2', '8', '0', '0', '2', '0', '0', '4', '0', '5', '3', '3', '2', '2', '19', '12', '6', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001470', '2', '2', '1', '0', '0', '1', '0', '0', '5', '1', '1', '4', '2', '0', '2', '30', '9', '13', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001471', '6', '2', '2', '0', '0', '4', '0', '0', '4', '1', '1', '2', '2', '1', '3', '82', '65', '61', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001472', '6', '2', '4', '0', '0', '8', '0', '0', '2', '0', '5', '5', '0', '2', '0', '66', '64', '58', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001473', '8', '2', '7', '0', '0', '6', '0', '0', '1', '0', '2', '0', '0', '3', '3', '82', '62', '55', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001474', '7', '2', '6', '0', '0', '8', '0', '0', '2', '1', '4', '1', '0', '0', '0', '18', '6', '4', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001475', '4', '2', '3', '0', '0', '7', '0', '0', '3', '1', '0', '1', '2', '2', '2', '64', '66', '58', '0', '0', '0', '0', '0', '0', '0', '0', '11307', '10433', '1632', '5376', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001476', '8', '2', '4', '0', '0', '2', '0', '0', '5', '1', '4', '5', '3', '0', '2', '13', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '11328', '1153', '1728', '5347', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001477', '8', '2', '8', '0', '0', '7', '0', '0', '5', '0', '3', '2', '0', '0', '1', '52', '55', '57', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '7424', '3148', '5121', '1060', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001478', '20971', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001479', '20971', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001480', '20971', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001481', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001482', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001483', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001484', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001485', '22', '2', '0', '0', '0', '1', '0', '0', '1', '0', '4', '0', '2', '1', '2', '17', '9', '15', '0', '0', '0', '0', '0', '0', '0', '0', '922657', '922848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001486', '23', '2', '0', '0', '0', '1', '0', '0', '2', '0', '5', '1', '2', '3', '0', '31', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '923968', '924001', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001487', '24', '2', '3', '0', '0', '1', '0', '0', '2', '0', '3', '4', '3', '1', '0', '9', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '924800', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001488', '25', '2', '0', '0', '0', '1', '0', '0', '5', '0', '0', '5', '1', '2', '2', '32', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '925826', '925890', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001489', '23', '2', '0', '0', '0', '1', '0', '0', '4', '0', '1', '2', '3', '2', '2', '6', '8', '13', '0', '0', '0', '0', '0', '0', '0', '0', '923713', '923747', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001490', '7', '2', '5', '0', '0', '5', '0', '0', '1', '0', '1', '3', '0', '2', '0', '19', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4130', '16417', '2048', '1024', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001491', '22', '2', '0', '0', '0', '1', '0', '0', '5', '1', '5', '3', '0', '3', '2', '8', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '922624', '923136', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001492', '8', '2', '5', '0', '0', '1', '0', '0', '0', '1', '1', '4', '3', '2', '2', '30', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001493', '5', '2', '2', '0', '0', '7', '0', '0', '4', '1', '2', '2', '1', '0', '3', '9', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001494', '9', '2', '1', '0', '0', '1', '0', '0', '1', '0', '2', '5', '2', '3', '2', '78', '53', '66', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001495', '4', '2', '3', '0', '0', '8', '0', '0', '1', '1', '2', '0', '3', '2', '3', '11', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001496', '6', '2', '4', '0', '0', '6', '0', '0', '5', '0', '4', '2', '2', '3', '3', '27', '10', '11', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001497', '5', '2', '1', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '58', '61', '60', '0', '862982145', '0', '0', '0', '0', '0', '0', '4355', '1124', '6401', '6339', '6400', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001498', '2', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001499', '3', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '7', '0', '168823829', '0', '0', '0', '0', '0', '0', '14464', '15553', '3298', '3200', '3200', '137216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001500', '3', '2', '8', '0', '0', '4', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20', '3', '11', '0', '79695883', '32515122', '0', '0', '0', '0', '0', '3200', '15553', '3328', '3200', '3200', '137216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001501', '2', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '5', '8', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001502', '7', '2', '7', '0', '0', '4', '31', '0', '0', '0', '0', '0', '0', '0', '0', '15', '4', '10', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001503', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '13', '6', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001504', '6', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '4', '7', '0', '0', '0', '0', '0', '0', '0', '0', '10432', '35268', '4356', '1024', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001505', '7', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001506', '4', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001507', '9', '2', '3', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '58', '62', '58', '0', '0', '0', '0', '0', '0', '0', '0', '20494', '5443', '5376', '1024', '9571', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001508', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '4', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001509', '7', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '2', '8', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001510', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '14', '7', '0', '383779842', '0', '0', '0', '0', '0', '0', '20496', '7424', '3148', '5121', '1060', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001511', '5', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '6', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001512', '9', '2', '5', '0', '0', '1', '31', '0', '0', '0', '0', '0', '0', '0', '0', '66', '62', '55', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001513', '8', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '5', '10', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001514', '8', '1', '3', '0', '0', '7', '0', '0', '0', '1', '1', '0', '0', '0', '0', '55', '55', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10368', '1664', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001515', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6848', '6848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001516', '21', '2', '41', '0', '0', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5888', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001517', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001518', '5', '2', '4', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '66', '66', '53', '0', '721421332', '0', '0', '0', '0', '0', '0', '0', '1122', '2208', '2114', '2082', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001519', '5', '2', '4', '0', '0', '6', '0', '0', '4', '1', '5', '1', '3', '1', '0', '62', '51', '55', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '32964', '9920', '6338', '6371', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001520', '5', '2', '3', '0', '0', '6', '0', '0', '3', '0', '3', '5', '1', '2', '3', '79', '60', '52', '0', '0', '0', '0', '0', '0', '0', '0', '23880', '2240', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001521', '4', '0', '6', '0', '0', '4', '0', '0', '1', '0', '0', '3', '1', '3', '0', '11', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '23884', '32929', '9856', '5376', '2112', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001522', '3', '1', '7', '0', '0', '4', '0', '0', '5', '0', '2', '0', '1', '2', '3', '10', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '23880', '2240', '16577', '10339', '8288', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001523', '6', '4', '2', '0', '0', '2', '0', '0', '5', '0', '3', '0', '3', '2', '0', '11', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '31937', '9856', '2240', '25792', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001524', '22', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922976', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001525', '1', '2', '7', '0', '0', '7', '0', '0', '3', '1', '2', '3', '3', '2', '0', '27', '2', '11', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001526', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001527', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001528', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001529', '8', '4', '2', '0', '0', '7', '1', '0', '0', '1', '0', '3', '0', '0', '0', '79', '59', '64', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '8192', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001530', '8', '0', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '8192', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001531', '7', '3', '4', '0', '0', '3', '31', '0', '4', '1', '5', '1', '3', '1', '3', '66', '56', '64', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '5282', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001532', '7', '4', '4', '0', '0', '1', '9', '0', '1', '0', '0', '3', '1', '3', '0', '25', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '5282', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001533', '5', '2', '4', '0', '0', '8', '0', '0', '4', '1', '5', '1', '3', '1', '0', '62', '53', '54', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '7330', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001534', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '7169', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001535', '4', '3', '6', '0', '0', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '67', '55', '57', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '7330', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001536', '6', '0', '2', '0', '0', '1', '16', '0', '0', '0', '0', '0', '0', '1', '0', '12', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '7331', '1024', '5378', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001537', '2', '2', '3', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '8192', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001538', '1', '2', '2', '0', '0', '1', '0', '0', '4', '1', '5', '1', '3', '1', '0', '28', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '7169', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001539', '3', '2', '8', '0', '0', '8', '22', '0', '0', '0', '0', '0', '0', '0', '0', '6', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '5282', '1024', '54272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001540', '2', '4', '6', '0', '0', '6', '9', '0', '3', '1', '2', '3', '3', '2', '0', '25', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '54272', '54272', '8192', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001541', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001542', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001543', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4098', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001544', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001553', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001554', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001555', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001556', '10854', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001557', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001558', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001559', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001560', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001561', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001562', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001563', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001564', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001565', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '30725', '30816', '2210', '1024', '25664', '30720', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001566', '4', '2', '2', '0', '0', '6', '26', '0', '4', '0', '1', '4', '0', '0', '3', '8', '8', '10', '0', '79693827', '0', '0', '0', '0', '0', '0', '23885', '15586', '3149', '11618', '8515', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001567', '25', '2', '0', '0', '0', '1', '0', '0', '0', '1', '1', '5', '2', '3', '1', '30', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '925763', '925795', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001568', '10', '2', '901', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '243270696', '0', '0', '0', '0', '0', '0', '0', '926720', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001569', '2', '2', '901', '0', '0', '33', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347082752', '0', '0', '0', '0', '0', '0', '0', '930816', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001570', '21', '2', '19', '0', '0', '19', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347083776', '0', '0', '0', '0', '0', '0', '0', '931840', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001571', '21', '2', '9', '0', '0', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '348130304', '0', '0', '0', '0', '0', '0', '0', '932864', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001572', '1', '2', '901', '0', '0', '33', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '928768', '928768', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001573', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001574', '3', '2', '5', '0', '0', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '23', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '7233', '34948', '10369', '10337', '5187', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001575', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '1', '0', '737152010', '0', '0', '0', '0', '0', '0', '21506', '32864', '9600', '2115', '2083', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001576', '1', '2', '1', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '10', '16', '0', '737152010', '0', '0', '0', '0', '0', '0', '20487', '32867', '9760', '2115', '9408', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001577', '5', '2', '2', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '10', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20491', '2211', '9632', '1024', '2243', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001578', '4', '2', '7', '0', '0', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '21569', '32930', '9664', '1024', '2114', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001579', '7', '2', '9', '0', '0', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '6', '0', '0', '0', '0', '0', '0', '0', '0', '21537', '1090', '9600', '2114', '2082', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001580', '9', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '51', '66', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2208', '2144', '1024', '25665', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001581', '6', '2', '4', '0', '0', '7', '16', '0', '0', '0', '0', '0', '0', '0', '0', '78', '63', '65', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '32769', '2049', '2305', '25601', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001582', '7', '2', '6', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '75', '65', '56', '0', '800065536', '0', '0', '0', '0', '0', '0', '0', '29793', '1024', '1024', '35874', '391168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001583', '4', '2', '6', '0', '0', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '8', '10', '11', '0', '347081739', '0', '0', '0', '0', '0', '0', '21696', '7587', '1024', '5348', '8257', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001584', '6', '2', '3', '0', '0', '7', '10', '0', '0', '0', '0', '0', '0', '0', '0', '68', '58', '51', '0', '0', '0', '0', '0', '0', '0', '0', '56416', '39233', '39584', '39105', '38916', '491520', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001585', '24', '2', '0', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '3', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '924769', '924864', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001586', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001587', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001588', '8', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '63', '65', '0', '0', '0', '0', '0', '0', '0', '0', '56352', '39200', '39616', '39105', '39168', '495616', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001589', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '3', '11', '0', '0', '0', '0', '0', '0', '0', '0', '1761', '1761', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001590', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001591', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001592', '2', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '56353', '39296', '39584', '39168', '39139', '495616', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001593', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '4837', '4992', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001594', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001595', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001596', '9', '2', '3', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '54', '54', '66', '0', '0', '0', '0', '0', '0', '0', '0', '21504', '32771', '4098', '6145', '6145', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001597', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '10', '5', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '33953', '4164', '11329', '21633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001598', '1', '2', '7', '0', '0', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '3', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '28801', '5217', '1024', '5348', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001599', '5', '2', '3', '0', '0', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '78', '61', '56', '0', '862979072', '0', '0', '0', '0', '0', '0', '4129', '32800', '9408', '5153', '6177', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001600', '3', '2', '2', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '33956', '2080', '5152', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001601', '1', '2', '2', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '32', '2', '8', '0', '862979072', '0', '0', '0', '0', '0', '0', '21664', '1058', '6177', '6179', '6179', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001602', '8', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '66', '53', '0', '58722324', '59770900', '0', '0', '0', '0', '0', '10283', '29767', '10272', '10465', '4196', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001603', '6', '2', '2', '0', '0', '4', '14', '0', '0', '0', '0', '0', '0', '0', '0', '76', '57', '66', '0', '878707712', '0', '0', '0', '0', '0', '0', '6304', '28673', '28673', '6147', '28674', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001604', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '10', '5', '0', '878707712', '0', '0', '0', '0', '0', '0', '6144', '35875', '28705', '6177', '6179', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001605', '1', '2', '5', '0', '0', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '9', '0', '0', '0', '0', '0', '0', '0', '0', '35842', '28672', '28674', '6145', '6144', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001606', '5', '2', '3', '0', '0', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '82', '64', '55', '0', '0', '0', '0', '0', '0', '0', '0', '23587', '35875', '28740', '6144', '28738', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001607', '2', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '9', '10', '0', '878707712', '0', '0', '0', '0', '0', '0', '6182', '28736', '6176', '6177', '28704', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001608', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '8', '0', '878707712', '0', '0', '0', '0', '0', '0', '6144', '4131', '28706', '6179', '28739', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001609', '7', '2', '4', '0', '0', '4', '31', '0', '0', '0', '0', '0', '0', '0', '0', '24', '6', '8', '0', '147850241', '0', '0', '0', '0', '0', '0', '23619', '8352', '4226', '5217', '8352', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001610', '3', '2', '5', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6183', '11299', '6179', '10304', '9280', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001611', '7', '2', '9', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23592', '11299', '9440', '9251', '25601', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001612', '25', '2', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '768607232', '0', '0', '0', '0', '0', '0', '925764', '925795', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001613', '8', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '4131', '4128', '6176', '9248', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001614', '5', '2', '2', '0', '0', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '54', '51', '55', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '4130', '2083', '6179', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001615', '1', '2', '7', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '9376', '9280', '11328', '9280', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001616', '1', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '12', '0', '79693844', '0', '0', '0', '0', '0', '0', '16577', '16544', '3170', '1024', '13377', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001617', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '2', '12', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001618', '2', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '2', '12', '0', '147852298', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001619', '7', '2', '3', '0', '0', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '12', '13', '14', '0', '147852298', '0', '0', '0', '0', '0', '0', '0', '16483', '3074', '1024', '13344', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001620', '4', '3', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '5', '10', '0', '168825856', '0', '0', '0', '0', '0', '0', '9476', '9412', '9472', '9289', '9344', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001621', '4', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '12', '0', '168823808', '0', '0', '0', '0', '0', '0', '4131', '9314', '9216', '9251', '9216', '8192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001622', '3', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '10', '10', '0', '168823828', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001623', '8', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '65', '66', '0', '168823828', '0', '0', '0', '0', '0', '0', '0', '9347', '9440', '9283', '9316', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001624', '7', '3', '2', '0', '0', '6', '5', '0', '0', '0', '0', '0', '0', '0', '0', '75', '62', '55', '0', '79697950', '0', '0', '0', '0', '0', '0', '10339', '10435', '10403', '5347', '10336', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001625', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '58', '51', '0', '79697930', '32510977', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001626', '6', '2', '4', '0', '0', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '74', '53', '60', '0', '79697940', '32510978', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001627', '5', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '69', '61', '66', '0', '79697940', '0', '0', '0', '0', '0', '0', '0', '10305', '10304', '5217', '10304', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001628', '2', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '3', '16', '0', '310379560', '0', '0', '0', '0', '0', '0', '7266', '7426', '1024', '1024', '25666', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001629', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '56', '54', '0', '0', '0', '0', '0', '0', '0', '0', '5281', '16481', '28739', '1024', '25665', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001630', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001631', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '16', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5249', '28897', '5188', '1024', '28704', '460800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001632', '8', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '5474', '28992', '7238', '1024', '1056', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001633', '3', '2', '3', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '28', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5568', '28960', '5345', '1024', '5441', '464896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001634', '2', '2', '5', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10', '14', '4', '0', '243270657', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001635', '4', '2', '8', '0', '0', '2', '31', '0', '0', '0', '0', '0', '0', '0', '0', '78', '54', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29952', '5344', '1024', '5472', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001636', '8', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '57', '60', '60', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '1216', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001637', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '8', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '16481', '14400', '9316', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001638', '1', '2', '8', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '15', '9', '8', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14624', '3106', '14624', '13379', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001639', '3', '2', '2', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '8', '2', '11', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '3137', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001640', '7', '4', '2', '0', '0', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '81', '57', '55', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '3137', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001641', '6', '2', '2', '0', '0', '8', '24', '0', '0', '0', '0', '0', '0', '0', '0', '81', '57', '58', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '3137', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001642', '5', '2', '1', '0', '0', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1', '12', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29857', '2081', '1024', '28736', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001643', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23591', '32841', '10337', '5188', '8225', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001644', '7', '4', '8', '0', '0', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '1090', '6211', '5251', '25665', '390144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001645', '7', '4', '7', '0', '0', '4', '31', '0', '0', '0', '0', '0', '0', '0', '0', '12', '8', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32992', '2208', '25696', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001646', '9', '4', '1', '0', '0', '1', '17', '0', '0', '0', '0', '0', '0', '0', '0', '53', '56', '56', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '2115', '1024', '1056', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001647', '4', '2', '7', '0', '0', '5', '24', '0', '0', '0', '0', '0', '0', '0', '0', '74', '63', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28742', '7234', '1024', '1056', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001648', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '1', '10', '0', '331351044', '0', '0', '0', '0', '0', '0', '9378', '7236', '7235', '5218', '5188', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001649', '3', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '4', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23884', '8323', '10304', '5187', '8260', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001650', '2', '2', '4', '0', '0', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '5', '0', '347079690', '0', '0', '0', '0', '0', '0', '7234', '4226', '7241', '5248', '5217', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001651', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6848', '6848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001652', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '0', '0', '0', '0', '0', '0', '24583', '1121', '10304', '25697', '25664', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001653', '8', '2', '2', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50176', '8864', '1024', '1056', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001654', '4', '3', '7', '0', '0', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '18', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50177', '15552', '1024', '8259', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001655', '6', '2', '4', '0', '2', '2', '28', '0', '0', '0', '0', '0', '0', '0', '0', '20', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50178', '8576', '1024', '1056', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001656', '2', '2', '8', '0', '0', '1', '11', '0', '0', '0', '0', '0', '0', '0', '0', '28', '15', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50179', '8768', '25697', '8256', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001657', '8', '2', '7', '0', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50179', '8768', '1024', '1057', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001658', '4', '2', '6', '0', '0', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '12', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '50178', '8576', '1024', '1056', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001659', '6', '2', '2', '0', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50177', '8448', '1024', '1152', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001660', '2', '2', '6', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '50176', '16064', '1024', '8288', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001661', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '50176', '8864', '1024', '8288', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001662', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '5', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50177', '8448', '25697', '8259', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001663', '5', '2', '1', '0', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '9', '13', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '50178', '8576', '1024', '1056', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001664', '3', '2', '8', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '19', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50179', '8768', '1024', '8256', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001665', '1', '2', '5', '0', '0', '7', '29', '0', '0', '0', '0', '0', '0', '0', '0', '28', '10', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50179', '8768', '25731', '1056', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001666', '7', '2', '7', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21698', '50178', '8576', '1024', '1056', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001667', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20484', '50177', '8448', '1024', '1058', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001668', '3', '2', '5', '0', '0', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '61', '53', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50176', '8864', '1024', '8288', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001669', '8', '2', '3', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50180', '8960', '1024', '1056', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001670', '4', '2', '8', '0', '0', '8', '22', '0', '0', '0', '0', '0', '0', '0', '0', '12', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50180', '8960', '1024', '1056', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001671', '2', '2', '5', '0', '0', '1', '20', '0', '0', '0', '0', '0', '0', '0', '0', '15', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '50180', '8960', '1024', '8288', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001672', '1', '2', '6', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '12', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '50180', '8960', '5217', '8288', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001673', '7', '2', '4', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '28', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '50180', '8960', '5217', '8288', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001674', '3', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '50180', '8960', '5217', '8288', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001675', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '10', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '50180', '8960', '5217', '8288', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001676', '20939', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001677', '20939', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001678', '20939', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001679', '20939', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001680', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3074', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001681', '7', '2', '6', '0', '0', '5', '0', '0', '5', '0', '5', '4', '3', '3', '2', '29', '14', '3', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001682', '1', '2', '8', '0', '0', '7', '31', '0', '2', '1', '2', '5', '2', '2', '2', '3', '1', '15', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001683', '8', '2', '1', '0', '0', '2', '0', '0', '0', '1', '3', '1', '2', '1', '3', '8', '13', '9', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001684', '1', '2', '7', '0', '0', '8', '26', '0', '3', '1', '1', '5', '1', '3', '0', '19', '9', '2', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001685', '9', '2', '4', '0', '0', '2', '0', '0', '0', '0', '5', '4', '0', '1', '1', '60', '64', '58', '0', '79697930', '32510977', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001686', '1', '2', '4', '0', '0', '1', '0', '0', '5', '1', '4', '5', '1', '3', '0', '2', '1', '2', '0', '79697940', '32510978', '0', '0', '0', '0', '0', '10339', '10435', '10403', '5347', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001687', '5', '2', '4', '0', '0', '4', '0', '0', '1', '0', '2', '3', '0', '2', '1', '65', '58', '54', '0', '347080704', '0', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001688', '2', '2', '2', '0', '0', '1', '0', '0', '4', '0', '2', '1', '2', '1', '1', '27', '15', '8', '0', '168823808', '0', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001689', '3', '2', '2', '0', '0', '8', '0', '0', '2', '0', '4', '1', '3', '1', '2', '20', '15', '10', '0', '210765824', '236979210', '0', '0', '0', '231736331', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001690', '1', '2', '5', '0', '0', '1', '0', '0', '5', '0', '2', '2', '1', '0', '1', '17', '4', '4', '0', '79692820', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001691', '8', '2', '7', '0', '0', '3', '0', '0', '3', '0', '2', '4', '2', '3', '2', '32', '9', '14', '0', '347079680', '0', '0', '0', '0', '231736331', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001692', '1', '2', '8', '0', '0', '7', '0', '0', '2', '1', '0', '3', '2', '1', '1', '8', '13', '8', '0', '168826881', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001693', '3', '2', '7', '0', '0', '8', '0', '0', '0', '1', '2', '5', '2', '2', '2', '4', '6', '15', '0', '210764840', '236979210', '0', '0', '0', '231736331', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001694', '7', '2', '3', '0', '0', '8', '0', '0', '1', '1', '2', '1', '0', '0', '2', '11', '2', '5', '0', '168826881', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001695', '5', '2', '2', '0', '0', '5', '0', '0', '1', '0', '2', '2', '2', '2', '1', '3', '1', '14', '0', '310379570', '0', '0', '0', '0', '0', '0', '0', '29762', '5312', '5155', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001696', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001697', '1', '2', '6', '0', '0', '1', '0', '0', '0', '0', '3', '2', '2', '2', '1', '25', '2', '10', '0', '383779841', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001698', '5', '2', '1', '0', '0', '6', '0', '0', '0', '0', '1', '0', '2', '3', '0', '60', '60', '60', '0', '347079681', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001699', '3', '2', '7', '0', '0', '7', '0', '0', '2', '0', '2', '3', '0', '3', '2', '24', '3', '3', '0', '79697930', '32510977', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001700', '5', '3', '4', '0', '0', '8', '0', '0', '1', '1', '2', '1', '3', '1', '0', '81', '55', '51', '0', '0', '0', '0', '0', '0', '0', '0', '9664', '5444', '16675', '5348', '10528', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001701', '6', '3', '3', '0', '0', '1', '0', '0', '2', '0', '4', '5', '0', '1', '0', '24', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '16577', '35266', '7332', '11426', '9476', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001702', '8', '2', '2', '0', '0', '3', '0', '0', '5', '1', '0', '2', '0', '2', '1', '28', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '33952', '9472', '10400', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001703', '2', '2', '2', '0', '0', '5', '0', '0', '4', '0', '1', '5', '2', '1', '0', '21', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10273', '8257', '9408', '8193', '8258', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001704', '7', '2', '2', '0', '0', '1', '0', '0', '3', '1', '2', '1', '2', '3', '1', '6', '9', '14', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001705', '4', '2', '1', '0', '0', '6', '0', '0', '5', '0', '5', '0', '2', '2', '1', '28', '11', '16', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001706', '6', '0', '1', '0', '0', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4384', '4384', '7297', '1024', '4352', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001707', '7', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10307', '6211', '1024', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001708', '3', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '8', '0', '210765824', '236979210', '0', '0', '0', '231736331', '0', '0', '9280', '9376', '9251', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001709', '2', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '4', '0', '79698945', '32514048', '0', '0', '0', '0', '0', '0', '31874', '4131', '11361', '13346', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001710', '1', '2', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '15', '5', '8', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '16481', '14400', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001711', '8', '1', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '15', '8', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '1216', '14624', '13379', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001712', '3', '2', '3', '0', '0', '8', '0', '0', '1', '0', '0', '4', '3', '2', '3', '22', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '10273', '7233', '5217', '1024', '28737', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001713', '8', '2', '8', '0', '0', '4', '0', '0', '4', '0', '2', '3', '2', '3', '3', '7', '7', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '34883', '10339', '1024', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001714', '9', '2', '4', '0', '0', '2', '0', '0', '1', '0', '3', '2', '2', '0', '2', '51', '59', '58', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '4224', '10304', '11360', '8225', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001715', '7', '2', '1', '0', '0', '8', '0', '0', '2', '1', '3', '5', '3', '3', '1', '24', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '35908', '2048', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001716', '5', '2', '1', '0', '0', '2', '0', '0', '0', '1', '4', '0', '2', '0', '0', '64', '62', '63', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001717', '2', '2', '1', '0', '0', '5', '0', '0', '0', '0', '5', '1', '2', '0', '1', '26', '8', '10', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001718', '1', '2', '7', '0', '0', '7', '31', '0', '3', '1', '3', '5', '0', '1', '1', '30', '3', '5', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '0', '29986', '3265', '1024', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001719', '3', '2', '2', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '14', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '0', '2112', '7424', '13696', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001720', '7', '2', '7', '0', '0', '1', '0', '0', '1', '1', '0', '1', '0', '0', '2', '15', '7', '16', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001721', '8', '2', '4', '0', '0', '3', '0', '0', '4', '1', '3', '5', '0', '2', '0', '24', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001722', '6', '2', '4', '0', '0', '5', '0', '0', '1', '1', '3', '1', '2', '3', '1', '12', '12', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001723', '1', '2', '4', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '2', '5', '7', '0', '752879636', '0', '0', '0', '0', '0', '0', '20507', '2304', '5312', '7392', '10532', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001724', '8', '2', '7', '0', '0', '8', '2', '0', '0', '0', '0', '0', '0', '0', '0', '62', '56', '60', '0', '752878604', '0', '0', '0', '0', '0', '0', '20496', '32836', '15648', '7328', '10370', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001725', '5', '2', '3', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '78', '58', '51', '0', '752878604', '0', '0', '0', '0', '0', '0', '25734', '2082', '5122', '7169', '10304', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001726', '22', '1', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '922659', '922848', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001727', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001728', '7', '3', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '66', '56', '0', '147850242', '0', '0', '0', '0', '0', '0', '2304', '3392', '3360', '3392', '3392', '220160', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001729', '5', '3', '4', '0', '0', '6', '3', '0', '0', '0', '0', '0', '0', '0', '0', '62', '58', '53', '0', '873464835', '0', '0', '0', '0', '0', '0', '6241', '10560', '28705', '6433', '25792', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001730', '8', '1', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '13', '9', '0', '747635722', '0', '0', '0', '0', '0', '0', '35904', '32963', '1696', '2081', '2304', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001731', '8', '2', '6', '0', '0', '4', '0', '0', '2', '1', '3', '2', '0', '2', '1', '9', '5', '11', '0', '0', '0', '0', '0', '0', '0', '0', '4193', '32866', '9280', '2115', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001732', '7', '2', '7', '0', '0', '5', '0', '0', '3', '1', '5', '0', '0', '1', '0', '28', '12', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1091', '2208', '2114', '9408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001733', '6', '2', '4', '0', '0', '3', '0', '0', '5', '1', '1', '2', '3', '1', '1', '82', '51', '57', '0', '0', '0', '0', '0', '0', '0', '0', '21504', '2145', '9664', '2114', '2082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001734', '1', '2', '7', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '8', '0', '79693825', '0', '0', '0', '0', '0', '0', '4193', '33953', '9760', '1024', '9380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001735', '3', '2', '7', '0', '0', '7', '0', '0', '4', '1', '5', '4', '3', '3', '3', '15', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '2147', '2080', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001736', '5', '2', '3', '0', '0', '6', '0', '0', '2', '0', '4', '3', '3', '0', '0', '78', '57', '61', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '1090', '9408', '5184', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001737', '7', '2', '7', '0', '0', '8', '0', '0', '1', '1', '0', '1', '3', '2', '2', '21', '8', '12', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001738', '3', '2', '8', '0', '0', '4', '0', '0', '1', '0', '3', '2', '3', '0', '3', '19', '4', '9', '0', '0', '0', '0', '0', '0', '0', '0', '46208', '46084', '1024', '46084', '46084', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001739', '1', '2', '7', '0', '0', '7', '4', '0', '5', '1', '4', '3', '2', '1', '2', '21', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '46240', '46085', '1024', '46085', '46085', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001740', '7', '2', '2', '0', '0', '8', '0', '0', '5', '1', '5', '0', '2', '3', '3', '12', '5', '14', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001741', '4', '2', '8', '0', '0', '4', '0', '0', '4', '0', '3', '2', '3', '0', '2', '22', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4417', '4417', '4128', '5152', '10529', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001742', '7', '2', '9', '0', '0', '1', '0', '0', '5', '1', '4', '4', '3', '1', '0', '25', '7', '12', '0', '0', '0', '0', '0', '0', '0', '0', '23880', '33955', '2117', '6214', '6214', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001743', '1', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '0', '2', '1', '0', '18', '14', '3', '0', '58722334', '59770910', '0', '0', '0', '0', '0', '5411', '10529', '5312', '5376', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001744', '8', '2', '2', '0', '0', '1', '0', '0', '4', '1', '1', '4', '0', '2', '2', '23', '14', '13', '0', '79694868', '32510983', '0', '0', '0', '0', '0', '11333', '8417', '15456', '11521', '15489', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001745', '6', '2', '3', '0', '0', '6', '0', '0', '5', '0', '2', '1', '2', '2', '0', '22', '1', '4', '0', '294652948', '0', '0', '0', '0', '0', '0', '0', '29955', '16608', '2240', '5472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001746', '1', '1', '6', '0', '0', '2', '0', '0', '3', '1', '1', '1', '1', '0', '2', '30', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '10273', '7171', '1024', '8194', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001747', '8', '3', '5', '0', '0', '3', '0', '0', '3', '1', '4', '2', '1', '2', '3', '23', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '31808', '1024', '6145', '25602', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001748', '1', '2', '4', '0', '0', '8', '0', '0', '0', '0', '4', '3', '1', '0', '1', '24', '2', '14', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001749', '7', '2', '6', '0', '0', '8', '0', '0', '1', '0', '0', '0', '3', '3', '1', '28', '1', '11', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001750', '4', '2', '6', '0', '0', '1', '0', '0', '1', '0', '5', '5', '3', '1', '3', '6', '7', '2', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001751', '1', '2', '6', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '12', '2', '2', '0', '79695882', '0', '0', '0', '0', '0', '0', '0', '8354', '3106', '10403', '8355', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001752', '7', '2', '9', '0', '0', '8', '28', '0', '0', '0', '0', '0', '0', '0', '0', '3', '4', '1', '0', '147853342', '0', '0', '0', '0', '0', '0', '0', '3104', '3147', '3104', '3104', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001753', '8', '2', '7', '0', '0', '5', '0', '0', '4', '1', '5', '1', '3', '2', '2', '71', '63', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10435', '39552', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001754', '4', '2', '4', '0', '0', '6', '12', '0', '5', '0', '2', '1', '3', '2', '3', '3', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '1441', '39552', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001755', '5', '3', '3', '0', '0', '3', '0', '0', '1', '1', '0', '3', '1', '2', '0', '27', '12', '7', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001756', '9', '2', '1', '0', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '82', '57', '58', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001757', '8', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '2', '8', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001758', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '2', '10', '0', '79697940', '32510977', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001759', '3', '2', '5', '0', '0', '7', '0', '0', '3', '1', '2', '2', '0', '0', '3', '8', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20483', '2145', '9408', '5185', '2080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001760', '2', '2', '6', '0', '0', '3', '0', '0', '0', '1', '0', '3', '2', '2', '3', '28', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '33024', '9440', '2048', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001761', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '3', '1', '1', '0', '23', '6', '1', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '32836', '2080', '2081', '9313', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001762', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001763', '20976', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001764', '7', '2', '1', '0', '0', '4', '4', '0', '4', '1', '3', '3', '2', '2', '3', '3', '14', '6', '0', '147850240', '0', '0', '0', '0', '0', '0', '23849', '10369', '16384', '5188', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001765', '6', '2', '4', '0', '0', '7', '0', '0', '4', '0', '3', '0', '0', '0', '0', '65', '63', '51', '0', '147852288', '0', '0', '0', '0', '0', '0', '25641', '10306', '15872', '1024', '2243', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001766', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '1', '2', '2', '2', '3', '12', '10', '5', '0', '147851264', '0', '0', '0', '0', '0', '0', '22528', '8256', '6213', '1024', '8257', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001767', '9', '3', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '60', '62', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001768', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001769', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001770', '2', '2', '4', '0', '0', '2', '9', '0', '3', '0', '0', '2', '3', '2', '0', '26', '5', '10', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '39424', '39168', '39139', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001771', '4', '2', '7', '0', '0', '4', '15', '0', '5', '0', '0', '0', '3', '2', '2', '19', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '39424', '39168', '39139', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001772', '8', '2', '2', '0', '0', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '76', '55', '56', '0', '79695882', '32506900', '0', '0', '0', '0', '0', '11276', '15396', '4098', '11424', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001773', '9', '2', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '62', '56', '56', '0', '210765825', '236979210', '0', '0', '0', '231736331', '0', '9473', '9472', '9440', '9344', '9345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001774', '4', '2', '6', '0', '0', '4', '31', '0', '0', '0', '0', '0', '0', '0', '0', '29', '5', '4', '0', '147853312', '0', '0', '0', '0', '0', '0', '23652', '8387', '8544', '8352', '21649', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001775', '7', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '2', '4', '0', '294652958', '0', '0', '0', '0', '0', '0', '0', '29985', '7168', '2274', '2210', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001776', '7', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '55', '58', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001777', '1', '1', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '16', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001778', '3', '1', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '4', '12', '0', '79697930', '32510976', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001779', '8', '3', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '8', '0', '79697930', '32510976', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001780', '5', '3', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '11', '15', '0', '79697930', '32510976', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001781', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '4', '5', '0', '2', '0', '21', '12', '10', '0', '0', '0', '0', '0', '0', '0', '0', '24866', '10528', '16704', '5376', '8384', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001782', '1', '2', '1', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '5', '1', '0', '79702016', '32508958', '0', '0', '0', '0', '0', '43008', '43008', '43008', '43008', '43008', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001783', '4', '2', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '5', '13', '0', '210766918', '236979200', '0', '0', '0', '231736331', '0', '9507', '9539', '9408', '9380', '9379', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001784', '8', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '3', '10', '0', '60818432', '61867008', '0', '0', '0', '0', '0', '45056', '45056', '45056', '45056', '45056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001785', '7', '2', '1', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '9', '15', '7', '0', '147853322', '0', '0', '0', '0', '0', '0', '8290', '8608', '8960', '8480', '8481', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001786', '3', '2', '1', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '9', '15', '7', '0', '173016064', '0', '0', '0', '0', '0', '0', '36864', '36864', '36864', '36864', '36864', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001787', '5', '2', '1', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '9', '15', '7', '0', '294651904', '0', '0', '0', '0', '0', '0', '40960', '40960', '40960', '40960', '40960', '40960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001788', '6', '2', '4', '4', '1', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '10', '9', '9', '0', '347081758', '0', '0', '0', '0', '0', '0', '0', '7584', '7394', '5410', '5442', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001789', '4', '2', '1', '0', '0', '6', '18', '0', '0', '0', '1', '4', '0', '3', '1', '32', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '49153', '8352', '3169', '5188', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001790', '6', '2', '3', '0', '0', '2', '0', '0', '5', '1', '2', '1', '3', '0', '3', '1', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '49153', '7299', '3106', '1024', '4193', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001791', '2', '2', '3', '0', '0', '5', '0', '0', '1', '0', '4', '0', '1', '0', '1', '5', '11', '16', '0', '0', '0', '0', '0', '0', '0', '0', '49153', '10339', '3139', '5218', '10337', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001792', '23', '2', '0', '0', '0', '1', '0', '0', '0', '1', '0', '0', '3', '1', '1', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '923809', '923746', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001793', '7', '2', '2', '0', '0', '5', '31', '0', '4', '1', '1', '0', '0', '3', '2', '28', '13', '8', '0', '147853322', '0', '0', '0', '0', '0', '0', '0', '15616', '15808', '5248', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001794', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '3', '5', '1', '0', '0', '12', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '28705', '7171', '1024', '4098', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001795', '6', '2', '3', '0', '0', '3', '0', '0', '2', '0', '5', '1', '3', '3', '2', '70', '55', '56', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '35904', '7232', '1024', '28737', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001796', '9', '2', '2', '0', '0', '2', '0', '0', '3', '0', '5', '4', '3', '1', '3', '54', '54', '58', '0', '862981120', '0', '0', '0', '0', '0', '0', '25632', '32867', '2112', '6221', '6209', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001797', '4', '2', '6', '0', '0', '1', '24', '0', '4', '0', '2', '3', '1', '2', '3', '28', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '5218', '39392', '1024', '38944', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001798', '8', '2', '2', '0', '0', '5', '5', '0', '3', '1', '5', '2', '0', '1', '3', '62', '55', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10338', '39616', '1024', '39137', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001799', '24', '2', '0', '0', '0', '1', '0', '0', '2', '0', '0', '5', '2', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '924801', '924706', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001800', '3', '2', '2', '0', '0', '1', '0', '0', '3', '0', '3', '3', '3', '2', '3', '69', '63', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33920', '39392', '1024', '28736', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001801', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001802', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5184', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001803', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001804', '3', '2', '5', '0', '0', '8', '0', '0', '5', '0', '0', '5', '3', '2', '3', '3', '10', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '16481', '5216', '1024', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001805', '8', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '51', '56', '0', '862982144', '0', '0', '0', '0', '0', '0', '20496', '5345', '28832', '5313', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001806', '4', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '5', '8', '0', '878707712', '0', '0', '0', '0', '0', '0', '6185', '28800', '28707', '6179', '6179', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001807', '7', '3', '1', '0', '0', '4', '24', '0', '0', '0', '0', '0', '0', '0', '0', '20', '4', '12', '0', '168823828', '0', '0', '0', '0', '0', '0', '9476', '9412', '9472', '9289', '9344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001808', '2', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '9', '11', '0', '168823828', '0', '0', '0', '0', '0', '0', '9476', '9412', '9472', '9289', '9344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001809', '3', '4', '5', '13', '0', '2', '13', '0', '1', '0', '0', '5', '0', '0', '0', '75', '55', '57', '0', '210765844', '236979210', '0', '0', '0', '231736332', '0', '0', '9568', '9504', '9312', '9345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001810', '8', '3', '6', '0', '0', '2', '30', '2', '5', '0', '1', '5', '2', '1', '0', '12', '3', '8', '0', '147852308', '0', '0', '0', '0', '0', '0', '16641', '16578', '3235', '1024', '13536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001811', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001812', '7', '2', '6', '0', '0', '5', '9', '0', '4', '0', '2', '5', '1', '2', '3', '5', '13', '3', '0', '79698954', '0', '0', '0', '0', '0', '0', '4192', '10304', '3138', '10403', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001813', '7', '2', '2', '0', '0', '1', '0', '0', '0', '1', '3', '2', '0', '1', '3', '29', '6', '5', '0', '168822815', '0', '0', '0', '0', '0', '0', '16577', '16544', '10338', '1024', '13377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001814', '7', '2', '3', '0', '0', '7', '0', '0', '3', '0', '5', '5', '3', '0', '1', '61', '59', '53', '0', '347081778', '0', '0', '0', '0', '0', '0', '16577', '16544', '10338', '1024', '13377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001815', '1', '4', '5', '0', '0', '7', '31', '2', '1', '0', '3', '0', '0', '1', '1', '22', '5', '2', '0', '79697970', '32510981', '0', '0', '0', '0', '0', '0', '10467', '10401', '5348', '10499', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001816', '3', '2', '8', '0', '0', '4', '0', '0', '5', '0', '1', '4', '3', '3', '3', '13', '11', '8', '0', '79697930', '32510976', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001817', '8', '2', '6', '0', '0', '4', '0', '0', '1', '0', '1', '4', '1', '3', '3', '18', '16', '6', '0', '168823808', '0', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001818', '5', '2', '2', '0', '0', '7', '0', '0', '5', '0', '2', '2', '1', '3', '1', '21', '4', '4', '0', '58722324', '59770900', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001819', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001820', '1', '2', '6', '0', '0', '2', '27', '0', '1', '1', '0', '0', '1', '2', '2', '24', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001821', '1', '2', '1', '0', '0', '8', '24', '0', '1', '0', '4', '0', '0', '0', '0', '10', '1', '3', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001822', '1', '2', '8', '0', '0', '7', '9', '0', '0', '0', '2', '2', '0', '3', '2', '16', '8', '3', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001823', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001824', '6', '2', '2', '0', '0', '5', '0', '0', '4', '0', '2', '5', '2', '3', '2', '32', '14', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '10273', '28704', '1024', '28704', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001825', '4', '2', '7', '0', '0', '6', '0', '0', '5', '1', '3', '1', '2', '2', '0', '21', '4', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '10273', '5155', '1024', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001826', '7', '2', '5', '0', '0', '8', '0', '0', '5', '1', '2', '5', '3', '3', '3', '29', '15', '6', '0', '0', '0', '0', '0', '0', '0', '0', '35841', '10273', '10304', '1024', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001827', '9', '2', '2', '0', '0', '4', '9', '0', '0', '1', '3', '2', '2', '3', '0', '77', '56', '54', '0', '0', '0', '0', '0', '0', '0', '0', '28864', '28832', '2116', '1024', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001828', '20979', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001829', '20979', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001830', '20979', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001831', '20979', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001832', '20979', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001833', '1', '2', '1', '0', '0', '2', '0', '0', '3', '0', '1', '2', '3', '1', '0', '14', '14', '6', '0', '147852288', '0', '0', '0', '0', '0', '0', '14370', '16483', '10304', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001834', '9', '2', '2', '0', '0', '2', '0', '0', '5', '1', '4', '2', '0', '3', '0', '81', '53', '53', '0', '210765836', '236979210', '0', '0', '0', '231736332', '0', '10528', '10467', '10401', '5348', '10499', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001835', '3', '2', '8', '0', '0', '3', '0', '0', '3', '1', '0', '5', '2', '3', '0', '21', '15', '13', '0', '210765844', '236979210', '0', '0', '0', '231736332', '0', '9441', '9568', '9504', '9312', '9345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001836', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001837', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001838', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001839', '24', '2', '1', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '924800', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001840', '8', '2', '7', '9', '0', '5', '2', '0', '0', '0', '0', '0', '0', '0', '0', '67', '55', '61', '0', '862979072', '0', '0', '0', '0', '0', '0', '0', '33860', '1024', '1024', '8224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001841', '2', '2', '7', '0', '0', '2', '0', '0', '5', '1', '0', '4', '1', '1', '3', '7', '6', '7', '0', '168823809', '0', '0', '0', '0', '0', '0', '0', '39200', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001842', '2', '2', '2', '0', '0', '1', '0', '0', '3', '0', '4', '0', '0', '0', '2', '13', '14', '5', '0', '168823809', '0', '0', '0', '0', '0', '0', '0', '39200', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001843', '2', '2', '3', '0', '0', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '4', '0', '168823809', '0', '0', '0', '0', '0', '0', '0', '39200', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001844', '8', '2', '3', '0', '0', '1', '0', '0', '5', '0', '3', '2', '0', '2', '1', '30', '11', '1', '0', '80741388', '0', '0', '0', '0', '0', '0', '0', '39168', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001845', '8', '2', '8', '0', '0', '3', '0', '0', '5', '1', '4', '1', '2', '0', '0', '8', '6', '11', '0', '80741388', '0', '0', '0', '0', '0', '0', '0', '39168', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001846', '8', '2', '2', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '4', '0', '80741388', '0', '0', '0', '0', '0', '0', '0', '39168', '39680', '39137', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001847', '6', '2', '4', '0', '0', '7', '0', '0', '0', '1', '0', '1', '0', '1', '3', '61', '56', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '39264', '39680', '39104', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001848', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '13', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '39264', '39680', '39104', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001849', '6', '2', '2', '0', '0', '5', '0', '0', '2', '1', '1', '3', '2', '2', '3', '6', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '39264', '39680', '39104', '39136', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001850', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001851', '10504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001852', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001853', '1', '3', '1', '0', '0', '7', '16', '0', '2', '0', '0', '4', '2', '1', '3', '18', '5', '16', '128', '79694869', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001854', '8', '2', '6', '0', '0', '3', '0', '0', '4', '1', '3', '2', '3', '1', '0', '1', '12', '11', '127', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001855', '4', '2', '5', '0', '0', '8', '31', '0', '2', '0', '1', '5', '3', '3', '0', '1', '7', '10', '127', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001856', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001857', '10043', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001858', '10043', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001859', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001860', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001861', '10047', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001862', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001863', '10509', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001864', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '2', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11424', '3147', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001865', '1', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '56', '58', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '11488', '3169', '11458', '15456', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001866', '1', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23655', '10369', '16387', '25696', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001867', '3', '1', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '2304', '5344', '1024', '10496', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001868', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1089', '5197', '1024', '4163', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001869', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '1', '6', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001870', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '11', '15', '0', '168821770', '0', '0', '0', '0', '0', '0', '19496', '14624', '3236', '14624', '10432', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001871', '1', '3', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '65', '63', '0', '210767912', '236979200', '0', '0', '0', '231736353', '0', '9761', '9856', '9856', '9505', '9603', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001872', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '11', '7', '0', '210766858', '236979210', '0', '0', '0', '231736332', '0', '9507', '9443', '9472', '9444', '9412', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001873', '7', '2', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '59', '57', '60', '0', '210764810', '236979210', '0', '0', '0', '231736331', '0', '9315', '9347', '9344', '9251', '9379', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001874', '3', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '14', '4', '0', '210764840', '236979210', '0', '0', '0', '231736350', '0', '9408', '9376', '9760', '9284', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001875', '2', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '6', '12', '0', '210766898', '236979200', '0', '0', '0', '231736351', '0', '9603', '9698', '9696', '9443', '9476', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001876', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001877', '8', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '8', '8', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '3138', '14624', '10339', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001878', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '10', '0', '168821790', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001879', '6', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '51', '54', '0', '347079684', '0', '0', '0', '0', '0', '0', '7266', '4290', '2114', '1024', '4321', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001880', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '3', '0', '168821810', '0', '0', '0', '0', '0', '0', '19499', '14688', '3297', '14720', '10496', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001881', '1', '2', '6', '0', '0', '1', '0', '0', '3', '1', '2', '5', '0', '0', '1', '24', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29923', '2113', '1024', '4197', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001882', '3', '2', '6', '0', '0', '8', '0', '0', '1', '0', '2', '0', '1', '2', '3', '15', '13', '14', '0', '768607243', '0', '0', '0', '0', '0', '0', '23585', '31875', '2113', '11360', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001883', '6', '3', '2', '0', '0', '7', '22', '0', '0', '0', '0', '0', '0', '0', '0', '74', '52', '55', '0', '878709770', '0', '0', '0', '0', '0', '0', '6304', '6528', '6496', '6275', '6464', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001884', '7', '2', '4', '0', '0', '5', '0', '0', '0', '0', '5', '0', '3', '3', '1', '6', '5', '8', '0', '705692683', '0', '0', '0', '0', '0', '0', '0', '1058', '6145', '9251', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001885', '9', '2', '3', '0', '0', '1', '30', '0', '3', '0', '1', '0', '1', '0', '0', '62', '52', '56', '0', '80741426', '32509982', '0', '0', '0', '0', '0', '0', '1154', '8896', '11617', '8576', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001886', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '7', '1', '0', '168823811', '0', '0', '0', '0', '0', '0', '12544', '8387', '8640', '13504', '13538', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001887', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '5', '1', '0', '0', '32507964', '0', '0', '0', '0', '0', '8289', '8417', '8640', '11490', '8448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001888', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '4', '1', '0', '210766850', '236979200', '0', '0', '0', '231736351', '0', '12800', '8418', '8640', '9505', '8481', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001889', '9', '2', '5', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '66', '66', '53', '0', '168825866', '0', '0', '0', '0', '0', '0', '21569', '8448', '8576', '14592', '15521', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001890', '3', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '57', '51', '60', '0', '347079685', '0', '0', '0', '0', '0', '0', '7396', '1122', '8640', '13600', '13602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001891', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '13', '1', '0', '210764830', '236979200', '0', '0', '0', '231736351', '0', '15490', '8386', '8608', '11520', '9537', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001892', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '11297', '4131', '11296', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001893', '6', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '55', '62', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '1377', '5154', '1024', '25633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001894', '1', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '4', '4', '0', '79697940', '0', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001896', '2', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '10', '5', '0', '168825856', '0', '0', '0', '0', '0', '0', '9476', '9412', '9472', '9289', '9344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001900', '2', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '9', '13', '0', '347079683', '0', '0', '0', '0', '0', '0', '7233', '7364', '7171', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001901', '3', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '7', '15', '0', '210766858', '236979200', '0', '0', '0', '231736352', '0', '9441', '9568', '9504', '9312', '9345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001903', '1', '3', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '5', '4', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001904', '3', '2', '4', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '14', '1', '10', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '3137', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001906', '4', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '13', '10', '0', '147852299', '0', '0', '0', '0', '0', '0', '16641', '16578', '3235', '1024', '13536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001911', '5', '2', '3', '0', '0', '2', '3', '0', '0', '0', '0', '0', '0', '0', '0', '58', '63', '55', '0', '310379550', '0', '0', '0', '0', '0', '0', '7234', '35012', '4167', '5218', '10370', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001913', '5', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '56', '61', '61', '0', '79692850', '1049600', '0', '0', '0', '0', '0', '13568', '11522', '10369', '13569', '13600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001914', '5', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '2', '13', '0', '79697960', '0', '0', '0', '0', '0', '0', '10528', '10467', '10401', '5348', '10499', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001916', '6', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '13', '16', '0', '347079690', '1049600', '0', '0', '0', '0', '0', '7267', '4224', '7241', '5248', '5284', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001921', '7', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '12', '10', '0', '243270657', '1049600', '0', '0', '0', '0', '0', '16576', '16544', '5312', '1024', '6496', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001922', '7', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '10', '0', '147850260', '0', '0', '0', '0', '0', '0', '14465', '14563', '8608', '14563', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001925', '7', '3', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '2', '4', '0', '79697930', '0', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001926', '8', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '57', '52', '54', '0', '210765825', '236979210', '0', '0', '0', '231736331', '0', '9378', '14528', '4170', '9281', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001927', '8', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '15', '2', '0', '79695882', '0', '0', '0', '0', '0', '0', '14496', '12640', '10369', '10432', '21638', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001928', '8', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '5', '2', '0', '347079690', '1049600', '0', '0', '0', '0', '0', '7234', '4224', '7237', '5248', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001931', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '52', '60', '0', '79697930', '0', '0', '0', '0', '0', '0', '10339', '10435', '10403', '5347', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001932', '9', '0', '4', '0', '0', '1', '9', '0', '2', '0', '1', '1', '1', '3', '0', '76', '53', '66', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '28800', '28800', '1024', '28800', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001936', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001937', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001938', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001951', '1', '2', '3', '0', '0', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '3', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '28960', '25664', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001952', '1', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '9', '14', '0', '147852288', '0', '0', '0', '0', '0', '0', '16577', '16544', '10338', '1024', '13377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001953', '1', '2', '5', '0', '0', '7', '25', '0', '0', '0', '0', '0', '0', '0', '0', '11', '2', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35937', '2208', '25697', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001954', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001955', '3', '3', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '1', '9', '0', '80741376', '32515092', '0', '0', '0', '0', '0', '15680', '15840', '3137', '8320', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001956', '2', '3', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '2', '4', '0', '79697960', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001957', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001960', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001961', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001962', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001963', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001964', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001965', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851276', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001966', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001967', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001968', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001969', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001970', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001971', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001972', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001973', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001974', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001975', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001976', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001977', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001978', '1', '2', '1', '0', '0', '1', '0', '0', '2', '1', '0', '3', '2', '1', '1', '8', '5', '1', '0', '168823809', '0', '0', '0', '0', '0', '0', '8289', '8417', '8640', '11490', '8448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001979', '1', '3', '1', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '1', '4', '1', '0', '147850241', '0', '0', '0', '0', '0', '0', '12800', '8419', '8640', '9505', '8481', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001980', '1', '2', '5', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '1', '7', '16', '0', '210764800', '236979210', '0', '0', '0', '231736331', '0', '12544', '8386', '8640', '9408', '13538', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001981', '1', '2', '2', '0', '0', '8', '20', '0', '3', '1', '4', '5', '1', '0', '2', '20', '14', '10', '0', '294650880', '0', '0', '0', '0', '0', '0', '7300', '34848', '28676', '7168', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001982', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001983', '3', '3', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '5', '10', '0', '173016064', '0', '0', '0', '0', '0', '0', '36864', '36864', '36864', '36864', '36864', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001984', '1', '2', '1', '0', '0', '1', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '80741396', '32510979', '0', '0', '0', '0', '0', '8290', '11587', '3144', '11492', '10465', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001985', '7', '3', '8', '0', '0', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '57', '57', '58', '0', '147856384', '0', '0', '0', '0', '0', '0', '0', '37888', '37888', '37888', '37888', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001986', '8', '2', '1', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5', '9', '9', '0', '0', '0', '0', '0', '0', '0', '0', '11319', '16512', '38976', '1024', '38914', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001987', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '38916', '5188', '38916', '38924', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001988', '6', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '38923', '30721', '39424', '1024', '38923', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001989', '3', '2', '5', '5', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '5', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '38921', '5190', '38918', '39138', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001990', '8', '2', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '56', '54', '0', '0', '0', '0', '0', '0', '0', '0', '38922', '30725', '39424', '1024', '38922', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001991', '6', '2', '1', '0', '0', '8', '13', '0', '0', '0', '0', '0', '0', '0', '0', '59', '63', '55', '0', '0', '0', '0', '0', '0', '0', '0', '11314', '16673', '1664', '1024', '38920', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001992', '7', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '66', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '38947', '5190', '38912', '39138', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001993', '2', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '9', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '30723', '39424', '38913', '38925', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001994', '8', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '60', '64', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '10369', '1024', '4259', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001995', '9', '2', '3', '0', '0', '2', '5', '0', '2', '0', '4', '2', '3', '2', '0', '62', '55', '56', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '39200', '39680', '39137', '39168', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001996', '8', '1', '7', '0', '0', '5', '5', '0', '1', '1', '1', '0', '3', '0', '0', '82', '63', '53', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '34946', '39648', '1024', '5186', '0', '0', '109568', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001997', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001998', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1001999', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002000', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002001', '1', '2', '2', '22', '0', '7', '27', '0', '3', '1', '2', '0', '3', '3', '0', '32', '6', '11', '0', '168822815', '0', '0', '0', '0', '0', '0', '0', '15744', '7238', '11584', '15744', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002002', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002003', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002004', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002005', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002006', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002007', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002008', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002009', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002010', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002011', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002012', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002013', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002014', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002015', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6145', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002016', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6146', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002017', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6208', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002018', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6209', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002019', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6210', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002020', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6176', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002021', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6177', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002022', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6178', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002023', '9', '2', '3', '11', '0', '4', '1', '0', '3', '0', '2', '1', '2', '3', '0', '62', '64', '62', '0', '65012736', '66061312', '0', '0', '0', '0', '0', '45057', '1154', '45057', '45057', '45057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002024', '3', '2', '2', '0', '0', '8', '15', '0', '2', '1', '5', '4', '3', '1', '0', '20', '5', '6', '0', '210765844', '236979200', '0', '0', '0', '231736333', '0', '9604', '14658', '28928', '9505', '9603', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002025', '10', '2', '901', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '243270696', '243270706', '0', '0', '0', '0', '0', '0', '926720', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002026', '10052', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002027', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '71', '55', '53', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002028', '8', '1', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '7', '3', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002029', '1', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '1', '2', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002030', '1', '1', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '5', '9', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002031', '7', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '4', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002032', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '7', '7', '0', '1049600', '168821760', '0', '0', '0', '0', '0', '19498', '14624', '3106', '11332', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002033', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '13', '2', '0', '1049600', '168821760', '0', '0', '0', '0', '0', '19498', '14624', '3106', '11332', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002034', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '10', '13', '0', '1049600', '168821760', '0', '0', '0', '0', '0', '19498', '14624', '3106', '11332', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002035', '1', '2', '2', '0', '0', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '28', '14', '15', '0', '147851287', '0', '0', '0', '0', '0', '0', '23851', '8512', '15936', '14658', '9504', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002036', '4', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '8', '0', '210764830', '236979210', '0', '0', '0', '231736331', '0', '9602', '9697', '7392', '14562', '9601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002037', '2', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '8', '0', '210764840', '236979210', '0', '0', '0', '231736331', '0', '9473', '9698', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002038', '1', '2', '7', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '8', '0', '210767873', '236979210', '0', '0', '0', '231736331', '0', '14465', '9699', '9280', '14465', '13506', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002039', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '73', '55', '66', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '5220', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002040', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '11', '14', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '5220', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002041', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '6', '16', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '5220', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002042', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '7', '8', '0', '243270656', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002043', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002044', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002045', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002046', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002047', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '16545', '16545', '1024', '25668', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002048', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002049', '1', '3', '6', '0', '0', '2', '16', '0', '2', '0', '0', '4', '2', '1', '3', '18', '5', '3', '128', '79694869', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002050', '1', '3', '8', '0', '0', '7', '16', '0', '2', '0', '0', '4', '2', '1', '3', '5', '14', '5', '128', '79694869', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002051', '9', '2', '901', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79700992', '32516096', '0', '0', '0', '0', '0', '0', '934912', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002052', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '243270686', '0', '0', '0', '0', '0', '0', '11364', '5188', '11360', '15424', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002053', '7', '3', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '64', '53', '57', '0', '79695902', '0', '0', '0', '0', '0', '0', '11301', '11460', '4225', '11459', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002054', '7', '1', '4', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '3', '0', '147859456', '147859456', '0', '0', '0', '0', '0', '16577', '16544', '10338', '1024', '13377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002055', '7', '3', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '3', '0', '79694848', '32508928', '0', '0', '0', '0', '0', '14370', '16483', '10304', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002056', '7', '2', '5', '0', '0', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '2', '0', '310379580', '0', '0', '0', '0', '0', '0', '0', '16483', '5191', '1024', '21646', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002057', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '8', '6', '0', '310379570', '0', '0', '0', '0', '0', '0', '0', '4194', '7329', '1024', '5280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002058', '5', '2', '1', '0', '0', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '24', '3', '13', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '14368', '4194', '10274', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002059', '2', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '6', '12', '0', '210767873', '236979200', '0', '0', '0', '231736331', '0', '5282', '4194', '9632', '9377', '9377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002060', '3', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '1', '4', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002061', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '13', '6', '0', '168821790', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002062', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002063', '10525', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002064', '10525', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002065', '1', '2', '7', '0', '0', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16675', '5284', '1024', '5444', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002066', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '2', '10', '0', '79693826', '32510977', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002067', '9', '2', '3', '0', '0', '2', '5', '0', '2', '0', '4', '2', '3', '2', '0', '62', '55', '56', '0', '705692752', '0', '0', '0', '0', '0', '0', '19467', '38915', '39008', '39137', '38922', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002068', '9', '2', '3', '0', '0', '2', '5', '0', '2', '0', '4', '2', '3', '2', '0', '62', '55', '56', '0', '0', '0', '0', '0', '0', '0', '0', '11458', '38919', '39424', '39137', '39168', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002069', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002070', '5', '3', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '9', '0', '310379590', '0', '0', '0', '0', '0', '0', '20507', '7589', '16641', '3265', '9504', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002071', '21', '2', '0', '0', '0', '41', '0', '0', '0', '1', '2', '5', '0', '3', '0', '14', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '1792', '1792', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002072', '21', '2', '51', '0', '0', '51', '0', '0', '0', '0', '3', '2', '3', '0', '0', '22', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '2816', '2816', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002073', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '1728', '1728', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002074', '3', '3', '4', '0', '0', '8', '27', '0', '0', '0', '0', '0', '0', '0', '0', '77', '65', '52', '10', '294650970', '0', '0', '0', '0', '0', '0', '7297', '7489', '7332', '1024', '5377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002075', '7', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '15', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002076', '3', '2', '8', '0', '0', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '21', '15', '13', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002077', '5', '2', '3', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '62', '63', '61', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002078', '8', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60417', '60417', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002079', '8', '2', '2', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60416', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002080', '8', '2', '7', '0', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60418', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002081', '8', '2', '3', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60418', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002082', '2', '2', '5', '0', '0', '1', '20', '0', '0', '0', '0', '0', '0', '0', '0', '15', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60417', '60417', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002083', '4', '2', '8', '0', '0', '8', '22', '0', '0', '0', '0', '0', '0', '0', '0', '12', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60416', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002084', '2', '2', '6', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60416', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002085', '4', '2', '6', '0', '0', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60417', '60417', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002086', '6', '2', '2', '0', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60418', '60416', '1024', '60416', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002087', '7', '2', '8', '0', '0', '4', '24', '0', '0', '0', '0', '0', '0', '0', '0', '24', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002088', '7', '2', '8', '0', '0', '4', '24', '0', '0', '0', '0', '0', '0', '0', '0', '24', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002089', '7', '2', '8', '0', '0', '4', '24', '0', '0', '0', '0', '0', '0', '0', '0', '24', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002090', '1', '2', '6', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '7', '5', '16', '0', '210766849', '236979210', '0', '0', '0', '231736331', '0', '4131', '14497', '3138', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002091', '4', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '13', '3', '0', '168825856', '0', '0', '0', '0', '0', '0', '4131', '14497', '3138', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002092', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002093', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002094', '1', '2', '6', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '12', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '60449', '60449', '1024', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002095', '3', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '60450', '60450', '1024', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002096', '7', '2', '4', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '28', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '60448', '60448', '1024', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002097', '9', '2', '3', '0', '0', '2', '5', '0', '2', '0', '4', '2', '3', '2', '0', '62', '55', '56', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '60450', '60450', '39137', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002098', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '60448', '60448', '1024', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002099', '5', '2', '1', '0', '0', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '9', '13', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60449', '60449', '1024', '60448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002100', '8', '1', '7', '0', '0', '5', '5', '0', '1', '1', '1', '0', '3', '0', '0', '82', '63', '53', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '34946', '39648', '1024', '5186', '0', '0', '109568', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002101', '5', '2', '3', '0', '0', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '62', '62', '51', '0', '0', '0', '0', '0', '0', '0', '0', '16611', '28864', '5198', '5251', '38925', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002102', '1', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '12', '0', '79693844', '0', '0', '0', '0', '0', '0', '16577', '16544', '3170', '1024', '13377', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002103', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '2', '12', '0', '147852288', '0', '0', '0', '0', '0', '0', '14368', '16416', '3072', '1024', '13314', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002104', '2', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '2', '12', '0', '147852298', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002105', '7', '2', '3', '0', '0', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '12', '13', '14', '0', '147852298', '0', '0', '0', '0', '0', '0', '0', '16483', '3074', '1024', '13344', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002106', '4', '3', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '5', '10', '0', '168825856', '0', '0', '0', '0', '0', '0', '9476', '9412', '9472', '9289', '9344', '185344', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002107', '4', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '12', '0', '168823808', '0', '0', '0', '0', '0', '0', '4131', '9314', '9216', '9251', '9216', '8192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002108', '3', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '10', '10', '0', '168823828', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002109', '8', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '65', '66', '0', '168823828', '0', '0', '0', '0', '0', '0', '0', '9347', '9440', '9283', '9316', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002110', '7', '3', '2', '0', '0', '6', '5', '0', '0', '0', '0', '0', '0', '0', '0', '75', '62', '55', '0', '79697950', '0', '0', '0', '0', '0', '0', '10339', '10435', '10403', '5347', '10336', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002111', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '58', '51', '0', '79697930', '32510977', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002112', '6', '2', '4', '0', '0', '8', '3', '0', '0', '0', '0', '0', '0', '0', '0', '74', '53', '60', '0', '79697940', '32510978', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002113', '5', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '69', '61', '66', '0', '79697940', '0', '0', '0', '0', '0', '0', '0', '10305', '10304', '5217', '10304', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002114', '24', '2', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '924802', '924705', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002115', '9', '2', '3', '0', '0', '2', '5', '0', '2', '0', '4', '2', '3', '2', '0', '62', '55', '56', '0', '80741406', '32508958', '0', '0', '0', '0', '0', '15808', '39200', '39680', '39137', '39168', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1002116', '5', '2', '4', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '65', '54', '56', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '36064', '16675', '1024', '35904', '0', '0', '5120', '5120', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060001', '7', '2', '5', '0', '0', '5', '0', '0', '1', '0', '1', '3', '0', '2', '0', '19', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4130', '16417', '2048', '1024', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060002', '6', '2', '901', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '929792', '929792', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060003', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '169870336', '0', '0', '0', '0', '0', '0', '0', '933888', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060004', '1', '3', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '5', '4', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060008', '9', '2', '901', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79700992', '32516096', '0', '0', '0', '0', '0', '934912', '934912', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060009', '3', '2', '5', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '1', '1', '0', '383779883', '0', '0', '0', '0', '0', '0', '0', '935936', '7298', '7392', '8288', '464896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060010', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060011', '3', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '2306', '2145', '5348', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060012', '5', '2', '3', '18', '0', '6', '31', '3', '0', '0', '0', '0', '0', '0', '0', '67', '62', '63', '0', '0', '0', '0', '0', '0', '0', '0', '10528', '4384', '5345', '5312', '10528', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060013', '6', '2', '4', '0', '0', '6', '28', '0', '0', '0', '0', '0', '0', '0', '0', '12', '6', '11', '0', '0', '0', '0', '0', '0', '0', '0', '18688', '7649', '2144', '7456', '5184', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060014', '5', '2', '4', '10', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '31072', '10464', '10400', '11586', '8417', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060015', '4', '2', '7', '0', '1', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '58', '59', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '35968', '5312', '1024', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060016', '7', '2', '3', '0', '0', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '51', '62', '54', '0', '0', '0', '0', '0', '0', '0', '0', '30976', '2272', '10496', '5376', '10531', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060017', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060018', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060019', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060021', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060022', '3', '2', '901', '0', '0', '33', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '11', '9', '0', '347080744', '0', '0', '0', '0', '0', '0', '0', '13824', '4160', '3104', '3264', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060024', '7', '2', '7', '0', '0', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '26', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '21698', '46086', '1024', '46086', '46086', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060025', '1', '2', '7', '21', '0', '2', '8', '0', '4', '0', '4', '1', '3', '1', '0', '12', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '22643', '46087', '1024', '46087', '46087', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060026', '4', '2', '6', '1', '0', '1', '24', '0', '3', '0', '1', '5', '2', '0', '0', '79', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '46088', '1024', '46088', '46088', '0', '0', '111616', '111616', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060027', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '15', '3', '0', '212861953', '236982273', '0', '0', '0', '231736333', '0', '21698', '41985', '39616', '41985', '2177', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060028', '7', '2', '5', '0', '0', '8', '2', '0', '3', '0', '1', '3', '2', '3', '0', '55', '57', '58', '0', '147856384', '0', '0', '0', '0', '0', '0', '37888', '37888', '37888', '37888', '37888', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060029', '21', '2', '32', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4994', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060030', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060031', '1', '2', '6', '0', '0', '8', '27', '0', '2', '0', '2', '2', '0', '0', '0', '10', '14', '3', '0', '79695902', '0', '0', '0', '0', '0', '0', '23884', '10465', '16609', '11616', '13634', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060032', '9', '2', '3', '11', '0', '4', '1', '0', '3', '0', '2', '1', '2', '3', '0', '62', '64', '62', '0', '65012736', '66061312', '0', '0', '0', '0', '0', '45057', '45057', '45057', '45057', '45057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060033', '1', '2', '7', '18', '0', '7', '0', '0', '5', '1', '4', '2', '2', '3', '0', '17', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20640', '35232', '16544', '1024', '10434', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060034', '5', '2', '2', '0', '0', '6', '0', '0', '1', '0', '2', '2', '1', '3', '1', '51', '63', '52', '0', '310380544', '0', '0', '0', '0', '0', '0', '40992', '40992', '40992', '40992', '40992', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060035', '6', '2', '4', '0', '0', '4', '14', '0', '1', '1', '4', '1', '3', '1', '0', '82', '60', '63', '0', '310380544', '0', '0', '0', '0', '0', '0', '41056', '41056', '41056', '41056', '41056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060036', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2052', '1088', '0', '2050', '1027', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060037', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '2080', '1056', '0', '2080', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060038', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060039', '3', '2', '7', '0', '0', '8', '29', '0', '2', '1', '5', '4', '3', '1', '0', '17', '5', '6', '0', '212861952', '0', '0', '0', '0', '0', '0', '9604', '28742', '28928', '1024', '9412', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060040', '3', '2', '5', '0', '0', '1', '5', '0', '2', '1', '1', '4', '0', '1', '0', '56', '65', '58', '0', '173016065', '0', '0', '0', '0', '0', '0', '36865', '36865', '36865', '36865', '36865', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060041', '7', '2', '4', '20', '0', '6', '18', '0', '5', '0', '5', '2', '3', '3', '0', '27', '13', '13', '0', '79702016', '32517120', '0', '0', '0', '0', '0', '43008', '43008', '43008', '43008', '43008', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060042', '1', '2', '7', '0', '0', '8', '9', '0', '4', '1', '5', '2', '2', '0', '0', '26', '5', '10', '0', '80741396', '32510978', '0', '0', '0', '0', '0', '0', '43008', '43008', '43008', '46089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1060043', '9', '2', '5', '0', '0', '2', '27', '0', '0', '0', '0', '0', '0', '0', '0', '32', '3', '55', '0', '721421362', '1049600', '0', '0', '0', '0', '0', '1024', '1154', '2240', '2274', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070001', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '13', '1', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070002', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '1', '12', '3', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070003', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '7', '9', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070004', '3', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '58', '52', '10', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070005', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '10', '11', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070006', '4', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '62', '58', '12', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070007', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '12', '2', '5', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070008', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '63', '63', '6', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070009', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '9', '7', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070010', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '66', '62', '8', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070011', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '8', '15', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070012', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '53', '58', '16', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070013', '7', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '14', '17', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070014', '7', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '62', '55', '18', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070015', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '59', '51', '13', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070016', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '4', '4', '79692860', '32507914', '0', '0', '0', '0', '0', '14369', '15392', '15360', '8224', '15456', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070017', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '13', '1', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070018', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '1', '12', '3', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070019', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '7', '9', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070020', '3', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '58', '52', '10', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070021', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '10', '11', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070022', '4', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '62', '58', '12', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070023', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '12', '2', '5', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070024', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '63', '63', '6', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070025', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '9', '7', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070026', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '66', '62', '8', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070027', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '8', '15', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070028', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '53', '58', '16', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070029', '7', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '14', '17', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070030', '7', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '62', '55', '18', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070031', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '59', '51', '13', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070032', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '4', '4', '168823828', '0', '0', '0', '0', '0', '0', '12353', '12386', '7238', '14464', '13409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070033', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '13', '1', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070034', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '1', '12', '3', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070035', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '7', '9', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070036', '3', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '58', '52', '10', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070037', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '10', '11', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070038', '4', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '62', '58', '12', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070039', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '12', '2', '5', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070040', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '63', '63', '6', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070041', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '9', '7', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070042', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '66', '62', '8', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070043', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '8', '15', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070044', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '53', '58', '16', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070045', '7', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '14', '17', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070046', '7', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '62', '55', '18', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070047', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '59', '51', '13', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070048', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '4', '4', '210764820', '236979200', '0', '0', '0', '231736350', '0', '9473', '9409', '9312', '9286', '9313', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070049', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '13', '1', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070050', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '1', '12', '3', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070051', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '7', '9', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070052', '3', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '58', '52', '10', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070053', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '10', '11', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070054', '4', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '62', '58', '12', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070055', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '12', '2', '5', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070056', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '63', '63', '6', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070057', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '9', '7', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070058', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '66', '62', '8', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070059', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '8', '15', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070060', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '53', '58', '16', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070061', '7', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '14', '17', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070062', '7', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '62', '55', '18', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070063', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '59', '51', '13', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070064', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '4', '4', '331351042', '0', '0', '0', '0', '0', '0', '7204', '7236', '7238', '5218', '5218', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070065', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '13', '1', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070066', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '1', '12', '3', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070067', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '7', '9', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070068', '3', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '58', '52', '10', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070069', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '10', '11', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070070', '4', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '62', '58', '12', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070071', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '12', '2', '5', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070072', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '63', '63', '6', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070073', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '9', '7', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070074', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '66', '62', '8', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070075', '8', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '8', '15', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070076', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '53', '58', '16', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070077', '7', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '14', '17', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070078', '7', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '62', '55', '18', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070079', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '59', '51', '13', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070080', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '4', '4', '294650900', '0', '0', '0', '0', '0', '0', '0', '29770', '7245', '13441', '10337', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070081', '1', '2', '2', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '1', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070082', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '1', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070083', '1', '2', '1', '0', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '1', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070084', '2', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '4', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070085', '2', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '4', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070086', '2', '2', '9', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '4', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070087', '3', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '10', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070088', '3', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '10', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070089', '3', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '10', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070090', '4', '2', '7', '0', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '11', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070091', '4', '2', '7', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '11', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070092', '4', '2', '7', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '11', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070093', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '6', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070094', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '6', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070095', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '6', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070096', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '7', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070097', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '7', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070098', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '7', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070099', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '17', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070100', '7', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '17', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070101', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '17', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070102', '8', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '15', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070103', '8', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '15', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070104', '8', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '15', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070105', '9', '2', '1', '0', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '13', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070106', '9', '2', '1', '0', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '13', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070107', '9', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '13', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070108', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070109', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070110', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070111', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070112', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070113', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070114', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070115', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1070116', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080001', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080002', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080003', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080004', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080005', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080006', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080007', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080008', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080009', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080010', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080011', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080012', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080013', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080014', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080015', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080016', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080017', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080018', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080019', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080020', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080021', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080022', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080023', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080024', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080025', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080026', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080027', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080028', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080029', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080030', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080031', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080032', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080033', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080034', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080035', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080036', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080037', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080038', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080039', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080040', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080041', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080042', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080043', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080044', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080045', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080046', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080047', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080048', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080049', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080050', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080051', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080052', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080053', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080054', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26624', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080055', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080056', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080057', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26624', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080058', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080059', '10709', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080060', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080061', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080062', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080063', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080064', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080065', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080066', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080067', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080068', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080069', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080070', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080071', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080072', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080073', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080074', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080075', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080076', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080077', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080081', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080082', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080083', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080084', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080085', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080086', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080087', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080088', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080089', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080090', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080091', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080092', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080093', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080094', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080095', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080096', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080097', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080098', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080099', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080100', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080101', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080102', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080103', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080104', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080105', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080106', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080107', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080108', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080109', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080110', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080111', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080112', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080113', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080114', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080115', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080116', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080120', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080121', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080122', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1080136', '20993', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090001', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090002', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090003', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090004', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090005', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090006', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090007', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090008', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090009', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090010', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090011', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090012', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090013', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090014', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090015', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090016', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090017', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090018', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090019', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090020', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090021', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090022', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090023', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090024', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090025', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090026', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090027', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090028', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090029', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090030', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090031', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090032', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090033', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090034', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090035', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090036', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090037', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090038', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090039', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090040', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090041', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090042', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090043', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090044', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090045', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090046', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090047', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090048', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090049', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090050', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090051', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090052', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090053', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090054', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090055', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090056', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090057', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090058', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090059', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090060', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090061', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090062', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090063', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090064', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090065', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090066', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090067', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090068', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090069', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090070', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090071', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090072', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090073', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090074', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090075', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090076', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090077', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090078', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090079', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090080', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090081', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090082', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090083', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090084', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090085', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090086', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090087', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090088', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090089', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090090', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090091', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090092', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090093', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090094', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090095', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090096', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090097', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090098', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090099', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090100', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090101', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090102', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090103', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090104', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090105', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090106', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090107', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090108', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090109', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090110', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090111', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090112', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090113', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090114', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090115', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090116', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090117', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090118', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090119', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090120', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090121', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090122', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090123', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090124', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090125', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090126', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090127', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090128', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090129', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090130', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090131', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090132', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090133', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090134', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090135', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090136', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090137', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090138', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090139', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090140', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090141', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090142', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090143', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090144', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090145', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090146', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090147', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090148', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090149', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090150', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090151', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090152', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090153', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090154', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090155', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090156', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090157', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090158', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090159', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090160', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090161', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090162', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090163', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090164', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090165', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090166', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090167', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090168', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090169', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090170', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090171', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090172', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090173', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090174', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090175', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090176', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090177', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090178', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090179', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090180', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090181', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090182', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090183', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090184', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090185', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090186', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090187', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090188', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090189', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090190', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090191', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090192', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090193', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090194', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090195', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090196', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090197', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090198', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090199', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090200', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090201', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090202', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090203', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090204', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090205', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090206', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090207', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090208', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090209', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090210', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090211', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090212', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090213', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090214', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090215', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090216', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090217', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090218', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090219', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090220', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090221', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090222', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090223', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090224', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090225', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090226', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090227', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090228', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090229', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090230', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090231', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090232', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090233', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090234', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090235', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090236', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090237', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090238', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090239', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090240', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090241', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090242', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090243', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090244', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090245', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090246', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090247', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090248', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090249', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090250', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090251', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090252', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090253', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090254', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090255', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090256', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090257', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090258', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090259', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090260', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090261', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090262', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090263', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090264', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090265', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090266', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090267', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090268', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090269', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090270', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090271', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090272', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090273', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090274', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090275', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090276', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090277', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090278', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090279', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090280', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090281', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090282', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090283', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090284', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090285', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090286', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090287', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090288', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090289', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090290', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090291', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090292', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090293', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090294', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090295', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090296', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090297', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090298', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090299', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090300', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090301', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090302', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090303', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090304', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090305', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090306', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090307', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090308', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090309', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090310', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090311', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090312', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090313', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090314', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090315', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090316', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090317', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090318', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090319', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090320', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090321', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090322', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090323', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090324', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090325', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090326', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090327', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090328', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090329', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090330', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090331', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090332', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090333', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090334', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090335', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090336', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090337', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090338', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090339', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090340', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090341', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090342', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090343', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090344', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090345', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090346', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090347', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090348', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090349', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090350', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090351', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090352', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090353', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090354', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090355', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090356', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090357', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090358', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090359', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090360', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090361', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090362', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090363', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090364', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090365', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090366', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090367', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090368', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090369', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090370', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090371', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090372', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090373', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090374', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090375', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090376', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090377', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090378', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090379', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090380', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090381', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090382', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090383', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090384', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090385', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090386', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090387', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090388', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090389', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090390', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090391', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090392', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090393', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090394', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090395', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090396', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090397', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090398', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090399', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090400', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090401', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090402', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090403', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090404', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090405', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090406', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090407', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090408', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090409', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090410', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090411', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090412', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090413', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090414', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090415', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090416', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090417', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090418', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090419', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090420', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090421', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090422', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090423', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090424', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090425', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090426', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090427', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090428', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090429', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090430', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090431', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090432', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090433', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090434', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090435', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090436', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090437', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090438', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090439', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090440', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090441', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090442', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090443', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090444', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090445', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090446', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090447', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090449', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090450', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090451', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090452', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090453', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090454', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090455', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090456', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090457', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090458', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090459', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090460', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090461', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090462', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090463', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090464', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090465', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090466', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090467', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090468', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090469', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090470', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090471', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090472', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090473', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090474', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090475', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090476', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090477', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090478', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090479', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090480', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090481', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090482', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090483', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090484', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090485', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090486', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090487', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090488', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090489', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090490', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090491', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090492', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090493', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090494', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090495', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090496', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090497', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090498', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090499', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090500', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090501', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090502', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090503', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090504', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090505', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090506', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090507', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090508', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090509', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090510', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090511', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090512', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090513', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090514', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090515', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090516', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090517', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090518', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090519', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090520', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090521', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090522', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090523', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090524', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090525', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090526', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090527', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090528', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090529', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090530', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090531', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090532', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090533', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090534', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090535', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090536', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090537', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090538', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090539', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090540', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090541', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090542', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090543', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090544', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090545', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090546', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090547', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090548', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090549', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090550', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090551', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090552', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1090553', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099001', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099002', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099003', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099004', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099005', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099006', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099007', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099008', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099009', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099010', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099011', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099012', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099013', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099014', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099015', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099016', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099017', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099018', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099019', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099020', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099021', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099022', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099023', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099024', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099025', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099026', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099027', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099028', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099029', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099030', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099031', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099032', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099033', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099034', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099035', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099036', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099037', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099038', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099039', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099040', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099041', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099042', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099043', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099044', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099045', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099046', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099047', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099048', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099049', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099050', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099051', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099052', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099053', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099054', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099055', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099056', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099057', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099058', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099059', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099060', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099061', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099062', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099063', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099064', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099065', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099066', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099067', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099068', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1099069', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200001', '20967', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200002', '20968', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200003', '20969', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200004', '20004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200005', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26624', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200006', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200007', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200008', '20906', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200009', '20907', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200010', '20908', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200011', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24576', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200012', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25600', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200013', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200014', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200015', '10708', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200016', '10709', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200017', '20924', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200018', '20915', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200019', '20917', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200020', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200021', '20913', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200022', '20949', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200023', '20950', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200024', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200025', '20911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200026', '20912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200027', '20958', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200028', '20943', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200029', '20966', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200030', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200031', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200032', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200033', '20916', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200034', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200035', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200036', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200037', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200038', '20941', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200039', '20910', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200040', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200041', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200042', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200043', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31744', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200044', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3074', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200045', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200046', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200047', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35840', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200048', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35841', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200049', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200050', '20922', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200051', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200052', '20966', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200053', '20966', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200054', '20967', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200055', '20968', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200056', '20967', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200057', '20969', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200058', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200059', '20952', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200060', '20957', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200061', '20955', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200062', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200063', '20954', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200064', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30720', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200065', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200066', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200067', '40076', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2068', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200068', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200069', '20941', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200070', '20941', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200071', '20965', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200072', '20918', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200073', '20953', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200074', '20937', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200075', '20904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200076', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200077', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200078', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200079', '20956', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200080', '20970', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200081', '20971', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200082', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200083', '20963', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200084', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200085', '20921', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200086', '20926', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200087', '20985', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200088', '20960', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200089', '20961', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200090', '20959', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200091', '20912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200092', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200093', '40902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200094', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200095', '20904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200096', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200097', '20960', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200098', '20922', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200099', '20960', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200100', '20922', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200101', '20960', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200102', '20922', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200103', '20904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200104', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200105', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200106', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200107', '20918', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200108', '20918', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200109', '20904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200110', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200111', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200112', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200113', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200114', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5130', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200115', '40903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200116', '40908', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200117', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200118', '40141', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200119', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200120', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200121', '20997', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200122', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200123', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200124', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200125', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200126', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200127', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200128', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200129', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200130', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200131', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200132', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200133', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200134', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200135', '20958', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200136', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18432', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200137', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200138', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200139', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200140', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200141', '20921', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200142', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200143', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200144', '20937', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200145', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200146', '20954', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200147', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26624', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200148', '20909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200149', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200150', '20951', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200151', '20933', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200152', '20934', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200153', '20935', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200154', '20929', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200155', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200156', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200157', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200158', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200159', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200160', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200161', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200162', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200163', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200164', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200165', '20928', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200166', '20928', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200167', '20928', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200168', '20930', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200169', '20930', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200170', '20931', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200171', '20931', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200172', '20932', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200173', '20932', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200174', '20933', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200175', '20930', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200176', '20930', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200177', '20930', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200178', '20930', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200184', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200185', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200186', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200187', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200188', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200189', '20914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200190', '20913', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200191', '20913', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200192', '20916', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200193', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200194', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200195', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200196', '20972', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200197', '20973', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200198', '20973', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200199', '20973', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200200', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200201', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200202', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200203', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200204', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200205', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200206', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200207', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200208', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200209', '10980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '2136064', '0', '0', '0', '0', '0', '0', '2178', '36864', '2050', '1250', '3072', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200210', '10980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '2135040', '0', '0', '0', '0', '0', '0', '3235', '36864', '3137', '1282', '3072', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200211', '10980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '2134016', '0', '0', '0', '0', '0', '0', '1185', '36864', '1095', '3202', '3072', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200212', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200213', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200214', '20921', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200215', '20926', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200216', '20960', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200217', '20961', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200218', '20963', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200219', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200220', '20962', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200221', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200222', '20964', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200223', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200224', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200225', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200226', '20974', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200227', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200228', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200229', '20938', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200230', '20942', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200231', '20975', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200232', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200233', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12288', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200234', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13312', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200235', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200236', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200237', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200238', '10709', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200239', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200240', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200241', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200242', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200243', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200244', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200245', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200246', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200247', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200248', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200249', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200250', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200251', '40396', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200252', '40914', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200253', '20940', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200254', '20976', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200255', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200256', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200257', '20978', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200258', '20978', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200259', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200260', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200261', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200262', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200263', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200264', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200265', '20979', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200266', '20979', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200267', '20979', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200268', '20979', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200269', '20979', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200270', '20980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200271', '20980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200272', '20980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200273', '20980', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200274', '20981', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200275', '20981', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200276', '20981', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200277', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200278', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200279', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200280', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200281', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200282', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200283', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200284', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200285', '20982', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200286', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200287', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200288', '20903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200289', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200290', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200291', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200292', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200293', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200294', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200295', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200296', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200297', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200298', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200299', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200300', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200301', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200302', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200303', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200304', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200305', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200306', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200307', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200308', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200309', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200310', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200311', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200312', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200313', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200314', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200315', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200316', '20983', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200317', '40203', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200318', '40331', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3074', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200319', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200320', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200321', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200322', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200323', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200324', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200325', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200326', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200327', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200328', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200329', '20936', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200330', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200331', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12288', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200332', '20996', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200333', '20996', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200334', '20986', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200335', '20986', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200336', '20986', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200337', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200338', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200339', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200340', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200341', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200342', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200343', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200344', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200345', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200346', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200347', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200348', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200349', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200350', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200351', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200352', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12288', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200353', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13312', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200354', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14336', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200355', '20984', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200356', '20972', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200357', '20972', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200358', '20972', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200359', '20996', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200360', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200361', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200362', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200363', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200364', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200365', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200366', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200367', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200368', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200369', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200370', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200371', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200372', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200373', '20988', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200374', '20988', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200375', '20988', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200376', '20991', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200377', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200378', '20990', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200379', '20990', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200380', '20990', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200381', '20989', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200382', '20991', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200383', '20991', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200384', '20991', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200385', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200386', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200387', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200388', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200389', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200390', '20987', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200391', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200392', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200393', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200394', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200395', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200396', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200397', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200398', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200399', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200400', '20920', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200401', '20919', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200402', '20927', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200404', '40162', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200405', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200406', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16384', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200407', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17408', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200408', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18432', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200409', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19456', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200410', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200411', '20992', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1200412', '20901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25600', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280000', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280001', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280002', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280003', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280004', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280005', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280006', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280007', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280008', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280009', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280010', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280011', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280012', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280013', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280014', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280015', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280016', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280017', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280018', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280019', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280020', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280021', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280022', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280023', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280031', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280032', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280033', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280034', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280035', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280036', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280037', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280038', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280039', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280040', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280041', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280042', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280043', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280044', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280045', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280046', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280047', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280048', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280049', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280050', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280051', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280052', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280053', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280054', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280055', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280056', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280057', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280058', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280059', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280061', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280062', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280063', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280064', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280065', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280066', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280067', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280068', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280069', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280070', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280071', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280072', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280073', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280074', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280075', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280076', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280077', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280078', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280079', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280080', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280081', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280082', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280083', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280084', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280085', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280086', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280087', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280088', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280089', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280091', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280092', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280093', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280094', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280095', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280096', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280097', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280098', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280099', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280100', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280101', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280102', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280103', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280104', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280105', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280106', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280107', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280108', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280109', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280110', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280111', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280112', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280113', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280114', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280115', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280116', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280117', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280118', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280119', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280121', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280122', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280123', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280124', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280125', '20925', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280126', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1280127', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290001', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290002', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290003', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290004', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290005', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290006', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290007', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290008', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290009', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290010', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290011', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290012', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290013', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290014', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290015', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290016', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290017', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290018', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290019', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290020', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290021', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290022', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290023', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290024', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290025', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290026', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290027', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290028', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290029', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290030', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290031', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290032', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1290033', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500001', '3', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '5379', '5197', '1024', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500002', '8', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '9505', '16513', '5197', '1024', '5280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500003', '7', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '5191', '1024', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500004', '2', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5250', '4164', '5156', '1024', '4199', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500005', '7', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '5250', '4164', '5156', '1024', '4199', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500006', '2', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '9379', '5250', '5188', '21505', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500007', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '8', '10', '0', '79693844', '0', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500008', '9', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '62', '53', '0', '147851265', '0', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500009', '3', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '1', '0', '147851265', '0', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500010', '8', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '2', '0', '210767872', '236979210', '0', '0', '0', '231736331', '0', '7235', '7300', '5190', '1024', '5219', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500011', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '6154', '1057', '6146', '1024', '1057', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500012', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '20483', '4131', '2048', '1024', '6144', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500013', '5', '2', '2', '0', '0', '7', '0', '0', '2', '1', '4', '0', '3', '1', '2', '23', '3', '10', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500014', '2', '2', '5', '0', '0', '1', '0', '0', '4', '0', '0', '1', '3', '2', '0', '15', '12', '15', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500015', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '1', '0', '3', '3', '24', '7', '7', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500016', '4', '2', '1', '0', '0', '8', '0', '0', '3', '0', '5', '4', '2', '3', '2', '18', '10', '8', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500017', '7', '2', '8', '0', '0', '8', '0', '0', '2', '0', '0', '4', '0', '2', '1', '21', '1', '10', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500018', '5', '2', '3', '0', '0', '1', '0', '0', '1', '0', '3', '2', '1', '1', '1', '21', '2', '10', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500019', '8', '2', '7', '0', '0', '2', '0', '0', '0', '1', '0', '3', '1', '0', '3', '5', '2', '14', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500020', '4', '2', '8', '0', '0', '1', '0', '0', '1', '1', '5', '2', '3', '0', '2', '2', '16', '12', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500021', '7', '2', '5', '0', '0', '8', '0', '0', '1', '1', '2', '1', '3', '0', '1', '10', '4', '13', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500022', '1', '2', '5', '0', '0', '2', '0', '0', '0', '1', '1', '5', '1', '1', '3', '7', '15', '8', '0', '79698945', '32507944', '0', '0', '0', '0', '0', '14528', '10338', '10369', '5218', '21642', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500023', '8', '2', '6', '0', '0', '2', '0', '0', '0', '1', '2', '4', '2', '0', '2', '21', '14', '16', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500024', '9', '2', '5', '0', '0', '4', '0', '0', '1', '0', '3', '0', '3', '0', '1', '55', '51', '61', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500025', '6', '2', '1', '0', '0', '5', '0', '0', '3', '0', '5', '1', '2', '0', '2', '31', '9', '1', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500026', '8', '2', '1', '0', '0', '2', '0', '0', '1', '0', '2', '2', '2', '0', '0', '21', '16', '9', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500027', '4', '2', '8', '0', '0', '4', '0', '0', '5', '0', '2', '2', '0', '1', '1', '26', '8', '4', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500028', '6', '0', '2', '0', '0', '2', '0', '0', '2', '1', '0', '0', '1', '3', '0', '20', '16', '6', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500029', '2', '2', '2', '0', '0', '2', '0', '0', '3', '1', '4', '4', '3', '0', '1', '4', '16', '10', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500030', '1', '2', '8', '0', '0', '7', '0', '0', '5', '0', '1', '3', '1', '3', '2', '11', '5', '10', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500031', '5', '2', '3', '0', '0', '1', '0', '0', '5', '0', '1', '3', '2', '2', '0', '15', '5', '4', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500032', '3', '2', '2', '0', '0', '3', '0', '0', '2', '1', '0', '1', '0', '1', '1', '30', '14', '9', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500033', '2', '2', '9', '0', '0', '1', '0', '0', '0', '0', '2', '3', '3', '2', '3', '27', '6', '16', '0', '79697950', '32507944', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500034', '6', '2', '2', '0', '0', '5', '0', '0', '0', '1', '2', '3', '3', '0', '1', '26', '4', '2', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500035', '9', '2', '2', '0', '0', '1', '0', '0', '0', '0', '3', '3', '3', '1', '2', '77', '52', '62', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500036', '7', '2', '8', '0', '0', '4', '0', '0', '0', '0', '3', '4', '0', '0', '1', '27', '15', '2', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500037', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '2', '2', '1', '0', '1', '4', '12', '12', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500038', '8', '2', '1', '0', '0', '4', '0', '0', '5', '0', '2', '4', '1', '0', '1', '8', '11', '16', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500039', '8', '2', '2', '0', '0', '3', '0', '0', '2', '0', '5', '4', '1', '2', '2', '17', '5', '8', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500040', '5', '2', '2', '0', '0', '5', '0', '0', '1', '0', '3', '3', '1', '2', '1', '12', '1', '4', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500041', '7', '2', '8', '0', '0', '4', '0', '0', '3', '1', '0', '4', '1', '2', '1', '22', '9', '15', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500042', '9', '2', '1', '0', '0', '4', '0', '0', '0', '0', '5', '2', '2', '3', '2', '82', '61', '58', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500043', '2', '2', '9', '0', '0', '1', '0', '0', '0', '1', '4', '5', '0', '3', '0', '23', '1', '8', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500044', '2', '2', '1', '0', '0', '5', '0', '0', '1', '0', '2', '3', '3', '2', '3', '28', '14', '1', '0', '79696976', '32507944', '0', '0', '0', '0', '0', '19495', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500045', '6', '2', '4', '0', '0', '1', '0', '0', '4', '1', '4', '3', '0', '0', '1', '10', '6', '14', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500046', '9', '2', '2', '0', '0', '3', '0', '0', '5', '1', '5', '5', '1', '0', '2', '62', '63', '56', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500047', '7', '2', '6', '0', '0', '1', '0', '0', '5', '1', '3', '1', '3', '2', '3', '25', '12', '6', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500048', '4', '2', '7', '0', '0', '8', '0', '0', '3', '0', '2', '3', '1', '1', '2', '29', '14', '5', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500049', '8', '2', '6', '0', '0', '2', '0', '0', '5', '0', '4', '1', '2', '2', '2', '13', '7', '5', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500050', '8', '2', '7', '0', '0', '4', '0', '0', '4', '1', '3', '2', '0', '1', '0', '19', '3', '16', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500051', '5', '2', '4', '0', '0', '5', '0', '0', '2', '1', '0', '2', '2', '1', '3', '25', '12', '7', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500052', '7', '2', '1', '0', '0', '1', '0', '0', '5', '1', '0', '4', '1', '3', '0', '8', '13', '13', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500053', '9', '2', '3', '0', '0', '3', '0', '0', '3', '0', '3', '0', '3', '3', '3', '73', '63', '66', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500054', '2', '2', '1', '0', '0', '3', '0', '0', '4', '1', '4', '0', '0', '3', '3', '23', '3', '15', '0', '79698946', '32507944', '0', '0', '0', '0', '0', '15840', '35040', '3169', '3424', '15392', '11264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500055', '3', '2', '3', '0', '0', '8', '0', '0', '4', '1', '2', '1', '2', '0', '3', '28', '13', '1', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '5191', '1024', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500056', '2', '2', '8', '0', '0', '3', '0', '0', '5', '1', '0', '4', '0', '2', '2', '8', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '39424', '39168', '39139', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500057', '2', '2', '2', '0', '0', '3', '0', '0', '1', '1', '3', '5', '1', '2', '2', '28', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '9248', '2148', '5188', '1024', '5188', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500058', '6', '2', '2', '0', '0', '2', '0', '0', '4', '1', '5', '0', '1', '0', '0', '9', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '9248', '2148', '5188', '1024', '5188', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500059', '8', '2', '2', '0', '0', '3', '0', '0', '3', '1', '0', '3', '3', '0', '0', '1', '12', '11', '0', '0', '0', '0', '0', '0', '0', '0', '4224', '9602', '1152', '11329', '21537', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500060', '3', '2', '1', '0', '0', '8', '0', '0', '3', '1', '4', '4', '1', '1', '3', '28', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '21577', '9602', '4164', '11329', '21537', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500061', '7', '2', '1', '0', '0', '5', '0', '0', '3', '1', '4', '1', '2', '1', '3', '21', '11', '9', '0', '0', '0', '0', '0', '0', '0', '0', '4292', '9601', '4163', '11332', '21635', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500062', '1', '2', '7', '0', '0', '8', '0', '0', '1', '0', '2', '1', '2', '0', '2', '24', '8', '14', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500063', '4', '2', '8', '0', '0', '8', '0', '0', '5', '0', '5', '5', '1', '2', '2', '29', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500064', '2', '2', '7', '0', '0', '5', '0', '0', '1', '0', '0', '3', '0', '2', '1', '8', '15', '6', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500065', '5', '2', '4', '0', '0', '8', '0', '0', '1', '0', '4', '3', '0', '2', '0', '56', '56', '64', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500066', '3', '2', '5', '0', '0', '8', '0', '0', '3', '0', '2', '3', '0', '1', '2', '18', '14', '2', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500067', '6', '2', '3', '0', '0', '3', '0', '0', '5', '1', '5', '0', '3', '0', '0', '59', '59', '51', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500068', '4', '2', '3', '0', '0', '8', '0', '0', '5', '1', '5', '4', '0', '1', '0', '1', '7', '10', '0', '168821780', '0', '0', '0', '0', '0', '0', '19503', '14598', '3268', '14560', '13475', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500069', '7', '2', '4', '0', '0', '1', '0', '0', '2', '1', '0', '5', '2', '1', '1', '24', '2', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500070', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '5', '3', '0', '3', '2', '16', '16', '10', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500071', '6', '2', '2', '0', '0', '8', '0', '0', '1', '1', '4', '1', '1', '0', '2', '82', '63', '62', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500072', '1', '2', '6', '0', '0', '1', '0', '0', '3', '0', '0', '2', '1', '1', '3', '28', '11', '2', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500073', '3', '2', '6', '0', '0', '4', '0', '0', '4', '1', '4', '0', '2', '3', '0', '26', '2', '7', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500074', '7', '2', '6', '0', '0', '6', '0', '0', '1', '0', '0', '1', '1', '3', '3', '53', '53', '64', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500075', '5', '2', '2', '0', '0', '6', '0', '0', '1', '1', '0', '2', '0', '2', '3', '60', '55', '59', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500076', '8', '2', '3', '0', '0', '1', '0', '0', '0', '1', '0', '3', '3', '3', '2', '19', '9', '8', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500077', '1', '2', '7', '0', '0', '8', '0', '0', '0', '0', '1', '5', '3', '1', '0', '26', '1', '14', '0', '79697950', '32514058', '0', '0', '0', '0', '0', '10282', '15392', '4098', '14464', '15392', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500078', '2', '2', '3', '0', '0', '1', '0', '0', '1', '0', '4', '1', '1', '2', '1', '26', '4', '6', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500079', '8', '2', '1', '0', '0', '6', '0', '0', '5', '1', '4', '0', '1', '3', '0', '59', '64', '55', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500080', '5', '2', '1', '0', '0', '6', '0', '0', '2', '1', '2', '0', '1', '1', '1', '76', '56', '51', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500081', '3', '2', '5', '0', '0', '6', '0', '0', '1', '0', '4', '4', '0', '1', '1', '61', '52', '55', '0', '79698954', '32508948', '0', '0', '0', '0', '0', '15424', '15425', '3169', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500082', '8', '2', '2', '0', '0', '4', '0', '0', '1', '1', '0', '4', '2', '0', '2', '14', '12', '10', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500083', '7', '2', '4', '0', '0', '7', '0', '0', '3', '0', '0', '5', '3', '1', '2', '70', '65', '63', '0', '79698946', '32508938', '0', '0', '0', '0', '0', '15392', '7296', '3169', '3105', '15392', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500084', '3', '2', '3', '0', '0', '4', '0', '0', '5', '1', '0', '2', '2', '3', '2', '18', '8', '14', '0', '79698944', '32508928', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500085', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '1026', '1026', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500086', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '1026', '1026', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500087', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500088', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500089', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500090', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500091', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500092', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500093', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500094', '2', '2', '6', '0', '0', '1', '0', '0', '4', '0', '3', '0', '2', '2', '0', '13', '14', '11', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5191', '5187', '5347', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500095', '7', '2', '4', '0', '0', '1', '0', '0', '1', '0', '5', '5', '0', '0', '3', '24', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500096', '5', '2', '3', '0', '0', '7', '0', '0', '4', '0', '4', '2', '3', '0', '1', '28', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500097', '8', '2', '3', '0', '0', '4', '0', '0', '2', '0', '2', '0', '0', '2', '3', '22', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5191', '5187', '5347', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500098', '3', '2', '8', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '26', '6', '6', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14530', '3202', '11360', '13410', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500099', '6', '2', '3', '0', '0', '1', '0', '0', '3', '0', '5', '1', '0', '2', '3', '7', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500100', '2', '2', '1', '0', '0', '2', '0', '0', '0', '0', '3', '5', '2', '1', '3', '31', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10274', '7202', '15360', '11264', '10240', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500101', '7', '2', '5', '0', '0', '5', '0', '0', '2', '1', '0', '5', '0', '3', '1', '11', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500102', '9', '2', '5', '0', '0', '3', '0', '0', '5', '0', '0', '3', '2', '3', '3', '65', '66', '60', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500103', '4', '2', '3', '0', '0', '6', '0', '0', '5', '1', '2', '1', '2', '1', '1', '27', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500104', '1', '2', '7', '0', '0', '7', '0', '0', '1', '0', '5', '3', '2', '2', '0', '27', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500105', '7', '2', '1', '0', '0', '4', '0', '0', '4', '0', '2', '3', '0', '1', '0', '5', '3', '11', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '4128', '4097', '5252', '25825', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500106', '6', '2', '2', '0', '0', '6', '0', '0', '5', '1', '3', '1', '0', '1', '1', '14', '10', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '16385', '7170', '1024', '5120', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500107', '8', '2', '5', '0', '0', '1', '0', '0', '2', '0', '1', '4', '2', '3', '2', '31', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '16385', '7170', '1024', '5120', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500108', '4', '2', '5', '0', '0', '6', '0', '0', '4', '0', '3', '3', '0', '2', '3', '6', '15', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500109', '3', '2', '3', '0', '0', '7', '0', '0', '0', '0', '5', '3', '0', '0', '3', '27', '10', '4', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500110', '8', '2', '1', '0', '0', '1', '0', '0', '4', '1', '4', '2', '0', '0', '1', '4', '14', '2', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500111', '1', '2', '8', '0', '0', '8', '0', '0', '4', '1', '0', '3', '1', '2', '3', '10', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500112', '6', '2', '2', '0', '0', '5', '0', '0', '2', '0', '5', '0', '3', '1', '2', '25', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500113', '8', '2', '3', '0', '0', '3', '0', '0', '3', '1', '2', '5', '1', '1', '1', '27', '12', '4', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '3104', '3138', '3104', '3104', '134144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500114', '3', '2', '5', '0', '0', '7', '0', '0', '2', '0', '5', '4', '2', '0', '3', '26', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '21537', '32836', '2112', '2114', '2081', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500115', '2', '2', '8', '0', '0', '3', '0', '0', '4', '1', '4', '5', '2', '0', '2', '29', '16', '15', '0', '0', '0', '0', '0', '0', '0', '0', '25739', '9378', '5184', '5250', '10336', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500116', '5', '2', '4', '0', '0', '1', '0', '0', '1', '1', '5', '1', '1', '1', '3', '3', '14', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23585', '31875', '2113', '11360', '25697', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500117', '9', '2', '4', '0', '0', '2', '0', '0', '2', '1', '4', '2', '0', '3', '0', '54', '51', '52', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16418', '5152', '1024', '5120', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500118', '3', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '5', '1', '2', '2', '25', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '10496', '4224', '10304', '11360', '8225', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500119', '2', '2', '4', '0', '0', '3', '0', '0', '0', '1', '4', '0', '2', '1', '1', '23', '15', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500120', '7', '2', '9', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '68', '61', '55', '0', '79695902', '32507954', '0', '0', '0', '0', '0', '22628', '15840', '3360', '8320', '15840', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500121', '8', '2', '4', '0', '0', '1', '19', '0', '0', '1', '0', '0', '0', '0', '0', '6', '11', '14', '0', '79696966', '32513064', '0', '0', '0', '0', '0', '13505', '8288', '15488', '11459', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500122', '1', '2', '4', '0', '0', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '13', '11', '11', '0', '79693855', '32512010', '0', '0', '0', '0', '0', '20507', '34976', '2210', '5376', '25792', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500123', '1', '2', '8', '0', '0', '2', '0', '0', '3', '0', '1', '5', '0', '0', '1', '32', '5', '11', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500124', '6', '2', '1', '0', '0', '1', '0', '0', '1', '0', '0', '5', '0', '0', '3', '7', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '16385', '7170', '1024', '5120', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500125', '2', '2', '8', '0', '0', '1', '0', '0', '1', '1', '3', '4', '0', '3', '2', '25', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500126', '6', '2', '2', '0', '0', '6', '0', '0', '3', '0', '2', '4', '0', '0', '2', '22', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5184', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500127', '3', '2', '6', '0', '0', '3', '0', '0', '1', '0', '5', '5', '2', '0', '0', '13', '8', '12', '0', '210767873', '236979210', '0', '0', '0', '231736331', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500128', '7', '2', '2', '0', '0', '8', '0', '0', '5', '1', '2', '2', '0', '0', '0', '9', '14', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500129', '5', '2', '3', '0', '0', '3', '0', '0', '1', '0', '5', '2', '2', '0', '2', '7', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500130', '8', '2', '3', '0', '0', '3', '0', '0', '2', '0', '2', '1', '2', '2', '0', '23', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34884', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500131', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500132', '6', '2', '1', '0', '0', '4', '0', '0', '4', '0', '0', '3', '0', '3', '2', '65', '51', '64', '0', '0', '0', '0', '0', '0', '0', '0', '5378', '5316', '5218', '1024', '5314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500133', '7', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '1', '3', '0', '0', '63', '52', '61', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '9314', '9280', '1024', '9315', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500134', '7', '2', '7', '0', '0', '8', '0', '0', '3', '1', '3', '5', '3', '3', '2', '32', '8', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23875', '8322', '15904', '14466', '8259', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500135', '8', '2', '7', '0', '0', '1', '0', '0', '2', '0', '3', '3', '1', '0', '2', '28', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5249', '4163', '10273', '1024', '5154', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500136', '8', '2', '1', '0', '0', '2', '0', '0', '5', '1', '4', '3', '1', '1', '3', '8', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1092', '6215', '1024', '5281', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500137', '1', '2', '7', '0', '0', '2', '0', '0', '2', '0', '2', '5', '1', '2', '3', '29', '6', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '5153', '2115', '1024', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500138', '1', '2', '2', '0', '0', '8', '0', '0', '0', '1', '3', '5', '3', '0', '0', '15', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16546', '5280', '1024', '5444', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500139', '4', '2', '8', '0', '0', '8', '0', '0', '1', '0', '2', '2', '0', '1', '0', '14', '7', '12', '0', '243270658', '0', '0', '0', '0', '0', '0', '16546', '16514', '10339', '1024', '21637', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500140', '5', '2', '2', '0', '0', '3', '0', '0', '4', '1', '3', '2', '3', '3', '2', '18', '5', '15', '0', '147851275', '0', '0', '0', '0', '0', '0', '23588', '11300', '9248', '5122', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500141', '5', '2', '2', '0', '0', '3', '0', '0', '4', '1', '3', '2', '3', '3', '2', '18', '5', '15', '0', '147851275', '0', '0', '0', '0', '0', '0', '23588', '11300', '9248', '5122', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500142', '7', '2', '9', '0', '0', '8', '30', '0', '3', '1', '1', '1', '2', '1', '0', '28', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500143', '8', '2', '4', '0', '0', '2', '25', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '7234', '1024', '28800', '195584', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500144', '4', '2', '5', '0', '0', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '4', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35904', '7236', '1024', '28864', '462848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500145', '3', '2', '5', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500146', '2', '2', '1', '0', '0', '2', '18', '0', '0', '0', '0', '0', '0', '0', '0', '6', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35904', '7236', '1024', '28864', '462848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500147', '9', '2', '1', '0', '0', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '51', '64', '57', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500148', '9', '2', '2', '0', '0', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '65', '65', '65', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '7234', '1024', '28800', '195584', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500149', '1', '2', '5', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '24', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35904', '7236', '1024', '28864', '462848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500150', '1', '2', '7', '0', '0', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '31', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500151', '1', '2', '4', '0', '0', '2', '25', '0', '0', '0', '0', '0', '0', '0', '0', '25', '5', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35875', '2082', '1024', '25667', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500152', '9', '2', '3', '0', '0', '2', '18', '0', '0', '0', '0', '0', '0', '0', '0', '61', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '35906', '35906', '28740', '1024', '28738', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500153', '2', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '35906', '35906', '28740', '1024', '28738', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500154', '2', '2', '3', '0', '0', '4', '18', '0', '0', '0', '0', '0', '0', '0', '0', '12', '11', '16', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500155', '2', '2', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500156', '7', '2', '7', '0', '0', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '12', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35875', '2082', '1024', '25667', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500157', '8', '2', '2', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '5', '5', '0', '0', '0', '0', '0', '0', '0', '0', '35906', '35906', '28740', '1024', '28738', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500158', '7', '2', '6', '0', '0', '1', '22', '0', '0', '0', '0', '0', '0', '0', '0', '32', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500159', '7', '2', '1', '0', '0', '8', '1', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '12', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35876', '28708', '1024', '28801', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500160', '7', '2', '5', '0', '0', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '12', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35908', '28740', '1024', '25666', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500161', '8', '2', '3', '0', '0', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '12', '11', '3', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35876', '28708', '1024', '28801', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500162', '8', '2', '7', '0', '0', '4', '22', '0', '0', '0', '0', '0', '0', '0', '0', '32', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35908', '28740', '1024', '25666', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500163', '2', '2', '5', '0', '0', '5', '9', '0', '3', '1', '1', '1', '2', '1', '0', '12', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500164', '4', '2', '1', '0', '0', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '24', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35876', '28708', '1024', '28801', '461824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500165', '3', '2', '5', '0', '0', '8', '25', '0', '0', '0', '0', '0', '0', '0', '0', '28', '11', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35908', '28740', '1024', '25666', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500166', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500167', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500168', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500169', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500170', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500171', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500172', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500173', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500174', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500175', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500176', '6', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500177', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500178', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500179', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500180', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500181', '5', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '67', '58', '56', '0', '383779840', '0', '0', '0', '0', '0', '0', '20499', '4128', '5153', '6209', '10272', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500182', '2', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '12', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1122', '39648', '1024', '38976', '0', '103424', '207872', '207872', '207872', '207872', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500183', '2', '2', '6', '0', '0', '5', '9', '0', '3', '1', '1', '1', '2', '0', '0', '25', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '33120', '2145', '5281', '2242', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500184', '9', '2', '1', '0', '0', '2', '23', '0', '0', '0', '0', '0', '0', '0', '0', '77', '53', '58', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '2112', '2208', '5185', '25666', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500185', '7', '2', '3', '0', '0', '8', '29', '0', '0', '0', '0', '0', '0', '0', '0', '28', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '4256', '28707', '5155', '25664', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500186', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500187', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500188', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500189', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500190', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500191', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500192', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500193', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500194', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '1026', '1026', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500195', '1', '2', '2', '0', '0', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '26', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500196', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500197', '1', '2', '1', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '23', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '13888', '28704', '1024', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500198', '1', '2', '5', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '17', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '46240', '46085', '1024', '46085', '46085', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500199', '1', '2', '4', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5', '10', '1', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500200', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '46208', '46084', '1024', '46084', '46084', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500201', '8', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '5', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500202', '7', '1', '4', '0', '0', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '66', '63', '58', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500203', '4', '1', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '5', '13', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500204', '3', '2', '5', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '1', '1', '0', '383779883', '0', '0', '0', '0', '0', '0', '0', '935936', '7298', '7392', '8288', '464896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500205', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '1', '8', '0', '147850240', '0', '0', '0', '0', '0', '0', '6304', '11299', '6146', '9216', '9216', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500206', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500207', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '5191', '1024', '5348', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500208', '2', '2', '6', '0', '0', '5', '20', '0', '0', '0', '0', '0', '0', '0', '0', '10', '15', '12', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '39424', '39168', '39139', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500209', '4', '2', '5', '0', '0', '6', '30', '0', '0', '0', '0', '0', '0', '0', '0', '32', '11', '4', '0', '0', '0', '0', '0', '0', '0', '0', '38924', '32802', '39424', '39168', '39139', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500210', '8', '1', '7', '0', '0', '5', '0', '0', '0', '1', '1', '3', '1', '2', '2', '81', '62', '63', '0', '0', '0', '0', '0', '0', '0', '0', '46176', '46083', '1024', '46083', '46083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500211', '7', '2', '4', '0', '0', '5', '0', '0', '3', '1', '2', '2', '1', '3', '2', '6', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46208', '46084', '1024', '46084', '46084', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500212', '3', '3', '2', '0', '0', '4', '0', '0', '4', '0', '0', '0', '1', '3', '0', '13', '8', '13', '0', '0', '0', '0', '0', '0', '0', '0', '46240', '46085', '1024', '46085', '46085', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500213', '4', '2', '5', '0', '0', '4', '0', '0', '1', '1', '2', '1', '1', '3', '3', '9', '12', '15', '0', '171967488', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500214', '4', '2', '7', '0', '0', '1', '0', '0', '1', '0', '1', '0', '1', '3', '2', '25', '1', '13', '0', '171969536', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500215', '4', '2', '4', '0', '0', '1', '0', '0', '0', '1', '2', '0', '3', '2', '1', '12', '4', '8', '0', '171968512', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500216', '22', '1', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922976', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500217', '22', '1', '0', '0', '0', '1', '22', '0', '0', '0', '0', '0', '0', '0', '0', '4', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '922659', '923136', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500218', '22', '1', '0', '0', '0', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '21', '8', '12', '0', '0', '0', '0', '0', '0', '0', '0', '922721', '922944', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500219', '7', '2', '1', '0', '0', '4', '5', '0', '1', '0', '5', '1', '2', '0', '0', '4', '3', '4', '0', '171967488', '0', '0', '0', '0', '0', '0', '28801', '28801', '28800', '1024', '25792', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500220', '7', '2', '1', '0', '0', '1', '0', '0', '2', '0', '3', '5', '0', '0', '2', '5', '11', '13', '0', '171969536', '0', '0', '0', '0', '0', '0', '4256', '28707', '28800', '1024', '28737', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500221', '7', '2', '4', '0', '0', '8', '4', '0', '0', '0', '4', '3', '0', '3', '2', '24', '13', '14', '0', '171968512', '0', '0', '0', '0', '0', '0', '6144', '28800', '6144', '1024', '25792', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500222', '9', '3', '3', '0', '0', '1', '0', '0', '5', '1', '1', '1', '3', '3', '1', '60', '54', '66', '0', '171967488', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500223', '9', '3', '4', '0', '0', '3', '0', '0', '3', '0', '3', '4', '0', '3', '3', '54', '52', '54', '0', '171967488', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500224', '9', '3', '5', '0', '0', '3', '0', '0', '2', '0', '3', '4', '2', '0', '1', '58', '51', '64', '0', '171969536', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500225', '9', '3', '1', '0', '0', '2', '0', '0', '5', '0', '3', '0', '2', '3', '0', '82', '61', '52', '0', '171969536', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500226', '9', '3', '1', '0', '0', '1', '0', '0', '3', '1', '0', '0', '3', '1', '2', '57', '63', '51', '0', '171968512', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500227', '9', '3', '3', '0', '0', '2', '0', '0', '3', '0', '3', '0', '0', '0', '1', '80', '61', '59', '0', '171968512', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500228', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500229', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500230', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500231', '1', '2', '2', '0', '0', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '26', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500232', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500233', '3', '2', '8', '0', '0', '3', '0', '0', '0', '1', '4', '4', '1', '2', '1', '12', '15', '12', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500234', '1', '1', '7', '0', '0', '1', '0', '0', '5', '1', '5', '4', '3', '3', '2', '10', '6', '11', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500235', '7', '3', '9', '0', '0', '8', '0', '0', '5', '1', '3', '1', '1', '3', '0', '22', '15', '15', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500236', '4', '2', '7', '0', '0', '4', '0', '0', '5', '0', '2', '2', '1', '1', '1', '20', '9', '13', '0', '0', '0', '0', '0', '0', '0', '0', '16672', '16609', '28865', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500237', '1', '2', '7', '0', '0', '7', '5', '0', '5', '0', '2', '2', '2', '0', '2', '11', '12', '10', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28864', '2304', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500238', '1', '3', '2', '0', '0', '7', '0', '0', '4', '1', '0', '3', '3', '0', '0', '26', '2', '16', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28864', '2304', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500239', '1', '1', '1', '0', '0', '2', '5', '0', '1', '1', '1', '4', '0', '0', '3', '7', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30756', '28864', '2305', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500240', '1', '2', '4', '0', '0', '8', '0', '0', '1', '1', '4', '5', '3', '2', '0', '17', '10', '1', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28864', '2304', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500241', '7', '2', '6', '0', '0', '8', '5', '0', '4', '0', '2', '0', '1', '2', '0', '5', '8', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30756', '28865', '2306', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500242', '4', '2', '7', '0', '0', '1', '0', '0', '2', '1', '0', '2', '3', '1', '2', '21', '11', '9', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28833', '2305', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500243', '6', '2', '3', '0', '0', '2', '0', '0', '2', '0', '0', '1', '3', '0', '0', '18', '16', '1', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28707', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500244', '7', '2', '5', '0', '0', '8', '5', '0', '5', '1', '2', '5', '2', '2', '0', '15', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28742', '2305', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500245', '6', '2', '2', '0', '0', '5', '0', '0', '3', '0', '5', '1', '0', '3', '3', '12', '12', '9', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30756', '28864', '2305', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500246', '2', '2', '3', '0', '0', '2', '0', '0', '0', '1', '3', '5', '1', '2', '2', '31', '16', '6', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30756', '28674', '2305', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500247', '5', '2', '2', '0', '0', '1', '5', '0', '3', '0', '5', '5', '2', '2', '2', '4', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28741', '2306', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500248', '3', '2', '6', '0', '0', '7', '5', '0', '1', '0', '0', '0', '2', '2', '2', '9', '12', '3', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28864', '2304', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500249', '8', '2', '6', '0', '0', '7', '0', '0', '1', '0', '2', '2', '2', '2', '1', '78', '60', '51', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30944', '28800', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500250', '3', '2', '7', '0', '0', '3', '5', '0', '4', '0', '4', '4', '1', '3', '0', '19', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28741', '2306', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500251', '8', '2', '4', '0', '0', '6', '0', '0', '3', '0', '3', '1', '3', '2', '0', '60', '66', '51', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28833', '2305', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500252', '8', '2', '1', '0', '0', '6', '0', '0', '0', '1', '4', '2', '3', '3', '1', '53', '66', '59', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28739', '2305', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500253', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '4', '1', '1', '0', '2', '11', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28864', '2304', '25728', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500254', '3', '2', '6', '0', '0', '4', '5', '0', '2', '0', '4', '3', '3', '0', '0', '13', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28864', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500255', '3', '2', '6', '0', '0', '3', '0', '0', '5', '0', '1', '0', '3', '1', '3', '28', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28864', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500256', '2', '2', '6', '0', '0', '5', '0', '0', '2', '1', '2', '5', '3', '2', '0', '10', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28704', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500257', '3', '2', '1', '0', '0', '3', '0', '0', '3', '0', '1', '0', '1', '3', '3', '16', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30722', '28742', '2305', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500258', '2', '2', '4', '0', '0', '2', '0', '0', '5', '0', '4', '1', '3', '0', '3', '19', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28704', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500259', '9', '2', '4', '0', '0', '1', '5', '0', '0', '1', '1', '0', '0', '3', '2', '58', '52', '62', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30944', '28801', '2305', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500260', '4', '2', '1', '0', '0', '8', '0', '0', '1', '1', '4', '4', '0', '0', '0', '16', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30756', '28865', '2306', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500261', '1', '2', '7', '0', '0', '1', '5', '0', '5', '1', '3', '3', '0', '2', '2', '1', '6', '5', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28739', '2305', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500262', '9', '2', '4', '0', '0', '4', '5', '0', '2', '0', '5', '5', '2', '3', '2', '72', '53', '57', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30852', '28704', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500263', '9', '2', '4', '0', '0', '1', '0', '0', '0', '1', '0', '3', '3', '1', '3', '54', '55', '65', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28707', '2304', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500264', '9', '2', '1', '0', '0', '3', '5', '0', '1', '0', '2', '3', '3', '0', '0', '55', '60', '66', '0', '0', '0', '0', '0', '0', '0', '0', '35968', '30724', '28741', '2306', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500265', '1', '2', '1', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '12', '0', '0', '0', '0', '0', '0', '0', '0', '16610', '28896', '4256', '5315', '38976', '464896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500266', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '16641', '28929', '15840', '5411', '39168', '462848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500267', '5', '2', '3', '0', '0', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '62', '62', '51', '0', '0', '0', '0', '0', '0', '0', '0', '16611', '28864', '5198', '5251', '38925', '463872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500268', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28706', '7201', '1024', '38912', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500269', '1', '2', '3', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '14', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35874', '28673', '1024', '28705', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500270', '4', '2', '6', '0', '0', '6', '5', '0', '0', '1', '1', '0', '1', '2', '2', '32', '13', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20491', '35072', '16548', '1024', '5184', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500271', '7', '2', '9', '0', '0', '33', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '65', '61', '0', '368051240', '0', '0', '0', '0', '0', '0', '20576', '36000', '4160', '5412', '21826', '0', '0', '205824', '205824', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500272', '5', '2', '2', '0', '0', '7', '4', '0', '1', '1', '0', '0', '1', '1', '0', '6', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '20496', '35040', '28865', '1024', '28704', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500273', '2', '2', '6', '0', '0', '3', '0', '0', '2', '1', '2', '2', '1', '2', '2', '7', '1', '4', '0', '383779870', '0', '0', '0', '0', '0', '0', '0', '35168', '9920', '1024', '9377', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500274', '1', '2', '7', '0', '0', '8', '0', '0', '2', '0', '2', '2', '1', '3', '1', '28', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5442', '39680', '10528', '5442', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500275', '3', '2', '5', '0', '0', '8', '4', '0', '4', '0', '2', '3', '3', '1', '0', '31', '12', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20493', '38918', '5190', '38977', '5280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500276', '3', '2', '4', '0', '0', '3', '0', '0', '5', '0', '1', '3', '2', '1', '0', '12', '16', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '2149', '2208', '2115', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500277', '1', '2', '2', '0', '0', '8', '9', '0', '4', '0', '5', '3', '0', '2', '3', '11', '15', '8', '0', '79693826', '0', '0', '0', '0', '0', '0', '6304', '33955', '10304', '5251', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500278', '2', '2', '9', '0', '0', '1', '20', '0', '1', '0', '5', '0', '0', '2', '3', '11', '15', '8', '0', '79693826', '0', '0', '0', '0', '0', '0', '6304', '33952', '10338', '10337', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500279', '22', '2', '0', '0', '0', '1', '9', '0', '4', '1', '1', '0', '2', '1', '0', '28', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '922721', '922944', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500280', '8', '2', '8', '0', '0', '3', '0', '0', '5', '1', '1', '5', '1', '2', '1', '14', '3', '12', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '9536', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500281', '9', '2', '5', '0', '0', '3', '0', '0', '0', '0', '2', '0', '3', '0', '0', '54', '64', '61', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500282', '6', '2', '3', '0', '0', '4', '0', '0', '1', '1', '0', '0', '1', '2', '3', '63', '55', '52', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500283', '24', '2', '7', '0', '0', '1', '31', '0', '5', '0', '1', '5', '3', '0', '1', '19', '10', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '924768', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500284', '4', '2', '4', '0', '0', '1', '0', '0', '0', '0', '4', '4', '1', '1', '2', '11', '11', '4', '0', '171967488', '0', '0', '0', '0', '0', '0', '14370', '16483', '3074', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500285', '4', '2', '2', '0', '0', '6', '0', '0', '0', '1', '1', '1', '1', '2', '2', '19', '6', '13', '0', '171969536', '0', '0', '0', '0', '0', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500286', '4', '2', '1', '0', '0', '8', '0', '0', '1', '0', '5', '4', '0', '0', '3', '30', '1', '13', '0', '171968512', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500287', '22', '1', '1', '0', '0', '1', '0', '0', '0', '1', '5', '4', '2', '1', '2', '15', '2', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922976', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500288', '22', '1', '0', '0', '0', '1', '0', '0', '1', '1', '1', '1', '3', '2', '3', '4', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '922659', '923136', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500289', '22', '1', '0', '0', '0', '1', '0', '0', '4', '0', '5', '4', '0', '0', '3', '28', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '922721', '922944', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500290', '7', '2', '1', '0', '0', '8', '0', '0', '2', '1', '3', '2', '2', '0', '3', '15', '4', '1', '0', '171967488', '0', '0', '0', '0', '0', '0', '28801', '28801', '28800', '1024', '25792', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500291', '7', '2', '7', '0', '0', '1', '0', '0', '2', '0', '3', '4', '1', '1', '2', '6', '15', '14', '0', '171969536', '0', '0', '0', '0', '0', '0', '4256', '28707', '28800', '1024', '28737', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500292', '7', '2', '8', '0', '0', '8', '0', '0', '4', '0', '2', '2', '0', '0', '3', '23', '15', '15', '0', '171968512', '0', '0', '0', '0', '0', '0', '6144', '28800', '6144', '1024', '25792', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500293', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500294', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500295', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500297', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500298', '5', '3', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500299', '6', '1', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '69', '64', '56', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500300', '6', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '58', '65', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500301', '6', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '66', '55', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500302', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '3', '11', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500303', '5', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '56', '9', '63', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500304', '5', '3', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '63', '61', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500305', '6', '1', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '55', '58', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500306', '6', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '61', '58', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500307', '6', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '63', '65', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500308', '5', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '60', '57', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500309', '5', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '72', '64', '59', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500310', '5', '3', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500311', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '71', '64', '63', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500312', '6', '3', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '69', '64', '61', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500313', '6', '3', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '66', '58', '62', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500314', '3', '2', '5', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '1', '1', '0', '383779883', '0', '0', '0', '0', '0', '0', '0', '935936', '7298', '7392', '8288', '464896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500315', '7', '4', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '4', '0', '80741416', '0', '0', '0', '0', '0', '0', '14592', '15554', '3072', '11585', '15555', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500316', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '4', '0', '79693835', '0', '0', '0', '0', '0', '0', '28738', '6338', '6215', '10400', '6274', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500317', '1', '4', '1', '0', '0', '7', '18', '0', '0', '0', '0', '0', '0', '0', '0', '15', '2', '12', '0', '79697970', '0', '0', '0', '0', '0', '0', '14373', '15555', '3072', '3168', '3168', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500318', '6', '2', '2', '0', '0', '7', '14', '0', '0', '0', '0', '0', '0', '0', '0', '82', '64', '54', '0', '79693835', '0', '0', '0', '0', '0', '0', '28736', '6340', '6216', '10400', '6275', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500319', '3', '4', '3', '0', '0', '8', '18', '0', '0', '0', '0', '0', '0', '0', '0', '3', '4', '4', '0', '79695883', '0', '0', '0', '0', '0', '0', '14560', '12736', '3144', '11588', '13601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500320', '8', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '70', '52', '64', '0', '79693835', '0', '0', '0', '0', '0', '0', '28739', '6336', '6217', '10400', '6276', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500321', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500322', '1', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500323', '1', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500324', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500325', '1', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500326', '1', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500327', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500328', '1', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500329', '1', '2', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500330', '2', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500331', '2', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500332', '2', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500333', '2', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500334', '2', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500335', '2', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46112', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500336', '2', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500337', '2', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500338', '2', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '46144', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500339', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '46080', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500340', '7', '4', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '12', '3', '4', '0', '80741416', '0', '0', '0', '0', '0', '0', '14592', '15554', '3072', '11585', '15555', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500341', '1', '4', '1', '0', '0', '7', '18', '0', '0', '0', '0', '0', '0', '0', '0', '15', '2', '12', '0', '79697970', '0', '0', '0', '0', '0', '0', '14373', '15555', '3072', '3168', '3168', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500342', '3', '4', '3', '0', '0', '8', '18', '0', '0', '0', '0', '0', '0', '0', '0', '3', '4', '4', '0', '79695883', '0', '0', '0', '0', '0', '0', '14560', '12736', '3144', '11588', '13601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500343', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '8', '8', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500344', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500345', '8', '2', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500346', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '13', '2', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500347', '8', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '68', '65', '62', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500348', '8', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '62', '60', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500349', '8', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '57', '52', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500350', '8', '2', '2', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '57', '59', '53', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500351', '1', '2', '4', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '8', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500352', '2', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '6', '12', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500353', '1', '2', '5', '0', '0', '7', '31', '0', '0', '0', '0', '0', '0', '0', '0', '9', '16', '12', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500354', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '9', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500355', '7', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '15', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500356', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500357', '7', '2', '1', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '2', '16', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500358', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '8', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500359', '7', '2', '6', '0', '0', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500360', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '2', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500361', '7', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '3', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500362', '7', '2', '4', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '7', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500363', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '13', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500364', '7', '2', '1', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500365', '3', '2', '8', '0', '0', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '21', '15', '13', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500366', '4', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '2', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500367', '3', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '12', '3', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500368', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500369', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '11', '1', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500370', '4', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '6', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500371', '3', '2', '8', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '4', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500372', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '8', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500373', '3', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '12', '14', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500374', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '8', '14', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500375', '5', '2', '3', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '62', '63', '61', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500376', '6', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '61', '62', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500377', '5', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '72', '64', '59', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500378', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '70', '57', '56', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500379', '5', '2', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '54', '60', '57', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500380', '6', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '65', '52', '55', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500381', '5', '2', '4', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '51', '59', '57', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500382', '6', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '65', '63', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500383', '5', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '67', '58', '56', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500384', '5', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '55', '59', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500385', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '4', '0', '79693835', '0', '0', '0', '0', '0', '0', '28738', '6338', '6215', '10400', '6274', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500386', '6', '2', '2', '0', '0', '7', '14', '0', '0', '0', '0', '0', '0', '0', '0', '82', '64', '54', '0', '79693835', '0', '0', '0', '0', '0', '0', '28736', '6340', '6216', '10400', '6275', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500387', '8', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '70', '52', '64', '0', '79693835', '0', '0', '0', '0', '0', '0', '28739', '6336', '6217', '10400', '6276', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500388', '7', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '13', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20496', '46080', '1024', '46080', '46080', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500389', '3', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '46081', '1024', '46081', '46081', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500390', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '13', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '46082', '1024', '46082', '46082', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500391', '1', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '14', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500392', '8', '2', '6', '14', '0', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '10', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '39168', '31810', '39648', '1024', '39137', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500393', '3', '2', '6', '27', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '16', '0', '0', '0', '0', '0', '0', '0', '0', '38921', '31840', '5155', '1024', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500394', '2', '2', '4', '31', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '38976', '31879', '39424', '1024', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500395', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500396', '1', '2', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '16', '10', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5187', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500397', '2', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '10', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500398', '3', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500399', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500400', '3', '2', '7', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5155', '5185', '5185', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500401', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '9441', '30852', '39104', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500402', '4', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '13', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500403', '4', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500404', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5155', '5185', '5185', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500405', '4', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '9441', '30852', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500406', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500407', '4', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '10279', '30784', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500408', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '13', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500409', '5', '2', '3', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '62', '55', '63', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5155', '5185', '5185', '9315', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500410', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '7', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500411', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '15', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6240', '30722', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500412', '5', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '13', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500413', '5', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '66', '52', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5185', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500414', '5', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '52', '57', '0', '0', '0', '0', '0', '0', '0', '0', '10279', '30784', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500415', '5', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '62', '55', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500416', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '10', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500417', '6', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '71', '61', '59', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38919', '39136', '38977', '38976', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500418', '6', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '56', '58', '51', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5185', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500419', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '16', '11', '0', '0', '0', '0', '0', '0', '0', '0', '10279', '30784', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500420', '7', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '9', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500421', '7', '2', '8', '0', '0', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '55', '56', '1', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5187', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500422', '8', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '9', '8', '0', '0', '0', '0', '0', '0', '0', '0', '9441', '30852', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500423', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '11', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6240', '30722', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500424', '8', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500425', '8', '2', '5', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '68', '65', '52', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5187', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500426', '8', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '71', '66', '51', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38916', '39296', '1024', '38916', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500427', '7', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '38921', '39200', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500428', '7', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '21568', '5185', '5185', '5185', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500429', '7', '2', '5', '0', '0', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11', '5', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6240', '30722', '39136', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500430', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '30756', '35876', '28708', '1024', '28674', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500431', '3', '2', '6', '0', '0', '8', '17', '0', '0', '0', '0', '0', '0', '0', '0', '9', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '30720', '35875', '28707', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500432', '5', '2', '4', '0', '0', '4', '9', '0', '0', '0', '0', '0', '0', '0', '0', '67', '57', '55', '0', '0', '0', '0', '0', '0', '0', '0', '30755', '35904', '28736', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500433', '8', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '14', '9', '0', '79693835', '0', '0', '0', '0', '0', '0', '28738', '6338', '6215', '10400', '6274', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500434', '8', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '11', '6', '0', '79693835', '0', '0', '0', '0', '0', '0', '28736', '6340', '6216', '10400', '6275', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500435', '8', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '14', '9', '0', '79693835', '0', '0', '0', '0', '0', '0', '28738', '6338', '6215', '10400', '6274', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500436', '8', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '11', '6', '0', '79693835', '0', '0', '0', '0', '0', '0', '28736', '6340', '6216', '10400', '6275', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500437', '5', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '67', '58', '56', '0', '383779840', '0', '0', '0', '0', '0', '0', '20499', '4128', '5153', '6209', '10272', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1500438', '8', '2', '4', '0', '0', '2', '31', '0', '0', '1', '0', '0', '0', '0', '0', '18', '3', '5', '0', '79696966', '32513064', '0', '0', '0', '0', '0', '13505', '8257', '15488', '11459', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600001', '2', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '4131', '9280', '1024', '9280', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600002', '6', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5184', '2081', '5122', '1024', '10240', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600003', '1', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '4160', '4160', '2080', '1024', '9314', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600004', '4', '2', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '5219', '6217', '1024', '5219', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600005', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5281', '5217', '2145', '1024', '5217', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600006', '8', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '15', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6304', '6464', '6432', '1024', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600007', '7', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '2', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4096', '6144', '1024', '1025', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600008', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4099', '10240', '1024', '5123', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600009', '8', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '10274', '5153', '1024', '1057', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600010', '3', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '6150', '4131', '2081', '1024', '25600', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600011', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '4132', '5188', '1024', '1024', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600012', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '5155', '5120', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600013', '1', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '2080', '4098', '1024', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600014', '2', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '16386', '2080', '4098', '1024', '4096', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600015', '6', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2148', '5120', '5217', '5316', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600016', '2', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '9', '11', '0', '0', '0', '0', '0', '0', '0', '0', '6152', '1121', '5155', '10336', '1057', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600017', '1', '2', '1', '0', '0', '7', '0', '0', '2', '1', '0', '5', '0', '1', '0', '27', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9376', '6145', '11264', '9315', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600018', '7', '2', '5', '0', '0', '4', '0', '0', '4', '0', '4', '0', '3', '3', '1', '27', '11', '9', '0', '768610324', '0', '0', '0', '0', '0', '0', '20507', '2276', '4320', '11360', '9570', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600019', '9', '2', '5', '0', '0', '3', '0', '0', '1', '1', '4', '3', '2', '0', '3', '59', '65', '66', '0', '0', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600020', '2', '2', '8', '0', '0', '2', '0', '0', '4', '0', '1', '4', '1', '1', '3', '28', '9', '3', '0', '815793163', '0', '0', '0', '0', '0', '0', '5216', '33920', '9632', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600021', '3', '2', '5', '0', '0', '8', '0', '0', '3', '1', '1', '3', '0', '3', '0', '15', '5', '7', '0', '737152010', '0', '0', '0', '0', '0', '0', '22658', '2209', '9696', '5440', '9538', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600022', '5', '2', '3', '0', '0', '4', '0', '0', '5', '0', '0', '2', '2', '3', '2', '62', '62', '65', '0', '752878622', '0', '0', '0', '0', '0', '0', '4417', '4417', '5344', '5440', '10529', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600023', '7', '2', '3', '0', '0', '5', '0', '0', '2', '1', '1', '2', '2', '0', '3', '28', '11', '9', '0', '721421342', '0', '0', '0', '0', '0', '0', '21573', '2276', '2177', '2240', '2272', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600024', '4', '2', '5', '0', '0', '4', '0', '0', '5', '0', '3', '1', '1', '2', '1', '16', '9', '11', '0', '784335912', '0', '0', '0', '0', '0', '0', '23880', '4356', '10433', '5280', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600025', '6', '2', '4', '0', '0', '7', '0', '0', '0', '1', '3', '3', '0', '1', '3', '55', '55', '57', '0', '800070656', '0', '0', '0', '0', '0', '0', '11333', '4356', '10432', '6340', '5442', '8192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600026', '1', '2', '8', '0', '0', '7', '0', '0', '3', '1', '1', '1', '2', '0', '1', '18', '9', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23589', '6243', '4164', '5219', '9315', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600027', '4', '2', '6', '0', '0', '3', '0', '0', '2', '0', '1', '3', '2', '0', '2', '78', '64', '53', '0', '0', '0', '0', '0', '0', '0', '0', '9475', '7200', '7241', '25668', '4288', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600028', '2', '2', '3', '0', '0', '5', '0', '0', '1', '0', '5', '1', '1', '0', '1', '15', '2', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5191', '5187', '5347', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600029', '3', '2', '8', '0', '0', '3', '0', '0', '3', '1', '2', '4', '2', '0', '0', '28', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29857', '1024', '5412', '8225', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600030', '1', '2', '5', '0', '0', '7', '0', '0', '4', '1', '0', '0', '1', '3', '2', '14', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600031', '7', '2', '7', '0', '0', '1', '0', '0', '3', '0', '3', '3', '2', '3', '2', '30', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600032', '8', '2', '2', '0', '0', '4', '0', '0', '1', '1', '0', '0', '0', '3', '0', '7', '7', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5600', '5472', '9856', '5440', '5440', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600033', '8', '2', '1', '0', '0', '4', '0', '0', '2', '0', '4', '2', '2', '1', '3', '17', '7', '11', '0', '0', '0', '0', '0', '0', '0', '0', '9316', '2084', '15424', '5120', '4384', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600034', '2', '2', '9', '0', '0', '5', '0', '0', '4', '1', '5', '1', '2', '0', '2', '28', '16', '6', '0', '0', '0', '0', '0', '0', '0', '0', '9316', '2084', '15424', '5120', '4384', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600035', '3', '2', '2', '0', '0', '3', '0', '0', '1', '1', '4', '1', '1', '3', '3', '21', '16', '14', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '4128', '4097', '5252', '25825', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600036', '4', '2', '5', '0', '0', '6', '0', '0', '5', '0', '1', '2', '2', '3', '1', '7', '11', '10', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5191', '5187', '5347', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600037', '7', '2', '1', '0', '0', '3', '0', '0', '1', '1', '3', '5', '3', '1', '1', '59', '58', '56', '0', '0', '0', '0', '0', '0', '0', '0', '20576', '10243', '10307', '1024', '4131', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600038', '1', '2', '3', '0', '0', '8', '0', '0', '1', '1', '5', '1', '3', '3', '2', '32', '13', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600039', '6', '2', '4', '0', '0', '1', '0', '0', '2', '1', '2', '0', '0', '3', '2', '32', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600040', '3', '2', '5', '0', '0', '7', '0', '0', '0', '0', '3', '1', '1', '2', '1', '19', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600041', '3', '2', '6', '0', '0', '3', '0', '0', '1', '1', '0', '3', '1', '1', '3', '17', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35204', '5190', '1024', '4288', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600042', '7', '2', '1', '0', '0', '5', '9', '0', '3', '1', '2', '4', '3', '2', '2', '19', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23589', '32867', '2112', '5185', '4161', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600043', '8', '2', '4', '0', '0', '2', '0', '0', '1', '1', '2', '0', '0', '3', '0', '14', '10', '12', '0', '815793167', '0', '0', '0', '0', '0', '0', '25728', '35072', '15744', '1024', '8288', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600044', '4', '2', '6', '0', '0', '6', '0', '0', '5', '0', '1', '1', '1', '3', '2', '14', '8', '12', '0', '737149955', '0', '0', '0', '0', '0', '0', '0', '2208', '15744', '10528', '8258', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600045', '2', '2', '6', '0', '0', '1', '0', '0', '5', '1', '2', '4', '1', '3', '1', '21', '3', '6', '0', '768609300', '0', '0', '0', '0', '0', '0', '20640', '2209', '15648', '6340', '9568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600046', '7', '2', '5', '0', '0', '1', '0', '0', '2', '1', '2', '3', '2', '2', '3', '3', '8', '16', '0', '721421325', '0', '0', '0', '0', '0', '0', '23596', '2304', '2240', '2272', '9603', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600047', '1', '2', '3', '0', '0', '8', '0', '0', '5', '0', '5', '0', '1', '3', '0', '17', '3', '1', '0', '705692693', '0', '0', '0', '0', '0', '0', '0', '9376', '6145', '11264', '9315', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600048', '5', '2', '4', '0', '0', '4', '0', '0', '5', '1', '4', '0', '1', '1', '1', '68', '58', '60', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600049', '2', '2', '1', '0', '0', '1', '0', '0', '5', '0', '4', '0', '1', '2', '3', '7', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '2146', '2049', '1024', '8192', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600050', '6', '2', '4', '0', '0', '8', '0', '0', '1', '0', '4', '2', '3', '1', '0', '52', '64', '52', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600051', '1', '2', '7', '0', '0', '2', '0', '0', '1', '0', '2', '0', '1', '0', '0', '12', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600052', '3', '2', '8', '0', '0', '4', '0', '0', '5', '1', '4', '2', '1', '2', '0', '19', '11', '4', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '4227', '10304', '1024', '4129', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600053', '2', '2', '8', '0', '0', '3', '0', '0', '2', '0', '2', '2', '0', '1', '2', '16', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '23887', '10272', '2083', '11296', '10336', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600054', '3', '2', '1', '0', '0', '2', '0', '0', '5', '0', '1', '3', '2', '3', '0', '72', '57', '60', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4130', '16417', '2048', '1024', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600055', '4', '2', '1', '0', '0', '8', '0', '0', '2', '0', '4', '5', '3', '1', '3', '12', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '10274', '7202', '15360', '11264', '10240', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600056', '7', '2', '5', '0', '0', '4', '0', '0', '2', '0', '3', '4', '3', '0', '1', '24', '10', '12', '0', '0', '0', '0', '0', '0', '0', '0', '10496', '4224', '10304', '11360', '8225', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600057', '7', '2', '3', '0', '0', '4', '31', '0', '3', '0', '1', '2', '3', '3', '3', '32', '10', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31904', '4352', '25729', '15552', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600058', '8', '2', '8', '0', '0', '3', '0', '0', '4', '0', '2', '5', '1', '1', '2', '5', '1', '1', '0', '752879636', '0', '0', '0', '0', '0', '0', '4417', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600059', '4', '2', '5', '0', '0', '1', '0', '0', '3', '1', '2', '2', '0', '0', '1', '29', '7', '13', '0', '0', '0', '0', '0', '0', '0', '0', '23887', '10272', '2083', '11296', '10336', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600060', '5', '2', '3', '0', '0', '4', '0', '0', '4', '0', '2', '1', '3', '3', '0', '56', '52', '55', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600061', '3', '2', '1', '0', '0', '5', '0', '0', '0', '1', '3', '3', '1', '2', '3', '77', '65', '55', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600062', '1', '2', '7', '0', '0', '1', '0', '0', '2', '0', '5', '1', '1', '1', '0', '2', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '7297', '2048', '1024', '8257', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600063', '8', '2', '2', '0', '0', '1', '0', '0', '2', '1', '0', '2', '2', '3', '1', '12', '11', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600064', '8', '2', '1', '0', '0', '3', '0', '0', '3', '1', '1', '4', '2', '1', '2', '13', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10339', '39360', '1024', '38921', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600065', '2', '2', '8', '0', '0', '3', '0', '0', '4', '0', '0', '5', '1', '0', '3', '9', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '10276', '39040', '38976', '38919', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600066', '6', '2', '2', '0', '0', '3', '29', '0', '0', '0', '0', '0', '0', '0', '0', '56', '52', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10370', '39168', '1024', '38925', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600067', '3', '2', '3', '0', '0', '7', '0', '0', '3', '0', '4', '2', '3', '1', '3', '6', '2', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600068', '7', '2', '7', '0', '0', '8', '0', '0', '5', '0', '0', '5', '0', '0', '1', '5', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600069', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '4', '2', '1', '0', '0', '10', '14', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600070', '1', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '3', '1', '1', '18', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600071', '2', '2', '4', '0', '0', '5', '0', '0', '3', '1', '0', '2', '2', '0', '2', '3', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600072', '4', '2', '7', '0', '0', '1', '0', '0', '0', '1', '1', '2', '2', '3', '0', '27', '13', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600073', '22', '2', '0', '0', '0', '1', '0', '0', '1', '0', '3', '4', '0', '3', '3', '28', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '922720', '922816', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600074', '9', '2', '1', '0', '0', '3', '0', '0', '3', '0', '2', '0', '0', '2', '1', '68', '53', '59', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '10273', '28739', '1024', '28704', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600075', '3', '2', '7', '0', '0', '4', '0', '0', '1', '0', '2', '0', '0', '2', '2', '21', '9', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20513', '5313', '7297', '5313', '9345', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600076', '4', '3', '5', '0', '0', '8', '0', '0', '5', '0', '5', '3', '1', '2', '3', '20', '15', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28742', '4099', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600077', '8', '2', '1', '0', '0', '4', '0', '0', '2', '0', '0', '2', '3', '0', '2', '28', '11', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '2146', '2049', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600078', '6', '1', '3', '0', '0', '3', '0', '0', '4', '0', '2', '2', '1', '3', '3', '75', '62', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '4194', '10305', '1024', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600079', '3', '2', '3', '0', '0', '8', '0', '0', '1', '0', '0', '2', '3', '2', '3', '21', '16', '6', '0', '0', '0', '0', '0', '0', '0', '0', '35840', '4128', '4097', '5121', '25825', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600080', '22', '2', '7', '0', '0', '1', '0', '0', '2', '0', '3', '3', '3', '0', '1', '27', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '922880', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600081', '9', '1', '5', '0', '0', '4', '9', '0', '1', '1', '3', '1', '3', '2', '3', '52', '60', '64', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16515', '5280', '1024', '5313', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600082', '3', '2', '2', '0', '0', '4', '0', '0', '3', '1', '4', '3', '2', '3', '0', '2', '6', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '28737', '28675', '1024', '4194', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600083', '23', '2', '0', '0', '0', '1', '0', '0', '3', '1', '3', '1', '1', '3', '2', '29', '5', '13', '0', '0', '0', '0', '0', '0', '0', '0', '923872', '923872', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600084', '22', '2', '0', '0', '0', '1', '5', '0', '3', '1', '3', '3', '0', '2', '2', '32', '9', '9', '0', '0', '0', '0', '0', '0', '0', '0', '922720', '922816', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600085', '23', '2', '0', '0', '0', '1', '0', '0', '2', '1', '5', '0', '2', '3', '2', '8', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '923744', '923873', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600086', '3', '2', '5', '0', '0', '4', '0', '0', '1', '0', '2', '4', '3', '0', '3', '7', '7', '16', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '35075', '2178', '2048', '5280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600087', '5', '3', '1', '0', '0', '1', '2', '0', '3', '1', '5', '4', '3', '1', '1', '30', '6', '10', '0', '0', '0', '0', '0', '0', '0', '0', '30850', '30755', '7170', '5280', '28738', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600088', '4', '2', '4', '0', '0', '6', '0', '0', '4', '0', '3', '4', '1', '0', '2', '9', '5', '6', '0', '0', '0', '0', '0', '0', '0', '0', '10279', '32833', '28704', '11331', '25668', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600089', '8', '2', '6', '0', '0', '1', '0', '0', '1', '1', '3', '2', '3', '0', '3', '19', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '6176', '39008', '25668', '6176', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600090', '7', '2', '3', '0', '0', '5', '9', '0', '1', '0', '0', '4', '1', '1', '2', '14', '6', '11', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '33858', '7170', '5250', '6212', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600091', '22', '3', '0', '0', '0', '1', '31', '0', '4', '1', '5', '2', '1', '0', '0', '3', '9', '6', '0', '0', '0', '0', '0', '0', '0', '0', '922752', '922912', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600092', '22', '2', '0', '0', '0', '1', '8', '0', '3', '0', '1', '1', '1', '1', '2', '23', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '922656', '922880', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600093', '8', '1', '3', '0', '0', '3', '0', '0', '3', '0', '3', '2', '2', '1', '0', '30', '14', '14', '0', '0', '0', '0', '0', '0', '0', '0', '9474', '30722', '1024', '5218', '38919', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600094', '7', '2', '2', '0', '0', '1', '9', '0', '0', '1', '2', '0', '0', '0', '2', '12', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '35873', '30851', '28705', '1024', '28736', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600095', '22', '2', '0', '0', '0', '1', '31', '0', '5', '1', '0', '1', '0', '0', '0', '27', '1', '14', '0', '0', '0', '0', '0', '0', '0', '0', '922752', '922720', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600096', '22', '1', '0', '0', '0', '1', '0', '0', '0', '1', '1', '0', '2', '1', '2', '12', '12', '12', '0', '0', '0', '0', '0', '0', '0', '0', '922658', '922784', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600097', '22', '3', '0', '0', '0', '1', '0', '0', '1', '0', '0', '0', '0', '3', '2', '19', '1', '16', '0', '0', '0', '0', '0', '0', '0', '0', '922656', '922656', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600098', '5', '2', '4', '0', '0', '1', '0', '0', '2', '0', '0', '0', '0', '3', '2', '17', '3', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600099', '7', '2', '1', '0', '0', '5', '5', '0', '2', '0', '5', '4', '0', '1', '2', '32', '2', '11', '0', '0', '0', '0', '0', '0', '0', '0', '6176', '28736', '6144', '1024', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600100', '7', '2', '5', '0', '0', '5', '9', '0', '5', '0', '1', '1', '1', '0', '1', '19', '11', '16', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600101', '6', '2', '1', '0', '0', '5', '0', '0', '5', '1', '1', '3', '3', '2', '3', '2', '10', '2', '0', '0', '0', '0', '0', '0', '0', '0', '9345', '35872', '5120', '25668', '4256', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600102', '4', '2', '8', '0', '0', '8', '0', '0', '1', '1', '1', '0', '0', '3', '0', '17', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600103', '7', '2', '1', '0', '0', '1', '0', '0', '0', '1', '1', '0', '2', '0', '0', '13', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '28801', '2048', '1024', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600104', '7', '2', '1', '0', '0', '5', '0', '0', '5', '0', '0', '4', '0', '0', '3', '10', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4226', '28736', '1024', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600105', '7', '2', '4', '0', '0', '1', '0', '0', '2', '0', '3', '3', '1', '2', '2', '29', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16418', '5152', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600106', '7', '2', '5', '0', '0', '4', '0', '0', '2', '1', '4', '1', '2', '0', '2', '7', '15', '9', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16418', '5152', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600107', '7', '2', '1', '0', '0', '4', '1', '0', '5', '1', '0', '2', '3', '2', '1', '8', '4', '8', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600108', '6', '2', '4', '0', '0', '5', '0', '0', '4', '0', '4', '4', '2', '2', '3', '5', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35872', '39392', '1024', '5152', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600109', '7', '2', '4', '0', '0', '1', '9', '0', '0', '1', '2', '5', '2', '0', '0', '21', '11', '5', '0', '0', '0', '0', '0', '0', '0', '0', '35904', '35937', '28801', '1024', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600110', '2', '2', '7', '0', '0', '2', '0', '0', '2', '1', '1', '5', '2', '1', '2', '8', '3', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '28737', '5217', '1024', '1059', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600111', '8', '2', '4', '0', '0', '7', '0', '0', '0', '1', '5', '3', '2', '2', '2', '58', '53', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28742', '4099', '1024', '4130', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600112', '3', '2', '1', '0', '0', '4', '0', '0', '0', '1', '5', '2', '3', '0', '3', '4', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '35872', '4097', '1024', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600113', '5', '2', '4', '0', '0', '3', '0', '0', '5', '1', '4', '3', '2', '2', '2', '24', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '35872', '4097', '5220', '25825', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600114', '5', '2', '2', '0', '0', '7', '0', '0', '5', '0', '4', '4', '2', '1', '2', '7', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '33827', '7170', '5312', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600115', '2', '2', '4', '0', '0', '2', '0', '0', '4', '1', '3', '4', '3', '3', '1', '15', '6', '3', '0', '0', '0', '0', '0', '0', '0', '0', '5410', '5379', '5191', '5187', '5347', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600116', '3', '2', '1', '0', '0', '7', '0', '0', '2', '0', '1', '4', '1', '0', '2', '13', '2', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29857', '1024', '5412', '8225', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600117', '4', '2', '7', '0', '0', '8', '0', '0', '1', '0', '4', '5', '1', '1', '1', '26', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '28674', '28704', '28737', '25668', '25633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600118', '3', '2', '8', '0', '0', '8', '0', '0', '3', '0', '1', '1', '3', '0', '2', '13', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '13408', '2148', '16545', '10337', '25697', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600119', '8', '2', '8', '0', '0', '8', '0', '0', '3', '1', '3', '0', '2', '1', '3', '54', '60', '51', '0', '0', '0', '0', '0', '0', '0', '0', '35907', '35936', '28707', '1024', '28769', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600120', '3', '2', '5', '0', '0', '7', '0', '0', '3', '0', '0', '0', '0', '2', '1', '24', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '5184', '28704', '1024', '28737', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600121', '4', '2', '2', '0', '0', '4', '0', '0', '4', '0', '2', '4', '2', '0', '0', '16', '10', '16', '0', '0', '0', '0', '0', '0', '0', '0', '6176', '30720', '2083', '25668', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600122', '3', '2', '2', '0', '0', '4', '0', '0', '5', '1', '3', '3', '0', '0', '0', '8', '10', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5376', '4224', '10304', '1024', '25633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600123', '2', '2', '8', '0', '0', '2', '0', '0', '2', '0', '2', '4', '1', '1', '1', '30', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600124', '2', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '4', '1', '2', '2', '21', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600125', '5', '2', '3', '0', '0', '3', '0', '0', '5', '0', '3', '2', '2', '3', '2', '27', '3', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '28705', '28675', '1024', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600126', '8', '2', '3', '0', '0', '5', '0', '0', '5', '1', '4', '1', '0', '0', '2', '78', '56', '61', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '2146', '38944', '1024', '38913', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600127', '8', '2', '4', '0', '0', '5', '0', '0', '1', '1', '2', '0', '2', '2', '1', '69', '65', '60', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '32770', '28675', '25632', '28674', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600128', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600129', '1', '2', '1', '0', '0', '8', '5', '0', '4', '1', '1', '3', '1', '1', '2', '32', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600130', '9', '2', '2', '0', '0', '4', '0', '0', '3', '1', '5', '4', '3', '3', '0', '59', '61', '62', '0', '0', '0', '0', '0', '0', '0', '0', '9315', '4128', '28673', '5252', '25825', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600131', '5', '2', '1', '0', '0', '5', '0', '0', '3', '0', '2', '1', '1', '3', '1', '11', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600132', '9', '2', '4', '0', '0', '2', '0', '0', '4', '0', '4', '3', '1', '2', '2', '52', '66', '58', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '4291', '5185', '1024', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600133', '1', '2', '8', '0', '0', '7', '9', '0', '2', '0', '2', '5', '2', '0', '1', '4', '15', '5', '0', '0', '0', '0', '0', '0', '0', '0', '35905', '35937', '2120', '1024', '4224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600134', '2', '2', '1', '0', '0', '2', '0', '0', '3', '0', '0', '5', '3', '2', '1', '30', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600135', '2', '2', '4', '0', '0', '1', '0', '0', '1', '0', '3', '1', '0', '1', '3', '25', '14', '15', '0', '0', '0', '0', '0', '0', '0', '0', '20503', '16385', '7170', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600136', '2', '2', '5', '0', '0', '3', '0', '0', '3', '1', '1', '2', '2', '1', '2', '9', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '5121', '33860', '1024', '25600', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600137', '22', '2', '0', '0', '0', '1', '0', '0', '5', '1', '1', '3', '1', '2', '1', '7', '13', '11', '0', '0', '0', '0', '0', '0', '0', '0', '922720', '922816', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600138', '4', '2', '8', '0', '0', '1', '0', '0', '3', '0', '1', '2', '3', '1', '3', '14', '3', '11', '0', '0', '0', '0', '0', '0', '0', '0', '23887', '10272', '2083', '11296', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600139', '8', '2', '1', '0', '0', '5', '0', '0', '0', '0', '3', '3', '3', '3', '1', '51', '66', '61', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '31808', '1024', '6145', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600140', '9', '2', '5', '0', '0', '1', '0', '0', '3', '1', '0', '3', '1', '3', '0', '71', '59', '53', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '2209', '2178', '5188', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600141', '8', '2', '6', '0', '0', '8', '0', '0', '0', '1', '3', '5', '3', '2', '3', '74', '62', '63', '0', '0', '0', '0', '0', '0', '0', '0', '9312', '10276', '1248', '5120', '21506', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600142', '2', '2', '9', '0', '0', '2', '0', '0', '2', '1', '5', '5', '1', '2', '0', '2', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '30721', '39392', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600143', '6', '2', '1', '0', '0', '1', '24', '0', '0', '0', '0', '0', '0', '0', '0', '12', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '35874', '1376', '1024', '38919', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600144', '6', '2', '2', '0', '0', '2', '30', '0', '0', '0', '0', '0', '0', '0', '0', '12', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '35874', '1376', '1024', '38919', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1600145', '6', '2', '3', '0', '0', '2', '7', '0', '0', '0', '0', '0', '0', '0', '0', '12', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '35874', '1376', '1024', '38919', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700001', '2', '2', '6', '0', '0', '2', '0', '0', '2', '1', '4', '4', '0', '2', '3', '26', '15', '7', '0', '0', '0', '0', '0', '0', '0', '0', '11302', '10433', '16608', '5376', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700002', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7204', '5156', '1024', '4132', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700003', '3', '3', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '5152', '1024', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700004', '6', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '55', '62', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '1377', '5154', '1024', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700005', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '11297', '4131', '11296', '25632', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700006', '9', '2', '4', '0', '0', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '71', '56', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31776', '1088', '5121', '25602', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700007', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33824', '2272', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700008', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10240', '1027', '6144', '5121', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700009', '4', '2', '6', '0', '0', '8', '0', '0', '5', '1', '5', '2', '3', '1', '1', '4', '10', '10', '0', '79697950', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700010', '3', '2', '5', '0', '0', '4', '0', '0', '4', '0', '0', '3', '1', '0', '3', '23', '6', '3', '0', '210764830', '236979210', '0', '0', '0', '0', '0', '11425', '11364', '7264', '1024', '21568', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700011', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700012', '5', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '5', '1', '2', '1', '61', '51', '56', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700013', '7', '3', '1', '0', '0', '4', '0', '0', '2', '1', '5', '0', '0', '3', '3', '21', '5', '7', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700014', '5', '1', '4', '0', '0', '5', '0', '0', '2', '0', '4', '5', '1', '1', '2', '17', '1', '11', '0', '862980106', '0', '0', '0', '0', '0', '0', '23881', '33955', '2117', '1024', '6214', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700015', '6', '2', '4', '0', '0', '6', '0', '0', '1', '1', '0', '1', '3', '0', '1', '31', '4', '5', '0', '862980096', '0', '0', '0', '0', '0', '0', '25728', '1376', '6147', '6147', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700016', '6', '2', '2', '0', '0', '6', '0', '0', '4', '1', '3', '2', '3', '3', '1', '17', '9', '9', '0', '862980096', '0', '0', '0', '0', '0', '0', '25728', '1376', '6147', '6147', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700017', '3', '2', '8', '0', '0', '3', '0', '0', '1', '0', '3', '0', '2', '0', '0', '12', '14', '9', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '6433', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700018', '1', '2', '6', '0', '0', '8', '0', '0', '0', '0', '4', '0', '3', '3', '3', '16', '3', '8', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '1124', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700019', '7', '2', '2', '0', '0', '1', '0', '0', '3', '1', '3', '3', '1', '3', '3', '4', '8', '7', '0', '862981121', '0', '0', '0', '0', '0', '0', '4355', '6433', '6401', '6338', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700020', '4', '2', '6', '0', '0', '8', '0', '0', '0', '0', '4', '4', '3', '2', '0', '17', '10', '10', '0', '862981120', '0', '0', '0', '0', '0', '0', '23852', '6242', '1344', '6145', '6217', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700021', '4', '2', '8', '0', '0', '7', '0', '0', '5', '0', '2', '3', '3', '1', '1', '62', '57', '65', '0', '862981120', '0', '0', '0', '0', '0', '0', '23852', '6242', '1344', '6145', '6217', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700022', '8', '2', '8', '0', '0', '3', '0', '0', '4', '0', '5', '0', '2', '3', '1', '7', '7', '1', '0', '862980116', '0', '0', '0', '0', '0', '0', '23883', '6432', '4384', '6340', '6400', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700023', '21', '1', '0', '0', '0', '31', '0', '0', '3', '1', '0', '1', '0', '3', '2', '28', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '2753', '2753', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700024', '21', '2', '0', '0', '0', '21', '0', '0', '5', '0', '0', '5', '1', '1', '0', '28', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '1856', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700025', '21', '2', '0', '0', '0', '41', '0', '0', '0', '1', '2', '5', '0', '3', '0', '14', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '1792', '1792', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700026', '2', '2', '7', '0', '0', '1', '0', '0', '0', '0', '3', '1', '0', '3', '3', '11', '3', '8', '0', '878708737', '0', '0', '0', '0', '0', '0', '5376', '4354', '6304', '6304', '6340', '167936', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700027', '2', '2', '7', '0', '0', '5', '4', '0', '2', '1', '1', '1', '1', '1', '3', '9', '5', '12', '0', '705692693', '0', '0', '0', '0', '0', '0', '0', '2147', '7265', '2083', '9313', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700028', '2', '1', '8', '0', '0', '2', '0', '0', '5', '1', '5', '2', '2', '2', '1', '15', '9', '2', '0', '210765827', '236979210', '0', '0', '0', '0', '0', '0', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700029', '4', '2', '1', '0', '0', '5', '24', '0', '0', '0', '0', '0', '0', '0', '0', '73', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9376', '5190', '1024', '1057', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700030', '4', '2', '8', '0', '0', '8', '0', '0', '4', '0', '5', '2', '1', '3', '0', '16', '14', '11', '0', '347081798', '0', '0', '0', '0', '0', '0', '7392', '35136', '2147', '5282', '5408', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700031', '8', '3', '2', '0', '0', '3', '0', '0', '0', '0', '2', '2', '0', '1', '0', '12', '6', '11', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '1600', '14402', '21635', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700032', '5', '2', '1', '0', '0', '7', '0', '0', '1', '0', '1', '5', '3', '3', '2', '15', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20481', '10273', '7171', '1024', '8194', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700033', '6', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '13', '13', '0', '721421324', '731907074', '0', '0', '0', '0', '0', '0', '2153', '2115', '1024', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700034', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '11', '11', '0', '721421314', '731907073', '0', '0', '0', '0', '0', '4224', '1408', '2145', '2112', '2083', '122880', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700035', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '9', '12', '0', '826278912', '0', '0', '0', '0', '0', '0', '5152', '7200', '1152', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700036', '8', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '16', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '7200', '2080', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700037', '9', '2', '4', '0', '0', '2', '0', '0', '2', '1', '4', '2', '0', '3', '0', '54', '51', '52', '0', '0', '0', '0', '0', '0', '0', '0', '20502', '16418', '5152', '1024', '5120', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700038', '3', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '5', '1', '2', '2', '25', '14', '16', '0', '0', '0', '0', '0', '0', '0', '0', '10496', '4224', '10304', '11360', '8225', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700039', '2', '2', '4', '0', '0', '3', '0', '0', '0', '1', '4', '0', '2', '1', '1', '23', '15', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20507', '10368', '10242', '1024', '1121', '208896', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700040', '10902', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700041', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700042', '2', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4417', '4128', '5152', '10529', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700043', '10903', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('1700044', '5', '2', '2', '0', '0', '5', '0', '0', '5', '1', '5', '0', '3', '3', '2', '12', '6', '7', '0', '768607232', '0', '0', '0', '0', '0', '0', '4098', '4098', '4099', '6147', '9248', '14336', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100101', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100102', '10002', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100103', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100104', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100105', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100106', '10002', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100107', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100108', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100109', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100110', '10002', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100111', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100112', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100113', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100114', '10002', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100115', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100116', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100117', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100118', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100119', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100120', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100121', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100201', '10003', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100202', '10003', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100203', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100204', '10003', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100205', '10003', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100206', '10003', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100207', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100208', '10003', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100209', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100210', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100211', '10003', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100212', '10003', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100213', '10003', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100214', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100215', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100301', '10004', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100302', '10004', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100303', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100304', '10004', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100305', '10004', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100306', '10004', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100307', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100308', '10004', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100309', '10004', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100310', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100311', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100312', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100313', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100314', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100315', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100316', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100317', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100401', '10005', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100402', '10005', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100403', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100404', '10005', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100405', '10005', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100406', '10005', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100407', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100408', '10005', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100409', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100410', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100411', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100412', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100413', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100501', '10006', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100502', '10006', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100503', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100504', '10006', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100505', '10006', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100506', '10006', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100507', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100508', '10006', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100509', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100510', '10006', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100511', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100512', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100513', '10006', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100514', '10006', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100515', '10006', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100516', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100517', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100518', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100519', '10006', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100601', '10007', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100602', '10007', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100603', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100604', '10007', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100605', '10007', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100606', '10007', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100607', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100608', '10007', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100609', '10007', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100610', '10007', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100611', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100612', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100613', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100614', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100615', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100701', '10008', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100702', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100703', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100704', '10008', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100705', '10008', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100706', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100707', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100708', '10008', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100709', '10008', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100710', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100711', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100712', '10008', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100713', '10008', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100714', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100715', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100716', '10008', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100717', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100718', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100719', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100720', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100721', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100722', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100723', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100801', '10009', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100802', '10009', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100803', '10009', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100804', '10009', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100901', '10011', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100902', '10011', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100903', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100904', '10011', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100905', '10011', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100906', '10011', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100907', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100908', '10011', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100909', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100910', '10011', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100911', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100912', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100913', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100914', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100915', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2100916', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101001', '10012', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101002', '10012', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101003', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101004', '10012', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101005', '10012', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101006', '10012', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101007', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101008', '10012', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101009', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101010', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101011', '10012', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101101', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101102', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101103', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101104', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101105', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101106', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101107', '10017', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101108', '10017', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101109', '10017', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101110', '10017', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101111', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101112', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101113', '10017', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101114', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101115', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101116', '10017', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101117', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101118', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101119', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101120', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101201', '10020', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101202', '10020', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101203', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101204', '10020', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101205', '10020', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101206', '10020', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101207', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101208', '10020', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101209', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101210', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101211', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101212', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101213', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101214', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101301', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101302', '10021', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101303', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101304', '10021', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101305', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101306', '10021', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101307', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101308', '10021', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101309', '10021', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101310', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101311', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101312', '10021', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101313', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101314', '10021', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101315', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101316', '10021', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101317', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101318', '10021', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101319', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101320', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101321', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101322', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101323', '10021', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101401', '10023', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101402', '10023', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101403', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101404', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101405', '10023', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101406', '10023', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101407', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101408', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101409', '10023', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101410', '10023', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101411', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101412', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101413', '10023', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101414', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101415', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101416', '10023', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101417', '10023', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101418', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101419', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101420', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101421', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101422', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101423', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101424', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101425', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101426', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101427', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101428', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101429', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101430', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101431', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101501', '10025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101502', '10025', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101503', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101504', '10025', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101505', '10025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101506', '10025', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101507', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101508', '10025', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101509', '10025', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101510', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101511', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101512', '10025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101513', '10025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101514', '10025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101515', '10025', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101601', '10028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101602', '10028', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101603', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101604', '10028', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101605', '10028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101606', '10028', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101607', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101608', '10028', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101609', '10028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101610', '10028', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101611', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101612', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101613', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101614', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101701', '10029', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101702', '10029', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101703', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101704', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101705', '10029', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101706', '10029', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101707', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101708', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101709', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101710', '10029', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101711', '10029', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101712', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101713', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101714', '10029', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101715', '10029', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101801', '10030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101802', '10030', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101803', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101804', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101805', '10030', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101806', '10030', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101807', '10030', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101808', '10030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101809', '10030', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101810', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379570', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101811', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379570', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101812', '10030', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101813', '10030', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101814', '10030', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101815', '10030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101816', '10030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101817', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101818', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101819', '10030', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101820', '10030', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101821', '10030', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168822804', '0', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101822', '10030', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101901', '10031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693884', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101902', '10031', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692910', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101903', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692880', '32514138', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101904', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697920', '32514138', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101905', '10031', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697920', '32507964', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101906', '10031', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32507964', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101907', '10031', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32508968', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101908', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697920', '32514138', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101909', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101910', '10031', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32508968', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2101911', '10031', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32508968', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102001', '10032', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102002', '10032', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102003', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102004', '10032', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102005', '10032', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102006', '10032', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102007', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102008', '10032', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102009', '10032', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102010', '10032', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102011', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102012', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102013', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102014', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102015', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102016', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102017', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102018', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102101', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102102', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102103', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102104', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102105', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102106', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102107', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102108', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102109', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102110', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102111', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102112', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102113', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102114', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102115', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102116', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102117', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102118', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102119', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102120', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102121', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102122', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102123', '10033', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102124', '10033', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102125', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102126', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102127', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102128', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102129', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102201', '10034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102202', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102203', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102204', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102205', '10034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102206', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102207', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102208', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102209', '10034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102210', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102211', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102212', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102213', '10034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102214', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102215', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102216', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102217', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102218', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102219', '10034', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102220', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102221', '10034', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102222', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102223', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102224', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102225', '10034', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102226', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102227', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102228', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102301', '10035', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102302', '10035', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102303', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102304', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102305', '10035', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102306', '10035', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102307', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102308', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102309', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102310', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102311', '10035', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102312', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102313', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102314', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102315', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102316', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102317', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102318', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102319', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102401', '10036', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102501', '10037', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102502', '10037', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102503', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102504', '10037', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102505', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102506', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102507', '10037', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102508', '10037', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102601', '10038', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102602', '10038', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102603', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102604', '10038', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102605', '10038', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102606', '10038', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102607', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102608', '10038', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102609', '10038', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102610', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102611', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102612', '10038', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102613', '10038', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102701', '10039', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102702', '10039', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102703', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102704', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102705', '10039', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102706', '10039', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102707', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102708', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102709', '10039', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102710', '10039', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102711', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102712', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102713', '10039', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102714', '10039', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102715', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102716', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102717', '10039', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102718', '10039', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102719', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102720', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102721', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102722', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102723', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102724', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102801', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102802', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102803', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102804', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1057', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102805', '10040', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102806', '10040', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102807', '10040', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102808', '10040', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102809', '10040', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102901', '10041', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102902', '10041', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102903', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102904', '10041', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102905', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102906', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102907', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2102908', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103001', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103002', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103003', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103004', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103005', '10043', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103006', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103007', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103008', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103009', '10058', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103010', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103011', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103012', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103013', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103101', '10045', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103102', '10045', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103103', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103104', '10045', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103105', '10045', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103106', '10045', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103107', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103108', '10045', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103109', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103110', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103111', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103112', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103113', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103114', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103115', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103201', '10046', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103202', '10046', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103203', '10046', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103301', '10048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103302', '10048', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103303', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103304', '10048', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103305', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103306', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103307', '10048', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103401', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103402', '10049', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103403', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103404', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103405', '10049', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103406', '10049', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103501', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103502', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103503', '10054', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103504', '10054', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103505', '10054', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103801', '10057', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103802', '10057', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103901', '10501', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103902', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103903', '10501', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103904', '10501', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103905', '10501', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103906', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103907', '10501', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103908', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103909', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2103910', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104001', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104002', '10502', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104003', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104004', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104005', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104006', '10502', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104007', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104008', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104009', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104010', '10502', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104011', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104012', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104013', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104014', '10502', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104015', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104016', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104017', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104018', '10502', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104019', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104020', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104021', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104022', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104023', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104024', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104025', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104026', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104027', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104028', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104101', '10503', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104102', '10503', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104103', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104104', '10503', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104105', '10503', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104106', '10503', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104107', '10503', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104108', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104109', '10503', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104110', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104111', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104112', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104113', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104201', '10504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104202', '10504', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104203', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104204', '10504', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104205', '10504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104206', '10504', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104207', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104208', '10504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104209', '10504', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104210', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104211', '10504', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104212', '10504', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104213', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104214', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104215', '10504', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104216', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104217', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104218', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104301', '10505', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104302', '10505', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104303', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104304', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104305', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104306', '10505', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104307', '10505', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104308', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104309', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104310', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104311', '10505', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104312', '10505', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104313', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104314', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104315', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104316', '10505', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104317', '10505', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104318', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104319', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104320', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104321', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104322', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104323', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104324', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104325', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104326', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104327', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104328', '10505', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104329', '10505', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104401', '10506', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104402', '10506', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104403', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104404', '10506', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104405', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104406', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104407', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104501', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104502', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104503', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104504', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104505', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104506', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104507', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104508', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104509', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104510', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104511', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104512', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104513', '10507', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104514', '10507', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104515', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104516', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104517', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104601', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104602', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104603', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104604', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104605', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104606', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104607', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104701', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104702', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104703', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104704', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104705', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104706', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104801', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104802', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104803', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104804', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104805', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104806', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104901', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104902', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104903', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104904', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104905', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104906', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104907', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2104908', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105001', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105002', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105003', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105004', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105005', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105006', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105101', '10508', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105102', '10508', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105103', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105104', '10508', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105105', '10508', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105106', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105201', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105301', '10509', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105302', '10509', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105303', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105304', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105305', '10509', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105306', '10509', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105307', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105308', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105309', '10509', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105310', '10509', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105311', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105312', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105313', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105314', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105315', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105401', '10510', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105402', '10510', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105403', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105404', '10510', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105405', '10510', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105406', '10510', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105407', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105408', '10510', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105409', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105410', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105411', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105412', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105413', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105414', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105415', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105416', '10510', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105501', '10511', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105502', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105503', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105504', '10511', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105505', '10511', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105506', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105507', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105508', '10511', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105509', '10511', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105510', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105511', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105512', '10511', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105513', '10511', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105514', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105515', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105516', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105517', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105518', '10511', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105519', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105520', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105521', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105601', '10512', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105602', '10512', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105603', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105604', '10512', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105605', '10512', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105606', '10512', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105607', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105608', '10512', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105609', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105610', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105611', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105612', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105613', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105614', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105701', '10513', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105702', '10513', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105703', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105704', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105705', '10513', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105706', '10513', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105707', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105708', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105709', '10513', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105710', '10513', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105711', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105712', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105713', '10513', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105714', '10513', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105715', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105716', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105717', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105718', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105719', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105720', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105721', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105722', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105723', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105724', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105725', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105726', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105801', '10515', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105802', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105803', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105804', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105805', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105901', '10516', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105902', '10516', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105903', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105904', '10516', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105905', '10516', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105906', '10516', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105907', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105908', '10516', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105909', '10516', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105910', '10516', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105911', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105912', '10516', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105913', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105914', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105915', '10516', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105916', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105917', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105918', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2105919', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106001', '10518', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106002', '10518', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106003', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106004', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106005', '10518', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106006', '10518', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106007', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106008', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106009', '10518', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106010', '10518', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106011', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106012', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106013', '10518', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106014', '10518', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106015', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106016', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106017', '10518', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1029', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106018', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106019', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106020', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106021', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106022', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106201', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106202', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106203', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106204', '10520', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106205', '10520', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106206', '10520', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106207', '10520', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106208', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106209', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106210', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106211', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2144', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106212', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106213', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106214', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106215', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106216', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106217', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106218', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106219', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106220', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106221', '10520', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1216', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106222', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106223', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106224', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106225', '10520', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106301', '10901', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106302', '10901', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106303', '10901', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106304', '10901', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106305', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106306', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106307', '10901', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106308', '10901', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106309', '10901', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106310', '10901', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106311', '10901', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106312', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106401', '10902', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106402', '10902', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741396', '32507915', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106403', '10902', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79695892', '32510981', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106404', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106405', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741416', '32508948', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106406', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697970', '32510984', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106407', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697970', '32510984', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106408', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106409', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106410', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106411', '10902', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106412', '10902', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106413', '10902', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106414', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079681', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106415', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079681', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106416', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079681', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106417', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079683', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106418', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079683', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106419', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079683', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106420', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106421', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106422', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106423', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106424', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106425', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106426', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '32510978', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106427', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '32510978', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106428', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '32510978', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106429', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106430', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106431', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106432', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825858', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106433', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825858', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106434', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825858', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106435', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825866', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106436', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825866', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106437', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825866', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106438', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851275', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106439', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851275', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106440', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851275', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106441', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851276', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106442', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851276', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106443', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851276', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106444', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851287', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106445', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851287', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106446', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851287', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106447', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106448', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106449', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106450', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106451', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823848', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106452', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823848', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106453', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106454', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106455', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106456', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106457', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106458', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851284', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106459', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851286', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106460', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106461', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106462', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106463', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106464', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106465', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697970', '32510981', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106466', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697980', '32510984', '0', '0', '0', '0', '0', '3072', '1028', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106467', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080754', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106468', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080754', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106469', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080754', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106470', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106471', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106472', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106473', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106501', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106502', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724382', '59772958', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106503', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818492', '61867068', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106504', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724354', '59772930', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106505', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106506', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724393', '59772969', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106507', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724393', '59772969', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106508', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106509', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821790', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106510', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826885', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106511', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821800', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106512', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825858', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106513', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826884', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106514', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826884', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106515', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106516', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765835', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106517', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210767873', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106518', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765836', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106519', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765837', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106520', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765844', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106521', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765844', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106522', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106523', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379570', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106524', '10903', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379570', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106525', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106526', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106527', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106528', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106529', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106530', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106531', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106532', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106533', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106534', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106535', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '2051', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106536', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106537', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106538', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106539', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106540', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106541', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106542', '10903', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106601', '10904', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106602', '10904', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106603', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652958', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106604', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652958', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106605', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106606', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106607', '10904', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106608', '10904', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106609', '10904', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106610', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106611', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106612', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106613', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351051', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106614', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351051', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106615', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351051', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106616', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106617', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106618', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106619', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693834', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106620', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693834', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106621', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693834', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106622', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693825', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106623', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693825', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106624', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693825', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106625', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106626', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106627', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106628', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850241', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106629', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850241', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106630', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850241', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106631', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850242', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106632', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850242', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106633', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850242', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106634', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850270', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106635', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850270', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106636', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850270', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106637', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650892', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106638', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650892', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106639', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650892', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106640', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650920', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106641', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650920', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106642', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294650920', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106643', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351048', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106644', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351047', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106645', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106646', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351047', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106647', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351047', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106648', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351051', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106649', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351048', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106650', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693827', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106651', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693874', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106652', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693827', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106653', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693827', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106654', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693874', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106655', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106656', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106657', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106658', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106659', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106660', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850290', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106661', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106662', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106663', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106664', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106665', '10904', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294651984', '0', '0', '0', '0', '0', '0', '2048', '1184', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106666', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106701', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106702', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106703', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106704', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106705', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106706', '10905', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106707', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106708', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106709', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106710', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106711', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106712', '10905', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106713', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106714', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106715', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106716', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106717', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106718', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106719', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106720', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106721', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106722', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106723', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106724', '10905', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351045', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106725', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106726', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106727', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106728', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106729', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106730', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106731', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106801', '10907', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106802', '10907', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106803', '10907', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106804', '10907', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2106901', '10909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107002', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107003', '10911', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107004', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107301', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107302', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107303', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107401', '10854', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107601', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107602', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107603', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107604', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107605', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107606', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107607', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107608', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107609', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107610', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107611', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107612', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107613', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107614', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107615', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107616', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107617', '10013', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107618', '10013', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107619', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107620', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107621', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107622', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107623', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107624', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2107625', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108101', '10022', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108102', '10022', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108701', '10047', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108702', '10047', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108901', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108902', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108903', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2108904', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109001', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109002', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109003', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109004', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109005', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109006', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109801', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109901', '10515', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109902', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109903', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109904', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109905', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109906', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109907', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109908', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109909', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109910', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109911', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109912', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109913', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109914', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2109915', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110001', '10515', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110002', '10515', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110003', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110004', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110005', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110101', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110102', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110103', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110104', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110105', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110106', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110107', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110108', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110109', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110201', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110301', '10912', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693825', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110302', '10912', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693825', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110303', '10912', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692901', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110304', '10912', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692901', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110305', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741386', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110306', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741386', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110307', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110308', '10912', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110309', '10912', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110310', '10912', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110311', '10912', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697930', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110312', '10912', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697920', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110313', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741386', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110314', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110601', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110701', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2110702', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111001', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111002', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111003', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111004', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111005', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111006', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111007', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111008', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111009', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111010', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111011', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111012', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111013', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111014', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111015', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111016', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111017', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111018', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111019', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111020', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111021', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111022', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111023', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2111024', '10070', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162001', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766849', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162002', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766849', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162003', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766849', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162004', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766850', '236979210', '0', '0', '0', '231736332', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162005', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766850', '236979210', '0', '0', '0', '231736332', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162006', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766850', '236979210', '0', '0', '0', '231736332', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162007', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736350', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162008', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736350', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162009', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736350', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162010', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821760', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162011', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821760', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162012', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821760', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162013', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821761', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162014', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821761', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162015', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821761', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162016', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162017', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162018', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162019', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162020', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162021', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162022', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162023', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162024', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162025', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379520', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162026', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379520', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162027', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379520', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162028', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162029', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162030', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162031', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379610', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162032', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379630', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162033', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162034', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736360', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162035', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736360', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162036', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736360', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162037', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736360', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162038', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766859', '236979210', '0', '0', '0', '231736361', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162039', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162040', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162041', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162042', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162043', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162044', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162045', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825876', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162046', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162047', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162048', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162049', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162050', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162051', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724402', '59772978', '0', '0', '0', '0', '0', '3072', '1024', '1027', '1026', '1026', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162052', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162053', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162054', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162055', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162056', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162057', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162058', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162059', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162060', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379640', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2162061', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180001', '1', '2', '1', '0', '0', '2', '0', '0', '2', '0', '1', '0', '2', '1', '1', '29', '12', '16', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180002', '1', '2', '6', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '17', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180003', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '16', '9', '15', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180004', '1', '2', '4', '0', '0', '2', '0', '0', '1', '0', '1', '5', '3', '0', '3', '17', '11', '7', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180005', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '3', '1', '2', '1', '1', '29', '10', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180006', '1', '2', '5', '0', '0', '2', '0', '0', '1', '0', '4', '0', '0', '0', '0', '6', '1', '10', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180007', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '3', '1', '2', '3', '3', '17', '15', '4', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180008', '1', '2', '1', '0', '0', '1', '0', '0', '5', '0', '4', '3', '0', '3', '2', '19', '5', '15', '128', '383779881', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180009', '1', '4', '4', '0', '0', '7', '0', '0', '2', '0', '1', '0', '2', '1', '1', '20', '5', '9', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180010', '3', '4', '6', '0', '0', '3', '0', '0', '2', '0', '1', '0', '2', '1', '1', '3', '7', '1', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180011', '1', '3', '2', '0', '0', '2', '0', '0', '1', '1', '0', '0', '1', '2', '2', '18', '14', '15', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180012', '3', '4', '7', '0', '0', '4', '0', '0', '1', '1', '0', '0', '1', '2', '2', '5', '2', '9', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180013', '1', '3', '6', '0', '0', '2', '0', '0', '0', '0', '2', '2', '0', '3', '2', '27', '10', '15', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180014', '3', '4', '7', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '24', '3', '9', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180015', '1', '4', '1', '0', '0', '8', '0', '0', '1', '0', '1', '5', '3', '0', '3', '12', '5', '13', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180016', '3', '4', '6', '0', '0', '3', '0', '0', '1', '0', '1', '5', '3', '0', '3', '9', '14', '9', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180017', '1', '3', '5', '0', '0', '8', '0', '0', '0', '0', '3', '1', '2', '1', '1', '7', '10', '6', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180018', '3', '4', '3', '0', '0', '4', '0', '0', '0', '0', '3', '1', '2', '1', '1', '13', '5', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180019', '1', '3', '1', '0', '0', '1', '0', '0', '2', '0', '3', '1', '2', '3', '3', '26', '13', '7', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180020', '3', '4', '5', '0', '0', '3', '0', '0', '2', '0', '3', '1', '2', '3', '3', '9', '8', '2', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180021', '1', '3', '4', '0', '0', '2', '0', '0', '1', '0', '4', '0', '0', '0', '0', '2', '1', '2', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180022', '3', '2', '1', '0', '0', '7', '0', '0', '1', '0', '4', '0', '0', '0', '0', '18', '15', '7', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180023', '7', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '10', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180024', '1', '3', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '5', '14', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180025', '7', '2', '7', '0', '0', '5', '0', '0', '1', '1', '0', '0', '1', '2', '2', '26', '14', '3', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180026', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '12', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180027', '7', '3', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '11', '11', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180028', '1', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '15', '6', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180029', '7', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '6', '16', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180030', '1', '3', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '5', '9', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180031', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '3', '1', '2', '1', '1', '13', '3', '2', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180032', '7', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '12', '2', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180033', '1', '1', '7', '0', '0', '1', '0', '0', '2', '0', '3', '1', '2', '3', '3', '14', '5', '10', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180034', '1', '3', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '5', '10', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180035', '1', '1', '2', '0', '0', '1', '0', '0', '1', '0', '4', '0', '0', '0', '0', '15', '4', '9', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180036', '1', '3', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '2', '13', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180037', '1', '4', '4', '0', '0', '7', '0', '0', '2', '0', '1', '0', '2', '1', '1', '20', '5', '9', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180038', '1', '4', '1', '0', '0', '8', '0', '0', '1', '0', '1', '5', '3', '0', '3', '12', '5', '13', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180039', '1', '3', '5', '0', '0', '8', '0', '0', '0', '0', '3', '1', '2', '1', '1', '7', '10', '6', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180101', '1', '1', '5', '0', '0', '8', '0', '0', '5', '1', '3', '3', '3', '2', '1', '15', '3', '12', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180102', '1', '2', '6', '0', '0', '7', '0', '0', '3', '1', '4', '5', '2', '1', '3', '23', '8', '4', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180103', '1', '1', '6', '0', '0', '1', '0', '0', '1', '0', '4', '0', '1', '3', '2', '31', '13', '1', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180104', '1', '2', '7', '0', '0', '1', '0', '0', '1', '0', '3', '4', '3', '0', '3', '16', '6', '8', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180105', '1', '1', '3', '0', '0', '1', '0', '0', '4', '1', '4', '2', '0', '2', '0', '27', '1', '13', '128', '210766848', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180106', '1', '2', '2', '0', '0', '8', '0', '0', '1', '0', '5', '0', '2', '1', '1', '20', '4', '6', '128', '210766878', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180107', '5', '1', '1', '0', '0', '4', '0', '0', '0', '0', '2', '4', '2', '0', '1', '52', '60', '57', '128', '79693827', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180108', '6', '2', '1', '0', '0', '3', '0', '0', '1', '0', '2', '0', '0', '2', '1', '60', '59', '63', '127', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180109', '5', '3', '2', '0', '0', '2', '0', '0', '4', '1', '0', '4', '3', '0', '1', '67', '59', '65', '128', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180110', '6', '1', '3', '0', '0', '3', '0', '0', '5', '0', '3', '5', '1', '1', '1', '73', '56', '62', '127', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180111', '5', '2', '2', '0', '0', '4', '0', '0', '3', '1', '1', '5', '1', '3', '2', '59', '62', '51', '128', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180112', '6', '3', '2', '0', '0', '4', '0', '0', '1', '0', '2', '2', '3', '2', '2', '81', '60', '65', '127', '58724353', '59772929', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180113', '5', '1', '4', '0', '0', '6', '0', '0', '1', '0', '4', '3', '3', '3', '0', '80', '55', '60', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180114', '5', '2', '1', '0', '0', '8', '0', '0', '0', '1', '1', '1', '3', '1', '0', '70', '56', '65', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180115', '6', '3', '2', '0', '0', '7', '0', '0', '4', '1', '1', '3', '3', '3', '1', '51', '53', '58', '127', '310379570', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180116', '8', '1', '8', '0', '0', '7', '0', '0', '3', '0', '2', '1', '0', '3', '2', '56', '64', '55', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180117', '8', '2', '4', '0', '0', '5', '0', '0', '4', '0', '0', '0', '2', '1', '0', '61', '62', '53', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180118', '8', '3', '7', '0', '0', '7', '0', '0', '2', '0', '0', '1', '2', '2', '0', '82', '52', '61', '127', '58722334', '59770910', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180119', '8', '1', '5', '0', '0', '5', '0', '0', '4', '1', '1', '2', '0', '1', '3', '58', '63', '59', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180120', '8', '2', '6', '0', '0', '6', '0', '0', '2', '1', '2', '1', '0', '2', '1', '59', '55', '51', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180121', '8', '3', '5', '0', '0', '8', '0', '0', '2', '0', '4', '5', '1', '3', '1', '60', '61', '65', '127', '168821790', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180122', '8', '1', '3', '0', '0', '7', '0', '0', '5', '1', '1', '3', '3', '3', '3', '81', '53', '52', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180123', '8', '2', '3', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '81', '59', '53', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180124', '8', '3', '5', '0', '0', '7', '0', '0', '5', '0', '4', '1', '1', '2', '1', '76', '59', '63', '127', '210767902', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180125', '3', '1', '4', '0', '0', '5', '0', '0', '3', '0', '4', '5', '2', '1', '1', '74', '63', '63', '128', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180126', '4', '2', '8', '0', '0', '5', '0', '0', '4', '0', '5', '3', '0', '1', '3', '59', '65', '61', '127', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180127', '3', '3', '8', '0', '0', '2', '0', '0', '1', '0', '4', '4', '2', '0', '2', '68', '51', '54', '128', '168826883', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180128', '3', '1', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180129', '3', '2', '8', '0', '0', '6', '0', '0', '5', '0', '5', '2', '0', '1', '2', '77', '61', '65', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180130', '4', '3', '6', '0', '0', '5', '0', '0', '5', '0', '5', '2', '1', '0', '2', '63', '58', '52', '127', '210764840', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180131', '3', '1', '1', '0', '0', '2', '0', '0', '5', '1', '5', '3', '0', '1', '0', '82', '60', '58', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180132', '4', '2', '4', '0', '0', '2', '0', '0', '2', '1', '3', '5', '3', '3', '3', '65', '52', '57', '127', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180133', '4', '3', '7', '0', '0', '8', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '127', '347079683', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180134', '2', '1', '5', '0', '0', '3', '0', '0', '4', '1', '4', '4', '1', '3', '1', '16', '2', '9', '127', '80741376', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180135', '9', '2', '3', '0', '0', '4', '0', '0', '4', '0', '4', '0', '2', '0', '0', '67', '54', '60', '128', '80741376', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180136', '9', '3', '5', '0', '0', '1', '0', '0', '1', '0', '0', '5', '3', '3', '3', '60', '62', '59', '128', '80741388', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180137', '9', '1', '2', '0', '0', '4', '0', '0', '5', '1', '5', '1', '2', '0', '3', '60', '55', '60', '128', '147853322', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180138', '9', '2', '4', '0', '0', '3', '0', '0', '0', '1', '4', '4', '2', '2', '1', '76', '59', '65', '128', '147853322', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180139', '2', '3', '5', '0', '0', '3', '0', '0', '1', '0', '3', '4', '1', '1', '2', '17', '9', '1', '127', '147853313', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180140', '2', '1', '8', '0', '0', '1', '0', '0', '3', '0', '1', '0', '1', '0', '1', '32', '16', '5', '127', '310379570', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180141', '9', '2', '5', '0', '0', '2', '0', '0', '3', '0', '0', '5', '3', '2', '2', '56', '59', '60', '128', '310379570', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180142', '9', '3', '5', '0', '0', '3', '0', '0', '1', '0', '0', '3', '3', '1', '0', '57', '60', '65', '128', '310379580', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180143', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180144', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180145', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180146', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180147', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180148', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180149', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180150', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180151', '6', '2', '1', '0', '0', '3', '0', '0', '1', '0', '2', '0', '0', '2', '1', '60', '59', '63', '127', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180152', '6', '2', '1', '0', '0', '3', '0', '0', '1', '0', '2', '0', '0', '2', '1', '60', '59', '63', '127', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180153', '5', '2', '1', '0', '0', '8', '0', '0', '0', '1', '1', '1', '3', '1', '0', '70', '56', '65', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180154', '5', '2', '1', '0', '0', '8', '0', '0', '0', '1', '1', '1', '3', '1', '0', '70', '56', '65', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180155', '5', '2', '2', '0', '0', '4', '0', '0', '3', '1', '1', '5', '1', '3', '2', '59', '62', '51', '128', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180156', '5', '2', '2', '0', '0', '4', '0', '0', '3', '1', '1', '5', '1', '3', '2', '59', '62', '51', '128', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180157', '8', '2', '3', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '81', '59', '53', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180158', '8', '2', '3', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '81', '59', '53', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180159', '8', '2', '6', '0', '0', '6', '0', '0', '2', '1', '2', '1', '0', '2', '1', '59', '55', '51', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180160', '8', '2', '6', '0', '0', '6', '0', '0', '2', '1', '2', '1', '0', '2', '1', '59', '55', '51', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180161', '8', '2', '4', '0', '0', '5', '0', '0', '4', '0', '0', '0', '2', '1', '0', '61', '62', '53', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180162', '8', '2', '4', '0', '0', '5', '0', '0', '4', '0', '0', '0', '2', '1', '0', '61', '62', '53', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180163', '3', '2', '1', '0', '0', '2', '0', '0', '5', '1', '5', '3', '0', '1', '0', '82', '60', '58', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180164', '4', '2', '7', '0', '0', '8', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '127', '347079683', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180165', '4', '2', '7', '0', '0', '8', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '127', '347079683', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180166', '4', '2', '8', '0', '0', '5', '0', '0', '4', '0', '5', '3', '0', '1', '3', '59', '65', '61', '127', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180167', '3', '2', '4', '0', '0', '5', '0', '0', '3', '0', '4', '5', '2', '1', '1', '74', '63', '63', '128', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180168', '3', '2', '4', '0', '0', '5', '0', '0', '3', '0', '4', '5', '2', '1', '1', '74', '63', '63', '128', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180169', '3', '2', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180170', '4', '2', '6', '0', '0', '5', '0', '0', '5', '0', '5', '2', '1', '0', '2', '63', '58', '52', '127', '210764840', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180171', '3', '2', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180201', '7', '1', '2', '0', '0', '7', '0', '0', '0', '1', '2', '0', '2', '3', '0', '69', '58', '59', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180202', '7', '2', '9', '0', '0', '2', '0', '0', '4', '0', '3', '2', '3', '2', '3', '57', '60', '63', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180203', '7', '3', '5', '0', '0', '6', '0', '0', '3', '1', '3', '5', '3', '1', '1', '80', '55', '55', '128', '79697950', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180204', '7', '1', '4', '0', '0', '7', '0', '0', '4', '1', '3', '2', '1', '1', '2', '56', '56', '54', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180205', '7', '2', '5', '0', '0', '7', '0', '0', '4', '0', '2', '2', '3', '1', '2', '61', '56', '55', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180206', '7', '3', '2', '0', '0', '2', '0', '0', '2', '1', '3', '3', '0', '2', '0', '70', '64', '52', '128', '147852289', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180207', '7', '1', '5', '0', '0', '6', '0', '0', '1', '1', '1', '0', '2', '2', '1', '73', '54', '59', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180208', '7', '2', '2', '0', '0', '6', '0', '0', '3', '1', '2', '0', '0', '1', '3', '82', '55', '66', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180209', '7', '3', '5', '0', '0', '2', '0', '0', '4', '0', '2', '4', '1', '2', '1', '54', '56', '51', '128', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180210', '7', '1', '2', '0', '0', '7', '0', '0', '0', '1', '2', '0', '2', '3', '0', '69', '58', '59', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180211', '7', '1', '4', '0', '0', '7', '0', '0', '4', '1', '3', '2', '1', '1', '2', '56', '56', '54', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180212', '7', '1', '5', '0', '0', '6', '0', '0', '1', '1', '1', '0', '2', '2', '1', '73', '54', '59', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180213', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180214', '7', '2', '4', '0', '0', '6', '24', '0', '0', '1', '2', '0', '2', '3', '0', '69', '55', '59', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180215', '7', '2', '5', '0', '0', '4', '23', '0', '1', '1', '3', '0', '0', '2', '1', '11', '10', '13', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180216', '7', '2', '5', '0', '0', '3', '30', '0', '1', '0', '1', '0', '2', '2', '1', '82', '66', '54', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180217', '7', '2', '9', '0', '0', '6', '16', '0', '4', '1', '3', '2', '1', '1', '2', '60', '51', '51', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180218', '7', '2', '1', '0', '0', '1', '29', '0', '0', '1', '2', '0', '2', '3', '0', '10', '7', '5', '128', '79697950', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180219', '7', '2', '7', '0', '0', '4', '31', '0', '4', '1', '3', '2', '1', '1', '2', '28', '16', '13', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180301', '3', '2', '1', '0', '0', '3', '0', '0', '0', '1', '2', '0', '2', '3', '0', '8', '8', '8', '128', '79697950', '32510986', '0', '0', '0', '0', '0', '8193', '12576', '15968', '25697', '8264', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180302', '7', '2', '2', '0', '0', '2', '27', '0', '4', '1', '3', '2', '1', '1', '2', '78', '65', '65', '128', '147853332', '0', '0', '0', '0', '0', '0', '8225', '12576', '15968', '25731', '8264', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2180303', '2', '2', '1', '0', '0', '2', '0', '0', '1', '1', '1', '0', '2', '2', '1', '14', '14', '14', '127', '210765835', '236979210', '0', '0', '0', '231736332', '0', '8193', '12576', '15968', '9289', '8264', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200101', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200102', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200103', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200104', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200105', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200106', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200107', '10002', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200108', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200109', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200110', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200111', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200112', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200113', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200114', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200201', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200202', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200203', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200204', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200205', '10003', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200206', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200207', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200208', '10003', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200301', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200302', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200303', '10004', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200304', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200305', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200306', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200307', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200308', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200309', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200313', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200314', '10004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200401', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200402', '10005', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200403', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200404', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200405', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200406', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200407', '10005', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200501', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200502', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200503', '10006', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200504', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200505', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200506', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200507', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200508', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200509', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200510', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200511', '10006', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200601', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200602', '10007', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200603', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200604', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200605', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200606', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200607', '10007', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200608', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200609', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200610', '10007', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200611', '10007', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200701', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200702', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200703', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200704', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200705', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200706', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200707', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200708', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200709', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200710', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200711', '10008', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200801', '10009', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200802', '10009', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200803', '10009', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200804', '10009', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200901', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200902', '10011', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200903', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200904', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200905', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200906', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200907', '10011', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2200909', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201001', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201002', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201101', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201102', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201103', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201104', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201105', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201106', '10017', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201107', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201108', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201109', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201110', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201111', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201112', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201113', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201114', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201115', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201201', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201202', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201203', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201204', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201205', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201206', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201207', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201208', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201209', '10020', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201301', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201302', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201303', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201304', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201305', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201306', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201307', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201308', '10021', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201309', '10021', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201401', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201402', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201403', '10023', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201404', '10023', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201405', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201406', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201407', '10023', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201408', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201409', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201410', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201411', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201412', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201413', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201414', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201415', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201416', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201417', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201418', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201419', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201420', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201421', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201422', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201423', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201424', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201425', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201426', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201427', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201428', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201429', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201430', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201501', '10025', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201502', '10025', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201503', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201504', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201505', '10025', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201506', '10025', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201507', '10025', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201601', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201602', '10028', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201603', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201604', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201605', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201606', '10028', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201607', '10028', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201608', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201609', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201610', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201611', '10028', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201612', '10028', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201701', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201702', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201703', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201704', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201705', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201706', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201707', '10029', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201708', '10029', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201801', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201802', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201803', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201804', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201805', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692910', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201806', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201807', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201808', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201809', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201810', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823838', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201811', '10030', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201901', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693884', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201902', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692910', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201903', '10031', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79692880', '32514138', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201904', '10031', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697920', '32514138', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2201905', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202001', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202002', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202003', '10032', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202004', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202005', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202006', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202007', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202008', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202009', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202010', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202011', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202012', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202013', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202101', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202102', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202103', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202104', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202105', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202106', '10033', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202107', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202108', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202109', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202110', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202111', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202112', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202113', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202114', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202115', '10033', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202201', '10034', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202202', '10034', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202203', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202204', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202205', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202206', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202207', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202208', '10034', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202209', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202301', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202302', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202303', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202304', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202305', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202306', '10035', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202307', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202308', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202309', '10035', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202310', '10035', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202311', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202312', '10035', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202401', '10036', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202402', '10036', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202501', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202502', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202503', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202504', '10037', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202505', '10037', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202601', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202602', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202603', '10038', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202604', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202605', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202606', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202607', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202608', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202609', '10038', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202610', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202611', '10038', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202701', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202702', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202703', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202704', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202705', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202706', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202707', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202708', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202709', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202710', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202711', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202712', '10039', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202713', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202714', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202715', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202801', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202802', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202803', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202804', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1057', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202805', '10040', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202901', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2202902', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203001', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203002', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203003', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203004', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203005', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203006', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203007', '10058', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203008', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203009', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203010', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203011', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203101', '10045', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203102', '10045', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203103', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203104', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203105', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203106', '10045', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203107', '10045', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203201', '10046', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203202', '10046', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203203', '10046', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203204', '10046', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203301', '10048', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203302', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203303', '10048', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203401', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203402', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203403', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203404', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203405', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203406', '10049', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203407', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203408', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203409', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203410', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203411', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203412', '10049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203501', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203502', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203503', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203504', '10054', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203505', '10054', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203801', '10057', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203802', '10057', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203901', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203902', '10501', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203903', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203904', '10501', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203905', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203906', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203907', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2203908', '10501', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204001', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204002', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204003', '10502', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204004', '10502', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204005', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204006', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204007', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204008', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204009', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204010', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204011', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204012', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204013', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204014', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204015', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204016', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204017', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204018', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204019', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204020', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204021', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204022', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204023', '10502', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204024', '10502', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204025', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204026', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204027', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204101', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204102', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204103', '10503', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204104', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204105', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204106', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204107', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204108', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204109', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204201', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204202', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204203', '10504', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204204', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204205', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204206', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204207', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204208', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204209', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204210', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204211', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204212', '10504', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204213', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204301', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204302', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204303', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204304', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204305', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204306', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204307', '10505', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204308', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204309', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204310', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204311', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204312', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204313', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204314', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204315', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204316', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204317', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204318', '10505', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204401', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204402', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204403', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204404', '10506', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204501', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204502', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204503', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204504', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204505', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204506', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204507', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204508', '10507', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204509', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204510', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204511', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204601', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204602', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204603', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204604', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204605', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204606', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204607', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204608', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204609', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204610', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204701', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204702', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204703', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204704', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204705', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204706', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204707', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204801', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204802', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204803', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204804', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204805', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204806', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204807', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204901', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204902', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204903', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204904', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204905', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204906', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2204907', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205001', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205002', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205003', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205004', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205005', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205006', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205007', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205101', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205102', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205103', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205104', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205105', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205106', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205107', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205201', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205202', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205203', '10508', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205301', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205302', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205303', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205304', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205305', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205306', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205307', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205308', '10509', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205309', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205310', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205311', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205401', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205402', '10510', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205403', '10510', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205404', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205405', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205406', '10510', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205407', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205408', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205409', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205410', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205411', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205501', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205502', '10511', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205503', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205504', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205505', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205506', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205507', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205508', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205509', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205510', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205511', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205512', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205513', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205514', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205515', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205516', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205517', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205518', '10511', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205519', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205520', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205521', '10511', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205601', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205602', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205603', '10512', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205604', '10512', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205605', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205606', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205607', '10512', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205608', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205609', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205610', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205611', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205612', '10512', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205613', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205614', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205701', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205702', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205703', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205704', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205705', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205706', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205707', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205708', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205709', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205710', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205711', '10513', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205712', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205801', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205802', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205803', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205804', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205805', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205901', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205902', '10516', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205903', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205904', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205905', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205906', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205907', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205908', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2205909', '10516', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206001', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206002', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206003', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206004', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206005', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206006', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206007', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206008', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1029', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206009', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206010', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206011', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1031', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206012', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1029', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206013', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1030', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206014', '10518', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206015', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206016', '10518', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206201', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206202', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206203', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206204', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206205', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206206', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206207', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206208', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206209', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206210', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206211', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206212', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206213', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206214', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206215', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206216', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206301', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206302', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206303', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206304', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206305', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206306', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206401', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206402', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206403', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206404', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206405', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206406', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206407', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206408', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206409', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206410', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206411', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206412', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206413', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206414', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206415', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206416', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851287', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206417', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206418', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206419', '10902', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697980', '32510976', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206420', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206421', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206422', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206423', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206424', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697950', '32510981', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206425', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825857', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206426', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825866', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206427', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080706', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206428', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080814', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206429', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694859', '32507964', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206430', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821810', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206431', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347081758', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206432', '10902', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697940', '32510979', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206433', '10902', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851287', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206434', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206435', '10902', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347079685', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206436', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '0', '1027', '0', '2049', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206437', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147851285', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206438', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206439', '10902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '347080754', '0', '0', '0', '0', '0', '0', '2048', '1026', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206501', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206502', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206503', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206504', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206505', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206506', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168821780', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206507', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206508', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206509', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206510', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206511', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206512', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206513', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206514', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206515', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206516', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206517', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206518', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206519', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206520', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206521', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766898', '236979210', '0', '0', '0', '231736331', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206522', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206523', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206524', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206525', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206526', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206527', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206528', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206529', '10903', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818502', '61867078', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206530', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206531', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206532', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818482', '61867058', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206533', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818462', '61867038', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206534', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818472', '61867048', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206535', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826882', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206536', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168826883', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206537', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379550', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206538', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379580', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206539', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58723329', '59771905', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206540', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168823811', '0', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206541', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379620', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206542', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818502', '61867078', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206543', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '60818502', '61867078', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206544', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210766858', '236979210', '0', '0', '0', '231736360', '0', '0', '1024', '1024', '1024', '2049', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206545', '10903', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825867', '0', '0', '0', '0', '0', '0', '1024', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206546', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58722355', '59770931', '0', '0', '0', '0', '0', '2048', '1025', '0', '1025', '1025', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206547', '10903', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '310379600', '0', '0', '0', '0', '0', '0', '2050', '1027', '0', '2049', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206601', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206602', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652958', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206603', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206604', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206605', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206606', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850270', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206607', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206608', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206609', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206610', '10904', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652968', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206611', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206612', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206613', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206614', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693835', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206615', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693845', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206616', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850260', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206617', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850290', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206618', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206619', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652958', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206620', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206621', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147853332', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206622', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294651010', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206623', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294651010', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206624', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79697960', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206625', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147853332', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206626', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351049', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206627', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693827', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206628', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206629', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206701', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206702', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206703', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206704', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206705', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206706', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206707', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206708', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206709', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '3072', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206710', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206711', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '5120', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206712', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351044', '0', '0', '0', '0', '0', '0', '6144', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206713', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206714', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '4096', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206715', '10905', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351042', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2206901', '10909', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207001', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207003', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207004', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207005', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207006', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207007', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79695883', '32510984', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207008', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207009', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207301', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207302', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207303', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207304', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207305', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207306', '10524', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207307', '10524', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207308', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207309', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207310', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207311', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207312', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207313', '10524', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207314', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207315', '10524', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207401', '10854', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207601', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207602', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207603', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207604', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207605', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207606', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207607', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207608', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207609', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207610', '10013', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207611', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207612', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2207613', '10013', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208101', '10022', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208102', '10022', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208701', '10047', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208901', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208902', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208903', '10051', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208904', '10051', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208905', '10051', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208906', '10051', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208907', '10051', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2208908', '10051', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209001', '10052', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209002', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209003', '10052', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209004', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209005', '10052', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209501', '10851', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209502', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209503', '10526', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209504', '10851', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209505', '10851', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209506', '10526', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209507', '10526', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209508', '10526', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209509', '10526', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209510', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209511', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209512', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209513', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209514', '10851', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209515', '10851', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209516', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209517', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209518', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209519', '10527', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209801', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209901', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209902', '10515', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209903', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209904', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209905', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209906', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209907', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2209908', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210001', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210002', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210003', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210004', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210301', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741386', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210302', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210303', '10912', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210401', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2048', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210402', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2080', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210403', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2112', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210404', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2144', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210405', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2176', '0', '6144', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210406', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2208', '0', '7168', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210407', '10701', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2240', '0', '8192', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210408', '10701', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '9216', '2272', '0', '9216', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210501', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210502', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210503', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210504', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210505', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210506', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210507', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210508', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210509', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210510', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210511', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210512', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210513', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210514', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210515', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210516', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210517', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210518', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '921601', '3079', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210701', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210702', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210703', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210801', '10525', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210802', '10525', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210901', '10917', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '169870336', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210902', '10917', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '169870336', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210903', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210904', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210905', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210906', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210907', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210908', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210909', '10917', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '169870336', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210910', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210911', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210912', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2210913', '10091', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280001', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '5', '1', '1', '0', '3', '21', '6', '11', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280002', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '2', '0', '3', '3', '1', '25', '7', '10', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280003', '3', '2', '2', '0', '0', '7', '0', '0', '1', '0', '2', '0', '2', '0', '1', '11', '11', '10', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280004', '1', '2', '1', '0', '0', '2', '0', '0', '5', '1', '0', '2', '0', '2', '0', '13', '8', '13', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280005', '1', '2', '1', '0', '0', '1', '0', '0', '2', '1', '0', '3', '2', '2', '1', '28', '7', '15', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280006', '2', '2', '6', '0', '0', '3', '0', '0', '2', '1', '3', '5', '2', '2', '0', '18', '12', '7', '0', '210765844', '236979210', '0', '0', '0', '231736331', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280007', '1', '2', '5', '0', '0', '1', '0', '0', '0', '1', '2', '1', '0', '1', '1', '10', '1', '3', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280008', '1', '2', '2', '0', '0', '7', '0', '0', '1', '1', '3', '4', '3', '2', '2', '12', '2', '12', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280009', '1', '2', '1', '0', '0', '2', '0', '0', '2', '0', '1', '0', '2', '1', '1', '29', '12', '16', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280010', '1', '2', '6', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '17', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280011', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '16', '9', '15', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280012', '1', '2', '4', '0', '0', '2', '0', '0', '1', '0', '1', '5', '3', '0', '3', '17', '11', '7', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280013', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '3', '1', '2', '1', '1', '29', '10', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280014', '1', '2', '5', '0', '0', '2', '0', '0', '1', '0', '4', '0', '0', '0', '0', '6', '1', '10', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280015', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '3', '1', '2', '3', '3', '17', '15', '4', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280016', '1', '2', '1', '0', '0', '1', '0', '0', '5', '0', '4', '3', '0', '3', '2', '19', '5', '15', '128', '383779881', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280017', '1', '2', '4', '0', '0', '2', '0', '0', '1', '0', '1', '5', '3', '0', '3', '17', '11', '7', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280018', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '3', '1', '2', '1', '1', '32', '4', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280019', '1', '2', '6', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '17', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280020', '1', '2', '6', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '17', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280021', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '3', '1', '2', '3', '3', '17', '15', '4', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280022', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '5', '1', '1', '0', '3', '21', '6', '11', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280023', '1', '2', '1', '0', '0', '2', '0', '0', '2', '0', '1', '0', '2', '1', '1', '29', '12', '16', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280024', '1', '2', '6', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '17', '9', '1', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280025', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '16', '9', '15', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280026', '1', '2', '4', '0', '0', '2', '0', '0', '1', '0', '1', '5', '3', '0', '3', '17', '11', '7', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280027', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '3', '1', '2', '1', '1', '29', '10', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280028', '1', '2', '5', '0', '0', '2', '0', '0', '1', '0', '4', '0', '0', '0', '0', '6', '1', '10', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280029', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '3', '1', '2', '3', '3', '17', '15', '4', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280030', '7', '3', '2', '0', '0', '8', '31', '0', '4', '0', '2', '2', '1', '2', '3', '25', '16', '3', '128', '79695883', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280031', '3', '3', '5', '0', '0', '8', '31', '0', '4', '0', '2', '2', '1', '2', '3', '31', '4', '8', '128', '168826884', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280032', '4', '3', '2', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '58', '65', '53', '127', '210767922', '236979200', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280033', '5', '4', '1', '0', '0', '8', '28', '0', '4', '0', '2', '2', '1', '2', '3', '62', '52', '53', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280034', '1', '2', '3', '0', '0', '7', '0', '0', '2', '0', '0', '4', '2', '1', '3', '18', '5', '16', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280035', '5', '2', '2', '0', '0', '6', '0', '0', '1', '1', '0', '2', '0', '2', '3', '60', '55', '59', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280036', '7', '2', '4', '0', '0', '1', '0', '0', '3', '0', '2', '4', '2', '2', '3', '24', '2', '1', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280037', '1', '2', '7', '0', '0', '7', '0', '0', '1', '1', '3', '0', '2', '3', '1', '9', '11', '14', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280038', '4', '2', '3', '0', '0', '8', '0', '0', '2', '0', '1', '5', '3', '3', '0', '1', '7', '10', '127', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280039', '1', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '5', '3', '2', '3', '22', '4', '16', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280040', '3', '2', '1', '0', '0', '8', '0', '0', '1', '1', '0', '4', '3', '0', '3', '28', '13', '15', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280041', '1', '2', '3', '0', '0', '1', '0', '0', '3', '0', '3', '0', '1', '0', '3', '14', '4', '16', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280042', '8', '2', '2', '0', '0', '3', '0', '0', '4', '1', '3', '2', '3', '1', '0', '1', '12', '11', '127', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280043', '1', '2', '6', '0', '0', '8', '0', '0', '4', '1', '4', '1', '2', '0', '2', '26', '13', '8', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280044', '9', '2', '3', '0', '0', '2', '0', '0', '5', '1', '3', '2', '0', '2', '3', '21', '13', '8', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280045', '1', '2', '4', '0', '0', '2', '0', '0', '4', '1', '3', '2', '1', '1', '1', '29', '14', '15', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280046', '1', '2', '6', '0', '0', '7', '26', '0', '2', '0', '0', '4', '2', '1', '3', '23', '4', '16', '128', '79695883', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280047', '1', '2', '2', '0', '0', '8', '30', '0', '1', '1', '3', '0', '2', '3', '1', '6', '11', '14', '128', '168826884', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280048', '1', '2', '8', '0', '0', '7', '31', '0', '0', '0', '0', '5', '3', '2', '3', '22', '4', '16', '128', '210767922', '236979200', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280049', '5', '3', '2', '0', '0', '6', '29', '0', '1', '1', '0', '2', '0', '2', '3', '62', '53', '51', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280050', '1', '2', '6', '0', '0', '7', '26', '0', '2', '0', '0', '4', '2', '1', '3', '23', '4', '16', '128', '79695883', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280051', '7', '2', '1', '0', '0', '1', '0', '0', '3', '0', '2', '4', '2', '2', '3', '5', '13', '3', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280052', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '0', '4', '2', '1', '3', '24', '3', '7', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280053', '8', '2', '3', '0', '0', '2', '0', '0', '4', '1', '3', '2', '3', '1', '0', '14', '2', '2', '127', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280054', '1', '2', '2', '0', '0', '7', '0', '0', '1', '1', '3', '0', '2', '3', '1', '29', '10', '1', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280055', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '5', '3', '2', '3', '24', '5', '3', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280056', '5', '2', '4', '0', '0', '2', '0', '0', '1', '1', '0', '2', '0', '2', '3', '54', '59', '51', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280057', '4', '2', '4', '0', '0', '6', '0', '0', '2', '0', '1', '5', '3', '3', '0', '12', '5', '3', '127', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280058', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '15', '15', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280059', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '14', '5', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280060', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '14', '4', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280061', '2', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '13', '127', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280062', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '9', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280063', '8', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '16', '2', '127', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280064', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '14', '8', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280065', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '9', '4', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280066', '4', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '8', '3', '127', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280067', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '6', '8', '128', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280068', '4', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '14', '7', '127', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280069', '3', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '6', '9', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280070', '3', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '8', '11', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280101', '1', '2', '5', '0', '0', '8', '0', '0', '5', '1', '3', '3', '3', '2', '1', '15', '3', '12', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280102', '1', '3', '6', '0', '0', '7', '0', '0', '3', '1', '4', '5', '2', '1', '3', '23', '8', '4', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280103', '1', '2', '6', '0', '0', '1', '0', '0', '1', '0', '4', '0', '1', '3', '2', '31', '13', '1', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280104', '1', '3', '7', '0', '0', '1', '0', '0', '1', '0', '3', '4', '3', '0', '3', '16', '6', '8', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280105', '1', '2', '3', '0', '0', '1', '0', '0', '4', '1', '4', '2', '0', '2', '0', '27', '1', '13', '128', '210766848', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280106', '1', '3', '2', '0', '0', '8', '0', '0', '1', '0', '5', '0', '2', '1', '1', '20', '4', '6', '128', '210766878', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280107', '8', '2', '8', '0', '0', '7', '18', '0', '0', '0', '0', '0', '0', '0', '0', '60', '64', '60', '127', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280108', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '1', '4', '127', '210766848', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280109', '3', '3', '8', '0', '0', '6', '0', '0', '1', '0', '3', '4', '3', '0', '3', '65', '63', '59', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280110', '1', '3', '6', '0', '0', '7', '0', '0', '3', '1', '4', '5', '2', '1', '3', '23', '8', '4', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280111', '3', '2', '6', '0', '0', '4', '31', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '10', '128', '347079691', '0', '0', '0', '0', '0', '0', '28800', '28800', '28800', '1024', '28800', '389120', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280112', '5', '2', '1', '0', '0', '4', '0', '0', '0', '0', '2', '4', '2', '0', '1', '52', '60', '57', '128', '79693827', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280113', '6', '3', '1', '0', '0', '3', '0', '0', '1', '0', '2', '0', '0', '2', '1', '60', '59', '63', '127', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280114', '5', '2', '1', '0', '0', '4', '0', '0', '0', '0', '2', '4', '2', '0', '1', '52', '60', '57', '128', '79693827', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280115', '6', '2', '4', '0', '0', '3', '0', '0', '5', '0', '3', '5', '1', '1', '1', '73', '56', '62', '127', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280116', '5', '3', '2', '0', '0', '4', '0', '0', '3', '1', '1', '5', '1', '3', '2', '59', '62', '51', '128', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280117', '6', '2', '4', '0', '0', '3', '0', '0', '5', '0', '3', '5', '1', '1', '1', '73', '56', '62', '127', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280118', '5', '2', '4', '0', '0', '6', '0', '0', '1', '0', '4', '3', '3', '3', '0', '80', '55', '60', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280119', '5', '3', '1', '0', '0', '8', '0', '0', '0', '1', '1', '1', '3', '1', '0', '70', '56', '65', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280120', '5', '2', '4', '0', '0', '6', '0', '0', '1', '0', '4', '3', '3', '3', '0', '80', '55', '60', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280121', '8', '3', '8', '0', '0', '3', '0', '0', '1', '0', '2', '0', '0', '2', '1', '17', '7', '11', '127', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280122', '8', '2', '8', '0', '0', '7', '0', '0', '3', '0', '2', '1', '0', '3', '2', '56', '64', '55', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280123', '8', '3', '4', '0', '0', '5', '0', '0', '4', '0', '0', '0', '2', '1', '0', '61', '62', '53', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280124', '8', '2', '8', '0', '0', '7', '0', '0', '3', '0', '2', '1', '0', '3', '2', '56', '64', '55', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280125', '8', '2', '5', '0', '0', '5', '0', '0', '4', '1', '1', '2', '0', '1', '3', '58', '63', '59', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280126', '8', '3', '6', '0', '0', '6', '0', '0', '2', '1', '2', '1', '0', '2', '1', '59', '55', '51', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280127', '8', '2', '5', '0', '0', '5', '0', '0', '4', '1', '1', '2', '0', '1', '3', '58', '63', '59', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280128', '8', '2', '3', '0', '0', '7', '0', '0', '5', '1', '1', '3', '3', '3', '3', '81', '53', '52', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280129', '8', '3', '3', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '81', '59', '53', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280130', '8', '2', '3', '0', '0', '7', '0', '0', '5', '1', '1', '3', '3', '3', '3', '81', '53', '52', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280131', '5', '2', '2', '0', '0', '8', '0', '0', '3', '0', '2', '1', '0', '3', '2', '56', '64', '55', '128', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280132', '7', '3', '2', '0', '0', '5', '0', '0', '2', '1', '2', '1', '0', '2', '1', '59', '55', '51', '128', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280133', '2', '3', '1', '0', '0', '5', '0', '0', '4', '0', '2', '2', '1', '2', '3', '1', '7', '5', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280134', '2', '3', '1', '0', '0', '2', '0', '0', '4', '0', '2', '2', '1', '2', '3', '1', '7', '5', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280135', '4', '2', '8', '0', '0', '5', '0', '0', '4', '0', '5', '3', '0', '1', '3', '59', '65', '61', '127', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280136', '3', '3', '8', '0', '0', '2', '0', '0', '1', '0', '4', '4', '2', '0', '2', '68', '51', '54', '128', '168826883', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280137', '3', '2', '4', '0', '0', '5', '0', '0', '3', '0', '4', '5', '2', '1', '1', '74', '63', '63', '128', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280138', '3', '2', '4', '0', '0', '5', '0', '0', '3', '0', '4', '5', '2', '1', '1', '74', '63', '63', '128', '168826880', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280139', '3', '2', '8', '0', '0', '6', '0', '0', '5', '0', '5', '2', '0', '1', '2', '77', '61', '65', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280140', '4', '3', '6', '0', '0', '5', '0', '0', '5', '0', '5', '2', '1', '0', '2', '63', '58', '52', '127', '210764840', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280141', '3', '2', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280142', '3', '2', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280143', '4', '2', '4', '0', '0', '2', '0', '0', '2', '1', '3', '5', '3', '3', '3', '65', '52', '57', '127', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280144', '4', '3', '7', '0', '0', '8', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '127', '347079683', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280145', '3', '2', '1', '0', '0', '2', '0', '0', '5', '1', '5', '3', '0', '1', '0', '82', '60', '58', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280146', '3', '2', '1', '0', '0', '2', '0', '0', '5', '1', '5', '3', '0', '1', '0', '82', '60', '58', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280147', '6', '3', '2', '0', '0', '5', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '127', '347079683', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280148', '2', '2', '5', '0', '0', '3', '0', '0', '4', '1', '4', '4', '1', '3', '1', '16', '2', '9', '127', '80741376', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280149', '9', '3', '3', '0', '0', '4', '0', '0', '4', '0', '4', '0', '2', '0', '0', '67', '54', '60', '128', '80741376', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280150', '9', '3', '3', '0', '0', '4', '0', '0', '4', '0', '4', '0', '2', '0', '0', '67', '54', '60', '128', '80741376', '32508968', '0', '0', '0', '0', '0', '15840', '15840', '15808', '8352', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280151', '9', '2', '2', '0', '0', '4', '0', '0', '5', '1', '5', '1', '2', '0', '3', '60', '55', '60', '128', '147853322', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280152', '9', '3', '4', '0', '0', '3', '0', '0', '0', '1', '4', '4', '2', '2', '1', '76', '59', '65', '128', '147853322', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280153', '9', '3', '4', '0', '0', '3', '0', '0', '0', '1', '4', '4', '2', '2', '1', '76', '59', '65', '128', '147853322', '0', '0', '0', '0', '0', '0', '12704', '15840', '15808', '14530', '15840', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280154', '2', '2', '8', '0', '0', '1', '0', '0', '3', '0', '1', '0', '1', '0', '1', '32', '16', '5', '127', '310379570', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280155', '9', '3', '5', '0', '0', '2', '0', '0', '3', '0', '0', '5', '3', '2', '2', '56', '59', '60', '128', '310379570', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280156', '9', '3', '5', '0', '0', '2', '0', '0', '3', '0', '0', '5', '3', '2', '2', '56', '59', '60', '128', '310379570', '0', '0', '0', '0', '0', '0', '7392', '7552', '1024', '13440', '13601', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280157', '1', '1', '5', '0', '0', '8', '0', '0', '5', '1', '3', '3', '3', '2', '1', '15', '3', '12', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280158', '1', '2', '8', '0', '0', '8', '0', '0', '3', '0', '2', '3', '1', '3', '3', '17', '1', '6', '128', '58723329', '59771905', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280159', '1', '2', '5', '0', '0', '7', '0', '0', '3', '1', '3', '4', '2', '2', '1', '32', '2', '6', '128', '58723329', '59771905', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280160', '1', '2', '2', '0', '0', '2', '0', '0', '0', '1', '0', '3', '2', '0', '1', '25', '7', '5', '128', '58723329', '59771905', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280161', '1', '2', '3', '0', '0', '2', '0', '0', '0', '0', '1', '2', '3', '3', '0', '1', '8', '15', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280162', '1', '2', '4', '0', '0', '1', '0', '0', '5', '0', '3', '3', '2', '0', '1', '1', '6', '14', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280163', '1', '2', '5', '0', '0', '7', '0', '0', '2', '0', '4', '4', '1', '2', '1', '25', '12', '8', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280164', '3', '1', '1', '0', '0', '2', '0', '0', '2', '0', '4', '1', '1', '1', '1', '58', '52', '61', '128', '210764820', '236979210', '0', '0', '0', '231736331', '0', '9760', '11428', '7264', '9568', '21643', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280165', '3', '1', '1', '0', '0', '2', '0', '0', '5', '1', '5', '3', '0', '1', '0', '82', '60', '58', '128', '347079684', '0', '0', '0', '0', '0', '0', '10496', '35012', '4416', '13601', '5441', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280166', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280167', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280168', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280169', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280170', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280171', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280172', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280173', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280174', '1', '2', '5', '0', '0', '8', '0', '0', '5', '1', '3', '3', '3', '2', '1', '32', '2', '12', '128', '79692880', '32507904', '0', '0', '0', '0', '0', '25639', '9377', '9472', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280175', '1', '3', '3', '0', '0', '1', '0', '0', '4', '1', '4', '2', '0', '2', '0', '27', '1', '13', '128', '210766848', '236979210', '0', '0', '0', '231736331', '0', '25740', '9376', '9504', '11360', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280176', '1', '1', '4', '0', '0', '2', '9', '0', '2', '1', '3', '5', '3', '3', '3', '32', '3', '10', '128', '347080706', '0', '0', '0', '0', '0', '0', '0', '29762', '4416', '13601', '25665', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280177', '1', '2', '6', '0', '0', '7', '0', '0', '3', '1', '4', '5', '2', '1', '3', '23', '8', '4', '128', '79692880', '32513024', '0', '0', '0', '0', '0', '25638', '9379', '9344', '11361', '25633', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280178', '1', '2', '7', '0', '0', '1', '0', '0', '1', '0', '3', '4', '3', '0', '3', '16', '6', '8', '128', '168826880', '0', '0', '0', '0', '0', '0', '25768', '9376', '9248', '11332', '25760', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280179', '1', '2', '2', '0', '0', '8', '0', '0', '1', '0', '5', '0', '2', '1', '1', '20', '4', '6', '128', '210766878', '236979210', '0', '0', '0', '231736331', '0', '25738', '9632', '9504', '11360', '25792', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280180', '8', '1', '8', '0', '0', '7', '0', '0', '3', '0', '2', '1', '0', '3', '2', '56', '64', '55', '127', '58722324', '59770900', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280181', '8', '1', '5', '0', '0', '5', '0', '0', '4', '1', '1', '2', '0', '1', '3', '58', '63', '59', '127', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280182', '8', '1', '3', '0', '0', '7', '0', '0', '5', '1', '1', '3', '3', '3', '3', '81', '53', '52', '127', '210767892', '236979210', '0', '0', '0', '231736331', '0', '19490', '33955', '7298', '9472', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280183', '5', '1', '1', '0', '0', '4', '0', '0', '0', '0', '2', '4', '2', '0', '1', '52', '60', '57', '128', '79693827', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280184', '6', '1', '3', '0', '0', '3', '0', '0', '5', '0', '3', '5', '1', '1', '1', '73', '56', '62', '127', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '139264', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280185', '5', '1', '4', '0', '0', '6', '0', '0', '1', '0', '4', '3', '3', '3', '0', '80', '55', '60', '128', '310379550', '0', '0', '0', '0', '0', '0', '0', '30019', '5312', '5281', '5441', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280186', '8', '2', '1', '0', '0', '5', '0', '0', '1', '1', '5', '2', '0', '0', '1', '59', '63', '63', '127', '58722354', '59770930', '0', '0', '0', '0', '0', '19490', '10336', '10528', '10528', '10528', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280187', '9', '2', '1', '0', '0', '1', '0', '0', '1', '1', '1', '0', '2', '2', '1', '67', '60', '51', '128', '168821780', '0', '0', '0', '0', '0', '0', '19490', '8512', '3392', '14595', '9380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280188', '8', '2', '3', '0', '0', '6', '0', '0', '4', '0', '4', '4', '3', '0', '1', '65', '56', '56', '127', '210767902', '236979210', '0', '0', '0', '231736332', '0', '19490', '33955', '7298', '9472', '9504', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280189', '5', '2', '1', '0', '0', '8', '0', '0', '0', '0', '5', '3', '1', '2', '0', '53', '59', '63', '128', '79693845', '0', '0', '0', '0', '0', '0', '0', '30020', '1024', '5281', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280190', '5', '2', '2', '0', '0', '8', '0', '0', '4', '0', '3', '3', '2', '0', '2', '54', '55', '58', '128', '58724372', '59772948', '0', '0', '0', '0', '0', '0', '30017', '1024', '10592', '21643', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280191', '6', '2', '901', '0', '0', '7', '0', '0', '5', '0', '5', '0', '2', '3', '3', '68', '64', '62', '127', '310379570', '0', '0', '0', '0', '0', '0', '0', '30017', '5312', '5281', '5441', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280192', '1', '3', '1', '0', '0', '1', '0', '0', '0', '1', '4', '4', '2', '2', '1', '1', '3', '1', '128', '147853322', '0', '0', '0', '0', '0', '0', '0', '29985', '28742', '1024', '35873', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280193', '2', '2', '1', '0', '0', '1', '0', '0', '3', '0', '1', '0', '1', '0', '1', '1', '2', '1', '127', '310379570', '0', '0', '0', '0', '0', '0', '0', '30019', '7394', '1024', '5378', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280194', '7', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '3', '3', '128', '168823848', '0', '0', '0', '0', '0', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280195', '7', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '4', '3', '128', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280196', '1', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '1', '10', '128', '58724382', '59772958', '0', '0', '0', '0', '0', '0', '29985', '28742', '1024', '35873', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280197', '4', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '7', '127', '168821800', '0', '0', '0', '0', '0', '0', '0', '29985', '28739', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280198', '5', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '15', '13', '128', '210767892', '236979210', '0', '0', '0', '231737405', '0', '0', '29985', '28742', '1024', '35873', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280201', '7', '2', '9', '0', '0', '2', '0', '0', '4', '0', '3', '2', '3', '2', '3', '57', '60', '63', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280202', '7', '3', '5', '0', '0', '6', '0', '0', '3', '1', '3', '5', '3', '1', '1', '80', '55', '55', '128', '79697950', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280203', '7', '2', '2', '0', '0', '7', '0', '0', '0', '1', '2', '0', '2', '3', '0', '69', '58', '59', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280204', '7', '3', '2', '0', '0', '7', '0', '0', '0', '1', '2', '0', '2', '3', '0', '69', '58', '59', '128', '79697920', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280205', '7', '2', '5', '0', '0', '7', '0', '0', '4', '0', '2', '2', '3', '1', '2', '61', '56', '55', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280206', '7', '3', '2', '0', '0', '2', '0', '0', '2', '1', '3', '3', '0', '2', '0', '70', '64', '52', '128', '147852289', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280207', '7', '2', '4', '0', '0', '7', '0', '0', '4', '1', '3', '2', '1', '1', '2', '56', '56', '54', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280208', '7', '3', '4', '0', '0', '7', '0', '0', '4', '1', '3', '2', '1', '1', '2', '56', '56', '54', '128', '147852298', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280209', '7', '2', '2', '0', '0', '6', '0', '0', '3', '1', '2', '0', '0', '1', '3', '82', '55', '66', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280210', '7', '3', '5', '0', '0', '2', '0', '0', '4', '0', '2', '4', '1', '2', '1', '54', '56', '51', '128', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280211', '7', '2', '5', '0', '0', '6', '0', '0', '1', '1', '1', '0', '2', '2', '1', '73', '54', '59', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280212', '7', '3', '5', '0', '0', '6', '0', '0', '1', '1', '1', '0', '2', '2', '1', '73', '54', '59', '128', '210765835', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280213', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '4', '1', '3', '3', '22', '7', '9', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280214', '1', '2', '5', '0', '0', '7', '0', '0', '3', '0', '5', '5', '0', '2', '1', '18', '12', '4', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280215', '1', '2', '7', '0', '0', '2', '0', '0', '0', '1', '1', '1', '3', '3', '3', '22', '9', '16', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280216', '1', '2', '4', '0', '0', '2', '0', '0', '2', '0', '0', '1', '1', '1', '1', '11', '11', '8', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280217', '1', '2', '2', '0', '0', '2', '0', '0', '4', '1', '2', '5', '0', '2', '1', '18', '6', '3', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280218', '1', '2', '7', '0', '0', '2', '0', '0', '3', '1', '2', '3', '3', '0', '0', '9', '15', '6', '128', '147850260', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280219', '8', '2', '5', '0', '0', '3', '0', '0', '2', '1', '5', '1', '0', '0', '0', '1', '15', '3', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280220', '9', '2', '4', '0', '0', '1', '0', '0', '2', '1', '2', '5', '3', '3', '0', '69', '59', '64', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280221', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '128', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280222', '1', '2', '7', '0', '0', '2', '0', '0', '3', '1', '2', '3', '3', '0', '0', '9', '15', '6', '128', '147850241', '0', '0', '0', '0', '0', '0', '15648', '15648', '15840', '5314', '15648', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280223', '7', '2', '5', '0', '0', '6', '0', '0', '3', '1', '3', '5', '3', '1', '1', '80', '55', '55', '128', '79697950', '32507964', '0', '0', '0', '0', '0', '23712', '10336', '10369', '25730', '4416', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280224', '7', '2', '5', '0', '0', '2', '0', '0', '4', '0', '2', '4', '1', '2', '1', '54', '56', '51', '128', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9440', '9410', '4166', '9378', '9440', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280225', '7', '2', '2', '0', '0', '2', '0', '0', '2', '1', '3', '3', '0', '2', '0', '70', '64', '52', '128', '147852289', '0', '0', '0', '0', '0', '0', '13698', '8323', '8864', '8288', '8265', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280301', '8', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '8', '15', '127', '347079684', '0', '0', '0', '0', '0', '0', '0', '29985', '28742', '1024', '35873', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2280302', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '3', '1', '128', '310379570', '0', '0', '0', '0', '0', '0', '0', '29985', '28739', '1024', '35844', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289001', '1', '2', '7', '0', '0', '7', '0', '0', '3', '1', '2', '3', '3', '2', '0', '27', '2', '11', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289002', '1', '2', '8', '0', '0', '7', '0', '0', '1', '1', '3', '1', '2', '3', '3', '19', '13', '15', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29858', '5185', '10403', '4196', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289003', '1', '2', '7', '0', '0', '1', '0', '0', '5', '0', '2', '3', '3', '1', '1', '31', '7', '9', '0', '310379550', '0', '0', '0', '0', '0', '0', '7234', '35012', '4167', '5218', '10370', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289004', '7', '4', '9', '0', '0', '5', '31', '0', '3', '1', '4', '2', '2', '3', '1', '9', '6', '3', '0', '147850300', '0', '0', '0', '0', '0', '0', '0', '8576', '8896', '8576', '8545', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289005', '7', '4', '9', '0', '0', '5', '31', '0', '3', '1', '4', '2', '2', '3', '1', '9', '6', '3', '0', '147850300', '0', '0', '0', '0', '0', '0', '0', '8576', '8896', '8576', '8545', '136192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289006', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '79698946', '32508928', '0', '0', '0', '0', '0', '0', '3105', '3265', '11460', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289007', '1', '2', '3', '0', '0', '8', '0', '0', '2', '0', '3', '4', '0', '2', '0', '26', '15', '5', '0', '79692820', '0', '0', '0', '0', '0', '0', '0', '7744', '2112', '1024', '6144', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289008', '1', '2', '7', '0', '0', '1', '0', '0', '1', '1', '3', '2', '0', '2', '0', '5', '6', '1', '0', '79692820', '0', '0', '0', '0', '0', '0', '10243', '34848', '2272', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289009', '8', '3', '2', '0', '0', '3', '0', '0', '0', '0', '2', '2', '0', '1', '0', '12', '6', '11', '0', '168821780', '0', '0', '0', '0', '0', '0', '19498', '14624', '1600', '14402', '21635', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289010', '1', '2', '8', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '32', '6', '2', '0', '147850241', '0', '0', '0', '0', '0', '0', '0', '29792', '4098', '1024', '1089', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289011', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '79698946', '32508928', '0', '0', '0', '0', '0', '0', '3105', '3265', '11460', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289012', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '147851266', '0', '0', '0', '0', '0', '0', '0', '3105', '3265', '11460', '15553', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289013', '1', '2', '2', '0', '0', '7', '0', '0', '2', '0', '2', '2', '1', '1', '0', '18', '2', '14', '0', '79698946', '32507934', '0', '0', '0', '0', '0', '14337', '8288', '3143', '11427', '15426', '135168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289014', '6', '2', '1', '0', '0', '3', '0', '0', '1', '1', '3', '4', '2', '1', '0', '73', '62', '56', '0', '294651964', '0', '0', '0', '0', '0', '0', '0', '29771', '5217', '10528', '4198', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289015', '6', '2', '1', '0', '0', '6', '0', '0', '3', '1', '2', '5', '3', '2', '1', '14', '6', '7', '0', '310379560', '0', '0', '0', '0', '0', '0', '20485', '7234', '1024', '1024', '25666', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289016', '1', '3', '1', '0', '0', '8', '0', '0', '4', '0', '4', '2', '3', '0', '0', '23', '4', '5', '0', '210764850', '236979210', '0', '0', '0', '231736331', '0', '9440', '9472', '9472', '9312', '9345', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289017', '1', '3', '1', '0', '0', '8', '0', '0', '4', '0', '4', '2', '3', '0', '0', '23', '4', '5', '0', '210764850', '236979210', '0', '0', '0', '231736331', '0', '9440', '9472', '9472', '9312', '9345', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289018', '1', '3', '1', '0', '0', '8', '0', '0', '4', '0', '4', '2', '3', '0', '0', '23', '4', '5', '0', '210764850', '236979210', '0', '0', '0', '231736331', '0', '9440', '9472', '9472', '9312', '9345', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289019', '1', '2', '8', '0', '0', '7', '0', '0', '2', '1', '0', '3', '2', '1', '1', '8', '13', '8', '0', '168826881', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289020', '1', '2', '5', '0', '0', '1', '0', '0', '5', '0', '2', '2', '1', '0', '1', '17', '4', '4', '0', '79692820', '0', '0', '0', '0', '0', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289021', '8', '2', '7', '0', '0', '3', '0', '0', '3', '0', '2', '4', '2', '3', '2', '32', '9', '14', '0', '347079680', '0', '0', '0', '0', '231736331', '0', '9569', '14530', '3150', '14530', '9536', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289022', '1', '2', '6', '0', '0', '1', '12', '0', '3', '1', '4', '5', '1', '0', '2', '32', '4', '4', '0', '147850240', '0', '0', '0', '0', '0', '0', '23599', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289023', '1', '2', '3', '0', '0', '8', '30', '0', '3', '1', '4', '5', '1', '0', '2', '28', '3', '10', '0', '58722304', '59770880', '0', '0', '0', '0', '0', '23887', '16416', '3072', '1024', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289024', '1', '2', '5', '0', '0', '2', '29', '0', '3', '1', '4', '5', '1', '0', '2', '11', '2', '16', '0', '210764800', '236979210', '0', '0', '0', '0', '0', '23712', '16416', '3072', '1024', '1089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289025', '3', '2', '2', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '14', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '0', '2112', '7424', '13696', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289026', '1', '2', '1', '0', '0', '2', '0', '0', '3', '1', '4', '5', '1', '0', '2', '32', '11', '16', '0', '79692880', '0', '0', '0', '0', '0', '0', '25601', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289027', '1', '2', '4', '0', '0', '8', '0', '0', '3', '1', '4', '5', '1', '0', '2', '15', '16', '16', '0', '347079680', '0', '0', '0', '0', '0', '0', '25600', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289028', '1', '2', '7', '0', '0', '2', '0', '0', '3', '1', '4', '5', '1', '0', '2', '28', '4', '4', '0', '168823808', '0', '0', '0', '0', '0', '0', '25603', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289029', '1', '2', '2', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '19', '14', '10', '0', '294650880', '0', '0', '0', '0', '0', '0', '25632', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289030', '1', '2', '6', '0', '0', '8', '27', '0', '2', '0', '2', '2', '0', '0', '0', '10', '14', '3', '93', '79695902', '0', '0', '0', '0', '0', '0', '23884', '10465', '16609', '11616', '13634', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289031', '7', '2', '6', '0', '0', '4', '31', '0', '3', '1', '4', '5', '1', '0', '2', '12', '3', '3', '0', '147850280', '0', '0', '0', '0', '0', '0', '22625', '10370', '4166', '11363', '13504', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289032', '1', '2', '3', '0', '0', '2', '31', '0', '2', '1', '0', '3', '2', '1', '1', '16', '4', '2', '0', '168826890', '0', '0', '0', '0', '0', '0', '23652', '10370', '4166', '13443', '13506', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289033', '1', '2', '1', '0', '0', '8', '31', '0', '3', '1', '4', '5', '1', '0', '2', '7', '1', '4', '0', '58722304', '59770880', '0', '0', '0', '0', '0', '23596', '10370', '10369', '10400', '8356', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289034', '8', '2', '1', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '12', '1', '4', '0', '210764840', '236979210', '0', '0', '0', '231736350', '0', '9409', '10370', '9664', '9346', '9409', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289035', '1', '2', '7', '0', '0', '8', '9', '0', '4', '1', '5', '2', '2', '0', '0', '26', '5', '10', '95', '80741396', '32510978', '0', '0', '0', '0', '0', '0', '43008', '43008', '43008', '46089', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289036', '1', '2', '1', '0', '0', '1', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '80741396', '32510979', '0', '0', '0', '0', '0', '8290', '11587', '3144', '11492', '10465', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289037', '7', '2', '5', '0', '0', '8', '2', '0', '3', '0', '1', '3', '2', '3', '0', '55', '57', '58', '96', '147856384', '0', '0', '0', '0', '0', '0', '37888', '37888', '37888', '37888', '37888', '919552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289038', '3', '2', '5', '0', '0', '1', '5', '0', '2', '1', '1', '4', '0', '1', '0', '56', '65', '58', '92', '173016065', '0', '0', '0', '0', '0', '0', '36865', '36865', '36865', '36865', '36865', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289039', '9', '2', '3', '11', '0', '4', '1', '0', '3', '0', '2', '1', '2', '3', '0', '62', '64', '62', '94', '65012736', '66061312', '0', '0', '0', '0', '0', '45057', '45057', '45057', '45057', '45057', '919552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289040', '1', '2', '1', '0', '0', '1', '0', '0', '2', '1', '0', '3', '2', '1', '1', '8', '5', '1', '0', '168823809', '0', '0', '0', '0', '0', '0', '8289', '8417', '8640', '11490', '8448', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289041', '1', '3', '1', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '1', '4', '1', '0', '147850241', '0', '0', '0', '0', '0', '0', '12800', '8419', '8640', '9505', '8481', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289042', '1', '2', '5', '0', '0', '1', '0', '0', '3', '1', '4', '5', '1', '0', '2', '1', '7', '16', '0', '210764800', '236979210', '0', '0', '0', '231736331', '0', '12544', '8386', '8640', '9408', '13538', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289043', '1', '2', '2', '0', '0', '8', '20', '0', '3', '1', '4', '5', '1', '0', '2', '20', '14', '10', '0', '294650880', '0', '0', '0', '0', '0', '0', '7300', '34848', '28676', '7168', '25696', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2289044', '8', '2', '4', '0', '0', '2', '31', '0', '0', '1', '0', '0', '0', '0', '0', '18', '3', '5', '0', '79696966', '32513064', '0', '0', '0', '0', '0', '13505', '8257', '15488', '11459', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290001', '8', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '113', '331351046', '0', '0', '0', '0', '0', '0', '0', '4387', '5347', '1024', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290002', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '109', '147850241', '0', '0', '0', '0', '0', '0', '0', '11364', '5188', '11360', '15424', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290003', '3', '1', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '10', '111', '0', '0', '0', '0', '0', '0', '0', '20493', '2304', '5344', '1024', '10496', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290004', '1', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '5', '97', '79693844', '0', '0', '0', '0', '0', '0', '0', '9413', '16644', '5347', '8576', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290005', '5', '3', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '9', '98', '310379590', '0', '0', '0', '0', '0', '0', '20507', '7589', '16641', '3265', '9504', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290006', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '114', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290007', '6', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '65', '52', '55', '0', '894436363', '0', '0', '0', '0', '0', '0', '6336', '1409', '9440', '5250', '6496', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290008', '8', '1', '3', '0', '0', '7', '0', '0', '0', '1', '1', '0', '0', '0', '0', '55', '55', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10368', '1664', '25668', '21636', '198656', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290009', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '1728', '1728', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290010', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '2752', '2752', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290011', '1', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '3', '103', '147851265', '0', '0', '0', '0', '0', '0', '23655', '10369', '16387', '25696', '25632', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290012', '3', '1', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '13', '7', '104', '147852288', '0', '0', '0', '0', '0', '0', '11289', '14529', '15360', '14529', '15459', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290013', '3', '1', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '10', '111', '0', '0', '0', '0', '0', '0', '0', '20493', '2304', '5344', '1024', '10496', '126976', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290014', '7', '3', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '64', '53', '57', '101', '79695902', '0', '0', '0', '0', '0', '0', '11301', '11460', '4225', '11459', '15457', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290015', '3', '3', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '4', '1', '0', '210765825', '236979210', '0', '0', '0', '231736331', '0', '9345', '9345', '9472', '9281', '9312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290016', '3', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '14', '4', '0', '210764840', '236979210', '0', '0', '0', '231736350', '0', '9408', '9376', '9760', '9284', '9316', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290017', '8', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '168821770', '0', '0', '0', '0', '0', '0', '19498', '14624', '3150', '14624', '10339', '249856', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290018', '1', '3', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '1', '16', '0', '168821761', '0', '0', '0', '0', '0', '0', '19501', '14624', '3143', '14624', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290019', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '10', '0', '168821790', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '10304', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290020', '6', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '81', '51', '54', '0', '347079684', '0', '0', '0', '0', '0', '0', '7266', '4290', '2114', '1024', '4321', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290021', '8', '2', '6', '0', '0', '2', '0', '0', '4', '1', '5', '0', '2', '1', '1', '13', '15', '15', '0', '168823809', '0', '0', '0', '0', '0', '0', '21569', '8386', '8608', '11520', '9537', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290022', '9', '4', '1', '0', '0', '1', '0', '0', '5', '0', '4', '3', '1', '0', '2', '76', '63', '62', '0', '58723358', '59771934', '0', '0', '0', '0', '0', '5411', '10467', '10402', '10336', '25697', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290023', '8', '2', '6', '0', '0', '2', '0', '0', '2', '0', '3', '1', '3', '3', '0', '27', '13', '7', '0', '721421325', '0', '0', '0', '0', '0', '0', '23598', '2305', '2210', '2272', '25824', '148480', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290024', '6', '2', '3', '0', '0', '8', '0', '0', '3', '1', '4', '4', '2', '3', '2', '53', '61', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5380', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290025', '7', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '1', '2', '3', '2', '21', '10', '11', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290026', '1', '2', '1', '0', '0', '8', '0', '0', '4', '1', '2', '3', '0', '1', '1', '2', '2', '8', '0', '210765825', '236979210', '0', '0', '0', '0', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290027', '6', '2', '1', '0', '0', '2', '0', '0', '2', '1', '1', '5', '2', '1', '2', '9', '1', '13', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290028', '6', '2', '3', '0', '0', '8', '0', '0', '3', '1', '4', '4', '2', '3', '2', '53', '61', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5380', '35076', '16481', '1024', '5120', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290029', '7', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '1', '2', '3', '2', '21', '10', '11', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290030', '1', '2', '1', '0', '0', '8', '0', '0', '4', '1', '2', '3', '0', '1', '1', '2', '2', '8', '0', '210765825', '236979210', '0', '0', '0', '0', '0', '9475', '9441', '9472', '9345', '9345', '199680', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290031', '6', '2', '1', '0', '0', '2', '0', '0', '2', '1', '1', '5', '2', '1', '2', '9', '1', '13', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290032', '2', '1', '8', '0', '0', '2', '0', '0', '5', '1', '5', '2', '2', '2', '1', '15', '9', '2', '0', '210765827', '236979210', '0', '0', '0', '0', '0', '0', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290033', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '15', '16', '0', '331351046', '0', '0', '0', '0', '0', '0', '7360', '35268', '5348', '5344', '4259', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290034', '21', '2', '21', '0', '0', '21', '0', '0', '0', '1', '3', '0', '3', '0', '1', '16', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1952', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290035', '6', '1', '4', '0', '0', '4', '0', '0', '3', '0', '3', '2', '1', '3', '1', '70', '61', '53', '0', '0', '0', '0', '0', '0', '0', '0', '5441', '5379', '5283', '5348', '5440', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290036', '10520', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290037', '2', '2', '9', '0', '0', '2', '0', '0', '5', '0', '1', '2', '0', '1', '3', '26', '5', '12', '0', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9696', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290038', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '109', '147850241', '0', '0', '0', '0', '0', '0', '0', '11364', '5188', '11360', '15424', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290039', '1', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '5', '97', '79693844', '0', '0', '0', '0', '0', '0', '0', '9413', '16644', '5347', '8576', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290040', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '114', '58723339', '59771915', '0', '0', '0', '0', '0', '10529', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290041', '7', '2', '6', '0', '0', '5', '0', '0', '5', '0', '5', '4', '3', '3', '2', '29', '14', '3', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290042', '1', '2', '8', '0', '0', '7', '31', '0', '2', '1', '2', '5', '2', '2', '2', '3', '1', '15', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290043', '8', '2', '1', '0', '0', '2', '0', '0', '0', '1', '3', '1', '2', '1', '3', '8', '13', '9', '0', '147851276', '0', '0', '0', '0', '0', '0', '23885', '15362', '3149', '5219', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290044', '1', '2', '7', '0', '0', '8', '26', '0', '3', '1', '1', '5', '1', '3', '0', '19', '9', '2', '0', '147851276', '0', '0', '0', '0', '0', '0', '13506', '15362', '3149', '25732', '8261', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290045', '4', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '6', '4', '0', '862979074', '0', '0', '0', '0', '0', '0', '23744', '34848', '6208', '6176', '6208', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290046', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '2', '5', '0', '878707723', '0', '0', '0', '0', '0', '0', '9569', '6179', '6176', '6211', '6179', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290047', '2', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '11', '5', '0', '862979074', '0', '0', '0', '0', '0', '0', '21507', '4256', '2209', '5187', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290048', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '7', '8', '0', '800067584', '0', '0', '0', '0', '0', '0', '11282', '7296', '4167', '6213', '8259', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290049', '8', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '11', '8', '0', '79693824', '0', '0', '0', '0', '0', '0', '10304', '16416', '3072', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290050', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '3', '1', '0', '210765825', '236979210', '0', '0', '0', '231736331', '0', '9409', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290051', '7', '2', '8', '0', '0', '5', '5', '0', '0', '0', '0', '0', '0', '0', '0', '22', '16', '5', '0', '862979074', '0', '0', '0', '0', '0', '0', '0', '29856', '28864', '1024', '28864', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290052', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '8', '12', '0', '79697930', '32510977', '0', '0', '0', '0', '0', '10305', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290053', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '7', '3', '0', '862980106', '0', '0', '0', '0', '0', '0', '23650', '33956', '2208', '6242', '6209', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290054', '8', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '8', '8', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290055', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '6', '4', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290056', '8', '2', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290057', '8', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '13', '2', '0', '80741388', '32509962', '0', '0', '0', '0', '0', '12416', '15458', '3150', '8352', '15457', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290058', '1', '2', '4', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '8', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290059', '2', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '6', '12', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290060', '1', '2', '5', '0', '0', '7', '31', '0', '0', '0', '0', '0', '0', '0', '0', '9', '16', '12', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290061', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '9', '0', '79697950', '32509962', '0', '0', '0', '0', '0', '12416', '15460', '3150', '8352', '15458', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290062', '8', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '68', '65', '62', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290063', '8', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '62', '60', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290064', '8', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '82', '57', '52', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290065', '8', '2', '2', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '57', '59', '53', '0', '79695892', '32509962', '0', '0', '0', '0', '0', '12416', '15456', '3150', '8352', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290066', '7', '2', '1', '0', '0', '1', '18', '0', '0', '0', '0', '0', '0', '0', '0', '28', '12', '15', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290067', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290068', '7', '2', '1', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '2', '16', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290069', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '8', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290070', '7', '2', '6', '0', '0', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290071', '7', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '6', '2', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290072', '7', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '3', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290073', '7', '2', '4', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '7', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290074', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '13', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290075', '7', '2', '1', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11425', '9760', '9345', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290076', '5', '2', '3', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '62', '63', '61', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290077', '6', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '61', '62', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290078', '5', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '72', '64', '59', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290079', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '70', '57', '56', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290080', '5', '2', '2', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '54', '60', '57', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290081', '6', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '65', '52', '55', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290082', '5', '2', '4', '0', '0', '8', '20', '0', '0', '0', '0', '0', '0', '0', '0', '51', '59', '57', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290083', '6', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '65', '63', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290084', '5', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '67', '58', '56', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290085', '5', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '55', '59', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11427', '9472', '9312', '13474', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290086', '3', '2', '8', '0', '0', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '21', '15', '13', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290087', '4', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '2', '5', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290088', '3', '2', '8', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '12', '3', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290089', '4', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290090', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '11', '1', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290091', '4', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '6', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290092', '3', '2', '8', '0', '0', '3', '9', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '4', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290093', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '5', '8', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290094', '3', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '12', '14', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290095', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '8', '14', '0', '210765826', '236979210', '0', '0', '0', '231736351', '0', '8225', '11428', '9504', '9346', '13472', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290096', '9', '2', '2', '0', '0', '1', '0', '0', '0', '1', '1', '0', '0', '0', '0', '54', '63', '66', '0', '79696936', '32513064', '0', '0', '0', '0', '0', '13505', '8256', '15488', '11456', '9412', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290097', '8', '2', '4', '0', '0', '1', '19', '0', '0', '1', '0', '0', '0', '0', '0', '6', '11', '14', '0', '79696966', '32513064', '0', '0', '0', '0', '0', '13505', '8288', '15488', '11459', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2290098', '8', '2', '4', '0', '0', '1', '19', '0', '0', '1', '0', '0', '0', '0', '0', '6', '11', '14', '0', '79696966', '32513064', '0', '0', '0', '0', '0', '13505', '8288', '15488', '11459', '9504', '188416', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2291001', '1', '2', '7', '0', '0', '8', '0', '0', '1', '1', '5', '4', '2', '2', '3', '2', '9', '1', '0', '79695882', '32506900', '0', '0', '0', '0', '0', '15426', '15396', '4098', '8288', '13475', '215040', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2291002', '1', '2', '7', '0', '0', '7', '0', '0', '3', '1', '5', '3', '2', '3', '3', '29', '8', '15', '0', '168821780', '0', '0', '0', '0', '0', '0', '14337', '12416', '3147', '14467', '13474', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2291003', '1', '2', '8', '0', '0', '1', '0', '0', '3', '0', '3', '5', '2', '3', '3', '8', '4', '4', '0', '210766878', '236979210', '0', '0', '0', '0', '0', '9474', '9410', '4160', '9287', '6217', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2291004', '1', '2', '7', '0', '0', '8', '0', '0', '0', '0', '4', '0', '0', '0', '1', '7', '7', '10', '0', '0', '0', '0', '0', '0', '0', '0', '7236', '7300', '2081', '5251', '4197', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2291005', '1', '2', '8', '0', '0', '7', '0', '0', '4', '1', '1', '0', '1', '1', '2', '4', '12', '5', '0', '310379550', '0', '0', '0', '0', '0', '0', '7234', '35012', '4167', '5218', '10370', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2300101', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2300401', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2300701', '10008', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2300702', '10008', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2300901', '10011', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301001', '10012', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301101', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301102', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301103', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301104', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301105', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301106', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301107', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301108', '10017', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301109', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301110', '10017', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301111', '10017', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301301', '10021', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301601', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301701', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301702', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301901', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2301902', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '80741376', '32510986', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302101', '10033', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302201', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302501', '10037', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302701', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302702', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302703', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302704', '10039', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2302705', '10039', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303001', '10043', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303002', '10043', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303003', '10043', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1026', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303004', '10043', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303005', '10043', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303006', '10043', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303007', '10043', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303101', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303102', '10045', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303401', '10049', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2303501', '10054', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304101', '10503', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304201', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304202', '10504', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304203', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304204', '10504', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304205', '10504', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304301', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304302', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304303', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304304', '10505', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2304501', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2305301', '10509', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1025', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2305401', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2305601', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2305701', '10513', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2305901', '10516', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2307001', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2307002', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '112', '79695883', '32510981', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2308701', '10047', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2309901', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310601', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310602', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310603', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310604', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310605', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310606', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310607', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310608', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310609', '1255', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2310701', '10055', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380001', '1', '2', '1', '0', '0', '2', '0', '0', '2', '0', '1', '0', '2', '1', '1', '29', '12', '16', '128', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380002', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '16', '9', '15', '128', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380003', '1', '2', '2', '0', '0', '8', '0', '0', '2', '0', '3', '1', '2', '3', '3', '17', '15', '4', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380004', '1', '3', '1', '0', '0', '7', '16', '0', '2', '0', '0', '4', '2', '1', '3', '18', '5', '16', '128', '79694869', '32512030', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380005', '8', '2', '6', '0', '0', '3', '0', '0', '4', '1', '3', '2', '3', '1', '0', '1', '12', '11', '127', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380006', '1', '3', '4', '0', '0', '8', '7', '0', '0', '0', '0', '5', '3', '2', '3', '22', '4', '16', '128', '210765844', '236979200', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380007', '4', '2', '5', '0', '0', '8', '31', '0', '2', '0', '1', '5', '3', '3', '0', '1', '7', '10', '127', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('2380008', '5', '3', '2', '0', '0', '8', '31', '0', '1', '1', '0', '2', '0', '2', '3', '60', '55', '59', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3000001', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '25', '19', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001101', '1', '2', '7', '0', '0', '7', '0', '0', '2', '1', '1', '5', '2', '2', '2', '26', '7', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001102', '1', '1', '6', '0', '0', '7', '0', '0', '5', '1', '1', '1', '3', '3', '1', '13', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001103', '1', '2', '1', '0', '0', '8', '0', '0', '4', '0', '3', '1', '1', '2', '3', '2', '11', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001104', '1', '3', '8', '0', '0', '8', '0', '0', '0', '0', '1', '4', '1', '1', '2', '8', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '1089', '6145', '1024', '1024', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001105', '1', '4', '4', '0', '0', '8', '0', '0', '1', '0', '0', '5', '0', '0', '1', '30', '9', '3', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001106', '2', '2', '7', '0', '0', '3', '0', '0', '2', '1', '3', '0', '2', '3', '3', '29', '2', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001107', '2', '1', '5', '0', '0', '2', '0', '0', '3', '1', '4', '1', '1', '3', '0', '22', '16', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32834', '9536', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001108', '2', '4', '1', '0', '0', '2', '0', '0', '4', '0', '0', '1', '3', '2', '3', '20', '10', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001109', '2', '0', '6', '0', '0', '3', '0', '0', '1', '1', '3', '3', '0', '1', '2', '27', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31809', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001110', '2', '2', '4', '0', '0', '2', '0', '0', '1', '0', '4', '5', '1', '0', '0', '14', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001111', '9', '2', '3', '0', '0', '2', '0', '0', '4', '0', '5', '1', '1', '1', '0', '56', '58', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001112', '9', '0', '2', '0', '0', '1', '0', '0', '2', '1', '3', '2', '1', '0', '0', '68', '63', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001113', '9', '3', '3', '0', '0', '2', '0', '0', '4', '0', '0', '4', '0', '1', '3', '60', '61', '59', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001114', '9', '4', '3', '0', '0', '4', '0', '0', '4', '0', '4', '2', '3', '1', '2', '64', '65', '65', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001115', '9', '2', '4', '0', '0', '2', '0', '0', '1', '1', '3', '4', '0', '1', '3', '51', '53', '64', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '1089', '6145', '1024', '1024', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001116', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '2', '4', '0', '0', '0', '24', '10', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10276', '16449', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001117', '3', '1', '3', '0', '0', '4', '0', '0', '4', '1', '0', '0', '2', '0', '0', '25', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001118', '3', '0', '5', '0', '0', '7', '0', '0', '1', '1', '4', '4', '3', '1', '1', '2', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001119', '3', '4', '4', '0', '0', '4', '0', '0', '0', '1', '4', '3', '2', '0', '2', '11', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001120', '3', '2', '3', '0', '0', '7', '0', '0', '5', '0', '1', '3', '1', '3', '2', '29', '16', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32801', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001121', '4', '2', '4', '0', '0', '6', '0', '0', '2', '1', '2', '2', '2', '2', '0', '8', '12', '2', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1376', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001122', '4', '0', '4', '0', '0', '8', '0', '0', '2', '0', '0', '5', '2', '0', '3', '15', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001123', '4', '2', '2', '0', '0', '1', '0', '0', '1', '0', '5', '3', '0', '2', '3', '2', '4', '11', '0', '0', '0', '0', '0', '0', '0', '0', '21505', '1380', '15360', '25600', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001124', '4', '4', '1', '0', '0', '8', '0', '0', '0', '0', '0', '1', '0', '1', '3', '26', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5217', '2144', '2113', '1024', '2242', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001125', '4', '2', '4', '0', '0', '1', '0', '0', '4', '0', '5', '4', '2', '3', '1', '8', '15', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001126', '3', '2', '7', '0', '0', '6', '0', '0', '3', '1', '4', '4', '0', '1', '2', '77', '61', '63', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001127', '3', '1', '3', '0', '0', '6', '0', '0', '0', '1', '1', '0', '1', '2', '3', '52', '64', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001128', '3', '2', '6', '0', '0', '5', '0', '0', '5', '1', '0', '3', '2', '0', '0', '70', '66', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31811', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001129', '3', '3', '5', '0', '0', '1', '0', '0', '1', '1', '2', '4', '0', '2', '0', '80', '64', '63', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10304', '5154', '1024', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001130', '3', '4', '5', '0', '0', '6', '0', '0', '5', '0', '1', '4', '0', '3', '2', '73', '53', '60', '0', '0', '0', '0', '0', '0', '0', '0', '23593', '8224', '9760', '5188', '8224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001131', '4', '4', '2', '0', '0', '5', '0', '0', '1', '1', '2', '4', '3', '2', '0', '76', '52', '57', '0', '0', '0', '0', '0', '0', '0', '0', '23652', '10370', '16418', '25632', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001132', '4', '1', '2', '0', '0', '7', '0', '0', '3', '1', '4', '2', '3', '3', '0', '78', '63', '61', '0', '0', '0', '0', '0', '0', '0', '0', '6188', '4162', '6180', '1024', '6180', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001133', '4', '2', '8', '0', '0', '7', '0', '0', '4', '0', '0', '3', '0', '1', '1', '74', '60', '59', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1376', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001134', '4', '3', '3', '0', '0', '7', '0', '0', '4', '1', '0', '2', '0', '2', '3', '54', '53', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001135', '4', '0', '8', '0', '0', '7', '0', '0', '5', '0', '1', '5', '0', '0', '3', '69', '54', '54', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1378', '15360', '5155', '21568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001136', '5', '0', '3', '0', '0', '3', '0', '0', '4', '0', '1', '4', '3', '0', '1', '15', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1057', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001137', '5', '1', '3', '0', '0', '7', '0', '0', '3', '0', '1', '5', '3', '1', '0', '2', '11', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32800', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001138', '5', '2', '3', '0', '0', '7', '0', '0', '2', '0', '3', '5', '2', '2', '2', '23', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001139', '5', '3', '3', '0', '0', '3', '0', '0', '5', '0', '2', '5', '2', '1', '3', '15', '10', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32803', '9376', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001140', '5', '2', '2', '0', '0', '5', '0', '0', '1', '0', '2', '0', '3', '3', '0', '28', '12', '3', '0', '0', '0', '0', '0', '0', '0', '0', '6152', '10337', '5184', '1024', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001141', '6', '2', '1', '0', '0', '6', '0', '0', '0', '1', '5', '1', '2', '3', '1', '22', '14', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32864', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001142', '6', '0', '3', '0', '0', '6', '0', '0', '0', '1', '2', '5', '2', '2', '2', '20', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1376', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001143', '6', '4', '1', '0', '0', '2', '0', '0', '4', '0', '5', '4', '3', '3', '0', '3', '14', '3', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001144', '6', '3', '3', '0', '0', '5', '0', '0', '5', '0', '0', '2', '2', '0', '0', '7', '14', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32834', '9536', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001145', '6', '2', '4', '0', '0', '1', '0', '0', '2', '0', '2', '2', '0', '0', '0', '15', '7', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32803', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001146', '5', '2', '4', '0', '0', '8', '0', '0', '1', '0', '0', '0', '3', '2', '1', '63', '52', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1058', '6147', '25633', '4131', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001147', '5', '1', '1', '0', '0', '6', '0', '0', '2', '1', '1', '2', '3', '2', '1', '68', '53', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001148', '5', '0', '2', '0', '0', '2', '0', '0', '4', '0', '5', '2', '3', '1', '2', '72', '52', '53', '0', '0', '0', '0', '0', '0', '0', '0', '23586', '4131', '2082', '1024', '6179', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001149', '5', '3', '1', '0', '0', '2', '0', '0', '3', '1', '1', '2', '2', '0', '1', '72', '66', '61', '0', '0', '0', '0', '0', '0', '0', '0', '23584', '1089', '6145', '1024', '1024', '176128', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001150', '5', '2', '3', '0', '0', '6', '0', '0', '0', '1', '5', '3', '2', '1', '0', '80', '64', '57', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001151', '6', '2', '1', '0', '0', '4', '0', '0', '4', '1', '3', '4', '3', '2', '0', '68', '66', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001152', '6', '1', '3', '0', '0', '3', '0', '0', '3', '1', '4', '1', '1', '0', '0', '59', '61', '58', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1376', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001153', '6', '0', '3', '0', '0', '3', '0', '0', '0', '1', '4', '3', '3', '2', '0', '67', '64', '60', '0', '0', '0', '0', '0', '0', '0', '0', '6187', '1412', '6209', '5282', '1057', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001154', '6', '3', '1', '0', '0', '7', '0', '0', '1', '0', '2', '3', '2', '1', '0', '75', '63', '53', '0', '0', '0', '0', '0', '0', '0', '0', '21506', '2082', '2082', '5154', '2241', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001155', '6', '2', '4', '0', '0', '8', '0', '0', '2', '0', '1', '5', '2', '0', '1', '51', '51', '53', '0', '0', '0', '0', '0', '0', '0', '0', '23840', '1378', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001156', '8', '2', '5', '0', '0', '3', '0', '0', '5', '1', '1', '1', '0', '1', '0', '10', '15', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '4227', '1024', '4194', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001157', '8', '1', '1', '0', '0', '1', '0', '0', '0', '0', '4', '0', '0', '3', '2', '28', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001158', '8', '4', '5', '0', '0', '4', '0', '0', '0', '1', '0', '2', '3', '3', '0', '30', '5', '5', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33920', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001159', '8', '3', '3', '0', '0', '3', '0', '0', '0', '1', '3', '4', '2', '1', '1', '14', '13', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32801', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001160', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '4', '1', '2', '3', '1', '13', '2', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31811', '7240', '1024', '8260', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001161', '8', '4', '3', '0', '0', '8', '0', '0', '1', '1', '1', '5', '3', '2', '1', '66', '54', '61', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32834', '9536', '1024', '21600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001162', '8', '1', '8', '0', '0', '7', '0', '0', '5', '0', '5', '3', '0', '2', '2', '59', '57', '62', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '2084', '2050', '1024', '2241', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001163', '8', '4', '2', '0', '0', '5', '0', '0', '5', '0', '5', '4', '1', '2', '3', '63', '60', '65', '0', '0', '0', '0', '0', '0', '0', '0', '23876', '1056', '15360', '25600', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001164', '8', '0', '2', '0', '0', '8', '0', '0', '4', '1', '1', '4', '2', '1', '1', '51', '64', '53', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32802', '2116', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001165', '8', '2', '7', '0', '0', '7', '0', '0', '5', '0', '5', '0', '0', '0', '0', '63', '56', '54', '0', '0', '0', '0', '0', '0', '0', '0', '6160', '33860', '15360', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001166', '7', '2', '6', '0', '0', '8', '0', '0', '2', '0', '0', '2', '1', '2', '0', '17', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001167', '7', '1', '3', '0', '0', '1', '0', '0', '5', '1', '3', '2', '2', '2', '2', '9', '1', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '10369', '5190', '1024', '25666', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001168', '7', '4', '9', '0', '0', '1', '0', '0', '2', '1', '1', '2', '2', '3', '3', '20', '11', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31812', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001169', '7', '3', '8', '0', '0', '1', '0', '0', '2', '1', '0', '2', '0', '2', '3', '10', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9376', '2084', '1024', '1056', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001170', '7', '0', '2', '0', '0', '4', '0', '0', '5', '1', '1', '1', '3', '3', '1', '28', '2', '11', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '1056', '2083', '25600', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001171', '7', '2', '8', '0', '0', '2', '0', '0', '2', '1', '3', '2', '1', '1', '0', '53', '63', '56', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '32770', '10304', '1024', '8192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001172', '7', '1', '1', '0', '0', '7', '0', '0', '3', '0', '2', '5', '2', '0', '1', '80', '58', '64', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31808', '6146', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001173', '7', '4', '5', '0', '0', '3', '0', '0', '3', '0', '4', '0', '0', '3', '3', '54', '64', '52', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31809', '6147', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001174', '7', '3', '8', '0', '0', '3', '0', '0', '5', '0', '4', '5', '2', '0', '1', '64', '66', '66', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '4128', '6176', '1024', '6176', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3001175', '7', '4', '6', '0', '0', '6', '0', '0', '1', '1', '3', '2', '0', '3', '3', '53', '61', '56', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31810', '6144', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002101', '1', '2', '3', '0', '0', '8', '0', '0', '5', '0', '2', '2', '2', '0', '0', '4', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002102', '1', '1', '1', '0', '0', '1', '0', '0', '4', '0', '2', '1', '0', '3', '1', '23', '10', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002103', '1', '2', '4', '0', '0', '7', '0', '0', '2', '1', '2', '5', '2', '2', '2', '15', '3', '4', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002104', '1', '3', '5', '0', '0', '7', '0', '0', '4', '1', '2', '3', '3', '2', '3', '19', '11', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002105', '1', '4', '2', '0', '0', '8', '0', '0', '5', '1', '4', '3', '1', '0', '0', '13', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '21504', '2080', '2050', '1024', '2240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002106', '2', '2', '5', '0', '0', '2', '0', '0', '5', '0', '1', '4', '0', '0', '3', '14', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002107', '2', '1', '6', '0', '0', '1', '0', '0', '0', '1', '5', '0', '2', '3', '0', '7', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002108', '2', '4', '4', '0', '0', '5', '0', '0', '3', '0', '3', '2', '3', '1', '1', '13', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002109', '2', '0', '5', '0', '0', '3', '0', '0', '1', '0', '5', '0', '2', '2', '2', '9', '6', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002110', '2', '2', '5', '0', '0', '1', '0', '0', '4', '0', '1', '0', '3', '3', '1', '17', '6', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10273', '4128', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002111', '9', '2', '4', '0', '0', '4', '0', '0', '5', '1', '4', '0', '3', '1', '0', '58', '52', '66', '0', '0', '0', '0', '0', '0', '0', '0', '23587', '1090', '9216', '5251', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002112', '9', '0', '2', '0', '0', '2', '0', '0', '1', '0', '4', '3', '0', '0', '3', '69', '65', '57', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002113', '9', '3', '2', '0', '0', '3', '0', '0', '3', '1', '1', '5', '1', '1', '0', '82', '61', '57', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '4164', '2083', '1024', '25666', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002114', '9', '4', '3', '0', '0', '3', '0', '0', '3', '1', '0', '2', '0', '1', '0', '62', '53', '51', '0', '0', '0', '0', '0', '0', '0', '0', '20512', '5217', '5217', '1024', '5217', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002115', '9', '2', '1', '0', '0', '3', '0', '0', '2', '0', '4', '3', '0', '3', '1', '58', '57', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29764', '5193', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002116', '3', '2', '6', '0', '0', '4', '0', '0', '1', '1', '5', '1', '0', '0', '0', '28', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29765', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002117', '3', '1', '4', '0', '0', '3', '0', '0', '1', '0', '3', '0', '2', '1', '1', '12', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4291', '6147', '1024', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002118', '3', '0', '6', '0', '0', '7', '0', '0', '2', '1', '0', '5', '1', '3', '3', '10', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002119', '3', '4', '8', '0', '0', '3', '0', '0', '1', '1', '3', '2', '2', '0', '3', '25', '10', '8', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5315', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002120', '3', '2', '4', '0', '0', '8', '0', '0', '2', '0', '0', '3', '1', '1', '2', '7', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4290', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002121', '4', '2', '6', '0', '0', '8', '0', '0', '4', '0', '5', '4', '2', '0', '1', '8', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002122', '4', '0', '3', '0', '0', '4', '0', '0', '1', '1', '2', '2', '3', '3', '2', '15', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10368', '5188', '1024', '21600', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002123', '4', '2', '1', '0', '0', '1', '0', '0', '4', '1', '3', '2', '2', '3', '2', '13', '9', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6181', '4164', '6208', '1024', '6209', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002124', '4', '4', '1', '0', '0', '6', '0', '0', '4', '1', '0', '4', '2', '0', '2', '3', '13', '9', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002125', '4', '2', '6', '0', '0', '6', '0', '0', '3', '1', '3', '3', '0', '1', '3', '32', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5217', '2144', '2113', '1024', '2242', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002126', '3', '2', '2', '0', '0', '2', '0', '0', '4', '0', '4', '2', '1', '1', '0', '69', '59', '58', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002127', '3', '1', '4', '0', '0', '6', '0', '0', '3', '0', '1', '5', '0', '0', '0', '56', '54', '59', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002128', '3', '2', '8', '0', '0', '5', '0', '0', '2', '1', '3', '5', '1', '1', '3', '78', '51', '60', '0', '0', '0', '0', '0', '0', '0', '0', '20512', '5184', '2081', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002129', '3', '3', '6', '0', '0', '1', '0', '0', '3', '0', '5', '4', '3', '2', '3', '77', '59', '52', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002130', '3', '4', '5', '0', '0', '6', '0', '0', '1', '0', '0', '5', '3', '3', '2', '77', '52', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2144', '2080', '1024', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002131', '4', '4', '1', '0', '0', '2', '0', '0', '5', '1', '5', '1', '0', '1', '2', '55', '53', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1412', '5218', '1024', '1056', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002132', '4', '1', '2', '0', '0', '5', '0', '0', '1', '1', '0', '2', '1', '2', '1', '81', '59', '57', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002133', '4', '2', '4', '0', '0', '5', '0', '0', '4', '1', '5', '2', '0', '1', '2', '56', '51', '57', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5184', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002134', '4', '3', '1', '0', '0', '2', '0', '0', '3', '1', '2', '2', '3', '0', '2', '80', '66', '52', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4098', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002135', '4', '0', '8', '0', '0', '3', '0', '0', '3', '1', '1', '0', '1', '2', '0', '77', '54', '60', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5185', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002136', '5', '0', '4', '0', '0', '3', '0', '0', '0', '1', '0', '3', '2', '1', '1', '22', '16', '5', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7297', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002137', '5', '1', '2', '0', '0', '1', '0', '0', '3', '0', '1', '0', '2', '0', '0', '18', '10', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6152', '10339', '5184', '1024', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002138', '5', '2', '2', '0', '0', '5', '0', '0', '0', '1', '2', '5', '3', '2', '2', '7', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002139', '5', '3', '2', '0', '0', '1', '0', '0', '4', '0', '4', '2', '3', '0', '3', '30', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29772', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002140', '5', '2', '1', '0', '0', '7', '0', '0', '5', '0', '3', '5', '3', '1', '1', '2', '5', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29770', '5194', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002141', '6', '2', '2', '0', '0', '5', '0', '0', '2', '0', '4', '0', '1', '0', '1', '14', '10', '9', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002142', '6', '0', '4', '0', '0', '6', '0', '0', '5', '0', '5', '5', '1', '2', '2', '9', '2', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35012', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002143', '6', '4', '4', '0', '0', '6', '0', '0', '1', '1', '3', '3', '1', '2', '1', '13', '13', '16', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7489', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002144', '6', '3', '3', '0', '0', '6', '0', '0', '4', '0', '2', '1', '1', '2', '3', '29', '16', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6155', '1409', '16419', '1024', '5156', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002145', '6', '2', '4', '0', '0', '2', '0', '0', '5', '1', '0', '1', '2', '0', '1', '7', '2', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5184', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002146', '5', '2', '2', '0', '0', '2', '0', '0', '4', '1', '3', '1', '2', '1', '1', '80', '53', '61', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002147', '5', '1', '1', '0', '0', '8', '0', '0', '2', '0', '2', '5', '1', '3', '0', '52', '51', '61', '0', '0', '0', '0', '0', '0', '0', '0', '10282', '5316', '4130', '5120', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002148', '5', '0', '2', '0', '0', '4', '0', '0', '0', '0', '3', '4', '3', '3', '1', '82', '62', '60', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002149', '5', '3', '1', '0', '0', '6', '0', '0', '0', '1', '3', '3', '1', '1', '0', '70', '52', '61', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '2146', '2115', '1024', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002150', '5', '2', '4', '0', '0', '2', '0', '0', '1', '0', '5', '4', '2', '1', '0', '75', '60', '54', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29764', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002151', '6', '2', '4', '0', '0', '3', '0', '0', '1', '1', '2', '5', '2', '1', '3', '56', '55', '56', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4193', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002152', '6', '1', '1', '0', '0', '8', '0', '0', '1', '0', '1', '3', '3', '2', '1', '53', '65', '52', '0', '0', '0', '0', '0', '0', '0', '0', '4291', '7235', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002153', '6', '0', '1', '0', '0', '3', '0', '0', '1', '0', '1', '1', '3', '3', '1', '78', '57', '53', '0', '0', '0', '0', '0', '0', '0', '0', '4288', '7490', '2115', '1024', '4288', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002154', '6', '3', '2', '0', '0', '7', '0', '0', '4', '1', '2', '0', '2', '2', '3', '82', '61', '52', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002155', '6', '2', '3', '0', '0', '4', '0', '0', '3', '1', '2', '5', '2', '2', '2', '81', '51', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '8192', '1024', '21600', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002156', '8', '2', '7', '0', '0', '1', '0', '0', '2', '1', '0', '5', '2', '3', '3', '16', '16', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5184', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002157', '8', '1', '7', '0', '0', '1', '0', '0', '0', '0', '2', '2', '1', '1', '2', '14', '8', '11', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4195', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002158', '8', '4', '2', '0', '0', '3', '0', '0', '3', '0', '0', '1', '3', '0', '1', '13', '11', '12', '0', '0', '0', '0', '0', '0', '0', '0', '21697', '4099', '2144', '1024', '4224', '207872', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002159', '8', '3', '4', '0', '0', '3', '0', '0', '4', '0', '0', '2', '0', '3', '3', '29', '15', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35072', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002160', '8', '2', '4', '0', '0', '4', '0', '0', '4', '0', '3', '0', '1', '3', '0', '28', '14', '1', '0', '0', '0', '0', '0', '0', '0', '0', '6181', '4164', '2080', '1024', '6209', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002161', '8', '4', '7', '0', '0', '6', '0', '0', '5', '0', '1', '1', '0', '2', '2', '74', '57', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10369', '5197', '1024', '21634', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002162', '8', '1', '3', '0', '0', '7', '0', '0', '1', '0', '5', '0', '1', '1', '3', '70', '64', '54', '0', '0', '0', '0', '0', '0', '0', '0', '10288', '35012', '10337', '1024', '6304', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002163', '8', '4', '4', '0', '0', '7', '0', '0', '4', '1', '0', '4', '3', '2', '2', '54', '61', '62', '0', '0', '0', '0', '0', '0', '0', '0', '10241', '5186', '2114', '5121', '5380', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002164', '8', '0', '2', '0', '0', '7', '0', '0', '4', '1', '3', '5', '1', '1', '2', '70', '64', '51', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '4224', '2080', '1024', '2084', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002165', '8', '2', '8', '0', '0', '7', '0', '0', '1', '1', '1', '3', '3', '2', '0', '81', '59', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '1024', '1024', '8193', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002166', '7', '2', '8', '0', '0', '8', '0', '0', '4', '0', '0', '4', '3', '3', '3', '9', '9', '3', '0', '0', '0', '0', '0', '0', '0', '0', '10277', '7300', '5220', '1024', '9316', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002167', '7', '1', '2', '0', '0', '5', '0', '0', '1', '0', '2', '2', '0', '0', '1', '17', '13', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29763', '5195', '5153', '10434', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002168', '7', '4', '8', '0', '0', '1', '0', '0', '3', '1', '4', '1', '3', '3', '0', '20', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4292', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002169', '7', '3', '9', '0', '0', '5', '0', '0', '3', '0', '0', '3', '0', '3', '2', '2', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '4163', '6147', '1024', '6210', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002170', '7', '0', '9', '0', '0', '1', '0', '0', '4', '1', '4', '4', '1', '2', '3', '2', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '10272', '4291', '5184', '1024', '4163', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002171', '7', '2', '4', '0', '0', '6', '0', '0', '2', '0', '4', '0', '2', '1', '2', '52', '57', '54', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4225', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002172', '7', '1', '5', '0', '0', '2', '0', '0', '2', '1', '3', '4', '3', '1', '1', '62', '57', '61', '0', '0', '0', '0', '0', '0', '0', '0', '23603', '1091', '2116', '5187', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002173', '7', '4', '1', '0', '0', '3', '0', '0', '4', '0', '1', '2', '0', '2', '2', '56', '62', '58', '0', '0', '0', '0', '0', '0', '0', '0', '4224', '4288', '5312', '1024', '6272', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002174', '7', '3', '4', '0', '0', '7', '0', '0', '5', '1', '2', '3', '1', '2', '1', '68', '66', '59', '0', '0', '0', '0', '0', '0', '0', '0', '4227', '4291', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3002175', '7', '4', '8', '0', '0', '3', '0', '0', '1', '0', '0', '3', '3', '0', '0', '67', '51', '57', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '4290', '5312', '1024', '6274', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003101', '1', '2', '7', '0', '0', '2', '0', '0', '0', '1', '4', '2', '0', '1', '1', '24', '11', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003102', '1', '1', '4', '0', '0', '8', '0', '0', '2', '1', '3', '5', '3', '2', '2', '18', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003103', '1', '2', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '3', '2', '2', '27', '14', '9', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003104', '1', '3', '4', '0', '0', '8', '0', '0', '3', '0', '0', '0', '1', '1', '2', '27', '8', '10', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003105', '1', '4', '3', '0', '0', '7', '0', '0', '4', '1', '5', '3', '1', '3', '1', '10', '3', '7', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8192', '7168', '25696', '13313', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003106', '2', '2', '6', '0', '0', '5', '0', '0', '4', '0', '2', '4', '3', '3', '1', '16', '9', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003107', '2', '1', '8', '0', '0', '3', '0', '0', '5', '0', '1', '1', '0', '1', '0', '4', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '6185', '34881', '6179', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003108', '2', '4', '1', '0', '0', '3', '0', '0', '1', '0', '0', '0', '1', '1', '2', '9', '2', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003109', '2', '0', '6', '0', '0', '5', '0', '0', '4', '0', '0', '3', '3', '2', '0', '23', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34884', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003110', '2', '2', '5', '0', '0', '3', '0', '0', '0', '0', '2', '2', '3', '0', '0', '30', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '4224', '7170', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003111', '9', '2', '5', '0', '0', '3', '0', '0', '5', '0', '0', '5', '3', '3', '1', '81', '59', '54', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003112', '9', '0', '1', '0', '0', '4', '0', '0', '5', '1', '2', '3', '1', '2', '3', '51', '55', '57', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003113', '9', '3', '2', '0', '0', '4', '0', '0', '4', '0', '4', '1', '3', '2', '2', '76', '54', '51', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003114', '9', '4', '3', '0', '0', '4', '0', '0', '1', '1', '2', '1', '0', '2', '1', '70', '55', '64', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003115', '9', '2', '5', '0', '0', '1', '0', '0', '4', '0', '1', '2', '0', '3', '2', '74', '54', '60', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003116', '3', '2', '7', '0', '0', '8', '0', '0', '5', '0', '2', '1', '3', '0', '3', '28', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10276', '16449', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003117', '3', '1', '6', '0', '0', '3', '0', '0', '2', '1', '4', '5', '1', '1', '3', '10', '13', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '4130', '6147', '1024', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003118', '3', '0', '4', '0', '0', '7', '0', '0', '4', '1', '4', '4', '0', '3', '1', '22', '16', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003119', '3', '4', '3', '0', '0', '3', '0', '0', '2', '1', '4', '1', '3', '3', '0', '7', '12', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33794', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003120', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '4', '4', '0', '1', '3', '19', '1', '11', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003121', '4', '2', '8', '0', '0', '6', '0', '0', '4', '0', '0', '4', '0', '1', '2', '8', '3', '10', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003122', '4', '0', '5', '0', '0', '4', '0', '0', '4', '0', '3', '3', '1', '0', '0', '23', '13', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003123', '4', '2', '2', '0', '0', '1', '0', '0', '5', '1', '0', '1', '0', '1', '1', '23', '11', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003124', '4', '4', '7', '0', '0', '8', '0', '0', '5', '0', '1', '4', '3', '2', '3', '18', '15', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6181', '4164', '6208', '1024', '6209', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003125', '4', '2', '2', '0', '0', '4', '0', '0', '3', '0', '2', '4', '2', '1', '1', '2', '6', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7170', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003126', '3', '2', '6', '0', '0', '2', '0', '0', '0', '0', '3', '2', '2', '3', '2', '65', '63', '64', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8224', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003127', '3', '1', '3', '0', '0', '2', '0', '0', '3', '0', '5', '2', '2', '3', '2', '77', '53', '57', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003128', '3', '2', '2', '0', '0', '1', '0', '0', '5', '0', '1', '4', '3', '1', '2', '74', '62', '55', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003129', '3', '3', '4', '0', '0', '6', '0', '0', '4', '1', '4', '0', '0', '1', '2', '51', '64', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003130', '3', '4', '6', '0', '0', '5', '0', '0', '5', '0', '3', '4', '2', '2', '3', '57', '64', '55', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003131', '4', '4', '7', '0', '0', '7', '0', '0', '1', '1', '4', '2', '1', '2', '1', '69', '55', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31937', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003132', '4', '1', '3', '0', '0', '5', '0', '0', '0', '0', '1', '3', '3', '0', '0', '76', '54', '65', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003133', '4', '2', '5', '0', '0', '2', '0', '0', '0', '0', '5', '1', '2', '1', '0', '59', '53', '51', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31877', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003134', '4', '3', '8', '0', '0', '5', '0', '0', '0', '0', '0', '5', '2', '2', '3', '76', '52', '52', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4164', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003135', '4', '0', '2', '0', '0', '7', '0', '0', '3', '1', '2', '5', '3', '1', '1', '56', '51', '60', '0', '0', '0', '0', '0', '0', '0', '0', '13376', '8259', '15456', '25696', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003136', '5', '0', '4', '0', '0', '5', '0', '0', '0', '0', '4', '5', '3', '3', '1', '26', '11', '10', '0', '0', '0', '0', '0', '0', '0', '0', '23588', '4132', '6147', '1024', '6212', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003137', '5', '1', '2', '0', '0', '1', '0', '0', '0', '1', '1', '4', '3', '1', '3', '20', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '6152', '10339', '5184', '1024', '25667', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003138', '5', '2', '3', '0', '0', '3', '0', '0', '5', '1', '5', '2', '3', '1', '0', '26', '2', '1', '0', '0', '0', '0', '0', '0', '0', '0', '4161', '2151', '2116', '1024', '2241', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003139', '5', '3', '2', '0', '0', '5', '0', '0', '5', '0', '5', '2', '3', '2', '3', '7', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10272', '6211', '1024', '10272', '337920', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003140', '5', '2', '1', '0', '0', '7', '0', '0', '3', '1', '3', '5', '2', '2', '2', '2', '12', '10', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003141', '6', '2', '3', '0', '0', '5', '0', '0', '1', '0', '0', '2', '3', '0', '3', '10', '4', '1', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003142', '6', '0', '2', '0', '0', '2', '0', '0', '5', '0', '5', '4', '1', '2', '2', '17', '2', '14', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4193', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003143', '6', '4', '4', '0', '0', '1', '0', '0', '1', '1', '4', '2', '2', '0', '2', '25', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34948', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003144', '6', '3', '1', '0', '0', '6', '0', '0', '0', '0', '3', '3', '0', '2', '0', '31', '14', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8320', '15456', '25696', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003145', '6', '2', '1', '0', '0', '1', '0', '0', '5', '1', '3', '5', '0', '1', '3', '1', '4', '14', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003146', '5', '2', '4', '0', '0', '8', '0', '0', '5', '1', '3', '3', '0', '1', '0', '71', '60', '64', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003147', '5', '1', '2', '0', '0', '6', '0', '0', '5', '1', '2', '2', '1', '1', '2', '51', '62', '61', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8256', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003148', '5', '0', '4', '0', '0', '6', '0', '0', '0', '0', '5', '5', '3', '2', '0', '55', '55', '52', '0', '0', '0', '0', '0', '0', '0', '0', '23586', '4131', '2082', '1024', '6179', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003149', '5', '3', '4', '0', '0', '4', '0', '0', '5', '0', '1', '0', '2', '2', '1', '63', '55', '60', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003150', '5', '2', '3', '0', '0', '4', '0', '0', '3', '1', '4', '1', '2', '1', '1', '60', '57', '65', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003151', '6', '2', '3', '0', '0', '8', '0', '0', '0', '1', '3', '0', '1', '3', '2', '60', '57', '66', '0', '0', '0', '0', '0', '0', '0', '0', '6187', '1412', '6209', '5282', '1057', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003152', '6', '1', '2', '0', '0', '4', '0', '0', '1', '1', '2', '3', '3', '3', '0', '70', '66', '51', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34884', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003153', '6', '0', '1', '0', '0', '7', '0', '0', '4', '1', '1', '5', '2', '3', '1', '73', '59', '63', '0', '0', '0', '0', '0', '0', '0', '0', '13376', '8259', '15456', '25696', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003154', '6', '3', '1', '0', '0', '4', '0', '0', '1', '1', '4', '4', '1', '0', '1', '63', '60', '53', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7170', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003155', '6', '2', '3', '0', '0', '3', '0', '0', '4', '1', '5', '5', '3', '1', '3', '57', '57', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003156', '8', '2', '8', '0', '0', '4', '0', '0', '4', '1', '5', '1', '3', '2', '2', '15', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6181', '4164', '2080', '1024', '6209', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003157', '8', '1', '1', '0', '0', '3', '0', '0', '4', '0', '4', '2', '2', '0', '1', '18', '6', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7171', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003158', '8', '4', '8', '0', '0', '2', '0', '0', '0', '1', '2', '4', '2', '3', '1', '21', '5', '10', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '2084', '2050', '1024', '2241', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003159', '8', '3', '7', '0', '0', '4', '0', '0', '0', '1', '1', '5', '1', '2', '2', '8', '11', '2', '0', '0', '0', '0', '0', '0', '0', '0', '4228', '7203', '1024', '1024', '25730', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003160', '8', '2', '8', '0', '0', '2', '0', '0', '4', '0', '1', '5', '2', '0', '1', '2', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34884', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003161', '8', '4', '6', '0', '0', '8', '0', '0', '2', '0', '5', '0', '1', '2', '1', '75', '53', '60', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4132', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003162', '8', '1', '6', '0', '0', '5', '0', '0', '1', '0', '3', '3', '3', '2', '3', '52', '54', '62', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '1024', '1024', '8193', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003163', '8', '4', '1', '0', '0', '8', '0', '0', '4', '0', '5', '4', '2', '1', '2', '60', '57', '51', '0', '0', '0', '0', '0', '0', '0', '0', '11273', '4227', '10241', '1024', '8193', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003164', '8', '0', '1', '0', '0', '7', '0', '0', '0', '0', '2', '5', '1', '3', '1', '54', '63', '65', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '34949', '6176', '5155', '5155', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003165', '8', '2', '8', '0', '0', '7', '0', '0', '3', '0', '3', '2', '2', '3', '3', '76', '54', '62', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '31874', '2115', '10336', '25697', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003166', '7', '2', '6', '0', '0', '4', '0', '0', '3', '0', '1', '3', '2', '0', '3', '17', '14', '11', '0', '0', '0', '0', '0', '0', '0', '0', '6180', '10369', '5190', '1024', '25666', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003167', '7', '1', '7', '0', '0', '8', '0', '0', '3', '0', '3', '3', '0', '1', '1', '29', '15', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33795', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003168', '7', '4', '4', '0', '0', '5', '0', '0', '0', '1', '0', '3', '3', '2', '2', '10', '9', '4', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '8193', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003169', '7', '3', '8', '0', '0', '1', '0', '0', '3', '0', '3', '2', '0', '3', '0', '31', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33856', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003170', '7', '0', '4', '0', '0', '5', '0', '0', '3', '0', '3', '4', '0', '3', '0', '25', '11', '2', '0', '0', '0', '0', '0', '0', '0', '0', '13411', '4194', '9408', '5184', '1060', '175104', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003171', '7', '2', '6', '0', '0', '2', '0', '0', '5', '0', '0', '0', '1', '0', '0', '78', '62', '51', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10336', '5190', '1024', '25668', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003172', '7', '1', '6', '0', '0', '7', '0', '0', '1', '1', '5', '5', '3', '1', '1', '55', '59', '51', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11329', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003173', '7', '4', '8', '0', '0', '7', '0', '0', '2', '1', '1', '3', '3', '3', '1', '69', '65', '66', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '33860', '10242', '9282', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003174', '7', '3', '8', '0', '0', '3', '0', '0', '4', '0', '4', '2', '1', '2', '3', '65', '59', '54', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '8259', '7170', '10272', '13312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('3003175', '7', '4', '6', '0', '0', '7', '0', '0', '2', '0', '3', '3', '1', '3', '0', '56', '51', '63', '0', '0', '0', '0', '0', '0', '0', '0', '11279', '11299', '7236', '1024', '8257', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('5900031', '10526', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('5900032', '10526', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('5900033', '10526', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('5900034', '10526', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('5900035', '10526', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000001', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '33526784', '0', '0', '0', '0', '0', '0', '3072', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000002', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000003', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10274', '10274', '1024', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000004', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15360', '9280', '5152', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000005', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '54', '61', '0', '0', '0', '0', '0', '0', '0', '0', '5122', '1091', '9248', '5122', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000006', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '2', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11424', '3147', '1024', '25665', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000007', '1', '2', '1', '0', '2', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '4', '3', '0', '0', '0', '0', '0', '0', '0', '0', '10496', '10467', '10403', '25731', '25760', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000008', '1', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2081', '2081', '1024', '2241', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000009', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '6', '6', '0', '0', '0', '0', '0', '0', '0', '0', '5250', '5186', '5188', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000010', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '55', '64', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '1058', '9760', '5250', '6216', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000011', '1', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '7', '6', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '1059', '9248', '1024', '6180', '163840', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000012', '1', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '9345', '9377', '9440', '9285', '9315', '195584', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000013', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '7', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '6145', '5152', '6147', '165888', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000014', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '15', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1089', '2083', '25696', '25665', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000015', '1', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '56', '58', '0', '0', '0', '0', '0', '0', '0', '0', '11296', '11488', '3169', '11458', '15456', '218112', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000016', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '10', '0', '0', '0', '0', '0', '0', '0', '0', '13344', '15395', '15424', '5187', '15427', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000017', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '15', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8192', '10240', '25696', '8192', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000018', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '12', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '1124', '9472', '1024', '6211', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000019', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '11', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8193', '9248', '5122', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000020', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '76', '64', '66', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '2211', '2147', '1024', '2113', '124928', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000021', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '8', '14', '0', '0', '0', '0', '0', '0', '0', '0', '13472', '13505', '3139', '1024', '13475', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000022', '1', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '14', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5379', '5312', '10369', '1024', '5312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000023', '1', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '15', '14', '0', '0', '0', '0', '0', '0', '0', '0', '10279', '16483', '16480', '1024', '10337', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000024', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '7395', '7651', '5408', '5411', '5443', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000025', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000026', '1', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000027', '1', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000028', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000029', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000030', '1', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000031', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000032', '1', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000033', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5186', '5155', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000034', '2', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2337', '2049', '1024', '2240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000035', '2', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1154', '5344', '5348', '1056', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000036', '2', '2', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '12', '0', '0', '0', '0', '0', '0', '0', '0', '9476', '9412', '9440', '9289', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000037', '2', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000038', '2', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000039', '3', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '7203', '7201', '5190', '1024', '5153', '7168', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000040', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '2081', '2050', '1024', '2241', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000041', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '6150', '6211', '6211', '1024', '6209', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000042', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '13', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4195', '2116', '1024', '4163', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000043', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '15', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5123', '2116', '1024', '5123', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000044', '5', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000045', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8355', '8416', '5218', '8356', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000046', '7', '2', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '67', '55', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10304', '10272', '1024', '10304', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000047', '22', '2', '11', '0', '0', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000048', '8', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '0', '331351046', '0', '0', '0', '0', '0', '0', '0', '2084', '4164', '11361', '2050', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000049', '7', '4', '8', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '243270686', '0', '0', '0', '0', '0', '22629', '11364', '5188', '11360', '15424', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000050', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '69', '55', '62', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '1056', '2116', '5121', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000051', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '13', '16', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '1024', '2050', '5121', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000052', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '6', '0', '79692840', '0', '0', '0', '0', '0', '0', '0', '11264', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000053', '1', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '15', '66', '0', '79692840', '0', '0', '0', '0', '0', '0', '4097', '11265', '4097', '11264', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000054', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '16', '13', '0', '79692820', '0', '0', '0', '0', '0', '0', '0', '11264', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000055', '1', '2', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '9', '7', '0', '79692820', '0', '0', '0', '0', '0', '0', '4097', '11265', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000056', '1', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '10', '0', '79692840', '0', '0', '0', '0', '0', '0', '23552', '11265', '4097', '11264', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000057', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '5', '3', '0', '79692810', '0', '0', '0', '0', '0', '0', '13312', '11265', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000058', '1', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '64', '58', '0', '0', '0', '0', '0', '0', '0', '0', '23552', '11265', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000059', '1', '2', '5', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '1', '3', '0', '79692820', '0', '0', '0', '0', '0', '0', '23555', '11296', '4096', '11296', '15392', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000060', '1', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1090', '2116', '5121', '25601', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000061', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11264', '5120', '11264', '15360', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000062', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '4132', '4132', '2116', '5120', '4195', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000063', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '76', '58', '55', '0', '79692810', '0', '0', '0', '0', '0', '0', '0', '11296', '4096', '11296', '15392', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000064', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '13', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000065', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '12', '7', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '2082', '5155', '1024', '5154', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000066', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '11', '8', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '1056', '9216', '10240', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000067', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '66', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '2083', '5121', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000068', '1', '2', '1', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1060', '5155', '1024', '2241', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000069', '1', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '15', '1', '0', '0', '0', '0', '0', '0', '0', '0', '24585', '10400', '10304', '25697', '21636', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000070', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '13', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5282', '5154', '5188', '1024', '5188', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000071', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2338', '2050', '1024', '2240', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000072', '1', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '61', '54', '0', '0', '0', '0', '0', '0', '0', '0', '6336', '4132', '9216', '1024', '6145', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000073', '1', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '1', '7', '0', '0', '0', '0', '0', '0', '0', '0', '22528', '15712', '15904', '1024', '15712', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000074', '1', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '6', '14', '0', '0', '0', '0', '0', '0', '0', '0', '13377', '15712', '15904', '1024', '15712', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000075', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '7', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2275', '2145', '1024', '2176', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000076', '1', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '13', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1091', '2083', '1024', '2241', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000077', '2', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '5', '16', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '7200', '1152', '1024', '4128', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000078', '2', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '11', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4162', '5156', '1024', '1059', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000079', '2', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4226', '5154', '1024', '1059', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000080', '2', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '10', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4164', '5188', '1024', '1059', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000081', '2', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '13', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16416', '10272', '1024', '1059', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000082', '2', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '3', '6', '0', '0', '0', '0', '0', '0', '0', '0', '6145', '1057', '5155', '1024', '1059', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000083', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '1', '6', '0', '0', '0', '0', '0', '0', '0', '0', '16610', '16578', '16578', '1024', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000084', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '2', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '4096', '2048', '1024', '6208', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000085', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '4', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1124', '6209', '6274', '6209', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000086', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '1', '12', '0', '0', '0', '0', '0', '0', '0', '0', '23881', '1121', '6212', '5250', '6244', '166912', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000087', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '6', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '4096', '2048', '1024', '6208', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000088', '21', '2', '1', '0', '0', '1', '0', '0', '0', '0', '3', '4', '3', '2', '1', '14', '15', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1824', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000089', '21', '2', '2', '0', '0', '1', '0', '0', '2', '1', '5', '1', '2', '1', '2', '5', '1', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1761', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000090', '21', '2', '1', '0', '0', '1', '0', '0', '5', '0', '3', '3', '3', '0', '0', '15', '2', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1825', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000091', '21', '2', '2', '0', '0', '1', '0', '0', '0', '1', '4', '0', '0', '2', '2', '26', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3782', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000092', '21', '2', '1', '0', '0', '1', '0', '0', '0', '1', '2', '4', '1', '1', '1', '32', '6', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3779', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000093', '10510', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000094', '10510', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000095', '10703', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000096', '8', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '9', '16', '0', '0', '0', '0', '0', '0', '0', '0', '16421', '16485', '16419', '1024', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000097', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '5', '16', '0', '79692810', '0', '0', '0', '0', '0', '0', '0', '11296', '4096', '11296', '15392', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000098', '7', '4', '8', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '243270686', '0', '0', '0', '0', '0', '0', '24928', '16672', '10403', '3104', '21859', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000099', '10801', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000100', '20001', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000101', '20002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000102', '20003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000103', '20004', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000104', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000105', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000106', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000107', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000108', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000109', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000110', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000111', '11', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000112', '12', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000113', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000114', '21', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '15', '11', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1013760', '1013760', '1013760', '1013760', '1013760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000115', '22', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000116', '6', '1', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '11297', '4131', '11296', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000117', '6', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '55', '62', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '1377', '5154', '1024', '25633', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000118', '3', '3', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '5152', '1024', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000119', '1', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '1', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7204', '5156', '1024', '4132', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000120', '1', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '1058', '6144', '6144', '6144', '338944', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000121', '5', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '5', '7', '0', '0', '0', '0', '0', '0', '0', '0', '4097', '4096', '2049', '1024', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000122', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '10', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4164', '2080', '1024', '4161', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000123', '8', '1', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '13', '1', '0', '0', '0', '0', '0', '0', '0', '0', '5184', '5153', '5282', '25664', '5153', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000124', '5', '1', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '14', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4098', '5185', '1024', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000125', '1', '3', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '4096', '9216', '10304', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000126', '2', '1', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '6304', '1092', '6147', '6144', '6147', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000127', '4', '1', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4130', '2082', '1024', '4097', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000128', '3', '3', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '4161', '4161', '9376', '1024', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000129', '8', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '10', '14', '0', '0', '0', '0', '0', '0', '0', '0', '6146', '4131', '6146', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000130', '1', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5249', '2336', '4163', '1024', '21505', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000131', '2', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1124', '5155', '25600', '5153', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000132', '1', '3', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '58', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6147', '6144', '6145', '6144', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000133', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000134', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000135', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000136', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000137', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000138', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000139', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000140', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000141', '21', '2', '21', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '8', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1013760', '1013760', '1013760', '1013760', '1013760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000142', '1', '3', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '3', '0', '168822784', '0', '0', '0', '0', '0', '0', '13664', '13888', '3072', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000143', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '11', '8', '0', '168823809', '0', '0', '0', '0', '0', '0', '13664', '13888', '3072', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000144', '2', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '9', '15', '0', '80741386', '32509953', '0', '0', '0', '0', '0', '13664', '13888', '3072', '13696', '13568', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000145', '7', '3', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '52', '56', '0', '80741406', '32508939', '0', '0', '0', '0', '0', '14497', '15488', '15360', '8448', '15488', '217088', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000146', '7', '2', '5', '0', '0', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '2', '0', '310379580', '0', '0', '0', '0', '0', '0', '0', '29920', '7297', '13472', '10435', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000147', '8', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '58', '55', '0', '310379570', '0', '0', '0', '0', '0', '0', '0', '29921', '7329', '1024', '10434', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000148', '5', '2', '1', '0', '0', '5', '4', '0', '0', '0', '0', '0', '0', '0', '0', '24', '3', '13', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '10369', '10433', '10403', '10435', '10435', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000149', '2', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '6', '12', '0', '210765827', '236979200', '0', '0', '0', '231736352', '0', '9537', '9536', '9632', '9377', '9409', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000150', '1', '2', '6', '0', '0', '2', '9', '0', '0', '0', '0', '0', '0', '0', '0', '4', '2', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11329', '15360', '11296', '15392', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000151', '3', '2', '8', '0', '0', '6', '9', '0', '0', '0', '0', '0', '0', '0', '0', '58', '59', '59', '0', '0', '0', '0', '0', '0', '0', '0', '23590', '8256', '9408', '5185', '25632', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000152', '2', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '11276', '4164', '2116', '1024', '4194', '174080', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000153', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '1', '1', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '3072', '14624', '10338', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000154', '1', '3', '6', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '7', '5', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '3075', '14624', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000155', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '10', '4', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '3143', '14624', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000156', '3', '2', '6', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '4', '12', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '3106', '14624', '10336', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000157', '8', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '64', '52', '0', '168821761', '0', '0', '0', '0', '0', '0', '19502', '14624', '3143', '14624', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000158', '8', '3', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '13', '15', '0', '168821770', '0', '0', '0', '0', '0', '0', '19501', '14624', '3140', '14624', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000159', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '2', '2', '0', '0', '0', '0', '0', '0', '0', '0', '3780', '3968', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000160', '21', '2', '21', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4001', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000161', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '1', '10', '0', '0', '0', '0', '0', '0', '0', '0', '3778', '3904', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000162', '21', '2', '21', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4032', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000163', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '3779', '3936', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000164', '21', '2', '0', '0', '0', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '4837', '4992', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000165', '10', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '59741184', '60789760', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000166', '1', '3', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '4', '15', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000167', '1', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '64', '62', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000168', '1', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '13', '16', '0', '243270666', '0', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000169', '1', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '9', '6', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000170', '1', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '13', '1', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000171', '1', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '5', '16', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000172', '1', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '73', '57', '57', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000173', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '1', '5', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000174', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '10', '3', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000175', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '4', '3', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000176', '7', '3', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '1', '1', '0', '0', '32509953', '0', '0', '0', '0', '0', '16416', '16416', '10274', '1024', '21568', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000177', '3', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '10', '4', '0', '243270658', '0', '0', '0', '0', '0', '0', '16576', '16544', '10369', '1024', '21642', '196608', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000178', '1', '3', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000179', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000180', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000181', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000182', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000183', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000184', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000185', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000186', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000187', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000188', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '33526784', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000189', '3', '3', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000190', '10704', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000191', '1', '3', '5', '0', '0', '1', '5', '0', '0', '0', '0', '0', '0', '0', '0', '32', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '23590', '1089', '2113', '5188', '25633', '23552', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000192', '1', '2', '2', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '4', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1058', '6147', '5155', '6211', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000193', '1', '1', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '9', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20501', '16452', '5187', '1024', '5152', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000194', '1', '3', '6', '0', '0', '5', '9', '0', '0', '0', '0', '0', '0', '0', '0', '75', '62', '54', '0', '0', '0', '0', '0', '0', '0', '0', '10275', '1056', '10338', '1024', '25601', '123904', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000195', '1', '3', '6', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '3', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6209', '2113', '5155', '6211', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000196', '2', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '10', '7', '0', '0', '0', '0', '0', '0', '0', '0', '6156', '1124', '5155', '1024', '1058', '205824', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000197', '2', '1', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '9', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9602', '1024', '1024', '9280', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000198', '2', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '5185', '2082', '5122', '1024', '5154', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000199', '2', '1', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '10', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5248', '5217', '1024', '4195', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000200', '3', '3', '2', '0', '0', '7', '1', '0', '0', '0', '0', '0', '0', '0', '0', '14', '3', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10306', '5184', '25668', '1060', '10240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000201', '3', '2', '6', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '10', '5', '14', '0', '0', '0', '0', '0', '0', '0', '0', '21507', '2148', '2113', '1024', '2081', '125952', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000202', '3', '2', '2', '0', '0', '4', '5', '0', '0', '0', '0', '0', '0', '0', '0', '16', '4', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4256', '4192', '1024', '4224', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000203', '4', '2', '6', '0', '0', '8', '15', '0', '0', '0', '0', '0', '0', '0', '0', '32', '15', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4291', '1408', '1024', '1056', '197632', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000204', '5', '2', '2', '0', '0', '7', '2', '0', '0', '0', '0', '0', '0', '0', '0', '16', '5', '3', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4130', '2049', '1024', '4164', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000205', '5', '3', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '2', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10304', '2115', '1024', '9248', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000206', '5', '3', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '4', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29728', '7168', '1024', '10272', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000207', '6', '0', '2', '0', '0', '4', '25', '0', '0', '0', '0', '0', '0', '0', '0', '62', '53', '56', '0', '0', '0', '0', '0', '0', '0', '0', '5216', '1378', '10338', '10339', '1058', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000208', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '66', '60', '57', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16451', '5186', '1024', '5186', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000209', '6', '1', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '4', '13', '0', '0', '0', '0', '0', '0', '0', '0', '10289', '10371', '5188', '1024', '21568', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000210', '6', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '5', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20487', '5220', '5192', '1024', '5156', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000211', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '6', '7', '0', '752878603', '0', '0', '0', '0', '0', '0', '0', '2145', '5155', '1024', '5153', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000212', '1', '3', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '6', '6', '0', '862979072', '0', '0', '0', '0', '0', '0', '4097', '6147', '6176', '5122', '6176', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000213', '1', '2', '7', '0', '0', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '11', '15', '4', '0', '0', '0', '0', '0', '0', '0', '0', '6148', '10304', '10338', '1024', '4192', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000214', '1', '1', '5', '0', '0', '2', '9', '0', '0', '0', '0', '3', '1', '0', '0', '32', '12', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1057', '6147', '25601', '1060', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000215', '2', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '14', '2', '0', '79698945', '0', '0', '0', '0', '0', '0', '5185', '1057', '10305', '5218', '1060', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000216', '2', '1', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '15', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6187', '1120', '10307', '1024', '5155', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000217', '2', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '10', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '7240', '1024', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000218', '2', '1', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '8', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10307', '5155', '1024', '9280', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000219', '3', '3', '6', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '55', '51', '0', '0', '0', '0', '0', '0', '0', '0', '21505', '6179', '6179', '25696', '4131', '144384', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000220', '3', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '4', '4', '0', '0', '0', '0', '0', '0', '0', '0', '20485', '5188', '5155', '1024', '5153', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000221', '4', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4226', '5191', '1024', '21634', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000222', '4', '2', '6', '0', '0', '7', '24', '0', '0', '0', '0', '0', '0', '0', '0', '69', '63', '60', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10369', '4168', '1024', '21634', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000223', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '3', '14', '0', '0', '0', '0', '0', '0', '0', '0', '20480', '4256', '5155', '1024', '4194', '164864', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000224', '5', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '56', '53', '0', '0', '0', '0', '0', '0', '0', '0', '6151', '10336', '5191', '1024', '5218', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000225', '5', '2', '1', '0', '0', '3', '3', '0', '0', '0', '0', '0', '0', '0', '0', '17', '9', '7', '0', '0', '0', '0', '0', '0', '0', '0', '4098', '9217', '5120', '1024', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000226', '5', '3', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '5153', '5216', '5152', '1024', '4192', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000227', '5', '3', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '6180', '6180', '1024', '6180', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000228', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000229', '5', '2', '3', '0', '0', '6', '4', '0', '0', '0', '0', '0', '0', '0', '0', '82', '53', '63', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '1091', '2116', '5188', '21568', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000230', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000231', '6', '0', '2', '0', '0', '4', '10', '0', '0', '0', '0', '0', '0', '0', '0', '62', '51', '66', '0', '0', '0', '0', '0', '0', '0', '0', '5248', '4162', '5186', '10337', '9313', '8192', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000232', '6', '2', '4', '0', '0', '4', '2', '0', '0', '0', '0', '0', '0', '0', '0', '82', '62', '61', '0', '0', '0', '0', '0', '0', '0', '0', '20483', '5218', '5154', '1024', '5217', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000233', '7', '2', '9', '0', '0', '8', '5', '0', '0', '0', '0', '0', '0', '0', '0', '8', '2', '9', '0', '80741386', '32507914', '0', '0', '0', '0', '0', '0', '15392', '15360', '11296', '15392', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000234', '8', '2', '8', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '13', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1122', '9632', '1024', '25664', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000235', '9', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '51', '64', '0', '79698954', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000236', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000237', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000238', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000239', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000240', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000241', '2', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000242', '10852', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000243', '10036', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000244', '10854', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000245', '10040', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000246', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000247', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000248', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2112', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000249', '10508', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000250', '10701', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000251', '10704', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000252', '10910', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000253', '1', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '57', '52', '60', '0', '0', '0', '0', '0', '0', '0', '0', '6304', '1058', '6144', '6144', '1024', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000254', '2', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '10', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4162', '4290', '1024', '4098', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000255', '2', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '1', '2', '0', '0', '0', '0', '0', '0', '0', '0', '6146', '4128', '2083', '6145', '6147', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000256', '3', '2', '4', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '27', '7', '16', '0', '0', '0', '0', '0', '0', '0', '0', '6182', '33795', '6145', '1024', '1057', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000257', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '16', '4', '0', '0', '0', '0', '0', '0', '0', '0', '1824', '1824', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000258', '21', '2', '0', '0', '0', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '9', '14', '0', '0', '0', '0', '0', '0', '0', '0', '1825', '1825', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000259', '1', '4', '7', '0', '0', '8', '9', '0', '0', '0', '0', '0', '0', '0', '0', '15', '2', '13', '0', '0', '0', '0', '0', '0', '0', '0', '5184', '2081', '16416', '1024', '5153', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000260', '1', '0', '6', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '3', '4', '12', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1091', '9440', '5155', '9312', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000261', '1', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '3', '16', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '2049', '6147', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000262', '2', '0', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '14', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1123', '2146', '5282', '6213', '6144', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000263', '2', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '14', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4163', '7233', '1024', '1059', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000264', '5', '4', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '15', '10', '0', '0', '0', '0', '0', '0', '0', '0', '4131', '4131', '2147', '1024', '1057', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000265', '5', '0', '4', '0', '0', '7', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '3', '12', '0', '0', '0', '0', '0', '0', '0', '0', '6144', '6145', '2050', '6144', '6144', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000266', '5', '2', '1', '0', '0', '1', '3', '0', '0', '0', '0', '0', '0', '0', '0', '26', '6', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16417', '5155', '1024', '4099', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000267', '6', '0', '3', '0', '0', '8', '23', '0', '0', '0', '0', '0', '0', '0', '0', '62', '64', '52', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9378', '1600', '1024', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000268', '6', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '5', '13', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5219', '16484', '1024', '5219', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000269', '6', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '66', '61', '66', '0', '0', '0', '0', '0', '0', '0', '0', '5250', '10273', '5188', '25600', '25601', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000270', '3', '4', '4', '0', '0', '7', '22', '0', '0', '0', '0', '0', '0', '0', '0', '4', '11', '1', '0', '0', '0', '0', '0', '0', '0', '0', '20484', '10274', '10337', '1024', '8224', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000271', '4', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '68', '63', '58', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9377', '1088', '1024', '1057', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000272', '8', '4', '7', '0', '0', '4', '15', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4225', '7300', '1024', '1059', '194560', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000273', '7', '2', '7', '0', '0', '2', '5', '0', '0', '0', '0', '0', '0', '0', '0', '74', '56', '57', '0', '0', '0', '0', '0', '0', '0', '0', '21504', '1124', '2147', '5220', '2244', '143360', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000274', '10056', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000275', '10710', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000276', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1028', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000277', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000278', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000279', '10904', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000280', '1', '2', '2', '0', '0', '7', '9', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000281', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000282', '1', '2', '1', '0', '3', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000283', '2', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000284', '2', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000285', '2', '2', '9', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000286', '3', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000287', '3', '2', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000288', '3', '2', '1', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000289', '4', '2', '7', '0', '1', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000290', '4', '2', '7', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000291', '4', '2', '7', '0', '1', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000292', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000293', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000294', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000295', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000296', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000297', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000298', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000299', '7', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000300', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000301', '8', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000302', '8', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000303', '8', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000304', '9', '2', '1', '0', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '16672', '7424', '8544', '3105', '3105', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000305', '9', '2', '1', '0', '3', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '168823811', '0', '0', '0', '0', '0', '0', '12768', '14656', '3147', '14594', '13635', '246784', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000306', '9', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '10', '10', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '0', '11587', '8992', '8288', '8481', '216064', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000307', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000308', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000309', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000310', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000311', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000312', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000313', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000314', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000315', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000316', '20003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000317', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80', '61', '59', '0', '79697950', '32510976', '0', '0', '0', '0', '0', '13505', '11588', '15488', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000318', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '54', '58', '0', '294652948', '0', '0', '0', '0', '0', '0', '13505', '10305', '10304', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000319', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '73', '58', '55', '0', '80741406', '32510976', '0', '0', '0', '0', '0', '13505', '11588', '15488', '5217', '10304', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000320', '7', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '6', '10', '0', '148898866', '0', '0', '0', '0', '0', '0', '14370', '11586', '10304', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000321', '8', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '14', '6', '0', '147852308', '0', '0', '0', '0', '0', '0', '14370', '11586', '10304', '1024', '13344', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000322', '1', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '13', '2', '0', '170918942', '0', '0', '0', '0', '0', '0', '4163', '11584', '9472', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000323', '2', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '10', '16', '0', '210765837', '236979210', '0', '0', '0', '231736332', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000324', '3', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '9', '10', '0', '210765837', '236979210', '0', '0', '0', '231736332', '0', '4163', '9347', '9440', '9283', '9316', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000325', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '20', '14', '8', '0', '347079687', '0', '0', '0', '0', '0', '0', '0', '29766', '1024', '1024', '10371', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000326', '10911', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79698947', '32510983', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000327', '7', '4', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '10', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000328', '3', '4', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '5', '14', '0', '58723348', '59771924', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000329', '1', '3', '4', '0', '0', '1', '0', '0', '1', '1', '0', '0', '1', '2', '2', '26', '14', '3', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000330', '3', '3', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '12', '1', '0', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000331', '7', '3', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '11', '11', '0', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000332', '3', '3', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '15', '6', '0', '147850300', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000333', '7', '4', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '6', '16', '0', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000334', '3', '4', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '5', '9', '0', '168825858', '0', '0', '0', '0', '0', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000335', '1', '3', '6', '0', '0', '2', '0', '0', '0', '0', '3', '1', '2', '1', '1', '13', '3', '2', '128', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000336', '3', '3', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '12', '2', '0', '210765844', '236979210', '0', '0', '0', '231736332', '0', '13664', '13888', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000337', '1', '3', '7', '0', '0', '1', '0', '0', '2', '0', '3', '1', '2', '3', '3', '14', '5', '10', '128', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000338', '3', '3', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '5', '10', '0', '347079691', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000339', '1', '3', '2', '0', '0', '1', '0', '0', '1', '0', '4', '0', '0', '0', '0', '15', '4', '9', '128', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000340', '3', '3', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '2', '13', '0', '310379580', '0', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '10624', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000341', '10023', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000342', '7', '1', '1', '0', '0', '8', '6', '0', '0', '0', '0', '0', '0', '0', '0', '11', '11', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '2113', '1024', '2083', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000343', '2', '1', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '5', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1057', '15680', '1024', '15460', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000344', '1', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '1', '10', '0', '79693826', '32510977', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000345', '3', '1', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32', '2', '16', '0', '79693826', '32510977', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000346', '2', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '15', '16', '0', '79693826', '32510977', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000347', '8', '3', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '7', '13', '0', '147852298', '0', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000348', '1', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '16', '12', '0', '147852298', '0', '0', '0', '0', '0', '0', '23908', '10337', '39424', '5280', '21633', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000349', '1', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '13', '11', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000350', '7', '2', '3', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '5', '11', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000351', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '5', '9', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000352', '7', '2', '2', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '10', '9', '0', '147851286', '0', '0', '0', '0', '0', '0', '14592', '10497', '10403', '5409', '21859', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000353', '10525', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000354', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '7', '12', '0', '79695872', '32509962', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000355', '9', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '8', '1', '5', '0', '294651944', '0', '0', '0', '0', '0', '0', '0', '7297', '7238', '5217', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000356', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '18', '14', '10', '0', '79692820', '32507914', '0', '0', '0', '0', '0', '13377', '10242', '10272', '5122', '10240', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000357', '7', '2', '5', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '1', '11', '0', '147850280', '0', '0', '0', '0', '0', '0', '14368', '16416', '10274', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000358', '8', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '6', '7', '0', '147854356', '0', '0', '0', '0', '0', '0', '14368', '16416', '10274', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000359', '3', '2', '6', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '11', '14', '0', '168823828', '0', '0', '0', '0', '0', '0', '4131', '14497', '3138', '46081', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000360', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '28', '3', '6', '0', '210766878', '236979210', '0', '0', '0', '231736332', '0', '4131', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000361', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '3', '12', '0', '210764840', '236979210', '0', '0', '0', '231736332', '0', '4131', '9314', '9216', '9251', '9216', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000362', '1', '2', '5', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '15', '3', '0', '331351048', '0', '0', '0', '0', '0', '0', '0', '29766', '7298', '1024', '10371', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000363', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000364', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000365', '10702', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5184', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000366', '1', '2', '7', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3', '2', '6', '0', '243270656', '0', '0', '0', '0', '0', '0', '14368', '16416', '10274', '1024', '13314', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000367', '1', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '21', '6', '5', '0', '79693844', '0', '0', '0', '0', '0', '0', '0', '939008', '16644', '5347', '8576', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000368', '2', '2', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '25', '2', '10', '0', '58723339', '59771915', '0', '0', '0', '0', '0', '940032', '10532', '1664', '10528', '3234', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000369', '5', '3', '1', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '10', '13', '9', '0', '310379590', '0', '0', '0', '0', '0', '0', '20507', '941056', '16641', '3265', '9504', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000370', '8', '2', '4', '0', '0', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '11', '9', '0', '331351046', '0', '0', '0', '0', '0', '0', '0', '937984', '5347', '1024', '5443', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000371', '10917', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '169870336', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6000372', '21', '2', '31', '0', '0', '31', '0', '0', '1', '1', '0', '4', '2', '0', '0', '13', '18', '22', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7072', '1024', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500001', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '3072', '3072', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500002', '1', '4', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '273679360', '0', '0', '0', '0', '0', '0', '0', '3072', '3072', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500003', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500004', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500005', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500006', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500007', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500008', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500009', '10901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500010', '10703', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500011', '10703', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500012', '10703', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500013', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500014', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500015', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500016', '10502', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2080', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500017', '10505', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500018', '10041', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500019', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500020', '999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500021', '10998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500022', '10998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500023', '10512', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500024', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500025', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500026', '10017', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500027', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500028', '10017', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500029', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500030', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500031', '10037', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500032', '10054', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500033', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500034', '10034', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500035', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500036', '10505', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500037', '10031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500038', '10029', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1152', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500039', '10005', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500040', '10507', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500041', '1', '2', '1', '0', '0', '2', '0', '0', '2', '0', '1', '0', '2', '1', '1', '29', '12', '16', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500042', '1', '2', '8', '0', '0', '7', '0', '0', '0', '0', '2', '2', '0', '3', '2', '16', '9', '15', '128', '79694869', '32512010', '0', '0', '0', '0', '0', '13664', '35360', '7424', '13696', '13568', '245760', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500043', '10045', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500044', '10515', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500045', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '331351048', '0', '0', '0', '0', '0', '0', '1120', '1120', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500046', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '147850280', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500047', '10904', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '294652928', '0', '0', '0', '0', '0', '0', '1088', '1088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6500048', '10904', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79693874', '0', '0', '0', '0', '0', '0', '1024', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800001', '40232', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800002', '40141', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800003', '40838', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800004', '20998', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800005', '40386', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800006', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2051', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800007', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1056', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800008', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26624', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800009', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27648', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800010', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800011', '40901', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800012', '40076', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1020928', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800013', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3082', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800014', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1036', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800015', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800016', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1035', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800017', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1064', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800018', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800019', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2049', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800020', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1035', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800021', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3122', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800022', '40221', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1055', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800023', '40076', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2068', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800024', '40161', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1054', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800025', '40161', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1034', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800026', '40331', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3102', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800027', '40076', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1064', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800028', '40076', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4096', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800029', '40031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4106', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800030', '40141', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1064', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800031', '40161', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3092', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800032', '40201', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3102', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800033', '40331', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2088', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800034', '40077', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '80741406', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6800035', '40031', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '32508958', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900001', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '25', '19', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900002', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '31', '20', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900003', '1', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '40', '35', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900004', '1', '2', '4', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '79', '3', '64', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900005', '1', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '37', '31', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900006', '1', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '32', '29', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900007', '1', '2', '7', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '2', '30', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900008', '1', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '99', '30', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900009', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '49', '33', '19', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900010', '2', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '25', '20', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900011', '2', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '31', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900012', '2', '2', '4', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '36', '34', '64', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900013', '2', '2', '5', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '26', '25', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900014', '2', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '29', '29', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900015', '2', '2', '7', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '27', '25', '30', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900016', '2', '2', '8', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '33', '31', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900017', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900018', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '45', '21', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900019', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '24', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900020', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '17', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900021', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '10', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900022', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '61', '21', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900023', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '11', '13', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900024', '9', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '23', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900025', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '14', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900026', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '35', '20', '92', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900027', '3', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '10', '74', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900028', '3', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '36', '19', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900029', '3', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '42', '22', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900030', '3', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '19', '47', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900031', '3', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '40', '22', '73', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900032', '3', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '15', '11', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900033', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '29', '22', '10', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900034', '4', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '44', '24', '92', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900035', '4', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '18', '74', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900036', '4', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '37', '23', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900037', '4', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '14', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900038', '4', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '39', '21', '47', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900039', '4', '2', '3', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '45', '12', '73', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900040', '4', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '19', '55', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900041', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '72', '52', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900042', '3', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '92', '63', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900043', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '55', '51', '24', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900044', '3', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '77', '63', '25', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900045', '3', '2', '5', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '54', '50', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900046', '3', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '94', '62', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900047', '3', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '52', '66', '86', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900048', '3', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '93', '51', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900049', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '53', '66', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900050', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '51', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900051', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '59', '63', '24', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900052', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '96', '52', '25', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900053', '4', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '63', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900054', '4', '2', '6', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '88', '49', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900055', '4', '2', '7', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '51', '66', '86', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900056', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '88', '68', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900057', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '39', '33', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900058', '5', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '46', '38', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900059', '5', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '34', '33', '44', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900060', '5', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '44', '48', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900061', '5', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '74', '31', '34', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900062', '5', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '38', '36', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900063', '5', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '46', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900064', '5', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '40', '33', '44', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900065', '6', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '36', '29', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900066', '6', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '43', '38', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900067', '6', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '33', '46', '44', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900068', '6', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '73', '30', '48', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900069', '6', '2', '4', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '58', '47', '34', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900070', '6', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '32', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900071', '6', '2', '2', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '49', '48', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900072', '6', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '36', '34', '44', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900073', '5', '2', '1', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '18', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900074', '5', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '6', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900075', '5', '2', '3', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '19', '21', '18', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900076', '5', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '10', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900077', '5', '2', '4', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '17', '21', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900078', '5', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '22', '6', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900079', '5', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '4', '22', '86', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900080', '5', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '90', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900081', '6', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '9', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900082', '6', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '90', '23', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900083', '6', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '6', '7', '18', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900084', '6', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '16', '24', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900085', '6', '2', '4', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '7', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900086', '6', '2', '3', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '89', '10', '15', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900087', '6', '2', '2', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '19', '86', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900088', '6', '2', '1', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '24', '7', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900089', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '12', '37', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900090', '8', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '87', '41', '21', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900091', '8', '2', '3', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '92', '29', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900092', '8', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '43', '20', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900093', '8', '2', '5', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '33', '25', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900094', '8', '2', '6', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '9', '37', '33', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900095', '8', '2', '7', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '92', '32', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900096', '8', '2', '8', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '5', '42', '27', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900097', '8', '2', '1', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '56', '89', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900098', '8', '2', '2', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '72', '95', '65', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900099', '8', '2', '3', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '76', '82', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900100', '8', '2', '4', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '45', '93', '70', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900101', '8', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '92', '42', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900102', '8', '2', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '99', '83', '68', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900103', '8', '2', '7', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '45', '94', '79', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900104', '8', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '63', '85', '41', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900105', '7', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '30', '10', '34', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900106', '7', '2', '2', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '60', '3', '46', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900107', '7', '2', '3', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '11', '37', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900108', '7', '2', '4', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '62', '4', '32', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900109', '7', '2', '5', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '16', '44', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900110', '7', '2', '6', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '47', '1', '48', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900111', '7', '2', '7', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '96', '14', '35', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900112', '7', '2', '8', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '23', '7', '49', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900113', '7', '2', '1', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '78', '32', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900114', '7', '2', '2', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '14', '41', '17', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900115', '7', '2', '3', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '27', '84', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900116', '7', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '87', '38', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900117', '7', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '13', '28', '82', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900118', '7', '2', '6', '0', '0', '6', '0', '0', '0', '0', '0', '0', '0', '0', '0', '75', '42', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900119', '7', '2', '7', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '93', '25', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('6900120', '7', '2', '8', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '7', '38', '82', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9000001', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9000002', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9020001', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9020002', '10008', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9020003', '10037', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111101', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111102', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111103', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111104', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111201', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111202', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111204', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111206', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111207', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111208', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111209', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111210', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111211', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111212', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111213', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111214', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111215', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111216', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111217', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111218', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111219', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111220', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111221', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111222', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111223', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111224', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111225', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111226', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111227', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111228', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111229', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111230', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111231', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111232', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111233', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111234', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111235', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111236', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111237', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111238', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111239', '10003', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111240', '10028', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111241', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111242', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111243', '10008', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111244', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111245', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111246', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111247', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111248', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111249', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111250', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111251', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111252', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111253', '10510', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111254', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111255', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111256', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111257', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111258', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111259', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111260', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111261', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111262', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111263', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111264', '10037', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111265', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111270', '10502', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111271', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111272', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111275', '10502', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111276', '10502', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111280', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '3072', '3072', '1024', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111301', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79698944', '32509952', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111303', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9111304', '20923', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9112103', '10002', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9113102', '20958', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9113202', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9113203', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9113204', '7', '4', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '148870144', '0', '0', '0', '0', '0', '0', '0', '15360', '1024', '14336', '1024', '4096', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114401', '1', '3', '2', '0', '0', '7', '0', '0', '0', '0', '0', '0', '0', '0', '0', '31', '11', '4', '0', '168821780', '0', '0', '0', '0', '0', '0', '20483', '10434', '5347', '1024', '5218', '9216', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114402', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114403', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114404', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79698944', '79698944', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114405', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '32509952', '32509952', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114406', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '32509952', '32509952', '0', '0', '0', '0', '0', '0', '2048', '0', '0', '0', '0', '7168', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114407', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114408', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114409', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114410', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114411', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114412', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114413', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '32509952', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114414', '4', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114415', '7', '2', '8', '0', '0', '8', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114416', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114417', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114418', '6', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114419', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '3072', '3072', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114420', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '273679360', '0', '0', '0', '0', '0', '0', '0', '3072', '3072', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114421', '6', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114422', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '79694848', '0', '0', '0', '0', '0', '0', '0', '1024', '1024', '1024', '1024', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114423', '5', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114424', '3', '2', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114425', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114426', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '3072', '2048', '1024', '3072', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114427', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114428', '10999', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114429', '20902', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114430', '2', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114431', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114432', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '58724352', '59772928', '0', '0', '0', '0', '0', '3072', '3072', '1024', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114433', '8', '2', '1', '0', '0', '3', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114434', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '168825856', '0', '0', '0', '0', '0', '0', '0', '2048', '1024', '3072', '3072', '3072', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114435', '6', '1', '4', '0', '0', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114436', '8', '1', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114437', '1', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114438', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114439', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114440', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114441', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114442', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114443', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114444', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114445', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114446', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114447', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114448', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114449', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114450', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114451', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114452', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114453', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114454', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114455', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114456', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114457', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114458', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114459', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114460', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114461', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114462', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114463', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114464', '1', '2', '2', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114465', '2', '2', '4', '0', '0', '3', '0', '0', '5', '1', '3', '1', '1', '0', '2', '26', '12', '14', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1156', '4356', '10528', '5441', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9114466', '7', '4', '8', '0', '0', '32', '5', '0', '0', '0', '0', '0', '0', '0', '0', '20', '6', '12', '0', '147850241', '0', '0', '0', '0', '0', '0', '24583', '1121', '10304', '25697', '25664', '204800', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115401', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115402', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115403', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115404', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115405', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115406', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115407', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115408', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115409', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115410', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115411', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115412', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115413', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115414', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115415', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115416', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115417', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115418', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115419', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115420', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115421', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115422', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9115423', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9116400', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9116401', '0', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117001', '8', '2', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2048', '2048', '2048', '2048', '2048', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117101', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117102', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117103', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117104', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117105', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117106', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117107', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117108', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117109', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117110', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117111', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117112', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117113', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9117114', '1', '2', '5', '0', '0', '5', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '6144', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220101', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220102', '10502', '4', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220103', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220104', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220105', '8', '0', '7', '0', '0', '2', '0', '0', '2', '0', '0', '1', '0', '3', '0', '21', '6', '14', '0', '79697980', '32514078', '0', '0', '0', '0', '0', '10400', '15554', '4098', '8385', '15555', '206848', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220201', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220202', '10032', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220203', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220204', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220205', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220206', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220207', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220208', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220209', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220210', '10002', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220301', '10502', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1024', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220401', '20923', '2', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '1', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '3072', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220402', '1', '2', '1', '0', '0', '8', '0', '0', '4', '1', '2', '3', '0', '1', '1', '2', '2', '8', '0', '79693835', '32510977', '0', '0', '0', '0', '0', '14369', '11360', '8224', '11426', '15427', '138240', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220403', '2', '1', '8', '0', '0', '2', '0', '0', '5', '1', '5', '2', '2', '2', '1', '15', '9', '2', '0', '210765827', '236979210', '0', '0', '0', '231736331', '0', '9474', '9472', '9664', '9539', '9538', '147456', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220404', '4', '3', '7', '0', '0', '8', '0', '0', '4', '1', '1', '5', '1', '2', '1', '15', '8', '12', '0', '147850240', '0', '0', '0', '0', '0', '0', '0', '1376', '1152', '1024', '25600', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220405', '7', '2', '4', '0', '0', '1', '0', '0', '5', '1', '0', '1', '2', '3', '2', '21', '10', '11', '0', '58724372', '59772948', '0', '0', '0', '0', '0', '23883', '8352', '10337', '10336', '10336', '184320', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220406', '8', '1', '3', '0', '0', '7', '0', '0', '0', '1', '1', '0', '0', '0', '0', '55', '55', '53', '0', '168821790', '0', '0', '0', '0', '0', '0', '5380', '14624', '3106', '14624', '10304', '248832', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220407', '6', '1', '4', '0', '0', '4', '0', '0', '3', '0', '3', '2', '1', '3', '1', '70', '61', '53', '0', '310379590', '0', '0', '0', '0', '0', '0', '20507', '5379', '16641', '3265', '9504', '168960', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_appearance` VALUES ('9220408', '5', '2', '3', '0', '0', '5', '0', '0', '2', '1', '3', '2', '0', '2', '3', '3', '4', '6', '0', '347079684', '0', '0', '0', '0', '0', '0', '7266', '4290', '2114', '1024', '4321', '177152', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_actor_class` VALUES ('0', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000001', 'test1', '244', '0', '156', '0', '162', '1.55', '0', '0', '1900006', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000002', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000003', null, '0', '0', null, null, null, null, '0', '0', '1600217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000004', null, '0', '0', null, null, null, null, '0', '0', '1500015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000005', null, '0', '0', null, null, null, null, '0', '0', '1600150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000006', null, '0', '0', null, null, null, null, '0', '0', '1000053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000007', null, '0', '0', null, null, null, null, '0', '0', '1000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000008', null, '0', '0', null, null, null, null, '0', '1000', '1200028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000009', 'pplStd_fst0Btl03_01@0A600', '166', '0', '353.37', '3.88', '-698.98', '-2.6', '0', '1007', '2300120', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}\r\n');
INSERT INTO `gamedata_actor_class` VALUES ('1000010', 'pplStd_fst0Btl03_02@0A600', '166', '0', '353.37', '3.75', '-703.09', '-2.6', '0', '1000', '1400004', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000011', null, '0', '0', null, null, null, null, '0', '0', '2000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000012', null, '0', '0', null, null, null, null, '0', '0', '1000021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000013', null, '0', '0', null, null, null, null, '0', '0', '1000297', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000014', null, '0', '0', null, null, null, null, '0', '0', '1100019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000015', null, '0', '0', null, null, null, null, '0', '0', '1900026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000016', null, '0', '0', null, null, null, null, '0', '0', '1900030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000017', null, '0', '0', null, null, null, null, '0', '0', '1000006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000018', null, '0', '0', null, null, null, null, '0', '0', '1000013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000019', null, '0', '0', null, null, null, null, '0', '0', '1600233', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000020', null, '0', '0', null, null, null, null, '0', '0', '1000016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000021', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000022', null, '0', '0', null, null, null, null, '0', '0', '1600213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000023', null, '0', '0', null, null, null, null, '0', '0', '1200013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000024', null, '0', '0', null, null, null, null, '0', '0', '1200014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000025', null, '0', '0', null, null, null, null, '0', '0', '1100008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000026', null, '0', '0', null, null, null, null, '0', '0', '1400002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000027', null, '0', '0', null, null, null, null, '0', '0', '1600091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000028', null, '0', '0', null, null, null, null, '0', '0', '1100010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000029', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000030', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000031', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000032', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000033', null, '0', '0', null, null, null, null, '0', '0', '2000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000034', null, '0', '0', null, null, null, null, '0', '0', '1100004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000035', null, '0', '0', null, null, null, null, '0', '0', '1100002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000036', null, '0', '0', null, null, null, null, '0', '0', '1500004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000037', null, '0', '0', null, null, null, null, '0', '0', '1200024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000038', null, '0', '0', null, null, null, null, '0', '0', '1900054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000039', null, '0', '0', null, null, null, null, '0', '0', '1600089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000040', null, '0', '0', null, null, null, null, '0', '0', '1400080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000041', null, '0', '0', null, null, null, null, '0', '0', '1400081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000042', 'pplStd_wil0Btl01_0a@0B800', '184', '0', '11.45', '196.05', '128.44', '-0.52', '0', '0', '1100003', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000043', null, '0', '0', null, null, null, null, '0', '0', '1200025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000044', null, '0', '0', null, null, null, null, '0', '0', '1200009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000045', null, '0', '0', null, null, null, null, '0', '0', '1900051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000046', null, '0', '0', null, null, null, null, '0', '0', '1500072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000047', null, '0', '0', null, null, null, null, '0', '0', '1500034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000048', null, '0', '0', null, null, null, null, '0', '0', '1600099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000049', null, '0', '0', null, null, null, null, '0', '0', '1300046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000050', null, '0', '0', null, null, null, null, '0', '0', '1200075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000051', null, '0', '0', null, null, null, null, '0', '0', '1000366', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000052', null, '0', '0', null, null, null, null, '0', '0', '1200061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000053', null, '0', '0', null, null, null, null, '0', '0', '1900022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000054', null, '0', '0', null, null, null, null, '0', '0', '1600191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000055', null, '0', '0', null, null, null, null, '0', '0', '1600117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000056', 'pplStd_11@08500', '133', '0', '-452.41', '39.52', '202.89', '2.03', '0', '1025', '1300005', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000057', null, '0', '0', null, null, null, null, '0', '0', '1900027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000058', null, '0', '0', null, null, null, null, '0', '0', '4000111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000059', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000060', null, '0', '0', null, null, null, null, '0', '0', '1600141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000061', null, '0', '0', null, null, null, null, '0', '0', '1900019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000062', null, '0', '0', null, null, null, null, '0', '0', '1200010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000063', null, '0', '0', null, null, null, null, '0', '0', '2200116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000064', null, '0', '0', null, null, null, null, '0', '0', '1600002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000065', null, '0', '0', null, null, null, null, '0', '0', '1300040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000066', null, '0', '0', null, null, null, null, '0', '0', '1300025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000067', null, '0', '0', null, null, null, null, '0', '0', '1500062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000068', null, '0', '0', null, null, null, null, '0', '0', '1000152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000069', null, '0', '0', null, null, null, null, '0', '0', '1100350', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000070', null, '0', '0', null, null, null, null, '0', '0', '1400066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000071', null, '0', '0', null, null, null, null, '0', '0', '1200035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000072', null, '0', '0', null, null, null, null, '0', '0', '1300052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000073', null, '0', '0', null, null, null, null, '0', '0', '1000075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000074', null, '0', '0', null, null, null, null, '0', '0', '1100155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000075', null, '0', '0', null, null, null, null, '0', '0', '4000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000076', null, '0', '0', null, null, null, null, '0', '0', '4000006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000077', null, '0', '0', null, null, null, null, '0', '0', '4000007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000078', 'pplLinkshel_01@08500', '133', '0', '-439.55', '40', '182.26', '-0.31', '0', '0', '1900036', null, 'PopulaceLinkshellManager', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000079', null, '0', '0', null, null, null, null, '0', '0', '4000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000080', null, '0', '0', null, null, null, null, '0', '0', '4000011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000081', null, '0', '0', null, null, null, null, '0', '0', '4000012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000082', null, '0', '0', null, null, null, null, '0', '0', '4000013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000083', null, '0', '0', null, null, null, null, '0', '0', '4000014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000084', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000085', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000086', null, '0', '0', null, null, null, null, '0', '0', '4000015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000087', null, '0', '0', null, null, null, null, '0', '0', '4000113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000088', null, '0', '0', null, null, null, null, '0', '0', '4000114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000089', null, '0', '0', null, null, null, null, '0', '0', '4000115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000090', null, '0', '0', null, null, null, null, '0', '0', '1000179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000091', null, '0', '0', null, null, null, null, '0', '0', '4000016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000092', null, '0', '0', null, null, null, null, '0', '0', '4000017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000093', null, '0', '0', null, null, null, null, '0', '0', '4000018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000094', null, '0', '0', null, null, null, null, '0', '0', '4000019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000095', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000096', null, '0', '0', null, null, null, null, '0', '0', '4000020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000097', null, '0', '0', null, null, null, null, '0', '0', '4000021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000098', null, '0', '0', null, null, null, null, '0', '0', '4000008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000099', null, '0', '0', null, null, null, null, '0', '0', '4000009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000100', null, '0', '0', null, null, null, null, '0', '0', '4000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000101', null, '0', '0', null, null, null, null, '0', '0', '4000023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000102', null, '0', '0', null, null, null, null, '0', '0', '4000022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000103', null, '0', '0', null, null, null, null, '0', '0', '4000024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000104', null, '0', '0', null, null, null, null, '0', '0', '4000025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000105', null, '0', '0', null, null, null, null, '0', '0', '4000026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000106', null, '0', '0', null, null, null, null, '0', '0', '4000027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000107', null, '0', '0', null, null, null, null, '0', '0', '4000028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000108', null, '0', '0', null, null, null, null, '0', '0', '4000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000109', null, '0', '0', null, null, null, null, '0', '0', '4000030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000110', null, '0', '0', null, null, null, null, '0', '0', '4000031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000111', null, '0', '0', null, null, null, null, '0', '0', '4000035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000112', null, '0', '0', null, null, null, null, '0', '0', '4000032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000113', null, '0', '0', null, null, null, null, '0', '0', '4000033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000114', null, '0', '0', null, null, null, null, '0', '0', '4000034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000115', null, '0', '0', null, null, null, null, '0', '0', '4000038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000116', null, '0', '0', null, null, null, null, '0', '0', '4000039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000117', null, '0', '0', null, null, null, null, '0', '0', '4000040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000118', null, '0', '0', null, null, null, null, '0', '0', '4000041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000119', null, '0', '0', null, null, null, null, '0', '0', '4000042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000120', null, '0', '0', null, null, null, null, '0', '0', '4000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000121', null, '0', '0', null, null, null, null, '0', '0', '4000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000122', null, '0', '0', null, null, null, null, '0', '0', '1900035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000123', null, '0', '0', null, null, null, null, '0', '0', '4000043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000124', null, '0', '0', null, null, null, null, '0', '0', '4000044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000125', null, '0', '0', null, null, null, null, '0', '0', '1200039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000126', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000127', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000128', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000129', null, '0', '0', null, null, null, null, '0', '0', '1400053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000130', null, '0', '0', null, null, null, null, '0', '0', '1600120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000131', null, '0', '0', null, null, null, null, '0', '0', '1900079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000132', null, '0', '0', null, null, null, null, '0', '0', '1100076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000133', null, '0', '0', null, null, null, null, '0', '0', '1200097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000134', null, '0', '0', null, null, null, null, '0', '0', '1200084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000135', null, '0', '0', null, null, null, null, '0', '0', '1100138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000136', null, '0', '0', null, null, null, null, '0', '0', '1400059', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000137', 'pplStd_12@08500', '133', '0', '-428.06', '40.2', '185.96', '-1.37', '0', '1060', '1000015', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000138', null, '0', '0', null, null, null, null, '0', '0', '1000066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000139', null, '0', '0', null, null, null, null, '0', '0', '1600107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000140', null, '0', '0', null, null, null, null, '0', '0', '1000023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000141', null, '0', '0', null, null, null, null, '0', '0', '1000023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000142', null, '0', '0', null, null, null, null, '0', '0', '1600112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000143', null, '0', '0', null, null, null, null, '0', '0', '1600081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000144', null, '0', '0', null, null, null, null, '0', '0', '2200064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000145', null, '0', '0', null, null, null, null, '0', '0', '1900029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000146', null, '0', '0', null, null, null, null, '0', '0', '1900029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000147', null, '0', '0', null, null, null, null, '0', '0', '1200108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000148', null, '0', '0', null, null, null, null, '0', '0', '1100212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000149', null, '0', '0', null, null, null, null, '0', '0', '1900047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000150', null, '0', '0', null, null, null, null, '0', '0', '1900003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000151', null, '0', '0', null, null, null, null, '0', '0', '1000017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000152', null, '0', '0', null, null, null, null, '0', '0', '1200100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000153', null, '0', '0', null, null, null, null, '0', '0', '1900011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000154', null, '0', '0', null, null, null, null, '0', '0', '1400010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000155', null, '0', '0', null, null, null, null, '0', '0', '1500024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000156', null, '0', '0', null, null, null, null, '0', '0', '1500024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000157', null, '0', '0', null, null, null, null, '0', '0', '1900050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000158', null, '0', '0', null, null, null, null, '0', '0', '1300054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000159', null, '0', '0', null, null, null, null, '0', '0', '1100144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000160', null, '0', '0', null, null, null, null, '0', '0', '1600092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000161', null, '0', '0', null, null, null, null, '0', '0', '1400033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000162', null, '0', '0', null, null, null, null, '0', '0', '1900069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000163', 'pplShopSal_07@08500', '133', '0', '-482.91', '41.53', '438.15', '2.36', '0', '1016', '1200058', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000164', null, '0', '0', null, null, null, null, '0', '0', '1200045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000165', 'pplShopSal_08@08500', '133', '0', '-616.7', '4.55', '342.49', '-0.28', '0', '1017', '1300050', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000166', null, '0', '0', null, null, null, null, '0', '0', '1300068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000167', null, '0', '0', null, null, null, null, '0', '0', '1600123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000168', null, '0', '0', null, null, null, null, '0', '0', '1100450', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000169', null, '0', '0', null, null, null, null, '0', '0', '1100408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000170', null, '0', '0', null, null, null, null, '0', '0', '1900042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000171', null, '0', '0', null, null, null, null, '0', '0', '1400044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000172', null, '0', '0', null, null, null, null, '0', '0', '1200054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000173', null, '0', '0', null, null, null, null, '0', '0', '1100206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000174', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000175', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000176', null, '0', '0', null, null, null, null, '0', '0', '1400012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000177', null, '0', '0', null, null, null, null, '0', '0', '1600195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000178', null, '0', '0', null, null, null, null, '0', '0', '1500031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000179', null, '0', '0', null, null, null, null, '0', '0', '1900065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000180', null, '0', '0', null, null, null, null, '0', '0', '1300026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000181', null, '0', '0', null, null, null, null, '0', '0', '1200092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000182', null, '0', '0', null, null, null, null, '0', '0', '4000117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000183', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000184', null, '0', '0', null, null, null, null, '0', '0', '4000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000185', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000186', 'pplStd_wil0Btl01_09@0B800', '184', '0', '10.29', '196', '134.96', '2.45', '0', '0', '1000347', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000187', null, '0', '0', null, null, null, null, '0', '0', '1900039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000188', null, '0', '0', null, null, null, null, '0', '0', '1300016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000189', null, '0', '0', null, null, null, null, '0', '0', '1100015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000190', null, '0', '0', null, null, null, null, '0', '0', '1000045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000191', null, '0', '0', null, null, null, null, '0', '0', '1300067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000192', null, '0', '0', null, null, null, null, '0', '0', '1900077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000193', null, '0', '0', null, null, null, null, '0', '0', '1600056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000194', null, '0', '0', null, null, null, null, '0', '0', '1100099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000195', null, '0', '0', null, null, null, null, '0', '0', '1600064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000196', null, '0', '0', null, null, null, null, '0', '0', '1400055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000197', null, '0', '0', null, null, null, null, '0', '0', '1000143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000198', null, '0', '0', null, null, null, null, '0', '0', '1600199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000199', null, '0', '0', null, null, null, null, '0', '0', '1000069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000200', null, '0', '0', null, null, null, null, '0', '0', '1600211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000201', null, '0', '0', null, null, null, null, '0', '0', '1400074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000202', null, '0', '0', null, null, null, null, '0', '0', '1900072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000203', null, '0', '0', null, null, null, null, '0', '0', '1600045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000204', null, '0', '0', null, null, null, null, '0', '0', '2200192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000205', null, '0', '0', null, null, null, null, '0', '0', '1000395', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000206', null, '0', '0', null, null, null, null, '0', '0', '1300029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000207', null, '0', '0', null, null, null, null, '0', '0', '1000156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000208', null, '0', '0', null, null, null, null, '0', '0', '1400015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000209', null, '0', '0', null, null, null, null, '0', '0', '1400015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000210', null, '0', '0', null, null, null, null, '0', '0', '1200003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000211', null, '0', '0', null, null, null, null, '0', '0', '1900016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000212', null, '0', '0', null, null, null, null, '0', '0', '1000012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000213', null, '0', '0', null, null, null, null, '0', '0', '1100012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000214', null, '0', '0', null, null, null, null, '0', '0', '1300021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000215', null, '0', '0', null, null, null, null, '0', '0', '1600096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000216', null, '0', '0', null, null, null, null, '0', '0', '1900035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000217', null, '0', '0', null, null, null, null, '0', '0', '2470001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000218', null, '0', '0', null, null, null, null, '0', '0', '2470003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000219', null, '0', '0', null, null, null, null, '0', '0', '2470002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000220', null, '0', '0', null, null, null, null, '0', '0', '2470011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000221', null, '0', '0', null, null, null, null, '0', '0', '2470020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000222', null, '0', '0', null, null, null, null, '0', '0', '2470015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000223', null, '0', '0', null, null, null, null, '0', '0', '2470008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000224', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000225', 'pplStd_09@08500', '133', '0', '-421.29', '40', '229.11', '-1.39', '0', '0', '1600260', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000226', null, '0', '0', null, null, null, null, '0', '0', '1900053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000227', null, '0', '0', null, null, null, null, '0', '0', '2200036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000228', null, '0', '0', null, null, null, null, '0', '0', '1100248', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000229', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000230', null, '0', '0', null, null, null, null, '0', '0', '1300018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000231', null, '0', '0', null, null, null, null, '0', '0', '1000324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000232', null, '0', '0', null, null, null, null, '0', '0', '1100006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000233', null, '0', '0', null, null, null, null, '0', '0', '1100006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000234', null, '0', '0', null, null, null, null, '0', '0', '1300064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000235', null, '0', '0', null, null, null, null, '0', '0', '2000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000236', null, '0', '0', null, null, null, null, '0', '0', '1600132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000237', null, '0', '0', null, null, null, null, '0', '0', '1500021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000238', null, '0', '0', null, null, null, null, '0', '0', '1000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000239', null, '0', '0', null, null, null, null, '0', '0', '1100025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000240', null, '0', '0', null, null, null, null, '0', '0', '1400070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000241', null, '0', '0', null, null, null, null, '0', '0', '4000532', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000242', null, '0', '0', null, null, null, null, '0', '0', '1100014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000243', null, '0', '0', null, null, null, null, '0', '0', '1000013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000244', null, '0', '0', null, null, null, null, '0', '0', '1000019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000245', null, '0', '0', null, null, null, null, '0', '0', '1500008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000246', null, '0', '0', null, null, null, null, '0', '0', '1600250', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000247', null, '0', '0', null, null, null, null, '0', '0', '1000028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000248', null, '0', '0', null, null, null, null, '0', '0', '1900062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000249', null, '0', '0', null, null, null, null, '0', '0', '1300004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000250', null, '0', '0', null, null, null, null, '0', '0', '1900024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000251', null, '0', '0', null, null, null, null, '0', '0', '1900057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000252', null, '0', '0', null, null, null, null, '0', '0', '1600243', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000253', null, '0', '0', null, null, null, null, '0', '0', '4000057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000254', null, '0', '0', null, null, null, null, '0', '0', '4000107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000255', null, '0', '0', null, null, null, null, '0', '0', '4000050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000256', null, '0', '0', null, null, null, null, '0', '0', '4000108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000257', null, '0', '0', null, null, null, null, '0', '0', '4000058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000258', null, '0', '0', null, null, null, null, '0', '0', '4000061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000259', null, '0', '0', null, null, null, null, '0', '0', '4000062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000260', null, '0', '0', null, null, null, null, '0', '0', '4000102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000261', null, '0', '0', null, null, null, null, '0', '0', '4000103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000262', null, '0', '0', null, null, null, null, '0', '0', '4000104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000263', null, '0', '0', null, null, null, null, '0', '0', '4000105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000264', null, '0', '0', null, null, null, null, '0', '0', '4000106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000265', null, '0', '0', null, null, null, null, '0', '0', '1500071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000266', null, '0', '0', null, null, null, null, '0', '0', '1000073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000267', null, '0', '0', null, null, null, null, '0', '0', '1500052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000268', null, '0', '0', null, null, null, null, '0', '0', '1300093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000269', null, '0', '0', null, null, null, null, '0', '0', '1500073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000270', 'pplStd_06@08500', '133', '0', '-440.36', '39.52', '193.94', '-0.95', '0', '1026', '1400057', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000271', 'pplStd_0d@08500', '133', '0', '-447.57', '39.52', '194.65', '-1.55', '0', '1026', '1300092', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000272', 'pplStd_0c@08500', '133', '0', '-446', '39.52', '184.8', '1.56', '0', '1054', '1200079', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000273', 'pplStd_02@08500', '133', '0', '-442.85', '39.52', '185.29', '-1.69', '0', '1026', '1100069', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000274', 'pplStd_0f@08500', '133', '0', '-449.2', '39.52', '196.13', '-3.12', '0', '1025', '1000126', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000275', null, '0', '0', null, null, null, null, '0', '0', '1300077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000276', 'pplStd_05@08500', '133', '0', '-440.71', '39.52', '195.76', '-2.46', '0', '1024', '1500043', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000277', 'pplStd_01@08500', '133', '0', '-442.17', '39.52', '193.61', '0.39', '0', '1025', '1400072', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000278', 'pplStd_0e@08500', '133', '0', '-450.17', '39.52', '201.08', '-0.73', '0', '1061', '1200096', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000279', 'pplStd_0b@08500', '133', '0', '-444.62', '39.52', '186.68', '3.04', '0', '1026', '1000150', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000280', 'pplStd_13@08500', '133', '0', '-464.54', '40', '185.15', '1.49', '0', '0', '2200094', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000281', 'pplStd_10@08500', '133', '0', '-450.79', '39.52', '182.56', '0.15', '0', '1015', '1100366', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000282', null, '0', '0', null, null, null, null, '0', '0', '4000052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000283', null, '0', '0', null, null, null, null, '0', '0', '4000053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000284', null, '0', '0', null, null, null, null, '0', '0', '4000054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000285', null, '0', '0', null, null, null, null, '0', '0', '4000055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000286', null, '0', '0', null, null, null, null, '0', '0', '4000056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000287', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000288', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000289', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000290', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000291', null, '0', '0', null, null, null, null, '0', '0', '1400045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000292', null, '0', '0', null, null, null, null, '0', '0', '4000063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000293', null, '0', '0', null, null, null, null, '0', '0', '1300034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000294', null, '0', '0', null, null, null, null, '0', '0', '4000078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000295', null, '0', '0', null, null, null, null, '0', '0', '4000079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000296', null, '0', '0', null, null, null, null, '0', '0', '4000080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000297', null, '0', '0', null, null, null, null, '0', '0', '4000081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000298', null, '0', '0', null, null, null, null, '0', '0', '4000082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000299', null, '0', '0', null, null, null, null, '0', '0', '4000083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000300', null, '0', '0', null, null, null, null, '0', '0', '4000084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000301', null, '0', '0', null, null, null, null, '0', '0', '4000090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000302', null, '0', '0', null, null, null, null, '0', '0', '4000085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000303', null, '0', '0', null, null, null, null, '0', '0', '4000086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000304', null, '0', '0', null, null, null, null, '0', '0', '4000091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000305', null, '0', '0', null, null, null, null, '0', '0', '4000087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000306', null, '0', '0', null, null, null, null, '0', '0', '4000088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000307', null, '0', '0', null, null, null, null, '0', '0', '4000089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000308', null, '0', '0', null, null, null, null, '0', '0', '4000092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000309', null, '0', '0', null, null, null, null, '0', '0', '4000093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000310', null, '0', '0', null, null, null, null, '0', '0', '4000094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000311', null, '0', '0', null, null, null, null, '0', '0', '4000095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000312', null, '0', '0', null, null, null, null, '0', '0', '4000064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000313', null, '0', '0', null, null, null, null, '0', '0', '4000065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000314', null, '0', '0', null, null, null, null, '0', '0', '4000066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000315', null, '0', '0', null, null, null, null, '0', '0', '4000067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000316', null, '0', '0', null, null, null, null, '0', '0', '4000068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000317', null, '0', '0', null, null, null, null, '0', '0', '4000069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000318', null, '0', '0', null, null, null, null, '0', '0', '4000070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000319', null, '0', '0', null, null, null, null, '0', '0', '4000071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000320', null, '0', '0', null, null, null, null, '0', '0', '4000072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000321', null, '0', '0', null, null, null, null, '0', '0', '4000073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000322', null, '0', '0', null, null, null, null, '0', '0', '4000074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000323', null, '0', '0', null, null, null, null, '0', '0', '4000075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000324', null, '0', '0', null, null, null, null, '0', '0', '4000076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000325', null, '0', '0', null, null, null, null, '0', '0', '4000077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000326', null, '0', '0', null, null, null, null, '0', '0', '1100263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000327', null, '0', '0', null, null, null, null, '0', '0', '4000096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000328', null, '0', '0', null, null, null, null, '0', '0', '4000097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000329', null, '0', '0', null, null, null, null, '0', '0', '4000098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000330', null, '0', '0', null, null, null, null, '0', '0', '1000064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000331', null, '0', '0', null, null, null, null, '0', '0', '1100182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000332', null, '0', '0', null, null, null, null, '0', '0', '1600019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000333', null, '0', '0', null, null, null, null, '0', '0', '1600166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000334', null, '0', '0', null, null, null, null, '0', '0', '1500044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000335', null, '0', '0', null, null, null, null, '0', '0', '1900060', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000336', null, '0', '0', null, null, null, null, '0', '0', '1900004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000337', null, '0', '0', null, null, null, null, '0', '0', '1600110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000338', null, '0', '0', null, null, null, null, '0', '0', '1600158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000339', 'pplStd_0a@08500', '133', '0', '-455.5', '44', '85.79', '2.32', '0', '1041', '1900013', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000340', null, '0', '0', null, null, null, null, '0', '0', '1900038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000341', null, '0', '0', null, null, null, null, '0', '0', '1400014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000342', null, '0', '0', null, null, null, null, '0', '0', '1900044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000343', null, '0', '0', null, null, null, null, '0', '0', '1000084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000344', null, '0', '0', null, null, null, null, '0', '0', '1200047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000345', null, '0', '0', null, null, null, null, '0', '0', '1500033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000346', null, '0', '0', null, null, null, null, '0', '0', '1300075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000347', null, '0', '0', null, null, null, null, '0', '0', '1600006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000348', null, '0', '0', null, null, null, null, '0', '0', '2200195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000349', null, '0', '0', null, null, null, null, '0', '0', '1600182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000350', null, '0', '0', null, null, null, null, '0', '0', '1200089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000351', 'pplStd_04@08500', '133', '0', '-441.8', '21', '175', '-0.35', '0', '10', '1600258', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000352', null, '0', '0', null, null, null, null, '0', '0', '1600200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000353', null, '0', '0', null, null, null, null, '0', '0', '1600174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000354', null, '0', '0', null, null, null, null, '0', '0', '1000124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000355', null, '0', '0', null, null, null, null, '0', '0', '1200065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000356', null, '0', '0', null, null, null, null, '0', '0', '1200078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000357', null, '0', '0', null, null, null, null, '0', '0', '1900043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000358', null, '0', '0', null, null, null, null, '0', '0', '1400034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000359', null, '0', '0', null, null, null, null, '0', '0', '1600154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000360', null, '0', '0', null, null, null, null, '0', '0', '1900068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000361', null, '0', '0', null, null, null, null, '0', '0', '1600018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000362', null, '0', '0', null, null, null, null, '0', '0', '1300083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000363', null, '0', '0', null, null, null, null, '0', '0', '1000182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000364', null, '0', '0', null, null, null, null, '0', '0', '1600031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000365', null, '0', '0', null, null, null, null, '0', '0', '2200107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000366', null, '0', '0', null, null, null, null, '0', '0', '1200031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000367', null, '0', '0', null, null, null, null, '0', '0', '1900052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000368', null, '0', '0', null, null, null, null, '0', '0', '1500065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000369', null, '0', '0', null, null, null, null, '0', '0', '1200033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000370', null, '0', '0', null, null, null, null, '0', '0', '1200022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000371', null, '0', '0', null, null, null, null, '0', '0', '1600270', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000372', null, '0', '0', null, null, null, null, '0', '0', '1000141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000373', null, '0', '0', null, null, null, null, '0', '0', '1000233', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000374', null, '0', '0', null, null, null, null, '0', '0', '1400067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000375', null, '0', '0', null, null, null, null, '0', '0', '4000599', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000376', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000377', null, '0', '0', null, null, null, null, '0', '0', '1900016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000378', null, '0', '0', null, null, null, null, '0', '0', '4000051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000379', null, '0', '0', null, null, null, null, '0', '0', '1100110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000380', null, '0', '0', null, null, null, null, '0', '0', '4000137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000381', null, '0', '0', null, null, null, null, '0', '0', '4000138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000382', null, '0', '0', null, null, null, null, '0', '0', '4000139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000383', null, '0', '0', null, null, null, null, '0', '0', '4000140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000384', null, '0', '0', null, null, null, null, '0', '0', '4000141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000385', null, '0', '0', null, null, null, null, '0', '0', '4000145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000386', null, '0', '0', null, null, null, null, '0', '0', '4000142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000387', null, '0', '0', null, null, null, null, '0', '0', '4000143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000388', null, '0', '0', null, null, null, null, '0', '0', '1300094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000389', null, '0', '0', null, null, null, null, '0', '0', '4000144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000390', null, '0', '0', null, null, null, null, '0', '0', '4000146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000391', null, '0', '0', null, null, null, null, '0', '0', '4000147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000392', null, '0', '0', null, null, null, null, '0', '0', '4000148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000393', null, '0', '0', null, null, null, null, '0', '0', '4000149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000394', null, '0', '0', null, null, null, null, '0', '0', '4000150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000395', null, '0', '0', null, null, null, null, '0', '0', '4000151', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000396', null, '0', '0', null, null, null, null, '0', '0', '4000152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000397', null, '0', '0', null, null, null, null, '0', '0', '4000153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000398', null, '0', '0', null, null, null, null, '0', '0', '4000154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000399', null, '0', '0', null, null, null, null, '0', '0', '4000155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000400', null, '0', '0', null, null, null, null, '0', '0', '1400018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000401', null, '0', '0', null, null, null, null, '0', '0', '4000156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000402', null, '0', '0', null, null, null, null, '0', '0', '2200071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000403', null, '0', '0', null, null, null, null, '0', '0', '4000135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000404', null, '0', '0', null, null, null, null, '0', '0', '4000132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000405', null, '0', '0', null, null, null, null, '0', '0', '4000133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000406', null, '0', '0', null, null, null, null, '0', '0', '4000134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000407', null, '0', '0', null, null, null, null, '0', '0', '4000136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000408', null, '0', '0', null, null, null, null, '0', '0', '1100369', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000409', null, '0', '0', null, null, null, null, '0', '0', '1200068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000410', null, '0', '0', null, null, null, null, '0', '0', '1300028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000411', null, '0', '0', null, null, null, null, '0', '0', '1100294', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000412', null, '0', '0', null, null, null, null, '0', '0', '1000414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000413', null, '0', '0', null, null, null, null, '0', '0', '4000120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000414', null, '0', '0', null, null, null, null, '0', '0', '4000121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000415', null, '0', '0', null, null, null, null, '0', '0', '4000122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000416', null, '0', '0', null, null, null, null, '0', '0', '4000123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000417', null, '0', '0', null, null, null, null, '0', '0', '4000124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000418', null, '0', '0', null, null, null, null, '0', '0', '4000125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000419', null, '0', '0', null, null, null, null, '0', '0', '4000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000420', null, '0', '0', null, null, null, null, '0', '0', '4000127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000421', null, '0', '0', null, null, null, null, '0', '0', '4000128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000422', null, '0', '0', null, null, null, null, '0', '0', '4000129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000423', null, '0', '0', null, null, null, null, '0', '0', '4000130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000424', null, '0', '0', null, null, null, null, '0', '0', '4000131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000425', null, '0', '0', null, null, null, null, '0', '0', '1600124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000426', null, '0', '0', null, null, null, null, '0', '0', '1000170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000427', null, '0', '0', null, null, null, null, '0', '0', '1500093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000428', null, '0', '0', null, null, null, null, '0', '0', '1600192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000429', null, '0', '0', null, null, null, null, '0', '0', '1400098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000430', null, '0', '0', null, null, null, null, '0', '0', '1400084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000431', null, '0', '0', null, null, null, null, '0', '0', '1900099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000432', null, '0', '0', null, null, null, null, '0', '0', '1500098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000433', null, '0', '0', null, null, null, null, '0', '0', '1200041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000434', null, '0', '0', null, null, null, null, '0', '0', '1300081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000435', null, '0', '0', null, null, null, null, '0', '0', '2200048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000436', null, '0', '0', null, null, null, null, '0', '0', '1600160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000437', null, '0', '0', null, null, null, null, '0', '0', '1900085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000438', 'pplStd_01@0C100', '193', '0', '-0.71', '10.35', '-40.51', '0.3', '0', '1035', '4000157', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000439', 'pplStd_02@0C100', '193', '0', '-1.87', '9.15', '-30.67', '2.44', '0', '1032', '4000158', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000440', 'pplStd_03@0C100', '193', '0', '7.06', '9.15', '-28.62', '-1.54', '0', '1041', '4000159', '', 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000441', 'pplStd_04@0C100', '193', '0', '2.63', '915', '-33.91', '-0.16', '0', '1015', '4000160', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000442', 'pplStd_05@0C100', '193', '0', '4.2', '10.35', '-21.98', '3.11', '0', '1066', '4000161', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000443', 'pplStd_06@0C100', '193', '0', '4.06', '10.35', '-35.24', '2.52', '0', '1036', '4000162', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000444', 'pplStd_07@0C100', '193', '0', '-4.72', '10.35', '-22.56', '2.06', '0', '1041', '4000163', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000445', 'pplStd_08@0C100', '193', '0', '-4.09', '9.15', '-24.55', '2.09', '0', '1035', '4000164', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000446', 'pplStd_09@0C100', '193', '0', '-0.72', '9.15', '-31.81', '-1.18', '0', '1041', '4000165', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000447', 'pplStd_0a@0C100', '193', '0', '-2.16', '9.15', '-26.18', '0.09', '0', '1016', '4000166', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000448', 'pplStd_0b@0C100', '193', '0', '5.93', '10.35', '-25.09', '-2.01', '0', '1037', '4000167', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000449', 'pplStd_0c@0C100', '193', '0', '-1.92', '9.15', '-34.19', '0.82', '0', '1013', '4000168', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000450', 'pplStd_0d@0C100', '193', '0', '4.88', '9.15', '-29.5', '0.65', '0', '1271', '4000169', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000451', 'pplStd_0e@0C100', '193', '0', '-1.1', '9.85', '-33.62', '-0.82', '0', '1026', '4000170', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000452', null, '0', '0', '0', '10', '-18', '0', '0', '0', '4000003', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000453', null, '0', '0', null, null, null, null, '0', '0', '4000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000454', null, '0', '0', null, null, null, null, '0', '0', '1200100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000455', 'pplPassiveG_01@08500', '133', '0', '-459.76', '40', '178.22', '1.6', '0', '1015', '1900059', null, 'PopulacePassiveGLPublisher', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000456', null, '0', '0', null, null, null, null, '0', '0', '1100218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000457', null, '0', '0', null, null, null, null, '0', '0', '1200123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000458', null, '0', '0', null, null, null, null, '0', '0', '1900110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000459', null, '0', '0', null, null, null, null, '0', '0', '1100192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000460', null, '0', '0', null, null, null, null, '0', '0', '2200149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000461', null, '0', '0', null, null, null, null, '0', '0', '1500099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000462', null, '0', '0', null, null, null, null, '0', '0', '2200068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000463', null, '0', '0', null, null, null, null, '0', '0', '1400007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000464', null, '0', '0', null, null, null, null, '0', '0', '1100255', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000465', null, '0', '0', null, null, null, null, '0', '0', '1900034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000466', null, '0', '0', null, null, null, null, '0', '0', '1100316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000467', null, '0', '0', null, null, null, null, '0', '0', '1500065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000468', null, '0', '0', null, null, null, null, '0', '0', '1900112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000469', null, '0', '0', null, null, null, null, '0', '0', '1500036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000470', null, '0', '0', null, null, null, null, '0', '0', '1400082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000471', null, '0', '0', null, null, null, null, '0', '0', '1900095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000472', null, '0', '0', null, null, null, null, '0', '0', '1600113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000473', null, '0', '0', null, null, null, null, '0', '0', '1300079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000474', null, '0', '0', null, null, null, null, '0', '0', '1900124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000475', null, '0', '0', null, null, null, null, '0', '0', '1900105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000476', null, '0', '0', null, null, null, null, '0', '0', '1900088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000477', null, '0', '0', null, null, null, null, '0', '0', '4000524', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000478', null, '0', '0', null, null, null, null, '0', '0', '4000561', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000479', null, '0', '0', null, null, null, null, '0', '0', '4000560', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000480', null, '0', '0', null, null, null, null, '0', '0', '4000563', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000481', null, '0', '0', null, null, null, null, '0', '0', '4000424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000482', null, '0', '0', null, null, null, null, '0', '0', '4000562', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000483', null, '0', '0', null, null, null, null, '0', '0', '4000423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000484', null, '0', '0', null, null, null, null, '0', '0', '1000108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000485', null, '0', '0', null, null, null, null, '0', '0', '1200072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000486', null, '0', '0', null, null, null, null, '0', '0', '1300091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000487', null, '0', '0', null, null, null, null, '0', '0', '1600040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000488', null, '0', '0', null, null, null, null, '0', '0', '1600126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000489', null, '0', '0', null, null, null, null, '0', '0', '1600116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000490', null, '0', '0', null, null, null, null, '0', '0', '1400038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000491', null, '0', '0', null, null, null, null, '0', '0', '1900108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000492', null, '0', '0', null, null, null, null, '0', '0', '1000173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000493', null, '0', '0', null, null, null, null, '0', '0', '4000473', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000494', null, '0', '0', null, null, null, null, '0', '0', '4000474', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000495', null, '0', '0', null, null, null, null, '0', '0', '4000475', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000496', null, '0', '0', null, null, null, null, '0', '0', '4000476', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000497', null, '0', '0', null, null, null, null, '0', '0', '4000477', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000498', null, '0', '0', null, null, null, null, '0', '0', '4000478', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000499', null, '0', '0', null, null, null, null, '0', '0', '4000491', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000500', null, '0', '0', null, null, null, null, '0', '0', '4000492', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000501', null, '0', '0', null, null, null, null, '0', '0', '4000493', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000502', null, '0', '0', null, null, null, null, '0', '0', '4000494', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000503', null, '0', '0', null, null, null, null, '0', '0', '4000495', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000504', null, '0', '0', null, null, null, null, '0', '0', '1000415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000505', null, '0', '0', null, null, null, null, '0', '0', '1000175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000506', null, '0', '0', null, null, null, null, '0', '0', '1000175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000507', null, '0', '0', null, null, null, null, '0', '0', '1100180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000508', null, '0', '0', null, null, null, null, '0', '0', '1100416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000509', null, '0', '0', null, null, null, null, '0', '0', '1100364', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000510', null, '0', '0', null, null, null, null, '0', '0', '1000265', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000511', null, '0', '0', null, null, null, null, '0', '0', '1100268', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000512', null, '0', '0', null, null, null, null, '0', '0', '1200127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000513', null, '0', '0', null, null, null, null, '0', '0', '1500077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000514', null, '0', '0', null, null, null, null, '0', '0', '2420018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000515', null, '0', '0', null, null, null, null, '0', '0', '2420009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000516', null, '0', '0', null, null, null, null, '0', '0', '2420010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000517', null, '0', '0', null, null, null, null, '0', '0', '2420011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000518', null, '0', '0', null, null, null, null, '0', '0', '2420012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000519', null, '0', '0', null, null, null, null, '0', '0', '2420013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000520', null, '0', '0', null, null, null, null, '0', '0', '2420017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000521', null, '0', '0', null, null, null, null, '0', '0', '2420019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000522', null, '0', '0', null, null, null, null, '0', '0', '2420001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000523', null, '0', '0', null, null, null, null, '0', '0', '2420005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000524', null, '0', '0', null, null, null, null, '0', '0', '2420005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000525', null, '0', '0', null, null, null, null, '0', '0', '2420014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000526', null, '0', '0', null, null, null, null, '0', '0', '2420015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000527', null, '0', '0', null, null, null, null, '0', '0', '2420016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000528', null, '0', '0', null, null, null, null, '0', '0', '2420020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000529', null, '0', '0', null, null, null, null, '0', '0', '2420006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000530', null, '0', '0', null, null, null, null, '0', '0', '2420007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000531', null, '0', '0', null, null, null, null, '0', '0', '2420008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000532', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000533', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000534', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000535', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000536', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000537', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000538', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000539', null, '0', '0', null, null, null, null, '0', '0', '4000212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000540', null, '0', '0', null, null, null, null, '0', '0', '4000213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000541', null, '0', '0', null, null, null, null, '0', '0', '4000214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000542', null, '0', '0', null, null, null, null, '0', '0', '4000215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000543', null, '0', '0', null, null, null, null, '0', '0', '4000216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000544', null, '0', '0', null, null, null, null, '0', '0', '4000217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000545', null, '0', '0', null, null, null, null, '0', '0', '4000218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000546', null, '0', '0', null, null, null, null, '0', '0', '4000219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000547', null, '0', '0', null, null, null, null, '0', '0', '4000221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000548', null, '0', '0', null, null, null, null, '0', '0', '4000222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000549', null, '0', '0', null, null, null, null, '0', '0', '4000220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000550', null, '0', '0', null, null, null, null, '0', '0', '4000223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000551', null, '0', '0', null, null, null, null, '0', '0', '4000224', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000552', null, '0', '0', null, null, null, null, '0', '0', '2700012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000553', null, '0', '0', null, null, null, null, '0', '0', '4000040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000554', null, '0', '0', null, null, null, null, '0', '0', '4000042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000555', null, '0', '0', null, null, null, null, '0', '0', '1000045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000556', null, '0', '0', null, null, null, null, '0', '0', '1100118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000557', null, '0', '0', null, null, null, null, '0', '0', '4000479', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000558', null, '0', '0', null, null, null, null, '0', '0', '4000480', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000559', null, '0', '0', null, null, null, null, '0', '0', '4000481', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000560', null, '0', '0', null, null, null, null, '0', '0', '4000482', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000561', null, '0', '0', null, null, null, null, '0', '0', '4000483', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000562', null, '0', '0', null, null, null, null, '0', '0', '4000484', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000563', null, '0', '0', null, null, null, null, '0', '0', '4000485', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000564', null, '0', '0', null, null, null, null, '0', '0', '4000486', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000565', null, '0', '0', null, null, null, null, '0', '0', '1100124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000566', null, '0', '0', null, null, null, null, '0', '0', '1000112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000567', null, '0', '0', null, null, null, null, '0', '0', '1600054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000568', null, '0', '0', null, null, null, null, '0', '0', '2200184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000569', null, '0', '0', null, null, null, null, '0', '0', '1200122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000570', null, '0', '0', null, null, null, null, '0', '0', '1900089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000571', null, '0', '0', null, null, null, null, '0', '0', '4000471', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000572', null, '0', '0', null, null, null, null, '0', '0', '4000472', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000573', null, '0', '0', null, null, null, null, '0', '0', '4000470', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000574', null, '0', '0', null, null, null, null, '0', '0', '4000245', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000575', null, '0', '0', null, null, null, null, '0', '0', '4000246', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000576', null, '0', '0', null, null, null, null, '0', '0', '4000247', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000577', null, '0', '0', null, null, null, null, '0', '0', '4000248', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000578', null, '0', '0', null, null, null, null, '0', '0', '4000249', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000579', null, '0', '0', null, null, null, null, '0', '0', '4000250', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000580', null, '0', '0', null, null, null, null, '0', '0', '4000251', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000581', null, '0', '0', null, null, null, null, '0', '0', '4000252', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000582', null, '0', '0', null, null, null, null, '0', '0', '4000253', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000583', null, '0', '0', null, null, null, null, '0', '0', '4000254', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000584', null, '0', '0', null, null, null, null, '0', '0', '4000255', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000585', null, '0', '0', null, null, null, null, '0', '0', '4000256', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000586', null, '0', '0', null, null, null, null, '0', '0', '1200019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000587', null, '0', '0', null, null, null, null, '0', '0', '1100199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000588', null, '0', '0', null, null, null, null, '0', '0', '1000342', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000589', null, '0', '0', null, null, null, null, '0', '0', '1200103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000590', null, '0', '0', null, null, null, null, '0', '0', '1200103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000591', null, '0', '0', null, null, null, null, '0', '0', '1000086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000592', null, '0', '0', null, null, null, null, '0', '0', '1000218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000593', null, '0', '0', null, null, null, null, '0', '0', '1100394', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000594', null, '0', '0', null, null, null, null, '0', '0', '1900023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000595', null, '0', '0', null, null, null, null, '0', '0', '1000091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000596', null, '0', '0', null, null, null, null, '0', '0', '1200064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000597', null, '0', '0', null, null, null, null, '0', '0', '1200017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000598', null, '0', '0', null, null, null, null, '0', '0', '2200213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000599', null, '0', '0', null, null, null, null, '0', '0', '1900046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000600', null, '0', '0', null, null, null, null, '0', '0', '1900046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000601', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000602', null, '0', '0', null, null, null, null, '0', '0', '4000414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000603', null, '0', '0', null, null, null, null, '0', '0', '2200172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000604', null, '0', '0', null, null, null, null, '0', '0', '1500080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000605', null, '0', '0', null, null, null, null, '0', '0', '4000192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000606', null, '0', '0', null, null, null, null, '0', '0', '1600257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000607', null, '0', '0', null, null, null, null, '0', '0', '4000189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000608', null, '0', '0', null, null, null, null, '0', '0', '3105201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000609', null, '0', '0', null, null, null, null, '0', '0', '3101413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000610', null, '0', '0', null, null, null, null, '0', '0', '3105201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000611', null, '0', '0', null, null, null, null, '0', '0', '3106725', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000612', null, '0', '0', null, null, null, null, '0', '0', '2420003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000613', null, '0', '0', null, null, null, null, '0', '0', '1600125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000614', null, '0', '0', null, null, null, null, '0', '0', '1400076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000615', null, '0', '0', null, null, null, null, '0', '0', '1900056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000616', null, '0', '0', null, null, null, null, '0', '0', '1300073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000617', null, '0', '0', null, null, null, null, '0', '0', '2200258', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000618', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000619', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000620', null, '0', '0', null, null, null, null, '0', '0', '1400093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000621', null, '0', '0', null, null, null, null, '0', '0', '1000132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000622', null, '0', '0', null, null, null, null, '0', '0', '1100276', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000623', null, '0', '0', null, null, null, null, '0', '0', '1400083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000624', null, '0', '0', null, null, null, null, '0', '0', '1000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000625', null, '0', '0', null, null, null, null, '0', '0', '1500069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000626', null, '0', '0', null, null, null, null, '0', '0', '1000195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000627', null, '0', '0', null, null, null, null, '0', '0', '1600009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000628', null, '0', '0', null, null, null, null, '0', '0', '1200002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000629', null, '0', '0', null, null, null, null, '0', '0', '2200074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000630', null, '0', '0', null, null, null, null, '0', '0', '1000181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000631', null, '0', '0', null, null, null, null, '0', '0', '1000077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000632', null, '0', '0', null, null, null, null, '0', '0', '1100152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000633', null, '0', '0', null, null, null, null, '0', '0', '1600129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000634', null, '0', '0', null, null, null, null, '0', '0', '1100203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000635', null, '0', '0', null, null, null, null, '0', '0', '2200154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000636', null, '0', '0', null, null, null, null, '0', '0', '1400096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000637', null, '0', '0', null, null, null, null, '0', '0', '2200216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000638', null, '0', '0', null, null, null, null, '0', '0', '1400097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000639', null, '0', '0', null, null, null, null, '0', '0', '1100334', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000640', null, '0', '0', null, null, null, null, '0', '0', '1200128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000641', null, '0', '0', null, null, null, null, '0', '0', '1900071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000642', null, '0', '0', null, null, null, null, '0', '0', '1600130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000643', null, '0', '0', null, null, null, null, '0', '0', '1500038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000644', null, '0', '0', null, null, null, null, '0', '0', '1600101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000645', null, '0', '0', null, null, null, null, '0', '0', '1100376', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000646', null, '0', '0', null, null, null, null, '0', '0', '1900074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000647', null, '0', '0', null, null, null, null, '0', '0', '1600109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000648', null, '0', '0', null, null, null, null, '0', '0', '1400077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000649', null, '0', '0', null, null, null, null, '0', '0', '1900091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000650', null, '0', '0', null, null, null, null, '0', '0', '1100104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000651', null, '0', '0', null, null, null, null, '0', '0', '1500009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000652', null, '0', '0', null, null, null, null, '0', '0', '1500007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000653', null, '0', '0', null, null, null, null, '0', '0', '1900067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000654', null, '0', '0', null, null, null, null, '0', '0', '1400011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000655', null, '0', '0', null, null, null, null, '0', '0', '1000145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000656', null, '0', '0', null, null, null, null, '0', '0', '1100382', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000657', null, '0', '0', null, null, null, null, '0', '0', '1000161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000658', null, '0', '0', null, null, null, null, '0', '0', '2200098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000659', null, '0', '0', null, null, null, null, '0', '0', '1000092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000660', null, '0', '0', null, null, null, null, '0', '0', '1000128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000661', null, '0', '0', null, null, null, null, '0', '0', '1300066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000662', null, '0', '0', null, null, null, null, '0', '0', '1600167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000663', null, '0', '0', null, null, null, null, '0', '0', '1000070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000664', null, '0', '0', null, null, null, null, '0', '0', '1600131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000665', null, '0', '0', null, null, null, null, '0', '0', '1100412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000666', null, '0', '0', null, null, null, null, '0', '0', '1500084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000667', null, '0', '0', null, null, null, null, '0', '0', '1400042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000668', null, '0', '0', null, null, null, null, '0', '0', '1900083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000669', null, '0', '0', null, null, null, null, '0', '0', '1400003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000670', null, '0', '0', null, null, null, null, '0', '0', '1500055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000671', null, '0', '0', null, null, null, null, '0', '0', '1200066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000672', null, '0', '0', null, null, null, null, '0', '0', '1600036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000673', null, '0', '0', null, null, null, null, '0', '0', '1400032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000674', null, '0', '0', null, null, null, null, '0', '0', '1900090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000675', null, '0', '0', null, null, null, null, '0', '0', '1300082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000676', null, '0', '0', null, null, null, null, '0', '0', '1400088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000677', null, '0', '0', null, null, null, null, '0', '0', '1000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000678', null, '0', '0', null, null, null, null, '0', '0', '1600115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000679', null, '0', '0', null, null, null, null, '0', '0', '2000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000680', null, '0', '0', null, null, null, null, '0', '0', '1100010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000681', null, '0', '0', null, null, null, null, '0', '0', '1100210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000682', null, '0', '0', null, null, null, null, '0', '0', '1000027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000683', null, '0', '0', null, null, null, null, '0', '0', '1100023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000684', null, '0', '0', null, null, null, null, '0', '0', '1100211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000685', null, '0', '0', null, null, null, null, '0', '0', '1000227', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000686', null, '0', '0', null, null, null, null, '0', '0', '1900118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000687', null, '0', '0', null, null, null, null, '0', '0', '4000199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000688', null, '0', '0', null, null, null, null, '0', '0', '4000200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000689', null, '0', '0', null, null, null, null, '0', '0', '4000201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000690', null, '0', '0', null, null, null, null, '0', '0', '4000202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000691', null, '0', '0', null, null, null, null, '0', '0', '4000203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000692', null, '0', '0', null, null, null, null, '0', '0', '4000204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000693', null, '0', '0', null, null, null, null, '0', '0', '4000205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000694', null, '0', '0', null, null, null, null, '0', '0', '4000206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000695', null, '0', '0', null, null, null, null, '0', '0', '4000207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000696', null, '0', '0', null, null, null, null, '0', '0', '4000208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000697', null, '0', '0', null, null, null, null, '0', '0', '4000209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000698', null, '0', '0', null, null, null, null, '0', '0', '4000210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000699', null, '0', '0', null, null, null, null, '0', '0', '4000211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000700', null, '0', '0', null, null, null, null, '0', '0', '1600100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000701', null, '0', '0', null, null, null, null, '0', '0', '1400037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000702', null, '0', '0', null, null, null, null, '0', '0', '1100339', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000703', null, '0', '0', null, null, null, null, '0', '0', '4000190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000704', null, '0', '0', null, null, null, null, '0', '0', '4000193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000705', null, '0', '0', null, null, null, null, '0', '0', '4000194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000706', null, '0', '0', null, null, null, null, '0', '0', '4000195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000707', null, '0', '0', null, null, null, null, '0', '0', '4000196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000708', null, '0', '0', null, null, null, null, '0', '0', '4000197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000709', null, '0', '0', null, null, null, null, '0', '0', '4000198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000710', null, '0', '0', null, null, null, null, '0', '0', '1200147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000711', null, '0', '0', null, null, null, null, '0', '0', '4000225', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000712', null, '0', '0', null, null, null, null, '0', '0', '4000226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000713', null, '0', '0', null, null, null, null, '0', '0', '4000227', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000714', null, '0', '0', null, null, null, null, '0', '0', '4000228', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000715', null, '0', '0', null, null, null, null, '0', '0', '4000229', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000716', null, '0', '0', null, null, null, null, '0', '0', '4000230', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000717', null, '0', '0', null, null, null, null, '0', '0', '4000231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000718', null, '0', '0', null, null, null, null, '0', '0', '4000232', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000719', null, '0', '0', null, null, null, null, '0', '0', '4000233', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000720', null, '0', '0', null, null, null, null, '0', '0', '4000234', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000721', null, '0', '0', null, null, null, null, '0', '0', '4000235', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000722', null, '0', '0', null, null, null, null, '0', '0', '4000236', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000723', null, '0', '0', null, null, null, null, '0', '0', '4000237', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000724', null, '0', '0', null, null, null, null, '0', '0', '4000238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000725', null, '0', '0', null, null, null, null, '0', '0', '4000239', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000726', null, '0', '0', null, null, null, null, '0', '0', '4000240', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000727', null, '0', '0', null, null, null, null, '0', '0', '4000241', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000728', null, '0', '0', null, null, null, null, '0', '0', '4000242', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000729', null, '0', '0', null, null, null, null, '0', '0', '4000243', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000730', null, '0', '0', null, null, null, null, '0', '0', '4000244', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000731', null, '0', '0', null, null, null, null, '0', '0', '1000112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000732', null, '0', '0', null, null, null, null, '0', '0', '1000018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000733', null, '0', '0', null, null, null, null, '0', '0', '1000244', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000734', null, '0', '0', null, null, null, null, '0', '0', '1200134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000735', null, '0', '0', null, null, null, null, '0', '0', '1600094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000736', null, '0', '0', null, null, null, null, '0', '0', '1300116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000737', null, '0', '0', null, null, null, null, '0', '0', '1100121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000738', null, '0', '0', null, null, null, null, '0', '0', '1200140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000739', null, '0', '0', null, null, null, null, '0', '0', '1200150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000740', null, '0', '0', null, null, null, null, '0', '0', '1200146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000741', null, '0', '0', null, null, null, null, '0', '0', '1400016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000742', null, '0', '0', null, null, null, null, '0', '0', '1100364', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000743', null, '0', '0', null, null, null, null, '0', '0', '4000272', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000744', null, '0', '0', null, null, null, null, '0', '0', '4000273', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000745', null, '0', '0', null, null, null, null, '0', '0', '4000274', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000746', null, '0', '0', null, null, null, null, '0', '0', '4000275', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000747', null, '0', '0', null, null, null, null, '0', '0', '4000277', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000748', null, '0', '0', null, null, null, null, '0', '0', '4000278', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000749', null, '0', '0', null, null, null, null, '0', '0', '4000276', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000750', null, '0', '0', null, null, null, null, '0', '0', '1000081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000751', null, '0', '0', null, null, null, null, '0', '0', '1200154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000752', null, '0', '0', null, null, null, null, '0', '0', '1900147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000753', null, '0', '0', null, null, null, null, '0', '0', '1200007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000754', null, '0', '0', null, null, null, null, '0', '0', '1000408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000755', null, '0', '0', null, null, null, null, '0', '0', '4000279', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000756', null, '0', '0', null, null, null, null, '0', '0', '4000280', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000757', null, '0', '0', null, null, null, null, '0', '0', '4000281', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000758', null, '0', '0', null, null, null, null, '0', '0', '1200143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000759', null, '0', '0', null, null, null, null, '0', '0', '1900138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000760', null, '0', '0', null, null, null, null, '0', '0', '1600224', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000761', null, '0', '0', null, null, null, null, '0', '0', '4000400', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000762', null, '0', '0', null, null, null, null, '0', '0', '4000450', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000763', null, '0', '0', null, null, null, null, '0', '0', '4000451', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000764', null, '0', '0', null, null, null, null, '0', '0', '4000452', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000765', null, '0', '0', null, null, null, null, '0', '0', '4000453', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000766', null, '0', '0', null, null, null, null, '0', '0', '4000454', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000767', null, '0', '0', null, null, null, null, '0', '0', '4000455', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000768', null, '0', '0', null, null, null, null, '0', '0', '4000456', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000769', null, '0', '0', null, null, null, null, '0', '0', '4000457', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000770', null, '0', '0', null, null, null, null, '0', '0', '4000458', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000771', null, '0', '0', null, null, null, null, '0', '0', '4000459', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000772', null, '0', '0', null, null, null, null, '0', '0', '4000460', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000773', null, '0', '0', null, null, null, null, '0', '0', '4000461', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000774', null, '0', '0', null, null, null, null, '0', '0', '4000462', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000775', null, '0', '0', null, null, null, null, '0', '0', '4000463', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000776', null, '0', '0', null, null, null, null, '0', '0', '4000464', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000777', null, '0', '0', null, null, null, null, '0', '0', '4000465', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000778', null, '0', '0', null, null, null, null, '0', '0', '4000466', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000779', null, '0', '0', null, null, null, null, '0', '0', '4000467', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000780', null, '0', '0', null, null, null, null, '0', '0', '1100201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000781', null, '0', '0', null, null, null, null, '0', '0', '1900109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000782', null, '0', '0', null, null, null, null, '0', '0', '1000051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000783', null, '0', '0', null, null, null, null, '0', '0', '1100390', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000784', null, '0', '0', null, null, null, null, '0', '0', '1600263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000785', null, '0', '0', null, null, null, null, '0', '0', '1600181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000786', null, '0', '0', null, null, null, null, '0', '0', '1900117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000787', null, '0', '0', null, null, null, null, '0', '0', '1300097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000788', null, '0', '0', null, null, null, null, '0', '0', '1100370', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000789', null, '0', '0', null, null, null, null, '0', '0', '2200227', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000790', null, '0', '0', null, null, null, null, '0', '0', '4000282', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000791', null, '0', '0', null, null, null, null, '0', '0', '4000283', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000792', null, '0', '0', null, null, null, null, '0', '0', '4000284', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000793', null, '0', '0', null, null, null, null, '0', '0', '4000285', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000794', null, '0', '0', null, null, null, null, '0', '0', '4000286', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000795', null, '0', '0', null, null, null, null, '0', '0', '4000287', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000796', null, '0', '0', null, null, null, null, '0', '0', '4000288', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000797', null, '0', '0', null, null, null, null, '0', '0', '4000289', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000798', null, '0', '0', null, null, null, null, '0', '0', '4000290', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000799', null, '0', '0', null, null, null, null, '0', '0', '4000291', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000800', null, '0', '0', null, null, null, null, '0', '0', '2200222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000801', null, '0', '0', null, null, null, null, '0', '0', '1400058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000802', null, '0', '0', null, null, null, null, '0', '0', '1400109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000803', null, '0', '0', null, null, null, null, '0', '0', '2200009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000804', null, '0', '0', null, null, null, null, '0', '0', '1600095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000805', null, '0', '0', null, null, null, null, '0', '0', '1900135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000806', null, '0', '0', null, null, null, null, '0', '0', '4000298', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000807', null, '0', '0', null, null, null, null, '0', '0', '4000299', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000808', null, '0', '0', null, null, null, null, '0', '0', '4000300', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000809', null, '0', '0', null, null, null, null, '0', '0', '4000301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000810', null, '0', '0', null, null, null, null, '0', '0', '4000302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000811', null, '0', '0', null, null, null, null, '0', '0', '4000303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000812', null, '0', '0', null, null, null, null, '0', '0', '4000304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000813', null, '0', '0', null, null, null, null, '0', '0', '4000305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000814', null, '0', '0', null, null, null, null, '0', '0', '4000306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000815', null, '0', '0', null, null, null, null, '0', '0', '4000307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000816', null, '0', '0', null, null, null, null, '0', '0', '4000308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000817', null, '0', '0', null, null, null, null, '0', '0', '4000309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000818', null, '0', '0', null, null, null, null, '0', '0', '4000264', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000819', null, '0', '0', null, null, null, null, '0', '0', '4000265', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000820', null, '0', '0', null, null, null, null, '0', '0', '4000266', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000821', null, '0', '0', null, null, null, null, '0', '0', '1300118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000822', null, '0', '0', null, null, null, null, '0', '0', '1000061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000823', null, '0', '0', null, null, null, null, '0', '0', '1600210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000824', null, '0', '0', null, null, null, null, '0', '0', '4000267', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000825', null, '0', '0', null, null, null, null, '0', '0', '4000268', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000826', null, '0', '0', null, null, null, null, '0', '0', '4000269', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000827', null, '0', '0', null, null, null, null, '0', '0', '4000270', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000828', null, '0', '0', null, null, null, null, '0', '0', '4000271', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000829', null, '0', '0', null, null, null, null, '0', '0', '1900140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000830', null, '0', '0', null, null, null, null, '0', '0', '1200136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000831', null, '0', '0', null, null, null, null, '0', '0', '1000014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000832', null, '0', '0', null, null, null, null, '0', '0', '1300103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000833', null, '0', '0', null, null, null, null, '0', '0', '4000499', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000834', null, '0', '0', null, null, null, null, '0', '0', '4000500', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000835', null, '0', '0', null, null, null, null, '0', '0', '4000501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000836', null, '0', '0', null, null, null, null, '0', '0', '4000502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000837', null, '0', '0', null, null, null, null, '0', '0', '1900037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000838', null, '0', '0', null, null, null, null, '0', '0', '1400106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000839', null, '0', '0', null, null, null, null, '0', '0', '1900152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000840', 'pplStd_wil0Btl01_08@0B800', '184', '0', '12.18', '196', '133.42', '-1.26', '0', '1017', '1400060', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1000841', null, '184', '0', '10.29', '196', '134.96', '2.45', '0', '0', '1500014', null, 'PopulaceStandard', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000842', null, '184', '0', '11.45', '196.05', '128.44', '-0.52', '0', '0', '1900054', null, 'PopulaceStandard', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000843', null, '0', '0', '-13', '194.91', '76.75', '-2.72', '0', '0', '1100449', null, 'PopulaceStandard', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000844', null, '0', '0', null, null, null, null, '0', '0', '1400017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000845', null, '0', '0', null, null, null, null, '0', '0', '1400017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000846', null, '0', '0', null, null, null, null, '0', '0', '1500017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000847', null, '0', '0', null, null, null, null, '0', '0', '1900025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000848', null, '0', '0', null, null, null, null, '0', '0', '1400022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000849', null, '0', '0', null, null, null, null, '0', '0', '4000386', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000850', null, '0', '0', null, null, null, null, '0', '0', '4000496', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000851', null, '0', '0', null, null, null, null, '0', '0', '4000497', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000852', null, '0', '0', null, null, null, null, '0', '0', '1200008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000853', null, '0', '0', null, null, null, null, '0', '0', '1200030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000854', null, '0', '0', null, null, null, null, '0', '0', '1200030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000855', null, '0', '0', null, null, null, null, '0', '0', '1500114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000856', null, '0', '0', null, null, null, null, '0', '0', '1500114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000857', null, '0', '0', null, null, null, null, '0', '0', '1400080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000858', null, '0', '0', null, null, null, null, '0', '0', '1400081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000859', null, '0', '0', null, null, null, null, '0', '0', '1500089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000860', null, '0', '0', null, null, null, null, '0', '0', '1400024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000861', null, '0', '0', null, null, null, null, '0', '0', '1100016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000862', null, '0', '0', null, null, null, null, '0', '0', '1400019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000863', null, '0', '0', null, null, null, null, '0', '0', '1500022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000864', null, '0', '0', null, null, null, null, '0', '0', '1400113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000865', null, '0', '0', null, null, null, null, '0', '0', '1300128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000866', null, '0', '0', null, null, null, null, '0', '0', '1400110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000867', null, '0', '0', null, null, null, null, '0', '0', '1000260', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000868', null, '0', '0', null, null, null, null, '0', '0', '4000015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000869', null, '0', '0', null, null, null, null, '0', '0', '4000099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000870', null, '0', '0', null, null, null, null, '0', '0', '4000099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000871', null, '0', '0', null, null, null, null, '0', '0', '4000099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000872', null, '0', '0', null, null, null, null, '0', '0', '4000114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000873', null, '0', '0', null, null, null, null, '0', '0', '4000115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000874', null, '0', '0', null, null, null, null, '0', '0', '4000113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000875', null, '0', '0', null, null, null, null, '0', '0', '4000011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000876', null, '0', '0', null, null, null, null, '0', '0', '1900026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000877', null, '0', '0', null, null, null, null, '0', '0', '4000496', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000878', null, '0', '0', null, null, null, null, '0', '0', '4000497', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000879', null, '0', '0', null, null, null, null, '0', '0', '4000498', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000880', null, '0', '0', null, null, null, null, '0', '0', '4000487', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000881', null, '0', '0', null, null, null, null, '0', '0', '4000488', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000882', null, '0', '0', null, null, null, null, '0', '0', '4000489', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000883', null, '0', '0', null, null, null, null, '0', '0', '4000490', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000884', null, '0', '0', null, null, null, null, '0', '0', '1100175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000885', null, '0', '0', null, null, null, null, '0', '0', '4000519', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000886', null, '0', '0', null, null, null, null, '0', '0', '4000520', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000887', null, '0', '0', null, null, null, null, '0', '0', '1900018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000888', null, '0', '0', null, null, null, null, '0', '0', '1500080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000889', null, '0', '0', null, null, null, null, '0', '0', '1500102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000890', null, '0', '0', null, null, null, null, '0', '0', '1400047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000891', null, '0', '0', null, null, null, null, '0', '0', '4000374', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000892', null, '0', '0', null, null, null, null, '0', '0', '4000337', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000893', null, '0', '0', null, null, null, null, '0', '0', '4000375', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000894', null, '0', '0', null, null, null, null, '0', '0', '4000376', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000895', null, '0', '0', null, null, null, null, '0', '0', '4000377', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000896', null, '0', '0', null, null, null, null, '0', '0', '4000378', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000897', null, '0', '0', null, null, null, null, '0', '0', '4000352', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000898', null, '0', '0', null, null, null, null, '0', '0', '4000379', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000899', null, '0', '0', null, null, null, null, '0', '0', '1600269', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000900', null, '0', '0', null, null, null, null, '0', '0', '1200004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000901', null, '0', '0', null, null, null, null, '0', '0', '1500019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000902', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000903', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000904', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000905', null, '0', '0', null, null, null, null, '0', '0', '1500042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000906', null, '0', '0', null, null, null, null, '0', '0', '1500042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000907', null, '0', '0', null, null, null, null, '0', '0', '1300057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000908', null, '0', '0', null, null, null, null, '0', '0', '1900073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000909', null, '0', '0', null, null, null, null, '0', '0', '1100054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000910', null, '0', '0', null, null, null, null, '0', '0', '4000326', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000911', null, '0', '0', null, null, null, null, '0', '0', '4000327', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000912', null, '0', '0', null, null, null, null, '0', '0', '2450001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000913', null, '0', '0', null, null, null, null, '0', '0', '4000328', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000914', null, '0', '0', null, null, null, null, '0', '0', '4000329', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000915', null, '0', '0', null, null, null, null, '0', '0', '1200160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000916', null, '0', '0', null, null, null, null, '0', '0', '1500104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000917', null, '0', '0', null, null, null, null, '0', '0', '1100130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000918', null, '0', '0', null, null, null, null, '0', '0', '1200104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000919', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000920', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000921', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000922', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000923', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000924', null, '0', '0', null, null, null, null, '0', '0', '4000324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000925', null, '0', '0', null, null, null, null, '0', '0', '4000325', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000926', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000927', null, '0', '0', null, null, null, null, '0', '0', '1400023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000928', null, '0', '0', null, null, null, null, '0', '0', '1300015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000929', null, '0', '0', null, null, null, null, '0', '0', '1000235', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000930', null, '0', '0', null, null, null, null, '0', '0', '1500088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000931', null, '0', '0', null, null, null, null, '0', '0', '1900015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000932', null, '0', '0', null, null, null, null, '0', '0', '1900021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000933', null, '0', '0', null, null, null, null, '0', '0', '1100029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000934', null, '0', '0', null, null, null, null, '0', '0', '1400021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000935', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000936', null, '0', '0', null, null, null, null, '0', '0', '4000292', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000937', null, '0', '0', null, null, null, null, '0', '0', '4000293', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000938', null, '0', '0', null, null, null, null, '0', '0', '4000294', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000939', null, '0', '0', null, null, null, null, '0', '0', '4000295', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000940', null, '0', '0', null, null, null, null, '0', '0', '4000296', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000941', null, '0', '0', null, null, null, null, '0', '0', '4000297', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000942', null, '0', '0', null, null, null, null, '0', '0', '4000310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000943', null, '0', '0', null, null, null, null, '0', '0', '4000311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000944', null, '0', '0', null, null, null, null, '0', '0', '4000312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000945', null, '0', '0', null, null, null, null, '0', '0', '4000313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000946', null, '0', '0', null, null, null, null, '0', '0', '4000314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000947', null, '0', '0', null, null, null, null, '0', '0', '4000315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000948', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000949', null, '0', '0', null, null, null, null, '0', '0', '1200166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000950', null, '0', '0', null, null, null, null, '0', '0', '1300001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000951', null, '0', '0', null, null, null, null, '0', '0', '1600102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000952', null, '0', '0', null, null, null, null, '0', '0', '4000335', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000953', null, '0', '0', null, null, null, null, '0', '0', '4000336', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000954', null, '0', '0', null, null, null, null, '0', '0', '1000104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000955', null, '0', '0', null, null, null, null, '0', '0', '1400111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000956', null, '0', '0', null, null, null, null, '0', '0', '1300032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000957', null, '0', '0', null, null, null, null, '0', '0', '4000509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000958', null, '0', '0', null, null, null, null, '0', '0', '4000510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000959', null, '0', '0', null, null, null, null, '0', '0', '4000511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000960', null, '0', '0', null, null, null, null, '0', '0', '4000512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000961', null, '0', '0', null, null, null, null, '0', '0', '4000513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000962', null, '0', '0', null, null, null, null, '0', '0', '1500003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000963', null, '0', '0', null, null, null, null, '0', '0', '2200101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000964', null, '0', '0', null, null, null, null, '0', '0', '1600076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000965', null, '0', '0', null, null, null, null, '0', '0', '1400085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000966', null, '0', '0', null, null, null, null, '0', '0', '1400112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000967', null, '0', '0', null, null, null, null, '0', '0', '1600186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000968', null, '0', '0', null, null, null, null, '0', '0', '1100161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000969', null, '0', '0', null, null, null, null, '0', '0', '1900107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000970', null, '0', '0', null, null, null, null, '0', '0', '4000392', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000971', null, '0', '0', null, null, null, null, '0', '0', '4000393', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000972', null, '0', '0', null, null, null, null, '0', '0', '4000394', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000973', null, '0', '0', null, null, null, null, '0', '0', '4000395', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000974', null, '0', '0', null, null, null, null, '0', '0', '4000396', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000975', null, '0', '0', null, null, null, null, '0', '0', '4000397', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000976', null, '0', '0', null, null, null, null, '0', '0', '4000398', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000977', null, '0', '0', null, null, null, null, '0', '0', '4000399', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000978', null, '0', '0', null, null, null, null, '0', '0', '1000130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000979', null, '0', '0', null, null, null, null, '0', '0', '1200016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000980', null, '0', '0', null, null, null, null, '0', '0', '4000339', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000981', null, '0', '0', null, null, null, null, '0', '0', '4000366', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000982', null, '0', '0', null, null, null, null, '0', '0', '4000367', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000983', null, '0', '0', null, null, null, null, '0', '0', '4000368', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000984', null, '0', '0', null, null, null, null, '0', '0', '4000353', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000985', null, '0', '0', null, null, null, null, '0', '0', '4000358', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000986', null, '0', '0', null, null, null, null, '0', '0', '4000369', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000987', null, '0', '0', null, null, null, null, '0', '0', '4000359', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000988', null, '0', '0', null, null, null, null, '0', '0', '4000370', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000989', null, '0', '0', null, null, null, null, '0', '0', '4000371', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000990', null, '0', '0', null, null, null, null, '0', '0', '4000338', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000991', null, '0', '0', null, null, null, null, '0', '0', '4000340', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000992', null, '0', '0', null, null, null, null, '0', '0', '4000372', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000993', null, '0', '0', null, null, null, null, '0', '0', '4000373', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000994', null, '0', '0', null, null, null, null, '0', '0', '1100088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000995', null, '0', '0', null, null, null, null, '0', '0', '4000341', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000996', null, '0', '0', null, null, null, null, '0', '0', '4000342', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000997', null, '0', '0', null, null, null, null, '0', '0', '4000343', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000998', null, '0', '0', null, null, null, null, '0', '0', '4000344', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1000999', null, '0', '0', null, null, null, null, '0', '0', '4000345', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001000', null, '0', '0', null, null, null, null, '0', '0', '4000346', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001001', null, '0', '0', null, null, null, null, '0', '0', '4000347', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001002', null, '0', '0', null, null, null, null, '0', '0', '1600208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001003', null, '0', '0', null, null, null, null, '0', '0', '1100058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001004', null, '0', '0', null, null, null, null, '0', '0', '1900081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001005', null, '0', '0', null, null, null, null, '0', '0', '1600034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001006', null, '0', '0', null, null, null, null, '0', '0', '1200155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001007', null, '0', '0', null, null, null, null, '0', '0', '1000134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001008', null, '0', '0', null, null, null, null, '0', '0', '4000348', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001009', null, '0', '0', null, null, null, null, '0', '0', '1300104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001010', null, '0', '0', null, null, null, null, '0', '0', '1000184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001011', null, '0', '0', null, null, null, null, '0', '0', '2200187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001012', null, '0', '0', null, null, null, null, '0', '0', '1400105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001013', null, '0', '0', null, null, null, null, '0', '0', '4000515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001014', null, '0', '0', null, null, null, null, '0', '0', '4000354', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001015', null, '0', '0', null, null, null, null, '0', '0', '4000355', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001016', null, '0', '0', null, null, null, null, '0', '0', '4000356', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001017', null, '0', '0', null, null, null, null, '0', '0', '4000357', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001018', null, '0', '0', null, null, null, null, '0', '0', '1600029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001019', null, '0', '0', null, null, null, null, '0', '0', '1200156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001020', null, '0', '0', null, null, null, null, '0', '0', '4000360', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001021', null, '0', '0', null, null, null, null, '0', '0', '4000361', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001022', null, '0', '0', null, null, null, null, '0', '0', '1400108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001023', null, '0', '0', null, null, null, null, '0', '0', '4000362', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001024', null, '0', '0', null, null, null, null, '0', '0', '4000363', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001025', null, '0', '0', null, null, null, null, '0', '0', '4000364', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001026', null, '0', '0', null, null, null, null, '0', '0', '4000365', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001027', null, '0', '0', null, null, null, null, '0', '0', '1900087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001028', null, '0', '0', null, null, null, null, '0', '0', '4000349', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001029', null, '0', '0', null, null, null, null, '0', '0', '1100007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001030', null, '0', '0', null, null, null, null, '0', '0', '4000350', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001031', null, '0', '0', null, null, null, null, '0', '0', '4000351', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001032', null, '0', '0', null, null, null, null, '0', '0', '1300125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001033', null, '0', '0', null, null, null, null, '0', '0', '1100404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001034', null, '0', '0', null, null, null, null, '0', '0', '4000388', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001035', null, '0', '0', null, null, null, null, '0', '0', '4000330', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001036', null, '0', '0', null, null, null, null, '0', '0', '4000331', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001037', null, '0', '0', null, null, null, null, '0', '0', '4000332', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001038', null, '0', '0', null, null, null, null, '0', '0', '4000333', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001039', null, '0', '0', null, null, null, null, '0', '0', '4000334', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001040', null, '0', '0', null, null, null, null, '0', '0', '4000380', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001041', null, '0', '0', null, null, null, null, '0', '0', '4000381', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001042', null, '0', '0', null, null, null, null, '0', '0', '4000382', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001043', null, '0', '0', null, null, null, null, '0', '0', '4000383', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001044', null, '0', '0', null, null, null, null, '0', '0', '4000384', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001045', null, '0', '0', null, null, null, null, '0', '0', '4000385', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001046', null, '0', '0', null, null, null, null, '0', '0', '1500054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001047', null, '0', '0', null, null, null, null, '0', '0', '1000392', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001048', null, '0', '0', null, null, null, null, '0', '0', '1400089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001049', null, '0', '0', null, null, null, null, '0', '0', '2450008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001050', null, '0', '0', null, null, null, null, '0', '0', '1400008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001051', null, '0', '0', null, null, null, null, '0', '0', '1400061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001052', null, '0', '0', null, null, null, null, '0', '0', '1500075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001053', null, '0', '0', null, null, null, null, '0', '0', '1300113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001054', null, '0', '0', null, null, null, null, '0', '0', '1200025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001055', null, '0', '0', null, null, null, null, '0', '0', '1000055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001056', null, '0', '0', null, null, null, null, '0', '0', '1500111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001057', null, '0', '0', null, null, null, null, '0', '0', '4000259', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001058', null, '0', '0', null, null, null, null, '0', '0', '4000258', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001059', null, '0', '0', null, null, null, null, '0', '0', '4000260', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001060', null, '0', '0', null, null, null, null, '0', '0', '4000261', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001061', null, '0', '0', null, null, null, null, '0', '0', '4000262', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001062', null, '0', '0', null, null, null, null, '0', '0', '4000263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001063', null, '0', '0', null, null, null, null, '0', '0', '1600114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001064', null, '0', '0', null, null, null, null, '0', '0', '1600093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001065', null, '0', '0', null, null, null, null, '0', '0', '1900131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001066', null, '0', '0', null, null, null, null, '0', '0', '1600256', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001067', null, '0', '0', null, null, null, null, '0', '0', '1900080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001068', null, '0', '0', null, null, null, null, '0', '0', '1200157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001069', null, '0', '0', null, null, null, null, '0', '0', '1100401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001070', null, '0', '0', null, null, null, null, '0', '0', '2200073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001071', null, '0', '0', null, null, null, null, '0', '0', '1900093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001072', null, '0', '0', null, null, null, null, '0', '0', '1400050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001073', null, '0', '0', null, null, null, null, '0', '0', '1400099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001074', null, '0', '0', null, null, null, null, '0', '0', '1500087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001075', null, '0', '0', null, null, null, null, '0', '0', '2200058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001076', null, '0', '0', null, null, null, null, '0', '0', '1400023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001077', null, '0', '0', null, null, null, null, '0', '0', '1000362', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001078', null, '0', '0', null, null, null, null, '0', '0', '1100372', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001079', null, '0', '0', null, null, null, null, '0', '0', '1600061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001080', null, '0', '0', null, null, null, null, '0', '0', '1400114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001081', null, '0', '0', null, null, null, null, '0', '0', '1900122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001082', null, '0', '0', null, null, null, null, '0', '0', '1100094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001083', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001084', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001085', null, '0', '0', null, null, null, null, '0', '0', '2450002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001086', null, '0', '0', null, null, null, null, '0', '0', '2450004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001087', null, '0', '0', null, null, null, null, '0', '0', '2450007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001088', null, '0', '0', null, null, null, null, '0', '0', '2450003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001089', null, '0', '0', null, null, null, null, '0', '0', '2450005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001090', null, '0', '0', null, null, null, null, '0', '0', '2450006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001091', null, '0', '0', null, null, null, null, '0', '0', '2450009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001092', null, '0', '0', null, null, null, null, '0', '0', '2450010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001093', null, '0', '0', null, null, null, null, '0', '0', '4000503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001094', null, '0', '0', null, null, null, null, '0', '0', '4000504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001095', null, '0', '0', null, null, null, null, '0', '0', '4000505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001096', null, '0', '0', null, null, null, null, '0', '0', '4000506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001097', null, '0', '0', null, null, null, null, '0', '0', '4000507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001098', null, '0', '0', null, null, null, null, '0', '0', '4000508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001099', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001100', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001101', null, '0', '0', null, null, null, null, '0', '0', '1900142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001102', null, '0', '0', null, null, null, null, '0', '0', '1000223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001103', null, '0', '0', null, null, null, null, '0', '0', '1200141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001104', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001105', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001106', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001107', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001108', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001109', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001110', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001111', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001112', null, '0', '0', null, null, null, null, '0', '0', '4000517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001113', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001114', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001115', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001117', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001118', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001119', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001120', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001121', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001122', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001123', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001124', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001125', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001126', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001127', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001128', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001129', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001130', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001131', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001132', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001133', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001134', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001135', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001136', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001137', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001138', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001139', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001140', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001141', null, '0', '0', null, null, null, null, '0', '0', '1400117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001142', null, '0', '0', null, null, null, null, '0', '0', '1400095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001143', null, '0', '0', null, null, null, null, '0', '0', '1500020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001144', null, '0', '0', null, null, null, null, '0', '0', '1600085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001145', null, '0', '0', null, null, null, null, '0', '0', '1300074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001146', null, '0', '0', null, null, null, null, '0', '0', '1600261', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001147', null, '0', '0', null, null, null, null, '0', '0', '1900126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001148', null, '0', '0', null, null, null, null, '0', '0', '1400094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001149', null, '0', '0', null, null, null, null, '0', '0', '1000118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001150', null, '0', '0', null, null, null, null, '0', '0', '1200102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001151', null, '0', '0', null, null, null, null, '0', '0', '1100173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001152', null, '0', '0', null, null, null, null, '0', '0', '1400118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001153', null, '0', '0', null, null, null, null, '0', '0', '1500081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001154', null, '0', '0', null, null, null, null, '0', '0', '1600062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001155', null, '0', '0', null, null, null, null, '0', '0', '1000159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001156', null, '0', '0', null, null, null, null, '0', '0', '1300109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001157', null, '0', '0', null, null, null, null, '0', '0', '1500092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001158', null, '0', '0', null, null, null, null, '0', '0', '1200083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001159', null, '0', '0', null, null, null, null, '0', '0', '1400115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001160', null, '0', '0', null, null, null, null, '0', '0', '1600073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001161', null, '0', '0', null, null, null, null, '0', '0', '1900149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001162', null, '0', '0', null, null, null, null, '0', '0', '1200163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001163', null, '0', '0', null, null, null, null, '0', '0', '2200052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001164', null, '0', '0', null, null, null, null, '0', '0', '1500108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001165', null, '0', '0', null, null, null, null, '0', '0', '1400041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001166', null, '0', '0', null, null, null, null, '0', '0', '1400031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001167', null, '0', '0', null, null, null, null, '0', '0', '1500047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001168', null, '0', '0', null, null, null, null, '0', '0', '1500074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001169', null, '0', '0', null, null, null, null, '0', '0', '1200149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001170', null, '0', '0', null, null, null, null, '0', '0', '1600118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001171', null, '0', '0', null, null, null, null, '0', '0', '1900146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001172', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001173', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001174', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001175', null, '0', '0', null, null, null, null, '0', '0', '1100261', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001176', null, '0', '0', null, null, null, null, '0', '0', '1000022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001177', null, '0', '0', null, null, null, null, '0', '0', '1900092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001178', null, '0', '0', null, null, null, null, '0', '0', '2450012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001179', null, '0', '0', null, null, null, null, '0', '0', '2450013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001180', null, '0', '0', null, null, null, null, '0', '0', '2450014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001181', null, '0', '0', null, null, null, null, '0', '0', '2450015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001182', null, '0', '0', null, null, null, null, '0', '0', '1400068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001183', null, '0', '0', null, null, null, null, '0', '0', '1100126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001184', null, '0', '0', null, null, null, null, '0', '0', '1000131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001185', null, '0', '0', null, null, null, null, '0', '0', '1000333', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001186', null, '0', '0', null, null, null, null, '0', '0', '1900094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001187', null, '0', '0', null, null, null, null, '0', '0', '1400104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001188', null, '0', '0', null, null, null, null, '0', '0', '1100374', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001189', null, '0', '0', null, null, null, null, '0', '0', '1500110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001190', null, '0', '0', null, null, null, null, '0', '0', '1200043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001191', null, '0', '0', null, null, null, null, '0', '0', '1000213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001192', null, '0', '0', null, null, null, null, '0', '0', '1300033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001193', null, '0', '0', null, null, null, null, '0', '0', '1600214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001194', null, '0', '0', null, null, null, null, '0', '0', '1400075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001195', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001196', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001197', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001198', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001199', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001200', null, '0', '0', null, null, null, null, '0', '0', '1300139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001201', null, '0', '0', null, null, null, null, '0', '0', '1300124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001202', null, '0', '0', null, null, null, null, '0', '0', '1200169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001203', null, '0', '0', null, null, null, null, '0', '0', '1900130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001204', null, '0', '0', null, null, null, null, '0', '0', '1900113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001205', null, '0', '0', null, null, null, null, '0', '0', '1100417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001206', null, '0', '0', null, null, null, null, '0', '0', '1900101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001207', null, '0', '0', null, null, null, null, '0', '0', '4000401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001208', null, '0', '0', null, null, null, null, '0', '0', '4000402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001209', null, '0', '0', null, null, null, null, '0', '0', '4000403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001210', null, '0', '0', null, null, null, null, '0', '0', '4000404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001211', null, '0', '0', null, null, null, null, '0', '0', '1100395', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001212', null, '0', '0', null, null, null, null, '0', '0', '1200144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001213', null, '0', '0', null, null, null, null, '0', '0', '1000079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001214', null, '0', '0', null, null, null, null, '0', '0', '4000405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001215', null, '0', '0', null, null, null, null, '0', '0', '4000406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001216', null, '0', '0', null, null, null, null, '0', '0', '4000407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001217', null, '0', '0', null, null, null, null, '0', '0', '1900018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001218', null, '0', '0', null, null, null, null, '0', '0', '1400024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001219', null, '0', '0', null, null, null, null, '0', '0', '1600240', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001220', null, '0', '0', null, null, null, null, '0', '0', '4000408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001221', null, '0', '0', null, null, null, null, '0', '0', '4000409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001222', null, '0', '0', null, null, null, null, '0', '0', '4000410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001223', null, '0', '0', null, null, null, null, '0', '0', '4000411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001224', null, '0', '0', null, null, null, null, '0', '0', '1000135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001225', null, '0', '0', null, null, null, null, '0', '0', '4000412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001226', null, '0', '0', null, null, null, null, '0', '0', '4000413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001227', null, '0', '0', null, null, null, null, '0', '0', '4000414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001228', null, '0', '0', null, null, null, null, '0', '0', '1600159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001229', null, '0', '0', null, null, null, null, '0', '0', '1200152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001230', null, '0', '0', null, null, null, null, '0', '0', '1900127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001231', null, '0', '0', null, null, null, null, '0', '0', '4000415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001232', null, '0', '0', null, null, null, null, '0', '0', '4000416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001233', null, '0', '0', null, null, null, null, '0', '0', '4000417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001234', null, '0', '0', null, null, null, null, '0', '0', '4000418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001235', null, '0', '0', null, null, null, null, '0', '0', '4000419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001236', null, '0', '0', null, null, null, null, '0', '0', '4000420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001237', null, '0', '0', null, null, null, null, '0', '0', '2450020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001238', null, '0', '0', null, null, null, null, '0', '0', '2450021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001239', null, '0', '0', null, null, null, null, '0', '0', '4000421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001240', null, '0', '0', null, null, null, null, '0', '0', '4000422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001241', null, '0', '0', null, null, null, null, '0', '0', '4000423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001242', null, '0', '0', null, null, null, null, '0', '0', '4000424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001243', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001244', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001245', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001246', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001247', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001248', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001249', null, '0', '0', null, null, null, null, '0', '0', '4000425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001250', null, '0', '0', null, null, null, null, '0', '0', '4000426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001251', null, '0', '0', null, null, null, null, '0', '0', '4000427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001252', null, '0', '0', null, null, null, null, '0', '0', '2480001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001253', null, '0', '0', null, null, null, null, '0', '0', '4000428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001254', null, '0', '0', null, null, null, null, '0', '0', '4000429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001255', null, '0', '0', null, null, null, null, '0', '0', '4000430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001256', null, '0', '0', null, null, null, null, '0', '0', '2200127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001257', null, '0', '0', null, null, null, null, '0', '0', '1000322', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001258', null, '0', '0', null, null, null, null, '0', '0', '1300030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001259', null, '0', '0', null, null, null, null, '0', '0', '1600190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001260', null, '0', '0', null, null, null, null, '0', '0', '1900082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001261', null, '0', '0', null, null, null, null, '0', '0', '1300049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001262', null, '0', '0', null, null, null, null, '0', '0', '1000072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001263', null, '0', '0', null, null, null, null, '0', '0', '1400132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001264', null, '0', '0', null, null, null, null, '0', '0', '1900061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001265', null, '0', '0', null, null, null, null, '0', '0', '4000431', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001266', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001267', null, '0', '0', null, null, null, null, '0', '0', '1200183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001268', null, '0', '0', null, null, null, null, '0', '0', '1300121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001269', null, '0', '0', null, null, null, null, '0', '0', '1200185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001270', null, '0', '0', null, null, null, null, '0', '0', '4000432', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001271', null, '0', '0', null, null, null, null, '0', '0', '4000433', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001272', null, '0', '0', null, null, null, null, '0', '0', '4000434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001273', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001274', null, '0', '0', null, null, null, null, '0', '0', '4000435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001275', null, '0', '0', null, null, null, null, '0', '0', '4000436', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001276', null, '0', '0', null, null, null, null, '0', '0', '4000437', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001277', null, '0', '0', null, null, null, null, '0', '0', '4000438', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001278', null, '0', '0', null, null, null, null, '0', '0', '4000439', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001279', null, '0', '0', null, null, null, null, '0', '0', '4000440', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001280', null, '0', '0', null, null, null, null, '0', '0', '4000441', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001281', null, '0', '0', null, null, null, null, '0', '0', '4000442', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001282', null, '0', '0', null, null, null, null, '0', '0', '4000443', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001283', null, '0', '0', null, null, null, null, '0', '0', '4000444', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001284', null, '0', '0', null, null, null, null, '0', '0', '4000445', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001285', null, '0', '0', null, null, null, null, '0', '0', '1300144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001286', null, '0', '0', null, null, null, null, '0', '0', '1400127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001287', null, '0', '0', null, null, null, null, '0', '0', '4000446', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001288', null, '0', '0', null, null, null, null, '0', '0', '4000447', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001289', null, '0', '0', null, null, null, null, '0', '0', '4000448', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001290', null, '0', '0', null, null, null, null, '0', '0', '4000449', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001291', null, '0', '0', null, null, null, null, '0', '0', '4000111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001292', null, '0', '0', null, null, null, null, '0', '0', '4000111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001293', null, '0', '0', null, null, null, null, '0', '0', '4000111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001294', null, '0', '0', null, null, null, null, '0', '0', '1300138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001295', null, '0', '0', null, null, null, null, '0', '0', '1000065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001296', null, '0', '0', null, null, null, null, '0', '0', '1600236', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001297', null, '0', '0', null, null, null, null, '0', '0', '1100049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001298', null, '0', '0', null, null, null, null, '0', '0', '1500045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001299', null, '0', '0', null, null, null, null, '0', '0', '1900141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001300', null, '0', '0', null, null, null, null, '0', '0', '1600121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001301', null, '0', '0', null, null, null, null, '0', '0', '1500121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001302', null, '0', '0', null, null, null, null, '0', '0', '1600290', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001303', null, '0', '0', null, null, null, null, '0', '0', '1200135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001304', null, '0', '0', null, null, null, null, '0', '0', '1600169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001305', null, '0', '0', null, null, null, null, '0', '0', '1900017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001306', null, '0', '0', null, null, null, null, '0', '0', '1600198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001307', null, '0', '0', null, null, null, null, '0', '0', '1900133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001308', null, '0', '0', null, null, null, null, '0', '0', '1600111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001309', null, '0', '0', null, null, null, null, '0', '0', '1900174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001310', null, '0', '0', null, null, null, null, '0', '0', '2200234', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001311', null, '0', '0', null, null, null, null, '0', '0', '1900153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001312', null, '0', '0', null, null, null, null, '0', '0', '1600291', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001313', null, '0', '0', null, null, null, null, '0', '0', '1600303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001314', null, '0', '0', null, null, null, null, '0', '0', '1200139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001315', null, '0', '0', null, null, null, null, '0', '0', '1500120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001316', null, '0', '0', null, null, null, null, '0', '0', '1500067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001317', null, '0', '0', null, null, null, null, '0', '0', '1400140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001318', null, '0', '0', null, null, null, null, '0', '0', '1400145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001319', null, '0', '0', null, null, null, null, '0', '0', '2200055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001320', null, '0', '0', null, null, null, null, '0', '0', '1500012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001321', null, '0', '0', null, null, null, null, '0', '0', '1500018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001322', null, '0', '0', null, null, null, null, '0', '0', '1400139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001323', null, '0', '0', null, null, null, null, '0', '0', '1300100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001324', null, '0', '0', null, null, null, null, '0', '0', '1400120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001325', null, '0', '0', null, null, null, null, '0', '0', '1900161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001326', null, '0', '0', null, null, null, null, '0', '0', '1100142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001327', null, '0', '0', null, null, null, null, '0', '0', '1500053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001328', null, '0', '0', null, null, null, null, '0', '0', '2200039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001329', null, '0', '0', null, null, null, null, '0', '0', '1400123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001330', null, '0', '0', null, null, null, null, '0', '0', '1100245', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001331', null, '0', '0', null, null, null, null, '0', '0', '1600149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001332', null, '0', '0', null, null, null, null, '0', '0', '2200050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001333', null, '0', '0', null, null, null, null, '0', '0', '2200198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001334', null, '0', '0', null, null, null, null, '0', '0', '2200199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001335', null, '0', '0', null, null, null, null, '0', '0', '1500122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001336', null, '0', '0', null, null, null, null, '0', '0', '1100178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001337', null, '0', '0', null, null, null, null, '0', '0', '1000384', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001338', null, '0', '0', null, null, null, null, '0', '0', '1100093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001339', null, '0', '0', null, null, null, null, '0', '0', '1100158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001340', null, '0', '0', null, null, null, null, '0', '0', '1100159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001341', null, '0', '0', null, null, null, null, '0', '0', '1000374', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001342', null, '0', '0', null, null, null, null, '0', '0', '1600104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001343', null, '0', '0', null, null, null, null, '0', '0', '1400124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001344', null, '0', '0', null, null, null, null, '0', '0', '1000093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001345', null, '0', '0', null, null, null, null, '0', '0', '1000094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001346', null, '0', '0', null, null, null, null, '0', '0', '1500041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001347', null, '0', '0', null, null, null, null, '0', '0', '1600292', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001348', null, '0', '0', null, null, null, null, '0', '0', '1000176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001349', null, '0', '0', null, null, null, null, '0', '0', '1000177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001350', null, '0', '0', null, null, null, null, '0', '0', '1200172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001351', null, '0', '0', null, null, null, null, '0', '0', '1900181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001352', null, '0', '0', null, null, null, null, '0', '0', '1100071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001353', null, '0', '0', null, null, null, null, '0', '0', '1100082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001354', null, '0', '0', null, null, null, null, '0', '0', '2200242', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001355', null, '0', '0', null, null, null, null, '0', '0', '1300098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001356', null, '0', '0', null, null, null, null, '0', '0', '1200164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001357', null, '0', '0', null, null, null, null, '0', '0', '1600086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001358', null, '0', '0', null, null, null, null, '0', '0', '1000190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001359', null, '0', '0', null, null, null, null, '0', '0', '1300101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001360', null, '0', '0', null, null, null, null, '0', '0', '1300102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001361', null, '0', '0', null, null, null, null, '0', '0', '1200159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001362', null, '0', '0', null, null, null, null, '0', '0', '1500123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001363', null, '0', '0', null, null, null, null, '0', '0', '1300106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001364', null, '0', '0', null, null, null, null, '0', '0', '1000211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001365', null, '0', '0', null, null, null, null, '0', '0', '1100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001366', null, '0', '0', null, null, null, null, '0', '0', '1300099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001367', null, '0', '0', null, null, null, null, '0', '0', '1200087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001368', null, '0', '0', null, null, null, null, '0', '0', '1200088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001369', null, '0', '0', null, null, null, null, '0', '0', '1300087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001370', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001371', null, '0', '0', null, null, null, null, '0', '0', '1400141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001372', null, '0', '0', null, null, null, null, '0', '0', '1000106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001373', null, '0', '0', null, null, null, null, '0', '0', '1900129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001374', null, '0', '0', null, null, null, null, '0', '0', '1400142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001375', null, '0', '0', null, null, null, null, '0', '0', '1000125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001376', null, '0', '0', null, null, null, null, '0', '0', '1500130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001377', null, '0', '0', null, null, null, null, '0', '0', '1500141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001378', null, '0', '0', null, null, null, null, '0', '0', '1200184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001379', null, '0', '0', null, null, null, null, '0', '0', '4000549', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001380', null, '0', '0', null, null, null, null, '0', '0', '1500142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001381', null, '0', '0', null, null, null, null, '0', '0', '1300132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001382', null, '0', '0', null, null, null, null, '0', '0', '1000371', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001383', null, '0', '0', null, null, null, null, '0', '0', '1000403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001384', null, '0', '0', null, null, null, null, '0', '0', '1400064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001385', null, '0', '0', null, null, null, null, '0', '0', '2450024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001386', null, '0', '0', null, null, null, null, '0', '0', '2450025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001387', null, '0', '0', null, null, null, null, '0', '0', '2450026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001388', null, '0', '0', null, null, null, null, '0', '0', '2450027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001389', null, '0', '0', null, null, null, null, '0', '0', '2450028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001390', null, '0', '0', null, null, null, null, '0', '0', '4000550', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001391', null, '0', '0', null, null, null, null, '0', '0', '4000551', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001392', null, '0', '0', null, null, null, null, '0', '0', '1500091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001393', null, '0', '0', null, null, null, null, '0', '0', '2470016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001394', null, '0', '0', null, null, null, null, '0', '0', '2470017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001395', null, '0', '0', null, null, null, null, '0', '0', '2470018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001396', null, '0', '0', null, null, null, null, '0', '0', '1000164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001397', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001398', null, '0', '0', null, null, null, null, '0', '0', '2200096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001399', null, '0', '0', null, null, null, null, '0', '0', '4000553', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001400', null, '0', '0', null, null, null, null, '0', '0', '4000554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001401', null, '0', '0', null, null, null, null, '0', '0', '4000555', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001402', null, '0', '0', null, null, null, null, '0', '0', '4000556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001403', null, '0', '0', null, null, null, null, '0', '0', '4000557', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001404', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001405', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001406', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001407', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001408', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001409', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001410', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001411', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001412', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001413', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001414', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001415', null, '0', '0', null, null, null, null, '0', '0', '1100235', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001416', null, '0', '0', null, null, null, null, '0', '0', '1600297', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001417', null, '0', '0', null, null, null, null, '0', '0', '1400092', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001418', null, '0', '0', null, null, null, null, '0', '0', '1600248', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001419', null, '0', '0', null, null, null, null, '0', '0', '1500135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001420', null, '0', '0', null, null, null, null, '0', '0', '1500124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001421', null, '0', '0', null, null, null, null, '0', '0', '1400119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001422', null, '0', '0', null, null, null, null, '0', '0', '1500126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001423', null, '0', '0', null, null, null, null, '0', '0', '1400155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001424', null, '0', '0', null, null, null, null, '0', '0', '1400157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001425', null, '0', '0', null, null, null, null, '0', '0', '1900158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001426', null, '0', '0', null, null, null, null, '0', '0', '1500116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001427', null, '0', '0', null, null, null, null, '0', '0', '1200153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001428', null, '0', '0', null, null, null, null, '0', '0', '1400156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001429', null, '0', '0', null, null, null, null, '0', '0', '1500117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001430', null, '0', '0', null, null, null, null, '0', '0', '1000157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001431', null, '0', '0', null, null, null, null, '0', '0', '1100194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001432', null, '0', '0', null, null, null, null, '0', '0', '1000172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001433', null, '0', '0', null, null, null, null, '0', '0', '2200228', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001434', null, '0', '0', null, null, null, null, '0', '0', '1100396', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001435', null, '0', '0', null, null, null, null, '0', '0', '1300131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001436', null, '0', '0', null, null, null, null, '0', '0', '1000188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001437', null, '0', '0', null, null, null, null, '0', '0', '1100426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001438', null, '0', '0', null, null, null, null, '0', '0', '1400122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001439', null, '0', '0', null, null, null, null, '0', '0', '2200226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001440', null, '0', '0', null, null, null, null, '0', '0', '1500127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001441', null, '0', '0', null, null, null, null, '0', '0', '2200254', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001442', null, '0', '0', null, null, null, null, '0', '0', '1100163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001443', null, '0', '0', null, null, null, null, '0', '0', '1100354', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001444', null, '0', '0', null, null, null, null, '0', '0', '1000215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001445', null, '0', '0', null, null, null, null, '0', '0', '1000229', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001446', null, '0', '0', null, null, null, null, '0', '0', '1100189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001447', null, '0', '0', null, null, null, null, '0', '0', '1000237', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001448', null, '0', '0', null, null, null, null, '0', '0', '2200236', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001449', null, '0', '0', null, null, null, null, '0', '0', '1600282', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001450', null, '0', '0', null, null, null, null, '0', '0', '1400158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001451', null, '0', '0', null, null, null, null, '0', '0', '4000536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001452', null, '0', '0', null, null, null, null, '0', '0', '4000536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001453', null, '0', '0', null, null, null, null, '0', '0', '4000536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001454', null, '0', '0', null, null, null, null, '0', '0', '4000536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001455', null, '0', '0', null, null, null, null, '0', '0', '4000536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001456', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001457', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001458', 'pplShopSal_05@08500', '133', '0', '-482.08', '44.5', '403.33', '0.87', '0', '1017', '1600172', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001459', null, '0', '0', null, null, null, null, '0', '0', '1300129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001460', null, '0', '0', null, null, null, null, '0', '0', '1300141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001461', null, '0', '0', null, null, null, null, '0', '0', '1200180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001462', null, '0', '0', null, null, null, null, '0', '0', '1900116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001463', null, '0', '0', null, null, null, null, '0', '0', '1500025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001464', null, '0', '0', null, null, null, null, '0', '0', '1000247', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001465', null, '0', '0', null, null, null, null, '0', '0', '1500061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001466', null, '0', '0', null, null, null, null, '0', '0', '1900137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001467', null, '0', '0', null, null, null, null, '0', '0', '1200171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001468', null, '0', '0', null, null, null, null, '0', '0', '1100133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001469', null, '0', '0', null, null, null, null, '0', '0', '1100061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001470', null, '0', '0', null, null, null, null, '0', '0', '1100445', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001471', null, '0', '0', null, null, null, null, '0', '0', '1500056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001472', null, '0', '0', null, null, null, null, '0', '0', '1500057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001473', null, '0', '0', null, null, null, null, '0', '0', '1900121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001474', null, '0', '0', null, null, null, null, '0', '0', '1600285', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001475', null, '0', '0', null, null, null, null, '0', '0', '1300035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001476', null, '0', '0', null, null, null, null, '0', '0', '1900134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001477', null, '0', '0', null, null, null, null, '0', '0', '1900148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001478', null, '0', '0', null, null, null, null, '0', '0', '4000599', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001479', null, '0', '0', null, null, null, null, '0', '0', '4000599', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001480', null, '0', '0', null, null, null, null, '0', '0', '4000599', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001481', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001482', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001483', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001484', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001485', null, '0', '0', null, null, null, null, '0', '0', '4000537', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001486', null, '0', '0', null, null, null, null, '0', '0', '4000538', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001487', null, '0', '0', null, null, null, null, '0', '0', '4000539', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001488', null, '0', '0', null, null, null, null, '0', '0', '4000540', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001489', null, '0', '0', null, null, null, null, '0', '0', '4000541', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001490', 'pplStd_wil0Btl01_01@0B800', '184', '0', '-19.7', '196', '79.93', '-0.38', '0', '1009', '4000542', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001491', 'pplStd_wil0Btl01_02@0B800', '184', '0', '0.19', '196', '127.07', '-2.94', '0', '1021', '4000543', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001492', 'pplStd_wil0Btl01_03@0B800', '184', '0', '0.8', '196', '103.18', '-1.13', '0', '1015', '4000544', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001493', 'pplStd_wil0Btl01_04@0B800', '184', '0', '-33.57', '196', '82.42', '1.63', '0', '1013', '4000545', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001494', 'pplStd_wil0Btl01_05@0B800', '184', '0', '-9.13', '196', '114.84', '2.33', '0', '1031', '4000546', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001495', 'pplStd_wil0Btl01_06@0B800', '184', '0', '-19.11', '196', '95.09', '2.13', '0', '1037', '4000547', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001496', 'pplStd_wil0Btl01_07@0B800', '184', '0', '-32.37', '196', '80.75', '-0.74', '0', '1101', '4000548', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001497', null, '0', '0', null, null, null, null, '0', '0', '1400161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001498', null, '0', '0', null, null, null, null, '0', '0', '1100422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001499', null, '0', '0', null, null, null, null, '0', '0', '1200181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001500', null, '0', '0', null, null, null, null, '0', '0', '1200175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001501', null, '0', '0', null, null, null, null, '0', '0', '1100420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001502', null, '0', '0', null, null, null, null, '0', '0', '1600209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001503', null, '0', '0', null, null, null, null, '0', '0', '1000123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001504', null, '0', '0', null, null, null, null, '0', '0', '1500133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001505', null, '0', '0', null, null, null, null, '0', '0', '1600306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001506', null, '0', '0', null, null, null, null, '0', '0', '1300136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001507', null, '0', '0', null, null, null, null, '0', '0', '2200204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001508', null, '0', '0', null, null, null, null, '0', '0', '1300051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001509', null, '0', '0', null, null, null, null, '0', '0', '1600196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001510', null, '0', '0', null, null, null, null, '0', '0', '1600305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001511', null, '0', '0', null, null, null, null, '0', '0', '1400154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001512', null, '0', '0', null, null, null, null, '0', '0', '2200211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001513', null, '0', '0', null, null, null, null, '0', '0', '1900156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001514', null, '0', '0', null, null, null, null, '0', '0', '1900054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001515', null, '0', '0', null, null, null, null, '0', '0', '1100003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001516', null, '0', '0', null, null, null, null, '0', '0', '1200030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001517', null, '0', '0', null, null, null, null, '0', '0', '2450021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001518', null, '0', '0', null, null, null, null, '0', '0', '1400012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001519', null, '0', '0', null, null, null, null, '0', '0', '4000231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001520', null, '0', '0', null, null, null, null, '0', '0', '4000241', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001521', null, '0', '0', null, null, null, null, '0', '0', '4000556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001522', null, '0', '0', null, null, null, null, '0', '0', '4000555', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001523', null, '0', '0', null, null, null, null, '0', '0', '4000557', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001524', null, '0', '0', null, null, null, null, '0', '0', '4000553', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001525', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001526', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001527', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001528', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001529', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001530', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001531', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001532', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001533', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001534', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001535', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001536', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001537', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001538', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001539', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001540', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001541', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001542', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001543', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001544', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001553', null, '0', '0', null, null, null, null, '0', '0', '2450016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001554', null, '0', '0', null, null, null, null, '0', '0', '1600262', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001555', null, '0', '0', null, null, null, null, '0', '0', '1500049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001556', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001557', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001558', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001559', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001560', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001561', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001562', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001563', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001564', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001565', null, '0', '0', null, null, null, null, '0', '0', '1100290', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001566', null, '0', '0', null, null, null, null, '0', '0', '1300021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001567', null, '0', '0', null, null, null, null, '0', '0', '1100136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001568', null, '0', '0', null, null, null, null, '0', '0', '1700011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001569', null, '0', '0', null, null, null, null, '0', '0', '2700006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001570', null, '0', '0', null, null, null, null, '0', '0', '2700007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001571', null, '0', '0', null, null, null, null, '0', '0', '2700008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001572', null, '0', '0', null, null, null, null, '0', '0', '2700004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001573', null, '0', '0', null, null, null, null, '0', '0', '2500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001574', null, '0', '0', null, null, null, null, '0', '0', '1200162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001575', null, '0', '0', null, null, null, null, '0', '0', '1900166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001576', null, '0', '0', null, null, null, null, '0', '0', '1000169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001577', null, '0', '0', null, null, null, null, '0', '0', '1400182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001578', null, '0', '0', null, null, null, null, '0', '0', '1300019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001579', null, '0', '0', null, null, null, null, '0', '0', '1600004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001580', null, '0', '0', null, null, null, null, '0', '0', '2200047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001581', null, '0', '0', null, null, null, null, '0', '0', '1500115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001582', null, '0', '0', null, null, null, null, '0', '0', '1600184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001583', null, '0', '0', null, null, null, null, '0', '0', '1300175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001584', null, '0', '0', null, null, null, null, '0', '0', '1500030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001585', null, '0', '0', null, null, null, null, '0', '0', '1000251', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001586', null, '0', '0', null, null, null, null, '0', '0', '2600006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001587', null, '0', '0', null, null, null, null, '0', '0', '2600004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001588', null, '0', '0', null, null, null, null, '0', '0', '1900264', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001589', null, '0', '0', null, null, null, null, '0', '0', '1000365', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001590', null, '0', '0', null, null, null, null, '0', '0', '2600001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001591', null, '0', '0', null, null, null, null, '0', '0', '2600002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001592', null, '0', '0', null, null, null, null, '0', '0', '1100018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001593', null, '0', '0', null, null, null, null, '0', '0', '1100128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001594', null, '0', '0', null, null, null, null, '0', '0', '2600003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001595', null, '0', '0', null, null, null, null, '0', '0', '2600005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001596', null, '0', '0', null, null, null, null, '0', '0', '2200003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001597', null, '0', '0', null, null, null, null, '0', '0', '1400128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001598', null, '0', '0', null, null, null, null, '0', '0', '1000044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001599', null, '0', '0', null, null, null, null, '0', '0', '1400163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001600', null, '0', '0', null, null, null, null, '0', '0', '1200036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001601', null, '0', '0', null, null, null, null, '0', '0', '1000025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001602', null, '0', '0', null, null, null, null, '0', '0', '1900143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001603', null, '0', '0', null, null, null, null, '0', '0', '1500063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001604', null, '0', '0', null, null, null, null, '0', '0', '1900139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001605', null, '0', '0', null, null, null, null, '0', '0', '1000057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001606', null, '0', '0', null, null, null, null, '0', '0', '1400160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001607', null, '0', '0', null, null, null, null, '0', '0', '1100174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001608', null, '0', '0', null, null, null, null, '0', '0', '1300151', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001609', null, '0', '0', null, null, null, null, '0', '0', '1600005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001610', null, '0', '0', null, null, null, null, '0', '0', '1200038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001611', null, '0', '0', null, null, null, null, '0', '0', '1600080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001612', null, '0', '0', null, null, null, null, '0', '0', '1100371', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001613', null, '0', '0', null, null, null, null, '0', '0', '1900102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001614', null, '0', '0', null, null, null, null, '0', '0', '1400199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001615', null, '0', '0', null, null, null, null, '0', '0', '1000038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001616', null, '0', '0', null, null, null, null, '0', '0', '1000425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001617', null, '0', '0', null, null, null, null, '0', '0', '1100454', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001618', null, '0', '0', null, null, null, null, '0', '0', '1000426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001619', null, '0', '0', null, null, null, null, '0', '0', '1600313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001620', null, '0', '0', null, null, null, null, '0', '0', '1300200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001621', null, '0', '0', null, null, null, null, '0', '0', '1200238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001622', null, '0', '0', null, null, null, null, '0', '0', '1300201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001623', null, '0', '0', null, null, null, null, '0', '0', '1900265', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001624', null, '0', '0', null, null, null, null, '0', '0', '1600312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001625', null, '0', '0', null, null, null, null, '0', '0', '1500202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001626', null, '0', '0', null, null, null, null, '0', '0', '1400205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001627', null, '0', '0', null, null, null, null, '0', '0', '1400206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001628', null, '0', '0', null, null, null, null, '0', '0', '1100167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001629', null, '0', '0', null, null, null, null, '0', '0', '2200231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001630', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001631', null, '0', '0', null, null, null, null, '0', '0', '1400176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001632', null, '0', '0', null, null, null, null, '0', '0', '1900086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001633', null, '0', '0', null, null, null, null, '0', '0', '1200161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001634', null, '0', '0', null, null, null, null, '0', '0', '1100375', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001635', null, '0', '0', null, null, null, null, '0', '0', '1300060', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001636', null, '0', '0', null, null, null, null, '0', '0', '1900182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001637', null, '0', '0', null, null, null, null, '0', '0', '1400165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001638', null, '0', '0', null, null, null, null, '0', '0', '1000416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001639', null, '0', '0', null, null, null, null, '0', '0', '1200187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001640', null, '0', '0', null, null, null, null, '0', '0', '1600142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001641', null, '0', '0', null, null, null, null, '0', '0', '1500159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001642', null, '0', '0', null, null, null, null, '0', '0', '1400169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001643', null, '0', '0', null, null, null, null, '0', '0', '4000606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001644', null, '0', '0', null, null, null, null, '0', '0', '4000607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001645', null, '0', '0', null, null, null, null, '0', '0', '4000608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001646', null, '0', '0', null, null, null, null, '0', '0', '4000609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001647', null, '0', '0', null, null, null, null, '0', '0', '4000610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001648', null, '0', '0', null, null, null, null, '0', '0', '4000611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001649', null, '0', '0', null, null, null, null, '0', '0', '4000604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001650', null, '0', '0', null, null, null, null, '0', '0', '4000605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001651', null, '0', '0', null, null, null, null, '0', '0', '1100003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001652', 'pplStd_11@0C100', '193', '0', '-7.73', '9.967', '-27.44', '1.6', '0', '1041', '1600150', '', 'PopulaceTutorial', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1001653', null, '0', '0', null, null, null, null, '0', '0', '1900168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001654', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001655', null, '0', '0', null, null, null, null, '0', '0', '1500076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001656', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001657', null, '0', '0', null, null, null, null, '0', '0', '1900170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001658', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001659', null, '0', '0', null, null, null, null, '0', '0', '1500083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001660', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001661', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001662', null, '0', '0', null, null, null, null, '0', '0', '1600140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001663', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001664', null, '0', '0', null, null, null, null, '0', '0', '1200063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001665', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001666', null, '0', '0', null, null, null, null, '0', '0', '1600178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001667', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001668', null, '0', '0', null, null, null, null, '0', '0', '1200060', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001669', null, '0', '0', null, null, null, null, '0', '0', '1900175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001670', null, '0', '0', null, null, null, null, '0', '0', '1300152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001671', null, '0', '0', null, null, null, null, '0', '0', '1100355', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001672', null, '0', '0', null, null, null, null, '0', '0', '1000194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001673', null, '0', '0', null, null, null, null, '0', '0', '1600148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001674', null, '0', '0', null, null, null, null, '0', '0', '1200177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001675', null, '0', '0', null, null, null, null, '0', '0', '1400186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001676', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001677', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001678', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001679', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001680', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001681', null, '0', '0', null, null, null, null, '0', '0', '1600083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001682', null, '0', '0', null, null, null, null, '0', '0', '1000030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001683', null, '0', '0', null, null, null, null, '0', '0', '1900195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001684', null, '0', '0', null, null, null, null, '0', '0', '1000087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001685', null, '0', '0', null, null, null, null, '0', '0', '2200004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001686', null, '0', '0', null, null, null, null, '0', '0', '1000330', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001687', null, '0', '0', null, null, null, null, '0', '0', '1400166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001688', null, '0', '0', null, null, null, null, '0', '0', '1100011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001689', null, '0', '0', null, null, null, null, '0', '0', '1200221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001690', null, '0', '0', null, null, null, null, '0', '0', '1000059', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001691', null, '0', '0', null, null, null, null, '0', '0', '1900188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001692', null, '0', '0', null, null, null, null, '0', '0', '1000071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001693', null, '0', '0', null, null, null, null, '0', '0', '1200059', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001694', null, '0', '0', null, null, null, null, '0', '0', '1600012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001695', null, '0', '0', null, null, null, null, '0', '0', '1400153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001696', null, '0', '0', null, null, null, null, '0', '0', '2300120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001697', null, '0', '0', null, null, null, null, '0', '0', '1000158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001698', null, '0', '0', null, null, null, null, '0', '0', '1400180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001699', null, '0', '0', null, null, null, null, '0', '0', '1200057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001700', null, '0', '0', null, null, null, null, '0', '0', '1400167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001701', null, '0', '0', null, null, null, null, '0', '0', '1500119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001702', null, '0', '0', null, null, null, null, '0', '0', '1900190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001703', null, '0', '0', null, null, null, null, '0', '0', '1100044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001704', null, '0', '0', null, null, null, null, '0', '0', '1600119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001705', null, '0', '0', null, null, null, null, '0', '0', '1300110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001706', null, '0', '0', null, null, null, null, '0', '0', '1500134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001707', null, '0', '0', null, null, null, null, '0', '0', '1600135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001708', null, '0', '0', null, null, null, null, '0', '0', '1200196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001709', null, '0', '0', null, null, null, null, '0', '0', '1100073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001710', null, '0', '0', null, null, null, null, '0', '0', '1000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001711', null, '0', '0', null, null, null, null, '0', '0', '1900211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001712', null, '0', '0', null, null, null, null, '0', '0', '1200201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001713', null, '0', '0', null, null, null, null, '0', '0', '1900197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001714', null, '0', '0', null, null, null, null, '0', '0', '2200042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001715', null, '0', '0', null, null, null, null, '0', '0', '1600016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001716', null, '0', '0', null, null, null, null, '0', '0', '1400170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001717', null, '0', '0', null, null, null, null, '0', '0', '1100080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001718', null, '0', '0', null, null, null, null, '0', '0', '1000221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001719', null, '0', '0', null, null, null, null, '0', '0', '1200197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001720', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001721', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001722', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001723', null, '0', '0', null, null, null, null, '0', '0', '1000326', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001724', null, '0', '0', null, null, null, null, '0', '0', '1900187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001725', null, '0', '0', null, null, null, null, '0', '0', '1400174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001726', null, '0', '0', null, null, null, null, '0', '0', '1000274', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001727', null, '0', '0', null, null, null, null, '0', '0', '2500002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001728', null, '0', '0', null, null, null, null, '0', '0', '1600189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001729', null, '0', '0', null, null, null, null, '0', '0', '1400187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001730', null, '0', '0', null, null, null, null, '0', '0', '1900199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001731', null, '0', '0', null, null, null, null, '0', '0', '1900186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001732', null, '0', '0', null, null, null, null, '0', '0', '1600155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001733', null, '0', '0', null, null, null, null, '0', '0', '1500138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001734', null, '0', '0', null, null, null, null, '0', '0', '1000039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001735', null, '0', '0', null, null, null, null, '0', '0', '1200090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001736', null, '0', '0', null, null, null, null, '0', '0', '1400172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001737', null, '0', '0', null, null, null, null, '0', '0', '1600078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001738', null, '0', '0', null, null, null, null, '0', '0', '1200229', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001739', null, '0', '0', null, null, null, null, '0', '0', '1000205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001740', null, '0', '0', null, null, null, null, '0', '0', '4000619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001741', null, '0', '0', null, null, null, null, '0', '0', '1300199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001742', null, '0', '0', null, null, null, null, '0', '0', '1600037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001743', null, '0', '0', null, null, null, null, '0', '0', '1000034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001744', null, '0', '0', null, null, null, null, '0', '0', '1900185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001745', null, '0', '0', null, null, null, null, '0', '0', '1500132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001746', null, '0', '0', null, null, null, null, '0', '0', '1000333', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001747', null, '0', '0', null, null, null, null, '0', '0', '1900094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001748', null, '0', '0', null, null, null, null, '0', '0', '1000095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001749', null, '0', '0', null, null, null, null, '0', '0', '1600055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001750', null, '0', '0', null, null, null, null, '0', '0', '1300150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001751', null, '0', '0', null, null, null, null, '0', '0', '1000098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001752', null, '0', '0', null, null, null, null, '0', '0', '1600013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001753', null, '0', '0', null, null, null, null, '0', '0', '1900115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001754', null, '0', '0', null, null, null, null, '0', '0', '1300071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001755', null, '0', '0', null, null, null, null, '0', '0', '1400041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001756', null, '0', '0', null, null, null, null, '0', '0', '2200186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001757', null, '0', '0', null, null, null, null, '0', '0', '1900189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001758', null, '0', '0', null, null, null, null, '0', '0', '1000127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001759', null, '0', '0', null, null, null, null, '0', '0', '1200050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001760', null, '0', '0', null, null, null, null, '0', '0', '1100112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001761', null, '0', '0', null, null, null, null, '0', '0', '1500136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001762', null, '0', '0', null, null, null, null, '0', '0', '3202601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001763', null, '0', '0', null, null, null, null, '0', '0', '1400041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001764', null, '0', '0', null, null, null, null, '0', '0', '1600030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001765', null, '0', '0', null, null, null, null, '0', '0', '1500144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001766', null, '0', '0', null, null, null, null, '0', '0', '1200194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001767', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001768', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001769', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001770', null, '0', '0', null, null, null, null, '0', '0', '1100183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001771', null, '0', '0', null, null, null, null, '0', '0', '1300172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001772', null, '0', '0', null, null, null, null, '0', '0', '4000615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001773', null, '0', '0', null, null, null, null, '0', '0', '4000616', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001774', null, '0', '0', null, null, null, null, '0', '0', '4000617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001775', null, '0', '0', null, null, null, null, '0', '0', '4000618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001776', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001777', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001778', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001779', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001780', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001781', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001782', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001783', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001784', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001785', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001786', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001787', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001788', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001789', null, '0', '0', null, null, null, null, '0', '0', '1300189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001790', null, '0', '0', null, null, null, null, '0', '0', '1500170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001791', null, '0', '0', null, null, null, null, '0', '0', '1100448', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001792', null, '0', '0', null, null, null, null, '0', '0', '4000632', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001793', null, '0', '0', null, null, null, null, '0', '0', '4000633', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001794', null, '0', '0', null, null, null, null, '0', '0', '4000634', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001795', null, '0', '0', null, null, null, null, '0', '0', '4000635', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001796', null, '0', '0', null, null, null, null, '0', '0', '4000636', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001797', null, '0', '0', null, null, null, null, '0', '0', '4000637', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001798', null, '0', '0', null, null, null, null, '0', '0', '4000638', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001799', null, '0', '0', null, null, null, null, '0', '0', '4000639', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001800', null, '0', '0', null, null, null, null, '0', '0', '4000640', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001801', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001802', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001803', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001804', null, '0', '0', null, null, null, null, '0', '0', '1200091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001805', null, '0', '0', null, null, null, null, '0', '0', '1900144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001806', null, '0', '0', null, null, null, null, '0', '0', '1300078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001807', null, '0', '0', null, null, null, null, '0', '0', '1600299', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001808', null, '0', '0', null, null, null, null, '0', '0', '1100220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001809', null, '0', '0', null, null, null, null, '0', '0', '1200218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001810', null, '0', '0', null, null, null, null, '0', '0', '1900223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001811', null, '0', '0', null, null, null, null, '0', '0', '3206305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001812', null, '0', '0', null, null, null, null, '0', '0', '1600139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001813', null, '0', '0', null, null, null, null, '0', '0', '1600122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001814', null, '0', '0', null, null, null, null, '0', '0', '1600321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001815', null, '0', '0', null, null, null, null, '0', '0', '1000144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001816', null, '0', '0', null, null, null, null, '0', '0', '1200148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001817', null, '0', '0', null, null, null, null, '0', '0', '1900193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001818', null, '0', '0', null, null, null, null, '0', '0', '1400178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001819', null, '0', '0', null, null, null, null, '0', '0', '3207022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001820', null, '0', '0', null, null, null, null, '0', '0', '3280029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001821', null, '0', '0', null, null, null, null, '0', '0', '3280030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001822', null, '0', '0', null, null, null, null, '0', '0', '3280031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001823', null, '0', '0', null, null, null, null, '0', '0', '3103308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001824', null, '0', '0', null, null, null, null, '0', '0', '1500154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001825', null, '0', '0', null, null, null, null, '0', '0', '1300042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001826', null, '0', '0', null, null, null, null, '0', '0', '1600244', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001827', null, '0', '0', null, null, null, null, '0', '0', '2200235', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001828', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001829', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001830', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001831', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001832', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001833', null, '0', '0', null, null, null, null, '0', '0', '1000353', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001834', null, '0', '0', null, null, null, null, '0', '0', '2200183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001835', null, '0', '0', null, null, null, null, '0', '0', '1200227', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001836', null, '0', '0', null, null, null, null, '0', '0', '2480006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001837', null, '0', '0', null, null, null, null, '0', '0', '2480007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001838', null, '0', '0', null, null, null, null, '0', '0', '2480008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001839', null, '0', '0', null, null, null, null, '0', '0', '1000111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001840', null, '0', '0', null, null, null, null, '0', '0', '1900246', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001841', null, '0', '0', null, null, null, null, '0', '0', '1100397', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001842', null, '0', '0', null, null, null, null, '0', '0', '1100398', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001843', null, '0', '0', null, null, null, null, '0', '0', '1100399', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001844', null, '0', '0', null, null, null, null, '0', '0', '1900233', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001845', null, '0', '0', null, null, null, null, '0', '0', '1900234', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001846', null, '0', '0', null, null, null, null, '0', '0', '1900235', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001847', null, '0', '0', null, null, null, null, '0', '0', '1500187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001848', null, '0', '0', null, null, null, null, '0', '0', '1500188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001849', null, '0', '0', null, null, null, null, '0', '0', '1500189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001850', null, '0', '0', null, null, null, null, '0', '0', '3103110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001851', null, '0', '0', null, null, null, null, '0', '0', '3104208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001852', null, '0', '0', null, null, null, null, '0', '0', '3202706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001853', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001854', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001855', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001856', null, '0', '0', null, null, null, null, '0', '0', '3101010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001857', null, '0', '0', null, null, null, null, '0', '0', '3203001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001858', null, '0', '0', null, null, null, null, '0', '0', '3203004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001859', null, '0', '0', null, null, null, null, '0', '0', '3101605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001860', null, '0', '0', null, null, null, null, '0', '0', '3200706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001861', null, '0', '0', null, null, null, null, '0', '0', '3108702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001862', null, '0', '0', null, null, null, null, '0', '0', '3204101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001863', null, '0', '0', null, null, null, null, '0', '0', '3105301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001864', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001865', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001866', null, '0', '0', null, null, null, null, '0', '0', '1000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001867', null, '0', '0', null, null, null, null, '0', '0', '1200024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001868', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001869', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001870', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001871', null, '0', '0', null, null, null, null, '0', '0', '1000016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001872', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001873', null, '0', '0', null, null, null, null, '0', '0', '1600213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001874', null, '0', '0', null, null, null, null, '0', '0', '1200013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001875', null, '0', '0', null, null, null, null, '0', '0', '1100004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001876', null, '0', '0', null, null, null, null, '0', '0', '1900026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001877', null, '0', '0', null, null, null, null, '0', '0', '1900030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001878', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001879', null, '0', '0', null, null, null, null, '0', '0', '1500004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001880', null, '0', '0', null, null, null, null, '0', '0', '1000297', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001881', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001882', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001883', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001884', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001885', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001886', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001887', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001888', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001889', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001890', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001891', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001892', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001893', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001894', null, '0', '0', null, null, null, null, '0', '0', '1000090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001896', null, '0', '0', null, null, null, null, '0', '0', '4000651', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001900', null, '0', '0', null, null, null, null, '0', '0', '1100087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001901', null, '0', '0', null, null, null, null, '0', '0', '4000650', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001903', null, '0', '0', null, null, null, null, '0', '0', '1000052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001904', null, '0', '0', null, null, null, null, '0', '0', '1200191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001906', null, '0', '0', null, null, null, null, '0', '0', '4000648', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001911', null, '0', '0', null, null, null, null, '0', '0', '1400200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001913', null, '0', '0', null, null, null, null, '0', '0', '1400202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001914', null, '0', '0', null, null, null, null, '0', '0', '4000653', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001916', null, '0', '0', null, null, null, null, '0', '0', '1500171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001921', null, '0', '0', null, null, null, null, '0', '0', '1600333', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001922', null, '0', '0', null, null, null, null, '0', '0', '1600334', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001925', null, '0', '0', null, null, null, null, '0', '0', '1600337', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001926', null, '0', '0', null, null, null, null, '0', '0', '1900216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001927', null, '0', '0', null, null, null, null, '0', '0', '1900217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001928', null, '0', '0', null, null, null, null, '0', '0', '1900218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001931', null, '0', '0', null, null, null, null, '0', '0', '4000652', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001932', null, '0', '0', null, null, null, null, '0', '0', '2200217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001936', null, '0', '0', null, null, null, null, '0', '0', '2480005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001937', null, '0', '0', null, null, null, null, '0', '0', '2480004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001938', null, '0', '0', null, null, null, null, '0', '0', '2480002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001951', null, '0', '0', null, null, null, null, '0', '0', '1000036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001952', null, '0', '0', null, null, null, null, '0', '0', '4000649', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001953', null, '0', '0', null, null, null, null, '0', '0', '1000050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001954', null, '0', '0', null, null, null, null, '0', '0', '3310701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001955', null, '0', '0', null, null, null, null, '0', '0', '1200223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001956', null, '0', '0', null, null, null, null, '0', '0', '1100221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001957', null, '0', '0', null, null, null, null, '0', '0', '2480009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001960', null, '0', '0', null, null, null, null, '0', '0', '3202612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001961', null, '0', '0', null, null, null, null, '0', '0', '3206412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001962', null, '0', '0', null, null, null, null, '0', '0', '3201427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001963', null, '0', '0', null, null, null, null, '0', '0', '3206413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001964', null, '0', '0', null, null, null, null, '0', '0', '3206414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001965', null, '0', '0', null, null, null, null, '0', '0', '3206416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001966', null, '0', '0', null, null, null, null, '0', '0', '3204607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001967', null, '0', '0', null, null, null, null, '0', '0', '3204706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001968', null, '0', '0', null, null, null, null, '0', '0', '3204801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001969', null, '0', '0', null, null, null, null, '0', '0', '3204906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001970', null, '0', '0', null, null, null, null, '0', '0', '3205001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001971', null, '0', '0', null, null, null, null, '0', '0', '3205101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001972', null, '0', '0', null, null, null, null, '0', '0', '3200609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001973', null, '0', '0', null, null, null, null, '0', '0', '3203505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001974', null, '0', '0', null, null, null, null, '0', '0', '3209907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001975', null, '0', '0', null, null, null, null, '0', '0', '3202504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001976', null, '0', '0', null, null, null, null, '0', '0', '3201708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001977', null, '0', '0', null, null, null, null, '0', '0', '3202209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001978', null, '0', '0', null, null, null, null, '0', '0', '3280322', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001979', null, '0', '0', null, null, null, null, '0', '0', '3280323', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001980', null, '0', '0', null, null, null, null, '0', '0', '3280324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001981', null, '0', '0', null, null, null, null, '0', '0', '3280325', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001982', null, '0', '0', null, null, null, null, '0', '0', '3201209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001983', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001984', null, '0', '0', null, null, null, null, '0', '0', '3280318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001985', null, '0', '0', null, null, null, null, '0', '0', '1600296', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001986', null, '0', '0', null, null, null, null, '0', '0', '1900222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001987', null, '0', '0', null, null, null, null, '0', '0', '1000206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001988', null, '0', '0', null, null, null, null, '0', '0', '1500179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001989', null, '0', '0', null, null, null, null, '0', '0', '1200142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001990', null, '0', '0', null, null, null, null, '0', '0', '1900242', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001991', null, '0', '0', null, null, null, null, '0', '0', '1500185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001992', null, '0', '0', null, null, null, null, '0', '0', '1600315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001993', null, '0', '0', null, null, null, null, '0', '0', '1100385', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001994', null, '0', '0', null, null, null, null, '0', '0', '1900229', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001995', null, '0', '0', null, null, null, null, '0', '0', '2200152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001996', null, '0', '0', null, null, null, null, '0', '0', '1900226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001997', null, '0', '0', null, null, null, null, '0', '0', '2600003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001998', null, '0', '0', null, null, null, null, '0', '0', '2600001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1001999', null, '0', '0', null, null, null, null, '0', '0', '2600004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002000', null, '0', '0', null, null, null, null, '0', '0', '1100457', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002001', null, '0', '0', null, null, null, null, '0', '0', '1000275', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002002', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002003', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002004', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002005', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002006', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002007', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002008', null, '0', '0', null, null, null, null, '0', '0', '2600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002009', null, '0', '0', null, null, null, null, '0', '0', '2600007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002010', null, '0', '0', null, null, null, null, '0', '0', '2600007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002011', null, '0', '0', null, null, null, null, '0', '0', '2600007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002012', null, '0', '0', null, null, null, null, '0', '0', '3305901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002013', null, '0', '0', null, null, null, null, '0', '0', '3305401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002014', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002015', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002016', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002017', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002018', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002019', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002020', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002021', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002022', null, '0', '0', null, null, null, null, '0', '0', '4000613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002023', null, '0', '0', null, null, null, null, '0', '0', '2200241', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002024', null, '0', '0', null, null, null, null, '0', '0', '1200133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002025', null, '0', '0', null, null, null, null, '0', '0', '1700011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002026', null, '0', '0', null, null, null, null, '0', '0', '3305401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002027', null, '0', '0', null, null, null, null, '0', '0', '4000644', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002028', null, '0', '0', null, null, null, null, '0', '0', '4000654', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002029', null, '0', '0', null, null, null, null, '0', '0', '4000646', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002030', null, '0', '0', null, null, null, null, '0', '0', '4000645', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002031', null, '0', '0', null, null, null, null, '0', '0', '4000647', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002032', null, '0', '0', null, null, null, null, '0', '0', '1200195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002033', null, '0', '0', null, null, null, null, '0', '0', '1000193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002034', null, '0', '0', null, null, null, null, '0', '0', '1900214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002035', null, '0', '0', null, null, null, null, '0', '0', '1000109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002036', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002037', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002038', null, '0', '0', null, null, null, null, '0', '0', '1000149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002039', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002040', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002041', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002042', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002043', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002044', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002045', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002046', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002047', null, '0', '0', null, null, null, null, '0', '0', '1400131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002048', null, '0', '0', null, null, null, null, '0', '0', '3209501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002049', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002050', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002051', null, '0', '0', null, null, null, null, '0', '0', '2700009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002052', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002053', null, '0', '0', null, null, null, null, '0', '0', '1600089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002054', null, '0', '0', null, null, null, null, '0', '0', '1600091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002055', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002056', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002057', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002058', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002059', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002060', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002061', null, '0', '0', null, null, null, null, '0', '0', '1000013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002062', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002063', null, '0', '0', null, null, null, null, '0', '0', '3210801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002064', null, '0', '0', null, null, null, null, '0', '0', '3210802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002065', null, '0', '0', null, null, null, null, '0', '0', '1000117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002066', null, '0', '0', null, null, null, null, '0', '0', '1000026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002067', null, '0', '0', null, null, null, null, '0', '0', '2200152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002068', null, '0', '0', null, null, null, null, '0', '0', '2200152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002069', null, '0', '0', null, null, null, null, '0', '0', '2300120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002070', null, '0', '0', null, null, null, null, '0', '0', '1400004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002071', null, '0', '0', null, null, null, null, '0', '0', '1200068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002072', null, '0', '0', null, null, null, null, '0', '0', '1300028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002073', null, '0', '0', null, null, null, null, '0', '0', '1000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002074', null, '0', '0', null, null, null, null, '0', '0', '1200226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002075', null, '0', '0', null, null, null, null, '0', '0', '4000657', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002076', null, '0', '0', null, null, null, null, '0', '0', '4000657', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002077', null, '0', '0', null, null, null, null, '0', '0', '4000657', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002078', null, '0', '0', null, null, null, null, '0', '0', '1900206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002079', null, '0', '0', null, null, null, null, '0', '0', '1900168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002080', null, '0', '0', null, null, null, null, '0', '0', '1900170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002081', null, '0', '0', null, null, null, null, '0', '0', '1900175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002082', null, '0', '0', null, null, null, null, '0', '0', '1100355', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002083', null, '0', '0', null, null, null, null, '0', '0', '1300152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002084', null, '0', '0', null, null, null, null, '0', '0', '1100226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002085', null, '0', '0', null, null, null, null, '0', '0', '1300159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002086', null, '0', '0', null, null, null, null, '0', '0', '1500204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002087', null, '0', '0', null, null, null, null, '0', '0', '1600350', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002088', null, '0', '0', null, null, null, null, '0', '0', '1600350', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002089', null, '0', '0', null, null, null, null, '0', '0', '1600350', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002090', null, '0', '0', null, null, null, null, '0', '0', '1000232', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002091', null, '0', '0', null, null, null, null, '0', '0', '1300160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002092', null, '0', '0', null, null, null, null, '0', '0', '3200706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002093', null, '0', '0', null, null, null, null, '0', '0', '3200706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002094', null, '0', '0', null, null, null, null, '0', '0', '1000194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002095', null, '0', '0', null, null, null, null, '0', '0', '1200177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002096', null, '0', '0', null, null, null, null, '0', '0', '1600148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002097', null, '0', '0', null, null, null, null, '0', '0', '2200263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002098', null, '0', '0', null, null, null, null, '0', '0', '1000197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002099', null, '0', '0', null, null, null, null, '0', '0', '1400177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002100', null, '0', '0', null, null, null, null, '0', '0', '1900226', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002101', null, '0', '0', null, null, null, null, '0', '0', '1400220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002102', null, '0', '0', null, null, null, null, '0', '0', '1000425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002103', null, '0', '0', null, null, null, null, '0', '0', '1100454', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002104', null, '0', '0', null, null, null, null, '0', '0', '1000426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002105', null, '0', '0', null, null, null, null, '0', '0', '1600313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002106', null, '0', '0', null, null, null, null, '0', '0', '1300200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002107', null, '0', '0', null, null, null, null, '0', '0', '1200238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002108', null, '0', '0', null, null, null, null, '0', '0', '1300201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002109', null, '0', '0', null, null, null, null, '0', '0', '1900265', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002110', null, '0', '0', null, null, null, null, '0', '0', '1600312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002111', null, '0', '0', null, null, null, null, '0', '0', '1500202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002112', null, '0', '0', null, null, null, null, '0', '0', '1400205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002113', null, '0', '0', null, null, null, null, '0', '0', '1400206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002114', null, '0', '0', null, null, null, null, '0', '0', '1000281', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002115', null, '0', '0', null, null, null, null, '0', '0', '2200152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1002116', null, '0', '0', null, null, null, null, '0', '0', '1400222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060001', null, '0', '0', null, null, null, null, '0', '0', '4000542', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060002', null, '0', '0', null, null, null, null, '0', '0', '2700016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060003', null, '0', '0', null, null, null, null, '0', '0', '2700001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060004', null, '0', '0', null, null, null, null, '0', '0', '1000052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060008', null, '0', '0', null, null, null, null, '0', '0', '2700009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060009', null, '0', '0', null, null, null, null, '0', '0', '2700002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060010', null, '0', '0', null, null, null, null, '0', '0', '1000353', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060011', null, '0', '0', null, null, null, null, '0', '0', '1200193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060012', null, '0', '0', null, null, null, null, '0', '0', '1400009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060013', null, '0', '0', null, null, null, null, '0', '0', '2700014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060014', null, '0', '0', null, null, null, null, '0', '0', '1400135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060015', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060016', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060017', null, '0', '0', null, null, null, null, '0', '0', '1000353', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060018', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060019', null, '0', '0', null, null, null, null, '0', '0', '1000353', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060021', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060022', null, '0', '0', null, null, null, null, '0', '0', '2700013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060024', null, '0', '0', null, null, null, null, '0', '0', '1600360', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060025', null, '0', '0', null, null, null, null, '0', '0', '1000437', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060026', null, '0', '0', null, null, null, null, '0', '0', '1300204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060027', null, '0', '0', null, null, null, null, '0', '0', '1000436', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060028', null, '0', '0', null, null, null, null, '0', '0', '1600318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060029', null, '0', '0', null, null, null, null, '0', '0', '1100419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060030', null, '0', '0', null, null, null, null, '0', '0', '2600009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060031', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060032', null, '0', '0', null, null, null, null, '0', '0', '2200241', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060033', null, '0', '0', null, null, null, null, '0', '0', '1000101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060034', null, '0', '0', null, null, null, null, '0', '0', '1400197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060035', null, '0', '0', null, null, null, null, '0', '0', '1500186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060036', null, '0', '0', null, null, null, null, '0', '0', '2420027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060037', null, '0', '0', null, null, null, null, '0', '0', '2430006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060038', null, '0', '0', null, null, null, null, '0', '0', '2440001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060039', null, '0', '0', null, null, null, null, '0', '0', '1200133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060040', null, '0', '0', null, null, null, null, '0', '0', '1200199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060041', null, '0', '0', null, null, null, null, '0', '0', '1600175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060042', null, '0', '0', null, null, null, null, '0', '0', '1000146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1060043', null, '0', '0', null, null, null, null, '0', '0', '2200115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070001', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070002', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070003', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070004', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070005', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070006', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070007', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070008', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070009', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070010', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070011', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070012', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070013', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070014', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070015', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070016', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070017', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070018', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070019', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070020', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070021', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070022', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070023', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070024', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070025', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070026', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070027', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070028', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070029', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070030', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070031', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070032', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070033', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070034', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070035', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070036', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070037', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070038', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070039', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070040', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070041', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070042', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070043', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070044', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070045', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070046', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070047', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070048', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070049', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070050', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070051', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070052', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070053', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070054', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070055', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070056', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070057', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070058', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070059', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070060', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070061', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070062', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070063', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070064', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070065', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070066', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070067', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070068', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070069', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070070', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070071', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070072', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070073', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070074', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070075', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070076', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070077', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070078', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070079', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070080', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070081', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070082', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070083', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070084', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070085', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070086', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070087', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070088', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070089', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070090', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070091', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070092', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070093', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070094', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070095', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070096', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070097', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070098', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070099', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070100', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070101', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070102', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070103', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070104', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070105', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070106', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070107', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070108', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070109', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070110', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070111', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070112', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070113', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070114', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070115', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1070116', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080014', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080015', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080016', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080017', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080018', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080019', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080020', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080021', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080022', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080023', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080024', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080025', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080026', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080027', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080028', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080029', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080030', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080031', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080032', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080037', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080038', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080039', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080040', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080041', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080042', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080043', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080044', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080045', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080046', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080047', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080048', null, '0', '0', null, null, null, null, '0', '0', '4000595', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080049', null, '0', '0', null, null, null, null, '0', '0', '4000595', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080050', null, '0', '0', null, null, null, null, '0', '0', '4000595', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080051', null, '0', '0', null, null, null, null, '0', '0', '4000595', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080058', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080059', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080060', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080063', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080064', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080065', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080066', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080067', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080068', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080069', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080070', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080071', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080072', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080073', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080074', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080075', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080076', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080077', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080078', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080079', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080080', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080081', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080082', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080083', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080084', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080085', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080086', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080087', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080088', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080089', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080091', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080092', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080093', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080094', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080095', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080096', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080097', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080098', null, '0', '0', null, null, null, null, '0', '0', '4010011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080099', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080100', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080103', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080104', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080105', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080110', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080111', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080112', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080113', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080114', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080115', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080120', 'pplCutscene_01@0F400', '244', '0', '159.84', '0.7', '167.17', '-0.2', '0', '0', '4010013', null, 'PopulaceCutScenePlayer', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1080121', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080122', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080123', null, '0', '0', null, null, null, null, '0', '0', '4010020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080124', null, '0', '0', null, null, null, null, '0', '0', '4010021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080125', null, '0', '0', null, null, null, null, '0', '0', '4010022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080126', null, '0', '0', null, null, null, null, '0', '0', '4010023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080127', null, '0', '0', null, null, null, null, '0', '0', '4010024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080128', null, '0', '0', null, null, null, null, '0', '0', '4010025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080129', null, '0', '0', null, null, null, null, '0', '0', '4010026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080130', null, '0', '0', null, null, null, null, '0', '0', '4010027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080131', null, '0', '0', null, null, null, null, '0', '0', '4010028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080132', null, '0', '0', null, null, null, null, '0', '0', '4010029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080133', null, '0', '0', null, null, null, null, '0', '0', '4010030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080134', null, '0', '0', null, null, null, null, '0', '0', '4010031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080135', null, '0', '0', null, null, null, null, '0', '0', '4010032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1080136', null, '0', '0', null, null, null, null, '0', '0', '4010033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090025', 'pplStd_0f@0C100', '193', '0', '0', '10', '-18', '0', '0', '0', '0', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1090026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090039', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090040', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090041', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090042', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090043', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090044', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090045', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090046', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090047', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090048', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090049', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090050', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090051', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090058', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090059', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090060', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090063', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090064', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090065', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090066', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090067', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090068', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090069', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090070', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090071', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090072', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090073', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090074', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090075', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090076', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090077', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090078', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090079', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090080', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090081', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090082', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090083', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090084', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090085', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090086', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090087', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090088', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090089', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090091', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090092', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090093', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090094', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090095', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090096', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090097', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090098', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090099', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090100', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090103', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090104', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090105', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090110', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090111', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090112', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090113', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090114', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090115', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090117', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090118', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090119', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090120', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090121', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090122', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090123', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090124', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090125', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090126', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090127', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090128', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090129', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090130', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090131', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090132', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090133', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090134', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090135', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090136', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090137', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090138', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090139', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090140', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090141', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090142', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090143', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090144', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090145', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090146', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090147', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090148', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090149', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090150', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090151', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090152', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090153', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090154', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090155', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090156', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090157', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090158', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090159', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090160', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090161', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090162', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090163', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090164', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090165', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090166', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090167', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090168', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090169', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090170', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090171', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090172', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090173', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090174', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090175', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090176', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090177', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090178', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090179', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090180', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090181', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090182', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090183', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090184', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090185', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090186', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090187', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090188', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090189', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090190', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090191', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090192', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090193', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090194', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090195', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090196', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090197', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090198', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090199', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090200', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090201', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090202', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090203', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090204', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090205', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090206', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090207', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090208', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090209', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090210', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090211', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090212', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090213', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090214', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090215', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090216', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090217', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090218', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090219', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090220', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090221', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090222', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090223', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090224', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090225', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090226', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090227', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090228', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090229', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090230', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090231', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090232', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090233', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090234', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090235', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090236', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090237', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090238', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090239', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090240', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090241', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090242', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090243', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090244', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090245', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090246', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090247', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090248', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090249', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090250', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090251', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090252', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090253', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090254', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090255', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090256', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090257', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090258', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090259', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090260', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090261', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090262', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090263', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090264', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090265', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090266', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090267', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090268', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090269', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090270', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090271', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090272', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090273', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090274', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090275', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090276', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090277', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090278', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090279', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090280', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090281', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090282', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090283', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090284', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090285', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090286', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090287', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090288', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090289', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090290', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090291', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090292', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090293', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090294', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090295', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090296', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090297', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090298', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090299', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090300', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090301', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090302', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090303', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090304', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090305', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090306', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090307', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090308', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090309', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090310', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090311', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090312', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090313', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090314', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090315', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090316', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090317', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090318', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090319', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090320', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090321', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090322', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090323', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090324', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090325', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090326', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090327', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090328', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090329', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090330', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090331', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090332', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090333', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090334', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090335', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090336', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090337', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090338', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090339', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090340', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090341', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090342', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090343', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090344', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090345', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090346', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090347', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090348', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090349', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090350', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090351', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090352', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090353', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090354', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090355', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090356', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090357', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090358', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090359', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090360', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090361', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090362', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090363', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090364', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090365', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090366', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090367', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090368', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090369', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090370', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090371', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090372', 'pplStd_wil0Btl01_0b@0B800', '184', '0', '-13', '194.91', '76.75', '-2.72', '0', '0', '0', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1090373', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090374', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090375', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090376', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090377', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090378', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090379', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090380', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090381', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090382', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090383', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090384', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090385', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090386', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090387', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090388', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090389', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090390', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090391', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090392', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090393', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090394', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090395', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090396', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090397', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090398', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090399', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090400', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090401', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090402', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090403', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090404', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090405', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090406', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090407', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090408', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090409', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090410', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090411', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090412', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090413', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090414', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090415', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090416', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090417', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090418', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090419', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090420', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090421', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090422', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090423', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090424', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090425', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090426', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090427', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090428', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090429', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090430', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090431', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090432', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090433', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090434', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090435', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090436', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090437', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090438', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090439', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090440', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090441', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090442', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090443', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090444', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090445', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090446', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090447', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090449', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090450', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090451', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090452', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090453', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090454', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090455', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090456', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090457', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090458', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090459', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090460', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090461', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090462', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090463', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090464', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090465', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090466', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090467', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090468', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090469', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090470', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090471', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090472', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090473', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090474', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090475', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090476', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090477', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090478', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090479', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090480', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090481', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090482', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090483', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090484', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090485', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090486', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090487', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090488', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090489', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090490', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090491', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090492', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090493', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090494', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090495', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090496', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090497', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090498', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090499', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090500', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090501', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090502', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090503', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090504', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090505', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090506', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090507', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090508', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090509', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090510', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090511', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090512', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090513', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090514', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090515', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090516', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090517', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090518', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090519', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090520', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090521', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090522', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090523', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090524', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090525', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090526', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090527', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090528', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090529', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090530', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090531', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090532', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090533', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090534', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090535', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090536', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090537', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090538', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090539', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090540', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090541', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090542', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090543', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090544', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090545', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090546', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090547', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090548', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090549', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090550', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090551', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090552', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1090553', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099039', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099040', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099041', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099042', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099043', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099044', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099045', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099046', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099047', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099048', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099049', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099050', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099051', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099058', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099059', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099060', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099063', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099064', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099065', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099066', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099067', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099068', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1099069', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200001', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200002', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200003', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200014', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200024', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200039', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200040', null, '0', '0', null, null, null, null, '0', '0', '4010016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200041', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200042', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200043', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200044', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200045', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200046', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200047', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200048', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200049', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200050', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200051', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200058', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200059', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200060', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200063', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200064', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200065', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200066', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200067', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200068', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200069', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200070', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200071', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200072', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200073', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200074', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200075', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200076', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200077', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200078', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200079', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200080', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200081', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200082', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200083', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200084', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200085', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200086', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200087', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200088', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200089', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200091', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200092', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200093', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200094', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200095', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200096', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200097', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200098', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200099', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200100', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200103', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200104', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200105', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200110', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200111', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200112', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200113', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200114', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200115', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200117', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200118', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200119', null, '0', '0', null, null, null, null, '0', '0', '4000600', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200120', null, '0', '0', null, null, null, null, '0', '0', '4000600', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200121', null, '0', '0', null, null, null, null, '0', '0', '4000600', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200122', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200123', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200124', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200125', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200126', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200127', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200128', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200129', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200130', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200131', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200132', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200133', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200134', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200135', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200136', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200137', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200138', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200139', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200140', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200141', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200142', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200143', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200144', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200145', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200146', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200147', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200148', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200149', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200150', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200151', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200152', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200153', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200154', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200155', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200156', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200157', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200158', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200159', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200160', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200161', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200162', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200163', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200164', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200165', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200166', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200167', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200168', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200169', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200170', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200171', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200172', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200173', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200174', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200175', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200176', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200177', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200178', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200184', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200185', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200186', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200187', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200188', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200189', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200190', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200191', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200192', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200193', 'taskBoard_01@08500', '133', '0', '-464.77', '41.71', '183.27', '0', '0', '0', '4000602', null, 'TaskBoard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1200194', null, '0', '0', null, null, null, null, '0', '0', '4000602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200195', null, '0', '0', null, null, null, null, '0', '0', '4000602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200196', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200197', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200198', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200199', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200200', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200201', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200202', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200203', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200204', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200205', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200206', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200207', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200208', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200209', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200210', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200211', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200212', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200213', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200214', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200215', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200216', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200217', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200218', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200219', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200220', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200221', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200222', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200223', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200224', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200225', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200226', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200227', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200228', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200229', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200230', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200231', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200232', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200233', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200234', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200235', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200236', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200237', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200238', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200239', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200240', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200241', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200242', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200243', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200244', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200245', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200246', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200247', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200248', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200249', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200250', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200251', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200252', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200253', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200254', null, '0', '0', null, null, null, null, '0', '0', '4010012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200255', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200256', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200257', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200258', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200259', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200260', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200261', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200262', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200263', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200264', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200265', null, '0', '0', null, null, null, null, '0', '0', '4000642', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200266', null, '0', '0', null, null, null, null, '0', '0', '4000642', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200267', null, '0', '0', null, null, null, null, '0', '0', '4000642', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200268', null, '0', '0', null, null, null, null, '0', '0', '4000642', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200269', null, '0', '0', null, null, null, null, '0', '0', '4000642', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200270', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200271', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200272', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200273', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200274', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200275', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200276', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200277', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200278', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200279', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200280', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200281', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200282', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200283', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200284', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200285', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200286', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200287', null, '0', '0', null, null, null, null, '0', '0', '2480008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200288', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200289', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200290', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200291', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200292', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200293', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200294', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200295', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200296', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200297', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200298', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200299', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200300', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200301', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200302', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200303', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200304', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200305', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200306', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200307', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200308', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200309', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200310', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200311', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200312', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200313', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200314', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200315', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200316', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200317', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200318', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200319', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200320', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200321', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200322', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200323', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200324', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200325', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200326', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200327', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200328', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200329', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200330', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200331', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200332', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200333', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200334', 'objInnDoor_01@0F400', '244', '0', '159.98', '0.02', '151.9', '-0.44', '0', '0', '4010017', null, 'ObjectInnDoor', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1200335', null, '0', '0', null, null, null, null, '0', '0', '4010017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200336', null, '0', '0', null, null, null, null, '0', '0', '4010017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200337', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200338', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200339', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200340', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200341', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200342', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200343', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200344', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200345', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200346', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200347', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200348', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200349', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200350', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200351', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200352', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200353', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200354', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200355', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200356', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200357', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200358', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200359', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200360', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200361', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200362', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200363', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200364', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200365', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200366', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200367', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200368', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200369', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200370', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200371', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200372', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200373', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200374', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200375', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200376', 'objItemStore_01@0F400', '244', '0', '164.91', '-0.1', '167.03', '0.05', '0', '0', '4010019', null, 'ObjectItemStorage', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1200377', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200378', 'objBed_01@0F400', '244', '0', '155.97', '0', '165.14', '-1.65', '0', '0', '4010018', null, 'ObjectBed', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1200379', null, '0', '0', null, null, null, null, '0', '0', '4010018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200380', null, '0', '0', null, null, null, null, '0', '0', '4010018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200381', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200382', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200383', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200384', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200385', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200386', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200387', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200388', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200389', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200390', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200391', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200392', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200393', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200394', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200395', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200396', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200397', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200398', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200399', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200400', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200401', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200402', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200404', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200405', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200406', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200407', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200408', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200409', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200410', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200411', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1200412', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280000', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280001', 'aetheryteP_01@08500', '133', '0', '-395.1', '42.5', '337.12', '0', '0', '0', '4010014', null, 'AetheryteParent', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1280002', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280003', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280004', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280005', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280006', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280007', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280008', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280009', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280010', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280011', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280012', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280013', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280014', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280015', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280016', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280017', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280018', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280019', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280020', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280021', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280022', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280023', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280031', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280032', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280033', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280034', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280035', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280036', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280037', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280038', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280039', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280040', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280041', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280042', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280043', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280044', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280045', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280046', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280047', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280048', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280049', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280050', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280051', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280052', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280053', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280054', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280055', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280056', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280057', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280058', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280059', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280061', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280062', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280063', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280064', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280065', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280066', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280067', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280068', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280069', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280070', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280071', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280072', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280073', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280074', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280075', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280076', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280077', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280078', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280079', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280080', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280081', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280082', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280083', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280084', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280085', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280086', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280087', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280088', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280089', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280091', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280092', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280093', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280094', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280095', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280096', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280097', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280098', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280099', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280100', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280101', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280102', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280103', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280104', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280105', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280106', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280107', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280108', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280109', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280110', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280111', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280112', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280113', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280114', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280115', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280116', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280117', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280118', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280119', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280121', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280122', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280123', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280124', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280125', null, '0', '0', null, null, null, null, '0', '0', '4010015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280126', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1280127', null, '0', '0', null, null, null, null, '0', '0', '4010014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1290033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500001', 'pplGuildlev_01@08500', '133', '0', '-460.18', '40', '179.68', '0.82', '0', '1040', '1200001', null, 'PopulaceGuildlevePublisher', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1500002', null, '0', '0', null, null, null, null, '0', '0', '1900028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500003', null, '0', '0', null, null, null, null, '0', '0', '1600069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500004', null, '0', '0', null, null, null, null, '0', '0', '1100075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500005', null, '0', '0', null, null, null, null, '0', '0', '1600103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500006', 'pplStd_03@08500', '133', '0', '-440.19', '19', '206.1', '3.14', '0', '2051', '1100197', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1500007', null, '0', '0', null, null, null, null, '0', '0', '1400065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500008', null, '0', '0', null, null, null, null, '0', '0', '2200128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500009', null, '0', '0', null, null, null, null, '0', '0', '1200105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500010', null, '0', '0', null, null, null, null, '0', '0', '1900010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500011', null, '0', '0', null, null, null, null, '0', '0', '1900078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500012', null, '0', '0', null, null, null, null, '0', '0', '1600066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500013', null, '0', '0', null, null, null, null, '0', '0', '4000171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500014', null, '0', '0', null, null, null, null, '0', '0', '4000172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500015', null, '0', '0', null, null, null, null, '0', '0', '4000173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500016', null, '0', '0', null, null, null, null, '0', '0', '4000174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500017', null, '0', '0', null, null, null, null, '0', '0', '4000175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500018', null, '0', '0', null, null, null, null, '0', '0', '4000176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500019', null, '0', '0', null, null, null, null, '0', '0', '4000177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500020', null, '0', '0', null, null, null, null, '0', '0', '4000178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500021', null, '0', '0', null, null, null, null, '0', '0', '4000179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500022', null, '0', '0', null, null, null, null, '0', '0', '4000180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500023', null, '0', '0', null, null, null, null, '0', '0', '4000581', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500024', null, '0', '0', null, null, null, null, '0', '0', '4000582', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500025', null, '0', '0', null, null, null, null, '0', '0', '4000583', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500026', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500027', null, '0', '0', null, null, null, null, '0', '0', '4000584', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500028', null, '0', '0', null, null, null, null, '0', '0', '4000585', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500029', null, '0', '0', null, null, null, null, '0', '0', '4000586', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500030', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500031', null, '0', '0', null, null, null, null, '0', '0', '4000587', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500032', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500033', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500034', null, '0', '0', null, null, null, null, '0', '0', '4000588', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500035', null, '0', '0', null, null, null, null, '0', '0', '4000589', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500036', null, '0', '0', null, null, null, null, '0', '0', '4000590', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500037', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500038', null, '0', '0', null, null, null, null, '0', '0', '4000591', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500039', null, '0', '0', null, null, null, null, '0', '0', '4000592', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500040', null, '0', '0', null, null, null, null, '0', '0', '4000593', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500041', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500042', null, '0', '0', null, null, null, null, '0', '0', '4000181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500043', null, '0', '0', null, null, null, null, '0', '0', '4000182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500044', null, '0', '0', null, null, null, null, '0', '0', '4000183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500045', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500046', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500047', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500048', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500049', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500050', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500051', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500052', null, '0', '0', null, null, null, null, '0', '0', '4000184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500053', null, '0', '0', null, null, null, null, '0', '0', '4000185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500054', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500055', null, '0', '0', null, null, null, null, '0', '0', '1200062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500056', null, '0', '0', null, null, null, null, '0', '0', '1100083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500057', null, '0', '0', null, null, null, null, '0', '0', '1100447', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500058', null, '0', '0', null, null, null, null, '0', '0', '1500090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500059', null, '0', '0', null, null, null, null, '0', '0', '1900100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500060', null, '0', '0', null, null, null, null, '0', '0', '1200116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500061', null, '0', '0', null, null, null, null, '0', '0', '1600075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500062', null, '0', '0', null, null, null, null, '0', '0', '1000054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500063', null, '0', '0', null, null, null, null, '0', '0', '1300044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500064', null, '0', '0', null, null, null, null, '0', '0', '1100035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500065', null, '0', '0', null, null, null, null, '0', '0', '1400006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500066', null, '0', '0', null, null, null, null, '0', '0', '1200111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500067', null, '0', '0', null, null, null, null, '0', '0', '1500037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500068', null, '0', '0', null, null, null, null, '0', '0', '1300085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500069', null, '0', '0', null, null, null, null, '0', '0', '1600021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500070', null, '0', '0', null, null, null, null, '0', '0', '1900040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500071', null, '0', '0', null, null, null, null, '0', '0', '1500064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500072', null, '0', '0', null, null, null, null, '0', '0', '1000320', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500073', null, '0', '0', null, null, null, null, '0', '0', '1200106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500074', null, '0', '0', null, null, null, null, '0', '0', '1600058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500075', null, '0', '0', null, null, null, null, '0', '0', '1400079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500076', null, '0', '0', null, null, null, null, '0', '0', '1900045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500077', null, '0', '0', null, null, null, null, '0', '0', '1000063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500078', null, '0', '0', null, null, null, null, '0', '0', '1100096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500079', null, '0', '0', null, null, null, null, '0', '0', '1900125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500080', null, '0', '0', null, null, null, null, '0', '0', '1400056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500081', null, '0', '0', null, null, null, null, '0', '0', '1200126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500082', null, '0', '0', null, null, null, null, '0', '0', '1900007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500083', null, '0', '0', null, null, null, null, '0', '0', '1600171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500084', null, '0', '0', null, null, null, null, '0', '0', '1200005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500085', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500086', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500087', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500088', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500089', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500091', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500092', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500093', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500094', null, '0', '0', null, null, null, null, '0', '0', '1100050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500095', null, '0', '0', null, null, null, null, '0', '0', '1600205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500096', null, '0', '0', null, null, null, null, '0', '0', '1400069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500097', null, '0', '0', null, null, null, null, '0', '0', '1900111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500098', null, '0', '0', null, null, null, null, '0', '0', '1200093', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500099', null, '0', '0', null, null, null, null, '0', '0', '1500060', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500100', null, '0', '0', null, null, null, null, '0', '0', '1100072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500101', null, '0', '0', null, null, null, null, '0', '0', '1600028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500102', null, '0', '0', null, null, null, null, '0', '0', '2200114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500103', null, '0', '0', null, null, null, null, '0', '0', '1300070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500104', null, '0', '0', null, null, null, null, '0', '0', '1000089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500105', null, '0', '0', null, null, null, null, '0', '0', '1600162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500106', null, '0', '0', null, null, null, null, '0', '0', '1500068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500107', null, '0', '0', null, null, null, null, '0', '0', '1900119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500108', null, '0', '0', null, null, null, null, '0', '0', '1300123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500109', null, '0', '0', null, null, null, null, '0', '0', '1200110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500110', null, '0', '0', null, null, null, null, '0', '0', '1900145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500111', null, '0', '0', null, null, null, null, '0', '0', '1000168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500112', null, '0', '0', null, null, null, null, '0', '0', '1500105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500113', null, '0', '0', null, null, null, null, '0', '0', '1900151', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500114', null, '0', '0', null, null, null, null, '0', '0', '1200037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500115', null, '0', '0', null, null, null, null, '0', '0', '1100208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500116', null, '0', '0', null, null, null, null, '0', '0', '1400116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500117', null, '0', '0', null, null, null, null, '0', '0', '2200028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500118', null, '0', '0', null, null, null, null, '0', '0', '1200137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500119', null, '0', '0', null, null, null, null, '0', '0', '1100242', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500120', null, '0', '0', null, null, null, null, '0', '0', '1600311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500121', null, '0', '0', null, null, null, null, '0', '0', '1900183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500122', null, '0', '0', null, null, null, null, '0', '0', '1000424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500123', null, '0', '0', null, null, null, null, '0', '0', '1000240', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500124', null, '0', '0', null, null, null, null, '0', '0', '1500112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500125', 'pplStd_08@08500', '133', '0', '-423.93', '32', '224.19', '1.28', '0', '1040', '1100150', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1500126', null, '0', '0', null, null, null, null, '0', '0', '1500139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500127', null, '0', '0', null, null, null, null, '0', '0', '1200119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500128', null, '0', '0', null, null, null, null, '0', '0', '1600249', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500129', null, '0', '0', null, null, null, null, '0', '0', '1400148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500130', null, '0', '0', null, null, null, null, '0', '0', '1900173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500131', null, '0', '0', null, null, null, null, '0', '0', '4000533', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500132', null, '0', '0', null, null, null, null, '0', '0', '1500153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500133', null, '0', '0', null, null, null, null, '0', '0', '1600278', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500134', null, '0', '0', null, null, null, null, '0', '0', '1600173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500135', null, '0', '0', null, null, null, null, '0', '0', '1900163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500136', null, '0', '0', null, null, null, null, '0', '0', '1900154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500137', null, '0', '0', null, null, null, null, '0', '0', '1000120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500138', null, '0', '0', null, null, null, null, '0', '0', '1000171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500139', null, '0', '0', null, null, null, null, '0', '0', '1300090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500140', null, '0', '0', null, null, null, null, '0', '0', '1400159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500141', null, '0', '0', null, null, null, null, '0', '0', '1400159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500142', null, '0', '0', null, null, null, null, '0', '0', '1600294', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500143', null, '0', '0', null, null, null, null, '0', '0', '1900032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500144', null, '0', '0', null, null, null, null, '0', '0', '1300119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500145', null, '0', '0', null, null, null, null, '0', '0', '1200049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500146', null, '0', '0', null, null, null, null, '0', '0', '1100198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500147', null, '0', '0', null, null, null, null, '0', '0', '2200233', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500148', null, '0', '0', null, null, null, null, '0', '0', '2200245', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500149', null, '0', '0', null, null, null, null, '0', '0', '1000404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500150', null, '0', '0', null, null, null, null, '0', '0', '1000375', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500151', null, '0', '0', null, null, null, null, '0', '0', '1000379', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500152', null, '0', '0', null, null, null, null, '0', '0', '2200193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500153', null, '0', '0', null, null, null, null, '0', '0', '1100103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500154', null, '0', '0', null, null, null, null, '0', '0', '1100086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500155', null, '0', '0', null, null, null, null, '0', '0', '1100111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500156', null, '0', '0', null, null, null, null, '0', '0', '1600024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500157', null, '0', '0', null, null, null, null, '0', '0', '1900155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500158', null, '0', '0', null, null, null, null, '0', '0', '1600295', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500159', null, '0', '0', null, null, null, null, '0', '0', '1600048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500160', null, '0', '0', null, null, null, null, '0', '0', '1600070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500161', null, '0', '0', null, null, null, null, '0', '0', '1900159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500162', null, '0', '0', null, null, null, null, '0', '0', '1900162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500163', null, '0', '0', null, null, null, null, '0', '0', '1100215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500164', null, '0', '0', null, null, null, null, '0', '0', '1300127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500165', null, '0', '0', null, null, null, null, '0', '0', '1200077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500166', null, '0', '0', null, null, null, null, '0', '0', '1900114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500167', null, '0', '0', null, null, null, null, '0', '0', '1400040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500168', null, '0', '0', null, null, null, null, '0', '0', '1200176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500169', null, '0', '0', null, null, null, null, '0', '0', '1600137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500170', null, '0', '0', null, null, null, null, '0', '0', '1200170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500171', null, '0', '0', null, null, null, null, '0', '0', '1200173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500172', null, '0', '0', null, null, null, null, '0', '0', '1600157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500173', null, '0', '0', null, null, null, null, '0', '0', '1900106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500174', null, '0', '0', null, null, null, null, '0', '0', '1000382', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500175', null, '0', '0', null, null, null, null, '0', '0', '1900136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500176', null, '0', '0', null, null, null, null, '0', '0', '1500129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500177', null, '0', '0', null, null, null, null, '0', '0', '1200145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500178', null, '0', '0', null, null, null, null, '0', '0', '2200257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500179', null, '0', '0', null, null, null, null, '0', '0', '1900180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500180', null, '0', '0', null, null, null, null, '0', '0', '1300147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500181', null, '0', '0', null, null, null, null, '0', '0', '1400164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500182', null, '0', '0', null, null, null, null, '0', '0', '1100022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500183', null, '0', '0', null, null, null, null, '0', '0', '1100091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500184', null, '0', '0', null, null, null, null, '0', '0', '2200214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500185', null, '0', '0', null, null, null, null, '0', '0', '1600164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500186', null, '0', '0', null, null, null, null, '0', '0', '1000085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500187', null, '0', '0', null, null, null, null, '0', '0', '1000100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500188', null, '0', '0', null, null, null, null, '0', '0', '1000163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500189', null, '0', '0', null, null, null, null, '0', '0', '1000186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500190', null, '0', '0', null, null, null, null, '0', '0', '1000243', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500191', null, '0', '0', null, null, null, null, '0', '0', '1600289', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500192', null, '0', '0', null, null, null, null, '0', '0', '1600201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500193', null, '0', '0', null, null, null, null, '0', '0', '1000413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500194', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500195', null, '0', '0', null, null, null, null, '0', '0', '1000280', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500196', null, '0', '0', null, null, null, null, '0', '0', '1100415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500197', null, '0', '0', null, null, null, null, '0', '0', '1000110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500198', null, '0', '0', null, null, null, null, '0', '0', '1000288', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500199', null, '0', '0', null, null, null, null, '0', '0', '1000385', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500200', null, '0', '0', null, null, null, null, '0', '0', '1000114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500201', null, '0', '0', null, null, null, null, '0', '0', '1900184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500202', null, '0', '0', null, null, null, null, '0', '0', '1600072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500203', null, '0', '0', null, null, null, null, '0', '0', '1300185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500204', null, '0', '0', null, null, null, null, '0', '0', '2700002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500205', null, '0', '0', null, null, null, null, '0', '0', '4000612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500206', null, '0', '0', null, null, null, null, '0', '0', '1900205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500207', null, '0', '0', null, null, null, null, '0', '0', '1000258', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500208', null, '0', '0', null, null, null, null, '0', '0', '1100106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500209', null, '0', '0', null, null, null, null, '0', '0', '1300105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500210', null, '0', '0', null, null, null, null, '0', '0', '1900201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500211', null, '0', '0', null, null, null, null, '0', '0', '1600153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500212', null, '0', '0', null, null, null, null, '0', '0', '1200188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500213', null, '0', '0', null, null, null, null, '0', '0', '1300165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500214', null, '0', '0', null, null, null, null, '0', '0', '1300112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500215', null, '0', '0', null, null, null, null, '0', '0', '1300161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500216', null, '0', '0', null, null, null, null, '0', '0', '1000358', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500217', null, '0', '0', null, null, null, null, '0', '0', '1000046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500218', null, '0', '0', null, null, null, null, '0', '0', '1000129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500219', null, '0', '0', null, null, null, null, '0', '0', '1600170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500220', null, '0', '0', null, null, null, null, '0', '0', '1600251', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500221', null, '0', '0', null, null, null, null, '0', '0', '1600271', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500222', null, '0', '0', null, null, null, null, '0', '0', '2200035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500223', null, '0', '0', null, null, null, null, '0', '0', '2200045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500224', null, '0', '0', null, null, null, null, '0', '0', '2200067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500225', null, '0', '0', null, null, null, null, '0', '0', '2200070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500226', null, '0', '0', null, null, null, null, '0', '0', '2200077', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500227', null, '0', '0', null, null, null, null, '0', '0', '2200089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500228', null, '0', '0', null, null, null, null, '0', '0', '4000621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500229', null, '0', '0', null, null, null, null, '0', '0', '4000621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500230', null, '0', '0', null, null, null, null, '0', '0', '4000621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500231', null, '0', '0', null, null, null, null, '0', '0', '1000280', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500232', null, '0', '0', null, null, null, null, '0', '0', '1100415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500233', null, '0', '0', null, null, null, null, '0', '0', '1200222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500234', null, '0', '0', null, null, null, null, '0', '0', '1000133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500235', null, '0', '0', null, null, null, null, '0', '0', '1600043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500236', null, '0', '0', null, null, null, null, '0', '0', '1300107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500237', null, '0', '0', null, null, null, null, '0', '0', '1000035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500238', null, '0', '0', null, null, null, null, '0', '0', '1000048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500239', null, '0', '0', null, null, null, null, '0', '0', '1000068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500240', null, '0', '0', null, null, null, null, '0', '0', '1000080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500241', null, '0', '0', null, null, null, null, '0', '0', '1600265', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500242', null, '0', '0', null, null, null, null, '0', '0', '1300193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500243', null, '0', '0', null, null, null, null, '0', '0', '1500162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500244', null, '0', '0', null, null, null, null, '0', '0', '1600197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500245', null, '0', '0', null, null, null, null, '0', '0', '1500165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500246', null, '0', '0', null, null, null, null, '0', '0', '1100105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500247', null, '0', '0', null, null, null, null, '0', '0', '1400192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500248', null, '0', '0', null, null, null, null, '0', '0', '1200213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500249', null, '0', '0', null, null, null, null, '0', '0', '1900263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500250', null, '0', '0', null, null, null, null, '0', '0', '1200211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500251', null, '0', '0', null, null, null, null, '0', '0', '1900257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500252', null, '0', '0', null, null, null, null, '0', '0', '1900261', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500253', null, '0', '0', null, null, null, null, '0', '0', '1200206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500254', null, '0', '0', null, null, null, null, '0', '0', '1200205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500255', null, '0', '0', null, null, null, null, '0', '0', '1200204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500256', null, '0', '0', null, null, null, null, '0', '0', '1100084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500257', null, '0', '0', null, null, null, null, '0', '0', '1200203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500258', null, '0', '0', null, null, null, null, '0', '0', '1100074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500259', null, '0', '0', null, null, null, null, '0', '0', '2200097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500260', null, '0', '0', null, null, null, null, '0', '0', '1300198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500261', null, '0', '0', null, null, null, null, '0', '0', '1000099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500262', null, '0', '0', null, null, null, null, '0', '0', '2200076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500263', null, '0', '0', null, null, null, null, '0', '0', '2200049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500264', null, '0', '0', null, null, null, null, '0', '0', '2200041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500265', null, '0', '0', null, null, null, null, '0', '0', '1000434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500266', null, '0', '0', null, null, null, null, '0', '0', '1900271', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500267', null, '0', '0', null, null, null, null, '0', '0', '1400220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500268', null, '0', '0', null, null, null, null, '0', '0', '1100095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500269', null, '0', '0', null, null, null, null, '0', '0', '1000024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500270', null, '0', '0', null, null, null, null, '0', '0', '1300203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500271', null, '0', '0', null, null, null, null, '0', '0', '1600143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500272', null, '0', '0', null, null, null, null, '0', '0', '1400162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500273', null, '0', '0', null, null, null, null, '0', '0', '1100409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500274', null, '0', '0', null, null, null, null, '0', '0', '1000185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500275', null, '0', '0', null, null, null, null, '0', '0', '1200231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500276', null, '0', '0', null, null, null, null, '0', '0', '1200138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500277', null, '0', '0', null, null, null, null, '0', '0', '1000435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500278', null, '0', '0', null, null, null, null, '0', '0', '1100455', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500279', null, '0', '0', null, null, null, null, '0', '0', '1000088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500280', null, '0', '0', null, null, null, null, '0', '0', '1900215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500281', null, '0', '0', null, null, null, null, '0', '0', '2200066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500282', null, '0', '0', null, null, null, null, '0', '0', '1500182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500283', null, '0', '0', null, null, null, null, '0', '0', '1000148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500284', null, '0', '0', null, null, null, null, '0', '0', '1300166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500285', null, '0', '0', null, null, null, null, '0', '0', '1300167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500286', null, '0', '0', null, null, null, null, '0', '0', '1300168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500287', null, '0', '0', null, null, null, null, '0', '0', '1000200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500288', null, '0', '0', null, null, null, null, '0', '0', '1000201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500289', null, '0', '0', null, null, null, null, '0', '0', '1000202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500290', null, '0', '0', null, null, null, null, '0', '0', '1600330', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500291', null, '0', '0', null, null, null, null, '0', '0', '1600331', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500292', null, '0', '0', null, null, null, null, '0', '0', '1600332', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500293', null, '0', '0', null, null, null, null, '0', '0', '2470021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500294', null, '0', '0', null, null, null, null, '0', '0', '2470007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500295', null, '0', '0', null, null, null, null, '0', '0', '2470014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500297', null, '0', '0', null, null, null, null, '0', '0', '1400175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500298', null, '0', '0', null, null, null, null, '0', '0', '1400177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500299', null, '0', '0', null, null, null, null, '0', '0', '1500194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500300', null, '0', '0', null, null, null, null, '0', '0', '1500192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500301', null, '0', '0', null, null, null, null, '0', '0', '1500195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500302', null, '0', '0', null, null, null, null, '0', '0', '1400181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500303', null, '0', '0', null, null, null, null, '0', '0', '1400183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500304', null, '0', '0', null, null, null, null, '0', '0', '1400196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500305', null, '0', '0', null, null, null, null, '0', '0', '1500196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500306', null, '0', '0', null, null, null, null, '0', '0', '1500197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500307', null, '0', '0', null, null, null, null, '0', '0', '1500198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500308', null, '0', '0', null, null, null, null, '0', '0', '1400198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500309', null, '0', '0', null, null, null, null, '0', '0', '1400203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500310', null, '0', '0', null, null, null, null, '0', '0', '1400204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500311', null, '0', '0', null, null, null, null, '0', '0', '1500199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500312', null, '0', '0', null, null, null, null, '0', '0', '1500193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500313', null, '0', '0', null, null, null, null, '0', '0', '1500201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500314', null, '0', '0', null, null, null, null, '0', '0', '2700002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500315', null, '0', '0', null, null, null, null, '0', '0', '1600146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500316', null, '0', '0', null, null, null, null, '0', '0', '1100341', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500317', null, '0', '0', null, null, null, null, '0', '0', '1000062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500318', null, '0', '0', null, null, null, null, '0', '0', '1500156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500319', null, '0', '0', null, null, null, null, '0', '0', '1200220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500320', null, '0', '0', null, null, null, null, '0', '0', '1900236', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500321', null, '0', '0', null, null, null, null, '0', '0', '1000373', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500322', null, '0', '0', null, null, null, null, '0', '0', '1000389', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500323', null, '0', '0', null, null, null, null, '0', '0', '1000390', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500324', null, '0', '0', null, null, null, null, '0', '0', '1000394', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500325', null, '0', '0', null, null, null, null, '0', '0', '1000406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500326', null, '0', '0', null, null, null, null, '0', '0', '1000407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500327', null, '0', '0', null, null, null, null, '0', '0', '1000411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500328', null, '0', '0', null, null, null, null, '0', '0', '1000412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500329', null, '0', '0', null, null, null, null, '0', '0', '1000419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500330', null, '0', '0', null, null, null, null, '0', '0', '1100400', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500331', null, '0', '0', null, null, null, null, '0', '0', '1100410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500332', null, '0', '0', null, null, null, null, '0', '0', '1100421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500333', null, '0', '0', null, null, null, null, '0', '0', '1100430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500334', null, '0', '0', null, null, null, null, '0', '0', '1100433', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500335', null, '0', '0', null, null, null, null, '0', '0', '1100434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500336', null, '0', '0', null, null, null, null, '0', '0', '1100438', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500337', null, '0', '0', null, null, null, null, '0', '0', '1100440', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500338', null, '0', '0', null, null, null, null, '0', '0', '1100443', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500339', null, '0', '0', null, null, null, null, '0', '0', '1000252', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500340', null, '0', '0', null, null, null, null, '0', '0', '1600146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500341', null, '0', '0', null, null, null, null, '0', '0', '1000062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500342', null, '0', '0', null, null, null, null, '0', '0', '1200220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500343', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500344', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500345', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500346', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500347', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500348', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500349', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500350', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500351', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500352', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500353', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500354', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500355', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500356', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500357', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500358', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500359', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500360', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500361', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500362', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500363', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500364', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500365', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500366', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500367', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500368', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500369', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500370', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500371', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500372', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500373', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500374', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500375', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500376', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500377', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500378', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500379', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500380', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500381', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500382', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500383', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500384', null, '0', '0', null, null, null, null, '0', '0', '1000126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500385', null, '0', '0', null, null, null, null, '0', '0', '1100341', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500386', null, '0', '0', null, null, null, null, '0', '0', '1500156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500387', null, '0', '0', null, null, null, null, '0', '0', '1900236', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500388', null, '0', '0', null, null, null, null, '0', '0', '1600010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500389', null, '0', '0', null, null, null, null, '0', '0', '1200052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500390', null, '0', '0', null, null, null, null, '0', '0', '1400173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500391', null, '0', '0', null, null, null, null, '0', '0', '1000178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500392', null, '0', '0', null, null, null, null, '0', '0', '1900202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500393', null, '0', '0', null, null, null, null, '0', '0', '1200224', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500394', null, '0', '0', null, null, null, null, '0', '0', '1100059', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500395', null, '0', '0', null, null, null, null, '0', '0', '1000137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500396', null, '0', '0', null, null, null, null, '0', '0', '1000174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500397', null, '0', '0', null, null, null, null, '0', '0', '1100367', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500398', null, '0', '0', null, null, null, null, '0', '0', '1200082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500399', null, '0', '0', null, null, null, null, '0', '0', '1200094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500400', null, '0', '0', null, null, null, null, '0', '0', '1200098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500401', null, '0', '0', null, null, null, null, '0', '0', '1200107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500402', null, '0', '0', null, null, null, null, '0', '0', '1300137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500403', null, '0', '0', null, null, null, null, '0', '0', '1300155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500404', null, '0', '0', null, null, null, null, '0', '0', '1300164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500405', null, '0', '0', null, null, null, null, '0', '0', '1300183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500406', null, '0', '0', null, null, null, null, '0', '0', '1300186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500407', null, '0', '0', null, null, null, null, '0', '0', '1300187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500408', null, '0', '0', null, null, null, null, '0', '0', '1300190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500409', null, '0', '0', null, null, null, null, '0', '0', '1400049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500410', null, '0', '0', null, null, null, null, '0', '0', '1400175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500411', null, '0', '0', null, null, null, null, '0', '0', '1400181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500412', null, '0', '0', null, null, null, null, '0', '0', '1400183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500413', null, '0', '0', null, null, null, null, '0', '0', '1400196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500414', null, '0', '0', null, null, null, null, '0', '0', '1400203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500415', null, '0', '0', null, null, null, null, '0', '0', '1400204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500416', null, '0', '0', null, null, null, null, '0', '0', '1500094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500417', null, '0', '0', null, null, null, null, '0', '0', '1500155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500418', null, '0', '0', null, null, null, null, '0', '0', '1500157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500419', null, '0', '0', null, null, null, null, '0', '0', '1500177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500420', null, '0', '0', null, null, null, null, '0', '0', '1600022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500421', null, '0', '0', null, null, null, null, '0', '0', '1600317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500422', null, '0', '0', null, null, null, null, '0', '0', '1900208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500423', null, '0', '0', null, null, null, null, '0', '0', '1900209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500424', null, '0', '0', null, null, null, null, '0', '0', '1900221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500425', null, '0', '0', null, null, null, null, '0', '0', '1900231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500426', null, '0', '0', null, null, null, null, '0', '0', '1900232', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500427', null, '0', '0', null, null, null, null, '0', '0', '1600222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500428', null, '0', '0', null, null, null, null, '0', '0', '1600267', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500429', null, '0', '0', null, null, null, null, '0', '0', '1600319', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500430', null, '0', '0', null, null, null, null, '0', '0', '1000344', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500431', null, '0', '0', null, null, null, null, '0', '0', '1200125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500432', null, '0', '0', null, null, null, null, '0', '0', '1400039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500433', null, '0', '0', null, null, null, null, '0', '0', '1900198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500434', null, '0', '0', null, null, null, null, '0', '0', '1900200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500435', null, '0', '0', null, null, null, null, '0', '0', '1900198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500436', null, '0', '0', null, null, null, null, '0', '0', '1900200', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500437', null, '0', '0', null, null, null, null, '0', '0', '1400164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1500438', null, '0', '0', null, null, null, null, '0', '0', '1900183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600001', 'pplShopSal_0d@08500', '133', '0', '-684.9', '16.2', '229.5', '0', '0', '1041', '1100429', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600002', 'pplShopSal_0e@08500', '133', '0', '-705.3', '16.65', '245.95', '-3', '0', '1041', '1500023', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600003', 'pplShopSal_02@08500', '133', '0', '-583.2', '18.2', '204.3', '0.4', '0', '1016', '1000037', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600004', 'pplShopSal_09@08500', '133', '0', '-577.5', '18.2', '220', '-2.78', '0', '1017', '1300037', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600005', 'pplShopSal_11@08500', '133', '0', '-605.19', '18.65', '213.61', '0.37', '0', '1017', '1400035', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600006', 'pplShopSal_0c@08500', '133', '0', '-683.7', '16.2', '246.3', '-3.14', '0', '1017', '1900002', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600007', 'pplShopSal_0f@08500', '133', '0', '-696.12', '16.2', '229.45', '0', '0', '1016', '1600128', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600008', 'pplShopSal_0b@08500', '133', '0', '-597.14', '18.65', '227.81', '-2.76', '0', '1015', '1500058', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600009', 'pplShopSal_0a@08500', '133', '0', '-587.5', '18.2', '224', '-2.78', '0', '1015', '1900048', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600010', 'pplShopSal_10@08500', '133', '0', '-705.5', '16.2', '229.5', '0', '0', '1016', '1200048', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600011', 'pplShopSal_03@08500', '133', '0', '-490.5', '40', '312', '-1.6', '0', '1041', '1600272', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}\r\n');
INSERT INTO `gamedata_actor_class` VALUES ('1600012', 'pplShopSal_01@08500', '133', '0', '-442.6', '44', '37.7', '-1.5', '0', '1040', '1900009', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600013', 'pplShopSal_06@08500', '133', '0', '-500.2', '39.9', '363', '2.5', '0', '1016', '1000154', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600014', 'pplShopSal_04@08500', '133', '0', '-500.2', '39.9', '354.6', '0.9', '0', '1016', '1100089', null, 'PopulaceShopSalesman', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600015', null, '0', '0', null, null, null, null, '0', '0', '1500035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600016', null, '0', '0', null, null, null, null, '0', '0', '1100108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600017', null, '0', '0', null, null, null, null, '0', '0', '1000337', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600018', null, '0', '0', null, null, null, null, '0', '0', '1600176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600019', null, '0', '0', null, null, null, null, '0', '0', '2200132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600020', null, '0', '0', null, null, null, null, '0', '0', '1100107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600021', null, '0', '0', null, null, null, null, '0', '0', '1200109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600022', null, '0', '0', null, null, null, null, '0', '0', '1400052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600023', null, '0', '0', null, null, null, null, '0', '0', '1600017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600024', null, '0', '0', null, null, null, null, '0', '0', '1300039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600025', null, '0', '0', null, null, null, null, '0', '0', '1500079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600026', null, '0', '0', null, null, null, null, '0', '0', '1000139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600027', null, '0', '0', null, null, null, null, '0', '0', '1300096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600028', null, '0', '0', null, null, null, null, '0', '0', '1100117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600029', null, '0', '0', null, null, null, null, '0', '0', '1200124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600030', null, '0', '0', null, null, null, null, '0', '0', '1000166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600031', null, '0', '0', null, null, null, null, '0', '0', '1600206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600032', null, '0', '0', null, null, null, null, '0', '0', '1900005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600033', null, '0', '0', null, null, null, null, '0', '0', '1900096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600034', null, '0', '0', null, null, null, null, '0', '0', '1100079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600035', null, '0', '0', null, null, null, null, '0', '0', '1200118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600036', null, '0', '0', null, null, null, null, '0', '0', '1300095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600037', null, '0', '0', null, null, null, null, '0', '0', '1600252', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600038', null, '0', '0', null, null, null, null, '0', '0', '1000056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600039', null, '0', '0', null, null, null, null, '0', '0', '1500095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600040', null, '0', '0', null, null, null, null, '0', '0', '1200070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600041', null, '0', '0', null, null, null, null, '0', '0', '1200067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600042', null, '0', '0', null, null, null, null, '0', '0', '1600127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600043', null, '0', '0', null, null, null, null, '0', '0', '1900008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600044', null, '0', '0', null, null, null, null, '0', '0', '1300010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600045', null, '0', '0', null, null, null, null, '0', '0', '1100063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600046', null, '0', '0', null, null, null, null, '0', '0', '1600057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600047', null, '0', '0', null, null, null, null, '0', '0', '1000043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600048', null, '0', '0', null, null, null, null, '0', '0', '1400030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600049', null, '0', '0', null, null, null, null, '0', '0', '1100327', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600050', null, '0', '0', null, null, null, null, '0', '0', '1500011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600051', null, '0', '0', null, null, null, null, '0', '0', '1000147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600052', null, '0', '0', null, null, null, null, '0', '0', '1200011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600053', null, '0', '0', null, null, null, null, '0', '0', '1100065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600054', null, '0', '0', null, null, null, null, '0', '0', '1200099', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600055', null, '0', '0', null, null, null, null, '0', '0', '1300062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600056', null, '0', '0', null, null, null, null, '0', '0', '1600245', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600057', null, '0', '0', null, null, null, null, '0', '0', '1600254', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600058', null, '0', '0', null, null, null, null, '0', '0', '1900103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600059', null, '0', '0', null, null, null, null, '0', '0', '1300058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600060', null, '0', '0', null, null, null, null, '0', '0', '1400063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600061', null, '0', '0', null, null, null, null, '0', '0', '1200051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600062', null, '0', '0', null, null, null, null, '0', '0', '1000047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600063', null, '0', '0', null, null, null, null, '0', '0', '1900098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600064', null, '0', '0', null, null, null, null, '0', '0', '1900196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600065', null, '0', '0', null, null, null, null, '0', '0', '1100437', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600066', null, '0', '0', null, null, null, null, '0', '0', '1500160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600067', null, '0', '0', null, null, null, null, '0', '0', '1200202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600068', null, '0', '0', null, null, null, null, '0', '0', '1600193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600069', null, '0', '0', null, null, null, null, '0', '0', '1400188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600070', null, '0', '0', null, null, null, null, '0', '0', '1000238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600071', null, '0', '0', null, null, null, null, '0', '0', '1100436', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600072', null, '0', '0', null, null, null, null, '0', '0', '1300153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600073', null, '0', '0', null, null, null, null, '0', '0', '1000241', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600074', null, '0', '0', null, null, null, null, '0', '0', '2200044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600075', null, '0', '0', null, null, null, null, '0', '0', '1200219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600076', null, '0', '0', null, null, null, null, '0', '0', '1300157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600077', null, '0', '0', null, null, null, null, '0', '0', '1900191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600078', null, '0', '0', null, null, null, null, '0', '0', '1500161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600079', null, '0', '0', null, null, null, null, '0', '0', '1200207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600080', null, '0', '0', null, null, null, null, '0', '0', '1000245', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600081', null, '0', '0', null, null, null, null, '0', '0', '2200011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600082', null, '0', '0', null, null, null, null, '0', '0', '1200209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600083', null, '0', '0', null, null, null, null, '0', '0', '1100425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600084', null, '0', '0', null, null, null, null, '0', '0', '1000249', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600085', null, '0', '0', null, null, null, null, '0', '0', '1100413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600086', null, '0', '0', null, null, null, null, '0', '0', '1200217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600087', null, '0', '0', null, null, null, null, '0', '0', '1400189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600088', null, '0', '0', null, null, null, null, '0', '0', '1300162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600089', null, '0', '0', null, null, null, null, '0', '0', '1900192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600090', null, '0', '0', null, null, null, null, '0', '0', '1600212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600091', null, '0', '0', null, null, null, null, '0', '0', '1000259', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600092', null, '0', '0', null, null, null, null, '0', '0', '1000267', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600093', null, '0', '0', null, null, null, null, '0', '0', '1900194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600094', null, '0', '0', null, null, null, null, '0', '0', '1600218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600095', null, '0', '0', null, null, null, null, '0', '0', '1000082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600096', null, '0', '0', null, null, null, null, '0', '0', '1000096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600097', null, '0', '0', null, null, null, null, '0', '0', '1000107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600098', null, '0', '0', null, null, null, null, '0', '0', '1400195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600099', null, '0', '0', null, null, null, null, '0', '0', '1600259', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600100', null, '0', '0', null, null, null, null, '0', '0', '1600253', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600101', null, '0', '0', null, null, null, null, '0', '0', '1500164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600102', null, '0', '0', null, null, null, null, '0', '0', '1300194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600103', null, '0', '0', null, null, null, null, '0', '0', '1600232', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600104', null, '0', '0', null, null, null, null, '0', '0', '1600231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600105', null, '0', '0', null, null, null, null, '0', '0', '1600230', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600106', null, '0', '0', null, null, null, null, '0', '0', '1600229', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600107', null, '0', '0', null, null, null, null, '0', '0', '1600215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600108', null, '0', '0', null, null, null, null, '0', '0', '1500163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600109', null, '0', '0', null, null, null, null, '0', '0', '1600207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600110', null, '0', '0', null, null, null, null, '0', '0', '1100109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600111', null, '0', '0', null, null, null, null, '0', '0', '1900262', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600112', null, '0', '0', null, null, null, null, '0', '0', '1200215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600113', null, '0', '0', null, null, null, null, '0', '0', '1400194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600114', null, '0', '0', null, null, null, null, '0', '0', '1400191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600115', null, '0', '0', null, null, null, null, '0', '0', '1100100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600116', null, '0', '0', null, null, null, null, '0', '0', '1200214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600117', null, '0', '0', null, null, null, null, '0', '0', '1300197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600118', null, '0', '0', null, null, null, null, '0', '0', '1200212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600119', null, '0', '0', null, null, null, null, '0', '0', '1900259', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600120', null, '0', '0', null, null, null, null, '0', '0', '1200210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600121', null, '0', '0', null, null, null, null, '0', '0', '1300196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600122', null, '0', '0', null, null, null, null, '0', '0', '1200208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600123', 'pplStd_07@08500', '133', '0', '-435.2', '40', '207.07', '-1.9', '0', '0', '1100092', null, 'PopulaceStandard', '{\r\n  \"talkEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"talkDefault\"\r\n    }\r\n  ],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('1600124', null, '0', '0', null, null, null, null, '0', '0', '1100090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600125', null, '0', '0', null, null, null, null, '0', '0', '1400190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600126', null, '0', '0', null, null, null, null, '0', '0', '1900258', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600127', null, '0', '0', null, null, null, null, '0', '0', '1900253', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600128', null, '0', '0', null, null, null, null, '0', '0', '1000118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600129', null, '0', '0', null, null, null, null, '0', '0', '1000116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600130', null, '0', '0', null, null, null, null, '0', '0', '2200091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600131', null, '0', '0', null, null, null, null, '0', '0', '1400193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600132', null, '0', '0', null, null, null, null, '0', '0', '2200085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600133', null, '0', '0', null, null, null, null, '0', '0', '1000105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600134', null, '0', '0', null, null, null, null, '0', '0', '1100057', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600135', null, '0', '0', null, null, null, null, '0', '0', '1100055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600136', null, '0', '0', null, null, null, null, '0', '0', '1100053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600137', null, '0', '0', null, null, null, null, '0', '0', '1000083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600138', null, '0', '0', null, null, null, null, '0', '0', '1300195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600139', null, '0', '0', null, null, null, null, '0', '0', '1900256', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600140', null, '0', '0', null, null, null, null, '0', '0', '2200062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600141', null, '0', '0', null, null, null, null, '0', '0', '1900254', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600142', null, '0', '0', null, null, null, null, '0', '0', '1100051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600143', null, '0', '0', null, null, null, null, '0', '0', '1500166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600144', null, '0', '0', null, null, null, null, '0', '0', '1500167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1600145', null, '0', '0', null, null, null, null, '0', '0', '1500168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700001', null, '0', '0', null, null, null, null, '0', '0', '1100404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700002', null, '0', '0', null, null, null, null, '0', '0', '4000525', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700003', null, '0', '0', null, null, null, null, '0', '0', '4000526', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700004', null, '0', '0', null, null, null, null, '0', '0', '4000527', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700005', null, '0', '0', null, null, null, null, '0', '0', '4000528', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700006', null, '0', '0', null, null, null, null, '0', '0', '4000529', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700007', null, '0', '0', null, null, null, null, '0', '0', '4000530', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700008', null, '0', '0', null, null, null, null, '0', '0', '4000531', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700009', null, '0', '0', null, null, null, null, '0', '0', '1300094', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700010', null, '0', '0', null, null, null, null, '0', '0', '4000559', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700011', null, '0', '0', null, null, null, null, '0', '0', '2480001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700012', null, '0', '0', null, null, null, null, '0', '0', '4000201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700013', null, '0', '0', null, null, null, null, '0', '0', '4000202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700014', null, '0', '0', null, null, null, null, '0', '0', '4000203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700015', null, '0', '0', null, null, null, null, '0', '0', '4000204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700016', null, '0', '0', null, null, null, null, '0', '0', '4000205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700017', null, '0', '0', null, null, null, null, '0', '0', '4000206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700018', null, '0', '0', null, null, null, null, '0', '0', '4000207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700019', null, '0', '0', null, null, null, null, '0', '0', '4000208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700020', null, '0', '0', null, null, null, null, '0', '0', '4000209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700021', null, '0', '0', null, null, null, null, '0', '0', '4000210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700022', null, '0', '0', null, null, null, null, '0', '0', '4000211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700023', null, '0', '0', null, null, null, null, '0', '0', '1100294', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700024', null, '0', '0', null, null, null, null, '0', '0', '1000414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700025', null, '0', '0', null, null, null, null, '0', '0', '1200068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700026', null, '0', '0', null, null, null, null, '0', '0', '1100263', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700027', null, '0', '0', null, null, null, null, '0', '0', '1100394', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700028', null, '0', '0', null, null, null, null, '0', '0', '1100199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700029', null, '0', '0', null, null, null, null, '0', '0', '1300018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700030', null, '0', '0', null, null, null, null, '0', '0', '1300064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700031', null, '0', '0', null, null, null, null, '0', '0', '1900046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700032', null, '0', '0', null, null, null, null, '0', '0', '4000063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700033', null, '0', '0', null, null, null, null, '0', '0', '1500052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700034', null, '0', '0', null, null, null, null, '0', '0', '1500071', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700035', null, '0', '0', null, null, null, null, '0', '0', '1300040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700036', null, '0', '0', null, null, null, null, '0', '0', '1900042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700037', null, '0', '0', null, null, null, null, '0', '0', '2200028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700038', null, '0', '0', null, null, null, null, '0', '0', '1200137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700039', null, '0', '0', null, null, null, null, '0', '0', '1100242', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700040', null, '0', '0', null, null, null, null, '0', '0', '4000505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700041', null, '0', '0', null, null, null, null, '0', '0', '4000508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700042', null, '0', '0', null, null, null, null, '0', '0', '1100422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700043', null, '0', '0', null, null, null, null, '0', '0', '4000570', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('1700044', null, '0', '0', null, null, null, null, '0', '0', '4000153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100101', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100102', null, '0', '0', null, null, null, null, '0', '0', '3100102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100103', null, '0', '0', null, null, null, null, '0', '0', '3100103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100104', null, '0', '0', null, null, null, null, '0', '0', '3100104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100105', null, '0', '0', null, null, null, null, '0', '0', '3100105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100106', null, '0', '0', null, null, null, null, '0', '0', '3100106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100107', null, '0', '0', null, null, null, null, '0', '0', '3100107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100108', null, '0', '0', null, null, null, null, '0', '0', '3100108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100109', null, '0', '0', null, null, null, null, '0', '0', '3100109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100110', null, '0', '0', null, null, null, null, '0', '0', '3100110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100111', null, '0', '0', null, null, null, null, '0', '0', '3100111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100112', null, '0', '0', null, null, null, null, '0', '0', '3100112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100113', null, '0', '0', null, null, null, null, '0', '0', '3100116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100114', null, '0', '0', null, null, null, null, '0', '0', '3100117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100115', null, '0', '0', null, null, null, null, '0', '0', '3100113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100116', null, '0', '0', null, null, null, null, '0', '0', '3100114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100117', null, '0', '0', null, null, null, null, '0', '0', '3100115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100118', null, '0', '0', null, null, null, null, '0', '0', '3100114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100119', null, '0', '0', null, null, null, null, '0', '0', '3100118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100120', null, '0', '0', null, null, null, null, '0', '0', '3100118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100121', null, '0', '0', null, null, null, null, '0', '0', '3100118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100201', null, '0', '0', null, null, null, null, '0', '0', '3100205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100202', null, '0', '0', null, null, null, null, '0', '0', '3100206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100203', null, '0', '0', null, null, null, null, '0', '0', '3100207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100204', null, '0', '0', null, null, null, null, '0', '0', '3100208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100205', null, '0', '0', null, null, null, null, '0', '0', '3100201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100206', null, '0', '0', null, null, null, null, '0', '0', '3100202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100207', null, '0', '0', null, null, null, null, '0', '0', '3100203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100208', null, '0', '0', null, null, null, null, '0', '0', '3100204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100209', null, '0', '0', null, null, null, null, '0', '0', '3100210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100210', null, '0', '0', null, null, null, null, '0', '0', '3100209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100211', null, '0', '0', null, null, null, null, '0', '0', '3100211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100212', null, '0', '0', null, null, null, null, '0', '0', '3100211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100213', null, '0', '0', null, null, null, null, '0', '0', '3100211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100214', null, '0', '0', null, null, null, null, '0', '0', '3100212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100215', null, '0', '0', null, null, null, null, '0', '0', '3100213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100301', null, '0', '0', null, null, null, null, '0', '0', '3100301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100302', null, '0', '0', null, null, null, null, '0', '0', '3100302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100303', null, '0', '0', null, null, null, null, '0', '0', '3100303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100304', null, '0', '0', null, null, null, null, '0', '0', '3100304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100305', null, '0', '0', null, null, null, null, '0', '0', '3100305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100306', null, '0', '0', null, null, null, null, '0', '0', '3100306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100307', null, '0', '0', null, null, null, null, '0', '0', '3100307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100308', null, '0', '0', null, null, null, null, '0', '0', '3100308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100309', null, '0', '0', null, null, null, null, '0', '0', '3100311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100310', null, '0', '0', null, null, null, null, '0', '0', '3100309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100311', null, '0', '0', null, null, null, null, '0', '0', '3100310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100312', null, '0', '0', null, null, null, null, '0', '0', '3100312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100313', null, '0', '0', null, null, null, null, '0', '0', '3100312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100314', null, '0', '0', null, null, null, null, '0', '0', '3100312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100315', null, '0', '0', null, null, null, null, '0', '0', '3100313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100316', null, '0', '0', null, null, null, null, '0', '0', '3100313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100317', null, '0', '0', null, null, null, null, '0', '0', '3100313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100401', null, '0', '0', null, null, null, null, '0', '0', '3100401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100402', null, '0', '0', null, null, null, null, '0', '0', '3100402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100403', null, '0', '0', null, null, null, null, '0', '0', '3100403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100404', null, '0', '0', null, null, null, null, '0', '0', '3100404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100405', null, '0', '0', null, null, null, null, '0', '0', '3100405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100406', null, '0', '0', null, null, null, null, '0', '0', '3100406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100407', null, '0', '0', null, null, null, null, '0', '0', '3100407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100408', null, '0', '0', null, null, null, null, '0', '0', '3100408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100409', null, '0', '0', null, null, null, null, '0', '0', '3100409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100410', null, '0', '0', null, null, null, null, '0', '0', '3100410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100411', null, '0', '0', null, null, null, null, '0', '0', '3100411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100412', null, '0', '0', null, null, null, null, '0', '0', '3100411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100413', null, '0', '0', null, null, null, null, '0', '0', '3100411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100501', null, '0', '0', null, null, null, null, '0', '0', '3100501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100502', null, '0', '0', null, null, null, null, '0', '0', '3100502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100503', null, '0', '0', null, null, null, null, '0', '0', '3100503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100504', null, '0', '0', null, null, null, null, '0', '0', '3100504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100505', null, '0', '0', null, null, null, null, '0', '0', '3100505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100506', null, '0', '0', null, null, null, null, '0', '0', '3100506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100507', null, '0', '0', null, null, null, null, '0', '0', '3100507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100508', null, '0', '0', null, null, null, null, '0', '0', '3100508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100509', null, '0', '0', null, null, null, null, '0', '0', '3100511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100510', null, '0', '0', null, null, null, null, '0', '0', '3100512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100511', null, '0', '0', null, null, null, null, '0', '0', '3100509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100512', null, '0', '0', null, null, null, null, '0', '0', '3100510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100513', null, '0', '0', null, null, null, null, '0', '0', '3100513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100514', null, '0', '0', null, null, null, null, '0', '0', '3100513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100515', null, '0', '0', null, null, null, null, '0', '0', '3100513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100516', null, '0', '0', null, null, null, null, '0', '0', '3100514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100517', null, '0', '0', null, null, null, null, '0', '0', '3100514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100518', null, '0', '0', null, null, null, null, '0', '0', '3100514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100519', null, '0', '0', null, null, null, null, '0', '0', '3100515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100601', null, '0', '0', null, null, null, null, '0', '0', '3100601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100602', null, '0', '0', null, null, null, null, '0', '0', '3100602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100603', null, '0', '0', null, null, null, null, '0', '0', '3100603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100604', null, '0', '0', null, null, null, null, '0', '0', '3100604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100605', null, '0', '0', null, null, null, null, '0', '0', '3100605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100606', null, '0', '0', null, null, null, null, '0', '0', '3100606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100607', null, '0', '0', null, null, null, null, '0', '0', '3100607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100608', null, '0', '0', null, null, null, null, '0', '0', '3100608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100609', null, '0', '0', null, null, null, null, '0', '0', '3100611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100610', null, '0', '0', null, null, null, null, '0', '0', '3100612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100611', null, '0', '0', null, null, null, null, '0', '0', '3100609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100612', null, '0', '0', null, null, null, null, '0', '0', '3100610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100613', null, '0', '0', null, null, null, null, '0', '0', '3100613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100614', null, '0', '0', null, null, null, null, '0', '0', '3100613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100615', null, '0', '0', null, null, null, null, '0', '0', '3100613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100701', null, '0', '0', null, null, null, null, '0', '0', '3100701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100702', null, '0', '0', null, null, null, null, '0', '0', '3100702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100703', null, '0', '0', null, null, null, null, '0', '0', '3100703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100704', null, '0', '0', null, null, null, null, '0', '0', '3100704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100705', null, '0', '0', null, null, null, null, '0', '0', '3100705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100706', null, '0', '0', null, null, null, null, '0', '0', '3100706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100707', null, '0', '0', null, null, null, null, '0', '0', '3100707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100708', null, '0', '0', null, null, null, null, '0', '0', '3100708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100709', null, '0', '0', null, null, null, null, '0', '0', '3100709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100710', null, '0', '0', null, null, null, null, '0', '0', '3100710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100711', null, '0', '0', null, null, null, null, '0', '0', '3100711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100712', null, '0', '0', null, null, null, null, '0', '0', '3100712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100713', null, '0', '0', null, null, null, null, '0', '0', '3100713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100714', null, '0', '0', null, null, null, null, '0', '0', '3100714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100715', null, '0', '0', null, null, null, null, '0', '0', '3100715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100716', null, '0', '0', null, null, null, null, '0', '0', '3100716', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100717', null, '0', '0', null, null, null, null, '0', '0', '3100717', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100718', null, '0', '0', null, null, null, null, '0', '0', '3100718', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100719', null, '0', '0', null, null, null, null, '0', '0', '3100719', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100720', null, '0', '0', null, null, null, null, '0', '0', '3100720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100721', null, '0', '0', null, null, null, null, '0', '0', '3100720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100722', null, '0', '0', null, null, null, null, '0', '0', '3100720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100723', null, '0', '0', null, null, null, null, '0', '0', '3100721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100801', null, '0', '0', null, null, null, null, '0', '0', '3100801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100802', null, '0', '0', null, null, null, null, '0', '0', '3100802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100803', null, '0', '0', null, null, null, null, '0', '0', '3100803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100804', null, '0', '0', null, null, null, null, '0', '0', '3100804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100901', null, '0', '0', null, null, null, null, '0', '0', '3100901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100902', null, '0', '0', null, null, null, null, '0', '0', '3100902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100903', null, '0', '0', null, null, null, null, '0', '0', '3100903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100904', null, '0', '0', null, null, null, null, '0', '0', '3100904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100905', null, '0', '0', null, null, null, null, '0', '0', '3100905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100906', null, '0', '0', null, null, null, null, '0', '0', '3100906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100907', null, '0', '0', null, null, null, null, '0', '0', '3100907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100908', null, '0', '0', null, null, null, null, '0', '0', '3100908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100909', null, '0', '0', null, null, null, null, '0', '0', '3100909', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100910', null, '0', '0', null, null, null, null, '0', '0', '3100913', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100911', null, '0', '0', null, null, null, null, '0', '0', '3100910', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100912', null, '0', '0', null, null, null, null, '0', '0', '3100911', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100913', null, '0', '0', null, null, null, null, '0', '0', '3100912', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100914', null, '0', '0', null, null, null, null, '0', '0', '3100914', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100915', null, '0', '0', null, null, null, null, '0', '0', '3100914', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2100916', null, '0', '0', null, null, null, null, '0', '0', '3100914', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101001', null, '0', '0', null, null, null, null, '0', '0', '3101001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101002', null, '0', '0', null, null, null, null, '0', '0', '3101002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101003', null, '0', '0', null, null, null, null, '0', '0', '3101003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101004', null, '0', '0', null, null, null, null, '0', '0', '3101004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101005', null, '0', '0', null, null, null, null, '0', '0', '3101005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101006', null, '0', '0', null, null, null, null, '0', '0', '3101006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101007', null, '0', '0', null, null, null, null, '0', '0', '3101007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101008', null, '0', '0', null, null, null, null, '0', '0', '3101008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101009', null, '0', '0', null, null, null, null, '0', '0', '3101009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101010', null, '0', '0', null, null, null, null, '0', '0', '3101010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101011', null, '0', '0', null, null, null, null, '0', '0', '3101011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101101', null, '0', '0', null, null, null, null, '0', '0', '3101101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101102', null, '0', '0', null, null, null, null, '0', '0', '3101102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101103', null, '0', '0', null, null, null, null, '0', '0', '3101103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101104', null, '0', '0', null, null, null, null, '0', '0', '3101104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101105', null, '0', '0', null, null, null, null, '0', '0', '3101105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101106', null, '0', '0', null, null, null, null, '0', '0', '3101106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101107', null, '0', '0', null, null, null, null, '0', '0', '3101107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101108', null, '0', '0', null, null, null, null, '0', '0', '3101108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101109', null, '0', '0', null, null, null, null, '0', '0', '3101109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101110', null, '0', '0', null, null, null, null, '0', '0', '3101110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101111', null, '0', '0', null, null, null, null, '0', '0', '3101111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101112', null, '0', '0', null, null, null, null, '0', '0', '3101112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101113', null, '0', '0', null, null, null, null, '0', '0', '3101109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101114', null, '0', '0', null, null, null, null, '0', '0', '3101113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101115', null, '0', '0', null, null, null, null, '0', '0', '3101114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101116', null, '0', '0', null, null, null, null, '0', '0', '3101115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101117', null, '0', '0', null, null, null, null, '0', '0', '3101116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101118', null, '0', '0', null, null, null, null, '0', '0', '3101116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101119', null, '0', '0', null, null, null, null, '0', '0', '3101116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101120', null, '0', '0', null, null, null, null, '0', '0', '3101114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101201', null, '0', '0', null, null, null, null, '0', '0', '3101201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101202', null, '0', '0', null, null, null, null, '0', '0', '3101202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101203', null, '0', '0', null, null, null, null, '0', '0', '3101203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101204', null, '0', '0', null, null, null, null, '0', '0', '3101204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101205', null, '0', '0', null, null, null, null, '0', '0', '3101205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101206', null, '0', '0', null, null, null, null, '0', '0', '3101206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101207', null, '0', '0', null, null, null, null, '0', '0', '3101207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101208', null, '0', '0', null, null, null, null, '0', '0', '3101208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101209', null, '0', '0', null, null, null, null, '0', '0', '3101209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101210', null, '0', '0', null, null, null, null, '0', '0', '3101210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101211', null, '0', '0', null, null, null, null, '0', '0', '3101211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101212', null, '0', '0', null, null, null, null, '0', '0', '3101211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101213', null, '0', '0', null, null, null, null, '0', '0', '3101211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101214', null, '0', '0', null, null, null, null, '0', '0', '3101212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101301', null, '0', '0', null, null, null, null, '0', '0', '3101301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101302', null, '0', '0', null, null, null, null, '0', '0', '3101302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101303', null, '0', '0', null, null, null, null, '0', '0', '3101303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101304', null, '0', '0', null, null, null, null, '0', '0', '3101304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101305', null, '0', '0', null, null, null, null, '0', '0', '3101305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101306', null, '0', '0', null, null, null, null, '0', '0', '3101306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101307', null, '0', '0', null, null, null, null, '0', '0', '3101307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101308', null, '0', '0', null, null, null, null, '0', '0', '3101308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101309', null, '0', '0', null, null, null, null, '0', '0', '3101309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101310', null, '0', '0', null, null, null, null, '0', '0', '3101310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101311', null, '0', '0', null, null, null, null, '0', '0', '3101311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101312', null, '0', '0', null, null, null, null, '0', '0', '3101312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101313', null, '0', '0', null, null, null, null, '0', '0', '3101313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101314', null, '0', '0', null, null, null, null, '0', '0', '3101314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101315', null, '0', '0', null, null, null, null, '0', '0', '3101315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101316', null, '0', '0', null, null, null, null, '0', '0', '3101316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101317', null, '0', '0', null, null, null, null, '0', '0', '3101317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101318', null, '0', '0', null, null, null, null, '0', '0', '3101318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101319', null, '0', '0', null, null, null, null, '0', '0', '3101319', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101320', null, '0', '0', null, null, null, null, '0', '0', '3101320', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101321', null, '0', '0', null, null, null, null, '0', '0', '3101321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101322', null, '0', '0', null, null, null, null, '0', '0', '3101321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101323', null, '0', '0', null, null, null, null, '0', '0', '3101321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101401', null, '0', '0', null, null, null, null, '0', '0', '3101401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101402', null, '0', '0', null, null, null, null, '0', '0', '3101402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101403', null, '0', '0', null, null, null, null, '0', '0', '3101403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101404', null, '0', '0', null, null, null, null, '0', '0', '3101404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101405', null, '0', '0', null, null, null, null, '0', '0', '3101405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101406', null, '0', '0', null, null, null, null, '0', '0', '3101406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101407', null, '0', '0', null, null, null, null, '0', '0', '3101407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101408', null, '0', '0', null, null, null, null, '0', '0', '3101408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101409', null, '0', '0', null, null, null, null, '0', '0', '3101409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101410', null, '0', '0', null, null, null, null, '0', '0', '3101410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101411', null, '0', '0', null, null, null, null, '0', '0', '3101411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101412', null, '0', '0', null, null, null, null, '0', '0', '3101412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101413', null, '0', '0', null, null, null, null, '0', '0', '3101415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101414', null, '0', '0', null, null, null, null, '0', '0', '3101413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101415', null, '0', '0', null, null, null, null, '0', '0', '3101414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101416', null, '0', '0', null, null, null, null, '0', '0', '3101416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101417', null, '0', '0', null, null, null, null, '0', '0', '3101416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101418', null, '0', '0', null, null, null, null, '0', '0', '3101417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101419', null, '0', '0', null, null, null, null, '0', '0', '3101417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101420', null, '0', '0', null, null, null, null, '0', '0', '3101417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101421', null, '0', '0', null, null, null, null, '0', '0', '3101417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101422', null, '0', '0', null, null, null, null, '0', '0', '3101418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101423', null, '0', '0', null, null, null, null, '0', '0', '3101419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101424', null, '0', '0', null, null, null, null, '0', '0', '3101420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101425', null, '0', '0', null, null, null, null, '0', '0', '3101420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101426', null, '0', '0', null, null, null, null, '0', '0', '3101420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101427', null, '0', '0', null, null, null, null, '0', '0', '3101421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101428', null, '0', '0', null, null, null, null, '0', '0', '3101422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101429', null, '0', '0', null, null, null, null, '0', '0', '3101423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101430', null, '0', '0', null, null, null, null, '0', '0', '3101423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101431', null, '0', '0', null, null, null, null, '0', '0', '3101423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101501', null, '0', '0', null, null, null, null, '0', '0', '3101501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101502', null, '0', '0', null, null, null, null, '0', '0', '3101502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101503', null, '0', '0', null, null, null, null, '0', '0', '3101503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101504', null, '0', '0', null, null, null, null, '0', '0', '3101504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101505', null, '0', '0', null, null, null, null, '0', '0', '3101505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101506', null, '0', '0', null, null, null, null, '0', '0', '3101506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101507', null, '0', '0', null, null, null, null, '0', '0', '3101507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101508', null, '0', '0', null, null, null, null, '0', '0', '3101508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101509', null, '0', '0', null, null, null, null, '0', '0', '3101511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101510', null, '0', '0', null, null, null, null, '0', '0', '3101509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101511', null, '0', '0', null, null, null, null, '0', '0', '3101510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101512', null, '0', '0', null, null, null, null, '0', '0', '3101512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101513', null, '0', '0', null, null, null, null, '0', '0', '3101512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101514', null, '0', '0', null, null, null, null, '0', '0', '3101512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101515', null, '0', '0', null, null, null, null, '0', '0', '3101513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101601', null, '0', '0', null, null, null, null, '0', '0', '3101601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101602', null, '0', '0', null, null, null, null, '0', '0', '3101602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101603', null, '0', '0', null, null, null, null, '0', '0', '3101603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101604', null, '0', '0', null, null, null, null, '0', '0', '3101604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101605', null, '0', '0', null, null, null, null, '0', '0', '3101605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101606', null, '0', '0', null, null, null, null, '0', '0', '3101606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101607', null, '0', '0', null, null, null, null, '0', '0', '3101607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101608', null, '0', '0', null, null, null, null, '0', '0', '3101608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101609', null, '0', '0', null, null, null, null, '0', '0', '3101611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101610', null, '0', '0', null, null, null, null, '0', '0', '3101612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101611', null, '0', '0', null, null, null, null, '0', '0', '3101609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101612', null, '0', '0', null, null, null, null, '0', '0', '3101610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101613', null, '0', '0', null, null, null, null, '0', '0', '3101613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101614', null, '0', '0', null, null, null, null, '0', '0', '3101614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101701', null, '0', '0', null, null, null, null, '0', '0', '3101701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101702', null, '0', '0', null, null, null, null, '0', '0', '3101702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101703', null, '0', '0', null, null, null, null, '0', '0', '3101703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101704', null, '0', '0', null, null, null, null, '0', '0', '3101704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101705', null, '0', '0', null, null, null, null, '0', '0', '3101705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101706', null, '0', '0', null, null, null, null, '0', '0', '3101706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101707', null, '0', '0', null, null, null, null, '0', '0', '3101707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101708', null, '0', '0', null, null, null, null, '0', '0', '3101708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101709', null, '0', '0', null, null, null, null, '0', '0', '3101709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101710', null, '0', '0', null, null, null, null, '0', '0', '3101710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101711', null, '0', '0', null, null, null, null, '0', '0', '3101713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101712', null, '0', '0', null, null, null, null, '0', '0', '3101711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101713', null, '0', '0', null, null, null, null, '0', '0', '3101712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101714', null, '0', '0', null, null, null, null, '0', '0', '3101714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101715', null, '0', '0', null, null, null, null, '0', '0', '3101714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101801', null, '0', '0', null, null, null, null, '0', '0', '3101801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101802', null, '0', '0', null, null, null, null, '0', '0', '3101802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101803', null, '0', '0', null, null, null, null, '0', '0', '3101803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101804', null, '0', '0', null, null, null, null, '0', '0', '3101804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101805', null, '0', '0', null, null, null, null, '0', '0', '3101805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101806', null, '0', '0', null, null, null, null, '0', '0', '3101806', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101807', null, '0', '0', null, null, null, null, '0', '0', '3101807', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101808', null, '0', '0', null, null, null, null, '0', '0', '3101808', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101809', null, '0', '0', null, null, null, null, '0', '0', '3101809', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101810', null, '0', '0', null, null, null, null, '0', '0', '3101810', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101811', null, '0', '0', null, null, null, null, '0', '0', '3101811', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101812', null, '0', '0', null, null, null, null, '0', '0', '3101812', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101813', null, '0', '0', null, null, null, null, '0', '0', '3101813', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101814', null, '0', '0', null, null, null, null, '0', '0', '3101814', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101815', null, '0', '0', null, null, null, null, '0', '0', '3101817', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101816', null, '0', '0', null, null, null, null, '0', '0', '3101818', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101817', null, '0', '0', null, null, null, null, '0', '0', '3101815', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101818', null, '0', '0', null, null, null, null, '0', '0', '3101816', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101819', null, '0', '0', null, null, null, null, '0', '0', '3101819', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101820', null, '0', '0', null, null, null, null, '0', '0', '3101820', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101821', null, '0', '0', null, null, null, null, '0', '0', '3101819', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101822', null, '0', '0', null, null, null, null, '0', '0', '3101820', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101901', null, '0', '0', null, null, null, null, '0', '0', '3101901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101902', null, '0', '0', null, null, null, null, '0', '0', '3101902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101903', null, '0', '0', null, null, null, null, '0', '0', '3101903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101904', null, '0', '0', null, null, null, null, '0', '0', '3101904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101905', null, '0', '0', null, null, null, null, '0', '0', '3101905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101906', null, '0', '0', null, null, null, null, '0', '0', '3101906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101907', null, '0', '0', null, null, null, null, '0', '0', '3101907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101908', null, '0', '0', null, null, null, null, '0', '0', '3101909', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101909', null, '0', '0', null, null, null, null, '0', '0', '3101908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101910', null, '0', '0', null, null, null, null, '0', '0', '3101910', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2101911', null, '0', '0', null, null, null, null, '0', '0', '3101910', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102001', null, '0', '0', null, null, null, null, '0', '0', '3102001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102002', null, '0', '0', null, null, null, null, '0', '0', '3102002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102003', null, '0', '0', null, null, null, null, '0', '0', '3102003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102004', null, '0', '0', null, null, null, null, '0', '0', '3102004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102005', null, '0', '0', null, null, null, null, '0', '0', '3102005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102006', null, '0', '0', null, null, null, null, '0', '0', '3102006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102007', null, '0', '0', null, null, null, null, '0', '0', '3102007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102008', null, '0', '0', null, null, null, null, '0', '0', '3102008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102009', null, '0', '0', null, null, null, null, '0', '0', '3102011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102010', null, '0', '0', null, null, null, null, '0', '0', '3102012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102011', null, '0', '0', null, null, null, null, '0', '0', '3102009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102012', null, '0', '0', null, null, null, null, '0', '0', '3102010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102013', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102014', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102015', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102016', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102017', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102018', null, '0', '0', null, null, null, null, '0', '0', '3102013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102101', null, '0', '0', null, null, null, null, '0', '0', '3102101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102102', null, '0', '0', null, null, null, null, '0', '0', '3102102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102103', null, '0', '0', null, null, null, null, '0', '0', '3102103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102104', null, '0', '0', null, null, null, null, '0', '0', '3102104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102105', null, '0', '0', null, null, null, null, '0', '0', '3102105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102106', null, '0', '0', null, null, null, null, '0', '0', '3102106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102107', null, '0', '0', null, null, null, null, '0', '0', '3102107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102108', null, '0', '0', null, null, null, null, '0', '0', '3102108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102109', null, '0', '0', null, null, null, null, '0', '0', '3102109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102110', null, '0', '0', null, null, null, null, '0', '0', '3102110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102111', null, '0', '0', null, null, null, null, '0', '0', '3102111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102112', null, '0', '0', null, null, null, null, '0', '0', '3102112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102113', null, '0', '0', null, null, null, null, '0', '0', '3102113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102114', null, '0', '0', null, null, null, null, '0', '0', '3102114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102115', null, '0', '0', null, null, null, null, '0', '0', '3102115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102116', null, '0', '0', null, null, null, null, '0', '0', '3102116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102117', null, '0', '0', null, null, null, null, '0', '0', '3102117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102118', null, '0', '0', null, null, null, null, '0', '0', '3102118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102119', null, '0', '0', null, null, null, null, '0', '0', '3102119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102120', null, '0', '0', null, null, null, null, '0', '0', '3102120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102121', null, '0', '0', null, null, null, null, '0', '0', '3102121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102122', null, '0', '0', null, null, null, null, '0', '0', '3102122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102123', null, '0', '0', null, null, null, null, '0', '0', '3102123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102124', null, '0', '0', null, null, null, null, '0', '0', '3102124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102125', null, '0', '0', null, null, null, null, '0', '0', '3102125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102126', null, '0', '0', null, null, null, null, '0', '0', '3102126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102127', null, '0', '0', null, null, null, null, '0', '0', '3102128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102128', null, '0', '0', null, null, null, null, '0', '0', '3102128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102129', null, '0', '0', null, null, null, null, '0', '0', '3102127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102201', null, '0', '0', null, null, null, null, '0', '0', '3102201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102202', null, '0', '0', null, null, null, null, '0', '0', '3102202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102203', null, '0', '0', null, null, null, null, '0', '0', '3102203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102204', null, '0', '0', null, null, null, null, '0', '0', '3102204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102205', null, '0', '0', null, null, null, null, '0', '0', '3102205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102206', null, '0', '0', null, null, null, null, '0', '0', '3102206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102207', null, '0', '0', null, null, null, null, '0', '0', '3102207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102208', null, '0', '0', null, null, null, null, '0', '0', '3102208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102209', null, '0', '0', null, null, null, null, '0', '0', '3102209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102210', null, '0', '0', null, null, null, null, '0', '0', '3102210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102211', null, '0', '0', null, null, null, null, '0', '0', '3102211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102212', null, '0', '0', null, null, null, null, '0', '0', '3102212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102213', null, '0', '0', null, null, null, null, '0', '0', '3102213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102214', null, '0', '0', null, null, null, null, '0', '0', '3102214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102215', null, '0', '0', null, null, null, null, '0', '0', '3102215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102216', null, '0', '0', null, null, null, null, '0', '0', '3102216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102217', null, '0', '0', null, null, null, null, '0', '0', '3102217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102218', null, '0', '0', null, null, null, null, '0', '0', '3102218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102219', null, '0', '0', null, null, null, null, '0', '0', '3102224', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102220', null, '0', '0', null, null, null, null, '0', '0', '3102219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102221', null, '0', '0', null, null, null, null, '0', '0', '3102220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102222', null, '0', '0', null, null, null, null, '0', '0', '3102219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102223', null, '0', '0', null, null, null, null, '0', '0', '3102221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102224', null, '0', '0', null, null, null, null, '0', '0', '3102221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102225', null, '0', '0', null, null, null, null, '0', '0', '3102222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102226', null, '0', '0', null, null, null, null, '0', '0', '3102223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102227', null, '0', '0', null, null, null, null, '0', '0', '3102223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102228', null, '0', '0', null, null, null, null, '0', '0', '3102223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102301', null, '0', '0', null, null, null, null, '0', '0', '3102301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102302', null, '0', '0', null, null, null, null, '0', '0', '3102302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102303', null, '0', '0', null, null, null, null, '0', '0', '3102303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102304', null, '0', '0', null, null, null, null, '0', '0', '3102304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102305', null, '0', '0', null, null, null, null, '0', '0', '3102305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102306', null, '0', '0', null, null, null, null, '0', '0', '3102306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102307', null, '0', '0', null, null, null, null, '0', '0', '3102307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102308', null, '0', '0', null, null, null, null, '0', '0', '3102308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102309', null, '0', '0', null, null, null, null, '0', '0', '3102309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102310', null, '0', '0', null, null, null, null, '0', '0', '3102310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102311', null, '0', '0', null, null, null, null, '0', '0', '3102311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102312', null, '0', '0', null, null, null, null, '0', '0', '3102312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102313', null, '0', '0', null, null, null, null, '0', '0', '3102313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102314', null, '0', '0', null, null, null, null, '0', '0', '3102314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102315', null, '0', '0', null, null, null, null, '0', '0', '3102314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102316', null, '0', '0', null, null, null, null, '0', '0', '3102314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102317', null, '0', '0', null, null, null, null, '0', '0', '3102317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102318', null, '0', '0', null, null, null, null, '0', '0', '3102317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102319', null, '0', '0', null, null, null, null, '0', '0', '3102317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102401', null, '0', '0', null, null, null, null, '0', '0', '3102401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102501', null, '0', '0', null, null, null, null, '0', '0', '3102501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102502', null, '0', '0', null, null, null, null, '0', '0', '3102502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102503', null, '0', '0', null, null, null, null, '0', '0', '3102503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102504', null, '0', '0', null, null, null, null, '0', '0', '3102504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102505', null, '0', '0', null, null, null, null, '0', '0', '3102505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102506', null, '0', '0', null, null, null, null, '0', '0', '3102506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102507', null, '0', '0', null, null, null, null, '0', '0', '3102507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102508', null, '0', '0', null, null, null, null, '0', '0', '3102507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102601', null, '0', '0', null, null, null, null, '0', '0', '3102601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102602', null, '0', '0', null, null, null, null, '0', '0', '3102602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102603', null, '0', '0', null, null, null, null, '0', '0', '3102603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102604', null, '0', '0', null, null, null, null, '0', '0', '3102604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102605', null, '0', '0', null, null, null, null, '0', '0', '3102605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102606', null, '0', '0', null, null, null, null, '0', '0', '3102606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102607', null, '0', '0', null, null, null, null, '0', '0', '3102607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102608', null, '0', '0', null, null, null, null, '0', '0', '3102608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102609', null, '0', '0', null, null, null, null, '0', '0', '3102611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102610', null, '0', '0', null, null, null, null, '0', '0', '3102609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102611', null, '0', '0', null, null, null, null, '0', '0', '3102610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102612', null, '0', '0', null, null, null, null, '0', '0', '3102612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102613', null, '0', '0', null, null, null, null, '0', '0', '3102612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102701', null, '0', '0', null, null, null, null, '0', '0', '3102701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102702', null, '0', '0', null, null, null, null, '0', '0', '3102702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102703', null, '0', '0', null, null, null, null, '0', '0', '3102703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102704', null, '0', '0', null, null, null, null, '0', '0', '3102704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102705', null, '0', '0', null, null, null, null, '0', '0', '3102705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102706', null, '0', '0', null, null, null, null, '0', '0', '3102706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102707', null, '0', '0', null, null, null, null, '0', '0', '3102707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102708', null, '0', '0', null, null, null, null, '0', '0', '3102708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102709', null, '0', '0', null, null, null, null, '0', '0', '3102709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102710', null, '0', '0', null, null, null, null, '0', '0', '3102710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102711', null, '0', '0', null, null, null, null, '0', '0', '3102711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102712', null, '0', '0', null, null, null, null, '0', '0', '3102712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102713', null, '0', '0', null, null, null, null, '0', '0', '3102713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102714', null, '0', '0', null, null, null, null, '0', '0', '3102714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102715', null, '0', '0', null, null, null, null, '0', '0', '3102715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102716', null, '0', '0', null, null, null, null, '0', '0', '3102716', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102717', null, '0', '0', null, null, null, null, '0', '0', '3102719', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102718', null, '0', '0', null, null, null, null, '0', '0', '3102720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102719', null, '0', '0', null, null, null, null, '0', '0', '3102717', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102720', null, '0', '0', null, null, null, null, '0', '0', '3102718', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102721', null, '0', '0', null, null, null, null, '0', '0', '3102721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102722', null, '0', '0', null, null, null, null, '0', '0', '3102722', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102723', null, '0', '0', null, null, null, null, '0', '0', '3102722', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102724', null, '0', '0', null, null, null, null, '0', '0', '3102722', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102801', null, '0', '0', null, null, null, null, '0', '0', '3102801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102802', null, '0', '0', null, null, null, null, '0', '0', '3102802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102803', null, '0', '0', null, null, null, null, '0', '0', '3102803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102804', null, '0', '0', null, null, null, null, '0', '0', '3102804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102805', null, '0', '0', null, null, null, null, '0', '0', '3102805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102806', null, '0', '0', null, null, null, null, '0', '0', '3102806', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102807', null, '0', '0', null, null, null, null, '0', '0', '3102805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102808', null, '0', '0', null, null, null, null, '0', '0', '3102805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102809', null, '0', '0', null, null, null, null, '0', '0', '3102805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102901', null, '0', '0', null, null, null, null, '0', '0', '3102901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102902', null, '0', '0', null, null, null, null, '0', '0', '3102902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102903', null, '0', '0', null, null, null, null, '0', '0', '3102903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102904', null, '0', '0', null, null, null, null, '0', '0', '3102904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102905', null, '0', '0', null, null, null, null, '0', '0', '3102905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102906', null, '0', '0', null, null, null, null, '0', '0', '3102906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102907', null, '0', '0', null, null, null, null, '0', '0', '3102906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2102908', null, '0', '0', null, null, null, null, '0', '0', '3102906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103001', null, '0', '0', null, null, null, null, '0', '0', '3103001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103002', null, '0', '0', null, null, null, null, '0', '0', '3103002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103003', null, '0', '0', null, null, null, null, '0', '0', '3103003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103004', null, '0', '0', null, null, null, null, '0', '0', '3103004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103005', null, '0', '0', null, null, null, null, '0', '0', '3103009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103006', null, '0', '0', null, null, null, null, '0', '0', '3103005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103007', null, '0', '0', null, null, null, null, '0', '0', '3103006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103008', null, '0', '0', null, null, null, null, '0', '0', '3103007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103009', null, '0', '0', null, null, null, null, '0', '0', '3103008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103010', null, '0', '0', null, null, null, null, '0', '0', '3103010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103011', null, '0', '0', null, null, null, null, '0', '0', '3103010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103012', null, '0', '0', null, null, null, null, '0', '0', '3103010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103013', null, '0', '0', null, null, null, null, '0', '0', '3103006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103101', null, '0', '0', null, null, null, null, '0', '0', '3103101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103102', null, '0', '0', null, null, null, null, '0', '0', '3103102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103103', null, '0', '0', null, null, null, null, '0', '0', '3103103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103104', null, '0', '0', null, null, null, null, '0', '0', '3103104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103105', null, '0', '0', null, null, null, null, '0', '0', '3103105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103106', null, '0', '0', null, null, null, null, '0', '0', '3103106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103107', null, '0', '0', null, null, null, null, '0', '0', '3103107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103108', null, '0', '0', null, null, null, null, '0', '0', '3103108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103109', null, '0', '0', null, null, null, null, '0', '0', '3103109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103110', null, '0', '0', null, null, null, null, '0', '0', '3103110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103111', null, '0', '0', null, null, null, null, '0', '0', '3103111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103112', null, '0', '0', null, null, null, null, '0', '0', '3103112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103113', null, '0', '0', null, null, null, null, '0', '0', '3103113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103114', null, '0', '0', null, null, null, null, '0', '0', '3103114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103115', null, '0', '0', null, null, null, null, '0', '0', '3103103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103201', null, '0', '0', null, null, null, null, '0', '0', '3103201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103202', null, '0', '0', null, null, null, null, '0', '0', '3103202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103203', null, '0', '0', null, null, null, null, '0', '0', '3103203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103301', null, '0', '0', null, null, null, null, '0', '0', '3103301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103302', null, '0', '0', null, null, null, null, '0', '0', '3103302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103303', null, '0', '0', null, null, null, null, '0', '0', '3103303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103304', null, '0', '0', null, null, null, null, '0', '0', '3103304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103305', null, '0', '0', null, null, null, null, '0', '0', '3103305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103306', null, '0', '0', null, null, null, null, '0', '0', '3103306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103307', null, '0', '0', null, null, null, null, '0', '0', '3103307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103401', null, '0', '0', null, null, null, null, '0', '0', '3103401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103402', null, '0', '0', null, null, null, null, '0', '0', '3103402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103403', null, '0', '0', null, null, null, null, '0', '0', '3103403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103404', null, '0', '0', null, null, null, null, '0', '0', '3103404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103405', null, '0', '0', null, null, null, null, '0', '0', '3103405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103406', null, '0', '0', null, null, null, null, '0', '0', '3103405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103501', null, '0', '0', null, null, null, null, '0', '0', '3103501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103502', null, '0', '0', null, null, null, null, '0', '0', '3103502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103503', null, '0', '0', null, null, null, null, '0', '0', '3103502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103504', null, '0', '0', null, null, null, null, '0', '0', '3103503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103505', null, '0', '0', null, null, null, null, '0', '0', '3103503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103801', null, '0', '0', null, null, null, null, '0', '0', '3103801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103802', null, '0', '0', null, null, null, null, '0', '0', '3103802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103901', null, '0', '0', null, null, null, null, '0', '0', '3103901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103902', null, '0', '0', null, null, null, null, '0', '0', '3103902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103903', null, '0', '0', null, null, null, null, '0', '0', '3103903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103904', null, '0', '0', null, null, null, null, '0', '0', '3103904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103905', null, '0', '0', null, null, null, null, '0', '0', '3103905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103906', null, '0', '0', null, null, null, null, '0', '0', '3103906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103907', null, '0', '0', null, null, null, null, '0', '0', '3103907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103908', null, '0', '0', null, null, null, null, '0', '0', '3103908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103909', null, '0', '0', null, null, null, null, '0', '0', '3103909', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2103910', null, '0', '0', null, null, null, null, '0', '0', '3103910', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104001', null, '0', '0', null, null, null, null, '0', '0', '3104027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104002', null, '0', '0', null, null, null, null, '0', '0', '3104002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104003', null, '0', '0', null, null, null, null, '0', '0', '3104003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104004', null, '0', '0', null, null, null, null, '0', '0', '3104004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104005', null, '0', '0', null, null, null, null, '0', '0', '3104005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104006', null, '0', '0', null, null, null, null, '0', '0', '3104006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104007', 'testNutEater', '128', '0', '-8.48', '45.36', '139.5', '0', '0', '0', '3104007', null, 'NuteaterStandard', '{\r\n  \"talkEventConditions\": [],\r\n  \"noticeEventConditions\": [\r\n    {\r\n      \"unknown1\": 1,\r\n      \"unknown2\": 0,\r\n      \"conditionName\": \"noticeEvent\"\r\n    }\r\n  ],\r\n  \"emoteEventConditions\": [],\r\n  \"pushWithCircleEventConditions\": []\r\n}');
INSERT INTO `gamedata_actor_class` VALUES ('2104008', null, '0', '0', null, null, null, null, '0', '0', '3104008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104009', null, '0', '0', null, null, null, null, '0', '0', '3104009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104010', null, '0', '0', null, null, null, null, '0', '0', '3104010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104011', null, '0', '0', null, null, null, null, '0', '0', '3104011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104012', null, '0', '0', null, null, null, null, '0', '0', '3104012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104013', null, '0', '0', null, null, null, null, '0', '0', '3104013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104014', null, '0', '0', null, null, null, null, '0', '0', '3104014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104015', null, '0', '0', null, null, null, null, '0', '0', '3104015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104016', null, '0', '0', null, null, null, null, '0', '0', '3104016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104017', null, '0', '0', null, null, null, null, '0', '0', '3104017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104018', null, '0', '0', null, null, null, null, '0', '0', '3104018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104019', null, '0', '0', null, null, null, null, '0', '0', '3104019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104020', null, '0', '0', null, null, null, null, '0', '0', '3104020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104021', null, '0', '0', null, null, null, null, '0', '0', '3104025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104022', null, '0', '0', null, null, null, null, '0', '0', '3104026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104023', null, '0', '0', null, null, null, null, '0', '0', '3104021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104024', null, '0', '0', null, null, null, null, '0', '0', '3104022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104025', null, '0', '0', null, null, null, null, '0', '0', '3104023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104026', null, '0', '0', null, null, null, null, '0', '0', '3104024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104027', null, '0', '0', null, null, null, null, '0', '0', '3104028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104028', null, '0', '0', null, null, null, null, '0', '0', '3104028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104101', null, '0', '0', null, null, null, null, '0', '0', '3104101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104102', null, '0', '0', null, null, null, null, '0', '0', '3104102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104103', null, '0', '0', null, null, null, null, '0', '0', '3104103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104104', null, '0', '0', null, null, null, null, '0', '0', '3104104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104105', null, '0', '0', null, null, null, null, '0', '0', '3104105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104106', null, '0', '0', null, null, null, null, '0', '0', '3104106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104107', null, '0', '0', null, null, null, null, '0', '0', '3104107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104108', null, '0', '0', null, null, null, null, '0', '0', '3104108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104109', null, '0', '0', null, null, null, null, '0', '0', '3104109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104110', null, '0', '0', null, null, null, null, '0', '0', '3104110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104111', null, '0', '0', null, null, null, null, '0', '0', '3104111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104112', null, '0', '0', null, null, null, null, '0', '0', '3104112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104113', null, '0', '0', null, null, null, null, '0', '0', '3104113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104201', null, '0', '0', null, null, null, null, '0', '0', '3104201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104202', null, '0', '0', null, null, null, null, '0', '0', '3104202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104203', null, '0', '0', null, null, null, null, '0', '0', '3104203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104204', null, '0', '0', null, null, null, null, '0', '0', '3104204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104205', null, '0', '0', null, null, null, null, '0', '0', '3104205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104206', null, '0', '0', null, null, null, null, '0', '0', '3104206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104207', null, '0', '0', null, null, null, null, '0', '0', '3104207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104208', null, '0', '0', null, null, null, null, '0', '0', '3104208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104209', null, '0', '0', null, null, null, null, '0', '0', '3104209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104210', null, '0', '0', null, null, null, null, '0', '0', '3104210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104211', null, '0', '0', null, null, null, null, '0', '0', '3104211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104212', null, '0', '0', null, null, null, null, '0', '0', '3104214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104213', null, '0', '0', null, null, null, null, '0', '0', '3104212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104214', null, '0', '0', null, null, null, null, '0', '0', '3104213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104215', null, '0', '0', null, null, null, null, '0', '0', '3104215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104216', null, '0', '0', null, null, null, null, '0', '0', '3104216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104217', null, '0', '0', null, null, null, null, '0', '0', '3104216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104218', null, '0', '0', null, null, null, null, '0', '0', '3104216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104301', null, '0', '0', null, null, null, null, '0', '0', '3104301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104302', null, '0', '0', null, null, null, null, '0', '0', '3104302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104303', null, '0', '0', null, null, null, null, '0', '0', '3104303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104304', null, '0', '0', null, null, null, null, '0', '0', '3104304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104305', null, '0', '0', null, null, null, null, '0', '0', '3104305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104306', null, '0', '0', null, null, null, null, '0', '0', '3104306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104307', null, '0', '0', null, null, null, null, '0', '0', '3104307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104308', null, '0', '0', null, null, null, null, '0', '0', '3104308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104309', null, '0', '0', null, null, null, null, '0', '0', '3104309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104310', null, '0', '0', null, null, null, null, '0', '0', '3104310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104311', null, '0', '0', null, null, null, null, '0', '0', '3104311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104312', null, '0', '0', null, null, null, null, '0', '0', '3104312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104313', null, '0', '0', null, null, null, null, '0', '0', '3104313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104314', null, '0', '0', null, null, null, null, '0', '0', '3104314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104315', null, '0', '0', null, null, null, null, '0', '0', '3104315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104316', null, '0', '0', null, null, null, null, '0', '0', '3104316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104317', null, '0', '0', null, null, null, null, '0', '0', '3104317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104318', null, '0', '0', null, null, null, null, '0', '0', '3104318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104319', null, '0', '0', null, null, null, null, '0', '0', '3104319', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104320', null, '0', '0', null, null, null, null, '0', '0', '3104320', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104321', null, '0', '0', null, null, null, null, '0', '0', '3104323', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104322', null, '0', '0', null, null, null, null, '0', '0', '3104321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104323', null, '0', '0', null, null, null, null, '0', '0', '3104322', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104324', null, '0', '0', null, null, null, null, '0', '0', '3104324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104325', null, '0', '0', null, null, null, null, '0', '0', '3104324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104326', null, '0', '0', null, null, null, null, '0', '0', '3104324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104327', null, '0', '0', null, null, null, null, '0', '0', '3104325', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104328', null, '0', '0', null, null, null, null, '0', '0', '3104326', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104329', null, '0', '0', null, null, null, null, '0', '0', '3104326', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104401', null, '0', '0', null, null, null, null, '0', '0', '3104401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104402', null, '0', '0', null, null, null, null, '0', '0', '3104402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104403', null, '0', '0', null, null, null, null, '0', '0', '3104403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104404', null, '0', '0', null, null, null, null, '0', '0', '3104404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104405', null, '0', '0', null, null, null, null, '0', '0', '3104405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104406', null, '0', '0', null, null, null, null, '0', '0', '3104406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104407', null, '0', '0', null, null, null, null, '0', '0', '3104407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104501', null, '0', '0', null, null, null, null, '0', '0', '3104501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104502', null, '0', '0', null, null, null, null, '0', '0', '3104502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104503', null, '0', '0', null, null, null, null, '0', '0', '3104503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104504', null, '0', '0', null, null, null, null, '0', '0', '3104504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104505', null, '0', '0', null, null, null, null, '0', '0', '3104505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104506', null, '0', '0', null, null, null, null, '0', '0', '3104506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104507', null, '0', '0', null, null, null, null, '0', '0', '3104507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104508', null, '0', '0', null, null, null, null, '0', '0', '3104510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104509', null, '0', '0', null, null, null, null, '0', '0', '3104508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104510', null, '0', '0', null, null, null, null, '0', '0', '3104509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104511', null, '0', '0', null, null, null, null, '0', '0', '3104511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104512', null, '0', '0', null, null, null, null, '0', '0', '3104511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104513', null, '0', '0', null, null, null, null, '0', '0', '3104512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104514', null, '0', '0', null, null, null, null, '0', '0', '3104513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104515', null, '0', '0', null, null, null, null, '0', '0', '3104514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104516', null, '0', '0', null, null, null, null, '0', '0', '3104514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104517', null, '0', '0', null, null, null, null, '0', '0', '3104514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104601', null, '0', '0', null, null, null, null, '0', '0', '3104601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104602', null, '0', '0', null, null, null, null, '0', '0', '3104602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104603', null, '0', '0', null, null, null, null, '0', '0', '3104603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104604', null, '0', '0', null, null, null, null, '0', '0', '3104604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104605', null, '0', '0', null, null, null, null, '0', '0', '3104605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104606', null, '0', '0', null, null, null, null, '0', '0', '3104606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104607', null, '0', '0', null, null, null, null, '0', '0', '3104607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104701', null, '0', '0', null, null, null, null, '0', '0', '3104701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104702', null, '0', '0', null, null, null, null, '0', '0', '3104702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104703', null, '0', '0', null, null, null, null, '0', '0', '3104703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104704', null, '0', '0', null, null, null, null, '0', '0', '3104704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104705', null, '0', '0', null, null, null, null, '0', '0', '3104705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104706', null, '0', '0', null, null, null, null, '0', '0', '3104706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104801', null, '0', '0', null, null, null, null, '0', '0', '3104801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104802', null, '0', '0', null, null, null, null, '0', '0', '3104802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104803', null, '0', '0', null, null, null, null, '0', '0', '3104803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104804', null, '0', '0', null, null, null, null, '0', '0', '3104804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104805', null, '0', '0', null, null, null, null, '0', '0', '3104805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104806', null, '0', '0', null, null, null, null, '0', '0', '3104806', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104901', null, '0', '0', null, null, null, null, '0', '0', '3104901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104902', null, '0', '0', null, null, null, null, '0', '0', '3104902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104903', null, '0', '0', null, null, null, null, '0', '0', '3104903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104904', null, '0', '0', null, null, null, null, '0', '0', '3104904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104905', null, '0', '0', null, null, null, null, '0', '0', '3104905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104906', null, '0', '0', null, null, null, null, '0', '0', '3104906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104907', null, '0', '0', null, null, null, null, '0', '0', '3104907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2104908', null, '0', '0', null, null, null, null, '0', '0', '3104907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105001', null, '0', '0', null, null, null, null, '0', '0', '3105001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105002', null, '0', '0', null, null, null, null, '0', '0', '3105002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105003', null, '0', '0', null, null, null, null, '0', '0', '3105003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105004', null, '0', '0', null, null, null, null, '0', '0', '3105004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105005', null, '0', '0', null, null, null, null, '0', '0', '3105005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105006', null, '0', '0', null, null, null, null, '0', '0', '3105006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105101', null, '0', '0', null, null, null, null, '0', '0', '3105101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105102', null, '0', '0', null, null, null, null, '0', '0', '3105102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105103', null, '0', '0', null, null, null, null, '0', '0', '3105103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105104', null, '0', '0', null, null, null, null, '0', '0', '3105104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105105', null, '0', '0', null, null, null, null, '0', '0', '3105105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105106', null, '0', '0', null, null, null, null, '0', '0', '3105106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105201', null, '0', '0', null, null, null, null, '0', '0', '3105201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105301', null, '0', '0', null, null, null, null, '0', '0', '3105301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105302', null, '0', '0', null, null, null, null, '0', '0', '3105302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105303', null, '0', '0', null, null, null, null, '0', '0', '3105303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105304', null, '0', '0', null, null, null, null, '0', '0', '3105304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105305', null, '0', '0', null, null, null, null, '0', '0', '3105305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105306', null, '0', '0', null, null, null, null, '0', '0', '3105306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105307', null, '0', '0', null, null, null, null, '0', '0', '3105307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105308', null, '0', '0', null, null, null, null, '0', '0', '3105308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105309', null, '0', '0', null, null, null, null, '0', '0', '3105309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105310', null, '0', '0', null, null, null, null, '0', '0', '3105310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105311', null, '0', '0', null, null, null, null, '0', '0', '3105311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105312', null, '0', '0', null, null, null, null, '0', '0', '3105312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105313', null, '0', '0', null, null, null, null, '0', '0', '3105313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105314', null, '0', '0', null, null, null, null, '0', '0', '3105314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105315', null, '0', '0', null, null, null, null, '0', '0', '3105315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105401', null, '0', '0', null, null, null, null, '0', '0', '3105412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105402', null, '0', '0', null, null, null, null, '0', '0', '3105402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105403', null, '0', '0', null, null, null, null, '0', '0', '3105403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105404', null, '0', '0', null, null, null, null, '0', '0', '3105404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105405', null, '0', '0', null, null, null, null, '0', '0', '3105405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105406', null, '0', '0', null, null, null, null, '0', '0', '3105406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105407', null, '0', '0', null, null, null, null, '0', '0', '3105407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105408', null, '0', '0', null, null, null, null, '0', '0', '3105408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105409', null, '0', '0', null, null, null, null, '0', '0', '3105411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105410', null, '0', '0', null, null, null, null, '0', '0', '3105409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105411', null, '0', '0', null, null, null, null, '0', '0', '3105410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105412', null, '0', '0', null, null, null, null, '0', '0', '3105413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105413', null, '0', '0', null, null, null, null, '0', '0', '3105414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105414', null, '0', '0', null, null, null, null, '0', '0', '3105414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105415', null, '0', '0', null, null, null, null, '0', '0', '3105414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105416', null, '0', '0', null, null, null, null, '0', '0', '3105415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105501', null, '0', '0', null, null, null, null, '0', '0', '3105501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105502', null, '0', '0', null, null, null, null, '0', '0', '3105502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105503', null, '0', '0', null, null, null, null, '0', '0', '3105503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105504', null, '0', '0', null, null, null, null, '0', '0', '3105504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105505', null, '0', '0', null, null, null, null, '0', '0', '3105505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105506', null, '0', '0', null, null, null, null, '0', '0', '3105506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105507', null, '0', '0', null, null, null, null, '0', '0', '3105507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105508', null, '0', '0', null, null, null, null, '0', '0', '3105508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105509', null, '0', '0', null, null, null, null, '0', '0', '3105509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105510', null, '0', '0', null, null, null, null, '0', '0', '3105510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105511', null, '0', '0', null, null, null, null, '0', '0', '3105511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105512', null, '0', '0', null, null, null, null, '0', '0', '3105512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105513', null, '0', '0', null, null, null, null, '0', '0', '3105515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105514', null, '0', '0', null, null, null, null, '0', '0', '3105513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105515', null, '0', '0', null, null, null, null, '0', '0', '3105514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105516', null, '0', '0', null, null, null, null, '0', '0', '3105516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105517', null, '0', '0', null, null, null, null, '0', '0', '3105516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105518', null, '0', '0', null, null, null, null, '0', '0', '3105516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105519', null, '0', '0', null, null, null, null, '0', '0', '3105517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105520', null, '0', '0', null, null, null, null, '0', '0', '3105517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105521', null, '0', '0', null, null, null, null, '0', '0', '3105517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105601', null, '0', '0', null, null, null, null, '0', '0', '3105601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105602', null, '0', '0', null, null, null, null, '0', '0', '3105602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105603', null, '0', '0', null, null, null, null, '0', '0', '3105603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105604', null, '0', '0', null, null, null, null, '0', '0', '3105604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105605', null, '0', '0', null, null, null, null, '0', '0', '3105605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105606', null, '0', '0', null, null, null, null, '0', '0', '3105606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105607', null, '0', '0', null, null, null, null, '0', '0', '3105607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105608', null, '0', '0', null, null, null, null, '0', '0', '3105608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105609', null, '0', '0', null, null, null, null, '0', '0', '3105609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105610', null, '0', '0', null, null, null, null, '0', '0', '3105610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105611', null, '0', '0', null, null, null, null, '0', '0', '3105610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105612', null, '0', '0', null, null, null, null, '0', '0', '3105611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105613', null, '0', '0', null, null, null, null, '0', '0', '3105611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105614', null, '0', '0', null, null, null, null, '0', '0', '3105611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105701', null, '0', '0', null, null, null, null, '0', '0', '3105701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105702', null, '0', '0', null, null, null, null, '0', '0', '3105702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105703', null, '0', '0', null, null, null, null, '0', '0', '3105703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105704', null, '0', '0', null, null, null, null, '0', '0', '3105704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105705', null, '0', '0', null, null, null, null, '0', '0', '3105705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105706', null, '0', '0', null, null, null, null, '0', '0', '3105706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105707', null, '0', '0', null, null, null, null, '0', '0', '3105707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105708', null, '0', '0', null, null, null, null, '0', '0', '3105708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105709', null, '0', '0', null, null, null, null, '0', '0', '3105709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105710', null, '0', '0', null, null, null, null, '0', '0', '3105710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105711', null, '0', '0', null, null, null, null, '0', '0', '3105711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105712', null, '0', '0', null, null, null, null, '0', '0', '3105712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105713', null, '0', '0', null, null, null, null, '0', '0', '3105713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105714', null, '0', '0', null, null, null, null, '0', '0', '3105714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105715', null, '0', '0', null, null, null, null, '0', '0', '3105715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105716', null, '0', '0', null, null, null, null, '0', '0', '3105716', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105717', null, '0', '0', null, null, null, null, '0', '0', '3105719', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105718', null, '0', '0', null, null, null, null, '0', '0', '3105717', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105719', null, '0', '0', null, null, null, null, '0', '0', '3105718', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105720', null, '0', '0', null, null, null, null, '0', '0', '3105718', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105721', null, '0', '0', null, null, null, null, '0', '0', '3105721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105722', null, '0', '0', null, null, null, null, '0', '0', '3105721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105723', null, '0', '0', null, null, null, null, '0', '0', '3105721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105724', null, '0', '0', null, null, null, null, '0', '0', '3105720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105725', null, '0', '0', null, null, null, null, '0', '0', '3105720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105726', null, '0', '0', null, null, null, null, '0', '0', '3105720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105801', null, '0', '0', null, null, null, null, '0', '0', '3105801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105802', null, '0', '0', null, null, null, null, '0', '0', '3105802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105803', null, '0', '0', null, null, null, null, '0', '0', '3105803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105804', null, '0', '0', null, null, null, null, '0', '0', '3105804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105805', null, '0', '0', null, null, null, null, '0', '0', '3105805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105901', null, '0', '0', null, null, null, null, '0', '0', '3105901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105902', null, '0', '0', null, null, null, null, '0', '0', '3105902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105903', null, '0', '0', null, null, null, null, '0', '0', '3105903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105904', null, '0', '0', null, null, null, null, '0', '0', '3105904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105905', null, '0', '0', null, null, null, null, '0', '0', '3105905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105906', null, '0', '0', null, null, null, null, '0', '0', '3105906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105907', null, '0', '0', null, null, null, null, '0', '0', '3105907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105908', null, '0', '0', null, null, null, null, '0', '0', '3105908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105909', null, '0', '0', null, null, null, null, '0', '0', '3105909', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105910', null, '0', '0', null, null, null, null, '0', '0', '3105910', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105911', null, '0', '0', null, null, null, null, '0', '0', '3105911', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105912', null, '0', '0', null, null, null, null, '0', '0', '3105911', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105913', null, '0', '0', null, null, null, null, '0', '0', '3105913', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105914', null, '0', '0', null, null, null, null, '0', '0', '3105914', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105915', null, '0', '0', null, null, null, null, '0', '0', '3105915', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105916', null, '0', '0', null, null, null, null, '0', '0', '3105916', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105917', null, '0', '0', null, null, null, null, '0', '0', '3105917', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105918', null, '0', '0', null, null, null, null, '0', '0', '3105917', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2105919', null, '0', '0', null, null, null, null, '0', '0', '3105917', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106001', null, '0', '0', null, null, null, null, '0', '0', '3106001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106002', null, '0', '0', null, null, null, null, '0', '0', '3106002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106003', null, '0', '0', null, null, null, null, '0', '0', '3106003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106004', null, '0', '0', null, null, null, null, '0', '0', '3106004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106005', null, '0', '0', null, null, null, null, '0', '0', '3106005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106006', null, '0', '0', null, null, null, null, '0', '0', '3106006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106007', null, '0', '0', null, null, null, null, '0', '0', '3106007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106008', null, '0', '0', null, null, null, null, '0', '0', '3106008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106009', null, '0', '0', null, null, null, null, '0', '0', '3106009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106010', null, '0', '0', null, null, null, null, '0', '0', '3106010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106011', null, '0', '0', null, null, null, null, '0', '0', '3106011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106012', null, '0', '0', null, null, null, null, '0', '0', '3106012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106013', null, '0', '0', null, null, null, null, '0', '0', '3106013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106014', null, '0', '0', null, null, null, null, '0', '0', '3106014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106015', null, '0', '0', null, null, null, null, '0', '0', '3106015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106016', null, '0', '0', null, null, null, null, '0', '0', '3106016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106017', null, '0', '0', null, null, null, null, '0', '0', '3106019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106018', null, '0', '0', null, null, null, null, '0', '0', '3106017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106019', null, '0', '0', null, null, null, null, '0', '0', '3106018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106020', null, '0', '0', null, null, null, null, '0', '0', '3106020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106021', null, '0', '0', null, null, null, null, '0', '0', '3106020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106022', null, '0', '0', null, null, null, null, '0', '0', '3106021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106201', null, '0', '0', null, null, null, null, '0', '0', '3106201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106202', null, '0', '0', null, null, null, null, '0', '0', '3106202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106203', null, '0', '0', null, null, null, null, '0', '0', '3106203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106204', null, '0', '0', null, null, null, null, '0', '0', '3106204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106205', null, '0', '0', null, null, null, null, '0', '0', '3106205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106206', null, '0', '0', null, null, null, null, '0', '0', '3106206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106207', null, '0', '0', null, null, null, null, '0', '0', '3106209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106208', null, '0', '0', null, null, null, null, '0', '0', '3106207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106209', null, '0', '0', null, null, null, null, '0', '0', '3106208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106210', null, '0', '0', null, null, null, null, '0', '0', '3106210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106211', null, '0', '0', null, null, null, null, '0', '0', '3106211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106212', null, '0', '0', null, null, null, null, '0', '0', '3106212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106213', null, '0', '0', null, null, null, null, '0', '0', '3106213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106214', null, '0', '0', null, null, null, null, '0', '0', '3106214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106215', null, '0', '0', null, null, null, null, '0', '0', '3106215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106216', null, '0', '0', null, null, null, null, '0', '0', '3106216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106217', null, '0', '0', null, null, null, null, '0', '0', '3106217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106218', null, '0', '0', null, null, null, null, '0', '0', '3106218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106219', null, '0', '0', null, null, null, null, '0', '0', '3106219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106220', null, '0', '0', null, null, null, null, '0', '0', '3106220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106221', null, '0', '0', null, null, null, null, '0', '0', '3106221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106222', null, '0', '0', null, null, null, null, '0', '0', '3106222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106223', null, '0', '0', null, null, null, null, '0', '0', '3106222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106224', null, '0', '0', null, null, null, null, '0', '0', '3106222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106225', null, '0', '0', null, null, null, null, '0', '0', '3106223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106301', null, '0', '0', null, null, null, null, '0', '0', '3106301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106302', null, '0', '0', null, null, null, null, '0', '0', '3106302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106303', null, '0', '0', null, null, null, null, '0', '0', '3106303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106304', null, '0', '0', null, null, null, null, '0', '0', '3106304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106305', null, '0', '0', null, null, null, null, '0', '0', '3106305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106306', null, '0', '0', null, null, null, null, '0', '0', '3106306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106307', null, '0', '0', null, null, null, null, '0', '0', '3106307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106308', null, '0', '0', null, null, null, null, '0', '0', '3106308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106309', null, '0', '0', null, null, null, null, '0', '0', '3106309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106310', null, '0', '0', null, null, null, null, '0', '0', '3106310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106311', null, '0', '0', null, null, null, null, '0', '0', '3106312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106312', null, '0', '0', null, null, null, null, '0', '0', '3106311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106401', null, '0', '0', null, null, null, null, '0', '0', '3106401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106402', null, '0', '0', null, null, null, null, '0', '0', '3106402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106403', null, '0', '0', null, null, null, null, '0', '0', '3106403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106404', null, '0', '0', null, null, null, null, '0', '0', '3106404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106405', null, '0', '0', null, null, null, null, '0', '0', '3106405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106406', null, '0', '0', null, null, null, null, '0', '0', '3106406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106407', null, '0', '0', null, null, null, null, '0', '0', '3106407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106408', null, '0', '0', null, null, null, null, '0', '0', '3106408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106409', null, '0', '0', null, null, null, null, '0', '0', '3106409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106410', null, '0', '0', null, null, null, null, '0', '0', '3106410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106411', null, '0', '0', null, null, null, null, '0', '0', '3106401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106412', null, '0', '0', null, null, null, null, '0', '0', '3106401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106413', null, '0', '0', null, null, null, null, '0', '0', '3106401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106414', null, '0', '0', null, null, null, null, '0', '0', '3106411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106415', null, '0', '0', null, null, null, null, '0', '0', '3106411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106416', null, '0', '0', null, null, null, null, '0', '0', '3106411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106417', null, '0', '0', null, null, null, null, '0', '0', '3106412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106418', null, '0', '0', null, null, null, null, '0', '0', '3106412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106419', null, '0', '0', null, null, null, null, '0', '0', '3106412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106420', null, '0', '0', null, null, null, null, '0', '0', '3106413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106421', null, '0', '0', null, null, null, null, '0', '0', '3106413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106422', null, '0', '0', null, null, null, null, '0', '0', '3106413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106423', null, '0', '0', null, null, null, null, '0', '0', '3106414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106424', null, '0', '0', null, null, null, null, '0', '0', '3106414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106425', null, '0', '0', null, null, null, null, '0', '0', '3106414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106426', null, '0', '0', null, null, null, null, '0', '0', '3106415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106427', null, '0', '0', null, null, null, null, '0', '0', '3106415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106428', null, '0', '0', null, null, null, null, '0', '0', '3106415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106429', null, '0', '0', null, null, null, null, '0', '0', '3106420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106430', null, '0', '0', null, null, null, null, '0', '0', '3106420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106431', null, '0', '0', null, null, null, null, '0', '0', '3106420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106432', null, '0', '0', null, null, null, null, '0', '0', '3106421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106433', null, '0', '0', null, null, null, null, '0', '0', '3106421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106434', null, '0', '0', null, null, null, null, '0', '0', '3106421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106435', null, '0', '0', null, null, null, null, '0', '0', '3106422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106436', null, '0', '0', null, null, null, null, '0', '0', '3106422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106437', null, '0', '0', null, null, null, null, '0', '0', '3106422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106438', null, '0', '0', null, null, null, null, '0', '0', '3106427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106439', null, '0', '0', null, null, null, null, '0', '0', '3106427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106440', null, '0', '0', null, null, null, null, '0', '0', '3106427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106441', null, '0', '0', null, null, null, null, '0', '0', '3106428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106442', null, '0', '0', null, null, null, null, '0', '0', '3106428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106443', null, '0', '0', null, null, null, null, '0', '0', '3106428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106444', null, '0', '0', null, null, null, null, '0', '0', '3106429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106445', null, '0', '0', null, null, null, null, '0', '0', '3106429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106446', null, '0', '0', null, null, null, null, '0', '0', '3106429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106447', null, '0', '0', null, null, null, null, '0', '0', '3106416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106448', null, '0', '0', null, null, null, null, '0', '0', '3106416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106449', null, '0', '0', null, null, null, null, '0', '0', '3106417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106450', null, '0', '0', null, null, null, null, '0', '0', '3106417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106451', null, '0', '0', null, null, null, null, '0', '0', '3106418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106452', null, '0', '0', null, null, null, null, '0', '0', '3106419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106453', null, '0', '0', null, null, null, null, '0', '0', '3106423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106454', null, '0', '0', null, null, null, null, '0', '0', '3106423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106455', null, '0', '0', null, null, null, null, '0', '0', '3106424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106456', null, '0', '0', null, null, null, null, '0', '0', '3106424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106457', null, '0', '0', null, null, null, null, '0', '0', '3106424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106458', null, '0', '0', null, null, null, null, '0', '0', '3106425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106459', null, '0', '0', null, null, null, null, '0', '0', '3106426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106460', null, '0', '0', null, null, null, null, '0', '0', '3106430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106461', null, '0', '0', null, null, null, null, '0', '0', '3106430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106462', null, '0', '0', null, null, null, null, '0', '0', '3106430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106463', null, '0', '0', null, null, null, null, '0', '0', '3106431', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106464', null, '0', '0', null, null, null, null, '0', '0', '3106431', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106465', null, '0', '0', null, null, null, null, '0', '0', '3106432', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106466', null, '0', '0', null, null, null, null, '0', '0', '3106433', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106467', null, '0', '0', null, null, null, null, '0', '0', '3106434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106468', null, '0', '0', null, null, null, null, '0', '0', '3106434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106469', null, '0', '0', null, null, null, null, '0', '0', '3106434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106470', null, '0', '0', null, null, null, null, '0', '0', '3106435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106471', null, '0', '0', null, null, null, null, '0', '0', '3106435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106472', null, '0', '0', null, null, null, null, '0', '0', '3106436', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106473', null, '0', '0', null, null, null, null, '0', '0', '3106437', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106501', null, '0', '0', null, null, null, null, '0', '0', '3106501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106502', null, '0', '0', null, null, null, null, '0', '0', '3106502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106503', null, '0', '0', null, null, null, null, '0', '0', '3106503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106504', null, '0', '0', null, null, null, null, '0', '0', '3106504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106505', null, '0', '0', null, null, null, null, '0', '0', '3106505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106506', null, '0', '0', null, null, null, null, '0', '0', '3106506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106507', null, '0', '0', null, null, null, null, '0', '0', '3106507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106508', null, '0', '0', null, null, null, null, '0', '0', '3106508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106509', null, '0', '0', null, null, null, null, '0', '0', '3106509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106510', null, '0', '0', null, null, null, null, '0', '0', '3106510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106511', null, '0', '0', null, null, null, null, '0', '0', '3106511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106512', null, '0', '0', null, null, null, null, '0', '0', '3106512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106513', null, '0', '0', null, null, null, null, '0', '0', '3106513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106514', null, '0', '0', null, null, null, null, '0', '0', '3106514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106515', null, '0', '0', null, null, null, null, '0', '0', '3106515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106516', null, '0', '0', null, null, null, null, '0', '0', '3106516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106517', null, '0', '0', null, null, null, null, '0', '0', '3106517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106518', null, '0', '0', null, null, null, null, '0', '0', '3106518', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106519', null, '0', '0', null, null, null, null, '0', '0', '3106519', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106520', null, '0', '0', null, null, null, null, '0', '0', '3106520', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106521', null, '0', '0', null, null, null, null, '0', '0', '3106521', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106522', null, '0', '0', null, null, null, null, '0', '0', '3106522', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106523', null, '0', '0', null, null, null, null, '0', '0', '3106523', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106524', null, '0', '0', null, null, null, null, '0', '0', '3106524', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106525', null, '0', '0', null, null, null, null, '0', '0', '3106525', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106526', null, '0', '0', null, null, null, null, '0', '0', '3106526', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106527', null, '0', '0', null, null, null, null, '0', '0', '3106527', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106528', null, '0', '0', null, null, null, null, '0', '0', '3106528', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106529', null, '0', '0', null, null, null, null, '0', '0', '3106529', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106530', null, '0', '0', null, null, null, null, '0', '0', '3106530', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106531', null, '0', '0', null, null, null, null, '0', '0', '3106531', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106532', null, '0', '0', null, null, null, null, '0', '0', '3106532', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106533', null, '0', '0', null, null, null, null, '0', '0', '3106533', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106534', null, '0', '0', null, null, null, null, '0', '0', '3106534', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106535', null, '0', '0', null, null, null, null, '0', '0', '3106535', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106536', null, '0', '0', null, null, null, null, '0', '0', '3106536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106537', null, '0', '0', null, null, null, null, '0', '0', '3106537', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106538', null, '0', '0', null, null, null, null, '0', '0', '3106540', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106539', null, '0', '0', null, null, null, null, '0', '0', '3106540', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106540', null, '0', '0', null, null, null, null, '0', '0', '3106540', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106541', null, '0', '0', null, null, null, null, '0', '0', '3106538', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106542', null, '0', '0', null, null, null, null, '0', '0', '3106539', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106601', null, '0', '0', null, null, null, null, '0', '0', '3106601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106602', null, '0', '0', null, null, null, null, '0', '0', '3106602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106603', null, '0', '0', null, null, null, null, '0', '0', '3106603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106604', null, '0', '0', null, null, null, null, '0', '0', '3106604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106605', null, '0', '0', null, null, null, null, '0', '0', '3106605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106606', null, '0', '0', null, null, null, null, '0', '0', '3106606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106607', null, '0', '0', null, null, null, null, '0', '0', '3106607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106608', null, '0', '0', null, null, null, null, '0', '0', '3106607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106609', null, '0', '0', null, null, null, null, '0', '0', '3106607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106610', null, '0', '0', null, null, null, null, '0', '0', '3106612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106611', null, '0', '0', null, null, null, null, '0', '0', '3106612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106612', null, '0', '0', null, null, null, null, '0', '0', '3106612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106613', null, '0', '0', null, null, null, null, '0', '0', '3106613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106614', null, '0', '0', null, null, null, null, '0', '0', '3106613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106615', null, '0', '0', null, null, null, null, '0', '0', '3106613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106616', null, '0', '0', null, null, null, null, '0', '0', '3106614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106617', null, '0', '0', null, null, null, null, '0', '0', '3106614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106618', null, '0', '0', null, null, null, null, '0', '0', '3106614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106619', null, '0', '0', null, null, null, null, '0', '0', '3106618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106620', null, '0', '0', null, null, null, null, '0', '0', '3106618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106621', null, '0', '0', null, null, null, null, '0', '0', '3106618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106622', null, '0', '0', null, null, null, null, '0', '0', '3106619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106623', null, '0', '0', null, null, null, null, '0', '0', '3106619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106624', null, '0', '0', null, null, null, null, '0', '0', '3106619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106625', null, '0', '0', null, null, null, null, '0', '0', '3106620', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106626', null, '0', '0', null, null, null, null, '0', '0', '3106620', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106627', null, '0', '0', null, null, null, null, '0', '0', '3106620', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106628', null, '0', '0', null, null, null, null, '0', '0', '3106624', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106629', null, '0', '0', null, null, null, null, '0', '0', '3106624', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106630', null, '0', '0', null, null, null, null, '0', '0', '3106624', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106631', null, '0', '0', null, null, null, null, '0', '0', '3106625', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106632', null, '0', '0', null, null, null, null, '0', '0', '3106625', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106633', null, '0', '0', null, null, null, null, '0', '0', '3106625', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106634', null, '0', '0', null, null, null, null, '0', '0', '3106626', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106635', null, '0', '0', null, null, null, null, '0', '0', '3106626', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106636', null, '0', '0', null, null, null, null, '0', '0', '3106626', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106637', null, '0', '0', null, null, null, null, '0', '0', '3106629', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106638', null, '0', '0', null, null, null, null, '0', '0', '3106629', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106639', null, '0', '0', null, null, null, null, '0', '0', '3106629', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106640', null, '0', '0', null, null, null, null, '0', '0', '3106630', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106641', null, '0', '0', null, null, null, null, '0', '0', '3106630', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106642', null, '0', '0', null, null, null, null, '0', '0', '3106630', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106643', null, '0', '0', null, null, null, null, '0', '0', '3106608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106644', null, '0', '0', null, null, null, null, '0', '0', '3106608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106645', null, '0', '0', null, null, null, null, '0', '0', '3106609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106646', null, '0', '0', null, null, null, null, '0', '0', '3106608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106647', null, '0', '0', null, null, null, null, '0', '0', '3106608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106648', null, '0', '0', null, null, null, null, '0', '0', '3106610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106649', null, '0', '0', null, null, null, null, '0', '0', '3106611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106650', null, '0', '0', null, null, null, null, '0', '0', '3106615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106651', null, '0', '0', null, null, null, null, '0', '0', '3106616', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106652', null, '0', '0', null, null, null, null, '0', '0', '3106615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106653', null, '0', '0', null, null, null, null, '0', '0', '3106615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106654', null, '0', '0', null, null, null, null, '0', '0', '3106617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106655', null, '0', '0', null, null, null, null, '0', '0', '3106621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106656', null, '0', '0', null, null, null, null, '0', '0', '3106622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106657', null, '0', '0', null, null, null, null, '0', '0', '3106622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106658', null, '0', '0', null, null, null, null, '0', '0', '3106622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106659', null, '0', '0', null, null, null, null, '0', '0', '3106621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106660', null, '0', '0', null, null, null, null, '0', '0', '3106623', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106661', null, '0', '0', null, null, null, null, '0', '0', '3106627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106662', null, '0', '0', null, null, null, null, '0', '0', '3106627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106663', null, '0', '0', null, null, null, null, '0', '0', '3106627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106664', null, '0', '0', null, null, null, null, '0', '0', '3106627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106665', null, '0', '0', null, null, null, null, '0', '0', '3106628', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106666', null, '0', '0', null, null, null, null, '0', '0', '3106631', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106701', null, '0', '0', null, null, null, null, '0', '0', '3106701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106702', null, '0', '0', null, null, null, null, '0', '0', '3106702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106703', null, '0', '0', null, null, null, null, '0', '0', '3106703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106704', null, '0', '0', null, null, null, null, '0', '0', '3106704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106705', null, '0', '0', null, null, null, null, '0', '0', '3106705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106706', null, '0', '0', null, null, null, null, '0', '0', '3106706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106707', null, '0', '0', null, null, null, null, '0', '0', '3106707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106708', null, '0', '0', null, null, null, null, '0', '0', '3106708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106709', null, '0', '0', null, null, null, null, '0', '0', '3106709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106710', null, '0', '0', null, null, null, null, '0', '0', '3106710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106711', null, '0', '0', null, null, null, null, '0', '0', '3106711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106712', null, '0', '0', null, null, null, null, '0', '0', '3106712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106713', null, '0', '0', null, null, null, null, '0', '0', '3106713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106714', null, '0', '0', null, null, null, null, '0', '0', '3106714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106715', null, '0', '0', null, null, null, null, '0', '0', '3106715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106716', null, '0', '0', null, null, null, null, '0', '0', '3106716', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106717', null, '0', '0', null, null, null, null, '0', '0', '3106717', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106718', null, '0', '0', null, null, null, null, '0', '0', '3106718', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106719', null, '0', '0', null, null, null, null, '0', '0', '3106719', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106720', null, '0', '0', null, null, null, null, '0', '0', '3106720', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106721', null, '0', '0', null, null, null, null, '0', '0', '3106721', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106722', null, '0', '0', null, null, null, null, '0', '0', '3106722', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106723', null, '0', '0', null, null, null, null, '0', '0', '3106723', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106724', null, '0', '0', null, null, null, null, '0', '0', '3106724', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106725', null, '0', '0', null, null, null, null, '0', '0', '3106725', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106726', null, '0', '0', null, null, null, null, '0', '0', '3106726', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106727', null, '0', '0', null, null, null, null, '0', '0', '3106727', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106728', null, '0', '0', null, null, null, null, '0', '0', '3106728', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106729', null, '0', '0', null, null, null, null, '0', '0', '3106729', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106730', null, '0', '0', null, null, null, null, '0', '0', '3106730', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106731', null, '0', '0', null, null, null, null, '0', '0', '3106731', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106801', null, '0', '0', null, null, null, null, '0', '0', '3106801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106802', null, '0', '0', null, null, null, null, '0', '0', '3106801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106803', null, '0', '0', null, null, null, null, '0', '0', '3106801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106804', null, '0', '0', null, null, null, null, '0', '0', '3106801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2106901', null, '0', '0', null, null, null, null, '0', '0', '3106901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107002', null, '0', '0', null, null, null, null, '0', '0', '3107002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107003', null, '0', '0', null, null, null, null, '0', '0', '3107003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107004', null, '0', '0', null, null, null, null, '0', '0', '3107004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107301', null, '0', '0', null, null, null, null, '0', '0', '3107301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107302', null, '0', '0', null, null, null, null, '0', '0', '3107301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107303', null, '0', '0', null, null, null, null, '0', '0', '3107302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107401', null, '0', '0', null, null, null, null, '0', '0', '3107401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107601', null, '0', '0', null, null, null, null, '0', '0', '3107601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107602', null, '0', '0', null, null, null, null, '0', '0', '3107602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107603', null, '0', '0', null, null, null, null, '0', '0', '3107603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107604', null, '0', '0', null, null, null, null, '0', '0', '3107604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107605', null, '0', '0', null, null, null, null, '0', '0', '3107605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107606', null, '0', '0', null, null, null, null, '0', '0', '3107606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107607', null, '0', '0', null, null, null, null, '0', '0', '3107607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107608', null, '0', '0', null, null, null, null, '0', '0', '3107608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107609', null, '0', '0', null, null, null, null, '0', '0', '3107609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107610', null, '0', '0', null, null, null, null, '0', '0', '3107610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107611', null, '0', '0', null, null, null, null, '0', '0', '3107611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107612', null, '0', '0', null, null, null, null, '0', '0', '3107612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107613', null, '0', '0', null, null, null, null, '0', '0', '3107615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107614', null, '0', '0', null, null, null, null, '0', '0', '3107616', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107615', null, '0', '0', null, null, null, null, '0', '0', '3107613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107616', null, '0', '0', null, null, null, null, '0', '0', '3107614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107617', null, '0', '0', null, null, null, null, '0', '0', '3107617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107618', null, '0', '0', null, null, null, null, '0', '0', '3107617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107619', null, '0', '0', null, null, null, null, '0', '0', '3107618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107620', null, '0', '0', null, null, null, null, '0', '0', '3107619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107621', null, '0', '0', null, null, null, null, '0', '0', '3107619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107622', null, '0', '0', null, null, null, null, '0', '0', '3107619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107623', null, '0', '0', null, null, null, null, '0', '0', '3107612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107624', null, '0', '0', null, null, null, null, '0', '0', '3107612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2107625', null, '0', '0', null, null, null, null, '0', '0', '3107620', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108101', null, '0', '0', null, null, null, null, '0', '0', '3108101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108102', null, '0', '0', null, null, null, null, '0', '0', '3108102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108701', null, '0', '0', null, null, null, null, '0', '0', '3108701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108702', null, '0', '0', null, null, null, null, '0', '0', '3108702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108901', null, '0', '0', null, null, null, null, '0', '0', '3108902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108902', null, '0', '0', null, null, null, null, '0', '0', '3108902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108903', null, '0', '0', null, null, null, null, '0', '0', '3108902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2108904', null, '0', '0', null, null, null, null, '0', '0', '3108903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109001', null, '0', '0', null, null, null, null, '0', '0', '3109001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109002', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109003', null, '0', '0', null, null, null, null, '0', '0', '3109001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109004', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109005', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109006', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109801', null, '0', '0', null, null, null, null, '0', '0', '3109801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109901', null, '0', '0', null, null, null, null, '0', '0', '3109901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109902', null, '0', '0', null, null, null, null, '0', '0', '3109902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109903', null, '0', '0', null, null, null, null, '0', '0', '3109903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109904', null, '0', '0', null, null, null, null, '0', '0', '3109904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109905', null, '0', '0', null, null, null, null, '0', '0', '3109905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109906', null, '0', '0', null, null, null, null, '0', '0', '3110006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109907', null, '0', '0', null, null, null, null, '0', '0', '3110007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109908', null, '0', '0', null, null, null, null, '0', '0', '3109906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109909', null, '0', '0', null, null, null, null, '0', '0', '3109906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109910', null, '0', '0', null, null, null, null, '0', '0', '3109906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109911', null, '0', '0', null, null, null, null, '0', '0', '3109906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109912', null, '0', '0', null, null, null, null, '0', '0', '3110008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109913', null, '0', '0', null, null, null, null, '0', '0', '3110009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109914', null, '0', '0', null, null, null, null, '0', '0', '3110010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2109915', null, '0', '0', null, null, null, null, '0', '0', '3110011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110001', null, '0', '0', null, null, null, null, '0', '0', '3110001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110002', null, '0', '0', null, null, null, null, '0', '0', '3110002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110003', null, '0', '0', null, null, null, null, '0', '0', '3110003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110004', null, '0', '0', null, null, null, null, '0', '0', '3110004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110005', null, '0', '0', null, null, null, null, '0', '0', '3110005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110103', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110104', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110105', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110201', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110301', null, '0', '0', null, null, null, null, '0', '0', '3110301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110302', null, '0', '0', null, null, null, null, '0', '0', '3110302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110303', null, '0', '0', null, null, null, null, '0', '0', '3110303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110304', null, '0', '0', null, null, null, null, '0', '0', '3110304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110305', null, '0', '0', null, null, null, null, '0', '0', '3110305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110306', null, '0', '0', null, null, null, null, '0', '0', '3110306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110307', null, '0', '0', null, null, null, null, '0', '0', '3110307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110308', null, '0', '0', null, null, null, null, '0', '0', '3110308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110309', null, '0', '0', null, null, null, null, '0', '0', '3110309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110310', null, '0', '0', null, null, null, null, '0', '0', '3110310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110311', null, '0', '0', null, null, null, null, '0', '0', '3110311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110312', null, '0', '0', null, null, null, null, '0', '0', '3110312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110313', null, '0', '0', null, null, null, null, '0', '0', '3110313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110314', null, '0', '0', null, null, null, null, '0', '0', '3110314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110601', null, '0', '0', null, null, null, null, '0', '0', '3110601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110701', null, '0', '0', null, null, null, null, '0', '0', '3110701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2110702', null, '0', '0', null, null, null, null, '0', '0', '3110701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111001', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111002', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111003', null, '0', '0', null, null, null, null, '0', '0', '3111003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111004', null, '0', '0', null, null, null, null, '0', '0', '3111004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111005', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111006', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111007', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111008', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111009', null, '0', '0', null, null, null, null, '0', '0', '3111003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111010', null, '0', '0', null, null, null, null, '0', '0', '3111004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111011', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111012', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111013', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111014', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111015', null, '0', '0', null, null, null, null, '0', '0', '3111003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111016', null, '0', '0', null, null, null, null, '0', '0', '3111004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111017', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111018', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111019', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111020', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111021', null, '0', '0', null, null, null, null, '0', '0', '3111003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111022', null, '0', '0', null, null, null, null, '0', '0', '3111004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111023', null, '0', '0', null, null, null, null, '0', '0', '3111001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2111024', null, '0', '0', null, null, null, null, '0', '0', '3111002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162001', null, '0', '0', null, null, null, null, '0', '0', '3106541', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162002', null, '0', '0', null, null, null, null, '0', '0', '3106541', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162003', null, '0', '0', null, null, null, null, '0', '0', '3106541', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162004', null, '0', '0', null, null, null, null, '0', '0', '3106542', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162005', null, '0', '0', null, null, null, null, '0', '0', '3106542', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162006', null, '0', '0', null, null, null, null, '0', '0', '3106542', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162007', null, '0', '0', null, null, null, null, '0', '0', '3106543', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162008', null, '0', '0', null, null, null, null, '0', '0', '3106543', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162009', null, '0', '0', null, null, null, null, '0', '0', '3106543', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162010', null, '0', '0', null, null, null, null, '0', '0', '3106544', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162011', null, '0', '0', null, null, null, null, '0', '0', '3106544', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162012', null, '0', '0', null, null, null, null, '0', '0', '3106544', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162013', null, '0', '0', null, null, null, null, '0', '0', '3106545', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162014', null, '0', '0', null, null, null, null, '0', '0', '3106545', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162015', null, '0', '0', null, null, null, null, '0', '0', '3106545', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162016', null, '0', '0', null, null, null, null, '0', '0', '3106546', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162017', null, '0', '0', null, null, null, null, '0', '0', '3106546', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162018', null, '0', '0', null, null, null, null, '0', '0', '3106546', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162019', null, '0', '0', null, null, null, null, '0', '0', '3106547', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162020', null, '0', '0', null, null, null, null, '0', '0', '3106547', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162021', null, '0', '0', null, null, null, null, '0', '0', '3106547', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162022', null, '0', '0', null, null, null, null, '0', '0', '3106548', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162023', null, '0', '0', null, null, null, null, '0', '0', '3106548', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162024', null, '0', '0', null, null, null, null, '0', '0', '3106548', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162025', null, '0', '0', null, null, null, null, '0', '0', '3106549', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162026', null, '0', '0', null, null, null, null, '0', '0', '3106549', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162027', null, '0', '0', null, null, null, null, '0', '0', '3106549', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162028', null, '0', '0', null, null, null, null, '0', '0', '3106550', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162029', null, '0', '0', null, null, null, null, '0', '0', '3106550', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162030', null, '0', '0', null, null, null, null, '0', '0', '3106550', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162031', null, '0', '0', null, null, null, null, '0', '0', '3106551', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162032', null, '0', '0', null, null, null, null, '0', '0', '3106551', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162033', null, '0', '0', null, null, null, null, '0', '0', '3106551', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162034', null, '0', '0', null, null, null, null, '0', '0', '3106552', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162035', null, '0', '0', null, null, null, null, '0', '0', '3106552', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162036', null, '0', '0', null, null, null, null, '0', '0', '3106552', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162037', null, '0', '0', null, null, null, null, '0', '0', '3106552', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162038', null, '0', '0', null, null, null, null, '0', '0', '3106553', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162039', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162040', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162041', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162042', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162043', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162044', null, '0', '0', null, null, null, null, '0', '0', '3106554', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162045', null, '0', '0', null, null, null, null, '0', '0', '3106555', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162046', null, '0', '0', null, null, null, null, '0', '0', '3106556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162047', null, '0', '0', null, null, null, null, '0', '0', '3106556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162048', null, '0', '0', null, null, null, null, '0', '0', '3106556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162049', null, '0', '0', null, null, null, null, '0', '0', '3106556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162050', null, '0', '0', null, null, null, null, '0', '0', '3106556', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162051', null, '0', '0', null, null, null, null, '0', '0', '3106557', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162052', null, '0', '0', null, null, null, null, '0', '0', '3106558', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162053', null, '0', '0', null, null, null, null, '0', '0', '3106559', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162054', null, '0', '0', null, null, null, null, '0', '0', '3106560', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162055', null, '0', '0', null, null, null, null, '0', '0', '3106559', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162056', null, '0', '0', null, null, null, null, '0', '0', '3106561', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162057', null, '0', '0', null, null, null, null, '0', '0', '3106559', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162058', null, '0', '0', null, null, null, null, '0', '0', '3106562', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162059', null, '0', '0', null, null, null, null, '0', '0', '3106562', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162060', null, '0', '0', null, null, null, null, '0', '0', '3106564', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2162061', null, '0', '0', null, null, null, null, '0', '0', '3106563', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180001', null, '0', '0', null, null, null, null, '0', '0', '3180001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180002', null, '0', '0', null, null, null, null, '0', '0', '3180002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180003', null, '0', '0', null, null, null, null, '0', '0', '3180003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180004', null, '0', '0', null, null, null, null, '0', '0', '3180004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180005', null, '0', '0', null, null, null, null, '0', '0', '3180005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180006', null, '0', '0', null, null, null, null, '0', '0', '3180006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180007', null, '0', '0', null, null, null, null, '0', '0', '3180007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180008', null, '0', '0', null, null, null, null, '0', '0', '3180008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180009', null, '0', '0', null, null, null, null, '0', '0', '3180009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180010', null, '0', '0', null, null, null, null, '0', '0', '3180010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180011', null, '0', '0', null, null, null, null, '0', '0', '3180011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180012', null, '0', '0', null, null, null, null, '0', '0', '3180012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180013', null, '0', '0', null, null, null, null, '0', '0', '3180013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180014', null, '0', '0', null, null, null, null, '0', '0', '3180014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180015', null, '0', '0', null, null, null, null, '0', '0', '3180015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180016', null, '0', '0', null, null, null, null, '0', '0', '3180016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180017', null, '0', '0', null, null, null, null, '0', '0', '3180017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180018', null, '0', '0', null, null, null, null, '0', '0', '3180018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180019', null, '0', '0', null, null, null, null, '0', '0', '3180019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180020', null, '0', '0', null, null, null, null, '0', '0', '3180020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180021', null, '0', '0', null, null, null, null, '0', '0', '3180021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180022', null, '0', '0', null, null, null, null, '0', '0', '3180022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180023', null, '0', '0', null, null, null, null, '0', '0', '3180009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180024', null, '0', '0', null, null, null, null, '0', '0', '3180009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180025', null, '0', '0', null, null, null, null, '0', '0', '3180011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180026', null, '0', '0', null, null, null, null, '0', '0', '3180011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180027', null, '0', '0', null, null, null, null, '0', '0', '3180013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180028', null, '0', '0', null, null, null, null, '0', '0', '3180013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180029', null, '0', '0', null, null, null, null, '0', '0', '3180015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180030', null, '0', '0', null, null, null, null, '0', '0', '3180015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180031', null, '0', '0', null, null, null, null, '0', '0', '3180017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180032', null, '0', '0', null, null, null, null, '0', '0', '3180017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180033', null, '0', '0', null, null, null, null, '0', '0', '3180019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180034', null, '0', '0', null, null, null, null, '0', '0', '3180019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180035', null, '0', '0', null, null, null, null, '0', '0', '3180021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180036', null, '0', '0', null, null, null, null, '0', '0', '3180021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180037', null, '0', '0', null, null, null, null, '0', '0', '3180023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180038', null, '0', '0', null, null, null, null, '0', '0', '3180024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180039', null, '0', '0', null, null, null, null, '0', '0', '3180025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180101', null, '0', '0', null, null, null, null, '0', '0', '3180101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180102', null, '0', '0', null, null, null, null, '0', '0', '3180102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180103', null, '0', '0', null, null, null, null, '0', '0', '3180103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180104', null, '0', '0', null, null, null, null, '0', '0', '3180104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180105', null, '0', '0', null, null, null, null, '0', '0', '3180105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180106', null, '0', '0', null, null, null, null, '0', '0', '3180106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180107', null, '0', '0', null, null, null, null, '0', '0', '3180107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180108', null, '0', '0', null, null, null, null, '0', '0', '3180108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180109', null, '0', '0', null, null, null, null, '0', '0', '3180109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180110', null, '0', '0', null, null, null, null, '0', '0', '3180110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180111', null, '0', '0', null, null, null, null, '0', '0', '3180111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180112', null, '0', '0', null, null, null, null, '0', '0', '3180112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180113', null, '0', '0', null, null, null, null, '0', '0', '3180113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180114', null, '0', '0', null, null, null, null, '0', '0', '3180114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180115', null, '0', '0', null, null, null, null, '0', '0', '3180115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180116', null, '0', '0', null, null, null, null, '0', '0', '3180116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180117', null, '0', '0', null, null, null, null, '0', '0', '3180117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180118', null, '0', '0', null, null, null, null, '0', '0', '3180118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180119', null, '0', '0', null, null, null, null, '0', '0', '3180119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180120', null, '0', '0', null, null, null, null, '0', '0', '3180120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180121', null, '0', '0', null, null, null, null, '0', '0', '3180121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180122', null, '0', '0', null, null, null, null, '0', '0', '3180122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180123', null, '0', '0', null, null, null, null, '0', '0', '3180123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180124', null, '0', '0', null, null, null, null, '0', '0', '3180124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180125', null, '0', '0', null, null, null, null, '0', '0', '3180125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180126', null, '0', '0', null, null, null, null, '0', '0', '3180126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180127', null, '0', '0', null, null, null, null, '0', '0', '3180127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180128', null, '0', '0', null, null, null, null, '0', '0', '3180128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180129', null, '0', '0', null, null, null, null, '0', '0', '3180129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180130', null, '0', '0', null, null, null, null, '0', '0', '3180130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180131', null, '0', '0', null, null, null, null, '0', '0', '3180131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180132', null, '0', '0', null, null, null, null, '0', '0', '3180132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180133', null, '0', '0', null, null, null, null, '0', '0', '3180133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180134', null, '0', '0', null, null, null, null, '0', '0', '3180134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180135', null, '0', '0', null, null, null, null, '0', '0', '3180135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180136', null, '0', '0', null, null, null, null, '0', '0', '3180136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180137', null, '0', '0', null, null, null, null, '0', '0', '3180137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180138', null, '0', '0', null, null, null, null, '0', '0', '3180138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180139', null, '0', '0', null, null, null, null, '0', '0', '3180139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180140', null, '0', '0', null, null, null, null, '0', '0', '3180140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180141', null, '0', '0', null, null, null, null, '0', '0', '3180141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180142', null, '0', '0', null, null, null, null, '0', '0', '3180142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180143', null, '0', '0', null, null, null, null, '0', '0', '3180143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180144', null, '0', '0', null, null, null, null, '0', '0', '3180144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180145', null, '0', '0', null, null, null, null, '0', '0', '3180145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180146', null, '0', '0', null, null, null, null, '0', '0', '3180146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180147', null, '0', '0', null, null, null, null, '0', '0', '3180147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180148', null, '0', '0', null, null, null, null, '0', '0', '3180148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180149', null, '0', '0', null, null, null, null, '0', '0', '3180149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180150', null, '0', '0', null, null, null, null, '0', '0', '3180150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180151', null, '0', '0', null, null, null, null, '0', '0', '3107101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180152', null, '0', '0', null, null, null, null, '0', '0', '3107101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180153', null, '0', '0', null, null, null, null, '0', '0', '3107102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180154', null, '0', '0', null, null, null, null, '0', '0', '3107102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180155', null, '0', '0', null, null, null, null, '0', '0', '3107103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180156', null, '0', '0', null, null, null, null, '0', '0', '3107103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180157', null, '0', '0', null, null, null, null, '0', '0', '3107104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180158', null, '0', '0', null, null, null, null, '0', '0', '3107104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180159', null, '0', '0', null, null, null, null, '0', '0', '3107105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180160', null, '0', '0', null, null, null, null, '0', '0', '3107105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180161', null, '0', '0', null, null, null, null, '0', '0', '3107106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180162', null, '0', '0', null, null, null, null, '0', '0', '3107106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180163', null, '0', '0', null, null, null, null, '0', '0', '3107107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180164', null, '0', '0', null, null, null, null, '0', '0', '3107107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180165', null, '0', '0', null, null, null, null, '0', '0', '3107107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180166', null, '0', '0', null, null, null, null, '0', '0', '3107108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180167', null, '0', '0', null, null, null, null, '0', '0', '3107108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180168', null, '0', '0', null, null, null, null, '0', '0', '3107108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180169', null, '0', '0', null, null, null, null, '0', '0', '3107109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180170', null, '0', '0', null, null, null, null, '0', '0', '3107109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180171', null, '0', '0', null, null, null, null, '0', '0', '3107109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180201', null, '0', '0', null, null, null, null, '0', '0', '3180201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180202', null, '0', '0', null, null, null, null, '0', '0', '3180202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180203', null, '0', '0', null, null, null, null, '0', '0', '3180203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180204', null, '0', '0', null, null, null, null, '0', '0', '3180204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180205', null, '0', '0', null, null, null, null, '0', '0', '3180205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180206', null, '0', '0', null, null, null, null, '0', '0', '3180206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180207', null, '0', '0', null, null, null, null, '0', '0', '3180207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180208', null, '0', '0', null, null, null, null, '0', '0', '3180208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180209', null, '0', '0', null, null, null, null, '0', '0', '3180209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180210', null, '0', '0', null, null, null, null, '0', '0', '3180211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180211', null, '0', '0', null, null, null, null, '0', '0', '3180212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180212', null, '0', '0', null, null, null, null, '0', '0', '3180213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180213', null, '0', '0', null, null, null, null, '0', '0', '3180210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180214', null, '0', '0', null, null, null, null, '0', '0', '3180220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180215', null, '0', '0', null, null, null, null, '0', '0', '3180221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180216', null, '0', '0', null, null, null, null, '0', '0', '3180221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180217', null, '0', '0', null, null, null, null, '0', '0', '3180222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180218', null, '0', '0', null, null, null, null, '0', '0', '3180220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180219', null, '0', '0', null, null, null, null, '0', '0', '3180222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180301', null, '0', '0', null, null, null, null, '0', '0', '3180301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180302', null, '0', '0', null, null, null, null, '0', '0', '3180302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2180303', null, '0', '0', null, null, null, null, '0', '0', '3180303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200101', null, '0', '0', null, null, null, null, '0', '0', '3200101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200102', null, '0', '0', null, null, null, null, '0', '0', '3200102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200103', null, '0', '0', null, null, null, null, '0', '0', '3200103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200104', null, '0', '0', null, null, null, null, '0', '0', '3200104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200105', null, '0', '0', null, null, null, null, '0', '0', '3200105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200106', null, '0', '0', null, null, null, null, '0', '0', '3200106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200107', null, '0', '0', null, null, null, null, '0', '0', '3200107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200108', null, '0', '0', null, null, null, null, '0', '0', '3200108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200109', null, '0', '0', null, null, null, null, '0', '0', '3200109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200110', null, '0', '0', null, null, null, null, '0', '0', '3200110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200111', null, '0', '0', null, null, null, null, '0', '0', '3200111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200112', null, '0', '0', null, null, null, null, '0', '0', '3200112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200113', null, '0', '0', null, null, null, null, '0', '0', '3200113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200114', null, '0', '0', null, null, null, null, '0', '0', '3200115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200201', null, '0', '0', null, null, null, null, '0', '0', '3200201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200202', null, '0', '0', null, null, null, null, '0', '0', '3200202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200203', null, '0', '0', null, null, null, null, '0', '0', '3200204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200204', null, '0', '0', null, null, null, null, '0', '0', '3200203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200205', null, '0', '0', null, null, null, null, '0', '0', '3200205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200206', null, '0', '0', null, null, null, null, '0', '0', '3200206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200207', null, '0', '0', null, null, null, null, '0', '0', '3200207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200208', null, '0', '0', null, null, null, null, '0', '0', '3200208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200301', null, '0', '0', null, null, null, null, '0', '0', '3200301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200302', null, '0', '0', null, null, null, null, '0', '0', '3200302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200303', null, '0', '0', null, null, null, null, '0', '0', '3200303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200304', null, '0', '0', null, null, null, null, '0', '0', '3200304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200305', null, '0', '0', null, null, null, null, '0', '0', '3200305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200306', null, '0', '0', null, null, null, null, '0', '0', '3200306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200307', null, '0', '0', null, null, null, null, '0', '0', '3200309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200308', null, '0', '0', null, null, null, null, '0', '0', '3200308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200309', null, '0', '0', null, null, null, null, '0', '0', '3200309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200313', null, '0', '0', null, null, null, null, '0', '0', '3200310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200314', null, '0', '0', null, null, null, null, '0', '0', '3200311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200401', null, '0', '0', null, null, null, null, '0', '0', '3200401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200402', null, '0', '0', null, null, null, null, '0', '0', '3200402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200403', null, '0', '0', null, null, null, null, '0', '0', '3200403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200404', null, '0', '0', null, null, null, null, '0', '0', '3200404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200405', null, '0', '0', null, null, null, null, '0', '0', '3200405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200406', null, '0', '0', null, null, null, null, '0', '0', '3200407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200407', null, '0', '0', null, null, null, null, '0', '0', '3200408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200501', null, '0', '0', null, null, null, null, '0', '0', '3200501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200502', null, '0', '0', null, null, null, null, '0', '0', '3200502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200503', null, '0', '0', null, null, null, null, '0', '0', '3200503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200504', null, '0', '0', null, null, null, null, '0', '0', '3200504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200505', null, '0', '0', null, null, null, null, '0', '0', '3200505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200506', null, '0', '0', null, null, null, null, '0', '0', '3200506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200507', null, '0', '0', null, null, null, null, '0', '0', '3200507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200508', null, '0', '0', null, null, null, null, '0', '0', '3200508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200509', null, '0', '0', null, null, null, null, '0', '0', '3200509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200510', null, '0', '0', null, null, null, null, '0', '0', '3200510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200511', null, '0', '0', null, null, null, null, '0', '0', '3200511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200601', null, '0', '0', null, null, null, null, '0', '0', '3200601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200602', null, '0', '0', null, null, null, null, '0', '0', '3200602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200603', null, '0', '0', null, null, null, null, '0', '0', '3200603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200604', null, '0', '0', null, null, null, null, '0', '0', '3200604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200605', null, '0', '0', null, null, null, null, '0', '0', '3200605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200606', null, '0', '0', null, null, null, null, '0', '0', '3100601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200607', null, '0', '0', null, null, null, null, '0', '0', '3200606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200608', null, '0', '0', null, null, null, null, '0', '0', '3200607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200609', null, '0', '0', null, null, null, null, '0', '0', '3200608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200610', null, '0', '0', null, null, null, null, '0', '0', '3200609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200611', null, '0', '0', null, null, null, null, '0', '0', '3200610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200701', null, '0', '0', null, null, null, null, '0', '0', '3200701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200702', null, '0', '0', null, null, null, null, '0', '0', '3200702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200703', null, '0', '0', null, null, null, null, '0', '0', '3200703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200704', null, '0', '0', null, null, null, null, '0', '0', '3200704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200705', null, '0', '0', null, null, null, null, '0', '0', '3200707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200706', null, '0', '0', null, null, null, null, '0', '0', '3200705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200707', null, '0', '0', null, null, null, null, '0', '0', '3200706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200708', null, '0', '0', null, null, null, null, '0', '0', '3200708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200709', null, '0', '0', null, null, null, null, '0', '0', '3200709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200710', null, '0', '0', null, null, null, null, '0', '0', '3200702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200711', null, '0', '0', null, null, null, null, '0', '0', '3200710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200801', null, '0', '0', null, null, null, null, '0', '0', '3200801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200802', null, '0', '0', null, null, null, null, '0', '0', '3200802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200803', null, '0', '0', null, null, null, null, '0', '0', '3200803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200804', null, '0', '0', null, null, null, null, '0', '0', '3200804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200901', null, '0', '0', null, null, null, null, '0', '0', '3200901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200902', null, '0', '0', null, null, null, null, '0', '0', '3200902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200903', null, '0', '0', null, null, null, null, '0', '0', '3200903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200904', null, '0', '0', null, null, null, null, '0', '0', '3200904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200905', null, '0', '0', null, null, null, null, '0', '0', '3200905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200906', null, '0', '0', null, null, null, null, '0', '0', '3200907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200907', null, '0', '0', null, null, null, null, '0', '0', '3200908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2200909', null, '0', '0', null, null, null, null, '0', '0', '3200906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201001', null, '0', '0', null, null, null, null, '0', '0', '3201001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201002', null, '0', '0', null, null, null, null, '0', '0', '3201002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201101', null, '0', '0', null, null, null, null, '0', '0', '3201101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201102', null, '0', '0', null, null, null, null, '0', '0', '3201102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201103', null, '0', '0', null, null, null, null, '0', '0', '3201103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201104', null, '0', '0', null, null, null, null, '0', '0', '3201104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201105', null, '0', '0', null, null, null, null, '0', '0', '3201105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201106', null, '0', '0', null, null, null, null, '0', '0', '3201106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201107', null, '0', '0', null, null, null, null, '0', '0', '3201107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201108', null, '0', '0', null, null, null, null, '0', '0', '3201116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201109', null, '0', '0', null, null, null, null, '0', '0', '3101109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201110', null, '0', '0', null, null, null, null, '0', '0', '3201117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201111', null, '0', '0', null, null, null, null, '0', '0', '3201118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201112', null, '0', '0', null, null, null, null, '0', '0', '3201119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201113', null, '0', '0', null, null, null, null, '0', '0', '3201120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201114', null, '0', '0', null, null, null, null, '0', '0', '3201121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201115', null, '0', '0', null, null, null, null, '0', '0', '3201122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201201', null, '0', '0', null, null, null, null, '0', '0', '3201201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201202', null, '0', '0', null, null, null, null, '0', '0', '3201202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201203', null, '0', '0', null, null, null, null, '0', '0', '3201203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201204', null, '0', '0', null, null, null, null, '0', '0', '3201204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201205', null, '0', '0', null, null, null, null, '0', '0', '3201205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201206', null, '0', '0', null, null, null, null, '0', '0', '3201206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201207', null, '0', '0', null, null, null, null, '0', '0', '3201207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201208', null, '0', '0', null, null, null, null, '0', '0', '3201208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201209', null, '0', '0', null, null, null, null, '0', '0', '3201209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201301', null, '0', '0', null, null, null, null, '0', '0', '3201301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201302', null, '0', '0', null, null, null, null, '0', '0', '3201302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201303', null, '0', '0', null, null, null, null, '0', '0', '3201303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201304', null, '0', '0', null, null, null, null, '0', '0', '3201304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201305', null, '0', '0', null, null, null, null, '0', '0', '3201305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201306', null, '0', '0', null, null, null, null, '0', '0', '3201306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201307', null, '0', '0', null, null, null, null, '0', '0', '3201307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201308', null, '0', '0', null, null, null, null, '0', '0', '3201308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201309', null, '0', '0', null, null, null, null, '0', '0', '3201309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201401', null, '0', '0', null, null, null, null, '0', '0', '3201401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201402', null, '0', '0', null, null, null, null, '0', '0', '3201402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201403', null, '0', '0', null, null, null, null, '0', '0', '3201403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201404', null, '0', '0', null, null, null, null, '0', '0', '3201405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201405', null, '0', '0', null, null, null, null, '0', '0', '3201419', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201406', null, '0', '0', null, null, null, null, '0', '0', '3201404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201407', null, '0', '0', null, null, null, null, '0', '0', '3201406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201408', null, '0', '0', null, null, null, null, '0', '0', '3201407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201409', null, '0', '0', null, null, null, null, '0', '0', '3201408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201410', null, '0', '0', null, null, null, null, '0', '0', '3201409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201411', null, '0', '0', null, null, null, null, '0', '0', '3201410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201412', null, '0', '0', null, null, null, null, '0', '0', '3201411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201413', null, '0', '0', null, null, null, null, '0', '0', '3201412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201414', null, '0', '0', null, null, null, null, '0', '0', '3201413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201415', null, '0', '0', null, null, null, null, '0', '0', '3201414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201416', null, '0', '0', null, null, null, null, '0', '0', '3201415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201417', null, '0', '0', null, null, null, null, '0', '0', '3201416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201418', null, '0', '0', null, null, null, null, '0', '0', '3201417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201419', null, '0', '0', null, null, null, null, '0', '0', '3201418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201420', null, '0', '0', null, null, null, null, '0', '0', '3201420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201421', null, '0', '0', null, null, null, null, '0', '0', '3101403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201422', null, '0', '0', null, null, null, null, '0', '0', '3201421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201423', null, '0', '0', null, null, null, null, '0', '0', '3201422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201424', null, '0', '0', null, null, null, null, '0', '0', '3201423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201425', null, '0', '0', null, null, null, null, '0', '0', '3201424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201426', null, '0', '0', null, null, null, null, '0', '0', '3201425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201427', null, '0', '0', null, null, null, null, '0', '0', '3201426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201428', null, '0', '0', null, null, null, null, '0', '0', '3201427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201429', null, '0', '0', null, null, null, null, '0', '0', '3201428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201430', null, '0', '0', null, null, null, null, '0', '0', '3101424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201501', null, '0', '0', null, null, null, null, '0', '0', '3201501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201502', null, '0', '0', null, null, null, null, '0', '0', '3201502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201503', null, '0', '0', null, null, null, null, '0', '0', '3201503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201504', null, '0', '0', null, null, null, null, '0', '0', '3201504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201505', null, '0', '0', null, null, null, null, '0', '0', '3201505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201506', null, '0', '0', null, null, null, null, '0', '0', '3201506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201507', null, '0', '0', null, null, null, null, '0', '0', '3201507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201601', null, '0', '0', null, null, null, null, '0', '0', '3201601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201602', null, '0', '0', null, null, null, null, '0', '0', '3201602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201603', null, '0', '0', null, null, null, null, '0', '0', '3201603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201604', null, '0', '0', null, null, null, null, '0', '0', '3201604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201605', null, '0', '0', null, null, null, null, '0', '0', '3201605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201606', null, '0', '0', null, null, null, null, '0', '0', '3201607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201607', null, '0', '0', null, null, null, null, '0', '0', '3201608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201608', null, '0', '0', null, null, null, null, '0', '0', '3201609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201609', null, '0', '0', null, null, null, null, '0', '0', '3201610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201610', null, '0', '0', null, null, null, null, '0', '0', '3201611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201611', null, '0', '0', null, null, null, null, '0', '0', '3201612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201612', null, '0', '0', null, null, null, null, '0', '0', '3201613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201701', null, '0', '0', null, null, null, null, '0', '0', '3201701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201702', null, '0', '0', null, null, null, null, '0', '0', '3201702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201703', null, '0', '0', null, null, null, null, '0', '0', '3201703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201704', null, '0', '0', null, null, null, null, '0', '0', '3201704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201705', null, '0', '0', null, null, null, null, '0', '0', '3201707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201706', null, '0', '0', null, null, null, null, '0', '0', '3201708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201707', null, '0', '0', null, null, null, null, '0', '0', '3201709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201708', null, '0', '0', null, null, null, null, '0', '0', '3201710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201801', null, '0', '0', null, null, null, null, '0', '0', '3201801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201802', null, '0', '0', null, null, null, null, '0', '0', '3201802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201803', null, '0', '0', null, null, null, null, '0', '0', '3201803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201804', null, '0', '0', null, null, null, null, '0', '0', '3201804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201805', null, '0', '0', null, null, null, null, '0', '0', '3201805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201806', null, '0', '0', null, null, null, null, '0', '0', '3201806', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201807', null, '0', '0', null, null, null, null, '0', '0', '3201807', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201808', null, '0', '0', null, null, null, null, '0', '0', '3201808', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201809', null, '0', '0', null, null, null, null, '0', '0', '3201809', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201810', null, '0', '0', null, null, null, null, '0', '0', '3201810', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201811', null, '0', '0', null, null, null, null, '0', '0', '3201811', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201901', null, '0', '0', null, null, null, null, '0', '0', '3201901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201902', null, '0', '0', null, null, null, null, '0', '0', '3201902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201903', null, '0', '0', null, null, null, null, '0', '0', '3201903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201904', null, '0', '0', null, null, null, null, '0', '0', '3201904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2201905', null, '0', '0', null, null, null, null, '0', '0', '3201905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202001', null, '0', '0', null, null, null, null, '0', '0', '3202001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202002', null, '0', '0', null, null, null, null, '0', '0', '3202002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202003', null, '0', '0', null, null, null, null, '0', '0', '3202003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202004', null, '0', '0', null, null, null, null, '0', '0', '3202004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202005', null, '0', '0', null, null, null, null, '0', '0', '3202005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202006', null, '0', '0', null, null, null, null, '0', '0', '3202006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202007', null, '0', '0', null, null, null, null, '0', '0', '3202007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202008', null, '0', '0', null, null, null, null, '0', '0', '3202008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202009', null, '0', '0', null, null, null, null, '0', '0', '3202009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202010', null, '0', '0', null, null, null, null, '0', '0', '3202010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202011', null, '0', '0', null, null, null, null, '0', '0', '3202011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202012', null, '0', '0', null, null, null, null, '0', '0', '3202012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202013', null, '0', '0', null, null, null, null, '0', '0', '3202004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202101', null, '0', '0', null, null, null, null, '0', '0', '3202101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202102', null, '0', '0', null, null, null, null, '0', '0', '3202102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202103', null, '0', '0', null, null, null, null, '0', '0', '3202103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202104', null, '0', '0', null, null, null, null, '0', '0', '3202104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202105', null, '0', '0', null, null, null, null, '0', '0', '3202105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202106', null, '0', '0', null, null, null, null, '0', '0', '3202106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202107', null, '0', '0', null, null, null, null, '0', '0', '3202107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202108', null, '0', '0', null, null, null, null, '0', '0', '3202108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202109', null, '0', '0', null, null, null, null, '0', '0', '3202109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202110', null, '0', '0', null, null, null, null, '0', '0', '3202110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202111', null, '0', '0', null, null, null, null, '0', '0', '3202111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202112', null, '0', '0', null, null, null, null, '0', '0', '3102104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202113', null, '0', '0', null, null, null, null, '0', '0', '3202112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202114', null, '0', '0', null, null, null, null, '0', '0', '3202113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202115', null, '0', '0', null, null, null, null, '0', '0', '3202114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202201', null, '0', '0', null, null, null, null, '0', '0', '3202201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202202', null, '0', '0', null, null, null, null, '0', '0', '3202205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202203', null, '0', '0', null, null, null, null, '0', '0', '3202202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202204', null, '0', '0', null, null, null, null, '0', '0', '3202203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202205', null, '0', '0', null, null, null, null, '0', '0', '3202204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202206', null, '0', '0', null, null, null, null, '0', '0', '3202206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202207', null, '0', '0', null, null, null, null, '0', '0', '3202208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202208', null, '0', '0', null, null, null, null, '0', '0', '3202209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202209', null, '0', '0', null, null, null, null, '0', '0', '3202210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202301', null, '0', '0', null, null, null, null, '0', '0', '3202301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202302', null, '0', '0', null, null, null, null, '0', '0', '3202302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202303', null, '0', '0', null, null, null, null, '0', '0', '3202303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202304', null, '0', '0', null, null, null, null, '0', '0', '3202304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202305', null, '0', '0', null, null, null, null, '0', '0', '3202305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202306', null, '0', '0', null, null, null, null, '0', '0', '3202306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202307', null, '0', '0', null, null, null, null, '0', '0', '3202307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202308', null, '0', '0', null, null, null, null, '0', '0', '3202308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202309', null, '0', '0', null, null, null, null, '0', '0', '3202309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202310', null, '0', '0', null, null, null, null, '0', '0', '3202310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202311', null, '0', '0', null, null, null, null, '0', '0', '3202311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202312', null, '0', '0', null, null, null, null, '0', '0', '3202312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202401', null, '0', '0', null, null, null, null, '0', '0', '3202401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202402', null, '0', '0', null, null, null, null, '0', '0', '3202402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202501', null, '0', '0', null, null, null, null, '0', '0', '3202501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202502', null, '0', '0', null, null, null, null, '0', '0', '3202502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202503', null, '0', '0', null, null, null, null, '0', '0', '3202504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202504', null, '0', '0', null, null, null, null, '0', '0', '3202505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202505', null, '0', '0', null, null, null, null, '0', '0', '3202506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202601', null, '0', '0', null, null, null, null, '0', '0', '3202601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202602', null, '0', '0', null, null, null, null, '0', '0', '3202602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202603', null, '0', '0', null, null, null, null, '0', '0', '3202603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202604', null, '0', '0', null, null, null, null, '0', '0', '3202604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202605', null, '0', '0', null, null, null, null, '0', '0', '3202605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202606', null, '0', '0', null, null, null, null, '0', '0', '3202606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202607', null, '0', '0', null, null, null, null, '0', '0', '3202607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202608', null, '0', '0', null, null, null, null, '0', '0', '3202608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202609', null, '0', '0', null, null, null, null, '0', '0', '3202609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202610', null, '0', '0', null, null, null, null, '0', '0', '3202610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202611', null, '0', '0', null, null, null, null, '0', '0', '3202612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202701', null, '0', '0', null, null, null, null, '0', '0', '3202701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202702', null, '0', '0', null, null, null, null, '0', '0', '3202702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202703', null, '0', '0', null, null, null, null, '0', '0', '3202703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202704', null, '0', '0', null, null, null, null, '0', '0', '3202704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202705', null, '0', '0', null, null, null, null, '0', '0', '3202705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202706', null, '0', '0', null, null, null, null, '0', '0', '3202706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202707', null, '0', '0', null, null, null, null, '0', '0', '3202707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202708', null, '0', '0', null, null, null, null, '0', '0', '3202708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202709', null, '0', '0', null, null, null, null, '0', '0', '3202709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202710', null, '0', '0', null, null, null, null, '0', '0', '3202710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202711', null, '0', '0', null, null, null, null, '0', '0', '3202711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202712', null, '0', '0', null, null, null, null, '0', '0', '3202714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202713', null, '0', '0', null, null, null, null, '0', '0', '3202715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202714', null, '0', '0', null, null, null, null, '0', '0', '3202716', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202715', null, '0', '0', null, null, null, null, '0', '0', '3202717', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202801', null, '0', '0', null, null, null, null, '0', '0', '3202801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202802', null, '0', '0', null, null, null, null, '0', '0', '3202802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202803', null, '0', '0', null, null, null, null, '0', '0', '3202803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202804', null, '0', '0', null, null, null, null, '0', '0', '3202804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202805', null, '0', '0', null, null, null, null, '0', '0', '3202805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202901', null, '0', '0', null, null, null, null, '0', '0', '3202902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2202902', null, '0', '0', null, null, null, null, '0', '0', '3202902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203001', null, '0', '0', null, null, null, null, '0', '0', '3203001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203002', null, '0', '0', null, null, null, null, '0', '0', '3203002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203003', null, '0', '0', null, null, null, null, '0', '0', '3203003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203004', null, '0', '0', null, null, null, null, '0', '0', '3203004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203005', null, '0', '0', null, null, null, null, '0', '0', '3203005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203006', null, '0', '0', null, null, null, null, '0', '0', '3203006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203007', null, '0', '0', null, null, null, null, '0', '0', '3203007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203008', null, '0', '0', null, null, null, null, '0', '0', '3203008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203009', null, '0', '0', null, null, null, null, '0', '0', '3203009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203010', null, '0', '0', null, null, null, null, '0', '0', '3203010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203011', null, '0', '0', null, null, null, null, '0', '0', '3203011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203101', null, '0', '0', null, null, null, null, '0', '0', '3203101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203102', null, '0', '0', null, null, null, null, '0', '0', '3203102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203103', null, '0', '0', null, null, null, null, '0', '0', '3203103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203104', null, '0', '0', null, null, null, null, '0', '0', '3203104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203105', null, '0', '0', null, null, null, null, '0', '0', '3203106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203106', null, '0', '0', null, null, null, null, '0', '0', '3203107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203107', null, '0', '0', null, null, null, null, '0', '0', '3203101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203201', null, '0', '0', null, null, null, null, '0', '0', '3203201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203202', null, '0', '0', null, null, null, null, '0', '0', '3203202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203203', null, '0', '0', null, null, null, null, '0', '0', '3203203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203204', null, '0', '0', null, null, null, null, '0', '0', '3203204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203301', null, '0', '0', null, null, null, null, '0', '0', '3203301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203302', null, '0', '0', null, null, null, null, '0', '0', '3203302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203303', null, '0', '0', null, null, null, null, '0', '0', '3203303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203401', null, '0', '0', null, null, null, null, '0', '0', '3203401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203402', null, '0', '0', null, null, null, null, '0', '0', '3203402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203403', null, '0', '0', null, null, null, null, '0', '0', '3203403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203404', null, '0', '0', null, null, null, null, '0', '0', '3203404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203405', null, '0', '0', null, null, null, null, '0', '0', '3203406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203406', null, '0', '0', null, null, null, null, '0', '0', '3203407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203407', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203408', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203409', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203410', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203411', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203412', null, '0', '0', null, null, null, null, '0', '0', '3203408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203501', null, '0', '0', null, null, null, null, '0', '0', '3203501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203502', null, '0', '0', null, null, null, null, '0', '0', '3203502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203503', null, '0', '0', null, null, null, null, '0', '0', '3203505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203504', null, '0', '0', null, null, null, null, '0', '0', '3203506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203505', null, '0', '0', null, null, null, null, '0', '0', '3203507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203801', null, '0', '0', null, null, null, null, '0', '0', '3203801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203802', null, '0', '0', null, null, null, null, '0', '0', '3203802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203901', null, '0', '0', null, null, null, null, '0', '0', '3203901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203902', null, '0', '0', null, null, null, null, '0', '0', '3203902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203903', null, '0', '0', null, null, null, null, '0', '0', '3203903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203904', null, '0', '0', null, null, null, null, '0', '0', '3203904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203905', null, '0', '0', null, null, null, null, '0', '0', '3203905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203906', null, '0', '0', null, null, null, null, '0', '0', '3203906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203907', null, '0', '0', null, null, null, null, '0', '0', '3203907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2203908', null, '0', '0', null, null, null, null, '0', '0', '3203908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204001', null, '0', '0', null, null, null, null, '0', '0', '3204001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204002', null, '0', '0', null, null, null, null, '0', '0', '3204002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204003', null, '0', '0', null, null, null, null, '0', '0', '3204003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204004', null, '0', '0', null, null, null, null, '0', '0', '3204004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204005', null, '0', '0', null, null, null, null, '0', '0', '3204005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204006', null, '0', '0', null, null, null, null, '0', '0', '3204006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204007', null, '0', '0', null, null, null, null, '0', '0', '3204007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204008', null, '0', '0', null, null, null, null, '0', '0', '3204008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204009', null, '0', '0', null, null, null, null, '0', '0', '3204009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204010', null, '0', '0', null, null, null, null, '0', '0', '3204010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204011', null, '0', '0', null, null, null, null, '0', '0', '3204011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204012', null, '0', '0', null, null, null, null, '0', '0', '3204012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204013', null, '0', '0', null, null, null, null, '0', '0', '3204013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204014', null, '0', '0', null, null, null, null, '0', '0', '3204014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204015', null, '0', '0', null, null, null, null, '0', '0', '3204015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204016', null, '0', '0', null, null, null, null, '0', '0', '3204016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204017', null, '0', '0', null, null, null, null, '0', '0', '3204017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204018', null, '0', '0', null, null, null, null, '0', '0', '3204018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204019', null, '0', '0', null, null, null, null, '0', '0', '3204019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204020', null, '0', '0', null, null, null, null, '0', '0', '3204020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204021', null, '0', '0', null, null, null, null, '0', '0', '3204021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204022', null, '0', '0', null, null, null, null, '0', '0', '3204022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204023', null, '0', '0', null, null, null, null, '0', '0', '3204023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204024', null, '0', '0', null, null, null, null, '0', '0', '3204024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204025', null, '0', '0', null, null, null, null, '0', '0', '3204025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204026', null, '0', '0', null, null, null, null, '0', '0', '3204026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204027', null, '0', '0', null, null, null, null, '0', '0', '3204027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204101', null, '0', '0', null, null, null, null, '0', '0', '3204101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204102', null, '0', '0', null, null, null, null, '0', '0', '3204102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204103', null, '0', '0', null, null, null, null, '0', '0', '3204103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204104', null, '0', '0', null, null, null, null, '0', '0', '3204104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204105', null, '0', '0', null, null, null, null, '0', '0', '3204105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204106', null, '0', '0', null, null, null, null, '0', '0', '3204106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204107', null, '0', '0', null, null, null, null, '0', '0', '3204107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204108', null, '0', '0', null, null, null, null, '0', '0', '3204108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204109', null, '0', '0', null, null, null, null, '0', '0', '3204109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204201', null, '0', '0', null, null, null, null, '0', '0', '3204201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204202', null, '0', '0', null, null, null, null, '0', '0', '3204202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204203', null, '0', '0', null, null, null, null, '0', '0', '3204203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204204', null, '0', '0', null, null, null, null, '0', '0', '3204204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204205', null, '0', '0', null, null, null, null, '0', '0', '3204205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204206', null, '0', '0', null, null, null, null, '0', '0', '3204206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204207', null, '0', '0', null, null, null, null, '0', '0', '3204207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204208', null, '0', '0', null, null, null, null, '0', '0', '3204208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204209', null, '0', '0', null, null, null, null, '0', '0', '3204209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204210', null, '0', '0', null, null, null, null, '0', '0', '3204210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204211', null, '0', '0', null, null, null, null, '0', '0', '3204211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204212', null, '0', '0', null, null, null, null, '0', '0', '3204212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204213', null, '0', '0', null, null, null, null, '0', '0', '3204213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204301', null, '0', '0', null, null, null, null, '0', '0', '3204301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204302', null, '0', '0', null, null, null, null, '0', '0', '3204302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204303', null, '0', '0', null, null, null, null, '0', '0', '3204303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204304', null, '0', '0', null, null, null, null, '0', '0', '3204304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204305', null, '0', '0', null, null, null, null, '0', '0', '3204305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204306', null, '0', '0', null, null, null, null, '0', '0', '3204306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204307', null, '0', '0', null, null, null, null, '0', '0', '3204307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204308', null, '0', '0', null, null, null, null, '0', '0', '3204308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204309', null, '0', '0', null, null, null, null, '0', '0', '3204309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204310', null, '0', '0', null, null, null, null, '0', '0', '3204310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204311', null, '0', '0', null, null, null, null, '0', '0', '3204311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204312', null, '0', '0', null, null, null, null, '0', '0', '3204312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204313', null, '0', '0', null, null, null, null, '0', '0', '3204313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204314', null, '0', '0', null, null, null, null, '0', '0', '3204314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204315', null, '0', '0', null, null, null, null, '0', '0', '3204315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204316', null, '0', '0', null, null, null, null, '0', '0', '3204319', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204317', null, '0', '0', null, null, null, null, '0', '0', '3204320', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204318', null, '0', '0', null, null, null, null, '0', '0', '3204321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204401', null, '0', '0', null, null, null, null, '0', '0', '3204401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204402', null, '0', '0', null, null, null, null, '0', '0', '3204402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204403', null, '0', '0', null, null, null, null, '0', '0', '3204403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204404', null, '0', '0', null, null, null, null, '0', '0', '3204404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204501', null, '0', '0', null, null, null, null, '0', '0', '3204501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204502', null, '0', '0', null, null, null, null, '0', '0', '3204502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204503', null, '0', '0', null, null, null, null, '0', '0', '3204503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204504', null, '0', '0', null, null, null, null, '0', '0', '3204504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204505', null, '0', '0', null, null, null, null, '0', '0', '3204505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204506', null, '0', '0', null, null, null, null, '0', '0', '3204506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204507', null, '0', '0', null, null, null, null, '0', '0', '3204507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204508', null, '0', '0', null, null, null, null, '0', '0', '3204509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204509', null, '0', '0', null, null, null, null, '0', '0', '3204510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204510', null, '0', '0', null, null, null, null, '0', '0', '3204511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204511', null, '0', '0', null, null, null, null, '0', '0', '3204512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204601', null, '0', '0', null, null, null, null, '0', '0', '3204601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204602', null, '0', '0', null, null, null, null, '0', '0', '3204602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204603', null, '0', '0', null, null, null, null, '0', '0', '3204603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204604', null, '0', '0', null, null, null, null, '0', '0', '3204604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204605', null, '0', '0', null, null, null, null, '0', '0', '3204605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204606', null, '0', '0', null, null, null, null, '0', '0', '3204606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204607', null, '0', '0', null, null, null, null, '0', '0', '3104606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204608', null, '0', '0', null, null, null, null, '0', '0', '3104606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204609', null, '0', '0', null, null, null, null, '0', '0', '3204603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204610', null, '0', '0', null, null, null, null, '0', '0', '3204607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204701', null, '0', '0', null, null, null, null, '0', '0', '3204701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204702', null, '0', '0', null, null, null, null, '0', '0', '3204702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204703', null, '0', '0', null, null, null, null, '0', '0', '3204703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204704', null, '0', '0', null, null, null, null, '0', '0', '3204704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204705', null, '0', '0', null, null, null, null, '0', '0', '3204705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204706', null, '0', '0', null, null, null, null, '0', '0', '3204703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204707', null, '0', '0', null, null, null, null, '0', '0', '3204706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204801', null, '0', '0', null, null, null, null, '0', '0', '3204801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204802', null, '0', '0', null, null, null, null, '0', '0', '3204802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204803', null, '0', '0', null, null, null, null, '0', '0', '3204803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204804', null, '0', '0', null, null, null, null, '0', '0', '3204804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204805', null, '0', '0', null, null, null, null, '0', '0', '3204805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204806', null, '0', '0', null, null, null, null, '0', '0', '3204806', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204807', null, '0', '0', null, null, null, null, '0', '0', '3204801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204901', null, '0', '0', null, null, null, null, '0', '0', '3204901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204902', null, '0', '0', null, null, null, null, '0', '0', '3204902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204903', null, '0', '0', null, null, null, null, '0', '0', '3204903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204904', null, '0', '0', null, null, null, null, '0', '0', '3204904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204905', null, '0', '0', null, null, null, null, '0', '0', '3204905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204906', null, '0', '0', null, null, null, null, '0', '0', '3204903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2204907', null, '0', '0', null, null, null, null, '0', '0', '3204906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205001', null, '0', '0', null, null, null, null, '0', '0', '3205001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205002', null, '0', '0', null, null, null, null, '0', '0', '3205002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205003', null, '0', '0', null, null, null, null, '0', '0', '3205003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205004', null, '0', '0', null, null, null, null, '0', '0', '3205004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205005', null, '0', '0', null, null, null, null, '0', '0', '3205005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205006', null, '0', '0', null, null, null, null, '0', '0', '3205006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205007', null, '0', '0', null, null, null, null, '0', '0', '3205001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205101', null, '0', '0', null, null, null, null, '0', '0', '3205101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205102', null, '0', '0', null, null, null, null, '0', '0', '3205102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205103', null, '0', '0', null, null, null, null, '0', '0', '3205103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205104', null, '0', '0', null, null, null, null, '0', '0', '3205104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205105', null, '0', '0', null, null, null, null, '0', '0', '3205105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205106', null, '0', '0', null, null, null, null, '0', '0', '3205106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205107', null, '0', '0', null, null, null, null, '0', '0', '3205101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205201', null, '0', '0', null, null, null, null, '0', '0', '3205201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205202', null, '0', '0', null, null, null, null, '0', '0', '3205202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205203', null, '0', '0', null, null, null, null, '0', '0', '3205203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205301', null, '0', '0', null, null, null, null, '0', '0', '3205301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205302', null, '0', '0', null, null, null, null, '0', '0', '3205302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205303', null, '0', '0', null, null, null, null, '0', '0', '3205303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205304', null, '0', '0', null, null, null, null, '0', '0', '3205304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205305', null, '0', '0', null, null, null, null, '0', '0', '3205305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205306', null, '0', '0', null, null, null, null, '0', '0', '3205306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205307', null, '0', '0', null, null, null, null, '0', '0', '3205307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205308', null, '0', '0', null, null, null, null, '0', '0', '3205308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205309', null, '0', '0', null, null, null, null, '0', '0', '3205309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205310', null, '0', '0', null, null, null, null, '0', '0', '3205310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205311', null, '0', '0', null, null, null, null, '0', '0', '3205311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205401', null, '0', '0', null, null, null, null, '0', '0', '3205401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205402', null, '0', '0', null, null, null, null, '0', '0', '3205402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205403', null, '0', '0', null, null, null, null, '0', '0', '3205403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205404', null, '0', '0', null, null, null, null, '0', '0', '3205404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205405', null, '0', '0', null, null, null, null, '0', '0', '3205405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205406', null, '0', '0', null, null, null, null, '0', '0', '3205406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205407', null, '0', '0', null, null, null, null, '0', '0', '3205407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205408', null, '0', '0', null, null, null, null, '0', '0', '3205408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205409', null, '0', '0', null, null, null, null, '0', '0', '3205409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205410', null, '0', '0', null, null, null, null, '0', '0', '3205410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205411', null, '0', '0', null, null, null, null, '0', '0', '3205411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205501', null, '0', '0', null, null, null, null, '0', '0', '3205501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205502', null, '0', '0', null, null, null, null, '0', '0', '3205502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205503', null, '0', '0', null, null, null, null, '0', '0', '3205503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205504', null, '0', '0', null, null, null, null, '0', '0', '3205504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205505', null, '0', '0', null, null, null, null, '0', '0', '3205505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205506', null, '0', '0', null, null, null, null, '0', '0', '3205506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205507', null, '0', '0', null, null, null, null, '0', '0', '3205507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205508', null, '0', '0', null, null, null, null, '0', '0', '3205508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205509', null, '0', '0', null, null, null, null, '0', '0', '3205509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205510', null, '0', '0', null, null, null, null, '0', '0', '3205510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205511', null, '0', '0', null, null, null, null, '0', '0', '3205511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205512', null, '0', '0', null, null, null, null, '0', '0', '3205512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205513', null, '0', '0', null, null, null, null, '0', '0', '3205513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205514', null, '0', '0', null, null, null, null, '0', '0', '3205514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205515', null, '0', '0', null, null, null, null, '0', '0', '3205515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205516', null, '0', '0', null, null, null, null, '0', '0', '3205516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205517', null, '0', '0', null, null, null, null, '0', '0', '3205517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205518', null, '0', '0', null, null, null, null, '0', '0', '3205518', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205519', null, '0', '0', null, null, null, null, '0', '0', '3205519', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205520', null, '0', '0', null, null, null, null, '0', '0', '3205520', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205521', null, '0', '0', null, null, null, null, '0', '0', '3205521', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205601', null, '0', '0', null, null, null, null, '0', '0', '3205601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205602', null, '0', '0', null, null, null, null, '0', '0', '3205602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205603', null, '0', '0', null, null, null, null, '0', '0', '3205603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205604', null, '0', '0', null, null, null, null, '0', '0', '3205604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205605', null, '0', '0', null, null, null, null, '0', '0', '3205605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205606', null, '0', '0', null, null, null, null, '0', '0', '3205606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205607', null, '0', '0', null, null, null, null, '0', '0', '3205607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205608', null, '0', '0', null, null, null, null, '0', '0', '3205608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205609', null, '0', '0', null, null, null, null, '0', '0', '3205609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205610', null, '0', '0', null, null, null, null, '0', '0', '3105609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205611', null, '0', '0', null, null, null, null, '0', '0', '3105609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205612', null, '0', '0', null, null, null, null, '0', '0', '3205611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205613', null, '0', '0', null, null, null, null, '0', '0', '3205612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205614', null, '0', '0', null, null, null, null, '0', '0', '3205613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205701', null, '0', '0', null, null, null, null, '0', '0', '3205701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205702', null, '0', '0', null, null, null, null, '0', '0', '3205702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205703', null, '0', '0', null, null, null, null, '0', '0', '3205703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205704', null, '0', '0', null, null, null, null, '0', '0', '3205704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205705', null, '0', '0', null, null, null, null, '0', '0', '3205705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205706', null, '0', '0', null, null, null, null, '0', '0', '3205706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205707', null, '0', '0', null, null, null, null, '0', '0', '3205707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205708', null, '0', '0', null, null, null, null, '0', '0', '3205708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205709', null, '0', '0', null, null, null, null, '0', '0', '3205709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205710', null, '0', '0', null, null, null, null, '0', '0', '3205710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205711', null, '0', '0', null, null, null, null, '0', '0', '3205712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205712', null, '0', '0', null, null, null, null, '0', '0', '3205713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205801', null, '0', '0', null, null, null, null, '0', '0', '3205801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205802', null, '0', '0', null, null, null, null, '0', '0', '3205802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205803', null, '0', '0', null, null, null, null, '0', '0', '3205803', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205804', null, '0', '0', null, null, null, null, '0', '0', '3205804', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205805', null, '0', '0', null, null, null, null, '0', '0', '3205805', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205901', null, '0', '0', null, null, null, null, '0', '0', '3205901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205902', null, '0', '0', null, null, null, null, '0', '0', '3205902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205903', null, '0', '0', null, null, null, null, '0', '0', '3205903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205904', null, '0', '0', null, null, null, null, '0', '0', '3205904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205905', null, '0', '0', null, null, null, null, '0', '0', '3205905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205906', null, '0', '0', null, null, null, null, '0', '0', '3205906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205907', null, '0', '0', null, null, null, null, '0', '0', '3205907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205908', null, '0', '0', null, null, null, null, '0', '0', '3205908', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2205909', null, '0', '0', null, null, null, null, '0', '0', '3205909', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206001', null, '0', '0', null, null, null, null, '0', '0', '3206001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206002', null, '0', '0', null, null, null, null, '0', '0', '3206002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206003', null, '0', '0', null, null, null, null, '0', '0', '3206003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206004', null, '0', '0', null, null, null, null, '0', '0', '3206004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206005', null, '0', '0', null, null, null, null, '0', '0', '3206005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206006', null, '0', '0', null, null, null, null, '0', '0', '3206006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206007', null, '0', '0', null, null, null, null, '0', '0', '3206007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206008', null, '0', '0', null, null, null, null, '0', '0', '3206008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206009', null, '0', '0', null, null, null, null, '0', '0', '3206009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206010', null, '0', '0', null, null, null, null, '0', '0', '3206010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206011', null, '0', '0', null, null, null, null, '0', '0', '3206011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206012', null, '0', '0', null, null, null, null, '0', '0', '3206012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206013', null, '0', '0', null, null, null, null, '0', '0', '3206013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206014', null, '0', '0', null, null, null, null, '0', '0', '3206014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206015', null, '0', '0', null, null, null, null, '0', '0', '3206015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206016', null, '0', '0', null, null, null, null, '0', '0', '3206016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206201', null, '0', '0', null, null, null, null, '0', '0', '3206201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206202', null, '0', '0', null, null, null, null, '0', '0', '3206202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206203', null, '0', '0', null, null, null, null, '0', '0', '3206203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206204', null, '0', '0', null, null, null, null, '0', '0', '3206204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206205', null, '0', '0', null, null, null, null, '0', '0', '3206205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206206', null, '0', '0', null, null, null, null, '0', '0', '3206206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206207', null, '0', '0', null, null, null, null, '0', '0', '3206207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206208', null, '0', '0', null, null, null, null, '0', '0', '3206208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206209', null, '0', '0', null, null, null, null, '0', '0', '3206209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206210', null, '0', '0', null, null, null, null, '0', '0', '3206210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206211', null, '0', '0', null, null, null, null, '0', '0', '3206211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206212', null, '0', '0', null, null, null, null, '0', '0', '3206211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206213', null, '0', '0', null, null, null, null, '0', '0', '3206211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206214', null, '0', '0', null, null, null, null, '0', '0', '3206212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206215', null, '0', '0', null, null, null, null, '0', '0', '3206213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206216', null, '0', '0', null, null, null, null, '0', '0', '3206214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206301', null, '0', '0', null, null, null, null, '0', '0', '3206301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206302', null, '0', '0', null, null, null, null, '0', '0', '3206303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206303', null, '0', '0', null, null, null, null, '0', '0', '3206302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206304', null, '0', '0', null, null, null, null, '0', '0', '3206304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206305', null, '0', '0', null, null, null, null, '0', '0', '3206305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206306', null, '0', '0', null, null, null, null, '0', '0', '3206306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206401', null, '0', '0', null, null, null, null, '0', '0', '3206401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206402', null, '0', '0', null, null, null, null, '0', '0', '3206403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206403', null, '0', '0', null, null, null, null, '0', '0', '3206402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206404', null, '0', '0', null, null, null, null, '0', '0', '3206404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206405', null, '0', '0', null, null, null, null, '0', '0', '3206405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206406', null, '0', '0', null, null, null, null, '0', '0', '3206406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206407', null, '0', '0', null, null, null, null, '0', '0', '3206407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206408', null, '0', '0', null, null, null, null, '0', '0', '3206408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206409', null, '0', '0', null, null, null, null, '0', '0', '3206409', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206410', null, '0', '0', null, null, null, null, '0', '0', '3206410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206411', null, '0', '0', null, null, null, null, '0', '0', '3206411', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206412', null, '0', '0', null, null, null, null, '0', '0', '3206412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206413', null, '0', '0', null, null, null, null, '0', '0', '3206413', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206414', null, '0', '0', null, null, null, null, '0', '0', '3206414', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206415', null, '0', '0', null, null, null, null, '0', '0', '3206415', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206416', null, '0', '0', null, null, null, null, '0', '0', '3206416', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206417', null, '0', '0', null, null, null, null, '0', '0', '3206417', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206418', null, '0', '0', null, null, null, null, '0', '0', '3206418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206419', null, '0', '0', null, null, null, null, '0', '0', '3206422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206420', null, '0', '0', null, null, null, null, '0', '0', '3206420', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206421', null, '0', '0', null, null, null, null, '0', '0', '3206421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206422', null, '0', '0', null, null, null, null, '0', '0', '3206422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206423', null, '0', '0', null, null, null, null, '0', '0', '3206423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206424', null, '0', '0', null, null, null, null, '0', '0', '3206424', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206425', null, '0', '0', null, null, null, null, '0', '0', '3206425', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206426', null, '0', '0', null, null, null, null, '0', '0', '3206426', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206427', null, '0', '0', null, null, null, null, '0', '0', '3206427', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206428', null, '0', '0', null, null, null, null, '0', '0', '3206428', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206429', null, '0', '0', null, null, null, null, '0', '0', '3206429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206430', null, '0', '0', null, null, null, null, '0', '0', '3206430', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206431', null, '0', '0', null, null, null, null, '0', '0', '3206431', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206432', null, '0', '0', null, null, null, null, '0', '0', '3206432', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206433', null, '0', '0', null, null, null, null, '0', '0', '3206433', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206434', null, '0', '0', null, null, null, null, '0', '0', '3206434', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206435', null, '0', '0', null, null, null, null, '0', '0', '3206435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206436', null, '0', '0', null, null, null, null, '0', '0', '3106422', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206437', null, '0', '0', null, null, null, null, '0', '0', '3106429', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206438', null, '0', '0', null, null, null, null, '0', '0', '3206423', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206439', null, '0', '0', null, null, null, null, '0', '0', '3106412', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206501', null, '0', '0', null, null, null, null, '0', '0', '3206501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206502', null, '0', '0', null, null, null, null, '0', '0', '3206502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206503', null, '0', '0', null, null, null, null, '0', '0', '3206503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206504', null, '0', '0', null, null, null, null, '0', '0', '3206504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206505', null, '0', '0', null, null, null, null, '0', '0', '3206505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206506', null, '0', '0', null, null, null, null, '0', '0', '3206508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206507', null, '0', '0', null, null, null, null, '0', '0', '3206506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206508', null, '0', '0', null, null, null, null, '0', '0', '3206507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206509', null, '0', '0', null, null, null, null, '0', '0', '3206509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206510', null, '0', '0', null, null, null, null, '0', '0', '3206510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206511', null, '0', '0', null, null, null, null, '0', '0', '3206511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206512', null, '0', '0', null, null, null, null, '0', '0', '3206512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206513', null, '0', '0', null, null, null, null, '0', '0', '3206518', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206514', null, '0', '0', null, null, null, null, '0', '0', '3206513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206515', null, '0', '0', null, null, null, null, '0', '0', '3206515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206516', null, '0', '0', null, null, null, null, '0', '0', '3206514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206517', null, '0', '0', null, null, null, null, '0', '0', '3206516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206518', null, '0', '0', null, null, null, null, '0', '0', '3206517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206519', null, '0', '0', null, null, null, null, '0', '0', '3206519', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206520', null, '0', '0', null, null, null, null, '0', '0', '3206520', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206521', null, '0', '0', null, null, null, null, '0', '0', '3206521', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206522', null, '0', '0', null, null, null, null, '0', '0', '3206522', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206523', null, '0', '0', null, null, null, null, '0', '0', '3206523', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206524', null, '0', '0', null, null, null, null, '0', '0', '3206524', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206525', null, '0', '0', null, null, null, null, '0', '0', '3206525', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206526', null, '0', '0', null, null, null, null, '0', '0', '3206526', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206527', null, '0', '0', null, null, null, null, '0', '0', '3206527', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206528', null, '0', '0', null, null, null, null, '0', '0', '3206528', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206529', null, '0', '0', null, null, null, null, '0', '0', '3206532', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206530', null, '0', '0', null, null, null, null, '0', '0', '3206530', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206531', null, '0', '0', null, null, null, null, '0', '0', '3206531', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206532', null, '0', '0', null, null, null, null, '0', '0', '3206532', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206533', null, '0', '0', null, null, null, null, '0', '0', '3206533', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206534', null, '0', '0', null, null, null, null, '0', '0', '3206534', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206535', null, '0', '0', null, null, null, null, '0', '0', '3206535', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206536', null, '0', '0', null, null, null, null, '0', '0', '3206536', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206537', null, '0', '0', null, null, null, null, '0', '0', '3206537', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206538', null, '0', '0', null, null, null, null, '0', '0', '3206538', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206539', null, '0', '0', null, null, null, null, '0', '0', '3206539', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206540', null, '0', '0', null, null, null, null, '0', '0', '3206540', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206541', null, '0', '0', null, null, null, null, '0', '0', '3206541', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206542', null, '0', '0', null, null, null, null, '0', '0', '3206542', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206543', null, '0', '0', null, null, null, null, '0', '0', '3206543', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206544', null, '0', '0', null, null, null, null, '0', '0', '3106515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206545', null, '0', '0', null, null, null, null, '0', '0', '3106508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206546', null, '0', '0', null, null, null, null, '0', '0', '3106502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206547', null, '0', '0', null, null, null, null, '0', '0', '3106522', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206601', null, '0', '0', null, null, null, null, '0', '0', '3206601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206602', null, '0', '0', null, null, null, null, '0', '0', '3206602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206603', null, '0', '0', null, null, null, null, '0', '0', '3206604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206604', null, '0', '0', null, null, null, null, '0', '0', '3206603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206605', null, '0', '0', null, null, null, null, '0', '0', '3106629', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206606', null, '0', '0', null, null, null, null, '0', '0', '3206605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206607', null, '0', '0', null, null, null, null, '0', '0', '3206606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206608', null, '0', '0', null, null, null, null, '0', '0', '3206607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206609', null, '0', '0', null, null, null, null, '0', '0', '3206608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206610', null, '0', '0', null, null, null, null, '0', '0', '3206612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206611', null, '0', '0', null, null, null, null, '0', '0', '3206610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206612', null, '0', '0', null, null, null, null, '0', '0', '3206611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206613', null, '0', '0', null, null, null, null, '0', '0', '3206612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206614', null, '0', '0', null, null, null, null, '0', '0', '3206613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206615', null, '0', '0', null, null, null, null, '0', '0', '3206614', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206616', null, '0', '0', null, null, null, null, '0', '0', '3206615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206617', null, '0', '0', null, null, null, null, '0', '0', '3206616', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206618', null, '0', '0', null, null, null, null, '0', '0', '3206617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206619', null, '0', '0', null, null, null, null, '0', '0', '3206618', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206620', null, '0', '0', null, null, null, null, '0', '0', '3206619', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206621', null, '0', '0', null, null, null, null, '0', '0', '3206620', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206622', null, '0', '0', null, null, null, null, '0', '0', '3206621', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206623', null, '0', '0', null, null, null, null, '0', '0', '3206622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206624', null, '0', '0', null, null, null, null, '0', '0', '3206623', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206625', null, '0', '0', null, null, null, null, '0', '0', '3206624', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206626', null, '0', '0', null, null, null, null, '0', '0', '3206607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206627', null, '0', '0', null, null, null, null, '0', '0', '3206613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206628', null, '0', '0', null, null, null, null, '0', '0', '3206615', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206629', null, '0', '0', null, null, null, null, '0', '0', '3206617', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206701', null, '0', '0', null, null, null, null, '0', '0', '3206701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206702', null, '0', '0', null, null, null, null, '0', '0', '3206702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206703', null, '0', '0', null, null, null, null, '0', '0', '3206703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206704', null, '0', '0', null, null, null, null, '0', '0', '3206704', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206705', null, '0', '0', null, null, null, null, '0', '0', '3206705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206706', null, '0', '0', null, null, null, null, '0', '0', '3206706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206707', null, '0', '0', null, null, null, null, '0', '0', '3206707', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206708', null, '0', '0', null, null, null, null, '0', '0', '3206708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206709', null, '0', '0', null, null, null, null, '0', '0', '3206709', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206710', null, '0', '0', null, null, null, null, '0', '0', '3206710', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206711', null, '0', '0', null, null, null, null, '0', '0', '3206711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206712', null, '0', '0', null, null, null, null, '0', '0', '3206712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206713', null, '0', '0', null, null, null, null, '0', '0', '3206713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206714', null, '0', '0', null, null, null, null, '0', '0', '3206714', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206715', null, '0', '0', null, null, null, null, '0', '0', '3206715', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2206901', null, '0', '0', null, null, null, null, '0', '0', '3206901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207001', null, '0', '0', null, null, null, null, '0', '0', '3207001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207003', null, '0', '0', null, null, null, null, '0', '0', '3207003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207004', null, '0', '0', null, null, null, null, '0', '0', '3207006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207005', null, '0', '0', null, null, null, null, '0', '0', '3207021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207006', null, '0', '0', null, null, null, null, '0', '0', '3207022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207007', null, '0', '0', null, null, null, null, '0', '0', '3207023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207008', null, '0', '0', null, null, null, null, '0', '0', '3207028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207009', null, '0', '0', null, null, null, null, '0', '0', '3207001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207301', null, '0', '0', null, null, null, null, '0', '0', '3207301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207302', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207303', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207304', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207305', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207306', null, '0', '0', null, null, null, null, '0', '0', '3207303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207307', null, '0', '0', null, null, null, null, '0', '0', '3207303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207308', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207309', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207310', null, '0', '0', null, null, null, null, '0', '0', '3207302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207311', null, '0', '0', null, null, null, null, '0', '0', '3207304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207312', null, '0', '0', null, null, null, null, '0', '0', '3207304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207313', null, '0', '0', null, null, null, null, '0', '0', '3207303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207314', null, '0', '0', null, null, null, null, '0', '0', '3207304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207315', null, '0', '0', null, null, null, null, '0', '0', '3207303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207401', null, '0', '0', null, null, null, null, '0', '0', '3207401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207601', null, '0', '0', null, null, null, null, '0', '0', '3207601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207602', null, '0', '0', null, null, null, null, '0', '0', '3207602', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207603', null, '0', '0', null, null, null, null, '0', '0', '3207603', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207604', null, '0', '0', null, null, null, null, '0', '0', '3207604', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207605', null, '0', '0', null, null, null, null, '0', '0', '3207605', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207606', null, '0', '0', null, null, null, null, '0', '0', '3207606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207607', null, '0', '0', null, null, null, null, '0', '0', '3207607', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207608', null, '0', '0', null, null, null, null, '0', '0', '3207608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207609', null, '0', '0', null, null, null, null, '0', '0', '3207609', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207610', null, '0', '0', null, null, null, null, '0', '0', '3207610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207611', null, '0', '0', null, null, null, null, '0', '0', '3207611', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207612', null, '0', '0', null, null, null, null, '0', '0', '3207612', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2207613', null, '0', '0', null, null, null, null, '0', '0', '3207613', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208101', null, '0', '0', null, null, null, null, '0', '0', '3208101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208102', null, '0', '0', null, null, null, null, '0', '0', '3208102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208701', null, '0', '0', null, null, null, null, '0', '0', '3208701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208901', null, '0', '0', null, null, null, null, '0', '0', '3208901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208902', null, '0', '0', null, null, null, null, '0', '0', '3208902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208903', null, '0', '0', null, null, null, null, '0', '0', '3208903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208904', null, '0', '0', null, null, null, null, '0', '0', '3208905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208905', null, '0', '0', null, null, null, null, '0', '0', '3208904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208906', null, '0', '0', null, null, null, null, '0', '0', '3208905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208907', null, '0', '0', null, null, null, null, '0', '0', '3208905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2208908', null, '0', '0', null, null, null, null, '0', '0', '3208905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209001', null, '0', '0', null, null, null, null, '0', '0', '3209001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209002', null, '0', '0', null, null, null, null, '0', '0', '3209002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209003', null, '0', '0', null, null, null, null, '0', '0', '3109003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209004', null, '0', '0', null, null, null, null, '0', '0', '3109004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209005', null, '0', '0', null, null, null, null, '0', '0', '3109002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209501', null, '0', '0', null, null, null, null, '0', '0', '3209501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209502', null, '0', '0', null, null, null, null, '0', '0', '3209501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209503', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209504', null, '0', '0', null, null, null, null, '0', '0', '3209502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209505', null, '0', '0', null, null, null, null, '0', '0', '3209503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209506', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209507', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209508', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209509', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209510', null, '0', '0', null, null, null, null, '0', '0', '3209504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209511', null, '0', '0', null, null, null, null, '0', '0', '3209504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209512', null, '0', '0', null, null, null, null, '0', '0', '3209505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209513', null, '0', '0', null, null, null, null, '0', '0', '3209505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209514', null, '0', '0', null, null, null, null, '0', '0', '3209506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209515', null, '0', '0', null, null, null, null, '0', '0', '3209507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209516', null, '0', '0', null, null, null, null, '0', '0', '3209502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209517', null, '0', '0', null, null, null, null, '0', '0', '3209503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209518', null, '0', '0', null, null, null, null, '0', '0', '3209504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209519', null, '0', '0', null, null, null, null, '0', '0', '3209504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209801', null, '0', '0', null, null, null, null, '0', '0', '3209801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209901', null, '0', '0', null, null, null, null, '0', '0', '3209901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209902', null, '0', '0', null, null, null, null, '0', '0', '3209902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209903', null, '0', '0', null, null, null, null, '0', '0', '3209903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209904', null, '0', '0', null, null, null, null, '0', '0', '3209905', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209905', null, '0', '0', null, null, null, null, '0', '0', '3209906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209906', null, '0', '0', null, null, null, null, '0', '0', '3209907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209907', null, '0', '0', null, null, null, null, '0', '0', '3209907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2209908', null, '0', '0', null, null, null, null, '0', '0', '3209907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210001', null, '0', '0', null, null, null, null, '0', '0', '3210001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210002', null, '0', '0', null, null, null, null, '0', '0', '3210002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210003', null, '0', '0', null, null, null, null, '0', '0', '3210003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210004', null, '0', '0', null, null, null, null, '0', '0', '3210004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210301', null, '0', '0', null, null, null, null, '0', '0', '3210301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210302', null, '0', '0', null, null, null, null, '0', '0', '3210302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210303', null, '0', '0', null, null, null, null, '0', '0', '3210303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210401', null, '0', '0', null, null, null, null, '0', '0', '3210401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210402', null, '0', '0', null, null, null, null, '0', '0', '3210402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210403', null, '0', '0', null, null, null, null, '0', '0', '3210403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210404', null, '0', '0', null, null, null, null, '0', '0', '3210404', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210405', null, '0', '0', null, null, null, null, '0', '0', '3210405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210406', null, '0', '0', null, null, null, null, '0', '0', '3210406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210407', null, '0', '0', null, null, null, null, '0', '0', '3210407', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210408', null, '0', '0', null, null, null, null, '0', '0', '3210408', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210501', null, '0', '0', null, null, null, null, '0', '0', '3210501', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210502', null, '0', '0', null, null, null, null, '0', '0', '3210502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210503', null, '0', '0', null, null, null, null, '0', '0', '3210503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210504', null, '0', '0', null, null, null, null, '0', '0', '3210504', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210505', null, '0', '0', null, null, null, null, '0', '0', '3210505', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210506', null, '0', '0', null, null, null, null, '0', '0', '3210506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210507', null, '0', '0', null, null, null, null, '0', '0', '3210507', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210508', null, '0', '0', null, null, null, null, '0', '0', '3210508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210509', null, '0', '0', null, null, null, null, '0', '0', '3210509', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210510', null, '0', '0', null, null, null, null, '0', '0', '3210510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210511', null, '0', '0', null, null, null, null, '0', '0', '3210511', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210512', null, '0', '0', null, null, null, null, '0', '0', '3210512', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210513', null, '0', '0', null, null, null, null, '0', '0', '3210513', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210514', null, '0', '0', null, null, null, null, '0', '0', '3210514', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210515', null, '0', '0', null, null, null, null, '0', '0', '3210515', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210516', null, '0', '0', null, null, null, null, '0', '0', '3210516', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210517', null, '0', '0', null, null, null, null, '0', '0', '3210517', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210518', null, '0', '0', null, null, null, null, '0', '0', '3210518', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210701', null, '0', '0', null, null, null, null, '0', '0', '3110702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210702', null, '0', '0', null, null, null, null, '0', '0', '3110703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210703', null, '0', '0', null, null, null, null, '0', '0', '3210701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210801', null, '0', '0', null, null, null, null, '0', '0', '3210801', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210802', null, '0', '0', null, null, null, null, '0', '0', '3210802', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210901', null, '0', '0', null, null, null, null, '0', '0', '2700001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210902', null, '0', '0', null, null, null, null, '0', '0', '3210902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210903', null, '0', '0', null, null, null, null, '0', '0', '3210903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210904', null, '0', '0', null, null, null, null, '0', '0', '2700001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210905', null, '0', '0', null, null, null, null, '0', '0', '3210903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210906', null, '0', '0', null, null, null, null, '0', '0', '3210902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210907', null, '0', '0', null, null, null, null, '0', '0', '3210904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210908', null, '0', '0', null, null, null, null, '0', '0', '3210904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210909', null, '0', '0', null, null, null, null, '0', '0', '3210902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210910', null, '0', '0', null, null, null, null, '0', '0', '3210903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210911', null, '0', '0', null, null, null, null, '0', '0', '3210902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210912', null, '0', '0', null, null, null, null, '0', '0', '3210903', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2210913', null, '0', '0', null, null, null, null, '0', '0', '3210904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280001', null, '0', '0', null, null, null, null, '0', '0', '3280001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280002', null, '0', '0', null, null, null, null, '0', '0', '3280002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280003', null, '0', '0', null, null, null, null, '0', '0', '3280003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280004', null, '0', '0', null, null, null, null, '0', '0', '3280004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280005', null, '0', '0', null, null, null, null, '0', '0', '3280005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280006', null, '0', '0', null, null, null, null, '0', '0', '3280006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280007', null, '0', '0', null, null, null, null, '0', '0', '3280007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280008', null, '0', '0', null, null, null, null, '0', '0', '3280008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280009', null, '0', '0', null, null, null, null, '0', '0', '3280009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280010', null, '0', '0', null, null, null, null, '0', '0', '3280010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280011', null, '0', '0', null, null, null, null, '0', '0', '3280011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280012', null, '0', '0', null, null, null, null, '0', '0', '3280012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280013', null, '0', '0', null, null, null, null, '0', '0', '3280013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280014', null, '0', '0', null, null, null, null, '0', '0', '3280014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280015', null, '0', '0', null, null, null, null, '0', '0', '3280015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280016', null, '0', '0', null, null, null, null, '0', '0', '3280016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280017', null, '0', '0', null, null, null, null, '0', '0', '3280017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280018', null, '0', '0', null, null, null, null, '0', '0', '3280018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280019', null, '0', '0', null, null, null, null, '0', '0', '3280019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280020', null, '0', '0', null, null, null, null, '0', '0', '3280020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280021', null, '0', '0', null, null, null, null, '0', '0', '3280021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280022', null, '0', '0', null, null, null, null, '0', '0', '3280022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280023', null, '0', '0', null, null, null, null, '0', '0', '3207010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280024', null, '0', '0', null, null, null, null, '0', '0', '3207011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280025', null, '0', '0', null, null, null, null, '0', '0', '3207012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280026', null, '0', '0', null, null, null, null, '0', '0', '3207013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280027', null, '0', '0', null, null, null, null, '0', '0', '3207014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280028', null, '0', '0', null, null, null, null, '0', '0', '3207015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280029', null, '0', '0', null, null, null, null, '0', '0', '3207016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280030', null, '0', '0', null, null, null, null, '0', '0', '3207017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280031', null, '0', '0', null, null, null, null, '0', '0', '3207018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280032', null, '0', '0', null, null, null, null, '0', '0', '3207019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280033', null, '0', '0', null, null, null, null, '0', '0', '3207020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280034', null, '0', '0', null, null, null, null, '0', '0', '3280023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280035', null, '0', '0', null, null, null, null, '0', '0', '3280024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280036', null, '0', '0', null, null, null, null, '0', '0', '3280025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280037', null, '0', '0', null, null, null, null, '0', '0', '3280026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280038', null, '0', '0', null, null, null, null, '0', '0', '3280027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280039', null, '0', '0', null, null, null, null, '0', '0', '3280028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280040', null, '0', '0', null, null, null, null, '0', '0', '3280029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280041', null, '0', '0', null, null, null, null, '0', '0', '3280030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280042', null, '0', '0', null, null, null, null, '0', '0', '3280031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280043', null, '0', '0', null, null, null, null, '0', '0', '3280032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280044', null, '0', '0', null, null, null, null, '0', '0', '3280033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280045', null, '0', '0', null, null, null, null, '0', '0', '3280034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280046', null, '0', '0', null, null, null, null, '0', '0', '3207024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280047', null, '0', '0', null, null, null, null, '0', '0', '3207025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280048', null, '0', '0', null, null, null, null, '0', '0', '3207026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280049', null, '0', '0', null, null, null, null, '0', '0', '3207027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280050', null, '0', '0', null, null, null, null, '0', '0', '3207024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280051', null, '0', '0', null, null, null, null, '0', '0', '3280035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280052', null, '0', '0', null, null, null, null, '0', '0', '3280036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280053', null, '0', '0', null, null, null, null, '0', '0', '3280037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280054', null, '0', '0', null, null, null, null, '0', '0', '3280038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280055', null, '0', '0', null, null, null, null, '0', '0', '3280039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280056', null, '0', '0', null, null, null, null, '0', '0', '3280040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280057', null, '0', '0', null, null, null, null, '0', '0', '3280041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280058', null, '0', '0', null, null, null, null, '0', '0', '3180009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280059', null, '0', '0', null, null, null, null, '0', '0', '3180011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280060', null, '0', '0', null, null, null, null, '0', '0', '3180013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280061', null, '0', '0', null, null, null, null, '0', '0', '3180015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280062', null, '0', '0', null, null, null, null, '0', '0', '3180017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280063', null, '0', '0', null, null, null, null, '0', '0', '3180019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280064', null, '0', '0', null, null, null, null, '0', '0', '3180021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280065', null, '0', '0', null, null, null, null, '0', '0', '3180010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280066', null, '0', '0', null, null, null, null, '0', '0', '3180014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280067', null, '0', '0', null, null, null, null, '0', '0', '3180016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280068', null, '0', '0', null, null, null, null, '0', '0', '3180018', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280069', null, '0', '0', null, null, null, null, '0', '0', '3180020', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280070', null, '0', '0', null, null, null, null, '0', '0', '3180022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280101', null, '0', '0', null, null, null, null, '0', '0', '3280101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280102', null, '0', '0', null, null, null, null, '0', '0', '3280102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280103', null, '0', '0', null, null, null, null, '0', '0', '3280103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280104', null, '0', '0', null, null, null, null, '0', '0', '3280104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280105', null, '0', '0', null, null, null, null, '0', '0', '3280105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280106', null, '0', '0', null, null, null, null, '0', '0', '3280106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280107', null, '0', '0', null, null, null, null, '0', '0', '3280107', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280108', null, '0', '0', null, null, null, null, '0', '0', '3280108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280109', null, '0', '0', null, null, null, null, '0', '0', '3280109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280110', null, '0', '0', null, null, null, null, '0', '0', '3280110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280111', null, '0', '0', null, null, null, null, '0', '0', '3280111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280112', null, '0', '0', null, null, null, null, '0', '0', '3280112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280113', null, '0', '0', null, null, null, null, '0', '0', '3280113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280114', null, '0', '0', null, null, null, null, '0', '0', '3280114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280115', null, '0', '0', null, null, null, null, '0', '0', '3280115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280116', null, '0', '0', null, null, null, null, '0', '0', '3280116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280117', null, '0', '0', null, null, null, null, '0', '0', '3280117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280118', null, '0', '0', null, null, null, null, '0', '0', '3280118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280119', null, '0', '0', null, null, null, null, '0', '0', '3280119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280120', null, '0', '0', null, null, null, null, '0', '0', '3280120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280121', null, '0', '0', null, null, null, null, '0', '0', '3280121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280122', null, '0', '0', null, null, null, null, '0', '0', '3280122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280123', null, '0', '0', null, null, null, null, '0', '0', '3280123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280124', null, '0', '0', null, null, null, null, '0', '0', '3280124', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280125', null, '0', '0', null, null, null, null, '0', '0', '3280125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280126', null, '0', '0', null, null, null, null, '0', '0', '3280126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280127', null, '0', '0', null, null, null, null, '0', '0', '3280127', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280128', null, '0', '0', null, null, null, null, '0', '0', '3280128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280129', null, '0', '0', null, null, null, null, '0', '0', '3280129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280130', null, '0', '0', null, null, null, null, '0', '0', '3280130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280131', null, '0', '0', null, null, null, null, '0', '0', '3280131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280132', null, '0', '0', null, null, null, null, '0', '0', '3280132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280133', null, '0', '0', null, null, null, null, '0', '0', '3280133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280134', null, '0', '0', null, null, null, null, '0', '0', '3280173', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280135', null, '0', '0', null, null, null, null, '0', '0', '3280134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280136', null, '0', '0', null, null, null, null, '0', '0', '3280135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280137', null, '0', '0', null, null, null, null, '0', '0', '3280136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280138', null, '0', '0', null, null, null, null, '0', '0', '3280137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280139', null, '0', '0', null, null, null, null, '0', '0', '3280138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280140', null, '0', '0', null, null, null, null, '0', '0', '3280139', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280141', null, '0', '0', null, null, null, null, '0', '0', '3280140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280142', null, '0', '0', null, null, null, null, '0', '0', '3280141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280143', null, '0', '0', null, null, null, null, '0', '0', '3280142', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280144', null, '0', '0', null, null, null, null, '0', '0', '3280143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280145', null, '0', '0', null, null, null, null, '0', '0', '3280144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280146', null, '0', '0', null, null, null, null, '0', '0', '3280145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280147', null, '0', '0', null, null, null, null, '0', '0', '3280146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280148', null, '0', '0', null, null, null, null, '0', '0', '3280147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280149', null, '0', '0', null, null, null, null, '0', '0', '3280148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280150', null, '0', '0', null, null, null, null, '0', '0', '3280149', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280151', null, '0', '0', null, null, null, null, '0', '0', '3280150', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280152', null, '0', '0', null, null, null, null, '0', '0', '3280151', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280153', null, '0', '0', null, null, null, null, '0', '0', '3280152', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280154', null, '0', '0', null, null, null, null, '0', '0', '3280153', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280155', null, '0', '0', null, null, null, null, '0', '0', '3280154', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280156', null, '0', '0', null, null, null, null, '0', '0', '3280155', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280157', null, '0', '0', null, null, null, null, '0', '0', '3280156', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280158', null, '0', '0', null, null, null, null, '0', '0', '3280157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280159', null, '0', '0', null, null, null, null, '0', '0', '3280158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280160', null, '0', '0', null, null, null, null, '0', '0', '3280159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280161', null, '0', '0', null, null, null, null, '0', '0', '3280160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280162', null, '0', '0', null, null, null, null, '0', '0', '3280161', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280163', null, '0', '0', null, null, null, null, '0', '0', '3280162', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280164', null, '0', '0', null, null, null, null, '0', '0', '3280163', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280165', null, '0', '0', null, null, null, null, '0', '0', '3280164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280166', null, '0', '0', null, null, null, null, '0', '0', '3280165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280167', null, '0', '0', null, null, null, null, '0', '0', '3280166', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280168', null, '0', '0', null, null, null, null, '0', '0', '3280167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280169', null, '0', '0', null, null, null, null, '0', '0', '3280168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280170', null, '0', '0', null, null, null, null, '0', '0', '3280169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280171', null, '0', '0', null, null, null, null, '0', '0', '3280170', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280172', null, '0', '0', null, null, null, null, '0', '0', '3280171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280173', null, '0', '0', null, null, null, null, '0', '0', '3280172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280174', null, '0', '0', null, null, null, null, '0', '0', '3280174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280175', null, '0', '0', null, null, null, null, '0', '0', '3280175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280176', null, '0', '0', null, null, null, null, '0', '0', '3280176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280177', null, '0', '0', null, null, null, null, '0', '0', '3280177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280178', null, '0', '0', null, null, null, null, '0', '0', '3280178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280179', null, '0', '0', null, null, null, null, '0', '0', '3280179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280180', null, '0', '0', null, null, null, null, '0', '0', '3280180', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280181', null, '0', '0', null, null, null, null, '0', '0', '3280181', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280182', null, '0', '0', null, null, null, null, '0', '0', '3280182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280183', null, '0', '0', null, null, null, null, '0', '0', '3280183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280184', null, '0', '0', null, null, null, null, '0', '0', '3280184', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280185', null, '0', '0', null, null, null, null, '0', '0', '3280185', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280186', null, '0', '0', null, null, null, null, '0', '0', '3280186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280187', null, '0', '0', null, null, null, null, '0', '0', '3280187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280188', null, '0', '0', null, null, null, null, '0', '0', '3280188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280189', null, '0', '0', null, null, null, null, '0', '0', '3280189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280190', null, '0', '0', null, null, null, null, '0', '0', '3280190', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280191', null, '0', '0', null, null, null, null, '0', '0', '3280191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280192', null, '0', '0', null, null, null, null, '0', '0', '3280192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280193', null, '0', '0', null, null, null, null, '0', '0', '3280193', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280194', null, '0', '0', null, null, null, null, '0', '0', '3280194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280195', null, '0', '0', null, null, null, null, '0', '0', '3280195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280196', null, '0', '0', null, null, null, null, '0', '0', '3280196', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280197', null, '0', '0', null, null, null, null, '0', '0', '3280197', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280198', null, '0', '0', null, null, null, null, '0', '0', '3280198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280201', null, '0', '0', null, null, null, null, '0', '0', '3280201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280202', null, '0', '0', null, null, null, null, '0', '0', '3280202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280203', null, '0', '0', null, null, null, null, '0', '0', '3280203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280204', null, '0', '0', null, null, null, null, '0', '0', '3280204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280205', null, '0', '0', null, null, null, null, '0', '0', '3280205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280206', null, '0', '0', null, null, null, null, '0', '0', '3280206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280207', null, '0', '0', null, null, null, null, '0', '0', '3280207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280208', null, '0', '0', null, null, null, null, '0', '0', '3280208', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280209', null, '0', '0', null, null, null, null, '0', '0', '3280209', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280210', null, '0', '0', null, null, null, null, '0', '0', '3280210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280211', null, '0', '0', null, null, null, null, '0', '0', '3280211', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280212', null, '0', '0', null, null, null, null, '0', '0', '3280212', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280213', null, '0', '0', null, null, null, null, '0', '0', '3280213', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280214', null, '0', '0', null, null, null, null, '0', '0', '3280214', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280215', null, '0', '0', null, null, null, null, '0', '0', '3280215', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280216', null, '0', '0', null, null, null, null, '0', '0', '3280216', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280217', null, '0', '0', null, null, null, null, '0', '0', '3280217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280218', null, '0', '0', null, null, null, null, '0', '0', '3280218', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280219', null, '0', '0', null, null, null, null, '0', '0', '3280219', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280220', null, '0', '0', null, null, null, null, '0', '0', '3280220', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280221', null, '0', '0', null, null, null, null, '0', '0', '3280221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280222', null, '0', '0', null, null, null, null, '0', '0', '3280222', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280223', null, '0', '0', null, null, null, null, '0', '0', '3280223', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280224', null, '0', '0', null, null, null, null, '0', '0', '3280224', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280225', null, '0', '0', null, null, null, null, '0', '0', '3280225', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280301', null, '0', '0', null, null, null, null, '0', '0', '3280401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2280302', null, '0', '0', null, null, null, null, '0', '0', '3280402', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289001', null, '0', '0', null, null, null, null, '0', '0', '4000596', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289002', null, '0', '0', null, null, null, null, '0', '0', '4000596', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289003', null, '0', '0', null, null, null, null, '0', '0', '4000596', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289004', null, '0', '0', null, null, null, null, '0', '0', '1600116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289005', null, '0', '0', null, null, null, null, '0', '0', '1600116', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289006', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289007', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289008', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289009', null, '0', '0', null, null, null, null, '0', '0', '1900046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289010', null, '0', '0', null, null, null, null, '0', '0', '4000597', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289011', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289012', null, '0', '0', null, null, null, null, '0', '0', '4000191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289013', null, '0', '0', null, null, null, null, '0', '0', '4000598', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289014', null, '0', '0', null, null, null, null, '0', '0', '4000192', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289015', null, '0', '0', null, null, null, null, '0', '0', '4000189', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289016', null, '0', '0', null, null, null, null, '0', '0', '1000342', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289017', null, '0', '0', null, null, null, null, '0', '0', '1000342', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289018', null, '0', '0', null, null, null, null, '0', '0', '1000342', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289019', null, '0', '0', null, null, null, null, '0', '0', '3280308', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289020', null, '0', '0', null, null, null, null, '0', '0', '3280309', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289021', null, '0', '0', null, null, null, null, '0', '0', '3280310', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289022', null, '0', '0', null, null, null, null, '0', '0', '3280301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289023', null, '0', '0', null, null, null, null, '0', '0', '3280302', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289024', null, '0', '0', null, null, null, null, '0', '0', '3280303', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289025', null, '0', '0', null, null, null, null, '0', '0', '3280311', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289026', null, '0', '0', null, null, null, null, '0', '0', '3280304', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289027', null, '0', '0', null, null, null, null, '0', '0', '3280305', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289028', null, '0', '0', null, null, null, null, '0', '0', '3280306', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289029', null, '0', '0', null, null, null, null, '0', '0', '3280307', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289030', null, '0', '0', null, null, null, null, '0', '0', '3280312', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289031', null, '0', '0', null, null, null, null, '0', '0', '3280313', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289032', null, '0', '0', null, null, null, null, '0', '0', '3280314', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289033', null, '0', '0', null, null, null, null, '0', '0', '3280315', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289034', null, '0', '0', null, null, null, null, '0', '0', '3280316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289035', null, '0', '0', null, null, null, null, '0', '0', '3280317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289036', null, '0', '0', null, null, null, null, '0', '0', '3280318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289037', null, '0', '0', null, null, null, null, '0', '0', '3280319', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289038', null, '0', '0', null, null, null, null, '0', '0', '3280320', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289039', null, '0', '0', null, null, null, null, '0', '0', '3280321', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289040', null, '0', '0', null, null, null, null, '0', '0', '3280322', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289041', null, '0', '0', null, null, null, null, '0', '0', '3280323', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289042', null, '0', '0', null, null, null, null, '0', '0', '3280324', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289043', null, '0', '0', null, null, null, null, '0', '0', '3280325', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2289044', null, '0', '0', null, null, null, null, '0', '0', '3280403', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290001', null, '0', '0', null, null, null, null, '0', '0', '1900006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290002', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290003', null, '0', '0', null, null, null, null, '0', '0', '1200024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290004', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290005', null, '0', '0', null, null, null, null, '0', '0', '1400004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290006', null, '0', '0', null, null, null, null, '0', '0', '2300120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290007', null, '0', '0', null, null, null, null, '0', '0', '1500024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290008', null, '0', '0', null, null, null, null, '0', '0', '1900054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290009', null, '0', '0', null, null, null, null, '0', '0', '1000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290010', null, '0', '0', null, null, null, null, '0', '0', '1100025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290011', null, '0', '0', null, null, null, null, '0', '0', '1000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290012', null, '0', '0', null, null, null, null, '0', '0', '1200028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290013', null, '0', '0', null, null, null, null, '0', '0', '1200024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290014', null, '0', '0', null, null, null, null, '0', '0', '1600089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290015', null, '0', '0', null, null, null, null, '0', '0', '1200014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290016', null, '0', '0', null, null, null, null, '0', '0', '1200013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290017', null, '0', '0', null, null, null, null, '0', '0', '1900026', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290018', null, '0', '0', null, null, null, null, '0', '0', '1000006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290019', null, '0', '0', null, null, null, null, '0', '0', '1000013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290020', null, '0', '0', null, null, null, null, '0', '0', '1500004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290021', null, '0', '0', null, null, null, null, '0', '0', '4000421', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290022', null, '0', '0', null, null, null, null, '0', '0', '2200172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290023', null, '0', '0', null, null, null, null, '0', '0', '4000348', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290024', null, '0', '0', null, null, null, null, '0', '0', '4000135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290025', null, '0', '0', null, null, null, null, '0', '0', '4000132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290026', null, '0', '0', null, null, null, null, '0', '0', '4000133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290027', null, '0', '0', null, null, null, null, '0', '0', '4000134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290028', null, '0', '0', null, null, null, null, '0', '0', '4000135', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290029', null, '0', '0', null, null, null, null, '0', '0', '4000132', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290030', null, '0', '0', null, null, null, null, '0', '0', '4000133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290031', null, '0', '0', null, null, null, null, '0', '0', '4000134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290032', null, '0', '0', null, null, null, null, '0', '0', '1100199', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290033', null, '0', '0', null, null, null, null, '0', '0', '1000175', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290034', null, '0', '0', null, null, null, null, '0', '0', '4000257', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290035', null, '0', '0', null, null, null, null, '0', '0', '1500080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290036', null, '0', '0', null, null, null, null, '0', '0', '3206201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290037', null, '0', '0', null, null, null, null, '0', '0', '1100118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290038', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290039', null, '0', '0', null, null, null, null, '0', '0', '1000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290040', null, '0', '0', null, null, null, null, '0', '0', '2300120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290041', null, '0', '0', null, null, null, null, '0', '0', '1600083', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290042', null, '0', '0', null, null, null, null, '0', '0', '1000030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290043', null, '0', '0', null, null, null, null, '0', '0', '1900195', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290044', null, '0', '0', null, null, null, null, '0', '0', '1000087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290045', null, '0', '0', null, null, null, null, '0', '0', '4000622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290046', null, '0', '0', null, null, null, null, '0', '0', '4000623', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290047', null, '0', '0', null, null, null, null, '0', '0', '4000624', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290048', null, '0', '0', null, null, null, null, '0', '0', '4000625', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290049', null, '0', '0', null, null, null, null, '0', '0', '4000626', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290050', null, '0', '0', null, null, null, null, '0', '0', '4000627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290051', null, '0', '0', null, null, null, null, '0', '0', '4000628', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290052', null, '0', '0', null, null, null, null, '0', '0', '4000629', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290053', null, '0', '0', null, null, null, null, '0', '0', '4000630', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290054', null, '0', '0', null, null, null, null, '0', '0', '3290008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290055', null, '0', '0', null, null, null, null, '0', '0', '3290002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290056', null, '0', '0', null, null, null, null, '0', '0', '3290009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290057', null, '0', '0', null, null, null, null, '0', '0', '3290004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290058', null, '0', '0', null, null, null, null, '0', '0', '3290001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290059', null, '0', '0', null, null, null, null, '0', '0', '3290002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290060', null, '0', '0', null, null, null, null, '0', '0', '3290003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290061', null, '0', '0', null, null, null, null, '0', '0', '3290004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290062', null, '0', '0', null, null, null, null, '0', '0', '3290008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290063', null, '0', '0', null, null, null, null, '0', '0', '3290002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290064', null, '0', '0', null, null, null, null, '0', '0', '3290009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290065', null, '0', '0', null, null, null, null, '0', '0', '3290004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290066', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290067', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290068', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290069', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290070', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290071', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290072', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290073', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290074', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290075', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290076', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290077', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290078', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290079', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290080', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290081', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290082', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290083', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290084', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290085', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290086', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290087', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290088', null, '0', '0', null, null, null, null, '0', '0', '3290005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290089', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290090', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290091', null, '0', '0', null, null, null, null, '0', '0', '3290006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290092', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290093', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290094', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290095', null, '0', '0', null, null, null, null, '0', '0', '3290007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290096', null, '0', '0', null, null, null, null, '0', '0', '3290010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290097', null, '0', '0', null, null, null, null, '0', '0', '1900183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2290098', null, '0', '0', null, null, null, null, '0', '0', '1900183', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2291001', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2291002', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2291003', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2291004', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2291005', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2300101', null, '0', '0', null, null, null, null, '0', '0', '3200114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2300401', null, '0', '0', null, null, null, null, '0', '0', '3200406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2300701', null, '0', '0', null, null, null, null, '0', '0', '3300701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2300702', null, '0', '0', null, null, null, null, '0', '0', '3300702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2300901', null, '0', '0', null, null, null, null, '0', '0', '3300901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301001', null, '0', '0', null, null, null, null, '0', '0', '3301001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301101', null, '0', '0', null, null, null, null, '0', '0', '3201111', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301102', null, '0', '0', null, null, null, null, '0', '0', '3201108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301103', null, '0', '0', null, null, null, null, '0', '0', '3201109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301104', null, '0', '0', null, null, null, null, '0', '0', '3201110', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301105', null, '0', '0', null, null, null, null, '0', '0', '3201113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301106', null, '0', '0', null, null, null, null, '0', '0', '3201112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301107', null, '0', '0', null, null, null, null, '0', '0', '3201114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301108', null, '0', '0', null, null, null, null, '0', '0', '3201115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301109', null, '0', '0', null, null, null, null, '0', '0', '3201112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301110', null, '0', '0', null, null, null, null, '0', '0', '3301101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301111', null, '0', '0', null, null, null, null, '0', '0', '3301102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301301', null, '0', '0', null, null, null, null, '0', '0', '3301301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301601', null, '0', '0', null, null, null, null, '0', '0', '3201606', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301701', null, '0', '0', null, null, null, null, '0', '0', '3201705', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301702', null, '0', '0', null, null, null, null, '0', '0', '3201706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301901', null, '0', '0', null, null, null, null, '0', '0', '3201906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2301902', null, '0', '0', null, null, null, null, '0', '0', '3201907', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302101', null, '0', '0', null, null, null, null, '0', '0', '3302101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302201', null, '0', '0', null, null, null, null, '0', '0', '3202207', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302501', null, '0', '0', null, null, null, null, '0', '0', '3202503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302701', null, '0', '0', null, null, null, null, '0', '0', '3202712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302702', null, '0', '0', null, null, null, null, '0', '0', '3202713', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302703', null, '0', '0', null, null, null, null, '0', '0', '3302701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302704', null, '0', '0', null, null, null, null, '0', '0', '3302702', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2302705', null, '0', '0', null, null, null, null, '0', '0', '3302703', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303001', null, '0', '0', null, null, null, null, '0', '0', '3303001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303002', null, '0', '0', null, null, null, null, '0', '0', '3303002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303003', null, '0', '0', null, null, null, null, '0', '0', '3303003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303004', null, '0', '0', null, null, null, null, '0', '0', '3303004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303005', null, '0', '0', null, null, null, null, '0', '0', '3303005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303006', null, '0', '0', null, null, null, null, '0', '0', '3303006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303007', null, '0', '0', null, null, null, null, '0', '0', '3303007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303101', null, '0', '0', null, null, null, null, '0', '0', '3203105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303102', null, '0', '0', null, null, null, null, '0', '0', '3303101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303401', null, '0', '0', null, null, null, null, '0', '0', '3203405', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2303501', null, '0', '0', null, null, null, null, '0', '0', '3203503', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304101', null, '0', '0', null, null, null, null, '0', '0', '3304101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304201', null, '0', '0', null, null, null, null, '0', '0', '3304201', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304202', null, '0', '0', null, null, null, null, '0', '0', '3304202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304203', null, '0', '0', null, null, null, null, '0', '0', '3304203', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304204', null, '0', '0', null, null, null, null, '0', '0', '3304204', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304205', null, '0', '0', null, null, null, null, '0', '0', '3304205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304301', null, '0', '0', null, null, null, null, '0', '0', '3204316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304302', null, '0', '0', null, null, null, null, '0', '0', '3204317', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304303', null, '0', '0', null, null, null, null, '0', '0', '3204318', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304304', null, '0', '0', null, null, null, null, '0', '0', '3304301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2304501', null, '0', '0', null, null, null, null, '0', '0', '3204508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2305301', null, '0', '0', null, null, null, null, '0', '0', '3305301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2305401', null, '0', '0', null, null, null, null, '0', '0', '3305401', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2305601', null, '0', '0', null, null, null, null, '0', '0', '3205610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2305701', null, '0', '0', null, null, null, null, '0', '0', '3205711', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2305901', null, '0', '0', null, null, null, null, '0', '0', '3305901', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2307001', null, '0', '0', null, null, null, null, '0', '0', '3207005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2307002', null, '0', '0', null, null, null, null, '0', '0', '3307001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2308701', null, '0', '0', null, null, null, null, '0', '0', '3308701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2309901', null, '0', '0', null, null, null, null, '0', '0', '3209904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310601', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310602', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310603', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310604', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310605', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310606', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310607', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310608', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310609', null, '0', '0', null, null, null, null, '0', '0', '3310601', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2310701', null, '0', '0', null, null, null, null, '0', '0', '3310701', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380001', null, '0', '0', null, null, null, null, '0', '0', '3207007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380002', null, '0', '0', null, null, null, null, '0', '0', '3207008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380003', null, '0', '0', null, null, null, null, '0', '0', '3207009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380004', null, '0', '0', null, null, null, null, '0', '0', '3307002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380005', null, '0', '0', null, null, null, null, '0', '0', '3307003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380006', null, '0', '0', null, null, null, null, '0', '0', '3307004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380007', null, '0', '0', null, null, null, null, '0', '0', '3307005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('2380008', null, '0', '0', null, null, null, null, '0', '0', '3307006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3000001', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001101', null, '0', '0', null, null, null, null, '0', '0', '1000049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001102', null, '0', '0', null, null, null, null, '0', '0', '1000119', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001103', null, '0', '0', null, null, null, null, '0', '0', '1000198', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001104', null, '0', '0', null, null, null, null, '0', '0', '1000225', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001105', null, '0', '0', null, null, null, null, '0', '0', '1000254', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001106', null, '0', '0', null, null, null, null, '0', '0', '1100191', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001107', null, '0', '0', null, null, null, null, '0', '0', '1100346', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001108', null, '0', '0', null, null, null, null, '0', '0', '1100378', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001109', null, '0', '0', null, null, null, null, '0', '0', '1100406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001110', null, '0', '0', null, null, null, null, '0', '0', '1100435', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001111', null, '0', '0', null, null, null, null, '0', '0', '2200072', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001112', null, '0', '0', null, null, null, null, '0', '0', '2200079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001113', null, '0', '0', null, null, null, null, '0', '0', '2200141', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001114', null, '0', '0', null, null, null, null, '0', '0', '2200202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001115', null, '0', '0', null, null, null, null, '0', '0', '2200240', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001116', null, '0', '0', null, null, null, null, '0', '0', '1200042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001117', null, '0', '0', null, null, null, null, '0', '0', '1200074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001118', null, '0', '0', null, null, null, null, '0', '0', '1200076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001119', null, '0', '0', null, null, null, null, '0', '0', '1200080', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001120', null, '0', '0', null, null, null, null, '0', '0', '1200095', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001121', null, '0', '0', null, null, null, null, '0', '0', '1300041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001122', null, '0', '0', null, null, null, null, '0', '0', '1300043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001123', null, '0', '0', null, null, null, null, '0', '0', '1300061', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001124', null, '0', '0', null, null, null, null, '0', '0', '1300069', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001125', null, '0', '0', null, null, null, null, '0', '0', '1300088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001126', null, '0', '0', null, null, null, null, '0', '0', '1200112', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001127', null, '0', '0', null, null, null, null, '0', '0', '1200114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001128', null, '0', '0', null, null, null, null, '0', '0', '1200115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001129', null, '0', '0', null, null, null, null, '0', '0', '1200117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001130', null, '0', '0', null, null, null, null, '0', '0', '1200121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001131', null, '0', '0', null, null, null, null, '0', '0', '1300013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001132', null, '0', '0', null, null, null, null, '0', '0', '1300044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001133', null, '0', '0', null, null, null, null, '0', '0', '1300056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001134', null, '0', '0', null, null, null, null, '0', '0', '1300065', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001135', null, '0', '0', null, null, null, null, '0', '0', '1300089', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001136', null, '0', '0', null, null, null, null, '0', '0', '1400087', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001137', null, '0', '0', null, null, null, null, '0', '0', '1400090', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001138', null, '0', '0', null, null, null, null, '0', '0', '1400091', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001139', null, '0', '0', null, null, null, null, '0', '0', '1400100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001140', null, '0', '0', null, null, null, null, '0', '0', '1400101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001141', null, '0', '0', null, null, null, null, '0', '0', '1500082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001142', null, '0', '0', null, null, null, null, '0', '0', '1500085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001143', null, '0', '0', null, null, null, null, '0', '0', '1500096', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001144', null, '0', '0', null, null, null, null, '0', '0', '1500097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001145', null, '0', '0', null, null, null, null, '0', '0', '1500100', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001146', null, '0', '0', null, null, null, null, '0', '0', '1400051', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001147', null, '0', '0', null, null, null, null, '0', '0', '1400054', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001148', null, '0', '0', null, null, null, null, '0', '0', '1400062', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001149', null, '0', '0', null, null, null, null, '0', '0', '1400073', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001150', null, '0', '0', null, null, null, null, '0', '0', '1400078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001151', null, '0', '0', null, null, null, null, '0', '0', '1500010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001152', null, '0', '0', null, null, null, null, '0', '0', '1500013', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001153', null, '0', '0', null, null, null, null, '0', '0', '1500048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001154', null, '0', '0', null, null, null, null, '0', '0', '1500050', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001155', null, '0', '0', null, null, null, null, '0', '0', '1500070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001156', null, '0', '0', null, null, null, null, '0', '0', '1900012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001157', null, '0', '0', null, null, null, null, '0', '0', '1900014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001158', null, '0', '0', null, null, null, null, '0', '0', '1900031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001159', null, '0', '0', null, null, null, null, '0', '0', '1900041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001160', null, '0', '0', null, null, null, null, '0', '0', '1900049', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001161', null, '0', '0', null, null, null, null, '0', '0', '1900063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001162', null, '0', '0', null, null, null, null, '0', '0', '1900066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001163', null, '0', '0', null, null, null, null, '0', '0', '1900070', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001164', null, '0', '0', null, null, null, null, '0', '0', '1900075', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001165', null, '0', '0', null, null, null, null, '0', '0', '1900076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001166', null, '0', '0', null, null, null, null, '0', '0', '1600067', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001167', null, '0', '0', null, null, null, null, '0', '0', '1600097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001168', null, '0', '0', null, null, null, null, '0', '0', '1600138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001169', null, '0', '0', null, null, null, null, '0', '0', '1600188', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001170', null, '0', '0', null, null, null, null, '0', '0', '1600238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001171', null, '0', '0', null, null, null, null, '0', '0', '1600035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001172', null, '0', '0', null, null, null, null, '0', '0', '1600079', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001173', null, '0', '0', null, null, null, null, '0', '0', '1600106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001174', null, '0', '0', null, null, null, null, '0', '0', '1600134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3001175', null, '0', '0', null, null, null, null, '0', '0', '1600266', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002101', null, '0', '0', null, null, null, null, '0', '0', '1000102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002102', null, '0', '0', null, null, null, null, '0', '0', '1000250', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002103', null, '0', '0', null, null, null, null, '0', '0', '1000334', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002104', null, '0', '0', null, null, null, null, '0', '0', '1000388', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002105', null, '0', '0', null, null, null, null, '0', '0', '1000399', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002106', null, '0', '0', null, null, null, null, '0', '0', '1100056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002107', null, '0', '0', null, null, null, null, '0', '0', '1100078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002108', null, '0', '0', null, null, null, null, '0', '0', '1100114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002109', null, '0', '0', null, null, null, null, '0', '0', '1100217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002110', null, '0', '0', null, null, null, null, '0', '0', '1100418', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002111', null, '0', '0', null, null, null, null, '0', '0', '2200082', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002112', null, '0', '0', null, null, null, null, '0', '0', '2200125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002113', null, '0', '0', null, null, null, null, '0', '0', '2200159', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002114', null, '0', '0', null, null, null, null, '0', '0', '2200210', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002115', null, '0', '0', null, null, null, null, '0', '0', '2200239', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002116', null, '0', '0', null, null, null, null, '0', '0', '1200040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002117', null, '0', '0', null, null, null, null, '0', '0', '1200056', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002118', null, '0', '0', null, null, null, null, '0', '0', '1200101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002119', null, '0', '0', null, null, null, null, '0', '0', '1200165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002120', null, '0', '0', null, null, null, null, '0', '0', '1200178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002121', null, '0', '0', null, null, null, null, '0', '0', '1300009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002122', null, '0', '0', null, null, null, null, '0', '0', '1300036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002123', null, '0', '0', null, null, null, null, '0', '0', '1300053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002124', null, '0', '0', null, null, null, null, '0', '0', '1300117', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002125', null, '0', '0', null, null, null, null, '0', '0', '1300143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002126', null, '0', '0', null, null, null, null, '0', '0', '1200053', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002127', null, '0', '0', null, null, null, null, '0', '0', '1200085', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002128', null, '0', '0', null, null, null, null, '0', '0', '1200151', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002129', null, '0', '0', null, null, null, null, '0', '0', '1200168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002130', null, '0', '0', null, null, null, null, '0', '0', '1200186', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002131', null, '0', '0', null, null, null, null, '0', '0', '1300012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002132', null, '0', '0', null, null, null, null, '0', '0', '1300047', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002133', null, '0', '0', null, null, null, null, '0', '0', '1300076', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002134', null, '0', '0', null, null, null, null, '0', '0', '1300133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002135', null, '0', '0', null, null, null, null, '0', '0', '1300148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002136', null, '0', '0', null, null, null, null, '0', '0', '1400121', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002137', null, '0', '0', null, null, null, null, '0', '0', '1400129', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002138', null, '0', '0', null, null, null, null, '0', '0', '1400133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002139', null, '0', '0', null, null, null, null, '0', '0', '1400136', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002140', null, '0', '0', null, null, null, null, '0', '0', '1400138', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002141', null, '0', '0', null, null, null, null, '0', '0', '1500101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002142', null, '0', '0', null, null, null, null, '0', '0', '1500106', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002143', null, '0', '0', null, null, null, null, '0', '0', '1500118', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002144', null, '0', '0', null, null, null, null, '0', '0', '1500128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002145', null, '0', '0', null, null, null, null, '0', '0', '1500137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002146', null, '0', '0', null, null, null, null, '0', '0', '1400025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002147', null, '0', '0', null, null, null, null, '0', '0', '1400043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002148', null, '0', '0', null, null, null, null, '0', '0', '1400048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002149', null, '0', '0', null, null, null, null, '0', '0', '1400144', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002150', null, '0', '0', null, null, null, null, '0', '0', '1400147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002151', null, '0', '0', null, null, null, null, '0', '0', '1500039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002152', null, '0', '0', null, null, null, null, '0', '0', '1500059', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002153', null, '0', '0', null, null, null, null, '0', '0', '1500078', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002154', null, '0', '0', null, null, null, null, '0', '0', '1500143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002155', null, '0', '0', null, null, null, null, '0', '0', '1500146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002156', null, '0', '0', null, null, null, null, '0', '0', '1900058', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002157', null, '0', '0', null, null, null, null, '0', '0', '1900097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002158', null, '0', '0', null, null, null, null, '0', '0', '1900157', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002159', null, '0', '0', null, null, null, null, '0', '0', '1900164', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002160', null, '0', '0', null, null, null, null, '0', '0', '1900167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002161', null, '0', '0', null, null, null, null, '0', '0', '1900120', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002162', null, '0', '0', null, null, null, null, '0', '0', '1900128', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002163', null, '0', '0', null, null, null, null, '0', '0', '1900171', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002164', null, '0', '0', null, null, null, null, '0', '0', '1900176', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002165', null, '0', '0', null, null, null, null, '0', '0', '1900179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002166', null, '0', '0', null, null, null, null, '0', '0', '1600008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002167', null, '0', '0', null, null, null, null, '0', '0', '1600060', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002168', null, '0', '0', null, null, null, null, '0', '0', '1600133', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002169', null, '0', '0', null, null, null, null, '0', '0', '1600187', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002170', null, '0', '0', null, null, null, null, '0', '0', '1600239', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002171', null, '0', '0', null, null, null, null, '0', '0', '1600032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002172', null, '0', '0', null, null, null, null, '0', '0', '1600088', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002173', null, '0', '0', null, null, null, null, '0', '0', '1600168', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002174', null, '0', '0', null, null, null, null, '0', '0', '1600202', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3002175', null, '0', '0', null, null, null, null, '0', '0', '1600255', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003101', null, '0', '0', null, null, null, null, '0', '0', '1000074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003102', null, '0', '0', null, null, null, null, '0', '0', '1000231', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003103', null, '0', '0', null, null, null, null, '0', '0', '1000290', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003104', null, '0', '0', null, null, null, null, '0', '0', '1000338', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003105', null, '0', '0', null, null, null, null, '0', '0', '1000410', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003106', null, '0', '0', null, null, null, null, '0', '0', '1100052', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003107', null, '0', '0', null, null, null, null, '0', '0', '1100068', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003108', null, '0', '0', null, null, null, null, '0', '0', '1100097', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003109', null, '0', '0', null, null, null, null, '0', '0', '1100160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003110', null, '0', '0', null, null, null, null, '0', '0', '1100238', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003111', null, '0', '0', null, null, null, null, '0', '0', '2200025', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003112', null, '0', '0', null, null, null, null, '0', '0', '2200084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003113', null, '0', '0', null, null, null, null, '0', '0', '2200148', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003114', null, '0', '0', null, null, null, null, '0', '0', '2200182', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003115', null, '0', '0', null, null, null, null, '0', '0', '2200221', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003116', null, '0', '0', null, null, null, null, '0', '0', '1200012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003117', null, '0', '0', null, null, null, null, '0', '0', '1200055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003118', null, '0', '0', null, null, null, null, '0', '0', '1200086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003119', null, '0', '0', null, null, null, null, '0', '0', '1200158', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003120', null, '0', '0', null, null, null, null, '0', '0', '1200174', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003121', null, '0', '0', null, null, null, null, '0', '0', '1300002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003122', null, '0', '0', null, null, null, null, '0', '0', '1300014', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003123', null, '0', '0', null, null, null, null, '0', '0', '1300048', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003124', null, '0', '0', null, null, null, null, '0', '0', '1300114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003125', null, '0', '0', null, null, null, null, '0', '0', '1300140', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003126', null, '0', '0', null, null, null, null, '0', '0', '1200044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003127', null, '0', '0', null, null, null, null, '0', '0', '1200081', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003128', null, '0', '0', null, null, null, null, '0', '0', '1200113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003129', null, '0', '0', null, null, null, null, '0', '0', '1200167', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003130', null, '0', '0', null, null, null, null, '0', '0', '1200179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003131', null, '0', '0', null, null, null, null, '0', '0', '1300011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003132', null, '0', '0', null, null, null, null, '0', '0', '1300038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003133', null, '0', '0', null, null, null, null, '0', '0', '1300063', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003134', null, '0', '0', null, null, null, null, '0', '0', '1300122', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003135', null, '0', '0', null, null, null, null, '0', '0', '1300146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003136', null, '0', '0', null, null, null, null, '0', '0', '1400102', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003137', null, '0', '0', null, null, null, null, '0', '0', '1400126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003138', null, '0', '0', null, null, null, null, '0', '0', '1400130', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003139', null, '0', '0', null, null, null, null, '0', '0', '1400134', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003140', null, '0', '0', null, null, null, null, '0', '0', '1400137', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003141', null, '0', '0', null, null, null, null, '0', '0', '1500086', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003142', null, '0', '0', null, null, null, null, '0', '0', '1500103', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003143', null, '0', '0', null, null, null, null, '0', '0', '1500109', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003144', null, '0', '0', null, null, null, null, '0', '0', '1500125', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003145', null, '0', '0', null, null, null, null, '0', '0', '1500131', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003146', null, '0', '0', null, null, null, null, '0', '0', '1400005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003147', null, '0', '0', null, null, null, null, '0', '0', '1400036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003148', null, '0', '0', null, null, null, null, '0', '0', '1400046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003149', null, '0', '0', null, null, null, null, '0', '0', '1400143', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003150', null, '0', '0', null, null, null, null, '0', '0', '1400146', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003151', null, '0', '0', null, null, null, null, '0', '0', '1500016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003152', null, '0', '0', null, null, null, null, '0', '0', '1500046', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003153', null, '0', '0', null, null, null, null, '0', '0', '1500066', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003154', null, '0', '0', null, null, null, null, '0', '0', '1500113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003155', null, '0', '0', null, null, null, null, '0', '0', '1500145', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003156', null, '0', '0', null, null, null, null, '0', '0', '1900055', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003157', null, '0', '0', null, null, null, null, '0', '0', '1900084', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003158', null, '0', '0', null, null, null, null, '0', '0', '1900104', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003159', null, '0', '0', null, null, null, null, '0', '0', '1900160', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003160', null, '0', '0', null, null, null, null, '0', '0', '1900165', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003161', null, '0', '0', null, null, null, null, '0', '0', '1900064', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003162', null, '0', '0', null, null, null, null, '0', '0', '1900123', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003163', null, '0', '0', null, null, null, null, '0', '0', '1900169', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003164', null, '0', '0', null, null, null, null, '0', '0', '1900172', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003165', null, '0', '0', null, null, null, null, '0', '0', '1900178', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003166', null, '0', '0', null, null, null, null, '0', '0', '1600001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003167', null, '0', '0', null, null, null, null, '0', '0', '1600038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003168', null, '0', '0', null, null, null, null, '0', '0', '1600108', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003169', null, '0', '0', null, null, null, null, '0', '0', '1600177', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003170', null, '0', '0', null, null, null, null, '0', '0', '1600234', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003171', null, '0', '0', null, null, null, null, '0', '0', '1600011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003172', null, '0', '0', null, null, null, null, '0', '0', '1600074', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003173', null, '0', '0', null, null, null, null, '0', '0', '1600147', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003174', null, '0', '0', null, null, null, null, '0', '0', '1600194', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('3003175', null, '0', '0', null, null, null, null, '0', '0', '1600246', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000039', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000040', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000041', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000042', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000043', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000044', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000045', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000046', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000047', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000048', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000049', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000050', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000051', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000058', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000059', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000060', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000063', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000064', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000065', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000066', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000067', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000068', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000069', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000070', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000071', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000072', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000073', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000074', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000075', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000076', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000077', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000078', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000079', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000080', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000081', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000082', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000083', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000084', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000085', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000086', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000087', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000088', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000089', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000117', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000118', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000119', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000120', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5000121', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900031', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900032', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900033', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900034', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900035', null, '0', '0', null, null, null, null, '0', '0', '3209510', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('5900038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000001', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000002', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000003', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000004', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000005', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000006', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000007', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000008', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000009', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000010', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000011', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000012', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000013', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000014', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000015', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000016', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000017', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000018', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000019', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000020', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000021', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000022', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000023', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000024', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000025', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000026', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000027', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000028', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000029', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000030', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000031', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000032', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000033', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000034', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000035', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000036', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000037', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000038', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000039', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000040', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000041', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000042', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000043', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000044', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000045', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000046', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000047', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000048', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000049', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000050', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000051', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000052', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000053', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000054', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000055', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000056', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000057', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000058', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000059', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000060', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000061', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000062', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000063', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000064', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000065', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000066', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000067', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000068', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000069', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000070', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000071', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000072', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000073', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000074', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000075', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000076', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000077', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000078', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000079', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000080', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000081', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000082', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000083', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000084', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000085', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000086', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000087', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000088', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000089', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000090', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000091', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000092', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000093', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000094', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000095', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000096', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000097', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000098', null, '0', '0', null, null, null, null, '0', '0', '1600179', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000099', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000100', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000101', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000102', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000103', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000104', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000105', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000106', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000107', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000108', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000109', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000110', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000111', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000112', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000113', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000114', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000115', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000116', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000117', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000118', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000119', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000120', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000121', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000122', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000123', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000124', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000125', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000126', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000127', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000128', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000129', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000130', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000131', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000132', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000133', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000134', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000135', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000136', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000137', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000138', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000139', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000140', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000141', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000142', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000143', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000144', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000145', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000146', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000147', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000148', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000149', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000150', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000151', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000152', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000153', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000154', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000155', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000156', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000157', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000158', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000159', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000160', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000161', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000162', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000163', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000164', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000165', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000166', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000167', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000168', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000169', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000170', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000171', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000172', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000173', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000174', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000175', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000176', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000177', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000178', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000179', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000180', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000181', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000182', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000183', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000184', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000185', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000186', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000187', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000188', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000189', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000190', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000191', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000192', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000193', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000194', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000195', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000196', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000197', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000198', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000199', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000200', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000201', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000202', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000203', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000204', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000205', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000206', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000207', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000208', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000209', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000210', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000211', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000212', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000213', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000214', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000215', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000216', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000217', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000218', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000219', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000220', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000221', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000222', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000223', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000224', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000225', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000226', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000227', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000228', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000229', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000230', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000231', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000232', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000233', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000234', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000235', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000236', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000237', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000238', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000239', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000240', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000241', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000242', null, '0', '0', null, null, null, null, '0', '0', '3107301', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000243', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000244', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000245', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000246', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000247', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000248', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000249', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000250', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000251', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000252', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000253', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000254', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000255', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000256', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000257', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000258', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000259', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000260', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000261', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000262', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000263', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000264', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000265', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000266', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000267', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000268', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000269', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000270', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000271', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000272', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000273', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000274', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000275', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000276', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000277', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000278', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000279', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000280', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000281', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000282', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000283', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000284', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000285', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000286', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000287', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000288', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000289', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000290', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000291', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000292', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000293', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000294', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000295', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000296', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000297', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000298', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000299', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000300', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000301', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000302', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000303', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000304', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000305', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000306', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000307', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000308', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000309', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000310', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000311', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000312', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000313', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000314', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000315', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000316', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000317', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000318', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000319', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000320', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000321', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000322', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000323', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000324', null, '0', '0', null, null, null, null, '0', '0', '4000658', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000325', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000326', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000327', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000328', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000329', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000330', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000331', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000332', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000333', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000334', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000335', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000336', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000337', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000338', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000339', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000340', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000341', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000342', null, '0', '0', null, null, null, null, '0', '0', '4000655', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000343', null, '0', '0', null, null, null, null, '0', '0', '4000656', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000344', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000345', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000346', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000347', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000348', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000349', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000350', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000351', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000352', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000353', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000354', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000355', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000356', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000357', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000358', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000359', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000360', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000361', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000362', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000363', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000364', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000365', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000366', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000367', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000368', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000369', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000370', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000371', null, '0', '0', null, null, null, null, '0', '0', '3210902', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6000372', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500001', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500002', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500003', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500004', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500005', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500006', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500007', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500008', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500009', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500010', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500011', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500012', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500013', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500014', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500015', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500016', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500017', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500018', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500019', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500020', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500021', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500022', null, '0', '0', null, null, null, null, '0', '0', '1500032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500023', null, '0', '0', null, null, null, null, '0', '0', '3105610', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500024', null, '0', '0', null, null, null, null, '0', '0', '3100114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500025', null, '0', '0', null, null, null, null, '0', '0', '3101113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500026', null, '0', '0', null, null, null, null, '0', '0', '3101115', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500027', null, '0', '0', null, null, null, null, '0', '0', '3101113', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500028', null, '0', '0', null, null, null, null, '0', '0', '3101114', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500029', null, '0', '0', null, null, null, null, '0', '0', '3102217', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500030', null, '0', '0', null, null, null, null, '0', '0', '3101712', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500031', null, '0', '0', null, null, null, null, '0', '0', '3102506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500032', null, '0', '0', null, null, null, null, '0', '0', '3103502', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500033', null, '0', '0', null, null, null, null, '0', '0', '3200708', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500034', null, '0', '0', null, null, null, null, '0', '0', '3202206', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500035', null, '0', '0', null, null, null, null, '0', '0', '3200205', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500036', null, '0', '0', null, null, null, null, '0', '0', '3204316', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500037', null, '0', '0', null, null, null, null, '0', '0', '3201906', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500038', null, '0', '0', null, null, null, null, '0', '0', '3201706', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500039', null, '0', '0', null, null, null, null, '0', '0', '3200406', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500040', null, '0', '0', null, null, null, null, '0', '0', '3204508', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500041', null, '0', '0', null, null, null, null, '0', '0', '3207007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500042', null, '0', '0', null, null, null, null, '0', '0', '3207008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500043', null, '0', '0', null, null, null, null, '0', '0', '3203105', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500044', null, '0', '0', null, null, null, null, '0', '0', '3209904', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500045', null, '0', '0', null, null, null, null, '0', '0', '3106608', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500046', null, '0', '0', null, null, null, null, '0', '0', '3106622', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500047', null, '0', '0', null, null, null, null, '0', '0', '3106627', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6500048', null, '0', '0', null, null, null, null, '0', '0', '3106616', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800001', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800002', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800003', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800004', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800005', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800006', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800007', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800008', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800009', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800010', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800011', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800012', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800013', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800014', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800015', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800016', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800017', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800018', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800019', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800020', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800021', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800022', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800023', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800024', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800025', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800026', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800027', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800028', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800029', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800030', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800031', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800032', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800033', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800034', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6800035', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900001', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900002', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900003', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900004', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900005', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900006', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900007', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900008', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900009', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900010', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900011', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900012', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900013', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900014', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900015', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900016', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900017', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900018', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900019', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900020', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900021', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900022', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900023', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900024', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900025', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900026', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900027', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900028', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900029', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900030', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900031', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900032', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900033', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900034', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900035', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900036', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900037', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900038', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900039', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900040', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900041', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900042', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900043', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900044', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900045', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900046', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900047', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900048', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900049', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900050', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900051', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900052', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900053', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900054', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900055', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900056', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900057', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900058', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900059', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900060', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900061', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900062', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900063', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900064', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900065', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900066', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900067', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900068', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900069', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900070', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900071', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900072', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900073', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900074', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900075', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900076', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900077', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900078', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900079', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900080', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900081', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900082', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900083', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900084', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900085', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900086', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900087', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900088', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900089', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900090', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900091', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900092', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900093', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900094', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900095', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900096', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900097', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900098', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900099', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900100', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900101', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900103', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900104', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900105', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900106', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900107', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900108', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900109', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900110', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900111', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900112', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900113', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900114', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900115', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900116', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900117', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900118', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900119', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('6900120', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9000001', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9000002', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9020001', null, '0', '0', null, null, null, null, '0', '0', '3102009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9020002', null, '0', '0', null, null, null, null, '0', '0', '3100719', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9020003', null, '0', '0', null, null, null, null, '0', '0', '3102506', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111101', null, '0', '0', null, null, null, null, '0', '0', '1000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111102', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111103', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111104', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111201', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111202', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111204', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111206', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111207', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111208', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111209', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111210', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111211', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111212', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111213', null, '0', '0', null, null, null, null, '0', '0', '3000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111214', null, '0', '0', null, null, null, null, '0', '0', '3000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111215', null, '0', '0', null, null, null, null, '0', '0', '3000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111216', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111217', null, '0', '0', null, null, null, null, '0', '0', '3000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111218', null, '0', '0', null, null, null, null, '0', '0', '3000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111219', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111220', null, '0', '0', null, null, null, null, '0', '0', '3000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111221', null, '0', '0', null, null, null, null, '0', '0', '3000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111222', null, '0', '0', null, null, null, null, '0', '0', '3000005', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111223', null, '0', '0', null, null, null, null, '0', '0', '3000006', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111224', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111225', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111226', null, '0', '0', null, null, null, null, '0', '0', '3000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111227', null, '0', '0', null, null, null, null, '0', '0', '3000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111228', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111229', null, '0', '0', null, null, null, null, '0', '0', '3000007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111230', null, '0', '0', null, null, null, null, '0', '0', '3000008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111231', null, '0', '0', null, null, null, null, '0', '0', '3000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111232', null, '0', '0', null, null, null, null, '0', '0', '3000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111233', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111234', null, '0', '0', null, null, null, null, '0', '0', '3000007', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111235', null, '0', '0', null, null, null, null, '0', '0', '3000008', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111236', null, '0', '0', null, null, null, null, '0', '0', '3000010', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111237', null, '0', '0', null, null, null, null, '0', '0', '3000009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111238', null, '0', '0', null, null, null, null, '0', '0', '3000011', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111239', null, '0', '0', null, null, null, null, '0', '0', '3000039', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111240', null, '0', '0', null, null, null, null, '0', '0', '3000012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111241', null, '0', '0', null, null, null, null, '0', '0', '3000030', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111242', null, '0', '0', null, null, null, null, '0', '0', '3000042', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111243', null, '0', '0', null, null, null, null, '0', '0', '3000028', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111244', null, '0', '0', null, null, null, null, '0', '0', '3000029', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111245', null, '0', '0', null, null, null, null, '0', '0', '3000031', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111246', null, '0', '0', null, null, null, null, '0', '0', '3000032', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111247', null, '0', '0', null, null, null, null, '0', '0', '3000033', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111248', null, '0', '0', null, null, null, null, '0', '0', '3000034', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111249', null, '0', '0', null, null, null, null, '0', '0', '3000035', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111250', null, '0', '0', null, null, null, null, '0', '0', '3000036', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111251', null, '0', '0', null, null, null, null, '0', '0', '3000037', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111252', null, '0', '0', null, null, null, null, '0', '0', '3000038', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111253', null, '0', '0', null, null, null, null, '0', '0', '3000015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111254', null, '0', '0', null, null, null, null, '0', '0', '3000016', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111255', null, '0', '0', null, null, null, null, '0', '0', '3000017', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111256', null, '0', '0', null, null, null, null, '0', '0', '3000041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111257', null, '0', '0', null, null, null, null, '0', '0', '3000019', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111258', null, '0', '0', null, null, null, null, '0', '0', '3000040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111259', null, '0', '0', null, null, null, null, '0', '0', '3000021', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111260', null, '0', '0', null, null, null, null, '0', '0', '3000022', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111261', null, '0', '0', null, null, null, null, '0', '0', '3000023', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111262', null, '0', '0', null, null, null, null, '0', '0', '3000024', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111263', null, '0', '0', null, null, null, null, '0', '0', '3000040', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111264', null, '0', '0', null, null, null, null, '0', '0', '3000041', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111265', null, '0', '0', null, null, null, null, '0', '0', '3000027', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111270', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111271', null, '0', '0', null, null, null, null, '0', '0', '2000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111272', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111275', null, '0', '0', null, null, null, null, '0', '0', '3000044', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111276', null, '0', '0', null, null, null, null, '0', '0', '3000043', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111280', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111301', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111303', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9111304', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9112101', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9112102', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9112103', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9112104', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9113102', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9113202', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9113203', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9113204', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114401', null, '0', '0', null, null, null, null, '0', '0', '1000015', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114402', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114403', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114404', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114405', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114406', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114407', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114408', null, '0', '0', null, null, null, null, '0', '0', '1000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114409', null, '0', '0', null, null, null, null, '0', '0', '2000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114410', null, '0', '0', null, null, null, null, '0', '0', '1900001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114411', null, '0', '0', null, null, null, null, '0', '0', '1200001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114412', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114413', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114414', null, '0', '0', null, null, null, null, '0', '0', '1300001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114415', null, '0', '0', null, null, null, null, '0', '0', '1600098', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114416', null, '0', '0', null, null, null, null, '0', '0', '1400001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114417', null, '0', '0', null, null, null, null, '0', '0', '1100001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114418', null, '0', '0', null, null, null, null, '0', '0', '1500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114419', null, '0', '0', null, null, null, null, '0', '0', '1000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114420', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114421', null, '0', '0', null, null, null, null, '0', '0', '2000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114422', null, '0', '0', null, null, null, null, '0', '0', '1000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114423', null, '0', '0', null, null, null, null, '0', '0', '1000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114424', null, '0', '0', null, null, null, null, '0', '0', '1000001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114425', null, '0', '0', null, null, null, null, '0', '0', '1000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114426', null, '0', '0', null, null, null, null, '0', '0', '3000045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114427', null, '0', '0', null, null, null, null, '0', '0', '1000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114428', null, '0', '0', null, null, null, null, '0', '0', '1000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114429', null, '0', '0', null, null, null, null, '0', '0', '1000004', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114430', null, '0', '0', null, null, null, null, '0', '0', '1000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114431', null, '0', '0', null, null, null, null, '0', '0', '1500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114432', null, '0', '0', null, null, null, null, '0', '0', '3000045', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114433', null, '0', '0', null, null, null, null, '0', '0', '1500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114434', null, '0', '0', null, null, null, null, '0', '0', '1500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114435', null, '0', '0', null, null, null, null, '0', '0', '1500001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114436', null, '0', '0', null, null, null, null, '0', '0', '1900001', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114437', null, '0', '0', null, null, null, null, '0', '0', '1000002', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114438', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114439', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114440', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114441', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114442', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114443', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114444', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114445', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114446', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114447', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114448', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114449', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114450', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114451', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114452', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114453', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114454', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114455', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114456', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114457', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114458', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114459', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114460', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114461', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114462', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114463', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114464', null, '0', '0', null, null, null, null, '0', '0', '1000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114465', null, '0', '0', null, null, null, null, '0', '0', '1400012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9114466', null, '0', '0', null, null, null, null, '0', '0', '1400012', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115401', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115402', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115403', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115404', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115405', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115406', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115407', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115408', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115409', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115410', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115411', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115412', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115413', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115414', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115415', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115416', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115417', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115418', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115419', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115420', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115421', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115422', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9115423', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9116400', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9116401', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117001', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117101', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117102', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117103', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117104', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117105', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117106', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117107', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117108', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117109', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117110', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117111', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117112', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117113', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9117114', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220101', null, '0', '0', null, null, null, null, '0', '0', '3000003', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220102', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220103', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220104', null, '0', '0', null, null, null, null, '0', '0', '3102009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220105', null, '0', '0', null, null, null, null, '0', '0', '1900126', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220201', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220202', null, '0', '0', null, null, null, null, '0', '0', '3102009', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220203', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220204', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220205', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220206', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220207', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220208', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220209', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220210', null, '0', '0', null, null, null, null, '0', '0', '3100101', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220301', null, '0', '0', null, null, null, null, '0', '0', '1', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220401', null, '0', '0', null, null, null, null, '0', '0', '0', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220402', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220403', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220404', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220405', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220406', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220407', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_actor_class` VALUES ('9220408', null, '0', '0', null, null, null, null, '0', '0', '2', null, '', null);
INSERT INTO `gamedata_items` VALUES ('0', '[en]', 'Normal/DummyItem', '1', '0', '0', '0', '0', '60000', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1', '[en]', 'Normal/DummyItem', '1', '0', '0', '0', '0', '60000', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000001', 'Gil', 'Money/MoneyStandard', '999999999', '0', '0', '0', '0', '60737', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000002', 'Crystal', 'Money/MoneyStandard', '999', '0', '0', '0', '0', '60000', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000003', 'Fire Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60001', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000004', 'Ice Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60003', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000005', 'Wind Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60004', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000006', 'Earth Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60006', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000007', 'Lightning Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60005', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000008', 'Water Shard', 'Money/MoneyStandard', '9999', '0', '0', '0', '8', '60002', '1006', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000009', 'Fire Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60007', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000010', 'Ice Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60009', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000011', 'Wind Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60010', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000012', 'Earth Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60012', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000013', 'Lightning Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60011', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000014', 'Water Crystal', 'Money/MoneyStandard', '9999', '0', '0', '0', '38', '60008', '1006', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000015', 'Fire Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60013', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000016', 'Ice Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60015', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000017', 'Wind Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60016', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000018', 'Earth Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60018', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000019', 'Lightning Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60017', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000020', 'Water Cluster', 'Money/MoneyStandard', '9999', '0', '0', '0', '168', '60014', '1006', '1', '0', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000101', 'Pugilists\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000102', 'Gladiators\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000103', 'Marauders\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000104', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000105', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000106', 'Archers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000107', 'Lancers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000108', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000109', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000110', 'Thaumaturges\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000111', 'Conjurers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000112', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000113', 'Carpenters\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000114', 'Blacksmiths\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000115', 'Armorers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000116', 'Goldsmiths\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000117', 'Leatherworkers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000118', 'Weavers\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000119', 'Alchemists\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000120', 'Culinarians\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000121', 'Miners\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000122', 'Botanists\' Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000123', 'Fishermen\'s Guild Mark', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000124', '[en]', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '60745', '0', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000201', 'Storm Seal', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '61603', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000202', 'Serpent Seal', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '61602', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('1000203', 'Flame Seal', 'Money/MoneyStandard', '999999', '0', '0', '0', '0', '61601', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000001', 'Key', 'Important/ImportantItemStandard', '1', '0', '1', '0', '0', '60000', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000002', 'Pendant', 'Important/ImportantItemStandard', '1', '1', '0', '0', '0', '60000', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000101', 'Spinning Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000102', 'Tailoring Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000103', 'Glovemaking Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000104', 'Hatting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000105', 'Dyeing Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000106', 'Weaving Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000107', 'Sheeting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000108', 'Nailcasting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000109', 'Smelting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000110', 'Cobbling Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000111', 'Tawing Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000112', 'Tanning Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000113', 'Gemcutting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000114', 'Bonecarving Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000115', 'Bowyering Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000116', 'Fletchery Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000117', 'Breadbaking Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000118', 'Milling Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000119', 'Confectionery Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000120', 'Painting Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000121', 'Inlaying Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000122', 'Fishcleaning Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000123', 'Chainweaving Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000124', 'Woodlaying Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000125', 'Poisoning Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000126', 'Physicking Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000127', 'Chemicking Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000128', 'Tacklecraft Training', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60746', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000201', 'Soul of the Paladin', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61680', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000202', 'Soul of the Monk', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61681', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000203', 'Soul of the Warrior', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61682', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000204', 'Soul of the Dragoon', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61683', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000205', 'Soul of the Bard', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61684', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000206', 'Soul of the White Mage', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61685', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2000207', 'Soul of the Black Mage', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '61686', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001000', '[en]', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '60000', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001001', 'Materia Assimilator', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001002', 'Materia Melder', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001003', 'Augmented Materia Melder', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001004', 'Storm Chocobo Issuance', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001005', 'Serpent Chocobo Issuance', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001006', 'Flame Chocobo Issuance', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001007', 'Chocobo Whistle', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001008', 'Airship Ticket', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001009', 'Lapis Cross', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001010', 'Emerald Leaf', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001011', 'Gold Scales', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001012', '[en]', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001013', 'Goobbue Horn', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001014', 'Lominsan Aetherpass', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001015', 'Gridanian Aetherpass', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001016', 'Ul\'dahn Aetherpass', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001017', 'Lominsan Half Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001018', 'Lominsan Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001019', 'Lominsan Crested Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001020', 'Gridanian Half Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001021', 'Gridanian Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001022', 'Gridanian Crested Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001023', 'Ul\'dahn Half Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001024', 'Ul\'dahn Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001025', 'Ul\'dahn Crested Barding', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001026', 'On the Properties of Beastmen', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001027', 'Soiled Promissory Note', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001028', 'Aquamarine Cross', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001029', 'Emerald Bough', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('2001030', 'Platinum Scales', 'Important/ImportantItemStandard', '1', '1', '1', '0', '0', '798', '1003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010001', 'Meat Miq\'abob', 'Normal/FoodItem', '99', '0', '0', '0', '60', '60529', '2012', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010002', 'Aldgoat Steak', 'Normal/FoodItem', '99', '0', '0', '0', '97', '60530', '2012', '1', '1', '0', '0', '0', '25', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010003', 'Boiled Egg', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60614', '2016', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010004', 'Dodo Omelette', 'Normal/FoodItem', '99', '0', '0', '0', '45', '60560', '2016', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010005', 'Cottage Cheese', 'Normal/FoodItem', '99', '0', '0', '0', '64', '60567', '2025', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010006', 'Marmot Steak', 'Normal/FoodItem', '99', '0', '0', '0', '30', '60536', '2012', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010007', 'Rabbit Pie', 'Normal/FoodItem', '99', '0', '0', '0', '56', '60533', '2012', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010008', 'Jerked Beef', 'Normal/FoodItem', '99', '0', '0', '0', '134', '60531', '2012', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010009', 'Grilled Dodo', 'Normal/FoodItem', '99', '0', '0', '0', '45', '60530', '2012', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010010', 'Shepherd\'s Pie', 'Normal/FoodItem', '99', '0', '0', '0', '82', '60573', '2012', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010011', 'Smoked Raptor', 'Normal/FoodItem', '99', '0', '0', '0', '118', '60576', '2012', '1', '1', '0', '0', '0', '36', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010012', 'Deviled Eggs', 'Normal/FoodItem', '99', '0', '0', '0', '156', '60514', '2016', '1', '1', '0', '0', '0', '48', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010013', 'Roast Dodo', 'Normal/FoodItem', '99', '0', '0', '0', '93', '61460', '2012', '1', '1', '0', '0', '0', '24', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010014', 'Mole Loaf', 'Normal/FoodItem', '99', '0', '0', '0', '48', '60537', '2012', '1', '1', '0', '0', '0', '12', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010015', 'Blue Cheese', 'Normal/FoodItem', '99', '0', '0', '0', '63', '60566', '2025', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010016', 'Mustard Eggs', 'Normal/FoodItem', '99', '0', '0', '0', '86', '60561', '2016', '1', '1', '0', '0', '0', '22', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010017', 'Eft Steak', 'Normal/FoodItem', '99', '0', '0', '0', '172', '60530', '2012', '1', '1', '0', '0', '0', '53', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010018', 'Cream Cheese', 'Normal/FoodItem', '99', '0', '0', '0', '121', '61699', '2025', '1', '1', '0', '0', '0', '37', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010019', 'Rolanberry Cheese', 'Normal/FoodItem', '99', '0', '0', '0', '140', '61700', '2025', '1', '1', '0', '0', '0', '43', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010020', 'Apkallu Omelette', 'Normal/FoodItem', '99', '0', '0', '0', '169', '60560', '2016', '1', '1', '0', '0', '0', '52', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010021', 'Scrambled Eggs', 'Normal/FoodItem', '99', '0', '0', '0', '105', '61702', '2016', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010022', 'Fried Egg', 'Normal/FoodItem', '99', '0', '0', '0', '101', '61703', '2016', '1', '1', '0', '0', '0', '26', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010023', 'Trapper\'s Quiche', 'Normal/FoodItem', '99', '0', '0', '0', '124', '60555', '2016', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010024', '[en]', 'Normal/FoodItem', '99', '0', '0', '0', '3', '60000', '2017', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010101', 'Grilled Carp', 'Normal/FoodItem', '99', '0', '0', '0', '18', '60520', '2013', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010102', 'Salt Cod', 'Normal/FoodItem', '99', '0', '0', '0', '18', '61543', '2013', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010103', 'Boiled Crayfish', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60569', '2013', '1', '1', '0', '0', '0', '3', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010104', 'Raw Oyster', 'Normal/FoodItem', '99', '0', '0', '0', '59', '61544', '2013', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010105', 'Grilled Trout', 'Normal/FoodItem', '99', '0', '0', '0', '48', '60519', '2013', '1', '1', '0', '0', '0', '7', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010106', 'Salmon Meuniere', 'Normal/FoodItem', '99', '0', '0', '0', '66', '60522', '2013', '1', '1', '0', '0', '0', '19', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010107', 'Tuna Miq\'abob', 'Normal/FoodItem', '99', '0', '0', '0', '108', '60528', '2013', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010108', 'Eel Pie', 'Normal/FoodItem', '99', '0', '0', '0', '62', '60556', '2013', '1', '1', '0', '0', '0', '18', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010109', 'Salt Cod Puffs', 'Normal/FoodItem', '99', '0', '0', '0', '141', '60572', '2013', '1', '1', '0', '0', '0', '42', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010110', 'Stuffed Cabbage', 'Normal/FoodItem', '99', '0', '0', '0', '151', '60570', '2013', '1', '1', '0', '0', '0', '45', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010111', 'Lava Toad Legs', 'Normal/FoodItem', '99', '0', '0', '0', '171', '61477', '2013', '1', '1', '0', '0', '0', '51', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010112', 'Tree Toad Legs', 'Normal/FoodItem', '99', '0', '0', '0', '42', '61485', '2013', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010113', 'Baked Sole', 'Normal/FoodItem', '99', '0', '0', '0', '95', '61476', '2013', '1', '1', '0', '0', '0', '28', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010114', 'Braised Pipira', 'Normal/FoodItem', '99', '0', '0', '0', '23', '61478', '2013', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010115', 'Boiled Bream', 'Normal/FoodItem', '99', '0', '0', '0', '89', '61479', '2013', '1', '1', '0', '0', '0', '26', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010118', 'Mugwort Carp', 'Normal/FoodItem', '99', '0', '0', '0', '128', '61489', '2013', '1', '1', '0', '0', '0', '38', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010201', 'Flatbread', 'Normal/FoodItem', '99', '0', '0', '0', '13', '60494', '2015', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010202', 'Frumenty', 'Normal/FoodItem', '99', '0', '0', '0', '10', '60496', '2041', '1', '1', '0', '0', '0', '3', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010203', 'Honey Muffin', 'Normal/FoodItem', '99', '0', '0', '0', '56', '60489', '2015', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010204', 'La Noscean Toast', 'Normal/FoodItem', '99', '0', '0', '0', '129', '60554', '2015', '1', '1', '0', '0', '0', '47', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010205', 'Acorn Cookie', 'Normal/FoodItem', '99', '0', '0', '0', '94', '60508', '2015', '1', '1', '0', '0', '0', '34', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010206', 'Dark Pretzel', 'Normal/FoodItem', '99', '0', '0', '0', '62', '60485', '2015', '1', '1', '0', '0', '0', '22', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010207', 'Cornbread', 'Normal/FoodItem', '99', '0', '0', '0', '81', '60491', '2015', '1', '1', '0', '0', '0', '29', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010208', 'Knight\'s Bread', 'Normal/FoodItem', '99', '0', '0', '0', '105', '60486', '2015', '1', '1', '0', '0', '0', '38', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010209', 'Walnut Bread', 'Normal/FoodItem', '99', '0', '0', '0', '48', '60488', '2015', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010210', 'Lentils & Chestnuts', 'Normal/FoodItem', '99', '0', '0', '0', '43', '60503', '2041', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010211', 'Finger Sandwich', 'Normal/FoodItem', '99', '0', '0', '0', '140', '61708', '2015', '1', '1', '0', '0', '0', '51', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010301', 'Spinach Saute', 'Normal/FoodItem', '99', '0', '0', '0', '66', '60506', '2014', '1', '1', '0', '0', '0', '22', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010302', 'Jack-o\'-lantern', 'Normal/FoodItem', '99', '0', '0', '0', '31', '60509', '2014', '1', '1', '0', '0', '0', '10', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010303', 'Landtrap Salad', 'Normal/FoodItem', '99', '0', '0', '0', '143', '60505', '2014', '1', '1', '0', '0', '0', '49', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010304', 'Blood Currant Tart', 'Normal/FoodItem', '99', '0', '0', '0', '91', '60557', '2017', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010305', 'Parsnip Salad', 'Normal/FoodItem', '99', '0', '0', '0', '40', '60512', '2014', '1', '1', '0', '0', '0', '13', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010306', 'Sauerkraut', 'Normal/FoodItem', '99', '0', '0', '0', '103', '60516', '2014', '1', '1', '0', '0', '0', '35', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010307', 'Dzemael Gratin', 'Normal/FoodItem', '99', '0', '0', '0', '128', '61326', '2041', '1', '1', '0', '0', '0', '44', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010308', 'Tomato Pie', 'Normal/FoodItem', '99', '0', '0', '0', '131', '60558', '2014', '1', '1', '0', '0', '0', '45', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010309', 'Roasted Nopales', 'Normal/FoodItem', '99', '0', '0', '0', '48', '61492', '2014', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010310', 'Alligator Salad', 'Normal/FoodItem', '99', '0', '0', '0', '86', '61491', '2014', '1', '1', '0', '0', '0', '29', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010311', 'Stuffed Artichoke', 'Normal/FoodItem', '99', '0', '0', '0', '114', '61494', '2014', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010312', 'Forest Miq\'abob', 'Normal/FoodItem', '99', '0', '0', '0', '88', '60511', '2042', '1', '1', '0', '0', '0', '30', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010313', 'Button Mushroom Saute', 'Normal/FoodItem', '99', '0', '0', '0', '128', '61701', '2042', '1', '1', '0', '0', '0', '44', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010314', 'Raptor Stew', 'Normal/FoodItem', '99', '0', '0', '0', '114', '61704', '2042', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010315', 'Chicken and Mushrooms', 'Normal/FoodItem', '99', '0', '0', '0', '57', '61705', '2042', '1', '1', '0', '0', '0', '19', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010316', 'Chanterelle Saute', 'Normal/FoodItem', '99', '0', '0', '0', '17', '61706', '2042', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010317', 'Buttons in a Blanket', 'Normal/FoodItem', '99', '0', '0', '0', '145', '61707', '2042', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010401', 'Apple Tart', 'Normal/FoodItem', '99', '0', '0', '0', '51', '60550', '2017', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010402', 'Ginger Cookie', 'Normal/FoodItem', '99', '0', '0', '0', '1', '60487', '2017', '1', '1', '0', '0', '0', '24', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010403', 'Dried Prunes', 'Normal/FoodItem', '99', '0', '0', '0', '1', '60654', '2017', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010404', 'Raisins', 'Normal/FoodItem', '99', '0', '0', '0', '18', '60654', '2017', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010405', 'Crumpet', 'Normal/FoodItem', '99', '0', '0', '0', '84', '60492', '2017', '1', '1', '0', '0', '0', '27', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010406', 'Pastry Fish', 'Normal/FoodItem', '99', '0', '0', '0', '144', '60490', '2017', '1', '1', '0', '0', '0', '47', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010407', 'Crowned Cake', 'Normal/FoodItem', '99', '0', '0', '0', '153', '60559', '2017', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010408', 'Princess Pudding', 'Normal/FoodItem', '99', '0', '0', '0', '18', '61462', '2017', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010409', 'Starlight Log', 'Normal/FoodItem', '99', '0', '0', '0', '96', '60552', '2017', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010410', 'Snowflake Peak', 'Normal/FoodItem', '99', '0', '0', '0', '48', '61461', '2017', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010411', 'Ore Fruitcake', 'Normal/FoodItem', '99', '0', '0', '0', '30', '61463', '2017', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010412', 'Bubble Chocolate', 'Normal/FoodItem', '99', '0', '0', '0', '36', '61468', '2017', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010413', 'Pearl Chocolate', 'Normal/FoodItem', '99', '0', '0', '0', '36', '61470', '2017', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010414', 'Heart Chocolate', 'Normal/FoodItem', '99', '0', '0', '0', '45', '61469', '2017', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010415', 'White Chocolate', 'Normal/FoodItem', '99', '0', '0', '0', '45', '61471', '2017', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010416', 'Sweet Rice Cake', 'Normal/FoodItem', '99', '0', '0', '0', '1', '61472', '2017', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010417', 'Pumpkin Cookie', 'Normal/FoodItem', '99', '0', '0', '0', '24', '61673', '2017', '1', '1', '0', '0', '0', '7', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010418', 'Consecrated Chocolate', 'Normal/FoodItem', '99', '0', '0', '0', '33', '61471', '2017', '1', '1', '0', '0', '0', '10', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010419', 'Mizzenmast Biscuit', 'Normal/FoodItem', '99', '0', '0', '0', '15', '60508', '2015', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010420', 'Roost Biscuit', 'Normal/FoodItem', '99', '0', '0', '0', '15', '60508', '2015', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010421', 'Hourglass Biscuit', 'Normal/FoodItem', '99', '0', '0', '0', '15', '60508', '2015', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010501', 'Pea Soup', 'Normal/FoodItem', '99', '0', '0', '0', '82', '60495', '2041', '1', '1', '0', '0', '0', '25', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010502', 'Stone Soup', 'Normal/FoodItem', '99', '0', '0', '0', '76', '60499', '2041', '1', '1', '0', '0', '0', '23', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010503', 'Beef Stew', 'Normal/FoodItem', '99', '0', '0', '0', '170', '60532', '2041', '1', '1', '0', '0', '0', '53', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010504', 'Cawl Cennin', 'Normal/FoodItem', '99', '0', '0', '0', '107', '60501', '2041', '1', '1', '0', '0', '0', '33', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010505', 'Ratatouille', 'Normal/FoodItem', '99', '0', '0', '0', '120', '60510', '2041', '1', '1', '0', '0', '0', '37', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010506', 'Mutton Stew', 'Normal/FoodItem', '99', '0', '0', '0', '32', '60504', '2041', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010507', 'Fish Soup', 'Normal/FoodItem', '99', '0', '0', '0', '139', '60502', '2041', '1', '1', '0', '0', '0', '43', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010508', 'Bouillabaisse', 'Normal/FoodItem', '99', '0', '0', '0', '158', '61325', '2041', '1', '1', '0', '0', '0', '49', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010509', 'Zoni', 'Normal/FoodItem', '99', '0', '0', '0', '32', '61465', '2041', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010510', 'Orobon Stew', 'Normal/FoodItem', '99', '0', '0', '0', '88', '60521', '2041', '1', '1', '0', '0', '0', '27', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010601', 'Distilled Water', 'Normal/FoodItem', '99', '0', '0', '0', '5', '60474', '4026', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010602', 'Sour Red', 'Normal/FoodItem', '99', '0', '0', '0', '38', '61402', '2039', '1', '0', '0', '0', '0', '14', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010603', 'Aldgoat Milk', 'Normal/FoodItem', '99', '0', '0', '0', '36', '60626', '2025', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010604', 'Buffalo Milk', 'Normal/FoodItem', '99', '0', '0', '0', '54', '60626', '2025', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010605', 'Orange Juice', 'Normal/FoodItem', '99', '0', '0', '0', '18', '60540', '2018', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010606', 'Pineapple Juice', 'Normal/FoodItem', '99', '0', '0', '0', '133', '60544', '2018', '1', '1', '0', '0', '0', '51', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010607', 'Apple Juice', 'Normal/FoodItem', '99', '0', '0', '0', '105', '60541', '2018', '1', '1', '0', '0', '0', '40', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010608', 'Mulled Tea', 'Normal/FoodItem', '99', '0', '0', '0', '128', '60547', '2018', '1', '1', '0', '0', '0', '49', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010609', 'Mineral Water', 'Normal/FoodItem', '99', '0', '0', '0', '20', '60474', '2018', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010610', 'Chamomile Tea', 'Normal/FoodItem', '99', '0', '0', '0', '64', '61490', '2018', '1', '1', '0', '0', '0', '24', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010611', 'Grape Juice', 'Normal/FoodItem', '99', '0', '0', '0', '59', '60542', '2018', '1', '1', '0', '0', '0', '22', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3010612', 'Rolanberry Lassi', 'Normal/FoodItem', '99', '0', '0', '0', '120', '60766', '2025', '1', '1', '0', '0', '0', '46', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011001', 'Aldgoat Chuck', 'Normal/FoodItem', '99', '0', '0', '0', '137', '60578', '2024', '1', '1', '0', '0', '0', '25', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011002', 'Buffalo Sirloin', 'Normal/FoodItem', '99', '0', '0', '0', '221', '60578', '2024', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011003', 'Dodo Tenderloin', 'Normal/FoodItem', '99', '0', '0', '0', '84', '60577', '2024', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011004', 'Raptor Shank', 'Normal/FoodItem', '99', '0', '0', '0', '168', '60583', '2024', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011005', 'Mutton Loin', 'Normal/FoodItem', '99', '0', '0', '0', '53', '60579', '2024', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011006', 'Antelope Shank', 'Normal/FoodItem', '99', '0', '0', '0', '116', '61473', '2024', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011007', 'Marmot Meat', 'Normal/FoodItem', '99', '0', '0', '0', '26', '60655', '2024', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011008', 'Chicken Breast', 'Normal/FoodItem', '99', '0', '0', '0', '95', '60577', '2024', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011009', 'Megalocrab Leg', 'Normal/FoodItem', '99', '0', '0', '0', '110', '60582', '2032', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011010', 'Orobon Liver', 'Normal/FoodItem', '99', '0', '0', '0', '110', '60581', '2031', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011011', 'Jellyfish Umbrella', 'Normal/FoodItem', '99', '0', '0', '0', '63', '60580', '2031', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011012', 'Eft Tail', 'Normal/FoodItem', '99', '0', '0', '0', '221', '60581', '2024', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011013', 'Salamander Tail', 'Normal/FoodItem', '99', '0', '0', '0', '84', '60581', '2024', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011014', 'Mole Meat', 'Normal/FoodItem', '99', '0', '0', '0', '58', '60655', '2024', '1', '1', '0', '0', '0', '10', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011015', 'Chicken Egg', 'Normal/FoodItem', '99', '0', '0', '0', '11', '60596', '2034', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011016', 'Apkallu Egg', 'Normal/FoodItem', '99', '0', '0', '0', '221', '60586', '2034', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011017', 'Dodo Egg', 'Normal/FoodItem', '99', '0', '0', '0', '63', '60586', '2034', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011018', 'Young Dodo Roaster', 'Normal/FoodItem', '99', '0', '0', '0', '89', '61560', '2024', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011019', 'Pudding Flesh', 'Normal/FoodItem', '99', '0', '0', '0', '221', '61266', '2024', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011020', 'Puk Egg', 'Normal/FoodItem', '99', '0', '0', '0', '137', '60586', '2034', '1', '1', '0', '0', '0', '25', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011101', 'Black Eel', 'Normal/FoodItem', '99', '0', '0', '0', '77', '60663', '2032', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011102', 'Dark Bass', 'Normal/FoodItem', '99', '0', '0', '0', '91', '60664', '2032', '1', '1', '0', '0', '0', '18', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011103', 'Crayfish', 'Normal/FoodItem', '99', '0', '0', '0', '10', '60666', '2032', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011104', 'Crimson Crayfish', 'Normal/FoodItem', '99', '0', '0', '0', '19', '60665', '2032', '1', '1', '0', '0', '0', '3', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011105', 'Bone Crayfish', 'Normal/FoodItem', '99', '0', '0', '0', '19', '60667', '2032', '1', '1', '0', '0', '0', '3', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011106', 'Maiden Carp', 'Normal/FoodItem', '99', '0', '0', '0', '14', '60668', '2032', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011107', 'Velodyna Carp', 'Normal/FoodItem', '99', '0', '0', '0', '182', '60669', '2032', '1', '1', '0', '0', '0', '37', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011108', 'Pipira', 'Normal/FoodItem', '99', '0', '0', '0', '34', '60670', '2032', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011109', 'Black Ghost', 'Normal/FoodItem', '99', '0', '0', '0', '115', '60671', '2032', '1', '1', '0', '0', '0', '23', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011110', 'Brass Loach', 'Normal/FoodItem', '99', '0', '0', '0', '43', '60675', '2032', '1', '1', '0', '0', '0', '8', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011111', 'Ala Mhigan Fighting Fish', 'Normal/FoodItem', '99', '0', '0', '0', '62', '60676', '2032', '1', '1', '0', '0', '0', '12', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011112', 'Rainbow Trout', 'Normal/FoodItem', '99', '0', '0', '0', '29', '60662', '2032', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011113', 'Yugr\'am Salmon', 'Normal/FoodItem', '99', '0', '0', '0', '82', '60661', '2032', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011114', 'Blindfish', 'Normal/FoodItem', '99', '0', '0', '0', '154', '60672', '2032', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011115', 'Striped Goby', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60723', '2032', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011116', 'Sandfish', 'Normal/FoodItem', '99', '0', '0', '0', '91', '60729', '2032', '1', '1', '0', '0', '0', '18', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011117', 'Lamp Marimo', 'Normal/FoodItem', '99', '0', '0', '0', '154', '60673', '4026', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011118', 'Monke Onke', 'Normal/FoodItem', '99', '0', '0', '0', '163', '60678', '2032', '1', '1', '0', '0', '0', '33', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011119', 'Alligator Garfish', 'Normal/FoodItem', '99', '0', '0', '0', '278', '60679', '2032', '1', '1', '0', '0', '0', '57', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011120', 'Northern Pike', 'Normal/FoodItem', '99', '0', '0', '0', '211', '60680', '2032', '1', '1', '0', '0', '0', '43', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011121', 'Southern Pike', 'Normal/FoodItem', '99', '0', '0', '0', '192', '60681', '2032', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011122', 'Giant Donko', 'Normal/FoodItem', '99', '0', '0', '0', '360', '60682', '2032', '1', '1', '0', '0', '0', '74', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011123', 'Lava Toad', 'Normal/FoodItem', '99', '0', '0', '0', '202', '60683', '2032', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011124', 'Pirarucu', 'Normal/FoodItem', '99', '0', '0', '0', '432', '60684', '2032', '1', '1', '0', '0', '0', '89', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011125', 'Emperor Fish', 'Normal/FoodItem', '99', '0', '0', '0', '465', '60685', '2032', '1', '1', '0', '0', '0', '96', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011126', 'Takitaro', 'Normal/FoodItem', '99', '0', '0', '0', '403', '60686', '2032', '1', '1', '0', '0', '0', '83', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011127', 'Cave Cherax', 'Normal/FoodItem', '99', '0', '0', '0', '254', '60687', '2032', '1', '1', '0', '0', '0', '52', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011128', 'River Crab', 'Normal/FoodItem', '99', '0', '0', '0', '101', '60730', '2032', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011129', 'Helmet Crab', 'Normal/FoodItem', '99', '0', '0', '0', '82', '60717', '2031', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011130', 'King Crab', 'Normal/FoodItem', '99', '0', '0', '0', '9', '60717', '2032', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011131', 'Tricorn', 'Normal/FoodItem', '99', '0', '0', '0', '374', '60725', '2032', '1', '1', '0', '0', '0', '77', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011132', 'Tree Toad', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60726', '2032', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011133', 'Dart Frog', 'Normal/FoodItem', '99', '0', '0', '0', '202', '60719', '2032', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011134', 'Nether Newt', 'Normal/FoodItem', '99', '0', '0', '0', '134', '60720', '2032', '1', '1', '0', '0', '0', '27', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011135', 'Allagan Snail', 'Normal/FoodItem', '99', '0', '0', '0', '10', '60588', '2032', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011136', 'Box Turtle', 'Normal/FoodItem', '99', '0', '0', '0', '86', '60724', '2032', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011137', 'Giant Catfish', 'Normal/FoodItem', '99', '0', '0', '0', '331', '60677', '2032', '1', '1', '0', '0', '0', '68', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011201', 'Saber Sardine', 'Normal/FoodItem', '99', '0', '0', '0', '202', '60689', '2031', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011202', 'Ocean Cloud', 'Normal/FoodItem', '99', '0', '0', '0', '34', '60690', '2031', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011203', 'Nautilus', 'Normal/FoodItem', '99', '0', '0', '0', '130', '60691', '2031', '1', '1', '0', '0', '0', '26', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011204', 'Silver Shark', 'Normal/FoodItem', '99', '0', '0', '0', '178', '60696', '2031', '1', '1', '0', '0', '0', '36', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011205', 'Tiger Cod', 'Normal/FoodItem', '99', '0', '0', '0', '14', '60697', '2031', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011206', 'Rock Lobster', 'Normal/FoodItem', '99', '0', '0', '0', '274', '60698', '2031', '1', '1', '0', '0', '0', '56', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011207', 'Black Sole', 'Normal/FoodItem', '99', '0', '0', '0', '139', '60699', '2031', '1', '1', '0', '0', '0', '28', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011208', 'Coral Butterfly', 'Normal/FoodItem', '99', '0', '0', '0', '58', '60701', '2031', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011209', 'Bianaq Bream', 'Normal/FoodItem', '99', '0', '0', '0', '106', '60694', '2031', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011210', 'Merlthor Goby', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60674', '2031', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011211', 'Indigo Herring', 'Normal/FoodItem', '99', '0', '0', '0', '154', '60695', '2031', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011212', 'Blowfish', 'Normal/FoodItem', '99', '0', '0', '0', '178', '60692', '2031', '1', '1', '0', '0', '0', '36', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011213', 'Rothlyt Oyster', 'Normal/FoodItem', '99', '0', '0', '0', '86', '60700', '2031', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011214', 'Finger Shrimp', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60693', '2031', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011215', 'Cieldalaes Clam', 'Normal/FoodItem', '99', '0', '0', '0', '9', '60716', '2031', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011216', 'Malm Kelp', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60688', '2022', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011217', 'Ash Tuna', 'Normal/FoodItem', '99', '0', '0', '0', '154', '60703', '2031', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011218', 'Dinichthys', 'Normal/FoodItem', '99', '0', '0', '0', '370', '60704', '2031', '1', '1', '0', '0', '0', '76', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011219', 'Titanic Sawfish', 'Normal/FoodItem', '99', '0', '0', '0', '456', '60705', '2031', '1', '1', '0', '0', '0', '94', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011220', 'Sunfish', 'Normal/FoodItem', '99', '0', '0', '0', '355', '60706', '2031', '1', '1', '0', '0', '0', '73', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011221', 'Mazlaya Marlin', 'Normal/FoodItem', '99', '0', '0', '0', '336', '60707', '2031', '1', '1', '0', '0', '0', '69', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011222', 'Gigant Octopus', 'Normal/FoodItem', '99', '0', '0', '0', '307', '60708', '2031', '1', '1', '0', '0', '0', '63', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011223', 'Megalodon', 'Normal/FoodItem', '99', '0', '0', '0', '408', '60709', '2031', '1', '1', '0', '0', '0', '84', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011224', 'Wahoo', 'Normal/FoodItem', '99', '0', '0', '0', '211', '60710', '2031', '1', '1', '0', '0', '0', '43', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011225', 'Hammerhead Shark', 'Normal/FoodItem', '99', '0', '0', '0', '158', '60711', '2031', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011226', 'Giant Squid', 'Normal/FoodItem', '99', '0', '0', '0', '254', '60712', '2031', '1', '1', '0', '0', '0', '52', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011227', 'Haraldr Haddock', 'Normal/FoodItem', '99', '0', '0', '0', '192', '60702', '2031', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011228', 'Sea Cucumber', 'Normal/FoodItem', '99', '0', '0', '0', '67', '60713', '2031', '1', '1', '0', '0', '0', '13', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011229', 'Sea Pickle', 'Normal/FoodItem', '99', '0', '0', '0', '120', '60714', '2031', '1', '1', '0', '0', '0', '24', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011230', 'Razor Clam', 'Normal/FoodItem', '99', '0', '0', '0', '77', '60715', '2031', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011231', 'Vongola Clam', 'Normal/FoodItem', '99', '0', '0', '0', '48', '60716', '2031', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011301', 'Cieldalaes Spinach', 'Normal/FoodItem', '99', '0', '0', '0', '34', '60612', '2022', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011302', 'Ogre Pumpkin', 'Normal/FoodItem', '99', '0', '0', '0', '23', '60627', '2022', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011303', 'Alpine Parsnip', 'Normal/FoodItem', '99', '0', '0', '0', '27', '60649', '2022', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011304', 'Salt Leek', 'Normal/FoodItem', '99', '0', '0', '0', '74', '60658', '2022', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011305', 'Midland Cabbage', 'Normal/FoodItem', '99', '0', '0', '0', '59', '60623', '2022', '1', '1', '0', '0', '0', '25', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011306', 'Wizard Eggplant', 'Normal/FoodItem', '99', '0', '0', '0', '56', '60609', '2022', '1', '1', '0', '0', '0', '24', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011307', 'Popoto', 'Normal/FoodItem', '99', '0', '0', '0', '41', '60601', '2022', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011308', 'Wild Onion', 'Normal/FoodItem', '99', '0', '0', '0', '11', '60599', '2022', '1', '1', '0', '0', '0', '4', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011309', 'Coerthas Carrot', 'Normal/FoodItem', '99', '0', '0', '0', '23', '60613', '2022', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011310', 'Ruby Tomato', 'Normal/FoodItem', '99', '0', '0', '0', '36', '60624', '2022', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011311', 'La Noscean Lettuce', 'Normal/FoodItem', '99', '0', '0', '0', '29', '61359', '2022', '1', '1', '0', '0', '0', '12', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011312', 'Highland Parsley', 'Normal/FoodItem', '99', '0', '0', '0', '25', '60637', '2022', '1', '1', '0', '0', '0', '10', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011313', 'Ramhorn Zucchini', 'Normal/FoodItem', '99', '0', '0', '0', '32', '60643', '2022', '1', '1', '0', '0', '0', '13', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011314', 'Paprika', 'Normal/FoodItem', '99', '0', '0', '0', '36', '60644', '2026', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011315', 'Pimiento', 'Normal/FoodItem', '99', '0', '0', '0', '5', '60644', '2026', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011316', 'Maiden Artichoke', 'Normal/FoodItem', '99', '0', '0', '0', '72', '61360', '2022', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011317', 'Gysahl Greens', 'Normal/FoodItem', '99', '0', '0', '0', '47', '60741', '2022', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011318', 'Aloe', 'Normal/FoodItem', '99', '0', '0', '0', '50', '60645', '2022', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011319', 'Nopales', 'Normal/FoodItem', '99', '0', '0', '0', '41', '60646', '2022', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011401', 'Iron Acorn', 'Normal/FoodItem', '99', '0', '0', '0', '79', '60606', '2023', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011402', 'Gridanian Chestnut', 'Normal/FoodItem', '99', '0', '0', '0', '24', '60592', '2023', '1', '1', '0', '0', '0', '9', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011403', 'Gridanian Walnut', 'Normal/FoodItem', '99', '0', '0', '0', '14', '60591', '2023', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011404', 'Cinderfoot Olive', 'Normal/FoodItem', '99', '0', '0', '0', '29', '60620', '2023', '1', '1', '0', '0', '0', '11', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011405', 'Sunflower Seeds', 'Normal/FoodItem', '99', '0', '0', '0', '10', '60640', '2021', '1', '1', '0', '0', '0', '3', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011406', 'Button Mushroom', 'Normal/FoodItem', '99', '0', '0', '0', '55', '60621', '2035', '1', '1', '0', '0', '0', '22', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011407', 'Shriekshroom', 'Normal/FoodItem', '99', '0', '0', '0', '17', '61448', '2035', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011408', 'Black Truffle', 'Normal/FoodItem', '99', '0', '0', '0', '122', '60647', '2035', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011409', 'White Truffle', 'Normal/FoodItem', '99', '0', '0', '0', '77', '60648', '2035', '1', '1', '0', '0', '0', '31', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011410', 'Gil Bun', 'Normal/FoodItem', '99', '0', '0', '0', '38', '61405', '2035', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011411', 'Chanterelle', 'Normal/FoodItem', '99', '0', '0', '0', '14', '60594', '2035', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011412', 'Buffalo Beans', 'Normal/FoodItem', '99', '0', '0', '0', '31', '60617', '2021', '1', '1', '0', '0', '0', '12', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011413', 'Jade Peas', 'Normal/FoodItem', '99', '0', '0', '0', '58', '60617', '2021', '1', '1', '0', '0', '0', '23', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011414', 'Lalafellin Lentil', 'Normal/FoodItem', '99', '0', '0', '0', '26', '61339', '2021', '1', '1', '0', '0', '0', '10', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011415', 'Millioncorn', 'Normal/FoodItem', '99', '0', '0', '0', '38', '60602', '2021', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011416', 'Kukuru Bean', 'Normal/FoodItem', '99', '0', '0', '0', '19', '61467', '2023', '1', '1', '0', '0', '0', '7', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011417', 'Sticky Rice', 'Normal/FoodItem', '99', '0', '0', '0', '36', '61497', '2021', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011418', 'Ratstool', 'Normal/FoodItem', '99', '0', '0', '0', '84', '61449', '2035', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011419', 'Dalamud Nut', 'Normal/FoodItem', '99', '0', '0', '0', '3', '61619', '2023', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011420', 'Moon Nut', 'Normal/FoodItem', '99', '0', '0', '0', '5', '61618', '2023', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011451', 'La Noscean Orange', 'Normal/FoodItem', '99', '0', '0', '0', '14', '61334', '2023', '1', '1', '0', '0', '0', '5', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011452', 'Lowland Grapes', 'Normal/FoodItem', '99', '0', '0', '0', '7', '60630', '2023', '1', '1', '0', '0', '0', '2', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011453', 'Pixie Plums', 'Normal/FoodItem', '99', '0', '0', '0', '41', '60659', '2023', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011454', 'Prickly Pineapple', 'Normal/FoodItem', '99', '0', '0', '0', '101', '60598', '2023', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011455', 'Faerie Apple', 'Normal/FoodItem', '99', '0', '0', '0', '36', '60622', '2023', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011456', 'Sun Lemon', 'Normal/FoodItem', '99', '0', '0', '0', '43', '60610', '2023', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011457', 'Blood Currants', 'Normal/FoodItem', '99', '0', '0', '0', '53', '60657', '2023', '1', '1', '0', '0', '0', '21', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011458', 'Rolanberry', 'Normal/FoodItem', '99', '0', '0', '0', '101', '60618', '2023', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011459', 'Alligator Pear', 'Normal/FoodItem', '99', '0', '0', '0', '70', '61370', '2023', '1', '1', '0', '0', '0', '28', '1001', '1', '0', '0', '1800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011501', 'Pie Dough', 'Normal/FoodItem', '99', '0', '0', '0', '22', '60629', '2039', '1', '0', '0', '0', '0', '11', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011502', 'Salted Butter', 'Normal/FoodItem', '99', '0', '0', '0', '11', '60625', '2039', '1', '0', '0', '0', '0', '5', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011503', 'Maple Sugar', 'Normal/FoodItem', '99', '0', '0', '0', '4', '61410', '2027', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011504', 'Sweet Cream', 'Normal/FoodItem', '99', '0', '0', '0', '5', '61400', '2039', '1', '0', '0', '0', '0', '2', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011505', 'Chicken Stock', 'Normal/FoodItem', '99', '0', '0', '0', '41', '60656', '2039', '1', '0', '0', '0', '0', '22', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011506', 'Garlean Garlic', 'Normal/FoodItem', '99', '0', '0', '0', '9', '60600', '2026', '1', '0', '0', '0', '0', '4', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011507', 'Black Pepper', 'Normal/FoodItem', '99', '0', '0', '0', '27', '60603', '2026', '1', '0', '0', '0', '0', '14', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011508', 'Pearl Ginger', 'Normal/FoodItem', '99', '0', '0', '0', '7', '60611', '2026', '1', '0', '0', '0', '0', '3', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011509', 'Cinnamon', 'Normal/FoodItem', '99', '0', '0', '0', '5', '61336', '2026', '1', '0', '0', '0', '0', '2', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011510', 'Sagolii Sage', 'Normal/FoodItem', '99', '0', '0', '0', '76', '60605', '2026', '1', '0', '0', '0', '0', '41', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011511', 'Marjoram', 'Normal/FoodItem', '99', '0', '0', '0', '29', '60632', '2026', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011512', 'Dragon Pepper', 'Normal/FoodItem', '99', '0', '0', '0', '58', '60619', '2026', '1', '0', '0', '0', '0', '31', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011513', 'Laurel', 'Normal/FoodItem', '99', '0', '0', '0', '59', '60605', '2026', '1', '0', '0', '0', '0', '32', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011514', 'Thyme', 'Normal/FoodItem', '99', '0', '0', '0', '58', '61345', '2026', '1', '0', '0', '0', '0', '31', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011515', 'Nutmeg', 'Normal/FoodItem', '99', '0', '0', '0', '63', '61401', '2026', '1', '0', '0', '0', '0', '34', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011516', 'Desert Saffron', 'Normal/FoodItem', '99', '0', '0', '0', '79', '61451', '2026', '1', '0', '0', '0', '0', '43', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011517', 'Midland Basil', 'Normal/FoodItem', '99', '0', '0', '0', '41', '60607', '2026', '1', '0', '0', '0', '0', '22', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011518', 'Cloves', 'Normal/FoodItem', '99', '0', '0', '0', '27', '61455', '2026', '1', '0', '0', '0', '0', '14', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011519', 'Vanilla Beans', 'Normal/FoodItem', '99', '0', '0', '0', '29', '60631', '2026', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011520', 'Galago Mint', 'Normal/FoodItem', '99', '0', '0', '0', '29', '60635', '2026', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011521', 'Thanalan Tea Leaves', 'Normal/FoodItem', '99', '0', '0', '0', '81', '61345', '2026', '1', '0', '0', '0', '0', '44', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011522', 'Gelatin', 'Normal/FoodItem', '99', '0', '0', '0', '38', '60580', '2039', '1', '0', '0', '0', '0', '20', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011523', 'Sunset Wheat', 'Normal/FoodItem', '99', '0', '0', '0', '7', '61450', '2021', '1', '0', '0', '0', '0', '3', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011524', 'Sunset Wheat Flour', 'Normal/FoodItem', '99', '0', '0', '0', '9', '60593', '2021', '1', '0', '0', '0', '0', '4', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011525', 'Rye', 'Normal/FoodItem', '99', '0', '0', '0', '7', '61450', '2021', '1', '0', '0', '0', '0', '3', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011526', 'Rye Flour', 'Normal/FoodItem', '99', '0', '0', '0', '7', '61341', '2021', '1', '0', '0', '0', '0', '3', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011527', 'Cornmeal', 'Normal/FoodItem', '99', '0', '0', '0', '40', '61341', '2021', '1', '0', '0', '0', '0', '21', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011528', 'Almonds', 'Normal/FoodItem', '99', '0', '0', '0', '58', '60642', '2026', '1', '0', '0', '0', '0', '31', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011529', 'Table Salt', 'Normal/FoodItem', '99', '0', '0', '0', '4', '61411', '2027', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011530', 'Honey', 'Normal/FoodItem', '99', '0', '0', '0', '7', '60628', '2027', '1', '0', '0', '0', '0', '3', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011531', 'Maple Syrup', 'Normal/FoodItem', '99', '0', '0', '0', '4', '61452', '2027', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011532', 'Olive Oil', 'Normal/FoodItem', '99', '0', '0', '0', '25', '60595', '2040', '1', '0', '0', '0', '0', '13', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011533', 'Cider Vinegar', 'Normal/FoodItem', '99', '0', '0', '0', '29', '61454', '2027', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011534', 'Ala Mhigan Mustard', 'Normal/FoodItem', '99', '0', '0', '0', '40', '60656', '2026', '1', '0', '0', '0', '0', '21', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011535', 'Tomato Sauce', 'Normal/FoodItem', '99', '0', '0', '0', '20', '60539', '2027', '1', '0', '0', '0', '0', '10', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011536', 'Lavender Oil', 'Normal/FoodItem', '99', '0', '0', '0', '29', '61457', '2040', '1', '0', '0', '0', '0', '15', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011537', 'Clove Oil', 'Normal/FoodItem', '99', '0', '0', '0', '27', '61458', '2040', '1', '0', '0', '0', '0', '14', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011538', 'Dried Marjoram', 'Normal/FoodItem', '99', '0', '0', '0', '3', '60608', '2026', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011539', 'Dark Vinegar', 'Normal/FoodItem', '99', '0', '0', '0', '40', '61488', '2027', '1', '0', '0', '0', '0', '21', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011540', 'Powdered Sugar', 'Normal/FoodItem', '99', '0', '0', '0', '11', '61563', '2027', '1', '0', '0', '0', '0', '5', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011541', 'Kukuru Powder', 'Normal/FoodItem', '99', '0', '0', '0', '18', '60465', '2039', '1', '0', '0', '0', '0', '9', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011542', 'Kukuru Butter', 'Normal/FoodItem', '99', '0', '0', '0', '18', '60465', '2039', '1', '0', '0', '0', '0', '9', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011543', 'Fish Stock', 'Normal/FoodItem', '99', '0', '0', '0', '18', '61367', '2039', '1', '0', '0', '0', '0', '9', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011544', 'Dodo Stuffing', 'Normal/FoodItem', '99', '0', '0', '0', '36', '61367', '2039', '1', '0', '0', '0', '0', '19', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3011545', 'Mugwort', 'Normal/FoodItem', '99', '0', '0', '0', '58', '61345', '2026', '1', '0', '0', '0', '0', '31', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020001', 'Potion', 'Normal/PotionItem', '99', '0', '0', '0', '56', '60019', '2002', '1', '1', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '70', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020002', 'Hi-potion', 'Normal/PotionItem', '99', '0', '0', '0', '156', '60020', '2002', '1', '1', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '80', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020003', 'Mega-potion', 'Normal/PotionItem', '99', '0', '0', '0', '281', '60021', '2002', '1', '1', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '90', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020004', '[en]', 'Normal/PotionItem', '99', '0', '0', '0', '13', '60022', '2002', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020005', '[en]', 'Normal/PotionItem', '99', '0', '0', '0', '13', '60019', '2002', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020006', 'Fire Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020007', 'Water Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020008', 'Wind Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020009', 'Earth Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020010', 'Lightning Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020011', 'Ice Potion', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60019', '2002', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '45', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020101', 'Ether', 'Normal/PotionItem', '99', '0', '0', '0', '100', '60023', '2004', '1', '1', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020102', 'Hi-ether', 'Normal/PotionItem', '99', '0', '0', '0', '225', '60024', '2004', '1', '1', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '270', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020103', 'Mega-ether', 'Normal/PotionItem', '99', '0', '0', '0', '319', '60025', '2004', '1', '1', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020104', 'Hyper Ether', 'Normal/PotionItem', '99', '0', '0', '0', '13', '60026', '2004', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020105', 'Fire Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020106', 'Water Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020107', 'Wind Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020108', 'Earth Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020109', 'Lightning Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020110', 'Ice Ether', 'Normal/PotionItem', '99', '0', '0', '0', '150', '60023', '2004', '1', '1', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '300', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020201', 'Elixir', 'Normal/PotionItem', '99', '0', '0', '0', '540', '60027', '2004', '1', '1', '0', '0', '0', '53', '1001', '0', '0', '0', '0', '450', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020202', 'Dusken Draught', 'Normal/PotionItem', '1', '1', '1', '0', '0', '60027', '2004', '1', '1', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '210', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020203', 'Kiss of the Morning Meadow', 'Normal/PotionItem', '1', '1', '1', '0', '0', '60028', '2004', '1', '1', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '270', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020204', 'Onyx Tears', 'Normal/PotionItem', '1', '1', '1', '0', '0', '61609', '2004', '1', '1', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '270', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020301', 'Blinding Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '200', '60044', '2005', '1', '1', '0', '0', '0', '31', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020302', 'Silencing Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '238', '60043', '2005', '1', '1', '0', '0', '0', '37', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020303', 'Sleeping Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '300', '60042', '2005', '1', '1', '0', '0', '0', '47', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020304', 'Paralyzing Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '313', '60041', '2005', '1', '1', '0', '0', '0', '49', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020305', 'Maddening Potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '200', '61559', '2006', '1', '1', '0', '0', '0', '31', '1001', '0', '0', '0', '60', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020306', 'Poisoning Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '231', '60039', '2005', '1', '1', '0', '0', '0', '36', '1001', '0', '0', '0', '20', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020307', 'Smothering Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '263', '60039', '2005', '1', '1', '0', '0', '0', '41', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020308', 'Disabling Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '288', '60039', '2005', '1', '1', '0', '0', '0', '45', '1001', '0', '0', '0', '10', '120', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020309', 'Venom Potion', 'Normal/CmnBadStatusItem', '99', '0', '0', '0', '22', '60030', '2005', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020401', 'Eye Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '88', '60034', '2003', '1', '1', '0', '0', '0', '13', '1001', '1', '0', '0', '0', '270', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020402', 'Throat Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '206', '60035', '2003', '1', '1', '0', '0', '0', '32', '1001', '1', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020403', 'Dawn Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '1', '61556', '2003', '1', '1', '0', '0', '0', '19', '1001', '1', '0', '0', '0', '210', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020404', 'Spine Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '263', '61557', '2003', '1', '1', '0', '0', '0', '41', '1001', '1', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020405', 'Nerve Drops', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '206', '61558', '2006', '1', '1', '0', '0', '0', '32', '1001', '0', '0', '0', '60', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020406', 'Blood Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '1', '60033', '2003', '1', '1', '0', '0', '0', '6', '1001', '1', '0', '0', '0', '180', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020407', 'Lung Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '250', '60033', '2003', '1', '1', '0', '0', '0', '39', '1001', '1', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020408', 'Heart Drops', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '306', '60033', '2003', '1', '1', '0', '0', '0', '48', '1001', '1', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020409', 'Gold Needle', 'Normal/CmnRemoveStatusItem', '99', '0', '0', '0', '331', '61709', '2003', '1', '1', '0', '0', '0', '52', '1001', '1', '0', '0', '0', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020410', 'The Keeper\'s Hymn', 'Normal/CmnGoodStatusItem', '99', '0', '1', '0', '0', '60760', '7101', '1', '0', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020411', 'Company-issue Expectorant', 'Normal/RaiseItem', '1', '1', '1', '0', '0', '61599', '2003', '1', '1', '0', '0', '0', '15', '1001', '0.6', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020412', 'Company-issue Tonic', 'Normal/RaiseItem', '1', '1', '1', '0', '0', '61600', '2003', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020413', 'Over-aspected Cluster', 'Normal/RaiseItem', '1', '1', '1', '0', '0', '61725', '2003', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020501', 'Ironhide Unguent', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '125', '60038', '2006', '1', '1', '0', '0', '0', '19', '1001', '45', '0', '0', '300', '600', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020502', 'Ironwill Unguent', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '188', '60038', '2006', '1', '1', '0', '0', '0', '29', '1001', '45', '0', '0', '300', '600', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020503', '[en]', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '22', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '300', '600', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020504', 'Company-issue Engineering Manual II', 'Normal/CmnGoodStatusItem', '1', '1', '1', '0', '0', '61598', '1016', '1', '1', '0', '0', '0', '1', '1001', '1.5', '9000', '0', '10800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020505', 'Company-issue Survival Manual II', 'Normal/CmnGoodStatusItem', '1', '1', '1', '0', '0', '61597', '1016', '1', '1', '0', '0', '0', '1', '1001', '1.5', '9000', '0', '10800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020506', 'Sanction', 'Normal/CmnGoodStatusItem', '1', '1', '1', '0', '0', '60751', '1016', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '10800', '5400', '3', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020507', 'Peach Confetti', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61495', '4026', '1', '1', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020508', 'Cherry Confetti', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61496', '4026', '1', '1', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020509', 'Company-issue Engineering Manual', 'Normal/CmnGoodStatusItem', '1', '1', '1', '0', '0', '61598', '1016', '1', '1', '0', '0', '0', '1', '1001', '1.5', '4000', '0', '10800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020510', 'Company-issue Survival Manual', 'Normal/CmnGoodStatusItem', '1', '1', '1', '0', '0', '61597', '1016', '1', '1', '0', '0', '0', '1', '1001', '1.5', '4000', '0', '10800', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020511', 'Muscle Restorative', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '123', '60038', '2006', '1', '1', '0', '0', '0', '10', '1001', '0', '0', '0', '600', '900', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020512', 'Potion of Strength', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '131', '60038', '2006', '1', '1', '0', '0', '0', '20', '1001', '1', '0', '0', '30', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020513', 'Hi-potion of Strength', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '256', '60038', '2006', '1', '1', '0', '0', '0', '40', '1001', '1', '0', '0', '30', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020514', 'Mega-potion of Strength', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '325', '60038', '2006', '1', '1', '0', '0', '0', '51', '1001', '1', '0', '0', '30', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020515', 'Potion of Vitality', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '113', '60038', '2006', '1', '1', '0', '0', '0', '17', '1001', '1', '0', '0', '60', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020516', 'Hi-potion of Vitality', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '194', '60038', '2006', '1', '1', '0', '0', '0', '30', '1001', '1', '0', '0', '60', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020517', 'Mega-potion of Vitality', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '300', '60038', '2006', '1', '1', '0', '0', '0', '47', '1001', '1', '0', '0', '60', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020518', 'Potion of Dexterity', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '106', '60038', '2006', '1', '1', '0', '0', '0', '16', '1001', '1', '0', '0', '40', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020519', 'Hi-potion of Dexterity', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '244', '60038', '2006', '1', '1', '0', '0', '0', '38', '1001', '1', '0', '0', '40', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020520', 'Mega-potion of Dexterity', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '294', '60038', '2006', '1', '1', '0', '0', '0', '46', '1001', '1', '0', '0', '40', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020521', 'Potion of Intelligence', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '100', '60038', '2006', '1', '1', '0', '0', '0', '15', '1001', '1', '0', '0', '30', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020522', 'Hi-potion of Intelligence', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '188', '60038', '2006', '1', '1', '0', '0', '0', '29', '1001', '1', '0', '0', '30', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020523', 'Mega-potion of Intelligence', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '288', '60038', '2006', '1', '1', '0', '0', '0', '45', '1001', '1', '0', '0', '30', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020524', 'Potion of Mind', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '94', '60038', '2006', '1', '1', '0', '0', '0', '14', '1001', '1', '0', '0', '60', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020525', 'Hi-potion of Mind', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '175', '60038', '2006', '1', '1', '0', '0', '0', '27', '1001', '1', '0', '0', '60', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020526', 'Mega-potion of Mind', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '281', '60038', '2006', '1', '1', '0', '0', '0', '44', '1001', '1', '0', '0', '60', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020527', 'Potion of Piety', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '88', '60038', '2006', '1', '1', '0', '0', '0', '13', '1001', '1', '0', '0', '60', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020528', 'Hi-potion of Piety', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '181', '60038', '2006', '1', '1', '0', '0', '0', '28', '1001', '1', '0', '0', '60', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020529', 'Mega-potion of Piety', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '275', '60038', '2006', '1', '1', '0', '0', '0', '43', '1001', '1', '0', '0', '60', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020530', 'Bloodwall Potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020531', 'Bloodwall Hi-potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020532', 'Bloodwall Mega-potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020533', 'Manawall Potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '220', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020534', 'Manawall Hi-potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020535', 'Manawall Mega-potion', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '0', '60038', '2006', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '40', '240', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020536', 'Giant\'s Drink', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '517', '60038', '2006', '1', '1', '0', '0', '0', '50', '1001', '1', '0', '0', '600', '600', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020537', 'Over-aspected Crystal', 'Normal/EnchantMedicineItem', '99', '0', '0', '0', '517', '61726', '2006', '1', '1', '0', '0', '0', '45', '1001', '1', '0', '0', '40', '230', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020538', 'Lunar Curtain', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '573', '60473', '2006', '1', '1', '0', '0', '0', '50', '1001', '0.5', '0', '0', '15', '1800', '2', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020601', 'Storm Tracer', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61596', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020602', 'Flame Tracer', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61594', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020603', 'Serpent Tracer', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61595', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020604', 'Lominsan Sparkler', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61596', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020605', 'Gridanian Sparkler', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61595', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020606', 'Ul\'dahn Sparkler', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '1', '61594', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020607', 'Magicked Prism (Harbor Herald)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61212', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020608', 'Magicked Prism (Mythril Eye)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61212', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020609', 'Magicked Prism (The Raven)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61212', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020610', 'Magicked Prism (Crimson Star)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61215', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020611', 'Magicked Prism (Emerald Star)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61217', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020612', 'Magicked Prism (Indigo Star)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '25', '61216', '4026', '1', '1', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020613', 'Bombard Bloom', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '19', '61596', '4026', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020614', 'Magicked Prism (Maelstrom)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '19', '61215', '4026', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020615', 'Magicked Prism (Twin Adder)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '19', '61212', '4026', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3020616', 'Magicked Prism (Immortal Flames)', 'Normal/CmnGoodStatusItem', '99', '0', '0', '0', '19', '61216', '4026', '1', '1', '0', '0', '0', '1', '1001', '1', '0', '0', '0', '5', '1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910001', 'Smoothed Stone', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60082', '5020', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910005', 'Levinstone', 'Normal/StandardItem', '99', '0', '0', '0', '4', '60085', '5020', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910006', 'Firepot', 'Normal/StandardItem', '99', '0', '0', '0', '5', '61430', '5020', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910007', 'Bomb Arm', 'Normal/StandardItem', '99', '0', '0', '0', '7', '60447', '5020', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910008', 'Grenade Arm', 'Normal/StandardItem', '99', '0', '0', '0', '8', '60447', '5020', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910009', 'Exorcism Bean', 'Normal/StandardItem', '99', '0', '0', '0', '1', '61466', '5020', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910101', 'Bronze Chakram', 'Normal/StandardItem', '99', '0', '0', '0', '5', '70264', '5021', '1', '0', '2', '0', '0', '12', '2130', '0.5', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910102', 'Steel Chakram', 'Normal/StandardItem', '99', '0', '0', '0', '19', '70267', '5021', '1', '0', '2', '0', '0', '47', '2130', '0.5', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910103', 'Iron Chakram', 'Normal/StandardItem', '99', '0', '0', '0', '13', '70266', '5021', '1', '0', '2', '0', '0', '32', '2130', '0.5', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910104', 'Silver Chakram', 'Normal/StandardItem', '99', '0', '0', '0', '17', '70265', '5021', '1', '0', '2', '0', '0', '42', '2130', '0.5', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910201', 'Bronze Francisca', 'Normal/StandardItem', '99', '0', '0', '0', '5', '70268', '5023', '1', '0', '4', '0', '0', '12', '2132', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910202', 'Brass Francisca', 'Normal/StandardItem', '99', '0', '0', '0', '10', '70269', '5023', '1', '0', '4', '0', '0', '22', '2132', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910203', 'Iron Francisca', 'Normal/StandardItem', '99', '0', '0', '0', '14', '70270', '5023', '1', '0', '4', '0', '0', '32', '2132', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910204', 'Silver Francisca', 'Normal/StandardItem', '99', '0', '0', '0', '19', '70271', '5023', '1', '0', '4', '0', '0', '42', '2132', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910301', 'Bronze Javelin', 'Normal/StandardItem', '99', '0', '0', '0', '6', '70274', '5022', '1', '0', '8', '0', '0', '12', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910302', 'Brass Javelin', 'Normal/StandardItem', '99', '0', '0', '0', '11', '70273', '5022', '1', '0', '8', '0', '0', '22', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910303', 'Iron Javelin', 'Normal/StandardItem', '99', '0', '0', '0', '16', '70272', '5022', '1', '0', '8', '0', '0', '32', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910304', 'Silver Javelin', 'Normal/StandardItem', '99', '0', '0', '0', '21', '70275', '5022', '1', '0', '8', '0', '0', '42', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910305', 'Bronze Azagai', 'Normal/StandardItem', '99', '0', '0', '0', '14', '70276', '5022', '1', '0', '8', '0', '0', '27', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910306', 'Iron Azagai', 'Normal/StandardItem', '99', '0', '0', '0', '24', '70277', '5022', '1', '0', '8', '0', '0', '47', '2134', '0.2', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910401', 'Bronze Throwing Dagger', 'Normal/StandardItem', '99', '0', '0', '0', '4', '70385', '5024', '1', '0', '3', '0', '0', '12', '2131', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910402', 'Iron Throwing Dagger', 'Normal/StandardItem', '99', '0', '0', '0', '10', '70386', '5024', '1', '0', '3', '0', '0', '27', '2131', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3910403', 'Silver Throwing Dagger', 'Normal/StandardItem', '99', '0', '0', '0', '14', '70387', '5024', '1', '0', '3', '0', '0', '37', '2131', '0.3', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920001', 'Dated Bronze Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60843', '5017', '1', '0', '7', '0', '0', '3', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920002', 'Dated Iron Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '5', '60844', '5017', '1', '0', '7', '0', '0', '23', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920003', 'Steel Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60845', '5017', '1', '0', '7', '0', '1', '28', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920004', 'Bronze Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60843', '5017', '1', '0', '7', '0', '1', '8', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920005', 'Dated Silver Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '8', '60847', '5017', '1', '0', '7', '0', '0', '33', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920006', 'Iron Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60844', '5017', '1', '0', '7', '0', '1', '18', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920007', 'Mythril Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '2', '60849', '5017', '1', '0', '7', '0', '1', '38', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920008', 'Cobalt Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '2', '60845', '5017', '1', '0', '7', '0', '1', '48', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920009', 'Dated Fang Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '2', '60837', '5017', '1', '0', '7', '0', '0', '9', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920010', 'Horn Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60837', '5017', '1', '0', '7', '0', '0', '1', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920011', 'Dated Shell Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '6', '60837', '5017', '1', '0', '7', '0', '0', '27', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920012', 'Dated White Coral Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '9', '60837', '5017', '1', '0', '7', '0', '0', '37', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920013', 'Wolf Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60837', '5017', '1', '0', '7', '0', '0', '1', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920014', 'Jade Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60840', '5017', '1', '0', '7', '0', '0', '1', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920015', 'Dated Obsidian Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '4', '60841', '5017', '1', '0', '7', '0', '0', '17', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920016', 'Warped Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60843', '5017', '1', '0', '7', '0', '0', '1', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920017', 'Dated Flint Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '1', '60835', '5017', '1', '0', '7', '0', '0', '7', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920018', 'Dated Blue Coral Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '10', '60842', '5017', '1', '0', '7', '0', '0', '42', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920019', 'Dated Red Coral Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '11', '60838', '5017', '1', '0', '7', '0', '0', '47', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920020', 'Dated Bronze Swallowtail Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '3', '60851', '5017', '1', '0', '7', '0', '0', '13', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3920021', 'Dated Iron Swallowtail Arrow', 'Normal/StandardItem', '999', '0', '0', '0', '6', '60852', '5017', '1', '0', '7', '0', '0', '28', '2133', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940001', 'Bloodworm', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60783', '6112', '1', '0', '41', '0', '0', '2', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940002', 'Lugworm', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60781', '6112', '1', '0', '41', '0', '0', '1', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940003', 'Moth Pupa', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60780', '6112', '1', '0', '41', '0', '0', '1', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940004', 'Pill Bug', 'Normal/StandardItem', '99', '0', '0', '0', '2', '60782', '6112', '1', '0', '41', '0', '0', '8', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940005', 'Crayfish Ball', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60785', '6112', '1', '0', '41', '0', '0', '3', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940006', 'Goby Ball', 'Normal/StandardItem', '99', '0', '0', '0', '3', '60786', '6112', '1', '0', '41', '0', '0', '11', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940007', 'Crab Ball', 'Normal/StandardItem', '99', '0', '0', '0', '5', '60788', '6112', '1', '0', '41', '0', '0', '18', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940008', 'Bass Ball', 'Normal/StandardItem', '99', '0', '0', '0', '8', '60787', '6112', '1', '0', '41', '0', '0', '26', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940009', 'Herring Ball', 'Normal/StandardItem', '99', '0', '0', '0', '11', '60784', '6112', '1', '0', '41', '0', '0', '37', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940010', 'Rat Tail', 'Normal/StandardItem', '99', '0', '0', '0', '2', '60453', '6112', '1', '0', '41', '0', '0', '7', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940011', 'Midge Basket', 'Normal/StandardItem', '99', '0', '0', '0', '2', '60759', '6112', '1', '0', '41', '0', '0', '6', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940012', 'Syrphid Basket', 'Normal/StandardItem', '99', '0', '0', '0', '4', '60759', '6112', '1', '0', '41', '0', '0', '13', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940101', 'Chocobo Fly', 'Normal/StandardItem', '99', '0', '0', '0', '19', '60773', '6113', '1', '0', '41', '0', '0', '7', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940102', 'Crow Fly', 'Normal/StandardItem', '99', '0', '0', '0', '33', '60774', '6113', '1', '0', '41', '0', '0', '13', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940103', 'Snurble Fly', 'Normal/StandardItem', '99', '0', '0', '0', '52', '60775', '6113', '1', '0', '41', '0', '0', '21', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940104', 'Wildfowl Fly', 'Normal/StandardItem', '99', '0', '0', '0', '79', '60776', '6113', '1', '0', '41', '0', '0', '32', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940105', 'Vulture Fly', 'Normal/StandardItem', '99', '0', '0', '0', '93', '60777', '6113', '1', '0', '41', '0', '0', '38', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940106', 'Floating Minnow', 'Normal/StandardItem', '99', '0', '0', '0', '31', '60768', '6113', '1', '0', '41', '0', '0', '12', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940107', 'Sinking Minnow', 'Normal/StandardItem', '99', '0', '0', '0', '84', '60772', '6113', '1', '0', '41', '0', '0', '34', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940108', 'Topwater Frog', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60771', '6113', '1', '0', '41', '0', '0', '44', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940109', 'Spoon Lure', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60769', '6113', '1', '0', '41', '0', '0', '23', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('3940110', 'Cage Feeder', 'Normal/StandardItem', '99', '0', '0', '0', '67', '60770', '6113', '1', '0', '41', '0', '0', '27', '2147', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4020001', 'Weathered Hora', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70010', '5005', '1', '0', '2', '0', '0', '1', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4020002', 'Dated Bone Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '742', '70011', '5005', '1', '0', '2', '0', '0', '6', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4020003', 'Dated Tortoiseshell Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '2862', '70012', '5005', '1', '0', '2', '0', '0', '26', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4020004', 'Dated Crabshell Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '4982', '70086', '5005', '1', '0', '2', '0', '0', '46', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4020005', 'Bone Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '636', '70011', '5005', '1', '0', '2', '0', '1', '5', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4020006', 'Crabshell Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '3498', '70086', '5005', '1', '0', '2', '0', '1', '32', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4020007', 'Dated Jade Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '5406', '70316', '5005', '1', '0', '2', '0', '0', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020008', 'Tortoiseshell Hora', 'Normal/StandardItem', '1', '0', '0', '131760', '4452', '70012', '5005', '1', '0', '2', '0', '1', '41', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4020009', 'Verdant Hora', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70316', '5005', '3', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020010', 'Ifrit\'s Claws', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70489', '5005', '3', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020011', 'Ul\'dahn Hora', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70012', '5005', '2', '0', '2', '0', '1', '40', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4020012', 'Gridanian Hora', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70519', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020101', 'Dated Leather Himantes', 'Normal/StandardItem', '1', '0', '0', '161040', '960', '70087', '5005', '1', '0', '2', '0', '0', '9', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4020102', 'Dated Dodoskin Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '1920', '70088', '5005', '1', '0', '2', '0', '0', '19', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4020103', 'Dated Toadskin Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '2880', '70091', '5005', '1', '0', '2', '0', '0', '29', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4020104', 'Dated Boarskin Himantes', 'Normal/StandardItem', '1', '0', '0', '161040', '3840', '70089', '5005', '1', '0', '2', '0', '0', '39', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('4020105', 'Dated Peiste Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '4800', '70090', '5005', '1', '0', '2', '0', '0', '49', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4020106', 'Gridanian Cesti', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70091', '5005', '2', '0', '2', '0', '1', '30', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4020107', 'Sheepskin Himantes', 'Normal/StandardItem', '1', '0', '0', '161040', '864', '70087', '5005', '1', '0', '2', '0', '1', '8', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4020108', 'Dodoskin Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '1920', '70088', '5005', '1', '0', '2', '0', '1', '19', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4020109', 'Toadskin Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '2592', '70091', '5005', '1', '0', '2', '0', '1', '26', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4020110', 'Boarskin Himantes', 'Normal/StandardItem', '1', '0', '0', '161040', '3456', '70089', '5005', '1', '0', '2', '0', '1', '35', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4020111', 'Peiste Cesti', 'Normal/StandardItem', '1', '0', '0', '161040', '4512', '70090', '5005', '1', '0', '2', '0', '1', '46', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4020112', 'Murderous Mogfists', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70496', '5005', '3', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020113', 'Ul\'dahn Himantes', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70090', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020201', 'Dated Bronze Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '1652', '70092', '5005', '1', '0', '2', '0', '0', '13', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('4020202', 'Dated Brass Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '2832', '70094', '5005', '1', '0', '2', '0', '0', '23', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4020203', 'Dated Spiked Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '4012', '70093', '5005', '1', '0', '2', '0', '0', '33', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('4020204', 'Fists of the Sixth Sun', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70423', '5005', '2', '0', '2', '0', '0', '35', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4020205', 'Unbreakable Knuckles', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70093', '5005', '2', '0', '2', '0', '1', '30', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4020206', 'Bronze Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '1534', '70092', '5005', '1', '0', '2', '0', '1', '12', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('4020207', 'Brass Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '2006', '70094', '5005', '1', '0', '2', '0', '1', '16', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4020208', 'Spiked Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '2832', '70093', '5005', '1', '0', '2', '0', '1', '23', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4020209', 'Cobalt Knuckles', 'Normal/StandardItem', '1', '0', '0', '175680', '5192', '70432', '5005', '1', '0', '2', '0', '1', '43', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4020210', 'Lominsan Knuckles', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70423', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020211', 'Gridanian Knuckles', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70432', '5005', '2', '0', '2', '0', '1', '40', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4020301', 'Dated Iron Baghnakhs', 'Normal/StandardItem', '1', '0', '0', '146400', '5848', '70007', '5005', '1', '0', '2', '0', '0', '42', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4020302', 'Steel Claws', 'Normal/StandardItem', '1', '0', '0', '146400', '4080', '70433', '5005', '1', '0', '2', '0', '1', '29', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4020303', 'Symon\'s Honeyclaws', 'Normal/StandardItem', '1', '1', '0', '146400', '6936', '70532', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020304', 'Howling Talons', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70008', '5005', '2', '0', '2', '0', '0', '25', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4020305', 'Gridanian Baghnakhs', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70009', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020306', 'Lominsan Baghnakhs', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70007', '5005', '2', '0', '2', '0', '1', '40', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4020307', 'Mythril Claws', 'Normal/StandardItem', '1', '0', '0', '146400', '5304', '70434', '5005', '1', '0', '2', '0', '1', '38', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4020308', '[en]', 'Normal/StandardItem', '1', '0', '0', '146400', '272', '60000', '5005', '1', '0', '2', '0', '1', '1', '2130', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4020309', 'Cobalt Claws', 'Normal/StandardItem', '1', '0', '0', '146400', '6800', '70435', '5005', '1', '0', '2', '0', '1', '49', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4020310', 'Dated Smothering Baghnakhs', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '146400', '6528', '70007', '5005', '1', '0', '2', '0', '0', '47', '2130', '5', '0', '0', '30', '0', '-1', '35', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4020311', 'Dated Disabling Baghnakhs', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '146400', '6528', '70007', '5005', '1', '0', '2', '0', '0', '47', '2130', '5', '0.3', '0', '30', '0', '-1', '35', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('4020401', 'Unfinished Sphairai', 'Normal/StandardItem', '1', '1', '1', '65000', '0', '70619', '5005', '1', '0', '2', '0', '1', '50', '2119', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020402', 'Sphairai', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70613', '5005', '4', '0', '2', '0', '1', '50', '2119', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020403', 'Avengers', 'Normal/StandardItem', '1', '0', '0', '175680', '6018', '70543', '5005', '2', '0', '2', '0', '1', '50', '2148', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020404', 'Storm Lieutenant\'s Hooks', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70590', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020405', 'Serpent Lieutenant\'s Claws', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70597', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020406', 'Flame Lieutenant\'s Jamadhars', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70604', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020407', 'Garuda\'s Talons', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70536', '5005', '3', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020408', 'Storm Sergeant\'s Hooks', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70569', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020409', 'Serpent Sergeant\'s Patas', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70570', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020410', 'Flame Sergeant\'s Patas', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70571', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4020411', 'Giantsgall Claws', 'Normal/StandardItem', '1', '0', '0', '146400', '6936', '70627', '5005', '2', '0', '2', '0', '1', '50', '2130', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030001', 'Bronze Gladius', 'Normal/StandardItem', '1', '0', '0', '87840', '800', '70096', '5006', '1', '0', '3', '0', '1', '7', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030002', 'Dated Bronze Spatha', 'Normal/StandardItem', '1', '0', '0', '87840', '1200', '70014', '5006', '1', '0', '3', '0', '0', '11', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030003', 'Dated Iron Spatha', 'Normal/StandardItem', '1', '0', '0', '87840', '3200', '70015', '5006', '1', '0', '3', '0', '0', '31', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4030004', 'Bronze Spatha', 'Normal/StandardItem', '1', '0', '0', '87840', '1400', '70014', '5006', '1', '0', '3', '0', '1', '13', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('4030005', 'Dated Brass Gladius', 'Normal/StandardItem', '1', '0', '0', '87840', '1700', '70016', '5006', '1', '0', '3', '0', '0', '16', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4030006', 'Brass Gladius', 'Normal/StandardItem', '1', '0', '0', '87840', '1900', '70016', '5006', '1', '0', '3', '0', '1', '18', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('4030007', 'Dated Bee Spatha', 'Normal/StandardItem', '1', '0', '0', '87840', '3700', '70017', '5006', '1', '0', '3', '0', '0', '36', '2131', '0', '0', '0', '0', '0', '-1', '35', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('4030008', 'Iron Spatha', 'Normal/StandardItem', '1', '0', '0', '87840', '2400', '70015', '5006', '1', '0', '3', '0', '1', '23', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4030009', '[en]', 'Normal/StandardItem', '1', '0', '0', '87840', '200', '60000', '5006', '1', '0', '3', '0', '0', '1', '2131', '0', '0', '0', '0', '0', '-1', '30', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4030010', 'Weathered Gladius', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70095', '5006', '1', '0', '3', '0', '0', '1', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030011', 'Dated Bronze Gladius', 'Normal/StandardItem', '1', '0', '0', '87840', '700', '70096', '5006', '1', '0', '3', '0', '0', '6', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030012', 'Dated Iron Gladius', 'Normal/StandardItem', '1', '0', '0', '87840', '2700', '70097', '5006', '1', '0', '3', '0', '0', '26', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4030013', 'Blunt Goblin Gladius', 'Normal/StandardItem', '1', '1', '0', '48800', '1200', '70318', '5006', '1', '0', '3', '0', '0', '29', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4030014', 'Goblin Gladius', 'Normal/StandardItem', '1', '1', '0', '87840', '4000', '70097', '5006', '1', '0', '3', '0', '0', '39', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4030015', 'Ul\'dahn Spatha', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70015', '5006', '2', '0', '3', '0', '1', '30', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4030016', 'Gridanian Spatha', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70017', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030101', 'Dated Bronze Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '900', '70098', '5006', '1', '0', '3', '0', '0', '9', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030102', 'Dated Brass Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '1800', '70101', '5006', '1', '0', '3', '0', '0', '19', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4030103', 'Dated Iron Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '2700', '70099', '5006', '1', '0', '3', '0', '0', '29', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4030104', 'Dated Paralyzing Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '2250', '70102', '5006', '1', '0', '3', '0', '0', '24', '2131', '0.2', '0', '0', '60', '0', '-1', '35', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('4030105', 'Dated Maddening Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '3150', '70102', '5006', '1', '0', '3', '0', '0', '34', '2131', '0.05', '0', '0', '60', '0', '-1', '35', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4030106', 'Dated Poison Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '3150', '70102', '5006', '1', '0', '3', '0', '0', '34', '2131', '3', '0', '0', '60', '0', '-1', '35', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4030107', 'Dated Blinding Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '1350', '70102', '5006', '1', '0', '3', '0', '0', '14', '2131', '-10', '0', '0', '60', '0', '-1', '35', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('4030108', 'Dated Silencing Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '1350', '70102', '5006', '1', '0', '3', '0', '0', '14', '2131', '0', '0', '0', '30', '0', '-1', '35', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('4030109', 'Dated Sleeping Dagger', 'Normal/AdditionalEffectEquipItem', '1', '0', '0', '78080', '2250', '70102', '5006', '1', '0', '3', '0', '0', '24', '2131', '0', '0', '0', '30', '0', '-1', '35', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4030110', 'Bronze Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '540', '70098', '5006', '1', '0', '3', '0', '1', '5', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030111', 'Blunt Goblin Dagger', 'Normal/StandardItem', '1', '1', '0', '48800', '880', '70319', '5006', '1', '0', '3', '0', '0', '21', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4030112', 'Goblin Dagger', 'Normal/StandardItem', '1', '1', '0', '78080', '2880', '70099', '5006', '1', '0', '3', '0', '0', '31', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4030113', 'Warden\'s Dagger', 'Normal/StandardItem', '1', '1', '1', '78080', '0', '70099', '5006', '2', '0', '3', '0', '1', '30', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4030114', 'Brass Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '1530', '70101', '5006', '1', '0', '3', '0', '1', '16', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4030115', 'Steel Baselard', 'Normal/StandardItem', '1', '0', '0', '78080', '2430', '70436', '5006', '1', '0', '3', '0', '1', '26', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4030116', 'Mythril Knife', 'Normal/StandardItem', '1', '0', '0', '78080', '3510', '70437', '5006', '1', '0', '3', '0', '1', '38', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4030117', 'Lominsan Baselard', 'Normal/StandardItem', '1', '1', '1', '78080', '0', '70436', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030118', 'Maddening Dagger', 'Normal/StandardItem', '1', '0', '0', '78080', '2160', '70102', '5006', '1', '0', '3', '0', '1', '23', '2131', '0', '0', '0', '0', '0', '-1', '35', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4030201', 'Dated Iron Shortsword', 'Normal/StandardItem', '1', '0', '0', '97600', '4472', '70018', '5006', '1', '0', '3', '0', '0', '42', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4030202', 'Frostbite', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70019', '5006', '2', '0', '3', '0', '0', '30', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4030203', 'Iron Shortsword', 'Normal/StandardItem', '1', '0', '0', '97600', '2288', '70019', '5006', '1', '0', '3', '0', '1', '21', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4030204', 'Cobalt Katzbalger', 'Normal/StandardItem', '1', '0', '0', '97600', '4576', '70020', '5006', '1', '0', '3', '0', '1', '43', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4030205', 'Lominsan Shortsword', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70018', '5006', '2', '0', '3', '0', '1', '40', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4030301', 'Dated Iron Falchion', 'Normal/StandardItem', '1', '0', '0', '102480', '4290', '70103', '5006', '1', '0', '3', '0', '0', '38', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4030302', 'Dated Toothed Falchion', 'Normal/StandardItem', '1', '0', '0', '102480', '5390', '70104', '5006', '1', '0', '3', '0', '0', '48', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('4030303', 'Templar\'s Falchion', 'Normal/StandardItem', '1', '1', '1', '102480', '0', '70104', '5006', '3', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030304', 'Steel Falchion', 'Normal/StandardItem', '1', '0', '0', '102480', '3520', '70438', '5006', '1', '0', '3', '0', '1', '31', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4030305', 'Ul\'dahn Falchion', 'Normal/StandardItem', '1', '1', '1', '102480', '0', '70103', '5006', '2', '0', '3', '0', '1', '40', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4030401', 'Dated Iron Longsword', 'Normal/StandardItem', '1', '0', '0', '112240', '5452', '70278', '5006', '1', '0', '3', '0', '0', '46', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4030402', 'Blunt Goblin Longsword', 'Normal/StandardItem', '1', '1', '0', '48800', '1240', '70328', '5006', '1', '0', '3', '0', '0', '30', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4030403', 'Goblin Longsword', 'Normal/StandardItem', '1', '1', '0', '112240', '4756', '70329', '5006', '1', '0', '3', '0', '0', '40', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4030404', 'Flametongue', 'Normal/StandardItem', '1', '1', '1', '112240', '0', '70330', '5006', '2', '0', '3', '0', '0', '35', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4030405', 'Steel Longsword', 'Normal/StandardItem', '1', '0', '0', '112240', '4292', '70439', '5006', '1', '0', '3', '0', '1', '36', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('4030406', 'Cobalt Winglet', 'Normal/StandardItem', '1', '0', '0', '112240', '5800', '70440', '5006', '1', '0', '3', '0', '1', '49', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4030407', 'Morbid Mogblade', 'Normal/StandardItem', '1', '1', '1', '112240', '0', '70497', '5006', '3', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030408', 'Ul\'dahn Winglet', 'Normal/StandardItem', '1', '1', '1', '112240', '0', '70516', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030501', 'Blunt Goblin Scimitar', 'Normal/StandardItem', '1', '1', '0', '48800', '1120', '70323', '5006', '1', '0', '3', '0', '0', '27', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('4030502', 'Goblin Scimitar', 'Normal/StandardItem', '1', '1', '0', '107360', '4560', '70324', '5006', '1', '0', '3', '0', '0', '37', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('4030503', 'Blunt Aeolian Scimitar', 'Normal/StandardItem', '1', '1', '0', '48800', '1640', '70323', '5006', '1', '0', '3', '0', '0', '40', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4030504', 'Aeolian Scimitar', 'Normal/StandardItem', '1', '1', '0', '107360', '6120', '70325', '5006', '1', '0', '3', '0', '0', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4030505', 'Ul\'dahn Scimitar', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70427', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030506', 'Cobalt Shamshir', 'Normal/StandardItem', '1', '0', '0', '107360', '5640', '70427', '5006', '1', '0', '3', '0', '1', '46', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4030507', 'Ifrit\'s Blade', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70490', '5006', '3', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030601', 'Unfinished Curtana', 'Normal/StandardItem', '1', '1', '1', '48800', '0', '70620', '5006', '1', '0', '3', '0', '1', '50', '2120', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030602', 'Curtana', 'Normal/StandardItem', '1', '1', '1', '112240', '0', '70611', '5006', '4', '0', '3', '0', '1', '50', '2120', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030603', 'Mailbreaker', 'Normal/StandardItem', '1', '0', '0', '112240', '5916', '70544', '5006', '2', '0', '3', '0', '1', '50', '2149', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030604', 'Storm Lieutenant\'s Cutlass', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70591', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030605', 'Serpent Lieutenant\'s Longsword', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70598', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030606', 'Flame Lieutenant\'s Katzbalger', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70605', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030607', 'Garuda\'s Gaze', 'Normal/StandardItem', '1', '1', '1', '102480', '0', '70537', '5006', '3', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030608', 'Giantsgall Longsword', 'Normal/StandardItem', '1', '0', '0', '97600', '5304', '70626', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4030701', 'Dated Ash Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '2652', '70105', '5006', '1', '0', '3', '0', '0', '25', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('4030702', 'Dated Elm Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '3672', '70107', '5006', '1', '0', '3', '0', '0', '35', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4030703', 'Dated Walnut Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '4692', '70106', '5006', '1', '0', '3', '0', '0', '45', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4030704', 'Dated Oak Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '5100', '70321', '5006', '1', '0', '3', '0', '0', '49', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('4030705', 'Dated Plumed Walnut Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '4998', '70322', '5006', '1', '0', '3', '0', '0', '48', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('4030706', 'Ash Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '1122', '70105', '5006', '1', '0', '3', '0', '1', '10', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4030707', 'Elm Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '2958', '70107', '5006', '1', '0', '3', '0', '1', '28', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4030708', 'Walnut Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '3570', '70106', '5006', '1', '0', '3', '0', '1', '34', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4030709', 'Plumed Oak Macuahuitl', 'Normal/StandardItem', '1', '0', '0', '82960', '4284', '70322', '5006', '1', '0', '3', '0', '1', '41', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4030710', 'Gridanian Macuahuitl', 'Normal/StandardItem', '1', '1', '1', '82960', '0', '70321', '5006', '2', '0', '3', '0', '1', '40', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4030711', 'Thormoen\'s Pride', 'Normal/StandardItem', '1', '1', '0', '82960', '5202', '70530', '5006', '2', '0', '3', '0', '1', '50', '2131', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040001', 'Weathered War Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70111', '5009', '1', '0', '4', '0', '0', '1', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4040002', 'Dated Bronze War Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '980', '70021', '5009', '1', '0', '4', '0', '0', '6', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4040003', 'Dated Iron War Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '3780', '70022', '5009', '1', '0', '4', '0', '0', '26', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4040004', 'Bronze War Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '840', '70021', '5009', '1', '0', '4', '0', '1', '5', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4040005', 'Dated Storm Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '3080', '70108', '5009', '1', '0', '4', '0', '0', '21', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('4040006', 'Dated Inferno Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '5180', '70109', '5009', '1', '0', '4', '0', '0', '36', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('4040007', 'Cloud Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '1540', '70108', '5009', '1', '0', '4', '0', '1', '10', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4040008', 'Dated Thunderstorm Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '6580', '70279', '5009', '1', '0', '4', '0', '0', '46', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4040009', 'Iron War Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '2240', '70022', '5009', '1', '0', '4', '0', '1', '15', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('4040010', 'Inferno Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '2940', '70109', '5009', '1', '0', '4', '0', '1', '20', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('4040011', 'Charred Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70109', '5009', '2', '0', '4', '0', '1', '30', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4040012', 'Thunderstorm Axe', 'Normal/StandardItem', '1', '0', '0', '146400', '3640', '70279', '5009', '1', '0', '4', '0', '1', '25', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4040013', 'Malignant Mogaxe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70498', '5009', '3', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040014', 'Lominsan War Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70279', '5009', '2', '0', '4', '0', '1', '40', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4040101', 'Dated Bronze Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '1584', '70024', '5009', '1', '0', '4', '0', '0', '10', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4040102', 'Dated Iron Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '4464', '70025', '5009', '1', '0', '4', '0', '0', '30', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4040103', 'Bronze Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '2016', '70024', '5009', '1', '0', '4', '0', '1', '13', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('4040104', 'Dated Spiked Bronze Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '3024', '70026', '5009', '1', '0', '4', '0', '0', '20', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('4040105', 'Dated Spiked Iron Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '5184', '70027', '5009', '1', '0', '4', '0', '0', '35', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4040106', 'Iron Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '2736', '70025', '5009', '1', '0', '4', '0', '1', '18', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('4040107', 'Spiked Steel Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '4176', '70441', '5009', '1', '0', '4', '0', '1', '28', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4040108', 'Spiked Mythril Labrys', 'Normal/StandardItem', '1', '0', '0', '161040', '5616', '70442', '5009', '1', '0', '4', '0', '1', '38', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4040109', 'Ifrit\'s Battleaxe', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70491', '5009', '3', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040110', 'Lominsan Labrys', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70027', '5009', '2', '0', '4', '0', '1', '30', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4040111', 'Gridanian Labrys', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70520', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040201', 'Dated Iron Bhuj', 'Normal/StandardItem', '1', '0', '0', '175680', '5850', '70112', '5009', '1', '0', '4', '0', '0', '38', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4040202', 'Dated Engraved Bhuj', 'Normal/StandardItem', '1', '0', '0', '175680', '7350', '70113', '5009', '1', '0', '4', '0', '0', '48', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4040203', 'Elmlord\'s Tusk', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70421', '5009', '2', '0', '4', '0', '0', '30', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4040204', 'Lominsan Bhuj', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70428', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040205', 'Steel Bhuj', 'Normal/StandardItem', '1', '0', '0', '175680', '5250', '70443', '5009', '1', '0', '4', '0', '1', '34', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4040206', 'Mythril Bhuj', 'Normal/StandardItem', '1', '0', '0', '175680', '6300', '70421', '5009', '1', '0', '4', '0', '1', '41', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4040207', 'Demilune Bhuj', 'Normal/StandardItem', '1', '0', '0', '175680', '7350', '70428', '5009', '1', '0', '4', '0', '1', '48', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('4040208', 'Ul\'dahn Bhuj', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70113', '5009', '2', '0', '4', '0', '1', '40', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4040301', 'Dated Bronze Bardiche', 'Normal/StandardItem', '1', '0', '0', '131760', '6708', '70114', '5009', '1', '0', '4', '0', '0', '42', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4040302', 'Barbarian\'s Bardiche', 'Normal/StandardItem', '1', '1', '0', '131760', '7956', '70335', '5009', '2', '0', '4', '0', '0', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040303', 'Boar\'s Bane', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70334', '5009', '2', '0', '4', '0', '0', '35', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4040304', 'Steel Bardiche', 'Normal/StandardItem', '1', '0', '0', '131760', '4992', '70444', '5009', '1', '0', '4', '0', '1', '31', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4040305', 'Buccaneer\'s Bardiche', 'Normal/StandardItem', '1', '0', '0', '131760', '7176', '70445', '5009', '1', '0', '4', '0', '1', '45', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('4040306', 'Ul\'dahn Bardiche', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70445', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040401', 'Dated Iron Bill', 'Normal/StandardItem', '1', '0', '0', '131760', '6708', '70336', '5009', '1', '0', '4', '0', '0', '42', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('4040402', 'Vintage Bill', 'Normal/StandardItem', '1', '1', '0', '131760', '7488', '70338', '5009', '1', '0', '4', '0', '0', '47', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4040403', 'Notched Bill', 'Normal/StandardItem', '1', '1', '0', '65000', '1824', '70337', '5009', '1', '0', '4', '0', '0', '37', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('4040404', 'Canopus Bill', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70429', '5009', '3', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040405', 'Iron Bill', 'Normal/StandardItem', '1', '0', '0', '131760', '3744', '70336', '5009', '1', '0', '4', '0', '1', '23', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4040406', 'Lominsan Bill', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70514', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040407', 'Gridanian Bill', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70336', '5009', '2', '0', '4', '0', '1', '40', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4040408', 'Sibold\'s Reach', 'Normal/StandardItem', '1', '1', '0', '131760', '7956', '70531', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040501', 'Unfinished Bravura', 'Normal/StandardItem', '1', '1', '1', '65000', '0', '70621', '5009', '1', '0', '4', '0', '1', '50', '2121', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040502', 'Bravura', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70614', '5009', '4', '0', '4', '0', '1', '50', '2121', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040503', 'Rampager', 'Normal/StandardItem', '1', '0', '0', '161040', '7344', '70545', '5009', '2', '0', '4', '0', '1', '50', '2150', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040504', 'Storm Lieutenant\'s Labrys', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70592', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040505', 'Serpent Lieutenant\'s Bardiche', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70599', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040506', 'Flame Lieutenant\'s Axe', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70606', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040507', 'Garuda\'s Scream', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70538', '5009', '3', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040508', 'Storm Sergeant\'s Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70563', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040509', 'Serpent Sergeant\'s Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70564', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040510', 'Flame Sergeant\'s Axe', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70565', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4040511', 'Giantsgall War Axe', 'Normal/StandardItem', '1', '0', '0', '161040', '7344', '70628', '5009', '2', '0', '4', '0', '1', '50', '2132', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4050001', '[en]', 'Normal/StandardItem', '1', '0', '0', '97600', '200', '60000', '0', '1', '0', '5', '0', '0', '1', '2001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4060001', '[en]', 'Normal/StandardItem', '1', '0', '0', '97600', '200', '60000', '0', '1', '0', '6', '0', '0', '1', '2001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4070001', 'Weathered Shortbow', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70041', '5013', '1', '0', '7', '0', '0', '1', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070002', 'Dated Willow Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '952', '70038', '5013', '1', '0', '7', '0', '0', '6', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070003', 'Dated Elm Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '1632', '70039', '5013', '1', '0', '7', '0', '0', '11', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070004', 'Dated Plumed Willow Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '2992', '70040', '5013', '1', '0', '7', '0', '0', '21', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4070005', 'Dated Elm Velocity Bow', 'Normal/StandardItem', '1', '0', '0', '146400', '4352', '70115', '5013', '1', '0', '7', '0', '0', '31', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4070006', 'Maple Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '816', '70038', '5013', '1', '0', '7', '0', '1', '5', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070007', 'Bow of Owls', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70346', '5013', '2', '0', '7', '0', '0', '25', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4070008', 'Verdant Shortbow', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70347', '5013', '3', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070009', 'Plumed Maple Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '1496', '70040', '5013', '1', '0', '7', '0', '1', '10', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070010', 'Elm Shortbow', 'Normal/StandardItem', '1', '0', '0', '146400', '2312', '70039', '5013', '1', '0', '7', '0', '1', '16', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4070011', 'Elm Velocity Bow', 'Normal/StandardItem', '1', '0', '0', '146400', '2992', '70115', '5013', '1', '0', '7', '0', '1', '21', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4070012', 'Ul\'dahn Shortbow', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70115', '5013', '2', '0', '7', '0', '1', '40', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4070013', 'Gridanian Shortbow', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70346', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070101', 'Dated Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '2220', '70117', '5013', '1', '0', '7', '0', '0', '14', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('4070102', 'Dated Ironclad Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '3700', '70118', '5013', '1', '0', '7', '0', '0', '24', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('4070103', 'Dated Armored Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '5180', '70120', '5013', '1', '0', '7', '0', '0', '34', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4070104', 'Ash Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '4884', '70119', '5013', '1', '0', '7', '0', '1', '32', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4070105', 'Ul\'dahn Bow', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70120', '5013', '2', '0', '7', '0', '1', '30', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4070106', 'Mythril Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '5624', '70446', '5013', '1', '0', '7', '0', '1', '37', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('4070107', 'Cobalt Cavalry Bow', 'Normal/StandardItem', '1', '0', '0', '175680', '6512', '70447', '5013', '1', '0', '7', '0', '1', '43', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4070108', 'Lominsan Bow', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70447', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070201', 'Dated Maple Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '1260', '70042', '5013', '1', '0', '7', '0', '0', '8', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070202', 'Dated Ash Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '4060', '70043', '5013', '1', '0', '7', '0', '0', '28', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4070203', 'Dated Yew Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '6160', '70348', '5013', '1', '0', '7', '0', '0', '43', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4070204', 'Maple Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '1260', '70042', '5013', '1', '0', '7', '0', '1', '8', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4070205', 'Wrapped Maple Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '1960', '70044', '5013', '1', '0', '7', '0', '1', '13', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('4070206', 'Dated Wrapped Maple Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '2660', '70044', '5013', '1', '0', '7', '0', '0', '18', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('4070207', 'Dated Wrapped Ash Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '5460', '70045', '5013', '1', '0', '7', '0', '0', '38', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4070208', 'Ash Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '2800', '70043', '5013', '1', '0', '7', '0', '1', '19', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4070209', 'Kokoroon\'s Nestpicker', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70351', '5013', '2', '0', '7', '0', '0', '35', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4070210', 'Wrapped Ash Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '3500', '70045', '5013', '1', '0', '7', '0', '1', '24', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('4070211', 'Ul\'dahn Longbow', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70351', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070212', 'Oak Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '5040', '70448', '5013', '1', '0', '7', '0', '1', '35', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4070213', 'Yew Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '6580', '70348', '5013', '1', '0', '7', '0', '1', '46', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4070214', 'Mischievous Mogbow', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70500', '5013', '3', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070215', 'Gridanian Longbow', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70045', '5013', '2', '0', '7', '0', '1', '40', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4070301', 'Dated Willow Composite Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '3542', '70122', '5013', '1', '0', '7', '0', '0', '22', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('4070302', 'Dated Weevil Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '5082', '70281', '5013', '1', '0', '7', '0', '0', '32', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4070303', 'Dated Oak Composite Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '6622', '70121', '5013', '1', '0', '7', '0', '0', '42', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4070304', 'Dated Crab Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '7392', '70280', '5013', '1', '0', '7', '0', '0', '47', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('4070305', 'Joukil\'s Guile', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70354', '5013', '2', '0', '7', '0', '1', '30', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4070306', 'Ash Composite Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '4466', '70122', '5013', '1', '0', '7', '0', '1', '28', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4070307', 'Oak Composite Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '6314', '70121', '5013', '1', '0', '7', '0', '1', '40', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4070308', 'Crab Bow', 'Normal/StandardItem', '1', '0', '0', '190320', '7700', '70280', '5013', '1', '0', '7', '0', '1', '49', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4070309', 'Ifrit\'s Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70493', '5013', '3', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070310', 'Lominsan Composite Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70122', '5013', '2', '0', '7', '0', '1', '40', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4070311', 'Ul\'dahn Composite Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70123', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070312', 'Alesone\'s Songbow', 'Normal/StandardItem', '1', '1', '0', '190320', '7854', '70533', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070401', 'Unfinished Artemis Bow', 'Normal/StandardItem', '1', '1', '1', '65000', '0', '70623', '5013', '1', '0', '7', '0', '1', '50', '2122', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070402', 'Artemis Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70616', '5013', '4', '0', '7', '0', '1', '50', '2122', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070403', 'Sarnga', 'Normal/StandardItem', '1', '0', '0', '175680', '7548', '70547', '5013', '2', '0', '7', '0', '1', '50', '2151', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070404', 'Storm Lieutenant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70594', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070405', 'Serpent Lieutenant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70601', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070406', 'Flame Lieutenant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '190320', '0', '70608', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070407', 'Garuda\'s Spine', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70540', '5013', '3', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070408', 'Storm Sergeant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70581', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070409', 'Serpent Sergeant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70582', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070410', 'Flame Sergeant\'s Bow', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70583', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4070411', 'Giantsgall Longbow', 'Normal/StandardItem', '1', '0', '0', '161040', '7140', '70630', '5013', '2', '0', '7', '0', '1', '50', '2133', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080001', 'Dated Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '1360', '70124', '5014', '1', '0', '8', '0', '0', '9', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4080002', 'Dated Feathered Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '2040', '70125', '5014', '1', '0', '8', '0', '0', '14', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('4080003', 'Dated Tortoiseshell Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '4080', '70126', '5014', '1', '0', '8', '0', '0', '29', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4080004', 'Dated Yarzonshell Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '5440', '70127', '5014', '1', '0', '8', '0', '0', '39', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('4080005', 'Bone Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '816', '70124', '5014', '1', '0', '8', '0', '1', '5', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4080006', 'Crimson Tide', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70339', '5014', '2', '0', '8', '0', '0', '25', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4080007', 'Ifrit\'s Harpoon', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70492', '5014', '3', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080008', 'Feathered Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '1768', '70125', '5014', '1', '0', '8', '0', '1', '12', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('4080009', 'Yarzonshell Harpoon', 'Normal/StandardItem', '1', '0', '0', '131760', '5168', '70127', '5014', '1', '0', '8', '0', '1', '37', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('4080010', 'Gridanian Harpoon', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70028', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080011', 'Gerbald\'s Redspike', 'Normal/StandardItem', '1', '1', '0', '131760', '6936', '70029', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080101', 'Dated Iron Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '4408', '70030', '5014', '1', '0', '8', '0', '0', '28', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4080102', 'Dated Heavy Iron Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '5928', '70129', '5014', '1', '0', '8', '0', '0', '38', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('4080103', 'Dated Banneret Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '7448', '70031', '5014', '1', '0', '8', '0', '0', '48', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('4080104', 'Iron Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '3192', '70030', '5014', '1', '0', '8', '0', '1', '20', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('4080105', 'Heavy Steel Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '5320', '70449', '5014', '1', '0', '8', '0', '1', '34', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4080106', 'Mythril Lance', 'Normal/StandardItem', '1', '0', '0', '161040', '6232', '70450', '5014', '1', '0', '8', '0', '1', '40', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4080107', 'Lominsan Lance', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70032', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080108', '[en]', 'Normal/StandardItem', '1', '0', '0', '161040', '304', '60000', '5014', '1', '0', '8', '0', '0', '1', '2134', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4080109', 'Champion\'s Lance', 'Normal/StandardItem', '1', '1', '0', '161040', '7752', '70341', '5014', '2', '0', '8', '0', '0', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080110', 'Tidesplitter', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70129', '5014', '2', '0', '8', '0', '1', '30', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4080201', 'Weathered Spear', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70131', '5014', '1', '0', '8', '0', '0', '1', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4080202', 'Dated Bronze Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '980', '70033', '5014', '1', '0', '8', '0', '0', '6', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4080203', 'Dated Brass Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '2380', '70130', '5014', '1', '0', '8', '0', '0', '16', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4080204', 'Dated Iron Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '3780', '70034', '5014', '1', '0', '8', '0', '0', '26', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4080205', 'Bronze Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '1260', '70033', '5014', '1', '0', '8', '0', '1', '8', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4080206', 'Iron Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '2380', '70034', '5014', '1', '0', '8', '0', '1', '16', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4080207', 'Dated Battle Fork', 'Normal/StandardItem', '1', '0', '0', '146400', '5180', '70035', '5014', '1', '0', '8', '0', '0', '36', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('4080208', 'Silver Battle Fork', 'Normal/StandardItem', '1', '0', '0', '146400', '3780', '70451', '5014', '1', '0', '8', '0', '1', '26', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4080209', 'Steel Spear', 'Normal/StandardItem', '1', '0', '0', '146400', '4480', '70452', '5014', '1', '0', '8', '0', '1', '31', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4080210', 'Cobalt Trident', 'Normal/StandardItem', '1', '0', '0', '146400', '6580', '70453', '5014', '1', '0', '8', '0', '1', '46', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4080211', 'Lominsan Spear', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70130', '5014', '2', '0', '8', '0', '1', '30', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4080212', 'Melancholy Mogfork', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70499', '5014', '3', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080213', 'Gridanian Fork', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70035', '5014', '2', '0', '8', '0', '1', '40', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4080301', 'Dated Iron Halberd', 'Normal/StandardItem', '1', '0', '0', '175680', '8160', '70036', '5014', '1', '0', '8', '0', '0', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080302', 'Shellsplitter', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70422', '5014', '2', '0', '8', '0', '0', '35', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('4080303', 'Lominsan Halberd', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70430', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080304', 'Steel Halberd', 'Normal/StandardItem', '1', '0', '0', '175680', '4800', '70036', '5014', '1', '0', '8', '0', '1', '29', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4080305', 'Cobalt Halberd', 'Normal/StandardItem', '1', '0', '0', '175680', '7040', '70430', '5014', '1', '0', '8', '0', '1', '43', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4080306', 'Ul\'dahn Halberd', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70422', '5014', '2', '0', '8', '0', '1', '40', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4080401', 'Dated Iron Guisarme', 'Normal/StandardItem', '1', '0', '0', '139080', '4884', '70132', '5014', '1', '0', '8', '0', '0', '32', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4080402', 'Dated Jarl\'s Guisarme', 'Normal/StandardItem', '1', '0', '0', '139080', '6364', '70133', '5014', '1', '0', '8', '0', '0', '42', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4080403', 'Crooked Guisarme', 'Normal/StandardItem', '1', '1', '0', '65000', '1824', '70345', '5014', '1', '0', '8', '0', '0', '37', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('4080404', 'Vintage Guisarme', 'Normal/StandardItem', '1', '1', '0', '139080', '7104', '70345', '5014', '1', '0', '8', '0', '0', '47', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('4080405', 'Canopus Guisarme', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70344', '5014', '3', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080406', 'Iron Guisarme', 'Normal/StandardItem', '1', '0', '0', '139080', '3552', '70345', '5014', '1', '0', '8', '0', '1', '23', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4080407', 'Hart Guisarme', 'Normal/StandardItem', '1', '0', '0', '139080', '7400', '70454', '5014', '1', '0', '8', '0', '1', '49', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4080408', 'Lominsan Guisarme', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70133', '5014', '2', '0', '8', '0', '1', '40', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4080409', 'Ul\'dahn Guisarme', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70517', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080501', 'Unfinished Gae Bolg', 'Normal/StandardItem', '1', '1', '1', '65000', '0', '70622', '5014', '1', '0', '8', '0', '1', '50', '2123', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080502', 'Gae Bolg', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70615', '5014', '4', '0', '8', '0', '1', '50', '2123', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080503', 'Obelisk', 'Normal/StandardItem', '1', '0', '0', '146400', '7140', '70546', '5014', '2', '0', '8', '0', '1', '50', '2152', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080504', 'Storm Lieutenant\'s Trident', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70593', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080505', 'Serpent Lieutenant\'s Spear', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70600', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080506', 'Flame Lieutenant\'s Spear', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70607', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080507', 'Garuda\'s Beak', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70539', '5014', '3', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080508', 'Storm Sergeant\'s Spear', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70566', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080509', 'Serpent Sergeant\'s Spear', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70567', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080510', 'Flame Sergeant\'s Spear', 'Normal/StandardItem', '1', '1', '1', '139080', '0', '70568', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4080511', 'Giantsgall Trident', 'Normal/StandardItem', '1', '0', '0', '146400', '7140', '70629', '5014', '2', '0', '8', '0', '1', '50', '2134', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4090001', '[en]', 'Normal/StandardItem', '1', '0', '0', '97600', '200', '60000', '0', '1', '0', '9', '0', '0', '1', '2001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4100001', 'Dated Leather Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '3828', '70135', '5003', '1', '0', '10', '0', '0', '32', '2105', '38', '52', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4100002', 'Dated Sheepskin Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '2088', '70134', '5003', '1', '0', '10', '0', '0', '17', '2105', '15', '22', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('4100003', 'Dated Raptorskin Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '5568', '70141', '5003', '1', '0', '10', '0', '0', '47', '2105', '64', '86', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4100004', 'Thalassian Targe', 'Normal/ShieldItem', '1', '1', '1', '43920', '0', '70299', '5003', '2', '0', '10', '0', '0', '25', '2105', '28', '38', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4100005', 'Gridanian Targe', 'Normal/ShieldItem', '1', '1', '1', '43920', '0', '70138', '5003', '2', '0', '10', '0', '1', '30', '2005', '37', '51', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4100006', 'Sheepskin Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '1508', '70134', '5003', '1', '0', '10', '0', '1', '12', '2105', '12', '17', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('4100007', 'Leather Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '3364', '70135', '5003', '1', '0', '10', '0', '1', '28', '2105', '33', '49', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('4100008', 'Raptorskin Targe', 'Normal/ShieldItem', '1', '0', '0', '43920', '4988', '70141', '5003', '1', '0', '10', '0', '1', '42', '2105', '56', '81', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('4100101', 'Dated Round Chestnut Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '1440', '70001', '5003', '1', '0', '10', '0', '0', '11', '2106', '9', '14', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100102', 'Dated Round Oak Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '3840', '70002', '5003', '1', '0', '10', '0', '0', '31', '2106', '34', '49', '0', '0', '0', '-1', '29', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4100103', 'Vintage Round Shield', 'Normal/ShieldItem', '1', '1', '0', '41480', '5640', '70282', '5003', '1', '0', '10', '0', '0', '46', '2106', '60', '86', '0', '0', '0', '-1', '29', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('4100104', 'Dated Warded Round Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '2640', '70142', '5003', '1', '0', '10', '0', '0', '21', '2106', '18', '27', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4100105', 'Dated Serpent Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '5040', '70143', '5003', '1', '0', '10', '0', '0', '41', '2106', '47', '68', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('4100106', 'Round Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '1320', '70001', '5003', '1', '0', '10', '0', '1', '10', '2117', '10', '14', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100107', '[en]', 'Normal/ShieldItem', '1', '0', '0', '41480', '240', '60000', '5003', '1', '0', '10', '0', '0', '1', '2106', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4100108', 'Rotting Round Shield', 'Normal/ShieldItem', '1', '1', '0', '41480', '3240', '70283', '5003', '1', '0', '10', '0', '0', '26', '2106', '22', '33', '0', '0', '0', '-1', '29', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('4100109', 'Gridanian Shield', 'Normal/ShieldItem', '1', '1', '1', '41480', '0', '70142', '5003', '2', '0', '10', '0', '1', '50', '2108', '66', '97', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100110', 'Viper-crested Round Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '3120', '70143', '5003', '1', '0', '10', '0', '1', '25', '2117', '29', '39', '0', '0', '0', '-1', '29', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('4100111', 'Eagle-crested Round Shield', 'Normal/ShieldItem', '1', '0', '0', '41480', '5520', '70301', '5003', '1', '0', '10', '0', '1', '45', '2117', '64', '87', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('4100112', 'Ul\'dahn Round Shield', 'Normal/ShieldItem', '1', '1', '1', '41480', '0', '70002', '5003', '2', '0', '10', '0', '1', '40', '2108', '64', '82', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4100201', 'Scarred Kite Shield', 'Normal/ShieldItem', '1', '1', '0', '27000', '1476', '70304', '5003', '1', '0', '10', '0', '0', '40', '2106', '23', '56', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4100202', 'Vintage Kite Shield', 'Normal/ShieldItem', '1', '1', '0', '58560', '8160', '70303', '5003', '1', '0', '10', '0', '0', '50', '2106', '120', '92', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100203', 'Canopus Shield', 'Normal/ShieldItem', '1', '1', '1', '58560', '0', '70424', '5003', '3', '0', '10', '0', '1', '50', '2106', '122', '94', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100204', 'Kite Shield', 'Normal/ShieldItem', '1', '0', '0', '58560', '7840', '70455', '5003', '1', '0', '10', '0', '1', '48', '2106', '119', '91', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('4100205', 'Lominsan Kite Shield', 'Normal/ShieldItem', '1', '1', '1', '58560', '0', '70303', '5003', '2', '0', '10', '0', '1', '40', '2106', '89', '72', '0', '0', '0', '-1', '31', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4100206', 'Thormoen\'s Purpose', 'Normal/ShieldItem', '1', '1', '0', '58560', '8160', '70529', '5003', '2', '0', '10', '0', '1', '50', '2106', '122', '95', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100301', 'Dated Bronze Scutum', 'Normal/ShieldItem', '1', '0', '0', '56120', '4350', '70003', '5003', '1', '0', '10', '0', '0', '28', '2106', '58', '37', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4100302', 'Dated Iron Scutum', 'Normal/ShieldItem', '1', '0', '0', '56120', '5850', '70144', '5003', '1', '0', '10', '0', '0', '38', '2106', '83', '54', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('4100303', 'Dated Decorated Iron Scutum', 'Normal/ShieldItem', '1', '0', '0', '56120', '7350', '70145', '5003', '1', '0', '10', '0', '0', '48', '2106', '116', '75', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('4100304', 'Rusting Scutum', 'Normal/ShieldItem', '1', '1', '0', '56120', '3450', '70144', '5003', '1', '0', '10', '0', '0', '22', '2106', '35', '22', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('4100305', 'Vintage Scutum', 'Normal/ShieldItem', '1', '1', '0', '56120', '6450', '70284', '5003', '1', '0', '10', '0', '0', '42', '2106', '101', '65', '0', '0', '0', '-1', '31', '10013005', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('4100306', 'Ul\'dahn Scutum', 'Normal/ShieldItem', '1', '1', '1', '56120', '0', '70425', '5003', '2', '0', '10', '0', '1', '50', '2106', '131', '84', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100307', 'Iron Scutum', 'Normal/ShieldItem', '1', '0', '0', '56120', '3600', '70144', '5003', '1', '0', '10', '0', '1', '23', '2106', '47', '30', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4100308', 'Decorated Iron Scutum', 'Normal/ShieldItem', '1', '0', '0', '56120', '5550', '70145', '5003', '1', '0', '10', '0', '1', '36', '2106', '86', '56', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('4100401', 'Dated Lantern Shield', 'Normal/ShieldItem', '1', '0', '0', '53680', '5040', '70146', '5003', '1', '0', '10', '0', '0', '34', '2105', '50', '54', '0', '0', '0', '-1', '31', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4100402', 'Dated Bladed Lantern Shield', 'Normal/ShieldItem', '1', '0', '0', '53680', '6480', '70147', '5003', '1', '0', '10', '0', '0', '44', '2105', '70', '75', '0', '0', '0', '-1', '30', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('4100403', 'Ul\'dahn Shield', 'Normal/ShieldItem', '1', '1', '1', '53680', '0', '70146', '5003', '2', '0', '10', '0', '1', '30', '2105', '45', '48', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4100404', 'Bladed Lantern Shield', 'Normal/ShieldItem', '1', '0', '0', '53680', '5760', '70456', '5003', '1', '0', '10', '0', '1', '39', '2106', '57', '70', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('4100405', 'Lominsan Lantern Shield', 'Normal/ShieldItem', '1', '1', '1', '53680', '0', '70515', '5003', '2', '0', '10', '0', '1', '50', '2106', '86', '126', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100501', 'Dated Bronze Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '1960', '70004', '5003', '1', '0', '10', '0', '0', '13', '2105', '13', '16', '0', '0', '0', '-1', '31', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('4100502', 'Dated Ironclad Bronze Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '3360', '70005', '5003', '1', '0', '10', '0', '0', '23', '2105', '25', '31', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('4100503', 'Dated Decorated Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '4760', '70006', '5003', '1', '0', '10', '0', '0', '33', '2105', '45', '52', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('4100504', 'Bronze Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '2100', '70004', '5003', '1', '0', '10', '0', '1', '14', '2118', '14', '19', '0', '0', '0', '-1', '31', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('4100505', 'Ironclad Bronze Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '3080', '70005', '5003', '1', '0', '10', '0', '1', '21', '2118', '23', '30', '0', '0', '0', '-1', '31', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('4100506', 'Decorated Buckler', 'Normal/ShieldItem', '1', '0', '0', '48800', '4900', '70006', '5003', '1', '0', '10', '0', '1', '34', '2118', '47', '60', '0', '0', '0', '-1', '32', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('4100507', 'Gridanian Buckler', 'Normal/ShieldItem', '1', '1', '1', '48800', '0', '70522', '5003', '2', '0', '10', '0', '1', '50', '2118', '71', '168', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100508', 'Warlock\'s Buckler', 'Normal/ShieldItem', '1', '1', '1', '48800', '0', '70426', '5003', '2', '0', '10', '0', '1', '50', '2107', '83', '98', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100509', '[en]', 'Normal/ShieldItem', '1', '0', '0', '48800', '280', '60000', '5003', '1', '0', '10', '0', '0', '1', '2105', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4100510', 'Notched Buckler', 'Normal/ShieldItem', '1', '1', '0', '48800', '2380', '70285', '5003', '1', '0', '10', '0', '0', '16', '2105', '14', '18', '0', '0', '0', '-1', '31', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('4100511', 'Vintage Buckler', 'Normal/ShieldItem', '1', '1', '0', '48800', '5180', '70004', '5003', '1', '0', '10', '0', '0', '36', '2105', '51', '60', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('4100601', 'Dated Square Maple Shield', 'Normal/ShieldItem', '1', '0', '0', '39040', '660', '70148', '5003', '1', '0', '10', '0', '0', '5', '2105', '8', '8', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100602', 'Dated Square Ash Shield', 'Normal/ShieldItem', '1', '0', '0', '39040', '1760', '70150', '5003', '1', '0', '10', '0', '0', '15', '2105', '18', '17', '0', '0', '0', '-1', '29', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('4100603', 'Shield of the Savage', 'Normal/ShieldItem', '1', '1', '1', '39040', '0', '70149', '5003', '2', '0', '10', '0', '0', '30', '2105', '48', '48', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4100604', 'Square Maple Shield', 'Normal/ShieldItem', '1', '0', '0', '39040', '660', '70148', '5003', '1', '0', '10', '0', '1', '5', '2105', '9', '9', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100605', 'Square Ash Shield', 'Normal/ShieldItem', '1', '0', '0', '39040', '1980', '70150', '5003', '1', '0', '10', '0', '1', '17', '2105', '21', '23', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('4100606', 'Worm-eaten Square Shield', 'Normal/ShieldItem', '1', '1', '0', '39040', '1210', '70286', '5003', '1', '0', '10', '0', '0', '10', '2105', '11', '11', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100607', 'Vintage Square Shield', 'Normal/ShieldItem', '1', '1', '0', '39040', '2310', '70148', '5003', '1', '0', '10', '0', '0', '20', '2105', '26', '26', '0', '0', '0', '-1', '29', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('4100608', 'Gridanian Square Shield', 'Normal/ShieldItem', '1', '1', '1', '39040', '0', '70153', '5003', '2', '0', '10', '0', '1', '40', '2105', '46', '68', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('4100609', 'Aubriest\'s Allegory', 'Normal/ShieldItem', '1', '1', '0', '39040', '5280', '70526', '5003', '2', '0', '10', '0', '1', '47', '2005', '58', '75', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('4100701', 'Dated Bronze Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '1240', '70155', '5003', '1', '0', '10', '0', '0', '9', '2106', '12', '11', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100702', 'Dated Bronze Pelta', 'Normal/ShieldItem', '1', '0', '0', '51240', '2480', '70156', '5003', '1', '0', '10', '0', '0', '19', '2106', '26', '22', '0', '0', '0', '-1', '31', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4100703', 'Dated Iron Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '3720', '70157', '5003', '1', '0', '10', '0', '0', '29', '2106', '48', '41', '0', '0', '0', '-1', '31', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('4100704', 'Dated Iron Pelta', 'Normal/ShieldItem', '1', '0', '0', '51240', '4960', '70158', '5003', '1', '0', '10', '0', '0', '39', '2106', '69', '58', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('4100705', 'Dated Bull Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '6200', '70159', '5003', '1', '0', '10', '0', '0', '49', '2106', '97', '82', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('4100706', 'Tarnished Hoplon', 'Normal/ShieldItem', '1', '1', '0', '51240', '1860', '70287', '5003', '1', '0', '10', '0', '0', '14', '2106', '16', '14', '0', '0', '0', '-1', '31', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('4100707', 'Vintage Hoplon', 'Normal/ShieldItem', '1', '1', '0', '51240', '3100', '70155', '5003', '1', '0', '10', '0', '0', '24', '2106', '38', '32', '0', '0', '0', '-1', '31', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('4100708', 'Waning Sun Pelta', 'Normal/ShieldItem', '1', '1', '1', '51240', '0', '70158', '5003', '2', '0', '10', '0', '1', '30', '2106', '53', '45', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('4100709', 'Bronze Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '1116', '70155', '5003', '1', '0', '10', '0', '1', '8', '2106', '13', '11', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100710', 'Iron Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '2480', '70157', '5003', '1', '0', '10', '0', '1', '19', '2106', '28', '24', '0', '0', '0', '-1', '31', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('4100711', 'Bull Hoplon', 'Normal/ShieldItem', '1', '0', '0', '51240', '3968', '70159', '5003', '1', '0', '10', '0', '1', '31', '2106', '57', '49', '0', '0', '0', '-1', '31', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('4100712', 'Ul\'dahn Hoplon', 'Normal/ShieldItem', '1', '1', '1', '51240', '0', '70309', '5003', '2', '0', '10', '0', '1', '50', '2106', '107', '131', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100713', 'Scorpion Shield', 'Normal/ShieldItem', '1', '1', '0', '51240', '6076', '70527', '5003', '2', '0', '10', '0', '1', '48', '2106', '92', '125', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('4100801', 'Maelstrom Escutcheon', 'Normal/ShieldItem', '1', '1', '1', '39040', '0', '70523', '5003', '3', '0', '10', '0', '0', '1', '2105', '15', '15', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100802', 'Immortal Flames Escutcheon', 'Normal/ShieldItem', '1', '1', '1', '39040', '0', '70524', '5003', '3', '0', '10', '0', '0', '1', '2105', '15', '15', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100803', 'Twin Adder Escutcheon', 'Normal/ShieldItem', '1', '1', '1', '39040', '0', '70525', '5003', '3', '0', '10', '0', '0', '1', '2105', '15', '15', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('4100804', 'Storm Sergeant\'s Targe', 'Normal/ShieldItem', '1', '1', '1', '43920', '0', '70560', '5003', '2', '0', '10', '0', '1', '50', '2105', '70', '94', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100805', 'Storm Sergeant\'s Hoplon', 'Normal/ShieldItem', '1', '1', '1', '51240', '0', '70578', '5003', '2', '0', '10', '0', '1', '50', '2106', '106', '132', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100806', 'Serpent Sergeant\'s Targe', 'Normal/ShieldItem', '1', '1', '1', '43920', '0', '70561', '5003', '2', '0', '10', '0', '1', '50', '2105', '70', '94', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100807', 'Serpent Sergeant\'s Hoplon', 'Normal/ShieldItem', '1', '1', '1', '51240', '0', '70579', '5003', '2', '0', '10', '0', '1', '50', '2106', '108', '130', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100808', 'Flame Sergeant\'s Targe', 'Normal/ShieldItem', '1', '1', '1', '43920', '0', '70562', '5003', '2', '0', '10', '0', '1', '50', '2105', '70', '94', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100809', 'Flame Sergeant\'s Shield', 'Normal/ShieldItem', '1', '1', '1', '53680', '0', '70580', '5003', '2', '0', '10', '0', '1', '50', '2106', '85', '127', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100810', 'Holy Shield', 'Normal/ShieldItem', '1', '1', '1', '58560', '0', '70612', '5003', '4', '0', '10', '0', '1', '50', '2120', '138', '100', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('4100811', '[en]', 'Normal/ShieldItem', '1', '0', '0', '41480', '240', '60000', '5003', '1', '0', '10', '0', '0', '1', '2106', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4100812', '[en]', 'Normal/ShieldItem', '1', '0', '0', '41480', '240', '60000', '5003', '1', '0', '10', '0', '0', '1', '2106', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('4100813', '[en]', 'Normal/ShieldItem', '1', '0', '0', '41480', '240', '60000', '5003', '1', '0', '10', '0', '0', '1', '2106', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('5010001', '[en]', 'Normal/StandardItem', '1', '0', '0', '0', '0', '60000', '0', '1', '0', '21', '0', '0', '1', '2001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('5020001', 'Weathered Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70160', '5105', '1', '0', '22', '0', '0', '1', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020002', 'Dated Copper Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '812', '70061', '5105', '1', '0', '22', '0', '0', '6', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020003', 'Dated Decorated Copper Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '1392', '70062', '5105', '1', '0', '22', '0', '0', '11', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020004', 'Dated Silver Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '2552', '70063', '5105', '1', '0', '22', '0', '0', '21', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('5020005', 'Dated Decorated Silver Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '3712', '70064', '5105', '1', '0', '22', '0', '0', '31', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('5020006', 'Dated Ornate Silver Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '4872', '70065', '5105', '1', '0', '22', '0', '0', '41', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('5020007', 'Copper Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '1160', '70061', '5105', '1', '0', '22', '0', '1', '9', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020008', 'Decorated Copper Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '2204', '70062', '5105', '1', '0', '22', '0', '1', '18', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('5020009', 'Verdant Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70356', '5105', '3', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020010', 'Silver Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '3364', '70063', '5105', '1', '0', '22', '0', '1', '28', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('5020011', 'Decorated Silver Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '3944', '70064', '5105', '1', '0', '22', '0', '1', '33', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('5020012', 'Electrum Scepter', 'Normal/StandardItem', '1', '0', '0', '107360', '5104', '70065', '5105', '1', '0', '22', '0', '1', '43', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('5020013', 'Lominsan Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70357', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020014', 'Gridanian Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70064', '5105', '2', '0', '22', '0', '1', '40', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5020101', 'Dated Bone Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '852', '70167', '5106', '1', '0', '22', '0', '0', '5', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020102', 'Dated Decorated Bone Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '2272', '70168', '5106', '1', '0', '22', '0', '0', '15', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('5020103', 'Dated Horn Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '3692', '70169', '5106', '1', '0', '22', '0', '0', '25', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5020104', 'Aubriest\'s Whisper', 'Normal/StandardItem', '1', '1', '0', '146400', '7242', '70535', '5106', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020105', 'Dated Decorated Horn Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '5112', '70170', '5106', '1', '0', '22', '0', '0', '35', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5020106', 'Bone Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '852', '70167', '5106', '1', '0', '22', '0', '1', '5', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5020107', 'Taurus Staff', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70171', '5106', '2', '0', '22', '0', '0', '30', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5020108', 'Decorated Bone Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '1846', '70168', '5106', '1', '0', '22', '0', '1', '12', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('5020109', 'Horn Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '5680', '70170', '5106', '1', '0', '22', '0', '1', '39', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('5020110', 'Ivory Staff', 'Normal/StandardItem', '1', '0', '0', '146400', '7100', '70365', '5106', '1', '0', '22', '0', '1', '49', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('5020111', 'Maleficent Mogstaff', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70501', '5106', '3', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020112', 'Lominsan Staff', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70171', '5106', '2', '0', '22', '0', '1', '40', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5020113', 'Gridanian Staff', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70521', '5106', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020114', 'Tenfinger Tallstaff', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70169', '5106', '2', '0', '22', '0', '1', '30', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5020115', '[en]', 'Normal/StandardItem', '1', '0', '0', '146400', '284', '60000', '5106', '1', '0', '22', '0', '0', '1', '2135', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('5020201', 'Dated Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '2496', '70161', '5105', '1', '0', '22', '0', '0', '23', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('5020202', 'Dated Wind Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70162', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5020203', 'Dated Earth Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70163', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5020204', 'Dated Lightning Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70164', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('5020205', 'Dated Ice Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70288', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5020206', 'Dated Fire Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70289', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5020207', 'Dated Water Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4576', '70290', '5105', '1', '0', '22', '0', '0', '43', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('5020208', 'Anathema', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70362', '5105', '2', '0', '22', '0', '0', '35', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5020209', 'Lominsan Brand', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70289', '5105', '2', '0', '22', '0', '1', '30', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5020210', 'Wind Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '2288', '70162', '5105', '1', '0', '22', '0', '1', '21', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('5020211', 'Ice Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '2808', '70288', '5105', '1', '0', '22', '0', '1', '26', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('5020212', 'Earth Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '3328', '70163', '5105', '1', '0', '22', '0', '1', '31', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('5020213', 'Fire Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '3848', '70289', '5105', '1', '0', '22', '0', '1', '36', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('5020214', 'Lightning Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4368', '70164', '5105', '1', '0', '22', '0', '1', '41', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('5020215', 'Water Brand', 'Normal/StandardItem', '1', '0', '0', '87840', '4888', '70290', '5105', '1', '0', '22', '0', '1', '46', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('5020216', 'Ifrit\'s Cudgel', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70495', '5105', '3', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020217', 'Ul\'dahn Brand', 'Normal/StandardItem', '1', '1', '1', '87840', '0', '70164', '5105', '2', '0', '22', '0', '1', '40', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5020301', 'Dated Brass Cudgel', 'Normal/StandardItem', '1', '0', '0', '117120', '1980', '70166', '5105', '1', '0', '22', '0', '0', '17', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5020302', 'Dated Iron Cudgel', 'Normal/StandardItem', '1', '0', '0', '117120', '4180', '70165', '5105', '1', '0', '22', '0', '0', '37', '2135', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('5020303', 'Vintage Cudgel', 'Normal/StandardItem', '1', '1', '0', '117120', '4950', '70165', '5105', '1', '0', '22', '0', '0', '44', '2135', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('5020304', 'Damaged Cudgel', 'Normal/StandardItem', '1', '1', '0', '45000', '1260', '70363', '5105', '1', '0', '22', '0', '0', '34', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('5020305', 'Lominsan Cudgel', 'Normal/StandardItem', '1', '1', '1', '117120', '0', '70431', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020306', 'Brass Cudgel', 'Normal/StandardItem', '1', '0', '0', '117120', '1760', '70166', '5105', '1', '0', '22', '0', '1', '15', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('5020307', 'Ul\'dahn Cudgel', 'Normal/StandardItem', '1', '1', '1', '117120', '0', '70518', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020401', 'Unfinished Stardust Rod', 'Normal/StandardItem', '1', '1', '1', '55000', '0', '70624', '5106', '1', '0', '22', '0', '1', '50', '2124', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020402', 'Stardust Rod', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70617', '5106', '4', '0', '22', '0', '1', '50', '2124', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020403', 'Astrolabe', 'Normal/StandardItem', '1', '0', '0', '146400', '7242', '70548', '5106', '2', '0', '22', '0', '1', '50', '2153', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020404', 'Storm Lieutenant\'s Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70595', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020405', 'Serpent Lieutenant\'s Scepter', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70602', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020406', 'Flame Lieutenant\'s Cudgel', 'Normal/StandardItem', '1', '1', '1', '107360', '0', '70609', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020407', 'Garuda\'s Van', 'Normal/StandardItem', '1', '1', '1', '146400', '0', '70541', '5106', '3', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020408', 'Storm Sergeant\'s Cudgel', 'Normal/StandardItem', '1', '1', '1', '117120', '0', '70586', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020409', 'Serpent Sergeant\'s Cudgel', 'Normal/StandardItem', '1', '1', '1', '117120', '0', '70587', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020410', 'Flame Sergeant\'s Cudgel', 'Normal/StandardItem', '1', '1', '1', '117120', '0', '70588', '5105', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5020411', 'Giantsgall Longstaff', 'Normal/StandardItem', '1', '0', '0', '146400', '7242', '70632', '5106', '2', '0', '22', '0', '1', '50', '2135', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030001', 'Dated Maple Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '784', '70172', '5107', '1', '0', '23', '0', '0', '7', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030002', 'Dated Willow Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '1127', '70173', '5107', '1', '0', '23', '0', '0', '22', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('5030003', 'Maple Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '588', '70172', '5107', '1', '0', '23', '0', '1', '5', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030004', 'Dated Budding Maple Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '1274', '70174', '5107', '1', '0', '23', '0', '0', '12', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('5030005', 'Dated Budding Walnut Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '4214', '70175', '5107', '1', '0', '23', '0', '0', '42', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5030006', 'Budding Maple Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '1176', '70174', '5107', '1', '0', '23', '0', '1', '11', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030007', 'Yew Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '2940', '70291', '5107', '1', '0', '23', '0', '1', '29', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('5030008', 'Dated Maple Wand of Flames', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70176', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030009', 'Dated Maple Wand of Gales', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70177', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030010', 'Dated Maple Wand of Storms', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70178', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030011', 'Dated Maple Wand of Tremors', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70179', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030012', 'Dated Maple Wand of Tides', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70180', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030013', 'Dated Maple Wand of Frost', 'Normal/StandardItem', '1', '0', '0', '97600', '1764', '70181', '5107', '1', '0', '23', '0', '0', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030014', 'Dated Walnut Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '3724', '70291', '5107', '1', '0', '23', '0', '0', '37', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('5030015', 'Dated Budding Willow Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '2744', '70292', '5107', '1', '0', '23', '0', '0', '27', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5030016', 'Dated Willow Wand of Flames', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70176', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030017', 'Dated Willow Wand of Gales', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70177', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030018', 'Dated Willow Wand of Storms', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70178', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030019', 'Dated Willow Wand of Tremors', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70179', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030020', 'Dated Willow Wand of Tides', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70180', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030021', 'Dated Willow Wand of Frost', 'Normal/StandardItem', '1', '0', '0', '97600', '3234', '70181', '5107', '1', '0', '23', '0', '0', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030022', 'Dated Walnut Wand of Flames', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70176', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030023', 'Dated Walnut Wand of Gales', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70177', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030024', 'Dated Walnut Wand of Storms', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70178', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030025', 'Dated Walnut Wand of Tremors', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70179', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030026', 'Dated Walnut Wand of Tides', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70180', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030027', 'Dated Walnut Wand of Frost', 'Normal/StandardItem', '1', '0', '0', '97600', '4704', '70181', '5107', '1', '0', '23', '0', '0', '47', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030028', 'Gridanian Wand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70177', '5107', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030029', 'Budding Yew Wand', 'Normal/StandardItem', '1', '0', '0', '97600', '3528', '70175', '5107', '1', '0', '23', '0', '1', '35', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5030030', 'Wand of Tremors', 'Normal/StandardItem', '1', '0', '0', '97600', '4214', '70179', '5107', '1', '0', '23', '0', '1', '42', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('5030031', 'Wand of Tides', 'Normal/StandardItem', '1', '0', '0', '97600', '4214', '70180', '5107', '1', '0', '23', '0', '1', '42', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('5030032', 'Wand of Frost', 'Normal/StandardItem', '1', '0', '0', '97600', '4214', '70181', '5107', '1', '0', '23', '0', '1', '42', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('5030033', 'Wand of Flames', 'Normal/StandardItem', '1', '0', '0', '97600', '4802', '70176', '5107', '1', '0', '23', '0', '1', '48', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('5030034', 'Wand of Gales', 'Normal/StandardItem', '1', '0', '0', '97600', '4802', '70177', '5107', '1', '0', '23', '0', '1', '48', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('5030035', 'Wand of Storms', 'Normal/StandardItem', '1', '0', '0', '97600', '4802', '70178', '5107', '1', '0', '23', '0', '1', '48', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('5030036', 'Malevolent Mogwand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70502', '5107', '3', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030037', 'Ul\'dahn Wand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70292', '5107', '2', '0', '23', '0', '1', '40', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5030101', 'Weathered Cane', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70186', '5108', '1', '0', '23', '0', '0', '1', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030102', 'Dated Ash Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '980', '70067', '5108', '1', '0', '23', '0', '0', '6', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030103', 'Dated Elm Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '1680', '70068', '5108', '1', '0', '23', '0', '0', '11', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('5030104', 'Dated Pastoral Elm Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '3080', '70069', '5108', '1', '0', '23', '0', '0', '21', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('5030105', 'Dated Oak Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '4480', '70070', '5108', '1', '0', '23', '0', '0', '31', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('5030106', 'Dated Pastoral Oak Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '5880', '70071', '5108', '1', '0', '23', '0', '0', '41', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('5030107', 'Elm Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '2520', '70068', '5108', '1', '0', '23', '0', '1', '17', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030108', 'Astaroth Cane', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70072', '5108', '3', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030109', 'Pastoral Oak Cane', 'Normal/StandardItem', '1', '0', '0', '161040', '5460', '70071', '5108', '1', '0', '23', '0', '1', '38', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('5030110', 'Ifrit\'s Cane', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70494', '5108', '3', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030111', 'Lominsan Cane', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70374', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030112', 'Bloodcry', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70374', '5108', '2', '0', '23', '0', '0', '35', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5030113', 'Gridanian Cane', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70069', '5108', '2', '0', '23', '0', '1', '40', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5030201', 'Dated Pine Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '2584', '70182', '5108', '1', '0', '23', '0', '0', '18', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('5030202', 'Dated Plumed Pine Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '3264', '70183', '5108', '1', '0', '23', '0', '0', '23', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('5030203', 'Dated Yew Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '5304', '70184', '5108', '1', '0', '23', '0', '0', '38', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('5030204', 'Dated Plumed Yew Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '5984', '70185', '5108', '1', '0', '23', '0', '0', '43', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('5030205', 'Dated Jade Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '6664', '70377', '5108', '1', '0', '23', '0', '0', '48', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('5030206', 'Gridanian Crook', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70183', '5108', '2', '0', '23', '0', '1', '30', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5030207', 'Yew Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '3536', '70184', '5108', '1', '0', '23', '0', '1', '25', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5030208', 'Plumed Yew Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '4488', '70185', '5108', '1', '0', '23', '0', '1', '32', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('5030209', 'Jade Crook', 'Normal/StandardItem', '1', '0', '0', '175680', '6256', '70377', '5108', '1', '0', '23', '0', '1', '45', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('5030210', 'Ul\'dahn Crook', 'Normal/StandardItem', '1', '1', '1', '175680', '0', '70378', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030301', 'Dated Mahogany Radical', 'Normal/StandardItem', '1', '0', '0', '131760', '3796', '70187', '5108', '1', '0', '23', '0', '0', '25', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('5030302', 'Dated Flambeau Radical', 'Normal/StandardItem', '1', '0', '0', '131760', '5256', '70293', '5108', '1', '0', '23', '0', '0', '35', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('5030303', 'Dated Sprouting Radical', 'Normal/StandardItem', '1', '0', '0', '131760', '5694', '70189', '5108', '1', '0', '23', '0', '0', '38', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('5030304', 'Kple Kple', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70380', '5108', '2', '0', '23', '0', '0', '30', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5030305', 'Heart of House d\'Arlendre', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70293', '5108', '2', '0', '23', '0', '1', '30', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('5030306', 'Yew Radical', 'Normal/StandardItem', '1', '0', '0', '131760', '3212', '70188', '5108', '1', '0', '23', '0', '1', '21', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('5030307', 'Lominsan Radical', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70189', '5108', '2', '0', '23', '0', '1', '40', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('5030308', 'Gridanian Radical', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70384', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030309', 'Chiran Zabran\'s Tempest', 'Normal/StandardItem', '1', '1', '0', '131760', '7446', '70534', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030401', 'Unfinished Thyrus', 'Normal/StandardItem', '1', '1', '1', '55000', '0', '70625', '5108', '1', '0', '23', '0', '1', '50', '2125', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030402', 'Thyrus', 'Normal/StandardItem', '1', '1', '1', '161040', '0', '70618', '5108', '4', '0', '23', '0', '1', '50', '2125', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030403', 'Alkalurops', 'Normal/StandardItem', '1', '0', '0', '131760', '7446', '70549', '5108', '2', '0', '23', '0', '1', '50', '2154', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030404', 'Storm Lieutenant\'s Wand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70596', '5107', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030405', 'Serpent Lieutenant\'s Wand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70603', '5107', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030406', 'Flame Lieutenant\'s Wand', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70610', '5107', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030407', 'Garuda\'s Wile', 'Normal/StandardItem', '1', '1', '1', '97600', '0', '70542', '5107', '3', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030408', 'Storm Sergeant\'s Radical', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70293', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030409', 'Serpent Sergeant\'s Radical', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70584', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030410', 'Flame Sergeant\'s Radical', 'Normal/StandardItem', '1', '1', '1', '131760', '0', '70585', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5030411', 'Giantsgall Cane', 'Normal/StandardItem', '1', '0', '0', '131760', '7446', '70631', '5108', '2', '0', '23', '0', '1', '50', '2136', '0', '0', '0', '0', '0', '-1', '35', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('5040001', '[en]', 'Normal/StandardItem', '1', '0', '0', '0', '0', '60000', '0', '1', '0', '24', '0', '0', '1', '2001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('6010001', 'Weathered Saw', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70190', '6003', '1', '0', '29', '0', '0', '1', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6010002', 'Dated Bronze Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '880', '70191', '6003', '1', '0', '29', '0', '0', '7', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6010003', 'Dated Iron Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '2530', '70193', '6003', '1', '0', '29', '0', '0', '22', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6010004', 'Dated Bas-relief Iron Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '3630', '70195', '6003', '1', '0', '29', '0', '0', '32', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6010005', 'Dated Chocobotail Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70192', '6003', '1', '0', '29', '0', '0', '12', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('6010006', 'Dated Iron Chocobotail Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70194', '6003', '1', '0', '29', '0', '0', '42', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('6010007', 'Dated Fish Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70192', '6003', '1', '0', '29', '0', '0', '17', '2137', '0', '0', '0', '0', '0', '-1', '35', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6010008', 'Dated Crosscut Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '3800', '70408', '6003', '1', '0', '29', '0', '0', '37', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('6010009', 'Bronze Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '990', '70191', '6003', '1', '0', '29', '0', '1', '8', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6010010', 'Chocobotail Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '1700', '70192', '6003', '1', '0', '29', '0', '1', '16', '2137', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('6010011', 'Bas-relief Iron Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '2640', '70195', '6003', '1', '0', '29', '0', '1', '23', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('6010012', 'Iron Chocobotail Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '2900', '70194', '6003', '1', '0', '29', '0', '1', '28', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('6010013', 'Crosscut Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '3500', '70408', '6003', '1', '0', '29', '0', '1', '34', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('6010014', 'Mythril Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '4400', '70457', '6003', '1', '0', '29', '0', '1', '39', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('6010015', 'Bas-relief Cobalt Saw', 'Normal/ToolItem', '1', '0', '0', '97600', '5390', '70458', '6003', '1', '0', '29', '0', '1', '48', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6010016', 'Saw of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70503', '6003', '3', '0', '29', '0', '1', '50', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6011001', 'Dated Bronze Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '924', '70196', '6004', '1', '0', '29', '0', '0', '10', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6011002', 'Dated Iron Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '2352', '70197', '6004', '1', '0', '29', '0', '0', '27', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6011003', 'Dated Steel Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '4032', '70409', '6004', '1', '0', '29', '0', '0', '47', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6011004', 'Bronze Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '1008', '70196', '6004', '1', '0', '29', '0', '1', '11', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6011005', 'Iron Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '1764', '70197', '6004', '1', '0', '29', '0', '1', '20', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('6011006', 'Steel Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '2688', '70409', '6004', '1', '0', '29', '0', '1', '31', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6011007', 'Mythril Claw Hammer', 'Normal/ToolItem', '1', '0', '0', '63440', '3696', '70459', '6004', '1', '0', '29', '0', '1', '43', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6011008', 'Militia Claw Hammer', 'Normal/ToolItem', '1', '1', '0', '63440', '4284', '70550', '6004', '2', '0', '29', '0', '1', '50', '2137', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6020001', 'Weathered Cross-pein Hammer', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70078', '6005', '1', '0', '30', '0', '0', '1', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6020002', 'Dated Bronze Cross-pein Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '800', '70073', '6005', '1', '0', '30', '0', '0', '7', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6020003', 'Dated Iron Cross-pein Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2300', '70074', '6005', '1', '0', '30', '0', '0', '22', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6020004', 'Bronze Cross-pein Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '900', '70073', '6005', '1', '0', '30', '0', '1', '8', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6020005', 'Birdsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1500', '70075', '6005', '1', '0', '30', '0', '1', '14', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('6020006', 'Dated Birdsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70075', '6005', '1', '0', '30', '0', '0', '12', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6020007', 'Dated Crowsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3300', '70076', '6005', '1', '0', '30', '0', '0', '32', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6020008', 'Iron Cross-pein Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1900', '70074', '6005', '1', '0', '30', '0', '1', '18', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('6020009', 'Crowsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2500', '70076', '6005', '1', '0', '30', '0', '1', '24', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('6020010', 'Dated Wrapped Crowsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70077', '6005', '1', '0', '30', '0', '0', '42', '2138', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('6020011', 'Heavy Crowsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3000', '70388', '6005', '1', '0', '30', '0', '1', '29', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('6020012', 'Steel Cross-pein Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3900', '70460', '6005', '1', '0', '30', '0', '1', '38', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('6020013', '[en]', 'Normal/ToolItem', '1', '0', '0', '97600', '200', '60000', '6005', '1', '0', '30', '0', '0', '1', '2138', '0', '0', '0', '0', '0', '-1', '30', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('6020014', 'Wrapped Hawksbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4900', '70461', '6005', '1', '0', '30', '0', '1', '48', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6020015', 'Hammer of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70504', '6005', '3', '0', '30', '0', '1', '50', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6020016', '[en]', 'Normal/ToolItem', '1', '0', '0', '97600', '200', '60000', '6005', '1', '0', '30', '0', '0', '1', '2138', '0', '0', '0', '0', '0', '-1', '30', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('6020017', 'Dated Fortified Birdsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70075', '6005', '1', '0', '30', '0', '0', '17', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6020018', 'Dated Heavy Crowsbeak Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4800', '70388', '6005', '1', '0', '30', '0', '0', '47', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6021001', 'Dated Bronze File', 'Normal/ToolItem', '1', '0', '0', '63440', '836', '70079', '6006', '1', '0', '30', '0', '0', '10', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6021002', 'Dated Iron File', 'Normal/ToolItem', '1', '0', '0', '63440', '2128', '70080', '6006', '1', '0', '30', '0', '0', '27', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6021003', 'Bronze File', 'Normal/ToolItem', '1', '0', '0', '63440', '912', '70079', '6006', '1', '0', '30', '0', '1', '11', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6021004', 'Iron File', 'Normal/ToolItem', '1', '0', '0', '63440', '1672', '70080', '6006', '1', '0', '30', '0', '1', '21', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('6021005', 'Steel File', 'Normal/ToolItem', '1', '0', '0', '63440', '2584', '70462', '6006', '1', '0', '30', '0', '1', '33', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('6021006', 'Dated Polished Iron File', 'Normal/ToolItem', '1', '0', '0', '63440', '2888', '70080', '6006', '1', '0', '30', '0', '0', '37', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6021007', 'Mythril File', 'Normal/ToolItem', '1', '0', '0', '63440', '3344', '70463', '6006', '1', '0', '30', '0', '1', '43', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6021008', 'Militia File', 'Normal/ToolItem', '1', '1', '0', '63440', '3876', '70551', '6006', '2', '0', '30', '0', '1', '50', '2138', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6030001', 'Weathered Doming Hammer', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70200', '6007', '1', '0', '31', '0', '0', '1', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6030002', 'Dated Bronze Doming Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '832', '70198', '6007', '1', '0', '31', '0', '0', '7', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6030003', 'Dated Iron Doming Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2392', '70199', '6007', '1', '0', '31', '0', '0', '22', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('6030004', 'Dated Bronze Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70201', '6007', '1', '0', '31', '0', '0', '12', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6030005', 'Dated Iron Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3300', '70202', '6007', '1', '0', '31', '0', '0', '32', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6030006', 'Dated Wrapped Iron Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70203', '6007', '1', '0', '31', '0', '0', '42', '2139', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6030007', 'Dated Tin Bronze Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70201', '6007', '1', '0', '31', '0', '0', '17', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6030008', 'Dated Heavy-duty Iron Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4800', '70199', '6007', '1', '0', '31', '0', '0', '47', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6030009', 'Bronze Doming Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '936', '70198', '6007', '1', '0', '31', '0', '1', '8', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6030010', 'Bronze Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1500', '70201', '6007', '1', '0', '31', '0', '1', '14', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('6030011', 'Iron Doming Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1976', '70199', '6007', '1', '0', '31', '0', '1', '18', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('6030012', 'Iron Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2500', '70202', '6007', '1', '0', '31', '0', '1', '24', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('6030013', 'Wrapped Iron Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3000', '70203', '6007', '1', '0', '31', '0', '1', '29', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('6030014', 'Steel Doming Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4056', '70464', '6007', '1', '0', '31', '0', '1', '38', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('6030015', 'Cobalt Raising Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4900', '70465', '6007', '1', '0', '31', '0', '1', '48', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6030016', 'Mallet of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70505', '6007', '3', '0', '31', '0', '1', '50', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6031001', 'Dated Bronze Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '880', '70204', '6008', '1', '0', '31', '0', '0', '10', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6031002', 'Dated Iron Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '2240', '70205', '6008', '1', '0', '31', '0', '0', '27', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6031003', 'Dated Steel Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '3040', '70205', '6008', '1', '0', '31', '0', '0', '37', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6031004', 'Bronze Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '960', '70204', '6008', '1', '0', '31', '0', '1', '11', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6031005', 'Iron Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '1760', '70205', '6008', '1', '0', '31', '0', '1', '21', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('6031006', 'Steel Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '2720', '70205', '6008', '1', '0', '31', '0', '1', '33', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('6031007', 'Mythril Pliers', 'Normal/ToolItem', '1', '0', '0', '63440', '3520', '70466', '6008', '1', '0', '31', '0', '1', '43', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6031008', 'Militia Pliers', 'Normal/ToolItem', '1', '1', '0', '63440', '4080', '70552', '6008', '2', '0', '31', '0', '1', '50', '2139', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6040001', 'Weathered Chaser Hammer', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70206', '6009', '1', '0', '32', '0', '0', '1', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6040002', 'Dated Bronze Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '848', '70207', '6009', '1', '0', '32', '0', '0', '7', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6040003', 'Dated Iron Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2438', '70208', '6009', '1', '0', '32', '0', '0', '22', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6040004', 'Dated Bronze Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70209', '6009', '1', '0', '32', '0', '0', '12', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('6040005', 'Dated Iron Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70210', '6009', '1', '0', '32', '0', '0', '42', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('6040006', 'Dated Tin Bronze Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70209', '6009', '1', '0', '32', '0', '0', '17', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6040007', 'Dated Fortified Iron Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3498', '70208', '6009', '1', '0', '32', '0', '0', '32', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6040008', 'Dated Steel Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '5088', '70411', '6009', '1', '0', '32', '0', '0', '47', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6040009', 'Bronze Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '954', '70207', '6009', '1', '0', '32', '0', '1', '8', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6040010', 'Bronze Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '1500', '70209', '6009', '1', '0', '32', '0', '1', '14', '2140', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('6040011', 'Iron Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2014', '70208', '6009', '1', '0', '32', '0', '1', '18', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('6040012', 'Iron Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '2500', '70210', '6009', '1', '0', '32', '0', '1', '24', '2140', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('6040013', 'Steel Chaser Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3180', '70411', '6009', '1', '0', '32', '0', '1', '29', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('6040014', 'Mythril Ornamental Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '3900', '70467', '6009', '1', '0', '32', '0', '1', '38', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('6040015', 'Electrum Lapidary Hammer', 'Normal/ToolItem', '1', '0', '0', '97600', '5390', '70468', '6009', '1', '0', '32', '0', '1', '48', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6040016', 'Gavel of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70506', '6009', '3', '0', '32', '0', '1', '50', '2140', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6041001', 'Dated Mudstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '1078', '70211', '6010', '1', '0', '32', '0', '0', '10', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6041002', 'Dated Ragstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '2744', '70212', '6010', '1', '0', '32', '0', '0', '27', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6041003', 'Dated Siltstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '3724', '70390', '6010', '1', '0', '32', '0', '0', '37', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6041004', 'Ragstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '1176', '70212', '6010', '1', '0', '32', '0', '1', '11', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6041005', 'Mudstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '2156', '70211', '6010', '1', '0', '32', '0', '1', '21', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('6041006', 'Siltstone Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '3332', '70390', '6010', '1', '0', '32', '0', '1', '33', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('6041007', 'Garnet Grinding Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '4312', '70469', '6010', '1', '0', '32', '0', '1', '43', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6041008', 'Militia Grinding Wheel', 'Normal/ToolItem', '1', '1', '0', '63440', '4998', '70553', '6010', '2', '0', '32', '0', '1', '50', '2140', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6050001', 'Dated Bronze Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '784', '70213', '6011', '1', '0', '33', '0', '0', '7', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6050002', 'Dated Brass Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '1274', '70214', '6011', '1', '0', '33', '0', '0', '12', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('6050003', 'Weathered Head Knife', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70216', '6011', '1', '0', '33', '0', '0', '1', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6050004', 'Dated Iron Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '3234', '70218', '6011', '1', '0', '33', '0', '0', '32', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6050005', 'Dated Iron Round Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '2300', '70217', '6011', '1', '0', '33', '0', '0', '22', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6050006', 'Dated Darksilver Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '4214', '70215', '6011', '1', '0', '33', '0', '0', '42', '2141', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('6050007', 'Dated Heavy-duty Brass Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '1764', '70214', '6011', '1', '0', '33', '0', '0', '17', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6050008', 'Dated Steel Round Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '4800', '70217', '6011', '1', '0', '33', '0', '0', '47', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6050009', 'Bronze Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '882', '70213', '6011', '1', '0', '33', '0', '1', '8', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6050010', 'Brass Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '1470', '70214', '6011', '1', '0', '33', '0', '1', '14', '2141', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('6050011', 'Iron Round Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '2400', '70217', '6011', '1', '0', '33', '0', '1', '23', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('6050012', 'Iron Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '2842', '70218', '6011', '1', '0', '33', '0', '1', '28', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('6050013', 'Steel Round Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '3500', '70217', '6011', '1', '0', '33', '0', '1', '34', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('6050014', 'Mythril Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '3822', '70470', '6011', '1', '0', '33', '0', '1', '38', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('6050015', 'Electrum Head Knife', 'Normal/ToolItem', '1', '0', '0', '97600', '4802', '70471', '6011', '1', '0', '33', '0', '1', '48', '2141', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6050016', 'Knife of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70507', '6011', '3', '0', '33', '0', '1', '50', '2141', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6051001', 'Dated Bronze Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '990', '70219', '6012', '1', '0', '33', '0', '0', '10', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6051002', 'Dated Iron Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '2520', '70220', '6012', '1', '0', '33', '0', '0', '27', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6051003', 'Dated Steel Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '3420', '70412', '6012', '1', '0', '33', '0', '0', '37', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6051004', 'Bronze Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '1080', '70219', '6012', '1', '0', '33', '0', '1', '11', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6051005', 'Iron Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '1800', '70220', '6012', '1', '0', '33', '0', '1', '19', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('6051006', 'Steel Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '2880', '70472', '6012', '1', '0', '33', '0', '1', '31', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6051007', 'Mythril Awl', 'Normal/ToolItem', '1', '0', '0', '63440', '3960', '70473', '6012', '1', '0', '33', '0', '1', '43', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6051008', 'Militia Awl', 'Normal/ToolItem', '1', '1', '0', '63440', '4590', '70589', '6012', '2', '0', '33', '0', '1', '50', '2141', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6060001', 'Dated Hedgemole Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '325', '61329', '6013', '1', '0', '34', '0', '0', '12', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6060002', 'Dated Thousand Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '1075', '61328', '6013', '1', '0', '34', '0', '0', '42', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6060003', 'Dated Bronze Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '180', '60825', '6013', '1', '0', '34', '0', '0', '7', '2142', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6060004', 'Dated Silver Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '742', '60832', '6013', '1', '0', '34', '0', '0', '32', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6060005', 'Dated Iron Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '517', '60826', '6013', '1', '0', '34', '0', '0', '22', '2142', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6060006', 'Rusty Needle', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '60825', '6013', '1', '0', '34', '0', '0', '1', '2142', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6060007', 'Dated Steel Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '855', '60827', '6013', '1', '0', '34', '0', '0', '37', '2142', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('6060008', 'Copper Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '648', '60825', '6013', '1', '0', '34', '0', '1', '8', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6060009', 'Bat Fang Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '1088', '61329', '6013', '1', '0', '34', '0', '1', '16', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('6060010', 'Brass Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '1512', '60831', '6013', '1', '0', '34', '0', '1', '20', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('6060011', 'Silver Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '2088', '60832', '6013', '1', '0', '34', '0', '1', '28', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('6060012', 'Mythril Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '2736', '60829', '6013', '1', '0', '34', '0', '1', '37', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6060013', 'Thousand Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '2816', '61328', '6013', '1', '0', '34', '0', '1', '43', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6060014', 'Electrum Needle', 'Normal/ToolItem', '1', '0', '0', '97600', '3528', '60828', '6013', '1', '0', '34', '0', '1', '48', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6060015', 'Needle of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70508', '6013', '3', '0', '34', '0', '1', '50', '2142', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6061001', 'Dated Maple Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '1056', '70227', '6014', '1', '0', '34', '0', '0', '10', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6061002', 'Dated Walnut Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '2688', '70228', '6014', '1', '0', '34', '0', '0', '27', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6061003', 'Dated Elm Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '1728', '70395', '6014', '1', '0', '34', '0', '0', '17', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6061004', 'Dated Oak Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '4608', '70396', '6014', '1', '0', '34', '0', '0', '47', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('6061005', 'Maple Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '1152', '70227', '6014', '1', '0', '34', '0', '1', '11', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6061006', 'Elm Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '2304', '70395', '6014', '1', '0', '34', '0', '1', '23', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('6061007', 'Walnut Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '3168', '70228', '6014', '1', '0', '34', '0', '1', '32', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6061008', 'Mahogany Spinning Wheel', 'Normal/ToolItem', '1', '0', '0', '63440', '3936', '70474', '6014', '1', '0', '34', '0', '1', '40', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('6061009', 'Militia Spinning Wheel', 'Normal/ToolItem', '1', '1', '0', '63440', '4896', '70554', '6014', '2', '0', '34', '0', '1', '50', '2142', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6070001', 'Weathered Alembic', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70232', '6015', '1', '0', '35', '0', '0', '1', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6070002', 'Dated Copper Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '816', '70229', '6015', '1', '0', '35', '0', '0', '7', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6070003', 'Dated Brass Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '1326', '70230', '6015', '1', '0', '35', '0', '0', '12', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('6070004', 'Dated Iron Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '2346', '70231', '6015', '1', '0', '35', '0', '0', '22', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6070005', 'Dated Conical Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '3366', '70233', '6015', '1', '0', '35', '0', '0', '32', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6070006', 'Dated Silver Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '4386', '70294', '6015', '1', '0', '35', '0', '0', '42', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('6070007', 'Dated Tin Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '1836', '70229', '6015', '1', '0', '35', '0', '0', '17', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6070008', 'Dated Thermal Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '4800', '70234', '6015', '1', '0', '35', '0', '0', '47', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('6070009', 'Bronze Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '918', '70229', '6015', '1', '0', '35', '0', '1', '8', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6070010', 'Brass Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '1632', '70230', '6015', '1', '0', '35', '0', '1', '15', '2143', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('6070011', 'Iron Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '2448', '70231', '6015', '1', '0', '35', '0', '1', '23', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('6070012', 'Conical Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '2958', '70233', '6015', '1', '0', '35', '0', '1', '28', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('6070013', 'Silver Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '3570', '70294', '6015', '1', '0', '35', '0', '1', '34', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('6070014', 'Mythril Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '4080', '70475', '6015', '1', '0', '35', '0', '1', '39', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('6070015', 'Thermal Alembic', 'Normal/ToolItem', '1', '0', '0', '97600', '4900', '70234', '6015', '1', '0', '35', '0', '1', '48', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6070016', 'Alembic of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70509', '6015', '3', '0', '35', '0', '1', '50', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6071001', 'Dated Bronze Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '924', '70235', '6016', '1', '0', '35', '0', '0', '10', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6071002', 'Dated Iron Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '2352', '70236', '6016', '1', '0', '35', '0', '0', '27', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6071003', 'Dated Steel Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '3192', '70236', '6016', '1', '0', '35', '0', '0', '37', '2143', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6071004', 'Bronze Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '1008', '70235', '6016', '1', '0', '35', '0', '1', '11', '2143', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6071005', 'Iron Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '1764', '70236', '6016', '1', '0', '35', '0', '1', '20', '2143', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('6071006', 'Steel Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '2688', '70236', '6016', '1', '0', '35', '0', '1', '31', '2143', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6071007', 'Mythril Mortar', 'Normal/ToolItem', '1', '0', '0', '63440', '3696', '70476', '6016', '1', '0', '35', '0', '1', '43', '2143', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6071008', 'Militia Mortar', 'Normal/ToolItem', '1', '1', '0', '63440', '4284', '70555', '6016', '2', '0', '35', '0', '1', '50', '2143', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6080001', 'Weathered Skillet', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70240', '6017', '1', '0', '36', '0', '0', '1', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6080002', 'Dated Bronze Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '832', '70237', '6017', '1', '0', '36', '0', '0', '7', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6080003', 'Dated Iron Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '1352', '70238', '6017', '1', '0', '36', '0', '0', '12', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('6080004', 'Dated Royal Kitchens Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '2392', '70239', '6017', '1', '0', '36', '0', '0', '22', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('6080005', 'Dated Iron Frypan', 'Normal/ToolItem', '1', '0', '0', '97600', '3300', '70241', '6017', '1', '0', '36', '0', '0', '32', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('6080006', 'Dated Bomb Frypan', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70242', '6017', '1', '0', '36', '0', '0', '42', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('6080007', 'Dated White Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70413', '6017', '1', '0', '36', '0', '0', '17', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('6080008', 'Dated Steel Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '3952', '70400', '6017', '1', '0', '36', '0', '0', '37', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('6080009', 'Bronze Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '936', '70237', '6017', '1', '0', '36', '0', '1', '8', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6080010', 'Iron Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '1664', '70238', '6017', '1', '0', '36', '0', '1', '15', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('6080011', 'Iron Frypan', 'Normal/ToolItem', '1', '0', '0', '97600', '2400', '70241', '6017', '1', '0', '36', '0', '1', '23', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('6080012', 'Bomb Frypan', 'Normal/ToolItem', '1', '0', '0', '97600', '2900', '70242', '6017', '1', '0', '36', '0', '1', '28', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('6080013', 'White Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '3500', '70413', '6017', '1', '0', '36', '0', '1', '34', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('6080014', 'Steel Frypan', 'Normal/ToolItem', '1', '0', '0', '97600', '4000', '70477', '6017', '1', '0', '36', '0', '1', '39', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('6080015', 'Cobalt Skillet', 'Normal/ToolItem', '1', '0', '0', '97600', '5096', '70478', '6017', '1', '0', '36', '0', '1', '48', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('6080016', 'Pan of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70510', '6017', '3', '0', '36', '0', '1', '50', '2144', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('6081001', 'Dated Bronze Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '858', '70243', '6018', '1', '0', '36', '0', '0', '10', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6081002', 'Dated Iron Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '2184', '70244', '6018', '1', '0', '36', '0', '0', '27', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('6081003', 'Dated Mythril Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '3744', '70420', '6018', '1', '0', '36', '0', '0', '47', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('6081004', 'Bronze Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '936', '70243', '6018', '1', '0', '36', '0', '1', '11', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('6081005', 'Iron Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '1638', '70244', '6018', '1', '0', '36', '0', '1', '20', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('6081006', 'Steel Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '2496', '70479', '6018', '1', '0', '36', '0', '1', '31', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('6081007', 'Mythril Culinary Knife', 'Normal/ToolItem', '1', '0', '0', '63440', '3432', '70420', '6018', '1', '0', '36', '0', '1', '43', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('6081008', 'Militia Culinary Knife', 'Normal/ToolItem', '1', '1', '0', '63440', '3978', '70556', '6018', '2', '0', '36', '0', '1', '50', '2144', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7010001', 'Dated Bronze Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '800', '70081', '6103', '1', '0', '39', '0', '0', '7', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010002', 'Dated Iron Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '2300', '70082', '6103', '1', '0', '39', '0', '0', '22', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('7010003', 'Dated Polished Iron Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '3300', '70295', '6103', '1', '0', '39', '0', '0', '32', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('7010004', 'Bronze Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '900', '70081', '6103', '1', '0', '39', '0', '1', '8', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010005', 'Weathered Pickaxe', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70083', '6103', '1', '0', '39', '0', '0', '1', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010006', 'Dated Plumed Bronze Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70084', '6103', '1', '0', '39', '0', '0', '12', '2145', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('7010007', 'Plumed Bronze Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '1500', '70084', '6103', '1', '0', '39', '0', '1', '14', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('7010008', 'Iron Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '2000', '70082', '6103', '1', '0', '39', '0', '1', '19', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('7010009', 'Dated Iron Dolabra', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70085', '6103', '1', '0', '39', '0', '0', '42', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('7010010', 'Iron Dolabra', 'Normal/ToolItem', '1', '0', '0', '97600', '2652', '70085', '6103', '1', '0', '39', '0', '1', '25', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('7010011', 'Steel Dolabra', 'Normal/ToolItem', '1', '0', '0', '97600', '3000', '70295', '6103', '1', '0', '39', '0', '1', '29', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('7010012', 'Plumed Mythril Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '3900', '70480', '6103', '1', '0', '39', '0', '1', '38', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('7010013', 'Cobalt Dolabra', 'Normal/ToolItem', '1', '0', '0', '97600', '4998', '70481', '6103', '1', '0', '39', '0', '1', '48', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('7010014', '[en]', 'Normal/ToolItem', '1', '0', '0', '97600', '200', '60000', '6103', '1', '0', '39', '0', '0', '1', '2145', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('7010015', 'Dated Oiled Bronze Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70414', '6103', '1', '0', '39', '0', '0', '17', '2145', '0', '0', '0', '0', '0', '-1', '35', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('7010016', 'Dated Dodotail Pickaxe', 'Normal/ToolItem', '1', '0', '0', '97600', '3800', '70404', '6103', '1', '0', '39', '0', '0', '37', '2145', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('7010017', 'Pick of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70511', '6103', '3', '0', '39', '0', '1', '50', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7010101', 'Dated Bronze Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '880', '70246', '6104', '1', '0', '39', '0', '0', '10', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010102', 'Dated Iron Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '2240', '70247', '6104', '1', '0', '39', '0', '0', '27', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('7010103', 'Bronze Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '960', '70246', '6104', '1', '0', '39', '0', '1', '11', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010104', 'Iron Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '1840', '70247', '6104', '1', '0', '39', '0', '1', '22', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('7010105', 'Steel Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '2720', '70482', '6104', '1', '0', '39', '0', '1', '33', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('7010106', 'Dated Mythril Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '3840', '70483', '6104', '1', '0', '39', '0', '0', '47', '2145', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('7010107', 'Mythril Sledgehammer', 'Normal/ToolItem', '1', '0', '0', '63440', '3520', '70483', '6104', '1', '0', '39', '0', '1', '43', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('7010108', 'Weathered Sledgehammer', 'Normal/ToolItem', '1', '1', '1', '63440', '0', '70246', '6104', '1', '0', '39', '0', '0', '1', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7010109', 'Militia Sledgehammer', 'Normal/ToolItem', '1', '1', '0', '63440', '4080', '70559', '6104', '2', '0', '39', '0', '1', '50', '2145', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7020001', 'Dated Bronze Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '848', '70248', '6105', '1', '0', '40', '0', '0', '7', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020002', 'Weathered Hatchet', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70250', '6105', '1', '0', '40', '0', '0', '1', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020003', 'Dated Brass Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '2438', '70251', '6105', '1', '0', '40', '0', '0', '22', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('7020004', 'Dated Iron Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '3498', '70249', '6105', '1', '0', '40', '0', '0', '32', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('7020005', 'Dated Plumed Bronze Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '1300', '70252', '6105', '1', '0', '40', '0', '0', '12', '2146', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('7020006', 'Dated Plumed Iron Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '4300', '70253', '6105', '1', '0', '40', '0', '0', '42', '2146', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('7020007', 'Dated Oiled Bronze Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '1800', '70416', '6105', '1', '0', '40', '0', '0', '17', '2146', '0', '0', '0', '0', '0', '-1', '35', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('7020008', 'Dated Steel Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '4028', '70249', '6105', '1', '0', '40', '0', '0', '37', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('7020009', 'Bronze Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '954', '70248', '6105', '1', '0', '40', '0', '1', '8', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020010', 'Iron Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '1696', '70249', '6105', '1', '0', '40', '0', '1', '15', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('7020011', 'Brass Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '2544', '70251', '6105', '1', '0', '40', '0', '1', '23', '2146', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('7020012', 'Plumed Iron Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '2900', '70252', '6105', '1', '0', '40', '0', '1', '28', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('7020013', 'Steel Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '3710', '70249', '6105', '1', '0', '40', '0', '1', '34', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('7020014', 'Mythril Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '4240', '70484', '6105', '1', '0', '40', '0', '1', '39', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('7020015', 'Horned Hatchet', 'Normal/ToolItem', '1', '0', '0', '97600', '5096', '70485', '6105', '1', '0', '40', '0', '1', '48', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('7020016', 'Axe of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70512', '6105', '3', '0', '40', '0', '1', '50', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7020101', 'Dated Bronze Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '924', '70254', '6106', '1', '0', '40', '0', '0', '10', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020102', 'Dated Iron Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '2352', '70255', '6106', '1', '0', '40', '0', '0', '27', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('7020103', 'Dated Steel Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '4032', '70255', '6106', '1', '0', '40', '0', '0', '47', '2146', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('7020104', 'Bronze Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '1008', '70254', '6106', '1', '0', '40', '0', '1', '11', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020105', 'Iron Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '1764', '70255', '6106', '1', '0', '40', '0', '1', '20', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('7020106', 'Steel Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '2688', '70255', '6106', '1', '0', '40', '0', '1', '31', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('7020107', 'Mythril Scythe', 'Normal/ToolItem', '1', '0', '0', '63440', '3696', '70486', '6106', '1', '0', '40', '0', '1', '43', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('7020108', 'Weathered Scythe', 'Normal/ToolItem', '1', '1', '1', '63440', '0', '70254', '6106', '1', '0', '40', '0', '0', '1', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7020109', 'Militia Scythe', 'Normal/ToolItem', '1', '1', '0', '63440', '4284', '70558', '6106', '2', '0', '40', '0', '1', '50', '2146', '0', '0', '0', '0', '0', '-1', '30', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7030001', 'Dated Ash Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '880', '70257', '6107', '1', '0', '41', '0', '0', '7', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030002', 'Weathered Fishing Rod', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70258', '6107', '1', '0', '41', '0', '0', '1', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030003', 'Dated Willow Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '1430', '70259', '6107', '1', '0', '41', '0', '0', '12', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('7030004', 'Dated Bamboo Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '2530', '70256', '6107', '1', '0', '41', '0', '0', '22', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('7030005', 'Dated Rattan Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '3630', '70296', '6107', '1', '0', '41', '0', '0', '32', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('7030006', 'Dated Yew Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '4730', '70297', '6107', '1', '0', '41', '0', '0', '42', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('7030007', 'Dated Pine Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '1980', '70418', '6107', '1', '0', '41', '0', '0', '17', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('7030008', 'Dated Horn Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '4800', '70419', '6107', '1', '0', '41', '0', '0', '47', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('7030009', 'Maple Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '990', '70257', '6107', '1', '0', '41', '0', '1', '8', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030010', 'Elm Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '1760', '70256', '6107', '1', '0', '41', '0', '1', '15', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('7030011', 'Yew Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '2860', '70297', '6107', '1', '0', '41', '0', '1', '25', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('7030012', 'Walnut Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '3630', '70296', '6107', '1', '0', '41', '0', '1', '32', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('7030013', 'Horn Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '3800', '70419', '6107', '1', '0', '41', '0', '1', '37', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('7030014', 'Rosewood Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '4840', '70487', '6107', '1', '0', '41', '0', '1', '43', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('7030015', 'Gilded Rosewood Fishing Rod', 'Normal/ToolItem', '1', '0', '0', '97600', '5488', '70407', '6107', '1', '0', '41', '0', '1', '48', '2147', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('7030016', 'Rod of the Luminary', 'Normal/ToolItem', '1', '1', '1', '97600', '0', '70513', '6107', '3', '0', '41', '0', '1', '50', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('7030101', 'Dated Bronze Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '858', '70262', '6108', '1', '0', '41', '0', '0', '10', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030102', 'Dated Iron Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '2184', '70263', '6108', '1', '0', '41', '0', '0', '27', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('7030103', 'Dated Steel Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '2964', '70263', '6108', '1', '0', '41', '0', '0', '37', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('7030104', 'Bronze Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '936', '70262', '6108', '1', '0', '41', '0', '1', '11', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030105', 'Iron Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '1638', '70263', '6108', '1', '0', '41', '0', '1', '20', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('7030106', 'Steel Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '2340', '70263', '6108', '1', '0', '41', '0', '1', '29', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('7030107', 'Mythril Gig', 'Normal/ToolItem', '1', '0', '0', '63440', '3198', '70488', '6108', '1', '0', '41', '0', '1', '40', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('7030108', 'Weathered Gig', 'Normal/ToolItem', '1', '1', '1', '63440', '0', '70262', '6108', '1', '0', '41', '0', '0', '1', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('7030109', 'Militia Gig', 'Normal/ToolItem', '1', '1', '0', '63440', '3978', '70557', '6108', '2', '0', '41', '0', '1', '50', '2147', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010001', 'Dated Bronze Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '8190', '80370', '7004', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010002', 'Dated Iron Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '10290', '80371', '7004', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010003', 'Dated Iron Celata (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '10290', '80374', '7004', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010004', 'Dated Iron Celata (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '10290', '80375', '7004', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010005', 'Steel Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '8400', '80372', '7004', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8010006', 'Steel Celata (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '8400', '80376', '7004', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8010007', 'Cobalt Celata (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '10500', '82412', '7004', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8010008', 'Sentinel\'s Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '10710', '80380', '7004', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010009', 'Cobalt Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '10500', '82159', '7004', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8010010', 'Cobalt Celata (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '10500', '82160', '7004', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8010011', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '420', '60000', '7004', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010012', 'Darksteel Celata', 'Normal/StandardItem', '1', '0', '0', '20850', '420', '60000', '7004', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010013', 'Darksteel Celata (White)', 'Normal/StandardItem', '1', '0', '0', '20850', '420', '60000', '7004', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010014', 'Darksteel Celata (Gold)', 'Normal/StandardItem', '1', '0', '0', '20850', '420', '60000', '7004', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010015', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '420', '60000', '7004', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010016', 'Dented Celata', 'Normal/StandardItem', '1', '1', '0', '20850', '4410', '81429', '7004', '1', '0', '0', '0', '0', '20', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010017', 'Vintage Celata', 'Normal/StandardItem', '1', '1', '0', '20850', '6510', '80370', '7004', '1', '0', '0', '0', '0', '30', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010101', 'Dated Hempen Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '803', '80409', '7005', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010102', 'Dated Hempen Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '803', '80410', '7005', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010103', 'Dated Hempen Hat (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '803', '80411', '7005', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010104', 'Dated Hempen Hat (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '803', '80412', '7005', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010105', 'Dated Canvas Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '3099', '80413', '7005', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010106', 'Dated Canvas Hat (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12510', '3099', '80414', '7005', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010107', 'Dated Canvas Hat (Pink)', 'Normal/StandardItem', '1', '0', '0', '12510', '3099', '80415', '7005', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010108', 'Dated Canvas Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '3099', '80416', '7005', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010109', 'Dated Canvas Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '3099', '80417', '7005', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010110', 'Dated Velveteen Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '80418', '7005', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010111', 'Dated Velveteen Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '80419', '7005', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010112', 'Dated Velveteen Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '80420', '7005', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010113', 'Dated Velveteen Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '80421', '7005', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010114', 'Dated Velveteen Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '80422', '7005', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010115', 'Woolen Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80423', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010116', 'Woolen Hat (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80425', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010117', 'Woolen Hat of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80425', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010118', 'Woolen Hat (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80427', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010119', 'Woolen Hat of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80427', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010120', 'Felt Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80428', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010121', 'Felt Hat of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80429', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010122', 'Felt Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80429', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010123', 'Felt Hat of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80431', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010124', 'Felt Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80431', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010125', 'Linen Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82174', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010126', 'Linen Hat of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82175', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010127', 'Linen Hat of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82176', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010128', 'Linen Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82175', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010129', 'Sorcerer\'s Hat', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80432', '7005', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010130', 'Divining Hat', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81490', '7005', '2', '0', '0', '0', '0', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8010131', 'Linen Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82176', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010132', 'Linen Hat of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82174', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010133', 'Linen Hat of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82176', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010134', 'Linen Hat of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82174', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010135', 'Linen Hat of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4247', '82175', '7005', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010136', 'Woolen Hat of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80423', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010137', 'Woolen Hat of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80427', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010138', 'Woolen Hat of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80423', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010139', 'Woolen Hat of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4821', '80425', '7005', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8010140', 'Felt Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80430', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010141', 'Felt Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80432', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010142', 'Felt Hat of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80428', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010143', 'Felt Hat of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80431', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010144', 'Felt Hat of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80430', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010145', 'Felt Hat of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80432', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010146', 'Felt Hat of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80428', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010147', 'Felt Hat of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80429', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010148', 'Felt Hat of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80430', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010149', 'Felt Hat of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5395', '80432', '7005', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010201', 'Dated Bronze Goggles', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80495', '7009', '1', '0', '0', '0', '0', '15', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8010202', 'Dated Bronze Goggles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80483', '7009', '1', '0', '0', '0', '0', '15', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8010203', 'Dated Bronze Goggles (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80484', '7009', '1', '0', '0', '0', '0', '15', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8010204', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010205', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010206', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010207', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010208', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010209', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010210', 'Steel Goggles', 'Normal/StandardItem', '1', '0', '0', '13900', '3225', '82204', '7009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010211', 'Steel Goggles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3225', '82204', '7009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010212', 'Steel Goggles (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3225', '82204', '7009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010213', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010214', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010215', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010216', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010217', 'Dated Brass Preserves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2620', '80487', '7009', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010218', 'Dated Brass Preserves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2620', '80488', '7009', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010219', 'Dated Iron Preserves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3628', '80491', '7009', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8010220', 'Dated Iron Preserves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '3628', '80492', '7009', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8010221', 'Cobalt Preserves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '4536', '82205', '7009', '1', '0', '0', '0', '0', '44', '2003', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8010222', 'Cobalt Preserves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '4536', '82205', '7009', '1', '0', '0', '0', '0', '44', '2003', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8010223', 'Darksteel Eyeguards (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010224', 'Darksteel Eyeguards (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '201', '60000', '7009', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010225', 'Garlond Goggles', 'Normal/SpecialEquipItem', '1', '1', '1', '13900', '0', '81352', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010301', 'Coeurl\'s Eye', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82155', '7009', '2', '0', '0', '0', '1', '20', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010302', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010303', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010304', 'Leather Eyepatch', 'Normal/StandardItem', '1', '0', '0', '12510', '1276', '80501', '7009', '1', '0', '0', '0', '0', '23', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8010305', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010306', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010307', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010308', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010309', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010310', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010311', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010312', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010313', 'Skull Eyepatch (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1808', '80510', '7009', '1', '0', '0', '0', '0', '33', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8010314', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010315', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010316', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010317', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010318', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010319', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010320', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010321', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010322', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010323', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010324', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010325', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010326', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010327', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010328', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010329', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010330', '[en]', 'Normal/StandardItem', '1', '0', '0', '12510', '106', '60000', '7009', '1', '0', '0', '0', '0', '1', '1006', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010401', 'Dated Copper Circlet (Sunstone)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80433', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010402', 'Dated Copper Circlet (Lapis Lazuli)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80434', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010403', 'Dated Copper Circlet (Sphene)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80435', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010404', 'Dated Copper Circlet (Malachite)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80436', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010405', 'Dated Copper Circlet (Fluorite)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80437', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010406', 'Dated Copper Circlet (Danburite)', 'Normal/StandardItem', '1', '0', '0', '13900', '1612', '80438', '7007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010407', 'Dated Brass Circlet (Sunstone)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80439', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010408', 'Dated Brass Circlet (Lapis Lazuli)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80440', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010409', 'Dated Brass Circlet (Sphene)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80441', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010410', 'Dated Brass Circlet (Malachite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80442', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010411', 'Dated Brass Circlet (Fluorite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80443', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010412', 'Dated Brass Circlet (Danburite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2852', '80444', '7007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010413', 'Dated Silver Circlet (Garnet)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80445', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010414', 'Dated Silver Circlet (Aquamarine)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80446', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010415', 'Dated Silver Circlet (Heliodor)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80447', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010416', 'Dated Silver Circlet (Peridot)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80448', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010417', 'Dated Silver Circlet (Amethyst)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80449', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010418', 'Dated Silver Circlet (Goshenite)', 'Normal/StandardItem', '1', '0', '0', '13900', '4092', '80450', '7007', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010419', 'Brass Circlet (Sunstone)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80439', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010420', 'Brass Circlet (Lapis Lazuli)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80440', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010421', 'Brass Circlet (Sphene)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80441', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010422', 'Brass Circlet (Malachite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80442', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010423', 'Brass Circlet (Fluorite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80443', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010424', 'Brass Circlet (Danburite)', 'Normal/StandardItem', '1', '0', '0', '13900', '2356', '80444', '7007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8010425', 'Dated Darksilver Circlet (Garnet)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80580', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010426', 'Dated Darksilver Circlet (Aquamarine)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80581', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010427', 'Dated Darksilver Circlet (Heliodor)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80582', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010428', 'Dated Darksilver Circlet (Peridot)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80583', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010429', 'Dated Darksilver Circlet (Amethyst)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80584', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010430', 'Dated Darksilver Circlet (Goshenite)', 'Normal/StandardItem', '1', '0', '0', '13900', '5332', '80585', '7007', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010431', 'Dated Electrum Circlet (Rubellite)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81555', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010432', 'Dated Electrum Circlet (Turquoise)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81556', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010433', 'Dated Electrum Circlet (Amber)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81557', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010434', 'Dated Electrum Circlet (Tourmaline)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81558', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010435', 'Dated Electrum Circlet (Spinel)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81559', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010436', 'Dated Electrum Circlet (Zircon)', 'Normal/StandardItem', '1', '0', '0', '13900', '5952', '81560', '7007', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010437', 'Silver Circlet (Garnet)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80445', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010438', 'Silver Circlet (Aquamarine)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80446', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010439', 'Silver Circlet (Heliodor)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80447', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010440', 'Silver Circlet (Peridot)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80448', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010441', 'Silver Circlet (Amethyst)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80449', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010442', 'Silver Circlet (Goshenite)', 'Normal/StandardItem', '1', '0', '0', '13900', '3596', '80450', '7007', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8010443', 'Mythril Circlet (Rubellite)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010444', 'Mythril Circlet (Turquoise)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010445', 'Mythril Circlet (Amber)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010446', 'Mythril Circlet (Tourmaline)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010447', 'Mythril Circlet (Spinel)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010448', 'Mythril Circlet (Zircon)', 'Normal/StandardItem', '1', '0', '0', '13900', '4836', '82189', '7007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010449', 'Electrum Circlet (Rubellite)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81555', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010450', 'Electrum Circlet (Turquoise)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81556', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010451', 'Electrum Circlet (Amber)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81557', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010452', 'Electrum Circlet (Tourmaline)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81558', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010453', 'Electrum Circlet (Spinel)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81559', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010454', 'Electrum Circlet (Zircon)', 'Normal/StandardItem', '1', '0', '0', '13900', '6076', '81560', '7007', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010455', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010456', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010457', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010458', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010459', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010460', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010461', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010462', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010463', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010464', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010465', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010466', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010467', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010468', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010469', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010470', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010471', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010472', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010473', 'Leather Vizard', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010474', 'Nighthawk Visor', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80458', '7008', '2', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010475', 'Leather Vizard (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010476', 'Leather Vizard (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010477', 'Leather Vizard (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010478', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010479', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010480', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010481', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010482', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '224', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010501', 'Dated Hempen Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80381', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010502', 'Dated Hempen Coif (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80382', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010503', 'Dated Hempen Coif (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80383', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010504', 'Dated Hempen Coif (Beige)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80384', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010505', 'Dated Cotton Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '1092', '80385', '7006', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010506', 'Dated Cotton Coif (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1092', '80386', '7006', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010507', 'Dated Cotton Coif (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1092', '80387', '7006', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010508', 'Dated Cotton Coif (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1092', '80388', '7006', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010509', 'Dated Cotton Coif (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1092', '80389', '7006', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010510', 'Dated Canvas Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80390', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010511', 'Dated Canvas Coif (Auburn)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80391', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010512', 'Dated Canvas Coif (Pink)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80392', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010513', 'Dated Canvas Coif (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80393', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010514', 'Dated Canvas Coif (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80394', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010515', 'Dated Velveteen Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '2912', '80512', '7006', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010516', 'Dated Velveteen Coif (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '2912', '80513', '7006', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010517', 'Dated Velveteen Coif (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '2912', '80514', '7006', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010518', 'Dated Velveteen Coif (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2912', '80515', '7006', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010519', 'Dated Velveteen Coif (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2912', '80516', '7006', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010520', 'Hempen Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80381', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010521', 'Hempen Coif of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80382', '7006', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010522', 'Hempen Coif of Toiling (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80383', '7006', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010523', 'Cotton Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80385', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010524', 'Cotton Coif of Casting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80387', '7006', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010525', 'Cotton Coif of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80388', '7006', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010526', 'Woolen Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82161', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010527', 'Woolen Coif of Casting (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82162', '7006', '1', '0', '0', '0', '1', '40', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010528', 'Woolen Coif of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82067', '7006', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010529', 'Felt Coif', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82163', '7006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010530', 'Felt Coif of Toiling (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82162', '7006', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010531', 'Felt Coif of Casting (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82164', '7006', '1', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010532', 'Hempen Coif (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80382', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010533', 'Hempen Coif (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80383', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010534', 'Hempen Coif of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80381', '7006', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010535', 'Hempen Coif of Casting (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80383', '7006', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010536', 'Hempen Coif of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80381', '7006', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010537', 'Hempen Coif of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '182', '80382', '7006', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010538', 'Cotton Coif (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80387', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010539', 'Cotton Coif (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80388', '7006', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010540', 'Cotton Coif of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80385', '7006', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010541', 'Cotton Coif of Casting (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80388', '7006', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010542', 'Cotton Coif of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80385', '7006', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010543', 'Cotton Coif of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2002', '80387', '7006', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010544', 'Woolen Coif (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82162', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010545', 'Weathered Coif (Grey)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80517', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010546', 'Vintage Coif', 'Normal/StandardItem', '1', '1', '0', '11120', '4459', '82067', '7006', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010547', 'Torn Coif', 'Normal/StandardItem', '1', '1', '0', '7500', '1248', '81439', '7006', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8010548', 'Claret Coif', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82068', '7006', '3', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010549', 'Woolen Coif (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82067', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010550', 'Woolen Coif of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82161', '7006', '1', '0', '0', '0', '1', '40', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010551', 'Woolen Coif of Casting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82067', '7006', '1', '0', '0', '0', '1', '40', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010552', 'Woolen Coif of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82161', '7006', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010553', 'Woolen Coif of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '3731', '82162', '7006', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010554', 'Felt Coif (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82162', '7006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010555', 'Felt Coif (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82164', '7006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010556', 'Felt Coif (Purple)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82414', '7006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010557', 'Felt Coif (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82413', '7006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010558', 'Felt Coif of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82163', '7006', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010559', 'Felt Coif of Toiling (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82164', '7006', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010560', 'Felt Coif of Toiling (Purple)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82414', '7006', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010561', 'Felt Coif of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82413', '7006', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010562', 'Felt Coif of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82163', '7006', '1', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010563', 'Felt Coif of Casting (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82162', '7006', '1', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010564', 'Felt Coif of Casting (Purple)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82414', '7006', '1', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010565', 'Felt Coif of Casting (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '4186', '82413', '7006', '1', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8010566', 'Serpent Private\'s Coif', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80388', '7006', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010567', 'Serpent Sergeant\'s Coif', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80393', '7006', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010601', 'Dated Hempen Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '525', '80395', '7005', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010602', 'Dated Hempen Beret (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '525', '80396', '7005', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010603', 'Dated Hempen Beret (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '525', '80397', '7005', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010604', 'Dated Hempen Beret (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '525', '80398', '7005', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010605', 'Dated Cotton Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80399', '7005', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8010606', 'Dated Cotton Beret (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80400', '7005', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8010607', 'Dated Cotton Beret (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80401', '7005', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8010608', 'Dated Cotton Beret (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80402', '7005', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8010609', 'Dated Cotton Beret (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80403', '7005', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8010610', 'Dated Canvas Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '2625', '80404', '7005', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8010611', 'Dated Canvas Beret (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12510', '2625', '80405', '7005', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8010612', 'Dated Canvas Beret (Pink)', 'Normal/StandardItem', '1', '0', '0', '12510', '2625', '80406', '7005', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8010613', 'Dated Canvas Beret (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2625', '80407', '7005', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8010614', 'Dated Canvas Beret (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2625', '80408', '7005', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8010615', 'Dated Velveteen Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '3675', '80518', '7005', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8010616', 'Dated Velveteen Beret (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '3675', '80519', '7005', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8010617', 'Dated Velveteen Beret (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '3675', '80520', '7005', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8010618', 'Dated Velveteen Beret (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '3675', '80521', '7005', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8010619', 'Dated Velveteen Beret (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '3675', '80522', '7005', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8010620', 'Woolen Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82165', '7005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010621', 'Woolen Beret of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82166', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010622', 'Woolen Beret of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82167', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010623', 'Woolen Beret of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82168', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010624', 'Felt Beret', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82166', '7005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010625', 'Felt Beret of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82169', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010626', 'Felt Beret of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82170', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010627', 'Felt Beret of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82171', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010628', 'Woolen Beret (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82166', '7005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010629', 'Woolen Beret (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82167', '7005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010630', 'Woolen Beret (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82168', '7005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010631', 'Woolen Beret of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82165', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010632', 'Woolen Beret of Dexterity (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82167', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010633', 'Woolen Beret of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82168', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010634', 'Woolen Beret of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82165', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010635', 'Woolen Beret of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82166', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010636', 'Woolen Beret of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82168', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010637', 'Woolen Beret of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82165', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010638', 'Woolen Beret of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82166', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010639', 'Woolen Beret of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '4620', '82167', '7005', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8010640', 'Felt Beret (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82169', '7005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010641', 'Felt Beret (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82170', '7005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010642', 'Felt Beret (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82171', '7005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010643', 'Felt Beret (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82415', '7005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010644', 'Felt Beret of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82166', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010645', 'Felt Beret of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82170', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010646', 'Weathered Beret (Beige)', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81450', '7005', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010647', 'Felt Beret of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82171', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010648', 'Felt Beret of Dexterity (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82415', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010649', 'Felt Beret of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82166', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010650', 'Felt Beret of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82169', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010651', 'Felt Beret of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82171', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010652', 'Felt Beret of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82415', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010653', 'Felt Beret of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82166', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010654', 'Felt Beret of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82169', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010655', 'Felt Beret of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82170', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010656', 'Felt Beret of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5145', '82415', '7005', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8010701', 'Elm Mask', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010702', 'Maple Mask', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010703', 'Ash Mask', 'Normal/StandardItem', '1', '0', '0', '11120', '595', '80464', '7008', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8010704', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010705', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010706', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010707', 'Ash Mask (Lapis Lazuli)', 'Normal/StandardItem', '1', '0', '0', '11120', '735', '81646', '7008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010708', 'Mask of the Mortal Hex', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82152', '7008', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8010709', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010710', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010711', 'Dated Willow Halfmask', 'Normal/StandardItem', '1', '0', '0', '11120', '630', '80465', '7008', '1', '0', '0', '0', '0', '17', '1116', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8010712', 'Dated Oak Halfmask', 'Normal/StandardItem', '1', '0', '0', '11120', '980', '80466', '7008', '1', '0', '0', '0', '0', '27', '1116', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010713', 'Dated Yew Halfmask', 'Normal/StandardItem', '1', '0', '0', '11120', '1330', '80467', '7008', '1', '0', '0', '0', '0', '37', '1116', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010714', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '70', '60000', '7008', '1', '0', '0', '0', '0', '1', '1116', '0', '0', '0', '0', '0', '-1', '29', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010715', 'Dated Lauan Halfmask', 'Normal/StandardItem', '1', '0', '0', '11120', '280', '80624', '7008', '1', '0', '0', '0', '0', '7', '1116', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010716', 'Dated Walnut Mask', 'Normal/StandardItem', '1', '0', '0', '11120', '1505', '82035', '7008', '1', '0', '0', '0', '0', '42', '1116', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8010801', 'Dated Copper Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '1176', '80468', '7009', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010802', 'Dated Brass Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '2156', '80471', '7009', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010803', 'Dated Brass Spectacles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2156', '80472', '7009', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8010804', 'Iron Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010805', 'Iron Spectacles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010806', 'Dated Silver Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '3136', '80475', '7009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010807', 'Dated Silver Spectacles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '3136', '80476', '7009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8010808', 'Silver Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '2548', '80475', '7009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010809', 'Silver Spectacles (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '2548', '80476', '7009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8010810', 'Mythril Spectacles', 'Normal/StandardItem', '1', '0', '0', '11120', '3528', '82202', '7009', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8010811', 'Mythril Spectacles (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '3528', '82202', '7009', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8010812', 'Pince-nez', 'Normal/StandardItem', '1', '1', '0', '11120', '4606', '80477', '7009', '2', '0', '0', '0', '1', '46', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8010813', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010814', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010815', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010816', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010817', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010818', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010819', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010820', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010821', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010822', 'Torturer\'s Monocle', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81656', '7009', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8010823', 'Electrum Monocle', 'Normal/StandardItem', '1', '0', '0', '11120', '4704', '81656', '7009', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010824', 'Electrum Monocle (White)', 'Normal/StandardItem', '1', '0', '0', '11120', '4704', '81658', '7009', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8010825', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010826', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010827', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010828', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010829', 'Dated Brass Magnifiers (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1666', '80625', '7009', '1', '0', '0', '0', '0', '16', '1008', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8010830', 'Dated Iron Magnifiers (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '2646', '80626', '7009', '1', '0', '0', '0', '0', '26', '1008', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8010831', 'Dated Silver Magnifiers (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '3626', '80627', '7009', '1', '0', '0', '0', '0', '36', '1008', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8010832', 'Silver Magnifiers', 'Normal/StandardItem', '1', '0', '0', '11120', '2744', '80627', '7009', '1', '0', '0', '0', '0', '27', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8010833', 'Mythril Magnifiers', 'Normal/StandardItem', '1', '0', '0', '11120', '3724', '82203', '7009', '1', '0', '0', '0', '0', '37', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8010834', 'Dated Weathered Spectacles (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1176', '80469', '7009', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010835', 'Dated Weathered Spectacles (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1176', '80470', '7009', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010836', 'Weathered Spectacles (White)', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010837', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '196', '60000', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8010838', 'Weathered Spectacles', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81657', '7009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010901', 'Dated Hempen Sugarloaf Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '1355', '80615', '7005', '1', '0', '0', '0', '0', '10', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010902', 'Dated Hempen Sugarloaf Hat (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '1355', '80616', '7005', '1', '0', '0', '0', '0', '10', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010903', 'Dated Hempen Sugarloaf Hat (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '1355', '80617', '7005', '1', '0', '0', '0', '0', '10', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8010904', 'Dated Cotton Sugarloaf Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2587', '80618', '7005', '1', '0', '0', '0', '0', '20', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010905', 'Dated Cotton Sugarloaf Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2587', '80619', '7005', '1', '0', '0', '0', '0', '20', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010906', 'Dated Cotton Sugarloaf Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2587', '80620', '7005', '1', '0', '0', '0', '0', '20', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8010907', 'Dated Velveteen Sugarloaf Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '5051', '80621', '7005', '1', '0', '0', '0', '0', '40', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010908', 'Dated Velveteen Sugarloaf Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5051', '80622', '7005', '1', '0', '0', '0', '0', '40', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010909', 'Dated Velveteen Sugarloaf Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '5051', '80623', '7005', '1', '0', '0', '0', '0', '40', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8010910', 'Cotton Sugarloaf Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '82201', '7005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010911', 'Cotton Sugarloaf Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80618', '7005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010912', 'Cotton Sugarloaf Hat of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80619', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010913', 'Cotton Sugarloaf Hat of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80620', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010914', 'Velveteen Sugarloaf Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '82201', '7005', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010915', 'Velveteen Sugarloaf Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80621', '7005', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010916', 'Velveteen Sugarloaf Hat of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80622', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010917', 'Velveteen Sugarloaf Hat of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80623', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010918', 'Cotton Sugarloaf Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80619', '7005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010919', 'Cotton Sugarloaf Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80620', '7005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010920', 'Cotton Sugarloaf Hat of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '82201', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010921', 'Cotton Sugarloaf Hat of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80618', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010922', 'Cotton Sugarloaf Hat of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80620', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010923', 'Cotton Sugarloaf Hat of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '82201', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010924', 'Cotton Sugarloaf Hat of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80618', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010925', 'Cotton Sugarloaf Hat of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2833', '80619', '7005', '1', '0', '0', '0', '1', '22', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8010926', 'Velveteen Sugarloaf Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80622', '7005', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010927', 'Velveteen Sugarloaf Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80623', '7005', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010928', 'Velveteen Sugarloaf Hat of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '82201', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010929', 'Velveteen Sugarloaf Hat of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80621', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010930', 'Velveteen Sugarloaf Hat of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80623', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010931', 'Velveteen Sugarloaf Hat of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '82201', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010932', 'Woolen Sugarloaf Hat (Red)', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82032', '7005', '1', '0', '0', '0', '0', '35', '1115', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8010933', 'Velveteen Sugarloaf Hat of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80621', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8010934', 'Velveteen Sugarloaf Hat of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '4065', '80622', '7005', '1', '0', '0', '0', '1', '32', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8011001', 'Weathered Bandana', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81301', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011002', 'Dated Hempen Bandana', 'Normal/StandardItem', '1', '0', '0', '11120', '189', '80511', '7006', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011003', 'Dated Hempen Bandana (Beige)', 'Normal/StandardItem', '1', '0', '0', '11120', '189', '80628', '7006', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011004', 'Dated Hempen Bandana (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '189', '80630', '7006', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011005', 'Dated Hempen Bandana (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '189', '80629', '7006', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011006', 'Dated Cotton Bandana', 'Normal/StandardItem', '1', '0', '0', '11120', '819', '80631', '7006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011007', 'Dated Cotton Bandana (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '819', '80632', '7006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011008', 'Dated Cotton Bandana (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '819', '80633', '7006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011009', 'Dated Cotton Bandana (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '819', '80634', '7006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011010', 'Dated Cotton Bandana (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '819', '80635', '7006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011011', 'Dated Canvas Bandana', 'Normal/StandardItem', '1', '0', '0', '11120', '1449', '80636', '7006', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011012', 'Dated Canvas Bandana (Auburn)', 'Normal/StandardItem', '1', '0', '0', '11120', '1449', '80637', '7006', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011013', 'Dated Canvas Bandana (Pink)', 'Normal/StandardItem', '1', '0', '0', '11120', '1449', '80638', '7006', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011014', 'Dated Canvas Bandana (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '1449', '80639', '7006', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011015', 'Dated Canvas Bandana (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1449', '80640', '7006', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011016', 'Velveteen Bandana', 'Normal/StandardItem', '1', '0', '0', '11120', '1701', '81682', '7006', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011017', 'Velveteen Bandana (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1701', '81700', '7006', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011018', 'Velveteen Bandana (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1701', '81703', '7006', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011019', 'Pirate\'s Bandana', 'Normal/StandardItem', '1', '1', '0', '11120', '1197', '81687', '7006', '1', '0', '0', '0', '1', '18', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011020', 'Velveteen Bandana (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1701', '81701', '7006', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011021', 'Velveteen Bandana (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1701', '81702', '7006', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011022', 'Explorer\'s Bandana', 'Normal/StandardItem', '1', '1', '0', '11120', '3087', '81710', '7006', '2', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011101', 'Dated Copper Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '2156', '80544', '7004', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011102', 'Dated Bronze Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '3696', '80545', '7004', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8011103', 'Dated Iron Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '5236', '80546', '7004', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8011104', 'Dated Visored Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '6776', '80547', '7004', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011105', 'Warden\'s Barbut', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '80546', '7004', '2', '0', '0', '0', '1', '30', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8011106', 'Bronze Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '2002', '80544', '7004', '1', '0', '0', '0', '0', '12', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8011107', 'Decorated Bronze Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '2772', '80545', '7004', '1', '0', '0', '0', '0', '17', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8011108', 'Steel Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '5852', '81506', '7004', '1', '0', '0', '0', '0', '37', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8011109', 'Mythril Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '6622', '82177', '7004', '1', '0', '0', '0', '0', '42', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8011110', 'Cobalt Barbut', 'Normal/StandardItem', '1', '0', '0', '16680', '7392', '82178', '7004', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8011201', 'Dated Hunting Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '80548', '7005', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011202', 'Dated Hunting Hat (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '80549', '7005', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011203', 'Dated Hunting Hat (Beige)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '80550', '7005', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011204', 'Dated Trapper\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '80551', '7005', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011205', 'Dated Trapper\'s Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '80552', '7005', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011206', 'Dated Trapper\'s Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '80553', '7005', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011207', 'Dated Trapper\'s Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '80554', '7005', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011208', 'Dated Trapper\'s Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '80555', '7005', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011209', 'Dated Tracker\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '3906', '80556', '7005', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011210', 'Dated Tracker\'s Hat (Auburn)', 'Normal/StandardItem', '1', '0', '0', '15290', '3906', '80557', '7005', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011211', 'Dated Tracker\'s Hat (Pink)', 'Normal/StandardItem', '1', '0', '0', '15290', '3906', '80558', '7005', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011212', 'Dated Tracker\'s Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '3906', '80559', '7005', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011213', 'Dated Tracker\'s Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '3906', '80560', '7005', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011214', 'Dated Bowman\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '5208', '80561', '7005', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011215', 'Dated Bowman\'s Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '5208', '80562', '7005', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011216', 'Dated Bowman\'s Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '5208', '80563', '7005', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011217', 'Dated Bowman\'s Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '15290', '5208', '80564', '7005', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011218', 'Dated Bowman\'s Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '5208', '80565', '7005', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011219', 'Poacher\'s Hat', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81527', '7005', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8011220', 'Ranger\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '5728', '82179', '7005', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011221', 'Ranger\'s Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '5728', '82180', '7005', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011222', 'Rainmaker\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '6379', '82181', '7005', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011223', 'Rainmaker\'s Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '6379', '82182', '7005', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011301', 'Dated Hempen Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '491', '80566', '7006', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011302', 'Dated Hempen Turban (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '491', '80567', '7006', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011303', 'Dated Hempen Turban (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '491', '80568', '7006', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011304', 'Dated Hempen Turban (Beige)', 'Normal/StandardItem', '1', '0', '0', '13900', '491', '80569', '7006', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011305', 'Dated Cotton Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '80570', '7006', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011306', 'Dated Cotton Turban (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '80571', '7006', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011307', 'Dated Cotton Turban (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '80572', '7006', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011308', 'Dated Cotton Turban (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '80573', '7006', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011309', 'Dated Cotton Turban (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '80574', '7006', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011310', 'Dated Velveteen Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '80575', '7006', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8011311', 'Dated Velveteen Turban (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '80576', '7006', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8011312', 'Dated Velveteen Turban (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '80577', '7006', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8011313', 'Dated Velveteen Turban (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '80578', '7006', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8011314', 'Dated Velveteen Turban (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '80579', '7006', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8011315', 'Velveteen Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '82183', '7006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011316', 'Velveteen Turban of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80578', '7006', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011317', 'Velveteen Turban of Invoking (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80579', '7006', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011318', 'Linen Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82184', '7006', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011319', 'Linen Turban of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82185', '7006', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011320', 'Linen Turban of Invoking (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82186', '7006', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011321', 'Woolen Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82187', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011322', 'Woolen Turban of Invoking (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82188', '7006', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011323', 'Sipahi Turban', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82146', '7006', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8011324', 'Velveteen Turban (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80578', '7006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011325', 'Velveteen Turban (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80579', '7006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011326', 'Velveteen Turban of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '82183', '7006', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011327', 'Velveteen Turban of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80579', '7006', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011328', 'Velveteen Turban of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '82183', '7006', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011329', 'Velveteen Turban of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '80578', '7006', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011330', 'Linen Turban (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82185', '7006', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011331', 'Linen Turban (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82186', '7006', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011332', 'Linen Turban of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82184', '7006', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011333', 'Linen Turban of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82186', '7006', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011334', 'Linen Turban of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82184', '7006', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011335', 'Linen Turban of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82185', '7006', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011336', 'Woolen Turban (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82188', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011337', 'Woolen Turban (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82416', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011338', 'Woolen Turban (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82417', '7006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011339', 'Woolen Turban of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82187', '7006', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011340', 'Woolen Turban of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82416', '7006', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011341', 'Woolen Turban of Invoking (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82417', '7006', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011401', 'Dated Bronze Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '3360', '80586', '7004', '1', '0', '0', '0', '0', '19', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011402', 'Dated Brass Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '5040', '80587', '7004', '1', '0', '0', '0', '0', '29', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011403', 'Conquistador Elmo', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81580', '7004', '2', '0', '0', '0', '0', '35', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011404', 'Iron Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '3864', '81571', '7004', '1', '0', '0', '0', '0', '22', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011405', 'Iron Elmo (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '3864', '81577', '7004', '1', '0', '0', '0', '0', '22', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8011406', 'Mythril Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '7056', '82190', '7004', '1', '0', '0', '0', '0', '41', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8011407', 'Reinforced Mythril Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '7560', '82191', '7004', '1', '0', '0', '0', '0', '44', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8011408', 'Cobalt Elmo', 'Normal/StandardItem', '1', '0', '0', '18070', '7896', '82192', '7004', '1', '0', '0', '0', '0', '46', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8011409', 'Cobalt Elmo (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '7896', '82193', '7004', '1', '0', '0', '0', '0', '46', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8011501', 'Dated Sheepskin Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '1288', '80588', '7004', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011502', 'Dated Dodoskin Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '2576', '80591', '7004', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011503', 'Dated Dodoskin Pot Helm (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '2576', '80592', '7004', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8011504', 'Dated Leather Pot Helm (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '3864', '80593', '7004', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011505', 'Dated Leather Pot Helm (Ochre)', 'Normal/StandardItem', '1', '0', '0', '15290', '3864', '80594', '7004', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011506', 'Dated Leather Pot Helm (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '3864', '80595', '7004', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011507', 'Dated Leather Pot Helm (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '3864', '80596', '7004', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011508', 'Dated Toadskin Pot Helm (Sunstone)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80597', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011509', 'Dated Toadskin Pot Helm (Lapis Lazuli)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80598', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011510', 'Dated Toadskin Pot Helm (Sphene)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80599', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011511', 'Dated Toadskin Pot Helm (Malachite)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80600', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011512', 'Dated Toadskin Pot Helm (Fluorite)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80601', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011513', 'Dated Toadskin Pot Helm (Danburite)', 'Normal/StandardItem', '1', '0', '0', '15290', '5152', '80602', '7004', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011514', 'Helm of the Lone Knight', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81587', '7004', '3', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8011515', 'Dodoskin Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '1159', '80589', '7004', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011516', 'Dodoskin Pot Helm (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '1159', '80590', '7004', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011517', 'Leather Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '2447', '80591', '7004', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011518', 'Leather Pot Helm (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '2447', '80592', '7004', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8011519', 'Boarskin Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '5667', '82194', '7004', '1', '0', '0', '0', '0', '43', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011520', 'Raptorskin Pot Helm', 'Normal/StandardItem', '1', '0', '0', '15290', '6311', '82195', '7004', '1', '0', '0', '0', '0', '48', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011521', 'Mercenary\'s Pot Helm', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82142', '7004', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8011522', 'Flame Private\'s Pot Helm', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '80592', '7004', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011523', 'Flame Sergeant\'s Pot Helm', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82194', '7004', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8011524', 'Veteran\'s Pot Helm', 'Normal/StandardItem', '1', '1', '0', '15290', '6440', '82512', '7004', '2', '0', '0', '0', '1', '49', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8011601', 'Dated Bronze Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '2352', '80603', '7004', '1', '0', '0', '0', '0', '15', '1113', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8011602', 'Dated Assault Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '3822', '80604', '7004', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8011603', 'Dated Iron Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '5292', '80605', '7004', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8011604', 'Dated Iron Assault Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '6762', '80606', '7004', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8011605', 'Iron Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '3087', '80606', '7004', '1', '0', '0', '0', '0', '20', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8011606', 'Reinforced Iron Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '3528', '80605', '7004', '1', '0', '0', '0', '0', '23', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8011607', 'Steel Sallet', 'Normal/StandardItem', '1', '0', '0', '16680', '4557', '81595', '7004', '1', '0', '0', '0', '0', '30', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8011608', 'Steel Sallet (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '4557', '81599', '7004', '1', '0', '0', '0', '0', '30', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8011609', 'Storm Private\'s Sallet', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '80604', '7004', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8011610', 'Storm Sergeant\'s Sallet', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81595', '7004', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8011701', 'Dated Bronze Chain Coif', 'Normal/StandardItem', '1', '0', '0', '19460', '5096', '80607', '7004', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011702', 'Dated Iron Chain Coif', 'Normal/StandardItem', '1', '0', '0', '19460', '6916', '80608', '7004', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8011703', 'Dated Cavalry Chain Coif', 'Normal/StandardItem', '1', '0', '0', '19460', '8736', '80609', '7004', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011704', 'Dated Cavalry Chain Coif (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '8736', '80610', '7004', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011705', 'Dated Cavalry Chain Coif (Black)', 'Normal/StandardItem', '1', '0', '0', '19460', '8736', '80611', '7004', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011706', 'Dated Cavalry Chain Coif (Ochre)', 'Normal/StandardItem', '1', '0', '0', '19460', '8736', '80612', '7004', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011707', 'Dated Cavalry Chain Coif (Green)', 'Normal/StandardItem', '1', '0', '0', '19460', '8736', '80613', '7004', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8011708', 'Judge\'s Chain Coif', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '80614', '7004', '1', '0', '0', '0', '0', '1', '2033', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011709', 'Templar\'s Chain Coif', 'Normal/StandardItem', '1', '1', '0', '19460', '9100', '82046', '7004', '2', '0', '0', '0', '0', '49', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8011710', 'Mythril Chain Coif', 'Normal/StandardItem', '1', '0', '0', '19460', '8008', '82196', '7004', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011711', 'Mythril Chain Coif (Black)', 'Normal/StandardItem', '1', '0', '0', '19460', '8008', '82196', '7004', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8011712', 'Cobalt Chain Coif', 'Normal/StandardItem', '1', '0', '0', '19460', '8918', '82197', '7004', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011713', 'Cobalt Chain Coif (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '8918', '82197', '7004', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8011801', 'Dated Hempen Scarf', 'Normal/StandardItem', '1', '0', '0', '11120', '224', '80641', '7006', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011802', 'Dated Hempen Scarf (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '224', '80642', '7006', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011803', 'Dated Hempen Scarf (Beige)', 'Normal/StandardItem', '1', '0', '0', '11120', '224', '80643', '7006', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011804', 'Dated Hempen Scarf (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '224', '80644', '7006', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011805', 'Dated Cotton Scarf', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '80645', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011806', 'Dated Cotton Scarf (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '80646', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011807', 'Dated Cotton Scarf (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '80647', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011808', 'Dated Cotton Scarf (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '80648', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011809', 'Dated Cotton Scarf (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '80649', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8011810', 'Dated Velveteen Scarf', 'Normal/StandardItem', '1', '0', '0', '11120', '1904', '80650', '7006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8011811', 'Dated Velveteen Scarf (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1904', '80652', '7006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8011812', 'Dated Velveteen Scarf (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1904', '80654', '7006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8011813', 'Dated Velveteen Scarf (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1904', '80651', '7006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8011814', 'Dated Velveteen Scarf (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1904', '80653', '7006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8011815', 'Cotton Scarf', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '81731', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8011816', 'Cotton Scarf (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '81741', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8011817', 'Cotton Scarf (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '784', '81747', '7006', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8011901', 'Moldering Jester\'s Cap', 'Normal/StandardItem', '1', '1', '0', '13900', '3628', '82033', '7005', '1', '0', '0', '0', '0', '26', '1007', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8011902', 'Vintage Jester\'s Cap', 'Normal/StandardItem', '1', '1', '0', '13900', '6316', '81641', '7005', '1', '0', '0', '0', '0', '46', '1007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8011903', 'Harlequin\'s Cap', 'Normal/StandardItem', '1', '1', '0', '13900', '6854', '81643', '7005', '2', '0', '0', '0', '0', '50', '1007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8012001', 'Dated Straw Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '322', '80523', '7005', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012002', 'Dated Walking Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '1288', '80526', '7005', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012003', 'Dated Tarred Walking Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '2898', '80529', '7005', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8012004', 'Dated Fishing Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '80532', '7005', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8012005', 'Dated Fishing Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '80533', '7005', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8012006', 'Dated Fishing Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '80534', '7005', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8012007', 'Dated Fishing Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '80535', '7005', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8012008', 'Dated Fishing Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '80536', '7005', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8012009', 'Weathered Sun Hat', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '80542', '7005', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012010', 'Weathered Beach Hat (Blue)', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '80543', '7005', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012011', 'Straw Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '660', '80523', '7005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012012', 'Stablehand\'s Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '660', '81471', '7005', '1', '0', '0', '0', '0', '10', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012013', 'Stablemaid\'s Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '660', '82172', '7005', '1', '0', '0', '0', '0', '10', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012014', 'Angler\'s Hat', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012015', 'Angler\'s Hat of Strength (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012016', 'Angler\'s Hat of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012017', 'Straw Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '660', '80524', '7005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012018', 'Straw Hat (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '660', '80525', '7005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012019', 'Angler\'s Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012020', 'Angler\'s Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012021', 'Angler\'s Hat of Strength', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012022', 'Angler\'s Hat of Strength (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012023', 'Angler\'s Hat of Dexterity', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012024', 'Angler\'s Hat of Dexterity (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '2220', '82173', '7005', '1', '0', '0', '0', '1', '36', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012101', 'Onion Helm', 'Normal/SpecialEquipItem', '1', '1', '1', '15290', '0', '80655', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012102', 'Peregrine Helm', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82075', '7004', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8012103', 'Red Onion Helm', 'Normal/StandardItem', '1', '1', '0', '15290', '5345', '80657', '7004', '2', '0', '0', '0', '1', '45', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8012201', 'Buccaneer\'s Tricorne', 'Normal/StandardItem', '1', '1', '0', '13900', '6115', '82049', '7005', '2', '0', '0', '0', '0', '47', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8012202', 'Silver Tricorne', 'Normal/StandardItem', '1', '1', '0', '12510', '2606', '82074', '7005', '2', '0', '0', '0', '0', '48', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8012301', 'Dated Chef\'s Hat', 'Normal/StandardItem', '1', '0', '0', '13900', '3168', '81848', '7005', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012302', 'Dated Chef\'s Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3168', '81849', '7005', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012303', 'Dated Chef\'s Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3168', '81850', '7005', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012304', 'Dated Chef\'s Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3168', '81851', '7005', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012305', 'Dated Chef\'s Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '3168', '81852', '7005', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012306', 'Vintage Chef\'s Hat', 'Normal/StandardItem', '1', '1', '0', '13900', '2664', '81846', '7005', '1', '0', '0', '0', '0', '36', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8012307', 'Ripped Chef\'s Hat', 'Normal/StandardItem', '1', '1', '0', '7500', '544', '81847', '7005', '1', '0', '0', '0', '0', '16', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8012308', 'Linen Deerstalker', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012309', 'Linen Deerstalker of Piety (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012310', 'Linen Deerstalker of Intelligence (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012311', 'Linen Deerstalker of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012312', 'Woolen Deerstalker', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012313', 'Woolen Deerstalker of Piety (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012314', 'Woolen Deerstalker of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82208', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012315', 'Woolen Deerstalker of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82209', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012316', 'Linen Deerstalker (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012317', 'Linen Deerstalker (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012318', 'Linen Deerstalker (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012319', 'Linen Deerstalker of Piety', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012320', 'Linen Deerstalker of Piety (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012321', 'Linen Deerstalker of Piety (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012322', 'Linen Deerstalker of Intelligence', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012323', 'Linen Deerstalker of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012324', 'Linen Deerstalker of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012325', 'Linen Deerstalker of Dexterity', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012326', 'Linen Deerstalker of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012327', 'Linen Deerstalker of Dexterity (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '3024', '82206', '7005', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8012328', 'Woolen Deerstalker (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012329', 'Woolen Deerstalker (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82208', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012330', 'Woolen Deerstalker (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82209', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012331', 'Woolen Deerstalker (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82421', '7005', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012332', 'Woolen Deerstalker of Piety', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012333', 'Woolen Deerstalker of Piety (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82208', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012334', 'Woolen Deerstalker of Piety (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82209', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012335', 'Woolen Deerstalker of Piety (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82421', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012336', 'Woolen Deerstalker of Intelligence', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012337', 'Woolen Deerstalker of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012338', 'Woolen Deerstalker of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82209', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012339', 'Woolen Deerstalker of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82421', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012340', 'Woolen Deerstalker of Dexterity', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012341', 'Woolen Deerstalker of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82207', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012342', 'Woolen Deerstalker of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82208', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012343', 'Woolen Deerstalker of Dexterity (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '3384', '82421', '7005', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8012401', 'Dated Sheepskin Calot', 'Normal/StandardItem', '1', '0', '0', '11120', '648', '81887', '7005', '1', '0', '0', '0', '0', '8', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012402', 'Dated Sheepskin Calot (Taupe)', 'Normal/StandardItem', '1', '0', '0', '11120', '648', '81887', '7005', '1', '0', '0', '0', '0', '8', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012403', 'Dated Sheepskin Calot (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '648', '81887', '7005', '1', '0', '0', '0', '0', '8', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012404', 'Dated Dodoskin Calot', 'Normal/StandardItem', '1', '0', '0', '11120', '1368', '81887', '7005', '1', '0', '0', '0', '0', '18', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8012405', 'Dated Dodoskin Calot (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1368', '81887', '7005', '1', '0', '0', '0', '0', '18', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8012406', 'Dated Leather Calot (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '2088', '81889', '7005', '1', '0', '0', '0', '0', '28', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012407', 'Dated Leather Calot (Ochre)', 'Normal/StandardItem', '1', '0', '0', '11120', '2088', '81889', '7005', '1', '0', '0', '0', '0', '28', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012408', 'Dated Leather Calot (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2088', '81889', '7005', '1', '0', '0', '0', '0', '28', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012409', 'Dated Leather Calot (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '2088', '81889', '7005', '1', '0', '0', '0', '0', '28', '1121', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012410', 'Sheepskin Calot', 'Normal/StandardItem', '1', '0', '0', '11120', '144', '81887', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012411', 'Sheepskin Calot (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '144', '81887', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012412', 'Explorer\'s Calot', 'Normal/StandardItem', '1', '1', '0', '11120', '3456', '81889', '7005', '2', '0', '0', '0', '1', '47', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8012501', 'Dream Hat', 'Normal/StandardItem', '1', '0', '0', '11120', '144', '81892', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012502', 'Reindeer Antlers', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82401', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012601', 'Black Usagi Kabuto', 'Normal/StandardItem', '1', '0', '0', '20000', '2688', '81973', '7004', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8012602', 'Silver Usagi Kabuto', 'Normal/StandardItem', '1', '0', '0', '20000', '2688', '81974', '7004', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8012603', 'Usagi Kabuto', 'Normal/StandardItem', '1', '0', '0', '20000', '256', '81972', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012604', 'Dragon Kabuto', 'Normal/StandardItem', '1', '1', '1', '20000', '0', '82407', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012605', 'Crimson Dragon Kabuto', 'Normal/StandardItem', '1', '1', '1', '20000', '0', '82409', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012606', 'Golden Dragon Kabuto', 'Normal/StandardItem', '1', '1', '1', '20000', '0', '82408', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012607', 'Black Dragon Kabuto', 'Normal/StandardItem', '1', '1', '1', '20000', '0', '82410', '7004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012701', 'Dated Canvas Wedge Cap', 'Normal/StandardItem', '1', '0', '0', '12500', '1984', '81956', '7005', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8012702', 'Dated Canvas Wedge Cap (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12500', '1984', '81957', '7005', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8012703', 'Dated Canvas Wedge Cap (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '1984', '81958', '7005', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8012704', 'Dated Canvas Wedge Cap (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1984', '81959', '7005', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8012705', 'Dated Canvas Wedge Cap (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1984', '81960', '7005', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8012706', 'Dated Velveteen Wedge Cap', 'Normal/StandardItem', '1', '0', '0', '12500', '2624', '81961', '7005', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8012707', 'Dated Velveteen Wedge Cap (Black)', 'Normal/StandardItem', '1', '0', '0', '12500', '2624', '81962', '7005', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8012708', 'Dated Velveteen Wedge Cap (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2624', '81963', '7005', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8012709', 'Dated Velveteen Wedge Cap (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2624', '81964', '7005', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8012710', 'Dated Velveteen Wedge Cap (Green)', 'Normal/StandardItem', '1', '0', '0', '12500', '2624', '81965', '7005', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8012711', 'Dated Linen Wedge Cap', 'Normal/StandardItem', '1', '0', '0', '12500', '3264', '82076', '7005', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8012712', 'Dated Linen Wedge Cap (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '3264', '82077', '7005', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8012713', 'Dated Linen Wedge Cap (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '3264', '82078', '7005', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8012714', 'Dated Linen Wedge Cap (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '3264', '82079', '7005', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8012715', 'Dated Linen Wedge Cap (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '3264', '82080', '7005', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8012716', 'Velveteen Wedge Cap', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81961', '7005', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012717', 'Velveteen Wedge Cap of Crafting (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81963', '7005', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012718', 'Velveteen Wedge Cap of Gathering (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81964', '7005', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012719', 'Linen Wedge Cap', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82076', '7005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012720', 'Linen Wedge Cap of Crafting (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82078', '7005', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012721', 'Linen Wedge Cap of Gathering (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82079', '7005', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012722', 'Velveteen Wedge Cap (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81963', '7005', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012723', 'Velveteen Wedge Cap (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81964', '7005', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012724', 'Velveteen Wedge Cap of Crafting', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81961', '7005', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012725', 'Velveteen Wedge Cap of Crafting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81964', '7005', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012726', 'Velveteen Wedge Cap of Gathering', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81961', '7005', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012727', 'Velveteen Wedge Cap of Gathering (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1856', '81963', '7005', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8012728', 'Linen Wedge Cap (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82078', '7005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012729', 'Linen Wedge Cap (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82079', '7005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012730', 'Linen Wedge Cap (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82077', '7005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012731', 'Linen Wedge Cap (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82080', '7005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012732', 'Linen Wedge Cap of Crafting', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82076', '7005', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012733', 'Linen Wedge Cap of Crafting (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82079', '7005', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012734', 'Linen Wedge Cap of Crafting (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82077', '7005', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012735', 'Linen Wedge Cap of Crafting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82080', '7005', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012736', 'Linen Wedge Cap of Gathering', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82076', '7005', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012737', 'Linen Wedge Cap of Gathering (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82078', '7005', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012738', 'Linen Wedge Cap of Gathering (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82077', '7005', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012739', 'Linen Wedge Cap of Gathering (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2496', '82080', '7005', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8012801', 'Pristine Egg Cap', 'Normal/StandardItem', '1', '1', '0', '12000', '10', '82056', '7005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8012802', 'Vibrant Egg Cap', 'Normal/StandardItem', '1', '1', '0', '12000', '10', '82060', '7005', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8012803', 'Brilliant Egg Cap', 'Normal/StandardItem', '1', '1', '0', '12000', '10', '82059', '7005', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8012804', 'Midnight Egg Cap', 'Normal/StandardItem', '1', '1', '0', '12000', '10', '82058', '7005', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8012805', 'Chocobo Egg Cap', 'Normal/StandardItem', '1', '1', '0', '12000', '10', '82057', '7005', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8012901', 'Mythril Mesail', 'Normal/StandardItem', '1', '0', '0', '13900', '5598', '82156', '7008', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8012902', 'Cobalt Mesail', 'Normal/StandardItem', '1', '0', '0', '13900', '6249', '82157', '7008', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8012903', 'Cobalt Mesail (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '6249', '82158', '7008', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8012904', 'Cobalt Mesail (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '6249', '82411', '7008', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8013001', 'Woolen Cavalier\'s Hat', 'Normal/StandardItem', '1', '0', '0', '13900', '7875', '82198', '7005', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8013002', 'Woolen Cavalier\'s Hat (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '7875', '82199', '7005', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8013003', 'Felt Cavalier\'s Hat', 'Normal/StandardItem', '1', '0', '0', '13900', '8750', '82200', '7005', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013004', 'Felt Cavalier\'s Hat (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '8750', '82200', '7005', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013005', 'Plundered Cavalier\'s Hat', 'Normal/StandardItem', '1', '1', '0', '13900', '2800', '82154', '7005', '1', '0', '0', '0', '1', '15', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8013006', 'Felt Cavalier\'s Hat (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '8750', '82420', '7005', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013007', 'Felt Cavalier\'s Hat (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '8750', '82418', '7005', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013008', 'Felt Cavalier\'s Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '8750', '82419', '7005', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013101', 'Dodoskin Skullcap', 'Normal/StandardItem', '1', '0', '0', '13900', '1296', '81823', '7005', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8013102', 'Dodoskin Skullcap (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1296', '81824', '7005', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8013201', 'Lominsan Soldier\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82128', '7005', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8013202', 'Gridanian Soldier\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82129', '7005', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8013203', 'Ul\'dahn Soldier\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82130', '7005', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8013204', 'Lominsan Officer\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82131', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013205', 'Gridanian Officer\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82132', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013206', 'Ul\'dahn Officer\'s Cap', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82133', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013301', 'Pumpkin Head', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82137', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '36', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8013302', 'Unripened Pumpkin Head', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82138', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '36', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8013303', 'White Pumpkin Head', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82139', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '36', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8013304', 'Ripened Pumpkin Head', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82140', '7005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '36', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8013401', 'Butcher\'s Crown', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82403', '7007', '3', '0', '0', '0', '1', '50', '2002', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013402', 'Chronicler\'s Crown', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82404', '7007', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013403', 'Paragon\'s Crown', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82405', '7007', '3', '0', '0', '0', '1', '50', '2002', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013404', 'Gambler\'s Crown', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82406', '7007', '3', '0', '0', '0', '1', '50', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013501', 'Gallant Coronet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82486', '7007', '3', '0', '0', '0', '1', '49', '2120', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013502', 'Temple Circlet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82491', '7007', '3', '0', '0', '0', '1', '49', '2119', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013503', 'Fighter\'s Burgeonet', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82466', '7004', '3', '0', '0', '0', '1', '49', '2121', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013504', 'Drachen Armet', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82461', '7004', '3', '0', '0', '0', '1', '49', '2123', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013505', 'Choral Chapeau', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82481', '7005', '3', '0', '0', '0', '1', '49', '2122', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013506', 'Healer\'s Circlet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82471', '7007', '3', '0', '0', '0', '1', '49', '2125', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013507', 'Wizard\'s Petasos', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82476', '7005', '3', '0', '0', '0', '1', '49', '2124', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013601', 'Darklight Helm', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82498', '7004', '3', '0', '0', '0', '1', '50', '2127', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013602', 'Darklight Eyepatch', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82502', '7009', '3', '0', '0', '0', '1', '50', '2128', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013603', 'Vanya Hat', 'Normal/StandardItem', '1', '0', '0', '12510', '5740', '82567', '7005', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013604', 'Vanya Hat (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '5740', '82566', '7005', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013605', 'Vanya Hat (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '5740', '82565', '7005', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013606', 'Vanya Hat (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '5740', '82568', '7005', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013607', 'Vanya Hat (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '5740', '82569', '7005', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8013608', 'Militia Armet', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80378', '7004', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013609', 'Militia Hat', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82574', '7005', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013610', 'Militia Barbut', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82576', '7004', '2', '0', '0', '0', '1', '50', '2158', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013611', 'Hamlet Puller\'s Hat', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82570', '7005', '2', '0', '0', '0', '1', '50', '2147', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013612', 'Hamlet Cutter\'s Hat', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82571', '7005', '2', '0', '0', '0', '1', '50', '2146', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013613', 'Hamlet Digger\'s Helmet', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82572', '7004', '2', '0', '0', '0', '1', '50', '2145', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013614', 'Storm Sergeant\'s Circlet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82588', '7007', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013615', 'Storm Sergeant\'s Mask', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82578', '7008', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013616', 'Storm Sergeant\'s Beret', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80520', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013617', 'Serpent Sergeant\'s Circlet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82589', '7007', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013618', 'Serpent Sergeant\'s Mask', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81646', '7008', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013619', 'Serpent Sergeant\'s Beret', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80521', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013620', 'Flame Sergeant\'s Circlet', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82587', '7007', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013621', 'Flame Sergeant\'s Mask', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81647', '7008', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013622', 'Flame Sergeant\'s Beret', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80519', '7005', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013623', 'Scarf of Wondrous Wit', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81742', '7006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8013624', 'Legionary Visor', 'Normal/StandardItem', '1', '0', '0', '7500', '1472', '80460', '7008', '1', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013625', 'Rose Gold Circlet', 'Normal/StandardItem', '1', '0', '0', '13900', '5152', '82600', '7007', '1', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013626', 'Chocobo Mask', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82607', '7004', '2', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8013627', 'Carpenter\'s Hood', 'Normal/StandardItem', '1', '0', '0', '11120', '3213', '82612', '7005', '1', '0', '0', '0', '1', '50', '2137', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013628', 'Blacksmith\'s Goggles', 'Normal/StandardItem', '1', '0', '0', '13900', '5140', '82613', '7009', '1', '0', '0', '0', '1', '50', '2138', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013629', 'Armorer\'s Visor', 'Normal/StandardItem', '1', '0', '0', '13900', '6640', '82614', '7008', '1', '0', '0', '0', '1', '50', '2139', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013630', 'Goldsmith\'s Turban', 'Normal/StandardItem', '1', '0', '0', '13900', '2784', '82615', '7005', '1', '0', '0', '0', '1', '50', '2140', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013631', 'Leatherworker\'s Hat', 'Normal/StandardItem', '1', '0', '0', '15290', '6640', '82616', '7005', '1', '0', '0', '0', '1', '50', '2141', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013632', 'Weaver\'s Gibus', 'Normal/StandardItem', '1', '0', '0', '13900', '8925', '82617', '7005', '1', '0', '0', '0', '1', '50', '2142', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013633', 'Alchemist\'s Monocle', 'Normal/StandardItem', '1', '0', '0', '11120', '4998', '82618', '7009', '1', '0', '0', '0', '1', '50', '2143', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013634', 'Culinarian\'s Hat', 'Normal/StandardItem', '1', '0', '0', '13900', '3672', '82619', '7005', '1', '0', '0', '0', '1', '50', '2144', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013635', 'Dalamud Horn', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82620', '7007', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013636', 'Imperial Operative Tricorne', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82635', '7005', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8013637', 'Imperial Operative Hat', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82636', '7005', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030001', 'Dated Hempen Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '1302', '80044', '7016', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030002', 'Dated Hempen Doublet (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '1302', '80045', '7016', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030003', 'Dated Hempen Doublet (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '1302', '80046', '7016', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030004', 'Dated Hempen Doublet (Beige)', 'Normal/StandardItem', '1', '0', '0', '27800', '1302', '80047', '7016', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030005', 'Dated Cotton Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '3162', '80019', '7016', '1', '0', '0', '0', '0', '16', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8030006', 'Dated Cotton Doublet (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '3162', '80020', '7016', '1', '0', '0', '0', '0', '16', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8030007', 'Dated Cotton Doublet (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '3162', '80021', '7016', '1', '0', '0', '0', '0', '16', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8030008', 'Dated Cotton Doublet (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '3162', '80022', '7016', '1', '0', '0', '0', '0', '16', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8030009', 'Dated Cotton Doublet (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '3162', '80023', '7016', '1', '0', '0', '0', '0', '16', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8030010', 'Dated Canvas Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '5022', '80024', '7016', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8030011', 'Dated Canvas Doublet (Auburn)', 'Normal/StandardItem', '1', '0', '0', '27800', '5022', '80025', '7016', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8030012', 'Dated Canvas Doublet (Pink)', 'Normal/StandardItem', '1', '0', '0', '27800', '5022', '80026', '7016', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8030013', 'Dated Canvas Doublet (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '5022', '80027', '7016', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8030014', 'Dated Canvas Doublet (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5022', '80028', '7016', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8030015', 'Linen Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80029', '7016', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030016', 'Linen Doublet (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80031', '7016', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030017', 'Linen Doublet of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80031', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030018', 'Linen Doublet of Strength (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80032', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030019', 'Linen Doublet of Dexterity (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80033', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030020', 'Woolen Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82210', '7016', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030021', 'Woolen Doublet of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030022', 'Woolen Doublet of Strength (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030023', 'Woolen Doublet of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82211', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030024', 'Linen Doublet (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80032', '7016', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030025', 'Linen Doublet (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80033', '7016', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030026', 'Linen Doublet of Vitality', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80029', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030027', 'Linen Doublet of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80032', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030028', 'Linen Doublet of Vitality (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80033', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030029', 'Linen Doublet of Strength', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80029', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030030', 'Linen Doublet of Strength (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80031', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030031', 'Linen Doublet of Strength (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80033', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030032', 'Weathered Doublet (Yellow)', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '80676', '7016', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030033', 'Onion Doublet', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '81353', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030034', 'Dodore Doublet', 'Normal/StandardItem', '1', '0', '0', '27800', '9114', '81405', '7016', '2', '0', '0', '0', '0', '48', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030035', 'Gridanian Doublet', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '80021', '7016', '2', '0', '0', '0', '1', '25', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030036', 'Linen Doublet of Dexterity', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80029', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030037', 'Linen Doublet of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80031', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030038', 'Linen Doublet of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '7998', '80032', '7016', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030039', 'Woolen Doublet (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030040', 'Woolen Doublet (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030041', 'Woolen Doublet (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82211', '7016', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030042', 'Woolen Doublet of Vitality', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82210', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030043', 'Woolen Doublet of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030044', 'Woolen Doublet of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82211', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030045', 'Woolen Doublet of Strength', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82210', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030046', 'Woolen Doublet of Strength (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030047', 'Woolen Doublet of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82211', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030048', 'Woolen Doublet of Dexterity', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82210', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030049', 'Woolen Doublet of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030050', 'Woolen Doublet of Dexterity (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '8928', '82212', '7016', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030101', 'Dated Bronze Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '11700', '80048', '7014', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8030102', 'Dated Bronze Cuirass (Auburn)', 'Normal/StandardItem', '1', '0', '0', '41700', '11700', '80049', '7014', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8030103', 'Dated Bronze Cuirass (Pink)', 'Normal/StandardItem', '1', '0', '0', '41700', '11700', '80050', '7014', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8030104', 'Dated Bronze Cuirass (Brown)', 'Normal/StandardItem', '1', '0', '0', '41700', '11700', '80051', '7014', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8030105', 'Dated Bronze Cuirass (Blue)', 'Normal/StandardItem', '1', '0', '0', '41700', '11700', '80052', '7014', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8030106', 'Dated Iron Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '14700', '80053', '7014', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030107', 'Dated Iron Cuirass (Green)', 'Normal/StandardItem', '1', '0', '0', '41700', '14700', '80056', '7014', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030108', 'Dated Iron Cuirass (Brown)', 'Normal/StandardItem', '1', '0', '0', '41700', '14700', '80057', '7014', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030109', 'Steel Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '12000', '80054', '7014', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030110', 'Steel Cuirass (Blue)', 'Normal/StandardItem', '1', '0', '0', '41700', '12000', '80058', '7014', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030111', 'Cobalt Cuirass (Blue)', 'Normal/StandardItem', '1', '0', '0', '41700', '15000', '82422', '7014', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8030112', 'Sentinel\'s Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '15300', '80062', '7014', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030113', 'Cobalt Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '15000', '82213', '7014', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8030114', 'Cobalt Cuirass (Red)', 'Normal/StandardItem', '1', '0', '0', '41700', '15000', '82214', '7014', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8030115', '[en]', 'Normal/StandardItem', '1', '0', '0', '41700', '600', '60000', '7014', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030116', 'Darksteel Cuirass', 'Normal/StandardItem', '1', '0', '0', '41700', '600', '60000', '7014', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030117', 'Darksteel Cuirass (White)', 'Normal/StandardItem', '1', '0', '0', '41700', '600', '60000', '7014', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030118', 'Darksteel Cuirass (Gold)', 'Normal/StandardItem', '1', '0', '0', '41700', '600', '60000', '7014', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030119', '[en]', 'Normal/StandardItem', '1', '0', '0', '41700', '600', '60000', '7014', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030201', 'Dated Hempen Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '1148', '80091', '7016', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030202', 'Dated Hempen Robe (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '1148', '80092', '7016', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030203', 'Dated Hempen Robe (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '1148', '80093', '7016', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030204', 'Dated Hempen Robe (Beige)', 'Normal/StandardItem', '1', '0', '0', '25020', '1148', '80094', '7016', '1', '0', '0', '0', '0', '6', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030205', 'Dated Cotton Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '2788', '80095', '7016', '1', '0', '0', '0', '0', '16', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8030206', 'Dated Cotton Robe (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '2788', '80096', '7016', '1', '0', '0', '0', '0', '16', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8030207', 'Dated Cotton Robe (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '2788', '80097', '7016', '1', '0', '0', '0', '0', '16', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8030208', 'Dated Cotton Robe (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '2788', '80098', '7016', '1', '0', '0', '0', '0', '16', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8030209', 'Dated Cotton Robe (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '2788', '80099', '7016', '1', '0', '0', '0', '0', '16', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8030210', 'Dated Canvas Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '4428', '80100', '7016', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8030211', 'Dated Canvas Robe (Auburn)', 'Normal/StandardItem', '1', '0', '0', '25020', '4428', '80101', '7016', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8030212', 'Dated Canvas Robe (Pink)', 'Normal/StandardItem', '1', '0', '0', '25020', '4428', '80102', '7016', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8030213', 'Dated Canvas Robe (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '4428', '80103', '7016', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8030214', 'Dated Canvas Robe (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '4428', '80104', '7016', '1', '0', '0', '0', '0', '26', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8030215', 'Dated Velveteen Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80105', '7016', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8030216', 'Dated Velveteen Robe (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80106', '7016', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8030217', 'Dated Velveteen Robe (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80107', '7016', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8030218', 'Dated Velveteen Robe (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80108', '7016', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8030219', 'Dated Velveteen Robe (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80109', '7016', '1', '0', '0', '0', '0', '36', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8030220', 'Linen Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80110', '7016', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030221', 'Linen Robe of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80111', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030222', 'Linen Robe of Casting (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80112', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030223', 'Linen Robe (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80111', '7016', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030224', 'Linen Robe (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80112', '7016', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030225', 'Woolen Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80115', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030226', 'Woolen Robe (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80117', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030227', 'Woolen Robe of Casting (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80117', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030228', 'Woolen Robe (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80119', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030229', 'Woolen Robe of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80119', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030230', 'Felt Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80120', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030231', 'Felt Robe of Casting (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80121', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030232', 'Felt Robe (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80121', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030233', 'Felt Robe of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80123', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030234', 'Linen Robe of the Mind', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80110', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030235', 'Linen Robe of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80112', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030236', 'Linen Robe of Casting', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80110', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030237', 'Linen Robe of Casting (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '6068', '80111', '7016', '1', '0', '0', '0', '1', '36', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8030238', 'Woolen Robe of Casting', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80115', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030239', 'Woolen Robe of Casting (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80119', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030240', 'Woolen Robe of the Mind', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80115', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030241', 'Woolen Robe of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6888', '80117', '7016', '1', '0', '0', '0', '1', '41', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8030242', 'Felt Robe (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80123', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030243', 'Felt Robe (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80122', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030244', 'Sorcerer\'s Robe', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '82149', '7016', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030245', 'Weathered Robe', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80711', '7016', '1', '0', '0', '0', '0', '1', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030246', 'Vintage Robe', 'Normal/StandardItem', '1', '1', '0', '25020', '8036', '81485', '7016', '1', '0', '0', '0', '0', '48', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030247', 'Tattered Robe', 'Normal/StandardItem', '1', '1', '0', '15000', '2340', '81485', '7016', '1', '0', '0', '0', '0', '38', '1106', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030248', 'Ul\'dahn Robe', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80106', '7016', '2', '0', '0', '0', '1', '25', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030249', 'Felt Robe (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80124', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030250', 'Felt Robe of Casting', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80120', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030251', 'Felt Robe of Casting (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80123', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030252', 'Felt Robe of Casting (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80122', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030253', 'Felt Robe of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80124', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030254', 'Felt Robe of the Mind', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80120', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030255', 'Felt Robe of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80121', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030256', 'Felt Robe of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80122', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030257', 'Felt Robe of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7708', '80124', '7016', '1', '0', '0', '0', '1', '46', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8030301', 'Dated Bronze Chainmail', 'Normal/StandardItem', '1', '0', '0', '33360', '2080', '80127', '7015', '1', '0', '0', '0', '0', '12', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030302', 'Dated Bronze Chainmail (Brown)', 'Normal/StandardItem', '1', '0', '0', '33360', '2080', '80128', '7015', '1', '0', '0', '0', '0', '12', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030303', 'Dated Bronze Chainmail (Grey)', 'Normal/StandardItem', '1', '0', '0', '33360', '2080', '80129', '7015', '1', '0', '0', '0', '0', '12', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030304', 'Dated Bronze Chainmail (Beige)', 'Normal/StandardItem', '1', '0', '0', '33360', '2080', '80130', '7015', '1', '0', '0', '0', '0', '12', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030305', 'Dated Sentinel\'s Chainmail', 'Normal/StandardItem', '1', '0', '0', '33360', '3680', '80131', '7015', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030306', 'Dated Sentinel\'s Chainmail (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '3680', '80132', '7015', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030307', 'Dated Sentinel\'s Chainmail (Yellow)', 'Normal/StandardItem', '1', '0', '0', '33360', '3680', '80133', '7015', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030308', 'Dated Sentinel\'s Chainmail (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '3680', '80134', '7015', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030309', 'Dated Sentinel\'s Chainmail (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '3680', '80135', '7015', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030310', 'Dated Mercenary\'s Chainmail', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '80136', '7015', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030311', 'Dated Mercenary\'s Chainmail (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '80137', '7015', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030312', 'Dated Mercenary\'s Chainmail (Yellow)', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '80138', '7015', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030313', 'Dated Mercenary\'s Chainmail (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '80139', '7015', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030314', 'Dated Mercenary\'s Chainmail (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '80140', '7015', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030315', 'Dated Cavalier\'s Chainmail', 'Normal/StandardItem', '1', '0', '0', '33360', '6880', '80141', '7015', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030316', 'Dated Cavalier\'s Chainmail (Auburn)', 'Normal/StandardItem', '1', '0', '0', '33360', '6880', '80142', '7015', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030317', 'Dated Cavalier\'s Chainmail (Pink)', 'Normal/StandardItem', '1', '0', '0', '33360', '6880', '80143', '7015', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030318', 'Dated Cavalier\'s Chainmail (Brown)', 'Normal/StandardItem', '1', '0', '0', '33360', '6880', '80144', '7015', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030319', 'Dated Cavalier\'s Chainmail (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '6880', '80145', '7015', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8030320', 'Steel Chainmail', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '82243', '7015', '1', '0', '0', '0', '0', '32', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030321', 'Steel Chainmail (Yellow)', 'Normal/StandardItem', '1', '0', '0', '33360', '5280', '82244', '7015', '1', '0', '0', '0', '0', '32', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8030322', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030323', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030324', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030325', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030326', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030327', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030328', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030329', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030330', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030331', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030332', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030333', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030334', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030335', 'Felt Tabard', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030336', 'Felt Tabard (Teal)', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030337', 'Felt Tabard (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030338', 'Felt Tabard (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030339', 'Felt Tabard (Brown)', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030340', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030341', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030342', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030343', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030344', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030345', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030346', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030347', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030348', '[en]', 'Normal/StandardItem', '1', '0', '0', '33360', '320', '60000', '7015', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030349', 'Explorer\'s Tabard', 'Normal/StandardItem', '1', '1', '0', '33360', '8160', '80147', '7015', '2', '0', '0', '0', '1', '50', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030350', 'Lominsan Chainmail', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82069', '7015', '2', '0', '0', '0', '1', '25', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030401', 'Dated Hempen Dalmatica', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80063', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030402', 'Dated Hempen Dalmatica (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80064', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030403', 'Dated Hempen Dalmatica (Grey)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80065', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030404', 'Dated Hempen Dalmatica (Beige)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80066', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030405', 'Dated Cotton Dalmatica', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80067', '7016', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030406', 'Dated Cotton Dalmatica (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80068', '7016', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030407', 'Dated Cotton Dalmatica (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80069', '7016', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030408', 'Dated Cotton Dalmatica (Green)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80070', '7016', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030409', 'Dated Cotton Dalmatica (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80071', '7016', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030410', 'Dated Canvas Dalmatica', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80072', '7016', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030411', 'Dated Canvas Dalmatica (Auburn)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80073', '7016', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030412', 'Dated Canvas Dalmatica (Pink)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80074', '7016', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030413', 'Dated Canvas Dalmatica (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80075', '7016', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030414', 'Dated Canvas Dalmatica (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80076', '7016', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030415', 'Hempen Dalmatica (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80064', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030416', 'Hempen Dalmatica (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80066', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030417', 'Hempen Dalmatica of Casting', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80063', '7016', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030418', 'Hempen Dalmatica of Casting (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80066', '7016', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030419', 'Hempen Dalmatica of Toiling', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80063', '7016', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030420', 'Hempen Dalmatica', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80063', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030421', 'Hempen Dalmatica of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80064', '7016', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030422', 'Hempen Dalmatica of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80066', '7016', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030423', 'Cotton Dalmatica', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80067', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030424', 'Cotton Dalmatica of Casting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80069', '7016', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030425', 'Cotton Dalmatica of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80071', '7016', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030426', 'Hempen Dalmatica of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80064', '7016', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030427', 'Cotton Dalmatica (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80069', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030428', 'Cotton Dalmatica (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80071', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030429', 'Cotton Dalmatica of Casting', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80067', '7016', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030430', 'Cotton Dalmatica of Casting (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80071', '7016', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030431', 'Cotton Dalmatica of Toiling', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80067', '7016', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030432', 'Cotton Dalmatica of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80069', '7016', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8030433', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030434', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030435', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030436', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030437', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030438', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030439', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030440', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030441', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030442', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030443', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030444', '[en]', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '60000', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8030445', 'Weathered Dalmatica', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '80682', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030446', 'Weathered Dalmatica (Grey)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '80683', '7016', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030447', 'Lominsan Dalmatica', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '80679', '7016', '2', '0', '0', '0', '1', '25', '2111', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030501', 'Dated Hempen Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80077', '7016', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030502', 'Dated Hempen Gown (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80078', '7016', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030503', 'Dated Hempen Gown (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80079', '7016', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030504', 'Dated Hempen Gown (Beige)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80080', '7016', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030505', 'Dated Cotton Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80081', '7016', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8030506', 'Dated Cotton Gown (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80082', '7016', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8030507', 'Dated Cotton Gown (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80083', '7016', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8030508', 'Dated Cotton Gown (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80084', '7016', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8030509', 'Dated Cotton Gown (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80085', '7016', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8030510', 'Dated Canvas Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80086', '7016', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8030511', 'Dated Canvas Gown (Auburn)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80087', '7016', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8030512', 'Dated Canvas Gown (Pink)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80088', '7016', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8030513', 'Dated Canvas Gown (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80089', '7016', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8030514', 'Dated Canvas Gown (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80090', '7016', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8030515', 'Dated Velveteen Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80684', '7016', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8030516', 'Dated Velveteen Gown (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80685', '7016', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8030517', 'Dated Velveteen Gown (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80686', '7016', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8030518', 'Dated Velveteen Gown (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80687', '7016', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8030519', 'Dated Velveteen Gown (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80688', '7016', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8030520', 'Woolen Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82215', '7016', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030521', 'Woolen Gown of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82216', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030522', 'Woolen Gown of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82217', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030523', 'Woolen Gown of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82218', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030524', 'Felt Gown', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82219', '7016', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030525', 'Felt Gown of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82220', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030526', 'Felt Gown of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82221', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030527', 'Felt Gown of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82222', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030528', 'Woolen Gown (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82216', '7016', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030529', 'Woolen Gown (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82217', '7016', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030530', 'Woolen Gown (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82218', '7016', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030531', 'Woolen Gown of the Mind', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82215', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030532', 'Woolen Gown of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82217', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030533', 'Woolen Gown of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82218', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030534', 'Woolen Gown of Vitality', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82215', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030535', 'Woolen Gown of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82216', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030536', 'Woolen Gown of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82218', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030537', 'Woolen Gown of Intelligence', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82215', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030538', 'Woolen Gown of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82216', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030539', 'Woolen Gown of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '6600', '82217', '7016', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030540', 'Felt Gown (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82220', '7016', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030541', 'Felt Gown (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82221', '7016', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030542', 'Felt Gown (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82222', '7016', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030543', 'Felt Gown (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82423', '7016', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030544', 'Felt Gown of the Mind', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82219', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030545', 'Felt Gown of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82221', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030546', 'Weathered Gown (Grey)', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80689', '7016', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030547', 'Weathered Gown (Beige)', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80690', '7016', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030548', 'Ul\'dahn Gown', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80685', '7016', '2', '0', '0', '0', '1', '25', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030549', 'Felt Gown of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82222', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030550', 'Felt Gown of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82423', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030551', 'Felt Gown of Vitality', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82219', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030552', 'Felt Gown of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82220', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030553', 'Felt Gown of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82222', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030554', 'Felt Gown of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82423', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030555', 'Felt Gown of Intelligence', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82219', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030556', 'Felt Gown of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82220', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030557', 'Felt Gown of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82221', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030558', 'Felt Gown of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '7350', '82423', '7016', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030601', 'Weathered Hunting Tunic (Brown)', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '80745', '7016', '1', '0', '0', '0', '0', '1', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030602', 'Dated Hunting Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '30580', '1860', '80125', '7016', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030603', 'Dated Hunting Tunic (Grey)', 'Normal/StandardItem', '1', '0', '0', '30580', '1860', '80728', '7016', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030604', 'Dated Hunting Tunic (Beige)', 'Normal/StandardItem', '1', '0', '0', '30580', '1860', '80729', '7016', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030605', 'Dated Trapper\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '3720', '80730', '7016', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030606', 'Dated Trapper\'s Tunic (Red)', 'Normal/StandardItem', '1', '0', '0', '30580', '3720', '80731', '7016', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030607', 'Dated Trapper\'s Tunic (Yellow)', 'Normal/StandardItem', '1', '0', '0', '30580', '3720', '80732', '7016', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030608', 'Dated Trapper\'s Tunic (Green)', 'Normal/StandardItem', '1', '0', '0', '30580', '3720', '80733', '7016', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030609', 'Dated Trapper\'s Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '30580', '3720', '80734', '7016', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030610', 'Dated Tracker\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '5580', '80735', '7016', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030611', 'Dated Tracker\'s Tunic (Auburn)', 'Normal/StandardItem', '1', '0', '0', '30580', '5580', '80736', '7016', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030612', 'Dated Tracker\'s Tunic (Pink)', 'Normal/StandardItem', '1', '0', '0', '30580', '5580', '80737', '7016', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030613', 'Dated Tracker\'s Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '30580', '5580', '80738', '7016', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030614', 'Dated Tracker\'s Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '30580', '5580', '80739', '7016', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030615', 'Dated Bowman\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '7440', '80740', '7016', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030616', 'Dated Bowman\'s Tunic (Black)', 'Normal/StandardItem', '1', '0', '0', '30580', '7440', '80741', '7016', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030617', 'Dated Bowman\'s Tunic (Red)', 'Normal/StandardItem', '1', '0', '0', '30580', '7440', '80742', '7016', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030618', 'Dated Bowman\'s Tunic (Yellow)', 'Normal/StandardItem', '1', '0', '0', '30580', '7440', '80743', '7016', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030619', 'Dated Bowman\'s Tunic (Green)', 'Normal/StandardItem', '1', '0', '0', '30580', '7440', '80744', '7016', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030620', 'Poacher\'s Tunic', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '81511', '7016', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8030621', 'Ranger\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '8184', '82233', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030622', 'Ranger\'s Tunic (Red)', 'Normal/StandardItem', '1', '0', '0', '30580', '8184', '82234', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8030623', 'Rainmaker\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '9114', '82235', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030624', 'Rainmaker\'s Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '30580', '9114', '82236', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030625', 'Serpent Private\'s Tunic', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '80733', '7016', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030626', 'Serpent Sergeant\'s Tunic', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '80738', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030627', 'Explorer\'s Tunic', 'Normal/StandardItem', '1', '1', '0', '30580', '9114', '82509', '7016', '2', '0', '0', '0', '1', '48', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8030701', 'Weathered Shirt', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '80759', '7016', '1', '0', '0', '0', '0', '1', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030702', 'Dated Hempen Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '1404', '80126', '7016', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030703', 'Dated Hempen Shirt (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '1404', '80746', '7016', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030704', 'Dated Hempen Shirt (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '1404', '80747', '7016', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030705', 'Dated Hempen Shirt (Beige)', 'Normal/StandardItem', '1', '0', '0', '27800', '1404', '80748', '7016', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030706', 'Dated Cotton Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '2964', '80749', '7016', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030707', 'Dated Cotton Shirt (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '2964', '80750', '7016', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030708', 'Dated Cotton Shirt (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '2964', '80751', '7016', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030709', 'Dated Cotton Shirt (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '2964', '80752', '7016', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030710', 'Dated Cotton Shirt (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '2964', '80753', '7016', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030711', 'Dated Velveteen Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '6084', '80754', '7016', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030712', 'Dated Velveteen Shirt (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '6084', '80755', '7016', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030713', 'Dated Velveteen Shirt (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6084', '80756', '7016', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030714', 'Dated Velveteen Shirt (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '6084', '80757', '7016', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030715', 'Dated Velveteen Shirt (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '6084', '80758', '7016', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8030716', 'Buccaneer\'s Shirt', 'Normal/StandardItem', '1', '1', '0', '27800', '8736', '82050', '7016', '2', '0', '0', '0', '0', '47', '1006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8030717', 'Velveteen Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '82237', '7016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030718', 'Velveteen Shirt of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81534', '7016', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030719', 'Velveteen Shirt of Invoking (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81535', '7016', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030720', 'Linen Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82238', '7016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030721', 'Linen Shirt of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82239', '7016', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030722', 'Linen Shirt of Invoking (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82240', '7016', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030723', 'Woolen Shirt', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82241', '7016', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030724', 'Woolen Shirt of Invoking (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82242', '7016', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030725', 'Sipahi Shirt', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '82147', '7016', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030726', 'Velveteen Shirt (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81534', '7016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030727', 'Velveteen Shirt (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81535', '7016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030728', 'Velveteen Shirt of Slaying', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '82237', '7016', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030729', 'Velveteen Shirt of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81535', '7016', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030730', 'Velveteen Shirt of Invoking', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '82237', '7016', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030731', 'Velveteen Shirt of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '4056', '81534', '7016', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030732', 'Linen Shirt (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82239', '7016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030733', 'Linen Shirt (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82240', '7016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030734', 'Linen Shirt of Slaying', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82238', '7016', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030735', 'Linen Shirt of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82240', '7016', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030736', 'Linen Shirt of Invoking', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82238', '7016', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030737', 'Linen Shirt of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5616', '82239', '7016', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030738', 'Woolen Shirt (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82242', '7016', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030739', 'Woolen Shirt (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82427', '7016', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030740', 'Woolen Shirt (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82428', '7016', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030741', 'Woolen Shirt of Invoking', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82241', '7016', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030742', 'Woolen Shirt of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82427', '7016', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030743', 'Woolen Shirt of Invoking (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '6396', '82428', '7016', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030744', 'Flame Private\'s Shirt', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '80747', '7016', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8030745', 'Flame Sergeant\'s Shirt', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '80755', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030801', 'Weathered Acton (Grey)', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '80778', '7015', '1', '0', '0', '0', '0', '1', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030802', 'Dated Hempen Acton (Grey)', 'Normal/StandardItem', '1', '0', '0', '30580', '1840', '80149', '7015', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030803', 'Dated Hempen Acton (Beige)', 'Normal/StandardItem', '1', '0', '0', '30580', '1840', '80764', '7015', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030804', 'Dated Hempen Acton (Brown)', 'Normal/StandardItem', '1', '0', '0', '30580', '1840', '81582', '7015', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030805', 'Dated Cotton Acton (Red)', 'Normal/StandardItem', '1', '0', '0', '30580', '3680', '80766', '7015', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030806', 'Dated Cotton Acton (Blue)', 'Normal/StandardItem', '1', '0', '0', '30580', '3680', '80767', '7015', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030807', 'Dated Cotton Acton (Yellow)', 'Normal/StandardItem', '1', '0', '0', '30580', '3680', '80768', '7015', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030808', 'Dated Cotton Acton (Green)', 'Normal/StandardItem', '1', '0', '0', '30580', '3680', '80769', '7015', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8030809', 'Dated Canvas Acton (Auburn)', 'Normal/StandardItem', '1', '0', '0', '30580', '5520', '80770', '7015', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030810', 'Dated Canvas Acton (Pink)', 'Normal/StandardItem', '1', '0', '0', '30580', '5520', '80771', '7015', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030811', 'Dated Canvas Acton (Brown)', 'Normal/StandardItem', '1', '0', '0', '30580', '5520', '80772', '7015', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030812', 'Dated Canvas Acton (Blue)', 'Normal/StandardItem', '1', '0', '0', '30580', '5520', '80773', '7015', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8030813', 'Dated Velveteen Acton', 'Normal/StandardItem', '1', '0', '0', '30580', '7360', '80774', '7015', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030814', 'Dated Velveteen Acton (Green)', 'Normal/StandardItem', '1', '0', '0', '30580', '7360', '80775', '7015', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030815', 'Dated Velveteen Acton (Yellow)', 'Normal/StandardItem', '1', '0', '0', '30580', '7360', '80776', '7015', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030816', 'Dated Velveteen Acton (Black)', 'Normal/StandardItem', '1', '0', '0', '30580', '7360', '80777', '7015', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8030817', 'Harlequin\'s Acton', 'Normal/StandardItem', '1', '1', '0', '25020', '8976', '81583', '7015', '2', '0', '0', '0', '0', '50', '1007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030818', 'Brigand\'s Acton', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '80776', '7015', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8030819', 'Hempen Acton', 'Normal/StandardItem', '1', '0', '0', '30580', '1656', '80764', '7015', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030820', 'Hempen Acton (Grey)', 'Normal/StandardItem', '1', '0', '0', '30580', '1656', '80149', '7015', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8030821', 'Cotton Acton', 'Normal/StandardItem', '1', '0', '0', '30580', '3496', '80767', '7015', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030822', 'Cotton Acton (Brown)', 'Normal/StandardItem', '1', '0', '0', '30580', '3496', '80766', '7015', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8030823', 'Mercenary\'s Acton', 'Normal/StandardItem', '1', '1', '1', '30580', '0', '82143', '7015', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030824', 'Veteran\'s Acton', 'Normal/StandardItem', '1', '1', '0', '30580', '9200', '82510', '7015', '2', '0', '0', '0', '1', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8030901', 'Dated Dodoskin Jacket (Rat)', 'Normal/StandardItem', '1', '0', '0', '33360', '3360', '80779', '7015', '1', '0', '0', '0', '0', '15', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8030902', 'Dated Dodoskin Jacket (Squirrel)', 'Normal/StandardItem', '1', '0', '0', '33360', '3360', '80780', '7015', '1', '0', '0', '0', '0', '15', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8030903', 'Dated Dodoskin Jacket (Marmot)', 'Normal/StandardItem', '1', '0', '0', '33360', '3360', '80781', '7015', '1', '0', '0', '0', '0', '15', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8030904', 'Dated Leather Jacket (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '5460', '80782', '7015', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030905', 'Dated Leather Jacket (Ochre)', 'Normal/StandardItem', '1', '0', '0', '33360', '5460', '80783', '7015', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030906', 'Dated Leather Jacket (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '5460', '80784', '7015', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030907', 'Dated Leather Jacket (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '5460', '80785', '7015', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030908', 'Dated Scouting Jacket (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '7560', '80786', '7015', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030909', 'Dated Scouting Jacket (Ochre)', 'Normal/StandardItem', '1', '0', '0', '33360', '7560', '80787', '7015', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030910', 'Dated Scouting Jacket (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '7560', '80788', '7015', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030911', 'Dated Scouting Jacket (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '7560', '80789', '7015', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8030912', 'Dated Harrier\'s Jacket (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '9660', '80790', '7015', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8030913', 'Dated Harrier\'s Jacket (Ochre)', 'Normal/StandardItem', '1', '0', '0', '33360', '9660', '80791', '7015', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8030914', 'Dated Harrier\'s Jacket (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '9660', '80792', '7015', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8030915', 'Dated Harrier\'s Jacket (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '9660', '80793', '7015', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8030916', 'Wood Wailer\'s Jacket', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '81589', '7015', '1', '0', '0', '0', '0', '20', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8030917', 'Eternal Shade', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '81367', '7015', '2', '0', '0', '0', '0', '25', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030918', 'Alpine War Jacket', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82072', '7015', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8030919', 'Gridanian Jacket', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '80791', '7015', '2', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8030920', 'Leather Jacket', 'Normal/StandardItem', '1', '0', '0', '33360', '4410', '80786', '7015', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8030921', 'Leather Jacket (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '4410', '80788', '7015', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8030922', 'Toadskin Jacket', 'Normal/StandardItem', '1', '0', '0', '33360', '6510', '82248', '7015', '1', '0', '0', '0', '0', '30', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8030923', 'Toadskin Jacket (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '6510', '82249', '7015', '1', '0', '0', '0', '0', '30', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8030924', 'Plundered Jacket', 'Normal/StandardItem', '1', '1', '0', '33360', '3360', '81588', '7015', '1', '0', '0', '0', '1', '15', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031001', 'Dated Taupe Sheepskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '4140', '80691', '7016', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031002', 'Dated Taupe Sheepskin Jerkin (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '4140', '80692', '7016', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031003', 'Dated Sheepskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '4140', '80693', '7016', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031004', 'Dated Slate-grey Sheepskin Jerkin (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '4140', '80694', '7016', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031005', 'Dated Dodoskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '6440', '80695', '7016', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031006', 'Dated Dodoskin Jerkin (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '6440', '80696', '7016', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031007', 'Dated Dodoskin Jerkin (Yellow)', 'Normal/StandardItem', '1', '0', '0', '36140', '6440', '80697', '7016', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031008', 'Dated Dodoskin Jerkin (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '6440', '80698', '7016', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031009', 'Dated Dodoskin Jerkin (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '6440', '80699', '7016', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031010', 'Dated Leather Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '8740', '80700', '7016', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031011', 'Dated Leather Jerkin (Auburn)', 'Normal/StandardItem', '1', '0', '0', '36140', '8740', '80701', '7016', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031012', 'Dated Leather Jerkin (Pink)', 'Normal/StandardItem', '1', '0', '0', '36140', '8740', '80702', '7016', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031013', 'Dated Leather Jerkin (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '8740', '80703', '7016', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031014', 'Dated Leather Jerkin (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '8740', '80704', '7016', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031015', 'Dated Tarred Leather Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '11040', '80705', '7016', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031016', 'Dated Tarred Leather Jerkin (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '11040', '80706', '7016', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031017', 'Dated Tarred Leather Jerkin (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11040', '80707', '7016', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031018', 'Dated Tarred Leather Jerkin (Yellow)', 'Normal/StandardItem', '1', '0', '0', '36140', '11040', '80708', '7016', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031019', 'Dated Tarred Leather Jerkin (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '11040', '80709', '7016', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031020', 'Weathered Jerkin (Brown)', 'Normal/StandardItem', '1', '1', '1', '36140', '0', '80710', '7016', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031021', 'Ul\'dahn Jerkin', 'Normal/StandardItem', '1', '1', '1', '36140', '0', '80707', '7016', '2', '0', '0', '0', '1', '25', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031022', 'Boarskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82223', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031023', 'Boarskin Jerkin of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82224', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031024', 'Boarskin Jerkin of Strength (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82225', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031025', 'Boarskin Jerkin of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82226', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031026', 'Raptorskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031027', 'Raptorskin Jerkin of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82228', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031028', 'Raptorskin Jerkin of Strength (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031029', 'Raptorskin Jerkin of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82229', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031030', 'Boarskin Jerkin (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82224', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031031', 'Boarskin Jerkin (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82225', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031032', 'Boarskin Jerkin (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82226', '7016', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031033', 'Boarskin Jerkin of Vitality', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82223', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031034', 'Boarskin Jerkin of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82225', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031035', 'Boarskin Jerkin of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82226', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031036', 'Boarskin Jerkin of Strength', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82223', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031037', 'Boarskin Jerkin of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82224', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031038', 'Boarskin Jerkin of Strength (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82226', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031039', 'Boarskin Jerkin of Dexterity', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82223', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031040', 'Boarskin Jerkin of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82224', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031041', 'Boarskin Jerkin of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '10120', '82225', '7016', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031042', 'Raptorskin Jerkin (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82228', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031043', 'Raptorskin Jerkin (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031044', 'Raptorskin Jerkin (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82229', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031045', 'Raptorskin Jerkin (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82424', '7016', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031046', 'Raptorskin Jerkin of Vitality', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031047', 'Raptorskin Jerkin of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031048', 'Raptorskin Jerkin of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82229', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031049', 'Raptorskin Jerkin of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82424', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031050', 'Raptorskin Jerkin of Strength', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031051', 'Raptorskin Jerkin of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82228', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031052', 'Raptorskin Jerkin of Strength (Blue)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82229', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031053', 'Raptorskin Jerkin of Strength (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82424', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031054', 'Raptorskin Jerkin of Dexterity', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031055', 'Raptorskin Jerkin of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82228', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031056', 'Raptorskin Jerkin of Dexterity (Green)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82227', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031057', 'Raptorskin Jerkin of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '36140', '11270', '82424', '7016', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031101', 'Dated Hempen Tabard', 'Normal/StandardItem', '1', '0', '0', '25020', '960', '80830', '7015', '1', '0', '0', '0', '0', '5', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031102', 'Dated Hempen Tabard (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '960', '80831', '7015', '1', '0', '0', '0', '0', '5', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031103', 'Dated Hempen Tabard (Beige)', 'Normal/StandardItem', '1', '0', '0', '25020', '960', '80832', '7015', '1', '0', '0', '0', '0', '5', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031104', 'Dated Hempen Tabard (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '960', '80833', '7015', '1', '0', '0', '0', '0', '5', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031105', 'Dated Cotton Tabard', 'Normal/StandardItem', '1', '0', '0', '25020', '2560', '80834', '7015', '1', '0', '0', '0', '0', '15', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031106', 'Dated Cotton Tabard (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '2560', '80835', '7015', '1', '0', '0', '0', '0', '15', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031107', 'Dated Cotton Tabard (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '2560', '80836', '7015', '1', '0', '0', '0', '0', '15', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031108', 'Dated Cotton Tabard (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '2560', '80837', '7015', '1', '0', '0', '0', '0', '15', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031109', 'Dated Cotton Tabard (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '2560', '80838', '7015', '1', '0', '0', '0', '0', '15', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031110', 'Dated Canvas Tabard', 'Normal/StandardItem', '1', '0', '0', '25020', '4160', '80839', '7015', '1', '0', '0', '0', '0', '25', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031111', 'Dated Canvas Tabard (Auburn)', 'Normal/StandardItem', '1', '0', '0', '25020', '4160', '80840', '7015', '1', '0', '0', '0', '0', '25', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031112', 'Dated Canvas Tabard (Pink)', 'Normal/StandardItem', '1', '0', '0', '25020', '4160', '80841', '7015', '1', '0', '0', '0', '0', '25', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031113', 'Dated Canvas Tabard (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '4160', '80842', '7015', '1', '0', '0', '0', '0', '25', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031114', 'Dated Canvas Tabard (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '4160', '80843', '7015', '1', '0', '0', '0', '0', '25', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031115', 'Dated Velveteen Tabard', 'Normal/StandardItem', '1', '0', '0', '25020', '5760', '80844', '7015', '1', '0', '0', '0', '0', '35', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031116', 'Dated Velveteen Tabard (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '5760', '80845', '7015', '1', '0', '0', '0', '0', '35', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031117', 'Dated Velveteen Tabard (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '5760', '80846', '7015', '1', '0', '0', '0', '0', '35', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031118', 'Dated Velveteen Tabard (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '5760', '80847', '7015', '1', '0', '0', '0', '0', '35', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031119', 'Dated Velveteen Tabard (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '5760', '80848', '7015', '1', '0', '0', '0', '0', '35', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031120', 'Weathered Tabard', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80849', '7015', '1', '0', '0', '0', '0', '1', '1004', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031121', 'Cotton Tabard', 'Normal/StandardItem', '1', '0', '0', '25020', '2720', '80834', '7015', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8031122', 'Cotton Tabard (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '2720', '80835', '7015', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8031201', 'Dated Hempen Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80850', '7016', '1', '0', '0', '0', '0', '4', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031202', 'Dated Hempen Doublet Vest (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80851', '7016', '1', '0', '0', '0', '0', '4', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031203', 'Dated Hempen Doublet Vest (Beige)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80852', '7016', '1', '0', '0', '0', '0', '4', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031204', 'Dated Hempen Doublet Vest (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '750', '80853', '7016', '1', '0', '0', '0', '0', '4', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031205', 'Dated Cotton Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80854', '7016', '1', '0', '0', '0', '0', '14', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031206', 'Dated Cotton Doublet Vest (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80855', '7016', '1', '0', '0', '0', '0', '14', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031207', 'Dated Cotton Doublet Vest (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80856', '7016', '1', '0', '0', '0', '0', '14', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031208', 'Dated Cotton Doublet Vest (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80857', '7016', '1', '0', '0', '0', '0', '14', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031209', 'Dated Cotton Doublet Vest (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '2250', '80858', '7016', '1', '0', '0', '0', '0', '14', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031210', 'Dated Canvas Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80859', '7016', '1', '0', '0', '0', '0', '24', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031211', 'Dated Canvas Doublet Vest (Auburn)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80860', '7016', '1', '0', '0', '0', '0', '24', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031212', 'Dated Canvas Doublet Vest (Pink)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80861', '7016', '1', '0', '0', '0', '0', '24', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031213', 'Dated Canvas Doublet Vest (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80862', '7016', '1', '0', '0', '0', '0', '24', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031214', 'Dated Canvas Doublet Vest (Blue)', 'Normal/StandardItem', '1', '0', '0', '25020', '3750', '80863', '7016', '1', '0', '0', '0', '0', '24', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031215', 'Weathered Doublet Vest (Grey)', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80869', '7016', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031216', 'Dated Velveteen Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80864', '7016', '1', '0', '0', '0', '0', '34', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8031217', 'Dated Velveteen Doublet Vest (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80865', '7016', '1', '0', '0', '0', '0', '34', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8031218', 'Dated Velveteen Doublet Vest (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80866', '7016', '1', '0', '0', '0', '0', '34', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8031219', 'Dated Velveteen Doublet Vest (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80867', '7016', '1', '0', '0', '0', '0', '34', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8031220', 'Dated Velveteen Doublet Vest (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '5250', '80868', '7016', '1', '0', '0', '0', '0', '34', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8031221', 'Frayed Cotton Doublet Vest', 'Normal/StandardItem', '1', '1', '0', '25020', '1650', '81856', '7016', '1', '0', '0', '0', '0', '10', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031222', 'Vintage Doublet Vest', 'Normal/StandardItem', '1', '1', '0', '25020', '4650', '80858', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031223', 'Lominsan Doublet Vest', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '80866', '7016', '2', '0', '0', '0', '1', '25', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031224', 'Hempen Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80850', '7016', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031225', 'Hempen Doublet Vest of Gathering (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80853', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031226', 'Hempen Doublet Vest of Crafting (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80851', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031227', 'Cotton Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80854', '7016', '1', '0', '0', '0', '0', '22', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031228', 'Cotton Doublet Vest of Gathering (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80857', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031229', 'Cotton Doublet Vest of Crafting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80858', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031230', 'Velveteen Doublet Vest', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80864', '7016', '1', '0', '0', '0', '0', '32', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031231', 'Velveteen Doublet Vest of Gathering (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80865', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031232', 'Velveteen Doublet Vest of Crafting (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80867', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031233', 'Hempen Doublet Vest (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80853', '7016', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031234', 'Hempen Doublet Vest (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80851', '7016', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031235', 'Hempen Doublet Vest of Gathering', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80850', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031236', 'Hempen Doublet Vest of Gathering (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80851', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031237', 'Hempen Doublet Vest of Crafting', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80850', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031238', 'Hempen Doublet Vest of Crafting (Grey)', 'Normal/StandardItem', '1', '0', '0', '25020', '1950', '80853', '7016', '1', '0', '0', '0', '1', '12', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031239', 'Cotton Doublet Vest (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80857', '7016', '1', '0', '0', '0', '0', '22', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031240', 'Cotton Doublet Vest (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80858', '7016', '1', '0', '0', '0', '0', '22', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031241', 'Cotton Doublet Vest of Gathering', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80854', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031242', 'Cotton Doublet Vest of Gathering (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80858', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031243', 'Cotton Doublet Vest of Crafting', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80854', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031244', 'Cotton Doublet Vest of Crafting (Brown)', 'Normal/StandardItem', '1', '0', '0', '25020', '3450', '80857', '7016', '1', '0', '0', '0', '1', '22', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031245', 'Velveteen Doublet Vest (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80865', '7016', '1', '0', '0', '0', '0', '32', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031246', 'Velveteen Doublet Vest (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80867', '7016', '1', '0', '0', '0', '0', '32', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031247', 'Velveteen Doublet Vest of Gathering', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80864', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031248', 'Velveteen Doublet Vest of Gathering (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80867', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031249', 'Velveteen Doublet Vest of Crafting', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80864', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031250', 'Velveteen Doublet Vest of Crafting (Green)', 'Normal/StandardItem', '1', '0', '0', '25020', '4950', '80865', '7016', '1', '0', '0', '0', '1', '32', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031301', 'Dated Hempen Tunic', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80870', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031302', 'Dated Hempen Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80871', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031303', 'Dated Hempen Tunic (Beige)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80872', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031304', 'Dated Hempen Tunic (Grey)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80873', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031305', 'Dated Cotton Tunic', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80874', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031306', 'Dated Cotton Tunic (Green)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80875', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031307', 'Dated Cotton Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80876', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031308', 'Dated Cotton Tunic (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80877', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031309', 'Dated Cotton Tunic (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '1560', '80878', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031310', 'Dated Canvas Tunic', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80879', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031311', 'Dated Canvas Tunic (Auburn)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80880', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031312', 'Dated Canvas Tunic (Pink)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80881', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031313', 'Dated Canvas Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80882', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031314', 'Dated Canvas Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '2860', '80883', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031315', 'Hempen Tunic', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80870', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031316', 'Hempen Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '80871', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031401', 'Dated Hempen Halfrobe', 'Normal/StandardItem', '1', '0', '0', '22240', '280', '80885', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031402', 'Dated Hempen Halfrobe (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '280', '80886', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031403', 'Dated Hempen Halfrobe (Beige)', 'Normal/StandardItem', '1', '0', '0', '22240', '280', '80887', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031404', 'Dated Hempen Halfrobe (Grey)', 'Normal/StandardItem', '1', '0', '0', '22240', '280', '80888', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031405', 'Dated Cotton Halfrobe', 'Normal/StandardItem', '1', '0', '0', '22240', '1680', '80889', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031406', 'Dated Cotton Halfrobe (Green)', 'Normal/StandardItem', '1', '0', '0', '22240', '1680', '80890', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031407', 'Dated Cotton Halfrobe (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '1680', '80891', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031408', 'Dated Cotton Halfrobe (Red)', 'Normal/StandardItem', '1', '0', '0', '22240', '1680', '80892', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031409', 'Dated Cotton Halfrobe (Yellow)', 'Normal/StandardItem', '1', '0', '0', '22240', '1680', '80893', '7016', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031410', 'Dated Canvas Halfrobe', 'Normal/StandardItem', '1', '0', '0', '22240', '3080', '80894', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031411', 'Dated Canvas Halfrobe (Auburn)', 'Normal/StandardItem', '1', '0', '0', '22240', '3080', '80895', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031412', 'Dated Canvas Halfrobe (Pink)', 'Normal/StandardItem', '1', '0', '0', '22240', '3080', '80896', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031413', 'Dated Canvas Halfrobe (Brown)', 'Normal/StandardItem', '1', '0', '0', '22240', '3080', '80897', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031414', 'Dated Canvas Halfrobe (Blue)', 'Normal/StandardItem', '1', '0', '0', '22240', '3080', '80898', '7016', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031415', 'Weathered Halfrobe (Beige)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '80904', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031416', 'Ascetic\'s Halfrobe', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '80896', '7016', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031417', 'Cotton Halfrobe', 'Normal/StandardItem', '1', '0', '0', '22240', '3500', '80889', '7016', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031418', 'Cotton Halfrobe (Green)', 'Normal/StandardItem', '1', '0', '0', '22240', '3500', '80890', '7016', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8031419', 'Velveteen Robe', 'Normal/StandardItem', '1', '0', '0', '22240', '4480', '81873', '7016', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8031420', 'Velveteen Robe (Black)', 'Normal/StandardItem', '1', '0', '0', '22240', '4480', '81876', '7016', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8031421', 'Mage\'s Halfrobe', 'Normal/StandardItem', '1', '1', '0', '22240', '7140', '82507', '7016', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8031501', 'Dated Sheepskin Harness (Taupe)', 'Normal/StandardItem', '1', '0', '0', '33360', '1540', '80712', '7015', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031502', 'Dated Sheepskin Harness (Grey)', 'Normal/StandardItem', '1', '0', '0', '33360', '1540', '80713', '7015', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031503', 'Dated Dodoskin Harness (Taupe)', 'Normal/StandardItem', '1', '0', '0', '33360', '2640', '80714', '7015', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8031504', 'Dated Dodoskin Harness (Grey)', 'Normal/StandardItem', '1', '0', '0', '33360', '2640', '80715', '7015', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8031505', 'Dated Leather Harness (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '7480', '80716', '7015', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031506', 'Dated Leather Harness (Ochre)', 'Normal/StandardItem', '1', '0', '0', '33360', '7480', '80717', '7015', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031507', 'Dated Leather Harness (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '7480', '80718', '7015', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031508', 'Dated Leather Harness (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '7480', '80719', '7015', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031509', 'Dated Toadskin Harness (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '9680', '80724', '7015', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031510', 'Dated Toadskin Harness (Ochre)', 'Normal/StandardItem', '1', '0', '0', '33360', '9680', '80725', '7015', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031511', 'Dated Toadskin Harness (Green)', 'Normal/StandardItem', '1', '0', '0', '33360', '9680', '80726', '7015', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031512', 'Dated Toadskin Harness (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '9680', '80727', '7015', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031513', 'Ul\'dahn Harness', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '80724', '7015', '2', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031514', 'Dodoskin Harness', 'Normal/StandardItem', '1', '0', '0', '33360', '2860', '80714', '7015', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031515', 'Dodoskin Harness (Grey)', 'Normal/StandardItem', '1', '0', '0', '33360', '2860', '80715', '7015', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031516', 'Boarskin Harness', 'Normal/StandardItem', '1', '0', '0', '33360', '8360', '82230', '7015', '1', '0', '0', '0', '0', '37', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031517', 'Boarskin Harness (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '8360', '82230', '7015', '1', '0', '0', '0', '0', '37', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031518', 'Peisteskin Harness', 'Normal/StandardItem', '1', '0', '0', '33360', '9460', '82231', '7015', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8031519', 'Peisteskin Harness (Black)', 'Normal/StandardItem', '1', '0', '0', '33360', '9460', '82231', '7015', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8031520', 'Raptorskin Harness', 'Normal/StandardItem', '1', '0', '0', '33360', '10560', '82232', '7015', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031521', 'Raptorskin Harness (Blue)', 'Normal/StandardItem', '1', '0', '0', '33360', '10560', '82232', '7015', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031522', 'Raptorskin Harness (White)', 'Normal/StandardItem', '1', '0', '0', '33360', '10560', '82425', '7015', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031523', 'Raptorskin Harness (Red)', 'Normal/StandardItem', '1', '0', '0', '33360', '10560', '82426', '7015', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031601', 'Dated Bone Scale Mail (Grey)', 'Normal/StandardItem', '1', '0', '0', '36140', '3600', '80760', '7015', '1', '0', '0', '0', '0', '14', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031602', 'Dated Bone Scale Mail (Taupe)', 'Normal/StandardItem', '1', '0', '0', '36140', '3600', '80761', '7015', '1', '0', '0', '0', '0', '14', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8031603', 'Dated Bronze Scale Mail', 'Normal/StandardItem', '1', '0', '0', '36140', '4800', '81364', '7015', '1', '0', '0', '0', '0', '19', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8031604', 'Blackened Scale Mail', 'Normal/StandardItem', '1', '1', '0', '36140', '5280', '81569', '7015', '1', '0', '0', '0', '0', '21', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8031605', 'Vintage Scale Mail', 'Normal/StandardItem', '1', '1', '0', '36140', '10080', '81568', '7015', '1', '0', '0', '0', '0', '41', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8031606', 'Mosshorn Scale Mail', 'Normal/StandardItem', '1', '1', '0', '36140', '11520', '81563', '7015', '2', '0', '0', '0', '0', '47', '1111', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031607', 'Kokoroon\'s Darkshell Mail', 'Normal/StandardItem', '1', '1', '1', '36140', '0', '82064', '7015', '2', '0', '0', '0', '0', '35', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031608', 'Solid Scale Mail', 'Normal/StandardItem', '1', '1', '1', '36140', '0', '82070', '7015', '2', '0', '0', '0', '1', '50', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8031609', 'Iron Scale Mail', 'Normal/StandardItem', '1', '0', '0', '36140', '5520', '81365', '7015', '1', '0', '0', '0', '0', '22', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031610', 'Horn Scale Mail', 'Normal/StandardItem', '1', '0', '0', '36140', '10080', '82245', '7015', '1', '0', '0', '0', '0', '41', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8031611', 'Horn Scale Mail (White)', 'Normal/StandardItem', '1', '0', '0', '36140', '10080', '82246', '7015', '1', '0', '0', '0', '0', '41', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8031612', 'Tortoiseshell Scale Mail', 'Normal/StandardItem', '1', '0', '0', '36140', '11280', '82247', '7015', '1', '0', '0', '0', '0', '46', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8031613', 'Tortoiseshell Scale Mail (White)', 'Normal/StandardItem', '1', '0', '0', '36140', '11280', '82247', '7015', '1', '0', '0', '0', '0', '46', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8031701', 'Dated Bronze Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '7280', '80794', '7015', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8031702', 'Dated Bronze Haubergeon (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '7280', '80795', '7015', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8031703', 'Dated Bronze Haubergeon (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '7280', '80796', '7015', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8031704', 'Dated Bronze Haubergeon (Green)', 'Normal/StandardItem', '1', '0', '0', '38920', '7280', '80797', '7015', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8031705', 'Dated Bronze Haubergeon (Blue)', 'Normal/StandardItem', '1', '0', '0', '38920', '7280', '80798', '7015', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8031706', 'Dated Iron Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '9880', '80799', '7015', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8031707', 'Dated Iron Haubergeon (Auburn)', 'Normal/StandardItem', '1', '0', '0', '38920', '9880', '80800', '7015', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8031708', 'Dated Iron Haubergeon (Pink)', 'Normal/StandardItem', '1', '0', '0', '38920', '9880', '80801', '7015', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8031709', 'Dated Iron Haubergeon (Brown)', 'Normal/StandardItem', '1', '0', '0', '38920', '9880', '80802', '7015', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8031710', 'Dated Iron Haubergeon (Blue)', 'Normal/StandardItem', '1', '0', '0', '38920', '9880', '80803', '7015', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8031711', 'Dated Cavalry Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '12480', '80804', '7015', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031712', 'Dated Cavalry Haubergeon (Black)', 'Normal/StandardItem', '1', '0', '0', '38920', '12480', '80805', '7015', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031713', 'Dated Cavalry Haubergeon (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '12480', '80806', '7015', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031714', 'Dated Cavalry Haubergeon (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '12480', '80807', '7015', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031715', 'Dated Cavalry Haubergeon (Green)', 'Normal/StandardItem', '1', '0', '0', '38920', '12480', '80808', '7015', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031716', 'Judge\'s Haubergeon', 'Normal/StandardItem', '1', '1', '1', '38920', '0', '80809', '7015', '1', '0', '0', '0', '0', '1', '2033', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031717', 'Ripped Haubergeon', 'Normal/StandardItem', '1', '1', '0', '38920', '8060', '81401', '7015', '1', '0', '0', '0', '0', '30', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8031718', 'Vintage Haubergeon', 'Normal/StandardItem', '1', '1', '0', '38920', '13260', '80804', '7015', '1', '0', '0', '0', '0', '50', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8031719', 'Templar\'s Haubergeon', 'Normal/StandardItem', '1', '1', '0', '38920', '13000', '82047', '7015', '2', '0', '0', '0', '0', '49', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8031720', 'Mythril Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '11440', '82250', '7015', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031721', 'Mythril Haubergeon (Black)', 'Normal/StandardItem', '1', '0', '0', '38920', '11440', '82250', '7015', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8031722', 'Cobalt Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '12740', '82251', '7015', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031723', 'Cobalt Haubergeon (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '12740', '82252', '7015', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8031724', 'Plundered Haubergeon', 'Normal/StandardItem', '1', '1', '0', '38920', '4160', '80794', '7015', '1', '0', '0', '0', '1', '15', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8031801', 'Dated Hempen Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '3600', '80810', '7017', '1', '0', '0', '0', '0', '14', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031802', 'Dated Hempen Cowl (Beige)', 'Normal/StandardItem', '1', '0', '0', '38920', '3600', '80811', '7017', '1', '0', '0', '0', '0', '14', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031803', 'Dated Hempen Cowl (Grey)', 'Normal/StandardItem', '1', '0', '0', '38920', '3600', '80812', '7017', '1', '0', '0', '0', '0', '14', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031804', 'Dated Hempen Cowl (Brown)', 'Normal/StandardItem', '1', '0', '0', '38920', '3600', '80813', '7017', '1', '0', '0', '0', '0', '14', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031805', 'Dated Cotton Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '6000', '80814', '7017', '1', '0', '0', '0', '0', '24', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031806', 'Dated Cotton Cowl (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '6000', '80815', '7017', '1', '0', '0', '0', '0', '24', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031807', 'Dated Cotton Cowl (Green)', 'Normal/StandardItem', '1', '0', '0', '38920', '6000', '80816', '7017', '1', '0', '0', '0', '0', '24', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031808', 'Dated Cotton Cowl (Blue)', 'Normal/StandardItem', '1', '0', '0', '38920', '6000', '80817', '7017', '1', '0', '0', '0', '0', '24', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031809', 'Dated Cotton Cowl (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '6000', '80818', '7017', '1', '0', '0', '0', '0', '24', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8031810', 'Dated Canvas Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '8400', '80819', '7017', '1', '0', '0', '0', '0', '34', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031811', 'Dated Canvas Cowl (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '8400', '80820', '7017', '1', '0', '0', '0', '0', '34', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031812', 'Dated Canvas Cowl (Green)', 'Normal/StandardItem', '1', '0', '0', '38920', '8400', '80821', '7017', '1', '0', '0', '0', '0', '34', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031813', 'Dated Canvas Cowl (Blue)', 'Normal/StandardItem', '1', '0', '0', '38920', '8400', '80822', '7017', '1', '0', '0', '0', '0', '34', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031814', 'Dated Canvas Cowl (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '8400', '80823', '7017', '1', '0', '0', '0', '0', '34', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8031815', 'Dated Velveteen Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '10800', '80824', '7017', '1', '0', '0', '0', '0', '44', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031816', 'Dated Velveteen Cowl (Black)', 'Normal/StandardItem', '1', '0', '0', '38920', '10800', '80825', '7017', '1', '0', '0', '0', '0', '44', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031817', 'Dated Velveteen Cowl (Green)', 'Normal/StandardItem', '1', '0', '0', '38920', '10800', '80826', '7017', '1', '0', '0', '0', '0', '44', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031818', 'Dated Velveteen Cowl (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '10800', '80827', '7017', '1', '0', '0', '0', '0', '44', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031819', 'Dated Velveteen Cowl (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '10800', '80828', '7017', '1', '0', '0', '0', '0', '44', '1118', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8031820', 'Seer\'s Cowl', 'Normal/StandardItem', '1', '1', '1', '38920', '0', '82065', '7017', '2', '0', '0', '0', '0', '35', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8031821', 'Gridanian Cowl', 'Normal/StandardItem', '1', '1', '1', '38920', '0', '80820', '7017', '2', '0', '0', '0', '1', '25', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8031822', 'Linen Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '9120', '82256', '7017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031823', 'Linen Cowl (Brown)', 'Normal/StandardItem', '1', '0', '0', '38920', '9120', '82257', '7017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031824', 'Linen Cowl (Yellow)', 'Normal/StandardItem', '1', '0', '0', '38920', '9120', '82258', '7017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8031825', 'Woolen Cowl', 'Normal/StandardItem', '1', '0', '0', '38920', '11520', '82259', '7017', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031826', 'Woolen Cowl (Black)', 'Normal/StandardItem', '1', '0', '0', '38920', '11520', '82260', '7017', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031827', 'Woolen Cowl (Red)', 'Normal/StandardItem', '1', '0', '0', '38920', '11520', '82261', '7017', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031828', 'Woolen Cowl (Grey)', 'Normal/StandardItem', '1', '0', '0', '38920', '11520', '82259', '7017', '1', '0', '0', '0', '0', '47', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8031901', 'Dated Hempen Shepherd\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '27800', '1040', '81751', '7016', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031902', 'Dated Hempen Shepherd\'s Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '1040', '81752', '7016', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031903', 'Dated Hempen Shepherd\'s Tunic (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '1040', '81753', '7016', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031904', 'Dated Hempen Shepherd\'s Tunic (Beige)', 'Normal/StandardItem', '1', '0', '0', '27800', '1040', '81754', '7016', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8031905', 'Dated Cotton Shepherd\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81757', '7016', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031906', 'Dated Cotton Shepherd\'s Tunic (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81758', '7016', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031907', 'Dated Cotton Shepherd\'s Tunic (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81759', '7016', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031908', 'Dated Cotton Shepherd\'s Tunic (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81760', '7016', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031909', 'Dated Cotton Shepherd\'s Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81761', '7016', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031910', 'Dated Canvas Shepherd\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '27800', '3640', '81762', '7016', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031911', 'Dated Canvas Shepherd\'s Tunic (Auburn)', 'Normal/StandardItem', '1', '0', '0', '27800', '3640', '81763', '7016', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031912', 'Dated Canvas Shepherd\'s Tunic (Pink)', 'Normal/StandardItem', '1', '0', '0', '27800', '3640', '81764', '7016', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031913', 'Dated Canvas Shepherd\'s Tunic (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '3640', '81765', '7016', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031914', 'Dated Canvas Shepherd\'s Tunic (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '3640', '81766', '7016', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8031915', 'Cotton Shepherd\'s Tunic', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81757', '7016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031916', 'Cotton Shepherd\'s Tunic (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81760', '7016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8031917', 'Cotton Shepherd\'s Tunic (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '2340', '81759', '7016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8032001', 'Vintage Chef\'s Apron', 'Normal/StandardItem', '1', '1', '0', '27800', '4810', '81839', '7016', '1', '0', '0', '0', '0', '36', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032002', 'Stained Chef\'s Apron', 'Normal/StandardItem', '1', '1', '0', '27800', '2210', '81840', '7016', '1', '0', '0', '0', '0', '16', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8032003', 'Dated Chef\'s Apron', 'Normal/StandardItem', '1', '0', '0', '27800', '5720', '81841', '7016', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032004', 'Dated Chef\'s Apron (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '5720', '81842', '7016', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032005', 'Dated Chef\'s Apron (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '5720', '81843', '7016', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032006', 'Dated Chef\'s Apron (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5720', '81844', '7016', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032007', 'Dated Chef\'s Apron (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '5720', '81845', '7016', '1', '0', '0', '0', '0', '43', '1120', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8032008', 'Lominsan Apron', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '81843', '7016', '2', '0', '0', '0', '1', '25', '2110', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032009', 'Linen Smock', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82262', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032010', 'Linen Smock of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82263', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032011', 'Linen Smock of Piety (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82264', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032012', 'Linen Smock of Piety (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82265', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032013', 'Woolen Smock', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032014', 'Woolen Smock of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032015', 'Woolen Smock of Piety (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82267', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032016', 'Woolen Smock of Piety (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82268', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032017', 'Linen Smock (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82263', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032018', 'Linen Smock (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82264', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032019', 'Linen Smock (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82265', '7016', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032020', 'Linen Smock of the Mind', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82262', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032021', 'Linen Smock of the Mind (Yellow)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82264', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032022', 'Linen Smock of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82265', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032023', 'Linen Smock of Piety', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82262', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032024', 'Linen Smock of Piety (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '5460', '82263', '7016', '1', '0', '0', '0', '1', '41', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8032025', 'Woolen Smock (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032026', 'Woolen Smock (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82267', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032027', 'Woolen Smock (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82268', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032028', 'Woolen Smock (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82433', '7016', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032029', 'Woolen Smock of the Mind', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032030', 'Woolen Smock of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82267', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032031', 'Woolen Smock of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82268', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032032', 'Woolen Smock of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82433', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032033', 'Woolen Smock of Piety', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032034', 'Woolen Smock of Piety (Grey)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82266', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032035', 'Woolen Smock of Piety (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '6110', '82433', '7016', '1', '0', '0', '0', '1', '46', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8032101', 'Dream Tunic', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '81890', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032102', 'Reindeer Suit', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82402', '7033', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032201', 'Dated Canvas Coatee', 'Normal/StandardItem', '1', '0', '0', '25000', '3720', '81893', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032202', 'Dated Canvas Coatee (Auburn)', 'Normal/StandardItem', '1', '0', '0', '25000', '3720', '81894', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032203', 'Dated Canvas Coatee (Pink)', 'Normal/StandardItem', '1', '0', '0', '25000', '3720', '81895', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032204', 'Dated Canvas Coatee (Brown)', 'Normal/StandardItem', '1', '0', '0', '25000', '3720', '81896', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032205', 'Dated Canvas Coatee (Blue)', 'Normal/StandardItem', '1', '0', '0', '25000', '3720', '81897', '7016', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032206', 'Dated Velveteen Coatee', 'Normal/StandardItem', '1', '0', '0', '25000', '4920', '81898', '7016', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032207', 'Dated Velveteen Coatee (Black)', 'Normal/StandardItem', '1', '0', '0', '25000', '4920', '81899', '7016', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032208', 'Dated Velveteen Coatee (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '4920', '81900', '7016', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032209', 'Dated Velveteen Coatee (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '4920', '81901', '7016', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032210', 'Dated Velveteen Coatee (Green)', 'Normal/StandardItem', '1', '0', '0', '25000', '4920', '81902', '7016', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032211', 'Dated Linen Coatee', 'Normal/StandardItem', '1', '0', '0', '25000', '6120', '81898', '7016', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032212', 'Dated Linen Coatee (Pink)', 'Normal/StandardItem', '1', '0', '0', '25000', '6120', '81895', '7016', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032213', 'Dated Linen Coatee (Blue)', 'Normal/StandardItem', '1', '0', '0', '25000', '6120', '81897', '7016', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032214', 'Dated Linen Coatee (Brown)', 'Normal/StandardItem', '1', '0', '0', '25000', '6120', '81896', '7016', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032215', 'Dated Linen Coatee (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '6120', '81894', '7016', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032216', 'Vintage Coatee', 'Normal/StandardItem', '1', '1', '0', '25000', '3120', '81906', '7016', '1', '0', '0', '0', '0', '25', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032217', 'Moth-eaten Coatee', 'Normal/StandardItem', '1', '1', '0', '25000', '1920', '81905', '7016', '1', '0', '0', '0', '0', '15', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8032218', 'Vintage Seneschal Coatee', 'Normal/StandardItem', '1', '1', '0', '25000', '5520', '81904', '7016', '1', '0', '0', '0', '0', '45', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8032219', 'Moth-eaten Seneschal Coatee', 'Normal/StandardItem', '1', '1', '0', '25000', '4320', '81903', '7016', '1', '0', '0', '0', '0', '35', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8032220', 'Gridanian Coatee', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '81901', '7016', '2', '0', '0', '0', '1', '25', '2110', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032221', 'Velveteen Coatee', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81898', '7016', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032222', 'Velveteen Coatee of Crafting (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81900', '7016', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032223', 'Velveteen Coatee of Gathering (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81901', '7016', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032224', 'Linen Coatee', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81898', '7016', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032225', 'Linen Coatee of Crafting (Blue)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81897', '7016', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032226', 'Linen Coatee of Gathering (Brown)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81896', '7016', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032227', 'Velveteen Coatee (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81900', '7016', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032228', 'Velveteen Coatee (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81901', '7016', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032229', 'Velveteen Coatee of Crafting', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81898', '7016', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032230', 'Velveteen Coatee of Crafting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81901', '7016', '1', '0', '0', '0', '1', '28', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032231', 'Velveteen Coatee of Gathering', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81898', '7016', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032232', 'Velveteen Coatee of Gathering (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '3480', '81900', '7016', '1', '0', '0', '0', '1', '28', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8032233', 'Linen Coatee (Blue)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81897', '7016', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032234', 'Linen Coatee (Brown)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81896', '7016', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032235', 'Linen Coatee (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81895', '7016', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032236', 'Linen Coatee (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81894', '7016', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032237', 'Linen Coatee of Crafting', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81898', '7016', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032238', 'Linen Coatee of Crafting (Brown)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81896', '7016', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032239', 'Linen Coatee of Crafting (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81895', '7016', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032240', 'Linen Coatee of Crafting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81894', '7016', '1', '0', '0', '0', '1', '38', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032241', 'Linen Coatee of Gathering', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81898', '7016', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032242', 'Linen Coatee of Gathering (Blue)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81897', '7016', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032243', 'Linen Coatee of Gathering (Red)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81895', '7016', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032244', 'Linen Coatee of Gathering (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25000', '4680', '81894', '7016', '1', '0', '0', '0', '1', '38', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8032301', 'Loyalist\'s Bliaud', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82061', '7016', '2', '0', '0', '0', '0', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8032302', 'Revolutionary\'s Bliaud', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82073', '7016', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032303', 'Woolen Bliaud', 'Normal/StandardItem', '1', '0', '0', '27800', '11250', '82253', '7016', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8032304', 'Woolen Bliaud (Purple)', 'Normal/StandardItem', '1', '0', '0', '27800', '11250', '82254', '7016', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8032305', 'Felt Bliaud', 'Normal/StandardItem', '1', '0', '0', '27800', '12500', '82255', '7016', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032306', 'Felt Bliaud (Brown)', 'Normal/StandardItem', '1', '0', '0', '27800', '12500', '82255', '7016', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032307', 'Plundered Bliaud', 'Normal/StandardItem', '1', '1', '0', '27800', '4000', '82153', '7016', '1', '0', '0', '0', '1', '15', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8032308', 'Felt Bliaud (Green)', 'Normal/StandardItem', '1', '0', '0', '27800', '12500', '82431', '7016', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032309', 'Felt Bliaud (Blue)', 'Normal/StandardItem', '1', '0', '0', '27800', '12500', '82429', '7016', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032310', 'Felt Bliaud (Red)', 'Normal/StandardItem', '1', '0', '0', '27800', '12500', '82430', '7016', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032311', 'Storm Private\'s Bliaud', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '82455', '7016', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8032312', 'Storm Sergeant\'s Bliaud', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '82456', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032401', 'Red Summer Top', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82081', '7012', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032402', 'Green Summer Top', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82082', '7012', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032403', 'Blue Summer Top', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82083', '7012', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032404', 'Solar Summer Top', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82084', '7012', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032405', 'Lunar Summer Top', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82085', '7012', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032406', 'Red Summer Halter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82091', '7012', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032407', 'Green Summer Halter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82092', '7012', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032408', 'Blue Summer Halter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82093', '7012', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032409', 'Solar Summer Halter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82094', '7012', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032410', 'Lunar Summer Halter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82095', '7012', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032501', 'Hempen Kurta', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '82269', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032502', 'Hempen Kurta (Grey)', 'Normal/StandardItem', '1', '0', '0', '22240', '260', '82270', '7016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032601', 'Lominsan Soldier\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82101', '7016', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032602', 'Gridanian Soldier\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82102', '7016', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032603', 'Ul\'dahn Soldier\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82103', '7016', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8032604', 'Lominsan Officer\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82104', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032605', 'Gridanian Officer\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82105', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032606', 'Ul\'dahn Officer\'s Overcoat', 'Normal/StandardItem', '1', '1', '1', '25000', '0', '82106', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032701', 'Gallant Surcoat', 'Normal/StandardItem', '1', '1', '1', '38920', '0', '82482', '7015', '3', '0', '0', '0', '1', '50', '2120', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032702', 'Temple Cyclas', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82487', '7015', '3', '0', '0', '0', '1', '50', '2119', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032703', 'Fighter\'s Cuirass', 'Normal/StandardItem', '1', '1', '1', '41700', '0', '82462', '7015', '3', '0', '0', '0', '1', '50', '2121', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032704', 'Drachen Mail', 'Normal/StandardItem', '1', '1', '1', '36140', '0', '82457', '7015', '3', '0', '0', '0', '1', '50', '2123', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032705', 'Choral Shirt', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '82477', '7015', '3', '0', '0', '0', '1', '50', '2122', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032706', 'Healer\'s Robe', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '82467', '7016', '3', '0', '0', '0', '1', '50', '2125', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032707', 'Wizard\'s Coat', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82472', '7016', '3', '0', '0', '0', '1', '50', '2124', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032801', 'Heavy Darklight Armor', 'Normal/StandardItem', '1', '1', '1', '60000', '0', '82492', '7014', '3', '0', '0', '0', '1', '50', '2126', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032802', 'Darklight Cuirass', 'Normal/StandardItem', '1', '1', '1', '41700', '0', '82495', '7014', '3', '0', '0', '0', '1', '50', '2127', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032803', 'Darklight Corselet', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82499', '7015', '3', '0', '0', '0', '1', '50', '2128', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032804', 'Darklight Cowl', 'Normal/StandardItem', '1', '1', '1', '38920', '0', '82503', '7017', '3', '0', '0', '0', '1', '50', '2129', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032805', 'Heavy Darksteel Armor', 'Normal/StandardItem', '1', '0', '0', '60000', '15000', '82516', '7014', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032806', 'Heavy Darksteel Armor (White)', 'Normal/StandardItem', '1', '0', '0', '60000', '15000', '82515', '7014', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032807', 'Heavy Darksteel Armor (Red)', 'Normal/StandardItem', '1', '0', '0', '60000', '15000', '82517', '7014', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032808', 'Heavy Darksteel Armor (Green)', 'Normal/StandardItem', '1', '0', '0', '60000', '15000', '82518', '7014', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032809', 'Heavy Darksteel Armor (Blue)', 'Normal/StandardItem', '1', '0', '0', '60000', '15000', '82519', '7014', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032810', 'Gryphonskin Jerkin', 'Normal/StandardItem', '1', '0', '0', '36140', '11500', '82530', '7015', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032811', 'Gryphonskin Jerkin (White)', 'Normal/StandardItem', '1', '0', '0', '36140', '11500', '82531', '7015', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032812', 'Gryphonskin Jerkin (Black)', 'Normal/StandardItem', '1', '0', '0', '36140', '11500', '82532', '7015', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032813', 'Gryphonskin Jerkin (Red)', 'Normal/StandardItem', '1', '0', '0', '36140', '11500', '82533', '7015', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032814', 'Gryphonskin Jerkin (Yellow)', 'Normal/StandardItem', '1', '0', '0', '36140', '11500', '82534', '7015', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032815', 'Vanya Robe', 'Normal/StandardItem', '1', '0', '0', '25020', '8200', '82552', '7016', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032816', 'Vanya Robe (Yellow)', 'Normal/StandardItem', '1', '0', '0', '25020', '8200', '82551', '7016', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032817', 'Vanya Robe (Black)', 'Normal/StandardItem', '1', '0', '0', '25020', '8200', '82550', '7016', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032818', 'Vanya Robe (Purple)', 'Normal/StandardItem', '1', '0', '0', '25020', '8200', '82553', '7016', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032819', 'Vanya Robe (Red)', 'Normal/StandardItem', '1', '0', '0', '25020', '8200', '82554', '7016', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8032820', 'Storm Sergeant\'s Tabard', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82583', '7015', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032821', 'Storm Sergeant\'s Apron', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '81843', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032822', 'Serpent Sergeant\'s Tabard', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82584', '7015', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032823', 'Serpent Sergeant\'s Apron', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '81844', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032824', 'Flame Sergeant\'s Tabard', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82582', '7015', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032825', 'Flame Sergeant\'s Apron', 'Normal/StandardItem', '1', '1', '1', '27800', '0', '81842', '7016', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032826', 'Militia Robe', 'Normal/StandardItem', '1', '1', '1', '25020', '0', '82599', '7016', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032827', 'Militia Cuirass', 'Normal/StandardItem', '1', '1', '1', '41700', '0', '80060', '7014', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032828', 'Militia Harness', 'Normal/StandardItem', '1', '1', '1', '33360', '0', '82598', '7015', '2', '0', '0', '0', '1', '50', '2158', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032829', 'Imperial Operative Dalmatica', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82605', '7016', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032830', 'Gryphonskin Tunic', 'Normal/StandardItem', '1', '0', '0', '30580', '8556', '82601', '7016', '1', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032831', 'Darksteel Haubergeon', 'Normal/StandardItem', '1', '0', '0', '38920', '11960', '82602', '7015', '1', '0', '0', '0', '1', '50', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8032832', 'Coliseum Galerus', 'Normal/StandardItem', '1', '0', '0', '33360', '10120', '82608', '7015', '2', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8032833', 'Coliseum Shawl', 'Normal/StandardItem', '1', '0', '0', '25020', '7544', '82610', '7016', '2', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8032834', 'Lord\'s Yukata (Blue)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82624', '7016', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032835', 'Lord\'s Yukata (Green)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82625', '7016', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032836', 'Lord\'s Yukata (Grey)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82626', '7016', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032837', 'Lady\'s Yukata (Red)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82621', '7016', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032838', 'Lady\'s Yukata (Blue)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82622', '7016', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8032839', 'Lady\'s Yukata (Black)', 'Normal/StandardItem', '1', '1', '1', '22240', '0', '82623', '7016', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040001', 'Well-worn Undershirt', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81303', '7012', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040002', 'Well-worn Breastcloth', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81305', '7012', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040003', 'Well-worn Chestband', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81325', '7012', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040004', 'Well-worn Undersleeves', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81307', '7012', '1', '0', '0', '0', '0', '1', '2011', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040005', 'Well-worn Undersleeves (Brown)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81308', '7012', '1', '0', '0', '0', '0', '1', '2013', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040006', 'Well-worn Bodice', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81310', '7012', '1', '0', '0', '0', '0', '1', '2012', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040007', 'Well-worn Bodice (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81311', '7012', '1', '0', '0', '0', '0', '1', '2014', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040008', 'Well-worn Camise', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81313', '7012', '1', '0', '0', '0', '0', '1', '2015', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040009', 'Well-worn Camise (Beige)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81314', '7012', '1', '0', '0', '0', '0', '1', '2017', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040010', 'Well-worn Camisole (Brown)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81316', '7012', '1', '0', '0', '0', '0', '1', '2016', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040011', 'Well-worn Camisole (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81317', '7012', '1', '0', '0', '0', '0', '1', '2018', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040012', 'Well-worn Halftop', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81322', '7012', '1', '0', '0', '0', '0', '1', '2019', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040013', 'Well-worn Halftop (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81323', '7012', '1', '0', '0', '0', '0', '1', '2020', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040014', 'Well-worn Singlet (Beige)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81319', '7012', '1', '0', '0', '0', '0', '1', '2021', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040015', 'Well-worn Singlet (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81320', '7012', '1', '0', '0', '0', '0', '1', '2022', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040016', 'Hempen Undershirt (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '80001', '7012', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040017', 'Hempen Undershirt', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81302', '7012', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040018', 'Hempen Undershirt (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '80003', '7012', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040019', 'Hempen Undershirt (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81302', '7012', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040020', 'Hempen Breastcloth (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81276', '7012', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040021', 'Hempen Breastcloth', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81304', '7012', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040022', 'Hempen Breastcloth (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81278', '7012', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040023', 'Hempen Breastcloth (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81279', '7012', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040024', 'Hempen Chestband (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81325', '7012', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040025', 'Hempen Chestband', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81324', '7012', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040026', 'Hempen Chestband (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81324', '7012', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040027', 'Hempen Chestband (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81325', '7012', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040028', 'Hempen Undersleeves (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81308', '7012', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040029', 'Hempen Undersleeves', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81306', '7012', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040030', 'Hempen Undersleeves (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81308', '7012', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040031', 'Hempen Undersleeves (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81306', '7012', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040032', 'Hempen Bodice (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81285', '7012', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040033', 'Hempen Bodice', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81309', '7012', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040034', 'Hempen Bodice (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81287', '7012', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040035', 'Hempen Bodice (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81309', '7012', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040036', 'Hempen Camise (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '82041', '7012', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040037', 'Hempen Camise', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81312', '7012', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040038', 'Hempen Camise (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '82041', '7012', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040039', 'Hempen Camise (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81314', '7012', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040040', 'Hempen Camisole (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81316', '7012', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040041', 'Hempen Camisole', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81315', '7012', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040042', 'Hempen Camisole (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81317', '7012', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040043', 'Hempen Camisole (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '82042', '7012', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040044', 'Hempen Halftop (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81322', '7012', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040045', 'Hempen Halftop', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81321', '7012', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040046', 'Hempen Halftop (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81322', '7012', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040047', 'Hempen Halftop (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81321', '7012', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040048', 'Hempen Singlet (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81320', '7012', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040049', 'Hempen Singlet', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81318', '7012', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040050', 'Hempen Singlet (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81320', '7012', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040051', 'Hempen Singlet (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '120', '81318', '7012', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8040052', 'Cotton Undershirt', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81302', '7012', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040053', 'Cotton Undershirt (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81302', '7012', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040054', 'Cotton Undershirt (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81302', '7012', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040055', 'Cotton Undershirt (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81302', '7012', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040056', 'Cotton Undershirt (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81302', '7012', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040057', 'Cotton Breastcloth', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81304', '7012', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040058', 'Cotton Breastcloth (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81304', '7012', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040059', 'Cotton Breastcloth (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81304', '7012', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040060', 'Cotton Breastcloth (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81304', '7012', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040061', 'Cotton Breastcloth (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81304', '7012', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040062', 'Cotton Chestband', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81324', '7012', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040063', 'Cotton Chestband (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81324', '7012', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040064', 'Cotton Chestband (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81324', '7012', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040065', 'Cotton Chestband (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81324', '7012', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040066', 'Cotton Chestband (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81324', '7012', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040067', 'Cotton Undersleeves', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81306', '7012', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040068', 'Cotton Undersleeves (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81306', '7012', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040069', 'Cotton Undersleeves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81306', '7012', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040070', 'Cotton Undersleeves (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81306', '7012', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040071', 'Cotton Undersleeves (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81306', '7012', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040072', 'Cotton Bodice', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81309', '7012', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040073', 'Cotton Bodice (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81309', '7012', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040074', 'Cotton Bodice (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81309', '7012', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040075', 'Cotton Bodice (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81309', '7012', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040076', 'Cotton Bodice (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81309', '7012', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040077', 'Cotton Camise', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81312', '7012', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040078', 'Cotton Camise (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81312', '7012', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040079', 'Cotton Camise (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81312', '7012', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040080', 'Cotton Camise (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81312', '7012', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040081', 'Cotton Camise (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81312', '7012', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040082', 'Cotton Camisole', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81315', '7012', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040083', 'Cotton Camisole (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81315', '7012', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040084', 'Cotton Camisole (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81315', '7012', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040085', 'Cotton Camisole (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81315', '7012', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040086', 'Cotton Camisole (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81315', '7012', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040087', 'Cotton Halftop', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81321', '7012', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040088', 'Cotton Halftop (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81321', '7012', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040089', 'Cotton Halftop (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81321', '7012', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040090', 'Cotton Halftop (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81321', '7012', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040091', 'Cotton Halftop (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81321', '7012', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040092', 'Cotton Singlet', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81318', '7012', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040093', 'Cotton Singlet (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81318', '7012', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040094', 'Cotton Singlet (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81318', '7012', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040095', 'Cotton Singlet (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81318', '7012', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8040096', 'Cotton Singlet (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '1320', '81318', '7012', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050001', 'Dated Hempen Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '390', '80159', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050002', 'Dated Hempen Slops (Beige)', 'Normal/StandardItem', '1', '0', '0', '13900', '390', '80162', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050003', 'Dated Hempen Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '390', '80160', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050004', 'Dated Hempen Slops (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '390', '80161', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050005', 'Dated Cotton Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '948', '80163', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8050006', 'Dated Cotton Slops (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '948', '80165', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8050007', 'Dated Cotton Slops (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '948', '80166', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8050008', 'Dated Cotton Slops (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '948', '80167', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8050009', 'Dated Cotton Slops (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '948', '80164', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8050010', 'Dated Canvas Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '1506', '80168', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8050011', 'Dated Canvas Slops (Pink)', 'Normal/StandardItem', '1', '0', '0', '13900', '1506', '80170', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8050012', 'Dated Canvas Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1506', '80171', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8050013', 'Dated Canvas Slops (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1506', '80172', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8050014', 'Dated Canvas Slops (Auburn)', 'Normal/StandardItem', '1', '0', '0', '13900', '1506', '80169', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8050015', 'Linen Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82271', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050016', 'Linen Slops of Vitality (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82272', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050017', 'Linen Slops of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82273', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050018', 'Linen Slops of Strength (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82274', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050019', 'Woolen Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82275', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050020', 'Woolen Slops of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82276', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050021', 'Woolen Slops of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82277', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050022', 'Woolen Slops of Strength (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82278', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050023', 'Linen Slops (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82272', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050024', 'Linen Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82273', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050025', 'Linen Slops (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82274', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050026', 'Linen Slops of Vitality', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82271', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050027', 'Linen Slops of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82273', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050028', 'Lominsan Slops', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80170', '7021', '2', '0', '0', '0', '1', '30', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050029', 'Gridanian Slops', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80165', '7021', '2', '0', '0', '0', '1', '30', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050030', 'Weathered Slops (Brown)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80920', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050031', 'Weathered Slops (Grey)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80921', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050032', 'Weathered Slops (Beige)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80922', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050033', 'Linen Slops of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82274', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050034', 'Linen Slops of the Mind', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82271', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050035', 'Linen Slops of the Mind (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82272', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050036', 'Linen Slops of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82274', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050037', 'Linen Slops of Strength', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82271', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050038', 'Linen Slops of Strength (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82272', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050039', 'Linen Slops of Strength (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2399', '82273', '7021', '1', '0', '0', '0', '1', '42', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050040', 'Woolen Slops (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82276', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050041', 'Woolen Slops (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82277', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050042', 'Woolen Slops (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82278', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050043', 'Woolen Slops of Vitality', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82275', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050044', 'Woolen Slops of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82277', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050045', 'Woolen Slops of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82278', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050046', 'Woolen Slops of the Mind', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82275', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050047', 'Woolen Slops of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82276', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050048', 'Woolen Slops of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82278', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050049', 'Woolen Slops of Strength', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82275', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050050', 'Woolen Slops of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82276', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050051', 'Woolen Slops of Strength (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2678', '82277', '7021', '1', '0', '0', '0', '1', '47', '2109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050101', 'Dated Hempen Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '1710', '80173', '7021', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050102', 'Dated Hempen Trousers (Beige)', 'Normal/StandardItem', '1', '0', '0', '20850', '1710', '80174', '7021', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050103', 'Dated Hempen Trousers (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '1710', '80175', '7021', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050104', 'Dated Hempen Trousers (Grey)', 'Normal/StandardItem', '1', '0', '0', '20850', '1710', '80176', '7021', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050105', 'Dated Cotton Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '2610', '80177', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050106', 'Dated Cotton Trousers (Yellow)', 'Normal/StandardItem', '1', '0', '0', '20850', '2610', '80178', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050107', 'Dated Cotton Trousers (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '2610', '80179', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050108', 'Dated Cotton Trousers (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '2610', '80180', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050109', 'Dated Cotton Trousers (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '2610', '80181', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050110', 'Dated Canvas Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '3510', '80182', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050111', 'Dated Canvas Trousers (Pink)', 'Normal/StandardItem', '1', '0', '0', '20850', '3510', '80183', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050112', 'Dated Canvas Trousers (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '3510', '80184', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050113', 'Dated Canvas Trousers (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '3510', '80185', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050114', 'Dated Canvas Trousers (Auburn)', 'Normal/StandardItem', '1', '0', '0', '20850', '3510', '80186', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050115', 'Dated Tarred Leather Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '4410', '80187', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050116', 'Dated Tarred Leather Trousers (Pink)', 'Normal/StandardItem', '1', '0', '0', '20850', '4410', '80188', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050117', 'Dated Tarred Leather Trousers (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '4410', '80189', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050118', 'Dated Tarred Leather Trousers (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4410', '80190', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050119', 'Dated Tarred Leather Trousers (Auburn)', 'Normal/StandardItem', '1', '0', '0', '20850', '4410', '80191', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050120', 'Velveteen Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '3150', '80923', '7021', '1', '0', '0', '0', '0', '34', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050121', 'Velveteen Trousers (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '3150', '80925', '7021', '1', '0', '0', '0', '0', '34', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050122', 'Woolen Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '4050', '82397', '7021', '1', '0', '0', '0', '0', '44', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8050123', 'Woolen Trousers (Purple)', 'Normal/StandardItem', '1', '0', '0', '20850', '4050', '82398', '7021', '1', '0', '0', '0', '0', '44', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8050124', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050125', 'Linen Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '3600', '82395', '7021', '1', '0', '0', '0', '0', '39', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8050126', 'Linen Trousers (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '3600', '82396', '7021', '1', '0', '0', '0', '0', '39', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8050127', 'Felt Trousers (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '4500', '82436', '7021', '1', '0', '0', '0', '0', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050128', 'Felt Trousers (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4500', '82434', '7021', '1', '0', '0', '0', '0', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050129', 'Felt Trousers (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '4500', '82435', '7021', '1', '0', '0', '0', '0', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050130', 'Felt Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '4500', '82399', '7021', '1', '0', '0', '0', '0', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050131', 'Felt Trousers (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '4500', '82400', '7021', '1', '0', '0', '0', '0', '49', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050132', 'Storm Private\'s Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80173', '7021', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050133', 'Storm Sergeant\'s Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80175', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050134', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050135', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050136', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050137', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050138', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050139', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050140', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050141', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050142', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050143', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050144', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050145', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050146', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050147', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '180', '60000', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050148', 'Gridanian Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80184', '7021', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050149', 'Sentinel\'s Trousers', 'Normal/StandardItem', '1', '0', '0', '20850', '4590', '80173', '7021', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050150', 'Weathered Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80928', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050151', 'Paladin\'s Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82062', '7021', '2', '0', '0', '0', '0', '35', '2103', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050201', 'Dated Hempen Breeches', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80193', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050202', 'Dated Hempen Breeches (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80194', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050203', 'Dated Hempen Breeches (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80195', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050204', 'Dated Hempen Breeches (Beige)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80196', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050205', 'Dated Cotton Breeches', 'Normal/StandardItem', '1', '0', '0', '11120', '468', '80197', '7021', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050206', 'Dated Cotton Breeches (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '468', '80198', '7021', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050207', 'Dated Cotton Breeches (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '468', '80199', '7021', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050208', 'Dated Cotton Breeches (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '468', '80200', '7021', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050209', 'Dated Cotton Breeches (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '468', '80201', '7021', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050210', 'Dated Canvas Breeches', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80202', '7021', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050211', 'Dated Canvas Breeches (Auburn)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80203', '7021', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050212', 'Dated Canvas Breeches (Pink)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80204', '7021', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050213', 'Dated Canvas Breeches (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80205', '7021', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050214', 'Dated Canvas Breeches (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80206', '7021', '1', '0', '0', '0', '0', '21', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050215', 'Dated Velveteen Hose', 'Normal/StandardItem', '1', '0', '0', '11120', '1248', '80929', '7021', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8050216', 'Dated Velveteen Hose (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1248', '80930', '7021', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8050217', 'Dated Velveteen Hose (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1248', '80931', '7021', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8050218', 'Dated Velveteen Hose (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1248', '80932', '7021', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8050219', 'Dated Velveteen Hose (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1248', '80933', '7021', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8050220', 'Hempen Breeches', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80193', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050221', 'Hempen Breeches of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80194', '7021', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050222', 'Hempen Breeches of Toiling (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80195', '7021', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050223', 'Cotton Breeches', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80197', '7021', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050224', 'Cotton Breeches of Casting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80199', '7021', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050225', 'Cotton Breeches of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80198', '7021', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050226', 'Hempen Breeches (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80194', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050227', 'Hempen Breeches (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80195', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050228', 'Hempen Breeches of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80193', '7021', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050229', 'Hempen Breeches of Casting (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80195', '7021', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050230', 'Hempen Breeches of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80193', '7021', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050231', 'Hempen Breeches of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '80194', '7021', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050232', 'Cotton Breeches (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80199', '7021', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050233', 'Cotton Breeches (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80198', '7021', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050234', 'Cotton Breeches of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80197', '7021', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050235', 'Cotton Breeches of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80198', '7021', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050236', 'Cotton Breeches of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80197', '7021', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050237', 'Cotton Breeches of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '858', '80199', '7021', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8050238', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '60000', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050239', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '60000', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050240', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '60000', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050241', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '78', '60000', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '34', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050242', 'Explorer\'s Breeches', 'Normal/StandardItem', '1', '1', '0', '11120', '1989', '82511', '7021', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050243', 'Lominsan Breeches', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80931', '7021', '2', '0', '0', '0', '1', '30', '2111', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050244', 'Gridanian Breeches', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80205', '7021', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050245', 'Weathered Breeches (Grey)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80934', '7021', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050246', 'Vintage Hose', 'Normal/StandardItem', '1', '1', '0', '11120', '1521', '81434', '7021', '1', '0', '0', '0', '0', '38', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050247', 'Ripped Hose', 'Normal/StandardItem', '1', '1', '0', '7500', '638', '81434', '7021', '1', '0', '0', '0', '0', '28', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8050248', 'Claret Breeches', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82066', '7021', '3', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050301', 'Dated Hempen Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '225', '80207', '7021', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050302', 'Dated Hempen Chausses (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '225', '80208', '7021', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050303', 'Dated Hempen Chausses (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '225', '80209', '7021', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050304', 'Dated Hempen Chausses (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '225', '80210', '7021', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050305', 'Dated Cotton Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '675', '80211', '7021', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8050306', 'Dated Cotton Chausses (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '675', '80212', '7021', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8050307', 'Dated Cotton Chausses (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '675', '80213', '7021', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8050308', 'Dated Cotton Chausses (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '675', '80214', '7021', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8050309', 'Dated Cotton Chausses (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '675', '80215', '7021', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8050310', 'Dated Canvas Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '1125', '80216', '7021', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8050311', 'Dated Canvas Chausses (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12510', '1125', '80217', '7021', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8050312', 'Dated Canvas Chausses (Pink)', 'Normal/StandardItem', '1', '0', '0', '12510', '1125', '80218', '7021', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8050313', 'Dated Canvas Chausses (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '1125', '80219', '7021', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8050314', 'Dated Canvas Chausses (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '1125', '80220', '7021', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8050315', 'Dated Velveteen Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80935', '7021', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050316', 'Dated Velveteen Chausses (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80936', '7021', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050317', 'Dated Velveteen Chausses (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80937', '7021', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050318', 'Dated Velveteen Chausses (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80938', '7021', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050319', 'Dated Velveteen Chausses (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '1575', '80939', '7021', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8050320', 'Woolen Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82279', '7021', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050321', 'Woolen Chausses of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82280', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050322', 'Woolen Chausses of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82281', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050323', 'Woolen Chausses of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82282', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050324', 'Felt Chausses', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82283', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050325', 'Felt Chausses of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82284', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050326', 'Felt Chausses of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82285', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050327', 'Felt Chausses of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82286', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050328', 'Woolen Chausses (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82280', '7021', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050329', 'Woolen Chausses (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82281', '7021', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050330', 'Woolen Chausses (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82282', '7021', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050331', 'Woolen Chausses of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82279', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050332', 'Woolen Chausses of Dexterity (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82281', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050333', 'Woolen Chausses of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82282', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050334', 'Woolen Chausses of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82279', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050335', 'Woolen Chausses of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82280', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050336', 'Woolen Chausses of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82282', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050337', 'Woolen Chausses of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82279', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050338', 'Woolen Chausses of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82280', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050339', 'Woolen Chausses of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '1980', '82281', '7021', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050340', 'Felt Chausses (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82284', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050341', 'Felt Chausses (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82285', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050342', 'Felt Chausses (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82286', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050343', 'Felt Chausses (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82437', '7021', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050344', 'Lominsan Chausses', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80937', '7021', '2', '0', '0', '0', '1', '30', '2110', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050345', 'Ul\'dahn Chausses', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80936', '7021', '2', '0', '0', '0', '1', '30', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050346', 'Weathered Chausses', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80940', '7021', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050347', 'Weathered Chausses (Grey)', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80941', '7021', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050348', 'Felt Chausses of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82283', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050349', 'Felt Chausses of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82285', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050350', 'Felt Chausses of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82286', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050351', 'Felt Chausses of Dexterity (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82437', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050352', 'Felt Chausses of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82283', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050353', 'Felt Chausses of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82284', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050354', 'Felt Chausses of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82286', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050355', 'Felt Chausses of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82437', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050356', 'Felt Chausses of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82283', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050357', 'Felt Chausses of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82284', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050358', 'Felt Chausses of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82285', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050359', 'Felt Chausses of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2205', '82437', '7021', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050360', 'Mage\'s Chausses', 'Normal/StandardItem', '1', '1', '0', '12510', '2160', '80219', '7021', '2', '0', '0', '0', '1', '47', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050401', 'Dated Sheepskin Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '1242', '81370', '7021', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050402', 'Dated Sheepskin Culottes (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '1242', '81371', '7021', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050403', 'Dated Sheepskin Culottes (Beige)', 'Normal/StandardItem', '1', '0', '0', '18070', '1242', '81372', '7021', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050404', 'Dated Sheepskin Culottes (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '1242', '81373', '7021', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050405', 'Dated Dodoskin Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '1932', '81374', '7021', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8050406', 'Dated Dodoskin Culottes (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '1932', '81375', '7021', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8050407', 'Dated Dodoskin Culottes (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '1932', '81376', '7021', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8050408', 'Dated Dodoskin Culottes (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '1932', '81377', '7021', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8050409', 'Dated Dodoskin Culottes (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '1932', '81378', '7021', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8050410', 'Dated Leather Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '2622', '81379', '7021', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050411', 'Dated Leather Culottes (Auburn)', 'Normal/StandardItem', '1', '0', '0', '18070', '2622', '81380', '7021', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050412', 'Dated Leather Culottes (Pink)', 'Normal/StandardItem', '1', '0', '0', '18070', '2622', '81381', '7021', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050413', 'Dated Leather Culottes (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '2622', '81382', '7021', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050414', 'Dated Leather Culottes (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2622', '81383', '7021', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050415', 'Dated Tarred Leather Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '3312', '81384', '7021', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050416', 'Dated Tarred Leather Culottes (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3312', '81385', '7021', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050417', 'Dated Tarred Leather Culottes (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3312', '81386', '7021', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050418', 'Dated Tarred Leather Culottes (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '3312', '81387', '7021', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050419', 'Dated Tarred Leather Culottes (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3312', '82034', '7021', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050420', 'Boarskin Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050421', 'Boarskin Culottes of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82288', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050422', 'Boarskin Culottes of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050423', 'Boarskin Culottes of Piety (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82289', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050424', 'Raptorskin Culottes', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050425', 'Raptorskin Culottes of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82291', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050426', 'Raptorskin Culottes of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050427', 'Raptorskin Culottes of Piety (Purple)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82292', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050428', 'Boarskin Culottes (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82288', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050429', 'Boarskin Culottes (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050430', 'Boarskin Culottes (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82289', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050431', 'Boarskin Culottes of the Mind', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050432', 'Boarskin Culottes of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050433', 'Boarskin Culottes of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82289', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050434', 'Boarskin Culottes of Intelligence', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050435', 'Boarskin Culottes of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82288', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050436', 'Boarskin Culottes of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82289', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050437', 'Boarskin Culottes of Piety', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050438', 'Boarskin Culottes of Piety (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82288', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050439', 'Boarskin Culottes of Piety (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3036', '82287', '7021', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050440', 'Raptorskin Culottes (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82291', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050441', 'Raptorskin Culottes (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050442', 'Raptorskin Culottes (Purple)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82292', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050443', 'Raptorskin Culottes (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82438', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050444', 'Raptorskin Culottes of the Mind', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050445', 'Raptorskin Culottes of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050446', 'Raptorskin Culottes of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82292', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050447', 'Raptorskin Culottes of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82438', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050448', 'Raptorskin Culottes of Intelligence', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050449', 'Ul\'dahn Culottes', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81386', '7021', '2', '0', '0', '0', '1', '30', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050450', 'Weathered Culottes (Grey)', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81356', '7021', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050451', 'Raptorskin Culottes of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82291', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050452', 'Raptorskin Culottes of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82292', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050453', 'Raptorskin Culottes of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82438', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050454', 'Raptorskin Culottes of Piety', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050455', 'Raptorskin Culottes of Piety (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82291', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050456', 'Raptorskin Culottes of Piety (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82290', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050457', 'Raptorskin Culottes of Piety (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3381', '82438', '7021', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050501', 'Dated Sheepskin Subligar (Brown)', 'Normal/StandardItem', '1', '0', '0', '16680', '924', '80957', '7021', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050502', 'Dated Sheepskin Subligar (Grey)', 'Normal/StandardItem', '1', '0', '0', '16680', '924', '80958', '7021', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050503', 'Dodoskin Subligar', 'Normal/StandardItem', '1', '0', '0', '16680', '858', '80961', '7021', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8050504', 'Dodoskin Subligar (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '858', '80962', '7021', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8050505', 'Dated Dodoskin Subligar (Yellow)', 'Normal/StandardItem', '1', '0', '0', '16680', '1584', '80961', '7021', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8050506', 'Dated Dodoskin Subligar (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '1584', '80962', '7021', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8050507', 'Dated Leather Subligar (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2244', '80963', '7021', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8050508', 'Dated Leather Subligar (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '2244', '80964', '7021', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8050509', 'Boarskin Subligar', 'Normal/StandardItem', '1', '0', '0', '16680', '2508', '82297', '7021', '1', '0', '0', '0', '0', '37', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050510', 'Boarskin Subligar (Blue)', 'Normal/StandardItem', '1', '0', '0', '16680', '2508', '82297', '7021', '1', '0', '0', '0', '0', '37', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050511', 'Peisteskin Subligar', 'Normal/StandardItem', '1', '0', '0', '16680', '2838', '82298', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050512', 'Peisteskin Subligar (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2838', '82298', '7021', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8050513', 'Raptorskin Subligar', 'Normal/StandardItem', '1', '0', '0', '16680', '3168', '82299', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050514', 'Raptorskin Subligar (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '3168', '82299', '7021', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8050515', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '132', '60000', '7021', '1', '0', '0', '0', '0', '1', '1107', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050516', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '132', '60000', '7021', '1', '0', '0', '0', '0', '1', '1107', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050517', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '132', '60000', '7021', '1', '0', '0', '0', '0', '1', '1107', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050518', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '132', '60000', '7021', '1', '0', '0', '0', '0', '1', '1107', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8050519', 'Thormoen\'s Subligar', 'Normal/StandardItem', '1', '1', '0', '16680', '3036', '82514', '7021', '2', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8050520', 'Ul\'dahn Subligar', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '80963', '7021', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050521', 'Star-Spangled Subligar', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81495', '7021', '1', '0', '0', '0', '0', '18', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050601', 'Dated Hempen Kecks (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '558', '80221', '7021', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050602', 'Dated Hempen Kecks (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '558', '80222', '7021', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050603', 'Dated Cotton Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '1116', '80967', '7021', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8050604', 'Dated Cotton Kecks (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '1116', '80968', '7021', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8050605', 'Dated Canvas Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '1674', '80969', '7021', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8050606', 'Dated Canvas Kecks (Auburn)', 'Normal/StandardItem', '1', '0', '0', '15290', '1674', '80970', '7021', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8050607', 'Dated Velveteen Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '2232', '80971', '7021', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8050608', 'Dated Velveteen Kecks (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '2232', '80972', '7021', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8050609', 'Hempen Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '502', '80221', '7021', '1', '0', '0', '0', '0', '8', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050610', 'Hempen Kecks (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '502', '80222', '7021', '1', '0', '0', '0', '0', '8', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050611', 'Cotton Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '1339', '80967', '7021', '1', '0', '0', '0', '0', '23', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8050612', 'Cotton Kecks (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '1339', '80968', '7021', '1', '0', '0', '0', '0', '23', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8050613', 'Woolen Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '2455', '82300', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050614', 'Woolen Kecks (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2455', '82301', '7021', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050615', 'Felt Kecks', 'Normal/StandardItem', '1', '0', '0', '15290', '2734', '82302', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050616', 'Felt Kecks (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '2734', '82303', '7021', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8050618', 'Serpent Private\'s Kecks', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '80221', '7021', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050619', 'Serpent Sergeant\'s Kecks', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '80971', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050620', 'Lominsan Kecks', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82141', '7021', '2', '0', '0', '0', '1', '30', '2103', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8050621', 'Weathered Kecks (Brown)', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '80973', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050622', 'Weathered Kecks (Grey)', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '80974', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050701', 'Dated Hempen Sarouel (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '421', '80223', '7021', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050702', 'Dated Hempen Sarouel (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '421', '80975', '7021', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050703', 'Dated Hempen Sarouel (Beige)', 'Normal/StandardItem', '1', '0', '0', '13900', '421', '80976', '7021', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050704', 'Dated Cotton Sarouel (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '889', '80977', '7021', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050705', 'Dated Cotton Sarouel (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '889', '80978', '7021', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050706', 'Dated Cotton Sarouel (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '889', '80979', '7021', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050707', 'Dated Cotton Sarouel (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '889', '80980', '7021', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8050708', 'Dated Velveteen Sarouel (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1825', '80981', '7021', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050709', 'Dated Velveteen Sarouel (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1825', '80982', '7021', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050710', 'Dated Velveteen Sarouel (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1825', '80983', '7021', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050711', 'Dated Velveteen Sarouel (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1825', '80984', '7021', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8050712', 'Velveteen Sarouel', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '82304', '7021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050713', 'Velveteen Sarouel of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80983', '7021', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050714', 'Velveteen Sarouel of Invoking (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80984', '7021', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050715', 'Velveteen Sarouel of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80982', '7021', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050716', 'Linen Sarouel', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82305', '7021', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050717', 'Linen Sarouel of Slaying (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82306', '7021', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050718', 'Linen Sarouel of Invoking (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82307', '7021', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050719', 'Linen Sarouel of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82308', '7021', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050720', 'Woolen Sarouel', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82309', '7021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050721', 'Woolen Sarouel of Slaying (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82310', '7021', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050722', 'Woolen Sarouel of Invoking (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82311', '7021', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050723', 'Woolen Sarouel of Toiling (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82312', '7021', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050724', 'Velveteen Sarouel (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80983', '7021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050725', 'Velveteen Sarouel (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80984', '7021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050726', 'Velveteen Sarouel (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80982', '7021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050727', 'Sipahi Sarouel', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82148', '7021', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050728', 'Weathered Sarouel (Brown)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80985', '7021', '1', '0', '0', '0', '0', '1', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050729', 'Velveteen Sarouel of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '82304', '7021', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050730', 'Velveteen Sarouel of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80984', '7021', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050731', 'Velveteen Sarouel of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80982', '7021', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050732', 'Velveteen Sarouel of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '82304', '7021', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050733', 'Velveteen Sarouel of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80983', '7021', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050734', 'Velveteen Sarouel of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80982', '7021', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050735', 'Velveteen Sarouel of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '82304', '7021', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050736', 'Velveteen Sarouel of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80983', '7021', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050737', 'Velveteen Sarouel of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1216', '80984', '7021', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8050738', 'Linen Sarouel (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82306', '7021', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050739', 'Linen Sarouel (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82307', '7021', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050740', 'Linen Sarouel (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82308', '7021', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050741', 'Linen Sarouel of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82305', '7021', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050742', 'Linen Sarouel of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82307', '7021', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050743', 'Linen Sarouel of Slaying (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82308', '7021', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050744', 'Linen Sarouel of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82305', '7021', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050745', 'Linen Sarouel of Invoking (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82306', '7021', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050746', 'Linen Sarouel of Invoking (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82308', '7021', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050747', 'Linen Sarouel of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82305', '7021', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050748', 'Linen Sarouel of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82306', '7021', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050749', 'Linen Sarouel of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1684', '82307', '7021', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8050750', 'Woolen Sarouel (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82310', '7021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050751', 'Woolen Sarouel (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82311', '7021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050752', 'Woolen Sarouel (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82312', '7021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050753', 'Woolen Sarouel (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82439', '7021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050754', 'Woolen Sarouel of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82309', '7021', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050755', 'Woolen Sarouel of Slaying (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82311', '7021', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050756', 'Woolen Sarouel of Slaying (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82312', '7021', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050757', 'Woolen Sarouel of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82439', '7021', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050758', 'Woolen Sarouel of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82309', '7021', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050759', 'Woolen Sarouel of Invoking (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82310', '7021', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050760', 'Woolen Sarouel of Invoking (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82312', '7021', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050761', 'Woolen Sarouel of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82439', '7021', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050762', 'Woolen Sarouel of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82309', '7021', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050763', 'Woolen Sarouel of Toiling (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82310', '7021', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050764', 'Woolen Sarouel of Toiling (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82311', '7021', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050765', 'Woolen Sarouel of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1918', '82439', '7021', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050766', 'Flame Private\'s Sarouel', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80977', '7021', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8050767', 'Flame Sergeant\'s Sarouel', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80981', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050768', 'Serpent Sergeant\'s Sarouel', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80979', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050769', 'Storm Sergeant\'s Sarouel', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80978', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050801', 'Dated Sheepskin Skirt', 'Normal/StandardItem', '1', '0', '0', '19460', '1404', '80986', '7021', '1', '0', '0', '0', '0', '17', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050802', 'Dated Dodoskin Skirt', 'Normal/StandardItem', '1', '0', '0', '19460', '2184', '80987', '7021', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8050803', 'Dated Leather Skirt', 'Normal/StandardItem', '1', '0', '0', '19460', '2964', '80988', '7021', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050804', 'Dated Leather Skirt (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '2964', '80989', '7021', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050805', 'Dated Leather Skirt (Black)', 'Normal/StandardItem', '1', '0', '0', '19460', '2964', '80990', '7021', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050806', 'Dated Leather Skirt (Ochre)', 'Normal/StandardItem', '1', '0', '0', '19460', '2964', '80991', '7021', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050807', 'Dated Leather Skirt (Green)', 'Normal/StandardItem', '1', '0', '0', '19460', '2964', '80992', '7021', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8050808', 'Judge\'s Skirt', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '80993', '7021', '1', '0', '0', '0', '0', '1', '2033', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8050809', 'Boarskin Skirt', 'Normal/StandardItem', '1', '0', '0', '19460', '3432', '82313', '7021', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050810', 'Boarskin Skirt (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '3432', '82314', '7021', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8050811', 'Flame Sergeant\'s Skirt', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '80990', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8050901', 'Woolen Gaskins', 'Normal/StandardItem', '1', '0', '0', '13900', '3375', '82315', '7021', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8050902', 'Woolen Gaskins (Purple)', 'Normal/StandardItem', '1', '0', '0', '13900', '3375', '82316', '7021', '1', '0', '0', '0', '0', '44', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8050903', 'Felt Gaskins', 'Normal/StandardItem', '1', '0', '0', '13900', '3750', '82317', '7021', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050904', 'Felt Gaskins (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '3750', '82317', '7021', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050905', 'Felt Gaskins (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '3750', '82442', '7021', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050906', 'Felt Gaskins (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3750', '82440', '7021', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050907', 'Felt Gaskins (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3750', '82441', '7021', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8050940', 'Onion Gaskins', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81354', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051001', 'Dated Hempen Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '344', '80942', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051002', 'Dated Hempen Tights (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '344', '80943', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051003', 'Dated Hempen Tights (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '344', '80944', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051004', 'Dated Hempen Tights (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '344', '80945', '7021', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051005', 'Dated Cotton Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '836', '80946', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8051006', 'Dated Cotton Tights (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '836', '80947', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8051007', 'Dated Cotton Tights (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '836', '80948', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8051008', 'Dated Cotton Tights (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '836', '80949', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8051009', 'Dated Cotton Tights (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '836', '80950', '7021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8051010', 'Dated Velveteen Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '80951', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051011', 'Dated Velveteen Tights (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '80952', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051012', 'Dated Velveteen Tights (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '80953', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051013', 'Dated Velveteen Tights (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '80954', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051014', 'Dated Velveteen Tights (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '80955', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051015', 'Weathered Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80956', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051016', 'Harlequin\'s Tights', 'Normal/StandardItem', '1', '1', '0', '13900', '2937', '81489', '7021', '2', '0', '0', '0', '0', '50', '1007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051017', 'Ascetic\'s Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80954', '7021', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8051018', 'Velveteen Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '1328', '80951', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8051019', 'Velveteen Tights (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1328', '80952', '7021', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8051020', 'Linen Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '82293', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051021', 'Linen Tights (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '1820', '82294', '7021', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8051022', 'Woolen Tights', 'Normal/StandardItem', '1', '0', '0', '12510', '2066', '82295', '7021', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8051023', 'Woolen Tights (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2066', '82296', '7021', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8051024', 'Ul\'dahn Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80952', '7021', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8051025', 'Sorcerer\'s Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82151', '7021', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051101', 'Dated Hempen Shepherd\'s Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '384', '81777', '7021', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051102', 'Dated Hempen Shepherd\'s Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '384', '81778', '7021', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051103', 'Dated Hempen Shepherd\'s Slops (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '384', '81779', '7021', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051104', 'Dated Hempen Shepherd\'s Slops (Beige)', 'Normal/StandardItem', '1', '0', '0', '13900', '384', '81780', '7021', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051105', 'Dated Cotton Shepherd\'s Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81783', '7021', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051106', 'Dated Cotton Shepherd\'s Slops (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81784', '7021', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051107', 'Dated Cotton Shepherd\'s Slops (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81785', '7021', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051108', 'Dated Cotton Shepherd\'s Slops (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81787', '7021', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051109', 'Dated Cotton Shepherd\'s Slops (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81786', '7021', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051110', 'Dated Canvas Shepherd\'s Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '1344', '81788', '7021', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8051111', 'Dated Canvas Shepherd\'s Slops (Auburn)', 'Normal/StandardItem', '1', '0', '0', '13900', '1344', '81789', '7021', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8051112', 'Dated Canvas Shepherd\'s Slops (Pink)', 'Normal/StandardItem', '1', '0', '0', '13900', '1344', '81790', '7021', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8051113', 'Dated Canvas Shepherd\'s Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1344', '81791', '7021', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8051114', 'Dated Canvas Shepherd\'s Slops (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '1344', '81792', '7021', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8051115', 'Hempen Shepherd\'s Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '96', '81777', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051116', 'Hempen Shepherd\'s Slops (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '96', '81778', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051117', 'Hempen Shepherd\'s Slops (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '96', '81780', '7021', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051118', 'Cotton Shepherd\'s Slops', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81783', '7021', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051119', 'Cotton Shepherd\'s Slops (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81786', '7021', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051120', 'Cotton Shepherd\'s Slops (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '864', '81785', '7021', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8051121', 'Mercenary\'s Slops', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81800', '7021', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051201', 'Dated Canvas Bottom', 'Normal/StandardItem', '1', '0', '0', '12500', '1364', '81909', '7021', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051202', 'Dated Canvas Bottom (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12500', '1364', '81910', '7021', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051203', 'Dated Canvas Bottom (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '1364', '81911', '7021', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051204', 'Dated Canvas Bottom (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1364', '81912', '7021', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051205', 'Dated Canvas Bottom (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1364', '81913', '7021', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051206', 'Dated Velveteen Bottom', 'Normal/StandardItem', '1', '0', '0', '12500', '1804', '81914', '7021', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051207', 'Dated Velveteen Bottom (Black)', 'Normal/StandardItem', '1', '0', '0', '12500', '1804', '81915', '7021', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051208', 'Dated Velveteen Bottom (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1804', '81916', '7021', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051209', 'Dated Velveteen Bottom (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1804', '81917', '7021', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051210', 'Dated Velveteen Bottom (Green)', 'Normal/StandardItem', '1', '0', '0', '12500', '1804', '81918', '7021', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051211', 'Dated Linen Bottom', 'Normal/StandardItem', '1', '0', '0', '12500', '2244', '81914', '7021', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8051212', 'Dated Linen Bottom (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '2244', '81911', '7021', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8051213', 'Dated Linen Bottom (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2244', '81913', '7021', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8051214', 'Dated Linen Bottom (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2244', '81912', '7021', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8051215', 'Dated Linen Bottom (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2244', '81910', '7021', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8051216', 'Velveteen Bottom', 'Normal/StandardItem', '1', '0', '0', '12500', '1276', '81914', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051217', 'Velveteen Bottom (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1276', '81916', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051218', 'Velveteen Bottom (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1276', '81917', '7021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8051219', 'Linen Bottom', 'Normal/StandardItem', '1', '0', '0', '12500', '1716', '81914', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051220', 'Linen Bottom (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1716', '81913', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051221', 'Linen Bottom (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1716', '81912', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051222', 'Gridanian Bottom', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '81917', '7021', '2', '0', '0', '0', '1', '30', '2110', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8051223', 'Linen Bottom (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1716', '81911', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051224', 'Linen Bottom (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1716', '81910', '7021', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8051301', 'Red Summer Trunks', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82086', '7019', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051302', 'Green Summer Trunks', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82087', '7019', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051303', 'Blue Summer Trunks', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82088', '7019', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051304', 'Solar Summer Trunks', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82089', '7019', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051305', 'Lunar Summer Trunks', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82090', '7019', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051306', 'Red Summer Tanga', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82096', '7019', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051307', 'Green Summer Tanga', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82097', '7019', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051308', 'Blue Summer Tanga', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82098', '7019', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051309', 'Solar Summer Tanga', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82099', '7019', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051310', 'Lunar Summer Tanga', 'Normal/StandardItem', '1', '1', '1', '0', '0', '82100', '7019', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051401', 'Gallant Cuisses', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '82483', '7021', '3', '0', '0', '0', '1', '46', '2120', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051402', 'Temple Gaskins', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82488', '7021', '3', '0', '0', '0', '1', '46', '2119', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051403', 'Fighter\'s Breeches', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82463', '7021', '3', '0', '0', '0', '1', '46', '2121', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051404', 'Drachen Breeches', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82458', '7021', '3', '0', '0', '0', '1', '46', '2123', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051405', 'Choral Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82478', '7021', '3', '0', '0', '0', '1', '46', '2122', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051406', 'Healer\'s Culottes', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82468', '7021', '3', '0', '0', '0', '1', '46', '2125', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051407', 'Wizard\'s Tonban', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82473', '7021', '3', '0', '0', '0', '1', '46', '2124', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8051501', 'Heavy Darklight Flanchard', 'Normal/StandardItem', '1', '1', '1', '40000', '0', '82493', '7021', '3', '0', '0', '0', '1', '50', '2126', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051502', 'Darklight Breeches', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82504', '7021', '3', '0', '0', '0', '1', '50', '2129', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051503', 'Heavy Darksteel Flanchard', 'Normal/StandardItem', '1', '0', '0', '40000', '4500', '82521', '7021', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051504', 'Heavy Darksteel Flanchard (White)', 'Normal/StandardItem', '1', '0', '0', '40000', '4500', '82520', '7021', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051505', 'Heavy Darksteel Flanchard (Red)', 'Normal/StandardItem', '1', '0', '0', '40000', '4500', '82522', '7021', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051506', 'Heavy Darksteel Flanchard (Green)', 'Normal/StandardItem', '1', '0', '0', '40000', '4500', '82523', '7021', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051507', 'Heavy Darksteel Flanchard (Blue)', 'Normal/StandardItem', '1', '0', '0', '40000', '4500', '82524', '7021', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051508', 'Gryphonskin Trousers', 'Normal/StandardItem', '1', '0', '0', '18070', '3450', '82535', '7021', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051509', 'Gryphonskin Trousers (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '3450', '82536', '7021', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051510', 'Gryphonskin Trousers (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3450', '82537', '7021', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051511', 'Gryphonskin Trousers (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3450', '82538', '7021', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051512', 'Gryphonskin Trousers (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '3450', '82539', '7021', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8051513', 'Militia Trousers', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82590', '7021', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051514', 'Militia Tights', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82575', '7021', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051515', 'Militia Subligar', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82577', '7021', '2', '0', '0', '0', '1', '50', '2158', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051516', 'Storm Sergeant\'s Hose', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82585', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051517', 'Serpent Sergeant\'s Hose', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82586', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051518', 'Flame Sergeant\'s Hose', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82573', '7021', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8051519', 'Coliseum Subligar', 'Normal/StandardItem', '1', '0', '0', '16680', '3036', '82609', '7021', '2', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8051520', 'Coliseum Loincloth', 'Normal/StandardItem', '1', '0', '0', '12510', '2263', '82611', '7021', '2', '0', '0', '0', '1', '45', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8051521', 'Lord\'s Drawers (Black)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82630', '7021', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051522', 'Lord\'s Drawers (White)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82631', '7021', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051523', 'Lord\'s Drawers (Gold)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82632', '7021', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051524', 'Lady\'s Knickers (Black)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82627', '7021', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051525', 'Lady\'s Knickers (White)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82628', '7021', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8051526', 'Lady\'s Knickers (Gold)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82629', '7021', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060001', 'Well-worn Halftights', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81327', '7019', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060002', 'Well-worn Pagne', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81329', '7019', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060003', 'Well-worn Loinguard (Brown)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81349', '7019', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060004', 'Well-worn Braies', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81331', '7019', '1', '0', '0', '0', '0', '1', '2011', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060005', 'Well-worn Braies (Brown)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81332', '7019', '1', '0', '0', '0', '0', '1', '2013', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060006', 'Well-worn Stockings', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81334', '7019', '1', '0', '0', '0', '0', '1', '2012', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060007', 'Well-worn Stockings (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81335', '7019', '1', '0', '0', '0', '0', '1', '2014', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060008', 'Well-worn Shorts', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81337', '7019', '1', '0', '0', '0', '0', '1', '2015', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060009', 'Well-worn Shorts (Beige)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81338', '7019', '1', '0', '0', '0', '0', '1', '2017', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060010', 'Well-worn Drawers (Brown)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81340', '7019', '1', '0', '0', '0', '0', '1', '2016', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060011', 'Well-worn Drawers (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81341', '7019', '1', '0', '0', '0', '0', '1', '2018', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060012', 'Well-worn Pantalettes (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81346', '7019', '1', '0', '0', '0', '0', '1', '2019', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060013', 'Well-worn Pantalettes', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81347', '7019', '1', '0', '0', '0', '0', '1', '2020', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060014', 'Well-worn Trunks (Beige)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81343', '7019', '1', '0', '0', '0', '0', '1', '2021', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060015', 'Well-worn Trunks (Grey)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '81344', '7019', '1', '0', '0', '0', '0', '1', '2022', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060016', 'Hempen Halftights (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '80150', '7019', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060017', 'Hempen Halftights', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81326', '7019', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060018', 'Hempen Halftights (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '80152', '7019', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060019', 'Hempen Halftights (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '80153', '7019', '1', '0', '0', '0', '0', '1', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060020', 'Hempen Pagne (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81329', '7019', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060021', 'Hempen Pagne', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81328', '7019', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060022', 'Hempen Pagne (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81329', '7019', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060023', 'Hempen Pagne (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81328', '7019', '1', '0', '0', '0', '0', '1', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060024', 'Hempen Loinguard (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81349', '7019', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060025', 'Hempen Loinguard', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81348', '7019', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060026', 'Hempen Loinguard (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81349', '7019', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060027', 'Hempen Loinguard (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81348', '7019', '1', '0', '0', '0', '0', '1', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060028', 'Hempen Braies (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81331', '7019', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060029', 'Hempen Braies', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81330', '7019', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060030', 'Hempen Braies (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81331', '7019', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060031', 'Hempen Braies (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81330', '7019', '1', '0', '0', '0', '0', '1', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060032', 'Hempen Stockings (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81334', '7019', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060033', 'Hempen Stockings', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81333', '7019', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060034', 'Hempen Stockings (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81335', '7019', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060035', 'Hempen Stockings (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '82043', '7019', '1', '0', '0', '0', '0', '1', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060036', 'Hempen Shorts (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '82044', '7019', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060037', 'Hempen Shorts', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81336', '7019', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060038', 'Hempen Shorts (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '82044', '7019', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060039', 'Hempen Shorts (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81338', '7019', '1', '0', '0', '0', '0', '1', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060040', 'Hempen Drawers (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81340', '7019', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060041', 'Hempen Drawers', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81339', '7019', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060042', 'Hempen Drawers (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81341', '7019', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060043', 'Hempen Drawers (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '82045', '7019', '1', '0', '0', '0', '0', '1', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060044', 'Hempen Pantalettes (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81347', '7019', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060045', 'Hempen Pantalettes', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81345', '7019', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060046', 'Hempen Pantalettes (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81346', '7019', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060047', 'Hempen Pantalettes (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81345', '7019', '1', '0', '0', '0', '0', '1', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060048', 'Hempen Trunks (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81344', '7019', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060049', 'Hempen Trunks', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81342', '7019', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060050', 'Hempen Trunks (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81344', '7019', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060051', 'Hempen Trunks (Beige)', 'Normal/StandardItem', '1', '0', '0', '0', '36', '81342', '7019', '1', '0', '0', '0', '0', '1', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8060052', 'Cotton Halftights', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81326', '7019', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060053', 'Cotton Halftights (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81326', '7019', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060054', 'Cotton Halftights (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81326', '7019', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060055', 'Cotton Halftights (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81326', '7019', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060056', 'Cotton Halftights (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81326', '7019', '1', '0', '0', '0', '0', '21', '2008', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060057', 'Cotton Pagne', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81328', '7019', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060058', 'Cotton Pagne (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81328', '7019', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060059', 'Cotton Pagne (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81328', '7019', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060060', 'Cotton Pagne (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81328', '7019', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060061', 'Cotton Pagne (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81328', '7019', '1', '0', '0', '0', '0', '21', '2009', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060062', 'Cotton Loinguard', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81348', '7019', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060063', 'Cotton Loinguard (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81348', '7019', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060064', 'Cotton Loinguard (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81348', '7019', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060065', 'Cotton Loinguard (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81348', '7019', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060066', 'Cotton Loinguard (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81348', '7019', '1', '0', '0', '0', '0', '21', '2010', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060067', 'Cotton Braies', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81330', '7019', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060068', 'Cotton Braies (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81330', '7019', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060069', 'Cotton Braies (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81330', '7019', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060070', 'Cotton Braies (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81330', '7019', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060071', 'Cotton Braies (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81330', '7019', '1', '0', '0', '0', '0', '21', '2025', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060072', 'Cotton Stockings', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81333', '7019', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060073', 'Cotton Stockings (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81333', '7019', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060074', 'Cotton Stockings (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81333', '7019', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060075', 'Cotton Stockings (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81333', '7019', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060076', 'Cotton Stockings (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81333', '7019', '1', '0', '0', '0', '0', '21', '2026', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060077', 'Cotton Shorts', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81336', '7019', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060078', 'Cotton Shorts (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81336', '7019', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060079', 'Cotton Shorts (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81336', '7019', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060080', 'Cotton Shorts (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81336', '7019', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060081', 'Cotton Shorts (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81336', '7019', '1', '0', '0', '0', '0', '21', '2027', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060082', 'Cotton Drawers', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81339', '7019', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060083', 'Cotton Drawers (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81339', '7019', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060084', 'Cotton Drawers (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81339', '7019', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060085', 'Cotton Drawers (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81339', '7019', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060086', 'Cotton Drawers (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81339', '7019', '1', '0', '0', '0', '0', '21', '2028', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060087', 'Cotton Pantalettes', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81345', '7019', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060088', 'Cotton Pantalettes (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81345', '7019', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060089', 'Cotton Pantalettes (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81345', '7019', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060090', 'Cotton Pantalettes (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81345', '7019', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060091', 'Cotton Pantalettes (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81345', '7019', '1', '0', '0', '0', '0', '21', '2030', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060092', 'Cotton Trunks', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81342', '7019', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060093', 'Cotton Trunks (Brown)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81342', '7019', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060094', 'Cotton Trunks (Yellow)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81342', '7019', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060095', 'Cotton Trunks (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81342', '7019', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8060096', 'Cotton Trunks (Blue)', 'Normal/StandardItem', '1', '0', '0', '0', '396', '81342', '7019', '1', '0', '0', '0', '0', '21', '2029', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8070001', 'Dated Smithy\'s Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '455', '80232', '7024', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070002', 'Dated Leather Smithy\'s Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '1757', '80224', '7024', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8070003', 'Dated Leather Smithy\'s Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1757', '80225', '7024', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8070004', 'Dated Leather Smithy\'s Gloves (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '1757', '80226', '7024', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8070005', 'Dated Leather Smithy\'s Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1757', '80227', '7024', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8070006', 'Dated Leather Smithy\'s Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1757', '80228', '7024', '1', '0', '0', '0', '0', '26', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8070007', 'Boarskin Smithy\'s Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '2799', '80996', '7024', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070008', 'Boarskin Smithy\'s Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2799', '80998', '7024', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070009', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070010', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070011', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070012', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070013', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070014', 'Raptorskin Smithy\'s Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '3124', '80229', '7024', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070015', 'Raptorskin Smithy\'s Gloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3124', '82319', '7024', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070016', 'Raptorskin Smithy\'s Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '3124', '80230', '7024', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070017', 'Raptorskin Smithy\'s Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3124', '82443', '7024', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070018', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '130', '60000', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070019', 'Weathered Smithy\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81001', '7024', '1', '0', '0', '0', '0', '1', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070020', 'Dated Thick Smithy\'s Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '2408', '81414', '7024', '1', '0', '0', '0', '0', '36', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8070021', 'Dated Smithy\'s Gloves (Taupe)', 'Normal/StandardItem', '1', '0', '0', '13900', '455', '80994', '7024', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070022', 'Dated Smithy\'s Gloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '455', '80995', '7024', '1', '0', '0', '0', '0', '6', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070023', 'Vintage Smithy\'s Gloves', 'Normal/StandardItem', '1', '1', '0', '13900', '3189', '80229', '7024', '1', '0', '0', '0', '0', '48', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070024', 'Blackened Smithy\'s Gloves', 'Normal/StandardItem', '1', '1', '0', '7500', '780', '81415', '7024', '1', '0', '0', '0', '0', '38', '1101', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8070101', 'Dated Bronze Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '4095', '80233', '7023', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070102', 'Dated Bronze Gauntlets (Auburn)', 'Normal/StandardItem', '1', '0', '0', '20850', '4095', '80234', '7023', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070103', 'Dated Bronze Gauntlets (Pink)', 'Normal/StandardItem', '1', '0', '0', '20850', '4095', '80235', '7023', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070104', 'Dated Bronze Gauntlets (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '4095', '80236', '7023', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070105', 'Dated Bronze Gauntlets (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4095', '80237', '7023', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070106', 'Dated Iron Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '5145', '80238', '7023', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070107', 'Dated Iron Gauntlets (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '5145', '80241', '7023', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070108', 'Dated Iron Gauntlets (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '5145', '80242', '7023', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070109', 'Steel Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '4200', '80239', '7023', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8070110', 'Steel Gauntlets (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4200', '80243', '7023', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8070111', 'Cobalt Gauntlets (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82444', '7023', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8070112', 'Sentinel\'s Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '5355', '80247', '7023', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070113', 'Cobalt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82320', '7023', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8070114', 'Cobalt Gauntlets (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82321', '7023', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8070115', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '210', '60000', '7023', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070116', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '210', '60000', '7023', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070117', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '210', '60000', '7023', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070118', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '210', '60000', '7023', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070119', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '210', '60000', '7023', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070201', 'Dated Sheepskin Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '728', '80263', '7023', '1', '0', '0', '0', '0', '12', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070202', 'Dated Dodoskin Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '1008', '80264', '7023', '1', '0', '0', '0', '0', '17', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070203', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '60000', '7023', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070204', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '60000', '7023', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070205', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '60000', '7023', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070206', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '60000', '7023', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070207', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '60000', '7023', '1', '0', '0', '0', '0', '22', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070208', 'Dated Leather Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '80270', '7023', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070209', 'Dated Leather Vambraces (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '80271', '7023', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070210', 'Dated Leather Vambraces (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '80272', '7023', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070211', 'Dated Leather Vambraces (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '80273', '7023', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070212', 'Dated Leather Vambraces (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '80274', '7023', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070213', 'Dated Brass Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '80275', '7023', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070214', 'Dated Brass Vambraces (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '80276', '7023', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070215', 'Dated Brass Vambraces (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '80277', '7023', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070216', 'Dated Brass Vambraces (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '80278', '7023', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070217', 'Dated Brass Vambraces (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '80279', '7023', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070218', 'Iron Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '80280', '7023', '1', '0', '0', '0', '0', '22', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8070219', 'Iron Vambraces (Brown)', 'Normal/StandardItem', '1', '0', '0', '16680', '1288', '80282', '7023', '1', '0', '0', '0', '0', '22', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8070220', 'Steel Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '81549', '7023', '1', '0', '0', '0', '0', '32', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070221', 'Steel Vambraces (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '1848', '81550', '7023', '1', '0', '0', '0', '0', '32', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8070222', 'Mythril Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '82362', '7023', '1', '0', '0', '0', '0', '42', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070223', 'Mythril Vambraces (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '2408', '82362', '7023', '1', '0', '0', '0', '0', '42', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070224', 'Cobalt Vambraces', 'Normal/StandardItem', '1', '0', '0', '16680', '2688', '82363', '7023', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070225', 'Cobalt Vambraces (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '2688', '82364', '7023', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070226', 'Cobalt Vambraces (Blue)', 'Normal/StandardItem', '1', '0', '0', '16680', '2688', '82449', '7023', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070227', 'Cobalt Vambraces (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '2688', '82448', '7023', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070228', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070229', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070230', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070231', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070232', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070233', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070234', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070235', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070236', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070237', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070238', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070239', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070240', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070241', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070242', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '112', '60000', '7023', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070243', 'Judge\'s Vambraces', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81076', '7023', '1', '0', '0', '0', '0', '1', '2033', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070301', 'Dated Hempen Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '262', '80248', '7024', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070302', 'Dated Hempen Halfgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '262', '80249', '7024', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070303', 'Dated Hempen Halfgloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '262', '80250', '7024', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070304', 'Dated Hempen Halfgloves (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '262', '80251', '7024', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070305', 'Dated Cotton Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '787', '80252', '7024', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070306', 'Dated Cotton Halfgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '787', '80253', '7024', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070307', 'Dated Cotton Halfgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '787', '80254', '7024', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070308', 'Dated Cotton Halfgloves (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '787', '80255', '7024', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070309', 'Dated Cotton Halfgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '787', '80256', '7024', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070310', 'Dated Canvas Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '1312', '80257', '7024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070311', 'Dated Canvas Halfgloves (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12510', '1312', '80258', '7024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070312', 'Dated Canvas Halfgloves (Pink)', 'Normal/StandardItem', '1', '0', '0', '12510', '1312', '80259', '7024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070313', 'Dated Canvas Halfgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '1312', '80260', '7024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070314', 'Dated Canvas Halfgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '1312', '80261', '7024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070315', 'Dated Velveteen Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '1837', '81002', '7024', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070316', 'Dated Velveteen Halfgloves (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1837', '81003', '7024', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070317', 'Dated Velveteen Halfgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '1837', '81004', '7024', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070318', 'Dated Velveteen Halfgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '1837', '81005', '7024', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070319', 'Dated Velveteen Halfgloves (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '1837', '81006', '7024', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070320', 'Hempen Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '105', '80248', '7024', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070321', 'Hempen Halfgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '105', '80251', '7024', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070322', 'Cotton Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '840', '80252', '7024', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8070323', 'Cotton Halfgloves (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '840', '80255', '7024', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8070324', 'Woolen Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82322', '7024', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070325', 'Woolen Halfgloves of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82323', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070326', 'Woolen Halfgloves of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82324', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070327', 'Woolen Halfgloves of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82325', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070328', 'Felt Halfgloves', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82326', '7024', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070329', 'Felt Halfgloves of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82327', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070330', 'Felt Halfgloves of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82328', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070331', 'Felt Halfgloves of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82329', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070332', 'Woolen Halfgloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82323', '7024', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070333', 'Woolen Halfgloves (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82324', '7024', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070334', 'Woolen Halfgloves (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82325', '7024', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070335', 'Woolen Halfgloves of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82322', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070336', 'Woolen Halfgloves of Dexterity (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82324', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070337', 'Woolen Halfgloves of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82325', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070338', 'Woolen Halfgloves of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82322', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070339', 'Woolen Halfgloves of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82323', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070340', 'Woolen Halfgloves of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82325', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070341', 'Woolen Halfgloves of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82322', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070342', 'Woolen Halfgloves of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82323', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070343', 'Woolen Halfgloves of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2310', '82324', '7024', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070344', 'Felt Halfgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82327', '7024', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070345', 'Felt Halfgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82328', '7024', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070346', 'Weathered Halfgloves', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81007', '7024', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070347', 'Felt Halfgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82329', '7024', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070348', 'Felt Halfgloves (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82445', '7024', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070349', 'Felt Halfgloves of Dexterity', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82326', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070350', 'Felt Halfgloves of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82328', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070351', 'Felt Halfgloves of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82329', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070352', 'Felt Halfgloves of Dexterity (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82445', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070353', 'Felt Halfgloves of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82326', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070354', 'Felt Halfgloves of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82327', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070355', 'Felt Halfgloves of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82329', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070356', 'Felt Halfgloves of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82445', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070357', 'Felt Halfgloves of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82326', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070358', 'Felt Halfgloves of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82327', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070359', 'Felt Halfgloves of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82328', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070360', 'Felt Halfgloves of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2572', '82445', '7024', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070361', 'Flame Private\'s Halfgloves', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80250', '7024', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070362', 'Flame Sergeant\'s Halfgloves', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81003', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070363', 'Mage\'s Halfgloves', 'Normal/StandardItem', '1', '1', '0', '12510', '2520', '80260', '7024', '2', '0', '0', '0', '1', '47', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070401', 'Weathered Work Gloves', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81041', '7024', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070402', 'Dated Hempen Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '644', '80262', '7024', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070403', 'Dated Hempen Work Gloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '644', '81008', '7024', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070404', 'Dated Hempen Work Gloves (Beige)', 'Normal/StandardItem', '1', '0', '0', '18070', '644', '81009', '7024', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070405', 'Dated Hempen Work Gloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '644', '81010', '7024', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070406', 'Dated Cotton Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '1449', '81016', '7024', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070407', 'Dated Cotton Work Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '1449', '81017', '7024', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070408', 'Dated Cotton Work Gloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '1449', '81018', '7024', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070409', 'Dated Cotton Work Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '1449', '81019', '7024', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070410', 'Dated Cotton Work Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '1449', '81020', '7024', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070411', 'Dated Canvas Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '2254', '81392', '7024', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070412', 'Dated Canvas Work Gloves (Auburn)', 'Normal/StandardItem', '1', '0', '0', '18070', '2254', '81393', '7024', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070413', 'Dated Canvas Work Gloves (Pink)', 'Normal/StandardItem', '1', '0', '0', '18070', '2254', '81394', '7024', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070414', 'Dated Canvas Work Gloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '2254', '81395', '7024', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070415', 'Dated Canvas Work Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2254', '81462', '7024', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070416', 'Hempen Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '563', '80262', '7024', '1', '0', '0', '0', '0', '6', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070417', 'Hempen Work Gloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '563', '81010', '7024', '1', '0', '0', '0', '0', '6', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070418', 'Cotton Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '1771', '81016', '7024', '1', '0', '0', '0', '0', '21', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8070419', 'Cotton Work Gloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '1771', '81018', '7024', '1', '0', '0', '0', '0', '21', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8070420', 'Woolen Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82330', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070421', 'Woolen Work Gloves of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82331', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070422', 'Woolen Work Gloves of Strength (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82332', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070423', 'Woolen Work Gloves of Dexterity (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82333', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070424', 'Felt Work Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82334', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070425', 'Felt Work Gloves of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82335', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070426', 'Felt Work Gloves of Strength (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82336', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070427', 'Felt Work Gloves of Dexterity (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82337', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070428', 'Woolen Work Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82331', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070429', 'Woolen Work Gloves (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82332', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070430', 'Woolen Work Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82333', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070431', 'Woolen Work Gloves of Vitality', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82330', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070432', 'Woolen Work Gloves of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82332', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070433', 'Woolen Work Gloves of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82333', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070434', 'Woolen Work Gloves of Strength', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82330', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070435', 'Woolen Work Gloves of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82331', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070436', 'Woolen Work Gloves of Strength (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82333', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070437', 'Woolen Work Gloves of Dexterity', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82330', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070438', 'Woolen Work Gloves of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82331', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070439', 'Woolen Work Gloves of Dexterity (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '3542', '82332', '7024', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070440', 'Felt Work Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82335', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070441', 'Felt Work Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82336', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070442', 'Felt Work Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82337', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070443', 'Felt Work Gloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82446', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070444', 'Felt Work Gloves of Vitality', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82334', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070445', 'Felt Work Gloves of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82336', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070446', 'Felt Work Gloves of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82337', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070447', 'Felt Work Gloves of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82446', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070448', 'Felt Work Gloves of Strength', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82334', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070449', 'Felt Work Gloves of Strength (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82335', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070450', 'Felt Work Gloves of Strength (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82337', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070451', 'Felt Work Gloves of Strength (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82446', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070452', 'Felt Work Gloves of Dexterity', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82334', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070453', 'Felt Work Gloves of Dexterity (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82335', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070454', 'Felt Work Gloves of Dexterity (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82336', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070455', 'Felt Work Gloves of Dexterity (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '3944', '82446', '7024', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070501', 'Dated Fingerless Sheepskin Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '491', '81064', '7024', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070502', 'Dated Fingerless Dodoskin Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '1037', '81066', '7024', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8070503', 'Dated Fingerless Leather Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1583', '81067', '7024', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8070504', 'Dated Fingerless Leather Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1583', '81068', '7024', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8070505', 'Dated Fingerless Leather Gloves (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '1583', '81069', '7024', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8070506', 'Dated Fingerless Leather Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1583', '81070', '7024', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8070507', 'Dated Fingerless Toadskin Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '81071', '7024', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8070508', 'Dated Fingerless Toadskin Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '81072', '7024', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8070509', 'Dated Fingerless Toadskin Gloves (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '81073', '7024', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8070510', 'Dated Fingerless Toadskin Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2129', '81074', '7024', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8070511', 'Weathered Fingerless Gloves', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81075', '7024', '1', '0', '0', '0', '0', '1', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070512', 'Asuran Armguards', 'Normal/SpecialEquipItem', '1', '1', '1', '13900', '0', '81350', '7024', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070513', 'Brigand\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81537', '7024', '2', '0', '0', '0', '1', '30', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070514', 'Fingerless Leather Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81067', '7024', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070515', 'Fingerless Leather Gloves of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81068', '7024', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070516', 'Fingerless Leather Gloves of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81070', '7024', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070517', 'Fingerless Boarskin Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82353', '7024', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070518', 'Fingerless Boarskin Gloves of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82354', '7024', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070519', 'Fingerless Boarskin Gloves of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82355', '7024', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070520', 'Fingerless Peisteskin Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82356', '7024', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070521', 'Fingerless Peisteskin Gloves of Slaying (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82357', '7024', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070522', 'Fingerless Peisteskin Gloves of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82358', '7024', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070523', 'Fingerless Raptorskin Gloves', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82359', '7024', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070524', 'Fingerless Raptorskin Gloves of Slaying (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82360', '7024', '1', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070525', 'Fingerless Raptorskin Gloves of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82361', '7024', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070526', 'Sipahi Gloves', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81538', '7024', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070527', 'Fingerless Leather Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81068', '7024', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070528', 'Fingerless Leather Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81070', '7024', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070529', 'Fingerless Leather Gloves of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81067', '7024', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070530', 'Fingerless Leather Gloves of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81070', '7024', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070531', 'Fingerless Leather Gloves of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81067', '7024', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070532', 'Fingerless Leather Gloves of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1419', '81068', '7024', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070533', 'Fingerless Boarskin Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82354', '7024', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070534', 'Fingerless Boarskin Gloves (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82355', '7024', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070535', 'Fingerless Boarskin Gloves of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82353', '7024', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070536', 'Fingerless Boarskin Gloves of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82355', '7024', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070537', 'Fingerless Boarskin Gloves of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82353', '7024', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070538', 'Fingerless Boarskin Gloves of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1965', '82354', '7024', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070539', 'Fingerless Peisteskin Gloves (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82357', '7024', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070540', 'Fingerless Peisteskin Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82358', '7024', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070541', 'Fingerless Peisteskin Gloves of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82356', '7024', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070542', 'Fingerless Peisteskin Gloves of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82358', '7024', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070543', 'Fingerless Peisteskin Gloves of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82356', '7024', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070544', 'Fingerless Peisteskin Gloves of Toiling (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2238', '82357', '7024', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070545', 'Fingerless Raptorskin Gloves (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82360', '7024', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070546', 'Fingerless Raptorskin Gloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82361', '7024', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070547', 'Fingerless Raptorskin Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82447', '7024', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070548', 'Fingerless Raptorskin Gloves of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82359', '7024', '1', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070549', 'Fingerless Raptorskin Gloves of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82361', '7024', '1', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070550', 'Fingerless Raptorskin Gloves of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82447', '7024', '1', '0', '0', '0', '1', '45', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070551', 'Fingerless Raptorskin Gloves of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82359', '7024', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070552', 'Fingerless Raptorskin Gloves of Toiling (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82360', '7024', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070553', 'Fingerless Raptorskin Gloves of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2511', '82447', '7024', '1', '0', '0', '0', '1', '45', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070601', 'Dated Bronze Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '1078', '81042', '7023', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070602', 'Dated Reinforced Bronze Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '1771', '81043', '7023', '1', '0', '0', '0', '0', '22', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8070603', 'Dated Iron Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '2618', '81044', '7023', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8070604', 'Dated Reinforced Iron Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '3388', '81496', '7023', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8070605', 'Warden\'s Gauntlets', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81045', '7023', '2', '0', '0', '0', '1', '30', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070606', 'Bronze Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '1001', '81042', '7023', '1', '0', '0', '0', '0', '12', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8070607', 'Decorated Bronze Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '1386', '81043', '7023', '1', '0', '0', '0', '0', '17', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8070608', 'Steel Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '2926', '81497', '7023', '1', '0', '0', '0', '0', '37', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070609', 'Mythril Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '3311', '82347', '7023', '1', '0', '0', '0', '0', '42', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8070610', 'Cobalt Mitt Gauntlets', 'Normal/StandardItem', '1', '0', '0', '16680', '3696', '82348', '7023', '1', '0', '0', '0', '0', '47', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8070701', 'Dated Sheepskin Bracers (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '651', '81046', '7024', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070702', 'Dated Sheepskin Bracers (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '651', '81047', '7024', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070703', 'Dated Sheepskin Bracers (Beige)', 'Normal/StandardItem', '1', '0', '0', '15290', '651', '81048', '7024', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070704', 'Dated Dodoskin Bracers', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '81049', '7024', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070705', 'Dated Dodoskin Bracers (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '81050', '7024', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070706', 'Dated Dodoskin Bracers (Yellow)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '81051', '7024', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070707', 'Dated Dodoskin Bracers (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '81052', '7024', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070708', 'Dated Dodoskin Bracers (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '1302', '81053', '7024', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8070709', 'Dated Leather Bracers', 'Normal/StandardItem', '1', '0', '0', '15290', '1953', '81054', '7024', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070710', 'Dated Leather Bracers (Auburn)', 'Normal/StandardItem', '1', '0', '0', '15290', '1953', '81055', '7024', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070711', 'Dated Leather Bracers (Pink)', 'Normal/StandardItem', '1', '0', '0', '15290', '1953', '81056', '7024', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070712', 'Dated Leather Bracers (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '1953', '81057', '7024', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070713', 'Dated Leather Bracers (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '1953', '81058', '7024', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8070714', 'Dated Bowyer\'s Bracers', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '81059', '7024', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070715', 'Dated Bowyer\'s Bracers (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '81060', '7024', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070716', 'Dated Bowyer\'s Bracers (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '81061', '7024', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070717', 'Dated Bowyer\'s Bracers (Yellow)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '81062', '7024', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070718', 'Dated Bowyer\'s Bracers (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '2604', '81063', '7024', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8070719', 'Venerer\'s Bracers', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82063', '7024', '2', '0', '0', '0', '0', '35', '2133', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070720', 'Woolen Bracers', 'Normal/StandardItem', '1', '0', '0', '15290', '2864', '82349', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070721', 'Woolen Bracers (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2864', '82350', '7024', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8070722', 'Felt Bracers', 'Normal/StandardItem', '1', '0', '0', '15290', '3189', '82351', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070723', 'Felt Bracers (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '3189', '82352', '7024', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8070724', 'Serpent Private\'s Bracers', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81052', '7024', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8070725', 'Serpent Sergeant\'s Bracers', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81057', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070801', 'Dated Sheepskin Mitts (Taupe)', 'Normal/StandardItem', '1', '0', '0', '15290', '644', '81077', '7024', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070802', 'Dated Sheepskin Mitts (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '579', '81078', '7024', '1', '0', '0', '0', '0', '8', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070803', 'Dated Dodoskin Mitts (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '1288', '81079', '7024', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8070804', 'Dated Leather Mitts', 'Normal/StandardItem', '1', '0', '0', '15290', '1932', '81080', '7024', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8070805', 'Dated Toadskin Mitts', 'Normal/StandardItem', '1', '0', '0', '15290', '2576', '81085', '7024', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8070806', 'Mitts of the Lone Knight', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82071', '7024', '3', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070807', 'Sheepskin Mitts', 'Normal/StandardItem', '1', '0', '0', '15290', '579', '81077', '7024', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070808', 'Sheepskin Mitts (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '579', '81078', '7024', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8070809', 'Leather Mitts', 'Normal/StandardItem', '1', '0', '0', '15290', '1223', '81080', '7024', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8070810', 'Leather Mitts (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '1223', '81081', '7024', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8070811', 'Mercenary\'s Mitts', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82144', '7024', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8070812', '[en]', 'Normal/StandardItem', '1', '0', '0', '15290', '128', '60000', '7024', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8070901', 'Dated Sheepskin Armguards', 'Normal/StandardItem', '1', '0', '0', '16680', '1176', '81086', '7023', '1', '0', '0', '0', '0', '15', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8070902', 'Dated Dodoskin Armguards', 'Normal/StandardItem', '1', '0', '0', '16680', '1911', '81087', '7023', '1', '0', '0', '0', '0', '25', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8070903', 'Dated Leather Armguards (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2646', '81088', '7023', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070904', 'Dated Leather Armguards (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '2646', '81089', '7023', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070905', 'Dated Leather Armguards (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '2646', '81090', '7023', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070906', 'Dated Leather Armguards (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '2646', '81091', '7023', '1', '0', '0', '0', '0', '35', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8070907', 'Dated Spiked Leather Armguards (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '3381', '81096', '7023', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070908', 'Dated Spiked Leather Armguards (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '3381', '81097', '7023', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070909', 'Dated Spiked Leather Armguards (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '3381', '81098', '7023', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070910', 'Dated Spiked Leather Armguards (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '3381', '81099', '7023', '1', '0', '0', '0', '0', '45', '1113', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8070911', 'Leather Armguards', 'Normal/StandardItem', '1', '0', '0', '16680', '1543', '81088', '7023', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8070912', 'Leather Armguards (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '1543', '81090', '7023', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8070913', 'Toadskin Armguards', 'Normal/StandardItem', '1', '0', '0', '16680', '2278', '81098', '7023', '1', '0', '0', '0', '0', '30', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070914', 'Toadskin Armguards (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2278', '81096', '7023', '1', '0', '0', '0', '0', '30', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8070915', 'Spiked Armguards', 'Normal/StandardItem', '1', '1', '0', '16680', '3748', '82508', '7023', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071001', 'Dated Sheepskin Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '112', '81100', '7032', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071002', 'Dated Sheepskin Wristguards (Taupe)', 'Normal/StandardItem', '1', '0', '0', '11120', '112', '81101', '7032', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071003', 'Dated Sheepskin Wristguards (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '112', '81102', '7032', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071004', 'Dated Dodoskin Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '392', '81103', '7032', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8071005', 'Dated Dodoskin Wristguards (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '392', '81104', '7032', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8071006', 'Dated Leather Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '672', '81105', '7032', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071007', 'Dated Leather Wristguards (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '672', '81106', '7032', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071008', 'Dated Leather Wristguards (Ochre)', 'Normal/StandardItem', '1', '0', '0', '11120', '672', '81107', '7032', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071009', 'Dated Leather Wristguards (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '672', '81108', '7032', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071010', 'Dated Leather Wristguards (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '672', '81109', '7032', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071011', 'Dated Toadskin Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '952', '81110', '7032', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071012', 'Dated Toadskin Wristguards (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '952', '81111', '7032', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071013', 'Sheepskin Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '56', '81100', '7032', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071014', 'Sheepskin Wristguards (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '56', '81101', '7032', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071015', 'Dodoskin Wristguards', 'Normal/StandardItem', '1', '0', '0', '11120', '336', '81103', '7032', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071016', 'Dodoskin Wristguards (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '336', '81104', '7032', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8071017', 'Storm Private\'s Wristguards', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81102', '7032', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8071018', 'Storm Sergeant\'s Wristguards', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81106', '7032', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071101', 'Dated Canvas Shortgloves', 'Normal/StandardItem', '1', '0', '0', '12500', '1240', '81925', '7024', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071102', 'Dated Canvas Shortgloves (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12500', '1240', '81926', '7024', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071103', 'Dated Canvas Shortgloves (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '1240', '81927', '7024', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071104', 'Dated Canvas Shortgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1240', '81928', '7024', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071105', 'Dated Canvas Shortgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1240', '81929', '7024', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8071106', 'Dated Velveteen Shortgloves', 'Normal/StandardItem', '1', '0', '0', '12500', '1640', '81930', '7024', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071107', 'Dated Velveteen Shortgloves (Black)', 'Normal/StandardItem', '1', '0', '0', '12500', '1640', '81931', '7024', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071108', 'Dated Velveteen Shortgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1640', '81932', '7024', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071109', 'Dated Velveteen Shortgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1640', '81933', '7024', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071110', 'Dated Velveteen Shortgloves (Green)', 'Normal/StandardItem', '1', '0', '0', '12500', '1640', '81934', '7024', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8071111', 'Dated Linen Shortgloves', 'Normal/StandardItem', '1', '0', '0', '12500', '2040', '81930', '7024', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8071112', 'Dated Linen Shortgloves (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '2040', '81927', '7024', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8071113', 'Dated Linen Shortgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2040', '81929', '7024', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8071114', 'Dated Linen Shortgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2040', '81928', '7024', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8071115', 'Dated Linen Shortgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2040', '81926', '7024', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8071116', 'Velveteen Shortgloves', 'Normal/StandardItem', '1', '0', '0', '12500', '1160', '81930', '7024', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8071117', 'Velveteen Shortgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1160', '81932', '7024', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8071118', 'Velveteen Shortgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1160', '81933', '7024', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8071119', 'Linen Shortgloves', 'Normal/StandardItem', '1', '0', '0', '12500', '1560', '81930', '7024', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8071120', 'Linen Shortgloves (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1560', '81929', '7024', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8071121', 'Linen Shortgloves (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1560', '81928', '7024', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8071122', 'Linen Shortgloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1560', '81927', '7024', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8071123', 'Linen Shortgloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1560', '81926', '7024', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8071201', 'Dodoskin Ringbands', 'Normal/StandardItem', '1', '0', '0', '12510', '975', '82338', '7032', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8071202', 'Leather Ringbands', 'Normal/StandardItem', '1', '0', '0', '12510', '1549', '82339', '7032', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8071203', 'Leather Ringbands (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '1549', '82339', '7032', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8071204', 'Boarskin Ringbands', 'Normal/StandardItem', '1', '0', '0', '12510', '2123', '82340', '7032', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8071205', 'Boarskin Ringbands (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2123', '82340', '7032', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8071206', 'Boarskin Ringbands of Flames', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82341', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071207', 'Boarskin Ringbands of Tremors', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82342', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071208', 'Boarskin Ringbands of Tides', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82343', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071209', 'Boarskin Ringbands of Gales', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82344', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071210', 'Boarskin Ringbands of Frost', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82345', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071211', 'Boarskin Ringbands of Storms', 'Normal/StandardItem', '1', '0', '0', '12510', '2697', '82346', '7032', '1', '0', '0', '0', '0', '46', '2005', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8071212', 'Sorcerer\'s Ringbands', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82150', '7032', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071301', 'Lominsan Soldier\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82110', '7024', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8071302', 'Gridanian Soldier\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82111', '7024', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8071303', 'Ul\'dahn Soldier\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82112', '7024', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8071304', 'Lominsan Officer\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82113', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071305', 'Gridanian Officer\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82114', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071306', 'Ul\'dahn Officer\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82115', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071401', 'Gallant Gauntlets', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '82484', '7023', '3', '0', '0', '0', '1', '47', '2120', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071402', 'Temple Gloves', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82489', '7023', '3', '0', '0', '0', '1', '47', '2119', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071403', 'Fighter\'s Gauntlets', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82464', '7023', '3', '0', '0', '0', '1', '47', '2121', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071404', 'Drachen Gauntlets', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82459', '7023', '3', '0', '0', '0', '1', '47', '2123', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071405', 'Choral Ringbands', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82479', '7032', '3', '0', '0', '0', '1', '47', '2122', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071406', 'Healer\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82469', '7032', '3', '0', '0', '0', '1', '47', '2125', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071407', 'Wizard\'s Gloves', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82474', '7024', '3', '0', '0', '0', '1', '47', '2124', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8071501', 'Heavy Darklight Gauntlets', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '82494', '7023', '3', '0', '0', '0', '1', '50', '2126', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071502', 'Darklight Gauntlets', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '82496', '7023', '3', '0', '0', '0', '1', '50', '2127', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071503', 'Darklight Bracers', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82500', '7023', '3', '0', '0', '0', '1', '50', '2128', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071504', 'Darklight Gloves', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82505', '7024', '3', '0', '0', '0', '1', '50', '2129', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071505', 'Heavy Darksteel Gauntlets', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82526', '7023', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071506', 'Heavy Darksteel Gauntlets (White)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82525', '7023', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071507', 'Heavy Darksteel Gauntlets (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82527', '7023', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071508', 'Heavy Darksteel Gauntlets (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82528', '7023', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071509', 'Heavy Darksteel Gauntlets (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '5250', '82529', '7023', '2', '0', '0', '0', '1', '49', '2155', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071510', 'Gryphonskin Gloves', 'Normal/StandardItem', '1', '0', '0', '18070', '4025', '82540', '7023', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071511', 'Gryphonskin Gloves (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4025', '82541', '7023', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071512', 'Gryphonskin Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '4025', '82542', '7023', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071513', 'Gryphonskin Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4025', '82543', '7023', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071514', 'Gryphonskin Gloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4025', '82544', '7023', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071515', 'Vanya Gloves', 'Normal/StandardItem', '1', '0', '0', '12510', '2870', '82557', '7024', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071516', 'Vanya Gloves (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '2870', '82556', '7024', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071517', 'Vanya Gloves (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2870', '82555', '7024', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071518', 'Vanya Gloves (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2870', '82558', '7024', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071519', 'Vanya Gloves (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2870', '82559', '7024', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8071520', 'Storm Sergeant\'s Mitts', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82592', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071521', 'Storm Sergeant\'s Shortgloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82579', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071522', 'Serpent Sergeant\'s Mitts', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82593', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071523', 'Serpent Sergeant\'s Shortgloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82580', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071524', 'Flame Sergeant\'s Mitts', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82591', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071525', 'Flame Sergeant\'s Shortgloves', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82581', '7024', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071526', 'Militia Ringbands', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82597', '7024', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071527', 'Militia Gauntlets', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80245', '7023', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8071528', 'Militia Mitt Gauntlets', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82596', '7023', '2', '0', '0', '0', '1', '50', '2158', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080001', 'Dated Leather Thighboots', 'Normal/StandardItem', '1', '0', '0', '13900', '2008', '80300', '7027', '1', '0', '0', '0', '0', '26', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8080002', 'Dated Tarred Leather Thighboots', 'Normal/StandardItem', '1', '0', '0', '13900', '2752', '80301', '7027', '1', '0', '0', '0', '0', '36', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8080003', 'Dated Leather Thighboots (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '2008', '80302', '7027', '1', '0', '0', '0', '0', '26', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8080004', 'Dated Leather Thighboots (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2008', '80303', '7027', '1', '0', '0', '0', '0', '26', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8080005', 'Dated Leather Thighboots (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2008', '80304', '7027', '1', '0', '0', '0', '0', '26', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8080006', 'Boarskin Thighboots', 'Normal/StandardItem', '1', '0', '0', '13900', '3199', '80292', '7027', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8080007', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '148', '60000', '7027', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080008', 'Boarskin Thighboots (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '3199', '80294', '7027', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8080009', 'Raptorskin Thighboots (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '3571', '80298', '7027', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080010', 'Raptorskin Thighboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '3571', '82450', '7027', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080011', 'Raptorskin Thighboots', 'Normal/StandardItem', '1', '0', '0', '13900', '3571', '80297', '7027', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080012', 'Raptorskin Thighboots (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '3571', '82365', '7027', '1', '0', '0', '0', '0', '47', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080013', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '148', '60000', '7027', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080014', '[en]', 'Normal/StandardItem', '1', '0', '0', '13900', '148', '60000', '7027', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080015', 'Flame Sergeant\'s Thighboots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80301', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080016', 'Weathered Thighboots ', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81120', '7027', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080017', 'Weathered Thighboots (Grey)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81119', '7027', '1', '0', '0', '0', '0', '1', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080018', 'Dated Dodoskin Thighboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1264', '81117', '7027', '1', '0', '0', '0', '0', '16', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8080019', 'Vintage Thighboots', 'Normal/StandardItem', '1', '1', '0', '13900', '3645', '80297', '7027', '1', '0', '0', '0', '0', '48', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080020', 'Mildewed Thighboots', 'Normal/StandardItem', '1', '1', '0', '7500', '1014', '81418', '7027', '1', '0', '0', '0', '0', '38', '1005', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8080101', 'Dated Bronze Sabatons', 'Normal/StandardItem', '1', '0', '0', '20850', '4680', '80305', '7026', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080102', 'Dated Bronze Sabatons (Auburn)', 'Normal/StandardItem', '1', '0', '0', '20850', '4680', '80306', '7026', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080103', 'Dated Bronze Sabatons (Pink)', 'Normal/StandardItem', '1', '0', '0', '20850', '4680', '80307', '7026', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080104', 'Dated Bronze Sabatons (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '4680', '80308', '7026', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080105', 'Dated Bronze Sabatons (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4680', '80309', '7026', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080106', 'Dated Iron Sabatons', 'Normal/StandardItem', '1', '0', '0', '20850', '5880', '80310', '7026', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8080107', 'Dated Iron Sabatons (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '5880', '80313', '7026', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8080108', 'Dated Iron Sabatons (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '5880', '80314', '7026', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8080109', 'Steel Sabatons', 'Normal/StandardItem', '1', '0', '0', '20850', '4800', '80311', '7026', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080110', 'Steel Sabatons (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '4800', '80315', '7026', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080111', 'Cobalt Sabatons (Blue)', 'Normal/StandardItem', '1', '0', '0', '20850', '6000', '82451', '7026', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8080112', 'Sentinel\'s Sabatons', 'Normal/StandardItem', '1', '0', '0', '20850', '6120', '80319', '7026', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080113', 'Cobalt Sabatons', 'Normal/StandardItem', '1', '0', '0', '20850', '6000', '82366', '7026', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8080114', 'Cobalt Sabatons (Red)', 'Normal/StandardItem', '1', '0', '0', '20850', '6000', '82367', '7026', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8080115', 'Plundered Sabatons', 'Normal/StandardItem', '1', '1', '0', '20850', '1920', '80305', '7026', '1', '0', '0', '0', '1', '15', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8080116', 'Explorer\'s Sabatons', 'Normal/StandardItem', '1', '1', '0', '20850', '6120', '80310', '7026', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080117', 'Darksteel Sabatons (White)', 'Normal/StandardItem', '1', '0', '0', '20850', '240', '80317', '7026', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080118', 'Darksteel Sabatons (Gold)', 'Normal/StandardItem', '1', '0', '0', '20850', '240', '80318', '7026', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080119', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '240', '60000', '7026', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080201', 'Dated Sheepskin Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80320', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080202', 'Dated Sheepskin Duckbills (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80321', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080203', 'Dated Sheepskin Duckbills (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80322', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080204', 'Dated Sheepskin Duckbills (Beige)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80323', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080205', 'Dated Padded Sheepskin Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '624', '80324', '7027', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080206', 'Dated Padded Sheepskin Duckbills (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '624', '80325', '7027', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080207', 'Dated Padded Sheepskin Duckbills (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '624', '80326', '7027', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080208', 'Dated Padded Sheepskin Duckbills (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '624', '80327', '7027', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080209', 'Dated Padded Sheepskin Duckbills (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '624', '80328', '7027', '1', '0', '0', '0', '0', '11', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080210', 'Dated Leather Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '1664', '80329', '7027', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080211', 'Dated Leather Duckbills (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '1664', '80330', '7027', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080212', 'Dated Leather Duckbills (Ochre)', 'Normal/StandardItem', '1', '0', '0', '11120', '1664', '80331', '7027', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080213', 'Dated Leather Duckbills (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '1664', '80332', '7027', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080214', 'Dated Leather Duckbills (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1664', '80333', '7027', '1', '0', '0', '0', '0', '31', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080215', 'Dated Padded Leather Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '2184', '81121', '7027', '1', '0', '0', '0', '0', '41', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080216', 'Dated Padded Leather Duckbills (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '2184', '81122', '7027', '1', '0', '0', '0', '0', '41', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080217', 'Dated Padded Leather Duckbills (Ochre)', 'Normal/StandardItem', '1', '0', '0', '11120', '2184', '81123', '7027', '1', '0', '0', '0', '0', '41', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080218', 'Dated Padded Leather Duckbills (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '2184', '81124', '7027', '1', '0', '0', '0', '0', '41', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080219', 'Dated Padded Leather Duckbills (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '2184', '81125', '7027', '1', '0', '0', '0', '0', '41', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080220', 'Sheepskin Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80320', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080221', 'Sheepskin Duckbills of Casting (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80321', '7027', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080222', 'Sheepskin Duckbills of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80323', '7027', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080223', 'Sheepskin Duckbills of Toiling (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80322', '7027', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080224', 'Padded Sheepskin Duckbills', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80324', '7027', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080225', 'Padded Sheepskin Duckbills of Casting (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80326', '7027', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080226', 'Padded Sheepskin Duckbills of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80328', '7027', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080227', 'Padded Sheepskin Duckbills of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80327', '7027', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080228', 'Sheepskin Duckbills (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80321', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080229', 'Sheepskin Duckbills (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80323', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080230', 'Sheepskin Duckbills (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80322', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080231', 'Sheepskin Duckbills of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80320', '7027', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080232', 'Sheepskin Duckbills of Casting (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80323', '7027', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080233', 'Sheepskin Duckbills of Casting (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80322', '7027', '1', '0', '0', '0', '0', '1', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080234', 'Sheepskin Duckbills of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80320', '7027', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080235', 'Sheepskin Duckbills of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '80321', '7027', '1', '0', '0', '0', '0', '1', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080236', 'Padded Sheepskin Duckbills (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80326', '7027', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080237', 'Padded Sheepskin Duckbills (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80328', '7027', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080238', 'Padded Sheepskin Duckbills (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80327', '7027', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080239', 'Padded Sheepskin Duckbills of Casting', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80324', '7027', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080240', 'Padded Sheepskin Duckbills of Casting (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80328', '7027', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080241', 'Padded Sheepskin Duckbills of Casting (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80327', '7027', '1', '0', '0', '0', '1', '21', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080242', 'Padded Sheepskin Duckbills of Toiling', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80324', '7027', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080243', 'Padded Sheepskin Duckbills of Toiling (Yellow)', 'Normal/StandardItem', '1', '0', '0', '11120', '1144', '80326', '7027', '1', '0', '0', '0', '1', '21', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080244', '[en]', 'Normal/StandardItem', '1', '0', '0', '11120', '104', '60000', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8080245', 'Plundered Duckbills', 'Normal/StandardItem', '1', '1', '0', '11120', '832', '80329', '7027', '1', '0', '0', '0', '1', '15', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8080246', 'Weathered Duckbills', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81126', '7027', '1', '0', '0', '0', '0', '1', '1103', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080247', 'Torturer\'s Duckbills', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80332', '7027', '2', '0', '0', '0', '1', '30', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8080301', 'Dated Lauan Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '300', '80334', '7027', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080302', 'Dated Lauan Pattens (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '300', '80335', '7027', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080303', 'Dated Lauan Pattens (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '300', '80336', '7027', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080304', 'Dated Lauan Pattens (Beige)', 'Normal/StandardItem', '1', '0', '0', '12510', '300', '80337', '7027', '1', '0', '0', '0', '0', '4', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080305', 'Dated Maple Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '900', '80338', '7027', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8080306', 'Dated Maple Pattens (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '900', '80339', '7027', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8080307', 'Dated Maple Pattens (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '900', '80340', '7027', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8080308', 'Dated Maple Pattens (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '900', '80341', '7027', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8080309', 'Dated Maple Pattens (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '900', '80342', '7027', '1', '0', '0', '0', '0', '14', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8080310', 'Dated Elm Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '1500', '80343', '7027', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080311', 'Dated Elm Pattens (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12510', '1500', '80344', '7027', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080312', 'Dated Elm Pattens (Pink)', 'Normal/StandardItem', '1', '0', '0', '12510', '1500', '80345', '7027', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080313', 'Dated Elm Pattens (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '1500', '80346', '7027', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080314', 'Dated Elm Pattens (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '1500', '80347', '7027', '1', '0', '0', '0', '0', '24', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8080315', 'Dated Ash Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '2100', '81127', '7027', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8080316', 'Dated Ash Pattens (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2100', '81128', '7027', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8080317', 'Dated Ash Pattens (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2100', '81129', '7027', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8080318', 'Dated Ash Pattens (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '2100', '81130', '7027', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8080319', 'Dated Ash Pattens (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2100', '81131', '7027', '1', '0', '0', '0', '0', '34', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8080320', 'Oak Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82368', '7027', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080321', 'Oak Pattens of the Mind (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82369', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080322', 'Oak Pattens of Vitality (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82370', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080323', 'Oak Pattens of Intelligence (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82371', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080324', 'Mahogany Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82370', '7027', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080325', 'Mahogany Pattens of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82372', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080326', 'Mahogany Pattens of Vitality (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82373', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080327', 'Mahogany Pattens of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82369', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080328', 'Oak Pattens (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82369', '7027', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080329', 'Oak Pattens (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82370', '7027', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080330', 'Oak Pattens (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82371', '7027', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080331', 'Oak Pattens of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82368', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080332', 'Oak Pattens of the Mind (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82370', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080333', 'Oak Pattens of the Mind (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82371', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080334', 'Oak Pattens of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82368', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080335', 'Oak Pattens of Vitality (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82369', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080336', 'Oak Pattens of Vitality (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82371', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080337', 'Oak Pattens of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82368', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080338', 'Oak Pattens of Intelligence (Grey)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82369', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080339', 'Oak Pattens of Intelligence (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '2640', '82370', '7027', '1', '0', '0', '0', '1', '43', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080340', 'Mahogany Pattens (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82372', '7027', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080341', 'Mahogany Pattens (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82373', '7027', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080342', 'Mahogany Pattens (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82369', '7027', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080343', 'Mahogany Pattens (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82452', '7027', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080344', 'Mahogany Pattens of the Mind', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82370', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080345', 'Mahogany Pattens of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82373', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080346', 'Weathered Pattens', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81132', '7027', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080347', 'Weathered Pattens (Grey)', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81133', '7027', '1', '0', '0', '0', '0', '1', '1104', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080348', 'Onion Pattens', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '81355', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080349', 'Warlock\'s Pattens', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '80346', '7027', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080350', 'Mahogany Pattens of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82369', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080351', 'Mahogany Pattens of the Mind (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82452', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080352', 'Mahogany Pattens of Vitality', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82370', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080353', 'Mahogany Pattens of Vitality (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82372', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080354', 'Mahogany Pattens of Vitality (Brown)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82369', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080355', 'Mahogany Pattens of Vitality (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82452', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080356', 'Mahogany Pattens of Intelligence', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82370', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080357', 'Mahogany Pattens of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82372', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080358', 'Mahogany Pattens of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82373', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080359', 'Mahogany Pattens of Intelligence (Green)', 'Normal/StandardItem', '1', '0', '0', '12510', '2940', '82452', '7027', '1', '0', '0', '0', '1', '48', '2006', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080360', 'Mage\'s Pattens', 'Normal/StandardItem', '1', '1', '0', '12510', '2880', '80346', '7027', '2', '0', '0', '0', '1', '47', '2005', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080401', 'Dated Sheepskin Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '736', '81134', '7027', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080402', 'Dated Sheepskin Workboots (Grey)', 'Normal/StandardItem', '1', '0', '0', '18070', '736', '81135', '7027', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080403', 'Dated Sheepskin Workboots (Beige)', 'Normal/StandardItem', '1', '0', '0', '18070', '736', '81136', '7027', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080404', 'Dated Sheepskin Workboots (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '736', '80348', '7027', '1', '0', '0', '0', '0', '7', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080405', 'Dated Dodoskin Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '1656', '81137', '7027', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8080406', 'Dated Dodoskin Workboots (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '1656', '81138', '7027', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8080407', 'Dated Dodoskin Workboots (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '1656', '81139', '7027', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8080408', 'Dated Dodoskin Workboots (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '1656', '81140', '7027', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8080409', 'Dated Dodoskin Workboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '1656', '81141', '7027', '1', '0', '0', '0', '0', '17', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8080410', 'Dated Leather Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '2576', '81142', '7027', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8080411', 'Dated Leather Workboots (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '2576', '81143', '7027', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8080412', 'Dated Leather Workboots (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '2576', '81144', '7027', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8080413', 'Dated Leather Workboots (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '2576', '81145', '7027', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8080414', 'Dated Leather Workboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '2576', '81146', '7027', '1', '0', '0', '0', '0', '27', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8080415', 'Dated Padded Leather Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '3496', '81147', '7027', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8080416', 'Dated Padded Leather Workboots (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '3496', '81148', '7027', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8080417', 'Dated Padded Leather Workboots (Ochre)', 'Normal/StandardItem', '1', '0', '0', '18070', '3496', '81149', '7027', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8080418', 'Dated Padded Leather Workboots (Green)', 'Normal/StandardItem', '1', '0', '0', '18070', '3496', '81150', '7027', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8080419', 'Dated Padded Leather Workboots (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '3496', '81151', '7027', '1', '0', '0', '0', '0', '37', '1105', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8080420', 'Dated Toadskin Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '4416', '81152', '7027', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080421', 'Dated Toadskin Workboots (Auburn)', 'Normal/StandardItem', '1', '0', '0', '18070', '4416', '81153', '7027', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080422', 'Dated Toadskin Workboots (Pink)', 'Normal/StandardItem', '1', '0', '0', '18070', '4416', '81154', '7027', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080423', 'Dated Toadskin Workboots (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4416', '81155', '7027', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080424', 'Dated Toadskin Workboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4416', '81156', '7027', '1', '0', '0', '0', '0', '47', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080425', 'Weathered Workboots (Grey)', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81158', '7027', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080426', 'Weathered Workboots', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81157', '7027', '1', '0', '0', '0', '0', '1', '1105', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080427', 'Boarskin Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82374', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080428', 'Boarskin Workboots of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080429', 'Boarskin Workboots of Intelligence (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82376', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080430', 'Boarskin Workboots of Piety (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080431', 'Raptorskin Workboots', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080432', 'Raptorskin Workboots of the Mind (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080433', 'Raptorskin Workboots of Intelligence (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080434', 'Raptorskin Workboots of Piety (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080435', 'Boarskin Workboots (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080436', 'Boarskin Workboots (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82376', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080437', 'Boarskin Workboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080438', 'Boarskin Workboots of the Mind', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82374', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080439', 'Boarskin Workboots of the Mind (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82376', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080440', 'Boarskin Workboots of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080441', 'Boarskin Workboots of Intelligence', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82374', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080442', 'Boarskin Workboots of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080443', 'Boarskin Workboots of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080444', 'Boarskin Workboots of Piety', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82374', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080445', 'Boarskin Workboots of Piety (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82375', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080446', 'Boarskin Workboots of Piety (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4048', '82376', '7027', '1', '0', '0', '0', '1', '43', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080447', 'Raptorskin Workboots (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080448', 'Raptorskin Workboots (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080449', 'Raptorskin Workboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080450', 'Raptorskin Workboots (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82453', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080451', 'Raptorskin Workboots of the Mind', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080452', 'Raptorskin Workboots of the Mind (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080453', 'Raptorskin Workboots of the Mind (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080454', 'Raptorskin Workboots of the Mind (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82453', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080455', 'Raptorskin Workboots of Intelligence', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080456', 'Raptorskin Workboots of Intelligence (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080457', 'Raptorskin Workboots of Intelligence (Blue)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080458', 'Raptorskin Workboots of Intelligence (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82453', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080459', 'Raptorskin Workboots of Piety', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080460', 'Raptorskin Workboots of Piety (Brown)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82378', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080461', 'Raptorskin Workboots of Piety (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82377', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080462', 'Raptorskin Workboots of Piety (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4508', '82453', '7027', '1', '0', '0', '0', '1', '48', '2007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080501', 'Weathered Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81198', '7027', '1', '0', '0', '0', '0', '1', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080502', 'Dated Sheepskin Crakows', 'Normal/StandardItem', '1', '0', '0', '13900', '561', '80349', '7027', '1', '0', '0', '0', '0', '8', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080503', 'Dated Dodoskin Crakows', 'Normal/StandardItem', '1', '0', '0', '13900', '1185', '81189', '7027', '1', '0', '0', '0', '0', '18', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8080504', 'Dated Leather Crakows (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1809', '81190', '7027', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8080505', 'Dated Leather Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1809', '81191', '7027', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8080506', 'Dated Leather Crakows (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '1809', '81192', '7027', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8080507', 'Dated Leather Crakows (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1809', '81193', '7027', '1', '0', '0', '0', '0', '28', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8080508', 'Dated Toadskin Crakows (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2433', '81194', '7027', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8080509', 'Dated Toadskin Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2433', '81195', '7027', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8080510', 'Dated Toadskin Crakows (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '2433', '81196', '7027', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8080511', 'Dated Toadskin Crakows (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2433', '81197', '7027', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8080512', 'Hermes\' Shoes', 'Normal/EnchantItem', '1', '1', '1', '13900', '0', '81351', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080513', 'Leather Crakows', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81190', '7027', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080514', 'Leather Crakows of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81191', '7027', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080515', 'Leather Crakows of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81193', '7027', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080516', 'Leather Crakows of Invoking (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81192', '7027', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080517', 'Boarskin Crakows', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080518', 'Boarskin Crakows of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080519', 'Boarskin Crakows of Toiling (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080520', 'Boarskin Crakows of Invoking (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080521', 'Peisteskin Crakows', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080522', 'Peisteskin Crakows of Slaying (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82386', '7027', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080523', 'Peisteskin Crakows of Toiling (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080524', 'Peisteskin Crakows of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82387', '7027', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080525', 'Sipahi Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81541', '7027', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080526', 'Leather Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81191', '7027', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080527', 'Leather Crakows (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81193', '7027', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080528', 'Leather Crakows (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81192', '7027', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080529', 'Leather Crakows of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81190', '7027', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080530', 'Leather Crakows of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81193', '7027', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080531', 'Leather Crakows of Slaying (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81192', '7027', '1', '0', '0', '0', '1', '25', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080532', 'Leather Crakows of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81190', '7027', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080533', 'Leather Crakows of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81191', '7027', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080534', 'Leather Crakows of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81192', '7027', '1', '0', '0', '0', '1', '25', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080535', 'Leather Crakows of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81190', '7027', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080536', 'Leather Crakows of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81191', '7027', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080537', 'Leather Crakows of Invoking (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1622', '81193', '7027', '1', '0', '0', '0', '1', '25', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080538', 'Boarskin Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080539', 'Boarskin Crakows (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080540', 'Boarskin Crakows (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080541', 'Boarskin Crakows of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080542', 'Boarskin Crakows of Slaying (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080543', 'Boarskin Crakows of Slaying (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080544', 'Boarskin Crakows of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080545', 'Boarskin Crakows of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080546', 'Boarskin Crakows of Toiling (Brown)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080547', 'Boarskin Crakows of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080548', 'Boarskin Crakows of Invoking (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080549', 'Boarskin Crakows of Invoking (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2246', '82384', '7027', '1', '0', '0', '0', '1', '35', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080550', 'Peisteskin Crakows (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82386', '7027', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080551', 'Peisteskin Crakows (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080552', 'Peisteskin Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82387', '7027', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080553', 'Peisteskin Crakows of Slaying', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080554', 'Peisteskin Crakows of Slaying (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080555', 'Peisteskin Crakows of Slaying (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82387', '7027', '1', '0', '0', '0', '1', '40', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080556', 'Peisteskin Crakows of Toiling', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080557', 'Peisteskin Crakows of Toiling (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82386', '7027', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080558', 'Peisteskin Crakows of Toiling (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82387', '7027', '1', '0', '0', '0', '1', '40', '2003', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080559', 'Peisteskin Crakows of Invoking', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080560', 'Peisteskin Crakows of Invoking (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82386', '7027', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080561', 'Peisteskin Crakows of Invoking (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2558', '82385', '7027', '1', '0', '0', '0', '1', '40', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080562', 'Flame Private\'s Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80349', '7027', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080563', 'Flame Sergeant\'s Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81189', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080564', 'Serpent Sergeant\'s Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81197', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080565', 'Storm Sergeant\'s Crakows', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81195', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080601', 'Weathered Shoes (Taupe)', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81253', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080602', 'Weathered Shoes', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '81254', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080603', 'Dated Sheepskin Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '128', '81242', '7027', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080604', 'Dated Sheepskin Shoes (Taupe)', 'Normal/StandardItem', '1', '0', '0', '11120', '128', '80350', '7027', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080605', 'Dated Sheepskin Shoes (Grey)', 'Normal/StandardItem', '1', '0', '0', '11120', '128', '81243', '7027', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080606', 'Dated Dodoskin Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '448', '81244', '7027', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8080607', 'Dated Dodoskin Shoes (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '448', '81245', '7027', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('8080608', 'Dated Leather Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '768', '81246', '7027', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8080609', 'Dated Leather Shoes (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '768', '81247', '7027', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8080610', 'Dated Leather Shoes (Ochre)', 'Normal/StandardItem', '1', '0', '0', '11120', '768', '81248', '7027', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8080611', 'Dated Leather Shoes (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '768', '81249', '7027', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8080612', 'Dated Leather Shoes (Red)', 'Normal/StandardItem', '1', '0', '0', '11120', '768', '81250', '7027', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8080613', 'Dated Toadskin Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '1088', '81251', '7027', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8080614', 'Dated Toadskin Shoes (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '1088', '81252', '7027', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8080615', 'Sheepskin Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '64', '81242', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080616', 'Sheepskin Shoes (Brown)', 'Normal/StandardItem', '1', '0', '0', '11120', '64', '80350', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080617', 'Dodoskin Shoes', 'Normal/StandardItem', '1', '0', '0', '11120', '384', '81244', '7027', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080618', 'Dodoskin Shoes (Black)', 'Normal/StandardItem', '1', '0', '0', '11120', '384', '81245', '7027', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080701', 'Dated Sheepskin Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '744', '81174', '7027', '1', '0', '0', '0', '0', '9', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080702', 'Dated Dodoskin Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '1488', '81175', '7027', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8080703', 'Dated Leather Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '2232', '81176', '7027', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8080704', 'Dated Toadskin Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '2976', '81182', '7027', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080705', 'Dated Toadskin Moccasins (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2976', '81183', '7027', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080706', 'Dated Toadskin Moccasins (Ochre)', 'Normal/StandardItem', '1', '0', '0', '15290', '2976', '81184', '7027', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080707', 'Dated Toadskin Moccasins (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '2976', '81185', '7027', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080708', 'Dated Toadskin Moccasins (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '2976', '81186', '7027', '1', '0', '0', '0', '0', '39', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8080709', 'Weathered Moccasins', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81187', '7027', '1', '0', '0', '0', '0', '1', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080710', 'Boarskin Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '3273', '82382', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080711', 'Boarskin Moccasins (Black)', 'Normal/StandardItem', '1', '0', '0', '15290', '3273', '82382', '7027', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8080712', 'Hunting Moccasins', 'Normal/StandardItem', '1', '0', '0', '15290', '3645', '82382', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080713', 'Hunting Moccasins (White)', 'Normal/StandardItem', '1', '0', '0', '15290', '3645', '82383', '7027', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8080714', 'Plundered Moccasins', 'Normal/StandardItem', '1', '1', '0', '15290', '1190', '81177', '7027', '1', '0', '0', '0', '1', '15', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8080715', 'Serpent Private\'s Moccasins', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81174', '7027', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8080716', 'Serpent Sergeant\'s Moccasins', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81181', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080717', 'Explorer\'s Moccasins', 'Normal/StandardItem', '1', '1', '0', '15290', '3794', '82513', '7027', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080801', 'Dated Sheepskin Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '345', '81227', '7026', '1', '0', '0', '0', '0', '5', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080802', 'Dated Sheepskin Jackboots (Taupe)', 'Normal/StandardItem', '1', '0', '0', '13900', '345', '81228', '7026', '1', '0', '0', '0', '0', '5', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080803', 'Dated Sheepskin Jackboots (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '345', '81229', '7026', '1', '0', '0', '0', '0', '5', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080804', 'Dated Dodoskin Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '921', '81230', '7026', '1', '0', '0', '0', '0', '15', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8080805', 'Dated Dodoskin Jackboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '921', '81231', '7026', '1', '0', '0', '0', '0', '15', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8080806', 'Dated Leather Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '1497', '81232', '7026', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080807', 'Dated Leather Jackboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1497', '81233', '7026', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080808', 'Dated Leather Jackboots (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '1497', '81234', '7026', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080809', 'Dated Leather Jackboots (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1497', '81235', '7026', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080810', 'Dated Leather Jackboots (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1497', '81236', '7026', '1', '0', '0', '0', '0', '25', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8080811', 'Dated Armored Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '2073', '81237', '7026', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080812', 'Dated Armored Jackboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '2073', '81238', '7026', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080813', 'Dated Armored Jackboots (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '2073', '81239', '7026', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080814', 'Dated Armored Jackboots (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '2073', '81240', '7026', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080815', 'Dated Armored Jackboots (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2073', '81241', '7026', '1', '0', '0', '0', '0', '35', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8080816', 'Weathered Jackboots (Taupe)', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81228', '7026', '1', '0', '0', '0', '0', '1', '1117', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080817', 'Buccaneer\'s Boots', 'Normal/StandardItem', '1', '1', '0', '13900', '2764', '81661', '7026', '2', '0', '0', '0', '0', '47', '1006', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8080818', 'Bladedancer\'s Jackboots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81398', '7026', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8080819', 'Iron-plated Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '1267', '81663', '7026', '1', '0', '0', '0', '0', '21', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080820', 'Iron-plated Jackboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1267', '81664', '7026', '1', '0', '0', '0', '0', '21', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080821', 'Steel-plated Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '1843', '81668', '7026', '1', '0', '0', '0', '0', '31', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8080822', 'Steel-plated Jackboots (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1843', '81669', '7026', '1', '0', '0', '0', '0', '31', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8080823', 'Mythril-plated Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '2419', '82390', '7026', '1', '0', '0', '0', '0', '41', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8080824', 'Mythril-plated Jackboots (White)', 'Normal/StandardItem', '1', '0', '0', '13900', '2419', '82390', '7026', '1', '0', '0', '0', '0', '41', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8080825', 'Cobalt-plated Jackboots', 'Normal/StandardItem', '1', '0', '0', '13900', '2707', '82391', '7026', '1', '0', '0', '0', '0', '46', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8080826', 'Cobalt-plated Jackboots (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2707', '82392', '7026', '1', '0', '0', '0', '0', '46', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8080827', 'Cobalt-plated Jackboots (Blue)', 'Normal/StandardItem', '1', '0', '0', '13900', '2707', '82454', '7026', '1', '0', '0', '0', '0', '46', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8080901', 'Dated Lauan Sandals', 'Normal/StandardItem', '1', '0', '0', '0', '48', '80285', '7028', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080902', 'Dated Lauan Sandals (Grey)', 'Normal/StandardItem', '1', '0', '0', '0', '48', '80286', '7028', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8080903', 'Dated Walnut Sandals (Black)', 'Normal/StandardItem', '1', '0', '0', '0', '528', '80287', '7028', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080904', 'Dated Walnut Sandals', 'Normal/StandardItem', '1', '0', '0', '0', '528', '80288', '7028', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080905', 'Dated Walnut Sandals (Green)', 'Normal/StandardItem', '1', '0', '0', '0', '528', '80289', '7028', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080906', 'Dated Walnut Sandals (Ochre)', 'Normal/StandardItem', '1', '0', '0', '0', '528', '80290', '7028', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8080907', 'Dated Walnut Sandals (Red)', 'Normal/StandardItem', '1', '0', '0', '0', '528', '80291', '7028', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8081001', 'Dated Sheepskin Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '1232', '81159', '7028', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081002', 'Dated Sheepskin Caligae (Taupe)', 'Normal/StandardItem', '1', '0', '0', '16680', '1232', '81160', '7028', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081003', 'Dated Sheepskin Caligae (Grey)', 'Normal/StandardItem', '1', '0', '0', '16680', '1232', '81161', '7028', '1', '0', '0', '0', '0', '13', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081004', 'Dated Dodoskin Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '2112', '81162', '7028', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8081005', 'Dated Dodoskin Caligae (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2112', '81163', '7028', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8081006', 'Dated Leather Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '2992', '81164', '7028', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081007', 'Dated Leather Caligae (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '2992', '81165', '7028', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081008', 'Dated Leather Caligae (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '2992', '81166', '7028', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081009', 'Dated Leather Caligae (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '2992', '81167', '7028', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081010', 'Dated Leather Caligae (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '2992', '81168', '7028', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081011', 'Dated Armored Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '3872', '81169', '7028', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081012', 'Dated Armored Caligae (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '3872', '81170', '7028', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081013', 'Dated Armored Caligae (Ochre)', 'Normal/StandardItem', '1', '0', '0', '16680', '3872', '81171', '7028', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081014', 'Dated Armored Caligae (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '3872', '81172', '7028', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081015', 'Dated Armored Caligae (Red)', 'Normal/StandardItem', '1', '0', '0', '16680', '3872', '81173', '7028', '1', '0', '0', '0', '0', '43', '1107', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081016', 'Dodoskin Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '1144', '81162', '7028', '1', '0', '0', '0', '0', '12', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8081017', 'Dodoskin Caligae (Black)', 'Normal/StandardItem', '1', '0', '0', '16680', '1144', '81163', '7028', '1', '0', '0', '0', '0', '12', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8081018', 'Steel-plated Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '3344', '82379', '7028', '1', '0', '0', '0', '0', '37', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8081019', 'Steel-plated Caligae (Blue)', 'Normal/StandardItem', '1', '0', '0', '16680', '3344', '82379', '7028', '1', '0', '0', '0', '0', '37', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8081020', 'Mythril-plated Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '3784', '82380', '7028', '1', '0', '0', '0', '0', '42', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8081021', 'Mythril-plated Caligae (Brown)', 'Normal/StandardItem', '1', '0', '0', '16680', '3784', '82380', '7028', '1', '0', '0', '0', '0', '42', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8081022', 'Cobalt-plated Caligae', 'Normal/StandardItem', '1', '0', '0', '16680', '4224', '82381', '7028', '1', '0', '0', '0', '0', '47', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8081023', 'Cobalt-plated Caligae (Grey)', 'Normal/StandardItem', '1', '0', '0', '16680', '4224', '82381', '7028', '1', '0', '0', '0', '0', '47', '2004', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8081101', 'Dated Sheepskin Leggings (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '736', '81199', '7027', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081102', 'Dated Sheepskin Leggings (Beige)', 'Normal/StandardItem', '1', '0', '0', '15290', '736', '81200', '7027', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081103', 'Dated Sheepskin Leggings', 'Normal/StandardItem', '1', '0', '0', '15290', '736', '81201', '7027', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081104', 'Dated Sheepskin Leggings (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '736', '81202', '7027', '1', '0', '0', '0', '0', '9', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081105', 'Dated Dodoskin Leggings (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '1472', '81203', '7027', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8081106', 'Dated Dodoskin Leggings (Beige)', 'Normal/StandardItem', '1', '0', '0', '15290', '1472', '81204', '7027', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8081107', 'Dated Dodoskin Leggings (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '1472', '81205', '7027', '1', '0', '0', '0', '0', '19', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8081108', 'Dated Leather Leggings', 'Normal/StandardItem', '1', '0', '0', '15290', '2208', '81206', '7027', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8081109', 'Dated Leather Leggings (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '2208', '81207', '7027', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8081110', 'Dated Leather Leggings (Yellow)', 'Normal/StandardItem', '1', '0', '0', '15290', '2208', '81208', '7027', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8081111', 'Dated Leather Leggings (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '2208', '81209', '7027', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8081112', 'Dated Leather Leggings (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '2208', '81210', '7027', '1', '0', '0', '0', '0', '29', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8081113', 'Dated Toadskin Leggings (Auburn)', 'Normal/StandardItem', '1', '0', '0', '15290', '2944', '81215', '7027', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8081114', 'Dated Toadskin Leggings (Pink)', 'Normal/StandardItem', '1', '0', '0', '15290', '2944', '81216', '7027', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8081115', 'Dated Toadskin Leggings (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '2944', '81217', '7027', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8081116', 'Dated Toadskin Leggings (Blue)', 'Normal/StandardItem', '1', '0', '0', '15290', '2944', '81218', '7027', '1', '0', '0', '0', '0', '39', '1112', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8081117', 'Engineer\'s Leggings', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81585', '7027', '2', '0', '0', '0', '0', '35', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8081118', 'Sheepskin Leggings', 'Normal/StandardItem', '1', '0', '0', '15290', '662', '81199', '7027', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081119', 'Sheepskin Leggings (Grey)', 'Normal/StandardItem', '1', '0', '0', '15290', '662', '81202', '7027', '1', '0', '0', '0', '0', '8', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081120', 'Leather Leggings', 'Normal/StandardItem', '1', '0', '0', '15290', '1398', '81206', '7027', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8081121', 'Leather Leggings (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '1398', '81207', '7027', '1', '0', '0', '0', '0', '18', '2002', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8081122', 'Mercenary\'s Leggings', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82145', '7027', '2', '0', '0', '0', '1', '50', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081123', 'Storm Private\'s Leggings', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81201', '7027', '2', '0', '0', '0', '1', '40', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8081124', 'Storm Sergeant\'s Leggings', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81203', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081201', 'Dated Bronze Sollerets', 'Normal/StandardItem', '1', '0', '0', '19460', '2912', '81219', '7026', '1', '0', '0', '0', '0', '27', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013003', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081202', 'Dated Iron Sollerets', 'Normal/StandardItem', '1', '0', '0', '19460', '3952', '81220', '7026', '1', '0', '0', '0', '0', '37', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8081203', 'Dated Cavalry Sollerets', 'Normal/StandardItem', '1', '0', '0', '19460', '4992', '81221', '7026', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8081204', 'Dated Cavalry Sollerets (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '4992', '81222', '7026', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8081205', 'Dated Cavalry Sollerets (Black)', 'Normal/StandardItem', '1', '0', '0', '19460', '4992', '81223', '7026', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8081206', 'Dated Cavalry Sollerets (Ochre)', 'Normal/StandardItem', '1', '0', '0', '19460', '4992', '81224', '7026', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8081207', 'Dated Cavalry Sollerets (Green)', 'Normal/StandardItem', '1', '0', '0', '19460', '4992', '81225', '7026', '1', '0', '0', '0', '0', '47', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8081208', 'Judge\'s Sollerets', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '81226', '7026', '1', '0', '0', '0', '0', '1', '2033', '0', '0', '0', '0', '0', '-1', '31', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081209', 'Templar\'s Sollerets', 'Normal/StandardItem', '1', '1', '0', '19460', '5200', '82048', '7026', '2', '0', '0', '0', '0', '49', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081210', 'Mythril Sollerets', 'Normal/StandardItem', '1', '0', '0', '19460', '4576', '82388', '7026', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8081211', 'Mythril Sollerets (Black)', 'Normal/StandardItem', '1', '0', '0', '19460', '4576', '82388', '7026', '1', '0', '0', '0', '0', '43', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8081212', 'Cobalt Sollerets', 'Normal/StandardItem', '1', '0', '0', '19460', '5096', '82389', '7026', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8081213', 'Cobalt Sollerets (Red)', 'Normal/StandardItem', '1', '0', '0', '19460', '5096', '82389', '7026', '1', '0', '0', '0', '0', '48', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8081301', 'Dated Sheepskin Espadrilles', 'Normal/StandardItem', '1', '0', '0', '13900', '448', '81803', '7027', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081302', 'Dated Sheepskin Espadrilles (Taupe)', 'Normal/StandardItem', '1', '0', '0', '13900', '448', '81805', '7027', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081303', 'Dated Sheepskin Espadrilles (Grey)', 'Normal/StandardItem', '1', '0', '0', '13900', '448', '81804', '7027', '1', '0', '0', '0', '0', '7', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081304', 'Dated Dodoskin Espadrilles', 'Normal/StandardItem', '1', '0', '0', '13900', '1008', '81806', '7027', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8081305', 'Dated Dodoskin Espadrilles (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1008', '81807', '7027', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('8081306', 'Dated Leather Espadrilles', 'Normal/StandardItem', '1', '0', '0', '13900', '1568', '81816', '7027', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081307', 'Dated Leather Espadrilles (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1568', '81808', '7027', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081308', 'Dated Leather Espadrilles (Ochre)', 'Normal/StandardItem', '1', '0', '0', '13900', '1568', '81809', '7027', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081309', 'Dated Leather Espadrilles (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '1568', '81811', '7027', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081310', 'Dated Leather Espadrilles (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1568', '81810', '7027', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081311', 'Dodoskin Espadrilles', 'Normal/StandardItem', '1', '0', '0', '13900', '1008', '81806', '7027', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8081312', 'Dodoskin Espadrilles (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '1008', '81807', '7027', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8081401', 'Dated Lauan Clogs', 'Normal/StandardItem', '1', '0', '0', '11120', '378', '81883', '7027', '1', '0', '0', '0', '0', '8', '1121', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081402', 'Dated Willow Clogs', 'Normal/StandardItem', '1', '0', '0', '11120', '798', '82039', '7027', '1', '0', '0', '0', '0', '18', '1121', '0', '0', '0', '0', '0', '-1', '29', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('8081403', 'Dated Elm Clogs', 'Normal/StandardItem', '1', '0', '0', '11120', '1218', '82040', '7027', '1', '0', '0', '0', '0', '28', '1121', '0', '0', '0', '0', '0', '-1', '29', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8081404', 'Maple Clogs', 'Normal/StandardItem', '1', '0', '0', '11120', '84', '82039', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081501', 'Dream Boots', 'Normal/StandardItem', '1', '0', '0', '11120', '84', '81891', '7027', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081601', 'Dated Canvas Gaiters', 'Normal/StandardItem', '1', '0', '0', '12500', '1612', '81941', '7027', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081602', 'Dated Canvas Gaiters (Auburn)', 'Normal/StandardItem', '1', '0', '0', '12500', '1612', '81942', '7027', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081603', 'Dated Canvas Gaiters (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '1612', '81943', '7027', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081604', 'Dated Canvas Gaiters (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '1612', '81944', '7027', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081605', 'Dated Canvas Gaiters (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '1612', '81945', '7027', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '14', '0');
INSERT INTO `gamedata_items` VALUES ('8081606', 'Dated Velveteen Gaiters', 'Normal/StandardItem', '1', '0', '0', '12500', '2132', '81946', '7027', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081607', 'Dated Velveteen Gaiters (Black)', 'Normal/StandardItem', '1', '0', '0', '12500', '2132', '81947', '7027', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081608', 'Dated Velveteen Gaiters (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2132', '81948', '7027', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081609', 'Dated Velveteen Gaiters (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2132', '81949', '7027', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081610', 'Dated Velveteen Gaiters (Green)', 'Normal/StandardItem', '1', '0', '0', '12500', '2132', '82055', '7027', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('8081611', 'Dated Linen Gaiters', 'Normal/StandardItem', '1', '0', '0', '12500', '2652', '81946', '7027', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8081612', 'Dated Linen Gaiters (Pink)', 'Normal/StandardItem', '1', '0', '0', '12500', '2652', '81943', '7027', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8081613', 'Dated Linen Gaiters (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2652', '81945', '7027', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8081614', 'Dated Linen Gaiters (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2652', '81944', '7027', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8081615', 'Dated Linen Gaiters (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2652', '81942', '7027', '1', '0', '0', '0', '0', '50', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('8081616', 'Velveteen Gaiters', 'Normal/StandardItem', '1', '0', '0', '12500', '1508', '81946', '7027', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8081617', 'Velveteen Gaiters (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '1508', '81948', '7027', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8081618', 'Velveteen Gaiters (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '1508', '81949', '7027', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8081619', 'Linen Gaiters', 'Normal/StandardItem', '1', '0', '0', '12500', '2028', '81946', '7027', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8081620', 'Linen Gaiters (Blue)', 'Normal/StandardItem', '1', '0', '0', '12500', '2028', '81945', '7027', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8081621', 'Linen Gaiters (Brown)', 'Normal/StandardItem', '1', '0', '0', '12500', '2028', '81944', '7027', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8081622', 'Linen Gaiters (Red)', 'Normal/StandardItem', '1', '0', '0', '12500', '2028', '81943', '7027', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8081623', 'Linen Gaiters (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12500', '2028', '81942', '7027', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8081701', 'Lominsan Soldier\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82119', '7027', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8081702', 'Gridanian Soldier\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82120', '7027', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8081703', 'Ul\'dahn Soldier\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82121', '7027', '2', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8081704', 'Lominsan Officer\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82122', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081705', 'Gridanian Officer\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82123', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081706', 'Ul\'dahn Officer\'s Boots', 'Normal/StandardItem', '1', '1', '1', '12500', '0', '82124', '7027', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081801', 'Gallant Sollerets', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '82485', '7026', '3', '0', '0', '0', '1', '45', '2120', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081802', 'Temple Boots', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82490', '7026', '3', '0', '0', '0', '1', '45', '2119', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081803', 'Fighter\'s Jackboots', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82465', '7026', '3', '0', '0', '0', '1', '45', '2121', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081804', 'Drachen Greaves', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '82460', '7026', '3', '0', '0', '0', '1', '45', '2123', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081805', 'Choral Sandals', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82480', '7027', '3', '0', '0', '0', '1', '45', '2122', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081806', 'Healer\'s Boots', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82470', '7027', '3', '0', '0', '0', '1', '45', '2125', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081807', 'Wizard\'s Crakows', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82475', '7027', '3', '0', '0', '0', '1', '45', '2124', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8081901', 'Darklight Sollerets', 'Normal/StandardItem', '1', '1', '1', '19460', '0', '82497', '7026', '3', '0', '0', '0', '1', '50', '2127', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081902', 'Darklight Caligae', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82501', '7026', '3', '0', '0', '0', '1', '50', '2128', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081903', 'Darklight Boots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '82506', '7026', '3', '0', '0', '0', '1', '50', '2129', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081904', 'Gryphonskin Thighboots', 'Normal/StandardItem', '1', '0', '0', '18070', '4600', '82545', '7026', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081905', 'Gryphonskin Thighboots (White)', 'Normal/StandardItem', '1', '0', '0', '18070', '4600', '82546', '7026', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081906', 'Gryphonskin Thighboots (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '4600', '82547', '7026', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081907', 'Gryphonskin Thighboots (Red)', 'Normal/StandardItem', '1', '0', '0', '18070', '4600', '82548', '7026', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081908', 'Gryphonskin Thighboots (Yellow)', 'Normal/StandardItem', '1', '0', '0', '18070', '4600', '82549', '7026', '2', '0', '0', '0', '1', '49', '2156', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081909', 'Vanya Crakows', 'Normal/StandardItem', '1', '0', '0', '12510', '3280', '82562', '7027', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081910', 'Vanya Crakows (Yellow)', 'Normal/StandardItem', '1', '0', '0', '12510', '3280', '82561', '7027', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081911', 'Vanya Crakows (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '3280', '82560', '7027', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081912', 'Vanya Crakows (Purple)', 'Normal/StandardItem', '1', '0', '0', '12510', '3280', '82563', '7027', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081913', 'Vanya Crakows (Red)', 'Normal/StandardItem', '1', '0', '0', '12510', '3280', '82564', '7027', '2', '0', '0', '0', '1', '49', '2157', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8081914', 'Storm Sergeant\'s Jackboots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81667', '7026', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081915', 'Serpent Sergeant\'s Jackboots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81665', '7026', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081916', 'Flame Sergeant\'s Jackboots', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81664', '7026', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081917', 'Militia Duckbills', 'Normal/StandardItem', '1', '1', '1', '12510', '0', '82595', '7027', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081918', 'Militia Sabatons', 'Normal/StandardItem', '1', '1', '1', '20850', '0', '80317', '7026', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081919', 'Militia Caligae', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '82594', '7026', '2', '0', '0', '0', '1', '50', '2158', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081920', 'Spruce Pattens', 'Normal/StandardItem', '1', '0', '0', '12510', '2760', '82603', '7027', '1', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '29', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8081921', 'Lord\'s Clogs', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82634', '7028', '1', '0', '0', '0', '0', '1', '2031', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8081922', 'Lady\'s Clogs', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '82633', '7028', '1', '0', '0', '0', '0', '1', '2032', '0', '0', '0', '0', '0', '-1', '29', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090001', 'Dated Leather Tool Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '790', '80351', '7030', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8090002', 'Dated Leather Tool Belt (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '790', '81255', '7030', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8090003', 'Dated Leather Tool Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '13900', '790', '81256', '7030', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8090004', 'Dated Boarskin Tool Belt (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '2185', '81400', '7030', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8090005', 'Dated Boarskin Tool Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '2185', '81978', '7030', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8090006', 'Explorer\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '2371', '81979', '7030', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090007', 'Weathered Tool Belt', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '80351', '7030', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090008', 'Boarskin Tool Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '1999', '81978', '7030', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8090009', 'Boarskin Tool Belt (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1999', '81400', '7030', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8090101', 'Dated Bronze Plate Belt', 'Normal/StandardItem', '1', '0', '0', '20850', '2925', '80357', '7030', '1', '0', '0', '0', '0', '38', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8090102', 'Dated Iron Plate Belt', 'Normal/StandardItem', '1', '0', '0', '20850', '3675', '80358', '7030', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8090103', 'Dated Iron Plate Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '20850', '3675', '80359', '7030', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8090104', 'Dated Iron Plate Belt (Brown)', 'Normal/StandardItem', '1', '0', '0', '20850', '3675', '80360', '7030', '1', '0', '0', '0', '0', '48', '1102', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '30', '0');
INSERT INTO `gamedata_items` VALUES ('8090105', 'Steel Plate Belt', 'Normal/StandardItem', '1', '0', '0', '20850', '3000', '80352', '7030', '1', '0', '0', '0', '0', '39', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('8090106', 'Sentinel\'s Plate Belt', 'Normal/StandardItem', '1', '0', '0', '20850', '3825', '81984', '7030', '2', '0', '0', '0', '1', '50', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090107', 'Cobalt Plate Belt', 'Normal/StandardItem', '1', '0', '0', '20850', '3750', '81980', '7030', '1', '0', '0', '0', '0', '49', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8090108', 'Plundered Plate Belt', 'Normal/StandardItem', '1', '1', '0', '20850', '1200', '80357', '7030', '1', '0', '0', '0', '1', '15', '2101', '0', '0', '0', '0', '0', '-1', '31', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8090109', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '150', '60000', '7030', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8090110', '[en]', 'Normal/StandardItem', '1', '0', '0', '20850', '150', '60000', '7030', '1', '0', '0', '0', '0', '1', '1102', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8090201', 'Dated Leather Satchel Belt', 'Normal/StandardItem', '1', '0', '0', '11120', '715', '80353', '7030', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8090202', 'Dated Tarred Leather Satchel Belt', 'Normal/StandardItem', '1', '0', '0', '11120', '1040', '80361', '7030', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8090203', 'Dated Leather Satchel Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '11120', '715', '80362', '7030', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8090204', 'Boarskin Satchel Belt', 'Normal/StandardItem', '1', '0', '0', '11120', '1170', '81986', '7030', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8090205', 'Boarskin Satchel Belt (Blue)', 'Normal/StandardItem', '1', '0', '0', '11120', '1170', '81987', '7030', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8090206', 'Raptorskin Satchel Belt', 'Normal/StandardItem', '1', '0', '0', '11120', '1495', '81988', '7030', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8090207', 'Warlock\'s Satchel Belt', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80361', '7030', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090208', 'Weathered Satchel Belt', 'Normal/StandardItem', '1', '1', '1', '11120', '0', '80353', '7030', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090301', 'Dated Leather Survival Belt', 'Normal/StandardItem', '1', '0', '0', '18070', '1035', '81257', '7030', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8090302', 'Dated Tarred Leather Survival Belt', 'Normal/StandardItem', '1', '0', '0', '18070', '1610', '81258', '7030', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8090303', 'Dated Leather Survival Belt (Black)', 'Normal/StandardItem', '1', '0', '0', '18070', '1035', '81259', '7030', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8090304', 'Dated Safari Belt', 'Normal/StandardItem', '1', '0', '0', '18070', '2185', '82030', '7030', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('8090305', 'Boarskin Survival Belt', 'Normal/StandardItem', '1', '0', '0', '18070', '2530', '82030', '7030', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8090306', 'Raptorskin Survival Belt', 'Normal/StandardItem', '1', '0', '0', '18070', '2817', '81993', '7030', '1', '0', '0', '0', '0', '48', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('8090307', 'Weathered Survival Belt', 'Normal/StandardItem', '1', '1', '1', '18070', '0', '81257', '7030', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090401', 'Dated Rope Belt', 'Normal/StandardItem', '1', '0', '0', '12510', '287', '80354', '7031', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090402', 'Rope Belt', 'Normal/StandardItem', '1', '0', '0', '12510', '697', '80354', '7031', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8090403', 'Dated Velveteen Rope Belt', 'Normal/StandardItem', '1', '0', '0', '12510', '1517', '81260', '7031', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8090404', 'Dated Velveteen Rope Belt (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1517', '81261', '7031', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8090405', 'Velveteen Rope Belt', 'Normal/StandardItem', '1', '0', '0', '12510', '1107', '81260', '7031', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8090406', 'Velveteen Rope Belt (Black)', 'Normal/StandardItem', '1', '0', '0', '12510', '1107', '81261', '7031', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('8090407', 'Plundered Rope Belt', 'Normal/StandardItem', '1', '1', '0', '12510', '656', '80363', '7031', '1', '0', '0', '0', '1', '15', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8090408', 'Mage\'s Rope Belt', 'Normal/StandardItem', '1', '1', '0', '12510', '1968', '81997', '7031', '2', '0', '0', '0', '1', '47', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8090501', 'Dated Leather Hunting Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1320', '81262', '7030', '1', '0', '0', '0', '0', '23', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('8090502', 'Dated Tarred Leather Hunting Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1870', '81263', '7030', '1', '0', '0', '0', '0', '33', '1107', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('8090503', 'Dodoskin Hunting Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '715', '81262', '7030', '1', '0', '0', '0', '0', '12', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('8090504', 'Toadskin Hunting Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1540', '81264', '7030', '1', '0', '0', '0', '0', '27', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8090505', 'Peisteskin Hunting Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '2365', '81998', '7030', '1', '0', '0', '0', '0', '42', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8090506', 'Serpent Sergeant\'s Belt', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81263', '7030', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090507', 'Harlequin\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '2448', '82052', '7030', '2', '0', '0', '0', '0', '50', '1007', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090601', 'Dated Leather Belt (Red)', 'Normal/StandardItem', '1', '0', '0', '15290', '930', '81265', '7030', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8090602', 'Dated Leather Belt (Ochre)', 'Normal/StandardItem', '1', '0', '0', '15290', '930', '81266', '7030', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8090603', 'Dated Leather Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '15290', '930', '81267', '7030', '1', '0', '0', '0', '0', '19', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('8090604', 'Dated Tarred Leather Belt', 'Normal/StandardItem', '1', '0', '0', '15290', '1395', '81268', '7030', '1', '0', '0', '0', '0', '29', '1108', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('8090605', 'Boarskin Belt', 'Normal/StandardItem', '1', '0', '0', '15290', '2046', '82001', '7030', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8090606', 'Boarskin Belt (Brown)', 'Normal/StandardItem', '1', '0', '0', '15290', '2046', '82002', '7030', '1', '0', '0', '0', '0', '43', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('8090607', 'Penance', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '82003', '7030', '2', '0', '0', '0', '0', '35', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8090608', 'Plundered Leather Belt', 'Normal/StandardItem', '1', '1', '0', '15290', '744', '81266', '7030', '1', '0', '0', '0', '1', '15', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8090609', 'Storm Sergeant\'s Belt', 'Normal/StandardItem', '1', '1', '1', '15290', '0', '81268', '7030', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090701', 'Dated Tarred Velveteen Longsash', 'Normal/StandardItem', '1', '0', '0', '13900', '1911', '81269', '7031', '1', '0', '0', '0', '0', '48', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8090702', 'Dated Velveteen Longsash (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1521', '81270', '7031', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8090703', 'Dated Velveteen Longsash (Yellow)', 'Normal/StandardItem', '1', '0', '0', '13900', '1521', '81271', '7031', '1', '0', '0', '0', '0', '38', '1109', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8090704', 'Tarred Velveteen Longsash', 'Normal/StandardItem', '1', '0', '0', '13900', '1014', '81269', '7031', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8090705', 'Velveteen Longsash (Red)', 'Normal/StandardItem', '1', '0', '0', '13900', '1014', '81270', '7031', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8090706', 'Lominsan Sash', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81270', '7031', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8090707', 'Gridanian Sash', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81271', '7031', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8090708', 'Ul\'dahn Sash', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81269', '7031', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('8090709', 'Flame Sergeant\'s Sash', 'Normal/StandardItem', '1', '1', '1', '13900', '0', '81270', '7031', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8090801', 'Dated Brass Tassets', 'Normal/StandardItem', '1', '0', '0', '16680', '1320', '80364', '7030', '1', '0', '0', '0', '0', '32', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('8090802', 'Dated Iron Tassets', 'Normal/StandardItem', '1', '0', '0', '16680', '1720', '80365', '7030', '1', '0', '0', '0', '0', '42', '1110', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('8090803', 'Kobold Iron Tassets', 'Normal/StandardItem', '1', '0', '0', '16680', '80', '60000', '7030', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8090804', 'Steel Tassets', 'Normal/StandardItem', '1', '0', '0', '16680', '1320', '80355', '7030', '1', '0', '0', '0', '0', '32', '2103', '0', '0', '0', '0', '0', '-1', '31', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('8090805', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '80', '60000', '7030', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8090806', '[en]', 'Normal/StandardItem', '1', '0', '0', '16680', '80', '60000', '7030', '1', '0', '0', '0', '0', '1', '1110', '0', '0', '0', '0', '0', '-1', '31', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('8090807', 'Templar\'s Tassets', 'Normal/StandardItem', '1', '1', '0', '19460', '3250', '82011', '7030', '2', '0', '0', '0', '0', '49', '1114', '0', '0', '0', '0', '0', '-1', '31', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('8090901', 'Dated Dodoskin Field Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1365', '81272', '7030', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8090902', 'Voyager\'s Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1102', '81274', '7030', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8090903', 'Voyager\'s Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '1102', '81275', '7030', '1', '0', '0', '0', '0', '20', '2104', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('8090904', 'Dated Tarred Voyager\'s Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '2415', '81273', '7030', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('8090905', 'Dated Voyager\'s Belt', 'Normal/StandardItem', '1', '0', '0', '16680', '1890', '81274', '7030', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8090906', 'Dated Voyager\'s Belt (Green)', 'Normal/StandardItem', '1', '0', '0', '16680', '1890', '81275', '7030', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('8090907', 'Weathered Field Belt', 'Normal/StandardItem', '1', '1', '1', '16680', '0', '81272', '7030', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8090908', 'Veteran\'s Field Belt', 'Normal/StandardItem', '1', '1', '0', '16680', '2520', '81273', '7030', '2', '0', '0', '0', '1', '47', '2004', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8091001', 'Buccaneer\'s Sash', 'Normal/StandardItem', '1', '1', '0', '15290', '2208', '82054', '7031', '2', '0', '0', '0', '0', '47', '1006', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('8091002', 'Dated Tarred Canvas Sash', 'Normal/StandardItem', '1', '0', '0', '11120', '742', '80366', '7031', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('8091003', 'Dated Canvas Sash (Auburn)', 'Normal/StandardItem', '1', '0', '0', '11120', '517', '80367', '7031', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8091004', 'Scarlet Sash', 'Normal/StandardItem', '1', '1', '0', '11120', '1057', '80369', '7031', '2', '0', '0', '0', '1', '46', '2002', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8091005', 'Vanya Sash', 'Normal/StandardItem', '1', '0', '0', '11120', '1035', '82604', '7031', '1', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '34', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8091101', 'Vintage Shepherd\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '1505', '82017', '7030', '1', '0', '0', '0', '0', '42', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('8091102', 'Cracked Shepherd\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '805', '82018', '7030', '1', '0', '0', '0', '0', '22', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('8091103', 'Dated Sheepskin Shepherd\'s Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '630', '82017', '7030', '1', '0', '0', '0', '0', '17', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('8091104', 'Dated Dodoskin Shepherd\'s Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '980', '82015', '7030', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8091105', 'Dated Leather Shepherd\'s Belt (Black)', 'Normal/StandardItem', '1', '0', '0', '13900', '980', '82016', '7030', '1', '0', '0', '0', '0', '27', '1119', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('8091106', 'Dodoskin Shepherd\'s Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '630', '82015', '7030', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8091107', 'Militia Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '1785', '82016', '7030', '2', '0', '0', '0', '1', '50', '2005', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('8091201', 'Vintage Chef\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '1295', '82038', '7030', '1', '0', '0', '0', '0', '36', '1120', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('8091202', 'Frayed Chef\'s Belt', 'Normal/StandardItem', '1', '1', '0', '13900', '595', '82037', '7030', '1', '0', '0', '0', '0', '16', '1120', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('8091203', 'Dated Leather Chef\'s Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '1190', '82036', '7030', '1', '0', '0', '0', '0', '33', '1120', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8091204', 'Raptorskin Artisan\'s Belt', 'Normal/StandardItem', '1', '0', '0', '13900', '1645', '82393', '7030', '1', '0', '0', '0', '1', '46', '2144', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('8091301', 'Dated Canvas Half Apron', 'Normal/StandardItem', '1', '0', '0', '12500', '992', '81977', '7030', '1', '0', '0', '0', '0', '30', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8091302', 'Dated Velveteen Half Apron (Black)', 'Normal/StandardItem', '1', '0', '0', '12500', '1312', '82023', '7030', '1', '0', '0', '0', '0', '40', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '11', '0');
INSERT INTO `gamedata_items` VALUES ('8091303', 'Vintage Half Apron', 'Normal/StandardItem', '1', '1', '0', '12500', '832', '82025', '7030', '1', '0', '0', '0', '0', '25', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('8091304', 'Greasy Half Apron', 'Normal/StandardItem', '1', '1', '0', '7500', '256', '82024', '7030', '1', '0', '0', '0', '0', '15', '1005', '0', '0', '0', '0', '0', '-1', '34', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('8091305', 'Velveteen Half Apron', 'Normal/StandardItem', '1', '0', '0', '12500', '928', '82023', '7030', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('8091306', 'Linen Half Apron', 'Normal/StandardItem', '1', '0', '0', '12500', '1248', '82394', '7030', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '34', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('8091401', 'Merchant\'s Purse', 'Normal/StandardItem', '1', '0', '0', '12500', '64', '81976', '7030', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9010001', 'Dated Copper Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '660', '61106', '8006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9010002', 'Dated Brass Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '1260', '61107', '8006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '2', '0');
INSERT INTO `gamedata_items` VALUES ('9010003', 'Dated Silver Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '1860', '61108', '8006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '12', '0');
INSERT INTO `gamedata_items` VALUES ('9010004', 'Dated Darksilver Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '2160', '61116', '8006', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('9010005', 'Dated Electrum Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '2460', '61109', '8006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('9010006', 'Dated Mythril Wristlets', 'Normal/StandardItem', '1', '0', '0', '8280', '3060', '61110', '8006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '32', '0');
INSERT INTO `gamedata_items` VALUES ('9010007', 'Dated Bone Armillae', 'Normal/StandardItem', '1', '0', '0', '6210', '840', '61151', '8006', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('9010008', 'Dated Sunstone Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61117', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010009', 'Dated Lapis Lazuli Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61118', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010010', 'Dated Sphene Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61120', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010011', 'Dated Malachite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61119', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010012', 'Dated Fluorite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61122', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010013', 'Dated Danburite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2244', '61121', '8006', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9010014', 'Dated Pearl Bracelets', 'Normal/StandardItem', '1', '0', '0', '6210', '1960', '61123', '8006', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '24', '0');
INSERT INTO `gamedata_items` VALUES ('9010015', 'Dated Black Pearl Bracelets', 'Normal/StandardItem', '1', '0', '0', '6210', '2240', '61124', '8006', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('9010016', 'Dated White Coral Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '1998', '61157', '8006', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010017', 'Dated White Coral Wristbands (Black)', 'Normal/StandardItem', '1', '0', '0', '7590', '1998', '61160', '8006', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010018', 'Dated White Coral Wristbands (Yellow)', 'Normal/StandardItem', '1', '0', '0', '7590', '1998', '61163', '8006', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010019', 'Dated Blue Coral Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '2268', '61156', '8006', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010020', 'Dated Blue Coral Wristbands (Black)', 'Normal/StandardItem', '1', '0', '0', '7590', '2268', '61159', '8006', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010021', 'Dated Blue Coral Wristbands (Yellow)', 'Normal/StandardItem', '1', '0', '0', '7590', '2268', '61162', '8006', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010022', 'Dated Red Coral Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '2538', '61155', '8006', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010023', 'Dated Red Coral Wristbands (Black)', 'Normal/StandardItem', '1', '0', '0', '7590', '2538', '61158', '8006', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010024', 'Dated Red Coral Wristbands (Yellow)', 'Normal/StandardItem', '1', '0', '0', '7590', '2538', '61161', '8006', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010025', 'Patriot\'s Bracelet', 'Normal/StandardItem', '1', '1', '1', '7590', '0', '61157', '8006', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('9010026', 'Copper Wristlets', 'Normal/StandardItem', '1', '0', '0', '7590', '560', '61106', '8006', '1', '0', '0', '0', '1', '6', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9010027', 'Brass Wristlets', 'Normal/StandardItem', '1', '0', '0', '7590', '1360', '61107', '8006', '1', '0', '0', '0', '1', '16', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('9010028', 'Silver Wristlets', 'Normal/StandardItem', '1', '0', '0', '7590', '2160', '61108', '8006', '1', '0', '0', '0', '1', '26', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('9010029', 'Mythril Wristlets', 'Normal/StandardItem', '1', '0', '0', '7590', '2960', '61110', '8006', '1', '0', '0', '0', '1', '36', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9010030', 'Electrum Wristlets', 'Normal/StandardItem', '1', '0', '0', '7590', '3760', '61109', '8006', '1', '0', '0', '0', '1', '46', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('9010031', 'Sunstone Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61117', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010032', 'Lapis Lazuli Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61118', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010033', 'Sphene Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61120', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010034', 'Malachite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61119', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010035', 'Fluorite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61122', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010036', 'Danburite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '2494', '61121', '8006', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9010037', 'Garnet Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61133', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010038', 'Aquamarine Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61134', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010039', 'Heliodor Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61136', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010040', 'Peridot Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61135', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010041', 'Amethyst Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61138', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010042', 'Goshenite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61137', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010043', 'Pearl Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '3354', '61145', '8006', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9010044', 'Rubellite Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61139', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010045', 'Turquoise Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61140', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010046', 'Amber Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61142', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010047', 'Tourmaline Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61141', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010048', 'Spinel Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61144', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010049', 'Zircon Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61143', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010050', 'Black Pearl Bracelets', 'Normal/StandardItem', '1', '0', '0', '6900', '4214', '61150', '8006', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9010051', 'Bone Armillae', 'Normal/StandardItem', '1', '0', '0', '6900', '1170', '61151', '8006', '1', '0', '0', '0', '1', '14', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '4', '0');
INSERT INTO `gamedata_items` VALUES ('9010052', 'Horn Armillae', 'Normal/StandardItem', '1', '0', '0', '6900', '2340', '61152', '8006', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9010053', 'Coral Armillae', 'Normal/StandardItem', '1', '0', '0', '6900', '3510', '61153', '8006', '1', '0', '0', '0', '1', '44', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('9010054', 'Sheepskin Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '624', '61163', '8006', '1', '0', '0', '0', '1', '7', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9010055', 'Dodoskin Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '1404', '61157', '8006', '1', '0', '0', '0', '1', '17', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('9010056', 'Leather Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '2184', '61160', '8006', '1', '0', '0', '0', '1', '27', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('9010057', 'Boarskin Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '2964', '61156', '8006', '1', '0', '0', '0', '1', '37', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9010058', 'Raptorskin Wristbands', 'Normal/StandardItem', '1', '0', '0', '7590', '3744', '61161', '8006', '1', '0', '0', '0', '1', '47', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('9010059', 'Militia Bracelets', 'Normal/StandardItem', '1', '1', '0', '6900', '3978', '61152', '8006', '2', '0', '0', '0', '1', '50', '2007', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9010060', 'Militia Wristlets', 'Normal/StandardItem', '1', '1', '0', '7590', '4080', '61112', '8006', '2', '0', '0', '0', '1', '50', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9010061', 'Storm Sergeant\'s Bracelets', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61133', '8006', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9010062', 'Serpent Sergeant\'s Bracelets', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61135', '8006', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9010063', 'Flame Sergeant\'s Bracelets', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61146', '8006', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9010064', 'Imperial Operative Wristlets', 'Normal/StandardItem', '1', '1', '1', '7590', '0', '61111', '8006', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030001', 'Dated Fang Earrings', 'Normal/StandardItem', '1', '0', '0', '6210', '780', '61019', '8003', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9030002', 'Dated Copper Earrings', 'Normal/StandardItem', '1', '0', '0', '8280', '558', '60974', '8003', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9030003', 'Dated Brass Earrings', 'Normal/StandardItem', '1', '0', '0', '8280', '1178', '60975', '8003', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('9030004', 'Dated Silver Earrings', 'Normal/StandardItem', '1', '0', '0', '8280', '1798', '60976', '8003', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9030005', 'Dated Electrum Earrings', 'Normal/StandardItem', '1', '0', '0', '8280', '2418', '60977', '8003', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9030006', 'Dated Sunstone Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60985', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030007', 'Dated Lapis Lazuli Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60986', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030008', 'Dated Sphene Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60988', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030009', 'Dated Malachite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60987', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030010', 'Dated Fluorite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60990', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030011', 'Dated Danburite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2176', '60989', '8003', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9030012', 'Dated Pearl Earrings', 'Normal/StandardItem', '1', '0', '0', '6210', '1980', '60991', '8003', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('9030013', 'Dated Black Pearl Earrings', 'Normal/StandardItem', '1', '0', '0', '6210', '2280', '60992', '8003', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9030014', 'Dated Garnet Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61007', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030015', 'Dated Aquamarine Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61008', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030016', 'Dated Heliodor Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61010', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030017', 'Dated Peridot Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61009', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030018', 'Dated Amethyst Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61012', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030019', 'Dated Goshenite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2856', '61011', '8003', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9030020', 'Moonlet', 'Normal/StandardItem', '1', '1', '1', '6210', '0', '61617', '8003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9030021', 'Copper Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '624', '60974', '8003', '1', '0', '0', '0', '1', '7', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9030022', 'Brass Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '1404', '60975', '8003', '1', '0', '0', '0', '1', '17', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('9030023', 'Silver Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '2184', '60976', '8003', '1', '0', '0', '0', '1', '27', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('9030024', 'Mythril Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '2964', '60978', '8003', '1', '0', '0', '0', '1', '37', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9030025', 'Electrum Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '3744', '60977', '8003', '1', '0', '0', '0', '1', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('9030026', 'Sunstone Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60985', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030027', 'Lapis Lazuli Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60986', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030028', 'Sphene Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60988', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030029', 'Malachite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60987', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030030', 'Fluorite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60990', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030031', 'Danburite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2520', '60989', '8003', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9030032', 'Garnet Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61001', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030033', 'Aquamarine Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61002', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030034', 'Heliodor Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61004', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030035', 'Peridot Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61003', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030036', 'Amethyst Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61006', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030037', 'Goshenite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61005', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030038', 'Pearl Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3360', '61013', '8003', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9030039', 'Rubellite Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61007', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030040', 'Turquoise Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61008', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030041', 'Amber Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61010', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030042', 'Tourmaline Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61009', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030043', 'Spinel Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61012', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030044', 'Zircon Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61011', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030045', 'Black Pearl Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '4200', '61016', '8003', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030046', 'Fang Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '1216', '61019', '8003', '1', '0', '0', '0', '1', '15', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('9030047', 'Horn Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '1976', '61020', '8003', '1', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('9030048', 'Wolf Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '2736', '61019', '8003', '1', '0', '0', '0', '1', '35', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('9030049', 'Coral Earrings', 'Normal/StandardItem', '1', '0', '0', '6900', '3496', '61021', '8003', '1', '0', '0', '0', '1', '45', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9030050', 'Crimson Standard Earring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61690', '8003', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030051', 'Tipping Scales Earring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61691', '8003', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030052', 'Lily and Serpent Earring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61692', '8003', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030053', 'Peach Blossom', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61693', '8003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9030054', 'Explorer\'s Earrings', 'Normal/StandardItem', '1', '1', '0', '7590', '3978', '60984', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030055', 'Mage\'s Earrings', 'Normal/StandardItem', '1', '1', '0', '6900', '4284', '61018', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030056', 'Stonewall Earrings', 'Normal/StandardItem', '1', '1', '0', '7590', '3876', '61022', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030057', 'Blessed Earrings', 'Normal/StandardItem', '1', '1', '0', '6900', '4284', '61017', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030058', 'Rose Gold Earrings', 'Normal/StandardItem', '1', '0', '0', '7590', '3900', '61724', '8003', '2', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9030059', 'Militia Earrings', 'Normal/StandardItem', '1', '1', '0', '7590', '3978', '60980', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030060', 'Storm Sergeant\'s Earrings', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61001', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030061', 'Serpent Sergeant\'s Earrings', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61003', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030062', 'Flame Sergeant\'s Earrings', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61014', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030063', 'White Ravens', 'Normal/StandardItem', '1', '1', '1', '7590', '0', '61740', '8003', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9030064', 'Manderville Earring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61739', '8003', '1', '0', '0', '0', '1', '20', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '10', '0');
INSERT INTO `gamedata_items` VALUES ('9030065', '[en]', 'Normal/StandardItem', '1', '0', '0', '6900', '120', '60000', '8003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '0', '1', '0', '0');
INSERT INTO `gamedata_items` VALUES ('9040001', 'Dated Copper Choker', 'Normal/StandardItem', '1', '0', '0', '8280', '680', '61032', '8002', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040002', 'Dated Brass Choker', 'Normal/StandardItem', '1', '0', '0', '8280', '1360', '61033', '8002', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '3', '0');
INSERT INTO `gamedata_items` VALUES ('9040003', 'Dated Silver Choker', 'Normal/StandardItem', '1', '0', '0', '8280', '2040', '61034', '8002', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '13', '0');
INSERT INTO `gamedata_items` VALUES ('9040004', 'Dated Electrum Choker', 'Normal/StandardItem', '1', '0', '0', '8280', '2720', '61035', '8002', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '23', '0');
INSERT INTO `gamedata_items` VALUES ('9040005', 'Dated Mythril Choker', 'Normal/StandardItem', '1', '0', '0', '8280', '3400', '61036', '8002', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('9040006', 'Dated Sunstone Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61043', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040007', 'Dated Lapis Lazuli Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61044', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040008', 'Dated Sphene Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61046', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040009', 'Dated Malachite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61045', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040010', 'Dated Fluorite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61048', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040011', 'Dated Danburite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2442', '61047', '8002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040012', 'Dated Garnet Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61065', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040013', 'Dated Aquamarine Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61066', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040014', 'Dated Heliodor Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61068', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040015', 'Dated Peridot Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61067', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040016', 'Dated Amethyst Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61070', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040017', 'Dated Goshenite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3182', '61069', '8002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040018', 'Patriot\'s Choker', 'Normal/StandardItem', '1', '1', '1', '8280', '0', '61097', '8002', '2', '0', '0', '0', '1', '30', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '20', '0');
INSERT INTO `gamedata_items` VALUES ('9040019', 'Paramour\'s Pendant', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61677', '8002', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040020', 'Platinum Paramour\'s Pendant', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61678', '8002', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040021', 'Band of Eternal Passion', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61679', '8002', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040022', 'Copper Gorget', 'Normal/StandardItem', '1', '0', '0', '7590', '476', '61032', '8002', '1', '0', '0', '0', '1', '6', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040023', 'Brass Gorget', 'Normal/StandardItem', '1', '0', '0', '7590', '1156', '61033', '8002', '1', '0', '0', '0', '1', '16', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '6', '0');
INSERT INTO `gamedata_items` VALUES ('9040024', 'Silver Gorget', 'Normal/StandardItem', '1', '0', '0', '7590', '1836', '61034', '8002', '1', '0', '0', '0', '1', '26', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '16', '0');
INSERT INTO `gamedata_items` VALUES ('9040025', 'Mythril Gorget', 'Normal/StandardItem', '1', '0', '0', '7590', '2516', '61036', '8002', '1', '0', '0', '0', '1', '36', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '26', '0');
INSERT INTO `gamedata_items` VALUES ('9040026', 'Electrum Gorget', 'Normal/StandardItem', '1', '0', '0', '7590', '3196', '61035', '8002', '1', '0', '0', '0', '1', '46', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '36', '0');
INSERT INTO `gamedata_items` VALUES ('9040027', 'Copper Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '680', '61032', '8002', '1', '0', '0', '0', '1', '9', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040028', 'Brass Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '1360', '61033', '8002', '1', '0', '0', '0', '1', '19', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '9', '0');
INSERT INTO `gamedata_items` VALUES ('9040029', 'Silver Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2040', '61034', '8002', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9040030', 'Mythril Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2720', '61036', '8002', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9040031', 'Electrum Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3400', '61035', '8002', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9040032', 'Sunstone Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61043', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040033', 'Lapis Lazuli Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61044', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040034', 'Sphene Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61046', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040035', 'Malachite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61045', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040036', 'Fluorite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61048', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040037', 'Danburite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2146', '61047', '8002', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9040038', 'Garnet Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61059', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040039', 'Aquamarine Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61060', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040040', 'Heliodor Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61062', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040041', 'Peridot Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61061', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040042', 'Amethyst Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61064', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040043', 'Goshenite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61063', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040044', 'Pearl Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2886', '61071', '8002', '1', '0', '0', '0', '1', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9040045', 'Rubellite Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61065', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040046', 'Turquoise Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61066', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040047', 'Amber Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61068', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040048', 'Tourmaline Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61067', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040049', 'Spinel Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61070', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040050', 'Zircon Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '3626', '61069', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040051', 'Black Pearl Choker', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '61074', '8002', '1', '0', '0', '0', '1', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '38', '0');
INSERT INTO `gamedata_items` VALUES ('9040052', 'Fang Necklace', 'Normal/StandardItem', '1', '0', '0', '6900', '1080', '61077', '8002', '1', '0', '0', '0', '1', '17', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('9040053', 'Horn Necklace', 'Normal/StandardItem', '1', '0', '0', '6900', '1680', '61078', '8002', '1', '0', '0', '0', '1', '27', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('9040054', 'Wolf Necklace', 'Normal/StandardItem', '1', '0', '0', '6900', '2280', '61077', '8002', '1', '0', '0', '0', '1', '37', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9040055', 'Coral Necklace', 'Normal/StandardItem', '1', '0', '0', '6900', '2880', '61080', '8002', '1', '0', '0', '0', '1', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('9040056', 'Sheepskin Choker', 'Normal/StandardItem', '1', '0', '0', '7590', '360', '61103', '8002', '1', '0', '0', '0', '1', '5', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9040057', 'Dodoskin Choker', 'Normal/StandardItem', '1', '0', '0', '7590', '960', '61097', '8002', '1', '0', '0', '0', '1', '15', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013002', '1', '5', '0');
INSERT INTO `gamedata_items` VALUES ('9040058', 'Leather Choker', 'Normal/StandardItem', '1', '0', '0', '7590', '1560', '61100', '8002', '1', '0', '0', '0', '1', '25', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013003', '1', '15', '0');
INSERT INTO `gamedata_items` VALUES ('9040059', 'Boarskin Choker', 'Normal/StandardItem', '1', '0', '0', '7590', '2160', '61097', '8002', '1', '0', '0', '0', '1', '35', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013004', '1', '25', '0');
INSERT INTO `gamedata_items` VALUES ('9040060', 'Raptorskin Choker', 'Normal/StandardItem', '1', '0', '0', '7590', '2760', '61103', '8002', '1', '0', '0', '0', '1', '45', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9040061', 'Explorer\'s Choker', 'Normal/StandardItem', '1', '1', '0', '7590', '3468', '61042', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040062', 'Mage\'s Choker', 'Normal/StandardItem', '1', '1', '0', '6900', '3060', '61039', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040063', 'Stonewall Choker', 'Normal/StandardItem', '1', '1', '0', '7590', '3060', '61081', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040064', 'Militia Choker', 'Normal/StandardItem', '1', '1', '0', '7590', '3060', '61103', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '33', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040065', 'Storm Sergeant\'s Choker', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61059', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040066', 'Serpent Sergeant\'s Choker', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61061', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040067', 'Flame Sergeant\'s Choker', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61072', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9040068', 'Imperial Operative Choker', 'Normal/StandardItem', '1', '1', '1', '7590', '0', '61037', '8002', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050001', 'Dated Bone Ring', 'Normal/StandardItem', '1', '0', '0', '6210', '180', '60960', '8009', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050002', 'Dated Copper Ring', 'Normal/StandardItem', '1', '0', '0', '8280', '576', '60915', '8009', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050003', 'Dated Brass Ring', 'Normal/StandardItem', '1', '0', '0', '8280', '1216', '60916', '8009', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '8', '0');
INSERT INTO `gamedata_items` VALUES ('9050004', 'Dated Silver Ring', 'Normal/StandardItem', '1', '0', '0', '8280', '1856', '60917', '8009', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9050005', 'Dated Darksilver Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '2340', '60925', '8009', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '28', '0');
INSERT INTO `gamedata_items` VALUES ('9050006', 'Dated Electrum Ring', 'Normal/StandardItem', '1', '0', '0', '8280', '3136', '60918', '8009', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '34', '0');
INSERT INTO `gamedata_items` VALUES ('9050007', 'Dated Sunstone Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60926', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050008', 'Dated Lapis Lazuli Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60927', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050009', 'Dated Sphene Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60929', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050010', 'Dated Malachite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60928', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050011', 'Dated Fluorite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60931', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050012', 'Dated Danburite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2240', '60930', '8009', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '21', '0');
INSERT INTO `gamedata_items` VALUES ('9050013', 'Dated Pearl Ring', 'Normal/StandardItem', '1', '0', '0', '6210', '1980', '60932', '8009', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '22', '0');
INSERT INTO `gamedata_items` VALUES ('9050014', 'Dated Black Pearl Ring', 'Normal/StandardItem', '1', '0', '0', '6210', '2280', '60933', '8009', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9050015', 'Dated Garnet Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60948', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050016', 'Dated Aquamarine Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60949', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050017', 'Dated Heliodor Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60951', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050018', 'Dated Peridot Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60950', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050019', 'Dated Amethyst Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60953', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050020', 'Dated Goshenite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2940', '60952', '8009', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '31', '0');
INSERT INTO `gamedata_items` VALUES ('9050021', 'Stormbringer\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60948', '8009', '2', '0', '0', '0', '1', '45', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050022', 'Stormcarrier\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60949', '8009', '2', '0', '0', '0', '1', '45', '2007', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050023', 'Flamebringer\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60953', '8009', '2', '0', '0', '0', '1', '45', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050024', 'Flamecarrier\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60951', '8009', '2', '0', '0', '0', '1', '45', '2007', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050025', 'Serpentbringer\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60952', '8009', '2', '0', '0', '0', '1', '45', '2006', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050026', 'Serpentcarrier\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60950', '8009', '2', '0', '0', '0', '1', '45', '2007', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '35', '0');
INSERT INTO `gamedata_items` VALUES ('9050027', 'Copper Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '512', '60915', '8009', '1', '0', '0', '0', '1', '7', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050028', 'Brass Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '1152', '60916', '8009', '1', '0', '0', '0', '1', '17', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013002', '1', '7', '0');
INSERT INTO `gamedata_items` VALUES ('9050029', 'Silver Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '1792', '60917', '8009', '1', '0', '0', '0', '1', '27', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '17', '0');
INSERT INTO `gamedata_items` VALUES ('9050030', 'Mythril Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '2432', '60919', '8009', '1', '0', '0', '0', '1', '37', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '27', '0');
INSERT INTO `gamedata_items` VALUES ('9050031', 'Electrum Ring', 'Normal/StandardItem', '1', '0', '0', '7590', '3072', '60918', '8009', '1', '0', '0', '0', '1', '47', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '37', '0');
INSERT INTO `gamedata_items` VALUES ('9050032', 'Sunstone Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60926', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050033', 'Lapis Lazuli Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60927', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050034', 'Sphene Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60929', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050035', 'Malachite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60928', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050036', 'Fluorite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60931', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050037', 'Danburite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2100', '60930', '8009', '1', '0', '0', '0', '1', '29', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '19', '0');
INSERT INTO `gamedata_items` VALUES ('9050038', 'Garnet Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60942', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050039', 'Aquamarine Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60943', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050040', 'Heliodor Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60945', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050041', 'Peridot Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60944', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050042', 'Amethyst Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60947', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050043', 'Goshenite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60946', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050044', 'Pearl Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2800', '60954', '8009', '1', '0', '0', '0', '1', '39', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013004', '1', '29', '0');
INSERT INTO `gamedata_items` VALUES ('9050045', 'Rubellite Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60948', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050046', 'Turquoise Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60949', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050047', 'Amber Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60951', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050048', 'Tourmaline Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60950', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050049', 'Spinel Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60953', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050050', 'Zircon Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60952', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050051', 'Black Pearl Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '3500', '60957', '8009', '1', '0', '0', '0', '1', '49', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '39', '0');
INSERT INTO `gamedata_items` VALUES ('9050052', 'Bone Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '240', '60960', '8009', '1', '0', '0', '0', '1', '3', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050053', 'Horn Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '1740', '60961', '8009', '1', '0', '0', '0', '1', '28', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013003', '1', '18', '0');
INSERT INTO `gamedata_items` VALUES ('9050054', 'Coral Ring', 'Normal/StandardItem', '1', '0', '0', '6900', '2640', '60963', '8009', '1', '0', '0', '0', '1', '43', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '33', '0');
INSERT INTO `gamedata_items` VALUES ('9050055', 'Crimson Standard Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61687', '8009', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050056', 'Tipping Scales Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61688', '8009', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050057', 'Lily and Serpent Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61689', '8009', '3', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050058', 'Pristine Egg Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61694', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050059', 'Midnight Egg Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61695', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050060', 'Brilliant Egg Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61696', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050061', 'Vibrant Egg Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61697', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050062', 'Chocobo Egg Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61698', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050063', 'Explorer\'s Ring', 'Normal/StandardItem', '1', '1', '0', '7590', '3264', '60925', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050064', 'Mage\'s Ring', 'Normal/StandardItem', '1', '1', '0', '6900', '3570', '60959', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050065', 'Stonewall Ring', 'Normal/StandardItem', '1', '1', '0', '7590', '3060', '60964', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050066', 'Blessed Ring', 'Normal/StandardItem', '1', '1', '0', '6900', '3570', '60958', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050067', 'Storm Sergeant\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60942', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050068', 'Serpent Sergeant\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60944', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050069', 'Flame Sergeant\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '60955', '8009', '2', '0', '0', '0', '1', '50', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013005', '1', '40', '0');
INSERT INTO `gamedata_items` VALUES ('9050070', 'Byregot\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61735', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050071', 'Rhalgr\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61737', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050072', 'Llymlaen\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61738', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050073', 'Azeyma\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61727', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050074', 'Althyk\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61728', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050075', 'Menphina\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61736', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050076', 'Nophica\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61733', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050077', 'Nald\'thal\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61731', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050078', 'Nymeia\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61732', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050079', 'Oschon\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61729', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050080', 'Thaliak\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61730', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('9050081', 'Halone\'s Ring', 'Normal/StandardItem', '1', '1', '1', '6900', '0', '61734', '8009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '32', '10013001', '1', '1', '0');
INSERT INTO `gamedata_items` VALUES ('10001001', 'Tin Ore', 'Normal/StandardItem', '99', '0', '0', '0', '24', '60082', '4002', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001002', 'Pyrite', 'Normal/StandardItem', '99', '0', '0', '0', '130', '60087', '4002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001003', 'Limonite', 'Normal/StandardItem', '99', '0', '0', '0', '170', '60085', '4002', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001004', 'Iron Ore', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60081', '4002', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001005', 'Darksteel Ore', 'Normal/StandardItem', '99', '0', '0', '0', '460', '60084', '4002', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001006', 'Copper Ore', 'Normal/StandardItem', '99', '0', '0', '0', '12', '60136', '4002', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001007', 'Yellow Copper Ore', 'Normal/StandardItem', '99', '0', '0', '0', '110', '60087', '4002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001008', 'Zinc Ore', 'Normal/StandardItem', '99', '0', '0', '0', '51', '60137', '4002', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001009', 'Silver Ore', 'Normal/StandardItem', '99', '0', '0', '0', '63', '60138', '4002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001010', 'Mythril Ore', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60135', '4002', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001011', 'Gold Ore', 'Normal/StandardItem', '99', '0', '0', '0', '510', '60139', '4002', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001012', 'Platinum Ore', 'Normal/StandardItem', '99', '0', '0', '0', '610', '60141', '4002', '1', '0', '0', '0', '0', '60', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001013', 'Cobalt Ore', 'Normal/StandardItem', '99', '0', '0', '0', '126', '61661', '4002', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001014', 'Electrum Ore', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61662', '4002', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001101', 'Flint Stone', 'Normal/StandardItem', '99', '0', '0', '0', '60', '60143', '4004', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001102', 'Obsidian', 'Normal/StandardItem', '99', '0', '0', '0', '39', '60144', '4004', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001103', 'Wyvern Obsidian', 'Normal/StandardItem', '99', '0', '0', '0', '93', '61553', '4004', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001104', 'Dragon Obsidian', 'Normal/StandardItem', '99', '0', '0', '0', '380', '61554', '4004', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001105', 'Wyrm Obsidian', 'Normal/StandardItem', '99', '0', '0', '0', '410', '61555', '4004', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001106', 'Red Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60165', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001107', 'Blue Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60166', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001108', 'Yellow Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60167', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001109', 'Green Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60168', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001110', 'Indigo Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60169', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001111', 'Violet Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60170', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001112', 'Black Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60171', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001113', 'White Quartz', 'Normal/StandardItem', '99', '0', '0', '0', '100', '60172', '4004', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001114', 'Limestone', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60477', '4004', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001115', 'Mudstone', 'Normal/StandardItem', '99', '0', '0', '0', '66', '60163', '4004', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001116', 'Ragstone', 'Normal/StandardItem', '99', '0', '0', '0', '33', '60162', '4004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001117', 'Siltstone', 'Normal/StandardItem', '99', '0', '0', '0', '75', '60161', '4004', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001118', 'Mudstone Whetstone', 'Normal/StandardItem', '99', '0', '0', '0', '60', '61564', '4004', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001119', 'Ragstone Whetstone', 'Normal/StandardItem', '99', '0', '0', '0', '39', '61564', '4004', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001120', 'Siltstone Whetstone', 'Normal/StandardItem', '99', '0', '0', '0', '81', '61564', '4004', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001201', 'Red O\'Ghomoro Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60165', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001202', 'Brown O\'Ghomoro Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60076', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001203', 'Yellow O\'Ghomoro Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60167', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001204', 'Grey O\'Ghomoro Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60169', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001205', 'Black O\'Ghomoro Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60171', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001206', 'Purple Sagolii Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60170', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001207', 'Brown Sagolii Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60076', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001208', 'Yellow Sagolii Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60167', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001209', 'Grey Sagolii Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60169', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001210', 'Black Sagolii Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60171', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001211', 'Green Tinolqa Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60168', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001212', 'Brown Tinolqa Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60076', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001213', 'Yellow Tinolqa Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60167', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001214', 'Grey Tinolqa Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60169', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001215', 'Black Tinolqa Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60171', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001216', 'Red Abalathia Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60165', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001217', 'Brown Abalathia Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60076', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001218', 'Blue Abalathia Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60166', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001219', 'Grey Abalathia Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60169', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001220', 'White Abalathia Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60172', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001221', 'Red Mor Dhona Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60165', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001222', 'Black Mor Dhona Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60171', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001223', 'Yellow Mor Dhona Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60167', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001224', 'Grey Mor Dhona Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60169', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001225', 'White Mor Dhona Slag', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60172', '4002', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001226', 'Iron Sand', 'Normal/StandardItem', '99', '0', '0', '0', '160', '60083', '4002', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001227', 'Silver Sand', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60083', '4002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001228', 'Gold Sand', 'Normal/StandardItem', '99', '0', '0', '0', '410', '61404', '4002', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001229', 'Basilisk Egg', 'Normal/StandardItem', '99', '0', '0', '0', '108', '61427', '4002', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10001230', 'Basilisk Whetstone', 'Normal/StandardItem', '99', '0', '0', '0', '117', '61564', '4002', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002001', 'Bronze Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '26', '60053', '4020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002002', 'Iron Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '50', '60051', '4020', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002003', 'Tin Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60053', '4020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002004', 'Steel Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '86', '60052', '4020', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002005', 'Darksteel Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '122', '60054', '4020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002011', 'Bronze Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '110', '60048', '4020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002012', 'Iron Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60046', '4020', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002013', 'Steel Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '310', '60047', '4020', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002014', 'Tin Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '320', '60048', '4020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002015', 'Cobalt Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '460', '60047', '4020', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002016', 'Darksteel Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '510', '60049', '4020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002021', 'Bronze Plate', 'Normal/StandardItem', '99', '0', '0', '0', '242', '60062', '4021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002022', 'Iron Plate', 'Normal/StandardItem', '99', '0', '0', '0', '462', '60060', '4021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002023', 'Steel Plate', 'Normal/StandardItem', '99', '0', '0', '0', '682', '60061', '4021', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002024', 'Cobalt Plate', 'Normal/StandardItem', '99', '0', '0', '0', '1012', '60061', '4021', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002025', 'Darksteel Plate', 'Normal/StandardItem', '99', '0', '0', '0', '1122', '60063', '4021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002031', 'Bronze Square', 'Normal/StandardItem', '99', '0', '0', '0', '13', '61409', '4021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002032', 'Iron Square', 'Normal/StandardItem', '99', '0', '0', '0', '25', '61414', '4021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002033', 'Tin Square', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61409', '4021', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002034', 'Steel Square', 'Normal/StandardItem', '99', '0', '0', '0', '37', '61429', '4021', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002041', 'Bronze Wire', 'Normal/StandardItem', '99', '0', '0', '0', '44', '60058', '4022', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002042', 'Iron Wire', 'Normal/StandardItem', '99', '0', '0', '0', '84', '60056', '4022', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002051', 'Bronze Rings', 'Normal/StandardItem', '99', '0', '0', '0', '88', '61387', '4022', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002052', 'Iron Rings', 'Normal/StandardItem', '99', '0', '0', '0', '168', '61385', '4022', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002053', 'Steel Rings', 'Normal/StandardItem', '99', '0', '0', '0', '248', '61386', '4022', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002054', 'Cobalt Rings', 'Normal/StandardItem', '99', '0', '0', '0', '368', '61386', '4022', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002061', 'Bronze Chain', 'Normal/StandardItem', '99', '0', '0', '0', '132', '60071', '4022', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002062', 'Iron Chain', 'Normal/StandardItem', '99', '0', '0', '0', '252', '60069', '4022', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002071', 'Bronze Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '44', '61346', '4003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002072', 'Iron Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '84', '61346', '4003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002073', 'Steel Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '124', '61346', '4003', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002074', 'Cobalt Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '184', '61346', '4003', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002075', 'Darksteel Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '4003', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002081', 'Bronze Nails', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61545', '4003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002082', 'Iron Nails', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61356', '4003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002083', 'Steel Nails', 'Normal/StandardItem', '99', '0', '0', '0', '27', '61547', '4003', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002091', 'Bronze Scales', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61346', '4021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002092', 'Iron Scales', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61346', '4021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002093', 'Steel Scales', 'Normal/StandardItem', '99', '0', '0', '0', '27', '61346', '4021', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002101', 'Bronze Spikes', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61545', '4003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10002102', 'Iron Spikes', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61356', '4003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003001', 'Copper Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '14', '60102', '4020', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003002', 'Brass Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60104', '4020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003003', 'Silver Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '62', '60098', '4020', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003004', 'Electrum Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '110', '60101', '4020', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003005', 'Mythril Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '98', '60099', '4020', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003006', 'Gold Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '158', '60097', '4020', '1', '0', '0', '0', '0', '65', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003007', 'Rose Gold Nugget', 'Normal/StandardItem', '99', '0', '0', '0', '122', '60103', '4020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003011', 'Copper Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '60', '60093', '4020', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003012', 'Brass Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '160', '60095', '4020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003013', 'Silver Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '260', '60089', '4020', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003014', 'Electrum Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '460', '60092', '4020', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003015', 'Mythril Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '410', '60090', '4020', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003016', 'Rose Gold Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '510', '60094', '4020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003017', 'Gold Ingot', 'Normal/StandardItem', '99', '0', '0', '0', '1320', '60088', '4020', '1', '0', '0', '0', '0', '65', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003021', 'Copper Plate', 'Normal/StandardItem', '99', '0', '0', '0', '132', '60117', '4021', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003022', 'Brass Plate', 'Normal/StandardItem', '99', '0', '0', '0', '352', '60118', '4021', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003023', 'Silver Plate', 'Normal/StandardItem', '99', '0', '0', '0', '572', '60115', '4021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003024', 'Electrum Plate', 'Normal/StandardItem', '99', '0', '0', '0', '792', '60119', '4021', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003025', 'Mythril Plate', 'Normal/StandardItem', '99', '0', '0', '0', '902', '60116', '4021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003031', 'Copper Square', 'Normal/StandardItem', '99', '0', '0', '0', '7', '61416', '4021', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003032', 'Brass Square', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61417', '4021', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003033', 'Silver Square', 'Normal/StandardItem', '99', '0', '0', '0', '31', '61418', '4021', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003034', 'Darksilver Square', 'Normal/StandardItem', '99', '0', '0', '0', '34', '61419', '4021', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003035', 'Electrum Square', 'Normal/StandardItem', '99', '0', '0', '0', '55', '61493', '4021', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003036', 'Mythril Square', 'Normal/StandardItem', '99', '0', '0', '0', '49', '61420', '4021', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003041', 'Copper Wire', 'Normal/StandardItem', '99', '0', '0', '0', '24', '60108', '4022', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003042', 'Brass Wire', 'Normal/StandardItem', '99', '0', '0', '0', '64', '60109', '4022', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003043', 'Silver Wire', 'Normal/StandardItem', '99', '0', '0', '0', '104', '60106', '4022', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003044', 'Electrum Wire', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60110', '4022', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003045', 'Mythril Wire', 'Normal/StandardItem', '99', '0', '0', '0', '184', '60107', '4022', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003051', 'Copper Rings', 'Normal/StandardItem', '99', '0', '0', '0', '48', '61387', '4022', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003052', 'Brass Rings', 'Normal/StandardItem', '99', '0', '0', '0', '128', '61551', '4022', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003053', 'Silver Rings', 'Normal/StandardItem', '99', '0', '0', '0', '208', '61386', '4022', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003054', 'Electrum Rings', 'Normal/StandardItem', '99', '0', '0', '0', '368', '61552', '4022', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003055', 'Mythril Rings', 'Normal/StandardItem', '99', '0', '0', '0', '328', '61389', '4022', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003071', 'Copper Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '4', '61346', '4003', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003072', 'Brass Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61346', '4003', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003073', 'Silver Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61346', '4003', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003074', 'Mythril Rivets', 'Normal/StandardItem', '99', '0', '0', '0', '164', '61346', '4003', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003081', 'Copper Nails', 'Normal/StandardItem', '99', '0', '0', '0', '4', '61548', '4003', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003082', 'Brass Nails', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61549', '4003', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003083', 'Silver Nails', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61550', '4003', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003091', 'Brass Scales', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61346', '4021', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003101', 'Copper Dust', 'Normal/StandardItem', '99', '0', '0', '0', '60', '61453', '4003', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003102', 'Gold Dust', 'Normal/StandardItem', '99', '0', '0', '0', '660', '61404', '4003', '1', '0', '0', '0', '0', '65', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003103', 'Silver Dust', 'Normal/StandardItem', '99', '0', '0', '0', '360', '60448', '4003', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10003104', 'Silver Leaf', 'Normal/StandardItem', '99', '0', '0', '0', '23', '61383', '4003', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004001', 'Raw Sunstone', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004002', 'Raw Lapis Lazuli', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004003', 'Raw Sphene', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004004', 'Raw Malachite', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004005', 'Raw Fluorite', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004006', 'Raw Danburite', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60161', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004007', 'Raw Garnet', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004008', 'Raw Aquamarine', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004009', 'Raw Heliodor', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004010', 'Raw Peridot', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004011', 'Raw Amethyst', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004012', 'Raw Goshenite', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60161', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004013', 'Raw Rubellite', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004014', 'Raw Turquoise', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004015', 'Raw Amber', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004016', 'Raw Tourmaline', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004017', 'Raw Spinel', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004018', 'Raw Zircon', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60161', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004019', 'Raw Ruby', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004020', 'Raw Sapphire', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004021', 'Raw Topaz', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004022', 'Raw Emerald', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004023', 'Raw Iolite', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004024', 'Raw Diamond', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60161', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004025', 'Uncultured Pearl', 'Normal/StandardItem', '99', '0', '0', '0', '450', '60192', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004026', 'Jade', 'Normal/StandardItem', '99', '0', '0', '0', '570', '60145', '1017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004027', 'Fire Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004028', 'Lightning Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004029', 'Wind Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004030', 'Water Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004031', 'Ice Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004032', 'Earth Rock', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60143', '1017', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004101', 'Sunstone', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60185', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004102', 'Lapis Lazuli', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60181', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004103', 'Sphene', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60184', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004104', 'Malachite', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60190', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004105', 'Fluorite', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60187', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004106', 'Danburite', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60192', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004107', 'Garnet', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60182', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004108', 'Aquamarine', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60196', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004109', 'Heliodor', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60188', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004110', 'Peridot', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60173', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004111', 'Amethyst', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60193', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004112', 'Goshenite', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '60183', '1017', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004113', 'Rubellite', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60189', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004114', 'Turquoise', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60176', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004115', 'Amber', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60175', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004116', 'Tourmaline', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60198', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004117', 'Spinel', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60186', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004118', 'Zircon', 'Normal/StandardItem', '99', '0', '0', '0', '1500', '60180', '1017', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004119', 'Ruby', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60174', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004120', 'Sapphire', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60194', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004121', 'Topaz', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60197', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004122', 'Emerald', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60195', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004123', 'Iolite', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60191', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004124', 'Diamond', 'Normal/StandardItem', '99', '0', '0', '0', '2400', '60177', '1017', '1', '0', '0', '0', '0', '64', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004125', 'Pearl', 'Normal/StandardItem', '99', '0', '0', '0', '1020', '60178', '1017', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004126', 'Black Pearl', 'Normal/StandardItem', '99', '0', '0', '0', '1110', '60179', '1017', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004127', 'Nephrite', 'Normal/StandardItem', '99', '0', '0', '0', '420', '61317', '1017', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004128', 'Jadeite', 'Normal/StandardItem', '99', '0', '0', '0', '510', '61317', '1017', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004201', 'Marbled Eye', 'Normal/StandardItem', '99', '0', '0', '0', '300', '60160', '1017', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004202', 'Eye of Fire', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60146', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004203', 'Eye of Lightning', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60150', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004204', 'Eye of Wind', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60147', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004205', 'Eye of Water', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60148', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004206', 'Eye of Ice', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60151', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004207', 'Eye of Earth', 'Normal/StandardItem', '99', '0', '0', '0', '600', '60149', '1017', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004208', 'Radiant Eye of Fire', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60154', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004209', 'Radiant Eye of Lightning', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60158', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004210', 'Radiant Eye of Wind', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60155', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004211', 'Radiant Eye of Water', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60156', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004212', 'Radiant Eye of Ice', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60159', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004213', 'Radiant Eye of Earth', 'Normal/StandardItem', '99', '0', '0', '0', '900', '60157', '1017', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004214', 'Astral Eye', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60152', '1017', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004215', 'Umbral Eye', 'Normal/StandardItem', '99', '0', '0', '0', '1200', '60153', '1017', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004216', 'Fire Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60165', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004217', 'Lightning Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60170', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004218', 'Wind Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60168', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004219', 'Water Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60166', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004220', 'Ice Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60169', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004221', 'Earth Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '540', '60167', '1017', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004222', 'Radiant Fire Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60165', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004223', 'Radiant Lightning Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60170', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004224', 'Radiant Wind Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60168', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004225', 'Radiant Water Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60166', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004226', 'Radiant Ice Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60169', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004227', 'Radiant Earth Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60167', '1017', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004228', 'Astral Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '1140', '60172', '1017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004229', 'Umbral Moraine', 'Normal/StandardItem', '99', '0', '0', '0', '1140', '60171', '1017', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004230', 'Allagan Runestone - Byregot', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61569', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004231', 'Allagan Runestone - Rhalgr', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61570', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004232', 'Allagan Runestone - Llymlaen', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61571', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004233', 'Allagan Runestone - Azeyma', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61572', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004234', 'Allagan Runestone - Althyk', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61573', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004235', 'Allagan Runestone - Menphina', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61574', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004236', 'Allagan Runestone - Nophica', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61575', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004237', 'Allagan Runestone - Nald\'thal', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61576', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004238', 'Allagan Runestone - Nymeia', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61577', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004239', 'Allagan Runestone - Oschon', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61578', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004240', 'Allagan Runestone - Thaliak', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61579', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004241', 'Allagan Runestone - Halone', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61580', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004242', 'Astral Rock', 'Normal/StandardItem', '99', '0', '0', '0', '765', '60142', '1017', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10004243', 'Radiant Astral Eye', 'Normal/StandardItem', '99', '0', '0', '0', '1530', '60152', '1017', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005001', 'Undyed Hempen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '70', '60199', '4006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005002', 'Mole-brown Hempen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '70', '60200', '4006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005003', 'Lead-grey Hempen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '70', '60201', '4006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005004', 'Sand-beige Hempen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '70', '60202', '4006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005005', 'Undyed Cotton Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60203', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005006', 'Mesa-red Cotton Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60204', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005007', 'Maize-yellow Cotton Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60205', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005008', 'Olive-green Cotton Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60206', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005009', 'Celeste-blue Cotton Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60207', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005010', 'Undyed Canvas', 'Normal/StandardItem', '99', '0', '0', '0', '166', '60208', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005011', 'Sunset-auburn Canvas', 'Normal/StandardItem', '99', '0', '0', '0', '166', '60209', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005012', 'Rose-pink Canvas', 'Normal/StandardItem', '99', '0', '0', '0', '166', '60210', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005013', 'Orchard-brown Canvas', 'Normal/StandardItem', '99', '0', '0', '0', '166', '60211', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005014', 'Woad-blue Canvas', 'Normal/StandardItem', '99', '0', '0', '0', '166', '60212', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005015', 'Undyed Velveteen', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60213', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005016', 'Raven-black Velveteen', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60214', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005017', 'Wine-red Velveteen', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60215', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005018', 'Cream-yellow Velveteen', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60216', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005019', 'Hunter Green Velveteen', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60217', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005020', 'Undyed Linen', 'Normal/StandardItem', '99', '0', '0', '0', '262', '60218', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005021', 'Floral Pink Linen', 'Normal/StandardItem', '99', '0', '0', '0', '262', '60219', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005022', 'Deepsea-blue Linen', 'Normal/StandardItem', '99', '0', '0', '0', '262', '60220', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005023', 'Shale-brown Linen', 'Normal/StandardItem', '99', '0', '0', '0', '262', '60221', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005024', 'Saffron-yellow Linen', 'Normal/StandardItem', '99', '0', '0', '0', '262', '60222', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005025', 'Undyed Woolen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60223', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005026', 'Coal-black Woolen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60224', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005027', 'Dark Violet Woolen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60225', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005028', 'Carmine Red Woolen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60226', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005029', 'Fog-grey Woolen Cloth', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60227', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005030', 'Dream Hat Materials', 'Normal/StandardItem', '99', '0', '0', '0', '83', '61513', '4006', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005031', 'Dream Tunic Materials', 'Normal/StandardItem', '99', '0', '0', '0', '102', '61513', '4006', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005032', 'Dream Boots Materials', 'Normal/StandardItem', '99', '0', '0', '0', '128', '61534', '4009', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005033', 'Undyed Felt', 'Normal/StandardItem', '99', '0', '0', '0', '313', '60228', '4006', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005034', 'Vanya Silk', 'Normal/StandardItem', '99', '0', '0', '0', '326', '60233', '4006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005101', 'Hempen Fent', 'Normal/StandardItem', '99', '0', '0', '0', '8', '60278', '4006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005102', 'Cotton Fent', 'Normal/StandardItem', '99', '0', '0', '0', '16', '60279', '4006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005103', 'Canvas Fent', 'Normal/StandardItem', '99', '0', '0', '0', '20', '60280', '4006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005104', 'Velveteen Fent', 'Normal/StandardItem', '99', '0', '0', '0', '24', '60281', '4006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005105', 'Linen Fent', 'Normal/StandardItem', '99', '0', '0', '0', '32', '60282', '4006', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005201', 'Straw', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60247', '4005', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005202', 'Moko Grass', 'Normal/StandardItem', '99', '0', '0', '0', '12', '60248', '4005', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005203', 'Cotton Boll', 'Normal/StandardItem', '99', '0', '0', '0', '26', '60246', '4005', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005204', 'Flax', 'Normal/StandardItem', '99', '0', '0', '0', '54', '60245', '4005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005205', 'Cotton Stuffing', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60249', '4005', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005206', 'Crawler Cocoon', 'Normal/StandardItem', '99', '0', '0', '0', '274', '60275', '4005', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005301', 'Hempen Yarn', 'Normal/StandardItem', '99', '0', '0', '0', '27', '60254', '4005', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005302', 'Cotton Yarn', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60252', '4005', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005303', 'Linen Yarn', 'Normal/StandardItem', '99', '0', '0', '0', '117', '60255', '4005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005304', 'Woolen Yarn', 'Normal/StandardItem', '99', '0', '0', '0', '132', '60256', '4005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005305', 'Karakul Yarn', 'Normal/StandardItem', '99', '0', '0', '0', '52', '61447', '4005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005306', 'Diremite Web', 'Normal/StandardItem', '99', '0', '0', '0', '36', '61364', '4005', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005307', 'Dew Thread', 'Normal/StandardItem', '99', '0', '0', '0', '87', '60253', '4005', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005308', 'Twinthread', 'Normal/StandardItem', '99', '0', '0', '0', '153', '60253', '4005', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005401', 'Cock Feather', 'Normal/StandardItem', '99', '0', '0', '0', '19', '60265', '4011', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005402', 'Dodo Feather', 'Normal/StandardItem', '99', '0', '0', '0', '33', '60268', '4011', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005403', 'Crow Feather', 'Normal/StandardItem', '99', '0', '0', '0', '48', '60266', '4011', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005404', 'Wildfowl Feather', 'Normal/StandardItem', '99', '0', '0', '0', '62', '60267', '4011', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005405', 'Cockatrice Feather', 'Normal/StandardItem', '99', '0', '0', '0', '76', '60269', '4011', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005406', 'Vulture Feather', 'Normal/StandardItem', '99', '0', '0', '0', '91', '60270', '4011', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005407', 'Condor Feather', 'Normal/StandardItem', '99', '0', '0', '0', '105', '60270', '4011', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005408', 'Swan Feather', 'Normal/StandardItem', '99', '0', '0', '0', '120', '60271', '4011', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005409', 'Eagle Feather', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60272', '4011', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005410', 'Chocobo Feather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60259', '4011', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005411', 'Gnat Wing', 'Normal/StandardItem', '99', '0', '0', '0', '52', '60274', '4019', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005501', 'Apkallu Down', 'Normal/StandardItem', '99', '0', '0', '0', '124', '60249', '4011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005502', 'Snurble Tufts', 'Normal/StandardItem', '99', '0', '0', '0', '206', '60250', '4008', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005503', 'Fleece', 'Normal/StandardItem', '99', '0', '0', '0', '72', '60249', '4008', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10005504', 'Karakul Fleece', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61446', '4008', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006001', 'Bone Chip', 'Normal/StandardItem', '99', '0', '0', '0', '36', '60370', '4007', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006002', 'Bone Ash', 'Normal/StandardItem', '99', '0', '0', '0', '45', '60476', '4007', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006003', 'Soiled Femur', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60371', '4007', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006004', 'Bone Scales', 'Normal/StandardItem', '99', '0', '0', '0', '72', '61346', '4007', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006005', 'Aldgoat Horn', 'Normal/StandardItem', '99', '0', '0', '0', '576', '60391', '4007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006006', 'Antelope Horn', 'Normal/StandardItem', '99', '0', '0', '0', '396', '60386', '4007', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006007', 'Ogre Horn', 'Normal/StandardItem', '99', '0', '0', '0', '828', '60387', '4007', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006008', 'Hippogryph Talon', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60383', '4017', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006009', 'Raptor Talon', 'Normal/StandardItem', '99', '0', '0', '0', '279', '60382', '4017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006010', 'Wolf Fang', 'Normal/StandardItem', '99', '0', '0', '0', '198', '60384', '4017', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006011', 'Hyena Fang', 'Normal/StandardItem', '99', '0', '0', '0', '378', '60384', '4017', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006012', 'Hellhound Fang', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60384', '4017', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006013', 'Hedgemole Spine', 'Normal/StandardItem', '99', '0', '0', '0', '189', '60446', '4017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006014', 'Cactuar Needle', 'Normal/StandardItem', '99', '0', '0', '0', '234', '60454', '4017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006015', 'Drake Scales', 'Normal/StandardItem', '99', '0', '0', '0', '378', '60372', '4027', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006016', 'Biast Scales', 'Normal/StandardItem', '99', '0', '0', '0', '324', '60373', '4027', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006101', 'Weevil Elytron', 'Normal/StandardItem', '99', '0', '0', '0', '99', '60378', '4019', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006102', 'Ladybug Elytron', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60379', '4019', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006103', 'Firefly Elytron', 'Normal/StandardItem', '99', '0', '0', '0', '189', '61459', '4019', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006104', 'Yellow Yarzon Leg', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60389', '4027', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006105', 'Blue Yarzon Leg', 'Normal/StandardItem', '99', '0', '0', '0', '288', '60390', '4027', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006106', 'Green Megalocrab Shell', 'Normal/StandardItem', '99', '0', '0', '0', '378', '60380', '4027', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006107', 'Red Megalocrab Shell', 'Normal/StandardItem', '99', '0', '0', '0', '468', '60381', '4027', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006108', 'White Coral', 'Normal/StandardItem', '99', '0', '0', '0', '171', '60394', '4007', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006109', 'Blue Coral', 'Normal/StandardItem', '99', '0', '0', '0', '243', '60393', '4007', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006110', 'Red Coral', 'Normal/StandardItem', '99', '0', '0', '0', '360', '60392', '4007', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006111', 'Scallop Shell', 'Normal/StandardItem', '99', '0', '0', '0', '36', '60374', '4027', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006112', 'Sunrise Tellin', 'Normal/StandardItem', '99', '0', '0', '0', '81', '60375', '4027', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006113', 'Miter Shell', 'Normal/StandardItem', '99', '0', '0', '0', '126', '60376', '4027', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006114', 'Blacklip Oyster', 'Normal/StandardItem', '99', '0', '0', '0', '171', '60377', '4027', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006115', 'Hawksbill Shell', 'Normal/StandardItem', '99', '0', '0', '0', '756', '60748', '4027', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006116', 'Tortoiseshell', 'Normal/StandardItem', '99', '0', '0', '0', '522', '60748', '4027', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006117', 'Bat Fang', 'Normal/StandardItem', '99', '0', '0', '0', '54', '60384', '4017', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006118', 'Ram Horn', 'Normal/StandardItem', '99', '0', '0', '0', '162', '61426', '4007', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006119', 'Mossy Horn', 'Normal/StandardItem', '99', '0', '0', '0', '702', '60391', '4007', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10006120', 'Buffalo Horn', 'Normal/StandardItem', '99', '0', '0', '0', '792', '60385', '4007', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007001', 'Sheepskin', 'Normal/StandardItem', '99', '0', '0', '0', '79', '60341', '4008', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007002', 'Karakul Skin', 'Normal/StandardItem', '99', '0', '0', '0', '312', '60342', '4008', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007003', 'Dodo Skin', 'Normal/StandardItem', '99', '0', '0', '0', '115', '60293', '4008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007004', 'Buffalo Hide', 'Normal/StandardItem', '99', '0', '0', '0', '504', '60310', '4008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007005', 'Gigantoad Skin', 'Normal/StandardItem', '99', '0', '0', '0', '187', '60287', '4008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007006', 'Nakki Skin', 'Normal/StandardItem', '99', '0', '0', '0', '672', '60290', '4008', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007007', 'Wolf Hide', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60297', '4008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007008', 'Hyena Hide', 'Normal/StandardItem', '99', '0', '0', '0', '79', '60299', '4008', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007009', 'Hellhound Hide', 'Normal/StandardItem', '99', '0', '0', '0', '840', '60297', '4008', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007010', 'Rat Pelt', 'Normal/StandardItem', '99', '0', '0', '0', '216', '60303', '4008', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007011', 'Squirrel Pelt', 'Normal/StandardItem', '99', '0', '0', '0', '336', '60305', '4008', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007012', 'Marmot Pelt', 'Normal/StandardItem', '99', '0', '0', '0', '456', '60307', '4008', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007013', 'Dormouse Pelt', 'Normal/StandardItem', '99', '0', '0', '0', '576', '60309', '4008', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007014', 'Blue Antelope Hide', 'Normal/StandardItem', '99', '0', '0', '0', '648', '60319', '4008', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007015', 'Striped Antelope Hide', 'Normal/StandardItem', '99', '0', '0', '0', '768', '60321', '4008', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007016', 'Aldgoat Skin', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60323', '4008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007017', 'Hog Hide', 'Normal/StandardItem', '99', '0', '0', '0', '744', '60326', '4008', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007018', 'Boar Hide', 'Normal/StandardItem', '99', '0', '0', '0', '237', '60331', '4008', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007019', 'Goobbue Skin', 'Normal/StandardItem', '99', '0', '0', '0', '1104', '60339', '4008', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007020', 'Raptor Skin', 'Normal/StandardItem', '99', '0', '0', '0', '295', '60353', '4008', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007021', 'Lindwurm Skin', 'Normal/StandardItem', '99', '0', '0', '0', '1032', '60355', '4008', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007022', 'Basilisk Skin', 'Normal/StandardItem', '99', '0', '0', '0', '912', '60346', '4008', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007023', 'Peiste Skin', 'Normal/StandardItem', '99', '0', '0', '0', '259', '60349', '4008', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007024', 'Drake Skin', 'Normal/StandardItem', '99', '0', '0', '0', '367', '60359', '4008', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007025', 'Biast Skin', 'Normal/StandardItem', '99', '0', '0', '0', '1272', '60362', '4008', '1', '0', '0', '0', '0', '52', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007026', 'Uraeus Skin', 'Normal/StandardItem', '99', '0', '0', '0', '360', '60353', '4008', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007101', 'Sheep Leather', 'Normal/StandardItem', '99', '0', '0', '0', '88', '60343', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007102', 'Taupe Sheep Leather', 'Normal/StandardItem', '99', '0', '0', '0', '88', '60345', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007103', 'Slate-grey Sheep Leather', 'Normal/StandardItem', '99', '0', '0', '0', '88', '60344', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007104', 'Dodo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '128', '60294', '4009', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007105', 'Midnight-black Dodo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '128', '60295', '4009', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007106', 'Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60311', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007107', 'Soot-black Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60313', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007108', 'Red Ochre Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60314', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007109', 'Oxblood-red Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60315', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007110', 'Moss-green Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60316', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007111', 'Desert-yellow Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60317', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007112', 'Russet-brown Buffalo Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60318', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007113', 'Toad Leather', 'Normal/StandardItem', '99', '0', '0', '0', '208', '60288', '4009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007114', 'Dark Brown Toad Leather', 'Normal/StandardItem', '99', '0', '0', '0', '224', '60289', '4009', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007115', 'Wolf Leather', 'Normal/StandardItem', '99', '0', '0', '0', '200', '60344', '4009', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007116', 'Boar Leather', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60327', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007117', 'Storm-blue Boar Leather', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60332', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007118', 'Rust-red Boar Leather', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60329', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007119', 'Loam-brown Boar Leather', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60328', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007120', 'Light Beige Boar Leather', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60330', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007121', 'Nakki Leather', 'Normal/StandardItem', '99', '0', '0', '0', '224', '60291', '4009', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007122', 'Marsh-green Nakki Leather', 'Normal/StandardItem', '99', '0', '0', '0', '224', '60292', '4009', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007123', 'Basilisk Leather', 'Normal/StandardItem', '99', '0', '0', '0', '304', '60347', '4009', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007124', '[en]', 'Normal/StandardItem', '99', '0', '0', '0', '304', '60000', '4009', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007125', 'Peiste Leather', 'Normal/StandardItem', '99', '0', '0', '0', '288', '60350', '4009', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007126', 'Aldgoat Leather', 'Normal/StandardItem', '99', '0', '0', '0', '168', '60311', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007127', 'Raptor Leather', 'Normal/StandardItem', '99', '0', '0', '0', '328', '60353', '4009', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007128', 'Chamois', 'Normal/StandardItem', '99', '0', '0', '0', '216', '60320', '4009', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007129', 'Uraeus Leather', 'Normal/StandardItem', '99', '0', '0', '0', '400', '60353', '4009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007130', 'Dodore Leather', 'Normal/StandardItem', '99', '0', '0', '0', '312', '60295', '4009', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007201', 'Rat Fur', 'Normal/StandardItem', '99', '0', '0', '0', '72', '60303', '4010', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007202', 'Squirrel Fur', 'Normal/StandardItem', '99', '0', '0', '0', '112', '60305', '4010', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007203', 'Marmot Fur', 'Normal/StandardItem', '99', '0', '0', '0', '152', '60307', '4010', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007204', 'Treated Antelope Hide', 'Normal/StandardItem', '99', '0', '0', '0', '192', '60320', '4010', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007205', 'Wolf Fur', 'Normal/StandardItem', '99', '0', '0', '0', '200', '60297', '4010', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007206', 'Dormouse Fur', 'Normal/StandardItem', '99', '0', '0', '0', '232', '60309', '4010', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007207', 'Hippogryph Skin', 'Normal/StandardItem', '99', '0', '0', '0', '367', '60297', '4008', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007208', 'Hippogryph Leather', 'Normal/StandardItem', '99', '0', '0', '0', '408', '60344', '4009', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007209', 'Hard Hippogryph Leather', 'Normal/StandardItem', '99', '0', '0', '0', '448', '60344', '4009', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007210', 'Coeurl Skin', 'Normal/StandardItem', '99', '0', '0', '0', '333', '60334', '4008', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007211', 'Coeurl Fur', 'Normal/StandardItem', '99', '0', '0', '0', '370', '60334', '4010', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007301', 'Sheep Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '17', '60364', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007302', 'Dodo Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '25', '60369', '4009', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007303', 'Buffalo Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '33', '60365', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007304', 'Toad Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '41', '61565', '4009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007305', 'Wolf Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '40', '61567', '4009', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007306', 'Boar Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '49', '60366', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007307', 'Basilisk Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '60', '61566', '4009', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007308', 'Peiste Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60367', '4009', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007309', 'Raptor Leather Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '65', '61542', '4009', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007310', 'Chamois Spetch', 'Normal/StandardItem', '99', '0', '0', '0', '43', '61568', '4009', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007401', 'Sheep Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61350', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007402', 'Sheep Leather Strap (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61350', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007403', 'Sheep Leather Strap (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61350', '4009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007404', 'Dodo Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61350', '4009', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007405', 'Dodo Leather Strap (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61350', '4009', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007406', 'Buffalo Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007407', 'Buffalo Leather Strap (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007408', 'Buffalo Leather Strap (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007409', 'Buffalo Leather Strap (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007410', 'Buffalo Leather Strap (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007411', 'Buffalo Leather Strap (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007412', 'Buffalo Leather Strap (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61350', '4009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007413', 'Toad Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '20', '61350', '4009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007414', 'Toad Leather Strap (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '20', '61350', '4009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007415', 'Wolf Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '20', '61350', '4009', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007416', 'Boar Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61350', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007417', 'Boar Leather Strap (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61350', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007418', 'Boar Leather Strap (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61350', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007419', 'Boar Leather Strap (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61350', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007420', 'Boar Leather Strap (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61350', '4009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007427', 'Raptor Leather Strap', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61350', '4009', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007501', 'Antelope Sinew Cord', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61384', '4005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007502', 'Hippogryph Sinew Cord', 'Normal/StandardItem', '99', '0', '0', '0', '22', '61384', '4005', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007503', 'Raptor Sinew Cord', 'Normal/StandardItem', '99', '0', '0', '0', '29', '61384', '4005', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007504', 'Antelope Sinew', 'Normal/StandardItem', '99', '0', '0', '0', '52', '61383', '4005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007505', 'Hippogryph Sinew', 'Normal/StandardItem', '99', '0', '0', '0', '148', '61383', '4005', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007506', 'Raptor Sinew', 'Normal/StandardItem', '99', '0', '0', '0', '196', '61383', '4005', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007507', 'Mole Sinew', 'Normal/StandardItem', '99', '0', '0', '0', '28', '61383', '4005', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007508', 'Mole Sinew Cord', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61384', '4005', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007509', 'Diremite Sinew Cord', 'Normal/StandardItem', '99', '0', '0', '0', '26', '61384', '4005', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10007510', 'Diremite Sinew', 'Normal/StandardItem', '99', '0', '0', '0', '91', '61383', '4005', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008001', 'Lauan Log', 'Normal/StandardItem', '99', '0', '0', '0', '240', '60406', '4023', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008002', 'Willow Log', 'Normal/StandardItem', '99', '0', '0', '0', '270', '60400', '4023', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008003', 'Maple Log', 'Normal/StandardItem', '99', '0', '0', '0', '92', '60402', '4023', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008004', 'Elm Log', 'Normal/StandardItem', '99', '0', '0', '0', '176', '60399', '4023', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008005', 'Ash Log', 'Normal/StandardItem', '99', '0', '0', '0', '142', '60401', '4023', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008006', 'Cedar Log', 'Normal/StandardItem', '99', '0', '0', '0', '480', '60409', '4023', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008007', 'Walnut Log', 'Normal/StandardItem', '99', '0', '0', '0', '218', '60398', '4023', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008008', 'Yew Log', 'Normal/StandardItem', '99', '0', '0', '0', '193', '60403', '4023', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008009', 'Teak Log', 'Normal/StandardItem', '99', '0', '0', '0', '1290', '60397', '4023', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008010', 'Chestnut Log', 'Normal/StandardItem', '99', '0', '0', '0', '750', '60397', '4023', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008011', 'Oak Log', 'Normal/StandardItem', '99', '0', '0', '0', '277', '60395', '4023', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008012', 'Pine Log', 'Normal/StandardItem', '99', '0', '0', '0', '870', '60408', '4023', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008013', 'Spruce Log', 'Normal/StandardItem', '99', '0', '0', '0', '320', '60407', '4023', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008014', 'Rosewood Log', 'Normal/StandardItem', '99', '0', '0', '0', '386', '60405', '4023', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008015', 'Ebony Log', 'Normal/StandardItem', '99', '0', '0', '0', '429', '60396', '4023', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008016', 'Mahogany Log', 'Normal/StandardItem', '99', '0', '0', '0', '344', '60404', '4023', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008101', 'Arrowwood Branch', 'Normal/StandardItem', '99', '0', '0', '0', '33', '60411', '4023', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008102', 'Lauan Branch', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60411', '4023', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008103', 'Willow Branch', 'Normal/StandardItem', '99', '0', '0', '0', '43', '60411', '4023', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008104', 'Maple Branch', 'Normal/StandardItem', '99', '0', '0', '0', '52', '60411', '4023', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008105', 'Elm Branch', 'Normal/StandardItem', '99', '0', '0', '0', '72', '60411', '4023', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008106', 'Ash Branch', 'Normal/StandardItem', '99', '0', '0', '0', '81', '60411', '4023', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008107', 'Cedar Branch', 'Normal/StandardItem', '99', '0', '0', '0', '76', '60411', '4023', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008108', 'Walnut Branch', 'Normal/StandardItem', '99', '0', '0', '0', '91', '60411', '4023', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008109', 'Yew Branch', 'Normal/StandardItem', '99', '0', '0', '0', '110', '60411', '4023', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008110', 'Teak Branch', 'Normal/StandardItem', '99', '0', '0', '0', '206', '60411', '4023', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008111', 'Chestnut Branch', 'Normal/StandardItem', '99', '0', '0', '0', '120', '60411', '4023', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008112', 'Oak Branch', 'Normal/StandardItem', '99', '0', '0', '0', '158', '60411', '4023', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008113', 'Pine Branch', 'Normal/StandardItem', '99', '0', '0', '0', '139', '60411', '4023', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008114', 'Spruce Branch', 'Normal/StandardItem', '99', '0', '0', '0', '182', '60411', '4023', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008115', 'Rosewood Branch', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60411', '4023', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008116', 'Ebony Branch', 'Normal/StandardItem', '99', '0', '0', '0', '244', '60411', '4023', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008117', 'Mahogany Branch', 'Normal/StandardItem', '99', '0', '0', '0', '196', '60411', '4023', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008118', 'Peach Branch', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60455', '4023', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008119', 'Cherry Branch', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60455', '4023', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008201', 'Lauan Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '72', '60421', '4012', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008202', 'Willow Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '81', '60424', '4012', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008203', 'Maple Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '99', '60422', '4012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008204', 'Elm Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '189', '60418', '4012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008205', 'Ash Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '153', '60419', '4012', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008206', 'Cedar Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '144', '61321', '4012', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008207', 'Walnut Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '234', '60417', '4012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008208', 'Yew Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '207', '60420', '4012', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008209', 'Teak Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '387', '60414', '4012', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008210', 'Chestnut Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '225', '60414', '4012', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008211', 'Oak Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '297', '60416', '4012', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008212', 'Pine Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '261', '61320', '4012', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008213', 'Spruce Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '342', '61319', '4012', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008214', 'Rosewood Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '414', '60425', '4012', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008215', 'Ebony Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '459', '60415', '4012', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008216', 'Mahogany Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '369', '60423', '4012', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008301', 'Bamboo Stick', 'Normal/StandardItem', '99', '0', '0', '0', '126', '60412', '4012', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008302', 'Rattan Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '216', '60413', '4012', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008401', 'Lauan Plank', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60437', '4024', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008402', 'Willow Plank', 'Normal/StandardItem', '99', '0', '0', '0', '122', '60429', '4024', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008403', 'Maple Plank', 'Normal/StandardItem', '99', '0', '0', '0', '149', '60433', '4024', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008404', 'Elm Plank', 'Normal/StandardItem', '99', '0', '0', '0', '204', '60431', '4024', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008405', 'Ash Plank', 'Normal/StandardItem', '99', '0', '0', '0', '231', '60432', '4024', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008406', 'Cedar Plank', 'Normal/StandardItem', '99', '0', '0', '0', '217', '61324', '4024', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008407', 'Walnut Plank', 'Normal/StandardItem', '99', '0', '0', '0', '258', '60430', '4024', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008408', 'Yew Plank', 'Normal/StandardItem', '99', '0', '0', '0', '312', '60434', '4024', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008409', 'Teak Plank', 'Normal/StandardItem', '99', '0', '0', '0', '584', '60436', '4024', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008410', 'Chestnut Plank', 'Normal/StandardItem', '99', '0', '0', '0', '340', '60436', '4024', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008411', 'Oak Plank', 'Normal/StandardItem', '99', '0', '0', '0', '448', '60428', '4024', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008412', 'Pine Plank', 'Normal/StandardItem', '99', '0', '0', '0', '394', '61323', '4024', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008413', 'Spruce Plank', 'Normal/StandardItem', '99', '0', '0', '0', '516', '61322', '4024', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008414', 'Rosewood Plank', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61314', '4024', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008415', 'Ebony Plank', 'Normal/StandardItem', '99', '0', '0', '0', '693', '60435', '4024', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008416', 'Mahogany Plank', 'Normal/StandardItem', '99', '0', '0', '0', '557', '60427', '4024', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008501', 'Oak Chips', 'Normal/StandardItem', '99', '0', '0', '0', '46', '61375', '4023', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008502', 'Maple Sap', 'Normal/StandardItem', '99', '0', '0', '0', '140', '61546', '4026', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008503', 'Pine Chips', 'Normal/StandardItem', '99', '0', '0', '0', '40', '61375', '4023', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008504', 'Willow Chips', 'Normal/StandardItem', '99', '0', '0', '0', '12', '61375', '4023', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008505', 'Chestnut Chips', 'Normal/StandardItem', '99', '0', '0', '0', '35', '61375', '4023', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008506', 'Walnut Chips', 'Normal/StandardItem', '99', '0', '0', '0', '26', '61375', '4023', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10008507', 'Treated Spruce Lumber', 'Normal/StandardItem', '99', '0', '0', '0', '459', '61319', '4012', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009001', 'Blinding Powder', 'Normal/StandardItem', '99', '0', '0', '0', '192', '60443', '4026', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009002', 'Silencing Powder', 'Normal/StandardItem', '99', '0', '0', '0', '211', '60443', '4026', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009003', 'Sleeping Powder', 'Normal/StandardItem', '99', '0', '0', '0', '230', '60443', '4026', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009004', 'Paralyzing Powder', 'Normal/StandardItem', '99', '0', '0', '0', '249', '60443', '4026', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009005', 'Maddening Powder', 'Normal/StandardItem', '99', '0', '0', '0', '268', '60443', '4026', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009006', 'Poison Powder', 'Normal/StandardItem', '99', '0', '0', '0', '288', '60443', '4026', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009007', 'Smothering Powder', 'Normal/StandardItem', '99', '0', '0', '0', '307', '60443', '4026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009008', 'Disabling Powder', 'Normal/StandardItem', '99', '0', '0', '0', '326', '60443', '4026', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009011', 'Illuminating Salts', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61562', '4026', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009012', 'Speaking Salts', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61562', '4026', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009013', 'Reviving Salts', 'Normal/StandardItem', '99', '0', '0', '0', '240', '61562', '4026', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009014', 'Stimulating Salts', 'Normal/StandardItem', '99', '0', '0', '0', '259', '61562', '4026', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009015', 'Soothing Salts', 'Normal/StandardItem', '99', '0', '0', '0', '278', '61562', '4026', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009016', 'Thickening Salts', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61562', '4026', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009017', 'Breathing Salts', 'Normal/StandardItem', '99', '0', '0', '0', '316', '61562', '4026', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009018', 'Reanimating Salts', 'Normal/StandardItem', '99', '0', '0', '0', '336', '61562', '4026', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009021', 'Ironhide Powder', 'Normal/StandardItem', '99', '0', '0', '0', '259', '61562', '4026', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009022', 'Ironwill Powder', 'Normal/StandardItem', '99', '0', '0', '0', '278', '61562', '4026', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009101', 'Brimstone', 'Normal/StandardItem', '99', '0', '0', '0', '76', '60473', '4026', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009102', 'Silex', 'Normal/StandardItem', '99', '0', '0', '0', '115', '60468', '4026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009103', 'Saltpeter', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60477', '4026', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009104', 'Rock Salt', 'Normal/StandardItem', '99', '0', '0', '0', '45', '60589', '4026', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009105', 'Fine Sand', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60905', '4004', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009106', 'River Sand', 'Normal/StandardItem', '99', '0', '0', '0', '25', '60906', '4004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009107', 'Sea Sand', 'Normal/StandardItem', '99', '0', '0', '0', '25', '60907', '4004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009108', 'Minium', 'Normal/StandardItem', '99', '0', '0', '0', '45', '60910', '4026', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009109', 'Chalk', 'Normal/StandardItem', '99', '0', '0', '0', '51', '60479', '4026', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009110', 'Natron', 'Normal/StandardItem', '99', '0', '0', '0', '36', '60479', '4026', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009111', 'Alumen', 'Normal/StandardItem', '99', '0', '0', '0', '76', '60479', '4026', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009112', 'Bomb Ash', 'Normal/StandardItem', '99', '0', '0', '0', '358', '60448', '4026', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009113', 'Grenade Ash', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60448', '4026', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009201', 'Quicksilver', 'Normal/StandardItem', '99', '0', '0', '0', '89', '60472', '4026', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009202', 'Vitriol', 'Normal/StandardItem', '99', '0', '0', '0', '115', '60472', '4026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009203', 'Jellyfish Humours', 'Normal/StandardItem', '99', '0', '0', '0', '70', '61365', '4026', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009204', 'Muddy Water', 'Normal/StandardItem', '99', '0', '0', '0', '25', '61376', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009205', 'Effervescent Water', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60474', '4026', '1', '0', '0', '0', '0', '2', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009206', 'Growth Formula Alpha', 'Normal/StandardItem', '99', '0', '0', '0', '86', '60445', '4026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009207', 'Growth Formula Beta', 'Normal/StandardItem', '99', '0', '0', '0', '182', '60445', '4026', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009208', 'Growth Formula Gamma', 'Normal/StandardItem', '99', '0', '0', '0', '307', '60445', '4026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009209', 'Beastkin Blood', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60438', '4026', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009210', 'Scalekin Blood', 'Normal/StandardItem', '99', '0', '0', '0', '371', '60438', '4026', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009211', 'Formic Acid', 'Normal/StandardItem', '99', '0', '0', '0', '410', '60474', '4026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009212', 'Viscous Secretions', 'Normal/StandardItem', '99', '0', '0', '0', '179', '60441', '4026', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009213', 'Acidic Secretions', 'Normal/StandardItem', '99', '0', '0', '0', '307', '60441', '4026', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009214', 'Coal Tar', 'Normal/StandardItem', '99', '0', '0', '0', '240', '60465', '4026', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009215', 'Linseed Oil', 'Normal/StandardItem', '99', '0', '0', '0', '278', '61365', '2040', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009216', 'Fish Oil', 'Normal/StandardItem', '99', '0', '0', '0', '86', '61365', '2040', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009217', 'Crab Oil', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61365', '2040', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009218', 'Shark Oil', 'Normal/StandardItem', '99', '0', '0', '0', '403', '61365', '2040', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009219', 'Spoken Blood', 'Normal/StandardItem', '99', '0', '0', '0', '538', '60438', '4026', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009301', 'Beehive Chip', 'Normal/StandardItem', '99', '0', '0', '0', '51', '60470', '4026', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009302', 'Beeswax', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60457', '4026', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009303', 'Animal Glue', 'Normal/StandardItem', '99', '0', '0', '0', '86', '60456', '4026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009304', 'Carbon Fiber', 'Normal/StandardItem', '99', '0', '0', '0', '396', '60467', '4005', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009305', 'Carbon Fiber Weave', 'Normal/StandardItem', '99', '0', '0', '0', '588', '60244', '4006', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009306', 'Latex', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61561', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009307', 'Rubber', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61393', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009308', 'Rubber Sole', 'Normal/StandardItem', '99', '0', '0', '0', '134', '60740', '9007', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009309', 'Rubber Band', 'Normal/StandardItem', '99', '0', '0', '0', '144', '60740', '4026', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009310', 'Clear Glass Lens', 'Normal/StandardItem', '99', '0', '0', '0', '154', '60444', '4026', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009311', 'Green Glass Lens', 'Normal/StandardItem', '99', '0', '0', '0', '268', '60797', '4026', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009312', 'Red Glass Lens', 'Normal/StandardItem', '99', '0', '0', '0', '268', '60794', '4026', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009313', 'Lanolin', 'Normal/StandardItem', '99', '0', '0', '0', '96', '60458', '4026', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009314', 'Fish Glue', 'Normal/StandardItem', '99', '0', '0', '0', '163', '60456', '4026', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009315', 'Horn Glue', 'Normal/StandardItem', '99', '0', '0', '0', '259', '60456', '4026', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009316', 'Wing Glue', 'Normal/StandardItem', '99', '0', '0', '0', '355', '60456', '4026', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009317', 'Scale Glue', 'Normal/StandardItem', '99', '0', '0', '0', '451', '60456', '4026', '1', '0', '0', '0', '0', '46', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009401', 'Mandrake', 'Normal/StandardItem', '99', '0', '0', '0', '307', '60484', '2026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009402', 'Mistletoe', 'Normal/StandardItem', '99', '0', '0', '0', '589', '60462', '2026', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009403', 'Carnation', 'Normal/StandardItem', '99', '0', '0', '0', '115', '60471', '2026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009404', 'Chamomile', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60604', '2026', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009405', 'Lavender', 'Normal/StandardItem', '99', '0', '0', '0', '154', '60469', '2026', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009406', 'Belladonna', 'Normal/StandardItem', '99', '0', '0', '0', '179', '60607', '2026', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009407', 'Yellow Ginseng', 'Normal/StandardItem', '99', '0', '0', '0', '64', '60587', '2026', '1', '0', '0', '0', '0', '4', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009501', 'Red Landtrap Leaf', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60584', '2022', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009502', 'Blue Landtrap Leaf', 'Normal/StandardItem', '99', '0', '0', '0', '410', '60585', '2022', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009503', 'Morbol Vine', 'Normal/StandardItem', '99', '0', '0', '0', '294', '60464', '4005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009504', 'Jellyfish Cnida', 'Normal/StandardItem', '99', '0', '0', '0', '153', '60439', '4026', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009505', 'Puk Wing', 'Normal/StandardItem', '99', '0', '0', '0', '179', '60451', '4019', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009506', 'Bat Wing', 'Normal/StandardItem', '99', '0', '0', '0', '102', '60450', '4019', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009507', 'Imp Wing', 'Normal/StandardItem', '99', '0', '0', '0', '205', '60449', '4019', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009508', 'Ahriman Wing', 'Normal/StandardItem', '99', '0', '0', '0', '538', '60452', '4019', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009509', 'Void Glue', 'Normal/StandardItem', '99', '0', '0', '0', '204', '60456', '4026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009510', 'Black Glass Lens', 'Normal/StandardItem', '99', '0', '0', '0', '278', '61431', '4026', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009601', 'Yellow Glass Lens', 'Normal/StandardItem', '99', '0', '0', '0', '278', '60799', '4026', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009602', 'Dodore Wing', 'Normal/StandardItem', '99', '0', '0', '0', '524', '60452', '4019', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009603', 'Bee Basket', 'Normal/StandardItem', '99', '0', '0', '0', '102', '60759', '4026', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009605', 'Tarantula', 'Normal/StandardItem', '99', '0', '0', '0', '410', '60718', '4026', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009606', 'Black Scorpion', 'Normal/StandardItem', '99', '0', '0', '0', '538', '60727', '4026', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009607', 'White Scorpion', 'Normal/StandardItem', '99', '0', '0', '0', '230', '60728', '4026', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009608', 'Grass Viper', 'Normal/StandardItem', '99', '0', '0', '0', '90', '60721', '4026', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009609', 'Moor Leech', 'Normal/StandardItem', '99', '0', '0', '0', '51', '61358', '4026', '1', '0', '0', '0', '0', '3', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009610', 'Tinolqa Mistletoe', 'Normal/StandardItem', '99', '0', '0', '0', '115', '60462', '2026', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009611', 'Matron\'s Mistletoe', 'Normal/StandardItem', '99', '0', '0', '0', '307', '60462', '2026', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009612', 'Vampire Plant', 'Normal/StandardItem', '99', '0', '0', '0', '653', '60462', '2026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009613', 'Trillium', 'Normal/StandardItem', '99', '0', '0', '0', '652', '60806', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009614', 'Trillium Bulb', 'Normal/StandardItem', '99', '0', '0', '0', '326', '60742', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009615', 'Growth Formula Delta', 'Normal/StandardItem', '99', '0', '0', '0', '245', '60445', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009616', 'Growth Formula Delta Concentrate', 'Normal/StandardItem', '99', '0', '0', '0', '489', '60445', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009617', 'Coke', 'Normal/StandardItem', '99', '0', '0', '0', '107', '60171', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009618', 'Peacock Ore', 'Normal/StandardItem', '99', '0', '0', '0', '148', '60139', '4002', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009619', 'Animal Fat', 'Normal/StandardItem', '99', '0', '0', '0', '97', '61393', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009620', 'Potash', 'Normal/StandardItem', '99', '0', '0', '0', '94', '60038', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009621', 'Lime Sulfur', 'Normal/StandardItem', '99', '0', '0', '0', '489', '60038', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009622', 'Aqueous Whetstone', 'Normal/StandardItem', '99', '0', '0', '0', '153', '61564', '4004', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10009623', 'Hardened Sap', 'Normal/StandardItem', '99', '0', '0', '0', '163', '61393', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010001', 'Mole-brown Hemp Dye', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60747', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010002', 'Lead-grey Hemp Dye', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60747', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010003', 'Sand-beige Hemp Dye', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60747', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010004', 'Olive-green Cotton Dye', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60747', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010005', 'Mesa-red Cotton Dye', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60747', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010006', 'Maize-yellow Cotton Dye', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60747', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010007', 'Celeste-blue Cotton Dye', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60747', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010008', 'Sunset-auburn Canvas Dye', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010009', 'Rose-pink Canvas Dye', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010010', 'Orchard-brown Canvas Dye', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010011', 'Woad-blue Canvas Dye', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010012', 'Raven-black Velveteen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010013', 'Wine-red Velveteen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010014', 'Cream-yellow Velveteen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010015', 'Hunter Green Velveteen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010101', 'Slate-grey Sheep Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '75', '60747', '4014', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010102', 'Taupe Sheep Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '75', '60747', '4014', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010103', 'Midnight-black Dodo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '102', '60747', '4014', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010104', 'Soot-black Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '129', '60747', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010105', 'Red Ochre Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '129', '60747', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010106', 'Oxblood-red Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '129', '60747', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010107', 'Moss-green Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '129', '60747', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010108', 'Desert-yellow Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '145', '60747', '4014', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010109', 'Russet-brown Buffalo Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '145', '60747', '4014', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010110', 'Dark Brown Toad Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '156', '60747', '4014', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010111', 'Marsh-green Nakki Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '156', '60747', '4014', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010112', 'Storm-blue Boar Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '183', '60747', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010113', 'Rust-red Boar Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '183', '60747', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010114', 'Loam-brown Boar Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '183', '60747', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010115', 'Light Beige Boar Leather Dye', 'Normal/StandardItem', '99', '0', '0', '0', '183', '60747', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010201', 'Green Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '97', '60747', '4016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010202', 'Brown Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '97', '60747', '4016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010203', 'Blue Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010204', 'Purple Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60747', '4016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010205', 'Red Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '194', '60747', '4016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010206', 'Indigo Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '194', '60747', '4016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010207', 'White Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60747', '4016', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010208', 'Gold Enamel', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60747', '4016', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010301', 'Vert Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60747', '4016', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010302', 'Azure Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '108', '60747', '4016', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010303', 'Gules Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60747', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010304', 'Purpure Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60747', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010305', 'Sable Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60747', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010306', 'Argent Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4016', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010307', 'Or Lacquer', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60747', '4016', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010401', 'Mole-brown Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60461', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010402', 'Lead-grey Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60461', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010403', 'Sand-beige Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60461', '4014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010404', 'Olive-green Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60461', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010405', 'Mesa-red Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60461', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010406', 'Maize-yellow Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60461', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010407', 'Celeste-blue Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '113', '60461', '4014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010408', 'Sunset-auburn Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60461', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010409', 'Rose-pink Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60461', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010410', 'Orchard-brown Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60461', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010411', 'Woad-blue Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60461', '4014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010412', 'Raven-black Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60461', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010413', 'Wine-red Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60461', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010414', 'Cream-yellow Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60461', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010415', 'Hunter Green Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '167', '60461', '4014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010501', 'Slate-grey Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '75', '61413', '4014', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010502', 'Taupe Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '75', '61413', '4014', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010503', 'Midnight-black Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '102', '61413', '4014', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010504', 'Soot-black Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '129', '61413', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010505', 'Red Ochre Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '129', '61413', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010506', 'Oxblood-red Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '129', '61413', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010507', 'Moss-green Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '129', '61413', '4014', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010508', 'Desert-yellow Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '145', '61413', '4014', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010509', 'Russet-brown Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '145', '61413', '4014', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010510', 'Dark Brown Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '156', '61413', '4014', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010511', 'Marsh-green Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '156', '61413', '4014', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010512', 'Storm-blue Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '183', '61413', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010513', 'Rust-red Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '183', '61413', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010514', 'Loam-brown Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '183', '61413', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010515', 'Light Beige Scale Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '183', '61413', '4014', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010601', 'Green Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '97', '60083', '4016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010602', 'Brown Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '97', '60083', '4016', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010603', 'Blue Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60083', '4016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010604', 'Purple Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '140', '60083', '4016', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010605', 'Red Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '194', '60083', '4016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010606', 'Indigo Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '194', '60083', '4016', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010607', 'White Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60083', '4016', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010608', 'Gold Stainsand', 'Normal/StandardItem', '99', '0', '0', '0', '248', '60083', '4016', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010701', 'Vert Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '108', '61412', '4016', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010702', 'Azure Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '108', '61412', '4016', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010703', 'Gules Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '151', '61412', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010704', 'Purpure Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '151', '61412', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010705', 'Sable Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '151', '61412', '4016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010706', 'Argent Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '167', '61412', '4016', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010707', 'Or Lac Bugs', 'Normal/StandardItem', '99', '0', '0', '0', '167', '61412', '4016', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010708', 'Floral Pink Linen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '221', '60747', '4014', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010709', 'Deepsea-blue Linen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '221', '60747', '4014', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010710', 'Shale-brown Linen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '221', '60747', '4014', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010711', 'Saffron-yellow Linen Dye', 'Normal/StandardItem', '99', '0', '0', '0', '221', '60747', '4014', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010712', 'Floral Pink Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60461', '4014', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010713', 'Deepsea-blue Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60461', '4014', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010714', 'Shale-brown Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60461', '4014', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010715', 'Saffron-yellow Dyer\'s Moss', 'Normal/StandardItem', '99', '0', '0', '0', '210', '60461', '4014', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010716', 'Black Urushi', 'Normal/StandardItem', '99', '0', '0', '0', '145', '60747', '4016', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010717', 'Raw Urushi', 'Normal/StandardItem', '99', '0', '0', '0', '91', '60747', '4016', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010718', 'All-purpose Blue Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61663', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010719', 'All-purpose Red Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61664', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010720', 'All-purpose Yellow Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61665', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010721', 'All-purpose Black Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61666', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010722', 'All-purpose Grey Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61667', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010723', 'All-purpose Brown Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61668', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010724', 'All-purpose Green Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61669', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010725', 'All-purpose White Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61670', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10010726', 'All-purpose Purple Dye', 'Normal/StandardItem', '99', '0', '0', '0', '32', '61671', '4014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011001', 'Tiny Crown', 'Normal/StandardItem', '99', '0', '0', '0', '400', '60738', '4003', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011002', 'Brass Dish', 'Normal/StandardItem', '99', '0', '0', '0', '475', '61371', '1018', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011003', 'Silver Goblet', 'Normal/StandardItem', '99', '0', '0', '0', '675', '61372', '1018', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011004', 'Brass Canteen', 'Normal/StandardItem', '99', '0', '0', '0', '425', '60738', '9021', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011005', 'Tallow Candle', 'Normal/StandardItem', '99', '0', '0', '0', '86', '60460', '1018', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011006', 'Rope', 'Normal/StandardItem', '99', '0', '0', '0', '67', '60765', '1018', '1', '0', '0', '0', '0', '6', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011007', 'Humus', 'Normal/StandardItem', '99', '0', '0', '0', '128', '60909', '4026', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011008', 'Potter\'s Clay', 'Normal/StandardItem', '99', '0', '0', '0', '102', '61357', '4026', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011101', 'Ixali Willowknot', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60890', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011102', 'Ixali Mapleknot', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60891', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011103', 'Ixali Ebonknot', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60892', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011104', 'Sylphic Brownleaf', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60896', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011105', 'Sylphic Yellowleaf', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60897', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011106', 'Sylphic Redleaf', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60898', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011107', 'Titan Copperpiece', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60893', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011108', 'Titan Mythrilpiece', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60894', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011109', 'Titan Electrumpiece', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60895', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011110', 'Greentide Psashp', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60899', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011111', 'Redtide Psashp', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60900', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011112', 'Goldtide Psashp', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60901', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011113', 'Bronze Amalj\'ok', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60887', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011114', 'Iron Amalj\'ok', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60888', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011115', 'Darksteel Amalj\'ok', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60889', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011116', 'Ququroon Doom-die', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60884', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011117', 'Gagaroon Luck-die', 'Normal/StandardItem', '99', '0', '0', '0', '660', '60885', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011118', 'Peperoon Fate-die', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '60886', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011119', 'Beeswax Candle', 'Normal/StandardItem', '99', '0', '0', '0', '57', '60459', '1018', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011120', 'Goblin Mask', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61267', '9020', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011121', 'Twinklebox', 'Normal/StandardItem', '99', '0', '1', '0', '0', '61464', '1018', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011122', 'Brass Gobcog', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61480', '1004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011123', 'Silver Gobcog', 'Normal/StandardItem', '99', '0', '0', '0', '660', '61481', '1004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011124', 'Gold Gobcog', 'Normal/StandardItem', '99', '0', '0', '0', '1920', '61482', '1004', '1', '0', '0', '0', '0', '95', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011125', '[en]', 'Normal/StandardItem', '99', '0', '0', '0', '364', '60000', '1009', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011126', 'Inferno Taper', 'Normal/StandardItem', '99', '0', '1', '0', '0', '61672', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011127', 'Gold Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60731', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011128', 'Electrum Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60731', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011129', 'Rose Gold Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60731', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011130', 'Silver Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60732', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011131', 'Mythril Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60732', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011132', 'Steel Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60732', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011133', 'Copper Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60733', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011134', 'Brass Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60733', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011135', 'Bronze Shposhae Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60733', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011136', 'Brass Zahar\'ak Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011137', 'Copper Zahar\'ak Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011138', 'Silver Zahar\'ak Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61675', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011139', 'Gold Zahar\'ak Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61676', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011140', 'Brass U\'Ghamaro Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011141', 'Silver U\'Ghamaro Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61675', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011142', 'Copper U\'Ghamaro Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011143', 'Bronze U\'Ghamaro Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011144', 'Gold U\'Ghamaro Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61676', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011145', 'Brass Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011146', 'Copper Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61674', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011147', 'Silver Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61675', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011148', 'Steel Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61675', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011149', 'Mythril Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61675', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011150', 'Gold Natalan Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61676', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011151', 'Inferno Totem', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60738', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011152', 'Kupo Nut Charm', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60738', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011153', 'Unmarked Keystone', 'Normal/StandardItem', '99', '0', '1', '0', '0', '61383', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011154', 'Vortex Totem', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60738', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011155', 'Vortex Headdress', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60262', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011156', 'Inferno Seal', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60889', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011157', 'Vortex Seal', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60892', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011158', 'Tremor Seal', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60895', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011159', 'Flawless Mailbreaker Blade', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011160', 'Flawless Avenger Grips', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011161', 'Flawless Rampager Head', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011162', 'Flawless Obelisk Head', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011163', 'Flawless Sarnga Limb', 'Normal/StandardItem', '99', '0', '0', '0', '972', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011164', 'Flawless Suspended Trillium Flower', 'Normal/StandardItem', '99', '0', '0', '0', '777', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011165', 'Flawless Astrolabe Clinometer', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9001', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011166', 'Flawless Vanya Silk Hat Lining', 'Normal/StandardItem', '99', '0', '0', '0', '777', '61346', '9006', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011167', 'Flawless Vanya Silk Robe Lining', 'Normal/StandardItem', '99', '0', '0', '0', '777', '61346', '9006', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011168', 'Flawless Vanya Silk Glove Lining', 'Normal/StandardItem', '99', '0', '0', '0', '777', '61346', '9006', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011169', 'Flawless Vanya Silk Crakow Lining', 'Normal/StandardItem', '99', '0', '0', '0', '777', '61346', '9006', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011170', 'Flawless Gryphonskin Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '810', '61346', '9020', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011171', 'Flawless Gryphonskin Shin Guards', 'Normal/StandardItem', '99', '0', '0', '0', '810', '61346', '9020', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011172', 'Flawless Gryphonskin Elbow Pads', 'Normal/StandardItem', '99', '0', '0', '0', '810', '61346', '9020', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011173', 'Flawless Gryphonskin Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '810', '61346', '9020', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011174', 'Flawless Darksteel Breastplate', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9021', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011175', 'Flawless Darksteel Gauntlet Plates', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9021', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011176', 'Flawless Darksteel Couters', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9021', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011177', 'Flawless Rose Gold Clasps', 'Normal/StandardItem', '99', '0', '0', '0', '2025', '61346', '9021', '2', '0', '0', '0', '0', '80', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011178', 'Mailbreaker Blade', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011179', 'Avenger Grips', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011180', 'Rampager Head', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011181', 'Obelisk Head', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011182', 'Sarnga Limb', 'Normal/StandardItem', '99', '0', '0', '0', '612', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011183', 'Suspended Trillium Flower', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011184', 'Astrolabe Clinometer', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9001', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011185', 'Vanya Silk Hat Lining', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61346', '9006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011186', 'Vanya Silk Robe Lining', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61346', '9006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011187', 'Vanya Silk Glove Lining', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61346', '9006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011188', 'Vanya Silk Crakow Lining', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61346', '9006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011189', 'Gryphonskin Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '510', '61346', '9020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011190', 'Gryphonskin Shin Guards', 'Normal/StandardItem', '99', '0', '0', '0', '510', '61346', '9020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011191', 'Gryphonskin Elbow Pads', 'Normal/StandardItem', '99', '0', '0', '0', '510', '61346', '9020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011192', 'Gryphonskin Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '510', '61346', '9020', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011193', 'Darksteel Breastplate', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011194', 'Darksteel Gauntlet Plates', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011195', 'Darksteel Couters', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011196', 'Rose Gold Clasps', 'Normal/StandardItem', '99', '0', '0', '0', '1275', '61346', '9021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011197', 'Light Kidney Ore', 'Normal/StandardItem', '99', '0', '0', '0', '138', '60085', '4002', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011198', 'Young Indigo Herring', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60695', '2031', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011199', 'Supple Spruce Branch', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60455', '4023', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011200', 'Militia Bow', 'Normal/StandardItem', '99', '0', '0', '0', '6440', '70350', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011201', 'Militia Sword', 'Normal/StandardItem', '99', '0', '0', '0', '4784', '70018', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011202', 'Militia Helm', 'Normal/StandardItem', '99', '0', '0', '0', '7728', '80606', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011203', 'Militia Gorget', 'Normal/StandardItem', '99', '0', '0', '0', '3128', '61035', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011204', 'Militia Longboots', 'Normal/StandardItem', '99', '0', '0', '0', '3422', '80297', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011205', 'Militia Leggings', 'Normal/StandardItem', '99', '0', '0', '0', '4140', '82399', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011206', 'Militia Poultice', 'Normal/StandardItem', '99', '0', '0', '0', '287', '60020', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011207', 'Militia Rations', 'Normal/StandardItem', '99', '0', '0', '0', '151', '60700', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011208', 'Stiperstone', 'Normal/StandardItem', '99', '0', '0', '0', '138', '60477', '4002', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011209', 'Resin', 'Normal/StandardItem', '99', '0', '0', '0', '588', '61393', '4026', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011210', 'Navigator\'s Ear', 'Normal/StandardItem', '99', '0', '0', '0', '220', '60700', '2031', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011211', 'Miser\'s Mythril', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60135', '4002', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011212', 'Alumina Salts', 'Normal/StandardItem', '99', '0', '1', '0', '0', '60468', '4004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011213', 'Copper Castrum Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60733', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011214', 'Silver Castrum Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60732', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011215', 'Gold Castrum Coffer Key', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60731', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011216', 'Sanguine Humours', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60021', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011217', 'Phlegmatic Humours', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60019', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011218', 'Melancholic Humours', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60020', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011219', 'Reinforced Pavis', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011220', 'Spiked Pavis', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011221', 'Musked Pavis', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011222', 'Blessed Pavis', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011223', 'Reinforced Decoy', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011224', 'Spiked Decoy', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011225', 'Musked Decoy', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011226', 'Blessed Decoy', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011227', 'Fortified Rations', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011228', 'Spiked Rations', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011229', 'Musked Rations', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011230', 'Blessed Rations', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011231', 'Pavis Parts (Reinforcement)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011232', 'Pavis Parts (Spikes)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011233', 'Pavis Parts (Musk)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011234', 'Pavis Parts (Blessing)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011235', 'Decoy Parts (Reinforcement)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011236', 'Decoy Parts (Spikes)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011237', 'Decoy Parts (Musk)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011238', 'Decoy Parts (Blessing)', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61346', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011239', 'Fortifying Philter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011240', 'Spiking Philter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011241', 'Musky Philter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011242', 'Sanctifying Philter', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60740', '1009', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011243', 'Wanted: Gauwyn the Gannet', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61352', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011244', 'Enchiridion', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60746', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011245', 'Allagan Band', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60924', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011246', 'Oschon\'s Finger', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61217', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011247', 'Garlean Steel Joint', 'Normal/StandardItem', '99', '0', '0', '0', '490', '61429', '4003', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011248', 'Garlean Steel Plate', 'Normal/StandardItem', '99', '0', '0', '0', '1150', '60118', '4021', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011249', 'Garlean Rubber', 'Normal/StandardItem', '99', '0', '0', '0', '441', '60740', '4026', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011250', 'Garlean Fiber', 'Normal/StandardItem', '99', '0', '0', '0', '419', '60467', '4005', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011251', 'Commemorative Coin', 'Normal/StandardItem', '1', '1', '1', '0', '0', '60745', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011252', 'Unsealed Memorandum', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61352', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011253', 'Bombard Ash', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60448', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10011254', 'Deaspected Cluster', 'Normal/StandardItem', '99', '0', '0', '0', '102', '61741', '1006', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012001', 'Archon Egg', 'Normal/StandardItem', '1', '1', '0', '0', '33', '61581', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012002', 'Colored Archon Egg', 'Normal/StandardItem', '1', '1', '0', '0', '63', '61582', '1017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012003', 'Painted Archon Egg', 'Normal/StandardItem', '1', '1', '0', '0', '93', '61583', '1017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012004', 'Darkened Archon Egg', 'Normal/StandardItem', '1', '1', '0', '0', '123', '61584', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012005', 'Wind Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61587', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012006', 'Lightning Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61589', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012007', 'Fire Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61585', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012008', 'Earth Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61588', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012009', 'Ice Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61586', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012010', 'Water Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61590', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012011', 'Astral Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '4', '61591', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012012', 'Umbral Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '4', '61592', '1017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012013', 'Deaspected Crystal', 'Normal/StandardItem', '99', '0', '0', '0', '22', '61593', '1006', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012014', 'Red Bombard Ash', 'Normal/StandardItem', '99', '0', '0', '0', '1', '61610', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012015', 'Blue Bombard Ash', 'Normal/StandardItem', '99', '0', '0', '0', '1', '61611', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012016', 'Green Bombard Ash', 'Normal/StandardItem', '99', '0', '0', '0', '1', '61612', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012017', 'Black Bombard Ash', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60083', '4026', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012018', 'Red Lion', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61613', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012019', 'Blue Spinner', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61614', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012020', 'Green Comet', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61615', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012021', 'Azeyma\'s Candle', 'Normal/StandardItem', '1', '1', '1', '0', '0', '61616', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012022', 'Motley Egg', 'Normal/StandardItem', '1', '1', '0', '0', '60', '61710', '1017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012023', 'Odd Egg', 'Normal/StandardItem', '99', '0', '1', '0', '0', '61213', '1017', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012024', 'Red Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61585', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012025', 'Blue Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61586', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012026', 'Green Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61587', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012027', 'Yellow Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61588', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012028', 'Violet Archon Egg', 'Normal/StandardItem', '99', '0', '0', '0', '2', '61589', '1017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10012029', 'Faded Page', 'Normal/StandardItem', '99', '0', '0', '0', '1', '60751', '1009', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013001', 'Grade 1 Dark Matter', 'Normal/StandardItem', '99', '0', '0', '0', '6', '61604', '1013', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013002', 'Grade 2 Dark Matter', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61605', '1013', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013003', 'Grade 3 Dark Matter', 'Normal/StandardItem', '99', '0', '0', '0', '26', '61606', '1013', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013004', 'Grade 4 Dark Matter', 'Normal/StandardItem', '99', '0', '0', '0', '36', '61607', '1013', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013005', 'Grade 5 Dark Matter', 'Normal/StandardItem', '99', '0', '0', '0', '46', '61608', '1013', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013006', 'Carbonized Matter', 'Normal/StandardItem', '99', '0', '0', '0', '9', '61660', '1013', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013007', 'Petrified Matter', 'Normal/StandardItem', '99', '0', '0', '0', '29', '61660', '1013', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013008', 'Fossilized Matter', 'Normal/StandardItem', '99', '0', '0', '0', '39', '61660', '1013', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013009', 'Crystallized Matter', 'Normal/StandardItem', '99', '0', '0', '0', '44', '61660', '1013', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013010', 'Germinated Matter', 'Normal/StandardItem', '99', '0', '0', '0', '9', '61660', '1013', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013011', 'Decayed Matter', 'Normal/StandardItem', '99', '0', '0', '0', '29', '61660', '1013', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013012', 'Decomposed Matter', 'Normal/StandardItem', '99', '0', '0', '0', '39', '61660', '1013', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013013', 'Liquefied Matter', 'Normal/StandardItem', '99', '0', '0', '0', '44', '61660', '1013', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013014', 'Calcified Matter', 'Normal/StandardItem', '99', '0', '0', '0', '9', '61660', '1013', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013015', 'Cultured Matter', 'Normal/StandardItem', '99', '0', '0', '0', '29', '61660', '1013', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013016', 'Ossified Matter', 'Normal/StandardItem', '99', '0', '0', '0', '39', '61660', '1013', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10013017', 'Cretified Matter', 'Normal/StandardItem', '99', '0', '0', '0', '44', '61660', '1013', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100001', 'Bloodthirst Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61628', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100002', 'Bloodthirst Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61629', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100003', 'Bloodthirst Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61630', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100004', 'Bloodthirst Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61631', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100005', 'Manathirst Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61628', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100006', 'Manathirst Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61629', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100007', 'Manathirst Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61630', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100008', 'Manathirst Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61631', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100009', 'Lifethirst Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61628', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100010', 'Lifethirst Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61629', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100011', 'Lifethirst Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61630', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100012', 'Lifethirst Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61631', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100013', 'Strength Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100014', 'Strength Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100015', 'Strength Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100016', 'Strength Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100017', 'Vitality Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100018', 'Vitality Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100019', 'Vitality Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100020', 'Vitality Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100021', 'Dexterity Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100022', 'Dexterity Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100023', 'Dexterity Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100024', 'Dexterity Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100025', 'Intelligence Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100026', 'Intelligence Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100027', 'Intelligence Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100028', 'Intelligence Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100029', 'Mind Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100030', 'Mind Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100031', 'Mind Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100032', 'Mind Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100033', 'Piety Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100034', 'Piety Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100035', 'Piety Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100036', 'Piety Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100037', 'Ironman\'s Will Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100038', 'Ironman\'s Will Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100039', 'Ironman\'s Will Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100040', 'Ironman\'s Will Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100041', 'Swordsman\'s Cry Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100042', 'Swordsman\'s Cry Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100043', 'Swordsman\'s Cry Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100044', 'Swordsman\'s Cry Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100045', 'Watchman\'s Vigil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100046', 'Watchman\'s Vigil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100047', 'Watchman\'s Vigil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100048', 'Watchman\'s Vigil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100049', 'Loresman\'s Wit Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100050', 'Loresman\'s Wit Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100051', 'Loresman\'s Wit Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100052', 'Loresman\'s Wit Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100053', 'Wise Man\'s Vision Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100054', 'Wise Man\'s Vision Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100055', 'Wise Man\'s Vision Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100056', 'Wise Man\'s Vision Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100057', 'Vestryman\'s Faith Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61652', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100058', 'Vestryman\'s Faith Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61653', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100059', 'Vestryman\'s Faith Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61654', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100060', 'Vestryman\'s Faith Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61655', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100061', 'Fire Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100062', 'Fire Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100063', 'Fire Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100064', 'Fire Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100065', 'Ice Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100066', 'Ice Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100067', 'Ice Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100068', 'Ice Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100069', 'Wind Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100070', 'Wind Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100071', 'Wind Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100072', 'Wind Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100073', 'Earth Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100074', 'Earth Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100075', 'Earth Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100076', 'Earth Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100077', 'Lightning Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100078', 'Lightning Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100079', 'Lightning Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100080', 'Lightning Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100081', 'Water Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100082', 'Water Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100083', 'Water Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100084', 'Water Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100085', 'Fire Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100086', 'Fire Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100087', 'Fire Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100088', 'Fire Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100089', 'Ice Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100090', 'Ice Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100091', 'Ice Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100092', 'Ice Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100093', 'Wind Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100094', 'Wind Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100095', 'Wind Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100096', 'Wind Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100097', 'Earth Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100098', 'Earth Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100099', 'Earth Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100100', 'Earth Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100101', 'Lightning Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100102', 'Lightning Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100103', 'Lightning Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100104', 'Lightning Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100105', 'Water Veil Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100106', 'Water Veil Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100107', 'Water Veil Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100108', 'Water Veil Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100109', 'Heavens\' Fist Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100110', 'Heavens\' Fist Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100111', 'Heavens\' Fist Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100112', 'Heavens\' Fist Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100113', 'Heavens\' Eye Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100114', 'Heavens\' Eye Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100115', 'Heavens\' Eye Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100116', 'Heavens\' Eye Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100117', 'Hells\' Fist Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100118', 'Hells\' Fist Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100119', 'Hells\' Fist Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100120', 'Hells\' Fist Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100121', 'Hells\' Eye Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100122', 'Hells\' Eye Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100123', 'Hells\' Eye Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100124', 'Hells\' Eye Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100125', 'Savage Aim Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100126', 'Savage Aim Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100127', 'Savage Aim Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100128', 'Savage Aim Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100129', 'Savage Might Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100130', 'Savage Might Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100131', 'Savage Might Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100132', 'Savage Might Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100133', 'Sagacious Aim Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100134', 'Sagacious Aim Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100135', 'Sagacious Aim Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100136', 'Sagacious Aim Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100137', 'Sagacious Might Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100138', 'Sagacious Might Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100139', 'Sagacious Might Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100140', 'Sagacious Might Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100141', 'Battledance Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61632', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100142', 'Battledance Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61633', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100143', 'Battledance Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61634', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100144', 'Battledance Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61635', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100145', 'Gatherer\'s Guerdon Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100146', 'Gatherer\'s Guerdon Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100147', 'Gatherer\'s Guerdon Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100148', 'Gatherer\'s Guerdon Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100149', 'Gatherer\'s Guile Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100150', 'Gatherer\'s Guile Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100151', 'Gatherer\'s Guile Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100152', 'Gatherer\'s Guile Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100153', 'Gatherer\'s Grasp Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100154', 'Gatherer\'s Grasp Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100155', 'Gatherer\'s Grasp Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100156', 'Gatherer\'s Grasp Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100157', 'Craftsman\'s Competence Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100158', 'Craftsman\'s Competence Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100159', 'Craftsman\'s Competence Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100160', 'Craftsman\'s Competence Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100161', 'Craftsman\'s Cunning Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100162', 'Craftsman\'s Cunning Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100163', 'Craftsman\'s Cunning Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100164', 'Craftsman\'s Cunning Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100165', 'Craftsman\'s Command Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61624', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100166', 'Craftsman\'s Command Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61625', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100167', 'Craftsman\'s Command Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61626', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100168', 'Craftsman\'s Command Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61627', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013008', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100169', 'Bloodflight Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61632', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100170', 'Bloodflight Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61633', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100171', 'Bloodflight Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61634', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100172', 'Bloodflight Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61635', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100173', 'Manaflight Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100174', 'Manaflight Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100175', 'Manaflight Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100176', 'Manaflight Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100177', 'Bloodwall Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61632', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100178', 'Bloodwall Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61633', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100179', 'Bloodwall Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61634', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100180', 'Bloodwall Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61635', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100181', 'Manawall Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100182', 'Manawall Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100183', 'Manawall Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100184', 'Manawall Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100185', 'Cactuar Foot Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100186', 'Cactuar Foot Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100187', 'Cactuar Foot Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100188', 'Cactuar Foot Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100189', 'Wyvern Skin Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100190', 'Wyvern Skin Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100191', 'Wyvern Skin Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100192', 'Wyvern Skin Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100193', 'Bomb Blood Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100194', 'Bomb Blood Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100195', 'Bomb Blood Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100196', 'Bomb Blood Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100197', 'Pixie Tongue Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100198', 'Pixie Tongue Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100199', 'Pixie Tongue Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100200', 'Pixie Tongue Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100201', 'Coeurl Eye Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100202', 'Coeurl Eye Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100203', 'Coeurl Eye Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100204', 'Coeurl Eye Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100205', 'Aurelia Kiss Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100206', 'Aurelia Kiss Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100207', 'Aurelia Kiss Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100208', 'Aurelia Kiss Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100209', 'Bison Hoof Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100210', 'Bison Hoof Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100211', 'Bison Hoof Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100212', 'Bison Hoof Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100213', 'Funguar Shriek Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100214', 'Funguar Shriek Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100215', 'Funguar Shriek Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100216', 'Funguar Shriek Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100217', 'Treant Root Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100218', 'Treant Root Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100219', 'Treant Root Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100220', 'Treant Root Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100221', 'Chocobo Down Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100222', 'Chocobo Down Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100223', 'Chocobo Down Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100224', 'Chocobo Down Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100225', 'Ahriman Gaze Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61636', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100226', 'Ahriman Gaze Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61637', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100227', 'Ahriman Gaze Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61638', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100228', 'Ahriman Gaze Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61639', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013012', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100229', 'Bloodflow Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61628', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100230', 'Bloodflow Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61629', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100231', 'Bloodflow Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61630', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100232', 'Bloodflow Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61631', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100233', 'Manaflow Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61628', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100234', 'Manaflow Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61629', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100235', 'Manaflow Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61630', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100236', 'Manaflow Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61631', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100237', 'Mettleflow Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100238', 'Mettleflow Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100239', 'Mettleflow Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100240', 'Mettleflow Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100241', 'Touch of Rage Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100242', 'Touch of Rage Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100243', 'Touch of Rage Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100244', 'Touch of Rage Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100245', 'Touch of Serenity Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100246', 'Touch of Serenity Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100247', 'Touch of Serenity Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100248', 'Touch of Serenity Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100249', 'Everspike Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100250', 'Everspike Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100251', 'Everspike Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100252', 'Everspike Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100253', 'Soldier\'s Step Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100254', 'Soldier\'s Step Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100255', 'Soldier\'s Step Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100256', 'Soldier\'s Step Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100257', 'Sorcerer\'s Step Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100258', 'Sorcerer\'s Step Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100259', 'Sorcerer\'s Step Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100260', 'Sorcerer\'s Step Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100261', 'Sprinter\'s Step Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100262', 'Sprinter\'s Step Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100263', 'Sprinter\'s Step Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100264', 'Sprinter\'s Step Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100265', 'Savant\'s Step Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100266', 'Savant\'s Step Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100267', 'Savant\'s Step Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100268', 'Savant\'s Step Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100269', 'Healer\'s Hand Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100270', 'Healer\'s Hand Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100271', 'Healer\'s Hand Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100272', 'Healer\'s Hand Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100273', 'Breath of Fire Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100274', 'Breath of Fire Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100275', 'Breath of Fire Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100276', 'Breath of Fire Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100277', 'Breath of Ice Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100278', 'Breath of Ice Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100279', 'Breath of Ice Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100280', 'Breath of Ice Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100281', 'Breath of Wind Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100282', 'Breath of Wind Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100283', 'Breath of Wind Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100284', 'Breath of Wind Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100285', 'Breath of Earth Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100286', 'Breath of Earth Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100287', 'Breath of Earth Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100288', 'Breath of Earth Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100289', 'Breath of Lightning Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100290', 'Breath of Lightning Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100291', 'Breath of Lightning Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100292', 'Breath of Lightning Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100293', 'Breath of Water Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61656', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100294', 'Breath of Water Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61657', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100295', 'Breath of Water Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61658', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100296', 'Breath of Water Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61659', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100297', 'Bloodbringer Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100298', 'Bloodbringer Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100299', 'Bloodbringer Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100300', 'Bloodbringer Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100301', 'Manabringer Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100302', 'Manabringer Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100303', 'Manabringer Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100304', 'Manabringer Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100305', 'Mettlebringer Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100306', 'Mettlebringer Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100307', 'Mettlebringer Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100308', 'Mettlebringer Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100309', 'Mana Martyr Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100310', 'Mana Martyr Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100311', 'Mana Martyr Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100312', 'Mana Martyr Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100313', 'Mettle Martyr Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61632', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100314', 'Mettle Martyr Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61633', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100315', 'Mettle Martyr Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61634', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100316', 'Mettle Martyr Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61635', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100317', 'Byregot\'s Hammer Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100318', 'Byregot\'s Hammer Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100319', 'Byregot\'s Hammer Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100320', 'Byregot\'s Hammer Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100321', 'Menphina\'s Whisper Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61648', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100322', 'Menphina\'s Whisper Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61649', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100323', 'Menphina\'s Whisper Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61650', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100324', 'Menphina\'s Whisper Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61651', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100325', 'Sanguinary Might Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100326', 'Sanguinary Might Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100327', 'Sanguinary Might Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100328', 'Sanguinary Might Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013017', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100329', 'Stellar Might Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100330', 'Stellar Might Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100331', 'Stellar Might Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100332', 'Stellar Might Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100333', 'Sound of Serenity Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100334', 'Sound of Serenity Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100335', 'Sound of Serenity Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100336', 'Sound of Serenity Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100337', 'Sound of Certainty Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100338', 'Sound of Certainty Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100339', 'Sound of Certainty Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100340', 'Sound of Certainty Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100341', 'Sound of Suffering Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61620', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013010', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100342', 'Sound of Suffering Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61621', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013011', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100343', 'Sound of Suffering Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61622', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100344', 'Sound of Suffering Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61623', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013013', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100345', 'Swiftwall Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61632', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013006', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100346', 'Swiftwall Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61633', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013007', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100347', 'Swiftwall Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61634', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100348', 'Swiftwall Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61635', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013009', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100349', 'Evenflow Materia I', 'Normal/MateriaItem', '99', '0', '0', '0', '36', '61640', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013014', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100350', 'Evenflow Materia II', 'Normal/MateriaItem', '99', '0', '0', '0', '384', '61641', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013015', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100351', 'Evenflow Materia III', 'Normal/MateriaItem', '99', '0', '0', '0', '672', '61642', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100352', 'Evenflow Materia IV', 'Normal/MateriaItem', '99', '0', '0', '0', '840', '61643', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '10013016', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100353', '[en]', 'Normal/MateriaItem', '99', '0', '0', '0', '364', '60000', '1007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100354', '[en]', 'Normal/MateriaItem', '99', '0', '0', '0', '364', '60000', '1007', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100355', '[en]', 'Normal/MateriaItem', '99', '0', '0', '0', '364', '60000', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10100356', '[en]', 'Normal/MateriaItem', '99', '0', '0', '0', '364', '60000', '1007', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300001', 'Bronze Spearhead', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61407', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300002', 'Iron Spearhead', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61407', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300003', 'Bone Harpoon Head', 'Normal/StandardItem', '99', '0', '0', '0', '330', '61407', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300004', 'Fang Harpoon Head', 'Normal/StandardItem', '99', '0', '0', '0', '630', '61407', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300005', 'Yarzonshell Harpoon Head', 'Normal/StandardItem', '99', '0', '0', '0', '1230', '61407', '9002', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300006', 'Tortoiseshell Harpoon Head', 'Normal/StandardItem', '99', '0', '0', '0', '930', '61407', '9002', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300007', 'Iron Halberd Head', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61407', '9002', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300008', 'Iron Lance Head', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61407', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300009', 'Heavy Iron Lance Head', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61407', '9002', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300010', 'Iron Guisarme Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61407', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300011', 'Bronze War Axe Head', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61406', '9002', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300012', 'Iron War Axe Head', 'Normal/StandardItem', '99', '0', '0', '0', '550', '61406', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300013', 'Storm Axe Head', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61406', '9002', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300014', 'Bronze Labrys Head', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61406', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300015', 'Iron Labrys Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61406', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300016', 'Iron Bhuj Head', 'Normal/StandardItem', '99', '0', '0', '0', '675', '61406', '9002', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300017', 'Bronze Bardiche Head', 'Normal/StandardItem', '99', '0', '0', '0', '450', '61406', '9002', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300018', 'Bronze Gladius Blade', 'Normal/StandardItem', '99', '0', '0', '0', '200', '61408', '9002', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300019', 'Brass Gladius Blade', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61408', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300020', 'Iron Gladius Blade', 'Normal/StandardItem', '99', '0', '0', '0', '450', '61408', '9002', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300021', 'Bronze Spatha Blade', 'Normal/StandardItem', '99', '0', '0', '0', '250', '61408', '9002', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300022', 'Iron Spatha Blade', 'Normal/StandardItem', '99', '0', '0', '0', '500', '61408', '9002', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300023', 'Iron Shortsword Blade', 'Normal/StandardItem', '99', '0', '0', '0', '550', '61408', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300024', 'Iron Longsword Blade', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61408', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300025', 'Falchion Blade', 'Normal/StandardItem', '99', '0', '0', '0', '675', '61408', '9002', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300026', 'Toothed Falchion Blade', 'Normal/StandardItem', '99', '0', '0', '0', '725', '61408', '9002', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300027', 'Bronze Dagger Blade', 'Normal/StandardItem', '99', '0', '0', '0', '250', '61408', '9002', '1', '0', '0', '0', '0', '9', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300028', 'Brass Dagger Blade', 'Normal/StandardItem', '99', '0', '0', '0', '375', '61408', '9002', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300029', 'Iron Dagger Blade', 'Normal/StandardItem', '99', '0', '0', '0', '500', '61408', '9002', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300030', 'Leather Knuckle Guards', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61346', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300031', 'Boarskin Himantes Covers', 'Normal/StandardItem', '99', '0', '0', '0', '320', '61346', '9002', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300032', 'Dodoskin Cesti Covers', 'Normal/StandardItem', '99', '0', '0', '0', '170', '61346', '9002', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300033', 'Peiste Skin Cesti Covers', 'Normal/StandardItem', '99', '0', '0', '0', '370', '61346', '9002', '1', '0', '0', '0', '0', '36', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300034', 'Nakki Skin Cesti Covers', 'Normal/StandardItem', '99', '0', '0', '0', '270', '61346', '9002', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300035', 'Baghnakh Talons', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300036', 'Bronze Javelin Head', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61407', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300037', 'Brass Javelin Head', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61407', '9002', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300038', 'Iron Javelin Head', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61407', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300039', 'Silver Javelin Head', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61407', '9002', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300040', 'Bronze Francisca Head', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61406', '9002', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300041', 'Brass Francisca Head', 'Normal/StandardItem', '99', '0', '0', '0', '425', '61406', '9002', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300042', 'Iron Francisca Head', 'Normal/StandardItem', '99', '0', '0', '0', '550', '61406', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300043', 'Silver Francisca Head', 'Normal/StandardItem', '99', '0', '0', '0', '675', '61406', '9002', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300044', 'Iron Bill Head', 'Normal/StandardItem', '99', '0', '0', '0', '1000', '61406', '9002', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300045', 'Bloody Lance Head', 'Normal/StandardItem', '99', '0', '0', '0', '1050', '61407', '9002', '1', '0', '0', '0', '0', '41', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10300046', 'Bloody Bardiche Head', 'Normal/StandardItem', '99', '0', '0', '0', '1075', '61406', '9002', '1', '0', '0', '0', '0', '42', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301001', 'Bronze Cross-pein Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301002', 'Iron Cross-pein Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301003', 'Birdsbeak Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61346', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301004', 'Crowsbeak Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301005', 'Bronze Saw Blade', 'Normal/StandardItem', '99', '0', '0', '0', '350', '61346', '9002', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301006', 'Iron Saw Blade', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301007', 'Bronze Claw Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61346', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301008', 'Iron Claw Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301009', 'Bronze Doming Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301010', 'Iron Doming Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301011', 'Bronze Raising Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61346', '9002', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301012', 'Iron Raising Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '550', '61346', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301013', 'Bronze Chaser Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '350', '61346', '9002', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301014', 'Iron Chaser Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301015', 'Ornamental Bronze Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '375', '61346', '9002', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301016', 'Ornamental Iron Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61346', '9002', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301017', 'Mudstone Wheel', 'Normal/StandardItem', '99', '0', '0', '0', '375', '61346', '9002', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301018', 'Ragstone Wheel', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61346', '9002', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301019', 'Bronze Culinary Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301020', 'Iron Culinary Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301021', 'Bronze Head Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9002', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301022', 'Brass Head Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9002', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301023', 'Iron Head Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9002', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301024', 'Iron Round Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301025', 'Bronze Pickaxe Head', 'Normal/StandardItem', '99', '0', '0', '0', '350', '61346', '9002', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301026', 'Iron Pickaxe Head', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301027', 'Bronze Sledgehammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61346', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301028', 'Iron Sledgehammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301029', 'Bronze Hatchet Head', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61346', '9002', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301030', 'Brass Hatchet Head', 'Normal/StandardItem', '99', '0', '0', '0', '450', '61346', '9002', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301031', 'Iron Hatchet Head', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9002', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301032', 'Bronze Scythe Blade', 'Normal/StandardItem', '99', '0', '0', '0', '350', '61346', '9002', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301033', 'Iron Scythe Blade', 'Normal/StandardItem', '99', '0', '0', '0', '600', '61346', '9002', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301034', 'Bronze Gig Head', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61346', '9002', '1', '0', '0', '0', '0', '11', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301035', 'Iron Gig Head', 'Normal/StandardItem', '99', '0', '0', '0', '550', '61346', '9002', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301036', 'Steel Saw Blade', 'Normal/StandardItem', '99', '0', '0', '0', '850', '61346', '9002', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301037', 'Steel Claw Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '850', '61346', '9002', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301038', 'Steel Chaser Hammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '850', '61346', '9002', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301039', 'Siltstone Wheel', 'Normal/StandardItem', '99', '0', '0', '0', '875', '61346', '9002', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301040', 'Steel Round Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61346', '9002', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301041', 'Mythril Culinary Knife Blade', 'Normal/StandardItem', '99', '0', '0', '0', '1025', '61346', '9002', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301042', 'Mythril Sledgehammer Head', 'Normal/StandardItem', '99', '0', '0', '0', '950', '61346', '9002', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301043', 'Steel Hatchet Head', 'Normal/StandardItem', '99', '0', '0', '0', '825', '61346', '9002', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301044', 'Steel Scythe Blade', 'Normal/StandardItem', '99', '0', '0', '0', '850', '61346', '9002', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10301045', 'Steel Gig Head', 'Normal/StandardItem', '99', '0', '0', '0', '800', '61346', '9002', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302001', 'Maple Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61351', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302002', 'Ash Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302003', 'Elm Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61351', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302004', 'Oak Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '396', '61351', '9004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302005', 'Cedar Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61351', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302006', 'Chestnut Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61351', '9004', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302007', 'Walnut Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '228', '61351', '9004', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302008', 'Pine Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '348', '61351', '9004', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302009', 'Bone Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302010', 'Horn Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302011', 'Aldgoat Horn Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '312', '61346', '9004', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302012', 'Ash Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302013', 'Elm Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61346', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302014', 'Cedar Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302015', 'Chestnut Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61346', '9004', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302016', 'Pine Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '348', '61346', '9004', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302017', 'Maple Dagger Grip', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302018', 'Elm Dagger Grip', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61346', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302019', 'Maple Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302020', 'Ash Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302021', 'Maple Axe Haft', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61351', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302022', 'Ash Axe Haft', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302023', 'Elm Axe Haft', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61351', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302024', 'Cedar Axe Haft', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61351', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302025', 'Aldgoat Horn Bow Grip', 'Normal/StandardItem', '99', '0', '0', '0', '312', '61346', '9004', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302026', 'Bronze Himantes Grips', 'Normal/StandardItem', '99', '0', '0', '0', '33', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302027', 'Brass Himantes Grips', 'Normal/StandardItem', '99', '0', '0', '0', '48', '61346', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302028', 'Iron Himantes Grips', 'Normal/StandardItem', '99', '0', '0', '0', '63', '61346', '9004', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302029', 'Elm Baghnakh Grips', 'Normal/StandardItem', '99', '0', '0', '0', '45', '61346', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302030', 'Cedar Javelin Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '48', '61351', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302031', 'Ash Francisca Haft', 'Normal/StandardItem', '99', '0', '0', '0', '51', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302032', 'Ram Horn Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '156', '61346', '9004', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302101', 'Ash Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302102', 'Maple Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302103', 'Walnut Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '228', '61346', '9004', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302104', 'Elm Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61346', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302105', 'Oak Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '396', '61346', '9004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302106', 'Cedar Hammer Grip', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302107', 'Ash Saw Grip', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302108', 'Elm Saw Grip', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61346', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302109', 'Maple Head Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61346', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302110', 'Ash Head Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61346', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302111', 'Chestnut Head Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '300', '61346', '9004', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302112', 'Cedar Skillet Handle', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9004', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302113', 'Pine Skillet Handle', 'Normal/StandardItem', '99', '0', '0', '0', '348', '61346', '9004', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302114', 'Maple Pickaxe Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61351', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302115', 'Ash Pickaxe Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302116', 'Elm Pickaxe Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61351', '9004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302117', 'Maple Sledgehammer Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61351', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302118', 'Ash Sledgehammer Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302119', 'Elm Sledgehammer Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61351', '9004', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302120', 'Maple Hatchet Haft', 'Normal/StandardItem', '99', '0', '0', '0', '132', '61351', '9004', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302121', 'Elm Hatchet Haft', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61351', '9004', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302122', 'Ash Hatchet Haft', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302123', 'Pine Hatchet Haft', 'Normal/StandardItem', '99', '0', '0', '0', '348', '61351', '9004', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302124', 'Ash Scythe Snead', 'Normal/StandardItem', '99', '0', '0', '0', '204', '61351', '9004', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302125', 'Walnut Saw Grip', 'Normal/StandardItem', '99', '0', '0', '0', '228', '61346', '9004', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302126', 'Oak Head Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '396', '61346', '9004', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302127', 'Mahogany Knife Grip', 'Normal/StandardItem', '99', '0', '0', '0', '492', '61346', '9004', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302128', 'Pine Sledgehammer Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '348', '61351', '9004', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302129', 'Walnut Hatchet Haft', 'Normal/StandardItem', '99', '0', '0', '0', '228', '61351', '9004', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302130', 'Pine Dagger Grip', 'Normal/StandardItem', '99', '0', '0', '0', '276', '61346', '9004', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302131', 'Ogre Horn Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '468', '61346', '9004', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302132', 'Buffalo Horn Sword Grip', 'Normal/StandardItem', '99', '0', '0', '0', '588', '61346', '9004', '1', '0', '0', '0', '0', '48', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10302133', 'Mahogany Spear Shaft', 'Normal/StandardItem', '99', '0', '0', '0', '324', '61351', '9004', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303001', 'Bronze Spear Clasp', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9001', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303002', 'Brass Spear Clasp', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9001', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303003', 'Iron Spear Clasp', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9001', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303004', 'Sheep Leather Swordguard', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61346', '9001', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303005', 'Sheep Leather Swordguard (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61346', '9001', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303006', 'Dodo Leather Swordguard', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61346', '9001', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303007', 'Leather Swordguard (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61346', '9001', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303008', 'Brass Crossguard', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9001', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303009', 'Iron Crossguard', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9001', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303010', 'Darksilver Crossguard', 'Normal/StandardItem', '99', '0', '0', '0', '725', '61346', '9001', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303011', 'Bronze Axe Ferrule', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9001', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303012', 'Iron Axe Ferrule', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61346', '9001', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303013', 'Baghnakh Frame', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9001', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303014', 'Feather Clasp', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9001', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303015', 'Steel Spear Clasp', 'Normal/StandardItem', '99', '0', '0', '0', '900', '61346', '9001', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303101', 'Bronze Spear Butt', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303102', 'Brass Spear Butt', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303103', 'Iron Spear Butt', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303104', 'Iron Halberd Butt', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303105', 'Iron Lance Butt', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303106', 'Bone Harpoon Butt', 'Normal/StandardItem', '99', '0', '0', '0', '180', '61346', '9003', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303107', 'Yarzonshell Harpoon Butt', 'Normal/StandardItem', '99', '0', '0', '0', '930', '61346', '9003', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303108', 'Tortoiseshell Harpoon Butt', 'Normal/StandardItem', '99', '0', '0', '0', '630', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303109', 'Bronze Axe Butt', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303110', 'Iron Axe Butt', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303111', 'Silver Axe Butt', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61346', '9003', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303112', 'Bronze Pommel', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303113', 'Brass Pommel', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9003', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303114', 'Iron Pommel', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303115', 'Darksilver Pommel', 'Normal/StandardItem', '99', '0', '0', '0', '725', '61346', '9003', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303116', 'Bronze Hammer Butt', 'Normal/StandardItem', '99', '0', '0', '0', '50', '61346', '9003', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303117', 'Bronze Sledgehammer Butt', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9003', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303118', 'Iron Sledgehammer Butt', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9003', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303119', 'Mythril Sledgehammer Butt', 'Normal/StandardItem', '99', '0', '0', '0', '1150', '61346', '9003', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303201', 'Hempen Bowstring', 'Normal/StandardItem', '99', '0', '0', '0', '86', '60740', '9001', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303202', 'Linen Bowstring', 'Normal/StandardItem', '99', '0', '0', '0', '374', '60740', '9001', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303203', 'Antelope Sinew Bowstring', 'Normal/StandardItem', '99', '0', '0', '0', '182', '60740', '9001', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303204', 'Hippocerf Sinew Bowstring', 'Normal/StandardItem', '99', '0', '0', '0', '20', '60740', '9001', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303205', 'Raptor Sinew Bowstring', 'Normal/StandardItem', '99', '0', '0', '0', '20', '60740', '9001', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303206', 'Iron Bow Nock', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61346', '9001', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303207', 'Copper Sheep Bell', 'Normal/StandardItem', '99', '0', '0', '0', '150', '60817', '1018', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303208', 'Brass Sheep Bell', 'Normal/StandardItem', '99', '0', '0', '0', '400', '60815', '1018', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303209', 'Copper Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '4', '61433', '9013', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303210', 'Bronze Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '8', '61433', '9013', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303211', 'Iron Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61433', '9013', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303212', 'Silver Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '19', '61433', '9013', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303213', 'Wolf Fang Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '225', '61456', '9013', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303214', 'Bone Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '117', '61456', '9013', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303215', 'Copper Gorge Hook', 'Normal/StandardItem', '99', '0', '0', '0', '6', '61433', '9013', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303216', 'Bronze Gorge Hook', 'Normal/StandardItem', '99', '0', '0', '0', '9', '61433', '9013', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303217', 'Iron Gorge Hook', 'Normal/StandardItem', '99', '0', '0', '0', '17', '61433', '9013', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303218', 'Bronze Reel', 'Normal/StandardItem', '99', '0', '0', '0', '375', '61346', '9001', '1', '0', '0', '0', '0', '14', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303219', 'Brass Reel', 'Normal/StandardItem', '99', '0', '0', '0', '500', '61346', '9001', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303220', 'Iron Reel', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61346', '9001', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303221', 'Flame Receptacle', 'Normal/StandardItem', '99', '0', '0', '0', '211', '61346', '4026', '1', '0', '0', '0', '0', '21', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303222', 'Bat Fang Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '99', '61456', '9013', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303223', 'Jackal Fang Fish Hook', 'Normal/StandardItem', '99', '0', '0', '0', '144', '61456', '9013', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303301', 'Broken Goblin Dagger', 'Normal/StandardItem', '1', '1', '0', '0', '425', '61346', '9001', '1', '0', '0', '0', '0', '16', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303302', 'Broken Goblin Gladius', 'Normal/StandardItem', '1', '1', '0', '0', '675', '61346', '9001', '1', '0', '0', '0', '0', '26', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303303', 'Broken Goblin Longsword', 'Normal/StandardItem', '1', '1', '0', '0', '800', '61346', '9001', '1', '0', '0', '0', '0', '31', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303304', 'Broken Goblin Scimitar', 'Normal/StandardItem', '1', '1', '0', '0', '875', '61346', '9001', '1', '0', '0', '0', '0', '34', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10303305', 'Broken Aeolian Scimitar', 'Normal/StandardItem', '1', '1', '0', '0', '950', '61346', '9001', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304001', 'Cock Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '11', '60875', '9014', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304002', 'Crow Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '21', '60876', '9014', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304003', 'Dodo Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60878', '9014', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304004', 'Cockatrice Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '40', '60879', '9014', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304005', 'Wildfowl Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '49', '60877', '9014', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304006', 'Condor Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '59', '60880', '9014', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304007', 'Vulture Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '69', '60880', '9014', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304008', 'Swan Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '78', '60881', '9014', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304009', 'Eagle Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '88', '60882', '9014', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304010', 'Gnat Fletchings', 'Normal/StandardItem', '99', '0', '0', '0', '36', '60876', '9014', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304101', 'Bronze Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '17', '60863', '9005', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304102', 'Iron Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '34', '60864', '9005', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304103', 'Bronze Swallowtail Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '21', '60871', '9005', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304104', 'Iron Swallowtail Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '37', '60872', '9005', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304105', 'Fang Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '14', '60857', '9005', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304106', 'Flint Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '22', '60855', '9005', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304107', 'Shell Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60857', '9005', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304108', 'Silver Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '34', '60867', '9005', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304109', 'Obsidian Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '38', '60861', '9005', '1', '0', '0', '0', '0', '23', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304110', 'White Coral Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '55', '60857', '9005', '1', '0', '0', '0', '0', '33', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304111', 'Blue Coral Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '63', '60862', '9005', '1', '0', '0', '0', '0', '38', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304112', 'Red Coral Arrowheads', 'Normal/StandardItem', '99', '0', '0', '0', '71', '60858', '9005', '1', '0', '0', '0', '0', '43', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304201', 'Arrowwood Arrow Shafts', 'Normal/StandardItem', '99', '0', '0', '0', '15', '61344', '9015', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304202', 'Ash Arrow Shafts', 'Normal/StandardItem', '99', '0', '0', '0', '24', '61344', '9015', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10304203', 'Cedar Arrow Shafts', 'Normal/StandardItem', '99', '0', '0', '0', '34', '61344', '9015', '1', '0', '0', '0', '0', '17', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305001', 'Sheepskin Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61526', '9008', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305002', 'Sheepskin Shoulder Guards (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61527', '9008', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305003', 'Sheepskin Shoulder Guards (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61528', '9008', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305004', 'Dodoskin Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305005', 'Dodoskin Shoulder Guards (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61530', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305006', 'Leather Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305007', 'Leather Shoulder Guards (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305008', 'Leather Shoulder Guards (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305009', 'Leather Shoulder Guards (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305010', 'Leather Shoulder Guards (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305011', 'Boarskin Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '310', '61538', '9008', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305012', 'Rat Fur Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '90', '61539', '9008', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305013', 'Squirrel Fur Shoulder Guards', 'Normal/StandardItem', '99', '0', '0', '0', '140', '61540', '9008', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305014', 'Cotton Shoulder Guards (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305015', 'Canvas Shoulder Guards (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305016', 'Velveteen Shoulder Guards (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9008', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305101', 'Cotton Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305102', 'Cotton Chest Guard (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305103', 'Cotton Chest Guard (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305104', 'Cotton Chest Guard (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305105', 'Cotton Chest Guard (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305106', 'Canvas Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305107', 'Canvas Chest Guard (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305108', 'Canvas Chest Guard (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305109', 'Canvas Chest Guard (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305110', 'Canvas Chest Guard (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305111', 'Dodoskin Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305112', 'Leather Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305113', 'Leather Chest Guard (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305114', 'Leather Chest Guard (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305115', 'Leather Chest Guard (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305116', 'Wolfskin Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '250', '61528', '9008', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305117', 'Toadskin Chest Guard', 'Normal/StandardItem', '99', '0', '0', '0', '260', '61536', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305201', 'Dodoskin Chest Protector', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305202', 'Leather Chest Protector', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305203', 'Leather Chest Protector (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305204', 'Leather Chest Protector (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305205', 'Leather Chest Protector (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305206', 'Leather Chest Protector (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305207', 'Heavy Leather Chest Protector', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305208', 'Heavy Leather Chest Protector (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305209', 'Heavy Leather Chest Protector (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305210', 'Heavy Leather Chest Protector (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305211', 'Heavy Leather Chest Protector (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305301', 'Dodoskin Outer Body Armor', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305302', 'Leather Outer Body Armor', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305303', 'Leather Outer Body Armor (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305304', 'Leather Outer Body Armor (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305305', 'Leather Outer Body Armor (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305306', 'Leather Outer Body Armor (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9008', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305401', 'Bronze Breastplate', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305402', 'Bronze Backplate', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9008', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305403', 'Iron Breastplate', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61346', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10305404', 'Iron Backplate', 'Normal/StandardItem', '99', '0', '0', '0', '650', '61346', '9008', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306001', 'Hempen Outer Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306002', 'Hempen Outer Cowl (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306003', 'Hempen Outer Cowl (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306004', 'Hempen Outer Cowl (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306005', 'Cotton Outer Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306006', 'Cotton Outer Cowl (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306007', 'Cotton Outer Cowl (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306008', 'Cotton Outer Cowl (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306009', 'Cotton Outer Cowl (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306010', 'Canvas Outer Cowl (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306011', 'Canvas Outer Cowl (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306012', 'Velveteen Outer Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306013', 'Velveteen Outer Cowl (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306014', 'Velveteen Outer Cowl (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306015', 'Velveteen Outer Cowl (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306016', 'Velveteen Outer Cowl (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306101', 'Hempen Outer Gown', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306102', 'Hempen Outer Gown (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306103', 'Hempen Outer Gown (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306104', 'Hempen Outer Gown (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9009', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306105', 'Cotton Outer Gown', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306106', 'Cotton Outer Gown (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306107', 'Cotton Outer Gown (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306108', 'Cotton Outer Gown (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306109', 'Cotton Outer Gown (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9009', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306110', 'Canvas Outer Gown', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306111', 'Canvas Outer Gown (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306112', 'Canvas Outer Gown (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306113', 'Canvas Outer Gown (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306114', 'Canvas Outer Gown (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9009', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306115', 'Velveteen Outer Gown', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306116', 'Velveteen Outer Gown (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306117', 'Velveteen Outer Gown (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306118', 'Velveteen Outer Gown (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306119', 'Velveteen Outer Gown (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9009', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306201', 'Hempen Acton Body (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '124', '61499', '9016', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306202', 'Hempen Acton Body (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '124', '61500', '9016', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306203', 'Hempen Acton Body (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '124', '61501', '9016', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306204', 'Cotton Acton Body (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61502', '9016', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306205', 'Cotton Acton Body (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61503', '9016', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306206', 'Cotton Acton Body (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61504', '9016', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306207', 'Cotton Acton Body (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '220', '61505', '9016', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306208', 'Canvas Acton Body (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '268', '61502', '9016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306209', 'Canvas Acton Body (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '268', '61503', '9016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306210', 'Canvas Acton Body (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '268', '61504', '9016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306211', 'Canvas Acton Body (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '268', '61505', '9016', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306212', 'Velveteen Acton Body', 'Normal/StandardItem', '99', '0', '0', '0', '316', '61511', '9016', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306213', 'Velveteen Acton Body (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '316', '61512', '9016', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306214', 'Velveteen Acton Body (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '316', '61514', '9016', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306215', 'Velveteen Acton Body (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '316', '61515', '9016', '1', '0', '0', '0', '0', '32', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306216', 'Canvas Coatee Body', 'Normal/StandardItem', '99', '0', '0', '0', '288', '61506', '9009', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306217', 'Canvas Coatee Body (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '288', '61507', '9009', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306218', 'Canvas Coatee Body (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '288', '61508', '9009', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306219', 'Canvas Coatee Body (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '288', '61509', '9009', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306220', 'Canvas Coatee Body (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '288', '61510', '9009', '1', '0', '0', '0', '0', '29', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306221', 'Velveteen Coatee Body', 'Normal/StandardItem', '99', '0', '0', '0', '384', '61511', '9009', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306222', 'Velveteen Coatee Body (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '384', '61512', '9009', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306223', 'Velveteen Coatee Body (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '384', '61513', '9009', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306224', 'Velveteen Coatee Body (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '384', '61514', '9009', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306225', 'Velveteen Coatee Body (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '384', '61515', '9009', '1', '0', '0', '0', '0', '39', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306226', 'Linen Coatee Body', 'Normal/StandardItem', '99', '0', '0', '0', '480', '61516', '9009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306227', 'Linen Coatee Body (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '480', '61517', '9009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306228', 'Linen Coatee Body (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '480', '61518', '9009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306229', 'Linen Coatee Body (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '480', '61519', '9009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10306230', 'Linen Coatee Body (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '480', '61520', '9009', '1', '0', '0', '0', '0', '49', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307001', 'Hempen Inner Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307002', 'Hempen Inner Cowl (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307003', 'Hempen Inner Cowl (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307004', 'Hempen Inner Cowl (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307005', 'Cotton Inner Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307006', 'Cotton Inner Cowl (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307007', 'Cotton Inner Cowl (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307008', 'Cotton Inner Cowl (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307009', 'Cotton Inner Cowl (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307010', 'Velveteen Inner Cowl', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307011', 'Velveteen Inner Cowl (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307012', 'Velveteen Inner Cowl (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307013', 'Velveteen Inner Cowl (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307014', 'Velveteen Inner Cowl (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307101', 'Hempen Inner Dalmatica', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307102', 'Hempen Inner Dalmatica (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307103', 'Hempen Inner Dalmatica (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307104', 'Hempen Inner Dalmatica (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307105', 'Cotton Inner Dalmatica', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307106', 'Cotton Inner Dalmatica (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307107', 'Cotton Inner Dalmatica (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307108', 'Cotton Inner Dalmatica (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307201', 'Hempen Inner Gown', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307202', 'Hempen Inner Gown (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307203', 'Hempen Inner Gown (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307204', 'Hempen Inner Gown (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307205', 'Cotton Inner Gown', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307206', 'Cotton Inner Gown (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307207', 'Cotton Inner Gown (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307208', 'Cotton Inner Gown (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307301', 'Hempen Inner Tunic', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307302', 'Hempen Inner Tunic (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307303', 'Hempen Inner Tunic (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307304', 'Cotton Inner Tunic', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61421', '9010', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307305', 'Cotton Inner Tunic (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307306', 'Cotton Inner Tunic (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307307', 'Cotton Inner Tunic (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307308', 'Cotton Inner Tunic (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9010', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307309', 'Velveteen Inner Tunic', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9010', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307401', 'Hempen Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307402', 'Hempen Sleeves (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307403', 'Hempen Sleeves (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307404', 'Hempen Sleeves (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307405', 'Cotton Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307406', 'Cotton Sleeves (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307407', 'Cotton Sleeves (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307408', 'Cotton Sleeves (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307409', 'Cotton Sleeves (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307410', 'Canvas Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307411', 'Canvas Sleeves (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307412', 'Canvas Sleeves (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307413', 'Canvas Sleeves (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307414', 'Canvas Sleeves (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307415', 'Velveteen Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307416', 'Velveteen Sleeves (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307417', 'Velveteen Sleeves (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307418', 'Velveteen Sleeves (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307419', 'Velveteen Sleeves (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307501', 'Hempen Acton Sleeves (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307502', 'Hempen Acton Sleeves (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307503', 'Hempen Acton Sleeves (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9017', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307504', 'Cotton Acton Sleeves (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307505', 'Cotton Acton Sleeves (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307506', 'Cotton Acton Sleeves (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307507', 'Cotton Acton Sleeves (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9017', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307508', 'Canvas Acton Sleeves (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307509', 'Canvas Acton Sleeves (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307510', 'Canvas Acton Sleeves (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307511', 'Canvas Acton Sleeves (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9017', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307512', 'Velveteen Acton Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307513', 'Velveteen Acton Sleeves (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307514', 'Velveteen Acton Sleeves (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307515', 'Velveteen Acton Sleeves (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9017', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307601', 'Bronze Chainmail Vest', 'Normal/StandardItem', '99', '0', '0', '0', '105', '60740', '9018', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307602', 'Bronze Chain Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '105', '60740', '9018', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307603', 'Iron Chainmail Vest', 'Normal/StandardItem', '99', '0', '0', '0', '153', '60740', '9018', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307604', 'Iron Chain Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '153', '60740', '9018', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307605', 'Linen Sleeves', 'Normal/StandardItem', '99', '0', '0', '0', '393', '61516', '9017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307606', 'Linen Sleeves (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '393', '61517', '9017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307607', 'Linen Sleeves (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '393', '61518', '9017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307608', 'Linen Sleeves (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '393', '61519', '9017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307609', 'Linen Sleeves (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '393', '61520', '9017', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10307610', 'Woolen Sleeves (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '489', '61523', '9017', '1', '0', '0', '0', '0', '50', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308001', 'Hempen Doublet Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308002', 'Hempen Doublet Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308003', 'Hempen Doublet Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308004', 'Hempen Doublet Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308005', 'Cotton Doublet Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308006', 'Cotton Doublet Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308007', 'Cotton Doublet Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308008', 'Cotton Doublet Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308009', 'Cotton Doublet Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308010', 'Canvas Doublet Front', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308011', 'Canvas Doublet Front (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308012', 'Canvas Doublet Front (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308013', 'Canvas Doublet Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308014', 'Canvas Doublet Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308015', 'Velveteen Doublet Front', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308016', 'Velveteen Doublet Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308017', 'Velveteen Doublet Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308018', 'Velveteen Doublet Front (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308019', 'Velveteen Doublet Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308101', 'Hempen Robe Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308102', 'Hempen Robe Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308103', 'Hempen Robe Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308104', 'Hempen Robe Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308105', 'Cotton Robe Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308106', 'Cotton Robe Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308107', 'Cotton Robe Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308108', 'Cotton Robe Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308109', 'Cotton Robe Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308110', 'Canvas Robe Front', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308111', 'Canvas Robe Front (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308112', 'Canvas Robe Front (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308113', 'Canvas Robe Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308114', 'Canvas Robe Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308115', 'Velveteen Robe Front', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308116', 'Velveteen Robe Front (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308117', 'Velveteen Robe Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308118', 'Velveteen Robe Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308119', 'Velveteen Robe Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308201', 'Hempen Shirt Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308202', 'Hempen Shirt Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308203', 'Hempen Shirt Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308204', 'Hempen Shirt Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308205', 'Cotton Shirt Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308206', 'Cotton Shirt Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308207', 'Cotton Shirt Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308208', 'Cotton Shirt Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308209', 'Cotton Shirt Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308210', 'Velveteen Shirt Front', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308211', 'Velveteen Shirt Front (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308212', 'Velveteen Shirt Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308213', 'Velveteen Shirt Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308214', 'Velveteen Shirt Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308301', 'Hempen Tunic Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308302', 'Hempen Tunic Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308303', 'Hempen Tunic Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308304', 'Hempen Tunic Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308305', 'Cotton Tunic Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308306', 'Cotton Tunic Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308307', 'Cotton Tunic Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308308', 'Cotton Tunic Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308309', 'Cotton Tunic Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308310', 'Canvas Tunic Front', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308311', 'Canvas Tunic Front (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308312', 'Canvas Tunic Front (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308313', 'Canvas Tunic Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308314', 'Canvas Tunic Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308315', 'Velveteen Tunic Front', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308316', 'Velveteen Tunic Front (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308317', 'Velveteen Tunic Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308318', 'Velveteen Tunic Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308319', 'Velveteen Tunic Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308401', 'Hempen Halfrobe Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308402', 'Hempen Halfrobe Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308403', 'Hempen Halfrobe Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308404', 'Hempen Halfrobe Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308405', 'Cotton Halfrobe Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308406', 'Cotton Halfrobe Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308407', 'Cotton Halfrobe Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308408', 'Cotton Halfrobe Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308409', 'Cotton Halfrobe Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308410', 'Canvas Halfrobe Front', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308411', 'Canvas Halfrobe Front (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308412', 'Canvas Halfrobe Front (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308413', 'Canvas Halfrobe Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308414', 'Canvas Halfrobe Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308501', 'Hempen Tabard Front', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308502', 'Hempen Tabard Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308503', 'Hempen Tabard Front (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308504', 'Hempen Tabard Front (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9011', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308505', 'Cotton Tabard Front', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308506', 'Cotton Tabard Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308507', 'Cotton Tabard Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308508', 'Cotton Tabard Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308509', 'Cotton Tabard Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9011', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308510', 'Canvas Tabard Front', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308511', 'Canvas Tabard Front (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308512', 'Canvas Tabard Front (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308513', 'Canvas Tabard Front (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308514', 'Canvas Tabard Front (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9011', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308515', 'Velveteen Tabard Front', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308516', 'Velveteen Tabard Front (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308517', 'Velveteen Tabard Front (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308518', 'Velveteen Tabard Front (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308519', 'Velveteen Tabard Front (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9011', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10308520', 'Dodore Leather Doublet Front', 'Normal/StandardItem', '99', '0', '0', '0', '441', '61530', '9011', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309001', 'Hempen Doublet Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309002', 'Hempen Doublet Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309003', 'Hempen Doublet Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309004', 'Hempen Doublet Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309005', 'Cotton Doublet Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309006', 'Cotton Doublet Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309007', 'Cotton Doublet Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309008', 'Cotton Doublet Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309009', 'Cotton Doublet Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309010', 'Canvas Doublet Back', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309011', 'Canvas Doublet Back (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309012', 'Canvas Doublet Back (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309013', 'Canvas Doublet Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309014', 'Canvas Doublet Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309015', 'Velveteen Doublet Back', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309016', 'Velveteen Doublet Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309017', 'Velveteen Doublet Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309018', 'Velveteen Doublet Back (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309019', 'Velveteen Doublet Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309101', 'Hempen Robe Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309102', 'Hempen Robe Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309103', 'Hempen Robe Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309104', 'Hempen Robe Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309105', 'Cotton Robe Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309106', 'Cotton Robe Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309107', 'Cotton Robe Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309108', 'Cotton Robe Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309109', 'Cotton Robe Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309110', 'Canvas Robe Back', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309111', 'Canvas Robe Back (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309112', 'Canvas Robe Back (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309113', 'Canvas Robe Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309114', 'Canvas Robe Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309115', 'Velveteen Robe Back', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309116', 'Velveteen Robe Back (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309117', 'Velveteen Robe Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309118', 'Velveteen Robe Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309119', 'Velveteen Robe Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309201', 'Hempen Shirt Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309202', 'Hempen Shirt Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309203', 'Hempen Shirt Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309204', 'Hempen Shirt Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309205', 'Cotton Shirt Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309206', 'Cotton Shirt Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309207', 'Cotton Shirt Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309208', 'Cotton Shirt Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309209', 'Cotton Shirt Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309210', 'Velveteen Shirt Back', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309211', 'Velveteen Shirt Back (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309212', 'Velveteen Shirt Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309213', 'Velveteen Shirt Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309214', 'Velveteen Shirt Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309301', 'Hempen Tunic Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309302', 'Hempen Tunic Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309303', 'Hempen Tunic Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309304', 'Hempen Tunic Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309305', 'Cotton Tunic Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309306', 'Cotton Tunic Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309307', 'Cotton Tunic Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309308', 'Cotton Tunic Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309309', 'Cotton Tunic Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309310', 'Canvas Tunic Back', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309311', 'Canvas Tunic Back (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309312', 'Canvas Tunic Back (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309313', 'Canvas Tunic Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309314', 'Canvas Tunic Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309315', 'Velveteen Tunic Back', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309316', 'Velveteen Tunic Back (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309317', 'Velveteen Tunic Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309318', 'Velveteen Tunic Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309319', 'Velveteen Tunic Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309401', 'Hempen Halfrobe Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309402', 'Hempen Halfrobe Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309403', 'Hempen Halfrobe Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309404', 'Hempen Halfrobe Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309405', 'Cotton Halfrobe Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309406', 'Cotton Halfrobe Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309407', 'Cotton Halfrobe Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309408', 'Cotton Halfrobe Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309409', 'Cotton Halfrobe Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309410', 'Canvas Halfrobe Back', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309411', 'Canvas Halfrobe Back (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309412', 'Canvas Halfrobe Back (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309413', 'Canvas Halfrobe Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309414', 'Canvas Halfrobe Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309501', 'Hempen Tabard Back', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309502', 'Hempen Tabard Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309503', 'Hempen Tabard Back (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309504', 'Hempen Tabard Back (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9012', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309505', 'Cotton Tabard Back', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309506', 'Cotton Tabard Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309507', 'Cotton Tabard Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309508', 'Cotton Tabard Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309509', 'Cotton Tabard Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9012', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309510', 'Canvas Tabard Back', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309511', 'Canvas Tabard Back (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309512', 'Canvas Tabard Back (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309513', 'Canvas Tabard Back (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309514', 'Canvas Tabard Back (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9012', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309515', 'Velveteen Tabard Back', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309516', 'Velveteen Tabard Back (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309517', 'Velveteen Tabard Back (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309518', 'Velveteen Tabard Back (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309519', 'Velveteen Tabard Back (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9012', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10309520', 'Dodore Leather Doublet Back', 'Normal/StandardItem', '99', '0', '0', '0', '441', '61530', '9012', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310001', 'Sheepskin Outsoles', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61526', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310002', 'Sheepskin Outsoles (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61527', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310003', 'Sheepskin Outsoles (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61528', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310004', 'Dodoskin Outsoles', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310005', 'Dodoskin Outsoles (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61530', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310006', 'Leather Outsoles', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310007', 'Leather Outsoles (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310008', 'Leather Outsoles (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310009', 'Leather Outsoles (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310010', 'Leather Outsoles (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310011', 'Toadskin Outsoles', 'Normal/StandardItem', '99', '0', '0', '0', '260', '61536', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310012', 'Toadskin Outsoles (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '260', '61537', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310101', 'Sheepskin Vamps', 'Normal/StandardItem', '99', '0', '0', '0', '11', '61526', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310102', 'Sheepskin Vamps (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '11', '61527', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310103', 'Sheepskin Vamps (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '11', '61528', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310104', 'Dodoskin Vamps', 'Normal/StandardItem', '99', '0', '0', '0', '16', '61529', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310105', 'Leather Vamps', 'Normal/StandardItem', '99', '0', '0', '0', '21', '61531', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310106', 'Leather Vamps (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '21', '61534', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310107', 'Leather Vamps (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '21', '61533', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310108', 'Leather Vamps (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '21', '61532', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310109', 'Leather Vamps (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '21', '61535', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310110', 'Toadskin Vamps', 'Normal/StandardItem', '99', '0', '0', '0', '26', '61536', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310111', 'Toadskin Vamps (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '26', '61537', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310201', 'Dodoskin Shin Guards', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61530', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310202', 'Leather Shin Guards', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310203', 'Leather Shin Guards (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310204', 'Leather Shin Guards (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310205', 'Leather Shin Guards (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '20', '61422', '9007', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310206', 'Leather Shin Guards (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310301', 'Hempen Socks', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310302', 'Hempen Socks (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310303', 'Hempen Socks (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310304', 'Hempen Socks (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310305', 'Cotton Socks', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310306', 'Cotton Socks (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310307', 'Cotton Socks (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310308', 'Cotton Socks (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310309', 'Cotton Socks (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310310', 'Canvas Socks', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61506', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310311', 'Canvas Socks (Auburn)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61507', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310312', 'Canvas Socks (Pink)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61508', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310313', 'Canvas Socks (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310314', 'Canvas Socks (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310315', 'Velveteen Socks', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9007', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310316', 'Velveteen Socks (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9007', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310317', 'Velveteen Socks (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9007', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310318', 'Velveteen Socks (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9007', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310319', 'Velveteen Socks (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9007', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310401', 'Sheepskin Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61526', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310402', 'Sheepskin Knee Pads (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61527', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310403', 'Sheepskin Knee Pads (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61528', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310404', 'Dodoskin Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310405', 'Dodoskin Knee Pads (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61530', '9007', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310406', 'Leather Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310407', 'Leather Knee Pads (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61534', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310408', 'Leather Knee Pads (Ochre)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61533', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310409', 'Leather Knee Pads (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61532', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310410', 'Leather Knee Pads (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61535', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310411', 'Toadskin Knee Pads', 'Normal/StandardItem', '99', '0', '0', '0', '260', '61536', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310412', 'Toadskin Knee Pads (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '260', '61537', '9007', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310501', 'Copper Toes', 'Normal/StandardItem', '99', '0', '0', '0', '200', '61346', '9007', '1', '0', '0', '0', '0', '7', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310502', 'Brass Toes', 'Normal/StandardItem', '99', '0', '0', '0', '325', '61346', '9007', '1', '0', '0', '0', '0', '12', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310503', 'Iron Toes', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9007', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310504', 'Silver Toes', 'Normal/StandardItem', '99', '0', '0', '0', '700', '61346', '9007', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310511', 'Bronze Cuisses', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310512', 'Iron Cuisses', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310521', 'Bronze Poleyns', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310522', 'Iron Poleyns', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310531', 'Bronze Greaves', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310532', 'Iron Greaves', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310541', 'Bronze Chain Chausses', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9007', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10310542', 'Iron Chain Chausses', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9007', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311001', 'Hempen Hood', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61498', '9006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311002', 'Hempen Hood (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61499', '9006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311003', 'Hempen Hood (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61500', '9006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311004', 'Hempen Hood (Beige)', 'Normal/StandardItem', '99', '0', '0', '0', '105', '61501', '9006', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311005', 'Cotton Hood', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61421', '9006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311006', 'Cotton Hood (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61502', '9006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311007', 'Cotton Hood (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61503', '9006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311008', 'Cotton Hood (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61504', '9006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311009', 'Cotton Hood (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '201', '61505', '9006', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311010', 'Canvas Hood (Brown)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61509', '9006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311011', 'Canvas Hood (Blue)', 'Normal/StandardItem', '99', '0', '0', '0', '249', '61510', '9006', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311012', 'Velveteen Hood', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61511', '9006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311013', 'Velveteen Hood (Black)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61512', '9006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311014', 'Velveteen Hood (Red)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61513', '9006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311015', 'Velveteen Hood (Yellow)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61514', '9006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311016', 'Velveteen Hood (Green)', 'Normal/StandardItem', '99', '0', '0', '0', '297', '61515', '9006', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311101', 'Rat Fur Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '90', '61539', '9019', '1', '0', '0', '0', '0', '8', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311102', 'Squirrel Fur Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '140', '61540', '9019', '1', '0', '0', '0', '0', '13', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311103', 'Marmot Fur Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '190', '61541', '9019', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311104', 'Sheepskin Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61526', '9020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311105', 'Sheepskin Neck Guard (Taupe)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61527', '9020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311106', 'Sheepskin Neck Guard (Grey)', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61528', '9020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311107', 'Dodoskin Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311108', 'Canvas Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '190', '61506', '9006', '1', '0', '0', '0', '0', '18', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311109', 'Copper Throat Guard', 'Normal/StandardItem', '99', '0', '0', '0', '150', '61346', '9021', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311110', 'Bronze Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311111', 'Iron Neck Guard', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311201', 'Sheep Leather Inner Mitts', 'Normal/StandardItem', '99', '0', '0', '0', '110', '61526', '9020', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311202', 'Dodo Leather Inner Mitts', 'Normal/StandardItem', '99', '0', '0', '0', '160', '61529', '9020', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311203', 'Buffalo Leather Inner Mitts', 'Normal/StandardItem', '99', '0', '0', '0', '210', '61531', '9020', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311204', 'Bronze Throat Guard', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311205', 'Wolf Collar', 'Normal/StandardItem', '99', '0', '0', '0', '625', '61346', '9021', '1', '0', '0', '0', '0', '24', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311206', 'Drake Collar', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9021', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311207', 'Black Odoshi Cord', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9006', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311208', 'Blue Odoshi Cord', 'Normal/StandardItem', '99', '0', '0', '0', '192', '61346', '9006', '1', '0', '0', '0', '0', '19', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311211', 'Copper Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '4', '60748', '9022', '1', '0', '0', '0', '0', '5', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311212', 'Bronze Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '8', '60748', '9022', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311213', 'Brass Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '12', '60748', '9022', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311214', 'Iron Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '15', '60748', '9022', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311215', 'Silver Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '19', '60748', '9022', '1', '0', '0', '0', '0', '25', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311216', 'Darksilver Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '21', '60748', '9022', '1', '0', '0', '0', '0', '28', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311217', 'Electrum Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '30', '60748', '9022', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311218', 'Mythril Buckle', 'Normal/StandardItem', '99', '0', '0', '0', '34', '60748', '9022', '1', '0', '0', '0', '0', '45', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311221', 'Brass Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '400', '60748', '9022', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311222', 'Silver Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '525', '60748', '9022', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311223', 'White Coral Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '930', '60748', '9022', '1', '0', '0', '0', '0', '30', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311224', 'Blue Coral Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '1080', '60748', '9022', '1', '0', '0', '0', '0', '35', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311225', 'Red Coral Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '1230', '60748', '9022', '1', '0', '0', '0', '0', '40', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311226', 'Nephrite Breastpin', 'Normal/StandardItem', '99', '0', '0', '0', '1140', '60748', '9022', '1', '0', '0', '0', '0', '37', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311231', 'Bronze Celata Visor', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311232', 'Iron Celata Visor', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311233', 'Iron Barbut Visor', 'Normal/StandardItem', '99', '0', '0', '0', '575', '61346', '9021', '1', '0', '0', '0', '0', '22', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311234', 'Kabuto Mask', 'Normal/StandardItem', '99', '0', '0', '0', '700', '61346', '9021', '1', '0', '0', '0', '0', '27', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311241', 'Bronze Couters', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311242', 'Iron Couters', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311251', 'Bronze Rerebraces', 'Normal/StandardItem', '99', '0', '0', '0', '275', '61346', '9021', '1', '0', '0', '0', '0', '10', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311252', 'Iron Rerebraces', 'Normal/StandardItem', '99', '0', '0', '0', '525', '61346', '9021', '1', '0', '0', '0', '0', '20', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('10311261', 'Brass Vambrace Plates', 'Normal/StandardItem', '99', '0', '0', '0', '400', '61346', '9021', '1', '0', '0', '0', '0', '15', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000001', 'Balloonfish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000002', 'Standard-Issue Flintlock', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000003', 'Faerie Remora', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000004', 'Naldiq Gramophone Case', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000005', 'Naldiq Trembler', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000006', 'Naldiq Coil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000007', 'Naldiq Horn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000008', 'Vymelli Gramophone Case', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000009', 'Vymelli Trembler', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000010', 'Vymelli Coil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000011', 'Vymelli Horn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000012', 'Sheep\'s-eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000013', 'Petrified Wood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000014', 'Ewer Fragment', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000015', 'Twisted Aldgoat Horn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000016', 'Alchemical Pheromones', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000017', 'Ladybug Tears', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000018', 'Spiny Turnip Leaves', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000019', 'Counterfeit Chip Mold', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000020', 'Bronze Kraken Key', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000021', 'Leather Chocobo Saddle', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000022', 'Whistling Windwheel', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000023', 'Seastone', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000024', 'Reverberating Steel', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000025', 'Barrel Feed', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000026', 'Vibrant Arrows', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000027', 'Sable Salve', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000028', 'Gods\' Quiver Petition', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000029', 'Colorful Building Block', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000030', 'Writ of Access', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000031', 'Seaspray Quiche', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000032', 'Mirage Token', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000033', 'Deep-red Ruby', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000034', 'Skull Island', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000035', 'Aged Rum', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000036', 'Far Eastern Sourleaf', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000037', 'Frondale\'s Funds', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000038', 'Penelope\'s Background', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000039', 'Penelope\'s Evaluation', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000040', 'Oak Atrium Ghost', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000041', 'Starfall Grass', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000042', 'Pirate Ship Tale', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000043', 'Yarzon Faeces', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000044', 'Damaged Wailer Armor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000045', 'Repaired Wailer Armor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000046', 'Armor Remnants', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000047', 'Fen-Yll Birkin Bag', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000048', 'Damaged Fen-Yll Boots', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000049', 'Vintage Fen-Yll Boots', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000050', 'Bronze Earplug Mold', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000051', 'Bronze Earplug Casing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000052', 'Sound-proofing Rubber', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000053', 'Admiral Alloy', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000054', 'Red Riding Hood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000055', 'Ripped Riding Hood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000056', 'Luxurious Gloves', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000057', 'Thanalan Spider Silk', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000058', 'Blooming Bow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000059', 'Supple Bow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000060', 'Sturdy Bow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000061', 'Splintered Bow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000062', 'Blooming Branch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000063', 'Supple Branch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000064', 'Sturdy Branch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000065', 'Fairweather Fetish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000066', 'Large Leaf', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000067', 'Atrium Arrow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000068', 'Light Branch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000069', 'Piping Hot Pie Crust', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000070', 'Aromatic Pate', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000071', 'Devilbelly Meatball', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000072', 'Devilshroom', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000073', 'Foulbelly Meatball', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000074', 'Queer-smelling Meat', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000075', 'Sweet-smelling Spice', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000076', 'Mummified Mole', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000077', 'Potent Medication', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000078', 'Frondale\'s Poultice', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000079', 'Faustigeant\'s Salve', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000080', 'Brass Earplugs', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000081', 'Niellefresne\'s Gold Dust', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000082', 'Wind Ward', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000083', 'Earth Ward', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000084', 'Water Ward', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000085', 'Nostalgic Ink', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000086', 'Bowing Pine Branch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000087', 'Foul-smelling Nut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000088', 'Treant Vine', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000089', 'Velodyna Cosmos', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000090', 'Purification Mask', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000091', 'Podling', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000092', 'Balloon Cargo', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000093', 'Ixal Diary', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000094', 'Amalj\'aa Ashes', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000095', 'Crystal Bag', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000096', 'Unaspected Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000097', 'King of Plots\'s Gil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000098', 'Wise Miser\'s Gil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000099', 'Lady Lewena\'s Gil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000100', 'Shiny Chip', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000101', 'Mysterious Leather Bag', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000102', 'Charred Red Newt', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000103', 'Bent Glasses', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000104', 'Island Coconut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000105', 'Mimidoa Drill', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000106', 'Mimidoa Barrow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000107', 'Mimidoa Rivet', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000108', 'Z\'ssapa\'s Brooch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000109', 'Brooch Pin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000110', 'Adorable Miner Sketch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000111', 'Graceful Miner Sketch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000112', 'Dashing Miner Sketch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000113', 'Ideal Miner Sketch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000114', 'Violet Augite', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000115', 'Mismatched Stones', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000116', 'Heartstrike Replica', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000117', 'Pure Metal Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000118', 'Brilliant Glass Shards', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000119', 'Silverwater', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000120', 'Sealed Correspondence', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000121', 'Amajina Silver Nuggets', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000122', 'Shattered Brooch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000123', 'Pearl Clover Blossom', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000124', 'F\'lhaminn\'s Flower', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000125', 'Baderon\'s Recommendation', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000126', 'Coliseum Pass', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000127', 'Pixie Remora', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000128', 'Pearl Clover Seeds', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000129', 'Pearl Clover Fruit', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000130', 'Trident Map', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000131', 'Pirate Ship Funds', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000132', 'Kraken Register', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000133', 'Wawalago Message', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000134', 'Platinum Mirage Ledger', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000135', 'Meracydian Olives', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000136', 'Letter to Nenekko', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000137', 'Amajina Ceruleum', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000138', 'Pearl Clover Seedling', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000139', 'Midnight Slippers', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000140', 'Ceruleum Compound', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000141', 'Heated Gallipot', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000142', 'Tinolqa Popoto', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000143', 'Blinking Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000144', 'Silky-smooth Marmot Hide', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000145', 'Tawdry Torque', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000146', 'Cedar Marionette', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000147', 'Nacre Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000148', 'Reaver Wristlet', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000149', 'Musk Roseling Pollen', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000150', 'Beryl Crab Shell', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000151', 'White Ash', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000152', 'Wolf Tail Trophy', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000153', 'Cursed Lens', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000154', 'Slumber Nut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000155', 'Skryvner Signet Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000156', 'Sunsilk Muslin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000157', 'Milkworm', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000158', 'Thanalan Natron', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000159', 'Menphina Stew', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000160', 'Lonsygg\'s Journal Scrap', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000161', 'Weaver Lily', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000162', 'Treehollow Brew', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000163', 'SÃ©ance Stone', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000164', 'Sable Tooth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000165', 'Novice\'s Clasp', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000166', 'Theda\'s Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000167', 'List of Companions', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000168', 'List of Champions', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000169', 'List of the Impoverished', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000170', 'List of Adoring Masses', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000171', 'List of the Elite', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000172', 'Milvaneth Talisman', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000173', 'Barbarous Choker', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000174', 'Conch Shell', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000175', 'Arrest Warrant', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000176', 'Fishtack', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000177', 'Sheepbur Seed', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000178', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000179', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000180', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000181', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000182', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000183', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000184', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000185', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000186', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000187', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000188', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000189', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000190', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000191', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000192', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000193', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000194', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000195', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000196', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000197', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000198', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000199', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000200', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000201', 'Lassae Ledger', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000202', 'Sourleaf Nectar', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000203', 'Death Sentence', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000204', 'Redbelly Wasp Map', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000205', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000206', 'Yellow Marble', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000207', 'Radz-at-Han Reserve', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000208', 'Airship Pass (GRD-LMS)', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000209', 'Airship Pass (ULD-LMS)', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000210', 'Fossil-fused Dark Matter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000211', 'Keystone of the Bloom', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000212', 'Keystone of the Bud', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000213', 'Keystone of the Bough', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000214', 'Keystone of the Leaf', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000215', 'Keystone of the Trunk', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000216', 'Keystones', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000217', 'Ensorcelled Snowball', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000218', 'Heart of Winter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000219', 'Young Dodo Leather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000220', 'Bloody Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000221', 'Needle Box', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000222', 'Sibold\'s Bouquet', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000223', 'Inkwell', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000224', 'Well-worn Bag', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000225', 'Divine Impetus', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000226', 'Coblyn Larva', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000227', 'Brass Kobold Strongbox Key', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000228', 'Mistbeard Insignia Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000229', 'Mottled Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000230', 'Bomb Bane', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000231', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000232', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000233', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000234', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000235', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000236', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000237', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000238', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000239', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000240', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000241', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000242', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000243', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000244', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000245', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000246', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000247', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000248', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000249', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000250', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000251', 'Ailith\'s Oath', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000252', 'Taylor\'s Letter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000253', 'Woolvale Arms Contract', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000254', 'Signed Agreement', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000255', 'Straight Edge Traders Contract', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000256', 'Gigas Forge Contract', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000257', 'Imperial Letter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000258', 'Magitek Designs', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000259', 'Magitek Transceiver', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000260', 'Magitek Recording Plate', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000261', 'Shattered Gauntlet', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000262', 'Magitek Cooling Plate', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000263', 'Blackened Accumulator', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000264', 'Draconian Rosary', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000265', 'Norwick Knight\'s Sigil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000266', 'Silver-winged Kabuto', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000267', 'Stillglade Fane Petition', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000268', 'Sealed Urn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000269', 'Faces of Mercy Medallion', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000270', 'Magitek Dowsing Rod', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000271', 'Ceremony Invitation', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000272', 'Earthbreaker', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000273', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000274', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000275', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000276', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000277', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000278', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000279', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000280', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000281', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000282', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000283', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000284', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000285', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000286', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000287', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000288', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000289', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000290', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000291', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000292', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000293', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000294', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000295', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000296', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000297', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000298', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000299', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000300', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000301', 'Mature Funguar Spore Sac', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000302', 'Scarlet Oil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000303', 'Stinky Yellow Liquid', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000304', 'Althyk Lavender', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000305', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000306', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000307', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000308', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000309', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000310', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000311', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000312', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000313', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000314', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000315', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000316', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000317', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000318', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000319', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000320', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000321', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000322', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000323', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000324', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000325', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000326', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000327', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000328', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000329', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000330', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000331', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000332', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000333', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000334', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000335', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000336', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000337', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000338', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000339', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000340', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000341', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000342', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000343', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000344', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000345', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000346', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000347', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000348', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000349', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000350', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000351', 'Inferno Lamp', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000352', 'Vortex Fletchings', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000353', 'Timeworn Curtana', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000354', 'Timeworn Sphairai', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000355', 'Timeworn Bravura', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000356', 'Timeworn Gae Bolg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000357', 'Timeworn Artemis Bow', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000358', 'Timeworn Thyrus', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000359', 'Timeworn Stardust Rod', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000360', 'The Song of Tristram', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000361', 'Enter the Coeurl', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000362', 'The Warrior Within', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000363', 'The Book of Reinette', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000364', 'Bow of the Gods', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000365', 'Interview with the Padjal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000366', 'On Verdant Pond', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000367', 'White-hot Ember', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000368', 'Howling Gale', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000369', 'Relic Weapon', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000370', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000371', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000372', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000373', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000374', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000375', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000376', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000377', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000378', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000379', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000380', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000381', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000382', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000383', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000384', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000385', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000386', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000387', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000388', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000389', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000390', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000391', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000392', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000393', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000394', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000395', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000396', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000397', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000398', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000399', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000400', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000401', 'Leather Armor Scrap', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000402', 'Hypnotic Scales', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000403', 'Sketch of Challinie', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000404', 'Cobalt Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000405', 'Prismatic Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000406', 'Omnomite', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000407', 'Dart Slug Anti-venom', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000408', 'Coblyn Choler', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000409', 'Leather Balloon Panel', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000410', 'Treated Kite Plume', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000411', 'Eye of Garuda', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000412', 'Tears of Nymeia', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000413', 'Wind Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000414', 'Water Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000415', 'Earth Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000416', 'Lightning Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000417', 'Ice Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000418', 'Fire Echo Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000419', 'Inferno Flambeau', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000420', 'Harmonizing Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000421', 'Imperial Disruptor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000422', 'Mist Emitter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000423', 'Imperial Disruptor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000424', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000425', 'War Merit', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000426', 'War Merit', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000427', 'War Merit', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000428', 'Magitek Amplifier', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000429', 'Nightshade Oil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000430', 'Suncake', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000431', 'Vortex Feather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000432', 'Vortex Catcher', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000433', 'Garlean Schematics', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000434', 'Imperial Strongbox Key', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000435', 'Kan-E-Senna\'s Missive', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000436', 'Merlwyb\'s Missive', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000437', 'Raubahn\'s Missive', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000438', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000439', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000440', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000441', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000442', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000443', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000444', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000445', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000446', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000447', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000448', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000449', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000450', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000451', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000452', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000453', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000454', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000455', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000456', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000457', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000458', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000459', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000460', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000461', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000462', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000463', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000464', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000465', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000466', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000467', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000468', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000469', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000470', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000471', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000472', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000473', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000474', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000475', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000476', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000477', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000478', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000479', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000480', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000481', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000482', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000483', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000484', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000485', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000486', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000487', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000488', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000489', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000490', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000491', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000492', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000493', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000494', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000495', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000496', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000497', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000498', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000499', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000500', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000501', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000502', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000503', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000504', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000505', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000506', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000507', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000508', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000509', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000510', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000511', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000512', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000513', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000514', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000515', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000516', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000517', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000518', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000519', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000520', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000521', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000522', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000523', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000524', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000525', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000526', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000527', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000528', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000529', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000530', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000531', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000532', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000533', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000534', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000535', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000536', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000537', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000538', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000539', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000540', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000541', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000542', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000543', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000544', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000545', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000546', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000547', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000548', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000549', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000550', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000551', 'Nirvana', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000552', 'Brand-new Aetheriometer', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000553', 'Outdated Aetheriometer', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000554', 'Widargelt\'s Aetheriometer', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000555', 'Experimental Aetheriometer', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000556', 'Gem of Shatotto', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000557', 'Pukno Poki\'s Charm', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000558', 'Engraved Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000559', 'Ashes of the Fallen', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000560', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000561', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000562', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000563', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000564', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000565', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000566', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000567', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000568', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000569', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000570', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000571', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000572', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000573', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000574', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000575', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000576', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000577', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000578', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000579', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000580', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000581', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000582', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000583', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000584', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000585', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000586', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000587', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000588', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000589', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000590', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000591', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000592', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000593', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000594', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000595', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000596', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000597', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000598', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000599', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000600', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000601', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000602', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000603', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000604', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000605', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000606', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000607', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000608', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000609', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000610', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000611', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000612', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000613', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000614', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000615', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000616', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000617', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000618', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000619', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000620', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000621', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000622', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000623', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000624', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000625', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000626', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000627', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000628', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000629', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000630', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000631', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000632', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000633', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000634', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000635', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000636', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000637', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000638', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000639', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000640', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000641', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000642', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000643', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000644', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000645', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000646', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000647', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000648', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000649', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000650', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000651', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000652', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000653', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000654', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000655', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000656', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000657', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000658', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000659', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000660', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000661', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000662', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000663', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000664', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000665', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000666', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000667', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000668', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000669', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000670', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000671', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000672', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000673', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000674', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000675', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000676', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000677', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000678', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000679', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000680', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000681', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000682', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000683', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000684', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000685', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000686', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000687', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000688', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000689', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000690', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000691', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000692', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000693', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000694', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000695', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000696', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000697', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000698', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000699', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000700', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000701', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000702', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000703', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000704', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000705', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000706', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000707', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000708', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000709', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000710', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000711', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000712', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000713', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000714', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000715', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000716', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000717', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000718', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000719', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000720', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000721', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000722', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000723', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000724', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000725', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000726', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000727', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000728', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000729', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000730', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000731', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000732', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000733', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000734', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000735', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000736', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000737', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000738', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000739', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000740', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000741', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000742', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000743', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000744', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000745', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000746', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000747', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000748', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000749', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000750', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000751', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000752', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000753', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000754', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000755', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000756', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000757', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000758', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000759', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000760', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000761', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000762', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000763', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000764', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000765', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000766', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000767', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000768', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000769', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000770', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000771', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000772', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000773', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000774', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000775', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000776', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000777', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000778', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000779', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000780', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000781', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000782', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000783', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000784', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000785', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000786', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000787', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000788', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000789', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000790', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000791', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000792', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000793', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000794', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000795', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000796', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000797', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000798', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000799', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000800', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000801', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000802', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000803', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000804', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000805', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000806', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000807', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000808', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000809', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000810', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000811', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000812', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000813', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000814', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000815', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000816', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000817', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000818', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000819', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000820', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000821', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000822', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000823', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000824', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000825', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000826', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000827', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000828', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000829', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000830', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000831', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000832', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000833', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000834', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000835', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000836', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000837', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000838', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000839', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000840', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000841', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000842', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000843', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000844', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000845', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000846', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000847', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000848', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000849', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000850', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000851', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000852', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000853', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000854', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000855', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000856', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000857', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000858', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000859', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000860', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000861', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000862', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000863', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000864', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000865', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000866', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000867', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000868', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000869', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000870', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000871', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000872', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000873', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000874', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000875', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000876', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000877', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000878', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000879', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000880', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000881', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000882', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000883', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000884', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000885', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000886', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000887', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000888', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000889', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000890', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000891', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000892', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000893', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000894', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000895', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000896', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000897', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000898', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000899', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000900', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000901', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000902', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000903', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000904', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000905', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000906', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000907', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000908', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000909', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000910', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000911', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000912', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000913', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000914', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000915', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000916', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000917', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000918', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000919', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000920', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000921', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000922', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000923', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000924', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000925', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000926', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000927', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000928', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000929', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000930', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000931', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000932', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000933', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000934', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000935', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000936', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000937', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000938', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000939', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000940', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000941', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000942', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000943', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000944', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000945', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000946', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000947', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000948', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000949', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000950', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000951', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000952', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000953', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000954', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000955', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000956', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000957', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000958', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000959', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000960', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000961', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000962', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000963', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000964', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000965', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000966', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000967', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000968', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000969', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000970', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000971', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000972', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000973', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000974', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000975', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000976', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000977', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000978', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000979', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000980', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000981', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000982', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000983', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000984', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000985', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000986', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000987', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000988', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000989', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000990', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000991', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000992', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000993', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000994', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000995', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000996', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000997', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000998', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('11000999', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000001', 'Faded \"\"Necrologos\"\" Page', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000002', 'Torn \"\"Necrologos\"\" Page', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000003', 'Charred \"\"Necrologos\"\" Page', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000004', 'The \"\"Necrologos\"\"', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000005', 'Mystic Gem', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000006', 'Wisp Dust', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000007', 'Bomb Shrapnel', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000008', 'Poison Pollen', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000009', 'Stolen Cargo', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000010', 'Fish Bone', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000011', 'Sweet Pollen', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000012', 'Elemental Shard', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000013', 'Natural Poison', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000014', 'Lemming Tail', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000015', 'Puk Wing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000016', 'Bat Wing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000017', 'Mermaid Charm', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000018', 'Rod', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000019', 'Flowersbreath', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000020', 'Gewgaw', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000021', 'Scalepuk Skin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000022', 'Butterfly Nuts', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000023', 'Nipper Shell', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000024', 'Nightwolf Hide', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000025', 'Stray Dodo Feather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000026', 'Game Dodo Meat', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000027', 'Flowering Roseling Petal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000028', 'Ocean Roseling Leaf', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000029', 'Dorbeetle Egg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000030', 'Bloodbeetle Wing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000031', 'Gorgebug Mandible', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000032', 'Plague Rat Tooth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000033', 'Pack Rat Tail', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000034', 'Wingrat Wing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000035', 'Rabid Wingrat Blood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000036', 'Boggart Robe', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000037', 'Seadevil Filet', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000038', 'Jellyfish Stinger', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000039', 'Bloodless Chiglet Carcass', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000040', 'Carrion Chiglet Humours', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000041', 'Tiny Bauble', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000042', 'Plague Rat Tooth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000043', 'Scalepuk Talon', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000044', 'Bat Skin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000045', 'Blue Yarzon Offal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000046', 'Aldgoat Sirloin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000047', 'Red Landtrap Vine', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000048', 'Blue Landtrap Vine', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000049', 'Floatstone', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000050', 'Cogwheel Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000051', 'Kidney Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000052', 'Fire Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000053', 'Ice Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000054', 'Wind Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000055', 'Earth Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000056', 'Lightning Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000057', 'Water Orb', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000058', 'Bent Silver Ingot', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000059', 'Blackmarket Bog Pepper', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000060', 'Lightweight Flint Stones', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000061', 'High-quality Copper Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000062', 'High-quality Saltpeter', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000063', 'High-quality Iron Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000064', 'Honeybee Hive', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000065', 'Unknotted Ash Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000066', 'Unknotted Teak Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000067', 'Unknotted Oak Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000068', 'Lancaster Cargo', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000069', 'Foreign Mythrilshells', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000070', 'Empty Flask', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000071', 'Goblin Sweetbox', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000072', 'Lominsan Armor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000073', 'Shiva\'s Tear', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000074', 'Spriggan Gold', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000075', 'Soil Sample', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000076', 'Antling Egg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000077', 'Red Rose Airship Cargo', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000078', 'Deadfire Flintlock', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000079', 'Striped Tail', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000080', 'Antelope Tail', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000081', 'Hippocerf Beak', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000082', 'Purple Acid', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000083', 'Canopy Apple', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000084', 'Gnat Antenna', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000085', 'Compound Gnat Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000086', 'Poisonous Spines', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000087', 'Cactuar Leg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000088', 'Crab Apron', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000089', 'Pungent Haunch', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000090', 'Sharp Fang', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000091', 'Bomb Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000092', 'Ahriman Tooth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000093', 'Dodo Wing Feather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000094', 'Cockatrice Egg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000095', 'Blue Iron Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000096', 'Aldgoat Salt', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000097', 'Imp Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000098', 'Devilet Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000099', 'Beetle Powder', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000100', 'Aphids', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000101', 'Evenfall Firefly', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000102', 'Violet Chestnut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000103', 'Twin Chestnut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000104', 'Fallen Chestnut', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000105', 'Doom Cricket', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000106', 'Snail Horn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000107', 'Snail Horn', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000108', 'Wraith Cloth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000109', 'Wight Cloth', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000110', 'Angler Eye', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000111', 'Orobon Whisker', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000112', 'Aurelia Feeler', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000113', 'Anemone Feeler', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000114', 'Yellow Yarzon Offal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000115', 'Chocobo Blood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000116', 'Voidsent Blood', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000117', 'Brightash', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000118', 'Black Worm', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000119', 'Blacksand', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000120', 'Lightning Gem', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000121', 'Wolf Tail', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000122', 'Mutton Loin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000123', 'Karakul Loin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000124', 'Gigantoad Leg', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000125', 'Condor Tailfeather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000126', 'Vulture Tailfeather', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000127', 'Shriekshroom Cap', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000128', 'Mottled Eft Skin', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000129', 'Ant Mandible', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000130', 'Queen Bee', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000131', 'Demon Mosquito', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000132', 'Orchidfly', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000133', 'Leafy Wing', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000134', 'Rusted Sword', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000135', 'Rusted Ring', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000136', 'Gold Hilt Dagger', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000137', 'Leather Hunting Vest', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000138', 'Stolen Finery', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000139', 'Necklace of Fingers', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000140', 'High-quality Silver Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000141', 'High-quality Mythril Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000142', 'High-quality Bone Chip', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000143', 'High-quality Obsidian', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000144', 'Herring for Smoking', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000145', 'Carp for Salting', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000146', 'Salmon for Drying', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000147', 'Fresh Oyster', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000148', 'Fresh Blowfish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000149', 'Fresh Lobster', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000150', 'Bigclaw Crayfish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000151', 'Bitterbite Pipira', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000152', 'Jade Marimo', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000153', 'Aquarium Bone Crayfish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000154', 'Gridanian Fighting Fish', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000155', 'Aquarium Monke Onke', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000156', 'Straight Willow Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000157', 'Straight Ash Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000158', 'Straight Oak Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000159', 'Unknotted Elm Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000160', 'Unknotted Walnut Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000161', 'Unknotted Mahogany Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000162', 'High-quality Spruce Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000163', 'Superior-quality Iron Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000164', 'Superior-quality Mythril Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000165', 'Thick Walnut Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000166', 'Thick Mahogany Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000167', 'Plump Bianaq Bream', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000168', 'Plump Maiden Carp', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000169', 'High-quality Raw Sphene', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000170', 'High-quality Raw Heliodor', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000171', 'Wormless Lauan Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000172', 'Straight Mahogany Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000173', 'Agitated Black Ghost', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000174', 'Mature Monke Onke', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000175', 'Superior-quality Silver Ore', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000176', 'Flawless Jade', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000177', 'Wormless Oak Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000178', 'Fine-grain Rosewood Log', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000179', 'Fresh Yugr\'am Salmon', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000180', 'Young Northern Pike', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000181', 'Virgin\'s Veil', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000182', 'Rainbow Fly', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000183', 'White Antelope Hide', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000184', 'Fresh Dung', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000185', 'Young Roseling Leaf', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000186', 'Roseling Bushel', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000187', 'Magicked Drake Scale', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000188', 'Stolen Tome', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000189', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000190', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000191', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000192', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000193', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000194', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000195', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000196', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000197', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000198', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000199', '[en]', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1016', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('12000200', 'Luminous Crystal', 'Normal/DummyItem', '1', '0', '1', '0', '0', '60739', '1005', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000001', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000002', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000003', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000004', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000005', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000006', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000007', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000008', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000009', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000010', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000011', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000012', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000013', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000014', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000015', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000016', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000017', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000018', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000019', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000020', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000021', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000022', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000023', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000024', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000025', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000026', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000027', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000028', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000029', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000030', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000031', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000032', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000033', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000034', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000035', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000036', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000037', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000038', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000039', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000040', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000041', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000042', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000043', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000044', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000045', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000046', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000047', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000048', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000049', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000050', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000051', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000052', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000053', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000054', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000055', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000056', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000057', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000058', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000059', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000060', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000061', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000062', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000063', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000064', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000065', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000066', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000067', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000068', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000069', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000070', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000071', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000072', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000073', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000074', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000075', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000076', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000077', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000078', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000079', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000080', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000081', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000082', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000083', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000084', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000085', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000086', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000087', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000088', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000089', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000090', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000091', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000092', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000093', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000094', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000095', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000096', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000097', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000098', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000099', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000100', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000101', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000102', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000103', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000104', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items` VALUES ('13000105', '', 'Normal/DummyItem', '1', '0', '0', '0', '0', '61352', '0', '1', '0', '0', '0', '0', '1', '1001', '0', '0', '0', '0', '0', '-1', '0', '0', '0', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010001', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010002', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010003', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010004', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010005', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010006', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010007', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010008', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010009', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010010', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010011', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010012', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010013', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010014', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010015', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010016', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010017', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010018', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010019', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010020', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010021', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010022', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010023', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010024', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010025', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010026', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010027', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010028', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010029', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010030', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010031', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010032', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010033', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010034', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010035', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010036', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010037', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010038', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010039', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010040', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010041', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010042', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010043', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010044', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010045', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010046', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010047', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010048', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010049', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010050', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010051', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010052', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010053', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010054', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010055', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010056', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010057', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010058', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010059', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010060', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010061', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010062', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010063', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9010064', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030001', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030002', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030003', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030004', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030005', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030006', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030007', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030008', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030009', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030010', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030011', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030012', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030013', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030014', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030015', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030016', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030017', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030018', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030019', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030020', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030021', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030022', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030023', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030024', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030025', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030026', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030027', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030028', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030029', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030030', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030031', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030032', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030033', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030034', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030035', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030036', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030037', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030038', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030039', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030040', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030041', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030042', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030043', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030044', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030045', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030046', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030047', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030048', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030049', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030050', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030051', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030052', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030053', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030054', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030055', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030056', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030057', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030058', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030059', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030060', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030061', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030062', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030063', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030064', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9030065', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040001', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040002', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040003', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040004', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040005', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040006', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040007', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040008', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040009', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040010', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040011', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040012', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040013', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040014', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040015', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040016', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040017', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040018', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040019', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040020', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040021', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040022', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040023', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040024', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040025', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040026', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040027', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040028', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040029', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040030', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040031', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040032', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040033', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040034', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040035', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040036', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040037', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040038', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040039', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040040', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040041', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040042', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040043', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040044', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040045', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040046', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040047', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040048', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040049', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040050', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040051', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040052', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040053', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040054', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040055', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040056', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040057', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040058', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040059', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040060', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040061', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040062', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040063', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040064', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040065', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040066', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040067', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9040068', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050001', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050002', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050003', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050004', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050005', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050006', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050007', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050008', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050009', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050010', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050011', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050012', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050013', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050014', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050015', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050016', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050017', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050018', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050019', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050020', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050021', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050022', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050023', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050024', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050025', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050026', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050027', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050028', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050029', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050030', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050031', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050032', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050033', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050034', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050035', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050036', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050037', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050038', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050039', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050040', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050041', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050042', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050043', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050044', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050045', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050046', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050047', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050048', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050049', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050050', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050051', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050052', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050053', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050054', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050055', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050056', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050057', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050058', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050059', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050060', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050061', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050062', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050063', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050064', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050065', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050066', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050067', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050068', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050069', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050070', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050071', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050072', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050073', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050074', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050075', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050076', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050077', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050078', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050079', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050080', '0', '0');
INSERT INTO `gamedata_items_accessory` VALUES ('9050081', '0', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010001', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010002', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010003', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010004', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010005', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010006', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010007', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010008', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010009', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010010', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010011', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010012', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010013', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010014', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010015', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010016', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010017', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010101', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010102', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010103', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010104', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010105', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010106', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010107', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010108', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010109', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010110', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010111', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010112', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010113', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010114', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010115', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010116', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010117', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010118', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010119', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010120', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010121', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010122', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010123', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010124', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010125', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010126', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010127', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010128', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010129', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010130', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010131', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010132', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010133', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010134', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010135', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010136', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010137', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010138', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010139', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010140', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010141', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010142', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010143', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010144', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010145', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010146', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010147', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010148', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010149', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010201', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010202', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010203', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010204', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010205', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010206', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010207', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010208', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010209', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010210', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010211', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010212', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010213', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010214', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010215', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010216', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010217', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010218', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010219', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010220', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010221', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010222', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010223', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010224', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010225', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010301', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010302', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010303', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010304', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010305', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010306', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010307', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010308', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010309', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010310', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010311', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010312', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010313', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010314', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010315', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010316', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010317', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010318', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010319', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010320', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010321', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010322', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010323', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010324', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010325', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010326', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010327', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010328', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010329', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010330', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010401', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010402', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010403', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010404', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010405', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010406', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010407', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010408', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010409', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010410', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010411', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010412', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010413', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010414', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010415', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010416', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010417', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010418', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010419', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010420', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010421', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010422', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010423', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010424', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010425', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010426', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010427', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010428', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010429', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010430', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010431', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010432', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010433', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010434', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010435', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010436', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010437', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010438', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010439', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010440', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010441', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010442', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010443', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010444', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010445', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010446', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010447', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010448', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010449', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010450', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010451', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010452', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010453', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010454', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010455', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010456', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010457', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010458', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010459', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010460', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010461', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010462', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010463', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010464', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010465', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010466', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010467', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010468', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010469', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010470', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010471', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010472', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010473', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010474', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010475', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010476', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010477', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010478', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010479', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010480', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010481', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010482', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010501', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010502', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010503', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010504', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010505', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010506', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010507', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010508', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010509', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010510', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010511', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010512', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010513', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010514', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010515', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010516', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010517', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010518', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010519', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010520', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010521', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010522', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010523', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010524', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010525', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010526', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010527', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010528', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010529', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010530', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010531', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010532', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010533', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010534', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010535', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010536', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010537', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010538', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010539', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010540', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010541', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010542', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010543', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010544', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010545', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010546', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010547', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010548', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010549', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010550', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010551', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010552', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010553', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010554', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010555', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010556', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010557', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010558', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010559', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010560', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010561', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010562', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010563', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010564', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010565', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010566', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010567', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010601', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010602', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010603', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010604', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010605', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010606', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010607', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010608', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010609', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010610', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010611', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010612', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010613', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010614', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010615', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010616', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010617', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010618', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010619', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010620', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010621', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010622', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010623', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010624', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010625', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010626', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010627', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010628', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010629', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010630', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010631', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010632', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010633', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010634', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010635', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010636', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010637', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010638', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010639', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010640', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010641', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010642', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010643', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010644', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010645', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010646', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010647', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010648', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010649', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010650', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010651', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010652', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010653', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010654', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010655', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010656', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010701', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010702', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010703', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010704', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010705', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010706', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010707', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010708', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010709', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010710', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010711', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010712', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010713', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010714', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010715', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010716', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010801', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010802', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010803', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010804', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010805', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010806', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010807', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010808', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010809', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010810', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010811', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010812', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010813', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010814', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010815', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010816', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010817', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010818', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010819', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010820', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010821', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010822', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010823', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010824', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010825', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010826', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010827', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010828', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010829', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010830', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010831', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010832', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010833', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010834', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010835', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010836', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010837', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010838', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010901', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010902', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010903', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010904', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010905', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010906', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010907', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010908', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010909', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010910', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010911', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010912', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010913', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010914', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010915', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010916', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010917', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010918', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010919', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010920', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010921', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010922', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010923', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010924', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010925', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010926', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010927', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010928', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010929', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010930', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010931', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010932', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010933', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8010934', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011001', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011002', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011003', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011004', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011005', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011006', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011007', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011008', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011009', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011010', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011011', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011012', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011013', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011014', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011015', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011016', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011017', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011018', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011019', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011020', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011021', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011022', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011101', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011102', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011103', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011104', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011105', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011106', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011107', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011108', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011109', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011110', '69', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011201', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011202', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011203', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011204', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011205', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011206', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011207', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011208', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011209', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011210', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011211', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011212', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011213', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011214', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011215', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011216', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011217', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011218', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011219', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011220', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011221', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011222', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011223', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011301', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011302', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011303', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011304', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011305', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011306', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011307', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011308', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011309', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011310', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011311', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011312', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011313', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011314', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011315', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011316', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011317', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011318', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011319', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011320', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011321', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011322', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011323', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011324', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011325', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011326', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011327', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011328', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011329', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011330', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011331', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011332', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011333', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011334', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011335', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011336', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011337', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011338', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011339', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011340', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011341', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011401', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011402', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011403', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011404', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011405', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011406', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011407', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011408', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011409', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011501', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011502', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011503', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011504', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011505', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011506', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011507', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011508', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011509', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011510', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011511', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011512', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011513', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011514', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011515', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011516', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011517', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011518', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011519', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011520', '69', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011521', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011522', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011523', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011524', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011601', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011602', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011603', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011604', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011605', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011606', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011607', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011608', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011609', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011610', '84', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011701', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011702', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011703', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011704', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011705', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011706', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011707', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011708', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011709', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011710', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011711', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011712', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011713', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011801', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011802', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011803', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011804', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011805', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011806', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011807', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011808', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011809', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011810', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011811', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011812', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011813', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011814', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011815', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011816', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011817', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011901', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011902', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8011903', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012001', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012002', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012003', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012004', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012005', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012006', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012007', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012008', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012009', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012010', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012011', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012012', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012013', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012014', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012015', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012016', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012017', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012018', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012019', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012020', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012021', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012022', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012023', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012024', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012101', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012102', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012103', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012201', '63', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012202', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012301', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012302', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012303', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012304', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012305', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012306', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012307', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012308', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012309', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012310', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012311', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012312', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012313', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012314', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012315', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012316', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012317', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012318', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012319', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012320', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012321', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012322', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012323', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012324', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012325', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012326', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012327', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012328', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012329', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012330', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012331', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012332', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012333', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012334', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012335', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012336', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012337', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012338', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012339', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012340', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012341', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012342', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012343', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012401', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012402', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012403', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012404', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012405', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012406', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012407', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012408', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012409', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012410', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012411', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012412', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012501', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012502', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012601', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012602', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012603', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012604', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012605', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012606', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012607', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012701', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012702', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012703', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012704', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012705', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012706', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012707', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012708', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012709', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012710', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012711', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012712', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012713', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012714', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012715', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012716', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012717', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012718', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012719', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012720', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012721', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012722', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012723', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012724', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012725', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012726', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012727', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012728', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012729', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012730', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012731', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012732', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012733', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012734', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012735', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012736', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012737', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012738', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012739', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012801', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012802', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012803', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012804', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012805', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012901', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012902', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012903', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8012904', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013001', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013002', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013003', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013004', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013005', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013006', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013007', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013008', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013101', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013102', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013201', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013202', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013203', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013204', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013205', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013206', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013301', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013302', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013303', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013304', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013401', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013402', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013403', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013404', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013501', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013502', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013503', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013504', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013505', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013506', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013507', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013601', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013602', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013603', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013604', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013605', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013606', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013607', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013608', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013609', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013610', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013611', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013612', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013613', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013614', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013615', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013616', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013617', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013618', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013619', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013620', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013621', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013622', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013623', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013624', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013625', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013626', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013627', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013628', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013629', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013630', '67', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013631', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013632', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013633', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013634', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013635', '71', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013636', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8013637', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030001', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030002', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030003', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030004', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030005', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030006', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030007', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030008', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030009', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030010', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030011', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030012', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030013', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030014', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030015', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030016', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030017', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030018', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030019', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030020', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030021', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030022', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030023', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030024', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030025', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030026', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030027', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030028', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030029', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030030', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030031', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030032', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030033', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030034', '125', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030035', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030036', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030037', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030038', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030039', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030040', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030041', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030042', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030043', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030044', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030045', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030046', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030047', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030048', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030049', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030050', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030101', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030102', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030103', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030104', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030105', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030106', '152', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030107', '152', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030108', '152', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030109', '110', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030110', '110', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030111', '175', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030112', '182', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030113', '175', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030114', '175', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030115', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030116', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030117', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030118', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030119', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030201', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030202', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030203', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030204', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030205', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030206', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030207', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030208', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030209', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030210', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030211', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030212', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030213', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030214', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030215', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030216', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030217', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030218', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030219', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030220', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030221', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030222', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030223', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030224', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030225', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030226', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030227', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030228', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030229', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030230', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030231', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030232', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030233', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030234', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030235', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030236', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030237', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030238', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030239', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030240', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030241', '77', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030242', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030243', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030244', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030245', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030246', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030247', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030248', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030249', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030250', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030251', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030252', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030253', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030254', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030255', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030256', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030257', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030301', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030302', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030303', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030304', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030305', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030306', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030307', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030308', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030309', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030310', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030311', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030312', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030313', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030314', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030315', '103', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030316', '103', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030317', '103', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030318', '103', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030319', '103', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030320', '71', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030321', '71', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030322', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030323', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030324', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030325', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030326', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030327', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030328', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030329', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030330', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030331', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030332', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030333', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030334', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030335', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030336', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030337', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030338', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030339', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030340', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030341', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030342', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030343', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030344', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030345', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030346', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030347', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030348', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030349', '163', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030350', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030401', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030402', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030403', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030404', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030405', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030406', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030407', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030408', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030409', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030410', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030411', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030412', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030413', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030414', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030415', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030416', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030417', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030418', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030419', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030420', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030421', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030422', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030423', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030424', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030425', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030426', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030427', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030428', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030429', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030430', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030431', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030432', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030433', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030434', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030435', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030436', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030437', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030438', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030439', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030440', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030441', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030442', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030443', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030444', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030445', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030446', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030447', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030501', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030502', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030503', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030504', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030505', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030506', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030507', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030508', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030509', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030510', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030511', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030512', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030513', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030514', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030515', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030516', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030517', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030518', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030519', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030520', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030521', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030522', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030523', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030524', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030525', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030526', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030527', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030528', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030529', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030530', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030531', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030532', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030533', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030534', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030535', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030536', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030537', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030538', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030539', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030540', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030541', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030542', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030543', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030544', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030545', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030546', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030547', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030548', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030549', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030550', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030551', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030552', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030553', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030554', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030555', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030556', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030557', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030558', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030601', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030602', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030603', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030604', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030605', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030606', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030607', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030608', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030609', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030610', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030611', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030612', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030613', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030614', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030615', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030616', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030617', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030618', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030619', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030620', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030621', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030622', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030623', '128', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030624', '128', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030625', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030626', '141', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030627', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030701', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030702', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030703', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030704', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030705', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030706', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030707', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030708', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030709', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030710', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030711', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030712', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030713', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030714', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030715', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030716', '107', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030717', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030718', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030719', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030720', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030721', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030722', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030723', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030724', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030725', '127', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030726', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030727', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030728', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030729', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030730', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030731', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030732', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030733', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030734', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030735', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030736', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030737', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030738', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030739', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030740', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030741', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030742', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030743', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030744', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030745', '129', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030801', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030802', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030803', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030804', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030805', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030806', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030807', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030808', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030809', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030810', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030811', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030812', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030813', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030814', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030815', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030816', '79', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030817', '139', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030818', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030819', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030820', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030821', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030822', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030823', '146', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030824', '141', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030901', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030902', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030903', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030904', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030905', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030906', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030907', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030908', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030909', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030910', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030911', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030912', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030913', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030914', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030915', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030916', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030917', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030918', '156', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030919', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030920', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030921', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030922', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030923', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8030924', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031001', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031002', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031003', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031004', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031005', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031006', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031007', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031008', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031009', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031010', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031011', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031012', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031013', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031014', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031015', '126', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031016', '126', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031017', '126', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031018', '126', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031019', '126', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031020', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031021', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031022', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031023', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031024', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031025', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031026', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031027', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031028', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031029', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031030', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031031', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031032', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031033', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031034', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031035', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031036', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031037', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031038', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031039', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031040', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031041', '116', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031042', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031043', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031044', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031045', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031046', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031047', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031048', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031049', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031050', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031051', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031052', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031053', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031054', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031055', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031056', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031057', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031101', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031102', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031103', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031104', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031105', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031106', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031107', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031108', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031109', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031110', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031111', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031112', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031113', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031114', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031115', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031116', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031117', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031118', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031119', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031120', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031121', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031122', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031201', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031202', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031203', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031204', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031205', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031206', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031207', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031208', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031209', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031210', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031211', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031212', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031213', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031214', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031215', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031216', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031217', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031218', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031219', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031220', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031221', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031222', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031223', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031224', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031225', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031226', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031227', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031228', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031229', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031230', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031231', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031232', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031233', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031234', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031235', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031236', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031237', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031238', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031239', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031240', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031241', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031242', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031243', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031244', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031245', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031246', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031247', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031248', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031249', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031250', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031301', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031302', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031303', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031304', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031305', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031306', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031307', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031308', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031309', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031310', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031311', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031312', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031313', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031314', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031315', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031316', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031401', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031402', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031403', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031404', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031405', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031406', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031407', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031408', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031409', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031410', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031411', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031412', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031413', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031414', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031415', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031416', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031417', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031418', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031419', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031420', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031421', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031501', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031502', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031503', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031504', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031505', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031506', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031507', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031508', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031509', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031510', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031511', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031512', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031513', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031514', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031515', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031516', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031517', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031518', '105', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031519', '105', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031520', '133', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031521', '133', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031522', '133', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031523', '133', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031601', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031602', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031603', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031604', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031605', '106', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031606', '141', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031607', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031608', '163', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031609', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031610', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031611', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031612', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031613', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031701', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031702', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031703', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031704', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031705', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031706', '87', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031707', '87', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031708', '87', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031709', '87', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031710', '87', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031711', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031712', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031713', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031714', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031715', '140', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031716', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031717', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031718', '166', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031719', '160', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031720', '129', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031721', '129', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031722', '162', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031723', '162', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031724', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031801', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031802', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031803', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031804', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031805', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031806', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031807', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031808', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031809', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031810', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031811', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031812', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031813', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031814', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031815', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031816', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031817', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031818', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031819', '142', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031820', '98', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031821', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031822', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031823', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031824', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031825', '181', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031826', '181', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031827', '181', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031828', '181', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031901', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031902', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031903', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031904', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031905', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031906', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031907', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031908', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031909', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031910', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031911', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031912', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031913', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031914', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031915', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031916', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8031917', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032001', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032002', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032003', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032004', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032005', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032006', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032007', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032008', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032009', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032010', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032011', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032012', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032013', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032014', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032015', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032016', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032017', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032018', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032019', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032020', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032021', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032022', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032023', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032024', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032025', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032026', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032027', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032028', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032029', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032030', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032031', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032032', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032033', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032034', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032035', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032101', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032102', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032201', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032202', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032203', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032204', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032205', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032206', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032207', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032208', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032209', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032210', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032211', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032212', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032213', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032214', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032215', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032216', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032217', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032218', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032219', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032220', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032221', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032222', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032223', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032224', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032225', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032226', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032227', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032228', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032229', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032230', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032231', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032232', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032233', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032234', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032235', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032236', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032237', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032238', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032239', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032240', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032241', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032242', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032243', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032244', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032301', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032302', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032303', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032304', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032305', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032306', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032307', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032308', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032309', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032310', '111', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032311', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032312', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032401', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032402', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032403', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032404', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032405', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032406', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032407', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032408', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032409', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032410', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032501', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032502', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032601', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032602', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032603', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032604', '150', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032605', '150', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032606', '150', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032701', '180', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032702', '146', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032703', '171', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032704', '165', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032705', '122', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032706', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032707', '117', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032801', '308', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032802', '182', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032803', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032804', '177', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032805', '275', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032806', '275', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032807', '275', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032808', '275', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032809', '275', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032810', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032811', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032812', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032813', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032814', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032815', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032816', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032817', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032818', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032819', '102', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032820', '158', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032821', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032822', '158', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032823', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032824', '158', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032825', '115', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032826', '120', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032827', '184', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032828', '153', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032829', '121', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032830', '145', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032831', '169', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032832', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032833', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032834', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032835', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032836', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032837', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032838', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8032839', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040001', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040002', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040003', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040004', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040005', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040006', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040008', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040009', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040010', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040011', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040012', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040013', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040014', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040015', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040016', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040017', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040018', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040019', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040020', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040021', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040022', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040023', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040024', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040025', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040026', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040027', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040028', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040029', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040030', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040031', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040032', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040033', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040034', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040035', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040036', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040037', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040038', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040039', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040040', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040041', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040042', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040043', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040044', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040045', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040046', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040047', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040048', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040049', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040050', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040051', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040052', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040053', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040054', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040055', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040056', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040057', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040058', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040059', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040060', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040061', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040062', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040063', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040064', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040065', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040066', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040067', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040068', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040069', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040070', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040071', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040072', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040073', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040074', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040075', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040076', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040077', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040078', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040079', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040080', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040081', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040082', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040083', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040084', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040085', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040086', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040087', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040088', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040089', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040090', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040091', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040092', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040093', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040094', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040095', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8040096', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050001', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050002', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050003', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050004', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050005', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050006', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050007', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050008', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050009', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050010', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050011', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050012', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050013', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050014', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050015', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050016', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050017', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050018', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050019', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050020', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050021', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050022', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050023', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050024', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050025', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050026', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050027', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050028', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050029', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050030', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050031', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050032', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050033', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050034', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050035', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050036', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050037', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050038', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050039', '74', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050040', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050041', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050042', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050043', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050044', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050045', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050046', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050047', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050048', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050049', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050050', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050051', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050101', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050102', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050103', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050104', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050105', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050106', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050107', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050108', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050109', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050110', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050111', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050112', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050113', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050114', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050115', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050116', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050117', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050118', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050119', '112', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050120', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050121', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050122', '105', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050123', '105', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050124', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050125', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050126', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050127', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050128', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050129', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050130', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050131', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050132', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050133', '138', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050134', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050135', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050136', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050137', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050138', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050139', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050140', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050141', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050142', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050143', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050144', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050145', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050146', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050147', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050148', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050149', '135', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050150', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050151', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050201', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050202', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050203', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050204', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050205', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050206', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050207', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050208', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050209', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050210', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050211', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050212', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050213', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050214', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050215', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050216', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050217', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050218', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050219', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050220', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050221', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050222', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050223', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050224', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050225', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050226', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050227', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050228', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050229', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050230', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050231', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050232', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050233', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050234', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050235', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050236', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050237', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050238', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050239', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050240', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050241', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050242', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050243', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050244', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050245', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050246', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050247', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050248', '88', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050301', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050302', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050303', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050304', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050305', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050306', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050307', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050308', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050309', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050310', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050311', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050312', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050313', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050314', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050315', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050316', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050317', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050318', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050319', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050320', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050321', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050322', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050323', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050324', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050325', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050326', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050327', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050328', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050329', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050330', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050331', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050332', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050333', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050334', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050335', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050336', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050337', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050338', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050339', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050340', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050341', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050342', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050343', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050344', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050345', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050346', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050347', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050348', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050349', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050350', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050351', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050352', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050353', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050354', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050355', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050356', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050357', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050358', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050359', '83', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050360', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050401', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050402', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050403', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050404', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050405', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050406', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050407', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050408', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050409', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050410', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050411', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050412', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050413', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050414', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050415', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050416', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050417', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050418', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050419', '93', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050420', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050421', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050422', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050423', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050424', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050425', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050426', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050427', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050428', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050429', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050430', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050431', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050432', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050433', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050434', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050435', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050436', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050437', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050438', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050439', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050440', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050441', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050442', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050443', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050444', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050445', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050446', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050447', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050448', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050449', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050450', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050451', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050452', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050453', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050454', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050455', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050456', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050457', '108', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050501', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050502', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050503', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050504', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050505', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050506', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050507', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050508', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050509', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050510', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050511', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050512', '78', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050513', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050514', '99', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050515', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050516', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050517', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050518', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050519', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050520', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050521', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050601', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050602', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050603', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050604', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050605', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050606', '35', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050607', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050608', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050609', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050610', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050611', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050612', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050613', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050614', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050615', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050616', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050618', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050619', '105', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050620', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050621', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050622', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050701', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050702', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050703', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050704', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050705', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050706', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050707', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050708', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050709', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050710', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050711', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050712', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050713', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050714', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050715', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050716', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050717', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050718', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050719', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050720', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050721', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050722', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050723', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050724', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050725', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050726', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050727', '94', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050728', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050729', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050730', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050731', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050732', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050733', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050734', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050735', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050736', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050737', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050738', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050739', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050740', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050741', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050742', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050743', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050744', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050745', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050746', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050747', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050748', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050749', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050750', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050751', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050752', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050753', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050754', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050755', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050756', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050757', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050758', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050759', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050760', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050761', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050762', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050763', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050764', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050765', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050766', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050767', '96', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050768', '96', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050769', '96', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050801', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050802', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050803', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050804', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050805', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050806', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050807', '64', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050808', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050809', '96', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050810', '96', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050811', '132', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050901', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050902', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050903', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050904', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050905', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050906', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050907', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8050940', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051001', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051002', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051003', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051004', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051005', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051006', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051007', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051008', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051009', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051010', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051011', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051012', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051013', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051014', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051015', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051016', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051017', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051018', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051019', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051020', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051021', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051022', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051023', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051024', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051025', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051101', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051102', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051103', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051104', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051105', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051106', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051107', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051108', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051109', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051110', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051111', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051112', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051113', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051114', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051115', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051116', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051117', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051118', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051119', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051120', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051121', '89', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051201', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051202', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051203', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051204', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051205', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051206', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051207', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051208', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051209', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051210', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051211', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051212', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051213', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051214', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051215', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051216', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051217', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051218', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051219', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051220', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051221', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051222', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051223', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051224', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051301', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051302', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051303', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051304', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051305', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051306', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051307', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051308', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051309', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051310', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051401', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051402', '95', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051403', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051404', '130', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051405', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051406', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051407', '82', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051501', '218', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051502', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051503', '204', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051504', '204', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051505', '204', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051506', '204', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051507', '204', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051508', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051509', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051510', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051511', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051512', '90', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051513', '138', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051514', '86', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051515', '104', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051516', '125', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051517', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051518', '135', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051519', '100', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051520', '81', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051521', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051522', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051523', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051524', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051525', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8051526', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060001', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060002', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060003', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060004', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060005', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060006', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060008', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060009', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060010', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060011', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060012', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060013', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060014', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060015', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060016', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060017', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060018', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060019', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060020', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060021', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060022', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060023', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060024', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060025', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060026', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060027', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060028', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060029', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060030', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060031', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060032', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060033', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060034', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060035', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060036', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060037', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060038', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060039', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060040', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060041', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060042', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060043', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060044', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060045', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060046', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060047', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060048', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060049', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060050', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060051', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060052', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060053', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060054', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060055', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060056', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060057', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060058', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060059', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060060', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060061', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060062', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060063', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060064', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060065', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060066', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060067', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060068', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060069', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060070', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060071', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060072', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060073', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060074', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060075', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060076', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060077', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060078', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060079', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060080', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060081', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060082', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060083', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060084', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060085', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060086', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060087', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060088', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060089', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060090', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060091', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060092', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060093', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060094', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060095', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8060096', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070001', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070002', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070003', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070004', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070005', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070006', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070007', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070008', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070009', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070010', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070011', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070012', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070013', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070014', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070015', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070016', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070017', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070018', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070019', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070020', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070021', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070022', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070023', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070024', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070101', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070102', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070103', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070104', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070105', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070106', '63', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070107', '63', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070108', '63', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070109', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070110', '46', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070111', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070112', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070113', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070114', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070115', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070116', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070117', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070118', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070119', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070201', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070202', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070203', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070204', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070205', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070206', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070207', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070208', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070209', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070210', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070211', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070212', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070213', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070214', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070215', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070216', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070217', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070218', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070219', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070220', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070221', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070222', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070223', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070224', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070225', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070226', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070227', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070228', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070229', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070230', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070231', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070232', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070233', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070234', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070235', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070236', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070237', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070238', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070239', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070240', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070241', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070242', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070243', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070301', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070302', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070303', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070304', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070305', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070306', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070307', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070308', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070309', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070310', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070311', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070312', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070313', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070314', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070315', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070316', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070317', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070318', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070319', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070320', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070321', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070322', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070323', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070324', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070325', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070326', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070327', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070328', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070329', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070330', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070331', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070332', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070333', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070334', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070335', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070336', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070337', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070338', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070339', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070340', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070341', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070342', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070343', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070344', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070345', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070346', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070347', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070348', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070349', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070350', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070351', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070352', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070353', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070354', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070355', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070356', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070357', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070358', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070359', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070360', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070361', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070362', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070363', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070401', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070402', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070403', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070404', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070405', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070406', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070407', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070408', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070409', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070410', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070411', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070412', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070413', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070414', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070415', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070416', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070417', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070418', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070419', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070420', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070421', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070422', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070423', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070424', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070425', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070426', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070427', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070428', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070429', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070430', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070431', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070432', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070433', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070434', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070435', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070436', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070437', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070438', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070439', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070440', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070441', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070442', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070443', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070444', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070445', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070446', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070447', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070448', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070449', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070450', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070451', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070452', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070453', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070454', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070455', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070501', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070502', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070503', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070504', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070505', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070506', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070507', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070508', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070509', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070510', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070511', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070512', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070513', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070514', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070515', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070516', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070517', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070518', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070519', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070520', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070521', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070522', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070523', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070524', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070525', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070526', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070527', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070528', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070529', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070530', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070531', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070532', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070533', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070534', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070535', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070536', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070537', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070538', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070539', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070540', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070541', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070542', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070543', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070544', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070545', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070546', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070547', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070548', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070549', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070550', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070551', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070552', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070553', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070601', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070602', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070603', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070604', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070605', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070606', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070607', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070608', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070609', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070610', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070701', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070702', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070703', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070704', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070705', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070706', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070707', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070708', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070709', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070710', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070711', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070712', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070713', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070714', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070715', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070716', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070717', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070718', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070719', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070720', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070721', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070722', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070723', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070724', '37', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070725', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070801', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070802', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070803', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070804', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070805', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070806', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070807', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070808', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070809', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070810', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070811', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070812', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070901', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070902', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070903', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070904', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070905', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070906', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070907', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070908', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070909', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070910', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070911', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070912', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070913', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070914', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8070915', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071001', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071002', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071003', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071004', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071005', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071006', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071007', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071008', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071009', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071010', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071011', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071012', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071013', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071014', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071015', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071016', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071017', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071018', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071101', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071102', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071103', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071104', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071105', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071106', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071107', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071108', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071109', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071110', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071111', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071112', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071113', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071114', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071115', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071116', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071117', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071118', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071119', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071120', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071121', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071122', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071123', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071201', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071202', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071203', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071204', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071205', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071206', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071207', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071208', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071209', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071210', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071211', '41', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071212', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071301', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071302', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071303', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071304', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071305', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071306', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071401', '73', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071402', '53', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071403', '72', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071404', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071405', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071406', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071407', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071501', '85', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071502', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071503', '65', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071504', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071505', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071506', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071507', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071508', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071509', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071510', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071511', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071512', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071513', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071514', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071515', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071516', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071517', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071518', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071519', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071520', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071521', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071522', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071523', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071524', '61', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071525', '55', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071526', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071527', '76', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8071528', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080001', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080002', '26', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080003', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080004', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080005', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080006', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080007', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080008', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080009', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080010', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080011', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080012', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080013', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080014', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080015', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080016', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080017', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080018', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080019', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080020', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080101', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080102', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080103', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080104', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080105', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080106', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080107', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080108', '58', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080109', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080110', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080111', '68', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080112', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080113', '68', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080114', '68', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080115', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080116', '75', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080117', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080118', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080119', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080201', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080202', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080203', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080204', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080205', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080206', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080207', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080208', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080209', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080210', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080211', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080212', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080213', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080214', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080215', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080216', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080217', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080218', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080219', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080220', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080221', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080222', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080223', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080224', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080225', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080226', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080227', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080228', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080229', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080230', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080231', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080232', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080233', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080234', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080235', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080236', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080237', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080238', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080239', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080240', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080241', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080242', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080243', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080244', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080245', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080246', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080247', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080301', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080302', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080303', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080304', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080305', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080306', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080307', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080308', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080309', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080310', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080311', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080312', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080313', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080314', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080315', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080316', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080317', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080318', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080319', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080320', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080321', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080322', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080323', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080324', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080325', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080326', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080327', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080328', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080329', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080330', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080331', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080332', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080333', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080334', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080335', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080336', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080337', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080338', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080339', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080340', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080341', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080342', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080343', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080344', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080345', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080346', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080347', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080348', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080349', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080350', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080351', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080352', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080353', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080354', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080355', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080356', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080357', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080358', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080359', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080360', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080401', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080402', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080403', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080404', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080405', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080406', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080407', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080408', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080409', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080410', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080411', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080412', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080413', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080414', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080415', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080416', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080417', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080418', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080419', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080420', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080421', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080422', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080423', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080424', '48', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080425', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080426', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080427', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080428', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080429', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080430', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080431', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080432', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080433', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080434', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080435', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080436', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080437', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080438', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080439', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080440', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080441', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080442', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080443', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080444', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080445', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080446', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080447', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080448', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080449', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080450', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080451', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080452', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080453', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080454', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080455', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080456', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080457', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080458', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080459', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080460', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080461', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080462', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080501', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080502', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080503', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080504', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080505', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080506', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080507', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080508', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080509', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080510', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080511', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080512', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080513', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080514', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080515', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080516', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080517', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080518', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080519', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080520', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080521', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080522', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080523', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080524', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080525', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080526', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080527', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080528', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080529', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080530', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080531', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080532', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080533', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080534', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080535', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080536', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080537', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080538', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080539', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080540', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080541', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080542', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080543', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080544', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080545', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080546', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080547', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080548', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080549', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080550', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080551', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080552', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080553', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080554', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080555', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080556', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080557', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080558', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080559', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080560', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080561', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080562', '31', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080563', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080564', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080565', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080601', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080602', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080603', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080604', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080605', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080606', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080607', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080608', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080609', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080610', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080611', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080612', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080613', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080614', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080615', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080616', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080617', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080618', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080701', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080702', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080703', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080704', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080705', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080706', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080707', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080708', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080709', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080710', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080711', '39', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080712', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080713', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080714', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080715', '34', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080716', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080717', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080801', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080802', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080803', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080804', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080805', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080806', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080807', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080808', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080809', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080810', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080811', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080812', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080813', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080814', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080815', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080816', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080817', '42', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080818', '49', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080819', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080820', '13', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080821', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080822', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080823', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080824', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080825', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080826', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080827', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080901', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080902', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080903', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080904', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080905', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080906', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8080907', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081001', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081002', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081003', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081004', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081005', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081006', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081007', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081008', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081009', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081010', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081011', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081012', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081013', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081014', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081015', '38', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081016', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081017', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081018', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081019', '32', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081020', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081021', '40', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081022', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081023', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081101', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081102', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081103', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081104', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081105', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081106', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081107', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081108', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081109', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081110', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081111', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081112', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081113', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081114', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081115', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081116', '30', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081117', '27', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081118', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081119', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081120', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081121', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081122', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081123', '36', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081124', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081201', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081202', '33', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081203', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081204', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081205', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081206', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081207', '54', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081208', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081209', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081210', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081211', '50', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081212', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081213', '62', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081301', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081302', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081303', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081304', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081305', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081306', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081307', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081308', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081309', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081310', '14', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081311', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081312', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081401', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081402', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081403', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081404', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081501', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081601', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081602', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081603', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081604', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081605', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081606', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081607', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081608', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081609', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081610', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081611', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081612', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081613', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081614', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081615', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081616', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081617', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081618', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081619', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081620', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081621', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081622', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081623', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081701', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081702', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081703', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081704', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081705', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081706', '52', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081801', '68', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081802', '51', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081803', '68', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081804', '60', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081805', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081806', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081807', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081901', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081902', '66', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081903', '45', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081904', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081905', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081906', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081907', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081908', '57', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081909', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081910', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081911', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081912', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081913', '43', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081914', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081915', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081916', '56', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081917', '47', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081918', '70', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081919', '59', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081920', '44', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081921', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8081922', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090001', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090002', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090003', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090004', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090005', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090006', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090008', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090009', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090101', '15', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090102', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090103', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090104', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090105', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090106', '29', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090107', '28', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090108', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090109', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090110', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090201', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090202', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090203', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090204', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090205', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090206', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090207', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090208', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090301', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090302', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090303', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090304', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090305', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090306', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090307', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090401', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090402', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090403', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090404', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090405', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090406', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090407', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090408', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090501', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090502', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090503', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090504', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090505', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090506', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090507', '23', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090601', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090602', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090603', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090604', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090605', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090606', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090607', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090608', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090609', '22', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090701', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090702', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090703', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090704', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090705', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090706', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090707', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090708', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090709', '20', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090801', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090802', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090803', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090804', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090805', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090806', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090807', '24', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090901', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090902', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090903', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090904', '18', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090905', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090906', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090907', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8090908', '19', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091001', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091002', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091003', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091004', '25', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091005', '17', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091101', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091102', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091103', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091104', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091105', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091106', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091107', '21', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091201', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091202', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091203', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091204', '16', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091301', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091302', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091303', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091304', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091305', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091306', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('8091401', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010001', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010002', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010003', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010004', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010005', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010006', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010008', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010009', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010010', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010011', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010012', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010013', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010014', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010015', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010016', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010017', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010018', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010019', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010020', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010021', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010022', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010023', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010024', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010025', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010026', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010027', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010028', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010029', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010030', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010031', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010032', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010033', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010034', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010035', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010036', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010037', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010038', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010039', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010040', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010041', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010042', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010043', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010044', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010045', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010046', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010047', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010048', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010049', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010050', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010051', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010052', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010053', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010054', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010055', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010056', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010057', '7', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010058', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010059', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010060', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010061', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010062', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010063', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9010064', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030001', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030002', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030003', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030004', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030005', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030006', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030008', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030009', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030010', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030011', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030012', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030013', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030014', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030015', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030016', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030017', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030018', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030019', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030020', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030021', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030022', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030023', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030024', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030025', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030026', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030027', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030028', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030029', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030030', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030031', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030032', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030033', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030034', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030035', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030036', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030037', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030038', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030039', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030040', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030041', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030042', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030043', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030044', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030045', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030046', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030047', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030048', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030049', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030050', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030051', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030052', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030053', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030054', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030055', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030056', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030057', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030058', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030059', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030060', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030061', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030062', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030063', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030064', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9030065', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040001', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040002', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040003', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040004', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040005', '8', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040006', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040007', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040008', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040009', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040010', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040011', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040012', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040013', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040014', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040015', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040016', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040017', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040018', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040019', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040020', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040021', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040022', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040023', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040024', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040025', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040026', '9', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040027', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040028', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040029', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040030', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040031', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040032', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040033', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040034', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040035', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040036', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040037', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040038', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040039', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040040', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040041', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040042', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040043', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040044', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040045', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040046', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040047', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040048', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040049', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040050', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040051', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040052', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040053', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040054', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040055', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040056', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040057', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040058', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040059', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040060', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040061', '6', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040062', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040063', '11', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040064', '12', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040065', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040066', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040067', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9040068', '10', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050001', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050002', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050003', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050004', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050005', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050006', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050007', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050008', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050009', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050010', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050011', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050012', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050013', '2', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050014', '3', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050015', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050016', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050017', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050018', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050019', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050020', '4', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050021', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050022', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050023', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050024', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050025', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050026', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050027', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050028', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050029', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050030', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050031', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050032', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050033', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050034', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050035', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050036', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050037', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050038', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050039', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050040', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050041', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050042', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050043', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050044', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050045', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050046', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050047', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050048', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050049', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050050', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050051', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050052', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050053', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050054', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050055', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050056', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050057', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050058', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050059', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050060', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050061', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050062', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050063', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050064', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050065', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050066', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050067', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050068', '5', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050069', '1', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050070', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050071', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050072', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050073', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050074', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050075', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050076', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050077', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050078', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050079', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050080', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_armor` VALUES ('9050081', '0', '0', '0', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010001', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '11', '1015009', '5', '-1', '0', '-1', '22', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010002', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '9', '1015004', '4', '-1', '0', '-1', '30', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010003', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '15', '-1', '0', '-1', '0', '-1', '30', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010004', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '13', '15005', '2', '-1', '0', '-1', '45', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010005', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '18', '1015035', '18', '-1', '0', '-1', '8', '-1', '8', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010006', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '13', '1015004', '7', '-1', '0', '-1', '15', '-1', '3', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010007', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '11', '1015007', '5', '-1', '0', '-1', '24', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010008', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '7', '1015009', '3', '-1', '0', '-1', '51', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010009', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '11', '1015006', '5', '-1', '0', '-1', '22', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010010', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '9', '15022', '10', '-1', '0', '-1', '32', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010011', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '8', '1015004', '3', '-1', '0', '-1', '41', '-1', '6', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010012', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '6', '-1', '0', '-1', '0', '-1', '180', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010013', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '9', '-1', '0', '-1', '0', '-1', '33', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010014', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '11', '1015004', '5', '-1', '0', '-1', '24', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010015', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '16', '1015035', '16', '-1', '0', '-1', '10', '-1', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010016', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '10', '-1', '0', '-1', '0', '-1', '70', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010017', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015018', '7', '1015007', '3', '-1', '0', '-1', '51', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010018', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '14', '1015035', '14', '-1', '0', '-1', '12', '-1', '12', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010019', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '12', '1015035', '11', '-1', '0', '-1', '15', '-1', '15', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010020', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '5', '-1', '0', '-1', '0', '-1', '220', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010021', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '7', '-1', '0', '-1', '0', '-1', '130', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010022', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '8', '-1', '0', '-1', '0', '-1', '90', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010023', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015001', '5', '15005', '10', '-1', '0', '-1', '230', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010024', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010101', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015005', '7', '-1', '7', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010102', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015008', '7', '-1', '7', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010103', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015009', '7', '-1', '7', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010104', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '11', '1015032', '10', '1015006', '5', '-1', '11', '-1', '5', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010105', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015007', '7', '-1', '7', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010106', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '11', '1015032', '10', '1015009', '5', '-1', '11', '-1', '5', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010107', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '8', '1015032', '9', '1015004', '3', '-1', '24', '-1', '9', '-1', '6', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010108', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '11', '1015032', '10', '1015004', '5', '-1', '12', '-1', '5', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010109', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '7', '1015032', '8', '1015006', '3', '-1', '34', '-1', '11', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010110', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '7', '1015032', '8', '1015009', '3', '-1', '34', '-1', '11', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010111', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '7', '1015032', '8', '1015007', '3', '-1', '34', '-1', '11', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010112', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015004', '7', '-1', '8', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010113', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '9', '1015032', '9', '1015007', '4', '-1', '15', '-1', '7', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010114', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '13', '1015032', '10', '1015006', '7', '-1', '7', '-1', '3', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010115', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '9', '1015032', '9', '15020', '10', '-1', '17', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010118', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015016', '8', '1015032', '9', '15001', '10', '-1', '23', '-1', '9', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010201', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '13', '1015005', '7', '-1', '0', '-1', '15', '-1', '3', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010202', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '12', '1015034', '20', '1015009', '7', '-1', '10', '-1', '5', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010203', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '11', '1015006', '5', '-1', '0', '-1', '22', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010204', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '7', '1015005', '3', '-1', '0', '-1', '51', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010205', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '8', '1015005', '3', '-1', '0', '-1', '41', '-1', '6', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010206', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '9', '1015005', '4', '-1', '0', '-1', '30', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010207', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '9', '1015006', '4', '-1', '0', '-1', '32', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010208', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '8', '1015006', '3', '-1', '0', '-1', '41', '-1', '6', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010209', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '11', '1015005', '5', '-1', '0', '-1', '22', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010210', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '10', '1015034', '18', '1015009', '5', '-1', '15', '-1', '7', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010211', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015019', '7', '1015006', '3', '-1', '0', '-1', '53', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010301', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '8', '1015033', '16', '1015007', '4', '-1', '20', '-1', '10', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010302', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '12', '1015033', '20', '1015005', '7', '-1', '10', '-1', '5', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010303', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '6', '1015033', '12', '1015007', '3', '-1', '31', '-1', '15', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010304', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '7', '1015007', '3', '-1', '0', '-1', '24', '-1', '6', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010305', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '10', '1015033', '18', '1015007', '5', '-1', '17', '-1', '7', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010306', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '7', '1015033', '14', '1015007', '3', '-1', '25', '-1', '13', '-1', '6', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010307', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '6', '1015034', '12', '1015008', '3', '-1', '31', '-1', '15', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010308', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '6', '1015033', '12', '1015005', '3', '-1', '33', '-1', '16', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010309', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '10', '1015033', '18', '1015005', '5', '-1', '15', '-1', '7', '-1', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010310', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '8', '1015033', '16', '1015005', '4', '-1', '22', '-1', '11', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010311', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015017', '7', '1015033', '14', '1015005', '3', '-1', '28', '-1', '12', '-1', '6', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010312', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '9', '1015008', '4', '-1', '0', '-1', '16', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010313', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '7', '1015008', '3', '-1', '0', '-1', '32', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010314', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '8', '1015007', '3', '-1', '0', '-1', '23', '-1', '6', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010315', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '11', '1015007', '5', '-1', '0', '-1', '11', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010316', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '13', '1015008', '7', '-1', '0', '-1', '7', '-1', '3', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010317', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015028', '7', '1015007', '3', '-1', '0', '-1', '34', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010401', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '1015007', '5', '-1', '0', '-1', '10', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010402', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '8', '1015008', '4', '-1', '0', '-1', '17', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010403', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '8', '15038', '5', '-1', '0', '-1', '15', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010404', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '12', '1015007', '7', '-1', '0', '-1', '6', '-1', '3', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010405', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '8', '1015007', '4', '-1', '0', '-1', '17', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010406', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '6', '1015008', '3', '-1', '0', '-1', '33', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010407', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '6', '1015007', '3', '-1', '0', '-1', '34', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010408', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '12', '-1', '0', '-1', '0', '-1', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010409', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '7', '-1', '0', '-1', '0', '-1', '24', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010410', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '-1', '0', '-1', '0', '-1', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010411', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '12', '-1', '0', '-1', '0', '-1', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010412', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '1015008', '5', '-1', '0', '-1', '9', '-1', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010413', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '15038', '5', '-1', '0', '-1', '9', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010414', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '-1', '0', '-1', '0', '-1', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010415', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '-1', '0', '-1', '0', '-1', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010416', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '-1', '0', '-1', '0', '-1', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010417', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '12', '-1', '0', '-1', '0', '-1', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010418', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015024', '10', '-1', '0', '-1', '0', '-1', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010419', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '0', '1015019', '13', '-1', '0', '-1', '0', '-1', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010420', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '0', '1015019', '13', '-1', '0', '-1', '0', '-1', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010421', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '0', '1015019', '13', '-1', '0', '-1', '0', '-1', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010501', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '8', '1015034', '16', '1015007', '4', '-1', '20', '-1', '10', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010502', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '8', '1015034', '16', '1015009', '4', '-1', '20', '-1', '10', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010503', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '6', '1015034', '12', '15001', '15', '-1', '32', '-1', '15', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010504', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '7', '1015034', '14', '1015009', '3', '-1', '25', '-1', '12', '-1', '6', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010505', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '7', '1015034', '14', '15001', '15', '-1', '25', '-1', '12', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010506', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '12', '1015034', '20', '1015008', '7', '-1', '10', '-1', '5', '-1', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010507', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '6', '1015034', '12', '1015009', '3', '-1', '31', '-1', '15', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010508', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '6', '1015034', '12', '1015007', '3', '-1', '31', '-1', '15', '-1', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010509', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '12', '1015034', '20', '-1', '0', '-1', '11', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010510', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015029', '8', '1015034', '16', '1015008', '4', '-1', '22', '-1', '10', '-1', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010601', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010602', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010603', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '20', '1015035', '20', '-1', '0', '-1', '5', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010604', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '18', '1015035', '18', '-1', '0', '-1', '7', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010605', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '15', '1015031', '20', '-1', '0', '-1', '30', '-1', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010606', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '5', '1015031', '12', '-1', '0', '-1', '190', '-1', '15', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010607', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '7', '1015031', '14', '-1', '0', '-1', '120', '-1', '12', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010608', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '6', '1015031', '12', '15009', '3', '-1', '160', '-1', '16', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010609', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010610', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '8', '1015031', '16', '-1', '0', '-1', '80', '-1', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010611', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015002', '10', '1015031', '18', '-1', '0', '-1', '50', '-1', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3010612', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '1015030', '11', '1015035', '12', '-1', '0', '-1', '15', '-1', '15', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011001', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011002', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011003', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011004', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011005', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011006', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011007', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011008', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011009', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011010', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011011', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011012', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011013', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011014', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011015', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011016', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011017', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011018', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011019', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011020', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011101', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011102', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011103', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011104', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011105', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011106', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011107', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011108', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011109', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011110', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011111', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011112', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011113', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011114', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011115', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011116', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011117', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011118', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011119', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011120', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011121', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011122', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011123', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011124', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011125', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011126', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011127', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011128', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011129', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011130', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011131', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011132', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011133', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011134', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011135', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011136', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011137', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011201', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011202', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011203', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011204', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011205', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011206', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011207', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011208', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011209', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011210', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011211', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011212', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011213', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011214', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011215', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011216', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011217', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011218', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011219', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011220', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011221', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011222', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011223', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011224', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011225', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011226', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011227', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011228', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011229', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011230', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011231', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011301', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011302', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011303', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011304', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011305', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011306', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011307', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011308', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011309', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011310', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011311', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011312', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011313', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011314', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011315', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011316', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011317', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011318', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011319', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011401', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011402', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011403', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011404', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011405', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011406', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011407', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011408', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011409', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011410', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011411', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011412', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011413', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011414', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011415', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011416', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011417', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011418', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011419', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011420', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011451', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011452', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011453', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011454', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011455', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011456', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011457', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011458', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011459', '0', '0', '-1', '0', '-1', '0', '1015063', '3', '-1', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011501', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011502', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011503', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011504', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011505', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011506', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011507', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011508', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011509', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011510', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011511', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011512', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011513', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011514', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011515', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011516', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011517', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011518', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011519', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011520', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011521', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011522', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011523', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011524', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011525', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011526', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011527', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011528', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011529', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011530', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011531', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011532', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011533', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011534', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011535', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011536', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011537', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011538', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011539', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011540', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011541', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011542', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011543', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011544', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3011545', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020001', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '100', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020002', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '30', '-1', '0', '-1', '0', '-1', '300', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020003', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '20', '-1', '0', '-1', '0', '-1', '600', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020004', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020005', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020006', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020007', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020008', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020009', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020010', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020011', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '40', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020101', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '40', '-1', '0', '-1', '0', '-1', '100', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020102', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '300', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020103', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '20', '-1', '0', '-1', '0', '-1', '600', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020104', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020105', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020106', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020107', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020108', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020109', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020110', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020201', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '50', '1016002', '30', '-1', '0', '-1', '2000', '-1', '1050', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020202', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '50', '-1', '0', '-1', '0', '-1', '2000', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020203', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016002', '30', '-1', '0', '-1', '0', '-1', '1050', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020204', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1016001', '20', '1016002', '20', '-1', '0', '-1', '850', '-1', '600', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020301', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020302', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020303', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020304', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020305', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '15052', '100', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020306', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020307', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020308', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020309', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020401', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020402', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020403', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020404', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020405', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '15052', '-80', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020406', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020407', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020408', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020409', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020410', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020411', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020412', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020413', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020501', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020502', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020503', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020504', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015063', '50', '-1', '0', '-1', '0', '-1', '9000', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020505', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015063', '50', '-1', '0', '-1', '0', '-1', '9000', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020506', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020507', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020508', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020509', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015063', '50', '-1', '0', '-1', '0', '-1', '4000', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020510', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015063', '50', '-1', '0', '-1', '0', '-1', '4000', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020511', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015001', '5', '-1', '0', '-1', '0', '-1', '250', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020512', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015004', '22', '1015018', '26', '-1', '0', '-1', '20', '-1', '45', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020513', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015004', '18', '1015018', '22', '-1', '0', '-1', '30', '-1', '90', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020514', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015004', '14', '1015018', '18', '-1', '0', '-1', '40', '-1', '125', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020515', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015005', '22', '1015019', '26', '-1', '0', '-1', '20', '-1', '45', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020516', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015005', '18', '1015019', '22', '-1', '0', '-1', '30', '-1', '90', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020517', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015005', '14', '1015019', '18', '-1', '0', '-1', '40', '-1', '125', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020518', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015006', '22', '1015016', '24', '-1', '0', '-1', '20', '-1', '40', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020519', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015006', '18', '1015016', '20', '-1', '0', '-1', '30', '-1', '60', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020520', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015006', '14', '1015016', '16', '-1', '0', '-1', '40', '-1', '80', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020521', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015007', '22', '1015024', '24', '-1', '0', '-1', '20', '-1', '40', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020522', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015007', '18', '1015024', '20', '-1', '0', '-1', '30', '-1', '60', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020523', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015007', '14', '1015024', '16', '-1', '0', '-1', '40', '-1', '80', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020524', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015008', '22', '1015025', '24', '-1', '0', '-1', '20', '-1', '40', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020525', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015008', '18', '1015025', '20', '-1', '0', '-1', '30', '-1', '60', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020526', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015008', '14', '1015025', '16', '-1', '0', '-1', '40', '-1', '80', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020527', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015009', '22', '1015029', '24', '-1', '0', '-1', '20', '-1', '40', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020528', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015009', '18', '1015029', '20', '-1', '0', '-1', '30', '-1', '60', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020529', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015009', '14', '1015029', '16', '-1', '0', '-1', '40', '-1', '80', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020530', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020531', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020532', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020533', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020534', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020535', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020536', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '10', '1015001', '6', '-1', '0', '-1', '0', '-1', '300', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020537', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015018', '22', '1015024', '20', '-1', '0', '-1', '90', '-1', '60', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020538', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020601', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020602', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020603', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020604', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020605', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020606', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020607', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020608', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020609', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020610', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020611', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020612', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020613', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020614', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020615', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3020616', '0', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910001', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910005', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910006', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910007', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910008', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910009', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910101', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910102', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910103', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910104', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910201', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910202', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910203', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910204', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910301', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910302', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910303', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910304', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910305', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910306', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910401', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910402', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3910403', '5', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920001', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920002', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920003', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920004', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920005', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920006', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920007', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920008', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920009', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920010', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920011', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920012', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920013', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920014', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920015', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920016', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920017', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920018', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920019', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920020', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3920021', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940001', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940002', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940003', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940004', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940005', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940006', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940007', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940008', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940009', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940010', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940011', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940012', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940101', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940102', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940103', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940104', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940105', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940106', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940107', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940108', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940109', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('3940110', '6', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020001', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020002', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '8', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020003', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '12', '15040', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020004', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '14', '15040', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020005', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '7', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020006', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '13', '15040', '7', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020007', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '15', '15040', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020008', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '14', '15040', '8', '15015', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020009', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15008', '2', '15016', '2', '15020', '17', '15040', '10', '-1', '0', '0', '0', '57');
INSERT INTO `gamedata_items_equipment` VALUES ('4020010', '37', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '53');
INSERT INTO `gamedata_items_equipment` VALUES ('4020011', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '20', '15040', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020012', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '25', '15040', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020101', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020102', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020103', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020104', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020105', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020106', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15006', '2', '15016', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020107', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020108', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020109', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020110', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '7', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020111', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020112', '37', '29', '-1', '0', '-1', '0', '20024', '0', '-1', '0', '15016', '30', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1021', '0', '55');
INSERT INTO `gamedata_items_equipment` VALUES ('4020113', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '15018', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020201', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020202', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '15020', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020203', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '15020', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020204', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15006', '3', '15016', '5', '15017', '3', '15020', '7', '15010', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020205', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15005', '2', '15019', '3', '15016', '6', '15020', '9', '15040', '2', '0', '0', '57');
INSERT INTO `gamedata_items_equipment` VALUES ('4020206', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020207', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '15020', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020208', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15020', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020209', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '15020', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020210', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '15020', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020211', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '10', '15020', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020301', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020302', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020303', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '40', '15016', '-20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020304', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15008', '2', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020305', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15006', '3', '15016', '1', '15020', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020306', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020307', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020308', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020309', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020310', '37', '29', '-1', '0', '-1', '0', '20005', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1013', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020311', '37', '29', '-1', '0', '-1', '0', '20006', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1014', '0', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020401', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020402', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20051', '0', '15017', '30', '15018', '60', '15050', '5', '15002', '70', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020403', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15004', '7', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '1');
INSERT INTO `gamedata_items_equipment` VALUES ('4020404', '37', '29', '16007', '5', '15018', '30', '-1', '0', '-1', '0', '15016', '20', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020405', '37', '29', '16008', '5', '15018', '25', '-1', '0', '-1', '0', '15016', '25', '15001', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020406', '37', '29', '16009', '5', '15016', '20', '-1', '0', '-1', '0', '15018', '30', '15019', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020407', '37', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15016', '25', '15022', '40', '15012', '15', '-1', '0', '-1', '0', '-1', '0', '1006', '0', '77');
INSERT INTO `gamedata_items_equipment` VALUES ('4020408', '37', '29', '16010', '1', '15007', '40', '-1', '0', '-1', '0', '15052', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020409', '37', '29', '16010', '1', '15016', '30', '-1', '0', '-1', '0', '15052', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020410', '37', '29', '16010', '1', '15018', '45', '-1', '0', '-1', '0', '15052', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4020411', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '5', '15016', '10', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '55');
INSERT INTO `gamedata_items_equipment` VALUES ('4030001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030002', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030003', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030004', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '2', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030005', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030006', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030007', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030008', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030009', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030010', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030011', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030012', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030013', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030014', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030015', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030016', '36', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030101', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030102', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030103', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030104', '36', '29', '-1', '0', '-1', '0', '20007', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1015', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030105', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '4', '15040', '1', '15052', '25', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030106', '36', '29', '-1', '0', '-1', '0', '20009', '0', '-1', '0', '15020', '4', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1017', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030107', '36', '29', '-1', '0', '-1', '0', '20010', '0', '-1', '0', '15020', '2', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1018', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030108', '36', '29', '-1', '0', '-1', '0', '20011', '0', '-1', '0', '15020', '2', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1019', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030109', '36', '29', '-1', '0', '-1', '0', '20012', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1020', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030110', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '2', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030111', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030112', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030113', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '1', '15005', '1', '15016', '2', '15020', '5', '15040', '3', '0', '0', '69');
INSERT INTO `gamedata_items_equipment` VALUES ('4030114', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030115', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '4', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030116', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '5', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030117', '36', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030118', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '5', '15020', '4', '15040', '1', '15052', '30', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030201', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030202', '36', '29', '-1', '0', '-1', '0', '20014', '0', '-1', '0', '15005', '1', '15006', '1', '15009', '1', '15040', '1', '15011', '4', '-1', '0', '1003', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030203', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030204', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030205', '36', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030301', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030302', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030303', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '15018', '7', '15019', '5', '-1', '0', '-1', '0', '0', '0', '69');
INSERT INTO `gamedata_items_equipment` VALUES ('4030304', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030305', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030401', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030402', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030403', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030404', '36', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15001', '16', '15004', '1', '15005', '2', '15010', '5', '-1', '0', '-1', '0', '1001', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030405', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030406', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030407', '36', '29', '-1', '0', '-1', '0', '20024', '0', '-1', '0', '15016', '30', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1021', '0', '71');
INSERT INTO `gamedata_items_equipment` VALUES ('4030408', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030501', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030502', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030503', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030504', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030505', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15005', '3', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030506', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030507', '36', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '70');
INSERT INTO `gamedata_items_equipment` VALUES ('4030601', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030602', '36', '29', '-1', '0', '-1', '0', '20025', '0', '-1', '0', '20050', '0', '15016', '40', '15025', '15', '15001', '120', '-1', '0', '-1', '0', '1023', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030603', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '7', '15008', '7', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030604', '36', '29', '16007', '5', '15018', '30', '-1', '0', '-1', '0', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030605', '36', '29', '16008', '5', '15008', '20', '-1', '0', '-1', '0', '15016', '20', '15005', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030606', '36', '29', '16009', '5', '15018', '40', '-1', '0', '-1', '0', '15020', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030607', '36', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15041', '15', '15012', '15', '15052', '20', '-1', '0', '-1', '0', '-1', '0', '1006', '0', '76');
INSERT INTO `gamedata_items_equipment` VALUES ('4030608', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '5', '15016', '10', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '71');
INSERT INTO `gamedata_items_equipment` VALUES ('4030701', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030702', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030703', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030704', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030705', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030706', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030707', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030708', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030709', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '2');
INSERT INTO `gamedata_items_equipment` VALUES ('4030710', '36', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15029', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4030711', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '20', '15017', '10', '15016', '-20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040001', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040002', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040003', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040004', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040005', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040006', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15020', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040007', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '15016', '2', '15045', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040008', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15020', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040009', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040010', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15016', '3', '15043', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040011', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15018', '7', '15020', '9', '15029', '2', '-1', '0', '-1', '0', '0', '0', '62');
INSERT INTO `gamedata_items_equipment` VALUES ('4040012', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15016', '3', '15047', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040013', '37', '29', '-1', '0', '-1', '0', '20024', '0', '-1', '0', '15016', '30', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1021', '0', '66');
INSERT INTO `gamedata_items_equipment` VALUES ('4040014', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '7', '15047', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040101', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040102', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040103', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15040', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040104', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040105', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040106', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '15040', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040107', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040108', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '6', '15040', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040109', '37', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '65');
INSERT INTO `gamedata_items_equipment` VALUES ('4040110', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15005', '2', '15018', '3', '15016', '1', '15020', '1', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040111', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040201', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15020', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040202', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15020', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040203', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15005', '2', '15018', '3', '15019', '4', '15020', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040204', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15005', '3', '15018', '7', '15020', '12', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040205', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15020', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040206', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15020', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040207', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15020', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040208', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040301', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040302', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '15018', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040303', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '-1', '15018', '6', '15017', '-3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040304', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040305', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040306', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040401', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15020', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040402', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15006', '1', '15020', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040403', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040404', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '2', '15018', '4', '15017', '4', '15020', '6', '15040', '2', '0', '0', '62');
INSERT INTO `gamedata_items_equipment` VALUES ('4040405', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15020', '2', '15040', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040406', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15005', '3', '15020', '15', '15040', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040407', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15020', '10', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040408', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '40', '15016', '-20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040501', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040502', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20052', '0', '15018', '30', '15019', '30', '15052', '50', '15049', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040503', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15005', '7', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '3');
INSERT INTO `gamedata_items_equipment` VALUES ('4040504', '37', '29', '16007', '5', '15018', '30', '-1', '0', '-1', '0', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040505', '37', '29', '16008', '5', '15005', '30', '-1', '0', '-1', '0', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040506', '37', '29', '16009', '5', '15016', '20', '-1', '0', '-1', '0', '15018', '25', '15019', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040507', '37', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15016', '25', '15022', '40', '15012', '15', '-1', '0', '-1', '0', '-1', '0', '1006', '0', '78');
INSERT INTO `gamedata_items_equipment` VALUES ('4040508', '37', '29', '16010', '1', '15005', '40', '-1', '0', '-1', '0', '15001', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040509', '37', '29', '16010', '1', '15016', '30', '-1', '0', '-1', '0', '15001', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040510', '37', '29', '16010', '1', '15018', '45', '-1', '0', '-1', '0', '15001', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4040511', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '15016', '10', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '66');
INSERT INTO `gamedata_items_equipment` VALUES ('4050001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4060001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070001', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070002', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070003', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070004', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070005', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '26', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070006', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070007', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15004', '2', '15009', '2', '15016', '24', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070008', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15008', '2', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '0', '0', '58');
INSERT INTO `gamedata_items_equipment` VALUES ('4070009', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070010', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070011', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070012', '38', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070013', '38', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070101', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070102', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070103', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070104', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070105', '38', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15009', '2', '15018', '8', '15016', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070106', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '8', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070107', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '9', '15016', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070108', '38', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070201', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070202', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070203', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '14', '15016', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070204', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '5', '15020', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070205', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15016', '6', '15020', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070206', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070207', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '13', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070208', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '15016', '7', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070209', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15008', '1', '15018', '12', '15016', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070210', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '8', '15016', '8', '15020', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070211', '38', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15009', '3', '15018', '18', '15016', '16', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070212', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '10', '15020', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070213', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '15', '15020', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070214', '38', '29', '-1', '0', '-1', '0', '20024', '0', '-1', '0', '15016', '30', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1021', '0', '61');
INSERT INTO `gamedata_items_equipment` VALUES ('4070215', '38', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '20', '15016', '20', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070301', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070302', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '8', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070303', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070304', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070305', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '-1', '15008', '-1', '15009', '3', '15018', '13', '15016', '5', '15017', '3', '0', '0', '58');
INSERT INTO `gamedata_items_equipment` VALUES ('4070306', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070307', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '12', '15016', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070308', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070309', '38', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '60');
INSERT INTO `gamedata_items_equipment` VALUES ('4070310', '38', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '18', '15016', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070311', '38', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '25', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070312', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '40', '15016', '-20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070401', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070402', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20054', '0', '15016', '40', '15018', '15', '15052', '-30', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070403', '38', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15006', '7', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '5');
INSERT INTO `gamedata_items_equipment` VALUES ('4070404', '38', '29', '16007', '5', '15018', '30', '-1', '0', '-1', '0', '15016', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070405', '38', '29', '16008', '5', '15018', '25', '-1', '0', '-1', '0', '15016', '25', '15001', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070406', '38', '29', '16009', '5', '15016', '20', '-1', '0', '-1', '0', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070407', '38', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15022', '40', '15016', '25', '15012', '15', '-1', '0', '-1', '0', '-1', '0', '1006', '0', '79');
INSERT INTO `gamedata_items_equipment` VALUES ('4070408', '38', '29', '16010', '1', '15022', '75', '-1', '0', '-1', '0', '15020', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070409', '38', '29', '16010', '1', '15018', '45', '-1', '0', '-1', '0', '15020', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070410', '38', '29', '16010', '1', '15016', '30', '-1', '0', '-1', '0', '15020', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4070411', '38', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15016', '10', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '61');
INSERT INTO `gamedata_items_equipment` VALUES ('4080001', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080002', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080003', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080004', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080005', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15040', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080006', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15004', '2', '15018', '4', '15016', '5', '15017', '2', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080007', '37', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15018', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '54');
INSERT INTO `gamedata_items_equipment` VALUES ('4080008', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '6', '15040', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080009', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '10', '15040', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080010', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '25', '15040', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080011', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '40', '15016', '-20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080101', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080102', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080103', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '22', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080104', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '12', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080105', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15020', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080106', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '18', '15020', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080107', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '25', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080108', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080109', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '5', '15018', '23', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080110', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '2', '15018', '22', '15016', '5', '-1', '0', '-1', '0', '0', '0', '52');
INSERT INTO `gamedata_items_equipment` VALUES ('4080201', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080202', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080203', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080204', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080205', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080206', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080207', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '8', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080208', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080209', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '15016', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080210', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080211', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15004', '2', '15018', '10', '15016', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080212', '37', '29', '-1', '0', '-1', '0', '20024', '0', '-1', '0', '15016', '30', '15020', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1021', '0', '56');
INSERT INTO `gamedata_items_equipment` VALUES ('4080213', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080301', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080302', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '-1', '15018', '12', '15019', '-5', '15016', '5', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080303', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15004', '3', '15018', '18', '15016', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080304', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15040', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080305', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080306', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '20', '15040', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080401', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080402', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '13', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080403', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080404', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15018', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080405', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15009', '2', '15018', '22', '15016', '5', '15017', '4', '-1', '0', '0', '0', '52');
INSERT INTO `gamedata_items_equipment` VALUES ('4080406', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080407', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15016', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080408', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '18', '15016', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080409', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '25', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080501', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080502', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20053', '0', '15016', '30', '15022', '100', '15020', '30', '15051', '30', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080503', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15009', '7', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '4');
INSERT INTO `gamedata_items_equipment` VALUES ('4080504', '37', '29', '16007', '5', '15018', '30', '-1', '0', '-1', '0', '15016', '20', '15020', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080505', '37', '29', '16008', '5', '15018', '25', '-1', '0', '-1', '0', '15016', '25', '15001', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080506', '37', '29', '16009', '5', '15016', '20', '-1', '0', '-1', '0', '15018', '30', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080507', '37', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15016', '25', '15022', '45', '15012', '15', '-1', '0', '-1', '0', '-1', '0', '1006', '0', '77');
INSERT INTO `gamedata_items_equipment` VALUES ('4080508', '37', '29', '16010', '1', '15016', '30', '-1', '0', '-1', '0', '15052', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080509', '37', '29', '16010', '1', '15018', '45', '-1', '0', '-1', '0', '15052', '-15', '15001', '-10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080510', '37', '29', '16010', '1', '15009', '35', '-1', '0', '-1', '0', '15052', '-30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4080511', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '5', '15016', '10', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '56');
INSERT INTO `gamedata_items_equipment` VALUES ('4090001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100001', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100002', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100003', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100004', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15007', '1', '15009', '1', '15029', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100005', '2', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '-1', '0', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100006', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100007', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100008', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100101', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100102', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100103', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100104', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100105', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100106', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100107', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100108', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100109', '2', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100110', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100111', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100112', '2', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100201', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100202', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100203', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15009', '2', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '68');
INSERT INTO `gamedata_items_equipment` VALUES ('4100204', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100205', '2', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100206', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '10', '15019', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100301', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100302', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100303', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100304', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100305', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100306', '2', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100307', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100308', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100401', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100402', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100403', '2', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100404', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '15018', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100405', '2', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100501', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100502', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100503', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100504', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100505', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100506', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100507', '2', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100508', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '50');
INSERT INTO `gamedata_items_equipment` VALUES ('4100509', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100510', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100511', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100601', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100602', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100603', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15004', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100604', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100605', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100606', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100607', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100608', '2', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100609', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '7', '15052', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100701', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100702', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100703', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100704', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100705', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100706', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100707', '2', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100708', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '68');
INSERT INTO `gamedata_items_equipment` VALUES ('4100709', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100710', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100711', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '6');
INSERT INTO `gamedata_items_equipment` VALUES ('4100712', '2', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100713', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15079', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100801', '2', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '5', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100802', '2', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '5', '15014', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100803', '2', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '5', '15011', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100804', '2', '29', '16007', '4', '15038', '15', '-1', '0', '-1', '0', '15029', '10', '15001', '60', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100805', '2', '29', '16010', '1', '15001', '100', '-1', '0', '-1', '0', '15025', '5', '15019', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100806', '2', '29', '16008', '4', '15036', '15', '-1', '0', '-1', '0', '15029', '10', '15001', '60', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100807', '2', '29', '16010', '1', '15001', '120', '-1', '0', '-1', '0', '15025', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100808', '2', '29', '16009', '4', '15007', '7', '-1', '0', '-1', '0', '15029', '10', '15001', '60', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100809', '2', '29', '16010', '1', '15001', '85', '-1', '0', '-1', '0', '15025', '5', '15018', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100810', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15019', '25', '15050', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100811', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100812', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('4100813', '2', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5010001', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020002', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15028', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020003', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '3', '15028', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020004', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '3', '15028', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020005', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '4', '15028', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020006', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '6', '15028', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020007', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '3', '15028', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020008', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '4', '15028', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020009', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15008', '2', '15024', '12', '15028', '17', '15036', '2', '-1', '0', '0', '0', '49');
INSERT INTO `gamedata_items_equipment` VALUES ('5020010', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '5', '15028', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020011', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '6', '15028', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020012', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '7', '15028', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020013', '36', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '15', '15028', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020014', '36', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '15028', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020101', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '5', '15036', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020102', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '6', '15036', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020103', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '7', '15036', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020104', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '-20', '15038', '120', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020105', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '7', '15036', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020106', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15036', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020107', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15007', '2', '15008', '2', '15028', '7', '15036', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020108', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '7', '15036', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020109', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '8', '15036', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020110', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15036', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020111', '37', '29', '-1', '0', '-1', '0', '20025', '0', '-1', '0', '15028', '30', '15036', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1022', '0', '74');
INSERT INTO `gamedata_items_equipment` VALUES ('5020112', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '15', '15036', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020113', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '20', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020114', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '6', '15028', '9', '15036', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '75');
INSERT INTO `gamedata_items_equipment` VALUES ('5020115', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020201', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020202', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15045', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020203', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15046', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020204', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15047', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020205', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15044', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020206', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15043', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020207', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '19', '15048', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020208', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '24', '15007', '4', '15024', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020209', '36', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15007', '2', '15024', '18', '15028', '1', '15036', '1', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020210', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15024', '12', '15045', '6', '15012', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020211', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15024', '14', '15044', '7', '15011', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020212', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15024', '16', '15046', '8', '15013', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020213', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15024', '18', '15043', '9', '15010', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020214', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '2', '15024', '20', '15047', '10', '15014', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020215', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '2', '15024', '22', '15048', '11', '15015', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020216', '36', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15024', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '73');
INSERT INTO `gamedata_items_equipment` VALUES ('5020217', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '25', '15047', '15', '15014', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020301', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '6', '15036', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020302', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '7', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020303', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '3', '15028', '8', '15036', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020304', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020305', '36', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15007', '3', '15024', '1', '15028', '9', '15036', '24', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020306', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '7', '15036', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '9');
INSERT INTO `gamedata_items_equipment` VALUES ('5020307', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '15', '15036', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020401', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020402', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20056', '0', '15007', '45', '15036', '35', '15027', '20', '15102', '50', '15024', '30', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020403', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '10', '15001', '80', '15007', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '10');
INSERT INTO `gamedata_items_equipment` VALUES ('5020404', '36', '29', '16007', '4', '15043', '60', '-1', '0', '-1', '0', '15007', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020405', '36', '29', '16008', '4', '15044', '60', '-1', '0', '-1', '0', '15007', '15', '15027', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020406', '36', '29', '16009', '4', '15028', '43', '-1', '0', '-1', '0', '15001', '70', '15002', '-70', '15013', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020407', '37', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15012', '15', '15052', '-30', '15028', '25', '15007', '30', '-1', '0', '-1', '0', '1006', '0', '80');
INSERT INTO `gamedata_items_equipment` VALUES ('5020408', '36', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15028', '15', '15050', '-3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020409', '36', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15028', '15', '15050', '-3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020410', '36', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15028', '15', '15050', '-3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5020411', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '5', '15028', '10', '15029', '10', '15024', '10', '15103', '50', '-1', '0', '0', '1', '74');
INSERT INTO `gamedata_items_equipment` VALUES ('5030001', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030002', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030003', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030004', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030005', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030006', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030007', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030008', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15043', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030009', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15045', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030010', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15047', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030011', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15046', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030012', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15048', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030013', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15044', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030014', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030015', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030016', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15043', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030017', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15045', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030018', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15047', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030019', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15046', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030020', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15048', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030021', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15044', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030022', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15043', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030023', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15045', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030024', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15047', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030025', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15046', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030026', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15048', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030027', '36', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15044', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030028', '36', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15008', '3', '15024', '5', '15036', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030029', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030030', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '4', '15024', '3', '15046', '20', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030031', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '4', '15024', '3', '15048', '20', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030032', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '4', '15024', '3', '15044', '20', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030033', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '4', '15024', '4', '15043', '24', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030034', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '4', '15024', '4', '15045', '24', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030035', '36', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '4', '15024', '4', '15047', '24', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '7');
INSERT INTO `gamedata_items_equipment` VALUES ('5030036', '36', '29', '-1', '0', '-1', '0', '20025', '0', '-1', '0', '15028', '30', '15036', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1022', '0', '48');
INSERT INTO `gamedata_items_equipment` VALUES ('5030037', '36', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030101', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030102', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15028', '5', '15036', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030103', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15028', '5', '15036', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030104', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '3', '15028', '6', '15036', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030105', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '3', '15028', '7', '15036', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030106', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '4', '15028', '8', '15036', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030107', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15024', '4', '15028', '6', '15036', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030108', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '-3', '15007', '5', '15024', '10', '15028', '10', '15036', '10', '-1', '0', '0', '0', '46');
INSERT INTO `gamedata_items_equipment` VALUES ('5030109', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15024', '5', '15028', '8', '15036', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030110', '37', '29', '-1', '0', '-1', '0', '20013', '0', '-1', '0', '15010', '15', '15024', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '1002', '0', '47');
INSERT INTO `gamedata_items_equipment` VALUES ('5030111', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '15028', '15', '15036', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030112', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '-10', '15008', '3', '15009', '3', '15024', '4', '15028', '7', '15036', '7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030113', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '8', '15028', '12', '15036', '12', '15008', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030201', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '8', '15036', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030202', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '9', '15036', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030203', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '10', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030204', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '11', '15036', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030205', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '11', '15036', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030206', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15008', '2', '15024', '3', '15028', '11', '15036', '21', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030207', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030208', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '12', '15036', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030209', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '3', '15028', '15', '15036', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030210', '37', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '20', '15036', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030301', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '7', '15028', '3', '15036', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030302', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '15028', '3', '15036', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030303', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '15028', '3', '15036', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030304', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '2', '15009', '2', '15024', '8', '15028', '3', '15036', '13', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030305', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15009', '3', '15017', '3', '15024', '14', '15028', '5', '15036', '15', '0', '0', '46');
INSERT INTO `gamedata_items_equipment` VALUES ('5030306', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15024', '8', '15028', '3', '15036', '13', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030307', '37', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '12', '15028', '6', '15036', '16', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030308', '37', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '15', '15028', '10', '15036', '25', '15009', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030309', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '-20', '15025', '40', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030401', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20057', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030402', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20055', '0', '15028', '10', '15025', '30', '15026', '10', '15008', '60', '15050', '1', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030403', '37', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '10', '15001', '80', '15008', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '8');
INSERT INTO `gamedata_items_equipment` VALUES ('5030404', '36', '29', '16007', '4', '15036', '30', '-1', '0', '-1', '0', '15025', '15', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030405', '36', '29', '16008', '4', '15046', '50', '-1', '0', '-1', '0', '15025', '15', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030406', '36', '29', '16009', '4', '15026', '7', '-1', '0', '-1', '0', '15025', '15', '15005', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030407', '36', '29', '-1', '0', '-1', '0', '20015', '0', '-1', '0', '15012', '15', '15045', '40', '15028', '25', '15027', '15', '-1', '0', '-1', '0', '1006', '0', '80');
INSERT INTO `gamedata_items_equipment` VALUES ('5030408', '37', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15050', '-3', '15028', '15', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030409', '37', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15050', '-3', '15028', '15', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030410', '37', '29', '16010', '1', '15024', '60', '-1', '0', '-1', '0', '15050', '-3', '15028', '15', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('5030411', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '5', '15028', '10', '15029', '10', '15025', '12', '15103', '50', '-1', '0', '0', '1', '91');
INSERT INTO `gamedata_items_equipment` VALUES ('5040001', '37', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6010001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6010002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '11');
INSERT INTO `gamedata_items_equipment` VALUES ('6010016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '10', '15006', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6011001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '28');
INSERT INTO `gamedata_items_equipment` VALUES ('6011008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6020001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6020002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6020014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '10', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6020016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020017', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6020018', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '12');
INSERT INTO `gamedata_items_equipment` VALUES ('6021001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '29');
INSERT INTO `gamedata_items_equipment` VALUES ('6021008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6030001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6030002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '13');
INSERT INTO `gamedata_items_equipment` VALUES ('6030016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '10', '15004', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6031001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '30');
INSERT INTO `gamedata_items_equipment` VALUES ('6031008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6040001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6040002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '14');
INSERT INTO `gamedata_items_equipment` VALUES ('6040016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '10', '15007', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6041001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '31');
INSERT INTO `gamedata_items_equipment` VALUES ('6041008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6050001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6050004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '15');
INSERT INTO `gamedata_items_equipment` VALUES ('6050016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '10', '15007', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6051001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '32');
INSERT INTO `gamedata_items_equipment` VALUES ('6051008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6060001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6060007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '16');
INSERT INTO `gamedata_items_equipment` VALUES ('6060015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '10', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6061001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '33');
INSERT INTO `gamedata_items_equipment` VALUES ('6061009', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6070001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6070002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '17');
INSERT INTO `gamedata_items_equipment` VALUES ('6070016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '10', '15009', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6071001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '34');
INSERT INTO `gamedata_items_equipment` VALUES ('6071008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6080001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6080002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '18');
INSERT INTO `gamedata_items_equipment` VALUES ('6080016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '10', '15009', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('6081001', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081002', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081003', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081004', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081005', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081006', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081007', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '35');
INSERT INTO `gamedata_items_equipment` VALUES ('6081008', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7010001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7010006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7010015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '19');
INSERT INTO `gamedata_items_equipment` VALUES ('7010017', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '10', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7010101', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010102', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010103', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010104', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010105', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010106', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010107', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '36');
INSERT INTO `gamedata_items_equipment` VALUES ('7010108', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7010109', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7020001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7020003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '20');
INSERT INTO `gamedata_items_equipment` VALUES ('7020016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '10', '15007', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7020101', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020102', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020103', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020104', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020105', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020106', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020107', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '37');
INSERT INTO `gamedata_items_equipment` VALUES ('7020108', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7020109', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7030001', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030002', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7030003', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030004', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030005', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030006', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030007', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030008', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030009', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030010', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030011', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030012', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030013', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030014', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030015', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '21');
INSERT INTO `gamedata_items_equipment` VALUES ('7030016', '39', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '10', '15009', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7030101', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030102', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030103', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030104', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030105', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030106', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030107', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '38');
INSERT INTO `gamedata_items_equipment` VALUES ('7030108', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('7030109', '40', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010001', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010002', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010003', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010004', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010005', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15001', '35', '15004', '2', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010006', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15001', '35', '15004', '2', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010007', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15001', '45', '15004', '3', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010008', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15021', '10', '15023', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010009', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15001', '45', '15004', '3', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010010', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15001', '45', '15004', '3', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010011', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010012', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010013', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010014', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010015', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010016', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010017', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15001', '25', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010101', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15029', '1', '15031', '3', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010102', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15029', '1', '15031', '3', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010103', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15029', '1', '15031', '3', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010104', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15029', '1', '15031', '3', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010105', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '28', '15007', '1', '15029', '5', '15031', '9', '15032', '5', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010106', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '28', '15007', '1', '15029', '5', '15031', '9', '15032', '5', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010107', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '28', '15007', '1', '15029', '5', '15031', '9', '15032', '5', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010108', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '28', '15007', '1', '15029', '5', '15031', '9', '15032', '5', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010109', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '28', '15007', '1', '15029', '5', '15031', '9', '15032', '5', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010110', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '34', '15007', '2', '15029', '5', '15031', '13', '15032', '7', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010111', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '34', '15007', '2', '15029', '5', '15031', '13', '15032', '7', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010112', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '34', '15007', '2', '15029', '5', '15031', '13', '15032', '7', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010113', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '34', '15007', '2', '15029', '5', '15031', '13', '15032', '7', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010114', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '34', '15007', '2', '15029', '5', '15031', '13', '15032', '7', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010115', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '5', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010116', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '5', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010117', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '5', '15029', '7', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010118', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '5', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010119', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '5', '15029', '7', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010120', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010121', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '6', '15029', '8', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010122', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010123', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '6', '15029', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010124', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010125', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010126', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '4', '15029', '6', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010127', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '4', '15029', '6', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010128', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010129', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15007', '5', '15052', '-20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010130', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15008', '2', '15009', '2', '15029', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010131', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010132', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '4', '15029', '6', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010133', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '4', '15029', '6', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010134', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '4', '15029', '6', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010135', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '4', '15029', '6', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010136', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '5', '15029', '7', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010137', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '5', '15029', '7', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010138', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '5', '15029', '7', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010139', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '5', '15029', '7', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010140', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010141', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '6', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010142', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '6', '15029', '8', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010143', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '6', '15029', '8', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010144', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '6', '15029', '8', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010145', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15028', '6', '15029', '8', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010146', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '6', '15029', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010147', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '6', '15029', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010148', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '6', '15029', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010149', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15028', '6', '15029', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010201', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010202', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010203', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010204', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010205', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010206', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010207', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010208', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010209', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010210', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15006', '2', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010211', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15006', '2', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010212', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15006', '2', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010213', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010214', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010215', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010216', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010217', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010218', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010219', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010220', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010221', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '4', '15006', '3', '15030', '21', '15035', '21', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010222', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '4', '15006', '3', '15030', '21', '15035', '21', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010223', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010224', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010225', '9', '29', '-1', '0', '-1', '0', '20001', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010301', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15076', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010302', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010303', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010304', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010305', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010306', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010307', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010308', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010309', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010310', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010311', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010312', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010313', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010314', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010315', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010316', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010317', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010318', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010319', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010320', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010321', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010322', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010323', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010324', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010325', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010326', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010327', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010328', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010329', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010330', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010401', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15010', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010402', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010403', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15013', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010404', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15012', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010405', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15014', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010406', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15011', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010407', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15010', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010408', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15015', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010409', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15013', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010410', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15012', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010411', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15014', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010412', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15011', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010413', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15010', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010414', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15015', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010415', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15013', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010416', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15012', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010417', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15014', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010418', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15011', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010419', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15002', '14', '15010', '7', '15043', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010420', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '1', '15002', '14', '15015', '7', '15048', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010421', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15002', '14', '15013', '7', '15046', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010422', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15002', '14', '15012', '7', '15045', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010423', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '1', '15002', '14', '15014', '7', '15047', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010424', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15002', '14', '15011', '7', '15044', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010425', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15010', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010426', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15015', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010427', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15013', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010428', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15012', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010429', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15014', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010430', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15011', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010431', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15010', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010432', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15015', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010433', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15013', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010434', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15012', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010435', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15014', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010436', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15011', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010437', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15002', '17', '15010', '10', '15043', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010438', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '1', '15002', '17', '15015', '10', '15048', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010439', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15002', '17', '15013', '10', '15046', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010440', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15002', '17', '15012', '10', '15045', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010441', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '1', '15002', '17', '15014', '10', '15047', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010442', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15002', '17', '15011', '10', '15044', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010443', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15002', '21', '15010', '13', '15043', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010444', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '1', '15002', '21', '15015', '13', '15048', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010445', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15002', '21', '15013', '13', '15046', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010446', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15002', '21', '15012', '13', '15045', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010447', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '1', '15002', '21', '15014', '13', '15047', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010448', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15002', '21', '15011', '13', '15044', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010449', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15002', '27', '15010', '17', '15043', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010450', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '1', '15002', '27', '15015', '17', '15048', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010451', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15002', '27', '15013', '17', '15046', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010452', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15002', '27', '15012', '17', '15045', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010453', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '1', '15002', '27', '15014', '17', '15047', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010454', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15002', '27', '15011', '17', '15044', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010455', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010456', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010457', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010458', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010459', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010460', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010461', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010462', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010463', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010464', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010465', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010466', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010467', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010468', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010469', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010470', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010471', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010472', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010473', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010474', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15016', '2', '15028', '2', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010475', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010476', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010477', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010478', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010479', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010480', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010481', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010482', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010501', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15002', '9', '15029', '1', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010502', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15002', '9', '15029', '1', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010503', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15002', '9', '15029', '1', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010504', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15002', '9', '15029', '1', '15032', '1', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010505', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '12', '15029', '1', '15032', '4', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010506', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '12', '15029', '1', '15032', '4', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010507', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '12', '15029', '1', '15032', '4', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010508', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '12', '15029', '1', '15032', '4', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010509', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '12', '15029', '1', '15032', '4', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010510', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010511', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010512', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010513', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010514', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010515', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15002', '19', '15029', '1', '15032', '9', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010516', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15002', '19', '15029', '1', '15032', '9', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010517', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15002', '19', '15029', '1', '15032', '9', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010518', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15002', '19', '15029', '1', '15032', '9', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010519', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15002', '19', '15029', '1', '15032', '9', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010520', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010521', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010522', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15001', '10', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010523', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010524', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15001', '17', '15002', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010525', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15001', '17', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010526', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010527', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15001', '24', '15002', '24', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010528', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15001', '24', '15035', '18', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010529', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010530', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15001', '28', '15035', '22', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010531', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15001', '28', '15002', '28', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010532', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010533', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010534', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010535', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010536', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15001', '10', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010537', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15001', '10', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010538', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010539', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010540', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15001', '17', '15002', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010541', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15001', '17', '15002', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010542', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15001', '17', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010543', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15001', '17', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010544', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010545', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010546', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '15001', '27', '15002', '27', '15029', '1', '15032', '13', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010547', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010548', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-14', '15002', '28', '15008', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '45');
INSERT INTO `gamedata_items_equipment` VALUES ('8010549', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010550', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15001', '24', '15002', '24', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010551', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15001', '24', '15002', '24', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010552', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15001', '24', '15035', '18', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010553', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15001', '24', '15035', '18', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010554', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010555', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010556', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010557', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010558', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15001', '28', '15035', '22', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010559', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15001', '28', '15035', '22', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010560', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15001', '28', '15035', '22', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010561', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15001', '28', '15035', '22', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010562', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15001', '28', '15002', '28', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010563', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15001', '28', '15002', '28', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010564', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15001', '28', '15002', '28', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010565', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15001', '28', '15002', '28', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010566', '9', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '15035', '20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010567', '9', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '15035', '24', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010601', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15031', '2', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010602', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15031', '2', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010603', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15031', '2', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010604', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15031', '2', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010605', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15031', '5', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010606', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15031', '5', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010607', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15031', '5', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010608', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15031', '5', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010609', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15031', '5', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010610', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15031', '8', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010611', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15031', '8', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010612', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15031', '8', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010613', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15031', '8', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010614', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15031', '8', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010615', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15031', '10', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010616', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15031', '10', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010617', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15031', '10', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010618', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15031', '10', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010619', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15031', '10', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010620', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '13', '15032', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010621', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '13', '15032', '10', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010622', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '13', '15032', '10', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010623', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '13', '15032', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010624', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010625', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '14', '15032', '11', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010626', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '14', '15032', '11', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010627', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '14', '15032', '11', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010628', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '13', '15032', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010629', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '13', '15032', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010630', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '13', '15032', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010631', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '13', '15032', '10', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010632', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '13', '15032', '10', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010633', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '13', '15032', '10', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010634', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '13', '15032', '10', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010635', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '13', '15032', '10', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010636', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '13', '15032', '10', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010637', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '13', '15032', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010638', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '13', '15032', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010639', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '13', '15032', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010640', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010641', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010642', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010643', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010644', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '14', '15032', '11', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010645', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '14', '15032', '11', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010646', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010647', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '14', '15032', '11', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010648', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '14', '15032', '11', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010649', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '14', '15032', '11', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010650', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '14', '15032', '11', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010651', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '14', '15032', '11', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010652', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15031', '14', '15032', '11', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010653', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '14', '15032', '11', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010654', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '14', '15032', '11', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010655', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '14', '15032', '11', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010656', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '14', '15032', '11', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010701', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010702', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010703', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010704', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010705', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010706', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010707', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '20', '15008', '1', '15048', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010708', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '20', '15012', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010709', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010710', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010711', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15002', '14', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010712', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15002', '18', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010713', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15002', '22', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010714', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010715', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15002', '11', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010716', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15002', '24', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010801', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '2', '15031', '5', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010802', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '4', '15031', '8', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010803', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '4', '15031', '8', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010804', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010805', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010806', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15008', '2', '15029', '6', '15031', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010807', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15008', '2', '15029', '6', '15031', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010808', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '2', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010809', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '2', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010810', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '3', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010811', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '3', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010812', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '10', '15007', '5', '15032', '24', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010813', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010814', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010815', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010816', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010817', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010818', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010819', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010820', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010821', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010822', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '-4', '15028', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '45');
INSERT INTO `gamedata_items_equipment` VALUES ('8010823', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '4', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010824', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '4', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010825', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010826', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010827', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010828', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010829', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '3', '15031', '7', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010830', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15008', '2', '15029', '6', '15031', '10', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010831', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15008', '3', '15029', '6', '15031', '13', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010832', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15007', '2', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010833', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15007', '3', '15031', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010834', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '2', '15031', '5', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010835', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '1', '15029', '2', '15031', '5', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010836', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010837', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010838', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010901', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15009', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010902', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15009', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010903', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15009', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010904', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15009', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010905', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15009', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010906', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15009', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010907', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '4', '15009', '2', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010908', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '4', '15009', '2', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010909', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '4', '15009', '2', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010910', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '18', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010911', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '18', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010912', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '18', '15009', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010913', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '18', '15009', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010914', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '24', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010915', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '24', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010916', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '24', '15009', '3', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010917', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '24', '15009', '3', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010918', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '18', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010919', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '18', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010920', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '18', '15009', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010921', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '18', '15009', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010922', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '18', '15009', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010923', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '18', '15009', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010924', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '18', '15009', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010925', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '18', '15009', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010926', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '24', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010927', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '24', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010928', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '24', '15009', '3', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010929', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '24', '15009', '3', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010930', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '24', '15009', '3', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010931', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '24', '15009', '3', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010932', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15009', '2', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8010933', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '24', '15009', '3', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8010934', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '24', '15009', '3', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011001', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011002', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011003', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011004', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011005', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011006', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011007', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011008', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011009', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011010', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011011', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011012', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011013', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011014', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011015', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011016', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011017', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011018', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011019', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '5', '15048', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011020', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011021', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011022', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '10', '15020', '10', '15035', '24', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011101', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011102', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15008', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011103', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15008', '2', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011104', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15008', '3', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011105', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '2', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '51');
INSERT INTO `gamedata_items_equipment` VALUES ('8011106', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011107', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011108', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '3', '15009', '1', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011109', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '3', '15009', '2', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011110', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '4', '15009', '2', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011201', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011202', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011203', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011204', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15007', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011205', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15007', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011206', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15007', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011207', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15007', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011208', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15007', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011209', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011210', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011211', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011212', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011213', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15007', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011214', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011215', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011216', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011217', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011218', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15007', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011219', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '-1', '15016', '3', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '51');
INSERT INTO `gamedata_items_equipment` VALUES ('8011220', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011221', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011222', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '5', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011223', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '5', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011301', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011302', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011303', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011304', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011305', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011306', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011307', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011308', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011309', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011310', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011311', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011312', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011313', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011314', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011315', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011316', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011317', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '2', '15007', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011318', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011319', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '3', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011320', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '1', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011321', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011322', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011323', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '7', '15052', '-7', '15012', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011324', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011325', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011326', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011327', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011328', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '2', '15007', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011329', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '2', '15007', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011330', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011331', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011332', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '3', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011333', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '3', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011334', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '1', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011335', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '1', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011336', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011337', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011338', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011339', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011340', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011341', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15006', '3', '15007', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011401', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15008', '1', '15029', '2', '15035', '8', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011402', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15008', '2', '15029', '2', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011403', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '1', '15005', '3', '15018', '4', '15029', '2', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011404', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15004', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011405', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15004', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011406', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '3', '15004', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011407', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15004', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011408', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15004', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011409', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15004', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011501', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011502', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011503', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011504', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '24', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011505', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '24', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011506', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '24', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011507', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '24', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011508', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011509', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011510', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011511', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011512', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011513', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011514', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '51');
INSERT INTO `gamedata_items_equipment` VALUES ('8011515', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '1', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011516', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '1', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011517', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011518', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011519', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15007', '2', '15015', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011520', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '5', '15007', '2', '15010', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011521', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15017', '3', '15006', '3', '15008', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011522', '9', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011523', '9', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '12', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011524', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '15018', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011601', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15005', '1', '15029', '1', '15032', '4', '15035', '8', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011602', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15005', '1', '15029', '1', '15032', '6', '15035', '12', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011603', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15005', '2', '15029', '1', '15032', '8', '15035', '16', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011604', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15005', '3', '15029', '1', '15032', '10', '15035', '21', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011605', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '15', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011606', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011607', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '20', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011608', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '20', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011609', '9', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011610', '9', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011701', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011702', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011703', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011704', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011705', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011706', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011707', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011708', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011709', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '81');
INSERT INTO `gamedata_items_equipment` VALUES ('8011710', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '28', '15006', '2', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011711', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '28', '15006', '2', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011712', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '33', '15006', '2', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011713', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '33', '15006', '2', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011801', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011802', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011803', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011804', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011805', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '4', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011806', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '4', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011807', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '4', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011808', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '4', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011809', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '4', '15035', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011810', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15009', '1', '15031', '9', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011811', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15009', '1', '15031', '9', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011812', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15009', '1', '15031', '9', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011813', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15009', '1', '15031', '9', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011814', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15009', '1', '15031', '9', '15035', '12', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011815', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15004', '1', '15031', '8', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011816', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15004', '1', '15031', '8', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011817', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15004', '1', '15031', '8', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011901', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8011902', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15008', '4', '15009', '4', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8011903', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '4', '15009', '4', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '85');
INSERT INTO `gamedata_items_equipment` VALUES ('8012001', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012002', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '1', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012003', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '3', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012004', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '1', '15032', '4', '15035', '15', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012005', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '1', '15032', '4', '15035', '15', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012006', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '1', '15032', '4', '15035', '15', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012007', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '1', '15032', '4', '15035', '15', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012008', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '1', '15032', '4', '15035', '15', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012009', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012010', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012011', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '6', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012012', '9', '27', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '6', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012013', '9', '28', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '6', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012014', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15035', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012015', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15035', '20', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012016', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15035', '20', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012017', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '6', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012018', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '6', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012019', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15035', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012020', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '4', '15035', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012021', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15035', '20', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012022', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15035', '20', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012023', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15035', '20', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012024', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15035', '20', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012101', '9', '29', '-1', '0', '-1', '0', '20002', '0', '-1', '0', '15001', '9', '15002', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012102', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15016', '1', '15024', '1', '15028', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012103', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012201', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '81');
INSERT INTO `gamedata_items_equipment` VALUES ('8012202', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15004', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012301', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '11', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012302', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '11', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012303', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '11', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012304', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '11', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012305', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '11', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012306', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '9', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012307', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012308', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012309', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '15', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012310', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '15', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012311', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '15', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012312', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012313', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '18', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012314', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012315', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '18', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012316', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012317', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012318', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012319', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '15', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012320', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '15', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012321', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '15', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012322', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '15', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012323', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '15', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012324', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '15', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012325', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '15', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012326', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '15', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012327', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '15', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012328', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012329', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012330', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012331', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012332', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '18', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012333', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '18', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012334', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '18', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012335', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '18', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012336', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012337', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012338', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012339', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012340', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '18', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012341', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '18', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012342', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '18', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012343', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '18', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012401', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012402', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012403', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012404', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '4', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012405', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '4', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012406', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012407', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012408', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012409', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012410', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012411', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012412', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '8', '15028', '8', '15030', '24', '15033', '24', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012501', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012502', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15011', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012601', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15002', '14', '15032', '7', '15035', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012602', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15002', '14', '15032', '7', '15035', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012603', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15002', '9', '15032', '1', '15035', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012604', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012605', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '1', '15015', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012606', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '1', '15011', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012607', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '1', '15014', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012701', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '14', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012702', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '14', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012703', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '14', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012704', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '14', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012705', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '14', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012706', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012707', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012708', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012709', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012710', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '18', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012711', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '23', '15035', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012712', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '23', '15035', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012713', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '23', '15035', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012714', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '23', '15035', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012715', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '23', '15035', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012716', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012717', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '12', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012718', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15030', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012719', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012720', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '16', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012721', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012722', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012723', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012724', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '12', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012725', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '12', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012726', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15030', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012727', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15030', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012728', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012729', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012730', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012731', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012732', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '16', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012733', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '16', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012734', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '16', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012735', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '16', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012736', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012737', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012738', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012739', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '3', '15030', '16', '15035', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012801', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012802', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012803', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012804', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15002', '40', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012805', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '10', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8012901', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '18', '15033', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012902', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '15030', '7', '15032', '20', '15033', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012903', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '15030', '7', '15032', '20', '15033', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8012904', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '15030', '7', '15032', '20', '15033', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013001', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '2', '15009', '4', '15024', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013002', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '2', '15009', '4', '15024', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013003', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '3', '15009', '5', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013004', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '3', '15009', '5', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013005', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15036', '5', '15081', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013006', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '3', '15009', '5', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013007', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '3', '15009', '5', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013008', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15007', '3', '15009', '5', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013101', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15031', '10', '15033', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013102', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15031', '10', '15033', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013201', '9', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15010', '5', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013202', '9', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15012', '5', '15011', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013203', '9', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15013', '5', '15014', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013204', '9', '29', '16010', '1', '15005', '30', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013205', '9', '29', '16010', '1', '15018', '15', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '15009', '15', '15020', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013206', '9', '29', '16010', '1', '15007', '40', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '15036', '25', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013301', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '-1', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013302', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '-1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013303', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '1', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013304', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013401', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15076', '10', '15077', '10', '15078', '10', '15079', '10', '15081', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013402', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '75', '15002', '75', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013403', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '10', '15005', '10', '15006', '10', '15007', '10', '15008', '10', '15009', '10', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013404', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013501', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15025', '15', '15052', '5', '15008', '16', '15002', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013502', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '25', '15004', '3', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013503', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20033', '0', '15001', '60', '15005', '5', '15004', '2', '15020', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013504', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15022', '40', '15004', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013505', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '10', '15006', '3', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013506', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15025', '25', '15008', '7', '15002', '22', '15024', '-5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013507', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20047', '0', '15038', '22', '15028', '4', '15007', '5', '15002', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013601', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '20', '15005', '10', '15004', '15', '15017', '-10', '15025', '-20', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013602', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15020', '40', '15022', '30', '15007', '20', '15017', '-10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013603', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15029', '8', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013604', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15029', '8', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013605', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15029', '8', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013606', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15029', '8', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013607', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '15029', '8', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013608', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '60', '15005', '7', '15008', '7', '15052', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013609', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '6', '15007', '20', '15036', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013610', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '50', '15016', '2', '15017', '2', '15020', '10', '16004', '30', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013611', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15105', '10', '15035', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013612', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15105', '10', '15035', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013613', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15105', '10', '15035', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013614', '9', '29', '16007', '3', '15002', '70', '-1', '0', '-1', '0', '15007', '10', '16006', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013615', '9', '29', '16007', '2', '15001', '35', '-1', '0', '-1', '0', '15024', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013616', '9', '29', '16007', '3', '15030', '5', '-1', '0', '-1', '0', '15031', '14', '15032', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013617', '9', '29', '16008', '3', '15002', '70', '-1', '0', '-1', '0', '15007', '10', '16006', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013618', '9', '29', '16008', '2', '15001', '35', '-1', '0', '-1', '0', '15024', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013619', '9', '29', '16008', '3', '15030', '5', '-1', '0', '-1', '0', '15031', '14', '15032', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013620', '9', '29', '16009', '3', '15002', '70', '-1', '0', '-1', '0', '15007', '10', '16006', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013621', '9', '29', '16009', '2', '15001', '35', '-1', '0', '-1', '0', '15024', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013622', '9', '29', '16009', '3', '15030', '5', '-1', '0', '-1', '0', '15031', '14', '15032', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013623', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013624', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013625', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '5', '15007', '8', '15002', '40', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013626', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013627', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013628', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013629', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013630', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013631', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013632', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013633', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013634', '9', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '5', '15104', '10', '15030', '15', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '22');
INSERT INTO `gamedata_items_equipment` VALUES ('8013635', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013636', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '10', '15006', '15', '15020', '20', '15022', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8013637', '9', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15027', '10', '15025', '25', '15008', '5', '15029', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030001', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15031', '1', '-1', '0', '-1', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030002', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15031', '1', '-1', '0', '-1', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030003', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15031', '1', '-1', '0', '-1', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030004', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15031', '1', '-1', '0', '-1', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030005', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15031', '3', '-1', '0', '-1', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030006', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15031', '3', '-1', '0', '-1', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030007', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15031', '3', '-1', '0', '-1', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030008', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15031', '3', '-1', '0', '-1', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030009', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15031', '3', '-1', '0', '-1', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030010', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '15030', '15', '15031', '5', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030011', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '15030', '15', '15031', '5', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030012', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '15030', '15', '15031', '5', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030013', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '15030', '15', '15031', '5', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030014', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '15030', '15', '15031', '5', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030015', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '5', '15031', '28', '15035', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030016', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '5', '15031', '28', '15035', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030017', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '28', '15035', '15', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030018', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '28', '15035', '15', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030019', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '28', '15035', '15', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030020', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15031', '31', '15035', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030021', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '31', '15035', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030022', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '31', '15035', '18', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030023', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '31', '15035', '18', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030024', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '5', '15031', '28', '15035', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030025', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '5', '15031', '28', '15035', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030026', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '28', '15035', '15', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030027', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '28', '15035', '15', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030028', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '28', '15035', '15', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030029', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '28', '15035', '15', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030030', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '28', '15035', '15', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030031', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '28', '15035', '15', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030032', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030033', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030034', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15004', '2', '15005', '2', '15030', '26', '15031', '9', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030035', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '20', '15034', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030036', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '28', '15035', '15', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030037', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '28', '15035', '15', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030038', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '28', '15035', '15', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030039', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15031', '31', '15035', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030040', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15031', '31', '15035', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030041', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '6', '15031', '31', '15035', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030042', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '31', '15035', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030043', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '31', '15035', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030044', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15031', '31', '15035', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030045', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '31', '15035', '18', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030046', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '31', '15035', '18', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030047', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15031', '31', '15035', '18', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030048', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '31', '15035', '18', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030049', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '31', '15035', '18', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030050', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15031', '31', '15035', '18', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030101', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030102', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030103', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030104', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030105', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030106', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '53', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030107', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '53', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030108', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '53', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030109', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15001', '45', '15005', '6', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030110', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15001', '45', '15005', '6', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030111', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15001', '60', '15005', '7', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030112', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '50', '15005', '4', '15008', '4', '15041', '5', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030113', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15001', '60', '15005', '7', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030114', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15001', '60', '15005', '7', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030115', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030116', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030117', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030118', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030119', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030201', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15008', '1', '15029', '2', '15030', '4', '15031', '2', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030202', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15008', '1', '15029', '2', '15030', '4', '15031', '2', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030203', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15008', '1', '15029', '2', '15030', '4', '15031', '2', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030204', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15008', '1', '15029', '2', '15030', '4', '15031', '2', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030205', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15008', '1', '15029', '4', '15030', '7', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030206', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15008', '1', '15029', '4', '15030', '7', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030207', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15008', '1', '15029', '4', '15030', '7', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030208', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15008', '1', '15029', '4', '15030', '7', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030209', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15008', '1', '15029', '4', '15030', '7', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030210', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '37', '15008', '2', '15029', '4', '15030', '11', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030211', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '37', '15008', '2', '15029', '4', '15030', '11', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030212', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '37', '15008', '2', '15029', '4', '15030', '11', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030213', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '37', '15008', '2', '15029', '4', '15030', '11', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030214', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '37', '15008', '2', '15029', '4', '15030', '11', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030215', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '45', '15008', '3', '15029', '5', '15030', '15', '15031', '9', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030216', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '45', '15008', '3', '15029', '5', '15030', '15', '15031', '9', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030217', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '45', '15008', '3', '15029', '5', '15030', '15', '15031', '9', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030218', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '45', '15008', '3', '15029', '5', '15030', '15', '15031', '9', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030219', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '45', '15008', '3', '15029', '5', '15030', '15', '15031', '9', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030220', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '9', '15002', '46', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030221', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '46', '15029', '6', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030222', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '46', '15029', '6', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030223', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '9', '15002', '46', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030224', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '9', '15002', '46', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030225', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '50', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030226', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '50', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030227', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '50', '15029', '7', '15024', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030228', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '50', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030229', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '50', '15029', '7', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030230', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '54', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030231', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '54', '15029', '8', '15024', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030232', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '54', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030233', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '54', '15029', '8', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030234', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '46', '15029', '6', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030235', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '46', '15029', '6', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030236', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '46', '15029', '6', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030237', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '46', '15029', '6', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030238', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '50', '15029', '7', '15024', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030239', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '50', '15029', '7', '15024', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030240', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '50', '15029', '7', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030241', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '50', '15029', '7', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030242', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '54', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030243', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '54', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030244', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '40', '15037', '5', '15036', '35', '15052', '-10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030245', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030246', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '13', '15002', '57', '15008', '4', '15029', '5', '15030', '20', '15031', '12', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030247', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030248', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15007', '3', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030249', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15002', '54', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030250', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '54', '15029', '8', '15024', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030251', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '54', '15029', '8', '15024', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030252', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '54', '15029', '8', '15024', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030253', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15002', '54', '15029', '8', '15024', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030254', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '54', '15029', '8', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030255', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '54', '15029', '8', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030256', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '54', '15029', '8', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030257', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '54', '15029', '8', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030301', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030302', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030303', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030304', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030305', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030306', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030307', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030308', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030309', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030310', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030311', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030312', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030313', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030314', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030315', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030316', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030317', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030318', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030319', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030320', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15001', '32', '15004', '4', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030321', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15001', '32', '15004', '4', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030322', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030323', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030324', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030325', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030326', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030327', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030328', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030329', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030330', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030331', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030332', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030333', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030334', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030335', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030336', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030337', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030338', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030339', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030340', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030341', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030342', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030343', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030344', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030345', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030346', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030347', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030348', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030349', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15004', '7', '15016', '7', '15022', '50', '15079', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030350', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15005', '3', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030401', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '1', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030402', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '1', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030403', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '1', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030404', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '1', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030405', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15006', '2', '15017', '2', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030406', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15006', '2', '15017', '2', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030407', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15006', '2', '15017', '2', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030408', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15006', '2', '15017', '2', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030409', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '21', '15006', '2', '15017', '2', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030410', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '15006', '3', '15017', '3', '15029', '1', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030411', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '15006', '3', '15017', '3', '15029', '1', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030412', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '15006', '3', '15017', '3', '15029', '1', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030413', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '15006', '3', '15017', '3', '15029', '1', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030414', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '15006', '3', '15017', '3', '15029', '1', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030415', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '15', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030416', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '15', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030417', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '15', '15029', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030418', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '15', '15029', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030419', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15001', '15', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030420', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '15', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030421', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '15', '15029', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030422', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15001', '15', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030423', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '27', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030424', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '27', '15029', '4', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030425', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15001', '27', '15029', '4', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030426', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15001', '15', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030427', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '27', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030428', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15001', '27', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030429', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '27', '15029', '4', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030430', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15001', '27', '15029', '4', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030431', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15001', '27', '15029', '4', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030432', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15001', '27', '15029', '4', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030433', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030434', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030435', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030436', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030437', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030438', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030439', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030440', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030441', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030442', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030443', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030444', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030445', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030446', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030447', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15002', '15', '15006', '3', '15009', '3', '15017', '4', '15029', '4', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030501', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15017', '1', '15030', '3', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030502', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15017', '1', '15030', '3', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030503', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15017', '1', '15030', '3', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030504', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15017', '1', '15030', '3', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030505', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15017', '2', '15030', '8', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030506', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15017', '2', '15030', '8', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030507', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15017', '2', '15030', '8', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030508', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15017', '2', '15030', '8', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030509', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15017', '2', '15030', '8', '15031', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030510', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15006', '1', '15017', '2', '15030', '12', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030511', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15006', '1', '15017', '2', '15030', '12', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030512', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15006', '1', '15017', '2', '15030', '12', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030513', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15006', '1', '15017', '2', '15030', '12', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030514', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15006', '1', '15017', '2', '15030', '12', '15031', '5', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030515', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15006', '1', '15017', '2', '15030', '17', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030516', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15006', '1', '15017', '2', '15030', '17', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030517', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15006', '1', '15017', '2', '15030', '17', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030518', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15006', '1', '15017', '2', '15030', '17', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030519', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15006', '1', '15017', '2', '15030', '17', '15031', '7', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030520', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030521', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15031', '18', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030522', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15031', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030523', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '10', '15031', '18', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030524', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '11', '15031', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030525', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '11', '15031', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030526', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '11', '15031', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030527', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '11', '15031', '20', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030528', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030529', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030530', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030531', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15031', '18', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030532', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15031', '18', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030533', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15031', '18', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030534', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15031', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030535', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15031', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030536', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15031', '18', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030537', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '10', '15031', '18', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030538', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '10', '15031', '18', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030539', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '10', '15031', '18', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030540', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '11', '15031', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030541', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '11', '15031', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030542', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '11', '15031', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030543', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '11', '15031', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030544', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '11', '15031', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030545', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '11', '15031', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030546', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030547', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030548', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15030', '10', '15031', '5', '15032', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030549', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '11', '15031', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030550', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '11', '15031', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030551', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '11', '15031', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030552', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '11', '15031', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030553', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '11', '15031', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030554', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '11', '15031', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030555', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '11', '15031', '20', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030556', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '11', '15031', '20', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030557', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '11', '15031', '20', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030558', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '11', '15031', '20', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030601', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030602', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030603', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030604', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15006', '2', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030605', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '3', '15017', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030606', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '3', '15017', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030607', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '3', '15017', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030608', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '3', '15017', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030609', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15006', '3', '15017', '4', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030610', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '4', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030611', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '4', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030612', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '4', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030613', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '4', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030614', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '4', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030615', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '6', '15017', '5', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030616', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '6', '15017', '5', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030617', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '6', '15017', '5', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030618', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '6', '15017', '5', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030619', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '6', '15017', '5', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030620', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15009', '-2', '15016', '2', '15017', '5', '15029', '1', '-1', '0', '0', '0', '59');
INSERT INTO `gamedata_items_equipment` VALUES ('8030621', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15004', '5', '15008', '5', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030622', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15004', '5', '15008', '5', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030623', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15004', '6', '15008', '6', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030624', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15004', '6', '15008', '6', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030625', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15008', '8', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030626', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '10', '15008', '10', '15018', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030627', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15018', '5', '15016', '5', '15006', '12', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030701', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030702', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030703', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030704', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030705', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030706', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030707', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030708', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030709', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030710', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15030', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030711', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15009', '2', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030712', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15009', '2', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030713', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15009', '2', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030714', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15009', '2', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030715', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15009', '2', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030716', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '48', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '82');
INSERT INTO `gamedata_items_equipment` VALUES ('8030717', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030718', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '5', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030719', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '5', '15008', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030720', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030721', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '8', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030722', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030723', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030724', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '10', '15008', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030725', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '15', '15029', '15', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030726', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030727', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030728', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '5', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030729', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '5', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030730', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '5', '15008', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030731', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '5', '15008', '1', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030732', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030733', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030734', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '8', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030735', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15017', '8', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030736', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030737', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030738', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030739', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030740', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030741', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '10', '15008', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030742', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '10', '15008', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030743', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '10', '15008', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030744', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '14', '15016', '7', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030745', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '20', '15016', '10', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030801', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030802', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15002', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030803', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15002', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030804', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15002', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030805', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030806', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030807', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030808', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030809', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030810', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030811', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030812', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030813', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15002', '44', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030814', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15002', '44', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030815', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15002', '44', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030816', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '44', '15002', '44', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030817', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '7', '15008', '4', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '86');
INSERT INTO `gamedata_items_equipment` VALUES ('8030818', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15008', '-2', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '63');
INSERT INTO `gamedata_items_equipment` VALUES ('8030819', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15002', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030820', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15002', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030821', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '32', '15002', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030822', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '32', '15002', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030823', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '50', '15002', '40', '15004', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030824', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15002', '40', '15017', '10', '15029', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030901', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15031', '2', '15033', '8', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030902', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15031', '2', '15033', '8', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030903', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15031', '2', '15033', '8', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030904', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15031', '3', '15033', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030905', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15031', '3', '15033', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030906', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15031', '3', '15033', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030907', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15031', '3', '15033', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030908', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '5', '15031', '4', '15033', '17', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030909', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '5', '15031', '4', '15033', '17', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030910', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '5', '15031', '4', '15033', '17', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030911', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '5', '15031', '4', '15033', '17', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030912', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15005', '6', '15031', '6', '15033', '22', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030913', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15005', '6', '15031', '6', '15033', '22', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030914', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15005', '6', '15031', '6', '15033', '22', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030915', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15005', '6', '15031', '6', '15033', '22', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030916', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '3', '15031', '3', '15033', '11', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030917', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '3', '15018', '2', '15016', '2', '15029', '1', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030918', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15004', '3', '15006', '3', '15005', '3', '15029', '1', '-1', '0', '0', '0', '59');
INSERT INTO `gamedata_items_equipment` VALUES ('8030919', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '3', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8030920', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '2', '15005', '3', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030921', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '2', '15005', '3', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030922', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '3', '15005', '4', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030923', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '3', '15005', '4', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8030924', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15006', '2', '15014', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031001', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15017', '1', '15031', '3', '15033', '10', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031002', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15017', '1', '15031', '3', '15033', '10', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031003', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15017', '1', '15031', '3', '15033', '10', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031004', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '2', '15017', '1', '15031', '3', '15033', '10', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031005', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '1', '15031', '5', '15033', '15', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031006', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '1', '15031', '5', '15033', '15', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031007', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '1', '15031', '5', '15033', '15', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031008', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '1', '15031', '5', '15033', '15', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031009', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '1', '15031', '5', '15033', '15', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031010', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15017', '1', '15031', '6', '15033', '20', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031011', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15017', '1', '15031', '6', '15033', '20', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031012', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15017', '1', '15031', '6', '15033', '20', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031013', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15017', '1', '15031', '6', '15033', '20', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031014', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15017', '1', '15031', '6', '15033', '20', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031015', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15005', '6', '15017', '1', '15031', '8', '15033', '24', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031016', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15005', '6', '15017', '1', '15031', '8', '15033', '24', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031017', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15005', '6', '15017', '1', '15031', '8', '15033', '24', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031018', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15005', '6', '15017', '1', '15031', '8', '15033', '24', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031019', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15005', '6', '15017', '1', '15031', '8', '15033', '24', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031020', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031021', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '10', '15034', '10', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031022', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '4', '15033', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031023', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '24', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031024', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '24', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031025', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '24', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031026', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15033', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031027', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '28', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031028', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '28', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031029', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '28', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031030', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '4', '15033', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031031', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '4', '15033', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031032', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '4', '15033', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031033', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '24', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031034', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '24', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031035', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '24', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031036', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '24', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031037', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '24', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031038', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '24', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031039', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '24', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031040', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '24', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031041', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '24', '15006', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031042', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15033', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031043', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15033', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031044', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15033', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031045', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15033', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031046', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '28', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031047', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '28', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031048', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '28', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031049', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15033', '28', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031050', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '28', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031051', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '28', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031052', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '28', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031053', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15033', '28', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031054', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '28', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031055', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '28', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031056', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '28', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031057', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15033', '28', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031101', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031102', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031103', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031104', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031105', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031106', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031107', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031108', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031109', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031110', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031111', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031112', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031113', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031114', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031115', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031116', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031117', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031118', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031119', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031120', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031121', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '25', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031122', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '25', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031201', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15009', '1', '15030', '3', '15033', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031202', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15009', '1', '15030', '3', '15033', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031203', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15009', '1', '15030', '3', '15033', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031204', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15009', '1', '15030', '3', '15033', '3', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031205', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '2', '15030', '7', '15033', '7', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031206', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '2', '15030', '7', '15033', '7', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031207', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '2', '15030', '7', '15033', '7', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031208', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '2', '15030', '7', '15033', '7', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031209', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '2', '15030', '7', '15033', '7', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031210', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031211', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031212', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031213', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031214', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031215', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031216', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '4', '15030', '16', '15033', '16', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031217', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '4', '15030', '16', '15033', '16', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031218', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '4', '15030', '16', '15033', '16', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031219', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '4', '15030', '16', '15033', '16', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031220', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '4', '15030', '16', '15033', '16', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031221', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031222', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15005', '4', '15009', '3', '15030', '14', '15033', '14', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031223', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '20', '15030', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031224', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '8', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031225', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '8', '15033', '8', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031226', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '8', '15033', '8', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031227', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031228', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '13', '15033', '13', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031229', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '13', '15033', '13', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031230', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031231', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '17', '15033', '17', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031232', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '17', '15033', '17', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031233', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '8', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031234', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '8', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031235', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '8', '15033', '8', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031236', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '8', '15033', '8', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031237', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '8', '15033', '8', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031238', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '8', '15033', '8', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031239', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031240', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031241', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '13', '15033', '13', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031242', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '13', '15033', '13', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031243', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '13', '15033', '13', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031244', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '13', '15033', '13', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031245', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031246', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031247', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '17', '15033', '17', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031248', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '17', '15033', '17', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031249', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '17', '15033', '17', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031250', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15030', '17', '15033', '17', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031301', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '17', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031302', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '17', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031303', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '17', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031304', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '17', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031305', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031306', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031307', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031308', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031309', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031310', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '29', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031311', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '29', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031312', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '29', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031313', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '29', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031314', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '29', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031315', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031316', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031401', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15002', '18', '15029', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031402', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15002', '18', '15029', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031403', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15002', '18', '15029', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031404', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15002', '18', '15029', '1', '15031', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031405', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15002', '24', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031406', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15002', '24', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031407', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15002', '24', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031408', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15002', '24', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031409', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15002', '24', '15029', '2', '15031', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031410', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '30', '15029', '2', '15031', '4', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031411', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '30', '15029', '2', '15031', '4', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031412', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '30', '15029', '2', '15031', '4', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031413', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '30', '15029', '2', '15031', '4', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031414', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '30', '15029', '2', '15031', '4', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031415', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031416', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-18', '15002', '18', '15005', '-3', '15008', '3', '15029', '3', '-1', '0', '0', '0', '72');
INSERT INTO `gamedata_items_equipment` VALUES ('8031417', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '6', '15001', '10', '15002', '32', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031418', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '6', '15001', '10', '15002', '32', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031419', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '7', '15001', '12', '15002', '36', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031420', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '7', '15001', '12', '15002', '36', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031421', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-60', '15002', '90', '15005', '-10', '15008', '15', '15017', '-20', '15029', '25', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031501', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15008', '1', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031502', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15008', '1', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031503', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15008', '2', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031504', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15008', '2', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031505', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15008', '3', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031506', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15008', '3', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031507', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15008', '3', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031508', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15008', '3', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031509', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15008', '4', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031510', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15008', '4', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031511', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15008', '4', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031512', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15008', '4', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031513', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15004', '3', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031514', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031515', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031516', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '5', '15008', '4', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031517', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '5', '15008', '4', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031518', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '4', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031519', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '4', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031520', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '5', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031521', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '5', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031522', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '5', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031523', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '6', '15008', '5', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031601', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15008', '2', '15033', '6', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031602', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15008', '2', '15033', '6', '15029', '1', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031603', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15008', '2', '15033', '8', '15029', '2', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031604', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031605', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15004', '5', '15008', '5', '15033', '15', '15029', '2', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031606', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15004', '6', '15008', '6', '15033', '17', '15029', '2', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031607', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15018', '5', '15016', '5', '15029', '2', '15015', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031608', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15018', '7', '15016', '7', '15029', '2', '15040', '3', '-1', '0', '0', '0', '63');
INSERT INTO `gamedata_items_equipment` VALUES ('8031609', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '3', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031610', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '5', '15018', '7', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031611', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '5', '15018', '7', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031612', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '6', '15018', '8', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031613', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15006', '6', '15018', '8', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031701', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031702', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031703', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031704', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031705', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '4', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031706', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031707', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031708', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031709', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031710', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '6', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031711', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031712', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031713', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031714', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031715', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031716', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031717', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031718', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031719', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '8', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '82');
INSERT INTO `gamedata_items_equipment` VALUES ('8031720', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15004', '5', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031721', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15004', '5', '15018', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031722', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15004', '6', '15018', '6', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031723', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15004', '6', '15018', '6', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031724', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15018', '3', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031801', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031802', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031803', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031804', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '2', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031805', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031806', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031807', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031808', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031809', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '3', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031810', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031811', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031812', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031813', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031814', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031815', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '6', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031816', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '6', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031817', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '6', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031818', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '6', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031819', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15008', '6', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031820', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15002', '30', '15008', '4', '15009', '4', '15024', '4', '15028', '4', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031821', '42', '29', '16008', '0', '-1', '0', '20026', '0', '-1', '0', '15002', '15', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8031822', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '1', '15008', '6', '15009', '3', '15029', '9', '15025', '9', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031823', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '1', '15008', '6', '15009', '3', '15029', '9', '15025', '9', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031824', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '1', '15008', '6', '15009', '3', '15029', '9', '15025', '9', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031825', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '2', '15008', '8', '15009', '4', '15029', '12', '15025', '12', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031826', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '2', '15008', '8', '15009', '4', '15029', '12', '15025', '12', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031827', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '2', '15008', '8', '15009', '4', '15029', '12', '15025', '12', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031828', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15025', '2', '15008', '8', '15009', '4', '15029', '12', '15025', '12', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031901', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15033', '2', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031902', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15033', '2', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031903', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15033', '2', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031904', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15033', '2', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031905', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '3', '15035', '6', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031906', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '3', '15035', '6', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031907', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '3', '15035', '6', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031908', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '3', '15035', '6', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031909', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '3', '15035', '6', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031910', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '5', '15035', '9', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031911', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '5', '15035', '9', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031912', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '5', '15035', '9', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031913', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '5', '15035', '9', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031914', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15012', '1', '15033', '5', '15035', '9', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031915', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15030', '9', '15033', '9', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031916', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15030', '9', '15033', '9', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8031917', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15030', '9', '15033', '9', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032001', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15015', '3', '15029', '1', '15030', '6', '15032', '11', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032002', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032003', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '15029', '1', '15030', '7', '15032', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032004', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '15029', '1', '15030', '7', '15032', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032005', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '15029', '1', '15030', '7', '15032', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032006', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '15029', '1', '15030', '7', '15032', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032007', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '15029', '1', '15030', '7', '15032', '13', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032008', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15031', '15', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032009', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '5', '15032', '27', '15034', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032010', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '27', '15034', '27', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032011', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '27', '15034', '27', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032012', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '27', '15034', '27', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032013', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '6', '15032', '30', '15034', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032014', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '30', '15034', '30', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032015', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '30', '15034', '30', '15009', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032016', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '30', '15034', '30', '15009', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032017', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '5', '15032', '27', '15034', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032018', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '5', '15032', '27', '15034', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032019', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '5', '15032', '27', '15034', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032020', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '27', '15034', '27', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032021', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '27', '15034', '27', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032022', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '27', '15034', '27', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032023', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '27', '15034', '27', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032024', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '27', '15034', '27', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032025', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '6', '15032', '30', '15034', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032026', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '6', '15032', '30', '15034', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032027', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '6', '15032', '30', '15034', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032028', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '6', '15032', '30', '15034', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032029', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '30', '15034', '30', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032030', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '30', '15034', '30', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032031', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '30', '15034', '30', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032032', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15032', '30', '15034', '30', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032033', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '30', '15034', '30', '15009', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032034', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '30', '15034', '30', '15009', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032035', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15032', '30', '15034', '30', '15009', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032101', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15011', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032102', '43', '29', '-1', '0', '-1', '0', '20027', '0', '-1', '0', '15011', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032201', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '1', '15031', '10', '15034', '11', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032202', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '1', '15031', '10', '15034', '11', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032203', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '1', '15031', '10', '15034', '11', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032204', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '1', '15031', '10', '15034', '11', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032205', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '1', '15031', '10', '15034', '11', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032206', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '2', '15031', '13', '15034', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032207', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '2', '15031', '13', '15034', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032208', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '2', '15031', '13', '15034', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032209', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '2', '15031', '13', '15034', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032210', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15017', '2', '15031', '13', '15034', '15', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032211', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15017', '2', '15031', '16', '15034', '18', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032212', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15017', '2', '15031', '16', '15034', '18', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032213', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15017', '2', '15031', '16', '15034', '18', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032214', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15017', '2', '15031', '16', '15034', '18', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032215', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15017', '2', '15031', '16', '15034', '18', '-1', '0', '-1', '0', '0', '0', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032216', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15008', '1', '15017', '2', '15031', '9', '15034', '10', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032217', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032218', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15008', '3', '15017', '2', '15031', '15', '15034', '17', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032219', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032220', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15030', '15', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032221', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032222', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '18', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032223', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15031', '18', '15034', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032224', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15031', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032225', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '24', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032226', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '4', '15031', '24', '15034', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032227', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032228', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15031', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032229', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '18', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032230', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '18', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032231', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15031', '18', '15034', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032232', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15031', '18', '15034', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032233', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15031', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032234', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15031', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032235', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15031', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032236', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15031', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032237', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '24', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032238', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '24', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032239', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '24', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032240', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15031', '24', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032241', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '4', '15031', '24', '15034', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032242', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '4', '15031', '24', '15034', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032243', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '4', '15031', '24', '15034', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032244', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '4', '15031', '24', '15034', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032301', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15008', '3', '15009', '3', '15028', '2', '15029', '4', '15012', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032302', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '5', '15008', '5', '15009', '5', '15028', '4', '15029', '4', '15040', '4', '0', '0', '72');
INSERT INTO `gamedata_items_equipment` VALUES ('8032303', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '4', '15008', '4', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032304', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '4', '15008', '4', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032305', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '5', '15008', '5', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032306', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '5', '15008', '5', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032307', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032308', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '5', '15008', '5', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032309', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '5', '15008', '5', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032310', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15007', '5', '15008', '5', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032311', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '6', '15008', '6', '15028', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032312', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '8', '15008', '8', '15028', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032401', '10', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032402', '10', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032403', '10', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032404', '10', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032405', '10', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032406', '10', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032407', '10', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032408', '10', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032409', '10', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032410', '10', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032501', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032502', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032601', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15010', '8', '15015', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032602', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15012', '8', '15011', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032603', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15013', '8', '15014', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032604', '11', '29', '16010', '1', '15019', '70', '-1', '0', '-1', '0', '15004', '10', '15006', '10', '15005', '10', '15008', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032605', '11', '29', '16010', '1', '15022', '120', '-1', '0', '-1', '0', '15004', '10', '15006', '10', '15007', '10', '15009', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032606', '11', '29', '16010', '1', '15028', '15', '-1', '0', '-1', '0', '15005', '10', '15007', '10', '15008', '10', '15009', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032701', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20029', '0', '15002', '40', '15008', '12', '15025', '3', '15052', '3', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032702', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20035', '0', '15018', '7', '15017', '7', '15007', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032703', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20034', '0', '15001', '50', '15018', '6', '15016', '6', '15005', '7', '15017', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032704', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20043', '0', '15018', '7', '15004', '7', '15009', '7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032705', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20038', '0', '15006', '7', '15009', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032706', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20046', '0', '15008', '7', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032707', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20049', '0', '15024', '7', '15007', '6', '15028', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032801', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15001', '160', '15052', '45', '15005', '20', '15017', '-20', '15029', '10', '15049', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032802', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '15', '15005', '15', '15018', '20', '15022', '50', '15017', '-10', '15025', '-30', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032803', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '10', '15004', '20', '15016', '18', '15022', '30', '15051', '40', '15017', '-7', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032804', '42', '29', '-1', '0', '-1', '0', '20026', '0', '-1', '0', '15002', '120', '15027', '15', '15007', '15', '15009', '15', '15017', '-20', '15050', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032805', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15001', '18', '15018', '7', '15016', '7', '15001', '90', '15002', '50', '15025', '15', '15020', '15', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032806', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15001', '18', '15018', '7', '15016', '7', '15001', '90', '15002', '50', '15025', '15', '15020', '15', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032807', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15001', '18', '15018', '7', '15016', '7', '15001', '90', '15002', '50', '15025', '15', '15020', '15', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032808', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15001', '18', '15018', '7', '15016', '7', '15001', '90', '15002', '50', '15025', '15', '15020', '15', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032809', '42', '29', '-1', '0', '-1', '0', '20026', '0', '15001', '18', '15018', '7', '15016', '7', '15001', '90', '15002', '50', '15025', '15', '15020', '15', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032810', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '5', '15017', '10', '15006', '10', '15009', '10', '15007', '10', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032811', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '5', '15017', '10', '15006', '10', '15009', '10', '15007', '10', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032812', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '5', '15017', '10', '15006', '10', '15009', '10', '15007', '10', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032813', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '5', '15017', '10', '15006', '10', '15009', '10', '15007', '10', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032814', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '5', '15017', '10', '15006', '10', '15009', '10', '15007', '10', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032815', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15002', '40', '15029', '9', '15024', '10', '15007', '5', '15008', '5', '15028', '5', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032816', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15002', '40', '15029', '9', '15024', '10', '15007', '5', '15008', '5', '15028', '5', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032817', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15002', '40', '15029', '9', '15024', '10', '15007', '5', '15008', '5', '15028', '5', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032818', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15002', '40', '15029', '9', '15024', '10', '15007', '5', '15008', '5', '15028', '5', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032819', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '2', '15002', '40', '15029', '9', '15024', '10', '15007', '5', '15008', '5', '15028', '5', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032820', '11', '29', '16007', '3', '15052', '-20', '-1', '0', '-1', '0', '15001', '60', '15004', '10', '15016', '5', '15018', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032821', '11', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '38', '15034', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032822', '11', '29', '16008', '3', '15018', '10', '-1', '0', '-1', '0', '15001', '60', '15004', '10', '15016', '5', '15052', '-20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032823', '11', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '38', '15034', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032824', '11', '29', '16009', '3', '15022', '40', '-1', '0', '-1', '0', '15001', '60', '15004', '10', '15016', '5', '15052', '-20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032825', '11', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '38', '15034', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032826', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '30', '15007', '15', '15008', '15', '15029', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032827', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '100', '15005', '7', '15020', '15', '15008', '13', '15040', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032828', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '80', '15016', '5', '15017', '5', '15020', '30', '16004', '60', '15033', '36', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032829', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-50', '15002', '50', '15050', '1', '15025', '50', '15076', '20', '15029', '25', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032830', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '2', '15018', '8', '15004', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032831', '11', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '7', '15018', '7', '15016', '8', '15004', '7', '15022', '10', '-1', '0', '-1', '0', '0', '1', '23');
INSERT INTO `gamedata_items_equipment` VALUES ('8032832', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '5', '15016', '5', '15004', '8', '15001', '30', '-1', '0', '-1', '0', '0', '1', '82');
INSERT INTO `gamedata_items_equipment` VALUES ('8032833', '11', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '5', '15028', '5', '15007', '4', '15008', '4', '-1', '0', '-1', '0', '0', '1', '86');
INSERT INTO `gamedata_items_equipment` VALUES ('8032834', '11', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032835', '11', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032836', '11', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032837', '11', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032838', '11', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8032839', '11', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040001', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040002', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040003', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040004', '10', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040005', '10', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040006', '10', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040007', '10', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040008', '10', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040009', '10', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040010', '10', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040011', '10', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040012', '10', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040013', '10', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040014', '10', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040015', '10', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040016', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040017', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040018', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040019', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040020', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040021', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040022', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040023', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040024', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040025', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040026', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040027', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040028', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040029', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040030', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040031', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040032', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040033', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040034', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040035', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040036', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040037', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040038', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040039', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040040', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040041', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040042', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040043', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040044', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040045', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040046', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040047', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040048', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040049', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040050', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040051', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040052', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040053', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040054', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040055', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040056', '10', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040057', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040058', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040059', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040060', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040061', '10', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040062', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040063', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040064', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040065', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040066', '10', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040067', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040068', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040069', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040070', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040071', '10', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040072', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040073', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040074', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040075', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040076', '10', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040077', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040078', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040079', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040080', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040081', '10', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040082', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040083', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040084', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040085', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040086', '10', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040087', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040088', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040089', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040090', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040091', '10', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040092', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040093', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040094', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040095', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8040096', '10', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050001', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050002', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050003', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050004', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050005', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050006', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050007', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050008', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050009', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050010', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '7', '15030', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050011', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '7', '15030', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050012', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '7', '15030', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050013', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '7', '15030', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050014', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '7', '15030', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050015', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050016', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '3', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050017', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15008', '3', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050018', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15004', '3', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050019', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '-1', '0', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050020', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '4', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050021', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15008', '4', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050022', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15004', '4', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050023', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050024', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050025', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050026', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '9', '15034', '9', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050027', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '9', '15034', '9', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050028', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050029', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '12', '15033', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050030', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050031', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050032', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050033', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '9', '15034', '9', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050034', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '9', '15034', '9', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050035', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '9', '15034', '9', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050036', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '9', '15034', '9', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050037', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '9', '15034', '9', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050038', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '9', '15034', '9', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050039', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '9', '15034', '9', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050040', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050041', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050042', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050043', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15034', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050044', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15034', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050045', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '10', '15034', '10', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050046', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15034', '10', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050047', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15034', '10', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050048', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15030', '10', '15034', '10', '15008', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050049', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '10', '15034', '10', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050050', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '10', '15034', '10', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050051', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15030', '10', '15034', '10', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050101', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050102', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050103', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050104', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050105', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050106', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050107', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050108', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050109', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050110', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050111', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050112', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050113', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050114', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050115', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050116', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050117', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050118', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050119', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15005', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050120', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '15005', '4', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050121', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '15005', '4', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050122', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '21', '15005', '5', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050123', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '21', '15005', '5', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050124', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050125', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '19', '15005', '5', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050126', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '19', '15005', '5', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050127', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '23', '15005', '6', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050128', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '23', '15005', '6', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050129', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '23', '15005', '6', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050130', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '23', '15005', '6', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050131', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '23', '15005', '6', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050132', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15005', '7', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050133', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15005', '9', '15004', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050134', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050135', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050136', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050137', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050138', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050139', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050140', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050141', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050142', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050143', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050144', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050145', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050146', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050147', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050148', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15005', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050149', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15005', '6', '15042', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050150', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050151', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '28', '15005', '5', '15013', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050201', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '11', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050202', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '11', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050203', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '11', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050204', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '11', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050205', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15006', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050206', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15006', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050207', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15006', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050208', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15006', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050209', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '15', '15006', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050210', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '15006', '2', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050211', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '15006', '2', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050212', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '15006', '2', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050213', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '15006', '2', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050214', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '15006', '2', '15017', '5', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050215', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '3', '15017', '9', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050216', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '3', '15017', '9', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050217', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '3', '15017', '9', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050218', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '3', '15017', '9', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050219', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '23', '15006', '3', '15017', '9', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050220', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050221', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15029', '1', '15002', '12', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050222', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050223', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050224', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15029', '3', '15002', '20', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050225', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '3', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050226', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050227', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050228', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15029', '1', '15002', '12', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050229', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15029', '1', '15002', '12', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050230', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050231', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050232', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050233', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050234', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15029', '3', '15002', '20', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050235', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15029', '3', '15002', '20', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050236', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '3', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050237', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '3', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050238', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050239', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050240', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050241', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050242', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '9', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050243', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '20', '15006', '2', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050244', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '20', '15006', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050245', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050246', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15002', '27', '15006', '4', '15017', '11', '15029', '1', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050247', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050248', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-14', '15002', '28', '15007', '4', '15024', '3', '15017', '13', '15029', '1', '0', '0', '43');
INSERT INTO `gamedata_items_equipment` VALUES ('8050301', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050302', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050303', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050304', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050305', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050306', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050307', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050308', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050309', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050310', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15030', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050311', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15030', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050312', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15030', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050313', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15030', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050314', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15030', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050315', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '10', '15030', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050316', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '10', '15030', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050317', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '10', '15030', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050318', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '10', '15030', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050319', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '10', '15030', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050320', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '5', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050321', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '5', '15032', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050322', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '5', '15032', '3', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050323', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '5', '15032', '3', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050324', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '6', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050325', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '6', '15032', '4', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050326', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '6', '15032', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050327', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '6', '15032', '4', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050328', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '5', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050329', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '5', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050330', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '5', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050331', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '5', '15032', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050332', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '5', '15032', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050333', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '5', '15032', '3', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050334', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '5', '15032', '3', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050335', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '5', '15032', '3', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050336', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '5', '15032', '3', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050337', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '5', '15032', '3', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050338', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '5', '15032', '3', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050339', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '5', '15032', '3', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050340', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '6', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050341', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '6', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050342', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '6', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050343', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '6', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050344', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '8', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050345', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '4', '15031', '4', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050346', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050347', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050348', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '6', '15032', '4', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050349', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '6', '15032', '4', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050350', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '6', '15032', '4', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050351', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15030', '6', '15032', '4', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050352', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '6', '15032', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050353', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '6', '15032', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050354', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '6', '15032', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050355', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15030', '6', '15032', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050356', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '6', '15032', '4', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050357', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '6', '15032', '4', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050358', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '6', '15032', '4', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050359', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15030', '6', '15032', '4', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050360', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-12', '15002', '25', '15028', '3', '15008', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050401', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '1', '15033', '6', '15017', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050402', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '1', '15033', '6', '15017', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050403', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '1', '15033', '6', '15017', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050404', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15009', '1', '15033', '6', '15017', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050405', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '1', '15033', '9', '15017', '7', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050406', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '1', '15033', '9', '15017', '7', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050407', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '1', '15033', '9', '15017', '7', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050408', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '1', '15033', '9', '15017', '7', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050409', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '1', '15033', '9', '15017', '7', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050410', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '2', '15033', '12', '15017', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050411', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '2', '15033', '12', '15017', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050412', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '2', '15033', '12', '15017', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050413', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '2', '15033', '12', '15017', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050414', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15009', '2', '15033', '12', '15017', '9', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050415', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15009', '3', '15033', '15', '15017', '10', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050416', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15009', '3', '15033', '15', '15017', '10', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050417', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15009', '3', '15033', '15', '15017', '10', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050418', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15009', '3', '15033', '15', '15017', '10', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050419', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15009', '3', '15033', '15', '15017', '10', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050420', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050421', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '14', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050422', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '14', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050423', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '14', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050424', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '3', '15033', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050425', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '16', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050426', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '16', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050427', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '16', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050428', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050429', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050430', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '2', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050431', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '14', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050432', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '14', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050433', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '14', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050434', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '14', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050435', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '14', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050436', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '14', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050437', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '14', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050438', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '14', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050439', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '14', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050440', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '3', '15033', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050441', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '3', '15033', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050442', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '3', '15033', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050443', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '3', '15033', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050444', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '16', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050445', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '16', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050446', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '16', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050447', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15033', '16', '15008', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050448', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '16', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050449', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '4', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050450', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050451', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '16', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050452', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '16', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050453', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15033', '16', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050454', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '16', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050455', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '16', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050456', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '16', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050457', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15033', '16', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050501', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '1', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050502', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '1', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050503', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15006', '2', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050504', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15006', '2', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050505', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050506', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050507', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '2', '15017', '10', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050508', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '2', '15017', '10', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050509', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '4', '15005', '3', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050510', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '4', '15005', '3', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050511', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '5', '15005', '3', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050512', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '5', '15005', '3', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050513', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '5', '15005', '4', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050514', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15006', '5', '15005', '4', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050515', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050516', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050517', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050518', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050519', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15083', '10', '15006', '7', '15005', '6', '15017', '14', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050520', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15005', '3', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050521', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15005', '1', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050601', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15007', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050602', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15007', '1', '15017', '2', '15029', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050603', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15007', '2', '15017', '4', '15029', '2', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050604', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15007', '2', '15017', '4', '15029', '2', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050605', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15007', '2', '15017', '8', '15029', '2', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050606', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15007', '2', '15017', '8', '15029', '2', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050607', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15007', '3', '15017', '12', '15029', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050608', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15007', '3', '15017', '12', '15029', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050609', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '3', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050610', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '3', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050611', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050612', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050613', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '13', '15005', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050614', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '13', '15005', '4', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050615', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '14', '15005', '5', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050616', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '14', '15005', '5', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050618', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '16', '15005', '6', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050619', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '20', '15005', '8', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050620', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15006', '3', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050621', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050622', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050701', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15030', '2', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050702', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15030', '2', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050703', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15030', '2', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050704', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15030', '4', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050705', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15030', '4', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050706', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15030', '4', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050707', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15030', '4', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050708', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '9', '15030', '8', '15033', '10', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050709', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '9', '15030', '8', '15033', '10', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050710', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '9', '15030', '8', '15033', '10', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050711', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15009', '1', '15017', '9', '15030', '8', '15033', '10', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050712', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050713', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '6', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050714', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15006', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050715', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '6', '15030', '6', '15033', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050716', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050717', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050718', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '9', '15006', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050719', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '9', '15030', '9', '15033', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050720', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050721', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '11', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050722', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '11', '15006', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050723', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15017', '11', '15030', '11', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050724', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050725', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050726', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050727', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '25', '15001', '15', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050728', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15033', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050729', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '6', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050730', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '6', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050731', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '6', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050732', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15006', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050733', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15006', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050734', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15006', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050735', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '6', '15030', '6', '15033', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050736', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '6', '15030', '6', '15033', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050737', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '6', '15030', '6', '15033', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050738', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050739', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050740', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050741', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050742', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050743', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050744', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '9', '15006', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050745', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '9', '15006', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050746', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '9', '15006', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050747', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '9', '15030', '9', '15033', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050748', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '9', '15030', '9', '15033', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050749', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15017', '9', '15030', '9', '15033', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050750', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050751', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050752', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050753', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050754', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '11', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050755', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '11', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050756', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '11', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050757', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15017', '11', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050758', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '11', '15006', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050759', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '11', '15006', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050760', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '11', '15006', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050761', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '11', '15006', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050762', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15017', '11', '15030', '11', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050763', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15017', '11', '15030', '11', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050764', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15017', '11', '15030', '11', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050765', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15017', '11', '15030', '11', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050766', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '15', '15018', '7', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050767', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '18', '15018', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050768', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '21', '15018', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050769', '13', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '18', '15018', '11', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050801', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050802', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050803', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050804', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050805', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050806', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050807', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050808', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050809', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '15017', '5', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050810', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '15017', '5', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050811', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15017', '9', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8050901', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '20', '15005', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050902', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '20', '15005', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050903', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '15005', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050904', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '15005', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050905', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '15005', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050906', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '15005', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050907', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '15005', '4', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8050940', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15008', '1', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051001', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051002', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051003', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051004', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051005', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '2', '15029', '2', '15030', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051006', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '2', '15029', '2', '15030', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051007', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '2', '15029', '2', '15030', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051008', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '2', '15029', '2', '15030', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051009', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '2', '15029', '2', '15030', '4', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051010', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '2', '15017', '3', '15029', '3', '15030', '9', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051011', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '2', '15017', '3', '15029', '3', '15030', '9', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051012', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '2', '15017', '3', '15029', '3', '15030', '9', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051013', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '2', '15017', '3', '15029', '3', '15030', '9', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051014', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15008', '2', '15017', '3', '15029', '3', '15030', '9', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051015', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051016', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '14', '15009', '3', '15017', '4', '15029', '5', '-1', '0', '-1', '0', '0', '1', '87');
INSERT INTO `gamedata_items_equipment` VALUES ('8051017', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-9', '15002', '9', '15005', '-2', '15024', '2', '15017', '3', '15029', '5', '0', '0', '43');
INSERT INTO `gamedata_items_equipment` VALUES ('8051018', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15002', '10', '15007', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051019', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15002', '10', '15007', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051020', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15002', '13', '15007', '1', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051021', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15002', '13', '15007', '1', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051022', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15002', '15', '15007', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051023', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15002', '15', '15007', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051024', '13', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '20', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051025', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '10', '15007', '7', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051101', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15013', '1', '15035', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051102', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15013', '1', '15035', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051103', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15013', '1', '15035', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051104', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '15013', '1', '15035', '1', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051105', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15029', '1', '15013', '1', '15035', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051106', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15029', '1', '15013', '1', '15035', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051107', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15029', '1', '15013', '1', '15035', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051108', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15029', '1', '15013', '1', '15035', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051109', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15029', '1', '15013', '1', '15035', '3', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051110', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15029', '1', '15013', '2', '15035', '5', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051111', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15029', '1', '15013', '2', '15035', '5', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051112', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15029', '1', '15013', '2', '15035', '5', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051113', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15029', '1', '15013', '2', '15035', '5', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051114', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15029', '1', '15013', '2', '15035', '5', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051115', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '2', '15031', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051116', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '2', '15031', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051117', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '2', '15031', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051118', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '4', '15031', '2', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051119', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '4', '15031', '2', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051120', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15030', '4', '15031', '2', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051121', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '15018', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051201', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051202', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051203', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051204', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051205', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051206', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051207', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051208', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051209', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051210', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051211', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051212', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051213', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051214', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051215', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051216', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '6', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051217', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '6', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051218', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '6', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051219', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '8', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051220', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '8', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051221', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '8', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051222', '13', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '8', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051223', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '8', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051224', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15031', '8', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051301', '12', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051302', '12', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051303', '12', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051304', '12', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051305', '12', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051306', '12', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051307', '12', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051308', '12', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051309', '12', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051310', '12', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051401', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20031', '0', '15005', '7', '15008', '7', '15002', '10', '15052', '2', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051402', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20037', '0', '15004', '10', '15017', '7', '15007', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051403', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '10', '15001', '20', '15005', '9', '15004', '11', '15020', '10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051404', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20041', '0', '15004', '10', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051405', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20039', '0', '15006', '7', '15009', '7', '15001', '10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051406', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20045', '0', '15008', '6', '15009', '6', '15025', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051407', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15038', '22', '15001', '-40', '15002', '40', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051501', '44', '29', '-1', '0', '-1', '0', '20028', '0', '-1', '0', '15001', '140', '15052', '25', '15005', '12', '15006', '12', '15017', '-20', '15029', '10', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051502', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '100', '15009', '10', '15027', '5', '15026', '5', '15017', '-10', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051503', '44', '29', '-1', '0', '-1', '0', '20028', '0', '15001', '18', '15018', '5', '15016', '2', '15001', '90', '15002', '20', '15025', '5', '15022', '10', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051504', '44', '29', '-1', '0', '-1', '0', '20028', '0', '15001', '18', '15018', '5', '15016', '2', '15001', '90', '15002', '20', '15025', '5', '15022', '10', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051505', '44', '29', '-1', '0', '-1', '0', '20028', '0', '15001', '18', '15018', '5', '15016', '2', '15001', '90', '15002', '20', '15025', '5', '15022', '10', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051506', '44', '29', '-1', '0', '-1', '0', '20028', '0', '15001', '18', '15018', '5', '15016', '2', '15001', '90', '15002', '20', '15025', '5', '15022', '10', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051507', '44', '29', '-1', '0', '-1', '0', '20028', '0', '15001', '18', '15018', '5', '15016', '2', '15001', '90', '15002', '20', '15025', '5', '15022', '10', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051508', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '2', '15017', '6', '15009', '4', '15006', '4', '15007', '4', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051509', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '2', '15017', '6', '15009', '4', '15006', '4', '15007', '4', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051510', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '2', '15017', '6', '15009', '4', '15006', '4', '15007', '4', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051511', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '2', '15017', '6', '15009', '4', '15006', '4', '15007', '4', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051512', '13', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '2', '15017', '6', '15009', '4', '15006', '4', '15007', '4', '-1', '0', '0', '1', '25');
INSERT INTO `gamedata_items_equipment` VALUES ('8051513', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '100', '15002', '50', '15005', '15', '15008', '15', '15016', '5', '15103', '50', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051514', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '4', '15007', '14', '15036', '40', '15001', '25', '15050', '1', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051515', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15018', '10', '15009', '20', '15017', '14', '15020', '10', '16004', '60', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051516', '13', '29', '16007', '3', '15016', '10', '-1', '0', '-1', '0', '15001', '80', '15004', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051517', '13', '29', '16008', '3', '15052', '-20', '-1', '0', '-1', '0', '15001', '30', '15007', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051518', '13', '29', '16009', '5', '15041', '5', '-1', '0', '-1', '0', '15001', '80', '15004', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051519', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '5', '15018', '5', '15004', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '89');
INSERT INTO `gamedata_items_equipment` VALUES ('8051520', '13', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '5', '15024', '5', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '0', '1', '87');
INSERT INTO `gamedata_items_equipment` VALUES ('8051521', '13', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051522', '13', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051523', '13', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051524', '13', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051525', '13', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8051526', '13', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060001', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060002', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060003', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060004', '12', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060005', '12', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060006', '12', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060007', '12', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060008', '12', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060009', '12', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060010', '12', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060011', '12', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060012', '12', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060013', '12', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060014', '12', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060015', '12', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060016', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060017', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060018', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060019', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060020', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060021', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060022', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060023', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060024', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060025', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060026', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060027', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060028', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060029', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060030', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060031', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060032', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060033', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060034', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060035', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060036', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060037', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060038', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060039', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060040', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060041', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060042', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060043', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060044', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060045', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060046', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060047', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060048', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060049', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060050', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060051', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060052', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060053', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060054', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060055', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060056', '12', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060057', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060058', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060059', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060060', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060061', '12', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060062', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060063', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060064', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060065', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060066', '12', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060067', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060068', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060069', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060070', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060071', '12', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060072', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060073', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060074', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060075', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060076', '12', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060077', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060078', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060079', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060080', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060081', '12', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060082', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060083', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060084', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060085', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060086', '12', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060087', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060088', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060089', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060090', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060091', '12', '23', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060092', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060093', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060094', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060095', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8060096', '12', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070001', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070002', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070003', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070004', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070005', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070006', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070007', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '12', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070008', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '12', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070009', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070010', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070011', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070012', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070013', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070014', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '14', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070015', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '14', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070016', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '14', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070017', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '14', '15033', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070018', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070019', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070020', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070021', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070022', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070023', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '15029', '4', '15032', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070024', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070101', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070102', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070103', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070104', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070105', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070106', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070107', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070108', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070109', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '15008', '2', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070110', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '28', '15008', '2', '15040', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070111', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '33', '15008', '3', '15040', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070112', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15041', '5', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070113', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '33', '15008', '3', '15040', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070114', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '33', '15008', '3', '15040', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070115', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070116', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070117', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070118', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070119', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070201', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070202', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070203', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070204', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070205', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070206', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070207', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070208', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070209', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070210', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070211', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070212', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070213', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070214', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070215', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070216', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070217', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070218', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '12', '15006', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070219', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '12', '15006', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070220', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '16', '15006', '2', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070221', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '16', '15006', '2', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070222', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '20', '15006', '3', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070223', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '20', '15006', '3', '15029', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070224', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15006', '3', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070225', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15006', '3', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070226', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15006', '3', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070227', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '24', '15006', '3', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070228', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070229', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070230', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070231', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070232', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070233', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070234', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070235', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070236', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070237', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070238', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070239', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070240', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070241', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070242', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070243', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '7', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070301', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15029', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070302', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15029', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070303', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15029', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070304', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15029', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070305', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15029', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070306', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15029', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070307', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15029', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070308', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15029', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070309', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15029', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070310', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070311', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070312', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070313', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070314', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15029', '3', '15032', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070315', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070316', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070317', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070318', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070319', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15029', '4', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070320', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15030', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070321', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15030', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070322', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15030', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070323', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15030', '2', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070324', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070325', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070326', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '13', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070327', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070328', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070329', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070330', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070331', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070332', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070333', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070334', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15032', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070335', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070336', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070337', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070338', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '13', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070339', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '13', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070340', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '13', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070341', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070342', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070343', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070344', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070345', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070346', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070347', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070348', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '3', '15032', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070349', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070350', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070351', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070352', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15032', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070353', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070354', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070355', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070356', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15032', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070357', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070358', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070359', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070360', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15032', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070361', '14', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15007', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070362', '14', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '6', '15007', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070363', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '9', '15024', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070401', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070402', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070403', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070404', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070405', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070406', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070407', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070408', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070409', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070410', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070411', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070412', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070413', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070414', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070415', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070416', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15034', '4', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070417', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15034', '4', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070418', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15034', '8', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070419', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15034', '8', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070420', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070421', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070422', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '13', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070423', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070424', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15034', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070425', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070426', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070427', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070428', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070429', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070430', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070431', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070432', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070433', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '13', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070434', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '13', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070435', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '13', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070436', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '13', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070437', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070438', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070439', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '13', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070440', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15034', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070441', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15034', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070442', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15034', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070443', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '3', '15034', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070444', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070445', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070446', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070447', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15034', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070448', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070449', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070450', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070451', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15034', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070452', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070453', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070454', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070455', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15034', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070501', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '3', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070502', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '15032', '5', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070503', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15032', '7', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070504', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15032', '7', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070505', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15032', '7', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070506', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '6', '15032', '7', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070507', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '8', '15032', '10', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070508', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '8', '15032', '10', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070509', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '8', '15032', '10', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070510', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '8', '15032', '10', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070511', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070512', '14', '29', '-1', '0', '-1', '0', '20003', '0', '-1', '0', '15029', '1', '15034', '1', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070513', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15009', '-1', '15029', '7', '15040', '3', '-1', '0', '-1', '0', '0', '0', '67');
INSERT INTO `gamedata_items_equipment` VALUES ('8070514', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070515', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '6', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070516', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '6', '15032', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070517', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070518', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '8', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070519', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '8', '15032', '11', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070520', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070521', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070522', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '9', '15032', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070523', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070524', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '10', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070525', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '10', '15032', '14', '15034', '14', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070526', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '10', '15020', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070527', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070528', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070529', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '6', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070530', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '6', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070531', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '6', '15032', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070532', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15029', '6', '15032', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070533', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070534', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070535', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '8', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070536', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '8', '15018', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070537', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '8', '15032', '11', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070538', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '8', '15032', '11', '15034', '11', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070539', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070540', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070541', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070542', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '9', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070543', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '9', '15032', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070544', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '9', '15032', '12', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070545', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070546', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070547', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070548', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '10', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070549', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '10', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070550', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15029', '10', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070551', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '10', '15032', '14', '15034', '14', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070552', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '10', '15032', '14', '15034', '14', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070553', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '2', '15029', '10', '15032', '14', '15034', '14', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070601', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070602', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070603', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070604', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070605', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15005', '2', '15018', '2', '15017', '1', '15029', '7', '-1', '0', '0', '0', '67');
INSERT INTO `gamedata_items_equipment` VALUES ('8070606', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070607', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '3', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070608', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15029', '9', '15004', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070609', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '10', '15004', '2', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070610', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15029', '2', '15029', '11', '15004', '3', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070701', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070702', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070703', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070704', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070705', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070706', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070707', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070708', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070709', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070710', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070711', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070712', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070713', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070714', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070715', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070716', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070717', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070718', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070719', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '-2', '15006', '3', '15016', '3', '15017', '3', '15029', '8', '15012', '3', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070720', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15029', '10', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070721', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '4', '15029', '10', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070722', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '5', '15029', '11', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070723', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '5', '15029', '11', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070724', '14', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '7', '15029', '14', '15009', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070725', '14', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '9', '15029', '18', '15009', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070801', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '14', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070802', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '14', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070803', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '18', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070804', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '22', '15029', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070805', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '27', '15029', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070806', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15008', '2', '15029', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '67');
INSERT INTO `gamedata_items_equipment` VALUES ('8070807', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15002', '15', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070808', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15002', '15', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070809', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15002', '20', '15018', '2', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070810', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15002', '20', '15018', '2', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070811', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '25', '15029', '15', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070812', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8070901', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15029', '2', '15034', '6', '-1', '0', '-1', '0', '-1', '2', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070902', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15029', '5', '15034', '9', '-1', '0', '-1', '0', '-1', '5', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070903', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15029', '8', '15034', '12', '-1', '0', '-1', '0', '-1', '8', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070904', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15029', '8', '15034', '12', '-1', '0', '-1', '0', '-1', '8', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070905', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15029', '8', '15034', '12', '-1', '0', '-1', '0', '-1', '8', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070906', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15029', '8', '15034', '12', '-1', '0', '-1', '0', '-1', '8', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070907', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15029', '10', '15034', '15', '-1', '0', '-1', '0', '-1', '10', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070908', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15029', '10', '15034', '15', '-1', '0', '-1', '0', '-1', '10', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070909', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15029', '10', '15034', '15', '-1', '0', '-1', '0', '-1', '10', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070910', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '23', '15029', '10', '15034', '15', '-1', '0', '-1', '0', '-1', '10', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070911', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15029', '4', '15016', '1', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070912', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15029', '4', '15016', '1', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070913', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15029', '7', '15016', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070914', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15029', '7', '15016', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8070915', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15005', '2', '15006', '2', '15007', '2', '15008', '2', '15009', '2', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071001', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071002', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071003', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071004', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071005', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071006', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071007', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071008', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071009', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071010', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071011', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071012', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071013', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071014', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071015', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071016', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071017', '14', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '15', '15017', '5', '15040', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071018', '14', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '20', '15017', '8', '15040', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071101', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '7', '15030', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071102', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '7', '15030', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071103', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '7', '15030', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071104', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '7', '15030', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071105', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '7', '15030', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071106', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071107', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071108', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071109', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071110', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '9', '15030', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071111', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071112', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071113', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071114', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071115', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15029', '9', '15030', '18', '-1', '0', '-1', '0', '-1', '0', '0', '0', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071116', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071117', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071118', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '13', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071119', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071120', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071121', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071122', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071123', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '17', '15033', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071201', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15028', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071202', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15028', '3', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071203', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15028', '3', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071204', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15028', '4', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071205', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15028', '4', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071206', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '1', '15028', '5', '15024', '3', '15043', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071207', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '1', '15028', '5', '15024', '3', '15046', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071208', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '1', '15028', '5', '15024', '3', '15048', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071209', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '1', '15028', '5', '15024', '3', '15045', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071210', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '1', '15028', '5', '15024', '3', '15044', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071211', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '1', '15028', '5', '15024', '3', '15047', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071212', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '7', '15038', '35', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071301', '14', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15010', '3', '15015', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071302', '14', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15012', '3', '15011', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071303', '14', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15013', '3', '15014', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071304', '14', '29', '16010', '1', '15016', '50', '-1', '0', '-1', '0', '15001', '100', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071305', '14', '29', '16010', '1', '15024', '25', '-1', '0', '-1', '0', '15001', '100', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071306', '14', '29', '16010', '1', '15041', '20', '-1', '0', '-1', '0', '15001', '100', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071401', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20030', '0', '15002', '30', '15005', '2', '15052', '4', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071402', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '40', '15002', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071403', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20032', '0', '15001', '30', '15018', '10', '15016', '8', '15005', '7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071404', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-30', '15052', '-10', '15018', '40', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071405', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20040', '0', '15009', '7', '15006', '7', '15017', '5', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071406', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15025', '7', '15002', '20', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071407', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-30', '15052', '-10', '15028', '5', '15038', '65', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071501', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '80', '15052', '45', '15005', '12', '15008', '12', '15017', '-20', '15029', '5', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071502', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '50', '15005', '25', '15004', '9', '15040', '5', '15017', '-10', '15025', '-20', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071503', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-100', '15018', '30', '15016', '35', '15017', '-7', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071504', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '80', '15005', '10', '15026', '15', '15017', '-10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071505', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15041', '2', '15001', '40', '15041', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071506', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15041', '2', '15001', '40', '15041', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071507', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15041', '2', '15001', '40', '15041', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071508', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15041', '2', '15001', '40', '15041', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071509', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15041', '2', '15001', '40', '15041', '10', '15040', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071510', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '15017', '5', '15006', '5', '15009', '5', '15007', '5', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071511', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '15017', '5', '15006', '5', '15009', '5', '15007', '5', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071512', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '15017', '5', '15006', '5', '15009', '5', '15007', '5', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071513', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '15017', '5', '15006', '5', '15009', '5', '15007', '5', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071514', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '15017', '5', '15006', '5', '15009', '5', '15007', '5', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071515', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15001', '30', '15025', '3', '15024', '5', '15028', '7', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071516', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15001', '30', '15025', '3', '15024', '5', '15028', '7', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071517', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15001', '30', '15025', '3', '15024', '5', '15028', '7', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071518', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15001', '30', '15025', '3', '15024', '5', '15028', '7', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071519', '14', '29', '-1', '0', '-1', '0', '-1', '0', '15024', '1', '15001', '30', '15025', '3', '15024', '5', '15028', '7', '-1', '0', '-1', '0', '0', '1', '24');
INSERT INTO `gamedata_items_equipment` VALUES ('8071520', '14', '29', '16007', '3', '15025', '10', '-1', '0', '-1', '0', '15001', '20', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071521', '14', '29', '16007', '2', '15032', '5', '-1', '0', '-1', '0', '15031', '22', '15033', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071522', '14', '29', '16008', '3', '15025', '9', '-1', '0', '-1', '0', '15001', '15', '15008', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071523', '14', '29', '16008', '2', '15032', '5', '-1', '0', '-1', '0', '15031', '22', '15033', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071524', '14', '29', '16009', '3', '15025', '9', '-1', '0', '-1', '0', '15001', '20', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071525', '14', '29', '16009', '2', '15032', '5', '-1', '0', '-1', '0', '15031', '22', '15033', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071526', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '5', '15007', '5', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071527', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '120', '15008', '7', '15052', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8071528', '14', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '80', '15007', '5', '15009', '5', '15017', '2', '15020', '7', '16004', '60', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080001', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080002', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15031', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080003', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080004', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080005', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080006', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '8', '15033', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080007', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080008', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '8', '15033', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080009', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080010', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080011', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080012', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15031', '9', '15033', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080013', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080014', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080015', '15', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '12', '15005', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080016', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080017', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080018', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080019', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '3', '15017', '5', '15031', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080020', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080101', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080102', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080103', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080104', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080105', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080106', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080107', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080108', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080109', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '25', '15006', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080110', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '25', '15006', '1', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080111', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15006', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080112', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '27', '15005', '3', '15052', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080113', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15006', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080114', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15006', '2', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080115', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15010', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080116', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '80', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080117', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080118', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080119', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080201', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080202', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080203', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080204', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080205', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080206', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080207', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080208', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080209', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080210', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080211', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080212', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080213', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080214', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080215', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080216', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080217', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080218', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080219', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080220', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080221', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '9', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080222', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '9', '15030', '2', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080223', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '9', '15030', '2', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080224', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080225', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '15', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080226', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '15', '15030', '4', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080227', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '15', '15030', '4', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080228', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080229', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080230', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080231', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '9', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080232', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '9', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080233', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '9', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080234', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '9', '15030', '2', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080235', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '9', '15030', '2', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080236', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080237', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080238', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080239', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '15', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080240', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '15', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080241', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15001', '15', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080242', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '15', '15030', '4', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080243', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15001', '15', '15030', '4', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080244', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080245', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '8', '15016', '2', '15011', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080246', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080247', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '-1', '15008', '2', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '44');
INSERT INTO `gamedata_items_equipment` VALUES ('8080301', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080302', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080303', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080304', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080305', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '2', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080306', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '2', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080307', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '2', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080308', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '2', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080309', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '2', '15031', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080310', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15017', '5', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080311', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15017', '5', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080312', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15017', '5', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080313', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15017', '5', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080314', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15017', '5', '15031', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080315', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15017', '8', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080316', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15017', '8', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080317', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15017', '8', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080318', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15017', '8', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080319', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15017', '8', '15031', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080320', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15002', '8', '15031', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080321', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '8', '15031', '9', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080322', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '8', '15031', '9', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080323', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '8', '15031', '9', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080324', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15002', '10', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080325', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15031', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080326', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '10', '15031', '10', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080327', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '10', '15031', '10', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080328', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15002', '8', '15031', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080329', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15002', '8', '15031', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080330', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15002', '8', '15031', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080331', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '8', '15031', '9', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080332', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '8', '15031', '9', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080333', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '8', '15031', '9', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080334', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '8', '15031', '9', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080335', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '8', '15031', '9', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080336', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '8', '15031', '9', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080337', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '8', '15031', '9', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080338', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '8', '15031', '9', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080339', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '8', '15031', '9', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080340', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15002', '10', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080341', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15002', '10', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080342', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15002', '10', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080343', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15002', '10', '15031', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080344', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15031', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080345', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15031', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080346', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080347', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080348', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15017', '1', '15031', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080349', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15024', '3', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '44');
INSERT INTO `gamedata_items_equipment` VALUES ('8080350', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15031', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080351', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15031', '10', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080352', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '10', '15031', '10', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080353', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '10', '15031', '10', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080354', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '10', '15031', '10', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080355', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '10', '15031', '10', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080356', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '10', '15031', '10', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080357', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '10', '15031', '10', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080358', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '10', '15031', '10', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080359', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '10', '15031', '10', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080360', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15009', '3', '15026', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080401', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080402', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080403', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080404', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080405', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080406', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080407', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080408', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080409', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080410', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080411', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080412', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080413', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080414', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080415', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080416', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080417', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080418', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080419', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15034', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080420', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080421', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080422', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080423', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080424', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080425', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080426', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080427', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080428', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '7', '15034', '12', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080429', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '7', '15034', '12', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080430', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15034', '12', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080431', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '8', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080432', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15034', '13', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080433', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '8', '15034', '13', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080434', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15034', '13', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080435', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080436', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080437', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '7', '15034', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080438', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '7', '15034', '12', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080439', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '7', '15034', '12', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080440', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '7', '15034', '12', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080441', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '7', '15034', '12', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080442', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '7', '15034', '12', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080443', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '7', '15034', '12', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080444', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15034', '12', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080445', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15034', '12', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080446', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15034', '12', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080447', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '8', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080448', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '8', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080449', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '8', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080450', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '2', '15017', '8', '15034', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080451', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15034', '13', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080452', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15034', '13', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080453', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15034', '13', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080454', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15017', '8', '15034', '13', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080455', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '8', '15034', '13', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080456', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '8', '15034', '13', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080457', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '8', '15034', '13', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080458', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15017', '8', '15034', '13', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080459', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15034', '13', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080460', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15034', '13', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080461', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15034', '13', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080462', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15034', '13', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080501', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '1', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080502', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15031', '2', '15034', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080503', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15031', '4', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080504', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080505', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080506', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080507', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080508', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080509', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080510', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080511', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080512', '15', '29', '-1', '0', '-1', '0', '20004', '0', '-1', '0', '15017', '1', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080513', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080514', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '5', '15004', '1', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080515', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080516', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15017', '5', '15029', '2', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080517', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080518', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '6', '15004', '2', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080519', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '6', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080520', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15017', '6', '15029', '3', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080521', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080522', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '7', '15004', '2', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080523', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '7', '15031', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080524', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15017', '7', '15029', '4', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080525', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '15', '15006', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080526', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080527', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080528', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080529', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '5', '15004', '1', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080530', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '5', '15004', '1', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080531', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '5', '15004', '1', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080532', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080533', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080534', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '5', '15031', '6', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080535', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15017', '5', '15029', '2', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080536', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15017', '5', '15029', '2', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080537', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15017', '5', '15029', '2', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080538', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080539', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080540', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080541', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '6', '15004', '2', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080542', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '6', '15004', '2', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080543', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '6', '15004', '2', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080544', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '6', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080545', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '6', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080546', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '6', '15031', '8', '15034', '8', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080547', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15017', '6', '15029', '3', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080548', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15017', '6', '15029', '3', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080549', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15017', '6', '15029', '3', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080550', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080551', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080552', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080553', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '7', '15004', '2', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080554', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '7', '15004', '2', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080555', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15017', '7', '15004', '2', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080556', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '7', '15031', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080557', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '7', '15031', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080558', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15017', '7', '15031', '9', '15034', '9', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080559', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15017', '7', '15029', '4', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080560', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15017', '7', '15029', '4', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080561', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15017', '7', '15029', '4', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080562', '15', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '15029', '6', '15031', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080563', '15', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '12', '15029', '8', '15031', '15', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080564', '15', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '12', '15029', '10', '15031', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080565', '15', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '15', '15029', '8', '15031', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080601', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080602', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080603', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080604', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080605', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080606', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080607', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080608', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080609', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080610', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080611', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080612', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '24', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080613', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080614', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '29', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080615', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '15034', '2', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080616', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '15034', '2', '15031', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080617', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '18', '15034', '3', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080618', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '18', '15034', '3', '15031', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080701', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080702', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080703', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080704', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080705', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080706', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080707', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080708', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080709', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080710', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080711', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15005', '2', '15017', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080712', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15005', '3', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080713', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15005', '3', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080714', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15015', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080715', '15', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15017', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080716', '15', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '6', '15017', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080717', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15018', '5', '15020', '30', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080801', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080802', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080803', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080804', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080805', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080806', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080807', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080808', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080809', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080810', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080811', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080812', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080813', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080814', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080815', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080816', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080817', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '83');
INSERT INTO `gamedata_items_equipment` VALUES ('8080818', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15016', '3', '15017', '13', '-1', '0', '-1', '0', '-1', '0', '0', '0', '64');
INSERT INTO `gamedata_items_equipment` VALUES ('8080819', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '1', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080820', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '1', '15016', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080821', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '2', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080822', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '2', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080823', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '3', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080824', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '3', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080825', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '3', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080826', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '3', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080827', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '3', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8080901', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080902', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080903', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080904', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080905', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080906', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8080907', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081001', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081002', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081003', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081004', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081005', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081006', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081007', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081008', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081009', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081010', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081011', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081012', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081013', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081014', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081015', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081016', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '1', '15006', '1', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081017', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '1', '15006', '1', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081018', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '1', '15006', '2', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081019', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '1', '15006', '2', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081020', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '2', '15006', '2', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081021', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '2', '15006', '2', '15017', '6', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081022', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '2', '15006', '3', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081023', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15004', '2', '15006', '3', '15017', '7', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081101', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081102', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081103', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081104', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081105', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081106', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081107', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081108', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081109', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081110', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081111', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081112', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15002', '20', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081113', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15002', '25', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081114', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15002', '25', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081115', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15002', '25', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081116', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '25', '15002', '25', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081117', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '32', '15005', '2', '15008', '2', '15017', '4', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081118', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '14', '15002', '14', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081119', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '14', '15002', '14', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081120', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '15002', '17', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081121', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15001', '17', '15002', '17', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081122', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15005', '3', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081123', '15', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '30', '15002', '30', '15017', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081124', '15', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '36', '15002', '36', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081201', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081202', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081203', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081204', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081205', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081206', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081207', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081208', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081209', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '83');
INSERT INTO `gamedata_items_equipment` VALUES ('8081210', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081211', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '2', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081212', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '3', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081213', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '3', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081301', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081302', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081303', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081304', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081305', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081306', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081307', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081308', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081309', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081310', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '6', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081311', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15032', '4', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081312', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15032', '4', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081401', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15030', '2', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081402', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15030', '3', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081403', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '15030', '5', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081404', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081501', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081601', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081602', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081603', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081604', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081605', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081606', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081607', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081608', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081609', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081610', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '7', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081611', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081612', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081613', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081614', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081615', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15017', '8', '15033', '17', '-1', '0', '-1', '0', '-1', '0', '0', '0', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081616', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081617', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081618', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '6', '15033', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081619', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '8', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081620', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '8', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081621', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '8', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081622', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '8', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081623', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '8', '15033', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081701', '15', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15010', '4', '15015', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081702', '15', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15012', '4', '15011', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081703', '15', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '20', '15013', '4', '15014', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081704', '15', '29', '16010', '1', '15028', '20', '-1', '0', '-1', '0', '15028', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081705', '15', '29', '16010', '1', '15019', '40', '-1', '0', '-1', '0', '15028', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081706', '15', '29', '16010', '1', '15022', '40', '-1', '0', '-1', '0', '15028', '5', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081801', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15041', '3', '15005', '2', '15002', '20', '15052', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081802', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20036', '0', '15007', '3', '15018', '3', '15017', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081803', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15040', '5', '15001', '70', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081804', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20042', '0', '15052', '-15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081805', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '10', '15001', '10', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081806', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20044', '0', '15008', '3', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081807', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '20048', '0', '15002', '30', '15007', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081901', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15005', '7', '15004', '10', '15017', '-10', '15025', '-20', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081902', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-60', '15016', '10', '15022', '20', '15009', '15', '15017', '-7', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081903', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '80', '15052', '-30', '15009', '20', '15017', '-10', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081904', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '4', '15017', '10', '15009', '2', '15007', '2', '15006', '2', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081905', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '4', '15017', '10', '15009', '2', '15007', '2', '15006', '2', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081906', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '4', '15017', '10', '15009', '2', '15007', '2', '15006', '2', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081907', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '4', '15017', '10', '15009', '2', '15007', '2', '15006', '2', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081908', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15018', '4', '15017', '10', '15009', '2', '15007', '2', '15006', '2', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081909', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15025', '3', '15024', '3', '15028', '1', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081910', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15025', '3', '15024', '3', '15028', '1', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081911', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15025', '3', '15024', '3', '15028', '1', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081912', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15025', '3', '15024', '3', '15028', '1', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081913', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '15025', '3', '15024', '3', '15028', '1', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081914', '15', '29', '16007', '2', '15006', '10', '-1', '0', '-1', '0', '15017', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081915', '15', '29', '16008', '2', '15007', '10', '-1', '0', '-1', '0', '15017', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081916', '15', '29', '16009', '2', '15009', '10', '-1', '0', '-1', '0', '15017', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081917', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15036', '10', '15002', '20', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081918', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '110', '15005', '3', '15008', '3', '15016', '2', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081919', '15', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '50', '15017', '15', '15020', '5', '16004', '20', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081920', '15', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15002', '20', '15007', '3', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '0', '1', '26');
INSERT INTO `gamedata_items_equipment` VALUES ('8081921', '15', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8081922', '15', '28', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090001', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090002', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090003', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090004', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090005', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090006', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '12', '15032', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090007', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090008', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '3', '15032', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090009', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '3', '15032', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090101', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090102', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090103', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090104', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090105', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15006', '1', '15005', '1', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090106', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '4', '15005', '4', '15080', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090107', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15006', '1', '15005', '2', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090108', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15023', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090109', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090110', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090201', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '7', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090202', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '8', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090203', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '7', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090204', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090205', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '10', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090206', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '15', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090207', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '12', '15036', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090208', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090301', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '5', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090302', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '8', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090303', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '5', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090304', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '10', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090305', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15034', '11', '15035', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090306', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '2', '15034', '12', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090307', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090401', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090402', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '1', '15002', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090403', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090404', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15032', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090405', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '1', '15002', '9', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090406', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '1', '15002', '9', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090407', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15076', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090408', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '5', '15028', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090501', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090502', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090503', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '3', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090504', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '5', '15005', '1', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090505', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '1', '15001', '8', '15005', '2', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090506', '16', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15005', '3', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090507', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '8', '15029', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '88');
INSERT INTO `gamedata_items_equipment` VALUES ('8090601', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090602', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090603', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090604', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15029', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090605', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090606', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '2', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090607', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '-10', '15004', '2', '15005', '-1', '15017', '2', '15029', '1', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090608', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15017', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090609', '16', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '4', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090701', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '11', '15032', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090702', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '9', '15032', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090703', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15034', '9', '15032', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090704', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '1', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090705', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15006', '1', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090706', '16', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15078', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090707', '16', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '6', '15077', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090708', '16', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '3', '15002', '3', '15079', '3', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090709', '16', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '15016', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090801', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090802', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '12', '15002', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090803', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090804', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15001', '10', '15018', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090805', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090806', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090807', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15021', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '84');
INSERT INTO `gamedata_items_equipment` VALUES ('8090901', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '9', '15034', '6', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090902', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15001', '8', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090903', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15001', '8', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090904', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '15034', '10', '15035', '12', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090905', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15034', '8', '15035', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090906', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '15034', '8', '15035', '9', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8090907', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8090908', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091001', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '84');
INSERT INTO `gamedata_items_equipment` VALUES ('8091002', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091003', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091004', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '3', '15005', '3', '15076', '10', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091005', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15025', '1', '15002', '20', '15025', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091101', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '5', '15035', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091102', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091103', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15035', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091104', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091105', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15035', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091106', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15032', '8', '15035', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091107', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '50', '15005', '3', '15026', '4', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091201', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '4', '15029', '1', '15010', '3', '15031', '12', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091202', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091203', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '1', '15010', '3', '15031', '11', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091204', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15031', '2', '15031', '14', '15008', '2', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091301', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '8', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091302', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '10', '15034', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091303', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '3', '15030', '7', '15034', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091304', '16', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('8091305', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '8', '15034', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091306', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '2', '15030', '10', '15034', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('8091401', '16', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '1', '15034', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '1', '27');
INSERT INTO `gamedata_items_equipment` VALUES ('9010001', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '11', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010002', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010003', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '17', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010004', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010005', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '22', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010006', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '26', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010007', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010008', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010009', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010010', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010011', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010012', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010013', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010014', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '19', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010015', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '21', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010016', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010017', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010018', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '13', '15002', '13', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010019', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010020', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010021', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '15', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010022', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010023', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010024', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '16', '15002', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010025', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010026', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '1', '15002', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010027', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '2', '15002', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010028', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '3', '15002', '18', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010029', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '4', '15002', '24', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010030', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15002', '6', '15002', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010031', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15002', '9', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010032', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '9', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010033', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '9', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010034', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '9', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010035', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15002', '9', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010036', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '9', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010037', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15002', '12', '15004', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010038', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '12', '15008', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010039', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '12', '15005', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010040', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '12', '15009', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010041', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15002', '12', '15006', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010042', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '12', '15007', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010043', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '-1', '15002', '12', '15052', '-3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010044', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15002', '15', '15004', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010045', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15002', '15', '15008', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010046', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15002', '15', '15005', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010047', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15002', '15', '15009', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010048', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15002', '15', '15006', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010049', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15002', '15', '15007', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010050', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '-1', '15002', '15', '15052', '-4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010051', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '1', '15052', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010052', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '1', '15052', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010053', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15052', '2', '15052', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010054', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '2', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010055', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '4', '15001', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010056', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '6', '15001', '30', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010057', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '8', '15001', '40', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010058', '45', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15001', '50', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '39');
INSERT INTO `gamedata_items_equipment` VALUES ('9010059', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15105', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010060', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15104', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010061', '45', '29', '16007', '3', '15004', '7', '-1', '0', '-1', '0', '15018', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010062', '45', '29', '16008', '3', '15008', '7', '-1', '0', '-1', '0', '15001', '45', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010063', '45', '29', '16009', '3', '15007', '7', '-1', '0', '-1', '0', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9010064', '45', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15020', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030001', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030002', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030003', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030004', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030005', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15017', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030006', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030007', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030008', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030009', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030010', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15014', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030011', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15011', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030012', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030013', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030014', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030015', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030016', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030017', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030018', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15014', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030019', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15011', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030020', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030021', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030022', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030023', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030024', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030025', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15035', '1', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030026', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15010', '1', '15029', '10', '15010', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030027', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15015', '1', '15029', '10', '15015', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030028', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15013', '1', '15029', '10', '15013', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030029', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15012', '1', '15029', '10', '15012', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030030', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15014', '1', '15029', '10', '15014', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030031', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15011', '1', '15029', '10', '15011', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030032', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15010', '1', '15029', '15', '15010', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030033', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15015', '1', '15029', '15', '15015', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030034', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15013', '1', '15029', '15', '15013', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030035', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15012', '1', '15029', '15', '15012', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030036', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15014', '1', '15029', '15', '15014', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030037', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15011', '1', '15029', '15', '15011', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030038', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15037', '2', '15029', '10', '15037', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030039', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15010', '2', '15029', '20', '15010', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030040', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15015', '2', '15029', '20', '15015', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030041', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15013', '2', '15029', '20', '15013', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030042', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15012', '2', '15029', '20', '15012', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030043', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15014', '2', '15029', '20', '15014', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030044', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15011', '2', '15029', '20', '15011', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030045', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15037', '3', '15029', '15', '15037', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030046', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030047', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030048', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030049', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15032', '1', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030050', '47', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030051', '47', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030052', '47', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030053', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '-1', '15081', '-1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030054', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030055', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030056', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030057', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15025', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030058', '47', '29', '-1', '0', '-1', '0', '-1', '0', '15001', '5', '15001', '25', '15002', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '40');
INSERT INTO `gamedata_items_equipment` VALUES ('9030059', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '-20', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030060', '47', '29', '16007', '4', '15022', '7', '-1', '0', '-1', '0', '15018', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030061', '47', '29', '16008', '4', '15007', '4', '-1', '0', '-1', '0', '15024', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030062', '47', '29', '16009', '4', '15001', '30', '-1', '0', '-1', '0', '15025', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030063', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15049', '1', '15050', '1', '15016', '3', '15028', '3', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030064', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9030065', '47', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040001', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15024', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040002', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '15024', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040003', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15024', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040004', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15024', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040005', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15024', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040006', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15010', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040007', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15015', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040008', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15013', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040009', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '2', '15012', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040010', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15014', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040011', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15011', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040012', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15010', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040013', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15015', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040014', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15013', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040015', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '3', '15012', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040016', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15014', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040017', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15011', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040018', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040019', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040020', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15078', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040021', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15078', '1', '15025', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040022', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '1', '15018', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040023', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '2', '15018', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040024', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '3', '15018', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040025', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '4', '15018', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040026', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15018', '5', '15018', '25', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040027', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040028', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040029', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040030', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040031', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15030', '1', '15030', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040032', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '3', '15024', '6', '15043', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040033', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '3', '15024', '6', '15048', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040034', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '3', '15024', '6', '15046', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040035', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '3', '15024', '6', '15045', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040036', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '3', '15024', '6', '15047', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040037', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '3', '15024', '6', '15044', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040038', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '4', '15024', '8', '15043', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040039', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '4', '15024', '8', '15048', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040040', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '4', '15024', '8', '15046', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040041', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '4', '15024', '8', '15045', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040042', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '4', '15024', '8', '15047', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040043', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '4', '15024', '8', '15044', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040044', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15025', '2', '15025', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040045', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15043', '5', '15024', '10', '15043', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040046', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15048', '5', '15024', '10', '15048', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040047', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15046', '5', '15024', '10', '15046', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040048', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15045', '5', '15024', '10', '15045', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040049', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15047', '5', '15024', '10', '15047', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040050', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15044', '5', '15024', '10', '15044', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040051', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15025', '3', '15025', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040052', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '1', '15017', '8', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040053', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '2', '15017', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040054', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '3', '15017', '16', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040055', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15017', '4', '15017', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040056', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040057', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040058', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040059', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040060', '17', '29', '-1', '0', '-1', '0', '-1', '0', '15033', '1', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '41');
INSERT INTO `gamedata_items_equipment` VALUES ('9040061', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '15', '15020', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040062', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '15', '15036', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040063', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040064', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15052', '30', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040065', '17', '29', '16007', '3', '15001', '30', '-1', '0', '-1', '0', '15025', '14', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040066', '17', '29', '16008', '3', '15022', '15', '-1', '0', '-1', '0', '15018', '27', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040067', '17', '29', '16009', '3', '15038', '15', '-1', '0', '-1', '0', '15024', '20', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9040068', '17', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '35', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050001', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050002', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '2', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050003', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050004', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050005', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15028', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050006', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15016', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050007', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050008', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050009', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050010', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050011', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050012', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050013', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '4', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050014', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050015', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15004', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050016', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15008', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050017', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15005', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050018', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15009', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050019', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15006', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050020', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15007', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050021', '49', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15031', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050022', '49', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050023', '49', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15030', '5', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050024', '49', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15033', '5', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050025', '49', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15031', '5', '15032', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050026', '49', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15034', '5', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050027', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '3', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050028', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '6', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050029', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '1', '15016', '9', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050030', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '2', '15016', '12', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050031', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15016', '3', '15016', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050032', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '1', '15004', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050033', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '1', '15008', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050034', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '1', '15005', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050035', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '1', '15009', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050036', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '1', '15006', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050037', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '1', '15007', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050038', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '2', '15004', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050039', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '2', '15008', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050040', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '2', '15005', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050041', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '2', '15009', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050042', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '2', '15006', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050043', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '2', '15007', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050044', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15036', '2', '15028', '7', '15036', '7', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050045', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15004', '3', '15004', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050046', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15008', '3', '15008', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050047', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15005', '3', '15005', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050048', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15009', '3', '15009', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050049', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15006', '3', '15006', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050050', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15007', '3', '15007', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050051', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15036', '3', '15028', '10', '15036', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050052', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '1', '15028', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050053', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '2', '15028', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050054', '49', '29', '-1', '0', '-1', '0', '-1', '0', '15028', '3', '15028', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '42');
INSERT INTO `gamedata_items_equipment` VALUES ('9050055', '49', '29', '16007', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15035', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050056', '49', '29', '16009', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15034', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050057', '49', '29', '16008', '0', '-1', '0', '-1', '0', '-1', '0', '15058', '1', '15033', '5', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050058', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050059', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050060', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15002', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050061', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050062', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15029', '5', '15001', '5', '15002', '5', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050063', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15018', '15', '15001', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050064', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15024', '15', '15001', '-15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050065', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15001', '40', '15002', '-10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050066', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15025', '15', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050067', '49', '29', '16007', '3', '15007', '10', '-1', '0', '-1', '0', '15024', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050068', '49', '29', '16008', '3', '15001', '15', '-1', '0', '-1', '0', '15001', '35', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050069', '49', '29', '16009', '3', '15018', '10', '-1', '0', '-1', '0', '15018', '10', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050070', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15014', '10', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050071', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15014', '10', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050072', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '10', '15006', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050073', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '10', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050074', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '10', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050075', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15011', '10', '15008', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050076', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15013', '10', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050077', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15010', '10', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050078', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '10', '15009', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050079', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15012', '10', '15005', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050080', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15015', '10', '15007', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_equipment` VALUES ('9050081', '49', '29', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '15011', '10', '15004', '1', '-1', '0', '-1', '0', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4020001', '58', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030010', '76', '1', '90', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030016', '76', '1', '60', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030117', '76', '2', '20', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030303', '76', '4', '10', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030407', '79', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030408', '77', '1', '60', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030507', '78', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030601', '76', '10', '10', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030602', '76', '10', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030603', '80', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030604', '76', '14', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030605', '76', '15', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030606', '76', '16', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030607', '76', '13', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030608', '76', '17', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4030711', '76', '5', '20', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040001', '141', '1', '70', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040013', '141', '6', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040109', '141', '8', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040501', '141', '7', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040502', '141', '7', '10', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040504', '141', '10', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040505', '141', '11', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040506', '141', '12', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4040507', '141', '9', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4070001', '201', '1', '60', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4080201', '161', '3', '50', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4100206', '31', '3', '11', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4100801', '31', '12', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4100802', '31', '13', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('4100803', '31', '14', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('5020001', '281', '1', '100', '4');
INSERT INTO `gamedata_items_graphics` VALUES ('5030101', '331', '1', '20', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8011001', '0', '23', '5', '1');
INSERT INTO `gamedata_items_graphics` VALUES ('8011708', '0', '15', '16', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8011709', '0', '15', '12', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8030245', '0', '7', '18', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8030445', '0', '4', '11', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8030601', '0', '9', '21', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8030701', '0', '10', '13', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8030801', '0', '13', '19', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8031120', '0', '31', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8031716', '0', '15', '16', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8031719', '0', '15', '12', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8032834', '0', '59', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040001', '0', '1', '5', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040002', '0', '1', '5', '2');
INSERT INTO `gamedata_items_graphics` VALUES ('8040003', '0', '1', '5', '3');
INSERT INTO `gamedata_items_graphics` VALUES ('8040004', '0', '1', '5', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040005', '0', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040006', '0', '1', '5', '3');
INSERT INTO `gamedata_items_graphics` VALUES ('8040007', '0', '1', '15', '1');
INSERT INTO `gamedata_items_graphics` VALUES ('8040008', '0', '1', '5', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040009', '0', '1', '5', '1');
INSERT INTO `gamedata_items_graphics` VALUES ('8040010', '0', '1', '15', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040011', '0', '1', '15', '1');
INSERT INTO `gamedata_items_graphics` VALUES ('8040012', '0', '1', '6', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040013', '0', '1', '5', '2');
INSERT INTO `gamedata_items_graphics` VALUES ('8040014', '0', '1', '5', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8040015', '0', '1', '5', '2');
INSERT INTO `gamedata_items_graphics` VALUES ('8050031', '0', '2', '6', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050245', '0', '4', '11', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050346', '0', '5', '11', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050621', '0', '9', '25', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050622', '0', '9', '24', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050728', '0', '10', '10', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8050808', '0', '15', '22', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8051015', '0', '7', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060001', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060002', '0', '1', '2', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060003', '0', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060004', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060005', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060006', '0', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060007', '0', '1', '2', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060008', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060009', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060010', '0', '1', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060011', '0', '1', '2', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060012', '0', '1', '2', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060013', '0', '1', '6', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060014', '0', '1', '1', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8060015', '0', '1', '2', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8070243', '0', '11', '7', '5');
INSERT INTO `gamedata_items_graphics` VALUES ('8070346', '0', '5', '11', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8080246', '0', '4', '10', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8080346', '0', '5', '12', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8080501', '0', '10', '13', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8080601', '0', '25', '7', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8081208', '0', '15', '16', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8081209', '0', '15', '12', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8090208', '0', '4', '0', '0');
INSERT INTO `gamedata_items_graphics` VALUES ('8090307', '0', '6', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '5', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '22', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '25', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '45', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '56', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '5', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '61', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '31', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '49', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '18', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '31', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '49', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '18', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '31', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '49', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '24', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '61', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '24', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3910403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '39', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '5', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '15', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '22', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '7', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '26', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '13', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '36', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '56', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '7', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '19', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '31', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '4', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '6', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '39', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '48', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '9', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3920021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '20', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('3940110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020001', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '8', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020002', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '11', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020003', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '33', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020004', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '85', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020005', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '11', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020006', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020007', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '99', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020008', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '76', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020009', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '106', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020010', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '131', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020011', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '73', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020012', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '112', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020101', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '13', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020102', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '24', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020103', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '40', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020104', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020105', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '98', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020106', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '44', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020107', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '14', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020108', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '27', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020109', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '38', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020110', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '59', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020111', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '97', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020112', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '123', '3.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020113', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '114', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020201', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '17', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020202', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '29', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020203', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '48', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020204', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '56', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020205', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '45', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020206', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '18', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020207', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '23', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020208', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '33', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020209', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '86', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020210', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '114', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020211', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '77', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020301', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '79', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020302', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '47', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020303', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '127', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020304', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020305', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '115', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020306', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '80', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020307', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '73', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020308', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020309', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '117', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020310', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '97', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020311', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '97', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020401', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '131', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020402', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '143', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020403', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '133', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020404', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '133', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020405', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '133', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020406', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '137', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020407', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '115', '2.8', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020408', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020409', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020410', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4020411', '0', '0', '0', '0', '0', '0', '2', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '130', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '10', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '12', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '35', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '15', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '16', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '20', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '44', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '26', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '7', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '9', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '27', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '28', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '54', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '35', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '90', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '10', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '18', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '30', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '23', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '39', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '39', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '14', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '14', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '23', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '9', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030111', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '18', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030112', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '35', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030113', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '34', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030114', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '17', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030115', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '29', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030116', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '52', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030117', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '86', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030118', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '25', '2.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '58', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '35', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '23', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '68', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '51', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '78', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '91', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '40', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '63', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '72', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '30', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '46', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '51', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '90', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '98', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '95', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030501', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '26', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030502', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '51', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030503', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '49', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030504', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '89', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030505', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '89', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030506', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '80', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030507', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '102', '2.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030601', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '107', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030602', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '119', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030603', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '101', '2.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030604', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '102', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030605', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '102', '2.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030606', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '114', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030607', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '88', '2.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030608', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '115', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030701', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '26', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030702', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '42', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030703', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '66', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030704', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '78', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030705', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '75', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030706', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '13', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030707', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '33', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030708', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '45', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030709', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '62', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030710', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4030711', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '91', '2.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '12', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '15', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '46', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '16', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '36', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '75', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '21', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '117', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '29', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '38', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '60', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '48', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '167', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '102', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '20', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '27', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '36', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '75', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '36', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '96', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '171', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '62', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040111', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '159', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '82', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '126', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '59', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '144', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '76', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '105', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040207', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '141', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040208', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '100', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '104', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '151', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '79', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '68', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '131', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '159', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '104', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '135', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '73', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '154', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '46', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '162', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '105', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '170', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040501', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '161', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040502', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '179', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040503', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '167', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040504', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '169', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040505', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '165', '4.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040506', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '173', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040507', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '159', '3.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040508', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '168', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040509', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '168', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040510', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '168', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4040511', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '169', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4050001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4060001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4070001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '6', '3.5', '4');
INSERT INTO `gamedata_items_weapon` VALUES ('4070002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '8', '3.5', '5');
INSERT INTO `gamedata_items_weapon` VALUES ('4070003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '3.5', '7');
INSERT INTO `gamedata_items_weapon` VALUES ('4070004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '18', '3.5', '13');
INSERT INTO `gamedata_items_weapon` VALUES ('4070005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '31', '3.5', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '8', '3.5', '5');
INSERT INTO `gamedata_items_weapon` VALUES ('4070007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '24', '3.5', '15');
INSERT INTO `gamedata_items_weapon` VALUES ('4070008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '77', '3.5', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '3.5', '7');
INSERT INTO `gamedata_items_weapon` VALUES ('4070010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '16', '3.5', '9');
INSERT INTO `gamedata_items_weapon` VALUES ('4070011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '21', '3.5', '13');
INSERT INTO `gamedata_items_weapon` VALUES ('4070012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '54', '3.5', '36');
INSERT INTO `gamedata_items_weapon` VALUES ('4070013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '79', '3.5', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '12', '3.3', '9');
INSERT INTO `gamedata_items_weapon` VALUES ('4070102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '20', '3.3', '15');
INSERT INTO `gamedata_items_weapon` VALUES ('4070103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '33', '3.3', '26');
INSERT INTO `gamedata_items_weapon` VALUES ('4070104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '34', '3.3', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '29', '3.3', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '43', '3.3', '31');
INSERT INTO `gamedata_items_weapon` VALUES ('4070107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '56', '3.3', '39');
INSERT INTO `gamedata_items_weapon` VALUES ('4070108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '75', '3.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '11', '4.2', '7');
INSERT INTO `gamedata_items_weapon` VALUES ('4070202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '32', '4.2', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '65', '4.2', '39');
INSERT INTO `gamedata_items_weapon` VALUES ('4070204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '12', '4.2', '7');
INSERT INTO `gamedata_items_weapon` VALUES ('4070205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '16', '4.2', '9');
INSERT INTO `gamedata_items_weapon` VALUES ('4070206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '19', '4.2', '13');
INSERT INTO `gamedata_items_weapon` VALUES ('4070207', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '52', '4.2', '36');
INSERT INTO `gamedata_items_weapon` VALUES ('4070208', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '22', '4.2', '13');
INSERT INTO `gamedata_items_weapon` VALUES ('4070209', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '47', '4.2', '26');
INSERT INTO `gamedata_items_weapon` VALUES ('4070210', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '29', '4.2', '15');
INSERT INTO `gamedata_items_weapon` VALUES ('4070211', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '90', '4.2', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070212', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '50', '4.2', '26');
INSERT INTO `gamedata_items_weapon` VALUES ('4070213', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '82', '4.2', '39');
INSERT INTO `gamedata_items_weapon` VALUES ('4070214', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '100', '4.2', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070215', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '63', '4.2', '36');
INSERT INTO `gamedata_items_weapon` VALUES ('4070301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '22', '4', '13');
INSERT INTO `gamedata_items_weapon` VALUES ('4070302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '37', '4', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '59', '4', '39');
INSERT INTO `gamedata_items_weapon` VALUES ('4070304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '73', '4', '48');
INSERT INTO `gamedata_items_weapon` VALUES ('4070305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '36', '4', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '33', '4', '22');
INSERT INTO `gamedata_items_weapon` VALUES ('4070307', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '60', '4', '36');
INSERT INTO `gamedata_items_weapon` VALUES ('4070308', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '87', '4', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070309', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '102', '4.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070310', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '60', '4', '36');
INSERT INTO `gamedata_items_weapon` VALUES ('4070311', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '93', '4', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070312', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '95', '4.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '102', '4.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '116', '4.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '106', '4.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '97', '3.8', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '77', '3.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '109', '4.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '71', '3.1', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '76', '3.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070409', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '76', '3.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070410', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '76', '3.3', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4070411', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '4', '1', '-1', '0', '-1', '0', '106', '4.2', '56');
INSERT INTO `gamedata_items_weapon` VALUES ('4080001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '15', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '20', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '44', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '71', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '13', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '38', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '151', '3.8', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '20', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '72', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '125', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '142', '3.6', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '47', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '76', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '117', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '35', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '70', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '93', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '143', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '133', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '56', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '10', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '13', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '24', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '40', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '16', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '27', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080207', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '65', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080208', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '44', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080209', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '57', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080210', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '114', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080211', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '51', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080212', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '147', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080213', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '88', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '119', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '66', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '126', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '52', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '100', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '88', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '57', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '91', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '64', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '119', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '136', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '41', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '135', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '95', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080409', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '140', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080501', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '150', '3.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080502', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '164', '3.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080503', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '137', '3.5', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080504', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '149', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080505', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '149', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080506', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '153', '3.8', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080507', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '127', '3.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080508', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080509', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080510', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '132', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4080511', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '146', '3.7', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4090001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100111', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100112', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100307', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100308', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100501', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100502', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100503', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100504', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100505', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100506', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100507', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100508', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100509', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100510', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100511', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100601', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100602', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100603', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100604', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100605', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100606', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100607', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100608', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100609', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100701', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100702', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100703', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100704', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100705', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100706', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100707', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100708', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100709', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100710', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100711', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100712', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100713', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100801', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100802', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100803', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100804', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100805', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100806', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100807', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100808', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100809', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100810', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100811', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100812', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('4100813', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5010001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '3', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '4', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '5', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '9', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '15', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '24', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '5', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '9', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '38', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '14', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '19', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '30', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '40', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '27', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '5', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '10', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '17', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '67', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '28', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '6', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '23', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '9', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '38', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '58', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020111', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '4.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020112', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '41', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020113', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '62', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020114', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '24', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020115', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '10', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020207', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020208', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '19', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020209', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '15', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020210', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '10', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020211', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '13', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020212', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020213', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '21', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020214', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020215', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '33', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020216', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '46', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020217', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '25', '2.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '8', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '22', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '31', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '17', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '40', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '8', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020307', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '42', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '74', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '62', '4.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '48', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '47', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '63', '3.9', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '46', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020409', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '46', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020410', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '46', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5020411', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '70', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '4', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '9', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '4', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '5', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '26', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '6', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '15', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '7', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '20', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '12', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030022', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030023', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030024', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030025', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030026', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030027', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '32', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030028', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030029', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '20', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030030', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '28', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030031', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '28', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030032', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '28', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030033', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030034', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030035', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030036', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '43', '3.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030037', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '27', '3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030101', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '4', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030102', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '6', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030103', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '8', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030104', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '14', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030105', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '23', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030106', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '37', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030107', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '13', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030108', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '58', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030109', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '36', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030110', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '68', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030111', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '60', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030112', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '30', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030113', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '41', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030201', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '12', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030202', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '15', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030203', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '33', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030204', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '41', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030205', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030206', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '23', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030207', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '19', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030208', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '27', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030209', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030210', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '62', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030301', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '18', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030302', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '30', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030303', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '34', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030304', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '24', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030305', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '25', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030306', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '16', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030307', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '42', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030308', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '4.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030309', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '4.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030401', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '65', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030402', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '74', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030403', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '62', '4.1', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030404', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '48', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030405', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '47', '3.2', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030406', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '3.4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030407', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '50', '3.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030408', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '64', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030409', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '64', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030410', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '64', '4', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5030411', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '70', '4.3', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('5040001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010003', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010004', '0', '0', '55', '49', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010005', '0', '0', '22', '19', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010006', '0', '0', '62', '54', '0', '0', '1', '0', '0', '70', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010007', '0', '0', '29', '25', '0', '0', '1', '0', '0', '33', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010008', '0', '0', '56', '56', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010010', '0', '0', '30', '25', '0', '0', '1', '0', '0', '32', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010011', '0', '0', '43', '40', '0', '0', '1', '0', '0', '34', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010012', '0', '0', '47', '40', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010013', '0', '0', '54', '54', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010014', '0', '0', '68', '63', '0', '0', '1', '0', '0', '53', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010015', '0', '0', '82', '76', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6010016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011003', '0', '0', '60', '78', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011005', '0', '0', '30', '39', '0', '0', '1', '0', '0', '36', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011006', '0', '0', '43', '56', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6011008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020003', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020004', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020005', '0', '0', '27', '23', '0', '0', '1', '0', '0', '29', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020006', '0', '0', '22', '19', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020007', '0', '0', '49', '43', '0', '0', '1', '0', '0', '55', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020008', '0', '0', '35', '33', '0', '0', '1', '0', '0', '28', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020009', '0', '0', '41', '35', '0', '0', '1', '0', '0', '45', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020010', '0', '0', '70', '62', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020011', '0', '0', '47', '47', '0', '0', '1', '0', '0', '47', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020012', '0', '0', '67', '61', '0', '0', '1', '0', '0', '52', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020014', '0', '0', '82', '76', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020015', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020017', '0', '0', '29', '25', '0', '0', '1', '0', '0', '33', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6020018', '0', '0', '69', '69', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021003', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021004', '0', '0', '31', '40', '0', '0', '1', '0', '0', '37', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021005', '0', '0', '46', '59', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021006', '0', '0', '49', '63', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6021008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030003', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030004', '0', '0', '22', '19', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030005', '0', '0', '49', '43', '0', '0', '1', '0', '0', '55', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030006', '0', '0', '62', '62', '0', '0', '1', '0', '0', '62', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030007', '0', '0', '29', '25', '0', '0', '1', '0', '0', '33', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030008', '0', '0', '69', '69', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030010', '0', '0', '27', '23', '0', '0', '1', '0', '0', '29', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030011', '0', '0', '35', '33', '0', '0', '1', '0', '0', '28', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030012', '0', '0', '41', '35', '0', '0', '1', '0', '0', '45', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030013', '0', '0', '47', '47', '0', '0', '1', '0', '0', '47', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030014', '0', '0', '67', '61', '0', '0', '1', '0', '0', '52', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030015', '0', '0', '76', '64', '0', '0', '1', '0', '0', '82', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6030016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031003', '0', '0', '49', '63', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031005', '0', '0', '31', '40', '0', '0', '1', '0', '0', '37', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031006', '0', '0', '46', '59', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6031008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040003', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040004', '0', '0', '22', '19', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040005', '0', '0', '62', '54', '0', '0', '1', '0', '0', '70', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040006', '0', '0', '29', '25', '0', '0', '1', '0', '0', '33', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040007', '0', '0', '55', '49', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040008', '0', '0', '78', '69', '0', '0', '1', '0', '0', '60', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040010', '0', '0', '27', '23', '0', '0', '1', '0', '0', '29', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040011', '0', '0', '35', '33', '0', '0', '1', '0', '0', '28', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040012', '0', '0', '41', '35', '0', '0', '1', '0', '0', '45', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040013', '0', '0', '53', '48', '0', '0', '1', '0', '0', '41', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040014', '0', '0', '61', '52', '0', '0', '1', '0', '0', '67', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040015', '0', '0', '74', '74', '0', '0', '1', '0', '0', '74', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6040016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041003', '0', '0', '49', '63', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041005', '0', '0', '31', '40', '0', '0', '1', '0', '0', '37', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041006', '0', '0', '46', '59', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6041008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050001', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050002', '0', '0', '25', '22', '0', '0', '1', '0', '0', '19', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050003', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050004', '0', '0', '55', '49', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050005', '0', '0', '36', '31', '0', '0', '1', '0', '0', '40', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050006', '0', '0', '70', '62', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050007', '0', '0', '33', '29', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050008', '0', '0', '69', '60', '0', '0', '1', '0', '0', '78', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050010', '0', '0', '29', '27', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050011', '0', '0', '40', '34', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050012', '0', '0', '51', '47', '0', '0', '1', '0', '0', '40', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050013', '0', '0', '56', '47', '0', '0', '1', '0', '0', '60', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050014', '0', '0', '67', '61', '0', '0', '1', '0', '0', '52', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050015', '0', '0', '82', '76', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6050016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051003', '0', '0', '49', '63', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051005', '0', '0', '29', '37', '0', '0', '1', '0', '0', '34', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051006', '0', '0', '43', '56', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6051008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060001', '0', '0', '22', '19', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060002', '0', '0', '62', '54', '0', '0', '1', '0', '0', '70', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060003', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060004', '0', '0', '55', '49', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060005', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060006', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060007', '0', '0', '63', '56', '0', '0', '1', '0', '0', '49', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060008', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060009', '0', '0', '30', '25', '0', '0', '1', '0', '0', '32', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060010', '0', '0', '39', '36', '0', '0', '1', '0', '0', '30', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060011', '0', '0', '51', '47', '0', '0', '1', '0', '0', '40', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060012', '0', '0', '65', '60', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060013', '0', '0', '69', '58', '0', '0', '1', '0', '0', '74', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060014', '0', '0', '82', '76', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6060015', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061003', '0', '0', '25', '33', '0', '0', '1', '0', '0', '29', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061004', '0', '0', '60', '78', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061005', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061006', '0', '0', '34', '43', '0', '0', '1', '0', '0', '40', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061007', '0', '0', '45', '57', '0', '0', '1', '0', '0', '53', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061008', '0', '0', '54', '70', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6061009', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070003', '0', '0', '25', '22', '0', '0', '1', '0', '0', '19', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070004', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070005', '0', '0', '55', '49', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070006', '0', '0', '70', '62', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070007', '0', '0', '33', '29', '0', '0', '1', '0', '0', '25', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070008', '0', '0', '69', '60', '0', '0', '1', '0', '0', '78', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070010', '0', '0', '31', '28', '0', '0', '1', '0', '0', '24', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070011', '0', '0', '43', '40', '0', '0', '1', '0', '0', '34', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070012', '0', '0', '51', '47', '0', '0', '1', '0', '0', '40', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070013', '0', '0', '60', '56', '0', '0', '1', '0', '0', '47', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070014', '0', '0', '68', '63', '0', '0', '1', '0', '0', '53', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070015', '0', '0', '76', '64', '0', '0', '1', '0', '0', '82', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6070016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071003', '0', '0', '49', '63', '0', '0', '1', '0', '0', '56', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071005', '0', '0', '30', '39', '0', '0', '1', '0', '0', '36', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071006', '0', '0', '43', '56', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6071008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080001', '0', '0', '9', '8', '0', '0', '1', '0', '0', '7', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080002', '0', '0', '18', '16', '0', '0', '1', '0', '0', '14', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080003', '0', '0', '25', '22', '0', '0', '1', '0', '0', '19', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080004', '0', '0', '40', '36', '0', '0', '1', '0', '0', '31', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080005', '0', '0', '49', '43', '0', '0', '1', '0', '0', '55', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080006', '0', '0', '62', '54', '0', '0', '1', '0', '0', '70', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080007', '0', '0', '29', '29', '0', '0', '1', '0', '0', '29', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080008', '0', '0', '63', '56', '0', '0', '1', '0', '0', '49', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080009', '0', '0', '20', '18', '0', '0', '1', '0', '0', '15', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080010', '0', '0', '31', '28', '0', '0', '1', '0', '0', '24', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080011', '0', '0', '40', '34', '0', '0', '1', '0', '0', '43', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080012', '0', '0', '47', '40', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080013', '0', '0', '54', '54', '0', '0', '1', '0', '0', '54', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080014', '0', '0', '63', '53', '0', '0', '1', '0', '0', '68', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080015', '0', '0', '82', '76', '0', '0', '1', '0', '0', '64', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6080016', '0', '0', '80', '80', '0', '0', '1', '0', '0', '77', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081001', '0', '0', '17', '22', '0', '0', '1', '0', '0', '20', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081002', '0', '0', '37', '48', '0', '0', '1', '0', '0', '42', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081003', '0', '0', '60', '78', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081004', '0', '0', '19', '24', '0', '0', '1', '0', '0', '23', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081005', '0', '0', '30', '39', '0', '0', '1', '0', '0', '36', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081006', '0', '0', '43', '56', '0', '0', '1', '0', '0', '51', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081007', '0', '0', '58', '74', '0', '0', '1', '0', '0', '69', '0', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('6081008', '0', '0', '70', '75', '0', '0', '1', '0', '0', '75', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010001', '0', '0', '0', '0', '18', '16', '1', '0', '0', '0', '14', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010002', '0', '0', '0', '0', '40', '36', '1', '0', '0', '0', '31', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010003', '0', '0', '0', '0', '55', '49', '1', '0', '0', '0', '43', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010004', '0', '0', '0', '0', '20', '18', '1', '0', '0', '0', '15', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010005', '0', '0', '0', '0', '9', '8', '1', '0', '0', '0', '7', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010006', '0', '0', '0', '0', '22', '22', '1', '0', '0', '0', '22', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010007', '0', '0', '0', '0', '26', '26', '1', '0', '0', '0', '26', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010008', '0', '0', '0', '0', '37', '34', '1', '0', '0', '0', '29', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010009', '0', '0', '0', '0', '70', '62', '1', '0', '0', '0', '54', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010010', '0', '0', '0', '0', '36', '46', '1', '0', '0', '0', '43', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010011', '0', '0', '0', '0', '53', '48', '1', '0', '0', '0', '41', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010012', '0', '0', '0', '0', '60', '60', '1', '0', '0', '0', '60', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010013', '0', '0', '0', '0', '64', '82', '1', '0', '0', '0', '76', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010015', '0', '0', '0', '0', '29', '29', '1', '0', '0', '0', '29', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010016', '0', '0', '0', '0', '56', '56', '1', '0', '0', '0', '56', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010017', '0', '0', '0', '0', '77', '79', '1', '0', '0', '0', '81', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010101', '0', '0', '0', '0', '20', '17', '1', '0', '0', '0', '22', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010102', '0', '0', '0', '0', '42', '37', '1', '0', '0', '0', '48', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010103', '0', '0', '0', '0', '23', '19', '1', '0', '0', '0', '24', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010104', '0', '0', '0', '0', '38', '32', '1', '0', '0', '0', '42', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010105', '0', '0', '0', '0', '54', '46', '1', '0', '0', '0', '59', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010106', '0', '0', '0', '0', '69', '60', '1', '0', '0', '0', '78', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010107', '0', '0', '0', '0', '69', '58', '1', '0', '0', '0', '74', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010108', '0', '0', '0', '0', '8', '7', '1', '0', '0', '0', '9', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7010109', '0', '0', '0', '0', '66', '71', '1', '0', '0', '0', '80', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020001', '0', '0', '0', '0', '18', '16', '1', '0', '0', '0', '14', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020002', '0', '0', '0', '0', '9', '8', '1', '0', '0', '0', '7', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020003', '0', '0', '0', '0', '40', '36', '1', '0', '0', '0', '31', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020004', '0', '0', '0', '0', '55', '49', '1', '0', '0', '0', '43', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020005', '0', '0', '0', '0', '22', '22', '1', '0', '0', '0', '22', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020006', '0', '0', '0', '0', '62', '62', '1', '0', '0', '0', '62', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020007', '0', '0', '0', '0', '29', '29', '1', '0', '0', '0', '29', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020008', '0', '0', '0', '0', '63', '56', '1', '0', '0', '0', '49', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020009', '0', '0', '0', '0', '20', '18', '1', '0', '0', '0', '15', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020010', '0', '0', '0', '0', '31', '28', '1', '0', '0', '0', '24', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020011', '0', '0', '0', '0', '43', '40', '1', '0', '0', '0', '34', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020012', '0', '0', '0', '0', '46', '46', '1', '0', '0', '0', '46', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020013', '0', '0', '0', '0', '60', '56', '1', '0', '0', '0', '47', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020014', '0', '0', '0', '0', '68', '63', '1', '0', '0', '0', '53', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020015', '0', '0', '0', '0', '64', '82', '1', '0', '0', '0', '76', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020016', '0', '0', '0', '0', '77', '79', '1', '0', '0', '0', '81', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020101', '0', '0', '0', '0', '20', '17', '1', '0', '0', '0', '22', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020102', '0', '0', '0', '0', '42', '37', '1', '0', '0', '0', '48', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020103', '0', '0', '0', '0', '69', '60', '1', '0', '0', '0', '78', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020104', '0', '0', '0', '0', '23', '19', '1', '0', '0', '0', '24', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020105', '0', '0', '0', '0', '36', '30', '1', '0', '0', '0', '39', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020106', '0', '0', '0', '0', '51', '43', '1', '0', '0', '0', '56', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020107', '0', '0', '0', '0', '69', '58', '1', '0', '0', '0', '74', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020108', '0', '0', '0', '0', '8', '7', '1', '0', '0', '0', '9', '0', '0', '0', '1', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7020109', '0', '0', '0', '0', '66', '71', '1', '0', '0', '0', '80', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030001', '0', '0', '0', '0', '18', '16', '1', '0', '0', '0', '14', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030002', '0', '0', '0', '0', '9', '8', '1', '0', '0', '0', '7', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030003', '0', '0', '0', '0', '25', '22', '1', '0', '0', '0', '19', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030004', '0', '0', '0', '0', '40', '36', '1', '0', '0', '0', '31', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030005', '0', '0', '0', '0', '55', '49', '1', '0', '0', '0', '43', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030006', '0', '0', '0', '0', '70', '62', '1', '0', '0', '0', '54', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030007', '0', '0', '0', '0', '33', '29', '1', '0', '0', '0', '25', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030008', '0', '0', '0', '0', '69', '69', '1', '0', '0', '0', '69', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030009', '0', '0', '0', '0', '20', '18', '1', '0', '0', '0', '15', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030010', '0', '0', '0', '0', '31', '28', '1', '0', '0', '0', '24', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030011', '0', '0', '0', '0', '46', '43', '1', '0', '0', '0', '36', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030012', '0', '0', '0', '0', '57', '53', '1', '0', '0', '0', '45', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030013', '0', '0', '0', '0', '58', '58', '1', '0', '0', '0', '58', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030014', '0', '0', '0', '0', '74', '69', '1', '0', '0', '0', '58', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030015', '0', '0', '0', '0', '64', '82', '1', '0', '0', '0', '76', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030016', '0', '0', '0', '0', '77', '79', '1', '0', '0', '0', '81', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030101', '0', '0', '0', '0', '20', '17', '1', '0', '0', '0', '22', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030102', '0', '0', '0', '0', '42', '37', '1', '0', '0', '0', '48', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030103', '0', '0', '0', '0', '56', '49', '1', '0', '0', '0', '63', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030104', '0', '0', '0', '0', '23', '19', '1', '0', '0', '0', '24', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030105', '0', '0', '0', '0', '36', '30', '1', '0', '0', '0', '39', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030106', '0', '0', '0', '0', '48', '41', '1', '0', '0', '0', '53', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030107', '0', '0', '0', '0', '64', '54', '1', '0', '0', '0', '70', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030108', '0', '0', '0', '0', '8', '7', '1', '0', '0', '0', '9', '0', '0', '0', '2', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('7030109', '0', '0', '0', '0', '66', '71', '1', '0', '0', '0', '80', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010022', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010023', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010024', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010025', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010026', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010027', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010028', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010029', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010030', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010031', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010032', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010033', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010034', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010035', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010036', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010037', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010038', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010039', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010040', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010041', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010042', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010043', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010044', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010045', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010046', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010047', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010048', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010049', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010050', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010051', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010052', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010053', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010054', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010055', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010056', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010057', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010058', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010059', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010060', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010061', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010062', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010063', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9010064', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030022', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030023', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030024', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030025', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030026', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030027', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030028', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030029', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030030', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030031', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030032', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030033', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030034', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030035', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030036', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030037', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030038', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030039', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030040', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030041', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030042', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030043', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030044', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030045', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030046', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030047', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030048', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030049', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030050', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030051', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030052', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030053', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030054', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030055', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030056', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030057', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030058', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030059', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030060', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030061', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030062', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030063', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030064', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9030065', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040022', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040023', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040024', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040025', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040026', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040027', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040028', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040029', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040030', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040031', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040032', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040033', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040034', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040035', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040036', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040037', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040038', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040039', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040040', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040041', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040042', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040043', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040044', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040045', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040046', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040047', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040048', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040049', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040050', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040051', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040052', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040053', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040054', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040055', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040056', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040057', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040058', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040059', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040060', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040061', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040062', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040063', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040064', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040065', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040066', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040067', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9040068', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050001', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050002', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050003', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050004', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050005', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050006', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050007', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050008', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050009', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050010', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050011', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050012', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050013', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050014', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050015', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050016', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050017', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050018', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050019', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050020', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050021', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050022', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050023', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050024', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050025', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050026', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050027', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050028', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050029', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050030', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050031', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050032', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050033', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050034', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050035', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050036', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050037', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050038', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050039', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050040', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050041', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050042', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050043', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050044', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050045', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050046', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050047', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050048', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050049', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050050', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050051', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050052', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050053', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050054', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050055', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050056', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050057', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050058', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050059', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050060', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050061', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050062', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050063', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050064', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050065', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050066', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050067', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050068', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050069', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050070', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050071', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050072', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050073', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050074', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050075', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050076', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050077', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050078', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050079', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050080', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `gamedata_items_weapon` VALUES ('9050081', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '3', '1', '-1', '0', '-1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('0', '0', null, '--', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('128', '101', 'sea0Field01', 'Lower La Noscea', 'ZoneMasterSeaS0', '60', '60', '21', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('129', '101', 'sea0Field02', 'Western La Noscea', 'ZoneMasterSeaS0', '60', '60', '21', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('130', '101', 'sea0Field03', 'Eastern La Noscea', 'ZoneMasterSeaS0', '60', '60', '21', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('131', '101', 'sea0Dungeon01', 'Mistbeard Cove', 'ZoneMasterSeaS0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('132', '101', 'sea0Dungeon02', 'Cassiopeia Hollow', 'ZoneMasterSeaS0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('133', '101', 'sea0Town01', 'Limsa Lominsa', 'ZoneMasterSeaS0', '59', '59', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('134', '202', 'sea0Market01', 'Market Wards', 'ZoneMasterMarketSeaS0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('135', '101', 'sea0Field04', 'Upper La Noscea', 'ZoneMasterSeaS0', '60', '60', '21', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('137', '101', null, 'U\'Ghamaro Mines', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('138', '101', null, 'La Noscea', '', '60', '60', '21', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('139', '101', null, 'The Cieldalaes', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('140', '101', null, 'Sailors Ward', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('141', '101', 'sea0Field01a', 'Lower La Noscea', 'ZoneMasterSeaS0', '60', '60', '21', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('143', '102', 'roc0Field01', 'Coerthas Central Highlands', 'ZoneMasterRocR0', '55', '55', '15', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('144', '102', 'roc0Field02', 'Coerthas Eastern Highlands', 'ZoneMasterRocR0', '55', '55', '15', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('145', '102', 'roc0Field03', 'Coerthas Eastern Lowlands', 'ZoneMasterRocR0', '55', '55', '15', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('146', '102', null, 'Coerthas', '', '55', '55', '15', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('147', '102', 'roc0Field04', 'Coerthas Central Lowlands', 'ZoneMasterRocR0', '55', '55', '15', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('148', '102', 'roc0Field05', 'Coerthas Western Highlands', 'ZoneMasterRocR0', '55', '55', '15', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('150', '103', 'fst0Field01', 'Central Shroud', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('151', '103', 'fst0Field02', 'East Shroud', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('152', '103', 'fst0Field03', 'North Shroud', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('153', '103', 'fst0Field04', 'West Shroud', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('154', '103', 'fst0Field05', 'South Shroud', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('155', '103', 'fst0Town01', 'Gridania', 'ZoneMasterFstF0', '51', '51', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('156', '103', null, 'The Black Shroud', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('157', '103', 'fst0Dungeon01', 'The Mun-Tuy Cellars', 'ZoneMasterFstF0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('158', '103', 'fst0Dungeon02', 'The Tam-Tara Deepcroft', 'ZoneMasterFstF0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('159', '103', 'fst0Dungeon03', 'The Thousand Maws of Toto-Rak', 'ZoneMasterFstF0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('160', '204', 'fst0Market01', 'Market Wards', 'ZoneMasterMarketFstF0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('161', '103', null, 'Peasants Ward', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('162', '103', null, 'Central Shroud', '', '52', '52', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('164', '106', 'fst0Battle01', 'Central Shroud', 'ZoneMasterBattleFstF0', '0', '0', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('165', '106', 'fst0Battle02', 'Central Shroud', 'ZoneMasterBattleFstF0', '0', '0', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('166', '106', 'fst0Battle03', 'Central Shroud', 'ZoneMasterBattleFstF0', '0', '0', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('167', '106', 'fst0Battle04', 'Central Shroud', 'ZoneMasterBattleFstF0', '0', '0', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('168', '106', 'fst0Battle05', 'Central Shroud', 'ZoneMasterBattleFstF0', '0', '0', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('170', '104', 'wil0Field01', 'Central Thanalan', 'ZoneMasterWilW0', '68', '68', '25', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('171', '104', 'wil0Field02', 'Eastern Thanalan', 'ZoneMasterWilW0', '68', '68', '25', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('172', '104', 'wil0Field03', 'Western Thanalan', 'ZoneMasterWilW0', '68', '68', '25', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('173', '104', 'wil0Field04', 'Northern Thanalan', 'ZoneMasterWilW0', '68', '68', '25', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('174', '104', 'wil0Field05', 'Southern Thanalan', 'ZoneMasterWilW0', '68', '68', '25', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('175', '104', 'wil0Town01', 'Ul\'dah', 'ZoneMasterWilW0', '66', '66', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('176', '104', 'wil0Dungeon01', 'Nanawa Mines', 'ZoneMasterWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('177', '207', '_jail', '-', 'ZoneMasterJail', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('178', '104', 'wil0Dungeon02', 'Copperbell Mines', 'ZoneMasterWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('179', '104', null, 'Thanalan', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('180', '205', 'wil0Market01', 'Market Wards', 'ZoneMasterMarketWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('181', '104', null, 'Merchants Ward', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('182', '104', null, 'Central Thanalan', '', '68', '68', '25', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('184', '107', 'wil0Battle01', 'Ul\'dah', 'ZoneMasterBattleWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('185', '107', 'wil0Battle01', 'Ul\'dah', 'ZoneMasterBattleWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('186', '104', 'wil0Battle02', 'Ul\'dah', 'ZoneMasterBattleWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('187', '104', 'wil0Battle03', 'Ul\'dah', 'ZoneMasterBattleWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('188', '104', 'wil0Battle04', 'Ul\'dah', 'ZoneMasterBattleWilW0', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('190', '105', 'lak0Field01', 'Mor Dhona', 'ZoneMasterLakL0', '49', '49', '11', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('192', '111', 'ocn0Battle01', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('193', '111', 'ocn0Battle02', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('194', '111', 'ocn0Battle03', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('195', '111', 'ocn0Battle04', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('196', '111', 'ocn0Battle05', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('198', '111', 'ocn0Battle06', 'Rhotano Sea', 'ZoneMasterBattleOcnO0', '0', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('200', '111', null, 'Strait of Merlthor', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('201', '111', null, '-', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('204', '101', 'sea0Field02a', 'Western La Noscea', '', '60', '60', '21', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('205', '101', 'sea0Field03a', 'Eastern La Noscea', '', '60', '60', '21', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('206', '103', 'fst0Town1a', 'Gridania', 'ZoneMasterFstF0', '52', '52', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('207', '103', null, 'North Shroud', '', '52', '52', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('208', '103', null, 'South Shroud', '', '52', '52', '13', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('209', '104', 'wil0Town01a', 'Ul\'dah', 'ZoneMasterWilW0', '66', '66', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('210', '104', null, 'Eastern Thanalan', '', '68', '68', '25', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('211', '104', null, 'Western Thanalan', '', '68', '68', '25', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('230', '101', 'sea0Town01a', 'Limsa Lominsa', '', '59', '59', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('231', '102', 'roc0Dungeon01', 'Dzemael Darkhold', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('232', '101', 'sea0Office01', 'Maelstrom Command', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('233', '104', 'wil0Office01', 'Hall of Flames', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('234', '103', 'fst0Office01', 'Adders\' Nest', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('235', '101', null, 'Shposhae', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('236', '101', null, 'Locke\'s Lie', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('237', '101', null, 'Turtleback Island', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('238', '103', 'fst0Field04', 'Thornmarch', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('239', '102', null, 'The Howling Eye', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('240', '104', 'wil0Field05a', 'The Bowl of Embers', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('244', '209', 'prv0Inn01', 'Inn Room', 'ZoneMasterPrvI0', '61', '61', '0', '0', '1', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('245', '102', 'roc0Dungeon02', 'The Aurum Vale', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('246', '104', null, 'Cutter\'s Cry', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('247', '103', null, 'North Shroud', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('248', '101', null, 'Western La Noscea', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('249', '104', null, 'Eastern Thanalan', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('250', '102', null, 'The Howling Eye', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('251', '105', null, 'Transmission Tower', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('252', '102', null, 'The Aurum Vale', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('253', '102', null, 'The Aurum Vale', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('254', '104', null, 'Cutter\'s Cry', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('255', '104', null, 'Cutter\'s Cry', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('256', '102', null, 'The Howling Eye', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('257', '109', null, 'Rivenroad', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('258', '103', null, 'North Shroud', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('259', '103', null, 'North Shroud', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('260', '101', null, 'Western La Noscea', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('261', '101', null, 'Western La Noscea', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('262', '104', null, 'Eastern Thanalan', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('263', '104', null, 'Eastern Thanalan', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('264', '105', 'lak0Field01', 'Transmission Tower', '', '0', '0', '0', '0', '0', '1', '0', '0');
INSERT INTO `server_zones` VALUES ('265', '104', null, 'The Bowl of Embers', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('266', '105', 'lak0Field01a', 'Mor Dhona', 'ZoneMasterLakL0', '49', '49', '11', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('267', '109', null, 'Rivenroad', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('268', '109', null, 'Rivenroad', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('269', '101', null, 'Locke\'s Lie', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones` VALUES ('270', '101', null, 'Turtleback Island', '', '0', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `server_zones_spawnlocations` VALUES ('1', '155', '2', '58.92', '4', '-1219.07', '0.52', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('2', '133', '2', '-444.266', '39.518', '191', '1.9', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('3', '175', '2', '-110.157', '202', '171.345', '0', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('4', '193', '2', '0.016', '10.35', '-36.91', '0.025', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('5', '166', '2', '356.09', '3.74', '-701.62', '-1.4', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('6', '184', '2', '12.63', '196.05', '131.01', '-1.34', NULL);
INSERT INTO `server_zones_spawnlocations` VALUES ('7', '128', '2', '-8.48', '45.36', '139.5', '2.02', NULL);
INSERT INTO `servers` VALUES ('1', 'Localhost', '127.0.0.1', '54992', '4', '0', '5000', '1');